public class AIAttacker extends AIPatroler
{
    /////////////////////////////////////////////////////////////////////////////
    // 
    //          PARAMETRY ZWIAZANE Z BRONIA POSIADANA PRZEZ AI
    //
    
    /** Bron jaka AI posiada defaultowo */
    public String sAIWeapon = "WeaponRifle";//#AI
    
    /** Ilosc poczatkowa amunicji */
    public int iAmmo = 20000;//#AI
    
    /** Ponizej jakiego stosunku ilosci trafien do ilosci strzalow 
     *  trzeba podbiegac jesli nReadinessToSearch > 0
     */
    public float fMinHitRatio = 0.5f;

    
    ////////////////////////////////////////////////
    // Ostrzeliwanie sie podczas marszu
    
    /** Znacznik, ze AI ma atakowac po sciezce patrolowej (musi dojsc do konca)
     */
    public boolean bPatrolAttack = false;//#AI

    /** Znacznik, ze AI ma szturmowac nie przechodzac do stanu SearchStatic
     */
    public boolean bAssaultMode = false;//#AI

    /** Znacznik, ze AI ma uciekac, gdy zbliza sie powazne niebezpieczenstwo
     *  (granaty, moze samochod)
     */
    public boolean bRunAwayFromDanger = true;//#AI
    
    /** Jak czesto sprawdzane jest, czy AI moze zaczac strzelac w czasie strafe'owania
     *  (strzela az do zakonczenia serii)
     */
    public float fUpdateStrafeFireInterval = 0.5f;
    
    /** Cosinus kata, o jaki moze byc maksymalnie odchylona lufa broni AI (w 2D)
     *  od celu, zeby do niego strzelalo
     */
    public float fMaxStrafeDirDifferenceCos = (float)Math.cos(Math.PI / 180.f * 30.f);
    

    ////////////////////////////////////////////////////////////////////////////////
    // Wyszukiwanie przeciwnika
    
    /** Waga odleglosci przeciwnika przy obliczaniu jego 'waznosci'
     */
    public float fEnemyDistanceImportance = 2;
    
    /** Waga parametru fTargetImportance przeciwnika przy obliczaniu jego 'waznosci'
     */
    public float fEnemyTargetImportance = 3;

    /** Co jaki czas AI moze zmieniac przeciwnika
     */
    public float fEnemyChangeInterval = 1;
    
    /** Losowy modyfikator dla fEnemyChangeInterval
     */
    public float fRandomEnemyChangeInterval = 5;
        
        
    /////////////////////////////////////////////////////////////////////////////
    // Modyfikatory parametrow broni AI

    /** Mnoznik zasiegu broni. Zasieg broni przemnozony przez ta wartosc daje
     *  odleglosc, z jakiej AI bedzie strzelalo do przeciwnika. 
     *  UWAGA: Ustawianie fWeaponRangeMplr > 1 nie ma sensu (bron i tak nie dostrzeli)
     */
    public float fWeaponRangeMplr = 1.f;//#AI
    
    /** Mnoznik dla fAIWeaponAimingDeviation z ActiveWeapon */
    public float fWeaAimingDeviationMplr = 1.f;//#AI
    /** Mnoznik dla fAIBurstAimingDeviation z ActiveWeapon */
    public float fWeaBurstAimingDeviationMplr = 1.f;//#AI

    /** Mnoznik dla fAISingleFireDelay z ActiveWeapon */
    public float fWeaSingleFireDelayMplr = 1.f;//#AI
    /** Mnoznik dla fAIRandomSingleFireDelay z ActiveWeapon */
    public float fWeaRandomSingleFireDelayMplr = 1.f;//#AI
    
    /** Mnoznik dla fAIBurstFireDelay z ActiveWeapon */
    public float fWeaBurstFireDelayMplr = 1.f;//#AI
    /** Mnoznik dla fAIRandomBurstFireDelay z ActiveWeapon */
    public float fWeaRandomBurstFireDelayMplr = 1.f;//#AI
    
    /** Nadpisanie nAIMaxSingleFireBullets z ActiveWeapon 
     * (gdy < 0 - bez zmian) */
    public int nWeaMaxSingleFireBulletsOvr = -1;//#AI

    /** Mnoznik dla fAIBurstTime z ActiveWeapon */
    public float fWeaBurstTimeMplr = 1.f;//#AI
    /** Mnoznik dla fAIRandomBurstTime z ActiveWeapon */
    public float fWeaRandomBurstTimeMplr = 1.f;//#AI

    /** Mnoznik dla fAIMaxBurstDistance z ActiveWeapon */
    public float fWeaMaxBurstDistanceMplr = 1.f;//#AI

    /** Mnoznik dla fAIHidingPosTime z ActiveWeapon */
    public float fWeaHidingPosTimeMplr = 1.f;//#AI
    /** Mnoznik dla fAIRandomHidingPosTime z ActiveWeapon */
    public float fWeaRandomHidingPosTimeMplr = 1.f;//#AI
    
    /** Mnoznik dla fAIFiringPosTime z ActiveWeapon */
    public float fWeaFiringPosTimeMplr = 1.f;//#AI
    /** Mnoznik dla fAIRandomFiringPosTime z ActiveWeapon */
    public float fWeaRandomFiringPosTimeMplr = 1.f;//#AI

    /////////////////////////////////////////////////////////////////////////////
    // Parametry ustawiane na podstawie danych z broni
    // UWAGA: sa one zastepowane wartosciami z broni ew. przemnozonymi
    //        przez odpowiednie wspolczynniki (patrz wyzej)
    
    /** Maksymalny rozrzut przy strzelaniu w stosunku do odleglosci [cm/cm] 
     *  dla pojedynczych strzalow
     */
    public float fAimingDeviation = 0.1f;
    /** Maksymalny rozrzut przy strzelaniu w stosunku do odleglosci [cm/cm] 
     *  dla strzelania seriami w trybie burst 
     */
    public float fBurstAimingDeviation = 0.5f;
        
    /** Minimalny odstep czasu pomiedzy seriami pojedynczych strzalow [s]*/
    public float fSingleFireDelay = 0.5f;
    /** Losowy modyfikator dla fSingleFireDelay [s]*/    
    public float fRandomSingleFireDelay = 2.f;
    
    /** Minimalny odstep czasu miedzy seriami strzalow w trybie burst (jesli nic innego nie podbiega) */
    public float fBurstFireDelay = 0.5f;
    /** Losowy modyfikator dla fBurstFireDelay */
    public float fRandomBurstFireDelay = .1f;

    /** Maksymalna (max-1) ilosc kul w serii zlozonej z pojedynczych strzalow */
    public int nMaxSingleFireBullets = 5;
    
    /** Dlugosc trwania serii [s]*/
    public float fBurstTime = 0.5f;
    /** Zakres losowania dlugosci trwania serii */
    public float fRandomBurstTime = .5f;

    /** Odleglosc, ponizej ktorej AI probuje strzelac seria [cm]*/
    public float fMaxBurstDistance = 2000;

    /** Prawdopodobienstwo, ze AI bedzie przycelowywac przy strzelaniu [%] */
    public int nReadinessToAim = 100;
    
    /** Prawdopodobienstwo, ze AI przestanie przycelowywac po strzale
     *  nawet, gdy nie biegnie [%]
     */
    public int nReadinessToStopAiming = 100;

    ////////////////////////////////
    // Atak z chowacza

    /** Czas, przez jaki AI pozostaje w ukryciu, gdy ma chowacza [s]*/
    public float fHidingPosTime = 1.1f;
    /** Losowy modyfikator dla fHidingPosTime */
    public float fRandomHidingPosTime = 0.5f;
    
    /** Czas, przez jaki AI pozostaje wychylone z ukrycia, gdy ma chowacza [s] */
    public float fFiringPosTime = 1.1f;
    /** Losowy modyfikator dla fFiringPosTime */
    public float fRandomFiringPosTime = 0.5f;

    /////////////////////////////////////////////////////////////////////////////
    // Pomocnicze parametry zwiazane z bronia AI

    /** Ile kul zostalo do wystrzelenia w serii pojedynczych strzalow */
    int nBulletsToFire = 0;

    
    /** Czy wlaczony jest tryb podbiegania zygzakami
     */
    boolean bZigZagAvailable = true;
    
    /** Minimalna odleglosc do celu, aby biegac zygzakami
     */
    float fZigZagMinDistance = 1200.0f;
    
    /** Jaki ma byc rozrzut w stosunku do odleglosci
     */
    float fZigZagDistanceDeviation = 0.6f;
    
    ////////////////////
    // Statystyki

    /** Ilosc wystrzelonych kul */
    int nRoundsShot = 0;
    /** Ilosc kul trafiajacych w przeciwnika  */
    int nRoundsHit = 0;
    
    /////////////////////////////////////////////////////////////////////////////
    
    
    
    
    /** Odleglosc, ponizej ktorej AI potrafi dokladnie okreslic pozycje wroga 
     *  gdy go uslyszy 
     */
    public float fMaxNoisePositionDistance = 1000;//#AI
              
    /** Odleglosc powyzej jakiej AI atakuje kucajac */
    public float fDuckDistance = 1000.0f;//#AI
    
    /** Odleglosc powyzej jakiej AI atakuje kladac sie na ziemie */
    public float fCrawlDistance = 3000.0f;//#AI
    
    
    /** Prawdopodobienstwo, ze stojace AI przejdzie w wolnej chwili do duck'a [%} */
    public int nReadinessToDuck = 70;
    
    /** Odleglosc powyzej jakiej musi byc wrog, zeby zaalarmowane przez MakeNoise AI
     *  nie atakowalo tylko sie rozgladalo (blizej - atakuje z prawdopodobienstwem 
     *  zaleznym od odleglosci) */
    public float fMaxAttackDistance = 3000.f;
    
    
    
    /////////////////////////////////////////////////////////////////////////////
    // Statyczne rozgladanie sie za przeciwnikiem
    
    /** Minimalna odleglosc, przy jakiej AI moze sie rozgladac zamiast atakowac
     *  (powyzej niej prawdopodobienstwo ataku rosnie liniowo az do fMaxAttackDistance
     *   gdzie jest rowne 100%)
     */
    public float fMinSearchStaticDistance = 500.f;

    /** Czas przez jaki AI sie rozglada, gdy zaalarmowane szuka przeciwnika [s]*/
    public float fSearchStaticTime = 7.f;
    
    /** Zakres rozrzutu dla fStaticSearchTime */
    public float fRandomSearchStaticTime = 10.f;
    
    /** Znacznik, ze AI moze obrocic sie o 180[deg] przy rozgladaniu sie gdy jest
     *  zaalarmowane (ustawic false np. zeby nie obrocil sie w kierunku sciany)
     */
    public boolean bSearchStaticLookBack = true;

    /** Znacznik, ze jesli AI rozgladajac sie nie znajdzie przeciwnika moze nie wrocic
     *  do kierunku sprzed poszukiwan 
     */
    public boolean bSearchStaticCanAlterDirection = true;
    
    /** Znacznik, ze jesli AI rozgladajac sie nie znajdzie przeciwnika moze nie wrocic
     *  do pozycji sprzed poszukiwan 
     */
    public boolean bSearchStaticCanAlterPosition = false;

    /** Czas w ktorym ostatnio szukalismy wroga
     */
    public float fSearchStaticLastTime = 0.0f;
    
    /** Flaga mowiaca o tym czy szukamy wroga bo strzelano
     *  do nas, czy do kogos innego
     */
    public boolean bSomebodyIsTryingToKillMe = false;
    
    /** licznik uslyszanych rykoszetow, bedzie on istotny
     *  podczas stanu SearchStatic, gdzie AI po pewnym czasie
     *  "zauwazy" strzelajacego nawet z dalszej odlaglosci
     */
    public int nRicochets = 0;
    
    /** Liczba rykoszetow wejsciowych w poprzednim stanie SearchStatic
     *  Bedzie to potrzebne przy przejsciu ze stanu SearchStatic -> SearchStatic
     */
    public int nLastStartRicochetsInSearchStatic = 0;
    
    public static int _MAX_RICOCHETS_IN_SEARCHSTATIC = 3;
    
    /** Odleglosc, z jakiej wyciagane sa przeszkody, gdy sprawdza czy moze patrzec do 
     *  tylu albo kucajac przy szukaniu statycznym
     */
    float fStaticSearchObstacleDistance = 500.f;

    
    /** Zakres losowania rozrzutu od wartosci wlaczania poszeczegolnych
     * sposobow ataku: stania, kucania, lezenia 
     *  + strzelania seria
     */
    public float fRandomDistance = 400.0f;//#AI

    /** Czas po jakim AI wychyla sie z ukrycia jak nikt nie strzela.
     */
    public float fTimeToSurprize = 1.0f;


    /** Czas po jakim AI strzela po krzyknieciu na widok gracza [s] */
    public float fFirstRoundDelayTime = 0.1f;
    
    /** Zakres rozrzutu czasu po jakim AI strzela po krzyknieciu na widok gracza [s] */
    public float fRandomFirstRoundDelayTime = 0.5f;
    
    /** Czas po jakim AI zaczyna szukac gracza, gdy przestanie go widziec 
     *  w stanie ataku [s]
     */
    public float fTimeToStartSearch = 3.f;//#AI
    
    /** Zakres rozrzutu czasu po jakim AI szuka gracza [s] */
    public float fRandomTimeToStartSearch = 1.f;
   
    
    /** Maksymalny czas losowej przerwy */
    public float fRandomWaitTime = 0.3f;

    //////////////////////////////////////////////////////////////////
    // Podbieganie
    
    /** Odleglosc, powyzej ktorej AI moze podbiegac */
    public float fStartRunUpDistance = 300.f;    
    
    /** Minimalny czas przez jaki AI podbiega, jesli wogole podbiega [s] */
    public float fRunUpTime = 1.f;
    
    /** Zakres rozrzutu czasu przez jaki AI podbiega do gracza [s] */
    public float fRandomRunUpTime = 3.f;
  
    //////////////
    // pomocnicze
    
    /** Znacznik, ze podbieganie wylaczylo sledzenie cialem celu - trzeba wlaczyc */
    boolean bWasTrackingBodyBeforeRunUp = false;

    /////////////////////////////////////////////////////////////////
    // Obszar ataku
    
    /** Odleglosc od punktu startowego, powyzej jakiej AI od niego nie odchodzi
     *  (gdy <0 - brak ograniczen)
     */
    public float fTerritoryRadius = -1.f;//#AI
    

    
    ////////////////////////////////////////////////////////////////////
    // Spacerowanie AI

    /** Jak daleko moze sobie pojsc AI jesli nie ma ograniczen na obszar, 
     *  po ktorym chodzi [cm]
     */
    public float fFreeWalkDistance = 100.f;

    /** Losowy modyfikator dla fFreeWalkDistance
     */
    public float fRandomFreeWalkDistance = 400.f;
    
    /** Promien okregu, wewnatrz ktorego moze sobei spacerowac AI [cm]
     *  (jesli -1 - nie ma ograniczenia)
     */
    public float fWalkAreaRadius = 300.f;


    /** Prawdopodobienstwo, ze AI sie przespaceruje w Idle, jesli 
     *  nReadinessTOSearch > 0 i minal juz odpowiednio dlugi czas [%]
     */
    public int nReadinessToWalk = 10;//#AI
    
    
    /** Czas pomiedzy kolejnymi przechadzkami AI w Idle [s]
     */
    public float fBetweenWalkTime = 3.f;
    
    /** Losowy modyfikator dla fBetweenWalkTime
     */
    public float fRandomBetweenWalkTime = 10;
    
    
    ////////////////////////
    // Pomocnicze

    /** Czas pomiedzy kolejnymi przechadzkami AI w Idle z losowa mdyfikacja
     */
    float fCurBetweenWalkTime = 0;
    /** Czas rozpoczecia ostatniego spaceru
     */
    float fLastWalkTime = 0;
    
    
    
    /** Wspolczynnik 'checi dobiegania' [%]
     *  0   - nigdy nie dobiega do gracza
     *  100 - zawsze dobiega do gracza
     *  UWAGA: dla >0 - moze dobiegac nawet gdy CanHappen = 0 
     *  (np. gdy nie trafia w przeciwnika)
     */
    public int nReadinessToSearch = 90;//#AI

    
    /////////////////////////////////////////
    // Radosc na widok wroga

    /** Tablica dzwiekow odpalanych po zauwazeniu wroga, gdy w poblizu nie ma innych AI */
    String[] aHeySoundsAlone = { "Data/Sounds/Ai/hej 01",
                                 "Data/Sounds/Ai/hej 02",
                                 "Data/Sounds/Ai/hej 03",
                                 "Data/Sounds/Ai/freeze 01",
                                 "Data/Sounds/Ai/freeze 02",
                                 "Data/Sounds/Ai/stop 01",
                                 "Data/Sounds/Ai/stop 02"
                               };

    /** Tablica dzwiekow odpalanych po zauwazeniu wroga, gdy w poblizu jest jakies AI */
    String[] aHeySoundsCrowd = aHeySoundsAlone;// chwilowo
    
    /** Znacznik, ze AI powinno krzyknac na widok przeciwnika */
    boolean bShouldShout = true;
    
    /** Dzwieki odpalane gdy zastanawia sie po uslyszeniu wroga */
    String[] aPlayerNoiseReaction = aHeySoundsAlone;// chwilowo
    
    /** Czas potrzebny na reakcje na uslyszenie gracza [s] */
    float fPlayerNoiseReactionTime = 0.3f;
    

    ///////////////////////////////////
    // Tryb kampowania podczas ataku //
    ///////////////////////////////////
    
    //////////////
    // PARAMETRY

    /** Minimalna odleglosc od wroga, przy ktorej AI atakuje jeszcze w trybie kampowania [cm] */
    public float fMinCamperDistanceToEnemy = 500.f;//#AI

    /** Jak dlugo po uslyszeniu krzyku kolegi kamper ma kampowac [s] */
    public float fFriendCamperTimer = 1e10f;//#AI
    /** Losowy modyfikator dla fFriendCamperTimer */
    public float fRandomFriendCamperTimer = 0.1f;//#AI
    
    public boolean bEnemyNoiseStartsCamperTimer = false;//#AI
    /** Jak dlugo po zauwazeniu (zobaczeniu, uslyszeniu) przeciwnika kamper ma kampowac [s]*/
    public float fEnemyCamperTimer = 1e10f;//#AI
    /** Losowy modyfikator dla fEnemyCamperTimer */
    public float fRandomEnemyCamperTimer = 0.1f;//#AI
    
    
    ////////////////
    // POMOCNICZE

    /**
     */
    float fLastFriendCamperTime = 0;
    /**
     */
    float fCurrentFriendCamperTimer = 0;
    /**
     */
    float fLastEnemyCamperTime = 0;
    /**
     */
    float fCurrentEnemyCamperTimer = 0;
    
    /** Znacznik, ze oberwal i trzeba na to zareagowac
     */
    boolean bDamageTaken = false;
    
    /** Znacznik, ze AI jest aktualnie w trybie kampowania */
    boolean bCamperMode = true;

    /**
     */
    float fLastFiringPosTime = 0;
    
    /** 
     */
    float fLastHidingPosTime = 0;
    
    /** 
     */
    float fCurrentFiringPosTime = 0;
    
    /** 
     */
    float fCurrentHidingPosTime = 0;
    
    
    
    /////////////////////////////////////////////
    // Sledzenie przeciwnika
    
    /** Indeks (parametr GetPointToLookAt) punktu, na ktory 
     *  ma patrzec AI sledzac przeciwnika
     */
    int nTrackingLookAtPointIdx = 0;
    
    
    /** Znacznik, ze AI powinno sledzic jakis obiekt
     */
    boolean bShouldWalkTracking = false;
    
    
    //----------------------------------------------------

    final static int _ACTION_GOTO_SIMPLE_FROM_CHOWACZ = 101;
    final static int _ACTION_FIRE_ROUND               = 102;
    final static int _ACTION_WAIT_FOR_WEAPON_READY    = 103;
    final static int _ACTION_RELOAD                   = 104;
    final static int _ACTION_SEARCH_ENEMY_DYNAMIC     = 105;
    final static int _ACTION_CALM_DOWN                = 106; 
    final static int _ACTION_TURN                     = 107;
    final static int _ACTION_TURN_QUICK               = 108;
    final static int _ACTION_TRACK_ENEMY_BODY         = 109;
    final static int _ACTION_SAY_HEY                  = 110;
    final static int _ACTION_WAIT                     = 111;
    final static int _ACTION_NOISE_REACTION           = 112;
    final static int _ACTION_RUN_UP_TO_ENEMY          = 113;
    final static int _ACTION_WAIT_A_MINUTE            = 114;

    final static int _ACTION_START_STRAFE_APPROACH    = 115;
    final static int _ACTION_START_STRAFE_AWAY        = 116;
    final static int _ACTION_START_STRAFE_SIDEWAYS    = 117;
    final static int _ACTION_STOP_STRAFE              = 118;
    
    final static int _ACTION_LOOK_LEFT                = 119;
    final static int _ACTION_LOOK_FORWARD             = 120;
    final static int _ACTION_LOOK_RIGHT               = 121;
    
    final static int _ACTION_THROW_GRENADE_TO_ENEMY   = 122;
    final static int _ACTION_ESCAPE_FROM_DANGER       = 123;
    
    final static int _ACTION_TAKE_A_WALK              = 124;
    final static int _ACTION_TAKE_A_RUN               = 125;
    final static int _ACTION_GOTO_POS                 = 126;
    final static int _ACTION_RUNTO_POS                = 127;
    
    final static int _ACTION_START_STRAFE_FIRE        = 128;
    final static int _ACTION_STOP_STRAFE_FIRE         = 129;
    
    
//-------------------------------------------
    
    /** Pozycje strzeleckie
     *  ( powiazane z tablicami aFiringPos* )
     */
    final static int _FIRINGPOS_CRAWL   =   0;
    final static int _FIRINGPOS_DUCK    =   1;
    final static int _FIRINGPOS_STAND   =   2;
    final static int _FIRINGPOS_DUCK_A  =   3;
    final static int _FIRINGPOS_STAND_A =   4;
    
    // w przypadku plywania przyjmuje sie ze mamy do czynienia z _FIRINGPOS_CRAWL,
    // zatem nie trzeba powiekszac ponizszych tablic!
    
    /** Tablica polozenia (wysokosci) broni dla roznych pozycji strzeleckich */
    final static float aWeaponHeight[] = { 23, 76, 120, 91, 142 };
    
    /** Tablica polozenia (wysokosci) glowy dla roznych pozycji strzeleckich */
    final static float aHeadHeight[] = { 45, 120, 175, 120, 175 }; 
//    final static float aHeadHeight[] = { 45, 125, 175, 125, 175 }; 
    /** Czynniki powodujace przejscie do ataku */
    final static int _ATTACK_CAUSE_NONE     = 0;
    final static int _ATTACK_CAUSE_NOISE    = 1;
    final static int _ATTACK_CAUSE_SIGHT    = 2;
    final static int _ATTACK_CAUSE_HIT      = 3;
    
    /** Znacznik, co spowodowalo przejscie do stanu ataku */
    int nAttackCause = _ATTACK_CAUSE_NONE;
    
    /** 
     * Przyjaciel ktory zginal, 
     * AI wchodzac do stanu SearchStatic moze chciec podbiec do trupa
     */
    AIAttacker cDeadFriend = null;
    
    /** Liczba przyjaciol ktora do tej pory "zainteresowala"
     *  sie smiercia gostka i pojdzie "zobaczyc co sie stalo"
     */
    int nFollowFriends = 0;
    
    /**
     *  Maksymalna ilosc przyjaciol ktora ma sie interesowac trupkiem
     *  Na razie ustawione na 0, bo cos nie chce dzialac (gostkowie podbiegaja
     * ale przebieraja w miejscu)
     */
    final static int _MAX_FOLLOW_FRIENDS = 0;
    
    
    /** Wrog AI, ktory jest atakowany */
    ChromeActor cEnemy = null;

    /** Indeks (parametr GetPointToLookAt) punktu, w ktory AI powinno
     *  strzelic wrogowi( zmieniane dynamicznie przy celowaniu ) */
    int nTargetPointIdx = 0;
    
    /** Czas, kiedy ostatnio widac bylo przeciwnika */
    float fLastKnownEnemyPosTime = 0;
    /** Ostatnia pozycja, na ktorej widziano przeciwnika */
    Vector vLastKnownEnemyPos = new Vector();
    /** Kierunek, w ktorym uciekl przeciwnik z ostatniej znanej pozycji */
    Vector vLastKnownEnemyDir = null;
    /** Znacznik, ze wrog jest juz niezywy (updateowany podczas patrzenia AI) */
    boolean bEnemyDown = false;

    /** Kierunek, do ktorego ma obrocic sie AI */
    Vector vDesiredDir = null;
    
    /** Punkt, do ktorego ma dojsc AI */
    Vector vDesiredPos = null;

    
    /** Czas oczekiwania dla _ACTION_WAIT (ustawiany przed wywolaniem taska) */
    float fWaitTime = 0.f;
    
    
    ///////////////////////
    // Zachowania stadne //
    ///////////////////////

    /** Przez jaki czas aktualne sa dane o pobliskich kolegach [s] */
    float fNearbyFriendsUpdateTime = 2.f;
    /** Jak blisko (promien w cm) musza byc AI, zeby uznac je za pobliskie */
    public float fNearbyFriendsMaxDistance = 1000.f;
    
    /** Promien okregu na jakim ustawiaja sie AI atakujac przeciwnika kupa [cm] */
    public float fGroupAttackRadius = 1500.f;
    
    
    int METHOD_FireDone         = 0;
    int METHOD_WeaponReady      = 0;
    int METHOD_FireOneBullet    = 0;
    int METHOD_WaitDone         = 0;
    int METHOD_RunUpDone        = 0;
    int METHOD_ReloadAnimEnd    = 0;
    int METHOD_UpdateStrafeFire = 0;
    
    // Callback
    int METHOD_TurnDone         = 0;
    int METHOD_QuickTurnDone    = 0;
    int METHOD_StopTurnAnim     = 0;
    

    
    /////////////////////////////
    // GRANATY

    /** Klasa granatow posiadanych przez AI
     */
    public String sAIGrenadeClass = "Grenade";
    
    /** Ilosc granatow posiadanych przez AI
     */
    public int nGrenades = 0;//#AI
    
    /** Powyzej jakiej ilosci granatow prawdopodobienstwo rzutu w sprzyjajacych 
     *  warunkach wynosi 100% (ponizej tej ilosci spada liniowo do 0)
     */
    public int nGrenadesMoreThanEnoughCount = 5;
    
    /** Czas od zauwazenia przeciwnika do wyrzucenia pierwszego granata */
    public float fGrenadeTimer = 0.f;
    
    /** Losowy modyfikator dla fGrenadeTimer */
    public float fRandomGrenadeTimer = 0.1f;
    
    /** Odstep czasu miedzy rzucanymi granatami
     */
    public float fGrenadeThrowingDelay = 5.f;
    
    /** Losowy modyfikator dla fGrenadeThrowinfDelay
     */
    public float fRandomGrenadeThrowingDelay = 10f;
    
    /** Minimalna odleglosc od przeciwnika, zeby AI rzucalo granatem
     */
    public float fMinGrenadeThrowDistance = 1000.f;
    
    /** Maksymalna odleglosc od przeciwnika, na jaka AI moze rzucac granatem
     */
    public float fMaxGrenadeThrowDistance = 4000.f;
    
    /** Maksymalna wysokosc przeszkody, ponad ktora AI rzuca granatem
     */
    public float fGrenadeMaxObstacleHeight = 300.f;
    
    /** Zakladany zasieg 'szkodliwosci' granatu
     */
    public float fGrenadeSafeDistance = 1000.f;
    
    /** Maksymalna odl. od celu na jaka musi moc doleciec granat, aby byl rzucony
     */
    public float fGrenadeTargetDistanceTolerance = 200.f;
    
    /** Kat dla plaskiego rzucania granatem (np. w budynkach) [deg]
     */
    public float fGrenadeAngleLow = 15.f;
    
    /** Kat dla standardowego rzucania granatem (najwiekszy zasieg) [deg]
     */
    public float fGrenadeAngleNormal = 45.f;
    
    /** Kat dla wysokiego rzucania granatem (np. zza skrzynki) [deg]
     */
    public float fGrenadeAngleHigh = 60.f;

    /** Maksymalny rozrzut w stosunku do odleglosci [cm/cm] 
     *  dla rzucania granatami
     */
    public float fGrenadeAimingDeviation = 0.1f;
    
    /** O ile blizej ma rzucac granatem AI, zeby sie podturlal do gracza[cm]
     */
    public float fGrenadeRollingDistance = 200.f;
    
    /** Wspolczynnik uwzglednienia predkosci celu w zaleznosci od odleglosci
     */
    public float fGrenadeTargetSpeedFactor = 4.f;
        
    /** Co jaki czas mozna sprawdzac, czy da sie rzucic granatem 
     *  (wymaga to sprawdzenia trace'a i wyciagniecia obiektow z grida)
     */
    float fGrenadeCheckDelay = 2.f;

    //////////////
    // Pomocnicze

    /** Ile jeszcze granatow pozostalo AI
     */
    int nGrenadesLeft = 0;
    
    java.util.Vector vGrenades = new java.util.Vector();
    
    /** Aktualna przerwa miedzy rzucanymi granatami
     */
    float fCurrentGrenadeThrowingDelay = 0;
    
    /** Czas wyrzucenia ostatniego granatu
     */
    float fLastGrenadeTime = 0;
    
    /** Obecna wartosc timera pierwszego granatu
     */
    float fCurrentGrenadeTimer = 0;
    
    /** Czas, kiedy wystartowal timer do rzucenia pierwszego granatu
     */
    float fLastStartGrenadeTime = 0;
    
    /** Czas, kiedy ostatnio sprawdzane bylo, czy mozna rzucic granatem
     */
    float fLastGrenadeCheckTime = 0;
    
    // Magiczne wspolczynniki doswiadczalne
    /** Mnoznik obliczonej sily rzutu (zeby sie dostosowac z odlegloscia wynikowa do fizyki)
     */
    float fMagicGrenadeThrowForceCoefficient = 12.7f / 414.f;
    
    /** Wspolczynnik wplywu roznicy wysokosci na sile rzutu, gdy cel powyzej AI
     */
    float fMagicGrenadeHeightUpCoefficient = 1.2f;
    
    /** Wspolczynnik wplywu roznicy wysokosci na sile rzutu, gdy cel ponizej AI
     */
    float fMagicGrenadeHeightDownCoefficient = 0.9f;

   
    
    ///////////////////////////////////////
    // Reakcja na niebezpieczne miejsca  //
    ///////////////////////////////////////
    
    /** Pozycja obszaru zagrozenia
     */
    Vector vDangerPosition = null;
    
    /** Promien obszaru zagrozenia [cm]
     */
    float fDangerRadius = 0;
    
    /** Zapamietany sledzony przy chodzeniu obiekt
     */
    ControlObject cBeforeEscapeWalkTrackedObject = null;
    

    
    ///////////////////////////////////////////////////////////////////
    // PROFILING
    //
    
/*    static int PROFILE_OnReact = 0;
    static int PROFILE_AttackDecision = 0;
    static int PROFILE_TakeAction = 0;    
*/    
    AIAttacker()
    {
        super();
        
        //#DEF_BEGIN
        ScreenshotIconPath = "data/textures/icons/icon_soldier.png";
        //#DEF_END
        
        nTeamID = 10000; // przeciwny playerowi
    }
    
    
    
    public void OnCreate()
    {
        //LogD("\n");
        super.OnCreate();
        
        METHOD_FireDone         = RegisterCallMethod("FireDone");
        METHOD_WeaponReady      = RegisterCallMethod("WeaponReady");
        METHOD_FireOneBullet    = RegisterCallMethod("FireOneBullet");
        METHOD_WaitDone         = RegisterCallMethod("WaitDone");
        METHOD_RunUpDone        = RegisterCallMethod("RunUpDone");
        
        METHOD_TurnDone         = RegisterCallMethod("TurnDone");
        METHOD_QuickTurnDone    = RegisterCallMethod("QuickTurnDone");
        METHOD_StopTurnAnim     = RegisterCallMethod("StopTurnAnim");
        METHOD_ReloadAnimEnd    = RegisterCallMethod("ReloadAnimEnd");
        
        METHOD_UpdateStrafeFire = RegisterCallMethod("UpdateStrafeFire");
        
        if (nThisInstanceNumber == 0) //obiekt inicjujacy
        {
/*            PROFILE_OnReact = ProfileAdd(sAIProfilingPage, "OnReact");
            PROFILE_AttackDecision = ProfileAdd(sAIProfilingPage, "AttackDecision");
            PROFILE_TakeAction = ProfileAdd(sAIProfilingPage, "TakeAction");
*/        }
        
        //bIsNameSprVisible = true; //wyswietlenie infosa
    }
    
    
    void Initialize()
    {
        super.Initialize();
        InitializeAIWeapon();
        ResetGrenadeTimers();
        ResetCamperTimers();
        bCamperMode = true;
    }

    
    
    void InitializeAIWeapon()
    {
//        if (ActiveWeapon == null) //TST!!!!!!!!!!!!!!
        if (ActiveWeapon != null)
        {
            /*
            ActiveWeapon.DetachFromParent();
            ActiveWeapon.DeactivateOnModule();
            ActiveWeapon.delete();    
            ActiveWeapon = null;
            */
            
            Weapon toRemove = ActiveWeapon;
            UseWeapon((Weapon)null);

            //wyciagamy z inventory stara bron
            cInventory.RemoveInvObject(toRemove);
            toRemove.ChangeInvState(this, EInvObjState._ONGROUND);
            toRemove.DetachFromParent();
            toRemove.DeactivateOnModuleAlways();
            toRemove.delete();    
            toRemove = null;

        }
        
        {
            if (sAIWeapon.equalsIgnoreCase("WeaponPistol02"))
                sAIWeapon = "WeaponPistol";
            if (sAIWeapon.equalsIgnoreCase("WeaponPistol04"))
                sAIWeapon = "WeaponPistolSilenced";
            if (sAIWeapon.equalsIgnoreCase("WeaponPistol07"))
                sAIWeapon = "WeaponPistolHeavy";
            
            if (sAIWeapon.equalsIgnoreCase("WeaponRifle08"))
                sAIWeapon = "WeaponRifle";
            if (sAIWeapon.equalsIgnoreCase("WeaponRifle06"))
                sAIWeapon = "WeaponRifleShort";
            if (sAIWeapon.equalsIgnoreCase("WeaponRifle07"))
                sAIWeapon = "WeaponRifleShortSilenced";
            if (sAIWeapon.equalsIgnoreCase("WeaponRifle16"))
                sAIWeapon = "WeaponRifleMachineGun";
            
            if (sAIWeapon.equalsIgnoreCase("WeaponRifle11"))
                sAIWeapon = "WeaponRifleSniper";
            if (sAIWeapon.equalsIgnoreCase("WeaponRifle12"))
                sAIWeapon = "WeaponRifleSniperHeavy";
            if (sAIWeapon.equalsIgnoreCase("WeaponHeavy03"))
                sAIWeapon = "WeaponRifleHeavy";

            if (sAIWeapon.equalsIgnoreCase("WeaponHeavy02"))
                sAIWeapon = "WeaponHeavyHEX";
            if (sAIWeapon.equalsIgnoreCase("WeaponHeavy07"))
                sAIWeapon = "WeaponHeavyRocketLauncher";
            if (sAIWeapon.equalsIgnoreCase("WeaponHeavy08"))
                sAIWeapon = "WeaponHeavyElectro";
            
            
            
            
            Weapon Gun = (Weapon)CreateObject(sAIWeapon);
            Gun.AddToInventory(this, false);
            ChangeWeapon(Gun);
            SetupAIParamsFromWeapon();
        }
        WeaponReload();
        nGrenadesLeft = nGrenades;
    }

    
    
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        /*
        // cheat - podmiana broni martwego AI na bazooke
        if ((nKeyCode==EKey._F1) && (bKeyState))
        {
            if (bDead)
            {
                sAIWeapon = "WeaponHeavyRocketLauncher";    
                InitializeAIWeapon();

                Ammo ammo = null;
                for (int i=0; i<2; i++)
                {
                    ammo = (Ammo)CreateObject("AmmoHEX");
                    ammo.Execute(this);
                }


            }
        }
        */
        super.OnInputKey(nKeyCode, bKeyState, nKeyAscii);
    }

    
    void SetupAIParamsFromWeapon()
    {
        if (ActiveWeapon != null)
        {
           SetupAimingFromWeapon();
           fSingleFireDelay  = ActiveWeapon.fAISingleFireDelay * fWeaSingleFireDelayMplr;
           fRandomSingleFireDelay  = ActiveWeapon.fAIRandomSingleFireDelay * fWeaRandomSingleFireDelayMplr;
           fBurstFireDelay  = ActiveWeapon.fAIBurstFireDelay * fWeaBurstFireDelayMplr;
           fRandomBurstFireDelay  = ActiveWeapon.fAIRandomBurstFireDelay * fWeaRandomBurstFireDelayMplr;
           if (nWeaMaxSingleFireBulletsOvr < 0)
               nMaxSingleFireBullets = ActiveWeapon.nAIMaxSingleFireBullets;
           else
               nMaxSingleFireBullets = nWeaMaxSingleFireBulletsOvr;
           fBurstTime = ActiveWeapon.fAIBurstTime * fWeaBurstTimeMplr;
           fRandomBurstTime  = ActiveWeapon.fAIRandomBurstTime * fWeaRandomBurstTimeMplr;
           fMaxBurstDistance  = ActiveWeapon.fAIMaxBurstDistance * fWeaMaxBurstDistanceMplr;
           nReadinessToAim = ActiveWeapon.nAIReadinessToAim;
           nReadinessToStopAiming = ActiveWeapon.nAIReadinessToStopAiming;
           fHidingPosTime = ActiveWeapon.fAIHidingPosTime * fWeaHidingPosTimeMplr;
           fRandomHidingPosTime = ActiveWeapon.fAIRandomHidingPosTime * fWeaRandomHidingPosTimeMplr;
           fFiringPosTime = ActiveWeapon.fAIFiringPosTime * fWeaFiringPosTimeMplr;
           fRandomFiringPosTime = ActiveWeapon.fAIRandomFiringPosTime * fWeaRandomFiringPosTimeMplr;
        }
    }
    
    void SetupAimingFromWeapon()
    {
        fAimingDeviation  = ActiveWeapon.fAIAimingDeviation * fWeaAimingDeviationMplr;
        fBurstAimingDeviation  = ActiveWeapon.fAIBurstAimingDeviation * fWeaBurstAimingDeviationMplr;        
    }
    
    
    
    
    void FillInventory()
    {
        /** Najpierw rzeczy z inventory
         */
        super.FillInventory();

        /** A teraz granaty */
//        Grenade cGrenade;
//        for (int i=0; i<nGrenades; i++)
//        {
//            cGrenade = (Grenade)CreateObject(sGrenadeClass);
//            cGrenade.Execute(this);
//            vGrenades.addElement(cGrenade);            
//        }
        
        //TODO: dodac wykorzystywanie tych granatow
    }
    
    
    
    
    void ChangeWeapon(Weapon cWpn)
    {
        UseWeapon(cWpn);
    }
    
    
    void SaveImportantMembers(java.io.PrintWriter output)
    {
        super.SaveImportantMembers(output);
        output.println("[AIAttacker]");
//        output.println("fMaxNoisePositionDistance = " + fMaxNoisePositionDistance);
//        output.println("fAimingDeviation = " + fAimingDeviation);
//        output.println("fBurstAimingDeviation = " + fBurstAimingDeviation);
//        output.println("fSingleFireDelay = " + fSingleFireDelay);
//        output.println("fRandomSingleFireDelay = " + fRandomSingleFireDelay);
//        output.println("fBurstTime = " + fBurstTime);
//        output.println("fRandomBurstTime = " + fRandomBurstTime);
//        output.println("fMaxBurstDistance = " + fMaxBurstDistance);
//        output.println("fMinBurstRate = " + fMinBurstRate);
//        output.println("fDuckDistance = " + fDuckDistance);
//        output.println("fRandomDistance = " + fRandomDistance);
//        output.println("fFirstRoundDelayTime = " + fFirstRoundDelayTime);
//        output.println("fRandomFirstRoundDelayTime = " + fRandomFirstRoundDelayTime);
//        output.println("fTimeToStartSearch = " + fTimeToStartSearch);
//        output.println("fRandomWaitTime = " + fRandomWaitTime);
//        output.println("fStartRunUpDistance = " + fStartRunUpDistance);
//        output.println("fRunUpTime = " + fRunUpTime);
//        output.println("fRandomRunUpTime = " + fRandomRunUpTime);
//        output.println("fMinHitRatio = " + fMinHitRatio);
//        output.println("fPlayerNoiseReactionTime = " + fPlayerNoiseReactionTime);
//        output.println("fTwistHorizMin = " + fTwistHorizMin);
//        output.println("fTwistHorizMax = " + fTwistHorizMax);
//        output.println("fTwistVertMin = " + fTwistVertMin);
//        output.println("fTwistVertMax = " + fTwistVertMax);
//        output.println("fHeadTwistFactor = " + fHeadTwistFactor);
//        output.println("fTwistTime = " + fTwistTime);
//        output.println(" = " + );
    }
    
    public void Run()
    {
        StartYourDuty();
        //SetState("TestState"); //tst
    }
    
    
    void StartYourDuty()
    {
        // gdy nasz kolo ma sciezke patrolowa to wlaczamy mu sloneczny patrol
        if ( (aPath != null) &&
			 (aPath.GetPointsNum() > 0) &&
			 (nCurrentNode < aPath.GetPointsNum() - 1))
            SetState("Patrol");
        else
            ChooseIdleState();
    }
    

    public void DisableVitalActivities()
    {
        //LogD("\n");
        if (ActiveWeapon != null)
            ActiveWeapon.StopFire();

        vDangerPosition = null;
        
        DisableCallMethod(METHOD_FireDone);
        DisableCallMethod(METHOD_WeaponReady);
        DisableCallMethod(METHOD_FireOneBullet);
        DisableCallMethod(METHOD_WaitDone);
        DisableCallMethod(METHOD_RunUpDone);
        DisableCallMethod(METHOD_ReloadAnimEnd);
        
        super.DisableVitalActivities();

        DisableTracingEnemyBody();
    }
    
    
    public void ActivateAI(boolean bActivate, int nFreezeCause)    
    {
        super.ActivateAI(bActivate, nFreezeCause);
        if (ActiveWeapon != null)
            ActiveWeapon.EnableRendering(bActivate);
    }
        
    

    public void FreezeAI(int nFreezeCause)
    {
        super.FreezeAI(nFreezeCause);
        if (ActiveWeapon != null) 
            ActiveWeapon.FreezeCallMethods();
    }
    
    public void UnfreezeAI(int nFreezeCause)
    {
        super.UnfreezeAI(nFreezeCause);
        if (ActiveWeapon != null)
            ActiveWeapon.UnfreezeCallMethods();
    }

    
    //////////////////////////////////////////////////////
    // Strafowanie - ostrzeliwanie sie podczas biegania

    
    boolean bStrafeFire = false;
    
    int nStrafeFireMode = Weapon._FIREMODE_NONE;
    
    /** Metoda wolana cyklicznie - w niej jest sprawdzane, czy AI ma zaczac strzelac
     *  strafujac
     */
    public void UpdateStrafeFire()
    {
        if (cEnemy != null)
        {
            if (ActiveWeapon != null &&
                ActiveWeapon.nAIReadinessToAim < 100) // moze strzelac biegnac tylko, jesli bron nie wymaga przycelowania
            {
                Vector vEnemyPos = cEnemy.GetPosition();
                Vector vDir = new Vector(vEnemyPos);
                vDir.Sub(GetPosition());
                vDir.fY = 0;
                float fDist2D = vDir.Len();
                
                // Sprawdz odleglosc od przeciwnika
                if (fDist2D < ActiveWeapon.fRange * fWeaponRangeMplr)
                {
                    vDir.Mul(1.f / fDist2D);
                    
                    Vector vBarrelDir = ActiveWeapon.GetForwardVector();
                    vBarrelDir.fY = 0;
                    vBarrelDir.Normalize();
                    
                    //                CrashLog("Dist: OK " + vDir.Dot(vBarrelDir) + "," + IsEnemyInWeaponRange() + "\n");
                    // Sprawdz kat odchylenia lufy od kierunku do celu i widocznosc celu
                    if (vDir.Dot(vBarrelDir) > fMaxStrafeDirDifferenceCos &&
                        IsEnemyInWeaponRange())
                    {
                        if ((ActiveWeapon.nAIFireModes & Weapon._FIREMODE_BURST) != 0 && 
                            (fDist2D < fMaxBurstDistance + RandomFloat(fRandomDistance)))
                            StartStrafeBurstFire();
                        else
                            StartStrafeSingleFire();
                        return;
                    }
                }
            }
        }
        else
        {
            if (bTrackingHead)
                StopHeadTracking();
        }
            
        CallMethodIn(METHOD_UpdateStrafeFire, fUpdateStrafeFireInterval);
    }
    
    /** Rozpoczecie strzelania podczas strafowania (tryb single fire)
     */
    void StartStrafeSingleFire()
    {
        cMotion.bFiring = true;
        nBulletsToFire = RandomInt(nMaxSingleFireBullets)+1;
        FireOneBullet();
        CallMethodIn(METHOD_UpdateStrafeFire, 60/ActiveWeapon.fRateOfFire * nBulletsToFire +
                                              fSingleFireDelay + RandomFloat(fRandomSingleFireDelay));
    }
    
    /** Rozpoczecie strzelania podczas strafowania (tryb burst fire)
     */
    void StartStrafeBurstFire()
    {
        float fFiringTime = fBurstTime + RandomFloat(fRandomBurstTime);
        cMotion.bFiring = true;
        ActiveWeapon.StartFire( Weapon.MODE_AUTO );
        CallMethodOnceIn( METHOD_UpdateStrafeFire, fFiringTime + 
                                                   fBurstFireDelay + RandomFloat(fRandomBurstFireDelay));
        CallMethodOnceIn( "EndStrafeFire", fFiringTime);
    }
    
    
    /** Zatrzymanie strzelania w trybie burst (wewnetrzne)
     */
    void EndStrafeFire()
    {
        nBulletsToFire = 0;
        ActiveWeapon.StopFire();
        cMotion.bFiring = false; 
    }
    
    /** Zaprzestanie strzelania
     */
    void StopStrafeFire()
    {
        EndStrafeFire();
        DisableCallMethod( METHOD_UpdateStrafeFire );
        DisableCallMethod( METHOD_FireOneBullet );
    }
    

    /** Odpalenie animacji przeladowania przy strafowaniu
     */
    void StrafeReload()
    {
        StopStrafeFire();
        
        PlayAnim("Spine", "Rwre_2", 1);
        CallMethodIn("StrafeReloadEnd", GetAnimLength("Rwre_2"));
    }

    /** Koniec animacji przeladowania i faktyczne przeladowanie broni
     */
    void StrafeReloadEnd()
    {
        WeaponReload();
        UpdateStrafeFire();
    }
    
    
    
    ////////////////////////////////////////////////////////////////////////////////
    
    
/*    public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        bDamageTaken = true;

        if (Assassin instanceof AIAttacker && 
             GetTeamRelation( (AIAttacker)Assassin ) > _TEAM_RELATION_NEUTRAL)
            ((AIAttacker) Assassin).NotifyPlayerHit(this); //powiedz mu, zeby nie strzelal do swoich
        else // AI cheat: friendly fire == false
        {
            // jesli oberwal zywy i jeszcze nie atakuje to do dziela
            if (fHealth >0 && 
                !(CurrentState instanceof AIAttacker.Attack) && 
                Assassin instanceof ChromeActor &&
				GetTeamRelation( (ChromeActor)Assassin ) < _TEAM_RELATION_NEUTRAL)
            {
                nAttackCause = _ATTACK_CAUSE_HIT;
                SeekAndDestroy((ChromeActor) Assassin);
            }
            super.OnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
        }
    }
*/    
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        bDamageTaken = true;

        if (Assassin instanceof AIAttacker && 
             GetTeamRelation( (AIAttacker)Assassin ) > _TEAM_RELATION_NEUTRAL)
            ((AIAttacker) Assassin).NotifyPlayerHit(this); //powiedz mu, zeby nie strzelal do swoich
        else // AI cheat: friendly fire == false
        {
            // jesli oberwal zywy i jeszcze nie atakuje to do dziela
            if (fHealth >0 && 
                !(CurrentState instanceof AIAttacker.Attack) && 
                Assassin instanceof ChromeActor &&
				GetTeamRelation( (ChromeActor)Assassin ) < _TEAM_RELATION_NEUTRAL)
            {
                nAttackCause = _ATTACK_CAUSE_HIT;
                SeekAndDestroy((ChromeActor) Assassin);
            }
            super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        }
    }
    
    /** Zakonczenie zadanie oczekiwania przez fWaitTime na cos
     */
    void WaitDone()
    {
        TaskFinishedQuick();
    }
    
    /** Przeladowanie broni AI
     */
    boolean WeaponReload()
    {
        if( iAmmo<=0 )
        {
            Log("[AIAttacker.WeaponReload] AI panic! No ammo left!\n");
            iAmmo=100;
        }
        
        if ( iAmmo >= ActiveWeapon.nCapacity )
        {
            iAmmo = iAmmo - ActiveWeapon.nCapacity;
            ActiveWeapon.Reload(ActiveWeapon.nCapacity);
        }
        else
        {
            ActiveWeapon.Reload(iAmmo);
        }
        return true;
    }
    
    /**
     */
    void ChangeEnemy(ChromeActor cNewEnemy)
    {
        cEnemy = cNewEnemy;
        if (bShouldWalkTracking)
            SetWalkTrackedObject(cEnemy);
    }
    
    /** Wlacza atakowanie podanego celu
     */
    public void Attack(ChromeActor enemy)
    {
        if (!bCriticalActionInProgress)
        {
            // wlaczamy nastepny stan
            ChangeEnemy(enemy);
            StopHeadTracking();

            //TODO: sprawdzenie, czy wszyscy przeciwnicy martwi
            
            if (nAttackCause == _ATTACK_CAUSE_SIGHT ||
                IsTargetInSight(cEnemy, true))
            {
                HeadTracking(enemy);
            }

            if (aPath != null && aPath.GetPointsNum() > 0 &&
                bPatrolAttack)
                SetState("PatrolAttack");
            else
                SetState("Attack");
			
			// jezeli nalezymy do teamu, to zawiadamiamy towarzyszy broni o wrogu
			if (!bDead)
			{
				DisableCallMethod("SendTeamMessage");
				CallMethodIn("SendTeamMessage", _TIME_TO_SEND_MESSAGE);
			}
        }
        //TODO: rozwazyc mozliwosc skolejkowania tej zmiany stanu...
    }
    
    boolean bBerserkAttack = true;
    
    /** W zaleznosci od odleglosci wybiera atak przeciwnika lub rozgladanie sie
     */
    public void SeekAndDestroy(ChromeActor cEnemy)
    {
        if (cEnemy != null)
        {
            if (aPath != null && aPath.GetPointsNum() > 0 &&
                bPatrolAttack)
            {
                SetState("PatrolAttack");
                return;
            }
            else
            {
                float fAttackChance = 100;

                if (!bAssaultMode)
                {
                    float fDistanceX = cEnemy.GetPosition().Distance(GetPosition()) - fMinSearchStaticDistance;
                    fAttackChance = 100.f * (fMaxAttackDistance - fDistanceX) /
                                            (fMaxAttackDistance - fMinSearchStaticDistance);
                    
                    if (fAttackChance < 0)
                        fAttackChance = 0;
                    else if (fAttackChance > 100.f)
                        fAttackChance = 100.f;
                }
                //LogD("Attack chance: " + fAttackChance + "\n");

                if (bBerserkAttack || CanHappen((int)fAttackChance))
                {
                    Attack(cEnemy);
                    return;
                }
            }
        }
        SetState("SearchStatic");
        // zeby nie przechodziz z SearchStatic do SearchStatic
        //ChangeState("SearchStatic");
    }
    

    //////////////////////////////////////////////////////////////////////////
    // Znajdowanie przeciwnika
    //
    
    java.util.Vector aEnemies = new java.util.Vector();
    
    float fLastUpdateNearbyEnemiesTime = 0;
    float fNearbyEnemiesUpdateTime = 3.f;
    
    boolean UpdateNearbyEnemies()
    {
        float fTime = GetTime();
        if (UpdateTargetsInSightRadius() ||
            fTime > fLastUpdateNearbyEnemiesTime + fNearbyEnemiesUpdateTime)
        {
            fLastUpdateNearbyEnemiesTime = fTime;
            aEnemies.removeAllElements();
            for (int i=0; i<aTargets.size(); i++)
            {
                ChromeActor cTarget = (ChromeActor)aTargets.elementAt(i);
                //CrashLog("DBG: cTarget=" + cTarget + "\n");
                // sprawdzenie, czy zywy i czy wrog
                if ((cTarget.fHealth > 0) &&
                    GetTeamRelation( cTarget ) < _TEAM_RELATION_NEUTRAL) //TODO: mozna dac <= i wyrzucic neutrali jesli sa jakies hostile
                {
                    //CrashLog("DBG: AddingEnemy: " + cTarget + "\n");
                    aEnemies.addElement(cTarget);
                }
            }
            return true;
        }
        return false;
    }

    /** Znacznik potrzebny do wyswietlania stanu AI
     */
    boolean bCanSeeEnemy = false;
    
        
    /** Pobranie przeciwnika, ktorego nalezy atakowac
     *  (bylo: najblizszy z tych, ktorych widzi, 
     *   jest: wybieranie raczej przeciwnika, ktorego moze zatluc, chyba, ze nie ma takiego
     *         i takiego, ktorego 'wartosc' (liczona na podstawie odleglosc i 
     *         fTargetImportance) jest najwyzsza
     */
    ChromeActor GetNearestEnemyInSight()
    {
        ChromeActor cRes = null; //cel, ktory da sie zniszczyc
        ChromeActor cRes2Heavy = null; //cel, ktorego nie da sie zniszczyc, ale mozna postrzelac
        
        float fMaxTargetValue = -1; // na pewno mniejszy niz mozliwy
        float fMaxTarget2HeavyValue = -1; // na pewno mniejszy niz mozliwy
        
        UpdateNearbyEnemies();
        for (int i=0; i<aEnemies.size(); i++)
        {
            ChromeActor cTarget = (ChromeActor)aEnemies.elementAt(i);
            if (cTarget.fHealth > 0) // tylko zywi
            {
                float fDistance2 = GetDistance2To(cTarget);
                // oblicz 'wartosc' potencjalnego celu
                float fTargetValue = (1 - fDistance2/fAISightRange2) * fEnemyDistanceImportance +
                                     cTarget.fTargetImportance/ChromeActor.fMaxTargetImportance * fEnemyTargetImportance;
        
                boolean bIs2Heavy = (ActiveWeapon == null || 
                                     ActiveWeapon.fDamage < cTarget.fDamageThreshold);

                /*
                CrashLog("DBG: fTargetValue=" + fTargetValue +
                         " bIs2Heavy = " + bIs2Heavy + 
                         "(" + cTarget + ")\n");
//              */               
                if (!bIs2Heavy &&
                    fTargetValue > fMaxTargetValue &&
                    IsTargetInSight(cTarget))
                {
                    cRes = cTarget;
                    fMaxTargetValue = fTargetValue;
                }
                else if (bIs2Heavy &&
                         fTargetValue > fMaxTarget2HeavyValue &&
                         IsTargetInSight(cTarget))
                {
                    cRes2Heavy = cTarget;
                    fMaxTarget2HeavyValue = fTargetValue;
                }
            }
        }
        if (cRes == null)
            cRes = cRes2Heavy;
        if (cRes != null)
            bCanSeeEnemy = true;
        // TODO: ustawianie znacznika, ze wszyscy przeciwnicy sa martwi
        return cRes;
    }
    
    
    
    /** Zwraca true jesli wrog AI jest w zasiegu jego broni i 
     *  mozna go trafic
     */
    boolean IsEnemyInWeaponRange()
    {
        if( (ActiveWeapon==null) ||
            (cEnemy == null)) return false;
        
        if (cEnemy.fHealth <= 0) // jesli przeciwnik martwy - poszukaj innego
        {
            ChromeActor cNewEnemy = GetNearestEnemyInSight(); 
            if (cNewEnemy == null)
                return false;
            else
            {
                ChangeEnemy(cNewEnemy);
                nTargetPointIdx = 0;
            }
        }
        
        Vector vEnemyPos = cEnemy.GetPosition();
        
        float fRange2;
        
        if (cEnemy instanceof AIBase)
            fRange2 = fAISightRange2 * aAISightRange2Modifier[((AIBase)cEnemy).cMotion.iSpeed];
        else if (cEnemy instanceof Player)
            fRange2 = fAISightRange2 * aAISightRange2Modifier[((Player)cEnemy).motion.iSpeed];
        else
            fRange2 = fAISightRange2;
        
        if (IsPointInSightRange(vEnemyPos, fRange2) && 
            (vEnemyPos.Distance(GetPosition()) <= ActiveWeapon.fRange * fWeaponRangeMplr))
        {
            int nTgtIdx = ChoosePointToHitIdx(MotionState2FiringPos(cMotion), cEnemy);
            if (nTgtIdx != -1)
            {
                // zapamietaj kosc, w ktora mozna trafic
                nTargetPointIdx = nTgtIdx;
                return true;
            }
        }
        return false;
    }

    /** Uaktualnienie zapamietanej pozycji wroga - ustawia pola vLastKnownEnemyPos i vLastKnownEnemyPosTime 
     *  a takze zeruje (ustawia na null) vLastKnownEnemyDir;
     *  Moze byc wolane tylko w OnHearNoise lub po sprawdzeniu widocznosci przez IsEnemyInSight
     *  @param cEnemy wrog, ktorego sledzimy
     *  @param bUpdateAfterNoise true, gdy metoda wolana w handlerze OnHearNoise
     */
    void UpdateLastKnownEnemyPos(ChromeActor cNewEnemy, boolean bUpdateAfterNoise)
    {
        if (cNewEnemy != null)
        {
            ChangeEnemy(cNewEnemy);
            if ( !bUpdateAfterNoise ||  //jesli nie po dzwieku albo w zakresie okreslania kierunku
                (GetDistanceToEnemy() <= fMaxNoisePositionDistance) )
            {
                vLastKnownEnemyPos.Set(cEnemy.GetPosition());
                fLastKnownEnemyPosTime = GetTime();
                vLastKnownEnemyDir = null;
                return;
            }
        }
        fLastKnownEnemyPosTime = 0;
    }
    
    /** Zwraca true gdy AI powinno podbiegac do gracza
     *  Update'uje tez kierunek, w ktorym uciekl gracz (ale tylko raz, zeby dac mu szanse...)
     */
    boolean ShouldSearchEnemy()
    {
        //LogD("\n");
        if (fLastKnownEnemyPosTime != 0) // jesli widzial juz przeciwnika
        {
            float fRandomTime = fTimeToStartSearch + RandomFloat(fRandomTimeToStartSearch);
            //LogD("widzial\n");
            if (vLastKnownEnemyDir == null)
            {
                vLastKnownEnemyDir = cEnemy.GetPosition();
                vLastKnownEnemyDir.Sub(vLastKnownEnemyPos);
                // zabezpieczenie przed zerowym kierunkiem
                if (vLastKnownEnemyDir.Len2() < 1e-3f)
                    vLastKnownEnemyDir = null;
            }
            if ((GetTime() - fLastKnownEnemyPosTime > fRandomTime) &&
                CanHappen(nReadinessToSearch))
                return true;
        }
        return false;
    }
    
    /** Pokryte z AIMovera - ma zapewnic trzymanie sie w poblizu punktu startowego
     */
    void UpdateDestinationDir()
    {
        if (CanGoFurtherTo(vDestPoint))
            super.UpdateDestinationDir();
        else
            StopGoTo();
    }
    
    /** Zwraca true gdy moze isc do podanego punktu
     */
    boolean CanGoFurtherTo(Vector vPoint)
    {
        Vector vDir = new Vector(vPoint);
        vDir.Sub(GetPosition());
        return CanGoFurtherIn(vDir);
    }
    
    /** Zwraca true gdy pojscie w podanym kierunku jest dozwolone (nie przekroczy za
     *  bardzo odleglosci od punktu startowego)
     *  @param vDir kierunek, w ktorym chcemy isc
     *  @return true jesli mozna isc
     */
    boolean CanGoFurtherIn(Vector vDir)
    {
        if (fTerritoryRadius < 0)
            return true;
        
        Vector vCenterDir = new Vector(vRespawnPos);
        vCenterDir.Sub(GetPosition());
        float fDist2Center = vCenterDir.Len();

        if (fDist2Center < fTerritoryRadius) // jesli wewnatrz territory - niech idzie
            return true;

        vCenterDir.Mul(1.f / fDist2Center);
        Vector vDirCopy = new Vector(vDir);
        vDirCopy.Normalize();
        
        if (vDirCopy.Dot(vCenterDir) > 0.1f) // jesli kat wskazuje, ze nie bedzie sie oddalal - niech idzie
            return true;
        else
        {
            LogD("Can't go further\n");
            return false; // nie moze isc
        }
    }
    
    int MotionState2FiringPos(MotionState cMotion)
    {
        return MotionState2FiringPos(cMotion, false);
    }
    
    /** Pomocnicza: zamienia MotionState na pozycje strzelecka
     *  @param bIgnoreAiming true oznacza, ze aiming nie jest brane pod uwage
     */
    int MotionState2FiringPos(MotionState cMotion, boolean bIgnoreAiming)
    {
        int nPos;
        switch (cMotion.iSpeed) 
        {
        case MotionState.SPEED_SWIM: 
        case MotionState.SPEED_CRAWL: 
            nPos = _FIRINGPOS_CRAWL;
            break;
        case MotionState.SPEED_DUCK:
            if (cMotion.bAiming && (!bIgnoreAiming))
                nPos = _FIRINGPOS_DUCK_A;
            else
                nPos = _FIRINGPOS_DUCK;
            break;
        default:
            if (cMotion.bAiming && (!bIgnoreAiming))
                nPos = _FIRINGPOS_STAND_A;
            else
                nPos = _FIRINGPOS_STAND;
            break;
        }    
        return nPos;
    }
    
    /** Porownuje dwie pozycje strzeleckie
     *  @param nPos1 pierwsza pozycja do porownania
     *  @param nPos2 druga pozycja do porownania
     *  @param bIgnoreAiming gdy true nie bierze pod uwage roznic w przycelowaniu
     *  @return true gdy rowne
     */
    boolean CompareFiringPos(int nPos1, int nPos2, boolean bIgnoreAiming)
    {
        if (bIgnoreAiming)
        {
            if (nPos1 > _FIRINGPOS_STAND)
                nPos1 -= _FIRINGPOS_STAND;
            if (nPos2 > _FIRINGPOS_STAND)
                nPos2 -= _FIRINGPOS_STAND;
        }
        return nPos1 == nPos2;
    }
    
    
    /** Znajdowanie, w ktory punkt wroga mozna trafic z danej pozycji strzeleckiej
     * @param nFiringPos testowana pozycja strzelecka (_FIRINGPOS_ *)
     * @param cEnemy przeciwnik, w ktorego strzelamy
     * @return indeks punktu, w ktory mozna trafic lub -1 jesli nie mozna w zadnen
     *         ze zwracanych przez GetPointToLookAt
     */
    int ChoosePointToHitIdx(int nFiringPos, ChromeActor cEnemy)
    {
        Vector vFireOrigin;
        vFireOrigin = GetPosition();
        vFireOrigin.fY += aWeaponHeight[nFiringPos];
        
        int nRet = -1;
        cEnemy.SetTraceCollType(ECollTraceFlags._COARSE_BOX);

        for (int i=0; ;i++)
        {
            Vector vTargetPos = cEnemy.GetPointToLookAt(i);
            if (vTargetPos != null)
            {
                if (CheckTraceAbsolute(cEnemy, vFireOrigin, vTargetPos))
                {
    //                LogD(nFiringPos + ", " + EBones.GetNameFromID(aBonesSequence[i]) + "\n");
                    nRet = i;
                    break;
                }
            }
            else
                break; //nie znalazl wsrod dostepnych punktow
        }
        cEnemy.SetTraceCollType(ECollTraceFlags._ELEMENT_BOX);
        return nRet; //nie znalazl
    }
    
    /** Znajdowanie pozycji strzeleckiej, z ktorej mozna trafic 
     */
    int FindFiringPos(ChromeActor cEnemy)
    {
        int aFiringPosSequence[] = { _FIRINGPOS_DUCK_A, _FIRINGPOS_STAND_A };
        for (int i=0; i<aFiringPosSequence.length; i++)
        {
            int nTgtIdx = ChoosePointToHitIdx(aFiringPosSequence[i], cEnemy);
            if (nTgtIdx != -1)
            {
                nTargetPointIdx = nTgtIdx;
                return aFiringPosSequence[i];
            }
        }
        return -1; //nie udalo sie znalezc
    }
    
    /** Znajdowanie pozycji strzeleckiej pozwalajacej sie ukryc, zeby nie dostac
     *  w czache z guna przeciwnika
     */
    int FindHidingPos(ChromeActor cEnemy)
    {
        int aHidingPosSequence[] = { _FIRINGPOS_DUCK };//, _FIRINGPOS_CRAWL };
        Vector vEnemyGunPos = cEnemy.GetFireOrigin();
        Vector vPos = GetPosition(),
               vHeadPos;

        for (int i=0; i<aHidingPosSequence.length; i++)
        {
            vHeadPos = new Vector(vPos);
            vHeadPos.fY += aHeadHeight[aHidingPosSequence[i]];
            if (!CheckTraceAbsolute(cEnemy, vHeadPos, vEnemyGunPos))
                return aHidingPosSequence[i];
        }
        
        return -1; //nie udalo sie znalezc
    }
    
    /** Metoda wolana przez gracza gdy zostanie on trafiony przez AI
     */
    void NotifyPlayerHit(Pawn cHitPawn)
    {
        // dla pewnosci sprawdzamy czy trafilismy w czlonka przeciwnego teamu
        if(GetTeamRelation( cHitPawn ) < _TEAM_RELATION_NEUTRAL)
            nRoundsHit++;
        else 
        {
            //LogD("Friendly fire!!!\n");
            if (cMotion.bFiring) //jesli jeszcze strzela to zaprzestan
                NewTaskExclusive(_ACTION_THINK);
        }
    }
    
    /** Zwraca odleglosc do aktualnego wroga
     */
    float GetDistanceToEnemy()
    {
        if (cEnemy != null)
            //return cEnemy.GetPosition().Distance(GetPosition());
            return GetDistanceTo(cEnemy);
        else
        {
            LogD("ERROR: cEnemy == null!!!\n");
            return fAISightRange * 2; //nie ma wroga = jest b. daleko
        }
    }

    /** Zwraca skad pada strzal
     */
    public Vector GetFireOrigin()
    {
        Vector vGunPos = GetPosition();
        vGunPos.fY += aWeaponHeight[MotionState2FiringPos(cMotion)];
        return vGunPos;
    }
    /** Zwraca kierunek strzalu.
     */
    public Vector GetFireDir()
    {
        // liczymy kierunek do celu
        Vector vDir = cEnemy.GetPointToLookAt(nTargetPointIdx);
        vDir.Sub(GetFireOrigin());
    
        // dodajemy rozrzut
        Vector vDev = new Vector(RandomFloat(1) - 0.5f, RandomFloat(1) - 0.5f, RandomFloat(1) - 0.5f);

        if (ActiveWeapon.nCurrentMode == Weapon.MODE_SINGLE)
            vDev.Mul(RandomFloat(fAimingDeviation));
        else //auto
            vDev.Mul(RandomFloat(fBurstAimingDeviation));

        vDev.Mul(vDir.Len());
        vDir.Add(vDev);

        
        return vDir;
    }

    
    /** Sprawdzenie (trace'm) czy na drodze lamanej o ksztalcie:
     *            __
     *           /  \
     *  nie ma przeszkod (do granatow). 
     *  @param vTarget punkt koncowy lamanej (poczatek w GetPosition())
     *  @param fStartAngle kat nachylenia pochylej czesci
     *  @param fMaxObstacleHeight wysokosc na jakiej znajduje sie poziomy fragment lamanej
     *  @param fTargetDistTolerance maksymalna odleglosc do celu, zeby uznac, ze dolecial
     *  @return true, gdy nie ma na tej drodze przeszkod
     */
    
    boolean CheckGrenadeTrajectory(Vector vTarget, float fStartAngle, float fMaxObstacleHeight, float fTargetDistTolerance)
    {
        Vector v1 = GetPosition(), 
            v2 = new Vector(), 
            v3 = new Vector(), 
            v4 = new Vector(vTarget); //potrzebna kopia
        float h = fMaxObstacleHeight; 
        float fTanA = (float)Math.tan(fStartAngle * Math.PI / 180);
        
        boolean bThreeTraces = true;
        
        // traceowane odcinki to: v1v2, v2v3, v3v4
        //
        //        v2______v3
        //         /|     \
        //        / |h     \
        //     v1/a)|       \v4
        //   -->| r |<-- 
        //
        
        // znajdz wektor v1v2
        Vector vSlopeVect = new Vector(v4.fX - v1.fX, 0, v4.fZ - v1.fZ);
        float f2Ddist = vSlopeVect.Len();
        vSlopeVect.Mul(1.f/f2Ddist); // normalizacja
        float r = fMaxObstacleHeight / fTanA; 
        
        if (2.f * r <= f2Ddist)
        {
            // gdy zachodzi przypadek, ze wektory v1v2 i v3v4 sie krzyzuja
            //      v3      v2
            //        \    /
            //         \  /
            //          \/v2' ________
            //          /\           ^
            //         /  \          | h
            //      v1/    \v4       v
            //
            // - traceowane sa odcinki v1v2' i v2'v4
            r = f2Ddist * 0.5f;
            h = r * fTanA;
            bThreeTraces = false;
            LogD("ONLY 2 TRACES (" + r + "," + h + ")\n");
        }

        vSlopeVect.Mul(r);
        vSlopeVect.fY = h;
        
        // oblicz v2
        v1.Add(vSlopeVect, v2);
        
        if (bThreeTraces)
        {
            // znajdz wektor v4v3 (odwrocony o 180[deg] wokol osi OY wektor v1v2)
            vSlopeVect.fX *= -1;
            vSlopeVect.fZ *= -1;
            // oblicz v3
            v4.Add(vSlopeVect, v3);
        }
        else
            v3 = v2;
        
        
        // Sprawdz trace'y
        
        // pierwszy odcinek pochyly
        Collision cCol = TraceTerrainObjectsAndTreesExcludeMe(v1, v2);
        if (cCol != null)
        {
            LogD("FIRST SLOPE COLLISION\n");
            return false;
        }
        
        if (bThreeTraces)
        {
            // odcinek poziomy
            cCol = TraceTerrainObjectsAndTreesExcludeMe(v2, v3);
            if (cCol != null)
            {
                LogD("HORIZONTAL SECTION COLLISION\n");
                return false;
            }
        }
        
        // drugi odcinek pochyly
        
        cCol = TraceTerrainObjectsAndTreesExcludeMe(v3, v4);
        // na ostatnim odcinku troche bardziej skomplikowane
        if (cCol != null)
        {
            LogD("SECOND SLOPE COLLISION\n");
            // w cos trafilismy - jak za daleko - zwroc false
            if (v4.Distance2(vTarget) > fTargetDistTolerance * fTargetDistTolerance)
            {
                LogD("TO FAR TO TARGET\n");
                return false;
            }
        }
        return true;
    }

    
    
    
    boolean ThrowThisGrenadeWithTest(Vector vTarget, float fAngle, 
                                     Grenade cGrenade, boolean bTestOnly)
    {

        float fAlpha = fAngle * (float)Math.PI / 180.f;;
        float fSinAlpha = (float)Math.sin(fAlpha),
              fCosAlpha = (float)Math.cos(fAlpha);

        Vector vStart = GetPosition();
        Vector vDir = new Vector();
        vTarget.Sub(vStart, vDir);

        float fDistance = vDir.Len();
        
        if (fDistance < fMinGrenadeThrowDistance ||
            fDistance > fMaxGrenadeThrowDistance)
            return false;
        

        float fDeltaHeight = vDir.fY;
        
        vDir.fY = 0;
        float fDist2D = vDir.Len();
        float fGravity = cGrenade.GetMass();

        float fAddForce;
        if (fDeltaHeight > 0)
            fAddForce = fDeltaHeight * fMagicGrenadeHeightUpCoefficient;
        else
            fAddForce = fDeltaHeight * fMagicGrenadeHeightDownCoefficient;
        
        if (fAddForce + fDist2D <=0) // nie uda sie rzucic
            return false;
        
        if (!bTestOnly) // jesli to nie test - wyrzuc granata
        {
            float fGrenadeForce = (float)Math.sqrt((fAddForce + fDist2D) * fGravity / (2 * fSinAlpha * fCosAlpha)) * fMagicGrenadeThrowForceCoefficient;
            
            vDir.fY = fDist2D * fSinAlpha / fCosAlpha; // == fDist2D * tan(fAlpha)
            vDir.Normalize();
            
            //            LogD(" fForce = " + fGrenadeForce + "Dist = " + vStart.Distance(vTarget) + "\n");
            
            //        cGrenade.ChangeInvState(this, EInvObjState._ONGROUND);
            //        cGrenade.DetachFromParent();

            cGrenade.ActivateOnModule();
            //ustawiamy i wyrzucamy granat
            cGrenade.SetPosition(GetFireOrigin());
            cGrenade.Start(fGrenadeForce,vDir);
        }
        return true;
    }

    ////////////////////////////////////////////////////////////////////////////
    // Rzucanie granatem
   
    float fGrenadeThrowingAngle = 0;

    Vector vGrenadeTargetPos = null;
    
    Grenade cGrenade = null;
    
    float fGrenadeAnimThrowPhase = 0.7f;
                                  
    float fGrenadeAnimShowPhase = 0.2f;
    
    boolean bIsThrowingGrenade = false;
    
    /** Rzucenie granatem do podanego miejsca.
     *  @return true, gdy granat zostal rzucony (odpalona zostala sekwencja rzucania)
     */
    boolean ThrowGrenade(Vector vTarget, float fStartAngle)
    {
        fGrenadeThrowingAngle = fStartAngle;

        vGrenadeTargetPos = vTarget;
        
        cGrenade = (Grenade)CreateObject(sAIGrenadeClass);
        cGrenade.Owner = this;
        cGrenade.SetPhysicsActive(false);
        cGrenade.EnableRendering(false);
        
        if (ThrowThisGrenadeWithTest(vGrenadeTargetPos, fGrenadeThrowingAngle, cGrenade, true))
        {        
            AttachChild(cGrenade, "Left_hand");

            int nAnimID = GetAnimID(ROOT_BONE, (cMotion.iSpeed == MotionState.SPEED_DUCK)
                                               ? "Rdnsgrenade" : "Rwnsgrenade");

            PlayAnim(nAnimID, 1);
            float fAnimTime = GetAnimLength(nAnimID);
            CallMethodOnceIn("ContinueThrowingGrenade", fAnimTime * fGrenadeAnimThrowPhase);
            CallMethodOnceIn("ShowGrenade", fAnimTime * fGrenadeAnimShowPhase);
            CallMethodOnceIn("ThrowGrenadeEnd", fAnimTime);
            bIsThrowingGrenade = true;
            return true;
        }
        else
        {
            cGrenade.DeactivateOnModuleAlways();
            cGrenade.delete();
            return false;
        }
    }

    
    /** Wywolywane przez CallMethodIn pokazanie granata
     */
    void ShowGrenade()
    {
        cGrenade.EnableRendering(true);
    }

    /** Wywolywane przez CallMethodIn wlasciwe wyrzucenie granata (we wlasciwej fazie animacji)
     */
    void ContinueThrowingGrenade()
    {
        cGrenade.DetachFromParent(); // trzeba odczepic, bo inaczej die wywali na delete
        cGrenade.SetPhysicsActive(true);
        ThrowThisGrenadeWithTest(vGrenadeTargetPos, fGrenadeThrowingAngle, cGrenade, false);
    }
    
    void ThrowGrenadeEnd()
    {
        bIsThrowingGrenade = false;
        TaskFinishedQuick();
    }
    
    void UpdateMotion()
    {
        if (!bIsThrowingGrenade)
            super.UpdateMotion();
    }
    //////////////////////////////////////////////////////////////////////////////////////////
    
    
    /** Metoda uruchamia podana akcje
     */
    void TakeAction(int nAction)
    {
//        ProfileBegin(PROFILE_TakeAction);
        
        // Zaznacz, ze akcja zaczela sie wykonywac
        bActionInProgress = true;
        switch(nAction)
        {
        case _ACTION_GOTO_SIMPLE_FROM_CHOWACZ:
            {
                //LogD("_ACTION_GOTO_SIMPLE_FROM_CHOWACZ\n");
                // liczmy gdzie mozna wybiec
                Vector vRunVector = null;
                Vector vMyPos = GetPosition();
                Vector vRight = null;
                
                // gdy cos bylo na drodze AI to trzeba starac sie to ominac
                if( cObstacle==null ) return;
                
                // liczymy wektor do gracza
                Vector vEnemyVector = cEnemy.GetPosition();
                vEnemyVector.Sub( vMyPos );
                vRight = vEnemyVector.Cross(Vector.Up);
                vRight.Normalize();
                    
//                Log("vRight="+vRight+"\n");
                    
                // wyliczamy jak ominac przeszkode
                ExtremeValues.Calculate(cObstacle, GetPosition(), vRight);

                vRunVector = GetPosition();
                if(ExtremeValues.fLeftDist > -ExtremeValues.fRightDist)
                {
//                    Log("Right mniejsze\n");
                    vRight.Mul(ExtremeValues.fRightDist -100.0f);
                }
                else
                {
//                    Log("Left mniejsze\n");
                    vRight.Mul(ExtremeValues.fLeftDist +100.0f);
                }
                    
                vRunVector.Add(vRight);
                    
//                Log("Aby ominac przeszkode trzeba sie odsunac lewo:"+ExtremeValues.fLeftDist+" prawo:"+ExtremeValues.fRightDist+"\n");
                    
//                Log("vMyPos      = "+vMyPos+"\n");
//                Log("vDestVector = "+vRunVector+"\n");
                
                // wyskok z chowacza ? zmiana pozycji strzeleckiej ?
                //GoTo(vRunVector, MotionState.SPEED_WALK, "OnGotoPointReached");
                cMotion.iMoveX = 1;
                cMotion.iSpeed = MotionState.SPEED_WALK;
                UpdateMotion();
                SetFacingDestDir(vEnemyVector);
                
                vRight.Normalize();
                vRight.Mul(aMotionVelocity[cMotion.iSpeed]);
                SetSpeed(vRight);
                    
                SetDestinationPos(vRunVector);
	            SetDestinationRadius(100.0f);
                
            }
            break;
            
        case _ACTION_FIRE_ROUND:
            {
                FireRound();
            }
            break;
            
        case _ACTION_WAIT_FOR_WEAPON_READY:
            {
                float fTime = Math.max( 60.f/ActiveWeapon.fRateOfFire, 
                                   fSingleFireDelay + RandomFloat(fRandomSingleFireDelay) );
                CallMethodOnceIn(METHOD_WeaponReady, fTime);
            }
            break;
            
        case _ACTION_RELOAD:
            {
                //LogD("_ACTION_RELOAD\n");
                // wylaczamy przyczepienie guna do reki
                bPlaceGun = false;
                // odpalamy animacje reload
                PlayAnim( Anims[A_WEA_RELOAD], 1);
                CallMethodOnceIn( METHOD_ReloadAnimEnd, GetAnimLength(Anims[A_WEA_RELOAD]));
            }
            break;
            
        case _ACTION_SEARCH_ENEMY_DYNAMIC:
            {
                SetState("SearchDynamic");
            }
            break;
            
        case _ACTION_CALM_DOWN:
            {
                StartYourDuty(); // == Idle | Patrol    
            }
            break;
            
        
        case _ACTION_TURN_QUICK:
            {
                //LogD("_ACTION_TURN_QUICK\n");
                if (vDesiredDir == null)
                    TaskFinishedQuick();
                else
                {
                    float fQuickTurnSpeed = 360.f; //TODO: wyprowadzic
                    if ( nReadinessToSearch == 0 )
                        fQuickTurnSpeed = 180.0f;
                    float fAngle = Dir2HorizAngle(vDesiredDir);
                    float fTurnTime = Math.abs(fAngle) / fQuickTurnSpeed;

                    // dla SetupAnims trzeba zredukowac tymczasowo predkosc (zeby sie nie obracal z Run)
                    //
                    byte byOld_iSpeed = cMotion.iSpeed;
                    cMotion.iSpeed = GetReducedMotionSpeed(cMotion);
                    SetupAnims();
                    cMotion.iSpeed = byOld_iSpeed;
                    int nAnim2Ply = (fAngle > 0) ? Anims[A_BACK_ROTATE_LEFT] :
                                                   Anims[A_BACK_ROTATE_RIGHT];

                    fOldAnimMorphTime = GetAnimMorphTime();
                    SetAnimMorphTime(fFastAnimMorphTime);
                    
                    PlayAnim(nAnim2Ply, -1);

                    SetMaxAngSpeed(fQuickTurnSpeed);
                    METHOD_DestDirReached = 0;
                    SetFacingDestDir(vDesiredDir);
                    
                    CallMethodOnceIn( METHOD_QuickTurnDone, fTurnTime );
                }
            }
            break;
            
        case _ACTION_TURN: 
            {
                float fTurnTime;
                if (vDesiredDir != null)
                    fTurnTime = SetTwistDestDir(vDesiredDir, _TWIST_TYPE_TORSO);
                else
                    fTurnTime = 0;
                //CrashLog("_ACTION_TURN (" + fTurnTime + "\n");
                
                CallMethodOnceIn(METHOD_TurnDone, fTurnTime);
            }
            break;
            
        case _ACTION_TRACK_ENEMY_BODY:
            {
                EnableTracingEnemyBody();
                TaskFinishedQuick();
            }
            break;
            
        case _ACTION_SAY_HEY:
            {
                if (bShouldShout && (GetNearestEnemyInSight() != null))
                {
                    bShouldShout = false;
                    String sSoundFile;
                    boolean bFriendsNearby = GetNumNearbyFriends() > 0; 
                    if (bFriendsNearby)
                    {
                        sSoundFile = aHeySoundsCrowd[RandomInt(aHeySoundsCrowd.length)];
                        TryToScream(_SCREAMTYPE_BACKUP_CALL);
                    }
                    else
                        sSoundFile = aHeySoundsAlone[RandomInt(aHeySoundsAlone.length)];

                    PlaySound(sSoundFile);
                    fWaitTime = GetWaveDuration(sSoundFile);
                    CallMethodOnceIn( METHOD_WaitDone, fWaitTime );
                }
                else
                    TaskFinishedQuick();
            }
            break;
            
        case _ACTION_WAIT:
            {
                CallMethodOnceIn( METHOD_WaitDone, fWaitTime );
            }
            break;
            
        case _ACTION_NOISE_REACTION:
            {
                UpdateMotion();
                // TODO: przywrocic jak beda dzwieki zastanawiania sie
                //PlaySound(aPlayerNoiseReaction[RandomInt(aPlayerNoiseReaction.length)]);
                CallMethodOnceIn( METHOD_WaitDone, fPlayerNoiseReactionTime);
            }
            break;
            
        case _ACTION_RUN_UP_TO_ENEMY:
            {
                /** maksymalny czas podbiegania = czas potrzebny na dobiegniecie 
                 *  do siebie gracza i AI po linii prostej
                 */
                // by MK
                // nie jest uwzgledniana tak na prawde predkosc Playera!
                // FIXIT!
                float fDistance = GetDistanceToEnemy();
                float fMaxTime  = fDistance / (aMotionVelocity[MotionState.SPEED_RUN] * 2.f);
                //LogD("_ACTION_RUN_UP_TO_ENEMY fMaxTime=" + fMaxTime + " rut=" + fRunUpTime + "\n");
                /** minimalny czas, dla ktorego warto podbiegac */
				
				// TODO: tymczasowo
				if (m_WpSystem != null)
					fRunUpTime = 0.2f;
                
				
                /*
                // kombinacje by MK, zeby w budynkach podbiegali
                if ( InBuilding() )
                {
                    if ( fDistance < 100.0f )
                    {
                        TaskFinishedQuick(); //koniec dobiegania
                        LogD(" RUN_UP - finished\n");
                        return;
                    }
                }
                */
                    
                if (fMaxTime < fRunUpTime)
                {
                    //LogD("_ACTION_RUN_UP_TO_ENEMY+tfq\n");
                    TaskFinishedQuick(); //koniec dobiegania
                }
                else
                {
                    float fTime = fRunUpTime + RandomFloat(fRandomRunUpTime);
                    if (fTime > fMaxTime)
                        fTime = fMaxTime;
                    //LogD("_ACTION_RUN_UP_TO_ENEMY - running\n");
                    cMotion.bAiming = false;
                    if (bTrackingBody)
                    {
                        DisableTracingEnemyBody(); // zeby smiesznie nie wygladalo
                        bWasTrackingBodyBeforeRunUp = true;
                    }
                    UpdateMotion();
                    // skoro dobiega, to wyzeruj statystyki strzelania
                    nRoundsHit = nRoundsShot = 0;
                    bTwistCanTurn = false;
                    Vector vLocation = GetMyAttackLocation(cEnemy);
                    // dorobienie zygzakow by MK
                    // jezeli jestesmy w miare daleko
                    // to dodajmy element losowosci do miejsca przeznaczenia
                    //CrashLog("proba ZIGZAG!!!!!\n");
                    if ( bZigZagAvailable && fDistance > fZigZagMinDistance )
                    {
                        Vector vDelta = new Vector(vLocation);
                        vDelta.Sub( GetPosition() );
                        vDelta.fY = 0.0f;
                        vDelta = RotateVector( vDelta, 90.0f, Vector.Up );
                        vDelta.Normalize();
                        // mamy wektor w poprzek ruchu, 
                        
                        // teraz policzmy losowy rozrzut
                        // bedzie to wartosc z przedzialu -fMaxDelta/2 .. +fMaxDelta/2 
                        float fMaxDelta = fDistance * fZigZagDistanceDeviation;
                        float fDelta    = fMaxDelta * (RandomFloat(1.0f)-0.5f);
                        vDelta.Mul( fDelta );
                                                
                        //CrashLog("ZIGZAG!!!!! fDistance:"+fDistance+" vPos:"+GetPosition()+"\n vTarget:"+vLocation+" vDelta:"+vDelta+"\n");
                        
                        // nalozmy ten rozrzut na cel
                        vLocation.Add( vDelta );
                    }
                    
                    GoTo( vLocation, MotionState.SPEED_RUN, "RunUpDone" );
                    CallMethodOnceIn( METHOD_RunUpDone, fTime);
                    //LogD("_ACTION_RUN_UP_TO_ENEMY, dur: " + fTime + "\n");
                }
            }
            break;
            
        case _ACTION_WAIT_A_MINUTE:
            {
                CallMethodOnceIn( METHOD_WaitDone, RandomFloat(fRandomWaitTime) );
            }
            break;
            
        case _ACTION_START_STRAFE_APPROACH:
        case _ACTION_START_STRAFE_AWAY:
        case _ACTION_START_STRAFE_SIDEWAYS:
        case _ACTION_STOP_STRAFE:
            {
                LogD("WARNING: Obsolete action performed: _ACTION_*_STRAFE*\n");
            }
            break;
            
        case _ACTION_LOOK_LEFT:
            {
                //LogD("_ACTION_LOOK_LEFT\n");
                TwistBody(fTwistHorizMax, 0, _TWIST_TYPE_HEAD_USE_TORSO);
                TaskFinishedQuick();
            }
            break;
            
        case _ACTION_LOOK_FORWARD:
            {
                //LogD("_ACTION_LOOK_FORWARD\n");
                TwistBody(0, 0, _TWIST_TYPE_NONE);
                TaskFinishedQuick();
            }
            break;
            
        case _ACTION_LOOK_RIGHT:
            {
                //LogD("_ACTION_LOOK_RIGHT\n");
                TwistBody(fTwistHorizMin, 0, _TWIST_TYPE_HEAD_USE_TORSO);
                TaskFinishedQuick();
            }
            break;
            
        case _ACTION_THROW_GRENADE_TO_ENEMY:
            {
                fLastGrenadeCheckTime = GetTime();
                Vector vTarget = cEnemy.GetPosition();
                float fDistance = GetDistanceTo(cEnemy);
                
                // Dodaj rozrzut
                Vector vDev = new Vector(RandomFloat(1) - 0.5f, 0, RandomFloat(1) - 0.5f);
                vDev.Mul(fGrenadeAimingDeviation * fDistance); 
                vTarget.Add(vDev);
                
                float fAngle;
                if ((CheckGrenadeTrajectory(vTarget, fAngle = fGrenadeAngleNormal, fGrenadeMaxObstacleHeight, fGrenadeTargetDistanceTolerance) ||
                     CheckGrenadeTrajectory(vTarget, fAngle = fGrenadeAngleHigh, fGrenadeMaxObstacleHeight, fGrenadeTargetDistanceTolerance) ||
                     CheckGrenadeTrajectory(vTarget, fAngle = fGrenadeAngleLow, fGrenadeMaxObstacleHeight, fGrenadeTargetDistanceTolerance)) &&
                    GetNumFriendsInRadius(vTarget, fGrenadeSafeDistance) == 0)
                {
                    // Rzucaj blizej, zeby sie podturlal
                    Vector vBackDir = GetPosition();
                    vBackDir.Sub(vTarget);
                    vBackDir.Mul(fGrenadeRollingDistance / fDistance);
                    vTarget.Add(vBackDir);

                    // uwzglednij predkosc gracza
                    Vector vSpeedFactor = cEnemy.GetSpeed();
                    vSpeedFactor.Mul(fGrenadeTargetSpeedFactor * fDistance / fMaxGrenadeThrowDistance);
                    vTarget.Add(vSpeedFactor);
                    if (ThrowGrenade(vTarget, fAngle))
                    {
                        DisableTracingEnemyBody();
                        fCurrentGrenadeThrowingDelay = fGrenadeThrowingDelay + RandomFloat(fRandomGrenadeThrowingDelay);
                        fLastGrenadeTime = GetTime();
                    }
                    else
                        TaskFinishedQuick();
                }
                else
                    TaskFinishedQuick();
            }
            break;
            
        case _ACTION_ESCAPE_FROM_DANGER:
            {
                LogD("_ACTION_ESCAPE_FROM_DANGER\n");
                // sprawdz, czy jestes zagrozony
                if (!((vDangerPosition != null) && (fDangerRadius > 0) &&
                    EscapeFromDangerRecalc()))
                {
                    vDangerPosition = null; // zaznacz, ze nieaktualny
                    TaskFinishedQuick();
                }
            }
            break;
            
        case _ACTION_TAKE_A_WALK:
            TakeAWalkOrRun( false );
            break;
            
        case _ACTION_TAKE_A_RUN:
            TakeAWalkOrRun( true );
            break;

        case _ACTION_GOTO_POS:
            {
                //LogD("_ACTION_GOTO_POS\n");
                GoTo(vDesiredPos, MotionState.SPEED_WALK, "RunUpDone");
                float fTime = vDesiredPos.Distance( GetPosition() ) / aMotionVelocity[MotionState.SPEED_WALK];
                CallMethodOnceIn("RunUpDone", fTime);
            }
            break;
            
        case _ACTION_RUNTO_POS:
            {
                //LogD("_ACTION_GOTO_POS\n");
                GoTo(vDesiredPos, MotionState.SPEED_RUN, "RunUpDone");
                float fTime = vDesiredPos.Distance( GetPosition() ) / aMotionVelocity[MotionState.SPEED_WALK]; // celowo WALK zeby tam troszke postal
                CallMethodOnceIn("RunUpDone", fTime);
            }            
            break;
          
        case _ACTION_START_STRAFE_FIRE:
            {
                bStrafeFire = true;
                CallMethodIn(METHOD_UpdateStrafeFire, fUpdateStrafeFireInterval);
                TaskFinishedQuick();
            }
            break;
            
        case _ACTION_STOP_STRAFE_FIRE:
            {
                bStrafeFire = false;
                StopStrafeFire();
                DisableCallMethod(METHOD_UpdateStrafeFire);
                TaskFinishedQuick();
            }
            break;
            
        default:
            super.TakeAction(nAction);
        }
        
//        ProfileEnd(PROFILE_TakeAction);
    }

    void TakeAWalkOrRun( boolean bRun )
    {
        //LogD("_ACTION_TAKE_A_WALK\n");
        Vector vWalkStartPoint;
        float fWalkDistance = fFreeWalkDistance + RandomFloat(fRandomFreeWalkDistance);
        float fWalkRadius;
                
        if (fTerritoryRadius < 0 && fWalkAreaRadius < 0)
        {// nie ma ograniczenia na chodzenie
            vWalkStartPoint = GetPosition();
            fWalkRadius = fWalkDistance;
        }
        else
        {// jest jakies ograniczenie - wybierz najbardziej restrykcyjne z nich
                    
            vWalkStartPoint = vRespawnPos;
            /** Wybierz mniejszy sposrod nieujemnych promieni
             */
            if (fTerritoryRadius < 0)
                fWalkRadius = fWalkAreaRadius;
            else
            {
                if (fWalkAreaRadius < 0)
                    fWalkRadius = fTerritoryRadius;
                else
                    fWalkRadius = Math.min(fTerritoryRadius, fWalkAreaRadius);
            }
        }
        float fWalkAngle = RandomFloat((float)(Math.PI * 2));
        Vector vNewPos = new Vector(fWalkRadius * (float)Math.cos(fWalkAngle), 0, fWalkRadius * (float)Math.sin(fWalkAngle));
        vNewPos.Add(vWalkStartPoint);
        GoTo( vNewPos, bRun ? MotionState.SPEED_RUN : MotionState.SPEED_WALK, "RunUpDone");
        float fTime = fWalkDistance / aMotionVelocity[MotionState.SPEED_WALK];
        CallMethodOnceIn("RunUpDone", fTime);
    }
    
    /** Metoda odwoluje podana akcje
     */
    void CancelAction(int nAction)
    {
        if (bActionInProgress) // tylko jesli jest co odwolac
        {
            switch(nAction)
            {
            case _ACTION_GOTO_SIMPLE_FROM_CHOWACZ:
                {
                    cMotion.iMoveX = 0;
                    UpdateMotion();
                    ClearDestinationDir();
                    
                    SetSpeed(new Vector());
                    
                    ClearDestinationPos();
                }
                break;
                
            case _ACTION_FIRE_ROUND:
                {
                    DisableCallMethod( METHOD_FireDone);
                    DisableCallMethod( METHOD_FireOneBullet);
                    nBulletsToFire = 0;
                    cMotion.bFiring = false;
                    ActiveWeapon.StopFire();
                }
                break;
                
            case _ACTION_WAIT_FOR_WEAPON_READY:
                {
                    DisableCallMethod( METHOD_WeaponReady );
                }
                break;
                
            case _ACTION_RELOAD:
                {
                    StopAnim("");
                    bPlaceGun=true;
                    DisableCallMethod( METHOD_ReloadAnimEnd );
                }
                break;
                
            case _ACTION_SEARCH_ENEMY_DYNAMIC:
            case _ACTION_CALM_DOWN:
                break;
                
            case _ACTION_TURN_QUICK:
                {
                    DisableCallMethod( METHOD_QuickTurnDone );
                    QuickTurnStopped();
                }
            case _ACTION_TURN:
                {
                    DisableCallMethod( METHOD_TurnDone );
                    TurnStopped();
                }
                break;
                
            case _ACTION_TRACK_ENEMY_BODY:
                {
                    DisableTracingEnemyBody();
                }
                break;
                
            case _ACTION_SAY_HEY:
                {
                    DisableCallMethod( METHOD_WaitDone );
                }
                break;
                
            case _ACTION_WAIT:
                {
                    DisableCallMethod( METHOD_WaitDone );
                }
                break;

            case _ACTION_NOISE_REACTION:
                {
                    DisableCallMethod( METHOD_WaitDone );
                }
                break;
                
            case _ACTION_RUN_UP_TO_ENEMY:
                {
                    if (bWasTrackingBodyBeforeRunUp)
                        EnableTracingEnemyBody();
                    StopGoTo();
                    bTwistCanTurn = true;
                    DisableCallMethod( METHOD_RunUpDone );
                }
                break;

            case _ACTION_WAIT_A_MINUTE:
                {
                    DisableCallMethod( METHOD_WaitDone );
                }
                break;

                
            case _ACTION_START_STRAFE_APPROACH:
            case _ACTION_START_STRAFE_AWAY:
            case _ACTION_START_STRAFE_SIDEWAYS:
            case _ACTION_STOP_STRAFE:
                {
                    LogD("WARNING: Obsolete action canceled: _ACTION_*_STRAFE*\n");
                }
                break;
                
            case _ACTION_LOOK_LEFT:
            case _ACTION_LOOK_RIGHT:
                {
                    TwistBody(0, 0, _TWIST_TYPE_NONE);
                }
                break;

            case _ACTION_LOOK_FORWARD:
                break;

            case _ACTION_THROW_GRENADE_TO_ENEMY:
                    DisableCallMethod("ContinueThrowingGrenade");
                    DisableCallMethod("ShowGrenade");
                    DisableCallMethod("ThrowGrenadeEnd");
                break;
                
            case _ACTION_ESCAPE_FROM_DANGER:
                {
                    if (bWasTrackingBodyBeforeRunUp)
                        EnableTracingEnemyBody();
                    if (vDangerPosition != null)
                        SetWalkTrackedObject(cBeforeEscapeWalkTrackedObject);
                    StopGoTo();
                    bTwistCanTurn = true;
                    vDangerPosition = null;
                    DisableCallMethod( "EscapeDone" );
                }
                break;
                
            case _ACTION_TAKE_A_RUN:
            case _ACTION_TAKE_A_WALK:
            case _ACTION_GOTO_POS:
            case _ACTION_RUNTO_POS:
                {
                    //if (bWasTrackingBodyBeforeRunUp)
                        //EnableTracingEnemyBody();
                    StopGoTo();
                    bTwistCanTurn = true;
                    DisableCallMethod( METHOD_RunUpDone );
                }
                break;
                
            case _ACTION_START_STRAFE_FIRE:
                {
                    if (ActiveWeapon != null)
                        ActiveWeapon.StopFire();
                    DisableCallMethod(METHOD_UpdateStrafeFire);
                }
                break;

                
            default:
                super.CancelAction(nAction);
            }
            // Zaznacz, ze akcja juz sie nie wykonuje
            bActionInProgress = false;
        }
    }
    
    ///////////////////////
    // zachowanie stadne //
    ///////////////////////

    
    /** zapamietany czas ostatniej aktualizacji danych o kolegach */
    float fLastUpdateNearbyFriendsTime = 0;
    
    /** Tablica z pobliskimi kolegami AI  */
    java.util.Vector aNearbyFriends = new java.util.Vector();
    
    /** Wyciaga z grida kolegow AI, gdy jest to potrzebne
     *  @return true gdy nastapil update listy kolesi
     */
    boolean UpdateNearbyFriends()
    {
        float fTime = GetTime();
        // Uplynal okres przydatnosci danych
        if (fTime > fLastUpdateNearbyFriendsTime + fNearbyFriendsUpdateTime)
        {
            fLastUpdateNearbyFriendsTime = fTime;
            GetFriendsInRadius(GetPosition(), fNearbyFriendsMaxDistance, aNearbyFriends);
            return true;
        }
        return false;
    }
    
    /** Pobiera ilosc przyjaciol wewnatrz okregu o podanym srodku i srednicy
     *  @param vPosition srodek okregu
     *  @param fRadius promien okregu
     *  @return ilosc przyjaciol
     */    
    int GetNumFriendsInRadius(Vector vPosition, float fRadius)
    {
        return GetFriendsInRadius(vPosition, fRadius, null);
    }

    /** Pobiera ilosc przyjaciol wewnatrz okregu o podanym srodku i srednicy, 
     *  wrzuca referencje do nich do podanego java.util.Vector'a
     *  @param vPosition srodek okregu
     *  @param fRadius promien okregu
     *  @param aResult java.util.Vector na referencje do przyjaciol albo null jesli nie trzeba
     *  @return ilosc przyjaciol
     */    
    int GetFriendsInRadius(Vector vPosition, float fRadius, java.util.Vector aResult)
    {
        ControlObject[] aObj = GetObjectsInRadiusFromClass(vPosition, fRadius, "Pawn");
        int nCount = 0;
        
        if (aResult != null)
            aResult.removeAllElements();
        
        if (aObj != null)
        {
            for (int i=0; i<aObj.length; i++)
            {
                Pawn cPawn = (Pawn)aObj[i];
                if (cPawn != this && // zeby nie dodawal siebie do listy swych przyjaciol
                    cPawn.fHealth > 0 && // zeby nie dodawal trupow
                    GetTeamRelation( cPawn ) > _TEAM_RELATION_NEUTRAL) 
                {
                    nCount++;
                    if (aResult != null)
                        aResult.addElement(cPawn);
                }
            }
        }
        return nCount;
    }    
    
    /** Wartosc pomocnicza dla GetNumNearbyFriends */
    private int nLastNumNearbyFriends = 0;

    /** Sprawdza ilu jest zywych kolegow AI w poblizu */
    int GetNumNearbyFriends()
    {
        if (UpdateNearbyFriends()) // cos sie moglo zmienic
        {
            nLastNumNearbyFriends = aNearbyFriends.size(); // tam sa tylko zywi przyjaciele
        }
        return nLastNumNearbyFriends;
    }
    
    
    private Vector vLastAttackLocationRel = Vector.Zero;

    /** Zwraca pozycje do jakiej AI ma dobiec atakujac przeciwnika w grupie
     */
    Vector GetMyAttackLocation(ChromeActor cEnemy)
    {
        Vector vDelta = new Vector();
        
        if (UpdateNearbyFriends()) // mogli sie zmienic kumple - przelicz
        {
            if (nLastNumNearbyFriends > 0) // sa kumple
            {
                //LogD("(nLastNumNearbyFriends > 0)\n");
                Vector vMid = new Vector();
                int nGroupSize = 0;
                for (int i=0; i<aNearbyFriends.size(); i++)
                {
                    Object cJObj = aNearbyFriends.elementAt(i); 
                    if (cJObj instanceof AIAttacker) // bo moze byc dowolny Pawn (ktory atakuje inaczej)
                    {    
                        AIAttacker cAI = ((AIAttacker)(cJObj));
                        if (cAI.fHealth > 0 &&
                            cAI.cEnemy == cEnemy) // jesli zyje i atakuje tego samego
                        {
                            vMid.Add(cAI.GetPosition());
                            nGroupSize++;
                        }
                    }
                }
                if (nGroupSize > 0) // jesli jest z kim atakowac
                {
                    vMid.Add(GetPosition()); //dodaj siebie
                    nGroupSize++;
                    //LogD("nGroupSize="+nGroupSize+"\n");
                    // znajdz srednia pozycje
                    vMid.Mul(1.f/(float)nGroupSize);
                    // znajdz wektor przesuniecia od srodka grupy                    
                    vDelta = GetPosition();
                    vDelta.Sub(vMid);
                    
                    if (vDelta.Len2() < 0.1f)
                        vDelta = Vector.Zero; // jesli to ten w srodku
                    else
                    {
                        // a teraz przesun na 'krag ataku'
                        vDelta.Normalize();
                        vDelta.Mul(fGroupAttackRadius);
                    }
                    vLastAttackLocationRel = new Vector(vDelta);
                }
                else
                    vLastAttackLocationRel = null;
            }
        }
        else // nie zmienilo sie nic (zalozenie)
        {
            if (vLastAttackLocationRel != null)
                vDelta = new Vector(vLastAttackLocationRel);
        }
        //LogD("vDelta = " + vDelta + "\n");
        vDelta.Add(cEnemy.GetPosition());
        return vDelta;
    }
    

    
    //////////////////////////////////////////////////////////////////////
    // Znajdowanie potencjalnych przeciwnikow
    //

    java.util.Vector aTargets = new java.util.Vector();
    
    float fLastUpdateTargetsTime = 0;
    float fUpdateTargetsTime = 5.f;
    
    boolean UpdateTargetsInSightRadius()
    {
        float fTime = GetTime();
        if (fTime > fLastUpdateTargetsTime + fUpdateTargetsTime)
        {
            fLastUpdateTargetsTime = fTime;
            ControlObject[] aObj = GetObjectsInRadiusFromClass(GetPosition(), fAISightRange, "ChromeActor");

            aTargets.removeAllElements();
            if (aObj != null)
                for (int i=0; i<aObj.length; i++)
                    if (aObj[i] != this)
                        aTargets.addElement(aObj[i]);
            return true;
        }
        return false;
    }
    
    
    ////////////////
    // strzelanie //
    ////////////////
    
    // ustawione zaraz po zakonczeniu strzelania
    boolean bFiringJustStoped = false;

    /** Strzela jeden pocisk lub serie, w zaleznosci od okolicznosci
     */
    void FireRound()
    {
        if ((ActiveWeapon.nAIFireModes & Weapon._FIREMODE_BURST) != 0 && 
            (GetDistanceToEnemy() < fMaxBurstDistance + RandomFloat(fRandomDistance)))
            FireBurst();
        else
            FireSingle();
    }
    /** Wystrzelenie serii pojedynczych kul
     */
    void FireSingle()
    {
        cMotion.bFiring = true;
        nBulletsToFire = RandomInt(nMaxSingleFireBullets)+1;
        FireOneBullet();
    }
    
    void FireOneBullet()
    {
        //LogD("\n");
        if (nBulletsToFire > 0)
        {
            ActiveWeapon.StartFire( Weapon.MODE_SINGLE );
            nBulletsToFire--;
            CallMethodOnceIn(METHOD_FireOneBullet, 60.f/ActiveWeapon.fRateOfFire);
        }
    }
    
        
    /** Wystrzelenie serii o losowej dlugosci
     */
    void FireBurst()
    {
        //LogD("#######################################\n");
        float fFiringTime = fBurstTime + RandomFloat(fRandomBurstTime);
        cMotion.bFiring = true;
        ActiveWeapon.StartFire( Weapon.MODE_AUTO );
        CallMethodOnceIn( METHOD_FireDone, fFiringTime );
    }
    
//    void DebugFireDone()
//    {
//        //LogD("przez cmi\n");
//        FireDone();
//    }
    /** Zakonczenie strzelania
     *  Wolane po pojedynczym strzale, po uplywie czasu  
     *  lub skonczeniu magazynka w trybie auto
     */
    void FireDone()
    {
        //LogD("#QV=" + aTaskQueue.toString() + "#\n");
        //gdyby zawolane po braku amunicji
        DisableCallMethod( METHOD_FireDone);
        DisableCallMethod( METHOD_FireOneBullet);
        nBulletsToFire = 0;
        ActiveWeapon.StopFire();
        if (cMotion.bFiring) //ten if to HAK - zapobiega zawolaniu przez CallMethodIn, ktore sie czasem zdarza, mimo DisableCallMethod
        {
            cMotion.bFiring = false; 
            TaskFinishedQuick();
        }
    }
    
    /** Wolana przy uzyciu CallMethodIn po czasie potrzebnym na ostygniecie broni */
    void WeaponReady()
    {
       TaskFinishedQuick();
    }
    /** Metoda wolana przez weapon po strzale, przy braku amunicji itp.
     */
    void MessageWeapon(int nState)
    {
        //LogD("(" + nState + ")\n");
        if (!bStrafeFire) // nie strafuje - normalna obsluga
        {
            int nWeaMode = ActiveWeapon.nCurrentMode;
            if ((nState & Weapon.STATE_SHOT) != 0)
            {
                PlayAnim( Anims[A_WEA_FIRE], 1 );
                nRoundsShot++;
                // sprawdz, czy nie przestal trafiac do gracza, bo go nie widzi
                if (nRoundsShot > 3) //mozna zaczac sprawdzac
                {
                    if (((float)nRoundsHit/(float)nRoundsShot < fMinHitRatio) && //cienka statystyka - sprawdz, czy jeszcze widzisz
                        !IsEnemyInWeaponRange())
                    {
                        FireDone();
                        return;
                    }
                }
                // jesli ostatni z pojedynczych strzalow - to koniec strzelania
                if ((nWeaMode == Weapon.MODE_SINGLE) && nBulletsToFire == 1)
                {
                    FireDone();
                    return;
                }
            }
        
            if ((nState & Weapon.STATE_NO_AMMO) != 0)
            {
                LogD("Out of ammo!\n"); 
                FireDone();
            } 
            else if ((nState & (Weapon.STATE_OVERHEAT | Weapon.STATE_ERROR)) != 0)
            { 
                //za czesto strzelamy albo cos nie wyszlo 
                LogD("Shooting to often!\n");
                FireDone();
            }
        }
        else // obsluga dla strafowania
        {
            if ((nState & Weapon.STATE_NO_AMMO) != 0) //brak amunicji
            {
                StrafeReload();
            }
        }
    }
     
    
    /** Procedurka wolana w OnHearNoise, zeby zalatwic to, co jest wspolne dla wszystkich stanow
     *  @return true, jesli obsluzona
     */
    public boolean GlobalNoiseReactionHandler(Actor Noisy, float fNoiseLevel, int nNoiseType)
    {
        if (nNoiseType == _NOISE_DANGEROUS_OBJECT_NEARBY)
        {
			// TODO to trzeba przerobic, by nie trzeba bylo rozrozniac czy to
			// granat, samochod, czy cos jeszcze innego...
            // Reakcja na granaty
            if (bRunAwayFromDanger &&
                Noisy instanceof Grenade)
            {
                Grenade cGrenade = (Grenade)Noisy;

                // nie uciekaj od granatow przyjaciol (i swoich)
                if (cGrenade.Owner != null &&
                    GetTeamRelation( cGrenade.Owner ) > _TEAM_RELATION_NEUTRAL)
                    return false;

                boolean bIsEscaping = vDangerPosition != null;
                vDangerPosition = cGrenade.GetPosition();
                fDangerRadius = cGrenade.fFlyingNoiseRange + 100;
                if (bIsEscaping)
                    EscapeFromDangerRecalc();
                else
                    TaskEscapeFromDanger();
                return true;
            }
        }
        return false;
    }
    
    
    public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
    {
        if (IsFrozen())
            return; 
        
        //LogD(nNoiseType + "\n");
        if (GlobalNoiseReactionHandler(Noisy, fNoiseLevel, nNoiseType))
            return;
        
        // sprawdzenie czy uslyszany halas jest wrogi czy nie
        if( Noisy instanceof Pawn )
        {
            Pawn cPawn = (Pawn)Noisy;

            if (GetTeamRelation( cPawn ) < _TEAM_RELATION_NEUTRAL)
            {
				//LogLine("Uslyszalem cos:" + this + ", " + nNoiseType + ", " + fNoiseLevel);
                // Wrog zahalasowal
                UpdateLastKnownEnemyPos(cPawn, true);
                if (bEnemyNoiseStartsCamperTimer)
                    StartEnemyCamperTimer();
                nAttackCause = _ATTACK_CAUSE_NOISE;
                SeekAndDestroy(cPawn);
            }
            else
            {
                // to jest przyjaciel...
                if(Noisy instanceof AIAttacker) //...ale tylko AIAttacker ma wyznaczony jasno cel (cEnemy)
                {
                    AIAttacker cFriend = (AIAttacker)Noisy;

                    if( nNoiseType==Pawn._NOISE_WEAPON_FIRING )
                    {
                        UpdateLastKnownEnemyPos(cFriend.cEnemy, true);
                        // atakujemy jego wroga
                        StartFriendCamperTimer();
                        nAttackCause = _ATTACK_CAUSE_NOISE;
                        SeekAndDestroy(cFriend.cEnemy);
                    }
                    else if (nNoiseType == Pawn._NOISE_SCREAM)
                    {
                        //LogD("Scream heard (" + cFriend.GetScreamType() + ")\n");
                        switch (cFriend.GetScreamType())
                        {
                            //TODO: rozdzielic akcje w zaleznosci od typu krzyku
                        case _SCREAMTYPE_DEATH:
                            // zapamietajmy tu ze ktos zginal, bedziemy to mogli
                            // obsluzyc z Searchstatic i "odwiedzic" trupa
                            cDeadFriend = cFriend;
                        case _SCREAMTYPE_PAIN:
                        case _SCREAMTYPE_BACKUP_CALL:
                            UpdateLastKnownEnemyPos(cFriend.cEnemy, true);
                            // atakujemy jego wroga
                            StartFriendCamperTimer();
                            nAttackCause = _ATTACK_CAUSE_NOISE;
                            SeekAndDestroy(cFriend.cEnemy);
                            // zapominamy o zabitym przyjacielu
                            cDeadFriend = null;
                            break;
                        case _SCREAMTYPE_ONRICOCHETNOISE:
                            if (!bAssaultMode)
                            {
                                nAttackCause = _ATTACK_CAUSE_NOISE;
                                SeekAndDestroy(null);
                            }
                            break;
                        }
                    }
                }
            }
        }
        else
        {
            if (nNoiseType == Pawn._NOISE_BULLET_HIT)
            {
                bSomebodyIsTryingToKillMe = true;
                nRicochets ++;
                //CrashLog("Ktos do mnie strzela? "+nRicochets+"\n");
                if (!bAssaultMode)
                {
                    nAttackCause = _ATTACK_CAUSE_NOISE;
                    SeekAndDestroy(null);
                }
                //LogD("ricochet noise\n");
                
                // powiadom innych ze malo co bys oberwal
                CallMethodIn("TryToScreamRicochet", 1.5f );
            }
        }
    }
    
    void TryToScreamRicochet()
    {
        TryToScream( _SCREAMTYPE_ONRICOCHETNOISE );
    }
    
//    /** Zmiana trybu prouszania sie
//     */
//    void ChangeMotionMode(byte nType)
//    {
//        super.ChangeMotionMode(nType);
//        UpdateSpeed();
//    }
    
    
    /** Info o zakonczeniu zadania zmiany trybu poruszania sie
     */
    void OnChangeMotionType()
    {
        TaskFinishedQuick();
    }

    
    
    ///////////////////////////////////////////////////
    // Nakierowywanie (czesci) ciala AI na przeciwnika
    //
    
    
    
    /** Znacznik, ze SetTwistDestDir moze obracac postacia wokol jej osi
     *  (wylaczane, gdy np. AI idzie i ma sledzic wroga 'wzrokiem' ale utrzymywac
     *  kierunek marszu)
     */
    public boolean bTwistCanTurn = true;
    /** [Pomocnicza] Zapamietana w SetTwistDestDir wartosc AnimMorphTime
     */
    float fSTDDAnimMorphTime = 0;

    /** Ustawia AI w podanym kierunku (deformuje cialo i obraca jesli trzeba)
     *  @param vDir zadany kierunek (<code>Vector</code>)
     *  @param nTwistType rodzaj deformacji (_TWIST_TYPE_*)
     *  @return czas potrzebny na wykonanie obrotu
     */
    float SetTwistDestDir(Vector vDir, int nTwistType)
    {
        float fAngleH = Dir2HorizAngle(vDir),
              fAngleV = -Dir2VertAngle(vDir),
              fCroppedAngleH = Crop(fAngleH, GetTwistHorizMin(nTwistType), GetTwistHorizMax(nTwistType)),
              fCroppedAngleV = Crop(fAngleV, GetTwistVertMin(nTwistType), GetTwistVertMax(nTwistType));

        if (bTwistCanTurn && fAngleH != fCroppedAngleH)
        {
            //CrashLog("DBG: Large angle: " + fCroppedAngleH + "(" + fAngleH + ")\n");
            
            int iTurn = (fAngleH > 0) ? 1 : -1;

            float fTurnTime = Math.abs(fAngleH / fAngSpeed);

            if (iTurn != cMotion.iTurn)
            {
                //CrashLog("DBG: iTurn != cMotion.iTurn\n");
                
                SetTorsoAnimMorphTime( fTurnTime );
                SetMaxAngSpeed(fAngSpeed);

                //TwistBody(0, fCroppedAngleV, nTwistType);
                TwistBody(0, 0, _TWIST_TYPE_NONE);

                // Ustawienie MotionState, zeby odpalic odpowiednia animacje
                if (fAngleH > 0)
                    cMotion.iTurn = 1;
                else
                    cMotion.iTurn = -1;
                UpdateMotion();
            }

            METHOD_DestDirReached = 0;
            SetFacingDestDir(vDir);
            bStopGotoClearsDestDir = false;
            CallMethodOnceIn( METHOD_StopTurnAnim, fTurnTime );
            return fTurnTime;
        }
        else if (cMotion.iTurn == 0) // skret tylko jesli sie nie obraca
        {     
            /*
            CrashLog("DBG: cMotion.iTurn " + cMotion.iTurn +
                     " bTwistCanTurn " + bTwistCanTurn +
                     " fAngleH "+fAngleH+
                     " fCroppedAngleH "+fCroppedAngleH+
                     "\n");
            //*/
            UpdateMotion();
            TwistBody(fCroppedAngleH, fCroppedAngleV, nTwistType);
            return GetAnimMorphTime();
        }
        else
        {
            //CrashLog("DBG: Math.abs(fAngleH / fAngSpeed)\n");
            return Math.abs(fAngleH / fAngSpeed);
        }
    }


    /** Wylaczenie animacji tupania przy obrocie i przywrocenie AnimMorphTime
     */
    void StopTurnAnim()
    {
        bStopGotoClearsDestDir = true;
        //CrashLog("DBG: StopTurnAnim\n");
        DisableCallMethod(METHOD_StopTurnAnim);

        //if (fSTDDAnimMorphTime != 0)
        //    SetAnimMorphTime(fSTDDAnimMorphTime);
        SetTorsoAnimMorphTime(GetAnimMorphTime());
        cMotion.iTurn = 0;
        UpdateMotion();
    }


    /** Znacznik nakierowywania sie cialem na przeciwnika
     */
    boolean bTrackingBody = false;
    
    /**
     */
    void EnableTracingEnemyBody()
    {
        //LogD("\n");
        if (!bTrackingBody)
        {
            bTrackingBody = true;
            AddTracking();
        }
    }
    
    /**
     */
    void DisableTracingEnemyBody()
    {
        //LogD("\n");
        if (bTrackingBody)
        {
            bTrackingBody = false;
            RemoveTracking();
        }
        TwistBody(0,0,_TWIST_TYPE_NONE); //reset skrecenia ciala
    }
        
    
    
    void UpdateTrackingPoint(Vector vPoint, int nTwistType)
    {
        Vector vDir = new Vector(vPoint);
        vDir.Sub(GetLookFromPoint());
        SetTwistDestDir(vDir, nTwistType);        
    }
    
    
    void UpdateTrackingEnemyBody()
    {
        if (cEnemy != null)
        {
            Vector vPoint = cEnemy.GetPointToLookAt(nTrackingLookAtPointIdx);
            if (vPoint == null)
                vPoint = cEnemy.GetPointToLookAt(0);
            if (vPoint != null)
                UpdateTrackingPoint(vPoint, _TWIST_TYPE_TORSO);
        }
    }

    
    void UpdateAllTrackings()
    {
        if (bTrackingBody)
            UpdateTrackingEnemyBody();
        else // Sledzenie cialem wyklucza inne sledzenia
            super.UpdateAllTrackings();
    }

    /** Zakonczenie zadania szybkiego obracania sie
     */
    void QuickTurnDone()
    {
        //LogD("\n");
        QuickTurnStopped();
        TaskFinishedQuick();
    }
    
    /** Zatrzymanie szybkiego obrotu */
    void QuickTurnStopped()
    {
        //LogD("\n");
        SetMaxAngSpeed( fAngSpeed );
        SetAnimMorphTime(fOldAnimMorphTime);
        ClearDestinationDir();
        vDesiredDir = null;
        UpdateMotion(); // zatrzymanie animacji
    }
    
    
    /** Zakonczenia zadania obracania sie */
    void TurnDone()
    {
        //CrashLog("DBG: TurnDone\n");
        TurnStopped();
        TaskFinishedQuick();
    }

    /** Metoda powodujaca zatrzymanie obrotu (np. gdy task przerwany lub zakonczony)
     */
    void TurnStopped()
    {
        //CrashLog("DBG: TurnStopped\n");
        ClearDestinationDir();
        StopTurnAnim();
    }
    
    
    /** Wrzucenie do kolejki zadan umozliwiajacych szybki obrot 
     *  (AI wstanie, jesli duck lub crawl a potem wroci do poprzedniej pozycji)
     */
    void PerformQuickTurnTask()
    {
        int iOldSpeed = -1;

        if (cMotion.iSpeed == MotionState.SPEED_CRAWL ||
            cMotion.iSpeed == MotionState.SPEED_DUCK)
        {
            iOldSpeed = cMotion.iSpeed;
            NewTask(_ACTION_GET_WALKED);
        }
        
        NewTask(_ACTION_TURN_QUICK);

        if (iOldSpeed == MotionState.SPEED_CRAWL)
            NewTask(_ACTION_GET_CRAWLED);
        else if (iOldSpeed == MotionState.SPEED_DUCK)
            NewTask(_ACTION_GET_DUCKED);
    }
    
    
    /** Wrzucenie do kolejki zadan umozliwiajacych przemiszczenie sie
     *  (AI wstanie, jesli duck lub crawl a potem wroci do poprzedniej pozycji)
     */
    void PerformQuickGoTask()
    {
        int iOldSpeed = -1;

        if (cMotion.iSpeed == MotionState.SPEED_CRAWL ||
            cMotion.iSpeed == MotionState.SPEED_DUCK)
        {
            iOldSpeed = cMotion.iSpeed;
            NewTask(_ACTION_GET_WALKED);
        }
        
        NewTask(_ACTION_GOTO_POS);

        if (iOldSpeed == MotionState.SPEED_CRAWL)
            NewTask(_ACTION_GET_CRAWLED);
        else if (iOldSpeed == MotionState.SPEED_DUCK)
            NewTask(_ACTION_GET_DUCKED);
    }
    
    void PerformQuickRunTask()
    {
        int iOldSpeed = -1;

        if (cMotion.iSpeed == MotionState.SPEED_CRAWL ||
            cMotion.iSpeed == MotionState.SPEED_DUCK)
        {
            iOldSpeed = cMotion.iSpeed;
            NewTask(_ACTION_GET_WALKED);
        }
        
        NewTask(_ACTION_RUNTO_POS);

        if (iOldSpeed == MotionState.SPEED_CRAWL)
            NewTask(_ACTION_GET_CRAWLED);
        else if (iOldSpeed == MotionState.SPEED_DUCK)
            NewTask(_ACTION_GET_DUCKED);
    }
    
    /** Zakonczenie podbiegania (po dojsciu do celu albo uplywie czasu */
    void RunUpDone()
    {
        StopGoTo();
        DisableCallMethod( METHOD_RunUpDone );
        cMotion.iSpeed = MotionState.SPEED_WALK;
        UpdateMotion();
        if (bWasTrackingBodyBeforeRunUp)
            EnableTracingEnemyBody();
        bTwistCanTurn = true;
        TaskFinishedQuick();
    }
    
    /** Zakonczenie ucieczki z miejsca niebezpiecznego */
    void EscapeDone()
    {
        LogD("\n");
        DisableCallMethod("EscapeDone");
        if (vDangerPosition != null)
        {
            vDangerPosition = null; // wylacz pozycje - zaznacza, ze juz nie podbiega
            SetWalkTrackedObject(cBeforeEscapeWalkTrackedObject);
            StopGoTo();
            if (bWasTrackingBodyBeforeRunUp)
                EnableTracingEnemyBody();
            bTwistCanTurn = true;
            bCriticalActionInProgress = false;
            TaskFinishedQuick();
        }
    }
    
    /** Zmiana parametrow ucieczki
     *  @return true, jesli ucieka
     */
    boolean EscapeFromDangerRecalc()
    {
        //Vector vMyPos = GetPosition();
        float fDistance=GetDistanceTo(vDangerPosition);//vMyPos.Distance(vDangerPosition);
        if (fDistance < fDangerRadius)
        {   // jestesmy w zasiegu

            // Oblicz wektor ucieczki
            Vector vMyPos = GetPosition();
            Vector vEscapeDir = GetPosition();
            vEscapeDir.Sub(vDangerPosition);
            
            float fEscapeDistance = fDangerRadius - fDistance;
            vEscapeDir.Mul(fEscapeDistance / fDistance); // == Normalize() i Mul(odleglosc do przebycia) w jednym
            vMyPos.Add(vEscapeDir);
            
            LogD("Escape from:" + GetPosition() + " to:" + vMyPos + " (dist: " + fEscapeDistance + ")\n");

            /** Oblicz minimalny czas ucieczki, zeby nie biegl w nieskonczonosc, 
             * jesli nie dojdzie do punktu */
            float fTime = fEscapeDistance / aMotionVelocity[MotionState.SPEED_RUN]; 
            
            GoTo(vMyPos, MotionState.SPEED_RUN, "EscapeDone"); 
            CallMethodOnceIn("EscapeDone", fTime); // zatrzymaj czasie, bo moze nie dojsc
            return true;
        }
        else
        {
            return false;
        }
    }        
    
    
    /** 
     */
    void TaskEscapeFromDanger()
    {
        LogD(aTaskQueue.toString() + "\n");
        
        // zaznacz, ze to jest akcja krytyczna
        bCriticalActionInProgress = true;
        
        if (bTrackingBody)
        {
            DisableTracingEnemyBody(); // zeby smiesznie nie wygladalo
            bWasTrackingBodyBeforeRunUp = true;
        }
        bTwistCanTurn = false;
        cMotion.bAiming = false;

        cBeforeEscapeWalkTrackedObject = GetWalkTrackedObject();
        SetWalkTrackedObject(null); // zeby mogl szybko uciekac

        Vector vDesiredDir = GetPosition();
        vDesiredDir.Sub(vDangerPosition);
        NewTaskExclusive(_ACTION_TURN_QUICK);
        
        NewTask(_ACTION_ESCAPE_FROM_DANGER);
    }
    

    int nGITCountsToResetInfo = 3;
    int nGITCounts = 0;
    /** Wyswietlanie informacji o obecnym stanie AI
     */
    String GetInfoText()
    {
        if (nGITCounts <= 0)
        {
            bCanSeeEnemy = false;
            nGITCounts = nGITCountsToResetInfo;
        }
        else
            nGITCounts--;
        
        String txt = GetName();
        txt += " " + sCurrentState;

        if (CurrentState instanceof AIAttacker.Attack)
            txt += bCamperMode ? "(C)" : "(N)";
            
        if (bCanSeeEnemy)
            txt += " EnemyInSight";
        
        return txt;
    }
        
    
    /////////////////////////////////////
    // Obsluga timerow kampera
    
    /** Reset timerow
     */
    void ResetCamperTimers()
    {
        fCurrentFriendCamperTimer = fFriendCamperTimer + RandomFloat(fRandomFriendCamperTimer);
        fLastFriendCamperTime = -1;
        fCurrentEnemyCamperTimer = fEnemyCamperTimer + RandomFloat(fRandomEnemyCamperTimer);
        fLastEnemyCamperTime = -1;
    }
    
    /** Start timera wyzwalanego przez krzyk kumpla
     */
    void StartFriendCamperTimer()
    {
        if (fLastFriendCamperTime <= 0) // zeby wystartowal tylko raz
            fLastFriendCamperTime = GetTime();
    }
    
    /** Start timera wyzwalanego przez zauwazenie (sight, noise) wroga
     */
    void StartEnemyCamperTimer()
    {
        if (fLastEnemyCamperTime <= 0) // zeby wystartowal tylko raz
            fLastEnemyCamperTime = GetTime();
    }
    
    /** Sprawdzenie stanu timerow kampera
     *  @return true jesli minal choc jeden z ustawionych czasow
     */    
    boolean CamperMayGo()
    {
        float fCurrentTime = GetTime();

        if (fLastFriendCamperTime > 0 &&
            fCurrentTime - fLastFriendCamperTime > fCurrentFriendCamperTimer)
            return true;
        if (fLastEnemyCamperTime > 0 &&
            fCurrentTime - fLastEnemyCamperTime > fCurrentEnemyCamperTimer)
            return true;

        return false;            
    }
    
    /////////////////////////////////////////
    // Obsluga timerow granata
    
    void ResetGrenadeTimers()
    {
        fCurrentGrenadeTimer = fGrenadeTimer + RandomFloat(fRandomGrenadeTimer);
        fLastStartGrenadeTime = -1;
        fLastGrenadeTime = 0;
        fCurrentGrenadeThrowingDelay = 0;
    }
    
    void StartGrenadeTimer()
    {
        if (fLastStartGrenadeTime <= 0)
            fLastStartGrenadeTime = GetTime();
    }
    
    /** Zwraca true jesli spelnione sa warunki czasowe, ilosciowe, probabilistyczne 
     *  i przestrzenne rzutu granatem
     *  @param fDistanceToTarget
     *  @return true jesli mozna probowac
     */
    boolean MayThrowGrenade(float fDistanceToTarget)
    {
        float fCurTime = GetTime();
        if (nGrenadesLeft > 0 && //sa granaty
            fLastStartGrenadeTime > 0 && // wystartowal timer
            fCurTime - fLastStartGrenadeTime > fCurrentGrenadeTimer && // timer mowi: go!
            fCurTime - fLastGrenadeTime > fCurrentGrenadeThrowingDelay && // nie rzucamy za czesto
            fCurTime - fLastGrenadeCheckTime > fGrenadeCheckDelay && // nie sprawdzamy za czesto (trace'y i rezanie obj. z grida)
            fDistanceToTarget >= fMinGrenadeThrowDistance && // nie za blisko
            fDistanceToTarget <= fMaxGrenadeThrowDistance) // nie za daleko
        {
            // jeszcze tylko prawdopodobienstwo - zal sie rozstawac z ostatnimi granatami...
            float fProbability = 100.f * (float)nGrenadesLeft / (float)nGrenadesMoreThanEnoughCount;
            if (fProbability > 100)
                fProbability = 100;
            return CanHappen((int)fProbability);
        }
        return false;
    }
    
    
    /** Odpala timery uruchamiane po zauwazeniu przeciwnika
     */
    void StartEnemyInSightTimers()
    {
        StartEnemyCamperTimer();
        StartGrenadeTimer();
    }
    
    /////////////////////////////////////////////////////
    // Stan Patrol pokryty //
    /////////////////////////////////////////////////////
    public class Patrol extends AIPatroler.Patrol
    {
        public void OnEnter()
        {
            super.OnEnter();
        }
        
        public void OnLeave()
        {
            super.OnLeave();
            bShouldShout = true;
        }
        
        public void OnReact()
        {
//            ProfileBegin(PROFILE_OnReact);
            // sprawdzamy czy nie widzimy wroga
            ChromeActor cTarget = GetNearestEnemyInSight();
            if(cTarget != null)
            {
                //LogD("Enemy is in sight\n");
                UpdateLastKnownEnemyPos(cTarget, false);

                StartEnemyInSightTimers();
                nAttackCause = _ATTACK_CAUSE_SIGHT;
                nTargetPointIdx = 0;
                Attack(cTarget);
            }
//            ProfileEnd(PROFILE_OnReact);
        }
    }

    
    public class PatrolAttack extends AIPatroler.Patrol
    {
        ControlObject cTrackedObject = null;
        
        public void OnEnter()
        {
            super.OnEnter();   
            
            cTrackedObject = GetWalkTrackedObject();
            SetWalkTrackedObject(cEnemy);
            bShouldWalkTracking = true;
        }
        
        public void OnLeave()
        {
            StopStrafeFire();
            SetWalkTrackedObject(cTrackedObject);
            
            bShouldWalkTracking = false;
            super.OnLeave();
        }
        
        public void OnReact()
        {
        }
        
        public void OnMakeDecisionEntering()
        {
            NewTask(_ACTION_START_STRAFE_FIRE);
            super.OnMakeDecisionEntering();
        }
        
        public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
        {
        }
    }
    
    
    ///////////////////////
    // Stan Idle pokryty //
    ///////////////////////
    public class Idle extends AIBase.Idle
    {
        public void OnEnter()
        {
            super.OnEnter();
            
            cMotion.iSpeed = MotionState.SPEED_STILL;
            UpdateMotion();
        }
        
        public void OnLeave()
        {
            super.OnLeave();
            bShouldShout = true; 
        }
        
        public void OnMakeDecision()
        {
            float fCurTime = GetTime();
            if (nReadinessToSearch > 0 && 
                CanHappen(nReadinessToWalk) &&
                fCurTime > fLastWalkTime + fCurBetweenWalkTime)
            {
                fLastWalkTime = fCurTime;
                fCurBetweenWalkTime = fBetweenWalkTime + RandomFloat(fRandomBetweenWalkTime);
                NewTask(_ACTION_TAKE_A_WALK);
            }
            else
                super.OnMakeDecision();
        }
        
        
        
        /** Sprawdzenie co dzieje sie wokol AI
         */
        public void OnReact()
        {
//            ProfileBegin(PROFILE_OnReact);

            // sprawdzamy czy nie widzimy wroga
            ChromeActor cTarget = GetNearestEnemyInSight();
            if(cTarget != null)
            {
                //LogD("Enemy is in sight\n");
                UpdateLastKnownEnemyPos(cTarget, false);
                StartEnemyInSightTimers();
                nAttackCause = _ATTACK_CAUSE_SIGHT;
                nTargetPointIdx = 0;
                Attack(cTarget);
            }
            
//            ProfileEnd(PROFILE_OnReact);
        }
    }
    
    //////////////////////////////
    // Stan IdleSitting pokryty //
    //////////////////////////////
    
    public class IdleSitting extends AIBase.IdleSitting
    {
        /** Sprawdzenie co dzieje sie wokol AI
         */
        public void OnReact()
        {
//            ProfileBegin(PROFILE_OnReact);
            
            // sprawdzamy czy nie widzimy wroga
            ChromeActor cTarget = GetNearestEnemyInSight();
            if(cTarget != null)
            {
                UpdateLastKnownEnemyPos(cTarget, false);
                StartEnemyInSightTimers();
                nAttackCause = _ATTACK_CAUSE_SIGHT;
                nTargetPointIdx = 0;
                Attack(cTarget);
            }
            
//            ProfileEnd(PROFILE_OnReact);
        }
        
    }
    

   // boolean bCameFromAttackState = false;
    int nHidingPos, 
        nFiringPos;
   
    /** Czas, kiedy ostatnio updateowane byly pozycje do kryjowki
     */
    float fLastUpdateHideoutParamsTime = 0;
    
    /** Minimalny czas, co jaki nalezy updateowac param. kryjowki
     */
    float fUpdateHideoutParamsTime = 3.f;
    
    /** Update'uje pozycje ukrycia i strzelania, zwraca czy chowacz aktualny
     *  @return true gdy chowacz aktualny
     */
    boolean UpdateHideoutParams()
    {
        fLastUpdateHideoutParamsTime = GetTime();
        nHidingPos = FindHidingPos(cEnemy);
        if (nHidingPos > -1) // gdy jest sie gdzie ukryc
            nFiringPos = FindFiringPos(cEnemy);
        else
            nFiringPos = -1;
        //LogD(nHidingPos + " " + nFiringPos + "\n");
        return (nFiringPos > -1);
    }
    
    
    
    float fCurrentEnemyChangeInterval = 0;
    float fLastEnemyChangeTime = 0;
    
    void InitEnemyChangeTimer()
    {
        fLastEnemyChangeTime = GetTime();
        fCurrentEnemyChangeInterval = fEnemyChangeInterval + RandomFloat(fRandomEnemyChangeInterval);
    }
    
    boolean ShouldChangeEnemy()
    {
        if (cEnemy == null ||
            cEnemy.fHealth <= 0 || 
            GetTime() - fLastEnemyChangeTime > fCurrentEnemyChangeInterval)
        {
            InitEnemyChangeTimer();
            return true;
        }
        else
            return false;
    }
    
    /////////////////////////////////////////////////////
    // Stan atacku z chowacza tzn. wychyl sie i strzel //
    /////////////////////////////////////////////////////
    public class AttackFromHideout extends Attack
    {
        public void OnEnter()
        {
            super.OnEnter();
        }
            
        /** Metoda podejmuje decyzje jak ma sie zachowac za chwile AI
         */
        void OnMakeDecision()
        {
//            ProfileBegin(PROFILE_AttackDecision);

            boolean bEnemyInRange = IsEnemyInWeaponRange();
            //LogD("----------------\n");
            
            
            if (ShouldChangeEnemy())
            {
                ChromeActor cNewEnemy = GetNearestEnemyInSight(); //..znajdz innego
                if (cNewEnemy == null) // nie udalo sie znalezc - uspokoj sie
                {
                    NewTask(_ACTION_CALM_DOWN);
//                    ProfileEnd(PROFILE_AttackDecision);
                    return;
                }
                else
                {
                    ChangeEnemy(cNewEnemy);
                    nTargetPointIdx = 0;
                    NewTask(_ACTION_THINK);
                }
            }
            
            float fCurrentTime = GetTime();
            boolean bNormalAttack = false;
            
            /** Jesli koniec kampowania - normalny atak */
            if (bCamperMode && CamperMayGo())
            {
                bNormalAttack = true;
            }
            /** Sprawdz parametry kryjowki, jesli minal odpowiednio dlugi czas */
            else if (fCurrentTime - fLastUpdateHideoutParamsTime > fUpdateHideoutParamsTime)
            {
                if (!UpdateHideoutParams())
                {
                    bNormalAttack = true;
                    if (nHidingPos == -1) // nie da sie ukryc - przestan kampowac
                        bCamperMode = false;
                }
            }
            /** Jesli za rzadko trafia - normalny atak */
            else if ((nRoundsShot > 0) && ((float)nRoundsHit/(float)nRoundsShot < fMinHitRatio))
            {
                bNormalAttack = true;
            }
            /** Jesli gracz b. blisko - normalny atak i koniec kampowania
             */
            else if (GetDistanceToEnemy() < fMinCamperDistanceToEnemy)
            {
                bCamperMode = false;
                bNormalAttack = true;
            }
            
            if (bNormalAttack)
            {
                // jesli kryjowka jest do bani - wyjdz z niej
                bShouldShout = false;
                SetState("Attack");
//                ProfileEnd(PROFILE_AttackDecision);
                return; // CHK: czy potrzebne?
            }

            
            if (bEnemyInRange)
            {
                // skoro go widac, to zapamietaj pozycje dla podbiegania
                UpdateLastKnownEnemyPos(cEnemy, false);
            }

            int nCurrentPos = MotionState2FiringPos(cMotion);
            if (bDamageTaken && nHidingPos > -1)
            {
                TaskHide();
            } 
            else if (nCurrentPos >= nFiringPos) // jesli sie wychyla ('>=' bo firingpos uszeregowane po wysokosci)
            {
                //LogD("Wychyla sie\n");
                // jesli nie ma amunicji - schowaj sie do przeladowania
                if( ActiveWeapon.GetState() == Weapon.STATE_NO_AMMO )
                {
                    if (nHidingPos > -1) 
                    {
                        TaskHide();
                    }
                    else // nie ma sie jak ukryc - przeladuj
                    {
                        if(cMotion.bAiming) 
                        {
                            NewTask(_ACTION_AIMING_OFF);
                            NewTask(_ACTION_RELOAD);
                            NewTask(_ACTION_AIMING_ON);
                        }
                        else
                            NewTask(_ACTION_RELOAD);
                    }
                }
                else
                {
                    if (bEnemyInRange)
                    {
                        //                        boolean bFireWithAim = false;
                        //                            if (nReadinessToAim == 100 &&
                        //                                !cMotion.bAiming)
                        //                            {
                        //                                NewTask(_ACTION_AIMING_ON);
                        //                                bFireWithAim = true;
                        //                            }
                        //LogD("Enemy in range - should fire\n");
                        NewTask(_ACTION_FIRE_ROUND);
                        
                        //                            if (nReadinessToStopAiming == 100 &&
                        //                                bFireWithAim)
                        //                                NewTask(_ACTION_AIMING_OFF);
                    }
                    else
                    {
                        NewTask(_ACTION_THINK);
                    }
                    // Jesli wystaje wystarczajaco dlugo - niech sie schowa
                    if (nHidingPos > -1 && 
                        fCurrentTime - fLastFiringPosTime > fCurrentFiringPosTime)
                    {
                        fLastFiringPosTime = fCurrentTime;
                        fCurrentFiringPosTime = fFiringPosTime + RandomFloat(fRandomFiringPosTime);
                        TaskHide();
                    }
                }
            }
            else
            {
                //LogD("Ukrywa sie\n");
                if( ActiveWeapon.GetState() == Weapon.STATE_NO_AMMO )
                {
                    if(cMotion.bAiming) 
                        NewTask(_ACTION_AIMING_OFF);
                    NewTask(_ACTION_RELOAD);
                } 
                /** Jesli ukrywa sie juz dlugo i ostatnio gracz nie strzelal */
                else if (nFiringPos > -1 &&
                         fCurrentTime - fLastHidingPosTime > fCurrentHidingPosTime &&
                         fCurrentTime - fLastEnemyFireNoise > fTimeToSurprize)
                {
                    fLastHidingPosTime = fCurrentTime;
                    fCurrentHidingPosTime = fHidingPosTime + RandomFloat(fRandomHidingPosTime);
                    TaskLeanOut();
                }
                else
                {
                    NewTask(_ACTION_THINK);
                }
            }
            bDamageTaken = false; //juz obsluzony, jesli sie dalo
//            ProfileEnd(PROFILE_AttackDecision);
        }
        
        
        void TaskHide()
        {
            //LogD("\n");
            if (cMotion.bAiming && nHidingPos <= _FIRINGPOS_STAND) // jesli trzeba wylaczyc przycelowanie
                NewTask(_ACTION_AIMING_OFF);
            if (CompareFiringPos(nHidingPos, _FIRINGPOS_DUCK, true))
                NewTask(_ACTION_GET_DUCKED);
            else
                NewTask(_ACTION_GET_CRAWLED);
        }
       
        void TaskLeanOut()
        {
            // snajper musi dodatkowo przycelowac
            /*
            if ( bSniperMode )
            {
                if (CompareFiringPos(nFiringPos, _FIRINGPOS_DUCK, true))
                    NewTask(_ACTION_GET_DUCKED);
                else
                    NewTask(_ACTION_GET_WALKED);
                
                if (!cMotion.bAiming && nFiringPos > _FIRINGPOS_STAND) // jesli trzeba przycelowac
                    NewTask(_ACTION_AIMING_ON);
                
                return;
                //fWaitTime = 1.0f;
                //NewTask(_ACTION_WAIT);
            }
            */
            
            //LogD("\n");
            if (!cMotion.bAiming && nFiringPos > _FIRINGPOS_STAND) // jesli trzeba przycelowac
                NewTask(_ACTION_AIMING_ON);
            
            if (CompareFiringPos(nFiringPos, _FIRINGPOS_DUCK, true))
                NewTask(_ACTION_GET_DUCKED);
            else
                NewTask(_ACTION_GET_WALKED);
        }
        
        void OnMakeDecisionEntering()
        {
/*            
            if (UpdateHideoutParams()) // kryjowka ok
            {
                bNeedUpdateHideoutParams = false;
                int nCurrentPos = MotionState2FiringPos(cMotion);                                
                if (CanHappen(50)) //TODO: uzaleznic od agresji i powodu wejscia do stanu
                { // ukryj sie
                    if (!CompareFiringPos(nCurrentPos, nHidingPos, true))
                    { // nie jest ukryty - ukryj sie
                        TaskHide();
                    }
                }
                else
                { // wychyl sie
                    if (!CompareFiringPos(nCurrentPos, nFiringPos, true))
                    { // nie wychyla sie - zrob to
                        TaskLeanOut();
                    }
                }
            }
            else // nie ma dobrej kryjowki - zastanow sie co robic
            {
                NewTask(_ACTION_THINK);
            }
*/
            InitEnemyChangeTimer();
            NewTask(_ACTION_TRACK_ENEMY_BODY);
        }
    }

    
    ///////////////////////////////////////////////////////////////////
    // Stan atacku - do tego stanu przechodzi AI gdy ktos je wkurzyl //
    ///////////////////////////////////////////////////////////////////

    public class Attack extends AIBaseState
    {
        public void OnEnter()
        {
            super.OnEnter();
            
            LogD(nAttackCause + "\n");
            
            if(cEnemy == null) 
                LogD("No enemy !\n");
            else
            {
                if ( (nAttackCause == _ATTACK_CAUSE_SIGHT) ||
                     (nAttackCause == _ATTACK_CAUSE_NOISE && 
                      (GetDistanceToEnemy() < fMaxNoisePositionDistance)) ) 
                {
                    LogD("Enemy in sight - remember his position\n");
                    // zapamietujemy pozycje przeciwnika
                    UpdateLastKnownEnemyPos(cEnemy, false);
                }
            }
            // w tym stanie AI strzela z guna, wiec musi miec go w lapach
            bPlaceGun = true;
            nRoundsHit = nRoundsShot = 0;
            bShouldWalkTracking = true;
            SetWalkTrackedObject(cEnemy);
        }
        
        public void OnLeave()
        {
            super.OnLeave();
            cMotion.bAiming = false;
            nAttackCause = _ATTACK_CAUSE_NONE;
            StopHeadTracking();
            DisableTracingEnemyBody();
            bShouldWalkTracking = false;
            SetWalkTrackedObject(null);
        }
        
        void OnReact()
        {
//            ProfileBegin(PROFILE_OnReact);

            if (!bTrackingHead) // jesli jeszcze nie sledzi go glowa, to sprawdz czy nie powinien
            {
                if (IsTargetInSight(cEnemy, true))
                    HeadTracking(cEnemy);
            }
//            LogD("curr motion= " + MotionState.aSpeedNames[cMotion.iSpeed] + (cMotion.bAiming ? "(a)" : "") + "\n");
//            LogD("qv = " + aTaskQueue.toString() + "\n");
//            LogD("sight=" + (IsEnemyInSight() != null) + " wea=" + IsEnemyInWeaponRange() + "\n");
            
//            ProfileEnd(PROFILE_OnReact);
        }
               
        float fLastEnemyFireNoise = 0.0f;
        
        public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
		{
            if (IsFrozen())
                return; 

            if (GlobalNoiseReactionHandler(Noisy, fNoiseLevel, nNoiseType))
                return;

            // sprawdzenie czy uslyszany halas jest wrogi czy nie
            if( Noisy == cEnemy )
            {
				//LogLine("Uslyszalem cos:" + this + ", " + nNoiseType + ", " + fNoiseLevel);
                UpdateLastKnownEnemyPos(cEnemy, true);
                if(nNoiseType == Pawn._NOISE_WEAPON_FIRING)
                {
                    // sprawdz jak daleko (na razie katowo) od ciebie strzela przeciwnik
                    Vector vAI_Enemy = GetPosition();
                    vAI_Enemy.Sub(cEnemy.GetPosition());
                    vAI_Enemy.Normalize();
                    Vector vEnemyFireDir = cEnemy.GetFireDir();
                    vEnemyFireDir.Normalize();
                    if (vAI_Enemy.Dot(vEnemyFireDir) > 0.87f) // jesli kat < 30[deg]
                    {
                        fLastEnemyFireNoise = GetTime();
                        //LogD("Enemy's  _NOISE_WEAPON_FIRING heard \n");
                    }
                }
            }
        }
        
        void ReloadAnimEnd()
        {
            // wlaczamy przyczepienie guna do reki
            bPlaceGun = true;
            
            UpdateMotion();
            //rzeczywisty reload dopiero po odegraniu animacji
            WeaponReload();
//            UpdateMotion();
            TaskFinishedQuick();
        }

        /////////////////////////////////
        // Zmiana sposobu ruszania sie //
        /////////////////////////////////

        /** flaga =true od momentu zmiany sposobu poruszania sie do pierwszego
         * podejmowania decyzji o tym co robic dalej.
         */
        boolean bMotionTypeJustChanged = false;
        
       
        /** Metoda wolana gdy AI zmieni sposob poruszania sie
         */
        void OnChangeMotionType()
        {
            //LogD("\n");
            // ustawienie flagi, ze wlasnie sie skonczylo przelaczanie stanu ruchu
            bMotionTypeJustChanged = true;

            // wlaczamy celowanie cialem
            EnableTracingEnemyBody();
            
            // wlaczamy myslenie
            TaskFinishedQuick();
        }

        
        /** Sprawdzenie, czy po przejsciu do duck'a mozna trafic przeciwnika
         *  @return true gdy mozna trafic przeciwnika po przejsciu do duck'a
         */
        boolean CanFireFromDuck()
        {
            int nTgtIdx = ChoosePointToHitIdx(_FIRINGPOS_DUCK, cEnemy);
            if (nTgtIdx != -1)
            {
                nTargetPointIdx = nTgtIdx;
                return true;
            }
            return false;
        }
        
        
        /////////////////////////////////////////
        // Podejmowanie decyzji co ma robic AI //
        /////////////////////////////////////////

        /** Metoda podejmuje decyzje jak ma sie zachowac za chwile AI
         */
        void OnMakeDecision()
        {
//            ProfileBegin(PROFILE_AttackDecision);
            
            boolean bMustRunToEnemyNow = false;
            
            /** Jesli kampuje i ma przestac - zaznacz, zeby wybiegl */
            if (bCamperMode && CamperMayGo())
            {
                bMustRunToEnemyNow = true;
                bCamperMode = false;
            }
            else 
            {
                /** Jesli mozliwy atak z chowacza - wykorzystaj to */
                if (UpdateHideoutParams())
                {
                    SetState("AttackFromHideout");
//                    ProfileEnd(PROFILE_AttackDecision);
                    return;
                }
                else // chowacz nie jest tak calkiem dobry...
                {
                    if (nHidingPos == -1) // nie mozna sie nawet schowac - koniec kampowania
                        bCamperMode = false; 
                }
            }
            
            
            
            float fDistance = GetDistanceToEnemy();
            
            if (fDistance < fMinCamperDistanceToEnemy)
            {
                // Skoro za blisko - wylacz kampowanie
                bCamperMode = false;
            }
            
            // modyfikujemy troche zakresy
            float fRandomModifier = RandomFloat(fRandomDistance);
            fDistance += fRandomDistance/2.0f + fRandomModifier;
            
            // wyliczamy czy z biezacej pozycji mozna trafic do wroga
            boolean bEnemyInRange = IsEnemyInWeaponRange();
            if (bEnemyInRange)
            {
                // skoro go widac, to zapamietaj pozycje dla podbiegania
                UpdateLastKnownEnemyPos(cEnemy, false);
            }
            
            /** znacznik, ze sie porusza, zeby nie dobiegal */
            boolean bIsMoving = cMotion.IsMovingLinear();
            
            /** aktualna pozycja */
            int nFiringPos = MotionState2FiringPos(cMotion, true);
            
            /** Przeladuj jesli trzeba - najwyzszy priorytet */
            if( ActiveWeapon.GetState() == Weapon.STATE_NO_AMMO )
            {
                /** Jesli stal, to raczej kleknie, bo tak bezpiecznej... */
                if (!bIsMoving && (nFiringPos == _FIRINGPOS_STAND) &&
                    (fDistance > fDuckDistance) && CanHappen(nReadinessToDuck))
                    NewTask(_ACTION_GET_DUCKED);
                /** Przeladuj zachowujac przycelowanie */
                if(cMotion.bAiming) 
                {
                    NewTask(_ACTION_AIMING_OFF);
                    NewTask(_ACTION_RELOAD);
                    if (!CanHappen(nReadinessToStopAiming))
                        NewTask(_ACTION_AIMING_ON);
                }
                else
                    NewTask(_ACTION_RELOAD);
            }
            /** Jesli przeciwnik martwy - uspokoj sie */
            else if (ShouldChangeEnemy()) 
            {
                ChromeActor cNewEnemy = GetNearestEnemyInSight();
                if (cNewEnemy != null)
                {
                    ChangeEnemy(cNewEnemy);
                    nTargetPointIdx = 0;
                    NewTask(_ACTION_THINK);
                }
                else
                {
//                    CrashLog("DBG: NO ENEMY! (Attack)\n");
                    NewTask(_ACTION_CALM_DOWN);
                }
            }
            /** Jesli dosc blisko gracza - musi stac 
             *  zeby brzydko nie wygladalo i zeby go gracz nie zdeptal */
            else if ((nFiringPos != _FIRINGPOS_STAND) && (fDistance < fDuckDistance))
            {
                //LogD("->_ACTION_GET_WALKED\n");
                NewTask(_ACTION_GET_WALKED);
                if (bEnemyInRange && CanHappen(80)) //TODO: DEPENDS: agresja
                {
                    if (!cMotion.bAiming && CanHappen(nReadinessToAim))
                        NewTask(_ACTION_AIMING_ON);
                    // wywal w goscia seryjke
                    NewTask(_ACTION_FIRE_ROUND);
                }
            }
            else if (MayThrowGrenade(fDistance))
            {
                NewTask(_ACTION_THROW_GRENADE_TO_ENEMY);
            }
            /** Sprawdz, czy nie trzeba szukac gracza */
            else if (!bCamperMode && !bEnemyInRange && ShouldSearchEnemy())
            {
                //zmiana stanu
                if (nReadinessToSearch > 0 && // moze sie ruszyc i...
                    CanGoFurtherTo(cEnemy.GetPosition())) //... jest jeszcze na swoim terenie
                    NewTask(_ACTION_SEARCH_ENEMY_DYNAMIC);  // jesli moze szukac to niech szuka
                else
                    NewTask(_ACTION_CALM_DOWN); // nie moze szukac - idle albo patrol
            }
            else
            {
                /** znacznik, ze za rzadko trafia - trzeba cos z tym zrobic */
                boolean bToMuchMisses = (nRoundsShot > 0) && 
                                        ((float)nRoundsHit/(float)nRoundsShot < fMinHitRatio);
                /** znacznik, ze nalezy podbiec do przeciwnika */
                boolean bShouldRunUp = false; 

                /*
                kombinacje by MK, zeby w budynkach podbiegali
                if ( InBuilding() )
                {
                    LogD(" bMustRunToEnemyNow\n");
                    bMustRunToEnemyNow = true;
                }
                */

                // Czy podbiegac? - tylko gdy nie strafuje i nie kampuje
                if (bMustRunToEnemyNow ||
                    (!bCamperMode && !bIsMoving && 
                     (fDistance > fStartRunUpDistance) &&
                     (nReadinessToSearch > 0) &&
                     (CanHappen(nReadinessToSearch) || bToMuchMisses)))
                {
                    //LogD("Distance to enemy=" + fDistance + " srud=" + fStartRunUpDistance + "\n");
                    if (CanGoFurtherTo(cEnemy.GetPosition()))
                        bShouldRunUp = true;
                }

                
                boolean bCanFireFromDuck = CanFireFromDuck();
                
                // Zmiana pozycji
                switch (nFiringPos) 
                {
                case _FIRINGPOS_STAND:
                    // kleknij albo przykucnij
                    if (!bShouldRunUp && !bMotionTypeJustChanged && 
                        (fDistance>fDuckDistance) && CanHappen(nReadinessToDuck) && 
                        bCanFireFromDuck)
                        NewTask(_ACTION_GET_DUCKED);
                    break;
                case _FIRINGPOS_DUCK:
                    // wstan 
                    if (bShouldRunUp || // trzeba podbiec
                        (!bMotionTypeJustChanged && 
                         (CanHappen(100 - nReadinessToDuck) || !bCanFireFromDuck)))
                        NewTask(_ACTION_GET_WALKED);
                    break;
                case _FIRINGPOS_CRAWL: //TODO: Obsluga wstawania
                    break;
                }

                // Strzelanie
                if (bEnemyInRange && 
                    (CanHappen(98) || fDistance < fDuckDistance)) //TODO: DEPENDS: agresja 
                {
                    // Przyceluj z odpowiednim prawdopodobienstwem
                    if (!cMotion.bAiming && CanHappen(nReadinessToAim))
                    {
                        NewTask(_ACTION_AIMING_ON);
                    }

                    /** Poczekaj az bron bedzie gotowa, jesli nie jest */
                    if ((ActiveWeapon.GetState() & Weapon.STATE_READY) == 0)
                        NewTask(_ACTION_WAIT_FOR_WEAPON_READY);

                    
                    NewTask(_ACTION_FIRE_ROUND);
                    
                    if (bShouldRunUp)
                    {
                        // Jesli celuje a nie powiniem - niech przestanie
                        if (cMotion.bAiming && 
                            ((!bToMuchMisses && CanHappen(100 - nReadinessToAim)) ||
                             CanHappen(nReadinessToStopAiming)))
                        {
                            //LogD("aim off, should run up\n");
                            NewTask(_ACTION_AIMING_OFF);
                        }
                    }
                    else
                    {
                        if (cMotion.bAiming &&
                            CanHappen(nReadinessToStopAiming))
                        {
                            //LogD("aim off\n");
                            NewTask(_ACTION_AIMING_OFF);
                        }
                        //Przerwa po strzale
                        fWaitTime = fBurstFireDelay + RandomFloat(fRandomBurstFireDelay);
                        NewTask(_ACTION_WAIT);
                    }
                }
                
                // Podbieganie do przeciwnika
                if (bShouldRunUp)
                {
                    NewTask(_ACTION_RUN_UP_TO_ENEMY);
                    //NewTask(_ACTION_TRACK_ENEMY_BODY); // bo dobieganie wylacza (juz nie)
                }       
                
                // Jesli nic nie zrobil, to niech pomysli
                if (aTaskQueue.size() == 0)
                    NewTask(_ACTION_THINK);
            }

//            LogD("outQV = " + aTaskQueue.toString() + "\n");

            // zerujemy flage
            bMotionTypeJustChanged = false;
            bFiringJustStoped = false;

//            ProfileEnd(PROFILE_AttackDecision);
        }

        
        /** Podjecie decyzji poczatkowej co robic, zaraz po wejsciu do stanu Atackowania
         */
        void OnMakeDecisionEntering()
        {
            if (!(bCamperMode && CamperMayGo()))
            {
                if (UpdateHideoutParams()) // dobra kryjowka
                {
                    SetState("AttackFromHideout");
                    return;
                }
                else if (nHidingPos == -1) // nawet schowac sie nie mozna - koniec kampowania
                {
                    bCamperMode = false;
                }
            }
            
            // liczymy odleglosc do wroga
            float fDistance = GetDistanceToEnemy();
            
            //Log("[AIAttacker$Attack.OnMakeDecisionEntering] Distnace to enemy="+fDistance+"\n");
            
            float fRandomModifier = RandomFloat(fRandomDistance);
            fDistance += fRandomDistance/2.0f + fRandomModifier;

            // znajdz kierunek do wroga, zeby sie nakierowac
            vDesiredDir = cEnemy.GetPosition();
            vDesiredDir.Sub(GetPosition());
            
            // obliczamy jak najlepiej sie ustawic do strzalu

            int nFiringPos = MotionState2FiringPos(cMotion, true);

            if( fDistance < fDuckDistance ) //jesli przeciwnik blisko
            {
                if (nFiringPos != _FIRINGPOS_STAND) //wstan
                    NewTask(_ACTION_GET_WALKED);
                // nakierowanie na cel przed strzalem
                NewTask(_ACTION_TRACK_ENEMY_BODY);
                NewTask(_ACTION_TURN_QUICK);
            } 
            else // jesli daleko
            {
                if (nAttackCause == _ATTACK_CAUSE_NOISE)
                    NewTask(_ACTION_NOISE_REACTION);

//                NewTask(_ACTION_WAIT_A_MINUTE);

                NewTask(_ACTION_TURN);

                if ((nFiringPos != _FIRINGPOS_DUCK) &&
                    CanHappen(nReadinessToDuck))// trzeba kucnac
                    NewTask(_ACTION_GET_DUCKED);

                NewTask(_ACTION_WAIT_A_MINUTE);

                // nakierowanie na cel przed strzalem
                NewTask(_ACTION_TRACK_ENEMY_BODY);
                NewTask(_ACTION_SAY_HEY); //krzyknie tylko jesli widzi i nie krzyczal ostatnio
            }
            

            fWaitTime = fFirstRoundDelayTime + RandomFloat(fRandomFirstRoundDelayTime);
            InitEnemyChangeTimer();
            NewTask(_ACTION_WAIT);
        }
        
    }
    
    
    //////////////////////////////////////////////////////////////////////////////////
    // Stan szukania dynamicznego - do tego stanu przechodzi AI gdy nie widzi wroga //
    // ale wie, ze jest w poblizu - podbiega do ostatniej pozycji                   //                                                   //
    //////////////////////////////////////////////////////////////////////////////////

    public class SearchDynamic extends AIBaseState
    {
        public void OnEnter()
        {
            super.OnEnter();
            if ((cEnemy == null) || (fLastKnownEnemyPosTime == 0))
            {
                LogD("No enemy to run up to!\n");
                NewTask(_ACTION_CALM_DOWN);
            }
            else
            {
                cMotion.bAiming = false;
                if (CanGoFurtherTo(vLastKnownEnemyPos))
                    GoTo(vLastKnownEnemyPos, MotionState.SPEED_RUN, "LastEnemyInSightPosReached");
                else
                    NewTask(_ACTION_CALM_DOWN);
            }
        }
        
        
        public void OnLeave()
        {
            super.OnLeave();
            StopGoTo();
            cMotion.iSpeed = MotionState.SPEED_WALK; //bo wczesniej biegl
        }
        
        
        void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
        {
            if (IsFrozen())
                return; 

            if (GlobalNoiseReactionHandler(Noisy, fNoiseLevel, nNoiseType))
                return;

            if ( Noisy instanceof Pawn &&
                 GetTeamRelation( (Pawn)Noisy ) < _TEAM_RELATION_NEUTRAL)
            {     
                ClearTasks(); //wyczyszczenie, bo mogl sie obracac...
                TurnStopped(); //przerwanie czekania na zakonczenie obrotu
                UpdateLastKnownEnemyPos((Pawn)Noisy, true);
    
                if (CanGoFurtherTo(vLastKnownEnemyPos))
                    GoTo(vLastKnownEnemyPos, MotionState.SPEED_RUN, "LastEnemyInSightPosReached");
            }
        }
        
        
        void OnReact()
        {
//            ProfileBegin(PROFILE_OnReact);

            // jesli widzimy, to koniec szukania
            ChromeActor cTarget = GetNearestEnemyInSight();
            if(cTarget != null)
            {
                LogD("Enemy is in sight!\n");
                UpdateLastKnownEnemyPos(cTarget, false);
                
                // posprzatanie po ewentualnym zadaniu obrotu
                ClearTasks(); 
                TurnStopped();

                // testowe
                if ((GetDistanceToEnemy() < 250.f) ||
                     IsEnemyInWeaponRange())
                {
                    StopGoTo();
                    StartEnemyInSightTimers();
                    nAttackCause = _ATTACK_CAUSE_SIGHT;
                    nTargetPointIdx = 0;

                    Attack(cTarget);
                }
                else
                {
                    LogD("Continue pursuit!\n");
                    GoTo(cEnemy.GetPosition(), MotionState.SPEED_RUN, "LastEnemyInSightPosReached");
                }
            }
            
//            ProfileEnd(PROFILE_OnReact);
        }
               

        void LastEnemyInSightPosReached()
        {
            LogD("End of searching!\n");
            if (vLastKnownEnemyDir != null)
            {
                LogD("Turning to last enemy dir\n");
                vDesiredDir = vLastKnownEnemyDir;
                NewTask(_ACTION_TURN_QUICK);
            }
            fLastKnownEnemyPosTime = 0;
            // TODO: a tutaj jakies skomplikowansze szukanie
            NewTask(_ACTION_CALM_DOWN);
        }
    }

    
    //////////////////////////////////////////////////////////////////////////////////
    // Stan szukania statycznego - przechodzi do niego, gdy uslyszy wroga, ale go   //
    // nie widzi - rozglada sie i ma wyostrzone zmysly                              //
    //////////////////////////////////////////////////////////////////////////////////

    public class SearchStatic extends AIBaseState
    {
        float fStateEnterTime = 0;
        float fSearchTime = 0;
        Vector vStartPos = null;
        Vector vStartDir = null;
        Vector vDeadFriendPos = null;
        boolean bOldUseSightSamplesIntegration;

        
        /** Stale bitowe oznaczajace sposob w jaki AI moze sie rozejrzec
         */
        final int _LOOK_NONE    = 0;
        final int _LOOK_FORWARD = 1;
        final int _LOOK_BACK    = 2;
        final int _LOOK_DUCK    = 4;

        /** Aktualny mozliwy typ rozgladania sie (suma stalych _LOOK_...)
         */
        int nLookAroundFlags = _LOOK_NONE;
        
        /** Znacznik, ze obrocil sie tylem
         */
        boolean bIsFacingBackwards;

        /** Znacznik, ktora akcje obrotu (lewo/prawo) ma podjac najpierw
         */
        int nTwistAction;
        /** Znacznik, ktora akcje obrotu (lewo/prawo) ma podjac za drugim razem
         */
        int nNextTwistAction;
        
        /** Ilosc uslyszanych rykoszetow jakie attacker mial
         *  przy wejsciu do stanu
         */
        int nStartRicochets = 0;
        
        /** Ilosc zliczonych rykoszetow
         */
        int nCntRicochets = 0;
        
        /** Wspolczynnik zakresu widzenia po kazdym rykoszecie
         */
        float _SIGHT_RANGE_MUL_AT_MAX_RICOCHETS = 1.2f;
        
        
        /** Flaga mowiaca o tym, ze mamy dokonac specjalnej (ze zwiekszonym
         *  zakresem widzenia) aktualizacji wroga
         */
        boolean bUpdateEnemies = false;
                
        public void OnEnter()
        {
            super.OnEnter();
            
            //CrashLog("Wchodze do SearchStatic\n");

            fSearchStaticLastTime = GetTime();
                
            // wyostrz zmysly
            bOldUseSightSamplesIntegration = bUseSightSamplesIntegration;
            bUseSightSamplesIntegration = false; // szybciej reaguje na widok wroga

            bPlaceGun =true; // lepiej miec guna w lapach
            UpdateMotion();

            fSearchTime = fSearchStaticTime + RandomFloat(fRandomSearchStaticTime);
            // jezeli to nie do mnie strzelali to moge sobie odpuscic szybciej
            if (!bSomebodyIsTryingToKillMe)
                fSearchTime *= 0.75f;    
                        
            // dowiedzialismy sie o smierci kumpla
            if ( cDeadFriend != null && cDeadFriend.nFollowFriends <_MAX_FOLLOW_FRIENDS )
            {
                // pojdziemy tam sprawdzic co sie stalo
                vDeadFriendPos = cDeadFriend.GetPosition();
                
                // "powiedzmy" mu o tym, na pewno sie ucieszy z wizyty ;-)
                cDeadFriend.nFollowFriends ++;
            }
            
            vStartPos = GetPosition();
            vStartDir = GetForwardVector();    
                        
            fStateEnterTime = GetTime();
            SetAnimMorphTime(fSlowAnimMorphTime);
            
            nLookAroundFlags = CheckLookAroundType();
            bIsFacingBackwards = false;
            
            nStartRicochets = nRicochets;
            nCntRicochets = 0;
                        
            // zeby zaliczyc te z poprzedniego stanu
            if ( sLastState.equals( sCurrentState ) )
            {
                bUpdateEnemies = true;
                nStartRicochets = nLastStartRicochetsInSearchStatic;
                
                /*
                CrashLog("Ponowne wejscie do SearchStatic "+
                         nRicochets+"/"+nStartRicochets+"\n");
                //*/
                // tego nie trzeba, to sie przeliczy
            }
            nLastStartRicochetsInSearchStatic = nStartRicochets;
                        
            RandomTwistActions();
        }
        
        void RandomTwistActions()
        {
            if ( CanHappen(50) )
            {
                nTwistAction     = _ACTION_LOOK_RIGHT;    
                nNextTwistAction = _ACTION_LOOK_LEFT;
            }
            else
            {
                nTwistAction     = _ACTION_LOOK_LEFT;    
                nNextTwistAction = _ACTION_LOOK_RIGHT;
            }
        }
        
        public void OnLeave()
        {
            super.OnLeave();
            // przestan sie rozgladac
            SetAnimMorphTime(fNormalAnimMorphTime);
            TwistBody(0,0, _TWIST_TYPE_NONE);
            // przywroc normalne zmysly
            bUseSightSamplesIntegration = bOldUseSightSamplesIntegration;
            bSomebodyIsTryingToKillMe = false;
        }
        


        public void OnReact()
        {
//            ProfileBegin(PROFILE_OnReact);

            // sprawdzamy czy nie widzimy wroga
            ChromeActor cTarget = GetNearestEnemyInSight();
            
            if ( cTarget == null &&
                 (nRicochets - nStartRicochets > nCntRicochets ||
                  bUpdateEnemies)
                )
                 //nRicochets - nStartRicochets > _MAX_RICOCHETS_IN_SEARCHSTATIC )
            {
                
                nCntRicochets = nRicochets - nStartRicochets;
                                
                // logan doprowadzil attackera do szalu, 
                // ten sie wcurwil i teraz zaatakuje
                
                /*
                // tu mozemy poszukac wroga w powiekszonym zasiegu
                float fPrevRange = fAISightRange;
                float fNewRange  = fPrevRange * nCntRicochets * _SIGHT_RANGE_MUL_AT_MAX_RICOCHETS;
                
                fAISightRange  = fNewRange;
                fAISightRange2 = fAISightRange * fAISightRange;
                
                cPawn = GetNearestEnemyInSight();
                
                fAISightRange  = fPrevRange;
                fAISightRange2 = fAISightRange * fAISightRange;
                */

                /*
                if ( cPawn != null )
                    CrashLog("Przegiales ("+nCntRicochets+" rykoszetow), ja Cie znajde! "+fPrevRange+"->"+fNewRange+" OK\n");    
                else
                    CrashLog("Przegiales ("+nCntRicochets+" rykoszetow), ja Cie znajde! "+fPrevRange+"->"+fNewRange+" FAILED\n");
                //*/
                
                bUpdateEnemies  = false;
                fStateEnterTime = GetTime();
            }
            
            if (cTarget != null)
            {
                //LogD("Enemy is in sight\n");
                UpdateLastKnownEnemyPos(cTarget, false);
                StartEnemyInSightTimers();
                nAttackCause = _ATTACK_CAUSE_SIGHT;
                nTargetPointIdx = 0;
                Attack(cTarget);
            }
            
            

//            ProfileBegin(PROFILE_OnReact);
        }

        void OnMakeDecision()    
        {
            int nFiringPos = MotionState2FiringPos(cMotion, true);

            if (GetTime() - fStateEnterTime < fSearchTime)
            {
                // wylosuj w prawo/lewo
                RandomTwistActions();
                
                // obrot o losowy kat w dana strone
                vDesiredDir = GetForwardVector();
                vDesiredDir.Add( GetPosition() );
                vDesiredDir.Mul( RandomFloat(1.5f)-0.5f ); 
                if (nTwistAction == _ACTION_LOOK_RIGHT) 
                    vDesiredDir.Add(GetRightVector());
                else
                    vDesiredDir.Sub(GetRightVector());
                //vDesiredDir.Add( GetPosition() );
                
                if ( nReadinessToSearch>0 )
                {
                    fWaitTime = 0.3f;
                    PerformQuickTurnTask();
                    NewTask( nTwistAction );
                    NewTask(_ACTION_TAKE_A_RUN);
                    RandomTwistActions();
                    NewTask( nTwistAction );
                    NewTask(_ACTION_WAIT);
                    NewTask(_ACTION_LOOK_FORWARD);
                    NewTask(_ACTION_WAIT);
                    NewTask( nNextTwistAction );
                    NewTask(_ACTION_WAIT);
                    NewTask(_ACTION_LOOK_FORWARD);
                }
                else
                {
                    fWaitTime = 0.2f;
                    PerformQuickTurnTask();
                    NewTask(_ACTION_WAIT);
                }
                
            }
            else // wyjdz ze stanu - nic nie znalazles
            {
                if (!bSearchStaticCanAlterPosition && nReadinessToSearch>0)
                {
                    //trzeba wrocic na miejsce
                    vDesiredPos = vStartPos;
                    PerformQuickGoTask();
                }
                NewTask(_ACTION_CALM_DOWN);
            }
        }
        
        void oldOnMakeDecision()
        {
            int nFiringPos = MotionState2FiringPos(cMotion, true);

            if (GetTime() - fStateEnterTime < fSearchTime)
            {
                // Jesli stoi przodem i wolno mu sie obrocic i bedzie widzial cos z tylu
                // albo stoi tylem i bedzie widzial cos z przodu
                if ((!bIsFacingBackwards && 
                     bSearchStaticLookBack && 
                     (nLookAroundFlags & _LOOK_BACK) != 0) ||
                    (bIsFacingBackwards &&
                     (nLookAroundFlags & _LOOK_FORWARD) != 0))
                {
                    // obrot o ca. 180[deg]
                    vDesiredDir = GetForwardVector();
                    vDesiredDir.Mul(-100); // zwieksz wartosc, zeby dodanie jednostkowego niewiele zmienilo
                    if (CanHappen(50)) // wylosuj w prawo/lewo
                        vDesiredDir.Add(GetRightVector());
                    else
                        vDesiredDir.Sub(GetRightVector());
                    PerformQuickTurnTask();
                    bIsFacingBackwards = !bIsFacingBackwards;
                    
                    // Wylosuj, w ktora strone ma sie teraz obracac AI
                    nNextTwistAction = CanHappen(50) ? _ACTION_LOOK_LEFT : _ACTION_LOOK_RIGHT;
                }
                
                fWaitTime = 0.5f;
                
                NewTask(nNextTwistAction);
                NewTask(_ACTION_WAIT);
                NewTask((nNextTwistAction == _ACTION_LOOK_RIGHT) 
                         ? _ACTION_LOOK_LEFT :_ACTION_LOOK_RIGHT);
                NewTask(_ACTION_WAIT);
                NewTask(_ACTION_WAIT);
                NewTask(_ACTION_LOOK_FORWARD);

            }
            else // wyjdz ze stanu - nic nie znalazles
            {
                if (!bSearchStaticCanAlterDirection)
                {  // trzeba przywrocic kierunek
                    vDesiredDir = vStartDir;
                    PerformQuickTurnTask();
                }
                NewTask(_ACTION_CALM_DOWN);
            }
        }
        
        void OnMakeDecisionEntering()
        {
            int nFiringPos = MotionState2FiringPos(cMotion, true);
            boolean bShouldStand = (nLookAroundFlags & _LOOK_DUCK) == 0;

            fWaitTime = RandomFloat(0.1f);
            if (!bSomebodyIsTryingToKillMe)
            {
                fWaitTime += 1.0f;                    
            }
            NewTask(_ACTION_WAIT);

            switch (nFiringPos)
            {
            case _FIRINGPOS_CRAWL: // podnies sie, bo jak tu sie rozgladac lezac
                if (bShouldStand) // sa niskie przeszkody - wstan
                    NewTask(_ACTION_GET_WALKED);
                else
                    NewTask(_ACTION_GET_DUCKED);
                break;
            case _FIRINGPOS_DUCK:
                if (bShouldStand)
                    NewTask(_ACTION_GET_WALKED);
                break;
            case _FIRINGPOS_STAND:
                if (!bShouldStand)
                    NewTask(_ACTION_GET_DUCKED);
                break;
            }
        
            
            
            // pobiegnijmy najpierw zobaczyc naszego zabitego przyjaciela
            if ( vDeadFriendPos != null && nReadinessToSearch>0 )
            {
                vDesiredPos = vDeadFriendPos;
                vDeadFriendPos = null;
                PerformQuickRunTask();
                CrashLog("RUN_TO_FRIEND\n");
            }
        }

        

        /** Sprawdz w jaki sposob moze sie rozgladac AI (biorac pod uwage przeszkody)
         *  @return suma logiczna wybranych sposrod stalych: _LOOK_FORWARD, _LOOK_BACKWARD, 
         *          _LOOK_DUCK
         */
        int CheckLookAroundType()
        {
            Vector vFwd = GetForwardVector(),
                   vBack = new Vector(vFwd);
            vBack.Negate();
            int nRes = _LOOK_NONE;

            float fEyeHeightDuck = aHeadHeight[_FIRINGPOS_DUCK] - 20,
                  fEyeHeightStand = aHeadHeight[_FIRINGPOS_STAND] - 20;

            /** Sprawdz czy wogole moze patrzec do przodu
             */
            if (!IsThereAnyViewingObstacle(fEyeHeightStand, vFwd))
                nRes |= _LOOK_FORWARD;

            /** Jesli moze sie obrocic - sprawdz, czy moze patrzec do tylu
             */
            if (bSearchStaticLookBack && !IsThereAnyViewingObstacle(fEyeHeightStand, vBack))
                nRes |= _LOOK_BACK;
            
            /** Jesli ma patrzec do przodu a nie moze w ducku albo ma patrzec do tylu a nie moze
             *  w ducku - nic, inaczej - zaznacz, ze duck
             *  UWAGA: spowoduje to, ze AI nie mogace patrzec zza przeszkod kucnie (ale to dobrze, 
             *         bo jak nie moze widziec, to lepiej, zeby jego tez nie widzieli)
             */
            if (!((((nRes & _LOOK_FORWARD) != 0) &&
                  IsThereAnyViewingObstacle(fEyeHeightDuck, vFwd)) ||
                (((nRes & _LOOK_BACK) != 0) &&
                  IsThereAnyViewingObstacle(fEyeHeightDuck, vBack))))
            {
                //nRes |= _LOOK_DUCK; 
            }
            return nRes;                
        }
        

        boolean IsThereAnyViewingObstacle(float fHeight, Vector vDir)
        {
            Vector vStart, vEnd;
            vStart = GetPosition();
            vStart.fY += fHeight;
            vDir.Normalize();
            vDir.Mul(fStaticSearchObstacleDistance);
            vEnd = new Vector(vStart);
            vEnd.Add(vDir);
            Collision cCol = TraceTerrainObjectsAndTreesExcludeMe(vStart, vEnd);
            if (cCol != null)
            {
                // jesli najblizsza przeszkoda nie jest prawdziwa przeszkoda
                if (!(cCol.Obstacle instanceof Pawn ||  // to, zeby mu jakis player albo AI nie przeszkadzalo
                      cCol.Obstacle instanceof FPPHands || // to znow do playera
                      cCol.Obstacle instanceof InvObject // a to np. do guna
                      ))
                    return true;
            }
            return false;
        }
    }
    
    
    public class TestState extends AIBaseState
    {
        public void OnEnter()
        {
            cEnemy = ((ChromeModuleSingle)GetModule()).MainPlayer;
            //EnableTracingEnemyBody();
        }
        
        
        public void OnReact()
        {
        }
        
        
        public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
        {
        }


        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if ((nKeyCode==EKey._K) && (bKeyState))
            {
                NewTask(_ACTION_START_STRAFE_FIRE);
            }
            if ((nKeyCode==EKey._J) && (bKeyState))
            {
                NewTask(_ACTION_STOP_STRAFE_FIRE);
            }
            if ((nKeyCode==EKey._L) && (bKeyState))
            {
                
                EnableTracingEnemyBody();
            }
            if ((nKeyCode==EKey._N) && (bKeyState))
            {
                bTwistCanTurn = false;
                SetWalkTrackedObject(cEnemy);
                fAISightRange2 = 1.f;
                SetState("Patrol");
            }
        }
    }
    
    /** Sprawdza, czy mozna wlaczyc jakiegos idlowego taska
     */
    boolean IdleTaskAvailable()
    {
        // minimum 5 minut od SearchStatic
        return ((GetTime() - fSearchStaticLastTime) > 150.0f);
    }
	
	void SendTeamMessage()
	{
		if (!bDead)
		{
			//LogLine("Wysylam komunikat:" + this);
			m_TeamsManager.SendTeamMessage(this, nTeamID, TeamsManager._ATTACK_PLAYER);
		}
	}
	
	void GotMessage(int nMessageID)
	{
		super.GotMessage(nMessageID);
		
		if (bDead)
			return;
		
		if (nMessageID == TeamsManager._ATTACK_PLAYER)
		{
			//LogLine("Dostalem komunikat:" + this);
			fAISightRange = 8000f;
			fAISightRange2 = fAISightRange * fAISightRange;
			fAISightAngle = 110f;
	        fAISightAngleCos = (float) Math.cos(fAISightAngle * 0.5f * Math.PI / 180f);
			
/*			if (CurrentState instanceof AIAttacker.Attack ||
				CurrentState instanceof AIAttacker.PatrolAttack)
				return; // juz atakujemy
			Attack( ((ChromeModuleSingle)GetModule()).MainPlayer );
*/			
		}
	}
}

class ExtremeValues
{
    static float fLeftDist=0.0f;
    static float fRightDist=0.0f;
    
    private static Vector vPos = null;
    private static Vector vRight = null;
    
    // wyliczenie rzutu na prosta prostopadla do kierunku
    private static void CalcDot(Vector vVert)
    {
        vVert.Sub(vPos);
        float fDot = vVert.Dot(vRight);
        if(fDot>0.0f)
        {
            if(fDot > fLeftDist) fLeftDist = fDot;
        }
        else
        {
            if(fDot < fRightDist) fRightDist = fDot;
        }
    }
    
    static void Calculate(MeshObject cObstacle, Vector pos, Vector right)
    {
        // zapisanie wewnetrznych zmiennych
        vPos = pos;
        vRight = right;
        
        // pobranie extentow
        Vector vMin = new Vector();
        Vector vMax = new Vector();
        cObstacle.GetMeshExtents(vMin, vMax);
        vMin=cObstacle.PointLocalToWorld(vMin);
        vMax=cObstacle.PointLocalToWorld(vMax);
        
        //
        fLeftDist = 0;
        fRightDist = 0;
        
        // rzutujemy wszystkie wierzcholki na os
        Vector vVert = new Vector();
        
        // wszystkie wierzcholki
        vVert.Set(vMin.fX, vMin.fY, vMin.fZ); CalcDot(vVert);
        vVert.Set(vMax.fX, vMax.fY, vMax.fZ); CalcDot(vVert);
        
        vVert.Set(vMin.fX, vMax.fY, vMin.fZ); CalcDot(vVert);
        vVert.Set(vMin.fX, vMax.fY, vMin.fZ); CalcDot(vVert);
        vVert.Set(vMax.fX, vMax.fY, vMin.fZ); CalcDot(vVert);
        
        vVert.Set(vMin.fX, vMin.fY, vMax.fZ); CalcDot(vVert);
        vVert.Set(vMax.fX, vMin.fY, vMax.fZ); CalcDot(vVert);
        vVert.Set(vMin.fX, vMax.fY, vMax.fZ); CalcDot(vVert);
        
        // teraz juz mamy wynik w dwoch zmiennych
    }
}
