import java.util.*;
import java.io.*;

/** Bazowa klasa AI. Obsluguje odpalanie animacji AI oraz podstawowe funkcjonalnosci.
 */
public class AIBase extends Pawn
{
	/** przyczyny freezowania ai */
	static int _FREEZE_MOVIE = 1;
	static int _FREEZE_PORTAL = 2;
	static int _FREEZE_ADVENTURE = 4;
	
	/** flaga przyczyn zfreezowania */
	int m_nFreezeCause = 0;
	
	/** menager komunikacji pomiedzy ai w teamach */
	static TeamsManager m_TeamsManager = new TeamsManager();
	
	/** czas, po jakim ai powiadomi kolegow z teamu o wrogu (chyba, ze zostanie
	 * szybciej zabite) */
	static float _TIME_TO_SEND_MESSAGE = 1f;
	
	/** wysokosc, ponizej ktorej AI ginie */
	static float _DYING_LEVEL = -3200f;
	
    /** Do testow!!!
     */
    public boolean bUseNewModel = true;//#AI - TEST

    
    //parametry kolidujacej elipsoidy
    //(still, swim, crawl, duck, walk, run)
    float fEllipsoidPos[] = {.0f, 20.0f/*swim*/,20.0f, 65.0f, 84.972f, 84.972f};
    float fEllipsoidHeight[] = {.0f, 20.0f*2/*swim*/,20.0f*2, 65.0f*2, 84.972f*2, 84.972f*2};
    float fEllipsoidRadius[] = {.0f, 39.7f/*swim*/,39.7f, 39.7f, 39.7f, 39.7f};

    // zwiekszenie energii AI by MK, bylo 100
    public float fStartHealth = 100.f;//#AI


    AIBase()
    {
        //bIsNameSprVisible = true;
        ActiveElement      = "Bip01 Spine1";
    }

    /////////////////////////////////////////////////////////////////////
    // INVENTORY AI
    // 

    /** Przedmioty, ktore moze posiadac kazde AI
     *  Skladnia: nazwy przedmiotow oddzielone sa przecinkami, 
     *  przedmioty tworzace grupe (np fajki i zapalki) laczone sa przez '+' lub ' '
     *  Przed grupa moze znajdowac poprzedzony znakiem '%' procentowe 
     *  prawdopodobienstwo, ze przedmiot bedzie wrzucany do inventory 
     *  (domyslnie - nDefaultItemProbability [%])
     *  np sItems = "%5 dziurawa_gumowa_lala + pompka, %80 mlotek"
     *  UWAGA: moze sie zdarzyc, ze ktorys z przedmiotow tworzacych grupe 
     *         nie zmiesci sie do inventory
     */
    public String sDefaultItems = "%2 Radio, %70 DrugHealthex, %60 WeaponGrenade, %60 WeaponGrenade";
    
    /** Domyslne prawdopodobienstwo wrzucania itema z sDefaultItems do 
     *  inventory [%]
     */
    public int nDefaultItemProbability = 50; //#AI
    
    /** Przedmioty, ktore beda wrzucane do inventory konkretnego AI
     *  (instancji) - nazwy oddzielone przecinkami
     */
    public String sItems = "Ammo8mmLong, Ammo8mmLong"; //#AI
    
    
    /** Minimalny czas pomiedzy zakonczeniem akcji a podjeciem nastepnej.
     * Mozna to traktowac jako minimalny czas myslenia. Odstep czasu w jakim mysli AI
     * bedzie losowany z przedzialy (fMinThinkingTime, fMaxThinkingTime)
     */
    public float fMinThinkingTime = 0.05f; //#AI
    
    /** Maxymalny czas pomiedzy zakonczeniem akcji a podjeciem nastepnej.
     * Mozna to traktowac jako maxymaly czas myslenia. Odstep czasu w jakim mysli AI
     * bedzie losowany z przedzialy (fMinThinkingTime, fMaxThinkingTime)
     */
    public float fMaxThinkingTime = 0.3f; //#AI
    
    /** Predkosc z jaka AI sie obraca */
    public float fAngSpeed = 180.0f;//#AI

    
    /** Czas co jaki mysli AI, a dokladniej zmienia decyzje co robic */
    public float fUpdateTime    = 0.3f;

    
    /** Kat widzenia AI: 0-180 [deg] */
	//#DEF_BEGIN
    public float fAISightAngle = 110.0f;//#AI
	//#DEF_END
    /** Cosinus kata widzenia liczony w OnCreate */
    float fAISightAngleCos;
    
    /** Odleglosc na jaka widzi AI */
    //#DEF_BEGIN
    public float fAISightRange = 8000.0f;//#AI
    //#DEF_END
    /** Kwadrat zasiegu widzenia AI liczony w OnCreate */
    float fAISightRange2;
    
    /** Wspolczynniki modyfikujace kwadrat zakresu widzenia przeciwnika w zaleznosci 
     *  od jego pozycji - MotionState.iSpeed SPEED_* (STILL, SWIM, CRAWL, DUCK, WALK, RUN, SWIM) */
    float aAISightRange2Modifier[] = { 1.f, 0.5f/*swim*/, 0.5f, 0.7f, 1.f, 1.f, 0.5f };

    /** Znacznik, ze mozliwe jest uzycie wizualizacji zasiegu widzenia
     *  (Powoduje generowanie wachlarza z trojkatow (nie renderuja sie)
     *   i wolanie na timehandlerze UpdateSightRangeVis !!!)
     *  Wartosc brana pod uwage na starcie AI 
     */
    boolean bAllowSightRangeVisualisation = false;
    
    /** Znacznik, ze renderuje sie wachlarz trojkatow od wizualizacji zasiegu widzenia
     *  (moze byc zmieniane dynamicznie, ale dziala tylko, gdy bAllowSightRangeVisualisation = true)
     */
    boolean bSightRangeVisualization = false;
    
    
    //////////////////////////////////////////////////////////////
    // Obliczanie, czy AI odpowiednio dlugo widzialo przeciwnika

    /** Znacznik uzywania mechanizmu calkowania probek widocznosci przeciwnika
     */
    public boolean bUseSightSamplesIntegration = false;//#AI
    
    /** Maksymalny czas probkowania (dla przeciwnika w odleglosci fAISightRange)
     *  [s]
     */
    public float fMaxSightSamplingTime = 3.f;//#AI
    
    /** Jaki ma byc minimalny stosunek probek widzial/nie widzial zeby uznac, 
     *  ze przeciwnik jest widoczny
     */
    public float fInSightNecessaryRatio = 0.5f;//#AI

    boolean aSightSample[] = null;
    int nStartSightSample = 0,
        nEndSightSample = 0,
        nSightSamples = 0,
        nMaxSightSamples = 0,
        nIsInSightSamples = 0;
    
    /** Odleglosc, ponizej ktorej AI wyczuwa przeciwnika, nawet jak jest z tylu [cm] */
    public float f6thSenseRange = 200.f;
    /** Kwadrat f6thSenseRange liczony w OnCreate */
    public float f6thSenseRange2;
    
    /** Tablica z dzwiekami smierci AI */
    String[] aDieSounds = { "Data/Sounds/Ai/krzyk 01",
                            /*"Data/Sounds/Ai/krzyk 03",misio*/
                            "Data/Sounds/Ai/krzyk 04",
                            "Data/Sounds/Ai/krzyk 05",
                            "Data/Sounds/Ai/krzyk 07",
                            "Data/Sounds/Ai/krzyk 08",
                            "Data/Sounds/Ai/krzyk 09"
    };
    
    /** Flaga trybu snajpera
     */
    boolean bSniperMode = false;
    //------------------------------------------------------------------------------------------

    ///////////////////////////////////////////////////////////////////////
    // Krzyczenie AI (MakeNoise)

    /** Rodzaje okrzykow */
    final static int _SCREAMTYPE_UNKNOWN            = 0;
    final static int _SCREAMTYPE_PAIN               = 1;
    final static int _SCREAMTYPE_DEATH              = 2;
    final static int _SCREAMTYPE_BACKUP_CALL        = 3;
    // added by MK, AI jak uslyszy rykoszet to mowi o tym innym
    final static int _SCREAMTYPE_ONRICOCHETNOISE    = 4;
    
    /** Tablica zasiegow slyszalnosci krzykow _SCREAMYPE_* (UNKNOWN, PAIN, DEATH, BACKUP_CALL)
     */
    public float aScreamNoiseLoudness[] = { 0, 10000.f, 5000.f, 10000.f, 2500.0f };

    /** Tablica prawdopodobienstwa [%] wydania okreslonego krzyku (UNKNOWN, PAIN, DEATH, BACKUP_CALL, ONHEARNOISE)
     */
    public int aScreamNoiseChance[] = { 0, 30, 100, 100, 100 };
    
    /** Typ ostatnio wydanego okrzyku */
    int nLastScreamType = _SCREAMTYPE_UNKNOWN;
    
    ///////////////////////////////////////////////////////////////////////
    
    /** Czas po jakim AI ma pomyslec */
    float fThinkingTime = 0.0f;
       
    /** Czas potrzebny AI do zebrania sie po postrzale (mnozony przez
     * wartosc GetDamageMultiplier() = 0.6-3.0) [s]*/
    public float fRecoverTime = 0.1f; // przywrocone, bo animacja ma 1 klatke
    

    /** Obecny czas zbierania sie po ostatnim postrzale */
    float fCurrentRecoverTime = 0.f;
    
    /** Stan poruszania sie AI na podstawie ktorego ustalane jest jakie animacje odpalac. */
    public MotionState cMotion = new MotionState();
    
    /** Stary stan poruszania do ustalania zmiany animacji */
    MotionState cOldMotion = new MotionState();

    /** Nazwa biezacego stanu AI */
    String sCurrentState    = "";
    
    /** Nazwa poprzedniego stanu AI */
    String sLastState        = "";

    /** Czas przejscia miedzy trybami chodzenia AI tzn. WALK to DUCK.
     */
    float fChanginModeInterval = 0.3f;
    
    /** Czas potrzebny na przycelowanie
     */
    float fChanginModeShortInterval = 0.25f;
    
    /** Czas potrzebny, zeby sie polozyc/wstac
     */                                    
    float fChanginModeLongInterval = 0.7f;

    // identyfikatory dummiesow do ustawiania broni
    int nLeftHandID = -1;
    int nRightHandID = -1;
    
    
    
    /////////////////////////////////////////
    // DEFORMACJE I OBROTY
    //

    final static int _TWIST_TYPE_NONE           = 0;
    final static int _TWIST_TYPE_HEAD_ONLY      = 1;
    final static int _TWIST_TYPE_HEAD_USE_TORSO = 2;
    final static int _TWIST_TYPE_TORSO          = 3;
    
    /** Minimalny kat skretu ciala w poziomie (prawo) [deg] */
    public float fTwistHorizMin = -60.f;
    /** Maksymalny kat skretu ciala w poziomie (lewo) [deg] */
    public float fTwistHorizMax = 60.f;
    /** Minimalny kat skretu ciala w pionie (dol) [deg] */
    public float fTwistVertMin = -30.f;
    /** Maksymalny kat skretu ciala w pionie (gora) [deg] */
    public float fTwistVertMax = 30.f;
    
    /** O ile razy wieksze katy sa dozwolone przy deformacji z nacelowaniem glowy */
    public float fHeadTwistFactor = 1.5f;
    /** Wspolczynnik o jaki modyfikowane sa zakresy twist'a przy duckowaniu 
     *  gdy skrecany jest kregoslup */
    public float fDuckTorsoTwistFactor = 0.5f;
    
        
    //  Pomocnicze wektory - osie obrotu kosci
    final static Vector vAlongXAxis = new Vector(1,0,0);
    final static Vector vAlongYAxis = new Vector(0,1,0);

    
    // Zapamietana wartosc czasu blendingu
    protected float fOldAnimMorphTime = 0;


    //-------------------------------------------

    final static int _ACTION_IDLE_ANIM          = 1;
    final static int _ACTION_IDLE_HEAD          = 2;
    final static int _ACTION_THINK              = 3;
    final static int _ACTION_AIMING_ON          = 4;
    final static int _ACTION_AIMING_OFF         = 5;
    final static int _ACTION_GET_DUCKED         = 6;
    final static int _ACTION_GET_WALKED         = 7;
    final static int _ACTION_GET_CRAWLED        = 8;
    final static int _ACTION_CHANGE_MOTION      = 9;
    final static int _ACTION_IDLE_SMOKE_START   = 10;
    final static int _ACTION_IDLE_SMOKE_LOOP    = 11;
    final static int _ACTION_IDLE_SMOKE_END     = 12;
    final static int _ACTION_IDLE_TALK          = 13;
    final static int _ACTION_WAIT_FOR_RECOVER   = 14;
    final static int _ACTION_BOX_SMOKE_START    = 15;
    final static int _ACTION_BOX_SMOKE_LOOP     = 16;
    final static int _ACTION_BOX_SMOKE_END      = 17;
    final static int _ACTION_BOX_LEAVE          = 18;

    //-------------------------------------------
    
    /** Identyfikatory metod wolanych poprzez CallMethodIn
     */
    int METHOD_OnMakeDecisionEntering   = 0;
    int METHOD_OnMakeDecision           = 0;
    int METHOD_UpdateMotion             = 0;
//    int METHOD_Run                      = 0;
    int METHOD_OnChangeMotionType       = 0;
    int METHOD_EndOfIdleHead            = 0;
    int METHOD_UpdateTrackings          = 0;
    int METHOD_WaitForRecoverDone       = 0;
    int METHOD_StepDone                 = 0;
    int METHOD_OnReact                  = 0;
    int METHOD_AnimationTaskFinished    = 0;
    int METHOD_PerformAnimTaskSmokeDo   = 0;
    
    //------------------------------------------------------------------------------------------
    String ROOT_BONE                 = "Bip01";
    /**Nazwa kosci zaczynajacej hierarchie torsu.
     * <br>Dla niej uruchamiane sa animacje dla gory ciala.
     */
    String TORSO_BONE                = "Bip01 Spine";
    
    /** Identyfikatory kosci w obrebie MeshObjectu
     */
    int nRootElementID = 0;
    int nTorsoElementID = 0;
    
    ////////////////////////////////////////////////////
    // Zapamietane parametry do respawnowania
    Vector vRespawnPos;
    Vector vRespawnDir;

    /**Indeksy do tablicy animacji
     */
    static byte A_STAND           = 0;
    static byte A_FORWARD         = 1;
    static byte A_BACKWARD        = 2;
    static byte A_STRAFE_LEFT     = 4;
    static byte A_STRAFE_RIGHT    = 5;
    static byte A_JUMP            = 6;
    static byte A_JUMP_FORWARD    = 7;
    static byte A_BUTT_HIT        = 8;

    static byte A_CRAWL2DUCK        = 9;
    static byte A_CRAWL2STAND       = 10;
    static byte A_DUCK2CRAWL        = 11;
    static byte A_STAND2CRAWL       = 12;

    static byte A_DIE               = 13; //TEMP

    //tylko bez broni, cale cialo:
    static byte A_KICK              = 14;
    static byte A_PUNCH             = 15;

    //kazda bron, tylko gora:
    static byte A_WEA_FIRE          = 10;
    static byte A_WEA_RELOAD        = 11;
    static byte A_WEA_GET           = 16;
    static byte A_WEA_PUTAWAY       = 17;
    
    static byte A_TAKE_HIT          = 18;
    
    static byte A_IDLE_SMOKE_START  = 19;
    static byte A_IDLE_SMOKE_LOOP   = 20;
    static byte A_IDLE_SMOKE_END    = 21;
    static byte A_IDLE_1            = 22;
    static byte A_IDLE_2            = 23;
    static byte A_IDLE_3            = 24;
    static byte A_IDLE_KEYBOARD     = 25;
    static byte A_IDLE_TALK         = 26;
    static byte A_IDLE_BOX          = 27;
    static byte A_IDLE_BOX_SMOKE_START = 28;
    static byte A_IDLE_BOX_SMOKE_LOOP  = 29;
    static byte A_IDLE_BOX_SMOKE_END   = 30;
    static byte A_IDLE_BOX_END      = 31;

    static byte A_ROTATE_LEFT       = 32;
    static byte A_ROTATE_RIGHT      = 33;
    
    static byte A_BACK_ROTATE_LEFT  = 34;
    static byte A_BACK_ROTATE_RIGHT = 35;
    
    public int Anims[] = new int[36];
    
    
    ///////////////////////////////////////////////////////////////////
    // Animacje posiadane przez AI
    //
    boolean bCanUseHandsAnims     = false;
    boolean bCanUsePistolAnims    = false;
    boolean bCanUseRifleAnims     = false;
    
    
    /** Czasu blendowania dla animacji
     */
    /** Czas blendowania np. przy postrzale albo szybkim obrocie
     */
    public float fFastAnimMorphTime     = 0.05f;
    /** Czas blendowania dla normalnych animacji
     */
    public float fNormalAnimMorphTime   = 0.15f;
    /** Czas belndowania dla animacji w stanie Idle
     */
    public float fSlowAnimMorphTime     = 0.55f;
        
    //public String aStandAnimName[] = { "Stand01", "Stand02" };
    
    //int aStandAnimID[] = new int[aStandAnimName.length];
    
    //int nCurrentStandAnimIdx = 0;
    
    
    ////////////////////////////////////////////////////////////
    // MINISTER ZDROWIA OSTRZEGA....

    /** Znacznik, ze to AI moze palic papierosa */
    boolean bCanSmoke = true;
    
    /** Minimalna ilosc 'machow' przy paleniu papierosa */
    int nCigaretteSmokeCount = 3;
    /** Losowy modyfikator dla nCigaretteSmokeCount */    
    int nRandomCigaretteSmokeCount = 10;
    
    /** Minimalna przerwa miedzy papierosami [s] */
    float fNoSmokingTime = 5.f;
    /** Losowy modyfikator dla fNoSmokingTime [s] */
    float fRandomNoSmokingTime = 30.f;

    
    /** Czas od rozpoczecia palenia papierosa do jego pokazania po wyciagnieciu */
    float fCigaretteShowTime = 0.4f;
        
    /** Czas od poczatku operacji wyrzucania papierosa do jego znikniecia */                              
    float fCigaretteHideTime = 1.f;
                              

    /** Mesh z pojedynczym papierosem */
    String sCigaretteMeshName = "Data/Meshes/Equipment/Fajka.3da";
    
    /** [pomocnicza] Zapamietany czas zakonczenia palenia ostatniego papierosa */
    float fLastSmokeTime = 0;
    
    /** [pomocnicza] Obiekt papierosa trzymanego w rece */
    MeshObject cCigarette = null;
    
    ////////////////////////////////////////////////////////////
    // Siedzenie na beczce
    
    /* Znacznik, ze jest to AI siedzace na beczce */
    public boolean bStartInSittingPose = false;//#AI
    
    /* Znacznik, ze AI aktualnie siedzi */
    boolean bIsSittingBull;
    

	/** czy wlaczone jest sprawdzanie,  */
	boolean bTrackingHeight = false;

    
    
    ///////////////////////////////////////////////////////////////////
    // PROFILING
    //
/*    String sAIProfilingPage = "AI Profiling";

    static int PROFILE_UpdateTrackings = 0;
    static int PROFILE_UpdateMotion = 0;
    static int PROFILE_SetupAnims = 0;
    static int PROFILE_BodyDeformStrafe = 0;
*/    
    //------------------------------------------------------------------------------------------

	boolean m_bAIActive = true;
	
	/** jezeli ta flaga jest ustawiona, to ai beda aktywowaly sie przez ActivateOnModuleGridIndependent() */
	boolean m_bActivateGridIndependent = false;

    /** Znikniecie i zablokowanie AI
     */
    public void ActivateAI(boolean bActivate, int nFreezeCause)    
    {
        if (bActivate)
        {
            UnfreezeAI(nFreezeCause);
			
			if ( (!IsFrozen()) || (m_nFreezeCause == _FREEZE_MOVIE) )
			{
				if (m_bActivateGridIndependent)
					ActivateOnModuleGridIndependent();
				else
				    ActivateOnModule();
				EnableRendering(true);
				
                if (!IsFrozen())
				    m_bAIActive = true;
			}
        }
        else
        {
            FreezeAI(nFreezeCause);
			
	        EnableRendering(false);
			if (m_bActivateGridIndependent)
				DeactivateOnModuleAlways();
			else
		        DeactivateOnModule();

			m_bAIActive = false;
			
			if (cCigarette != null)
                cCigarette.EnableRendering(false);
        }
    }

	/** czy po przywroceniu AI ma byc aktywne, czy nie */
	boolean m_bAIAfterRestoreActive = false;
	
	/** wlacza / wylacza (logike i rendering) AI znajdujace sie na zewnatrz
	 */ 
	public void SwitchOutdoorAI(boolean bEnableOutdoorAI)
	{
		// jezeli AI jest na zewnatrz
		if (GetParent() == null)
		{
			if (bEnableOutdoorAI)
				ActivateAI(true, AIBase._FREEZE_PORTAL);
			else
				ActivateAI(false, AIBase._FREEZE_PORTAL);
		}
	}
    
    boolean bPhysicsActiveBeforeFreeze = false;    

	boolean IsFrozen()
	{
		return (m_nFreezeCause != 0);
	}
	
	boolean IsFrozen(int nFreezeCause)
	{
		return ((m_nFreezeCause & nFreezeCause) != 0);
	}
	
    public void FreezeAI(int nFreezeCause)
    {
		// AI jest juz frozen z tej przyczyny
		if ( IsFrozen(nFreezeCause) )
			return;
		
		if (!IsFrozen())
		{
			// czy fizyka byla wlaczona przed freeze
	        bPhysicsActiveBeforeFreeze = GetPhysicsActive();
			FreezeCallMethods();
			SetPhysicsActive(false);
			StopAnim("");
		}
		
		m_nFreezeCause |= nFreezeCause;
    }

    public void UnfreezeAI(int nFreezeCause)
    {
		if ( !IsFrozen(nFreezeCause) )
			return; // jezeli nie jest freeze z tej przyczyny, to nie ma co robic unfreeze
		
		m_nFreezeCause &= (~nFreezeCause);
		
		if ( !IsFrozen() )
		{
			UnfreezeCallMethods();
			SetPhysicsActive(bPhysicsActiveBeforeFreeze);
			StartAnim("");
			UpdateMotion();
		}
    }

    
    
    /** Metoda tworzy identyfikator animacji przy podanych warunkach
     */
    int BuildSeqID(int nWeaponType, int iSpeed, int nMagic, int nPumpAction)
    {
		// HAK, bo animacje dla STILL i WALK sa takie same a maja rozne ID
		if (iSpeed == MotionState.SPEED_STILL)
			iSpeed = MotionState.SPEED_WALK;
        return (nWeaponType << 6) | (iSpeed << 9) | (nMagic << 12) | (nPumpAction << 13);
    }
    
    
    
    void UpdateAvailableAnims()
    {
        bCanUseHandsAnims = (GetAnimID(ROOT_BONE, "Nwn") > 0);
        bCanUsePistolAnims = (GetAnimID(ROOT_BONE, "Pwn") > 0);
        bCanUseRifleAnims = (GetAnimID(ROOT_BONE, "Rwn") > 0);
    }
    

    /** Definiowanie zbioru animacji dla AI.
	 */
	void DefineAnimationSet()
	{
        if (fAnimSpeedUp > 0) //zeby mozna bylo to wylaczyc
            SetAnimFreq("", 30.0f * fAnimSpeedUp);
        SetAnimMorphTime(fNormalAnimMorphTime);
        
        nRootElementID = GetElementID(ROOT_BONE);
        nTorsoElementID = GetElementID(TORSO_BONE);
        
        if (bUseNewModel)
        {
            // ustaw znaczniki o dostepnosci animacji
            UpdateAvailableAnims();
            
            // ustawienie animacji, ktore sie nigdy nie zmieniaja
            Anims[A_KICK]               = GetAnimID(ROOT_BONE, "Rk");
            Anims[A_PUNCH]              = GetAnimID(ROOT_BONE, "Rb");
            
            Anims[A_DIE]                = GetAnimID(ROOT_BONE, "death_front"); 
            
            // animacje idle
            Anims[A_IDLE_3]             = GetAnimID(ROOT_BONE, "gapi_sie_w_niebo");
            Anims[A_IDLE_SMOKE_START]   = GetAnimID(ROOT_BONE, "fajka_odpala");
            Anims[A_IDLE_SMOKE_LOOP]    = GetAnimID(ROOT_BONE, "fajka_loop");
            Anims[A_IDLE_SMOKE_END]     = GetAnimID(ROOT_BONE, "fajka_wyrzuca");
            Anims[A_IDLE_1]             = GetAnimID(ROOT_BONE, "przeciaga_sie");
            Anims[A_IDLE_2]             = GetAnimID(ROOT_BONE, "majstruje_przy_zamku_loop");
            Anims[A_IDLE_KEYBOARD]      = GetAnimID(ROOT_BONE, "klepie_w_klawiature_loop");
            Anims[A_IDLE_TALK]          = GetAnimID(ROOT_BONE, "gadka_loop");
            Anims[A_IDLE_BOX]           = GetAnimID(ROOT_BONE, "sk_rozglada_sie_loop");
            Anims[A_IDLE_BOX_SMOKE_START]   = GetAnimID(ROOT_BONE, "sk_zapala");
            Anims[A_IDLE_BOX_SMOKE_LOOP]    = GetAnimID(ROOT_BONE, "sk_pali_loop");
            Anims[A_IDLE_BOX_SMOKE_END]     = GetAnimID(ROOT_BONE, "sk_wyrzuca");
            Anims[A_IDLE_BOX_END]       = GetAnimID(ROOT_BONE, "sk_zeskakuje");
        }
        else
        {
            // ustawienie animacji, ktore sie nigdy nie zmieniaja
            Anims[A_KICK]               = GetAnimID(ROOT_BONE, "kick");
            Anims[A_PUNCH]              = GetAnimID(ROOT_BONE, "punch");
            
            // dodatkowo, zeby zobaczyc co sie dzieje
            Anims[A_DIE]                = GetAnimID(ROOT_BONE, "death_front"); 
            
            // animacje idle
            Anims[A_IDLE_3]             = GetAnimID(ROOT_BONE, "Idle01");
            Anims[A_IDLE_SMOKE_START]   = GetAnimID(ROOT_BONE, "Idle02a");
            Anims[A_IDLE_SMOKE_LOOP]    = GetAnimID(ROOT_BONE, "Idle02b");
            Anims[A_IDLE_SMOKE_END]     = GetAnimID(ROOT_BONE, "Idle02c");
            Anims[A_IDLE_1]             = GetAnimID(ROOT_BONE, "Idle03");
            Anims[A_IDLE_2]             = GetAnimID(ROOT_BONE, "Idle04");
            Anims[A_IDLE_KEYBOARD]      = GetAnimID(ROOT_BONE, "Idle05");
            Anims[A_IDLE_TALK]          = GetAnimID(ROOT_BONE, "Idle06");
            Anims[A_IDLE_BOX]           = GetAnimID(ROOT_BONE, "Idle07");
            Anims[A_IDLE_BOX_SMOKE_START]   = GetAnimID(ROOT_BONE, "Idle08a");
            Anims[A_IDLE_BOX_SMOKE_LOOP]    = GetAnimID(ROOT_BONE, "Idle08b");
            Anims[A_IDLE_BOX_SMOKE_END]     = GetAnimID(ROOT_BONE, "Idle08c");
            Anims[A_IDLE_BOX_END]       = GetAnimID(ROOT_BONE, "Idle09");
        }
        
        // ustawienie flag, ktore mowia w jaki sposob beda animowane kosci
        SetAnimType( EBones._HEAD, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false );
        SetAnimType( EBones._NECK, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false );
        SetAnimType( EBones._SPINE, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        SetAnimType( EBones._SPINE1, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        SetAnimType( EBones._PELVIS, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
/*        
        for (int i=0; i<aStandAnimName.length; i++)
        {
            String sName = aStandAnimName[i];
            aStandAnimID[i] = GetAnimID(ROOT_BONE, aStandAnimName[i]);
        SetAnimFreq(sName, 15.f);
        }
        */
        //----------------------------------------------------------------------
        
        int nUserID = 0;
        int nWeaponType = 0;
/* DEL
        if (bUseNewModel)
        {
            nWeaponType = EWeaponType._RIFLE;
            String prefix = "R";
            nUserID = BuildSeqID(nWeaponType, 0,0,0);
            SetUserSeqID( prefix+"b", A_BUTT_HIT + nUserID );
            SetUserSeqID( prefix+"c2d", A_CRAWL2DUCK + nUserID);
            SetUserSeqID( prefix+"c2s", A_CRAWL2STAND + nUserID);
            SetUserSeqID( prefix+"d2c", A_DUCK2CRAWL + nUserID);
            SetUserSeqID( prefix+"s2c", A_STAND2CRAWL + nUserID);
            int nSpeed = 0;
            for(nSpeed = MotionState.SPEED_STILL; nSpeed <= MotionState.SPEED_RUN; nSpeed++)
            {
                String prefix1 = new String(prefix);
                
                switch (nSpeed)
                {
                case MotionState.SPEED_RUN : prefix1 += "r"; break;
                case MotionState.SPEED_WALK : prefix1 += "w"; break;
                case MotionState.SPEED_DUCK : prefix1 += "d"; break;
                case MotionState.SPEED_CRAWL : prefix1 += "c"; break;
                case MotionState.SPEED_STILL : prefix1 += "w"; break;
                default: ;
                }

                nUserID = BuildSeqID(nWeaponType, nSpeed,0,0);
                SetUserSeqID( prefix1+"j", A_JUMP + nUserID);
                SetUserSeqID( prefix1+"jf", A_JUMP_FORWARD + nUserID);
                SetUserSeqID( prefix1+"re_2", A_WEA_RELOAD + nUserID);
                SetUserSeqID( prefix1+"g", A_WEA_GET + nUserID);
                SetUserSeqID( prefix1+"p", A_WEA_PUTAWAY + nUserID);
                
                int nMagic = 0;
                for(nMagic = 0; nMagic <= 1; nMagic++)
                {
                    String prefix2 = new String(prefix1);
                    
                    if (nMagic==0)
                        prefix2 += "a";
                    else
                        prefix2 += "n";

                    nUserID = BuildSeqID(nWeaponType, nSpeed,nMagic,0);
                    SetUserSeqID( prefix2+"s", A_STAND + nUserID);
                    SetUserSeqID( prefix2+"", A_FORWARD + nUserID);
                    SetUserSeqID( prefix2+"b", A_BACKWARD + nUserID);
                    SetUserSeqID( prefix2+"sl", A_STRAFE_LEFT + nUserID);
                    SetUserSeqID( prefix2+"sr", A_STRAFE_RIGHT + nUserID);
                    SetUserSeqID( prefix2+"rl", A_ROTATE_LEFT + nUserID);
                    SetUserSeqID( prefix2+"rr", A_ROTATE_RIGHT + nUserID);
                    SetUserSeqID( prefix2+"sh_f", A_TAKE_HIT + nUserID);
//                    SetUserSeqID( prefix2+"re_1", A_TAKE_HIT + nUserID);  //TMP: dopoki nie ma morphingu dla 1klatkowych animacji
                    SetUserSeqID( prefix2+"rlb", A_BACK_ROTATE_LEFT + nUserID);
                    SetUserSeqID( prefix2+"rrb", A_BACK_ROTATE_RIGHT + nUserID);

                    int nPumpAction = 0;
                    for(nPumpAction = 0; nPumpAction <= 1; nPumpAction++)
                    {
                        String prefix3 = new String(prefix2);
                        
                        if ( nPumpAction==0 )
                            SetUserSeqID(prefix3+"fS", A_WEA_FIRE + BuildSeqID(nWeaponType, nSpeed, nMagic,nPumpAction) );
                        else
                            SetUserSeqID(prefix3+"f", A_WEA_FIRE + BuildSeqID(nWeaponType, nSpeed, nMagic,nPumpAction) );
                    }
                }
            }

        }
        else
        {
*/
        
            for(nWeaponType = EWeaponType._HAND; nWeaponType <= EWeaponType._GRENADE; nWeaponType++)
            {
                if (bUseNewModel)
                {
                    // Wywal przebiegi od brakujacych animacji
                    if ((!bCanUseHandsAnims && (nWeaponType == EWeaponType._HAND)) ||
                        (!bCanUsePistolAnims && (nWeaponType == EWeaponType._PISTOL)) ||
                        (!bCanUseRifleAnims && (nWeaponType == EWeaponType._RIFLE)))
                        continue;
                }
                
                String prefix = "";
                
                switch (nWeaponType)
                {
                case EWeaponType._HAND      : prefix = "N"; break;
                case EWeaponType._KNIFE     : prefix = "K"; break;
                case EWeaponType._PISTOL    : prefix = "P"; break;
                case EWeaponType._RIFLE     : prefix = "R"; break;
                case EWeaponType._HEAVY     : prefix = "H"; break;
                case EWeaponType._GRENADE   : prefix = "G"; break;
                }

                nUserID = BuildSeqID(nWeaponType, 0,0,0);
                SetUserSeqID( prefix+"b", A_BUTT_HIT + nUserID );
                SetUserSeqID( prefix+"c2d", A_CRAWL2DUCK + nUserID);
                SetUserSeqID( prefix+"c2s", A_CRAWL2STAND + nUserID);
                SetUserSeqID( prefix+"d2c", A_DUCK2CRAWL + nUserID);
                SetUserSeqID( prefix+"s2c", A_STAND2CRAWL + nUserID);
                
                int nSpeed = 0;
                for(nSpeed = MotionState.SPEED_STILL; nSpeed <= MotionState.SPEED_RUN; nSpeed++)
                {
                    String prefix1 = new String(prefix);
                    
                    switch (nSpeed)
                    {
                    case MotionState.SPEED_RUN : prefix1 += "r"; break;
                    case MotionState.SPEED_WALK : prefix1 += "w"; break;
                    case MotionState.SPEED_DUCK : prefix1 += "d"; break;
                    case MotionState.SPEED_CRAWL : prefix1 += "c"; break;
                    case MotionState.SPEED_STILL : prefix1 += "w"; break;
                    default: ;
                    }
                    /*
                    Anims[A_JUMP]               = GetAnimID(ROOT_BONE, prefix1+"j");
                    Anims[A_JUMP_FORWARD]       = GetAnimID(ROOT_BONE, prefix1+"jf");
                    Anims[A_WEA_RELOAD]         = GetAnimID(TORSO_BONE, prefix1+"re");
                    Anims[A_WEA_GET]            = GetAnimID(TORSO_BONE, prefix1+"g");
                    Anims[A_WEA_PUTAWAY]        = GetAnimID(TORSO_BONE, prefix1+"p");
                    */
                    nUserID = BuildSeqID(nWeaponType, nSpeed,0,0);
                    SetUserSeqID( prefix1+"j", A_JUMP + nUserID);
                    SetUserSeqID( prefix1+"jf", A_JUMP_FORWARD + nUserID);
                    SetUserSeqID( prefix1+"re", A_WEA_RELOAD + nUserID);
                    SetUserSeqID( prefix1+"g", A_WEA_GET + nUserID);
                    SetUserSeqID( prefix1+"p", A_WEA_PUTAWAY + nUserID);
                    
                    int nMagic = 0;
                    for(nMagic = 0; nMagic <= 1; nMagic++)
                    {
                        String prefix2 = new String(prefix1);
                        
                        if (nMagic==0)
                            prefix2 += "a";
                        else
                            prefix2 += "n";

                        nUserID = BuildSeqID(nWeaponType, nSpeed,nMagic,0);
                        SetUserSeqID( prefix2+"s", A_STAND + nUserID);
                        SetUserSeqID( prefix2+"", A_FORWARD + nUserID);
                        SetUserSeqID( prefix2+"b", A_BACKWARD + nUserID);
                        SetUserSeqID( prefix2+"sl", A_STRAFE_LEFT + nUserID);
                        SetUserSeqID( prefix2+"sr", A_STRAFE_RIGHT + nUserID);
                        SetUserSeqID( prefix2+"rl", A_ROTATE_LEFT + nUserID);
                        SetUserSeqID( prefix2+"rr", A_ROTATE_RIGHT + nUserID);
                        SetUserSeqID( prefix2+"sh", A_TAKE_HIT + nUserID);
                        SetUserSeqID( prefix2+"rlb", A_BACK_ROTATE_LEFT + nUserID);
                        SetUserSeqID( prefix2+"rrb", A_BACK_ROTATE_RIGHT + nUserID);

                        int nPumpAction = 0;
                        for(nPumpAction = 0; nPumpAction <= 1; nPumpAction++)
                        {
                            String prefix3 = new String(prefix2);
                            
                            if ( nPumpAction==0 )
                                //Anims[A_WEA_FIRE] = GetAnimID(TORSO_BONE, prefix3+"fS");
                                SetUserSeqID(prefix3+"fS", A_WEA_FIRE + BuildSeqID(nWeaponType, nSpeed, nMagic,nPumpAction) );
                            else
                                //Anims[A_WEA_FIRE] = GetAnimID(TORSO_BONE, prefix3+"f");
                                SetUserSeqID(prefix3+"f", A_WEA_FIRE + BuildSeqID(nWeaponType, nSpeed, nMagic,nPumpAction) );
                        }
                    }
                }
            }
//        }
    }

	
    // TYLKO DO DEBUGOWANIA ANIMACJI
    /*
    public void SetUserSeqID(String sSeqName, int nSeqID)
    {
        CrashLog("DBG: SetUserSeqID for " + sSeqName + ", " + nSeqID + "\n");
        super.SetUserSeqID(sSeqName, nSeqID);
    }
    
    
    public int GetAnimID(String sElem, String sSeq)
    {
        int nID = super.GetAnimID(sElem, sSeq);
        if (nID <= 0)
        {
            CrashLog("DBG: GetAnimID(" + sElem + "," + sSeq + ") = " + nID + "\n");
            nID = -666;
        }
        return nID;
    }
    

    public int GetAnimID(int nElem, int nSeq)
    {
        int nID = super.GetAnimID(nElem, nSeq);
        if (nID <= 0)
        {
            //CrashLog("DBG: GetAnimID(" + nElem + "," + nSeq + ") = " + nID + "\n");
            nID = -nSeq;
        }
        return nID;
    }

    
    public int PlayAnim(int nAnimID, int nCount)
    {
        if (nAnimID > 0)
            return super.PlayAnim(nAnimID, nCount);
        else
        {
            CrashLog("DBG: PlayAnim for SequenceID " + (-nAnimID) + "\n");
            Thread.dumpStack();
        }
        return 0;
    }
    

    public int PlayAnim(String sAnim, int nCount)
    {
        if (super.GetAnimID(ROOT_BONE, sAnim) <= 0)
        {
            CrashLog("DBG: PlayAnim for Sequence " + sAnim + "\n");
            return 0;
        }
        else
            return super.PlayAnim(sAnim, nCount);
    }
    */
    float fAnimSpeedUp = 1.2f;
/*    
    boolean bNewSetupAnims = false;
    void SetupAnims()
    {
        if(bNewSetupAnims)
            SetupAnimsNew();
        else
            SetupAnimsOld();
    }
*/
    //void SetupAnimsNew()
    void SetupAnims()
    {
//        ProfileBegin(PROFILE_SetupAnims);
        
        //CrashLog("DBG: bAiming = " + cMotion.bAiming + "\n");
        
        int nUserID;
        byte weaponType;
        boolean bPumpAction = false;
        
        if (ActiveWeapon != null/* && bPlaceGun */)
        {
            weaponType = ActiveWeapon.nType;
            bPumpAction = ActiveWeapon.bPumpAction;
        }
        else
            weaponType = EWeaponType._HAND;

        
        if (bUseNewModel)
        {
            // odpal tylko te dozwolone animacje
            if ( !(bCanUseHandsAnims && weaponType == EWeaponType._HAND) &&
                 !(bCanUsePistolAnims && weaponType == EWeaponType._PISTOL) &&
                 bCanUseRifleAnims)
            {
                if (bCanUseRifleAnims)
                    weaponType = EWeaponType._RIFLE;
                else if (bCanUseHandsAnims)
                    weaponType = EWeaponType._HAND;
                else if (bCanUsePistolAnims)
                    weaponType = EWeaponType._PISTOL;
                else
                {
                    // no coz, po staremu...
                    weaponType = EWeaponType._RIFLE;
                }
            }
        }
        
        //these do not depend on motion mode
        /*
        Anims[A_BUTT_HIT]           = GetAnimID(ROOT_BONE, prefix+"b");
        Anims[A_CRAWL2DUCK]         = GetAnimID(ROOT_BONE, prefix+"c2d");
        Anims[A_CRAWL2STAND]        = GetAnimID(ROOT_BONE, prefix+"c2s");
        Anims[A_DUCK2CRAWL]         = GetAnimID(ROOT_BONE, prefix+"d2c");
        Anims[A_STAND2CRAWL]        = GetAnimID(ROOT_BONE, prefix+"s2c");
        */
        nUserID = BuildSeqID(weaponType,0,0,0);
        Anims[A_BUTT_HIT]           = GetAnimID(nRootElementID, A_BUTT_HIT + nUserID);
        Anims[A_CRAWL2DUCK]         = GetAnimID(nRootElementID, A_CRAWL2DUCK + nUserID);
        Anims[A_CRAWL2STAND]        = GetAnimID(nRootElementID, A_CRAWL2STAND + nUserID);
        Anims[A_DUCK2CRAWL]         = GetAnimID(nRootElementID, A_DUCK2CRAWL + nUserID);
        Anims[A_STAND2CRAWL]        = GetAnimID(nRootElementID, A_STAND2CRAWL + nUserID);

        //choose motion mode
/*        
        Anims[A_JUMP]               = GetAnimID(ROOT_BONE, prefix+"j");
        Anims[A_JUMP_FORWARD]       = GetAnimID(ROOT_BONE, prefix+"jf");
        Anims[A_WEA_RELOAD]         = GetAnimID(TORSO_BONE, prefix+"re");
        Anims[A_WEA_GET]            = GetAnimID(TORSO_BONE, prefix+"g");
        Anims[A_WEA_PUTAWAY]        = GetAnimID(TORSO_BONE, prefix+"p");
*/
        int nSpeed = cMotion.iSpeed;
        nUserID = BuildSeqID(weaponType, nSpeed, 0,0);
        Anims[A_JUMP]               = GetAnimID(nRootElementID, A_JUMP + nUserID);
        Anims[A_JUMP_FORWARD]       = GetAnimID(nRootElementID, A_JUMP_FORWARD + nUserID);
        Anims[A_WEA_RELOAD]         = GetAnimID(nTorsoElementID, A_WEA_RELOAD + nUserID);
        Anims[A_WEA_GET]            = GetAnimID(nTorsoElementID, A_WEA_GET + nUserID);
        Anims[A_WEA_PUTAWAY]        = GetAnimID(nTorsoElementID, A_WEA_PUTAWAY + nUserID);
        
        int nMagic = 0;
        if (bPlaceGun && cMotion.bAiming == true && 
            cMotion.iSpeed != MotionState.SPEED_CRAWL &&
            (cMotion.iSpeed != MotionState.SPEED_RUN || 
             (cMotion.iSpeed == MotionState.SPEED_RUN && !cMotion.IsMovingLinear()))
            )
            nMagic = 0;
        else
            nMagic = 1;

        
/*        
        Anims[A_STAND]              = GetAnimID(ROOT_BONE, prefix+"s");
        Anims[A_FORWARD]            = GetAnimID(ROOT_BONE, prefix+"");
        Anims[A_BACKWARD]           = GetAnimID(ROOT_BONE, prefix+"b");
        Anims[A_STRAFE_LEFT]        = GetAnimID(ROOT_BONE, prefix+"sl");
        Anims[A_STRAFE_RIGHT]       = GetAnimID(ROOT_BONE, prefix+"sr");
        Anims[A_ROTATE_LEFT]        = GetAnimID(ROOT_BONE, prefix+"rl");
        Anims[A_ROTATE_RIGHT]       = GetAnimID(ROOT_BONE, prefix+"rr");
        Anims[A_TAKE_HIT]           = GetAnimID(TORSO_BONE, prefix+"sh");
        Anims[A_BACK_ROTATE_LEFT]   = GetAnimID(ROOT_BONE, prefix+"rlb");
        Anims[A_BACK_ROTATE_RIGHT]  = GetAnimID(ROOT_BONE, prefix+"rrb");
*/
        nUserID = BuildSeqID(weaponType, nSpeed, nMagic, 0);
        Anims[A_STAND]              = GetAnimID(nRootElementID, A_STAND + nUserID);
        Anims[A_FORWARD]            = GetAnimID(nRootElementID, A_FORWARD + nUserID);
        Anims[A_BACKWARD]           = GetAnimID(nRootElementID, A_BACKWARD + nUserID);
        Anims[A_STRAFE_LEFT]        = GetAnimID(nRootElementID, A_STRAFE_LEFT + nUserID);
        Anims[A_STRAFE_RIGHT]       = GetAnimID(nRootElementID, A_STRAFE_RIGHT + nUserID);
        Anims[A_ROTATE_LEFT]        = GetAnimID(nRootElementID, A_ROTATE_LEFT + nUserID);
        Anims[A_ROTATE_RIGHT]       = GetAnimID(nRootElementID, A_ROTATE_RIGHT + nUserID);
        Anims[A_TAKE_HIT]           = GetAnimID(nTorsoElementID, A_TAKE_HIT + nUserID);
        Anims[A_BACK_ROTATE_LEFT]   = GetAnimID(nRootElementID, A_BACK_ROTATE_LEFT + nUserID);
        Anims[A_BACK_ROTATE_RIGHT]  = GetAnimID(nRootElementID, A_BACK_ROTATE_RIGHT + nUserID);
        
        if ( bPumpAction )
            //Anims[A_WEA_FIRE] = GetAnimID(TORSO_BONE, prefix+"fS");
            Anims[A_WEA_FIRE] = GetAnimID(nTorsoElementID, A_WEA_FIRE + BuildSeqID(weaponType, nSpeed, nMagic,0));
        else
            //Anims[A_WEA_FIRE] = GetAnimID(TORSO_BONE, prefix+"f");
            Anims[A_WEA_FIRE] = GetAnimID(nTorsoElementID, A_WEA_FIRE + BuildSeqID(weaponType, nSpeed, nMagic,1));
        
        //????
        //TODO
        //SetAnimFreq(prefix+"rlb", 50);
        //SetAnimFreq(prefix+"rrb", 50);
        
        // * 1.35f by MK
        if (fAnimSpeedUp > 0) //zeby mozna bylo to wylaczyc
            SetAnimFreq("", 30.f * fAnimSpeedUp);
        
//        ProfileEnd(PROFILE_SetupAnims);
    }
    
    /** Podmiana zestawu animacji dla kazdej broni i dla kazdego rodzaju chodzenia
     * no i oczywisci przycelowania.
     * Wolane gdy:
     * - PRZYCELOWANIE
     * - ZMIANA BRONI
     * - ZMIANA SPOSOBU PORUSZANIA
     */
    void SetupAnimsOld()
    {
//        ProfileBegin(PROFILE_SetupAnims);
        
        byte weaponType;
        boolean bPumpAction = false;
        
        if (ActiveWeapon != null/* && bPlaceGun */)
        {
            weaponType = ActiveWeapon.nType;
            bPumpAction = ActiveWeapon.bPumpAction;
        }
        else weaponType = EWeaponType._HAND;
        
        String prefix = "";
        //choose weapon type
        switch (weaponType)
        {
            case EWeaponType._HAND      : prefix = "N"; break;
            case EWeaponType._KNIFE     : prefix = "K"; break;
            case EWeaponType._PISTOL    : prefix = "P"; break;
            case EWeaponType._RIFLE     : prefix = "R"; break;
            case EWeaponType._HEAVY     : prefix = "H"; break;
            case EWeaponType._GRENADE   : prefix = "G"; break;
            default: prefix = "U"; //unknown
        }

        //these do not depend on motion mode
        Anims[A_BUTT_HIT]           = GetAnimID(ROOT_BONE, prefix+"b");

        Anims[A_CRAWL2DUCK]         = GetAnimID(ROOT_BONE, prefix+"c2d");
        Anims[A_CRAWL2STAND]        = GetAnimID(ROOT_BONE, prefix+"c2s");
        Anims[A_DUCK2CRAWL]         = GetAnimID(ROOT_BONE, prefix+"d2c");
        Anims[A_STAND2CRAWL]        = GetAnimID(ROOT_BONE, prefix+"s2c");

        //choose motion mode
        switch (cMotion.iSpeed)
        {
            case MotionState.SPEED_RUN : prefix += "r"; break;
            case MotionState.SPEED_WALK : prefix += "w"; break;
            case MotionState.SPEED_DUCK : prefix += "d"; break;
            case MotionState.SPEED_CRAWL : prefix += "c"; break;
            case MotionState.SPEED_STILL : prefix += "w"; break;
            default: ;
        }
        
        Anims[A_JUMP]               = GetAnimID(ROOT_BONE, prefix+"j");
        Anims[A_JUMP_FORWARD]       = GetAnimID(ROOT_BONE, prefix+"jf");

        // fire dla shotguna wyglada troche inaczej niz dla rifle
        
        //LogD(prefix + "\n");
        //a reszta animacji broni pozostaje taka sama
        Anims[A_WEA_RELOAD]         = GetAnimID(TORSO_BONE, prefix+"re");
        Anims[A_WEA_GET]            = GetAnimID(TORSO_BONE, prefix+"g");
        Anims[A_WEA_PUTAWAY]        = GetAnimID(TORSO_BONE, prefix+"p");

        if (bPlaceGun && cMotion.bAiming == true && 
            cMotion.iSpeed != MotionState.SPEED_CRAWL &&
            cMotion.iSpeed != MotionState.SPEED_RUN) prefix += "a";
        else prefix += "n";
        
        if ( bPumpAction )
        {
            //LogLine("Animacja dla strzelania = " + prefix + "fS");
            Anims[A_WEA_FIRE] = GetAnimID(TORSO_BONE, prefix+"fS");
        }
        else
        {
            //LogLine("Animacja dla strzelania = " + prefix + "f");
            Anims[A_WEA_FIRE] = GetAnimID(TORSO_BONE, prefix+"f");
        }
        
        //setup animations
        Anims[A_STAND]              = GetAnimID(ROOT_BONE, prefix+"s");
        //Anims[A_STAND] = GetAnimID(ROOT_BONE, "Idle01");
        Anims[A_FORWARD]            = GetAnimID(ROOT_BONE, prefix+"");
        Anims[A_BACKWARD]           = GetAnimID(ROOT_BONE, prefix+"b");
        Anims[A_STRAFE_LEFT]        = GetAnimID(ROOT_BONE, prefix+"sl");
        Anims[A_STRAFE_RIGHT]       = GetAnimID(ROOT_BONE, prefix+"sr");
        Anims[A_ROTATE_LEFT]        = GetAnimID(ROOT_BONE, prefix+"rl");
        Anims[A_ROTATE_RIGHT]       = GetAnimID(ROOT_BONE, prefix+"rr");
        Anims[A_TAKE_HIT]           = GetAnimID(TORSO_BONE, prefix+"sh");

        
        
        SetAnimFreq("", 30.f * fAnimSpeedUp);
        // uwaga - nie ma tych animacji dla crawl i duck
        Anims[A_BACK_ROTATE_LEFT]   = GetAnimID(ROOT_BONE, prefix+"rlb");
        SetAnimFreq(prefix+"rlb", 50);
        Anims[A_BACK_ROTATE_RIGHT]  = GetAnimID(ROOT_BONE, prefix+"rrb");
        SetAnimFreq(prefix+"rrb", 50);
        
        //LogD(prefix + "\n");
        
//        ProfileEnd(PROFILE_SetupAnims);
    }
    
    /** Redukcja (modyfikacja) predkosci (iSpeed) w zaleznosci kierunku ruchu
     *  i posiadanej broni. (Uzywac tylko podczas ruchu, bo np. mozna duckowac 
     *  z ciezkim gunem).
     */
    byte GetReducedMotionSpeed(MotionState cMotion)
    {
        byte iSpeed = cMotion.iSpeed;
        
        // Nie biegaj:
        // - do tylu
        // - celujac
        if ((cMotion.iSpeed == MotionState.SPEED_RUN) && 
            (cMotion.bAiming || (cMotion.iMoveZ == -1)))
            iSpeed = MotionState.SPEED_WALK;

        // Z weapon heavy mozna tylko chodzic - nie mozna duckowac ani biegac
        if ((ActiveWeapon != null && ActiveWeapon.nType == EWeaponType._HEAVY) &&
            (iSpeed == MotionState.SPEED_RUN || 
             (cMotion.IsMovingLinear() &&
              (iSpeed == MotionState.SPEED_DUCK ||
                iSpeed == MotionState.SPEED_CRAWL))))
            iSpeed = MotionState.SPEED_WALK;                                           

        // Jesli nie porusza sie, to zmien predkosc z Run na Walk, bo nie ma animacji stania i obrotow
        if (iSpeed == MotionState.SPEED_RUN &&
            !cMotion.IsMovingLinear())
            iSpeed = MotionState.SPEED_WALK;
        
        return iSpeed;
    }
    
    /** Wlacza odpowiednia animacje na podstawie parametrow opisujacych stan z
     * cMotion: iSpeed, iMove, iTurn
     */
    void UpdateMotion()
    {
        //CrashLog("DBG: UpdateMotion" + MotionState.aSpeedNames[cMotion.iSpeed] + "(" + 
        //         cMotion.iMoveZ + "," + cMotion.iMoveX + ")\n");
                
        if (bDead) return; //zeby martwy nie wstawal

//        ProfileBegin(PROFILE_UpdateMotion);

        byte iSpeedCopy = cMotion.iSpeed; //kopia, zeby predkosc zmieniac tylko tymczasowo
        
        cMotion.iSpeed = GetReducedMotionSpeed(cMotion);
        
        // przelaczenie odpowiednio animacji
        SetupAnims();
        if ( cMotion.IsMoving() )
        {
            //LogD("ismoving: Z=" + cMotion.iMoveZ + ", X=" + cMotion.iMoveX + "\n");
            int nAnimToPlay = -1;
            if (cMotion.IsMovingLinear())
            {
                switch ((int)cMotion.iMoveZ)
                {
                case -1 : //backward
                    nAnimToPlay = Anims[A_BACKWARD];
                    if (cMotion.iSpeed >= MotionState.SPEED_WALK)
                    {
                        //LogD("Bck-strafe\n");
                        BodyDeformStrafe((byte)-cMotion.iMoveX);
                    }
                    else
                    {
                        //LogD("Bck-no strafe\n");
                        BodyDeformStrafeReset();
                    }
                    break;
                case 0 : //strafe
                    if (cMotion.iSpeed == MotionState.SPEED_RUN)
                    {
                        nAnimToPlay = Anims[A_FORWARD];
                        BodyDeformStrafe((byte)cMotion.iMoveX);
                        //LogD("Strafe-run\n");
                    }
                    else {
                        BodyDeformStrafeReset();
                        if (cMotion.iMoveX > 0)
                        {
                            //LogD("Strafe-anim-left\n");
                            nAnimToPlay = Anims[A_STRAFE_LEFT];
                        }
                        else
                        {
                            //LogD("Strafe-anim-right\n");
                            nAnimToPlay = Anims[A_STRAFE_RIGHT];
                        }
                    }
                    break;
                case 1 : //forward
                    nAnimToPlay = Anims[A_FORWARD];
                    if (cMotion.iSpeed >= MotionState.SPEED_WALK)
                    {
                        //LogD("Fwd-strafe\n");
                        BodyDeformStrafe(cMotion.iMoveX);
                    }
                    else
                    {
                        //LogD("Fwd-no strafe\n");
                        BodyDeformStrafeReset();
                    }
                    break;
                }
            } 
            else if (cMotion.iTurn != 0) //obroty
            {
                BodyDeformStrafeReset();
                if (cMotion.iTurn > 0)
                    PlayAnim(Anims[A_ROTATE_LEFT], -1);
                else
                    PlayAnim(Anims[A_ROTATE_RIGHT], -1);
                //LogD("Playing turn animation\n");
            }
                
                
            if (nAnimToPlay != -1)
            {
                if (cOldMotion.iMoveX != cMotion.iMoveX ||
                    cOldMotion.iMoveZ != cMotion.iMoveZ)
                {
                    PlayAnim( nAnimToPlay, -1);
                    StepDone();
                    CallMethodEvery( METHOD_StepDone, GetAnimLength(nAnimToPlay) / 2.f);
                }
            }
        }
        else
        {
            BodyDeformStrafeReset();
            //LogD("!moving, old = " + cOldMotion.iSpeed + "\n");
            //czy wstajemy z czolgania?
            if ( (cOldMotion.iSpeed == MotionState.SPEED_CRAWL) &&
                 (cMotion.iSpeed != MotionState.SPEED_CRAWL) )
            {
                //animacja przejscia miedzy odpowiednimi stanami
                if (cMotion.iSpeed == MotionState.SPEED_DUCK)
                {
                    PlayAnim( Anims[A_CRAWL2DUCK], 1);
                    CallMethodOnceIn(METHOD_UpdateMotion, GetAnimLength(Anims[A_CRAWL2DUCK]));
                }
                else
                {
                    PlayAnim( Anims[A_CRAWL2STAND], 1);
                    CallMethodOnceIn(METHOD_UpdateMotion, GetAnimLength(Anims[A_CRAWL2STAND]));
                }

            // czy kladziemy sie do czolgania?
            } else if ( (cOldMotion.iSpeed != MotionState.SPEED_CRAWL) &&
                        (cMotion.iSpeed == MotionState.SPEED_CRAWL) )
            {
                if (cMotion.iSpeed == MotionState.SPEED_DUCK)
                {
                    PlayAnim( Anims[A_DUCK2CRAWL], 1);
                    CallMethodOnceIn(METHOD_UpdateMotion, GetAnimLength(Anims[A_DUCK2CRAWL]));
                }
                else
                {
                    PlayAnim( Anims[A_STAND2CRAWL], 1);
                    CallMethodOnceIn(METHOD_UpdateMotion, GetAnimLength(Anims[A_STAND2CRAWL]));
                }

            } 
            else
                PlayStandAnim();

            if (cOldMotion.IsMovingLinear())
                DisableCallMethod( METHOD_StepDone );
        }
        
        cMotion.iSpeed = iSpeedCopy; //przywroc wlasciwa predkosc
        cOldMotion = new MotionState(cMotion);

//        ProfileEnd(PROFILE_UpdateMotion);
}

    void PlayStandAnim()
    {
        if (CurrentState instanceof AIBaseState)
            ((AIBaseState)CurrentState).PlayStandAnim();
        else
            PlayAnim( Anims[A_STAND], -1 );

    }
    
    
    void StepDone()
    {
        if( !SoundEmitter.bListenerInsideBuilding )
            PlayStepSound(cMotion, 0);
    }

    
    byte byDeformStrafe = 0;
    
    /** Deformacja przy strafeowaniu
     */
    void BodyDeformStrafe(byte byDir)
    {
//        ProfileBegin(PROFILE_BodyDeformStrafe);
        
        if ( !((cMotion.iSpeed < MotionState.SPEED_DUCK) ||
             (byDeformStrafe == byDir)) )
        {
            BoneRotate(EBones._PELVIS, new Vector(1, 0, 0), byDir*30);
            BoneRotate(EBones._SPINE, new Vector(1, 0, 0), -byDir*15);
            BoneRotate(EBones._SPINE1, new Vector(1, 0, 0), -byDir*15);
            byDeformStrafe = byDir;
        }
        
//        ProfileEnd(PROFILE_BodyDeformStrafe);
    }

    
    /*
     * Wyprostowanie strafe'a
     */
    void BodyDeformStrafeReset()
    {
//        ProfileBegin(PROFILE_BodyDeformStrafe);
        
        if (byDeformStrafe != 0)
        {
            BoneRotate(EBones._PELVIS, new Vector(1, 0, 0), 0);
            BoneRotate(EBones._SPINE, new Vector(1, 0, 0), 0);
            BoneRotate(EBones._SPINE1, new Vector(1, 0, 0), 0);
            byDeformStrafe = 0;
        }
        
//        ProfileEnd(PROFILE_BodyDeformStrafe);
    }

    
    ///////////////////////
    // Metode pomocnicze //
    ///////////////////////

    /** Pokryte SetState wolajace OnLeave dla poprzedniego stanu
     */
    public void SetState(String sStateName)
    {
        //LogD(sStateName + "\n");
        // zawiadomienie poprzedniego stanu o zmianie
        if(CurrentState != null)
        {
            // Jesli w trakcie zmiany stanu - nie wolaj powtornie OnLeave
            if (!bIsChanginState)
            {
                ((AIBase.AIBaseState)CurrentState).OnLeave();
                // Jesli stan dluzej po sobie sprzata - daj mu czas
                if (((AIBaseState)CurrentState).bNeedTimeToLeave)
                {
                    sStateToSetName = sStateName;
                    bIsChanginState = true;
                }
                else
                    super.SetState(sStateName);
            }
            else if (sStateName.compareTo("Die") == 0) //hak, zeby mogl umrzec
            {
                bIsChanginState = false;
                super.SetState(sStateName);
            }
        }
        else
            super.SetState(sStateName);
    }
    
    /** Znacznik, ze wlasnie zmienia sie stan 
     *  (poprzedni nie posprzatal po sobie do konca)
     */
    boolean bIsChanginState = false;
        
    /** zapamietana nazwa stanu, do ktorego nalezy przejsc po zakonczeniu sprzatania po
     *  starym
     */
    String sStateToSetName = null;
    
    /** Callback wolany po zakonczeniu sprzatania po sobie przez poprzedni stan 
     *  (Wolany z opoznieniem przez OnLeave)
     */
    public void EnterNewState()
    {
        bIsChanginState = false;
        super.SetState(sStateToSetName);
    }
    
    /** Gdy flaga ustawiona to gun jest wyrownywany w rekach */
    boolean bPlaceGun = false;
    
    /** Metoda wyrownuje bron w rekach
     */
    void PlaceGun()
    {
        if (nLeftHandID == -1 || nRightHandID == -1) 
            return;
        
        if ( ActiveWeapon == null )
            return;

        Vector vGunAxis;
/* bylo TAK, ale to byl HAK, bo animacje sa robione wzgl. dummiego
        
        if (!bPlaceGun || ActiveWeapon.nType == EWeaponType._PISTOL)
        {
            //vGunAxis = GetForwardVector();
            //vGunAxis = GetBoneDirVector( EBones._R_FOREARM );
            vGunAxis = GetElementRightVector(nRightHandID); // bo tak wyszlo z max'a
        }
        else
        {
            vGunAxis = GetElementPos( nLeftHandID );
            vGunAxis.Sub( GetElementPos( nRightHandID ) );
        }
        ActiveWeapon.SetDir( vGunAxis );
*/
        
        if (bUseNewModel)
        {
            ActiveWeapon.FromUpForwardPos(GetElementUpVector(nRightHandID), 
                                          GetElementForwardVector(nRightHandID), 
                                          GetElementPos(nRightHandID));
        }
        else
        {
            Vector vUp = GetElementForwardVector(nRightHandID);
            vUp.Mul(-1);
            vGunAxis = GetElementRightVector(nRightHandID); // bo tak wyszlo z max'a...
            ActiveWeapon.FromUpForwardPos(vUp, vGunAxis, GetElementPos(nRightHandID));
        }
    }
    
    
    ////////////////////////////////////////////////////////////////////////
    // Sledzenie podanego celu (glowa, torsem, glowa ze skreceniem torsu) //
    ////////////////////////////////////////////////////////////////////////
    

    ///////////////////////////////////////////
    // Ogolny mechanizm sledzenia
    //
    
    /** Co jaki czas ma byc wolana metoda update'u przy sledzeniu obiektu [s]
     *  Gdy fUpdateTrackingTime <= 0 update wykonuje sie co ramke ale:
     *    UWAGA: 1) uzywac z rozwaga
     *           2) jesli w stanie/klasie bazowej podmieniono OnFrame trzeba zawolac
     *              je tez z AIBase
     */
    float fUpdateTrackingTime = 0.2f;
    float fUpdateTrackingTimeMax = 2.0f;

    /** Ilosc aktualnie podpietych 'sledzen' obiektow
     */
    int nUpdateTrackings = 0;

    /** Dodaj metode do lancuszka trackowania - jesli pierwsza - wlacz 'timerka'
     */
    void AddTracking()
    {
        if (nUpdateTrackings == 0 && fUpdateTrackingTime > 0)
            CallMethodEveryMinMax(METHOD_UpdateTrackings, fUpdateTrackingTime, fUpdateTrackingTimeMax);
        nUpdateTrackings++;
    }
    
    /** Usun metode z lancuszka trackowania - jesli ostatnia - wylasz 'timerka'
     */
    void RemoveTracking()
    {
        if (nUpdateTrackings > 0)
        {
            if (--nUpdateTrackings == 0)
                DisableCallMethod(METHOD_UpdateTrackings);
        }
    }
    
    /** Zmiana czestotliwosci wywolywania metody UpdateTrackings
     *  @param fNewTime nowy czas, co jaki wolana jest UpdateTrackings, jesli 
     *         fNewTime <= 0, wolane jest co klatke w OnFrame
     */
    void SetTrackingUpdateTime(float fNewTime)
    {
        if (nUpdateTrackings > 0)
        {
            if (fNewTime <= 0)
                DisableCallMethod(METHOD_UpdateTrackings);
            else
                CallMethodEveryMinMax(METHOD_UpdateTrackings, fNewTime, 10.0f*fNewTime);
        }
        fUpdateTrackingTime = fNewTime;
        fUpdateTrackingTimeMax = fNewTime*10.0f;
    }
    
    public void OnFrame()
    {
        if ((nUpdateTrackings > 0) && fUpdateTrackingTime <= 0)
            UpdateTrackings();
    }
    
    /** Metoda wolana przez CallMethodEvery - wola updaty (UpdateAllTrackings)
     *  dla wszystkich klas (UpdateAllTrackings musi wolac swoj odpowiednik w klasie bazowej)
     */
    void UpdateTrackings()
    {
//        ProfileBegin(PROFILE_UpdateTrackings);
        
        UpdateAllTrackings();
        
//        ProfileEnd(PROFILE_UpdateTrackings);
    }
    
    
    
    /////////////////////////////////////////////////////////
    // Deformacje ciala umozliwiajace skret przy sledzeniu
    //
    
    
    /** Obciecie wartosci do podanego przedzialu
     *  @param fValue wartosc wejsciowa (<code>float</code>)
     *  @param fMin poczatek przedzialu (<code>float</code>)
     *  @param fMax koniec przedzialu
     *  @return wartosc po obcieciu
     */
    float Crop(float fValue, float fMin, float fMax)
    {
        if (fValue <= fMin)
            return fMin;
        if (fValue >= fMax)
            return fMax;
        return fValue;
    }

    /** Kat miedzy wektorem do przodu a rzutem podanego kierunku na plaszczyzne pozioma (XZ)
     *  (zalozenie: wektor do przodu w przyblizeniu lezy w plaszczyznie XZ)
     */
    float Dir2HorizAngle(Vector vDir)
    {
        Vector vDirH = new Vector(vDir);
        vDirH.fY = 0;
        vDirH.Normalize();
            
        float vDot = Crop(vDirH.Dot(GetForwardVector()), -1, 1);
        float fAngle = (float)(Math.acos(vDot) * 180 / Math.PI);
        
        if (vDirH.Dot(GetRightVector()) < 0)
            return -fAngle;
        else
            return fAngle;
    }
    
    /** Kat miedzy podanym kierunkiem a plaszczyzna pozioma (XZ)
     */
    float Dir2VertAngle(Vector vDir)
    {
        Vector vDirH = new Vector(vDir);
        vDirH.fY = 0;
        return (float)(Math.atan2(vDir.fY, vDirH.Len()) * 180 / Math.PI);
    }
    
    
    /** [Pomocnicza] Zapamietana wartosc ostatniego typu deformacji ciala przez 
     *  TwistBody (optymalizacja)
     */
    int nLastTwistType = _TWIST_TYPE_NONE;
    
    /** Deformacja powodujaca skrecenie ciala w poziomie i w pionie o podane katy
     *  @param fHorizAngle kat o jaki ma byc skret w poziomie (>0 - w lewo) (<code>float</code>)
     *                     UWAGA: Musi byc w odpowiednio ograniczonym przedziale
     *  @param fVertAngle kat w pionie (>0 - w gore)m (<code>float</code>)
     *                     UWAGA: Musi byc w odpowiednio ograniczonym przedziale
     *  @param nTwistType rodzaj skretu (typ deformacji):
     *                    - _TWIST_TYPE_NONE - reset skretu ciala
     *                    - _TWIST_TYPE_HEAD_ONLY - obrot glowy
     *                    - _TWIST_TYPE_HEAD_USE_TORSO - obrot glowy i ciala (glowa obraca sie o zadany kat)
     *                    - _TWIST_TYPE_TORSO - obrot gornej czesci ciala o podane katy
     */
    void TwistBody(float fHorizAngle, float fVertAngle, int nTwistType)
    {
        //LogD(nTwistType + " " + fHorizAngle + " " + fVertAngle + "\n");
        switch (nTwistType)
        {
        case _TWIST_TYPE_NONE:
            {
                BoneRotate(EBones._HEAD, vAlongXAxis, 0.f);
                BoneRotate(EBones._NECK, vAlongYAxis, 0.f);
                BoneRotate(EBones._SPINE, vAlongXAxis, 0.f);
                BoneRotate(EBones._SPINE1, vAlongXAxis, 0.f);
            }
            break;
        case _TWIST_TYPE_HEAD_ONLY:
            {
                // Skrecenie w pionie - zlozenia z poprzednim
                BoneRotate(EBones._HEAD, vAlongYAxis, fVertAngle);

                BoneRotate(EBones._HEAD, vAlongXAxis, fHorizAngle, true);

            }
            break;
        case _TWIST_TYPE_HEAD_USE_TORSO:
            {
                // Skrecenie w poziomie
                BoneRotate(EBones._HEAD, vAlongXAxis, fHorizAngle*.4f);
                BoneRotate(EBones._SPINE, vAlongXAxis, fHorizAngle*.3f);
                BoneRotate(EBones._SPINE1, vAlongXAxis, fHorizAngle*.3f);

                // Skrecenie w pionie - zlozenia z poprzednim (_NECK - nadpisanie macierzy)
                BoneRotate(EBones._HEAD, vAlongYAxis, fVertAngle*.3f, true);
                BoneRotate(EBones._NECK, vAlongYAxis, fVertAngle*.3f);
                BoneRotate(EBones._SPINE, vAlongYAxis, fVertAngle*.2f, true);
                BoneRotate(EBones._SPINE1, vAlongYAxis, fVertAngle*.2f, true);
            }
            break;
        case _TWIST_TYPE_TORSO:
            {
                // Jesli ostatni twist uzywal glowy - zresetuj jej obrot
                if (nLastTwistType == _TWIST_TYPE_HEAD_ONLY ||
                    nLastTwistType == _TWIST_TYPE_HEAD_USE_TORSO)
                {
                    BoneRotate(EBones._HEAD, vAlongXAxis, 0.f);
                    BoneRotate(EBones._NECK, vAlongYAxis, 0.f);
                }

                // Skrecenie w poziomie
                BoneRotate(EBones._SPINE, vAlongXAxis, fHorizAngle*.5f);
                BoneRotate(EBones._SPINE1, vAlongXAxis, fHorizAngle*.5f);

                // Skrecenie w pionie - zlozenia z poprzednim
                BoneRotate(EBones._SPINE, vAlongYAxis, fVertAngle*.5f, true);
                BoneRotate(EBones._SPINE1, vAlongYAxis, fVertAngle*.5f, true);
            }
            break;
        default:
            LogD("Incorrent twist type value!\n");
            break;
        }
        nLastTwistType = nTwistType;
    }

    /** Przeksztalcenie wartosci ograniczajacej twist w zaleznosci od typu deformacji
     *  @param fInExtremumValue wejsciowa wartosc ograniczajaca (fTwistHorizMin itp.)
     *  @param nTwistType typ deformacji (_TWIST_TYPE_*)
     *  @return wartosc ograniczajaca po przeksztalceniu
     */
    float CalcTwistExtremum(float fInExtremumValue, int nTwistType)
    {
        float fMotionTwistFactor;

        // Wyznacz modyfikator ekstremalnej wartosc skrecenia ze wzgledu na MotionState
        if (cMotion.iSpeed == MotionState.SPEED_CRAWL)
            fMotionTwistFactor = 0.f;
        else if (cMotion.iSpeed == MotionState.SPEED_DUCK)
            fMotionTwistFactor = fDuckTorsoTwistFactor;
        else 
            fMotionTwistFactor = 1.f;
        
        // Wyznacz ekstremum ze wzgledu na rodzaj deformacji
        switch (nTwistType)
        {
        case _TWIST_TYPE_NONE:
            return 0.f;
        case _TWIST_TYPE_HEAD_ONLY:
            return fInExtremumValue;
        case _TWIST_TYPE_TORSO:
            return fInExtremumValue * fMotionTwistFactor;
        case _TWIST_TYPE_HEAD_USE_TORSO:
            return fInExtremumValue * fHeadTwistFactor * fMotionTwistFactor;
        default:
            LogD("Incorrent twist type value!\n");
            return 0.f;
        }
    }
    
    /** Pobranie minimalnego kata o jaki mozna skrecic cialo AI w poziomie (w prawo) 
     *  przy uzyciu podanego typu deformacji
     *  @param nTwistType rodzaj deformacji (_TWIST_TYPE_*)
     *  @return minimalny kat skretu [deg]
     */
    float GetTwistHorizMin(int nTwistType)
    {
        return CalcTwistExtremum(fTwistHorizMin, nTwistType);
    }

    /** Pobranie maksymalnego kata o jaki mozna skrecic cialo AI w poziomie (w lewo) 
     *  przy uzyciu podanego typu deformacji
     *  @param nTwistType rodzaj deformacji (_TWIST_TYPE_*)
     *  @return minimalny kat skretu [deg]
     */
    float GetTwistHorizMax(int nTwistType)
    {
        return CalcTwistExtremum(fTwistHorizMax, nTwistType);
    }

    /** Pobranie minimalnego kata o jaki mozna skrecic cialo AI w pionie (w dol) 
     *  przy uzyciu podanego typu deformacji
     *  @param nTwistType rodzaj deformacji (_TWIST_TYPE_*)
     *  @return minimalny kat skretu [deg]
     */
    float GetTwistVertMin(int nTwistType)
    {
        return CalcTwistExtremum(fTwistVertMin, nTwistType);
    }

    /** Pobranie maksymalnego kata o jaki mozna skrecic cialo AI w pionie (w gore) 
     *  przy uzyciu podanego typu deformacji
     *  @param nTwistType rodzaj deformacji (_TWIST_TYPE_*)
     *  @return minimalny kat skretu [deg]
     */
    float GetTwistVertMax(int nTwistType)
    {
        return CalcTwistExtremum(fTwistVertMax, nTwistType);
    }
    
    
    //////////////////////////////////////////
    // Sledzenie celu glowa
    //

    
    boolean bTrackingHead = false;
    boolean bTrackingHeadIdle = false;
    ControlObject cTrackedObject = null;
    Vector vTrackedPoint = null;
    float fOldLookAngle = 0.0f;
    
    /** Parametry ruszania glowa w stanie idle */
    float fHeadAngle = 0.0f;
    float fHeadAngleSpeed = 0.2f;
    float fHeadMaxAngle = 65.0f;
    float fHeadIdleTime = 7.f;
    float fHeadIdleDir = 1;
    
    
    /** Wlacza losowe ruszanie glowa
     */
    void HeadTrackingIdle()
    {
        if (!bTrackingHead)
        {
            bTrackingHead = true;
            AddTracking();
        }
        bTrackingHeadIdle = true;
        fHeadAngle = 0.0f;
    }
    
    /** Wlacza sledzenie podanego obiektu
     */
    void HeadTracking(ControlObject cObj)
    {
        //LogD("\n");
        if (!bTrackingHead)
        {
            bTrackingHead = true;
            AddTracking();
        }
        cTrackedObject = cObj;
    }
    
    void StopHeadTracking()
    {
        //LogD("\n");
        if (bTrackingHead)
        {
            bTrackingHead = false;
            RemoveTracking();
        }
        bTrackingHeadIdle = false;
        
        TwistBody(0,0,_TWIST_TYPE_NONE);
    }
	
	void HeightTracking()
	{
		if (!bTrackingHeight)
		{
			bTrackingHeight = true;
			AddTracking();
		}
	}
	
	void StopHeightTracking()
	{
		if (bTrackingHeight)
		{
			bTrackingHeight = false;
			RemoveTracking();
		}
	}
	
    
    void UpdateAllTrackings()
    {
        //LogD("\n");
        if (bTrackingHead)
            UpdateTrackingHead();
		
		if (bTrackingHeight)
			UpdateTrackingHeight();
    }
    
	void UpdateTrackingHeight()
	{
		if (GetPosition().fY < _DYING_LEVEL)
			Die();
	}

    boolean bHeadIdleUsesTorso = false;
    
    void UpdateTrackingHead()
    {
        float fAngleH = 0,
              fAngleV = 0;
        
        if(bTrackingHeadIdle)
        {
            fAngleH = fHeadMaxAngle*(float)java.lang.Math.sin( fHeadAngle );
            fHeadAngle+=fHeadAngleSpeed;
        }
        else
        {
            // liczymy wektor kierunku do celu
            Vector vLookTarget = null;
            if(cTrackedObject instanceof ChromeActor)
                vLookTarget = ((ChromeActor)cTrackedObject).GetPointToLookAt(0); //TODO: jakies lepsze wybieranie
            else
                if(vTrackedPoint!=null)
                    vLookTarget = new Vector(vTrackedPoint);
                else
                    return;
            Vector vDir = vLookTarget;
            vDir.Sub(GetLookFromPoint());

            fAngleH = Dir2HorizAngle(vDir);
            fAngleV = -Dir2VertAngle(vDir);
        }
        
        int nTwistType = (bHeadIdleUsesTorso) ? _TWIST_TYPE_HEAD_USE_TORSO : _TWIST_TYPE_HEAD_ONLY;
        float fCroppedAngleH = Crop(fAngleH, GetTwistHorizMin(nTwistType), GetTwistHorizMax(nTwistType)),
              fCroppedAngleV = Crop(fAngleV, GetTwistVertMin(nTwistType), GetTwistVertMax(nTwistType));

        //LogD(fCroppedAngleH + " " + fCroppedAngleV + "\n");
        TwistBody(fCroppedAngleH, fCroppedAngleV, nTwistType);
    }

            
    ////////////////////////////////////
    // Metode pokryte z klas bazowych //
    ////////////////////////////////////
    
    /** metoda inicjalizujaca inventory
     */
    void InitInventory()
    {
		cInventory = (InventoryAI)CreateObjectNoInit("InventoryAI");
        cInventory.Owner = this;
        cInventory.InitObject();
        
        CallMethodIn("FillInventory", 0);
    }

	/**
	 */
	Actor cAIInventoryExecutor = null;
	void ExecuteAIInventory()
	{
		if (cAIInventoryExecutor==null)
			return;
		//sprawdzamy, czy mamy do czynienia z PlayerHUD
        try
        {
			PlayerHUD cPlayerHUD = (PlayerHUD)cAIInventoryExecutor;
			//teraz sprawdzam czy trzeba wlaczyc czy wylaczyc inventory gracza i AI
			if (cPlayerHUD.SetAIInventory(cInventory))
			   bIsCorpseActive = true;
		}
        catch( ClassCastException e) 
        {
            Log("[AIBase.Execute]: AIBase corpse can be executed only by PlayerHUD\n");
        }
		cAIInventoryExecutor = null;
	}
		
	
    /** Obsluga przenoszenia inventory AI do gracza
     */
    void Execute( Actor cExecutor )
    {
        super.Execute( cExecutor );
		
		cAIInventoryExecutor = cExecutor;
		CallMethodIn("ExecuteAIInventory", 0.0f);
    }

    /** Wrzucenie itemow o podanych nazwach do inventory
     */
    void InsertItems(String aItems[], int nItems)
    {
        InvObject cObject;
        for (int i=0; i<nItems; i++)
        {
            if( GetClassID( aItems[i] )!=0)
            {
                cObject = (InvObject)CreateObject(aItems[i]);
                cObject.AddToInventory(this);
            }
        }
    }
    
    /** Wrzucenie przedmiotow do inventory
     */
    void FillInventory()
    {
        String sToken;
        String aItems[] = new String[10]; //max elems in group
        
        //LogD("\n");
        //Najpierw wrzucamy to, co ma miec konkretne AI
        StringTokenizer cItemsIter = new StringTokenizer(sItems, " ,", false);
        while (cItemsIter.hasMoreTokens())
        {
            sToken = cItemsIter.nextToken();
            aItems[0] = sToken;
            InsertItems(aItems, 1);
        }
        
        //A teraz defaultowe rzeczy
        StringTokenizer cDefaultItemsIter = new StringTokenizer(sDefaultItems, " ,+%", true);
        int nGroupItems = 0,
            nProbability = nDefaultItemProbability;
        while (cDefaultItemsIter.hasMoreTokens())
        {
            sToken = cDefaultItemsIter.nextToken();
//            LogD(">" + sToken + "\n");
            if (sToken.compareTo("%")==0)
            {
                if (cDefaultItemsIter.hasMoreTokens())
                {
                    sToken = cDefaultItemsIter.nextToken();
                    try 
                    {
                        nProbability = Integer.valueOf(sToken).intValue();
                    } 
                    catch (java.lang.NumberFormatException e)
                    {
                        LogD("Incorrect probability value!\n");
                        nProbability = nDefaultItemProbability;
                    }
                }
                else
                {
                    LogD("Default items names parsing error!\n");
                    return;
                }
            }
            else if (sToken.compareTo(" ")==0)
                ;
            else if (sToken.compareTo("+")==0)
                ;
            else if (sToken.compareTo(",")==0)
            {
                if (CanHappen(nProbability))
                    InsertItems(aItems, nGroupItems);
                nGroupItems = 0;
                nProbability = nDefaultItemProbability;
            }
            else
            {
                aItems[nGroupItems++] = sToken;
            }
        }
        // wrzucenie ostatniego itema/itemow
        if (CanHappen(nProbability))
            InsertItems(aItems, nGroupItems);
        
    }
    
    ///////////////////////////////////
    // Standardowa obsluga handlerow //
    ///////////////////////////////////

    public void OnCreate()
    {
        /*
        if (bUseNewModel)
        {
            //przepisz nazwe mesha do nazwy pliku ini i zmien rozszerzenie
            int nDotPos = MeshName.lastIndexOf('.');
            if (nDotPos > 0)
                sAnimSeqFile = MeshName.substring(0, nDotPos) + ".scr";
            else
                CrashLog("[AIBase.OnCreate] ERROR: Incorrect mesh name (" + MeshName +
                         ") for using new model!\n");
        }
        else
        {
            sAnimSeqFile = "Data/Meshes/Logan/logan.scr";
        }
        */
       
        super.OnCreate();

        bIsActiveTarget = true;
        
        // wymuszamy aktywowanie obiektu gdy jest kolizja na nim calym
        bForceWholeObjectCollision = true;
        
        // rejestracja wolania metod
        METHOD_OnMakeDecisionEntering   = RegisterCallMethod("OnMakeDecisionEntering");
        METHOD_OnMakeDecision           = RegisterCallMethod("OnMakeDecision");
        METHOD_UpdateMotion             = RegisterCallMethod("UpdateMotion");
//        METHOD_Run                      = RegisterCallMethod("Run");
        METHOD_OnChangeMotionType       = RegisterCallMethod("OnChangeMotionType");
        METHOD_EndOfIdleHead            = RegisterCallMethod("EndOfIdleHead");
        METHOD_UpdateTrackings          = RegisterCallMethod("UpdateTrackings");
        METHOD_WaitForRecoverDone       = RegisterCallMethod("WaitForRecoverDone");
        METHOD_StepDone                 = RegisterCallMethod("StepDone");
        METHOD_OnReact                  = RegisterCallMethod("OnReact");
        METHOD_AnimationTaskFinished    = RegisterCallMethod("AnimationTaskFinished");
        METHOD_PerformAnimTaskSmokeDo   = RegisterCallMethod("PerformAnimTaskSmokeDo");
        
        Initialize();
        InitHumanBody();
        
        // definiujemy zestaw animacji AI
        DefineAnimationSet();
        
        // ustawienie typu kolizji
        SetCollType(ECollFlags.OBJCOL_TYPE_ELLIPSOID);
        SetCollAction(ECollFlags.OBJCOL_ACTION_SLIDE);
        SetCollHandler(ECollFlags.OBJCOL_HANDLER_FULLINFO);
        SetTraceCollType(ECollTraceFlags._ELEMENT_BOX);
        
        // ustawienie flag
        ClearFlag(EFlags._NO_ANIMATION);
        SetFlag(EFlags._CAST_SHADOWS);
        
        if (GetParent() == null)
		{
            SetFlag(EFlags._PORTAL_INDEPENDENT);
		}
//        else
//            CrashLog("DBG: AI " + GetName() + " has parent and isn't portal independent!\n");
                     
        
        SetFlag(EFlags._BLOCK_TRACE);
        
        // AI updejtuje mape kolizji, zeby nikt inny w nie nie wszedl
        UpdatePathMap(true);

        // kazde AI ma fizyke chodzenia...
        SetPhysicsType( EPhysics._WALK );
        // ...ale wlaczamy ja dopiero, jak chodzi
        SetPhysicsActive(false);
        
        // wlaczenie korekcji fizyki cial dla AI chodzacych po ziemi
        Vector vPos = GetPosition();
		
        if (vPos.fY >= TerrainHeight(vPos.fX, vPos.fZ))
            SetFlag(EFlags._PHYSICS_COL_CORRECTION);

        // inicjacja fizyki ciala (po raz drugi, 1. raz w Pawnie)
        PhysicsCreate( 100 );        

        // ustawienie parametru zmiany LODa, bo AI za szybko wlacza kiepskiego
        SetLODCoeff(0.1f);
        
        SetLighting(true);
        
        // uruchamiamy odpowiednio AI, ale po inicjalizacji calego AI
//        CallMethodOnceIn(METHOD_Run, 0.0f); 

        RegisterKeyRequest();
        
        nThisInstanceNumber = nInstances;
        nInstances++;

        if (nThisInstanceNumber == 0) // jednorazowa inicjacja profilingu
        {
/*            PROFILE_UpdateTrackings = ProfileAdd(sAIProfilingPage, "UpdateTrackings");
            PROFILE_UpdateMotion = ProfileAdd(sAIProfilingPage, "UpdateMotion");
            PROFILE_SetupAnims = ProfileAdd(sAIProfilingPage, "SetupAnims");
            PROFILE_BodyDeformStrafe = ProfileAdd(sAIProfilingPage, "BodyDeform");
*/        }
		SetFlag(EFlags._STOPPED_BY_PATHFINDER);
        
		// dodanie ai do teamu (automatycznie jezeli ai ma odpowiedni nTeamID)
		m_TeamsManager.AddTeamMember(this);
		
        ////////////////////////////////////////////////////////////
        // dawne Init wolane z ChromeModule w OnCreate

        OnReactStart();
        // zapamietanie parametrow do respawnowania
        vRespawnPos = GetPosition();
        vRespawnDir = GetForwardVector();
        InitSightRangeVisualisation();
        
        // uruchamiamy odpowiednio AI, ale po inicjalizacji calego AI
        CallMethodIn("Run", 0); //to sie odpali po odfreezowaniu obiektow na levelu
    }
	
    /** Ilosc obiektow pochodzacych od AIBase */
    static int nInstances = 0;
    
    /** Numer kolejny (id instancji) */
    int nThisInstanceNumber = 0;
    

    /** Inicjalizacja rzeczy charakterystycznych dla skinowanego 
     *  modelu bipeda
     */
    void InitHumanBody()
    {
        // pobieramy identyfikatory rak do ustawiania broni w rekach
        nLeftHandID = GetElementID("Left_hand");
        nRightHandID = GetElementID("Right_hand");

        // Inicjalizacja tablicy z identyfikatorami meshelementow 
        InitBodyElemIDs();

        /** Przygotowanie do palenia */
        if (bCanSmoke)
        {
            cCigarette = (MeshObject)CreateObjectNoInit("MeshObject");
            cCigarette.MeshName = sCigaretteMeshName;
            cCigarette.InitObject();
            cCigarette.ClearFlag(EFlags._COLLISION);
            cCigarette.SetFlag(EFlags._NO_ANIMATION);
            cCigarette.SetFlag(EFlags._NO_BODY_PHYSICS);
            cCigarette.SetLighting(true);
            //"Bip01 L Finger2"
            AttachChild(cCigarette, "Bip01 L Finger2");
            cCigarette.SetDirLocal(new Vector(-1,0,0));
            HideCigarette();
        }
    }
    
    /** Inicjalizacja i reinicjalizacja (np. po respawnie AI)
     */
    void Initialize()
    {
        //LogD("\n");
        // Preprocessing
        fAISightAngleCos = (float)Math.cos(fAISightAngle * 0.5f * Math.PI / 180f);
        fAISightRange2 = fAISightRange * fAISightRange;
        f6thSenseRange2 = f6thSenseRange * f6thSenseRange;
        
        InitSightSamplesBuffer();


        // ustawienia prekosci katowej
        SetMaxAngSpeed( fAngSpeed );

        // zerujemy predkosc
        SetSpeed(new Vector());

        bReallyDead = false;
        bActionInProgress = bCriticalActionInProgress = false;

        SetFlag( EFlags._BLOCK_MOVE );
        ClearFlag(EFlags._NO_ANIMATION_REFRESH);

        fHealth            = fStartHealth;
        bDead = false;
        
        bIsSittingBull = bStartInSittingPose;

        
        // magiczne ustawienia elipsoidy
        SetEllipsoid( fEllipsoidRadius[MotionState.SPEED_RUN],
                      fEllipsoidHeight[MotionState.SPEED_RUN],
                      fEllipsoidPos[MotionState.SPEED_RUN]);
		// wlaczamy sprawdzanie, czy ai nie jest ponizej pewnego poziomu
		HeightTracking();
    }
    
    
    ///////////////////////////////////////////////////////////////////////////////////
    // Wizualizacja zasiegu widzenia AI
    //
    
    String sTriangleMeshName = "Data/Interface/triangle.3da";
    
    float fTriangleMaxAngle = 10.f;    
    Vector vTriangleScale = null;
    float fTriangleAlpha = 0;

    float fTriangleXSize = 0;
    float fTriangleZSize = 0;
    
    java.util.Vector vSightRangeVis = new java.util.Vector();

    void InitSightRangeVisualisation()
    {
        int nNumTriangles = (int)(fAISightAngle / fTriangleMaxAngle) + 1;
        int i;
        MeshObject cMO;
        
        /** usuniecie ewentualnych poprzednich trojkatow
         */
        for (i=0; i<vSightRangeVis.size(); i++)
        {
            cMO = (MeshObject)vSightRangeVis.elementAt(i);
            cMO.DeactivateOnModuleAlways();
            cMO.delete();
        }
        vSightRangeVis.removeAllElements();
        
        if (bAllowSightRangeVisualisation)
        {
            fTriangleAlpha = fAISightAngle / (float)nNumTriangles;
            //LogD(fAISightAngle + " #" + nNumTriangles + " *" +  fTriangleAlpha + "\n");
            
            float fCurAngle = -fAISightAngle/2 + fTriangleAlpha;

            vTriangleScale = null;         
            for (i=0; i<nNumTriangles; i++)
            {
                cMO = (MeshObject)CreateObjectNoInit("MeshObject");
                cMO.MeshName = sTriangleMeshName;
                cMO.InitObject();
                //            cMO.ActivateOnModule();
                //            cMO.EnableRendering(true);
                cMO.ClearFlag(EFlags._BLOCK_MOVE);
                cMO.ClearFlag(EFlags._BLOCK_TRACE);

                if (vTriangleScale == null)
                {
                    if (fTriangleXSize == 0 ||
                        fTriangleZSize == 0)
                    {
                        Vector vMin = new Vector();
                        Vector vMax = new Vector();
                        cMO.GetMeshExtents(vMin, vMax);
                        fTriangleXSize = vMax.fX - vMin.fX;
                        fTriangleZSize = vMax.fZ - vMin.fZ;
                    }

                    float fDestX = fAISightRange * (float)(2 * Math.sin(fTriangleAlpha / 2 * (Math.PI/180)));
                    float fDestZ = (float)Math.sqrt(fAISightRange * fAISightRange - 0.25f * fDestX * fDestX);
                    vTriangleScale = new Vector(fDestX / fTriangleXSize, 1, fDestZ / fTriangleZSize);
                }
                vSightRangeVis.addElement(cMO);
            }
            bTrianglesAreVisible = false;
            CallMethodEvery("UpdateSightRangeVis", 0.2f);
        }
    }


    /** Znacznik, ze trojkaty od wizualizacji sa widoczne
     */
    boolean bTrianglesAreVisible = true;
    
    void UpdateSightRangeVis()
    {
        int i;
        
        if (bSightRangeVisualization && !bDead)
        {
            if (!bTrianglesAreVisible)
            {
                for (i=0; i<vSightRangeVis.size(); i++)
                {
                    MeshObject cMO = (MeshObject)vSightRangeVis.elementAt(i);
                    cMO.ActivateOnModule();
                    cMO.EnableRendering(true);
                }
                bTrianglesAreVisible = true;
            }
            Vector vUp = new Vector(1,0,0);
            float fCurAngle = -fAISightAngle/2 + fTriangleAlpha;
            Vector vFwdHd = GetBonePerpVector(EBones._HEAD);
            vFwdHd.fY = 0;
            Vector vPos = GetPosition();
            vPos.fY += 70;
            for (i=0; i<vSightRangeVis.size(); i++)
            {
                MeshObject cMO = (MeshObject)vSightRangeVis.elementAt(i);
                cMO.SetPositionWorld(vPos);
                cMO.SetDir(RotateVector(vFwdHd, fCurAngle, Vector.Up));
                fCurAngle += fTriangleAlpha;
                cMO.SetScale(vTriangleScale);
            }
        }
        else
        {
            if (bTrianglesAreVisible)
            {
                for (i=0; i<vSightRangeVis.size(); i++)
                {
                    MeshObject cMO = (MeshObject)vSightRangeVis.elementAt(i);
                    cMO.DeactivateOnModuleAlways();
                    cMO.EnableRendering(false);
                }
                bTrianglesAreVisible = false;
            }
            if (bDead)
                DisableCallMethod("UpdateSightRangeRes");
        }
    }
    
    
    
    
    
    void OnReactStart()
    {
//DEL        CallMethodOnceIn("OnReactDelayedStart", fUpdateTime * (float)nThisInstanceNumber / (float)nInstances);
        //CallMethodEvery(METHOD_OnReact, fUpdateTime, fUpdateTime * (float)nThisInstanceNumber / (float)nInstances);
        CallMethodEveryMinMax(METHOD_OnReact, fUpdateTime, fUpdateTime * 5, fUpdateTime * (float)nThisInstanceNumber / (float)nInstances);
    }
    
    /* DEL
    void OnReactDelayedStart()
    {
        // wlaczamy myslenie AI
        CallMethodEvery(METHOD_OnReact, fUpdateTime, fUpdateTime);
    }
    */
    
    void RespawnAI()
    {
        DisableVitalActivities();
        PhysicsOff();
        SetPositionWorld(vRespawnPos);
        SetDir(vRespawnDir);
//        SetState("Dummy");
        Initialize();
        OnReactStart();
        UncutBodyParts();
        CallMethodOnceIn("Run", 0);
    }

    void UncutBodyParts()
    {
        if (HasBodyCuttedParts())
        {
            for (int i = 0; i < GetElementsNumber(); i++)
            {
                if (IsBodyPartCutted(GetBoneIDFromMeshElem(i)))
                {
                    UnCutBodyPart(GetBoneIDFromMeshElem(i), true);
                }
            }
        }
    }
    
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        
        //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        //Kto te klawisze kurwa zostawil? poszlo to z demem !!!!!
        //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
        if (!Game._bDbg)
            return;
        
        if ((nKeyCode==EKey._NUMPAD7) && (bKeyState))
        {
            //Initialize(); //przelicz wszystko
            /*
            // zapisz zmiany
            try {
                PrintWriter output = new PrintWriter(new BufferedWriter(new FileWriter("params.txt", true)));
                SaveImportantMembers(output);
                output.close();
            }
            catch (IOException e)
            {
                CrashLog("Can't save members to file!\n");
            }
            */
            
            //PlayAnim(Anims[A_TAKE_HIT], 1);
        }

        if ((nKeyCode==EKey._NUMPAD6) && (bKeyState))
        {
            PlayAnim(Anims[A_DIE], 1);
        }

        if ((nKeyCode==EKey._NUMPAD8) && (bKeyState))
        {
            RespawnAI();
        }
        
        if (nKeyCode==EKey._NUMPAD9)
        {
            if (bKeyState)
            {
                NewTask(_ACTION_GET_DUCKED);
            }
            else
            {
                NewTask(_ACTION_GET_WALKED);
            }
        }
    }
    
    
    void SaveImportantMembers(PrintWriter output)
    {
        output.println("\n----- SESSION START -----\n");
        output.println("[AIBase]");
//        output.println("fAngSpeed = " + fAngSpeed);
//        output.println("fUpdateTime = " + fUpdateTime);
        output.println("fAISightAngle = " + fAISightAngle);
        output.println("fAISightRange = " + fAISightRange);
//        output.println("fMaxSightSamplingTime = " + fMaxSightSamplingTime);
//        output.println("fInSightNecessaryRatio = " + fInSightNecessaryRatio);
//        output.println("f6thSenseRange = " + f6thSenseRange);
//        output.println("fThinkingTime = " + fThinkingTime);
//        output.println("fRecoverTime = " + fRecoverTime);
//        output.println("fChanginModeInterval = " + fChanginModeInterval);
    }
    
    /** Meotda uruchamia pocztkowy stan AI. Ma byc pokryta w kolejnych AI dziedziczonych
     * aby uruchamiac odpowiednie akcje poczatkowe
     */
    public void Run()
    {
        // ustawiamy AI w Idla
        ChooseIdleState();
    }
    
    
    public void ChooseIdleState()
    {
        if (bIsSittingBull)
            SetState("IdleSitting");
        else
            SetState("Idle");
    }
    
    
    boolean bSavedRecoverPlaceGun = false;
    float fSavedRecoverMorphTime;
    
/*    public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        if (Assassin != null)
            LogD("AI was hit by <"+ Assassin.GetName() +">\n");

        boolean wasDead = bDead;

        MakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
        Bleed(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);

        // jak AI nie zyje to nie odbiera energii sobie
        if( !bDead)
        {
            TryToScream(_SCREAMTYPE_PAIN);
            NewTaskExclusive(_ACTION_WAIT_FOR_RECOVER);
        }
        else
        {
            //LogD("PhysicsHit\n");
            //PhysicsHit((byte)nDamageType, vHitLocation, vSpeed, fEffectiveStrength, -1);

            //liczymy frag jesli AI zmienil stan istnienia
            if (wasDead != bDead)
            {
                WeaponThrowAway();
                //cInventory.ThrowInvObjFromHands();
                TryToScream(_SCREAMTYPE_DEATH);
                if (Assassin instanceof Pawn)
                    ((Pawn)Assassin).YouKilledMe(this);
            }
        }
    }
	
    void SuperOnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
	{
        //CrashLog("super on take damage "+ vHitLocation+", "+nDamageType+", "+vSpeed+"\n");
        
        // TODO: odremowac jak sie nie bedzie wypierdalalo!!!!!
        //Physics.Simulate(this, vHitLocation, vSpeed, fDamage, nDamageType);
		super.OnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);		
	}

    void AIBaseOnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        OnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
    }
*/
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if (Assassin != null)
            LogD("AI was hit by <"+ Assassin.GetName() +">\n");

        boolean wasDead = bDead;

        MakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        Bleed(fDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);

        // jak AI nie zyje to nie odbiera energii sobie
        if( !bDead)
        {
            TryToScream(_SCREAMTYPE_PAIN);
            NewTaskExclusive(_ACTION_WAIT_FOR_RECOVER);
        }
        else
        {
            //liczymy frag jesli AI zmienil stan istnienia
            if (wasDead != bDead)
            {
                WeaponThrowAway();
                //cInventory.ThrowInvObjFromHands();
                TryToScream(_SCREAMTYPE_DEATH);
                if (Assassin instanceof Pawn)
                    ((Pawn)Assassin).YouKilledMe(this);
            }
        }
    }
	
    void SuperOnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
	{
		super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);		
	}

    void AIBaseOnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
    }
    
    void WaitForRecoverDone()
    {
        //CrashLog("DBG: WaitForRecoverDone\n");
        SetAnimMorphTime(fSavedRecoverMorphTime);
        bPlaceGun = bSavedRecoverPlaceGun;
        UpdateMotion();
        TaskFinishedQuick();
    }
    
    
    /////////////////////
    // Krzyczenie AI   //
    /////////////////////
    
    /** Wydaj z (okreslonym prawdopodobienstwem) okrzyk podanego typu
     *  @param nScreamType typ okrzyku (stala _SCREAMTYPE_* (<code>int</code>)) 
     */
    void TryToScream(int nScreamType)
    {
        if (CanHappen(aScreamNoiseChance[nScreamType]))
        {
            nLastScreamType = nScreamType;
            MakeNoise(aScreamNoiseLoudness[nScreamType], Pawn._NOISE_SCREAM);
        }
        else
            nLastScreamType = _SCREAMTYPE_UNKNOWN; //skasuj okrzyk
    }
    
    /** Zwraca rodzaj wydanego okrzyku, powinna byc wolana tylko 
     *  w/po OnHearNoise z typem 'scream' 
     */
    public int GetScreamType()
    {
        return nLastScreamType;
    }
    
    /** Powoduje przejscie AI do podanego sposobu poruszania sie.
     * @param nMotionType typ ruchu ze struktury MotionState: SPEED_STILL, SPEED_CRAWL,
     * SPEED_DUCK, SPEED_WALK, SPEED_RUN
     */
    void ChangeMotionMode(byte nMotionMode)
    {
        float fEndTime = fChanginModeInterval;
        //CrashLog("DBG: ChangeMotionMode nMode=" + MotionState.aSpeedNames[nMotionMode] + "\n");
        
        cMotion.iSpeed = nMotionMode;
        
        
        if (nMotionMode == cOldMotion.iSpeed) // jesli nie zmienil sie iSpeed (np. gdy przycelowanie)
            fEndTime = fChanginModeShortInterval;
        // jesli przejscie ze stania do czolgania sie lub na odwrot
        else if ((nMotionMode == MotionState.SPEED_CRAWL && cOldMotion.iSpeed != MotionState.SPEED_DUCK) ||
                 (nMotionMode != MotionState.SPEED_DUCK && cOldMotion.iSpeed == MotionState.SPEED_CRAWL))
            fEndTime = fChanginModeLongInterval;
        
        UpdateMotion();
        //LogD("po UpdateMotion\n");   
        //TODO odpalamy callback z czasem odpowiednim do typu wykonywanej akcji
        //narazie zawsze jest to czas ustalony z gory
        CallMethodOnceIn( METHOD_OnChangeMotionType, fEndTime);
    }
    
    
    void OnPostUpdate()
    {
        PlaceGun();
    }
    
    ///////////////////////////
    // Obsluga widocznosci

    /** Inicjalizacja bufora probek widocznosci
     */
    void InitSightSamplesBuffer()
    {
        nMaxSightSamples = (int)(fMaxSightSamplingTime / fUpdateTime);
        aSightSample = new boolean[nMaxSightSamples+1];
        for (int i=0; i<nMaxSightSamples; i++)
            aSightSample[i] = false;
        nStartSightSample = 0;
        nEndSightSample = 0;
        nSightSamples = 0;
        nIsInSightSamples = 0;
    }
    
    /** Uaktualnienie rozmiaru i zawartosci bufora probek widocznosci
     *  @param fSamplingTime nowy czas gromadzenia probek
     *  @param bIsInSight nowa probka
     */
    void UpdateSightSamplesBuffer(float fSamplingTime, boolean bIsInSight)
    {
        int i, nSteps;
        int nNewSightSamples = (int)(fSamplingTime / fUpdateTime) + 1;
        if (nNewSightSamples > nMaxSightSamples)
            nNewSightSamples = nMaxSightSamples;

        if (nNewSightSamples > nSightSamples)
        {
            // powieksz bufor
            nSteps = nNewSightSamples-nSightSamples;
            for (i=0; i<nSteps; i++)
            {
                nEndSightSample++; nEndSightSample %= nMaxSightSamples + 1;
                aSightSample[nEndSightSample] = false;
            }
            nSightSamples = nNewSightSamples;
        }
        else 
        {
            // zmniejsz bufor, zmodyfikuj nIsInSightSamples o wyrzucone
            nSteps = nSightSamples - nNewSightSamples;
            for (i=0; i<nSteps; i++)
            {
                if (aSightSample[nStartSightSample])
                    nIsInSightSamples--;
                nStartSightSample++; nStartSightSample %= nMaxSightSamples + 1;
            }
            nSightSamples = nNewSightSamples;
        }
        // usun sampla z poczatku, dodaj nowego na koniec
        if (aSightSample[nStartSightSample])
            nIsInSightSamples--;
        nStartSightSample++; nStartSightSample %= nMaxSightSamples + 1;

        nEndSightSample++; nEndSightSample %= nMaxSightSamples + 1;
        aSightSample[nEndSightSample] = bIsInSight;
        if (bIsInSight)
            nIsInSightSamples++;
//        LogD(nIsInSightSamples + "/" + nSightSamples + "\n");
    }

    /** Zwraca czy przeciwnik jest wystarczajaco dlugo w zasiegu widzenia,
     *  zeby go zauwazyc
     */
    boolean ShouldSeeEnemy(float fDistance2)
    {
        if (nSightSamples>0)
        {
            float fDistance2Ratio = fDistance2/fAISightRange2;
            if (fDistance2Ratio>1)
                fDistance2Ratio = 1;
            return ((float)nIsInSightSamples/nSightSamples > 
                    fInSightNecessaryRatio * fDistance2Ratio);
        }
        else
            return true; // bo musi byc b. blisko
    }
    
    /** Zwraca kierunek, w ktorym patrzy AI */
    Vector GetLookDirection()
    {
        return GetBonePerpVector(EBones._HEAD);
    }
    
    /** Zwraca punkt, z ktorego patrzy AI
     */
    Vector GetLookFromPoint()
    {
        return GetBoneJointPos(EBones._HEAD);
    }
    
    /** Sprawdzenie, czy podany punkt znajduje sie w zasiegu widzenia AI
     *  ( w stozku widzenia ) Kierunek patrzenia pobierany z kierunku glowy
     *  @param vPosition badany punkt
     *  @param fRange2 kwadrat zakresu widzenia
     *  @return true, jesli jest w zasiegu
     */
    boolean IsPointInSightRange(Vector vPoint, float fRange2)
    {
        Vector vDirection = new Vector(vPoint);
        vDirection.Sub(GetPosition());
        if (vDirection.Len2() < fRange2) //sprawdz odleglosc
        {
            vDirection.Normalize();
            float fDotToPoint = vDirection.Dot(GetLookDirection());
            if (fDotToPoint > fAISightAngleCos) //sprawdz kat
                return true;
        }
        return false;
    }
    
    
    /** Obiekt ktory zagradza strzal we wroga */
    MeshObject cObstacle = null;
    
    //boolean bIsTargetInSightLog = false;
    /** Sprawdzenie czy podany ChromeActor jest w zasiegu widzenia 
     *  i czy z _HEAD AI jest widoczny jego SPINE1
     *  @param cTarget badany ChromeActor
     *  @param bQuickLook znacznik, ze ma nie uzywac bufora probek widzenia
     *  @param fRange2Modifier mnoznik zakresu widzenia (fAISightRange2), zalezny np. od MotionState celu
     *  @return true gdy jest widoczny
     */
    boolean IsTargetInSight(ChromeActor cTarget, boolean bQuickLook, float fRange2Modifier)
    {
        if (cTarget == null)
            return false;
        Vector vTargetPos = cTarget.GetPosition();
        
        if (vTargetPos == null || GetPosition() == null) // jesli AI albo cel poza gridem
            return false;
        
        float fTargetDist2 = vTargetPos.Distance2(GetPosition());
        boolean bRes = false;
        
        float fSightSamplingTime = (fTargetDist2 / fAISightRange2) * fMaxSightSamplingTime;
        if (fSightSamplingTime < 0)
            fSightSamplingTime = 0;

        if (fTargetDist2 < f6thSenseRange2 )
        {
            /*
            if ( bIsPawnInSightLog )
                 CrashLog("6thSense\n");
            */
            bRes = true;
        }
        else if (IsPointInSightRange(vTargetPos, fAISightRange2 * fRange2Modifier))
        {
            cTarget.SetTraceCollType(ECollTraceFlags._COARSE_BOX);
            // TODO: trace'owac wszystkie punkty zwracane przez Pawn'a
            if (CheckTraceAbsolute(cTarget, 
                                   GetLookFromPoint(), 
                                   cTarget.GetPointToLookAt(0)))
            {
                /*
                if ( bIsPawnInSightLog )
                    CrashLog("Trace OK -> CanSee\n");
                */
                if (!bQuickLook && bUseSightSamplesIntegration)
                {
                    UpdateSightSamplesBuffer(fSightSamplingTime, true);
                    if (ShouldSeeEnemy(fTargetDist2)) //tylko, gdy spelnione warunki czasowe
                    {
                        /*
                        if ( bIsPawnInSightLog )
                            CrashLog("ShouldSeeEnemy\n");
                        */
                        bRes = true;
                    }
                }
                else
                {
                    UpdateSightSamplesBuffer(0, false); // wyczysc bufor
                    /*
                    if ( bIsPawnInSightLog )
                         CrashLog("wyczyscbufor\n");
                    */
                    bRes = true;
                }
            }
            cTarget.SetTraceCollType(ECollTraceFlags._ELEMENT_BOX);
        }
        
        if (!bRes)
            UpdateSightSamplesBuffer(fSightSamplingTime, false);

        /*
        if ( bIsPawnInSightLog )
            CrashLog("updatebufor results:"+bRes+"\n");
        */
        return bRes;
    }
    
    /** Zawolanie IsTargetInSight(ChromeActor, boolean, float) z defaultowymi parametrami
     */
    boolean IsTargetInSight(ChromeActor cTarget, boolean bQuickLook)
    {
        float fRangeModifier;
        
        // w zaleznosci od typu Targeta roznie pobiera sie mnoznik zasiegu widzenia
        if (cTarget instanceof Player)
            fRangeModifier = aAISightRange2Modifier[((Player)cTarget).motion.iSpeed];
        else if (cTarget instanceof AIBase)
            fRangeModifier = aAISightRange2Modifier[((AIBase)cTarget).cMotion.iSpeed];
        else 
            fRangeModifier = 1.f;
        
        return IsTargetInSight(cTarget, bQuickLook, fRangeModifier);
    }
    
    /** Zawolanie IsTargetInSight(ChromeActor, boolean) z defaultowymi parametrami
     */
    boolean IsTargetInSight(ChromeActor cTarget)
    {
        return IsTargetInSight(cTarget, false);
    }

    /////////////////
    // Myslenie AI //
    /////////////////
    
    
    
    /** Wektor z zadaniami AI jakie wykonuje */
    java.util.Vector aTaskQueue = new java.util.Vector(10);
    

    
    /** Znacznik, ze aktualna akcja juz sie wykonuje
     */
    boolean bActionInProgress = false;
    /** Znacznik, ze aktualna akcja jest akcja krytyczna, ktorej nie mozna przerywac
     */
    boolean bCriticalActionInProgress = false;

    /** Dodaje nowe zadanie do wykonania
     */
    void NewTask(int nAction)
    {
        //LogD(nAction + "\n");
        DisableCallMethod( METHOD_OnMakeDecision ); // wyczyszczenie skolejkowanych przez CallMethodIn wywolan OnMakeDecision
        aTaskQueue.addElement(new Integer(nAction));
        
        if(aTaskQueue.size() == 1)
        {
            // wykonujemy zadanie, bo jest jedyne w kolejce
            TakeAction(((Integer)aTaskQueue.elementAt(0)).intValue());
        }
    }
    
    /** Dodaje nowe zadanie do wykonania, ale czysci cala kolejke.
     * Tak dodaje sie zadania w sytuacjach wyjatkowych
     */
    void NewTaskExclusive(int nAction)
    {
        ClearTasks();
        
        aTaskQueue.addElement(new Integer(nAction));
        
        // wykonujemy zadanie, bo jest jedyne w kolejce
        TakeAction(((Integer)aTaskQueue.elementAt(0)).intValue());
    }
    
    /** Czysci czekajace na wykonanie zadania
     */
    void ClearTasks()
    {
        //LogD(aTaskQueue.toString() + "\n");
        DisableCallMethod( METHOD_OnMakeDecision ); // gdyby bylo skolejkowane przez TaskFinished(false)
        if (aTaskQueue.size() > 0)
        {
            // Odwolaj akcje, ktora moze sie aktualnie wykonywac
            CancelAction(((Integer)aTaskQueue.elementAt(0)).intValue());
            // Wyczysc kolejke
            aTaskQueue.removeAllElements();
        }
    }
    
    /** Powinno byc zawolane zeby poinformowac o zakonczeniu wykonywania zadania.
     * Powoduje wykonanie nastepnego zadania oraz gdy nie ma zadan zawolanie myslenia
     * po czasie myslenia.
     */
    void TaskFinishedQuick()
    {
		TaskFinished(true);
    }
    
    /** Powinno byc zawolane zeby poinformowac o zakonczeniu wykonywania zadania.
     * Powoduje wykonanie nastepnego zadania oraz gdy nie ma zadan zawolanie myslenia
     * natychmiastowo.
     */
    void TaskFinished()
    {
        TaskFinished(false);
    }
    
    private void TaskFinished(boolean bQuick)
    {
		if (!bActionInProgress)
		{
			String s = "No action in progress, cannot finish task !!!, object:" +
					   this + " task:";
			if (aTaskQueue.size() > 0)
				s += ((Integer)aTaskQueue.elementAt(0)).intValue();
			else
				s += "no task";
			CrashLog(s + "\n");
			return;
		}
			
        // zaznacz, ze akcja juz sie nie wykonuje
        bActionInProgress = false;
        // wywalamy wykonane juz zadanie
        if( aTaskQueue.size() != 0)
        {
            aTaskQueue.removeElementAt(0);
        } 
        else
        {
            // nie moglo sie zadanie skonczyc, bo nie trwa zadne !!! to blad
            Thread.dumpStack();
        }
        
        // gdy nie ma juz zadan do wykonania to wolamy myslenie, zeby wygenerowalo zadanie
        if( aTaskQueue.size() == 0)
        {
//            LogD("->OnMakeDecision (" + bQuick + ")\n");
            //CallMethodOnceIn( METHOD_OnMakeDecision, bQuick ? 0 : fMinThinkingTime + RandomFloat(fMaxThinkingTime - fMinThinkingTime));
            DisableCallMethod( METHOD_OnMakeDecision );
            CallMethodInMinMax( METHOD_OnMakeDecision, (bQuick ? 0 : fMinThinkingTime + RandomFloat(fMaxThinkingTime - fMinThinkingTime)), (bQuick ? 1.0f : fMaxThinkingTime * 3.0f));
        }
        else
        {
            // sa jeszcze zadania w kolejce to je odpalamy
            TakeAction(((Integer)aTaskQueue.elementAt(0)).intValue());
        }
    }
    
    
    /** Do debugowania
     */
    void ShowTasks()
    {
        CrashLog("Current tasks for " + this + ": " + aTaskQueue.toString() + "\n");
    }
    
    
    /** Metoda zrwaca true z parawdopobienstwem podanym jako prametr.
     * @param fPercentage procentowe prawdopobienstwo ze metoda zwroci true
     */
    boolean CanHappen(int nPercentage)
    {
        return (RandomInt(100) < nPercentage);
    }
    
    void PerformAnimTask(int nAnimID, int nTimes)
    {
        if (nTimes < 0)
            nTimes = 0;

        PlayAnim(nAnimID,nTimes);
                
        CallMethodOnceIn(METHOD_AnimationTaskFinished, nTimes * GetAnimLength(nAnimID));
    }
    
    // dla palenia zrobie wyjatek i rozdziele te animacjejakims losowym czasem
    // niestaty na razie mi to nie dziala - jak sie taska przerwie
    // to i tak te "skolejkowane" animacje sie odgrywaja, musze spytac
    // Pshemka jak to obejsc
    int nPerformAnimSmokeTimes = 0;
    int nPerformAnimSmokeID    = 0;
    void PerformAnimTaskSmoke(int nAnimID, int nTimes)
    {
        if (nTimes < 0)
            nTimes = 0;

        nPerformAnimSmokeID    = nAnimID;
        nPerformAnimSmokeTimes = nTimes;
        
        PerformAnimTaskSmokeDo();
    }
    
    void PerformAnimTaskSmokeDo()
    {
        if ( nPerformAnimSmokeTimes-- <= 0 )
        {
            DisableCallMethod( METHOD_PerformAnimTaskSmokeDo );
            AnimationTaskFinished();
        }
        else
        {
            PlayAnim(nPerformAnimSmokeID,1);    
            CallMethodOnceIn( METHOD_PerformAnimTaskSmokeDo, RandomFloat(1.0f)+GetAnimLength(nPerformAnimSmokeID));
        }
    }
    
    /** Metoda uruchamia podana akcje.
     */
    void TakeAction(int nAction)
    {
        bActionInProgress = true;
        switch(nAction)
        {
        case _ACTION_IDLE_ANIM:
            {
                // wybieramy jedna z animacji
                PerformAnimTask(Anims[A_IDLE_1+RandomInt(3)], 1);
            }
            break;
            
        case _ACTION_IDLE_SMOKE_START:
            {
                PerformAnimTask(Anims[A_IDLE_SMOKE_START], 1);
                CallMethodOnceIn("ShowCigarette", fCigaretteShowTime);
            }
            break;
            
        case _ACTION_IDLE_SMOKE_LOOP:
            {
                PerformAnimTaskSmoke( Anims[A_IDLE_SMOKE_LOOP], 
                                      nCigaretteSmokeCount + RandomInt(nRandomCigaretteSmokeCount));
            }
            break;
            
        case _ACTION_IDLE_SMOKE_END:
            {
                PerformAnimTask(Anims[A_IDLE_SMOKE_END], 1);
                CallMethodOnceIn("HideCigarette", fCigaretteHideTime);
                fLastSmokeTime = GetTime();
            }
            break;
        
        case _ACTION_IDLE_TALK:
            {
                PerformAnimTask(Anims[A_IDLE_TALK], 1);
            }
            break;
            
        case _ACTION_IDLE_HEAD:
            {
                // ruszamy losowo glowa
                HeadTrackingIdle();
                bHeadIdleUsesTorso = CanHappen(30);
                fHeadIdleDir = CanHappen(50) ? 1 : -1;
                    
                CallMethodOnceIn( METHOD_EndOfIdleHead, fHeadIdleTime);
            }
            break;
            
        case _ACTION_THINK:
            {
                // to jest zadanie myslenia, wytarczy odpalic znowu myslenie :)
                TaskFinished();
            }
            break;
            
        case _ACTION_AIMING_ON:
            {
                // przycelowuje naprawde tylko gdy jest to dozwolone
                if ((cMotion.iSpeed != MotionState.SPEED_RUN) &&
                     cMotion.iSpeed != MotionState.SPEED_CRAWL)
                    cMotion.bAiming = true;
                ChangeMotionMode(cMotion.iSpeed);
            }
            break;
            
        case _ACTION_AIMING_OFF:
            {
                cMotion.bAiming = false;
                ChangeMotionMode(cMotion.iSpeed);
            }
            break;
            
        case _ACTION_GET_DUCKED:
            {
                ChangeMotionMode(MotionState.SPEED_DUCK);
            }
            break;
            
        case _ACTION_GET_WALKED:
            {
                ChangeMotionMode(MotionState.SPEED_WALK);
            }
            break;
            
        case _ACTION_GET_CRAWLED:
            {
                ChangeMotionMode(MotionState.SPEED_CRAWL);
            }
            break;
            
        case _ACTION_CHANGE_MOTION:
            {
                // troche dziwne, ale akuteczne
                ChangeMotionMode(cMotion.iSpeed);
            }
            break;
            
        case _ACTION_WAIT_FOR_RECOVER:
            {
                //CrashLog("DBG: _ACTION_WAIT_FOR_RECOVER\n");
                fCurrentRecoverTime = fRecoverTime; //GetAnimLength(Anims[A_TAKE_HIT]);
                bSavedRecoverPlaceGun = bPlaceGun;
                bPlaceGun = false; // wypusc bron z lapy
                fSavedRecoverMorphTime = GetAnimMorphTime();
                SetAnimMorphTime(fCurrentRecoverTime);
                if (!bUseNewModel)
                    PlayAnim(Anims[A_TAKE_HIT], 1);
                CallMethodOnceIn( METHOD_WaitForRecoverDone, fCurrentRecoverTime );
            }
            break;
            
        case _ACTION_BOX_SMOKE_START:
            {
                PerformAnimTask(Anims[A_IDLE_BOX_SMOKE_START], 1);
                CallMethodOnceIn("ShowCigarette", fCigaretteShowTime);
            }
            break;
            
        case _ACTION_BOX_SMOKE_LOOP:
            {
                PerformAnimTask(Anims[A_IDLE_BOX_SMOKE_LOOP], nCigaretteSmokeCount + 
                                                         RandomInt(nRandomCigaretteSmokeCount));
            }
            break;
            
        case _ACTION_BOX_SMOKE_END:
            {
                PerformAnimTask(Anims[A_IDLE_BOX_SMOKE_END], 1);
                CallMethodOnceIn("HideCigarette", fCigaretteHideTime);
                fLastSmokeTime = GetTime();
            }
            break;
            
        default:
            LogD("Unknown action: " + nAction + "\n");
        }
    }

    /** Metoda odwoluje podana akcje
     */
    void CancelAction(int nAction)
    {
        if (bActionInProgress) // tylko jesli sie wykonuje
        {
            switch(nAction)
            {
            case _ACTION_IDLE_SMOKE_START:
            case _ACTION_BOX_SMOKE_START:
                {
                    StopAnim("");
                    DisableCallMethod( METHOD_AnimationTaskFinished );
                    DisableCallMethod("ShowCigarette");
                }
                break;

            case _ACTION_IDLE_SMOKE_END:
            case _ACTION_BOX_SMOKE_END:
                {
                    StopAnim("");
                    DisableCallMethod( METHOD_AnimationTaskFinished );
                    DisableCallMethod("HideCigarette");
                }
                break;

            case _ACTION_IDLE_ANIM:
            case _ACTION_IDLE_SMOKE_LOOP:
            case _ACTION_BOX_SMOKE_LOOP:
            case _ACTION_IDLE_TALK:
                {
                    StopAnim("");
                    DisableCallMethod( METHOD_PerformAnimTaskSmokeDo );
                    DisableCallMethod( METHOD_AnimationTaskFinished );
                }
                break;

            case _ACTION_IDLE_HEAD:
                {
                    StopHeadTracking();                
                    DisableCallMethod( METHOD_EndOfIdleHead );
                }
                break;
                
            case _ACTION_THINK:
                break;
                
            case _ACTION_AIMING_ON:
                {
                    DisableCallMethod( METHOD_OnChangeMotionType );
                }
                break;
                
            case _ACTION_AIMING_OFF:
                {
                    DisableCallMethod( METHOD_OnChangeMotionType );
                }
                break;
                
            case _ACTION_GET_DUCKED:
                {
                    DisableCallMethod( METHOD_OnChangeMotionType );
                }
                break;
                
            case _ACTION_GET_WALKED:
                {
                    DisableCallMethod( METHOD_OnChangeMotionType );
                }
                break;
                
            case _ACTION_GET_CRAWLED:
                {
                    DisableCallMethod( METHOD_OnChangeMotionType );
                }
                break;
                
            case _ACTION_CHANGE_MOTION:
                {
                    DisableCallMethod( METHOD_OnChangeMotionType );
                }
                break;
                
            case _ACTION_WAIT_FOR_RECOVER:
                {
                    bPlaceGun = bSavedRecoverPlaceGun;
                    SetAnimMorphTime(fSavedRecoverMorphTime);
                    DisableCallMethod( METHOD_WaitForRecoverDone );
                }
                break;
                
            default:
                // moze nic sie nie stanie, bo akcja nie wymaga anulowania, ale lepiej info
                LogD("Unknown action: " + nAction + "\n");
            }
        }
        bActionInProgress = false; // juz sie nie wykonuje
    }
    
    
    ////////////////////////////////////////
    // Pomocnicze dla palacza
    
    void ShowCigarette()
    {
        if (cCigarette != null)
        {
            //LogD("\n");
            cCigarette.ActivateOnModule();
            cCigarette.EnableRendering(true);
        }
}
    
    void HideCigarette()
    {
        if (cCigarette != null)
        {
            //LogD("\n");
            cCigarette.DeactivateOnModuleAlways();
            cCigarette.EnableRendering(false);
        }
    }
    
    
    
    //////////////////////////////////////
    // Metody pokryte z TriggeredObject //
    //////////////////////////////////////

    /** Flaga ustawiona gdy mozna przeszukac cialo AI */
    boolean bReallyDead = false;
    
    /** Aktywny tylko jesli nie zyje
     */
    public boolean IsActive(ControlObject Activator)
    {
        if (!bIsCorpseActive) return bReallyDead;
        else return false;
    }
    
    
    /** Wolane po uplynieciu czasu potrzebnego na odegranie animacji
     *  (realizacja zadania)
     */
    void AnimationTaskFinished()
    {
        DisableCallMethod( METHOD_PerformAnimTaskSmokeDo );
        UpdateMotion();
        TaskFinishedQuick();
    }
    
    /** Wolane gdy skonczy sie losowe ruszanie glowa
     */
    void EndOfIdleHead()
    {
        StopHeadTracking();
        TaskFinished();
    }
    
    
    void AIBaseOnChangeMotionType()
    {
        OnChangeMotionType();
    }
    
    void OnChangeMotionType()
    {
    }

    
    /** Sprawdzenie kolizji ze wszystkim z czym sie da
     */
    Collision TraceTerrainObjectsAndTreesExcludeMe(Vector vStart, Vector vEnd)
    {
        Collision cColl = null, cCurrColl;

        cCurrColl = TraceTerrain(vStart, vEnd);
        if (cCurrColl != null)
            cColl = cCurrColl;

        cCurrColl = TraceObjectsExclude(vStart, vEnd, this);
        if (cCurrColl != null)
            cColl = cCurrColl;

        cCurrColl = TraceTrees(vStart, vEnd);
        if (cCurrColl != null)
            cColl = cCurrColl;
        
        return cColl;
    }
    
    
    private float fCurrentMorphTime = fNormalAnimMorphTime;
    
    public void SetAnimMorphTime(float fMorphTime)
    {
        //LogD(fMorphTime + "\n");
        super.SetAnimMorphTime(fCurrentMorphTime = fMorphTime);
    }
    
    public float GetAnimMorphTime()
    {
        return fCurrentMorphTime;
    }

    
    
    /** Identyfikatory meshelementow poszczegolnych kosci nog AI */
    int aLegElemID[] = null;

    /** Identyfikatory meshelementow poszczegolnych kosci kregoslupa AI */
    int aTorsoElemID[] = null;

    
    /** Inicjalizacja tablic a*ElemID
     */
    void InitBodyElemIDs()
    {
        InitTorsoElemIDs();
        InitLegElemIDs();
    }
    
    /** Inicjalizacja tablicy aTorsoElemID
     */
    void InitTorsoElemIDs()
    {
        byte aBoneID[] = {EBones._HEAD, EBones._NECK, 
                         EBones._SPINE1, EBones._SPINE,
                         EBones._PELVIS};
        aTorsoElemID = new int[aBoneID.length];
        for (int i=0; i<aBoneID.length; i++)
            aTorsoElemID[i] = GetMeshElemFromBoneID(aBoneID[i]);
    }
    
    /** Inicjalizacja tablicy aLegElemID
     */
    void InitLegElemIDs()
    {
        byte aBoneID[] = {EBones._L_THIGH, EBones._R_THIGH, 
                         EBones._L_CALF, EBones._R_CALF,
                         EBones._L_FOOT, EBones._R_FOOT };
        aLegElemID = new int[aBoneID.length];
        for (int i=0; i<aBoneID.length; i++)
            aLegElemID[i] = GetMeshElemFromBoneID(aBoneID[i]);
    }

    /** Ustawia AnimMorphTime kosci kregoslupa
     */
    public void SetTorsoAnimMorphTime(float fMorphTime)
    {
        // Dopoki nie bedzie dzialala propagacja, konieczna jest taka petla
        for (int i=0; i<aTorsoElemID.length; i++)
            SetAnimMorphTime(aTorsoElemID[i], fMorphTime, false);
    }
    
    /** Ustawia AnimMorphTime kosci nog
     */
    public void SetLegsAnimMorphTime(float fMorphTime)
    {
        // Dopoki nie bedzie dzialala propagacja, konieczna jest taka petla
        for (int i=0; i<aLegElemID.length; i++)
            SetAnimMorphTime(aLegElemID[i], fMorphTime, false);
    }
    
    /** Optymalizacja majaca na celu zapobiegniecie wielokrotnemu
     *  wrzucaniu metody do kolejki wywolan...
     */
    void CallMethodOnceIn(String funcname, float seconds)
    {
        DisableCallMethod(funcname);
        CallMethodIn(funcname, seconds);
    }
        
    void CallMethodOnceIn(int nFuncID, float seconds)
    {
        DisableCallMethod(nFuncID);
        CallMethodIn(nFuncID, seconds);
    }
    
    
    //////////////////////////////////////////////////////////////////////////////
    // Bazowy stan AI, zawiera defaultowe akcje podejmowane po wejsciu do stanu //
    //////////////////////////////////////////////////////////////////////////////
    public class AIBaseState extends State
    {
        /** Znacznik, ze przed przejsciem do nowego stanu obecny musi po 
         *  sobie posprzatac dluzej, niz jest to mozliwe w OnLeave
         */
        public boolean bNeedTimeToLeave = false;
        
        public void OnEnter()
        {
            // przelaczamy odpowiednio nazwy stanow
            sLastState = sCurrentState;
            sCurrentState = this.getClass().getName();
            
            Log("[" + sCurrentState +".OnEnter]\n");
            
            // wycinamy tylko nazwe stanu
            int nDolar = sCurrentState.indexOf('$');
            sCurrentState = sCurrentState.substring(nDolar+1);
            
            //LogD("sCurrentState = " + sCurrentState + "\n");
            
            // Wyczyszczenie kolejki zadan
            ClearTasks();
            
            //LogD("Po ClearTasks\n");
            // wolamy podjecie decyzji co w stanie robimy przy wejsciu
            CallMethodOnceIn( METHOD_OnMakeDecisionEntering, 0.0f);

            //LogD("Po CallMethodOnceIn\n");
        }
        
        /** Metoda wolana zawsze tuz przed zmiana stanu.
         * Ma ona posprzatac po aktualnym stanie. Szczegolnie przydatne np. przy
         * przerywaniu skomplikowanych akcji.
         */
        public void OnLeave()
        {
            LogD("\n");
            if (bNeedTimeToLeave)
                CallMethodOnceIn("EnterNewState", 0);
        }
        
        /** Ta metoda wola sie gdy zmieni sie tryb poruszania AI np. DUCK.
         * Aktualnie wlaczony tryb mozna pobrac cMotion
         */
        void OnChangeMotionType()
        {
            // Zawolaj OnChangeMotionType dla klasy glownej
            AIBaseOnChangeMotionType();
        }
        
        public void PlayStandAnim()
        {
            PlayAnim( Anims[A_STAND], -1 );
        }
//        public void OnAnimEnd(int iAnimID)
//        {
//            LogD("\n");
//            AnimationFinished(iAnimID);
//        }
        /////////////////////////////////////////
        // Podejmowanie decyzji co ma robic AI //
        /////////////////////////////////////////

        /** Ta metoda musi byc zaimplementowana dla kazdego stanu AI.
         * W niej ma odbywac sie updejtowanie stanu AI, czyli tzw. myslenie AI.
         * Ma ona na celu wywolanie metody NewTask() z okreslona akcja zalezna
         * od warunkow panujaca wokol AI.
         */
        //void OnMakeDecision()
        //{
        //}
        
        /** Podjecie decyzji poczatkowej co robic, zaraz po wejsciu do stanu.
         * Powinno byc mocno uzaleznione od powodu wejscia w stan.
         * TODO rozwazyc czy to wogole ma sens...
         */
        //void OnMakeDecisionEntering()
        //{
        //}
    }
    
//    public void SetAnimMorphTime(float f)
//    {
//        LogD(f + "\n");
//        super.SetAnimMorphTime(f);
//    }
    
    /////////////////////////////////////////////////////
    // Stan Idle podstawowy - reakcja na typowe bodzce //
    /////////////////////////////////////////////////////
    public class Idle extends AIBaseState
    {
        public void OnEnter()
        {
            super.OnEnter();
            
            bPlaceGun = false;
            SetAnimMorphTime(fSlowAnimMorphTime); // w idle'u AI jest troche bardziej leniwe (powolne)
            // wlaczamy animacje stania, bez broni tak poprostu
            cMotion.iSpeed=MotionState.SPEED_STILL;
            UpdateMotion();
            
            //TaskFinishedQuick();
        }
        
        public void OnLeave()
        {
            super.OnLeave();
            SetAnimMorphTime(fNormalAnimMorphTime); //przywroc poprzednia szybkosc
            HideCigarette();
        }
        
        float fInter_SmokeDelay = 0;
        public void OnMakeDecision()
        {
            if ( IdleTaskAvailable() )
            {
                if(CanHappen(80))
                {
                    float fCurTime = GetTime();
                    if(bCanSmoke && CanHappen(20) && (fCurTime - fLastSmokeTime > fInter_SmokeDelay))
                    {
                        NewTask(_ACTION_IDLE_SMOKE_START);
                        NewTask(_ACTION_IDLE_SMOKE_LOOP);
                        NewTask(_ACTION_IDLE_SMOKE_END);
                        fInter_SmokeDelay = fNoSmokingTime + RandomFloat(fRandomNoSmokingTime);
                    }
                    else
                    {
                        if (CanHappen(40))
                            NewTask(_ACTION_IDLE_ANIM);
                        else
                            NewTask(_ACTION_IDLE_HEAD);
                    }
                }
                else
                    NewTask(_ACTION_THINK);
            }
            else
            {
                if (CanHappen(30))
                    NewTask(_ACTION_IDLE_HEAD);
                else
                    NewTask(_ACTION_THINK);
            }
        }
        
        public void OnMakeDecisionEntering()
        {
            NewTask(_ACTION_THINK);
        }
        
        
        
        // pokryta z bazowej
        public void PlayStandAnim()
        {
/*            if (cMotion.iSpeed == MotionState.SPEED_WALK ||
                cMotion.iSpeed == MotionState.SPEED_STILL)
            {
                int nNewIdx = RandomInt(aStandAnimID.length);
                if (nNewIdx != nCurrentStandAnimIdx)
                    nCurrentStandAnimIdx = nNewIdx;
                else
                {
                    nCurrentStandAnimIdx++;
                    nCurrentStandAnimIdx %= aStandAnimID.length;
                }

                //LogD(nCurrentStandAnimIdx + "\n");
                PlayAnim(aStandAnimID[nCurrentStandAnimIdx], 1);
            }
            else
*/
            PlayAnim(Anims[A_STAND], -1);
        }

        
        
        public void OnAnimEnd(int iAnimID)
        {
            /** Zakonczenie obecnej animacji stania 
             */
//            if (iAnimID == aStandAnimID[nCurrentStandAnimIdx])
//                PlayStandAnim();
        }

    }
    
    float fGetUpSpeedZ = 150.f,
          fGetUpSpeedY = 300.f;

    
    /////////////////////////////////////////////////
    // Stan Idle dla AI siedzacego (np. na beczce) //
    /////////////////////////////////////////////////
    
    public class IdleSitting extends Idle
    {
        float fOldAnimMorphTime = 0;

        {
            bNeedTimeToLeave = true; // musi wstac z beczki, co wymaga czasu
        }
        
        public void OnEnter()
        {
            super.OnEnter();
            // Ustaw w pozycji siedzacej, zeby nie morphowal ze stania
            fOldAnimMorphTime = GetAnimMorphTime();
            SetAnimMorphTime(0);
            PlayStandAnim(); // Odpal animacje siedzenia
            CallMethodIn("OnEnterDelayed", 0.0f);
//            RegisterKeyRequest();
        }

        
        public void OnLeave()
        {
            //LogD("\n");
            GetUp();
        }

/**
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if ((nKeyCode==EKey._G) && (bKeyState))
            {
                GetUp();
            }
        }        
*/        
        void OnEnterDelayed()
        {
            SetAnimMorphTime(fOldAnimMorphTime);
        }

        
        float fInter_SmokeDelay = 0;
        public void OnMakeDecision()
        {
            float fCurTime = GetTime();
            if(bCanSmoke && CanHappen(20) && (fCurTime - fLastSmokeTime > fInter_SmokeDelay))
            {
                NewTask(_ACTION_BOX_SMOKE_START);
                NewTask(_ACTION_BOX_SMOKE_LOOP);
                NewTask(_ACTION_BOX_SMOKE_END);
                fInter_SmokeDelay = fNoSmokingTime + RandomFloat(fRandomNoSmokingTime);
            }
            else
            {
                PlayStandAnim();
                NewTask(_ACTION_THINK);
            }
        }
        
        public void OnMakeDecisionEntering()
        {
            NewTask(_ACTION_THINK);
        }
        
        
        /** Wstawanie (zeskakiwanie z beczki)
         */
        public void GetUp()
        {
            ClearTasks();
            bIsSittingBull = false;
            SetPhysicsType(EPhysics._FALL);
            SetPhysicsActive(true);
            SetLocalSpeed(new Vector(0, fGetUpSpeedY, fGetUpSpeedZ));
            PlayAnim(Anims[A_IDLE_BOX_END], 1);
            CallMethodOnceIn("GetUpDone", GetAnimLength(Anims[A_IDLE_BOX_END]));
            //LogD("\n");
        }

        
        public void GetUpDone()
        {
            //LogD("\n");
            SetPhysicsType(EPhysics._WALK);
            SetPhysicsActive(false);
            SetLocalSpeed(Vector.Zero);
            super.OnLeave();
        }
        
        // pokryta z bazowej
        public void PlayStandAnim()
        {
            //if (!bIsSittingBull)
            //    Thread.dumpStack();
            if (bIsSittingBull)
                PlayAnim(Anims[A_IDLE_BOX], -1);
            else
                super.PlayStandAnim();
        }
        
        public void OnAnimEnd(int iAnimID)
        {
        }

    }

    /////////////////////
    // Stan smierci AI //
    /////////////////////
    
    /** Zabicie AI.
     */
    public void Die()
    {
        if (!bDead) // zeby umarl tylko raz
        {
            super.Die();
			//LogLine("Umieram:" + this);
            SetState("Die");
        }
    }
    
    
    /** Funkcja powodujaca wylaczenie reakcji na wszystkie bodzce
     *  wolana po przejsciu do stanu Die; MUSI BYC POKRYTA W KAZDEJ 
     *  KLASIE POCHODNEJ I WOLAC SWOJ ODPOWIEDNIK W KLASIE BAZOWEJ!!!
     */
    public void DisableVitalActivities()
    {
        bActionInProgress = bCriticalActionInProgress = false;
        ClearTasks();
        
        //LogD("\n");
        // zerujemy predkosc
        SetSpeed(new Vector());
        
        // wylaczamy ruszanie cialem
        StopAnim(ROOT_BONE);
        StopAnim(TORSO_BONE);
        
        StopHeadTracking();
		
		StopHeightTracking();
        
        DisableCallMethod( METHOD_OnMakeDecisionEntering );
        DisableCallMethod( METHOD_OnMakeDecision );
        DisableCallMethod( METHOD_UpdateMotion );
//        DisableCallMethod( METHOD_Run );
        DisableCallMethod( METHOD_OnChangeMotionType );
        DisableCallMethod( METHOD_EndOfIdleHead );
        DisableCallMethod( METHOD_UpdateTrackings );
        DisableCallMethod( METHOD_WaitForRecoverDone );
        DisableCallMethod( METHOD_StepDone );
        DisableCallMethod( METHOD_AnimationTaskFinished );
        DisableCallMethod( METHOD_OnReact );

        // igonrujemy wszystkie handlery
        IgnoreHandler("OnHearNoise");
        IgnoreHandler("OnReact");
        //IgnoreHandler("OnTakeDamage");
    }

    AIBase This() {return this;}
    
    public class Die extends AIBaseState
    {
        public void OnEnter()
        {
            super.OnEnter();
            DisableVitalActivities();
            

            if (!bUsePhysicsToDeathFall)
            {    
                // wlaczamy animacje smierci
                PlayAnim( Anims[A_DIE], 1);
            }

            //SetFlag(EFlags._NO_ANIMATION_REFRESH);
            CallMethodOnceIn( "DeathAnimEnd", GetAnimLength(Anims[A_DIE]) );
            
            // zamykamy drzwi na trupie
            ((ChromeModule)GetModule()).GetDoorControler().IsNearDoorable(AIBase.this);
            
            // wlaczamy okrzyk smierci
            if (!bReallyDead)
                PlaySound(aDieSounds[RandomInt(aDieSounds.length)]);
        }

        void DeathAnimEnd()
        {
            // ustawienie flagi, zeby zwloki mozna bylo obszukac
            bReallyDead = true;
            
            // wylaczamy kolizje z cialem lezacym na ziemi
            ClearFlag( EFlags._BLOCK_MOVE );

            SetEllipsoid( fEllipsoidHeight[MotionState.SPEED_RUN],
                          3.0f*fEllipsoidRadius[MotionState.SPEED_RUN],
                          1.5f*fEllipsoidRadius[MotionState.SPEED_RUN]);

            //sprawdzamy jaki detal jest wlaczony
            if( GetShadows() != EShadowModes.SHADOWMAPS )
                ClearFlag(EFlags._CAST_SHADOWS);
            
            //!!!!!! POPRAWIC !!!!!!
            //DisableCallMethods();
        }

/*		public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
		{
            if(bReallyDead)
            {
                //LogD("\n");
                MakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);                
                Bleed(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
            }
			//float fEffectiveStrength = fDamage * 100.0f * vSpeed.Len();
     	    //PhysicsHit((byte)nDamageType, vHitLocation, vSpeed, fEffectiveStrength, -1);
		}
*/
		// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
		public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
		{
            if (bReallyDead)
            {
                MakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);                
                Bleed(fDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
            }
		}
    } 

    public class Dummy extends AIBaseState
    {
        public void OnReact()
        {
        }
        
        public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
        {
        }
    }
    
    /** Sprawdza, czy mozna wlaczyc jakiegos idlowego taska
     */
    boolean IdleTaskAvailable()
    {
        return true;        
    }
	
	void GotMessage(int nMessageID)
	{
        switch (nMessageID)
        {
        case TeamsManager._ACTIVATE_AI:
        case TeamsManager._DEACTIVATE_AI:
            ActivateAI(nMessageID == TeamsManager._ACTIVATE_AI, _FREEZE_ADVENTURE);
            break;
        }
	}
    
/*    
    public int PlayAnim(int anim, int elem)
    {
        Thread.dumpStack();
        return super.PlayAnim(anim, elem);
    }
    */

}
