public class TeamsManager
{
	/** min i max identyfikatory teamow - tylko AI o nTeamID z takiego
	 * zakresu bedzie brana pod uwage przy komunikatach
	 * UWAGA: sa to wartosci bezwzgledne - rowniez nTeamID z przedzialu:
	 * [-_MAX_TEAM_ID; -_MIN_TEAM_ID] naleza do 'teamowych' */
	final static int _MIN_TEAM_ID = 1900;
	final static int _MAX_TEAM_ID = 1999;
	
	/** komunikaty do AI */
	final static int _ATTACK_PLAYER       = 0; // obslugiwany w AIAttacker
	final static int _ACTIVATE_AI         = 1; //obslugiwane w AIBase
	final static int _DEACTIVATE_AI       = 2; //obslugiwane w AIBase
    
	/** wektor teamow */
	java.util.Vector m_Teams = new java.util.Vector();
	
	void SendTeamMessage(AIBase sender, int nTeamID, int nMessage)
	{
		Team team = FindTeam(nTeamID);
		if (team != null)
			team.SendTeamMessage(sender, nMessage);
	}
	
	void AddTeamMember(AIBase ai)
	{
		Team team = AddTeam(ai.nTeamID);
		if (team != null)
			team.AddMember(ai);
	}
	
	Team AddTeam(int nTeamID)
	{
		Team team = FindTeam(nTeamID);
		if (team == null)
			team = new Team(nTeamID);
		m_Teams.addElement(team);
		return team;
	}
    
	boolean IsIDTeamID(int nTeamID)
	{
		if ( ((nTeamID >= _MIN_TEAM_ID) && (nTeamID <= _MAX_TEAM_ID)) ||
             ((nTeamID >= -(_MAX_TEAM_ID)) && (nTeamID <= -(_MIN_TEAM_ID))))
			return true;
		else
			return false;
	}
	
	Team FindTeam(int nTeamID)
	{
		if ( !IsIDTeamID(nTeamID) )
			return null;
		
		Team team = null;
		
		for (int i = 0; i < m_Teams.size(); i++)
		{
			team = (Team) m_Teams.elementAt(i);
			if (team.m_iTeamID == nTeamID)
				return team;
		}
		return null;
	}
}

class Team
{
	int m_iTeamID = 0;
	
	java.util.Vector m_Members = new java.util.Vector();
	
	Team(int nTeamID)
	{
		m_iTeamID = nTeamID;
	}
	
	void AddMember(AIBase member)
	{
		m_Members.addElement(member);
	}
	
	void SendTeamMessage(AIBase sender, int nMessage)
	{
		AIBase ai = null;
		for (int i = 0; i < m_Members.size(); i++)
		{
			ai = (AIBase) m_Members.elementAt(i);
			if (ai != sender)
				ai.GotMessage(nMessage);
		}
	}
}
