public class CameraAI extends CameraExtended
{
    /** Wyskosc na jakiej kamera wisi ponad graczem
     */
	public float  fDeltaCameraY = 0.0f;
    public float  fDeltaCameraX = 0.0f;
 
    /** Player, ktorego pokazuje kamera
     */
    Pawn Target=null;
	
	/** HUD czyli ekranowe wyswietlacze
	 */
	//HUD	cHUD = null;
	
    	
    public void OnActivate()
    {	
        super.OnActivate();
        
		RegisterMouseAxisRequest();
		
		//tworze HUD'a
		//cHUD = (HUD)CreateObject("HUD");
		
			
        // poczatkowe ustawienie widoku
        //FromForwardUpPos(new Vector(-0.5f,0,0.5f), new Vector(0,1.0f,0), new Vector(750.0f, 50.0f, -750.0f));
		if ( Target != null )
        {
            Vector vPlayerPos = Target.GetPosition();
            FromForwardUpPos(  Vector.Forward, Vector.Up, vPlayerPos);
        }
        else
            FromForwardUpPos(  Vector.Forward, Vector.Up, new Vector(0.0f, 0.0f, 0.0f));
        Log("PlayerCamera actvated\n");
		
		
		
    }
    
    
    Vector GetTarget()
    {
        // wyliczamy w co celuje kamera
        Weapon Gun=Target.ActiveWeapon;
        
        // puszczamy trace'a w kierunku patrzenia kamery
                
        // wyliczamy kierunek od pozycji guna do punktu wyznaczonego z trace'a
        
        // zwracamy wyliczony kierunek
        
        //return this.GetForwardVector();
        return Target.GetForwardVector();
    }
    
    public void OnDeactivate()
		
    {
        super.OnDeactivate();
        
        UnregisterMouseAxisRequest();
		//cHUD = null;
    }
    
	public void OnFrame()
    {
        //Log("Frame z kamery\n");
     	if ( Target != null )
		{
			float fDist = 300.0f;
			Vector vPlayerPos		= Target.GetPosition();
			Vector vPlayerDir	    = Target.GetForwardVector();
			Vector vPlayerRight		= Target.GetRightVector();
									
			vPlayerDir.fY += fDeltaCameraY;
            vPlayerDir.fX += fDeltaCameraX;
				
			Vector vCameraPos = new Vector( vPlayerPos.fX - fDist*vPlayerDir.fX,
										    vPlayerPos.fY - fDist*vPlayerDir.fY + 120.0f,
										    vPlayerPos.fZ - fDist*vPlayerDir.fZ );
						
			Vector vCameraDir= new Vector( -vPlayerDir.fX,
										   -vPlayerDir.fY,
										   -vPlayerDir.fZ );
			// dorobic interpolacje
						
			FromForwardUpPos( vCameraDir, Vector.Up, vCameraPos );
		}
	}

    void OnInputMouseAxis(int nAxis, int nDelta)
    {   
		if(nAxis == EMouse._AXIS_Y) 
        {
		   fDeltaCameraY += 0.001*(float)nDelta;
           UpdateCameraTarget();
		}
        if( nAxis == EMouse._AXIS_X ) 
        {
		   fDeltaCameraX += 0.001*(float)nDelta;
           UpdateCameraTarget();
		}
    }

    
    void UpdateCameraTarget()
    {
        // obliczamy w co celuje kamera
        
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[CameraAI.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
		
        if (cFC.GetID() == ESGChunksChrome._CHK_CAMERA_AI)
        {
			super.SGLoadChunk(cFC);			
			
			// Wyskosc na jakiej kamera wisi ponad graczem
			fDeltaCameraY = cFC.LoadFloat();
			fDeltaCameraX = cFC.LoadFloat();
 
			// Player, ktorego pokazuje kamera
			Target = (Pawn)GameObject.cSG.LoadObjectRef(cFC);
        }
		
		cFC.delete();
	}
	
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[CameraAI.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_CAMERA_AI, cFCParent);
		
		super.SGSaveChunk(cFC);

		// Wyskosc na jakiej kamera wisi ponad graczem
		cFC.SaveFloat(fDeltaCameraY);
		cFC.SaveFloat(fDeltaCameraX);
 
		// Player, ktorego pokazuje kamera
		GameObject.cSG.SaveObjectRef(cFC,Target);
					
		cFC.delete();
	}	    	    
}
