public class ChromeFonts extends Fonts
{
    final static String FONT_VERDANA_12 = "Verdana12";
    final static String FONT_VERDANA_14 = "Verdana14";
    final static String FONT_VERDANA_18 = "Verdana18";
    final static String FONT_VERDANA_22 = "Verdana22";
    //final static String JAPANESE = "Japan";
    final static String FONT_HUD_640 = "Konstrukcyjny25";
    final static String FONT_HUD_800 = "Konstrukcyjny32";
    final static String FONT_HUD_1024 = "Konstrukcyjny40";
    final static String FONT_HACK_640 = "Visitor25";
    final static String FONT_HACK_800 = "Visitor32";
    final static String FONT_HACK_1024 = "Visitor40";

    
    static String       FONT_HINT           = FONT_VERDANA_14,
                        FONT_TERMINAL       = FONT_VERDANA_18,    //"FLPismoTechniczne22";
                        FONT_TRIGGER_TIP    = FONT_VERDANA_14, 
                        FONT_HUD            = FONT_VERDANA_12,
                        FONT_HUD_BIGGER     = FONT_VERDANA_18,
                        FONT_STATS          = FONT_VERDANA_14,//statystyki na koniec levelu
                        FONT_TIMER_TITLE    = FONT_VERDANA_18,
                        FONT_TIMER_TIME     = FONT_VERDANA_22,
                        FONT_TIMER_BTN      = FONT_VERDANA_22,
                        FONT_SUBTITLES      = FONT_VERDANA_18,
                        FONT_MENU           = FONT_VERDANA_12;
    
	ChromeFonts()
	{
		if (!FontTest._ON)
        {
            AddFont(FONT_MSSANSSERIF_10, "Microsoft Sans Serif", 10);  
            AddFont(FONT_VERDANA_12, "Verdana", 12);
            AddFont(FONT_VERDANA_14, "Verdana", 14);
            AddFont(FONT_VERDANA_18, "Verdana", 18);
            AddFont(FONT_VERDANA_22, "Verdana", 22);
            //AddFont(JAPANESE, "japanese_font",14);//Text.Get("&japanese&"), 24);
            SetDefaultFont(FONT_MENU);
        }
        else
        {
            AddFont(FONT_MSSANSSERIF_10, "Microsoft Sans Serif", 10);  
            SetDefaultFont(FONT_MSSANSSERIF_10);
        }
    }
    
    String GetProperFont(String sFontID)
    {
        String sProperFont = sFontID;
        if (sFontID.equals("Verdana12"))
        {
            if (m_cModule.GetScreenWidth() >= 1024)
                sProperFont = new String("Verdana14");
        }
        
        if (sFontID.equals("Verdana14"))
        {
            if (m_cModule.GetScreenWidth() <= 640)
                sProperFont = new String("Verdana12");
            else
                if (m_cModule.GetScreenWidth() <= 800)
                    ;
                else
                    if (m_cModule.GetScreenWidth() > 1280)
                        sProperFont = new String("Verdana18");
        }
        if (sFontID.equals("Verdana18"))
        {
            if (m_cModule.GetScreenWidth() <= 640)
                sProperFont = new String("Verdana14");
            else
                if (m_cModule.GetScreenWidth() <= 800)
                    ;
                else
                    if (m_cModule.GetScreenWidth() > 1280)
                        sProperFont = new String("Verdana22");
        }
        
        if (sFontID.equals("Verdana22"))
        {
            if (m_cModule.GetScreenWidth() <= 640)
                sProperFont = new String("Verdana18");
            else
                if (m_cModule.GetScreenWidth() <= 800)
                    ;
                /*else
                    //if (GetScreenWidth() <= 1024)
                    sProperFont = new String("Verdana22");*/
        }
        
        if (sFontID.equals(FONT_HUD_800))
        {
            if (m_cModule.GetScreenWidth() <= 640)
                sProperFont = new String(FONT_HUD_640);
            else
                if (m_cModule.GetScreenWidth() <= 800)
                    ;
                else
                    if (m_cModule.GetScreenWidth() >= 1024)
                        sProperFont = new String(FONT_HUD_1024);
        }
        
        if (sFontID.equals(FONT_HACK_800))
        {
            if (m_cModule.GetScreenWidth() <= 640)
                sProperFont = new String(FONT_HACK_640);
            else
                if (m_cModule.GetScreenWidth() <= 800)
                    ;
                else
                    if (m_cModule.GetScreenWidth() >= 1024)
                        sProperFont = new String(FONT_HACK_1024);
        }
        return sProperFont;
    }
    
    int m_nResolution = -1;
    
    
    void LoadFonts()
    {
        if (FontTest._ON)
            return;
        
        //usuwamy niepotrzebne
        RemoveFonts();
        
        m_nResolution = Game.GetScreenWidth();
        switch (m_nResolution)
        {
        case 640:
            AddAndLoadFont(FONT_HUD_640, "FL Konstrukcyjny 1", 25);
            AddAndLoadFont(FONT_HACK_640, "Visitor", 25);
            break;
        case 800:
            AddAndLoadFont(FONT_HUD_800, "FL Konstrukcyjny 1", 32);
            AddAndLoadFont(FONT_HACK_800, "Visitor", 32);
            break;
        case 1024:
        case 1152:
        case 1280:
        case 1600:
            AddAndLoadFont(FONT_HUD_1024, "FL Konstrukcyjny 1", 40);
            AddAndLoadFont(FONT_HACK_1024, "Visitor", 40);                 
            break;
        }
    }

    boolean AddAndLoadFont(String sFontID, String sTTFName, int iHeight)
    {
        super.AddFont(sFontID, sTTFName, iHeight);
        return m_cModule.LoadFont(sFontID, sTTFName, iHeight);
    }
    
    void RemoveFonts()
    {
        m_nResolution = Game.GetScreenWidth();
        switch (m_nResolution)
        {
        case 640:
            RemoveFont(FONT_HUD_640);
            RemoveFont(FONT_HACK_640);
            break;
        case 800:
            RemoveFont(FONT_HUD_800);
            RemoveFont(FONT_HACK_800);
            break;
        case 1024:
        case 1280:
        case 1600:
            RemoveFont(FONT_HUD_1024);
            RemoveFont(FONT_HACK_1024);                 
            break;
        }
    }
    
    void RemoveFont(String sFontId)
    {
        //GameObject.LogR("ChromeFonts.RemoveFont " + sFontId);
        int nInd = GetFontVectorInd(sFontId);
        if (nInd != -1)
        {
            m_vFonts.removeElementAt(nInd);
        }
        
        m_cModule.ReleaseFont(sFontId);
    }
    
    static void LoadScript()
    {
        ParseKeyword Root = GameObject.ParseFile("Fonts.scr");
        if(Root == null)
        {
            GameObject.CrashLog("No file Fonts.scr!\n");
        }
        else
        {
            ParseKeyword Key, SubKey;
            for (Key = Root; Key != null; Key = Key.GetNext())
            {
                if (Key.Equals("AddFont"))
                {
                    String sFont = Key.GetSParam(0);
                    int nSize = Key.GetIParam(1);
                    String sFormatFile = Key.GetSParam(2);
                    boolean bOldHeightMeasurement = (Key.GetIParam(3) != 0);
                    ChromeFonts.AddFont(sFont + " " + String.valueOf(nSize), sFont, nSize, 0, sFormatFile, bOldHeightMeasurement);
                }
            }
        }
    }

}
