public class ChromeModule extends Module
{
    static boolean _bMultiplayerDemo = false;
    
    /** Nazwa mapy pokazywanej na levelu */
    public FileName sInGameMap = null;//#MAP;
    String GetInGameMapName(){ return sInGameMap==null ? "" : sInGameMap.sName; }
    void   SetInGameMapName(String sName){ /* obslugiwane tylko w ModuleNet*/  }
    
    boolean AmIDedicatedServer(){ return false; }
    
    /**Margines mapy wystajacy poza teren (musi byc taki sam dookola)*/
    public int nMapMargin = 0;//#MAP;Map margin in pixels

    // zasieg na jakim obiekt sie wyfejdowuje
    public float fVisRangeObjectsBlend = 15000.0f;//#VISRANGE
    
    // zasieg na jakim obiekty znikaja
    public float fVisRangeObjects = 25000.0f;//#VISRANGE
    
    // zasieg klipowania kamer defaultowy na levelu
    public float fDefaultClipNear = 10.0f;//#VISRANGE
    
    // zasieg klipowania kamer defaultowy na levelu
    public float fDefaultClipFar = 40000.0f;//#VISRANGE

    // wielkosc obiektu poniezej ktorej sie wyklipuje
    public float fMeshCullSize = 8.0f;//#VISRANGE
    
    // blad do upraszczania terenu
    public float fTerrainError = 8.0f;//#TERRAIN
    
    // flaga okresla czy gracz startuje we wnetrzu i maja byc wlaczone portale
    public boolean bPlayerStartInside = false;//#START
    
    // wylacza wogole slonce na levelu razem z oslepieniem
    public boolean bDisableSun = false;//#SUN;Disables sun and any effect concerning it
    
   
    // wylacza efekt oslepiania slonca
    public boolean bDisableSunBlinding = false;//#SUN;Disables only blinding effect
    
    /** Definicje dzwiekow defaultowych do stawiania krokow na roznych materialach
     * Tablica [TYP_MATERIALU][RODZAJ_PORUSZANIA]
     * RODZAJ_PORUSZANIA:   _STEP_SOUND_MOVE - chodzenie DUCK, WALK, RUN
     *                      _STEP_SOUND_CRAWL - czolganie sie CRAWL
     *                      _STEP_SOUND_FALLDOWN - upadek czyli zeskakiwanie
     *                      _STEP_SOUND_SWIM 
     * W celu zmiany ktoregos dzwieku na levelu nalezy zrobic to w pokrytej
     * metodzie void SetupMotionSounds();
     */
    public String [][]aMotionSounds
        = { {"StepDirt", "StepDirt", "StepDirt", "StepDirt" }, // DIRT
            {"StepWood","StepWood","StepWood","StepWood"}, // WOOD
            {"StepMetal","StepMetal","StepMetal","StepMetal"}, // METAL 
            {"StepPlexi","StepPlexi","StepPlexi","StepPlexi"}, // PLASTIC
            {"","","",""},//GLASS
            {"StepConcrete", "StepConcrete", "StepConcrete", "StepConcrete" }, // CONCRETE
            {"StepPlexi", "StepPlexi", "StepPlexi", "StepPlexi" }, // PLEXIGLASS
            {"StepBody", "StepBody", "StepBody", "StepBody" }, // BODY
            {"","","",""},//ARMOR
            {"StepWater","StepWater","StepWater","StepWater"}, // WATER
          };

    private int [][]aMotionSoundsCounts = null;
    
    public final static int _STEP_SOUND_NONE       = -1;
    public final static int _STEP_SOUND_MOVE       = 0;
    public final static int _STEP_SOUND_CRAWL      = 1;
    public final static int _STEP_SOUND_FALLDOWN   = 2;
    public final static int _STEP_SOUND_SWIM       = 3;

    /** Sciezka z ktorej maja byc pobierane dzwieki krokow na levelu
     */
    public String sMotionSoundsPath = "Data/Sounds/Pawn/Steps/";
    
    // flaga okresla czy film mozna przerwac przez ESC
    boolean bBlockMovieBreak = false;
    
    boolean m_bSubtitlesFromBottom = true;
    
    Barrier []m_tBarriers = null;
    
/***
 * *************************************************************************/
   
    Credits m_cCredits = null;
   
    void InitCredits()
    {
        m_cCredits = (Credits)CreateObject("Credits");
        m_cCredits.MoveTop();
        m_cCredits.Show();
    }
    
    void InitEndCredits()
    {
        m_cCredits = (Credits)CreateObject("EndCredits");
        m_cCredits.MoveTop();
        m_cCredits.Show();
    }
    
    void ShowFirstCreditsEntry()
    {
        m_cCredits.ShowNextEntry();
    }
    
    
    final static int _LEVEL_CANCELED    = 0;
    final static int _LEVEL_INPROGRESS  = 1;
    final static int _LEVEL_FINISHED    = 2;
    final static int _LEVEL_SERVER_FINISHED    = 3;    
    final static int _LEVEL_CLIENT_FINISHED    = 4;
    final static int _LEVEL_CLIENT_FAILED_TO_ENTER_GAME = 5;
    final static int _INVENTORY_MENU_CANCELLED = 6;
    final static int _LEVEL_QUICK_LOADING = 7;
    
    UIWindow m_InventoryWindow = null;
    CursorChrome cCursor = null;
    String sMenuShowName = "";
    String sInventoryMenuName = "ChromeInventoryMenu";
    
    /**sciezka do pliku levelu ktory jest wczytany*/
    public String sPathMapFileName = null;
    
    /** Wskazanie na menu, ktore modul uruchomil
     */
    ChromeMenuModule cMenu = null;

    /** Dane wejsciowe do levelu gry
     */
    GameInitInfo cGameInitInfo = null;

    /** Obiekt 'opiekujacy sie' otwieraniem drzwi
     */
    DoorControler cDoorControler = null;
    
    /** Numer ostatnio pokazywanej kamery trackowanej
     */
    int nLastSetTrackCamera = -1;
    
    /** Chunki ladowane przez ChromeModule
     */
    static final int CHK_JAVA_PATHMAPGENERATOR_FILENAME = 10020;
    static final int CHK_RACE_CHECKPOINT = 10030;	// chunk checkpointow	
	static final int CHK_RACE_CHECKPOINT2 = 10031;	// chunk booleanow, czy AI czy nie
	static final int CHK_RACE_CHECKPOINT3 = 10032;	// chunk punktw dodatkowych    

    /** Aktualny widok gry
     */
    int iViewID = -1;
    
    /** Aktualny widok do filmow
     */
    int iFilmViewID = -1;

    /** Wysokosc paska na ekranie filmu.
     * Wartosc podawana jako procent wysokosci ekranu
     */
    float fBlackFilmBelt = 0.11f;
    
    /** Okresla czy jest aktywny widok do filmu
     */
    boolean bFilmViewActive = false;

    /** Kamera defaultowa na levelu
     */
    FreeCamera cFreeCamera = null;
    
	/** czy robic update inventory pokazujac okno menu - wazne przy przechodzeniu
	 * pomiedzy oknami inventoryroom - implant menu (klawisz back)
	 */
	boolean m_bUpdateInventoryFromScript = true;
	
	/** czy odgrywa sie wlasnie film */
	boolean bMoviePlaying = false;
        
    
    /** System objectivsow */
	ObjectivesManager m_ObjectivesManager = null;//dyn
    ObjectivesManager GetObjectivesManager(){ return m_ObjectivesManager; }
    
            
    void InitObjectives()
    {
        // MZM tworzenie objectives na podstawie skryptow
		m_ObjectivesManager = new ObjectivesManager(this);
        if(cGameInitInfo!=null && cGameInitInfo.cLevels!=null)
		{
			LevelContent level = cGameInitInfo.cLevels.GetCurrent();
			if (level != null)
			{
				m_ObjectivesManager.Init(cGameInitInfo.cLevels.GetCurrent().m_Objectives,
										 cGameInitInfo.cLevels.GetCurrent().m_Locations);
			}
		}
    }
    
    public void OnLoadChunk(int nChkID, int nDataSize, MapInputStream cMapStream)
    {
        super.OnLoadChunk(nChkID, nDataSize, cMapStream);
		
        if( nChkID == CHK_JAVA_PATHMAPGENERATOR_FILENAME)
        {
            try {
                sPathMapFileName = cMapStream.readString();
                //CrashLog("PathMap = " + sPathMapFileName + "\n");
            }
            catch(java.io.IOException e)
            {
                LogD("File error while reading map data (CHK_JAVA_PATHMAPGENERATOR_FILENAME)\n");
            }
        }

    //////////////////////////////////////////////////////
    /////wykorzystanie plugina racer
    /////////////////////////////////////////////////////
        if( nChkID == CHK_RACE_CHECKPOINT )
		{
		}

        if( nChkID == CHK_RACE_CHECKPOINT2 )
		{
		}
		
		if ( nChkID == CHK_RACE_CHECKPOINT3 )
        {
        }
    }
    
    /** Inicjalizacja z uwzglednieniem tworcy levelu
     */
    public void OnCreate(GameObject cCreator)
    {
		bSG = true;
		
        if(cCreator instanceof ChromeMenuModule)
        {
            cMenu = (ChromeMenuModule)cCreator;
            cGameInitInfo = cMenu.cGameInitInfo;
        }
        
        if(cCreator instanceof ChromeGame)
        {
            cMenu = null;
            cGameInitInfo = ((ChromeGame)cCreator).cGameInfo;
        }
        
        SkySetProperShadowDir();
    }
	
    /** Inicjalizacja rzeczy wspolnych dla wszystkich modulow w Chromie
     */
    void OnCreate()
    {
        SetMeshCullSize(fMeshCullSize);
        
        SetDefaultClipping(fDefaultClipNear, fDefaultClipFar);
        
        Pawn.bTerrainError = !Terrain_RecalcErrors(fTerrainError);

        TimerStart();
        
        LoadSoundTemplates("Data/Sounds/Sounds.ini");
        
        SetupMotionSounds();
        
        //fonty sa juz ladowane chromemenumodule, raz wystarczy
        if( Game.cSingleton instanceof ChromeGame)
        {
            if (((ChromeGame)Game.cSingleton).Menu == null)
            {
                fonts = new ChromeFonts();
                fonts.Init(this);
                ((ChromeFonts)fonts).LoadFonts();
            }
        }
        
        //SetVisionClass("AnimActor");
        
        InitFXSystem();

        if (sPathMapFileName != null)
        {
            SetPathMap(sPathMapFileName);
            /** ustawienie parametrow PathFindera na Chrome'owe 
             * (20 krokow, optymalizacja sciezki)
             */
            ConfigurePathFinder(20, false);//HACK - wylaczona optymalizacja, bo srednio dziala
        }

        iViewID = -1;
        
        cFreeCamera = (FreeCamera)CreateObject("FreeCamera");
        SetViewFullscreen(cFreeCamera);
        
        SetMovieSubtitleFont(ChromeFonts.FONT_SUBTITLES);
        
        // inicjalizacja opisow filmow i paskow
        //InitFilmDesc();
        //InitBlackMovieBelts();//paski sa tworzone przy pierwszym pokazaniu
        
        cDoorControler = (DoorControler)CreateObject("DoorControler");
        
        // ustawiamy widok do robienia screenshotow
        if(Game.cSingleton!=null) // dodatkowe sprawdzenie, bo w edytorze mozna gre odpalic
            Game.cSingleton.SetScreenshotView(this, iViewID);
		
        InitLadders();
        
        // zasieg widocznosci obiektow
        SetObjectsVisibilityRange(fVisRangeObjectsBlend, fVisRangeObjects);
        
        // ustawiamy slonce
        SkySunEnable(!bDisableSun);
        SkySetBlinding(!bDisableSunBlinding);
        
        EnableIndoorLighting(false);
        Vector vDir = new Vector(0, -0.1f, 1.0f);
        vDir.Normalize();
        SetDefaultLight(vDir, new Vector(fIndoorAmbientR, fIndoorAmbientG, fIndoorAmbientB), true);
        
        // klampujemy swiatlo do 45 stopni nachylenia
        Vector vShadowSunDir = SkyGetSunShadowDir();
        Vector vDown = new Vector(0, -1.f, 0);
        float fCosAngle = 0;
        if (vShadowSunDir != null)
            vDown.Dot(vShadowSunDir);
        //LogR("ShadowSunDir="+fCosAngle+" vShadowSunDir="+vShadowSunDir+"\n");
        /*
        if(fCosAngle < Math.cos(45.f))
        {
            vShadowSunDir.fY = 0;
            float fLen = vShadowSunDir.Len();
            vShadowSunDir.fY = fLen;
            SkySetSunShadowDir(vShadowSunDir.fX, vShadowSunDir.fY, vShadowSunDir.fZ);
        }
        */
        
        GameObject tBarriers[] = GetObjectsFromClass("Barrier");
        m_tBarriers = new Barrier[tBarriers.length];
        for (int i = 0; i < tBarriers.length; i++)
            m_tBarriers[i] = (Barrier)tBarriers[i];
        
    }
    
    void BulletStarted(Bullet cBullet)
    {
        if ( cBullet != null )
            cBullet.RegisterInInteractionMap();
        if (m_tBarriers != null &&
            m_tBarriers.length > 0)
        {
            for (int i = 0; i < m_tBarriers.length; i++)
            {
                if (m_tBarriers[i].IsEnabled() &&
                    !m_tBarriers[i].bBlockAllByDefault)
                    cBullet.SetInteraction(m_tBarriers[i], false);
            }
        }
    }
    
    
	public void OnPostCreate()
	{
		super.OnPostCreate();
		
        InitializeFlares();
        
        CallOnFrameEnd("DelayedRainSoundInit");
        
        if(bPlayerStartInside)
            CallMethodIn("ActivatePortalSystem", 0f);
	}

    void DelayedRainSoundInit()
    {
/*  /// TODO: wyrzucic to jezeli niepotrzebne
        // wlaczamy dzwiek deszczu
        ControlObject cSpk = GetMainPlayerSpeaker();
        if(cSpk != null)
            RegisterRainListener(cSpk);
*/
    }
    
    public void SetPortalSystemActive(boolean bActive)
    {
        //CrashLog("Activating portal system...\n");
        PortalSystemActive( iViewID, bActive );
    }
    
    public void ActivatePortalSystem()
    {
        //CrashLog("Activating portal system...\n");
        PortalSystemActive(iViewID, true);
    }
    
    public void DeactivatePortalSystem()
    {
        //CrashLog("Deactivating portal system...\n");
        PortalSystemActive(iViewID, false);
    }
	
    public boolean IsPortalSystemActive()
    {
        return IsPortalSystemActive( iViewID );
    }
    
    void InitLadders()
    {
        //ukrycie drabin
        GameObject[] ladders = GetObjectsFromClass("Ladder");
        for(int i=0; i< ladders.length; i++)
            ((Ladder)ladders[i]).EnableRendering(false);
    }
    
    /** Metoda do pokrycia w celu podmiany charakterystycznych dla levelu
     * dzwiekow chodzenia
     */
    void SetupMotionSounds()
    {
        // zliczamy ile jest waveow kazdego typu
        aMotionSoundsCounts = new int[aMotionSounds.length][aMotionSounds[0].length];
        
        for(int i=0; i< aMotionSounds.length; i++)
        {
            for(int j=0; j<aMotionSounds[0].length; j++)
            {
                int nSounds = 0;
                if( (aMotionSounds[i][j]!=null) && (aMotionSounds[i][j].compareTo("") != 0) )
                {
                    //Log("aMotionSounds["+i+"]["+j+"]="+aMotionSounds[i][j]+"\n");
                        
                    int k;
                    for(k=9; k>=0; k--)
                    {
                        String sFile = sMotionSoundsPath + aMotionSounds[i][j] + k + ".wav";
                
                        //Log("Checking: "+sFile+"\n");
                        
                        // skanujemy katalog z dzwiekami
                        java.io.File file = new java.io.File(sFile);
                        
                        if(file.exists()) break;
                    }
                
                    nSounds = k+1;
                }
                 
                //Log("Found "+nSounds+" files\n");
                aMotionSoundsCounts[i][j] = nSounds;
            }
        }
    }
    
    /** Metoda zwraca nazwe dzwieku ktoku dla podanego materialu i sposobu poruszania sie
     * @param nMaterial typ materialu
     * @param nMotion sposob poruszania sie zdefiowany w ChromeModule._STEP_*
     * @return String ze sciezka do wczytania dzwieku
     */
    public String GetStepSound(int nMaterial, int nMotion)
    {
        //LogR("GetStepSound nMaterial="+nMaterial+"\n");
        //FIXIT hack na syf Yoghurta!!!!!!!!!
        if(nMaterial == -1) nMaterial = 2;
        
        // losujemy sobie dzwiek
        String sSound = aMotionSounds[nMaterial][nMotion];
        int nSounds = aMotionSoundsCounts[nMaterial][nMotion];
       
		// sprawdzamy czy dzwiek chodzenia zdefiniowany
        if(nSounds == 0) return null;
        sSound= sSound + RandomInt( nSounds ) + ".wav";

        return sMotionSoundsPath + sSound;
    }
    
    //Inicjalizuje flary ze skasowaniem obiektow flar
    void InitializeFlares()
    {
        GameObject[] aFlares = GetObjectsFromClass("Flare");
        for (int i=0; i<aFlares.length; i++)
        {
            Flare cFlare = (Flare)aFlares[i];
            // tworzymy fxa z flary
            if(cFlare.sFX == null)
                CrashLog("Flare has no FX defined\n");
            else
            {
                ControlObject cParent = cFlare.GetParent();
                if(cParent==null)
                    ExecuteFXLensFlare(cFlare.sFX, cFlare.GetPosition());
                else
                {
                    Vector vLocalPos = cFlare.GetPosition();
                    vLocalPos = cParent.PointWorldToLocal(vLocalPos);
                    ExecuteFXLensFlare(cParent, cFlare.sFX, vLocalPos);
                }
            }
            
            // kasujemy flare, bo po co na jakies tam obiekty
            cFlare.DetachFromParent();
            cFlare.delete();
            cFlare = null;
        }
    }

    // inicjalizuje flary bez kasowania obiektow
/*
    void InitializeFlares()
    {
        GameObject[] aFlares = GetObjectsFromClass("Flare");
        for (int i=0; i<aFlares.length; i++)
        {
            Flare cFlare = (Flare)aFlares[i];
            // tworzymy fxa z flary
            if(cFlare.sFX == null)
                CrashLog("Flare has no FX defined\n");
            else
            {
                ExecuteFXLensFlare(cFlare, cFlare.sFX, Vector.Zero);
            }
            
            cFlare.EnableRendering(false);
            cFlare.ClearFlag(EFlags._COLLISION);
        }
    }
*/
    
    protected void MovieDestroySubtitles()
    {
        if (cSubtitleText != null)
        {
            cSubtitleText.Hide();
            RemoveSprite(cSubtitleText);

            cSubtitleText.delete();
            cSubtitleText = null;
        }
        super.MovieDestroySubtitles();
        
    }
    
    void OnDestroy()
    {
        if(m_ObjectivesManager != null)
        {
            m_ObjectivesManager.Destroy();
        }
        
        if (ImplantSystem.ImplantScript != null)
        {
            ImplantSystem.ImplantScript.delete();
            ImplantSystem.ImplantScript = null;
        }
        
        FadeDeleteSprite();
        // kasujemy rzeczy zwiazane z filmami
        ReleaseBlackMoviesBelts();
        //ReleaseFilmDesc();
        
        // kasowanie widokow
        if( cFreeCamera != null )
        {
            cFreeCamera.delete();
            cFreeCamera = null;
        }
        
        if( cCursor != null)
        {
            cCursor.delete();
            cCursor = null;
        }
        
        if( cDoorControler != null )
        {
            cDoorControler.delete();
            cDoorControler = null;
        }
        
        if (m_cCredits != null)
        {
            m_cCredits.Remove();
            RemoveSprite(m_cCredits);
            m_cCredits.delete();
            m_cCredits = null;
        }
        
        if (m_InventoryWindow != null)
        {
            m_InventoryWindow.Remove();
            RemoveSprite(m_InventoryWindow);
            m_InventoryWindow.delete();
            m_InventoryWindow = null;
        }
        
        if (cSubtitle != null)
        {
            if (nSubtitleTex != 0)
                cSubtitle.ReleaseTexture(nSubtitleTex);
            RemoveSprite(cSubtitle);
            cSubtitle.delete();
            cSubtitle = null;
        }
        if (cSubtitleText != null)
        {
            RemoveSprite(cSubtitleText);
            cSubtitleText.delete();
            cSubtitleText = null;
        }
        
        ImplantSystem.ImplantScript = null;
        
        if (Music.cPlayingMusic != null)
            Music.cPlayingMusic.ForceStop();
        
        Precache.ModuleDestroys(this);
    }

    void OnActivate()
    {
        Music.UpdateVolume();
        ClearInputQueue();
    }
    
    void OnDeactivate()
    {
        Music.UpdateVolume();
        if(cMenu!=null)
        {
            cMenu.Activate();
        }
    }
    
    void ReturnFromMenu()
    {
        //do pokrycia w single i w net 
    }
    
    //////////////////////////////////////////////////////////////////
    // Stan odpowiedzialny za wyswietlenie Inventroy i Inplant roomu//
    //////////////////////////////////////////////////////////////////
        
    public class PrepareToMission extends State  
    {
        public void OnEnter()
        {
            SetInventoryMenu(sInventoryMenuName);
        }
    }
    
    void SetInventoryMenu()
    {
        SetInventoryMenu( sInventoryMenuName );
    }
    
    void SetInventoryMenu(String sMenuName)
	{
		SetInventoryMenu(sMenuName, true);
	}
	
	void SetInventoryMenu(String sMenuName, boolean bUpdateInventoryFromScript)
    {
        LogD("\n");
        sMenuShowName = sMenuName;
		m_bUpdateInventoryFromScript = bUpdateInventoryFromScript;
		
        CallMethodIn("InventoryMenu",0.02f);
    }
    
    void InventoryMenu()
    {
        if (sMenuShowName == null ) 
            return;
        if (m_InventoryWindow == null)
        {
            m_InventoryWindow = CreateInvWindow();
        }
        else
        {
            //((ChromeInventoryMenu) m_InventoryWindow).Init(null);
            ((ChromeInventoryMenu)m_InventoryWindow).PlayerInit();
        }
        ((ChromeInventoryMenu)m_InventoryWindow).CallMethodIn("Activate",0);     
    }
        
    UIWindow CreateInvWindow()
    {
        Sprite cSprite = null;
        int nTex = 0;
        if (!(this instanceof ModuleNet))
        {
            cSprite = (Sprite)CreateObject("Sprite");
            AddSprite(cSprite);
            cSprite.SetFont("Verdana22");
            cSprite.SetTextPosFlags(ESpriteText.CENTER);
            cSprite.Show();
            cSprite.SetPos(new Vector());
            cSprite.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(),0));
            nTex = cSprite.AddTexture("er_t_black.png");
            cSprite.SetTexture(nTex, new Rect(0,0,1,1));
            cSprite.MoveTop();
            cSprite.DisplayText(Text.Get("&MENU_MAIN_PLEASE_WAIT&"));
            ForceRender();
        }  
        
        UIWindow cMenu = (UIWindow) CreateObject(sInventoryMenuName);
        AddSprite(cMenu);
        ((ChromeInventoryMenu) cMenu).Init(null);
        cMenu.Hide();
        
        if (!(this instanceof ModuleNet))
        {
            cSprite.ReleaseTexture(nTex);
            RemoveSprite(cSprite);
            cSprite.delete();
        }
        
        return cMenu;
    }
    
    void EndPrepareToMission()
    {
        sMenuShowName = null;
        CallMethodIn("InventoryMenu", 0.02f);    
    }
   
    void RestoreAfterInventoryMenu()
    {
        EndPrepareToMission();
    }
    
/****** OBSLUGA DRZWI ****************************************************************/    
    
    /** metoda wywolywana gdy na levelu otworzona zostanie jakas brama */
    /*public void GateOpened(String sGateName)
    {
        //LogD(": Gate "+sGateName+" has opened \n");   
    }*/
    
    /** metoda wywolywana gdy na levelu zamknie sie jakas brama */
    /*public void GateClosed(String sGateName)
    {
        //LogD(": Gate "+sGateName+" has opened \n");   
    }*/
    
    
/****** VIDOKI ****************************************************************/
 
    void SetViewFullscreen(Camera cam)
    {
        // wylaczamy widok od filmow
        if(bFilmViewActive)
        {
            ListenerOnViewActive(iFilmViewID, false);
            DeactivateView(iFilmViewID);
            
            bFilmViewActive = false;
        }
        
        
        if (iViewID == -1)
        {
            iViewID = AddView(cam, 0.f, 0.f, 1.f, 1.f);
            ForceClearView(iViewID, true);
        }

        ActivateView(iViewID);
        SetViewCamera(iViewID, cam);
        ListenerOnViewActive(iViewID, true);

        RegisterRainObserver(cam);
        
        if (Precache.bPrecaching)
            MuteAllSounds();//nie chcemy jeszcze slyszec deszczu
    }

    void RegisterRainObserver(Camera cam)
    {
        /// TODO: wpisac parametry zasiegu slyszalnosci deszczu
        RegisterRainObserver( cam, 450.f, 1000.f );
    }
    
    /** Metoda wlacza film z uwzglednieniem portali
     * @param bForcePortal gdy =true to na filmie beda portale wlaczone
     */
    void SetViewMovie(Camera cam, boolean bForcePortal)
    {
        SetViewMovie(cam);
        PortalSystemActive(iFilmViewID, bForcePortal);
    }
    
    void SetViewMovie(Camera cam)
    {
        if( iFilmViewID == -1 )
        {
            // wyliczamy ile zakryc ekranu
            float fStripeWidth = fBlackFilmBelt * (float)GetScreenHeight();

            iFilmViewID = AddView(cam, 0, (int)fStripeWidth, GetScreenWidth(), GetScreenHeight()-(int)(fStripeWidth*2.0f));
            ForceClearView(iFilmViewID, true);
        }
        
        // wlaczamy widok z kamery movie
        ActivateView(iFilmViewID);
        SetViewCamera(iFilmViewID, cam);
        ListenerOnViewActive(iFilmViewID, true);
        
        // wylaczamy view od normalnego ogladania
        if(iViewID != -1)
        {
            ListenerOnViewActive(iViewID, false);
            DeactivateView(iViewID);
        }

        bFilmViewActive = true;
    }

    void SetViewPercent(Camera cam, float fOriginX, float fOriginY, float fSizeX, float fSizeY)
    {
        if (iViewID >=0)
        {
            RemoveView(iViewID);
            iViewID = -1;
        }
        
        iViewID = AddView(cam, fOriginX, fOriginY, fSizeX, fSizeY);
        ForceClearView(iViewID, true);
        ListenerOnViewActive(iViewID, true);
    }
    
/****** FILMY ****************************************************************/
    
    //czarne sprite'y
    Sprite cBlack1 = null, cBlack2 = null;
    int iTex = 0;
    
    void InitBlackMovieBelts()
    {
        if (cBlack1 != null && cBlack2 != null)
            return;
        //sprite'y zastawiajace
        cBlack1 = (Sprite)CreateObject("Sprite");
        cBlack2 = (Sprite)CreateObject("Sprite");

        iTex = cBlack1.AddTexture("Data/Interface/ER_T_Black.png");
        cBlack1.SetTexture(iTex, new Rect(0, 0, 1, 1));
        cBlack2.SetTexture(iTex, new Rect(0, 0, 1, 1));

        AddSprite(cBlack1);
        AddSprite(cBlack2);
        cBlack1.MoveTop();
        cBlack2.MoveTop();
    }
    
    void ShowBlackMoviesBelts()
    {
        InitBlackMovieBelts();
        
        float fStripeWidth = fBlackFilmBelt * (float)GetScreenHeight();
        
        cBlack1.SetPos(new Vector());
        cBlack1.SetSize(new Vector(GetScreenWidth(), fStripeWidth, 0));
        cBlack1.Show();
        
        cBlack2.SetPos(new Vector(0, GetScreenHeight() - fStripeWidth, 0));
        cBlack2.SetSize(new Vector(GetScreenWidth(), fStripeWidth, 0));
        cBlack2.Show();
    }
    
    void HideBlackMoviesBelts()
    {
        if (cBlack1 != null)
            cBlack1.Hide();
        if (cBlack2 != null)
            cBlack2.Hide();
    }
    
    void ReleaseBlackMoviesBelts()
    {
        if (cBlack1 != null)
        {
            RemoveSprite(cBlack1);
            cBlack1.ReleaseTexture(iTex);
            cBlack1.delete();
            cBlack1 = null;    
        }
        if (cBlack2 != null)
        {
            RemoveSprite(cBlack2);
            cBlack2.delete();
            cBlack2 = null;
        }
    }
    
    
    
    int nSubtitleTex = 0;
    Sprite cSubtitleText = null;
    public void OnShowSubtitle(String sText, int iSubNumber)
    { 
        iSubtitleNumber = iSubNumber;
        
        if (cSubtitle != null)
        {
            if (cBlack2 != null && cBlack2.IsVisible())
            {
                int nSizeX = GetScreenWidth() - 2*nSubtitlesLeftMargin;
                cSubtitle.SetSize(new Vector(nSizeX,GetScreenHeight(),0));
                    
                cSubtitle.DisplayText(sText);
                int nSizeY = (int)cSubtitle.GetTextExtent(sText).fY;
                cSubtitle.SetSize(new Vector(nSizeX, nSizeY, 0));
                    
                int nPosY = 0;
                if (m_bSubtitlesFromBottom)
                {
                    nPosY = GetScreenHeight() - nSizeY - nSubtitlesDownMargin;
                }
                else
                {
                    nPosY = (int)cBlack2.GetPos().fY + nSubtitlesDownMargin;
                    //nie pozwolimy na wyjscie poza ekran
                    if (nPosY + nSizeY > GetScreenHeight())
                        nPosY = GetScreenHeight() - nSizeY - nSubtitlesDownMargin;
                }
            
                cSubtitle.SetPos(new Vector(nSubtitlesLeftMargin,nPosY,0));//new Vector(nSubtitlesLeftMargin, GetScreenWidth() - nSizeY - nSubtitlesDownMargin, 0.0f));
            }
            else
            {
                if (cSubtitleText == null)
                {
                    nSubtitleTex = cSubtitle.AddTexture("er_t_black.png");
                    cSubtitle.SetTexture(nSubtitleTex, new Rect(0,0,1,1));
                    cSubtitle.SetAlpha(0.66f);
                    
                    cSubtitleText = (Sprite)CreateObject("Sprite");
                    cSubtitleText.SetNoTexture();
                    cSubtitleText.ProcessMouse(false);
                    cSubtitleText.SetTextColor( 1.0f, 1.0f, 1.0f, 1.0f );
                    cSubtitleText.SetSize(new Vector(1024.0f, 768.0f,0));
                    cSubtitleText.SetPos(new Vector(10.0f, 455.0f, 0));
                    cSubtitle.AddChild(cSubtitleText);
                    
                    cSubtitleText.MoveTop();
                    cSubtitleText.Show();
                    cSubtitleText.SetFont(ChromeFonts.FONT_SUBTITLES);
                    cSubtitleText.SetTextPosFlags(ESpriteText.MULTILINE);
                    
                }
                int nSizeX = GetScreenWidth() - 2*nSubtitlesLeftMargin;
                cSubtitleText.SetSize(new Vector(nSizeX,GetScreenHeight(),0));
                
                cSubtitleText.DisplayText(sText);
                int nSizeY = (int)cSubtitleText.GetTextExtent(sText).fY;
                cSubtitleText.SetSize(new Vector(nSizeX, nSizeY, 0));
                cSubtitle.SetSize(new Vector(GetScreenWidth(), nSizeY + nSubtitlesDownMargin, 0));
                int nPosY = GetScreenHeight() - nSizeY - nSubtitlesDownMargin;
                
                cSubtitle.SetPos(new Vector(0,nPosY,0));
                cSubtitleText.SetPos(new Vector(nSubtitlesLeftMargin,nPosY + nSubtitlesDownMargin/2,0));//new Vector(nSubtitlesLeftMargin, GetScreenWidth() - nSizeY - nSubtitlesDownMargin, 0.0f));
                cSubtitle.MoveTop();
                cSubtitle.Show();

            }
            
            cSubtitle.MoveTop();
            cSubtitle.Show();
        }
    }
    
    
    /** Akcja zakonczenia misji na filmie */
    act_MovieEnd cMovieEndAction = null;
    
    /** Metoda wolana po zakonczeniu filmu */
    String sEndFilmMethod = null;
    GameObject cEndFilmMethodTarget = null;

    // OBSOLETE!!!!! for backward compatiblity
    void PlayFilm(int nFilm, String sMethod)
    {
        //PlayFilm(nFilm, sMethod, null, false, false, true, true, true);
    }
    
    Movie cMoviePlaying = null;
    
    // odegranie podanego filmu
    void PlayMovie(Movie cMovie)
    {
        cMoviePlaying = cMovie;
        
        // sprawdzamy czy film wogole sie fejduje
        if( cMoviePlaying.fMovieFadeIn == 0.0f &&
            cMoviePlaying.fMovieFadeOut == 0.0f &&
            cMoviePlaying.fWorldFadeIn == 0.0f &&
            cMoviePlaying.fWorldFadeOut == 0.0f)
        {
            PlayMovieInternal();
        }
        else
        {
            // wrzucamy fejdowanie filmu
            SetState("MovieState");
        }
    }
    
    public void StopMovieFade()
    {
        //CrashLog("[ChromeModule.StopMovie]\n");
        
        if(IsMoviePlaying() &&
           !bFadingOutMovie && 
           (cMoviePlaying!=null) )
        {
            if(CurrentState instanceof MovieState)
            {
                if(cMoviePlaying.fMovieFadeOut > 0.0f)
                {
                    DisableCallMethod("FadeOutMovieBeforeEnd");
                    
                    MovieState cMovieState = (MovieState)CurrentState;
                    cMovieState.FadeOutMovieBeforeEnd();
                }
                else
                {
                    StopMovie();
                }
            }
            else
            {
                StopMovie();
            }
        }
    }

    float PlayMovieInternal()
    {
        //CrashLog("cMoviePlaying="+cMoviePlaying+"\n");
        if(cMoviePlaying == null) return 0.0f;
        
        bBlockMovieBreak = !cMoviePlaying.bBreakable;
        
        SetMovieParams(!cMoviePlaying.bNoSubtitles);
        
        // budujemy nazwe filmu
        String sMovieName = "Film";
        if(cMoviePlaying.nMovie>=10)
            sMovieName = sMovieName + cMoviePlaying.nMovie;
        else
            sMovieName = sMovieName + "0" + cMoviePlaying.nMovie;

        // wlaczamy film
        PlayMovie(sMovieName, !cMoviePlaying.bFreezeGame, true);
        
        return GetMovieLength(sMovieName);
    }

    boolean bMovieView = false;
    
    public void ShowMovieView()
    {
        // blokujemy gre na czas filmu
        ShowBlackMoviesBelts();
        
        bMovieView = true;
        
        Camera cam = GetViewCamera(iMovieViewID);
        RegisterRainObserver(cam);
    }
    
    public void ShowWorldView()
    {
        HideBlackMoviesBelts();
        
        bMovieView = false;
        
        Camera cam = GetViewCamera(iViewID);
        RegisterRainObserver(cam);
    }
    
    /** Handler otrzymywany przed odegraniem filmu */
    public void OnStartMovie()
    {
        super.OnStartMovie();
        
        //TODO wywalic to jak Kuba poprawi w C
        //ShowMovieView();
        
		bMoviePlaying = true;
        
        // wolamy metode po zakonczeniu filmu
        if(cMoviePlaying!=null)
            cMoviePlaying.OnMovieStart();
        
        // gdyby okazalo sie, ze nagle filmy zaczely szarpac, sprobowac to przywrocic, ale
        // trzeba pamietac, ze to powoduje freeze przed filmami...
        //System.gc();
        TimerSetSmoothing(10);
    }
    
    /** Handler otrzymywany po odegraniu filmu */
    public void OnEndMovie()
    {
        //LogR("[ChromeModule.OnEndMovie]\n");
        TimerSetSmoothing(0);
        super.OnEndMovie();
        
        //ShowWorldView();
        
		bMoviePlaying = false;
		
        // wolamy metode po zakonczeniu filmu
        if(cMoviePlaying!=null)
        {
            //LogR("[ChromeModule.OnEndMovie] cMoviePlaying.OnMovieEnd\n");
            cMoviePlaying.OnMovieEnd();
            cMoviePlaying = null;
        }
    }
    
    public void SuperOnEndMovie()
    {
        super.OnEndMovie();
    }

    public void OnLevelViewsActivated(boolean bActivated)
    {
        super.OnLevelViewsActivated(bActivated);

        //LogR("[ChromeModule.OnLevelViewsActivated] bActivated="+bActivated+"\n");
        
        if(bActivated)
            ShowWorldView();
        else
            ShowMovieView();
    }
    
/****** AI ****************************************************************/
    void FreezeAI()
    {
        GameObject[] aAIs = GetObjectsFromClass("NewAI");
        for(int i=0; i< aAIs.length; i++)
            ((NewAI)aAIs[i]).Freeze();
    }
    
    void UnfreezeAI()
    {
        GameObject[] aAIs = GetObjectsFromClass("NewAI");
        for(int i=0; i< aAIs.length; i++)
            ((NewAI)aAIs[i]).Unfreeze();
    }
    
/****** CALLBACKI ****************************************************************/

    /** Callack wolany przez ChromeActora gdy umiera (zawolana metoda Die w ChromeActor)
     */
    void ChromeActorDied(ChromeActor cActor)
    {
    }

	/** wolane, gdy inventory object w inventory gracza zostanie
	 * z niego usuniety (wyrzucony, przelozony do inv AI itp.)
	 */
	public void OnPlayerInvObjectRemoved(InvObject invObj)
	{
	}

/****** INNE ****************************************************************/
    Player GetMainPlayer()
    {
        return null;
    }
    
    /** Funkcja umozliwiajaca pobranie DoorControlera dla modulu
     */
    DoorControler GetDoorControler()
    {
        return cDoorControler;
    }
	
/****** TYMCZASOWO FADE EKRANU BY POKAZAC INFO ****************************************************************/
	
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
	}
	
	String m_sTitle = "";
	String m_sText = "";
	boolean bInFadeState = false;
	
	public void ShowInfoScreen(String sTitle, String sText)
	{
		m_sTitle = sTitle;
		m_sText = sText;
		bInFadeState = true;
		SetState("ShowInfo");
	}
	
    public class ShowInfo extends FadeScene
    {
		InfoScreen screen = null;
	
        public void OnEnter()
        {
            super.OnEnter();
			
			FadeOut(2f);
			
			screen = new InfoScreen();
			screen.DisplayScreen(ChromeModule.this, m_sTitle, m_sText);
        }
		
        void OnFadeOutEnd()
        {
            bInFadeState = false;
            
			super.OnFadeOutEnd();
			
			screen.Black();
			ChromeModule.this.TimerStop();
        }

        void OnFadeInEnd()
        {
			super.OnFadeInEnd();
			
			bInFadeState = false;
			//TODO: poprawic to - przywracac poprzedni stan
        }
		
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
			if (bInFadeState)
			{
				if (bKeyState && nKeyCode == EKey._ESCAPE)
				{
					ChromeModule.this.TimerStart();
					screen.DeleteScreen();
					screen = null;
					FadeIn(2f);
				}
			}
			else
            {
                ChromeModule.this.OnInputKey(nKeyCode, bKeyState, nKeyAscii);
            }
        }
    }
	
    private Sprite cFade = null;
    private int FadeBackgroundTex = 0;
    
    void FadeCreateSprite(Module mod)
    {
        if (cFade == null)
        {
            cFade = (Sprite) CreateObject("Sprite");
	        FadeBackgroundTex = cFade.AddTexture("Data/Textures/FadeNoAlpha.png");
	        cFade.SetTexture(FadeBackgroundTex,new Rect(0f, 0f, 1f, 1f));
	        cFade.SetPos(new Vector(0f, 0f, 0f));
	        cFade.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0f));
	        cFade.ProcessMouse(false);
	        mod.AddSprite(cFade);
            cFade.Show();
            cFade.MoveTop();
            
            cFade.SetName("cFade");
        }
    }
    
    void FadeForceBlack()
    {
        FadeCreateSprite(this);
        cFade.SetAlpha(1.f);
    }
    
    void FadeDeleteSprite()
    {
        if (cFade != null)
        {
            cFade.Hide();
            cFade.ReleaseTexture(FadeBackgroundTex);
			RemoveSprite(cFade);
            cFade.delete();
            cFade = null;
            bInFadeState = false;
        }    
    }

    void ShowFade(boolean bShow)
    {
        if(bShow)
        {
            cFade.Show();
            cFade.MoveTop();
        }
        else
            cFade.Hide();
    }
    
    public class FadeScene extends State
    {
        private boolean bFade, bFadeIn, bFadeOut;
        private float fStartTime = 0f;
        private float fFadeTime = 0f;
        private float fFadeProg = 0f;
        float fUpdateTime = 0.01f;
        
        private boolean bFadeMusic = false;
        
        void FadeInWithMusic(float fTime) { FadeIn(fTime, true); }
        void FadeIn(float fTime) { FadeIn(fTime, false); }
        void FadeIn(float fTime, boolean bMusic)
        {
            bInFadeState = true;
            
            bFadeMusic = bMusic;
            
            fFadeProg = 1f;
			FadeCreateSprite(ChromeModule.this);
		    cFade.SetAlpha(fFadeProg);
            
            fFadeTime = fTime;
            fStartTime = GetAbsoluteTime();
            
            bFade = true;
            bFadeIn = true;
            bFadeOut = false;
            CallMethodIn("UpdateFade", fUpdateTime);
        }
        
        
        void FadeOutWithMusic(float fTime) { FadeOut(fTime, true); }
        void FadeOut(float fTime) { FadeOut(fTime, false); }
        void FadeOut(float fTime, boolean bMusic)
        {
            bInFadeState = true;
            
            bFadeMusic = bMusic;
            
            fFadeProg = 0f;
			FadeCreateSprite(ChromeModule.this);
            cFade.SetAlpha(fFadeProg);
            
            fFadeTime = fTime;
            fStartTime = GetAbsoluteTime();
            
            bFade = true;
            bFadeOut = true;
            bFadeIn = false;
            CallMethodIn("UpdateFade", fUpdateTime);
        }

        void OnFadeInEnd()
        {
            bInFadeState = false;
        }
        
        void OnFadeOutEnd()
        {
            bInFadeState = false;
        }
        
        
        void UpdateFade()
        {			
            if (bFade)
            {
                float fDeltaTime = GetAbsoluteTime() - fStartTime;
                
                if (fDeltaTime > fFadeTime)
                {
                    bFade = false;
                    if (bFadeIn)
                    {
                        bFadeIn = false;
                        OnFadeInEnd();
                        
                        if(cFade!=null)
                            cFade.SetAlpha(0f);
                        
                        if(bFadeMusic && (cMoviePlaying != null) && (cMoviePlaying.cMusic != null))
                            cMoviePlaying.cMusic.Fade(1f);
                    }
                    
                    if (bFadeOut)
                    {
                        bFadeOut = false;
                        OnFadeOutEnd();
                        
                        if(cFade!=null)
                            cFade.SetAlpha(1f);

                        if(bFadeMusic && (cMoviePlaying != null) && (cMoviePlaying.cMusic != null))
                            cMoviePlaying.cMusic.Fade(0f);
                    }
                }
                else
                {
                    if (bFadeIn)
						fFadeProg = 1f - fDeltaTime * 1f / fFadeTime;
                    
                    if (bFadeOut)
						fFadeProg = fDeltaTime * 1f / fFadeTime;
                    
                    if(cFade!=null)
                        cFade.SetAlpha(fFadeProg);
                    
                    if(bFadeMusic && (cMoviePlaying != null) && (cMoviePlaying.cMusic != null))
                            cMoviePlaying.cMusic.Fade(1f - fFadeProg);
                    
                    CallMethodIn("UpdateFade", fUpdateTime);
                }
            }
        }
		
		public void SGLoad(FileChunk cParentFC)
		{
			FileChunk.Log("[ChromeModule$FadeScene] : SGLoad\n");
			
			FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
			if (cFC.GetID() == ESGChunksChrome._CHK_CAMERA_PLAYER_MODE_FPP_STATE)
			{
				super.SGLoad(cFC);

				bFade = cFC.LoadBool();
				bFadeIn = cFC.LoadBool();
				bFadeOut = cFC.LoadBool();
						
				fStartTime = cFC.LoadFloat();
				fFadeTime = cFC.LoadFloat();
				fFadeProg = cFC.LoadFloat();
				fUpdateTime = cFC.LoadFloat();
					
				bFadeMusic = cFC.LoadBool();							
			}
			
			cFC.delete();
		}
	
		public void SGSave(FileChunk cParentFC)
		{
			FileChunk.Log("[ChromeModule$FadeScene] : SGSave\n");
			
			FileChunk cFC = NewChunk(ESGChunksChrome._CHK_CAMERA_PLAYER_MODE_FPP_STATE, cParentFC);
			
			super.SGSave(cFC);
			
			cFC.SaveBool(bFade);
			cFC.SaveBool(bFadeIn);
			cFC.SaveBool(bFadeOut);
				
			cFC.SaveFloat(fStartTime);
			cFC.SaveFloat(fFadeTime);
			cFC.SaveFloat(fFadeProg);
			cFC.SaveFloat(fUpdateTime);
			
			cFC.SaveBool(bFadeMusic);			
			
			cFC.delete();
		}				
    }
    
    boolean bFadingOutMovie = false;
    
    public class MovieState extends FadeScene
    {
        boolean bStartAfterFadeOut = false;
        
        public void OnEnter()
        {
            PlayerHUD MainPlayer = (PlayerHUD)GetMainPlayer();
            if(MainPlayer != null)
                MainPlayer.HUD.DisallowActivate();
            
            if(cMoviePlaying != null)
            {
                if( cMoviePlaying.fWorldFadeOut > 0.f)
                {
                    // wygaszamy gre
                    bStartAfterFadeOut = true;
                    FadeOut(cMoviePlaying.fWorldFadeOut);
                }
                else
                    StartMovie();
            }
        }
        
        public void OnFadeInEnd()
        {
            bInFadeState = false;
            
            if(cMoviePlaying == null)
                SetState("Idle");
        }
        
        public void OnFadeOutEnd()
        {
            bInFadeState = false;
            
            if(bStartAfterFadeOut && (cMoviePlaying != null))
            {
                bStartAfterFadeOut = false;
                StartMovie();
            }
            
            if(bFadingOutMovie)
            {
                ChromeModule.this.StopMovie();
                
                bFadingOutMovie = false;
            }
        }
 
        void StartMovie()
        {
            if(cMoviePlaying == null) return;
            
            // gra wygaszona, wlaczamy film
            float fMovieDuration = PlayMovieInternal();
			
			if(cMoviePlaying == null) return;

            FadeInWithMusic(cMoviePlaying.fMovieFadeIn);
            
            // wlaczamy wyfejdowanie
            if(cMoviePlaying.fMovieFadeOut > 0.f)
            {
                DisableCallMethod("FadeOutMovieBeforeEnd");
                CallMethodIn("FadeOutMovieBeforeEnd", fMovieDuration - cMoviePlaying.fMovieFadeOut);
            }

            bFadingOutMovie = false;
        }
        
        void FadeOutMovieBeforeEnd()
        {
            bFadingOutMovie = true;
            
            //CrashLog("FadeOutMovieBeforeEnd Now="+GetAbsoluteTime()+"\n");
            
            if(cMoviePlaying.fMovieFadeOut > 0.f)
            {
                FadeOutWithMusic(cMoviePlaying.fMovieFadeOut);
            }
        }
        
        /** Handler wolany po zakoczeniu filmu */
        public void OnEndMovie()
        {
            DisableCallMethod("FadeOutMovieBeforeEnd");

            // nie ma fejda gdy koniec misji
            if(cMovieEndAction == null)
                FadeIn(cMoviePlaying.fWorldFadeIn);
            
            ChromeModule.this.OnEndMovie();

            // wlaczenie akcji MovieEnd
            if(cMovieEndAction != null)
            {
                // jest akcja zakonczenia misji - wracamy do gry
                SetState("Idle");
                
                // i wlaczamy koniec misji
                cMovieEndAction.InvokeMissionEnd();
                cMovieEndAction = null;
                
                FadeForceBlack();
            }
        }
				
		public void SGLoad(FileChunk cParentFC)
		{
			FileChunk.Log("[ChromeModule$MovieState] : SGLoad\n");
			
			FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
			if (cFC.GetID() == ESGChunksChrome._CHK_CAMERA_PLAYER_MODE_FPP_STATE)
			{
				super.SGLoad(cFC);

				bStartAfterFadeOut = cFC.LoadBool();
			}
			
			cFC.delete();
		}
	
		public void SGSave(FileChunk cParentFC)
		{
			FileChunk.Log("[ChromeModule$MovieState] : SGSave\n");
			
			FileChunk cFC = NewChunk(ESGChunksChrome._CHK_CAMERA_PLAYER_MODE_FPP_STATE, cParentFC);
			
			super.SGSave(cFC);
						
			cFC.SaveBool(bStartAfterFadeOut);			
			
			cFC.delete();
		}
		
		public void SGUpdate()
		{
			FileChunk.Log("[ChromeModule$MovieState] : SGUpdate\n");
		}
    }
    
    // stan kiedy level zachowuje sie normalnie
    public class Idle extends State
    {
    }
    
    /** Pobranie speaker'a z glownego gracza
     */
    ControlObject GetMainPlayerSpeaker()
    {
        if ( GetMainPlayer() != null )
            return GetMainPlayer().GetSpeaker();
        return null;
    }

    Camera GetActiveViewCamera()
    {
        return GetViewCamera(iViewID);
    }
    
    static Vector l_vCameraDistance = new Vector();
    
    /** Zwraca wektor miedzy kamera a podanym punktem
     */
    Vector GetCameraDistanceVector(Vector vPos)
    {
        Camera cCamera = GetViewCamera(iViewID);
        cCamera.GetPosition(l_vCameraDistance);
        l_vCameraDistance.Sub(vPos);
        return l_vCameraDistance;
    }
        
    /** Zwraca odleglosc podanego punktu do kamery
     */
    float GetCameraDistance(Vector vPos)
    {
        return GetCameraDistanceVector(vPos).Len();
    }
    
    /** Zwraca kwadrat odleglosci podanego punktu do kamery 
     */
    float GetCameraDistance2(Vector vPos)
    {
        return GetCameraDistanceVector(vPos).Len2();
    }
    
    void OnCameraEnvironmentChange(int iEnv)
    {
        //CrashLog("OnCameraEnvironmentChange iEnv="+iEnv+"\n");
        super.OnCameraEnvironmentChange(iEnv);
        if (iEnv == 2)//under water
        {
            if (GetMainPlayer() != null)
                GetMainPlayer().SetUnderWater(true);
            else
                Tools.CrashLogError("Camera underwater, but no player");
        }
        else
        if (iEnv == 1)
        {
            if (GetMainPlayer() != null)
                GetMainPlayer().SetUnderWater(false);
        }
        else
        {
            if (GetMainPlayer() != null)
                GetMainPlayer().SetUnderWater(false);
        }
    }
    
	////////////////////////////////////////////////////////////////
	// Mgla dla filmow
	//
	protected int m_nFogTypeBeforeDisable = -1;
	/** Wylaczeniu mgly na potrzeby filmu z zapamietaniem typu na potrzeby EnableFog */
	public void DisableFog()
	{
		if (m_nFogTypeBeforeDisable == -1 &&
			FogGetType() != 0)
		{
			m_nFogTypeBeforeDisable = FogGetType();
			FogSetType(0);
		}
	}

	/** Przywrocenie mgly po wylaczeniu jej przez DisableFog */
	public void EnableFog()
	{
		if (m_nFogTypeBeforeDisable != -1 &&
			FogGetType() == 0)
		{
			FogSetType(m_nFogTypeBeforeDisable);
			m_nFogTypeBeforeDisable = -1;
		}
	}

	
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    boolean bActivatePortalSystem = false;
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[ChromeModule.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);

        if (cFC.GetID() == ESGChunksChrome._CHK_CHROMEMODULE)
        {
            super.SGLoadChunk(cFC);
            
            if(cFade!=null)
                cFade.SetAlpha(0f);			
            
            // Okresla czy jest aktywny widok do filmu
            bFilmViewActive = cFC.LoadBool();    	
            // czy odgrywa sie wlasnie film 
            bMoviePlaying = cFC.LoadBool();
            
            m_ObjectivesManager.SGLoadChunk(cFC);
            
            bActivatePortalSystem = cFC.LoadBool();
            
            cMoviePlaying = (Movie)cFC.LoadObjectRef();
            
            m_nFogTypeBeforeDisable = cFC.LoadInt();
            
            bBlockMovieBreak = cFC.LoadBool();
            
            GameObject[] aObjs = GetObjectsFromClassModule("SoundEmitter", this);
            
            if (cFC.LoadBool() != (aObjs != null))
                CrashLog("ERROR !!! Number of SoundEmitters is diffrent form that saved in file !!!\n");
            
            if (aObjs != null)
            {
                if (cFC.LoadInt() != aObjs.length)
                    CrashLog("ERROR !!! Number of SoundEmitters is diffrent form that saved in file !!!\n");
                for (int i=0; i < aObjs.length; i++)
				{
                    if (cFC.LoadBool())
                        ((SoundEmitter)aObjs[i]).Enable();
                    else
                        ((SoundEmitter)aObjs[i]).Disable();
				}
            }
            
            m_nFogTypeBeforeDisable = cFC.LoadInt();
            
            NativeSGLoadInteractionMap(cFC);
			
			cMovieEndAction = (act_MovieEnd)cFC.LoadObjectRef();
            
            cFC.LoadBool(); bFadingOutMovie = false;
        }
        
        cFC.delete();
    }
	
	public void SGReinitializeSoundEmitters()
	{
        GameObject[] aObjs = GetObjectsFromClassModule("SoundEmitter", this);
                        
        if (aObjs != null)
        {
            for (int i=0; i < aObjs.length; i++)                    
			{
				if (aObjs[i] != null)
					((SoundEmitter)aObjs[i]).Check();
			}
        }		
	}
    
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[ChromeModule.SGSaveChunk]\n");
        
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_CHROMEMODULE, cFCParent);
        
        super.SGSaveChunk(cFC);
        
        // Okresla czy jest aktywny widok do filmu
        cFC.SaveBool(bFilmViewActive);    	
        // czy odgrywa sie wlasnie film 
        cFC.SaveBool(bMoviePlaying);
        
        // System objectivsow
        m_ObjectivesManager.SGSaveChunk(cFC);

        // zapisujemy czy system portali jest aktywny w widoku gry tzn. czy jestesmy w budynku
        boolean bPortalActive = IsPortalSystemActive(iViewID);
        
        //CrashLog("bPortalActive="+bPortalActive+"\n");
        
        cFC.SaveBool( bPortalActive );
        
        cFC.SaveObjectRef(cMoviePlaying);
        if((cMoviePlaying == null) && IsMoviePlaying())
        {
            CrashLog("[ChromeModule] cMoviePlaying==null and some movie playing!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
        }

        cFC.SaveInt(m_nFogTypeBeforeDisable);
        
        cFC.SaveBool(bBlockMovieBreak);

        GameObject[] aObjs = GetObjectsFromClassModule("SoundEmitter", this);		
        cFC.SaveBool(aObjs != null);			
        if (aObjs != null)
        {
            cFC.SaveInt(aObjs.length);			
            for (int i=0; i < aObjs.length; i++)
                cFC.SaveBool(!((SoundEmitter)aObjs[i]).IsEnabled());		
        }
        
        cFC.SaveInt(m_nFogTypeBeforeDisable);

        NativeSGSaveInteractionMap(cFC);
		
		cFC.SaveObjectRef(cMovieEndAction);
        
        cFC.SaveBool(bFadingOutMovie);
        
        cFC.delete();
    }
    
    public void SGUpdate()
    {
        FileChunk.Log("[ChromeModule.SGUpdate]\n");
        
        super.SGUpdate();
        
        if (bActivatePortalSystem)
            CallMethodIn("ActivatePortalSystem", 0f);
        else
            CallMethodIn("DeactivatePortalSystem", 0f);
		
		CallMethodIn("SGReinitializeSoundEmitters",0.5f);
        
        if(cMoviePlaying == null)
        {
            if(IsMoviePlaying())
            {
                CrashLog("[ChromeModule.SGUpdate] cMoviePlaying==null and some movie playing!!!!!!!!\n");
            }
            
            // hack
            StopMovie();
        }
    }
}