/** Terminal sterujacy roznymi rzeczami na levelu.
 */
public class ComputerTerminalNew extends AnimatedScreen
{
    public String m_sHUDHackTitle = "&HUD_HACK_COMPUTER_SCREEN_TITLE&";//#MENU;HUD title
    
    //Ile sekwencji do shackowania
    public int m_nHackSequenceCount = -1;//#MENU;Hack sequences count, Count x Combo must be even and no more then 34
    //zlozonosc sekwencji
    public int m_nHackSequenceCombo = -1;//#MENU;Hack sequence complexity
    //ilosc dostepnych ruchow w zagadce
    public int m_nHackMovesCount = -1;//#MENU;Hack moves count
    // definicja menu goscia TODO zmiana nazwy
    public mnu_Element[] aMenuGuest = null;//#MENU
    
    // definicja menu admina tzn. po zahackowaniu
    public mnu_Element[] aMenuAdmin = null;//#MENU
    
    
    public boolean m_bCanSuccessfullyHack = true;//#MENU;Czy mozna shackowac komputer, jesli false, to losowo oswieza sie lamiglowka
    
    //================== parametry edytora ===========================
    // ::method - metoda z modulu
    // method - methoda lokalna

    String sGuestMenu = "&Lights&..[&Back&(Back) &Turn_On&(TermCom3) &Turn_Off&(LightsOff)] &WC_Doors&..[&Back&(Back) &Open&(WCOpen) &Close&(WCClose)] &Login_as_superuser&(Admin) disable_button(ExampleCommand1) enable_button(ExampleCommand2)";
    String sAdminMenu = "&Robots&..[&Back&(Back) &Turn_On&(::TermCom1) &Turn_Off&(::TermCom2)] &Doors&..[&Back&(Back) &Open&(::DoorsOpen) &Close&(::DoorsClose)]";
    String sLoginPrompt = "&ENTER_PASSWORD&";
    
    // dzwieki
    static String sSoundTextClick = "Data/Sounds/Menu/textclick.wav";
    static String sSoundShowLine = "Data/Sounds/Menu/showline.wav";
    static String sSoundButtonClick = "Data/Sounds/Menu/bong.wav";
    static String sSoundMoveScreen = "Data/Sounds/Menu/hud_move.wav";
    static String sSoundHacking  = "Data/Sounds/Menu/hacking.wav";
    static String sWrongPassword = "Data/Sounds/Menu/wrong.wav";
    static String sLetterGuessed = "Data/Sounds/Menu/guessed.wav";


    //===============================================================
    
    protected mnu_Submenu cMenuGuest = null;
    protected mnu_Submenu cMenuAdmin = null;

    protected PlayerHUD user = null;

    protected MenuScreen_ screen = null;

    int nKlawiaturaID = -1;
    
    HUDHack m_cHudHack = null;
    
    public void OnCreate()
    {
        super.OnCreate();
		
		bSG = true;

        /* niepotrzebne, bo menu jest juz zrobione
        if ( ((cMenuGuest = BuildMenu(sGuestMenu)) == null) ||
             ((cMenuAdmin = BuildMenu(sAdminMenu)) == null) )
        {
            CrashLog("ERROR: "+this+": Cannot build terminal menu\n");
        }
        else
        {
            cMenuGuest.sName = "Guest";
            cMenuAdmin.sName = "Superuser";
            LogD("Menu built:\nguest:"+cMenuGuest +"\nadmin:"+cMenuAdmin+"\n");
        }
        */

        // podpinamy menu
        cMenuGuest = (mnu_Submenu)CreateObject("mnu_Submenu");
        cMenuAdmin = (mnu_Submenu)CreateObject("mnu_Submenu");
        
        // podlaczamy menu
        cMenuGuest.aSubMenu = aMenuGuest;
        cMenuGuest.sName = Text.Get("&HUD_HACK_MENU_GUEST&");
        cMenuGuest.PropagateParents(null);
        
        cMenuAdmin.aSubMenu = aMenuAdmin;
        cMenuAdmin.sName = Text.Get("&HUD_HACK_MENU_ADMIN&");
        cMenuAdmin.PropagateParents(null);
        cMenuAdmin.parent = cMenuGuest;
        
        nKlawiaturaID = GetElementID("Klawiatura");
        
        // wlaczamy komputer
        bActiveTrigger = true;

        if (((ChromeModule)GetModule()).cMenu == null)
            return;
        
        LevelContent cLevel = ((ChromeModule)GetModule()).cMenu.cGameInitInfo.cLevels.GetCurrent(); 
        //LogR("Start m_nHackSequenceCount " + m_nHackSequenceCount);
        if (m_nHackSequenceCount == -1)
        {
            m_nHackSequenceCount = RandomInt(cLevel.m_nHackElemsMin, cLevel.m_nHackElemsMax);
            m_nHackSequenceCombo = cLevel.m_nHackCombo;
           
        }
        if (m_nHackMovesCount == -1)
            m_nHackMovesCount = (int)(cLevel.m_fHackMovesMult * ChromeGame.GetHackDiffLevelMult() * (float)m_nHackSequenceCount);
        else        
            m_nHackMovesCount = (int)((float)m_nHackMovesCount * ChromeGame.GetHackDiffLevelMult());
        
        //LogR("m_nHackSequenceCount " + m_nHackSequenceCount +
             //"\nm_nHackSequenceCombo " + m_nHackSequenceCombo);
        
    }

    /** Pokryte zeby podswietlala sie sama klawiatura */
    void GetTriggerExtents(Camera cam, Vector vMinExtent, Vector vMaxExtent )
    {
        GetScreenExtents(cam, vMinExtent, vMaxExtent, nKlawiaturaID);
    }
  
    void Execute( Actor executor )
    {
        if (! (executor instanceof PlayerHUD) )
            return;
        
        HUDManager cHUDManager = ((PlayerHUD)executor).HUD;
            
        if ( cHUDManager == null )
            return;
        
        m_cHudHack = cHUDManager.GetHUDHack();
        
        m_cHudHack.SetTitle(m_sHUDHackTitle);
        
		// nie mozemy zaktywowac, jezeli inny hud jest aktywny
		if (cHUDManager.m_bIsUserHUDActive)
		    return;
            
		cHUDManager.m_bIsUserHUDActive = true;
        
		
        super.Execute(executor);

        //potrzebujemy playera
        try
        {
            user = (PlayerHUD)executor;
        } catch( ClassCastException e) {
            Log("[Weapon.Execute]: Can be used only by Player\n");
            user = null;
            return;
        }
        
        //zablokuj gracza
        user.MouseUnacquire(false);
        user.UnregisterKeyRequest();
        //wylaczenie HUD INV_USE - z itemami
        //user.HUD.aHUDComponent[HUDManager._INV_USE].Deactivate();
        user.SetActiveTrigger(null);
        user.bDisableTriggerDetection = true;

        //stworz i wyswietl menu
        screen = m_cHudHack.GetMenuScreen();
        screen.InitControls(GetModule(), this, aMenuGuest != null, m_cHudHack, m_nHackMovesCount, m_nHackSequenceCount, m_nHackSequenceCombo);
        screen.Login();
        
        bActiveTrigger = false;
        
        ChromeModuleSingle cModule = (ChromeModuleSingle)GetModule();
        cModule.cCurrentTerminal = this;
    }

    
    public void ScreenExit()
    {
        LogR("screenexit!\n");
		// mozna aktywowac inne hudy
		//HUDManager.m_bIsUserHUDActive = false;
        //przeniesione nizej, by MK
		
        bActiveTrigger = true;
        
        if (user != null)
        {
            user.HUD.m_bIsUserHUDActive = false;
            user.MouseAcquire();
            user.RegisterKeyRequest();
            //user.HUD.aHUDComponent[HUDManager._INV_USE].Activate();  
            m_cHudHack.Deactivate();
            user.bDisableTriggerDetection = false;
            user = null;
        }

        screen.CallMethodIn("DestroyControls", 0);
            
        ChromeModuleSingle cModule = (ChromeModuleSingle)GetModule();
        cModule.cCurrentTerminal = null;
    }

    /** Aktywny tylko jesli nie zyje
     */
    public boolean IsActive(ControlObject Activator)
    {
        return bActiveTrigger;
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************	
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[ComputerTerminalNew.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_COMPUTER_TERMINAL_NEW)
        {	
			super.SGLoadChunk(cFC);
			
			user = (PlayerHUD)cFC.LoadObjectRef();
    
            cFC.LoadObjectsTable(aMenuGuest);
            cFC.LoadObjectsTable(aMenuAdmin);
            
            m_bCanSuccessfullyHack = cFC.LoadBool();
            m_nHackSequenceCount = cFC.LoadInt();
            m_nHackSequenceCombo = cFC.LoadInt();
            m_nHackMovesCount = cFC.LoadInt();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[ComputerTerminalNew.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_COMPUTER_TERMINAL_NEW, cFCParent);
		
		super.SGSaveChunk(cFC);
		
        // gupio, ze sie to zapisuje
		cFC.SaveObjectRef(user);
				
		cFC.SaveObjectsTable(aMenuGuest);
		cFC.SaveObjectsTable(aMenuAdmin);
        cFC.SaveBool(m_bCanSuccessfullyHack);	
        cFC.SaveInt(m_nHackSequenceCount);
        cFC.SaveInt(m_nHackSequenceCombo);
        cFC.SaveInt(m_nHackMovesCount);
        cFC.delete();
    }	    					
}
