abstract class mnu_Element extends GameObject
{
    // tekst pokazywany w menu
    public String sName = "";//#;Menu element text
    
    // okresla czy opcja ma byc niedostepna, do wykorzystania przy pisaniu tekstow
    public boolean bDisabled = false;//#
    
    //TODO warunek jaki ma byc spelniony, aby podana akcja byla dostepna, sprawdzane przy
    // wejsciu do komputera
    public Condition cEnableCondition = null;//#;
    
    mnu_Element parent = null;
	
	mnu_Element()
	{
		//SG!
		bSG = false;
	}
    
    boolean IsDisabled()
    {
        // wylaczamy warunek wlaczenia opcji
        if(cEnableCondition != null)
            bDisabled = !cEnableCondition.Evaluate();

        return bDisabled;
    }

    // wymuszenie wylaczenia opcji - kasuje warunek wlaczenia!
    void Disable()
    {
        bDisabled = true;
        
        // wylaczamy warunek wlaczenia opcji
        if(cEnableCondition != null)
        {
            cEnableCondition.delete();
            cEnableCondition = null;
        }
    }
    
    void OnDestroy()
    {
        // wylaczamy warunek wlaczenia opcji
        if(cEnableCondition != null)
        {
            cEnableCondition.delete();
            cEnableCondition = null;
        }
    }
    
    public String toString()
    {
        return new String(sName);
    }
    
    public void PropagateParents(mnu_Submenu cParent)
    {
        parent = cParent;
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[mnu_Element.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_MNU_ELEMENT)
        {
			// okresla czy opcja ma byc niedostepna, do wykorzystania przy pisaniu tekstow
			bDisabled = cFC.LoadBool();
			// warunek jaki ma byc spelniony, aby podana akcja byla dostepna, sprawdzane przy wejsciu do komputera
			cEnableCondition = (Condition)cFC.LoadObjectRef();			
        }
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[mnu_Element.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_MNU_ELEMENT, cFCParent);
		
		// okresla czy opcja ma byc niedostepna, do wykorzystania przy pisaniu tekstow
		cFC.SaveBool(bDisabled);
		// warunek jaki ma byc spelniony, aby podana akcja byla dostepna, sprawdzane przy wejsciu do komputera
		cFC.SaveObjectRef(cEnableCondition);
			    							                		
		cFC.delete();
	}							
}
