/** klasa zarzadzajaca obiektami typu DoorableObject
 */
public class DoorControler extends GameObject
{
    /** tablica wszystkich DoorableObjectow na levelu
     */
    DoorableBase aObjects[] = null;
    
    public void OnCreate()
    {
        
        GameObject [] objects = GetObjectsFromClass("DoorableBase");
        if(objects != null)
        {
            aObjects=new DoorableBase[objects.length];
            for(int i=0; i<objects.length; i++)
                aObjects[i]=(DoorableBase)objects[i];
        }
        else
            Log("[DoorControler.OnCreate]: No doorable objects\n");
    }

    /** metoda sprawdza czy Pawn znajduje sie w poblizu jakiegos DoorableObjecta
     */
    public boolean IsNearDoorable(Pawn cPawn)
    {
        boolean bInsideAny = false, 
                bInsideCurrent;

        if (aObjects == null) 
            return false;
        //jade po wszystkich doorable i sprawdzam
        for (int i=0; i<aObjects.length; i++)
        {
            bInsideCurrent = IsInsideDoorable(cPawn, aObjects[i]);
            bInsideAny |= bInsideCurrent;
            if (bInsideCurrent)
                aObjects[i].PawnInside(cPawn);
            else
                aObjects[i].PawnOutside(cPawn); 
        }
        return bInsideAny;
    }
    
    /** metoda sprawdza czy Pawn znajduje sie wewnatrz podanego DoorObject'a
     */
    boolean IsInsideDoorable(Pawn cPawn, DoorableBase obj)
    {
        Vector vMinExt = new Vector(), vMaxExt = new Vector(), 
               vPawnPos = cPawn.GetPosition();
        
        obj.GetMeshExtentsInWorld(vMinExt, vMaxExt);

        //LogD(vMinExt + ", " + vMaxExt + ", " + vPawnPos + "\n");
        return (vPawnPos.fX > vMinExt.fX - obj.fDoorReactionDistance) &&
               (vPawnPos.fX < vMaxExt.fX + obj.fDoorReactionDistance) &&
               (vPawnPos.fZ > vMinExt.fZ - obj.fDoorReactionDistance) &&
               (vPawnPos.fZ < vMaxExt.fZ + obj.fDoorReactionDistance) &&
               
               (vPawnPos.fY > vMinExt.fY - obj.fDoorReactionDistance) &&
               (vPawnPos.fY < vMaxExt.fY + obj.fDoorReactionDistance) &&
               (obj.bDeadCanOpen || !cPawn.bDead)
               ;
    }
}
