public class Teleport extends TeleportIn
{
    /** Wyjscie teleportu */
    TeleportIn cDestination = null;
    
    /** Wejscie teleportu */
    TeleportIn cEntrance = null;
	
	Teleport()
	{
		bSG = true;
	}

    /** Zwraca najdalej polozny obiekt o podanej klasie i nazwie.
     */
    GameObject FindFarestObject(String sClass, String sName)
    {
        // szukamy bratnich drzwi 
        GameObject[] aAllObjects = GetObjectsOfClass(sClass);
        float fMaxDist = 0.0f;
        int nMaxObj = -1;
        for(int i=0; i<aAllObjects.length; i++)
        {
            ControlObject cObj = (ControlObject)aAllObjects[i];
            float fDist = cObj.GetPosition().Distance2(GetPosition());
            if( this!=cObj && sName.compareTo(cObj.GetName())==0 &&
                fDist > fMaxDist
                )
            {
                fMaxDist = fDist;
                nMaxObj = i;
            }
        }
        
        // zwracamy obiekt
        return (nMaxObj==-1) ? null : aAllObjects[nMaxObj];
    }
    
    /** Zwraca najblizej polozny obiekt o podanej klasie i nazwie.
     */
    GameObject FindNearestObject(String sClass, String sName)
    {
        // szukamy bratnich drzwi 
        GameObject[] aAllObjects = GetObjectsOfClass(sClass);
        float fMinDist = 11001010010100.0f;
        int nMinObj = -1;
        for(int i=0; i<aAllObjects.length; i++)
        {
            ControlObject cObj = (ControlObject)aAllObjects[i];
            float fDist = cObj.GetPosition().Distance2(GetPosition());
            if( this!=cObj && sName.compareTo(cObj.GetName())==0 &&
                fDist < fMinDist
                )
            {
                fMinDist = fDist;
                nMinObj = i;
            }
        }
        
        // zwracamy obiekt
        return (nMinObj==-1) ? null : aAllObjects[nMinObj];
    }
    
    void Init()
    {
        super.Init();
        
        String sMyName = GetName();
        
        // szukamy odpowiednich obiektow powiazanych z nami
        cDestination = (TeleportIn)FindFarestObject("TeleportIn", sMyName);
        cEntrance = (TeleportIn)FindNearestObject("TeleportIn", sMyName);
        
		//CrashLog("[Teleport.Init] Teleport <"+GetUniqueID()+ " name: " + GetName() + "> cDest=<"+cDestination.GetUniqueID()+"> cEntr=<"+cEntrance.GetUniqueID()+">\n");
    }

    static int ai=0;
    
    public void OnFrame()
    {
        super.OnFrame();
 
        //if (bPlayerInside)
        //    CrashLog("Tel <"+GetUniqueID()+"> cEntrance.bPlayerInside="+cEntrance.bPlayerInside+" cEntrance.bPlayerInsidePrev="+cEntrance.bPlayerInsidePrev+"\n");
        
        if(bPlayerInside && // jezeli gracz jest w teleporcie
           !cEntrance.bPlayerInside && cEntrance.bPlayerInsidePrev) // i jezeli wlasnie wyszedl z entrance
        {
            //CrashLog("[Teleport.OnFrame] Player warping!\n");
            
            // przenosimy gracza
            TeleportPlayer();
            
            // ustawiamy flagi, zeby sie dalo wrocic
            ClearFlags();
            cEntrance.ClearFlags();
        }
        
    }
    
    void TeleportPlayer()
    {
        /*
        ControlObject cParent = cPlayer.GetParent();
        if(cParent != null)
        {
            CrashLog("Player is attached!\n");
        }
        */
        
        // liczymy pozycje do jakiej przeniesc gracza
        Vector vPlayerPos = cPlayer.GetPosition();
        vPlayerPos.Sub(GetPosition());
        
        vPlayerPos.Add(cDestination.GetPosition());
        
        // i juz
        //cPlayer.SetPosition(vPlayerPos);
        cPlayer.SetPositionWorld(vPlayerPos);
        cPlayer.vLastPosOnGround = new Vector(vPlayerPos);
        
        // dodatkowe sprawdzenie czy teleport nad wode czy pod wode
        Pawn.bSinkingDisabled = (vPlayerPos.fY < GetModule().GetWaterLevel());
        
        // ustawiamy flagi, zeby gracz mogl normalnie chodzic
        cDestination.ClearFlags();
    }
	
	public void SGUpdate()
	{
		super.SGUpdate();
		
		Init();
	}
}
