/** FX wznoszacego sie dymu
 *  @param fFxSmokeRisingDuration czas trwania efektu (taka zmienna publiczna 
 *         musi byc zadeklarowana w klasie obiektu, ktory wywoluje ten FX) 
 *         - pozwala na wlaczanie i wylaczanie efektu
 */
public class FXSmokeRising extends FX
{
    /** Szybkosc wznoszenia sie 'obloczka' [cm/s] (?)
     */
    float fRisingSpeed = 60;
    
    /** Czas zycia pojedynczego 'obloczka' [ms]
     */
    float fExplDuration = 15000;

    /** Czas, po jakim pojawi sie nastepny 'obloczek' [ms]
     */
    float fNextExplTime = 2000;
                  
    FXSmokeRising()
    {
		
        Sequence ("FXSmokeRising");
        {
            SeqDurationDyn("fFxSmokeRisingDuration");

            Expl();
            {
                Texture("FXTexOgon1");
                Duration(fExplDuration);
                BlendMode(_BLEND_MIX);
                
                TowardsToCamera(1);
                Size();
                {
                    v(50,50);
                    v(1400,1400);
                }
                Position();
                {
                    v(0,0,0);
                    v(0,fRisingSpeed * fExplDuration * 0.001,0);
                }
                Alpha();
                {
                    v(0.5f);
                    v(0);
                }
                RandomRotation();
                {
                    v(0,0,-60);
                    v(0,0,89);
                }
            }
            Repeat(fNextExplTime);
        }
        
    }

}
