public class ForceField extends GameObject implements iact_EnableDisable
{
    public boolean bEnabled = false;//#FENCE
    
    //TODO
    public ForceFieldFence[] aFence = null;//#FENCE;Objects that create fence
    
    public void OnCreate()
    {
        if(aFence == null)
        {
            //FIXIT chwilowo tzn. do czasu az nie bedzie w kontrolce edycji tablic
            // obiektow wyciagane sa wszystkie ploty
            GameObject[] aObjs = GetObjectsFromClass("ForceFieldFence");
            aFence = new ForceFieldFence[aObjs.length];
        
            if(aObjs != null)
                for(int i=0; i<aFence.length; ++i)
                {
                    aFence[i] = (ForceFieldFence)aObjs[i];
                }
        }
        
        if(bEnabled) Enable(); else Disable();
    }

    public void Enable()
    {
        bEnabled = true;
        for(int i=0; i<aFence.length; ++i)
            aFence[i].Enable();
    }
    
    public void Disable()
    {
        bEnabled = false;
        for(int i=0; i<aFence.length; ++i)
            aFence[i].Disable();
    }
    
    public boolean IsEnabled()
    {
        return bEnabled;
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
	boolean bEnabledSG = false;
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[ForceField.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
		
        if (cFC.GetID() == ESGChunksChrome._CHK_FORCE_FIELD)
        {
			super.SGLoadChunk(cFC);
			
			// Znacznik, ze siatka ma byc wlaczona na starcie 
			bEnabledSG = cFC.LoadBool();	
        }
		
		cFC.delete();
    }

    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[ForceField.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_FORCE_FIELD, cFCParent);
		
		super.SGSaveChunk(cFC);

		// Znacznik, ze siatka ma byc wlaczona na starcie 
		cFC.SaveBool(bEnabled);		
        		        
        cFC.delete();
    }		
	
    public void SGUpdate()
    {
        FileChunk.Log("[ForceFieldFence.SGUpdate]\n");

        if (bEnabledSG)
            CallMethodIn("Enable", 0f);
		else
			CallMethodIn("Disable", 0f);
        
    }	
}
