import java.io.*;
import java.util.Vector;

/** Informacje o grze single player
 */
public class GameInitInfoSingle extends GameInitInfo
{

    GameInitInfoSingle()
    {
       cLevels.Init("LevelsSingle.scr");
    }
	    
    GameInitInfoSingle(String sFileName)
    {
        cLevels.Init(sFileName);
    }
	
	Module cActiveModule = null;
	
	boolean bLoadLevel = true;
    
    /**
     */
    Module LoadCurrentLevel(GameObject cObject)
    {
        LevelContent cCurLevel = cLevels.GetCurrent();
        
        cCurLevel.AddTexturePaths();

        Module cSomeModule = null;
        switch( cCurLevel.nLevelType )
        {
            case LevelContent._MAP:
                GameObject.CrashLog("[Level Loading] <"+ cCurLevel.sLevelName +">\n");
                cSomeModule = cObject.LoadModule( cCurLevel.sLevelName );
                GameObject.CrashLog("[Level Loaded] <"+ cCurLevel.sLevelName +">\n");
                break;
        
            case LevelContent._MODULE:
                cSomeModule = (Module)cObject.CreateObject( cCurLevel.sLevelName );
                break;
                    
            case LevelContent._MOVIES_S:
                cSomeModule = (Module)cObject.CreateObject("ChromeModulePreMission");
                break;
                        
            case LevelContent._MOVIES_TH:
                cSomeModule = (Module)cObject.CreateObject("ChromeModulePreMission");
                break;
        }
        //GameObject.CrashLog("[GameInitInfoSingle.LoadCurrentLevel] Level loaded <"+ cCurLevel.sLevelName +">\n");

        cCurLevel.RemoveTexturePaths();

		cActiveModule = cSomeModule;
        
        return cSomeModule;
    }
    
//--------------------------------------------------------------------------------

    /** Metoda wczytuje dane */
    public void PreLoad(FileChunk cFC, Module cModule)
    {
		FileChunk.Log("[GameInitInfoSingle.PreLoad]\n");	
		
		super.PreLoad(cFC,cModule);
			
        // odczytujemy plik
        String sLoadingScript = cFC.LoadString();
		int nCurrent = cFC.LoadInt();
        ChromeGame.SetDiffLevel(cFC.LoadInt());
		//String sLevelName = cFC.LoadString();
		
		FileChunk.Log("[GameInitInfoSingle.PreLoad] nCurrent : <"+nCurrent+"> cLevels.nCurrent : <"+cLevels.nCurrent+">\n");
		FileChunk.Log("[GameInitInfoSingle.PreLoad] Level : <"+cLevels.sConfigFileName+" -> "+sLoadingScript+">\n");
		
		if( !cLevels.sConfigFileName.equals(sLoadingScript) ||
            cLevels.nCurrent != nCurrent )
		{
			FileChunk.Log("[GameInitInfoSingle.PreLoad] Reload\n");
			
			cLevels.nCurrent = nCurrent;
			
			bLoadLevel = true;
			
			// kasujemy poprzedi level i odczytujemy nowy plik
			cLevels.Destroy();
			cLevels.Init(sLoadingScript);						
			
			File file = new File(cLevels.GetCurrent().sLevelName);
			int nCRC32 = GameObject.FileCRC32(cLevels.GetCurrent().sLevelName,0,(int)file.length()-1);
			int nCRC32FromSave = cFC.LoadInt();
			if (nCRC32 != nCRC32FromSave)	
				GameObject.CrashLog("[SG-ERROR] Not valid CRC32 for map file <"+cLevels.GetCurrent().sLevelName+">. You've changed map file in editor. \n");
		}
		else
		{
			bLoadLevel = false;
		}
    }
    
    /** Metoda zapisuje dane */
    public void PreSave(FileChunk cFC)
    {
		FileChunk.Log("[GameInitInfoSingle.PreSave] Level : <"+cLevels.sConfigFileName+">\n");
		
		super.PreSave(cFC);
        
        // zapisujemy nazwe levelu
        cFC.SaveString( cLevels.sConfigFileName );
		cFC.SaveInt( cLevels.nCurrent );
        cFC.SaveInt(ChromeGame.GetDiffLevel());
		File file = new File(cLevels.GetCurrent().sLevelName);
		int nCRC32 = GameObject.FileCRC32(cLevels.GetCurrent().sLevelName,0,(int)file.length()-1);
		cFC.SaveInt(nCRC32);
		//cFC.SaveString( cLevels.GetCurrent().sLevelName );
			
		FileChunk.Log("[GameInitInfoSingle.PreSave] nCurrent : <"+cLevels.nCurrent+">\n");
    }
    
    
    void SetNextLevel()
    {
        cLevels.NextLevel();
    }
    
}
