/** klasa reprezentuje brame otwierana betonowa
 */

public class GateShield extends Gate
{
    //////////////////////////////////////
    // atyrbuty //////////////////////////
    //////////////////////////////////////
    
    /** dzwiek, ktory ma byc odgrywany podczas otwierania
     */
    public String sOpenSound = "Data/Sounds/WallDoor_Open";//#TRIGGER
    
    /** dzwiek, ktory ma byc odgrywany podczas zamykania
     */
    public String sCloseSound = "Data/Sounds/WallDoor_Close";//#TRIGGER
    
    //////////////////////////////////////
    // metody ////////////////////////////
    //////////////////////////////////////
 
    GateShield()
    {
        //nazwa elementu aktywnego
        ActiveElement = "B6_Zamek";
    }
    
    void OnCreate()
    {
        SetFlag(EFlags._BLOCK_TRACE);
        
        super.OnCreate();
        
        //inicjacja animacji wlaczania/wylaczania
        InitAnimSeq("open", 0, 120);
        InitAnimSeq("close", 121, 240);
    }
    
    /** Przelaczenie toggle'a
     */
    void Execute( Actor executor )
    {
        super.Execute(executor);
        
        if(bActiveTrigger)
        {
            PlayAnim("open", 1);
            PlaySound(sOpenSound, GetPosition());
            bActiveTrigger = false;
            
            SetTraceCollType(ECollTraceFlags._HULL);
        }
    }
    
    String GetTip()
    {
        return "Gate [Open]";
    }
}
