/** element HUD'a - celownik 
 */
public class HUDCompCrossHair extends HUDComponent
{
    /** rozmiar tekstury */
    float fTexSizeX = 16.0f;
    float fTexSizeY = 1.0f;
    
    /** wspolrzedne srodka celownika */
    int nCenterPointX = 0;
    int nCenterPointY = 0;
    
    /** rozmiary tekstury z pojedyncza kreska celownika */
    int nCrossWidth = 50;
    int nCrossHeight = 50;
    
    /** nazwa i sciezka tekstury celownika */
    String sTextureName = "celownik.png"; 
    String sBkgTextureName = "celownik2.png";
    String sAltTextureName = "celownik2.png";
    String sCurTextureName = "";
    
    /** sprit'y z czterema kreskami celownika */
    Sprite crossSpriteN = null;
    int crossSpriteNTex = 0;
    Sprite crossSpriteS = null;
    int crossSpriteSTex = 0;
    Sprite crossSpriteE = null;
    int crossSpriteETex = 0;
    Sprite crossSpriteW = null;
    int crossSpriteWTex = 0;
    
    Sprite bkg = null;
    int nBkgTex = 0;
    
    ChromeModule cModule = null;

    /** aktualnie wyswietlany nick */
    String sTargetName = "";
    /** sprite tekstu z nickiem celu do gry sieciowej*/
    Sprite cSprTargetName = null;
    float m_fSprTargetNameAlpha = 0.7f;
    
    int nTargetNameSizeX = 200;
    int nTargetNameSizeY = 120;
        
    int nTargetNameShiftY = 40;
    
    Vector m_vTargetNamePos = new Vector( nCenterPointX,
                                          nCenterPointY + nTargetNameShiftY,
                                          0 );
    
    public void OnCreate()
    {
        super.OnCreate();
		
        // kreska polnocna
        crossSpriteN = (Sprite) CreateObject("Sprite");
		crossSpriteN.SetRotation(-90f);
        crossSpriteN.SetSize(new Vector(fTexSizeX, fTexSizeY, 0));
        crossSpriteN.SetPos(new Vector(20, 0, 0));
        crossSpriteN.ProcessMouse(false);
       
        // kreska poludniowa
        crossSpriteS = (Sprite) CreateObject("Sprite");
		crossSpriteS.SetRotation(90f);
        crossSpriteS.SetSize(new Vector(fTexSizeX, fTexSizeY, 0));
        crossSpriteS.SetPos(new Vector(20, 20, 0));
        crossSpriteS.ProcessMouse(false);
        
        // kreski wschodnia
        crossSpriteE = (Sprite) CreateObject("Sprite");
        crossSpriteE.SetSize(new Vector(fTexSizeX, fTexSizeY, 0));
        crossSpriteE.SetPos(new Vector(40, 10, 0));
        crossSpriteE.ProcessMouse(false);
        
        // kreski zachodnia
        crossSpriteW = (Sprite) CreateObject("Sprite");
        crossSpriteW.SetSize(new Vector(fTexSizeX, fTexSizeY, 0));
        crossSpriteW.SetPos(new Vector(0, 10, 0));
        crossSpriteW.ProcessMouse(false);
        
        SetTexture(sTextureName);
        
        cSprTargetName = (Sprite)CreateObject("Sprite");
		cSprTargetName.SetNoTexture();
		cSprTargetName.ProcessMouse(false);
        cSprTargetName.SetSize(new Vector(nTargetNameSizeX, nTargetNameSizeY, 0));
		cSprTargetName.SetTextColor( vFontColor.fX, vFontColor.fY, vFontColor.fZ, 1.0f );
        cSprTargetName.SetFont(ChromeFonts.FONT_HUD_BIGGER);
        cSprTargetName.SetTextPosFlags(ESpriteText.MULTILINE);        
        
        bkg = (Sprite) CreateObject("Sprite");
        bkg.SetSize(new Vector(64, 64, 0));
        bkg.SetPos(new Vector(GetScreenWidth()/2 - 32, GetScreenHeight()/2 - 32, 0));
        nBkgTex = bkg.AddTexture(sBkgTextureName);
        bkg.SetTexture(nBkgTex, new Rect(0,0,1,1));
        bkg.SetName("CROSS_BK");
        
        bkg.ProcessMouse(false);
        bkg.Hide();
        
        RegisterMouseAxisRequest();
        
        AddSprite(crossSpriteN);
        AddSprite(crossSpriteS);
        AddSprite(crossSpriteE);
        AddSprite(crossSpriteW);
        AddSprite(bkg);
        AddSprite( cSprTargetName );
        
        int intwidth = GetScreenWidth();
        
        // ustawiam srodek ekranu
        SetCenterPoint(GetScreenWidth() / 2, GetScreenHeight() / 2);
        
        // ustawiam celnosc
        SetTargetInfo(null);

        ActivateOnModule();
        //Log("[HUDCompCrossHair.OnCreate]: Creating HUDCompCrossHair DONE. \n");
        
        cModule = (ChromeModule)GetModule();
    }
    
    void SetTexture(String sTexture)
    {
        if (sCurTextureName.compareTo(sTexture) == 0)
            return;
        
        sCurTextureName = new String(sTexture);
        
        if (crossSpriteNTex != 0)
            crossSpriteN.ReleaseTexture(crossSpriteNTex);
        crossSpriteNTex = crossSpriteN.AddTexture(sTexture, true, false);
        crossSpriteN.SetTexture(crossSpriteNTex, new Rect(0f, 0f, 1f, 1f));
        
        if (crossSpriteWTex != 0)
            crossSpriteW.ReleaseTexture(crossSpriteWTex);
        crossSpriteWTex = crossSpriteW.AddTexture(sTexture, true, false);
        crossSpriteW.SetTexture(crossSpriteWTex, new Rect(1f, 0f, 0f, 1f));
        
        if (crossSpriteETex != 0)
            crossSpriteE.ReleaseTexture(crossSpriteETex);
        crossSpriteETex = crossSpriteE.AddTexture(sTexture, true, false);
        crossSpriteE.SetTexture(crossSpriteETex, new Rect(0f, 0f, 1f, 1f));
        
        if (crossSpriteSTex != 0)
            crossSpriteS.ReleaseTexture(crossSpriteSTex);
        crossSpriteSTex = crossSpriteS.AddTexture(sTexture, true, false);
        crossSpriteS.SetTexture(crossSpriteSTex, new Rect(0f, 0f, 1f, 1f));
    }

    public void OnDestroy()
    {
		super.OnDestroy();

		crossSpriteN.ReleaseTexture(crossSpriteNTex);
        RemoveSprite(crossSpriteN);
        crossSpriteN.delete();
        crossSpriteN = null;	
        
        crossSpriteS.ReleaseTexture(crossSpriteSTex);
        RemoveSprite(crossSpriteS);
        crossSpriteS.delete();
        crossSpriteS = null;	
        
        crossSpriteE.ReleaseTexture(crossSpriteETex);
        RemoveSprite(crossSpriteE);
        crossSpriteE.delete();
        crossSpriteE = null;	
        
        crossSpriteW.ReleaseTexture(crossSpriteWTex);
        RemoveSprite(crossSpriteW);
        crossSpriteW.delete();
        crossSpriteW = null;	
        
        RemoveSprite(cSprTargetName);
        cSprTargetName.delete();
        cSprTargetName = null;	
        
        bkg.ReleaseTexture(nBkgTex);
        RemoveSprite(bkg);
        bkg.delete();
        bkg = null;
        
        //CrashLog("[HUDCompCrossHair.OnDestroy]: Destroing DONE. \n");
    }
    
	/** metoda wyswietlajaca celownik
	 */
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
        if ( m_bNet && cPlayer != null && !cPlayer.bNetIsOwner )
            return;
        
        //troche to chamskie, ale skuteczne
        if ( cPlayer != null &&
             cPlayer.cSeatInfo != null &&
             cPlayer.cSeatInfo.m_ObjectToOccupy instanceof Speeder)
            return;
        
        super.Activate();
        
        //crossSpriteN.Show();
        crossSpriteS.Show();
        crossSpriteE.Show();
        crossSpriteW.Show();
        bkg.Show();
        cSprTargetName.Show();
        
        Draw();
    }
    
	/** metoda chowajaca celownik
	 */
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
		super.Deactivate();

		DisableCallMethod("Activate");
             
        crossSpriteN.Hide();
        crossSpriteS.Hide();
        crossSpriteE.Hide();
        crossSpriteW.Hide();
        bkg.Hide();
        cSprTargetName.Hide();
    }
    
	/** metoda ustawiajaca centralny punkt celownika
	 */
    void SetCenterPoint(int X, int Y) 
    {
        nCenterPointX = X;
        nCenterPointY = Y;
    }

    static Vector l_vTempDD = new Vector();
    
    /** ustawienie i wyswietlenie polozenia celownika na podstawie celnosci 
     */
    public void DrawDo()
    {
        //pobranie celnosci z gracza
        Player cMainPlayer = cModule.GetMainPlayer();
        float fAccuracy;
        if(cMainPlayer == null)
        {
            fAccuracy = 0.0f;
        }
        else
        {
            // chowanie celownika jak jest Leaning
            if( cMainPlayer.IsLeaning() )
            {
                crossSpriteN.Hide();
                crossSpriteS.Hide();
                crossSpriteE.Hide();
                crossSpriteW.Hide();
                bkg.Hide();
                cSprTargetName.Hide();
                return;
            }
            else
            {
                crossSpriteS.Show();
                crossSpriteE.Show();
                crossSpriteW.Show();
                bkg.Show();
                cSprTargetName.Show();
            }
            
            fAccuracy = CalculateCrosshairSize(cMainPlayer.GetCurrentAccuracy());
        
            if (cMainPlayer.cSeatInfo != null)
            {
                bkg.Hide();
                crossSpriteN.Show();
            }
            else
            {
                bkg.Show();
                crossSpriteN.Hide();
            }
        }        
        // kreska N
        int posX = (int) ((float) nCenterPointX - fTexSizeX / 2f);
        int posY = nCenterPointY - (int) (fTexSizeX / 2f) - (int) fAccuracy;
        crossSpriteN.SetPos(l_vTempDD.Set(posX, posY, 0));
        
        // kreska S
        posY = nCenterPointY + (int) (fTexSizeX / 2f) + (int) fAccuracy;
        crossSpriteS.SetPos(l_vTempDD.Set(posX, posY, 0));
        
        // kreska E
        posX = nCenterPointX + (int) fAccuracy;
        posY = (int) ((float) nCenterPointY);
        crossSpriteE.SetPos(l_vTempDD.Set(posX, posY, 0));
        
        // kreska W
        posX = nCenterPointX - (int) fTexSizeX - (int) fAccuracy;
        crossSpriteW.SetPos(l_vTempDD.Set(posX, posY, 0));
        
        // napis
        //obsluzony w SetTarget...
    }
        
    public void OnFrame()
    {
        // odrysowanie
        if (bActiveFlag) 
            Draw();
    }

    /** Obliczenie wielkosci celownika na ekranie
     */
    public float CalculateCrosshairSize(float fCurrentAccuracy)
    {
        // pobranie FOVa
        float fFOVHalf = cModule.GetActiveViewCamera().GetFOV() * 0.5f;
        float fTangent = (float)Math.tan(fFOVHalf * Math.PI / 180.f);
        
        // skalowanie do wspolrzednych ekranowych
        return 0.5f * fCurrentAccuracy/100.f * (float)GetScreenWidth() / fTangent;
    }
    
	public void PositionHUDComponent(int relX, int relY)
	{
        SetCenterPoint(GetScreenWidth() / 2, GetScreenHeight() / 2);
        if (bActiveFlag) 
            Draw();
	}
	
	/** potrzebne, gdy chowamy implanty - krzyzyk widac nad modulem postaci */
	public void ActivateWithDelay(float fDelay)
	{
		CallMethodIn("Activate", fDelay);
	}
    
    NetTargetInfo m_cPrevTargetInfo = null;
    
    public void SetTargetInfo(NetTargetInfo cTargetInfo)
    {
        if (m_cPrevTargetInfo != null && 
            m_cPrevTargetInfo.Equals(cTargetInfo))
            return;
        
        m_cPrevTargetInfo = cTargetInfo != null ? 
                            new NetTargetInfo( cTargetInfo ) : null ;
        
        if ( cTargetInfo == null || cTargetInfo.Valid() == false )
        {
            cSprTargetName.DisplayText(" ");
            cSprTargetName.Hide();
            return;
        }
        cSprTargetName.Show();
        
        
        //pobierzmy i ustawmy kolor
        Vector vColor = cTargetInfo.GetColor();
        cSprTargetName.SetTextColor( vColor.fX, vColor.fY, vColor.fZ, m_fSprTargetNameAlpha );
        //pobierzmy i ustawmy tekst sformatowany do sprite'a
        sTargetName   = cTargetInfo.GetText( cSprTargetName );
        cSprTargetName.DisplayText( sTargetName );
        //no i ustalmy pozycje
        cSprTargetName.SetPos( l_vTempDD.Set( nCenterPointX - cTargetInfo.GetTextLength()/2,
                                              nCenterPointY + nTargetNameShiftY,
                                              0 ) );
    }
    
    public void MoveTop()
    {
        if (Precache.bPrecaching)
        {
            CallMethodIn("MoveTop",0.1f);
            return;
        }
        super.MoveTop();
        crossSpriteN.MoveTop();
        crossSpriteS.MoveTop();
        crossSpriteE.MoveTop();
        crossSpriteW.MoveTop();
        bkg.MoveTop();
        cSprTargetName.MoveTop();       
    }
}
