 /** klasa reprezentujaca na HUD'zie inventory gracza
 */
public class HUDCompInvPl extends HUDComponent
{
	/** referencja do invnetory gracza */
	Inventory cInventory = null;
	Inventory cAIInventory = null;


	/** sprit'y -  tlo do hud'a */
	SpriteInvObj cInvGridSprite = null;
	int nInvGridSpriteTex = 0;
	
	/** sprit'y -  tlo plecaka AI */
	SpriteInvObj cInvAIGridSprite = null;
	int nInvAIGridSpriteTex = 0;
    
	/** sprite - pole tekstowe pod plecakiem gracza */
	UIStatic cInvTextSprite = null;
    UIStatic cInvTextSpriteAI = null;
    UIStatic cInvTextTitle = null;
    UIStatic cInvTextTitleAI = null;
	
    UIWindow cInvFrame = null;
    UIWindow cInvFrameAI = null;
    
	/** aktualna pozycja kursora */
	Vector CursPos = null;
	
	/** referencja do aktualnie drag&dropowanego InvObjectu */
	InvObject cActiveInvObj = null;
	
    /**referencja do obiektu, ktorego opis jest aktualnie wyswietlany*/
    InvObject m_cInfoInvObject = null;
    
	/** flaga mowiaca czy aktywne jest inventory AI */
	boolean AIActive = false;

	/** flaga mowiaca czy wlasnie drag&dropowany jest jakis przedmiot */
	boolean bDragingInvObj  = false;

    /** dzwiek aktywacji inventory */
    String sSoundInventoryActivate = "Data/Sounds/InventoryChoose";
    
    /** dzwiek deaktywacji inventory */
    String sSoundInventoryDeactivate = "Data/Sounds/InventoryChooseOut";    
    
    /** dzwiek klikniecia na jakis obiekt w inventory */
    String sSoundInventoryClick = "Data/Sounds/InventoryClick2";
    
    /** dzwiek zatwierdzenia (odlozenia przedmiotu) w inventory */
    String sSoundInventoryPut = "Data/Sounds/InventoryPut";
    
    /** dzwiek zatwierdzenia (wyrzucenia przedmiotu) w inventory */
    String sSoundInventoryPutOut = "Data/Sounds/InventoryPutOut";

    public void OnInit()
    {
        super.OnInit();
        Hide();
        cInvFrame = GetElem("ID_FRAME_PLAYER");
        cInvFrameAI = GetElem("ID_FRAME_AI");
        cInvTextTitle = (UIStatic)cInvFrame.GetElem("ID_OBJ_DESC");
        cInvTextSprite = (UIStatic)cInvFrame.GetElem("ID_OBJ_DESC_TEXT");
        cInvTextTitleAI = (UIStatic)cInvFrameAI.GetElem("ID_OBJ_DESC");
        cInvTextSpriteAI = (UIStatic)cInvFrameAI.GetElem("ID_OBJ_DESC_TEXT");
        cInvTextSpriteAI.SetFontCharactersShiftV(-2);
        cInvTextTitle.Hide();
        cInvTextTitleAI.Hide();
        cInvGridSprite.SetSize(cInvFrame.GetSize());
        cInvGridSprite.SetPos(cInvFrame.GetPos());
        cInvAIGridSprite.SetSize(cInvFrameAI.GetSize());
        cInvAIGridSprite.SetPos(cInvFrameAI.GetPos());
        cInvFrameAI.Hide();
    }
        
    
	public void OnCreate()
	{					
        //Log("[HUDCompInvPl.OnCreate]: Creating HUDCompInvPl \n");	
		super.OnCreate();
		
        if (cHUDManager.m_bDisableInNetGame)
            return;
		// tworze sprite'a dla grida hud'a
		cInvGridSprite = (SpriteInvObj)CreateObject("SpriteInvObj");
        cInvGridSprite.DontProcessMouse();
		cInvGridSprite.ProcessMouse(true); 
	        
		
		AddSprite(cInvGridSprite);
		
		// inicjalizuje sprity, gridy zwiazane z inventory AI
		cInvAIGridSprite = (SpriteInvObj) CreateObject("SpriteInvObj");
        cInvAIGridSprite.DontProcessMouse();
		cInvAIGridSprite.ProcessMouse(true); 
		// ustawiam parametry dla HUD AI
		AddSprite(cInvAIGridSprite);
		
		ActivateOnModule();
		cInvGridSprite.Hide();
			
		// inicjalizcja kursora
		cCursor = (Cursor) CreateObject("Cursor");
		cCursor.SetCursorTex(cModule, sCursorTex);
		cCursor.Hide();
		
		// przekazywanie Spritowi referencji do HUDCompInvPL
		try 
		{
			((SpriteInvObj)cInvGridSprite).SetHUDInvPl(this);
		}
		catch (Exception ex)
		{
			Log("[HUDCompInvPl.OnCreate]: ERROR Cast \n");	
		}
		
        Load(GetModule(), "data/hud/HUDInventory.scr");
        
        cInvGridSprite.SetSize(cInvFrame.GetSize());
        
        cInvGridSprite.MoveTop();
        cInvAIGridSprite.MoveTop();
        
        PositionHUDComponent(0, 0);        
		RegisterMouseAxisRequest();
		//Log("[HUDCompInvPl.OnCreate]: Creating HUDCompInvPl DONE. \n");	
	}

	public void OnDestroy()
	{
		super.OnDestroy();
		Remove();
		// kasujemy sprite z gridem inventory
		//cInvGridSprite.ReleaseTexture(nInvGridSpriteTex);
		RemoveSprite(cInvGridSprite);
        if (cInvGridSprite != null)
		    cInvGridSprite.delete();
		cInvGridSprite = null;
		
		// kasujemy sprite inventory ai
		//cInvAIGridSprite.ReleaseTexture(nInvAIGridSpriteTex);
        if (cInvAIGridSprite != null)
        {
		    RemoveSprite(cInvAIGridSprite);
		    cInvAIGridSprite.delete();
        }
		cInvAIGridSprite = null;
        
        //CrashLog("[HUDCompInvPl.OnDestroy]: Destroing DONE. \n");
	}
	
	/** ustawia aktualne inventory gracza
	 */
	public void SetPlayerInv(Inventory inv)
	{
        if (inv == null)
			LogD(": ERROR inv == NULL \n");
		
		cInventory = inv;
		cInventory.ComputeInvObjPositions();
	}

	/** ustawia inventory AI (przeszukiwanie zwlok)
	 */
	public void SetInvAI(Inventory inv)
	{
        if (inv == null)
			LogD(" ERROR inv == NULL \n");

		cAIInventory = inv;
        if (!inv.bGridInited)
            inv.InitInvGrid(this);
		//PP cAIInventory.ShowAllInvObjects();
		cAIInventory.ComputeInvObjPositions(); // Compute ?? Show
		AIActive = true;
	}
    
	/** metoda rysuje inventory - obrazek plecaka
	 */
	public void DrawDo()
	{
		if (bActiveFlag) 
		{
            MoveTop();
			cInvGridSprite.Show();
            cInvGridSprite.MoveTop();
			ShowCursor();
			ShowAllInvObjects();
			cCursor.CallMethodIn("MoveTop",0);
            HideInvObjInfo(m_cInfoInvObject);
            Show();
		}	
	}
	
	/** metoda rysuje inventory AI - obrazek plecaka
	 */
	public void Draw_AI()
	{
        if (cAIInventory != null && !cAIInventory.bGridInited)
            cAIInventory.InitInvGrid(this);
        
        cInvAIGridSprite.Show();
        cInvAIGridSprite.MoveTop();
        cInvFrameAI.Show();
		ShowAllAIInvObjects();
	}

	/** metoda aktywujaca HUD Inv Player i ustawiajaca wszystkim spritom
	 *	InvObject referencje do HUDCompInvPl
	 */
	public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.CanActivate(HUDManager._HUD_INV_PLAYER))
			return;
        if (cInventory != null && !cInventory.bGridInited)
            ((InventoryPlayer)cInventory).InitInvGrid(this);
        
        super.Activate();
        
        PlaySound(sSoundInventoryActivate);
        
		// ustawianie wszystkim spritom z inv gracza referencji do HUDcompInvPl
        if ( (cInventory != null) && (cInventory.aInvObjects != null) )
        {
		    for (int i = 0; i < cInventory.aInvObjects.size(); i++)
		    {
			    ((InvObject) cInventory.aInvObjects.elementAt(i)).cInvObjSprite.SetHUDInvPl(this);
		    }
            
            // wyliczam pozycje przedmoitow w gridach
		    cInventory.ComputeInvObjPositions();    
        }
        cPlayer.MouseUnacquire(false);
		// teraz wlaczam rekacje na klikanie mysza na sprite'ach
		if ( (cInventory != null) && (cInventory.aInvObjects != null) )
        {
			for (int j = 0; j < cInventory.aInvObjects.size(); j++)
				((InvObject) cInventory.aInvObjects.elementAt(j)).cInvObjSprite.ProcessMouse(true);
        }
		Draw();
		
		if (AIActive)
		{
			// ustawianie wszystkim spritom z inv gracza referencji do HUDcompInvPl
			if (cAIInventory != null)
			{
                if (!cAIInventory.bGridInited)
                    cAIInventory.InitInvGrid(this);
			    for (int i = 0; i < cAIInventory.aInvObjects.size(); i++)
				    ((InvObject) cAIInventory.aInvObjects.elementAt(i)).cInvObjSprite.SetHUDInvPl(this);
			    // wyliczam pozycje przedmiotow w gridach
			    cAIInventory.ComputeInvObjPositions();
			    for (int j = 0; j < cAIInventory.aInvObjects.size(); j++)
				    ((InvObject) cAIInventory.aInvObjects.elementAt(j)).cInvObjSprite.ProcessMouse(true);
			}
			Draw_AI();
		}
        
        cHUDManager.HudMenuActivated(HUDManager._HUD_INV_PLAYER);
	 }
	
	public void ActivateSlow()
	{
        Activate();
	}
	
	public void ComponentMoved()
	{
		if (!bActiveFlag)
		{
			cHUDManager.m_bIsUserHUDActive = false;
		 
			HideAll();
			AIActive = false; // schowalismy ai, na pewno
		}
	}
	
	public void HideAll()
	{
        Hide();
		cInvGridSprite.Hide();
		HideAllInvObjects();
		HideCursor();
        HideInvObjInfo(m_cInfoInvObject);
		if (AIActive)
			Hide_AI();
	}
	
	/** metoda deaktywujaca  HUD'a
	  */
	public void Deactivate()
	{
		if (!bActiveFlag)
			return;
        
        //jesli cos trzymamy, to symulujemy puszczenie
        if (cActiveInvObj != null &&
            cActiveInvObj.cInvObjSprite != null &&
            cActiveInvObj.cInvObjSprite.bDrag &&
            bDragingInvObj)
        {
            cActiveInvObj.cInvObjSprite.OnLBUp(GetMousePos().fX, GetMousePos().fY);
        }
          
        
		super.Deactivate();

        HideInvObjInfo(m_cInfoInvObject);
        
		HideAll();
        cHUDManager.HudMenuDeactivated(HUDManager._HUD_INV_PLAYER);
        PlaySound(sSoundInventoryDeactivate);
         
		cPlayer.MouseAcquire();
        
        cHUDManager.m_bIsUserHUDActive = false;
        
		// wylaczam rekacje na klikanie na sprite'ach
		if (cInventory != null)
        {
            for (int j = 0; j < cInventory.aInvObjects.size(); j++)
			    ((InvObject) cInventory.aInvObjects.elementAt(j)).cInvObjSprite.ProcessMouse(false);
        }
		if (AIActive)
		{
			if (cAIInventory != null)
			{
				// teraz wlaczam rekacje na klikanie mysza na sprite'ach
			    for (int j = 0; j < cAIInventory.aInvObjects.size(); j++)
				    ((InvObject) cAIInventory.aInvObjects.elementAt(j)).cInvObjSprite.ProcessMouse(false);
			}
		}
	}
	 
	public void DeactivateSlow()
	{
        CallMethodIn("Deactivate", 0.1f);
	 }
	 
	 /** metoda chowajaca  HUD'a AI
	  */
	 public void Hide_AI()
	 {
        cInvAIGridSprite.Hide();
        cInvFrameAI.Hide();
		if (cAIInventory != null) 
            HideAllAIInvObjects();
		HideInvObjInfo(m_cInfoInvObject);
        AIActive = false;
	 }
	 
	/** metoda rysuujaca wszystkie przedmioty z Inventory
	 */
	public void ShowAllInvObjects()
	{
	    cInventory.ShowAllInvObjects(cInvGridSprite);        
	}
	/** metoda rysuujaca wszystkie przedmioty z Inventory AI
	 */
	public void ShowAllAIInvObjects()
	{
	    cAIInventory.ShowAllInvObjects(cInvAIGridSprite);                 
	}
	
	 /** metoda chowa wszystkie przedmioty z Inventory
	  */
	 public void HideAllInvObjects()
	 {
        cInventory.HideAllInvObjects();
	 }

	 /** metoda chowa wszystkie przedmioty z Inventory
	  */
	 public void HideAllAIInvObjects()
	 {
        cAIInventory.HideAllInvObjects();         
	 }
	 
	 /** metoda chowa wszystkie przedmioty z Inventory Other PLayera (multiplayer)
	  */
	 /** metoda wyswietla kursor 
	  */
	 public void ShowCursor()
	 {
         if (IsActuallyVisible())
         {
             cCursor.Show();
		     cCursor.MoveTop();
         }
	 }
	 
	 /** metoda chowa kursor 
	  */
	 public void HideCursor()
	 {
		 cCursor.Hide();
	 }
	 
	/** przekazywanie referencji do aktulanie drag&dropowanego 
	 *	InvObj
	 */ 
	public void SetActualInvObj(InvObject invobj)
	{
		cActiveInvObj = invobj;
	}
	
    public void ShowInvObjInfo(InvObject cObj)
	{
        if (m_cInfoInvObject == cObj)
            return;
        if (AIActive)
        {
            cInvTextSpriteAI.SetText(cObj.GetInvName() + "\n" + cObj.GetInfoString());
            cInvTextSpriteAI.SetFontCharactersShiftV(-2);
		    cInvTextTitleAI.Show();
            cInvTextTitle.Hide();
        }
        else
        {
            cInvTextSprite.SetText(cObj.GetInvName() + "\n" + cObj.GetInfoString());
		    cInvTextTitle.Show();
            cInvTextTitleAI.Hide();
        }
        m_cInfoInvObject = cObj;
	}
	
	public void ShowAIInvObjInfo(InvObject cObj)
	{
        ShowInvObjInfo(cObj);
	}
	
    public void HideInvObjInfo(InvObject cObj)
	{
        if (cObj == m_cInfoInvObject)
        {
		    cInvTextTitle.Hide();
            cInvTextTitleAI.Hide();
            m_cInfoInvObject = null;
        }
	}
    
	
	/** metoda wyswietla inventory AI
	 */
	public void ShowInvAI()
	{
		cInvAIGridSprite.Show();		
	}
	
	/** metoda chowa inventory AI
	 */
	public void HideInvAI()
	{
		cInvAIGridSprite.Hide();
	}

	/** handler na click na spricie
	 */
	void OnLBDownInvObj(float fMouseX, float fMouseY, InvObject cInvObj)
	{
        if (cInvObj.cInvObjSprite.IsVisible())
			SetActualInvObj(cInvObj);

        PlaySound(sSoundInventoryClick);
        
		bDragingInvObj = true;
        cCursor.Hide();
	
		if (IsAIInvObject(cInvObj))
		{
			// klik na przedmiocie w inventory AI (przeszukanie zwlok)
            ShowAIInvObjInfo(cInvObj);
		}
        else
		if (IsInvObject(cInvObj))
		{ 
			// klik przedmiocie w inventory gracza
            ShowPlayerInvObjInfo(cInvObj);
		}
	
   		// zwalniam miejsce w Gridzie
        Inventory cInventory = cInvObj.GetInventory();
        InvGrid cGrid = cInventory.GetInvGrid(cInvObj.nGrid);
        if(cGrid != null)
        {
            cGrid.SetFreeCells(cInvObj.nCellY, cInvObj.nCellsHeight, cInvObj.nCellX, cInvObj.nCellsWidth);
		    cGrid.PrintFreeCells();
        }
	}

	/** handler na puszczenie buttona myszy 
	 */
	void OnLBUpInvObj(float fMouseX, float fMouseY, InvObject cInvObj)
	{
        if (bDragingInvObj && (cInvObj == cActiveInvObj) && IsActuallyVisible())
		{
			bDragingInvObj = false;

			if (IsAIInvObject(cInvObj))
			{
				// klik na przedmiocie w inventory AI (przeszukanie zwlok)
				OperatingAIInvObject(cInvObj); 
			}
            else
			if (IsInvObject(cInvObj))
			{ 
				// klik przedmiocie w inventory gracza
				OperatingInvObject(cInvObj); 
			}
            
            ShowCursor();
		}
        if (!IsActuallyVisible())
        {
            CrashLog("HUDCompInvPl nieautoryzowane klikniecie!!!");
            //Thread.dumpStack();
        }
	}
	
    /** handler na ruszanie mysza
	 */
	void OnMouseMoveInvObj(float fMouseX, float fMouseY, int iButtonsFlags, InvObject cInvObj)
	{
        if (bDragingInvObj == false) 
		{
            if (IsAIInvObject(cInvObj))
				ShowAIInvObjInfo(cInvObj);
            else
			if (IsInvObject(cInvObj))
            {
				ShowInvObjInfo(cInvObj);
            }
		}
	}

	void OnMouseEnterInvObj(float fMouseX, float fMouseY, InvObject InvObj)
	{
        // by zachowac wlasciwa kolejnosc wyswietlania kursora i fanty
		if (bDragingInvObj == false)
        {
            InvObj.cInvObjSprite.MoveTop();
            cCursor.MoveTop();
        }
	}
	
	void OnMouseLeaveInvObj(float fMouseX, float fMouseY, InvObject cInvObj)
	{
        if (bDragingInvObj == false)
        {
            HideInvObjInfo(cInvObj);
        }
	}
    
    /** metoda sprawdza czy bylo klikniecie na przedmiocie z Inventory AI
     */
    boolean IsAIInvObject(InvObject cInvObj)
    {
       if ((cAIInventory != null) &&
		   (((InventoryAI)cAIInventory).BecomeToThisInventory(cInvObj))
          )
           return true;
       else
           return false;
    }
    
    /** metoda sprawdza czy bylo klikniecie na przedmiocie z inventory gracza
     */
    boolean IsInvObject(InvObject cInvObj)
    {
       if ((cInventory != null) &&
		   (((InventoryPlayer)cInventory ).BecomeToThisInventory(cInvObj))
          )
           return true;
       else
           return false;
    }

    /** metoda wyswietla opis przedmiotu w Inventory AI
     */    
    
	
    /** metoda wyswietla opis przedmiotu w Inventory PLayera
     */
    void ShowPlayerInvObjInfo(InvObject cInvObj)
    {
        if (cInvObj.cInvObjSprite.IsVisible()) 
            ShowInvObjInfo(cInvObj);    
    }
	
    /** metoda wyrzuca przedmiot z inventory gracza na teren i usuwa go z inventory gracza
     */    
    void DropOnTerrainInvObj(InvObject cInvObj)
    {
        //LogD(": Removing InvObject \n");
        
        HideInvObjInfo(m_cInfoInvObject);
        cInventory.RemoveInvObject(cInvObj);
        cInvObj.ChangeInvState(cInventory.Owner, EInvObjState._ONGROUND);
        //cInvObj.DropOnTerrain(cPlayer.ComputeDroppingPosition());
        cInvObj.PhysicsDrop(cPlayer.ComputePhysicsDropPosition(), cPlayer.ComputePhysicsDropSpeed());
        
        //LogD(": Removing InvObject DONE. \n");
    }

    /** metoda wyrzuca przedmiot z inventory AI na teren i usuwa go z inventory AI
     */    
    void DropOnTerrainAIInvObj(InvObject cInvObj)
    {
        //LogD(": Removing InvObject \n");
        
        HideInvObjInfo(m_cInfoInvObject);
        cAIInventory.RemoveInvObject(cInvObj);
        cInvObj.ChangeInvState(cAIInventory.Owner, EInvObjState._ONGROUND );
        //cInvObj.DropOnTerrain(cAIInventory.Owner.ComputeDroppingPosition());
        cInvObj.PhysicsDrop(cAIInventory.Owner.ComputePhysicsDropPosition(), cAIInventory.Owner.ComputePhysicsDropSpeed());
    }
    
    /** metoda wyrzuca przedmiot z Inv AI i dodaje go do Inv Gracza, jesli bDblClick jest
     * true, to wrzucamy obiekt w optymalne miejsce, jesli false, to tam gdzie przeciagnal 
     * gracz (draganddrop)
     */
    void MoveInvObjFromAIToPlayer(InvObject cInvObj, boolean bDblClick)
    {
        HideInvObjInfo(m_cInfoInvObject);
        
        //LogD(": Removing AI InvObject \n");
        // trzeba usunac przedmiot AI z inventory
        if (cAIInventory == null)
			LogD(": ERROR cAIInventoryL is NULL \n");
        
        cAIInventory.RemoveInvObject(cInvObj);
        //cInvObj.cInvObjSprite.DetachFromParent();
        //LogD(": Removing AI InvObject DONE. \n");
        
        // trzeba dodac przedmiot do playera
        //LogD("Dodaje playerowi przedmiot \n");
        
		// bylo tak:
        if (!bDblClick)
            cInvObj.bNearestCell = true;
        else
            cInvObj.bNearestCell = false;
        cInvObj.Execute(cPlayer);
        
        cInvGridSprite.AddChild(cInvObj.cInvObjSprite);        
		// lecz to "rzuca" do inventory
		// lepiej znalezc najblizsze miejsce zgodnie z polozeniem sprite'a
        
        //LogD("Dodalem playerowi przedmiot \n");
        
        //ShowInvObjInfo(cInvObj);

/*		// to po to, by inventory objecty sie dobrze pokazywaly (NA inventory)
		if ( (cInvGridSprite != null) && (cInvObj.cInvObjSprite != null) )
			cInvGridSprite.AddChild(cInvObj.cInvObjSprite);
*/		
        //LogD(": DONE\n");
    }

    void MoveInvObjFromPlayerToAI(InvObject cInvObj)
    {
        HideInvObjInfo(m_cInfoInvObject);
        
        // trzeba usunac przedmiot AI z inventory
        if ( (cInventory == null) || (cAIInventory == null) )
		{
			LogD(": ERROR cInventory or cAIInventory is NULL \n");
			return;
		}
        
        cInventory.RemoveInvObject(cInvObj);
        //cInvObj.cInvObjSprite.DetachFromParent();
        
        // trzeba dodac przedmiot do playera
        cInvObj.bNearestCell = true;
        cInvObj.Execute(cAIInventory.Owner);
        
        cInvAIGridSprite.AddChild(cInvObj.cInvObjSprite);
        
        //ShowInvObjInfo(cInvObj);
		
/*		// to po to, by inventory objecty sie dobrze pokazywaly (NA inventory)
		if ( (cInvAIGridSprite != null) && (cInvObj.cInvObjSprite != null) )
			cInvAIGridSprite.AddChild(cInvObj.cInvObjSprite);
*/		
    }
	
    
    /** metoda wraca z spritem przedmiotu do Inv AI
     */    
    void MoveInvObjBackToAI(InvObject cInvObj)
    {
        Vector AICells = cAIInventory.FindNearestCellGrid(cInvObj.cInvObjSprite.cActualSpritePos, cInvObj);
        //Log("<> <> NEarest Y ="+AICells.fY+" X= "+AICells.fX+" GRID = "+AICells.fZ+"\n");
        cInvObj.SetInvObjCellsGrid((byte)AICells.fX, (byte)AICells.fY, (byte)AICells.fZ);
        //Log(" !! nowa pozycja X = "+(int)AICells.fX+" Y="+(int)AICells.fY+" GRID = "+AICells.fZ+"\n" );
        cAIInventory.aInvGrids[(byte)AICells.fZ].SetTakenCells((byte)AICells.fY, cInvObj.nCellsHeight, (byte)AICells.fX, cInvObj.nCellsWidth); 
        
        cAIInventory.aInvGrids[(byte)AICells.fZ].PrintFreeCells();
    }
	
   	
    /** metoda wraca z spritem przedmiotu do Inv Playera
     */    
    void MoveInvObjBackToPlayer(InvObject cInvObj)
    {
        Vector cellGrid = cInventory.FindNearestCellGrid(cInvObj.cInvObjSprite.cActualSpritePos, cInvObj);
        //Log("<> <> NEarest Y ="+cellGrid.fY+" X= "+cellGrid.fX+" GRID = "+cellGrid.fZ+"\n");
        
        cInvObj.ActionSetNewGridPos( cInventory, (byte)cellGrid.fX, (byte)cellGrid.fY, (byte)cellGrid.fZ);
    }

    /** metoda wykonuje wszystkie czynnosci zwiazane z obsluga sprite'a
     *  przedmiotu po kliknieciu na przedmiot w invetory gracza
     */    
    void OperatingInvObject(InvObject cInvObj)
    {
        //LogD("\n");
        HideInvObjInfo(m_cInfoInvObject);
                
		if (!cInventory.IsOutOfInventory(cInvObj)) 
		{
			// jest wewnatrz grida inventory playera
            LogD("WEWNATRZ GRACZ\n");
            MoveInvObjBackToPlayer(cInvObj);
            ShowInvObjInfo(cInvObj);
            PlaySound( sSoundInventoryPut );
		}
        else 
		if((cAIInventory != null) &&
			!cAIInventory.IsOutOfInventory(cInvObj)
           )
        {
            LogD("WEWNATRZ AI\n");
            if ( (cAIInventory.IsFreeSpaceInInv(cInvObj)) && (!cInvObj.bLocked) )
            {
	            // jest wolne miejsce
                // przenosze przedmiot od AI do Playera
				cInvObj.RemoveFromHands();
                MoveInvObjFromPlayerToAI(cInvObj);
            }
            else
            {
				// nie ma wolnego miejsca
                // wracam ze spritem na miejsce do inventory
				MoveInvObjBackToPlayer(cInvObj);
				ShowInvObjInfo(cInvObj);
            }

			// jest wewnatrz grida AI (jezeli istnieje)
            PlaySound( sSoundInventoryPut );
        }
        else
		{
			// jest poza gridami
            //LogD("POZA\n");
            
            // niektorych przedmiotow nie mozemy wyrzucac
            if( cInvObj.bLocked )
            {
                // LogD("Nie mozna wyrzucic noza!\n");
                MoveInvObjBackToPlayer(cInvObj);
                ShowInvObjInfo(cInvObj);
                PlaySound( sSoundInventoryPut );
            }
            else
            {
                // jesli trzymamy przedmiot w dloni to trzeba go wyrzucic
                cInvObj.ActionThrowAway();
                PlaySound(sSoundInventoryPutOut);
            }
		}
    }

    /** metoda wykonuje wszystkie czynnosci zwiazane z obsluga sprite'a
     *  przedmiotu po kliknieciu na przedmiot w Invetory AI
     */    
    void OperatingAIInvObject(InvObject cInvObj)
    {
        //LogD("\n");
        HideInvObjInfo(m_cInfoInvObject);
        
        if (!cAIInventory.IsOutOfInventory(cInvObj))
        {
			// jest wewnatrz grida drugiego gracza
            LogD("WEWNATRZ AI\n");
            MoveInvObjBackToAI(cInvObj);		
            ShowAIInvObjInfo(cInvObj);                    
                        
            PlaySound( sSoundInventoryPut );
        }
        else
		if((cInventory != null) &&
			!cInventory.IsOutOfInventory(cInvObj)
           )
		{
			// jest wewnatrz grida inventory playera (jezeli istnieje)            
            //LogD("WEWNATRZ GRACZ\n");
            if (cInventory.IsFreeSpaceInInv(cInvObj)  || cInvObj.bMissionCritical || cInvObj.bHidden || cInvObj.bHiddenButUsable)
            {
	            // jest wolne miejsce
                // przenosze przedmiot od AI do Playera
                MoveInvObjFromAIToPlayer(cInvObj, false);
            }
            else
            {
                if (cInvObj.nInvType == EInvObjType._AMMO)
                {
                    //Amunicje mozemy czasem dodac mimo ze nie ma miejsca w inventory
                    int nCount = ((Ammo)cInvObj).nCount; 
                    Ammo cRet = (Ammo)cInventory.AddAmmo((Ammo)cInvObj);
                    if (cRet != null)
                    {
                        MoveInvObjBackToAI(cInvObj);
                        HideInvObjInfo(m_cInfoInvObject);
                    }
                }
                else
                {
				    // nie ma wolnego miejsca
                    // wracam ze spritem na miejsce do AI inv
                    MoveInvObjBackToAI(cInvObj);
                    HideInvObjInfo(m_cInfoInvObject);
                }
            }

            //TODO: tu mozna sie jeszcze pokusic o jakis dzwiek niepowidzenia
            PlaySound( sSoundInventoryPut );
        }
        else
        {
            LogD("POZA\n");
            // trzeba wyrzucic przedmiot na teren
            DropOnTerrainAIInvObj(cInvObj);
                        
            PlaySound( sSoundInventoryPutOut );
        }
    }

    
    /** metoda wywolywana gdy dwuklik na przedmiocie w inventory
     */
    void DoubleClickOnInvObj(InvObject cInvObj)
    {
        if (!bActiveFlag)
        {
            return;
        }
       
        if (!AIActive)
        {
            cInvObj.ActionThrowAway();
            PlaySound(sSoundInventoryPutOut);
            return;
        }
        
        HideInvObjInfo(m_cInfoInvObject);
        
		if (IsAIInvObject(cInvObj))
		{
			//klik na przedmiocie w inventory AI (przeszukanie zwlok)
			DoubleClickOnInvObj_AI(cInvObj);
		}
        else
        {
            if (IsInvObject(cInvObj))
                DoubleClickOnInvObj_Pl(cInvObj);
        }
        
        ShowCursor();
    }
	
    /** metoda wywolywana gdy dwuklik byl w inventory AI
     */
    void DoubleClickOnInvObj_AI(InvObject cInvObj)
    {
        HideInvObjInfo(m_cInfoInvObject);
        
        if (cInventory != null)   
		{
            //jest wolne miejsce
            if (cInventory.IsFreeSpaceInInv(cInvObj) || cInvObj.bMissionCritical || cInvObj.bHidden || cInvObj.bHiddenButUsable)
            {
                // przenosze przedmiot od AI do Playera
                HideInvObjInfo(m_cInfoInvObject);
                MoveInvObjFromAIToPlayer(cInvObj, true);
            }
            else
            {
                if (cInvObj.nInvType == EInvObjType._AMMO)
                {
                    //Amunicje mozemy czasem dodac mimo ze nie ma miejsca w inventory
                    int nCount = ((Ammo)cInvObj).nCount; 
                    Ammo cRet = (Ammo)cInventory.AddAmmo((Ammo)cInvObj);
                }
                else
                {
                    PlaySound( sSoundInventoryPut );
                }
            //TODO: tu mozna sie jeszcze pokusic o jakis dzwiek niepowidzenia
            }
        }  
    }
    
    /** metoda wywolywana gdy dwuklik byl w inventory gracza
     */
    void DoubleClickOnInvObj_Pl(InvObject cInvObj)
    {
        if (cAIInventory != null)
        {
            //jest wolne miejsce
            if (cAIInventory.IsFreeSpaceInInv(cInvObj))
            {
                // przenosze przedmiot od Playera do AI
                cInvObj.RemoveFromHands();
                MoveInvObjFromPlayerToAI(cInvObj);
                HideInvObjInfo(m_cInfoInvObject);
            }
            else
            {
                PlaySound( sSoundInventoryPut );
            }
        }  
        else
        {
            
        }
    }
    
    public void RestoreInventoryGridPositions()
    {
        ((InventoryPlayer)cInventory).InventoryGridPositions(this);
    }
     
	
	public void PositionHUDComponent(int relX, int relY)
	{
		super.PositionHUDComponent(relX, relY);
		cInvFrame.UpdateLogicSizeAndPos(cInvFrame.GetSize(), new Vector(relX + cInvFrame.GetPos().fX,
										 relY + cInvFrame.GetPos().fY,
										 0));
        cInvFrame.OnSizeAndPos();
		cInvGridSprite.SetPos(new Vector(relX + cInvFrame.GetPos().fX,
										 relY + cInvFrame.GetPos().fY,
										 0));
		/*cInvTextSprite.SetPos(new Vector(relX + GetScreenWidth() - EHudInvParams._POS_X_TEXT,
										 relY + EHudInvParams._POS_Y_TEXT,
										 0));*/
		if (cInventory != null)
			cInventory.ComputeInvObjPositions(relX, relY);
		
		cInvAIGridSprite.SetPos(new Vector(relX + cInvFrameAI.GetPos().fX,
										   relY + cInvFrameAI.GetPos().fY,
										   0));

        if (cAIInventory != null)
			cAIInventory.ComputeInvObjPositions(relX, relY);
	}
	
    /**
     */
    public void AboutToQuickSave()
    {
        if (cActiveInvObj != null &&
            cActiveInvObj.cInvObjSprite != null &&
            cActiveInvObj.cInvObjSprite.bDrag &&
            bDragingInvObj)
        {
            Deactivate();
        }
    }
    
	public void SGUpdate()
	{
		FileChunk.Log("[HUDCompInvPl.SGUpdate]\n");		
		
		if (bActiveFlag && !bActiveFlagSG)
			CallMethodIn("Deactivate",0.f);
		if (!bActiveFlag && bActiveFlagSG)
			CallMethodIn("Activate",0.f);		
	}
}
