public class HUDCompRack extends HUDComponent
{
    /** Tlo */
    String sTextureName = "data/textures/CH_lornetka.png";
    Sprite cBackSprite = null;
    int nBackSpriteTex = 0;
    
    /** sciezka do i nazwa tekstury HUDa vehicla  */
    String sHUDCompTex = "Data/Textures/vehicle.png";
    
    /** sciezka do i nazwa tekstury paska Damage */
    String sHUDDamageTex = "Data/Textures/damage_belt.png";    

    /** sprite z panelem vehicle */
    Sprite cHUDRackSpr = null;
    int nHUDRackSprTex = 0;

    /** sprite z paskiem Damage */
    Sprite cHUDDamageSpr = null;
    int nHUDDamageSprTex = 0;

    /** sprite'y z tekstami */
    Sprite cDamageTxtSpr = null;
    Sprite cAmmoTxtSpr = null;
    
    /** pozycja wzgledna napisu DAMAGE  */
    int nDamageTxtPosX = 11;
    int nDamageTxtPosY = 22;    
    
    /** pozycja wzgledna napisu AMMO  */
    int nAmmoTxtPosX = 21;
    int nAmmoTxtPosY = 22;    
    
    /** rozmiary spritow z napisami  */
    int nTxtSizeX = 40;
    int nTxtSizeY = 8; 
    
    /** pozycja wzgledna paska DAMAGE  */
    int nDamageBeltPosX = 57;
    int nDamageBeltPosY = 23;
    
    /** rozmiary paskow  */
    int nBeltSizeX = 103;
    int nBeltSizeY = 7;    
    
    protected float fMaxDamage = 1.0f/100;    
    protected float fOldHealth = -1;    
    
    /** referencja do aktualnie uzywanego stojaka  */
    WeaponRackPawn cRack = null;    
    
    public void OnCreate()
    {
        super.OnCreate();
        
        // ustawiam parametry okna
        
        nHUDCompWidth = 256;
        nHUDCompHeight = 64;
        nHUDCompPosX = 0;
        nHUDCompPosY = GetScreenHeight() - 65 - nHUDCompHeight;

        //sprite tla
        cBackSprite = (Sprite)CreateObject("Sprite");
        nBackSpriteTex = cBackSprite.AddTexture(sTextureName);
        cBackSprite.SetTexture(nBackSpriteTex, new Rect(.0f,.0f,1.f,1.f));
        cBackSprite.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
        cBackSprite.SetPos(new Vector());
        cBackSprite.ProcessMouse(false);
        AddSprite(cBackSprite);
        //laduje sprite panelu
        cHUDRackSpr = (Sprite)CreateObject("Sprite");
        nHUDRackSprTex = cHUDRackSpr.AddTexture(sHUDCompTex);
        cHUDRackSpr.SetTexture(nHUDRackSprTex, new Rect( .0f,.0f,1.f,1.f ));
        cHUDRackSpr.SetSize(new Vector(nHUDCompWidth,nHUDCompHeight,0));
        cHUDRackSpr.SetPos(new Vector(nHUDCompPosX,nHUDCompPosY,0));
        cHUDRackSpr.ProcessMouse(false);
		AddSprite(cHUDRackSpr);
        
        //tworze sprite z paskiem energii
        cHUDDamageSpr = (Sprite)CreateObject("Sprite");
        nHUDDamageSprTex = cHUDDamageSpr.AddTexture(sHUDDamageTex);
        cHUDDamageSpr.SetTexture(nHUDDamageSprTex, new Rect(0,0,1,1));
        cHUDDamageSpr.ProcessMouse(false);
        cHUDDamageSpr.SetSize(new Vector(nBeltSizeX, nBeltSizeY,0));
        cHUDDamageSpr.SetPos(new Vector(nHUDCompPosX+nDamageBeltPosX,nHUDCompPosY+nDamageBeltPosY,0));
        AddSprite(cHUDDamageSpr);
        
        //sprite z napisem Damage
        cDamageTxtSpr = (Sprite)CreateObject("Sprite");
		cDamageTxtSpr.SetNoTexture();
		cDamageTxtSpr.ProcessMouse(false);
        cDamageTxtSpr.MoveTop();
        cDamageTxtSpr.SetTextColor( vFontColor.fX, vFontColor.fY, vFontColor.fZ, 1.0f );
        cDamageTxtSpr.SetSize(new Vector(nTxtSizeX,nTxtSizeY,0));
		cDamageTxtSpr.SetPos(new Vector(nHUDCompPosX+nDamageTxtPosX,nHUDCompPosY+nDamageTxtPosY, 0));
        cDamageTxtSpr.SetFont(ChromeFonts.FONT_HUD);
        cDamageTxtSpr.DisplayText("DAMAGE : ");
        AddSprite(cDamageTxtSpr);        
        
        
        //sprite z napisem Ammo
        cAmmoTxtSpr = (Sprite)CreateObject("Sprite");
		cAmmoTxtSpr.SetNoTexture();
		cAmmoTxtSpr.ProcessMouse(false);
        cAmmoTxtSpr.MoveTop();
        cAmmoTxtSpr.SetTextColor( vFontColor.fX, vFontColor.fY, vFontColor.fZ, 1.0f );
        cAmmoTxtSpr.SetSize(new Vector(nTxtSizeX,nTxtSizeY,0));
		cAmmoTxtSpr.SetPos(new Vector(nHUDCompPosX+nAmmoTxtPosX,nHUDCompPosY+nAmmoTxtPosY, 0));
        cAmmoTxtSpr.SetFont(ChromeFonts.FONT_HUD);
        cAmmoTxtSpr.DisplayText("Ammo : ");
        AddSprite(cAmmoTxtSpr);             
    }

    public void OnDestroy()
    {
		super.OnDestroy();
		
        if (cBackSprite != null)
        {
            if (nBackSpriteTex != 0)
                cBackSprite.ReleaseTexture(nBackSpriteTex);    
            RemoveSprite(cBackSprite);
            cBackSprite.delete();
            cBackSprite = null;
        }
        
        if (cHUDRackSpr != null)
        {
            if (nHUDRackSprTex != 0)
                cHUDRackSpr.ReleaseTexture(nHUDRackSprTex);
            RemoveSprite(cHUDRackSpr);
            cHUDRackSpr.delete();
            cHUDRackSpr = null;
        }
               
        if (cHUDDamageSpr != null)
        {
            if (nHUDDamageSprTex != 0)
                cHUDDamageSpr.ReleaseTexture(nHUDDamageSprTex);
            RemoveSprite(cHUDDamageSpr);
            cHUDDamageSpr.delete();
            cHUDDamageSpr = null;
        }
        
        if (cDamageTxtSpr != null)
        {
            RemoveSprite(cDamageTxtSpr);
            cDamageTxtSpr.delete();
            cDamageTxtSpr = null;
        }
                
        if (cAmmoTxtSpr != null)
        {
            RemoveSprite(cAmmoTxtSpr);
            cAmmoTxtSpr.delete();
            cAmmoTxtSpr = null;
        }
		
        //CrashLog("[HUDCompRack.OnDestroy]: Destroing DONE. \n");
    }
        
    public void Activate()
    {
        if (cRack == null)
            LogD("Cannot activate - no rack!\n");
        else
        {
            super.Activate();
            ActivateOnModule();
            Draw();
        }
    }
    
    public void Deactivate()
    {
        super.Deactivate();

        cBackSprite.Hide();
        cHUDRackSpr.Hide();
        cHUDDamageSpr.Hide();
        cDamageTxtSpr.Hide();
        cAmmoTxtSpr.Hide();
    }

    public void DrawDo()
    {
       if (bActiveFlag)
       {
           //cBackSprite.Show();

           cHUDRackSpr.Show(); 
           cHUDDamageSpr.Show();

           cDamageTxtSpr.Show();
           cAmmoTxtSpr.Show();
       }
    }

    /** metoda ustwia pasek damage w zaleznosci od podanej wartosci
     */
    public void SetDamage(float dmg)
    {
        float dmg_level = dmg * fMaxDamage;

        cHUDDamageSpr.SetTextureCoords(new  Rect(0,0,dmg_level,1));
        cHUDDamageSpr.SetSize(new Vector(dmg_level * nBeltSizeX, nBeltSizeY,0));
    }
}
