/** klasa reprezentujaca huda logow z gry
 */
public class HUDGameLogs extends HUDComponent
{
	static float _DEACTIVATE_TIME = 1f;
	
	/** okno z kontrolka logow */
	LogsWindow m_LogsWnd = null;

    public void OnCreate()
    {
        super.OnCreate();   

        Load(GetModule(), "data/hud/Hudlogs.scr", false);
        
		// kursor
		cCursor = (Cursor) CreateObject("Cursor");
		cCursor.SetCursorTex(cModule, sCursorTex);
		cCursor.Hide();

		m_LogsWnd = (LogsWindow) CreateObject("LogsWindow");
        m_LogsWnd.Init(this);
		cModule.AddSprite(m_LogsWnd);
		m_LogsWnd.Hide();
		m_LogsWnd.ProcessMouse(false);
		m_LogsWnd.SetCursor(cCursor);
		
        m_LogsWnd.Init(); // to musi byc zawolane dopiero po ustaleniu pos
    }
	
    public void OnDestroy()
    {
		super.OnDestroy();
		
		m_LogsWnd.Destroy();
		m_LogsWnd.delete();
		m_LogsWnd = null;
		
        //CrashLog("[HUDGameLogs.OnDestroy]: Destroing DONE. \n");
    }
      
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.CanActivate(HUDManager._HUD_LOGS))
			return;
		
        if (GetModule() instanceof ModuleNet &&
            ((ModuleNetBase)GetModule()).GetGameInfo() != null)
        {
            HUDNetManager cNetHUD = ((NetGameInfoHud)((ModuleNetBase)GetModule()).GetGameInfo()).GetHUDNet();
            cNetHUD.Deactivate(HUDNetManager._INCOMING_MESSAGE);
            HUDNetManager.s_bCanActivateIncommingMsg = false;
        }
        
        super.Activate();   

        Draw();
		
		cHUDManager.HudMenuActivated(HUDManager._HUD_LOGS);
    }
	
	public void ActivateSlow()
	{
        Activate();   
	}

	public void ComponentMoved()
	{
		if (!bActiveFlag)
		{
			cHUDManager.m_bIsUserHUDActive = false;
			
			for (int i = 0; i < cPlayer.aWeaponHands.length; i++)
			{
				if ( (cPlayer.aWeaponHands[i] != null) &&
					 (cPlayer.aWeaponHands[i].cMesh != null) )
					((FPPHands) cPlayer.aWeaponHands[i].cMesh).SetHandsOnTop(true);
			}
			
			HideAll();
		}
	}
	
	public void HideAll()
	{
        Hide();
		cCursor.Hide();
		m_LogsWnd.Hide();
        m_LogsWnd.ProcessMouse(false);
	}
    
    public void DrawDo()
    {
	    if (bActiveFlag)
        {
            Show();
			cCursor.Show();
			m_LogsWnd.Show();
			m_LogsWnd.UpdateList();
	        m_LogsWnd.ProcessMouse(true);
        }
    }
	
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
        if (GetModule() instanceof ModuleNet &&
            ((ModuleNetBase)GetModule()).GetGameInfo() != null)
        {
            HUDNetManager cNetHUD = ((NetGameInfoHud)((ModuleNetBase)GetModule()).GetGameInfo()).GetHUDNet();
            cNetHUD.Deactivate(HUDNetManager._INCOMING_MESSAGE);
            HUDNetManager.s_bCanActivateIncommingMsg = true;
        }
        super.Deactivate();   
		
		HideAll();
		
        cHUDManager.HudMenuDeactivated(HUDManager._HUD_LOGS);
		//PositionHUDComponent(0, -nHUDCompHeight);
    }
	
	public void DeactivateSlow()
	{
		Deactivate();   
	}
	
	
	void InputText(String sText)
	{
		m_LogsWnd.AddText(sText);
	}
    
    void InputText(String sText,Vector vColor)
	{
		m_LogsWnd.AddText(sText,vColor);
	}
    
    public void MoveTop()
    {
        super.MoveTop();
	    m_LogsWnd.MoveTop();
        cCursor.MoveTop();
    }
    
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[HUDGameLogs.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_HUD_LOGS)
        {
			super.SGLoadChunk(cFC);
			
            m_LogsWnd.Clear();
            int nLoad = cFC.LoadInt();
            for (int i = 0; i < nLoad; i++)
            {
                String sText = cFC.LoadString();
                m_LogsWnd.AddText(sText);
                //LogR("LOADADD " + sText + "\n");
            }
            
        }
		
		cFC.delete();
	}
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[HUDGameLogs.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_HUD_LOGS, cFCParent);
		
		super.SGSaveChunk(cFC);
		
        cFC.SaveInt(m_LogsWnd.vItems.size());
        for (int i = 0; i < m_LogsWnd.vItems.size(); i++)
        {
            cFC.SaveString((String)((Button)m_LogsWnd.vItems.elementAt(i)).sText);
        }
		
		
		cFC.delete(); 
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[HUDGameLogs.SGUpdate]\n");
		
		super.SGUpdate();
		
	}
    
}
