/**Hud wyswietlajacy ikony aktywnych implantow*/
public class HUDImplantIndicators extends HUDComponent
{
    UIWindow m_tIcons[] = null;
    
    public void OnCreate()
    {
        super.OnCreate();
        if (!m_bDisableInNetGame)
            Load(GetModule(), "data/hud/HUDImplantIndicators.scr", true);
    }
    
    public void Activate()
    {
        if (GetModule() instanceof ChromeModuleSingle)
        {
            if (!((ChromeModuleSingle)GetModule()).m_bImplantsAvailable)
                return;
        }
        super.Activate();
    }
    
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (bKeyState)
        {
            Vector vPos = new Vector(((UIWindow)this).GetLogicPos());
            Tools.MovePointByKeys(vPos, nKeyCode, 0);
            ((UIWindow)this).SetLogicPos(vPos);
            
        }
        Tools.ShowInfoTop(GetLogicPos() + " " + " fDelta " + Tools.g_fDelta, GetModule());
    }

    
    public void OnInit()
    {
        super.OnInit();
        java.util.Vector vTemp = new java.util.Vector();
        int nIdx = 0;
        while (true)
        {
            UIWindow cWin = GetElem("ID_IMPLANT_" + nIdx);
            if (cWin != null)
                vTemp.addElement(cWin);
            else
                break;
                
            nIdx ++;    
        }
        m_tIcons = new UIWindow[vTemp.size()];
        for (int i = 0; i < vTemp.size(); i++)
            m_tIcons[i] = (UIWindow)vTemp.elementAt(i);
            
        
    }
    
    public void SetActiveImplants(Implant cImplants[])
    {
        if (m_bDisableInNetGame)
            return;
        /*if (m_vActiveImplants.size() == 0)
        {
            for (int i = 0; i < cImplants.length; i++)
            {
                m_vActiveImplants.addElement(cImplants[i]);
            }
        }
        for (int i = 0; i < cImplants.length; i++)
        {
            Implant cImplant = cImplants[i];
            if (cImplant.IsActive())
            {
                /*if (m_vActiveImplants.indexOf(cImplant) == -1)
                    m_vActiveImplants.addElement(cImplant);
            }
            else
            {
                if (m_vActiveImplants.indexOf(cImplant) != -1)
                    m_vActiveImplants.removeElement(cImplant);
            }
        }*/
        
        for (int i = 0; i < m_tIcons.length; i++)
        {
            UIWindow cIcon = m_tIcons[i];
            UITexture cTex = null;
            
            Implant cImpl = null;
            if(i<cImplants.length) cImpl = cImplants[i];
            
            if( cImpl!=null && !cImpl.m_bDisabled && cIcon.m_cNormalTexture == null)
            {
                cTex = cImpl.m_cIconNormal;
                cIcon.SetNormalTexture(cTex);
            }
            
            if (cImpl!=null && cImpl.IsActive())
            {
                cIcon.SetAlpha(1f);
            }
            else
            {
                /*if (cImplants[i].bHidden)
                   cIcon.SetAlpha(0.0f);
                else*/
                    cIcon.SetAlpha(0.33f);
            }
            
        }
    }
    
    public void SGUpdate()
	{
		FileChunk.Log("[HUDImplantIndicators.SGUpdate]\n");
		
        if (GetModule() instanceof ChromeModuleSingle)
        {
            if (!((ChromeModuleSingle)GetModule()).m_bImplantsAvailable)
                Deactivate();
            else
                Activate();
        }
		super.SGUpdate();
        
                
    }	
    
}
