/** klasa reprezentujaca mape na ktorej mozna ustalac destination point
 */
public class HUDMap extends HUDComponent
{
    int nMapWidth = 0;
    int nMapHeight = 0;
    int nMapPosX = 0;
    int nMapPosY = 0;
    int nMapSprTex = 0;
    UIWindow m_cMapPicture = null;
    UIWindow m_cMap = null;
    UIWindow m_cMapInterlace = null;
    UIStatic m_cObjectives = null;
	/** sciezka do huda */
    String sTexHudMapName = "CH_T_Talk.png";
    //Sprite cMapHud = null;
	int nHudMapNum = 0;

	/** czas migniecia pozycji gracza */
	float m_fBlinkTime = 0.3f;
	boolean m_bPlayerPosVisible = false;
	
    /** sciezka do i nazwa tekstury mapy */
    String sTexMapName = null;
	
    /** sprite mapy */
    SpriteHUDMap cMapSpr = null;

    /** sciezka do i nazwa tekstury punktu docelowego */
    String sTexDestName = "dest_point.png";
    /** sprite punktu docelowgo */
    Sprite cDestSpr = null;
    int nDestSprTex = 0;
    int nDestSprSizeX = 16;
    int nDestSprSizeY = 16;

    /** sciezka do i nazwa tekstury punktu pozycji playera */
    String sTexPlayerName = "player_point.png";
    /** sprite punktu playera */
    Sprite cPlayerSpr = null;
    int nPlayerSprTex = 0;
    int nPlayerSprSizeX = 16;
    int nPlayerSprSizeY = 16;
    
    /** rozmiary terenu */
    int nTerrainWidth = 70000;
    int nTerrainHeight = 70000;
    
    /** referencja do HUDCompas */
    public HUDCompass cHUDCompasRef = null;

    /** wektor bazowy (polnoc) - wedlug niego obliczany jest kat obrotu spritea z pozycja gracza */
    Vector vNBase = null;
	
    /** przeliczniki */
    float nXcmIsPixls = 0.0f;
    float nZcmIsPixls = 0.0f;
    
    /** Variable using in net game */
    private int m_nPlayersCnt = 1;
    void SetPlayersCnt(int nCnt) { m_nPlayersCnt = nCnt; }
    int  GetPlayersCnt() { return m_nPlayersCnt; }
    
    /** Variable using in net game */
    private int m_nVehiclesCnt = 0;
    void SetVehiclesCnt(int nCnt) {m_nVehiclesCnt = nCnt;}
    int GetVehiclesCnt() {return m_nVehiclesCnt;}
    
    public void OnCreate()
    {
        super.OnCreate();   
        
        if (m_bDisableInNetGame)
            return;
        
        // tworze sprite'a mapy
        cMapSpr = (SpriteHUDMap) CreateObject("SpriteHUDMap");
        cMapSpr.ProcessMouse(false);
		AddSprite(cMapSpr);
        cMapSpr.cHUDMapRef = this; // dodaje spritowi referencje do HUDMap
        
        // wektor polnocy
        vNBase = new Vector(0, 0, 1);
        
        Load(GetModule(), "data/hud/HUDMap.scr", false);
		
        // tworze sprite'a pozycji gracza
        cPlayerSpr = (Sprite) CreateObject("Sprite");
        nPlayerSprTex = cPlayerSpr.AddTexture(sTexPlayerName);
        cPlayerSpr.SetTexture(nPlayerSprTex, new Rect(0, 0, 1f, 1f));
        cPlayerSpr.SetSize(new Vector(nPlayerSprSizeX, nPlayerSprSizeY, 0));
        //cPlayerSpr.SetSpriteMaterial("sprite_nofiltering.mat");
		m_cMap.AddChild(cPlayerSpr);
        cPlayerSpr.ProcessMouse(false);
        cPlayerSpr.MoveTop();
        
        // tworze sprite'a pozycji dest point
        cDestSpr = (Sprite)CreateObject("Sprite");
        nDestSprTex = cDestSpr.AddTexture(sTexDestName);
        cDestSpr.SetTexture(nDestSprTex, new Rect(0, 0, 1f, 1f));
        cDestSpr.SetSize(new Vector(nDestSprSizeX, nDestSprSizeY, 0));
		m_cMap.AddChild(cDestSpr);
        //cDestSpr.SetSpriteMaterial("sprite_nofiltering.mat");
        cDestSpr.ProcessMouse(false);
        cDestSpr.MoveTop();
        
        Vector vTerrain = GetTerrainSize();
        if (vTerrain != null)
        {
            nTerrainWidth = (int) vTerrain.fX;
            nTerrainHeight = (int) vTerrain.fZ;
        }

        nMapWidth = (int)m_cMap.GetSize().fX;
        nMapHeight = (int)m_cMap.GetSize().fY;
        nMapPosX = (int)m_cMap.GetPos().fX;
        nMapPosY = (int)m_cMap.GetPos().fY;
        int nInterlaceTex = m_cMapInterlace.m_cNormalTexture.m_nId;
        m_cMapInterlace.SetTextureCoords(new Rect(0, 0, nMapWidth/m_cMapInterlace.GetTextureWidth(nInterlaceTex),
                                                        nMapHeight/m_cMapInterlace.GetTextureHeight(nInterlaceTex)));
        
        // inicjalizuje przliczniki
        nXcmIsPixls = (float) nMapWidth / (float) nTerrainWidth;
        nZcmIsPixls = (float) nMapHeight / (float) nTerrainHeight;
        
        // inicjalizcja kursora
		cCursor = (Cursor) CreateObject("Cursor");
		cCursor.SetCursorTex(cModule, sCursorTex);
		cCursor.Hide();
		ProcessMouse(false);
		//PositionHUDComponent(-511, 154);
    }
    
    void SetCompassRef(HUDCompass cCompass)
    {
        cHUDCompasRef = cCompass;
    }
    
    public void OnInit()
    {
        super.OnInit();
        m_cMapPicture = GetElem("ID_MAP");
        m_cMap = GetElem("ID_MAP_TOP");
        m_cMapInterlace = GetElem("ID_MAP_INTERLACE");
        GetElem("ID_FRAME").MoveTop();
        m_cObjectives = (UIStatic)GetElem("ID_OBJ_PRIMARY");
        cMapSpr.SetSize(m_cMap.GetSize());
    }
	
    public void OnDestroy()
    {
		super.OnDestroy();
		
		if (nMapSprTex != 0)
		{
			m_cMapPicture.ReleaseTexture(nMapSprTex);
			nMapSprTex = 0;
		}
        RemoveSprite(cMapSpr);
        cMapSpr.delete();
        cMapSpr = null;	   

		cPlayerSpr.ReleaseTexture(nPlayerSprTex);
        RemoveSprite(cPlayerSpr);
        cPlayerSpr.delete();
        cPlayerSpr = null;	
           
        cDestSpr.ReleaseTexture(nDestSprTex);
        RemoveSprite(cDestSpr);
        cDestSpr.delete();
        cDestSpr = null;	
        
        
        //Log("[HUDMap.OnDestroy]: Destroing DONE. \n");
    }
      
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.CanActivate(HUDManager._HUD_MAP))
			return;
		
        super.Activate();   
		
        CallMethodsAfterActivate();

        cMapSpr.ProcessMouse(true);

		Draw();
		
        PositionHUDComponent(0, 0);
        cHUDManager.HudMenuActivated(HUDManager._HUD_MAP);
    }
	
    void CallMethodsAfterActivate()
    {
        CallMethodEvery("ComputePlayerPos", 0.05f);        
		CallMethodEvery("PlayerPosBlink", m_fBlinkTime);
    }
    
    void DisableCallMethodsAfterDeactivate()
    {
        DisableCallMethod("ComputePlayerPos");
        DisableCallMethod("PlayerPosBlink");
    }
    
	public void ActivateSlow()
	{
		Activate();
	}

	public void ComponentMoved()
	{
		if (!bActiveFlag)
		{
			cHUDManager.m_bIsUserHUDActive = false;
			HideAll();
		}
	}
	
	public void HideAll()
	{
		cMapSpr.ProcessMouse(false);
		
		cMapSpr.Hide();
		cPlayerSpr.Hide();
		cDestSpr.Hide();
		cCursor.Hide();

        // chowamy tooltipy
        if (GetModule() instanceof ChromeModule )
		    ((ChromeModule) GetModule()).m_ObjectivesManager.HideAllTooltips();				
        
		// chowamy objectives i locations
        /*if (GetModule() instanceof ChromeModule )
		    ((ChromeModule) GetModule()).m_ObjectivesManager.HideAll();				*/
	}
	
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
        super.Deactivate();   
        
        DisableCallMethodsAfterDeactivate();
		
		HideAll();
		
        cHUDManager.HudMenuDeactivated(HUDManager._HUD_MAP);
    }
	
	public void DeactivateSlow()
	{
		Deactivate();
	}
    
    void DrawDoUnderCursor()
    {
        cDestSpr.CallOnFrameEnd("MoveTop");
        
        ShowDestPoint();
        
        cPlayerSpr.MoveTop();
        if (m_bPlayerPosVisible)
	        cPlayerSpr.Show();
    }
    
    
    public void DrawDo()
    {
	    if (bActiveFlag)
        {
            Show();
            cMapSpr.Show();
            
            DrawDoUnderCursor();
            
            cCursor.MoveTop();
            cCursor.Show();
            ShowDestPoint();
			
			// pokazujemy objectives i locations
            if ( GetModule() instanceof ChromeModule )
		        ((ChromeModule) GetModule()).m_ObjectivesManager.ShowAll();				
        }
    }
	
	public void PlayerPosBlink()
	{
        m_bPlayerPosVisible = !m_bPlayerPosVisible;
        
        if (m_bPlayerPosVisible)
			cPlayerSpr.Show();
		else
			cPlayerSpr.Hide();
	}
	
    /** metoda laduje mape terenu
     */
    public void SetTerrainMap(String map_texture)
    {
		//LogLine("SetTerrainMap:" + map_texture);
        sTexMapName = map_texture;
		if (nMapSprTex != 0)
		{
			m_cMapPicture.ReleaseTexture(nMapSprTex);
			nMapSprTex = 0;
		}
        
        nMapSprTex = m_cMapPicture.AddTexture(sTexMapName);
        float fMarginShift = (cHUDCompasRef._MARGIN/(float)GetTextureWidth(nMapSprTex));
        m_cMapPicture.SetTexture(nMapSprTex, new Rect(fMarginShift, fMarginShift, 1f - fMarginShift, 1f - fMarginShift));
        
    }
    
    /** metoda wylicza polozenie punktu playera na mapie
     */
    public void ComputePlayerPos()
    {
        float pl_spr_pos_x = 0.0f;
        float pl_spr_pos_z = 0.0f;
        Vector player_pos = cPlayer.GetPositionVectorVolatile();
        
        pl_spr_pos_x = nMapWidth - player_pos.fX * nXcmIsPixls;
        pl_spr_pos_z = nMapHeight - player_pos.fZ * nZcmIsPixls;
        
        cPlayerSpr.SetRelativePos(new Vector(pl_spr_pos_x - (float) nPlayerSprSizeX / 2.0f,
                                             pl_spr_pos_z - (float) nPlayerSprSizeY / 2.0f,
                                             0));               
        ComputeRotation();
    }
    
    /*void WorldToMap(Vector vPos)
    {
    vPos.fX *= nXcmIsPixls;
    vPos.fY = vPos.fZ * nXcmIsPixls;
    }*/
    
                    
	public Vector GetOnMapPos(Vector vector)
	{
		Vector vOnMap = new Vector();
		vOnMap.fX = nMapWidth - vector.fX * nXcmIsPixls;
		vOnMap.fY = nMapHeight - vector.fZ * nZcmIsPixls;
		return vOnMap;
	}
	
    /** metoda wylicza polozenie punktu docelowego na mapie
     */
    public void ComputeDestPointPos()
    {
		if (cHUDCompasRef == null)
			return;
		if (cHUDCompasRef.GetDestPosition() == null)
			return;
		
		float pl_spr_pos_x = 0;
		float pl_spr_pos_z = 0;
			 
		Vector dest_pos = new Vector(cHUDCompasRef.GetDestPosition());
		     
		pl_spr_pos_x = nMapWidth - dest_pos.fX * nXcmIsPixls;
		pl_spr_pos_z = nMapHeight - dest_pos.fZ * nZcmIsPixls;
        
		cDestSpr.SetRelativePos(new Vector(pl_spr_pos_x - (float) nDestSprSizeX / 2.0f,
		   								   pl_spr_pos_z - (float) nDestSprSizeY / 2.0f,
		   								   0));  
    }
	
	public Vector GetWorldPos(float fX, float fZ)
	{
		Vector vPos = new Vector();
		
		vPos.fX = (nMapWidth - (fX - (float) nMapPosX)) / nXcmIsPixls;//nMapWidth * nTerrainWidth;
		vPos.fZ = (nMapHeight - (fZ - (float) nMapPosY)) / nXcmIsPixls;//nMapHeight * nTerrainHeight;
		
		return vPos;
	}
	
    /** metoda ustawia nowy destination point
     */
    public void SetDestPoint(float xx, float yy)
    {
        float pos_x = nMapWidth - ( xx - (float) nMapPosX );
	    float pos_y = nMapHeight - ( yy - (float) nMapPosY );
        
        cDestSpr.SetPos(new Vector(xx - (float) nDestSprSizeX / 2.0f,
								   yy - (float) nDestSprSizeY / 2.0f,
								   0));        
        float dest_x = pos_x * (float) nTerrainWidth / (float) nMapWidth;
        float dest_z = pos_y * (float) nTerrainHeight /(float) nMapHeight;
        
		cHUDCompasRef.SetDestPosition( dest_x, 0, dest_z);
    }
	
    /** metoda wyswietla dest point jesli taki jest zaznaczony
     */
    public void ShowDestPoint()
    {
      if (cHUDCompasRef.GetDestPosition() != null) 
      {   
          ComputeDestPointPos();
          cDestSpr.Show();
          cDestSpr.CallOnFrameEnd("MoveTop");
      }
    }
    
    /** metoda oblicza kat obrotu sprite'a pozycji gracza
     */
    public void ComputeRotation()
    {
        double kat = 0.0;
    
        Vector PosVect = null;
        Vector RightPosVect = null;
        if (cPlayer != null)
        {
            PosVect = cPlayer.GetForwardVector();
			RightPosVect = cPlayer.GetRightVector();
		
			float cos_alfa = PosVect.Dot(vNBase);
			float cos_beta = RightPosVect.Dot(vNBase);
			double kat_alfa = (double)Tools.acos(cos_alfa);
			double kat_degree = (kat_alfa * 180.0) / java.lang.Math.PI;
			if (cos_beta >= 0)
				kat = kat_degree;
			else
				kat = 180.0f + (180.0f - kat_degree);
            cPlayerSpr.SetRotation((float) kat);
        }
	}
    
	public void PositionHUDComponent(int relX, int relY)
	{
		super.PositionHUDComponent(relX, relY);
		
        cMapSpr.SetPos(new Vector(nMapPosX, nMapPosY, 0));
        
        cPlayerSpr.SetRelativePos(new Vector(relX, relY, 0));
		ComputeDestPointPos();		

		Draw();
	}
    
    Sprite GetObjectivesSprite()
    {
        return m_cObjectives;
    }
    
    /** Method using in net game in class HudMapNet */
    void OnUpdateGameSettings()
    {
    }
}
