public class ImplantListBox extends ListBox
{
	Sprite m_ItemSelection[] = new Sprite[4];
	int m_iSelectionTex[] = new int[4];
	int m_SelStartX;
	int m_SelStartY;
	int m_iSelWidth;
	int m_iSelHeight;

	void CreateSelection(int startX, int startY, int iWidth, int iHeight)
	{
		RemoveSelection();
		
		m_iSelWidth = iWidth;
		float fHeight = (float) iHeight / (float) nCapacity;
		m_iSelHeight = (int) fHeight;
		
		for (int i = 0; i < 2; i++)
		{
			m_ItemSelection[i] = (Sprite) CreateObject("Sprite");
	        m_iSelectionTex[i] = m_ItemSelection[i].AddTexture("CH_T_cyber.png");
	        m_ItemSelection[i].SetTexture(m_iSelectionTex[i],
										  new Rect(startX * EHudInvParams._P1024,
												   ((float) startY) * EHudInvParams._P512,
												   (startX + m_iSelWidth) * EHudInvParams._P1024,
												   ((float) startY + 1f) * EHudInvParams._P512));
	        m_ItemSelection[i].SetSize(new Vector(m_iSelWidth, 1, 0));
			m_ItemSelection[i].ProcessMouse(false);
			AddChild(m_ItemSelection[i]);
		}
		
		for (int i = 2; i < 4; i++)
		{
			m_ItemSelection[i] = (Sprite) CreateObject("Sprite");
	        m_iSelectionTex[i] = m_ItemSelection[i].AddTexture("CH_T_cyber.png");
	        m_ItemSelection[i].SetTexture(m_iSelectionTex[i],
										  new Rect(startX * EHudInvParams._P1024,
												   startY * EHudInvParams._P512,
												   (startX + 1) * EHudInvParams._P1024,
												   (startY + m_iSelHeight + 1) * EHudInvParams._P512));
			// wysokosc tekstury musi byc o 1 wieksza, niz wyliczona
	        m_ItemSelection[i].SetSize(new Vector(1, m_iSelHeight + 1, 0));
			m_ItemSelection[i].ProcessMouse(false);
			AddChild(m_ItemSelection[i]);
		}
	}
	
	void DrawSelection(Vector vPos)
	{
		vPos.fX -= 1;
		
		m_ItemSelection[0].SetPos(new Vector(vPos.fX, vPos.fY, 0));
		m_ItemSelection[1].SetPos(new Vector(vPos.fX, vPos.fY + m_iSelHeight, 0));
		m_ItemSelection[2].SetPos(new Vector(vPos.fX, vPos.fY, 0));
		m_ItemSelection[3].SetPos(new Vector(vPos.fX + m_iSelWidth, vPos.fY, 0));
	}
	
	void HideSelection()
	{
		if (m_ItemSelection[0] == null)
			return;
		for (int i = 0; i < 4; i++)
			m_ItemSelection[i].Hide();
	}
	
	void ShowSelection()
	{
		if (m_ItemSelection[0] == null)
			return;
		for (int i = 0; i < 4; i++)
			m_ItemSelection[i].Show();
	}
	
	void RemoveSelection()
	{
		for (int i = 0; i < m_ItemSelection.length; i++)
		{
			if (m_ItemSelection[i] != null)
			{
				if (m_iSelectionTex[i] != 0)
				{
					m_ItemSelection[i].ReleaseTexture(m_iSelectionTex[i]);
					m_iSelectionTex[i] = 0;
				}
				RemoveSprite(m_ItemSelection[i]);
				m_ItemSelection[i].delete();
				m_ItemSelection[i] = null;
			}
		}
	}
	
	void CreateScrollBar()
    {
        btnUpArrow = (Button) CreateObject("Button");
        AddChild(btnUpArrow);
        AddChildWnd(btnUpArrow, wndParent);
        btnUpArrow.Init(new UIElement(EUI.ID_SCROLL_UP,0,
                                    new Vector(0, 0, 0),
                                    new Vector(ImplantWindow._SCROLL_ARROW_WIDTH,
											   20,
											   0),
	                                "CH_T_Cyber.png",
                                    new Rect(253.0f * EHudInvParams._P1024,
											 71.0f * EHudInvParams._P512,
											 275.0f * EHudInvParams._P1024,
											 91.0f * EHudInvParams._P512),
	                                "CH_T_Panel.png",
                                    new Rect(829.0f * EHudInvParams._P1024,
											 431 * EHudInvParams._P512,
											 851.0f * EHudInvParams._P1024,
											 451 * EHudInvParams._P512),
	                                "",
                                    new Rect(),
	                                "",
                                    new Rect(),
                                    EButtonFlags.BTN_TYPE_PUSHBUTTON,
                                    ""),
                      module);
                
        btnDnArrow = (Button) this.CreateObject("Button");
        AddChild(btnDnArrow);
        AddChildWnd(btnDnArrow, wndParent);
        btnDnArrow.Init(new UIElement(EUI.ID_SCROLL_DN,0,
                                    new Vector(0, 0, 0),
                                    new Vector(ImplantWindow._SCROLL_ARROW_WIDTH,
											   20,
											   0),
	                                "CH_T_Cyber.png",
                                    new Rect(253.0f * EHudInvParams._P1024,
											 387.0f * EHudInvParams._P512,
											 275.0f * EHudInvParams._P1024,
											 407.0f * EHudInvParams._P512),
	                                "CH_T_Panel.png",
                                    new Rect(829.0f * EHudInvParams._P1024,
											 453.0f * EHudInvParams._P512,
											 851.0f * EHudInvParams._P1024,
											 473.0f * EHudInvParams._P512),
	                                "",
                                    new Rect(),
	                                "",
                                    new Rect(),
                                    EButtonFlags.BTN_TYPE_PUSHBUTTON,
                                    ""),
                      module);
		
		btnScrollBar = (Button)CreateObject("Button");
		btnScrollBar.Init( new UIElement(0, 0,
										 new Vector(0, 0, 0),
										 new Vector(ImplantWindow._SCROLL_ARROW_WIDTH,
													20,
													0),
		                                 "CH_T_Panel.png",
                                         new Rect(829.0f * EHudInvParams._P1024,
												  475.0f * EHudInvParams._P512,
												  851.0f * EHudInvParams._P1024,
												  496.0f * EHudInvParams._P512),
		                                 "CH_T_Panel.png",
                                         new Rect(829.0f * EHudInvParams._P1024,
												  475.0f * EHudInvParams._P512,
												  851.0f * EHudInvParams._P1024,
												  496.0f * EHudInvParams._P512),
		                                 "CH_T_Panel.png",
                                         new Rect(829.0f * EHudInvParams._P1024,
												  475.0f * EHudInvParams._P512,
												  851.0f * EHudInvParams._P1024,
												  496.0f * EHudInvParams._P512),
		                                 "CH_T_Panel.png",
                                         new Rect(829.0f * EHudInvParams._P1024,
												  475.0f * EHudInvParams._P512,
												  851.0f * EHudInvParams._P1024,
												  496.0f * EHudInvParams._P512),
										 EButtonFlags.BTN_TYPE_PRESSBUTTON,
										 ""),
						   module);
		AddChild(btnScrollBar);
        AddChildWnd(btnScrollBar, wndParent);
    }
	
	void SetScrollBarPos()
	{
		int iScrollBarLevels = GetItemCount() - nCapacity;
		if (iScrollBarLevels > 0)
		{
			btnScrollBar.Show();
			
			float fPos = (float) nFirstVisible / (float) iScrollBarLevels;
			
			Vector size = GetSize();
			Vector arrowSize = btnUpArrow.GetSize();
			Vector scrollSize = btnScrollBar.GetSize();
			
			float fYWorkArea = size.fY - 2 * arrowSize.fY - 1 - scrollSize.fY;
				
			btnScrollBar.SetRelativePos(new Vector(size.fX - arrowSize.fX,
												   1 + arrowSize.fY + fYWorkArea * fPos,
												   0.0f));   	
		}
		else
		{
			btnScrollBar.Hide();
			return;
		}
	}
	
	public void Show()
	{
		super.Show();
		
		ShowSelection();
	}
	
	public void Hide()
	{
		super.Hide();
		
		HideSelection();
	}
	
	void OnButton(Button btnSender)
	{
		super.OnButton(btnSender);
		
		if ( (btnSender.nID == EUI.ID_SCROLL_UP) ||
			 (btnSender.nID == EUI.ID_SCROLL_DN) )
		{
			// powiadamiamy implantwindow, ze rezygnujemy z selekcji
			wndParent.OnButton(btnSender);
			SetSelection(-1);
		}
		
		int iSelection = GetSelection();
		
		if (iSelection != -1)
		{
			if ( (iSelection >= nFirstVisible) &&
				 (iSelection < nFirstVisible + nCapacity) )
			{
				ShowSelection();
				DrawSelection(GetItem(iSelection).GetPos());
			}
			else
				HideSelection();
		}
		else
			HideSelection();

	}
	
	void SetInactive(int iNum)
	{
		Button button = GetItem(iNum);
		button.SetTextColor(1, 1, 1, 1);
		button.DisplayText(button.sText);
	}

	void SetActive(int iNum)
	{
		Button button = GetItem(iNum);
		button.SetTextColor(0, 1, 0, 1);
		button.DisplayText(button.sText);
	}

	void SetDisabled(int iNum)
	{
		Button button = GetItem(iNum);
		button.SetTextColor(0.6f, 0.6f, 0.6f, 1);
		button.DisplayText(button.sText);
	}
}
