public class ImplantWindow extends Window
{
	static int _SCROLL_ARROW_WIDTH = 22;
	static int _LISTBOX_WIDTH = 198;
	static int _LISTBOX_HEIGHT = 336;
	static float _UPDATE_INTERVAL = 0.1f;
	static String _BUTTON_DBL_CLICK = "Data/Sounds/Menu/bong.wav";
	
	int _LISTBOX_X = 55;
	int _LISTBOX_Y = 71;

	int _DESCRIPTION_X = 304;
	int _DESCRIPTION_Y = 272;
	
	/** sciezka do textury huda */
    String m_TexHudImplantName = "CH_T_cyber.png";
	int m_iHudImplantTexNum = 0;

	ImplantListBox m_ImplantsList = null;
	
	Button m_ExitBtn = null;
	Button m_TimeBtn = null;
	
	static Module m_Module = null;
	Implant m_ActiveImplant = null;
	ImplantSystem m_ImplantSystem = null;

	ImplantDescriptionWindow m_DescriptionWindow = null;
	
	ImplantModule m_ImplantModule = null;
	
	ProgressBar m_Progress = null;
	
    void OnCreate()
    {
        super.OnCreate();
		
		m_Module = GetModule();

		// ustawiamy teksture menu implantow
		m_iHudImplantTexNum = AddTexture(m_TexHudImplantName, true, true);
        SetTexture(m_iHudImplantTexNum,
				   new Rect(0f * EHudInvParams._P1024,
							0f * EHudInvParams._P512,
							640f * EHudInvParams._P1024,
							480f * EHudInvParams._P512));
        SetSize(new Vector(640, 480, 0));
		
		// dodajemy list boxa
		m_ImplantsList = (ImplantListBox) CreateObject("ImplantListBox");
		m_ImplantsList.Init(new UIElement(EImplantWindowUI.ID_LISTBOX, 0,
								          new Vector(_LISTBOX_X, _LISTBOX_Y, 0),
										  new Vector(_LISTBOX_WIDTH + _SCROLL_ARROW_WIDTH,
													 _LISTBOX_HEIGHT,
													 0),
										  "",
										  new Rect(),
										  "",
										  new Rect(),
										  "", 
										  new Rect(),
										  "", 
										  new Rect(),
										  EButtonFlags.BTN_TYPE_LISTBOX,
										  ""),
							m_Module);
        AddChild(m_ImplantsList);
        AddChildWnd(m_ImplantsList, this);
        m_ImplantsList.ProcessMouse(true);
		m_ImplantsList.SetCapacity(10);
        m_ImplantsList.CreateSelection(_LISTBOX_X - 2,
									   _LISTBOX_Y,
									   _LISTBOX_WIDTH,
									   _LISTBOX_HEIGHT);
		
		m_ExitBtn = (Button) CreateObject("Button");
		m_ExitBtn.Init(new UIElement(EImplantWindowUI.ID_BTN_EXIT, 0,
									 new Vector(54, 426, 0),
									 new Vector(110, 19, 0),
									 "CH_T_Cyber.png",
									 new Rect(54f * EHudInvParams._P1024, 426f * EHudInvParams._P512, 164f * EHudInvParams._P1024, 445f * EHudInvParams._P512),
									 "CH_T_Cyber.png",
									 new Rect(734f * EHudInvParams._P1024, 123f * EHudInvParams._P512, 844f * EHudInvParams._P1024, 142f * EHudInvParams._P512),
									 "CH_T_Cyber.png",
									 new Rect(54f * EHudInvParams._P1024, 426f * EHudInvParams._P512, 164f * EHudInvParams._P1024, 445f * EHudInvParams._P512),
									 "CH_T_Cyber.png",
									 new Rect(54f * EHudInvParams._P1024, 426f * EHudInvParams._P512, 164f * EHudInvParams._P1024, 445f * EHudInvParams._P512),
									 EButtonFlags.BTN_TYPE_PUSHBUTTON,
									 "&Exit&"),
							m_Module);
        AddChild(m_ExitBtn);
        AddChildWnd(m_ExitBtn, this );
		m_ExitBtn.ProcessMouse(true);
        m_ExitBtn.SetTextPosFlags(ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_MIDDLE);
        m_ExitBtn.DisplayText("&Exit&");
		
		m_TimeBtn = (Button) CreateObject("Button");
		m_TimeBtn.Init(new UIElement(0, 0,
									 new Vector(529, 386, 0),
									 new Vector(54, 20, 0),
									 "",
									 new Rect(),
									 "",
									 new Rect(),
									 "",
									 new Rect(),
									 "",
									 new Rect(),
									 EButtonFlags.BTN_TYPE_PUSHBUTTON,
									 ""),
							m_Module);
        AddChild(m_TimeBtn);
        AddChildWnd(m_TimeBtn, this);
		m_TimeBtn.ProcessMouse(false);
        m_TimeBtn.SetTextPosFlags(ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_MIDDLE);
        m_TimeBtn.DisplayText("");

		m_Progress = (ProgressBar) CreateObject("ProgressBar");
		m_Progress.Init(new UIElement(0, 0,
									  new Vector(298, 388, 0),
									  new Vector(218, 17, 0),
									  "",
									  new Rect(),
									  "CH_T_Panel.png",
									  new Rect(609 * EHudInvParams._P1024,
											   495 * EHudInvParams._P512,
											   827 * EHudInvParams._P1024,
											   511 * EHudInvParams._P512),
									  "",
									  new Rect(),
									  "",
									  new Rect(),
									  EButtonFlags.WND_TYPE_PROGRESS_BAR,
									  ""),
						m_Module);
        AddChild(m_Progress);
        AddChildWnd(m_Progress, this);
		m_Progress.SetRange(100);
		m_Progress.ProcessMouse(false);
		
	}
	
	void SetImplantModule(ImplantModule module)
	{
		m_ImplantModule = module;
	}
	
	void InitControls()
	{
		for (int i = 0; i < ImplantSystem._IMPLANTS_NUM; i++)
		{
			ImplantButton button = (ImplantButton) CreateObject("ImplantButton");
			button.Init(new UIElement(EImplantWindowUI.ID_TEXT_LINES + i, 0,
									  new Vector(0, 0, 0),
									  new Vector(0, 0, 0),
									  "",
									  new Rect(),
									  "",
									  new Rect(),
									  "",
									  new Rect(),
									  "",
									  new Rect(),
									  EButtonFlags.BTN_TYPE_LISTBOX_ITEM,
									  ""),
						m_Module);
	        button.SetTextPosFlags(ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_MIDDLE);
	        button.SetFont(ChromeFonts.FONT_HUD);
            Implant cImplant = m_ImplantSystem.GetImplant(i);
			button.SetText(cImplant.m_sName);/* + 
                           " a: " + cImplant.m_fCurrAssimilation + 
                           " t: " + cImplant.GetCurAssimilationThreshold() + "/" +
                           cImplant.GetAssimilationThresholdsCount());*/
			button.DisplayText(button.sText);
	        button.ProcessMouse(true);
			m_ImplantsList.AddItem(button);
		}
	}
	
	
	
	public void SetImplantSystem(ImplantSystem system)
	{
		m_ImplantSystem = system;
	}
	
	
	
    
    Player GetPlayer()
    {
        if ( m_ImplantSystem != null )
             return m_ImplantSystem.GetPlayer();
        CrashLog("ImplantWindow m_ImplantSystem == null !!!\n");
        return null;
    }
}

class EImplantWindowUI
{
    static final int ID_LISTBOX  = 10;
    static final int ID_TEXT_LINES  = 100; // kolejne pozycje listy od tej liczby
    static final int ID_BTN_EXIT  = 50;
}
