
/** klasa modulu, w ktorym beda pokazane przemawiajace glowy
 * UWAGA: postac ta bedzie tylko ruszala ustami, dzwiek wav'ea
 * powinien zostat odpalony niezaleznie (z ChromeModuleSingle!)
 */
public class TalkingHeadModule extends Module
{
    /** Tytulowy bohater modulu, czyli gadajaca glowa :-) */
    TalkingHead m_cTalkingHead = null;
    
    /** Obiekt bedacy tlem glowy */
    MeshObject m_cBackground = null;
    
    /** identyfikator widoku */
	int m_iViewID = -1;		
    
	/** Parametry widoku */
    /** Pozycja widoku (wgledem lewego _dolnego_ naroznika ekranu)*/
	int m_nViewPosX         = 100;
	int m_nViewPosY         = 100;
    /** Pozycja Y wzgledem _gornego_ lewego naroznika ekranu */
    int m_nViewPosYFromUp   = 100;
    /** Wielkosc widoku */
	int m_nViewWidth        = 100;
	int m_nViewHeight       = 100;
    

    /** kamera, z ktorej patrzymy na glowe */
	CameraExtended m_cCamera = null;
    
    /** poczatkowe polozenie kamery */
	Vector m_vCamPos    = new Vector(0.0f, 90.0f, 280.0f);
	Vector m_vCamLookAt = new Vector(0.0f, 0.0f, 0.0f);
    
    /** FOV kamery */
    float m_fCameraFOV = 20.0f;
    
    
    /** Pozycja swiatla */
    Vector m_vLightPos = new Vector( 150.0f, 380.0f, 290.0f );
    
    
    /** 
     * Parametry dotyczace gadajacej glowy
     */
    
    /** plik z meshem gadajacej glowy */
    String m_sTHMeshName = null;
    /** nazwa elementu z ustami, jakby czasami sie kiedys miala roznic */
    String m_sTHLipsElementName = "Lips";
    /** nazwa sekwencji animacji ruszania glowa */
    String m_sTHHeadAnimName = "";
    
    /** 
     * Parametry dotyczace tla
     */
    
    /** Nazwa pliku z meshem */
    String m_sBackMeshName = null;
    /** Pozycja */
    Vector m_vBackPos = new Vector( 0.0f , 175.0f, 70.0f );
    
    // skin mesha
    String m_sTHSkin = null;
    
    /** Dodatkowe
     */
	
    /** character z module single dla ktorego stworzono ten modul z gadajaca glowa*/
    //CharacterDescription  m_cCharacter = null;
    
    /** HUDCompNiunia z ktorego bedzie wolana ta gadajaca glowa, do ewentualnych 
     * call backow np zakonczenia "mowienia" */
    HUDCompNiunia    m_cHUDCompNiunia = null;
        

    
    public void OnCreate()
	{
        TimerStart();
        
        // oczywiscie na module przydalaby sie jakas kamera,
        // stworzmy ja zatem sobie...
		m_cCamera = (CameraExtended) CreateObject("CameraExtended");
        
        // co wiecej, ustawmy jej jakies parametry
        // i ustawiamy kamere w odpowiedniej pozycji
		SetUpCamera();
        
        // teraz dodajmy widok z tej kamery do modulu
		m_iViewID = AddView( m_cCamera,
						     m_nViewPosX,
						     m_nViewPosY,
						     m_nViewWidth,
						     m_nViewHeight );
                    
        // wyrzucmy go na wierzch, a co...
        MoveViewToTop( m_iViewID );
        
        
        // ustawmy swiatlo na levelu
        SetUpLight();
                
         
		//ForceClearView( m_iViewID, true ); // widok musi pod soba wyswietlac tlo (w naszym przypadku czarne)
		ListenerOnViewActive( m_iViewID, false ); // bron boze nie ma byc zadnych dzwiekow z tego widoku
		
        //FogSetColor(1,1,1);
        
        InitGrid( 2000.0f, 2000.0f, -1000.0f, 1000.0f, -1000.0f, 1000.0f, -1000.0f, 1000.0f );
        
        // no i dodajmy nasz obiekt z gadajaca glowa
        InitSceneObjects();
        
        // domyslnie nasz level renderowal sie bedzie na samym koncu,
        boolean bRenderAfterSprites = false;
        // ale jak level single jest nieaktywny to nie
        if ( m_cHUDCompNiunia != null )
            bRenderAfterSprites = m_cHUDCompNiunia.GetActiveModuleSingle();
        
        SetRenderAfterSprites( bRenderAfterSprites );
        
        ShowSprites(false);
	}
    
    public void OnDestroy()
	{
        Deactivate();
        
        if ( m_iViewID != -1)
            RemoveView( m_iViewID );
        
        if ( m_cCamera != null )
        {
		    m_cCamera.delete();
            m_cCamera = null;
        }
		
        DestroySceneObjects();
	}
	
    public void OnDeactivate()
    {
        if (m_cTalkingHead != null)
            m_cTalkingHead.StopSpeak();
    }
    
    void SetParams(HUDCompNiunia cHud,
                   int nPosX,int nPosY,int nSizeX,int nSizeY)
    {
        m_cHUDCompNiunia = cHud;
        
        m_nViewPosX   = nPosX;
        // UWAGA: jako dana wejsciowa mamy pozycje wzgledem lewego _gornego_
        // naroznika ekranu, jako ze widok potrzebuje pozycji wzgledem
        // lewego _dolnego_ naroznika ekranu, to trzeba przed podaniem 
        // parametrow do widoku odswiezyc w zaleznosci od rozdzielczosci ekranu
	    m_nViewPosYFromUp  = nPosY;
	    m_nViewWidth  = nSizeX+1;
	    m_nViewHeight = nSizeY+1;
        
        // tu wspomniane wyzej odswiezenie
        UpdateViewOrigin();
    }
    
    /** Odswiezenie pozycji widoku, 
     * Jako ze pozycje widoku podaje sie zgledem jego _dolnego_ lewego 
     * naroznika, zatem po kazdej zmianie rozdzielczosci ekranu nalezu 
     * zawolac ta metode zeby odpowiednio przeliczyly sie wspolrzedne
     */
    void UpdateViewOrigin()
    {
	    m_nViewPosY = GetScreenHeight() - ( m_nViewPosYFromUp + m_nViewHeight );
       
        // jezeli widok juz jest dodany do modulu, to zaktualizujmy go
        if ( m_iViewID != -1 )
        {
            CrashLog("SetViewOrigin: m_iViewID="+m_iViewID+" m_nViewPosX="+m_nViewPosX+" m_nViewPosY="+m_nViewPosY+"\n");
            SetViewOrigin( m_iViewID, m_nViewPosX, m_nViewPosY );
        }
    }
    
    /** Stworzenie i inicjacja obiektu gadajacej glowy oraz tla
	 */
	public void InitSceneObjects()
	{
		// tutaj powstaje model obiektu do gadania
		m_cTalkingHead = (TalkingHead) CreateObjectNoInit("TalkingHead");
		// przepisujemy mu parametry charakterystyczne dla modulu
        m_cTalkingHead.MeshName          = m_sTHMeshName;
        m_cTalkingHead.sLipsElementName  = m_sTHLipsElementName;
        m_cTalkingHead.sHeadAnimName     = m_sTHHeadAnimName;
        m_cTalkingHead.sSkin             = m_sTHSkin;
		// no i inicjujemy
        m_cTalkingHead.InitObject();
        
		// TODO: move this param to the material script
		// m_cTalkingHead.SetMeshMaterialAmbient( 0.26f, 0.26f, 0.26f );
		
		
        // po czym dodajemy do levelu            
		m_cTalkingHead.ActivateOnModuleGridIndependent();
        
        if (m_sBackMeshName != null)
        {
            // jeszcze tlo
            /*m_cBackground           = (MeshObject) CreateObjectNoInit("MeshObject");
            m_cBackground.MeshName  = m_sBackMeshName;
            m_cBackground.InitObject();
            m_cBackground.SetPosition(m_vBackPos);
            
            AddControlObject( m_cBackground );*/
        }
	}
    
    /** Skasowanie obiektu gadajacej glowy
     */
    public void DestroySceneObjects()
	{
		if ( m_cTalkingHead != null )
        {
            m_cTalkingHead.delete();
            m_cTalkingHead = null;
        }
        
        if ( m_cBackground != null )
        {
            m_cBackground.delete();
            m_cBackground = null;
        }
	}
	    	
	
	/** Ustawienie kamery tak, by patrzyla z pozycji m_vCamPos
	 *  na punkt m_vCamLookAt, ponadto zapewnienie FOV (m_fCameraFOV)
	 *  oraz odpowiednie ClipNear i ClipFar
	 */
	void SetUpCamera()
	{
        if ( m_cCamera == null )
            return;

        // nasza kamera powinna
        // obslugiwac przychodzace propagacje
        m_cCamera.SetAcceptPropagatedFlash( true );
        // przyjmowac je (i pamietac) naet gdy nie jest aktualnie kamera aktywna
        m_cCamera.SetKeepFlashIfNotActive( false );
        // ale swoich ewentualnych flaszy nie powinnismy propagowac...
        m_cCamera.SetPropagateFlash( false );
        
            
        m_cCamera.SetFOV( m_fCameraFOV );
		m_cCamera.SetClipNear( 1.0f );
        m_cCamera.SetClipFar( 1000.0f );
        
        Vector vCamPos     = new Vector( m_vCamPos );
		Vector vCamForward = new Vector( m_vCamPos );
		vCamForward.Sub( m_vCamLookAt );
		vCamForward.Normalize();

        m_cCamera.FromForwardUpPos( vCamForward, Vector.Up, vCamPos );
	}
    
    CameraExtended GetCamera()
    {
        return m_cCamera;
    }
    
    void SetUpLight()
    {
        SetDefaultLight( m_vLightPos,
                         new Vector(1.0f,1.0f,1.0f),
                         true );
    }
		
    void ActivateAndSpeak(String sWave, int nPlayingWave)
    {
        Activate();
        
        // kazemy naszej glowie poruszac ustami
        m_cTalkingHead.Speak( sWave );
        m_cTalkingHead.SetExternalPlayingWave(nPlayingWave);
        //CallMethodIn("TestFlash",1.5f);
    }

    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[TalkingHeadModule.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_DIALOG)
        {
			super.SGLoadChunk(cFC);
	
			if (m_cTalkingHead != null)
				m_cTalkingHead.StopSpeak();
				m_cTalkingHead.StopAnim("");			
			
			m_cTalkingHead = (TalkingHead)cFC.LoadObject(m_cTalkingHead,this);
        }
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[TalkingHeadModule.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_DIALOG, cFCParent);
		
		super.SGSaveChunk(cFC);
		    
		cFC.SaveObject(m_cTalkingHead);
			
		cFC.delete();
	}				
    
    
    /** Ponizsze metody sa tylko potrzebne w fazie testow!!!!
     * TODO: wywalic to co ponizej!!!!
     */
    /*
    void TestFlash()
    {
        m_cCamera.Flash(CameraExtended._FLASH_BLOOD, 
                        2.0f, 
                        100.0f, 
                        1.5f);
    }
            
    */
            
    
    /*
	void Activate()
	{
		super.Activate();
		
        //FIXIT: tylko do testow
        RegisterKeyRequest();
	}
	
	void Deactivate()
	{
		super.Deactivate();
		
        //FIXIT: tylko do testow
        UnregisterKeyRequest();
	}
    
    
    float   fDelta = 1.0f;
    
    // co zmieniamy
    // 0, pozycja kamery
    // 1, punkt patrzenia kamery
    // 2, pozycja swiatla
    int     nModePos = 0;
    
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        Vector vModify = m_vCamPos;
        fDelta = 1.0f;
        switch ( nModePos )
        {
        case 0:
            vModify = m_vCamPos;
            break;
        case 1:
            vModify = m_vCamLookAt;
            break;
        case 2:
            vModify = m_vLightPos;
            fDelta = 10.0f;
            break;
        }
            
        
        //jesli nie mamy okularkow
        if (bKeyState)
        {
            boolean bUpdatePos = true;
            boolean bUpdateFOV = false;
            
            if(nKeyCode==EKey._NUMPAD8)
               vModify.fY += fDelta;
            else if(nKeyCode==EKey._NUMPAD2)
               vModify.fY -= fDelta;
            else if(nKeyCode==EKey._NUMPAD4)
               vModify.fX += fDelta;
            else if(nKeyCode==EKey._NUMPAD6)
               vModify.fX -= fDelta;
            else if(nKeyCode==EKey._UP)
               vModify.fZ -= fDelta;
            else if(nKeyCode==EKey._DOWN )
               vModify.fZ += fDelta;
            else
            {
                bUpdatePos = false;
                if(nKeyCode==EKey._NUMPAD7)
                {
                   m_fCameraFOV += 1.0;
                   bUpdateFOV = true;
                }
                else if(nKeyCode==EKey._NUMPAD1)
                {
                   m_fCameraFOV -= 1.0;
                   bUpdateFOV = true;
                } 
                else if (nKeyCode==EKey._NUMPAD5)
                {
                    CrashLog(" m_vCamPos    "+m_vCamPos+"\n"+
                         " m_vCamLookAt "+m_vCamLookAt+"\n"+
                         " m_vLightPos  "+m_vLightPos+"\n"+
                         " m_fCameraFOV "+m_fCameraFOV+"\n");
                } 
                else if (nKeyCode==EKey._NUMPAD0)
                {
                    nModePos = (nModePos+1)%3;
                    CrashLog("Aktualny tryb: "+ ((nModePos==0)?"CAMERA POS":(nModePos==1)?"CAMERA LOOKAT":"LIGHT POS")+"\n");
                }
            }
            
            if ( bUpdatePos || bUpdateFOV )
            {
                SetUpCamera();
                SetUpLight();
            }
        }
            
        vModify = null;
    }
    //*/        	
}
