/** Klasa definiujaca rodzaje amunicji
 */

public class EAmmoType
{
    final static byte _9mmShort		= 0;
    final static byte _12mmShort	= 1;
    final static byte _8mmLong		= 2;
    final static byte _14mmLong		= 3;
    final static byte _Energy		= 4;
    final static byte _HEX		    = 5;
    final static byte _Shotgun		= 6;
    final static byte _Rocket		= 7;
    final static byte _Grenades		= 8;
    final static byte _Unlimited    = 9;
    final static byte _Cannon       = 10;
    final static byte _EnergyRocket = 11;

    private static String [][]FxName = 
    //   _9mmShort,             _12mmShort,             _8mmLong,               _14mmLong,              _Energy,                _HEX,               _Shotgun,               _Rocket,            _Grenades,          _Unlimited,         _Cannon,            _EnergyRocket
    {
        {"GroundBulletSmall",   "GroundBulletLarge",    "GroundBulletSmall",    "GroundBulletLarge",    "GroundBulletEnergy",   "GroundHEX",        "GroundBulletSmall",    "GroundRocket",     "GroundRocket",     "GroundRocket",     "GroundCannon",     "GroundRocket"},//GROUND
        {"WoodBulletSmall",     "WoodBulletLarge",      "WoodBulletSmall",      "WoodBulletLarge",      "GroundBulletEnergy",   "GroundHEX",        "WoodBulletSmall",      "GroundRocket",     "GroundRocket",     "GroundRocket",     "WoodCannon",       "GroundRocket"},//WOOD
        {"MetalBulletSmall",    "MetalBulletLarge",     "MetalBulletSmall",     "MetalBulletLarge",     "MetalBulletEnergy",    "MetalHEX",         "MetalBulletSmall",     "MetalRocket",      "MetalRocket",      "MetalRocket",      "MetalCannon",      "MetalRocket"},//METAL
        {"PlasticBulletSmall",  "PlasticBulletLarge",   "PlasticBulletSmall",   "PlasticBulletLarge",   "GroundBulletEnergy",   "GroundHEX",        "PlasticBulletSmall",   "GroundRocket",     "GroundRocket",     "GroundRocket",     "PlasticCannon",    "GroundRocket"},//PLASTIC
        {"", "", "", "", "", "",  "", "", "", "", "", ""},//GLASS
        {"ConcreteBulletSmall", "ConcreteBulletLarge",  "ConcreteBulletSmall",  "ConcreteBulletLarge",  "ConcreteBulletEnergy", "GroundHEX",        "ConcreteBulletSmall",  "GroundRocket",     "GroundRocket",     "GroundRocket",     "ConcreteCannon",   "GroundRocket"},//CONCRETE
        {"PlexiBulletSmall",    "PlexiBulletLarge",     "PlexiBulletSmall",     "PlexiBulletLarge",     "PlexiBulletEnergy",    "GroundHEX",        "PlexiBulletSmall",     "GroundRocket",     "GroundRocket",     "GroundRocket",     "PlexiCannon",      "GroundRocket"},//PLEXI
        {"BodyBulletSmall",     "BodyBulletLarge",      "BodyBulletSmall",      "BodyBulletLarge",      "BodyBulletEnergy",     "GroundHEX",        "BodyBulletSmall",      "GroundRocket",     "GroundRocket",     "GroundRocket",     "BodyCannon",       "GroundRocket"},//BODY
        {"",                    "",                     "",                     "",                     "",                     "",                 "",                     "",                 "",                 "",                 "",                 ""},//ARMOR
        {"FXWaterHit",          "FXWaterHitLarge",      "FXWaterHit",           "FXWaterHitLarge",      "FXWaterHitLarge",      "FXWaterHitLarge",  "FXWaterHit",           "FXWaterHit",       "FXWaterHit",       "FXWaterHit",       "FXWaterHitLarge" , "FXWaterHit"},//WATER
    };

    private static String [][]SoundName =
    //  _9mmShort,              _12mmShort,         _8mmLong,           _14mmLong,          _Energy,                _HEX,                   _Shotgun,               _Rocket,                _Grenades,              _Unlimited,             _Cannon,                _EnergyRocket
    {
        {"RicGroundPistol",     "RicGroundRifle",   "RicGroundRifle",   "RicGroundRifle",   "RicGroundSniper",      "RicGroundSniper",      "RicGroundPistol",      "RicGroundPistol",      "RicGroundPistol",      "RicGroundPistol",      "RicGroundPistol",      "RicGroundPistol"}, //GROUND
        {"RicWoodPistol",       "RicWoodRifle",     "RicWoodRifle",     "RicWoodRifle",     "RicWoodSniper",        "RicWoodSniper",        "RicWoodPistol",        "RicWoodPistol",        "RicWoodPistol",        "RicWoodPistol",        "RicWoodPistol",        "RicWoodPistol"}, //WOOD
        {"RicMetalPistol",      "RicMetalRifle",    "RicMetalRifle",    "RicMetalRifle",    "RicMetalSniper",       "RicMetalSniper",       "RicMetalPistol",       "RicMetalPistol",       "RicMetalPistol",       "RicMetalPistol",       "RicMetalPistol",       "RicMetalPistol"}, //METAL
        {"RicPlasticPistol",    "RicPlasticRifle",  "RicPlasticRifle",  "RicPlasticRifle",  "RicPlasticSniper",     "RicPlasticSniper",     "RicPlasticPistol",     "RicPlasticPistol",     "RicPlasticPistol",     "RicPlasticPistol",     "RicPlasticPistol",     "RicPlasticPistol"}, // PLASTIC
        {"RicPlexiPistol",      "RicPlexiRifle",    "RicPlexiRifle",    "RicPlexiRifle",    "RicPlexiSniper",       "RicPlexiSniper",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol"},//GLASS
/*TODO*/{"RicConcretePistol",   "RicConcreteRifle", "RicConcreteRifle", "RicConcreteRifle", "RicConcreteSniper",    "RicConcreteSniper",    "RicConcretePistol",    "RicConcretePistol",    "RicConcretePistol",    "RicConcretePistol",    "RicConcretePistol",    "RicConcretePistol"},// CONCRETE
/*TODO*/{"RicPlexiPistol",      "RicPlexiRifle",    "RicPlexiRifle",    "RicPlexiRifle",    "RicPlexiSniper",       "RicPlexiSniper",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol"},// PLEXIGLASS
/*TODO*/{"RicBodyPistol",       "RicBodyRifle",     "RicBodyRifle",     "RicBodyRifle",     "RicBodySniper",        "RicBodySniper",        "RicBodyPistol",        "RicBodyPistol",        "RicBodyPistol",        "RicBodyPistol",        "RicBodyPistol",        "RicBodyPistol"},// BODY
        {"RicPlexiPistol",      "RicPlexiRifle",    "RicPlexiRifle",    "RicPlexiRifle",    "RicPlexiSniper",       "RicPlexiSniper",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol",       "RicPlexiPistol"},//ARMOR
        {"RicWaterPistol",      "RicWaterRifle",    "RicWaterRifle",    "RicWaterRifle",    "RicWaterSniper",       "RicWaterSniper",       "RicWaterPistol",       "RicWaterPistol",       "RicWaterPistol",       "RicWaterPistol",       "RicWaterPistol",       "RicWaterPistol"},// WATER
    };

    static String GetFXName(int nBulletType, int nMaterial)
    {
        if(nMaterial > -1)
            return FxName[nMaterial][nBulletType];
        else
            return "";
    }
    
    static String GetSoundName(int nBulletType, int nMaterial)
    {
        if(nMaterial > -1)
            return "Data/Sounds/Weapon/"+SoundName[nMaterial][nBulletType];
        else
            return "";
    }

    static String GetAmmoName(int nAmmo)
    {
        switch (nAmmo)
        {
        case _9mmShort:
            return Text.Get("&A_N_9MM_SHORT&");
        case _12mmShort:
            return Text.Get("&A_N_12MM_SHORT&");
        case _8mmLong:
            return Text.Get("&A_N_8MM_LONG&");
        case _14mmLong:
            return Text.Get("&A_N_14MM_LONG&");
        case _Energy:
            return Text.Get("&A_N_ENERGY&");
        case _HEX:
            return Text.Get("&A_N_HEX&");
        case _Shotgun:
            return Text.Get("&A_N_SHOTGUN&");
        case _Rocket:
            return Text.Get("&A_N_ROCKET&");
        case _EnergyRocket:
            return Text.Get("&A_N_ENERGY&");
        default:
            return "N/A";
        }
    }
    
    static String GetFXHitWater(byte nAmmoType)
    {
        return FxName[FxName.length - 1][nAmmoType];
    }
}
