public class AmmoBulletFree extends Actor
{
    /**predkosc poczatkowa*/
    public float fStartSpeed = 1000.0f;
    /**damage jaki jest brany przy trafieniu*/
    public float fDamage = 100.0f;
    /**Damage przekazywany do symulacji fizyki*/
    public float fPhysicsSimDamage = 100f;
    /**dameg jaki jest odbierany w promieniu, czym dalej tym mniej jest odbierane */
    public float fBlastDamage = 1000.0f;
    public float fPhysicsSimBlastDamage = 1000f;
    /**Promien razenia bulleta*/
    public float fBlastRadius = 100.0f;
	/**Skalar predkosci odrzutu wubuchu pocisku*/
	public float fBlastSpeed = 10000000.0f;
    /**Co ile ma sie zwiekszac predkosc*/
    public float fSpeedUpdateTime = 0.1f;
    /**Obiekt do ktorego nalezy bullet*/
    public GameObject cOwner = null;
    /**Vector przechowuje extents dla aktualnego levelu*/
    //public Vector vLevelExtents = null;
    /**Physics extents jaki jest zasieg updateu fizyki*/
    //public Vector vPhysicsExtents = null;
    /**Czy pocisk jest zniszczony czy nie */
    public boolean bExploded =  false;
    /**Nazwa FX przy zderzeniu*/
    public String sFXHitName = "FXAITakeDamage";
    /**Nazwa dzwiku odpalanego dla wybuchu bulleta*/
    public String sSoundExplodeName = "";

    /** pomocniczy wspolczynnik do obliczania sily uderzenia */
    float fBlastCoeff;    
    
    AmmoBulletFree()
    {
        super();

        sName = "Bulletus Freedomus";
        MeshName="Data/Meshes/Equipment/Pocisk.3DA"; 
    }

    public void OnCreate()
    {
        super.OnCreate();
        
        SetCollType(ECollFlags.OBJCOL_TYPE_PERFACE );
        SetCollAction(ECollFlags.OBJCOL_ACTION_STOP);
        SetCollHandler(ECollFlags.OBJCOL_HANDLER_FULLINFO);
        //Module mod = GetModule();
        //vLevelExtents = new Vector(mod.GetTerrainSize());
        //vPhysicsExtents = new Vector(mod.GetExtents());
        //LogD("vLevelExtents = " + vLevelExtents + "\n");

        fBlastCoeff = fBlastDamage / fBlastRadius;
        
        bActiveTrigger = false;
    }

    public void Init(GameObject cBulletOwner)
    {
        cOwner = cBulletOwner;
    }
    //-----------------------------------------------------------------------------------
    void Start(float fForce ,Vector vDirection)
    {
        SetDir(vDirection);
        SetState("Flying");
    }
    
    /** Pocisk przechodzi w ten stan gdy zostaje wystrzelony*/
    
    public class Flying extends State 
    {
        float fSpeed = 0;
        
        public void OnEnter()
        {
//            CallMethodIn("CheckExtents",fSpeedUpdateTime);
            LogD("\n");
        }
        
        void OnFrame()
        {
/*
            Vector vPos = GetPosition();
            
            if ( vPos.fX < 0 ||
                 vPos.fZ < 0 ||
                 vPos.fX > vLevelExtents.fX || 
                 vPos.fZ > vLevelExtents.fZ
               )
            {
                LogD("Rakieta jest po za terenem Pozycja = " + vPos + "\n");
                Explode();
                return;
            }
*/            
        }
        
        /**przyspieszamy do fMaxSpeed*/
        void SpeedUpdate()
        {
            LogD("\n");
        }
        
        void CheckExtents()
        {
/*
            Vector vPos = GetPosition();
            vPos.Sub(cOwner.Owner.GetPosition());
            if(java.lang.Math.abs(vPos.fX) > (vPhysicsExtents.fX - 100.0f) ||
               java.lang.Math.abs(vPos.fY) > (vPhysicsExtents.fY - 100.0f) ||
               java.lang.Math.abs(vPos.fZ) > (vPhysicsExtents.fZ - 100.0f))
            {
                LogD("Rakieta jest po za zasiegiem symulacji = " + vPos + "\n");
                Explode();
                return;
            }
            
            CallMethodIn("CheckExtents",fSpeedUpdateTime);
*/            
        }
        
        /** */
/*        public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
		{
            Damage(fDamage);
        }
*/
		// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
		public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation,
								 Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
		{
            Damage(fDamage);
		}
	
        /** Pocisk zniszczony wybucha */
        public void Die()
        {
            Explode();
        }

        /**Gdy czegos dotkniemy odbieramy energie*/
        public void OnCollisionFullInfo(ControlObject Col,Vector vPoint,Vector vNormal)
        {
            if ( Col instanceof Actor )
            {
                //zanegowana normalna to wektor z kierunku ktorego dostajemy
                // obrazenia
                vNormal.Negate();
                
                //obrazenia zaleza od kata miedzy normalna a wektorem predkosci
                // (najwieksze obrazenia przy prostopadlym strzale)
                //fDamage *= GetForwardVector().Dot(vNormal);

                //zadaj rownomierne obrazenia dla calego ciala (DamageType = -1)
                ((ControlObject)Col).TakeDamage(fDamage, fPhysicsSimDamage, cOwner, 
                                                vPoint, vNormal, EBones._NON_BONE, EnumDamageType._BULLET);
            }
        }
		
 		//*********************************************************
		//					SaveGame
		//*********************************************************
				
		public void SGLoad(FileChunk cParentFC)
		{
			FileChunk.Log("[AmmoBulletFree$Flying] : SGLoad\n");
			
			FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
			if (cFC.GetID() == ESGChunksChrome._CHK_AMMO_BULLET_FREE_FLYING_STATE)
			{
				super.SGLoad(cFC);
		
				fSpeed = cFC.LoadFloat();				
			}
			
			cFC.delete();
		}
	
		public void SGSave(FileChunk cParentFC)
		{
			FileChunk.Log("[AmmoBulletFree$Flying] : SGSave\n");
			
			FileChunk cFC = NewChunk(ESGChunksChrome._CHK_AMMO_BULLET_FREE_FLYING_STATE, cParentFC);
			
			super.SGSave(cFC);
			
			cFC.SaveFloat(fSpeed);
			
			cFC.delete();
		}		
    }

    /**Wybuchamy bullet i odbieramy wszystkim w promieniu odpowiednia ilosc energii*/
    void Explode()
    {
        Vector vMyPos = GetPosition();

		//fx'y
        ExecuteFX(sFXHitName, vMyPos);
		PlaySound(sSoundExplodeName, vMyPos);

		//zbieramy ofiary wybuchu
        GameObject []aVictim = GetObjectsInRadiusFromClass(fBlastRadius,"Actor");

        if ( aVictim != null )
        {
            for ( int index = 0 ; index < aVictim.length ; index++ )
            {
                Vector vVictimPos = ((ControlObject)aVictim[index]).GetPosition();
                float fDis = vVictimPos.Distance(vMyPos);

                if (fDis < fBlastRadius) //jestesmy w zasiegu razenia
                {
                    Vector vFromCenter = new Vector(vVictimPos);
                    vFromCenter.Sub(vMyPos);
					vFromCenter.Normalize();
					vFromCenter.Mul(fBlastSpeed);

                    //damage jest interpolowany liniowo na caly fBlastRadius
                    float fDam = (fBlastRadius - fDis) * fBlastCoeff;
                    ((ControlObject)aVictim[index]).TakeDamage( fDam, fDam, cOwner,
                                                                vVictimPos, vFromCenter,
																EBones._NON_BONE, EnumDamageType._BLAST);
                }
            }
        }
        DeactivateOnModuleAlways();
        bExploded = true;
		
		CallMethodIn("delete", 0);
        //cOwner.CallMethodIn("RemoveBullet",0.1f);
    }
}
