
public class Grenade extends Bullet
{
    static float _DAMAGE_DELAY = -1.0f;
    
    Grenade()
    {
        sName = "Grenades";
        MeshName= "Data/Meshes/Equipment/granat_zaczepny_fly.3DA";
        fHealth = 1.0f;
        fDamage = 10.0f;
        fDirectHitDamage = 0;
        fPhysicsSimDamage = fDamage;
        fBlastDamage = 1000.0f;
        fPhysicsSimBlastDamage = fBlastDamage;
        fBlastRadius = 1000.0f;
        fStartSpeed = 100.0f;
        sSoundExplodeName = "Data/Sounds/Weapon/GrenadeExplosion";
        sFXHitName = "FXBlowGrenade";
        m_fDamageDelay = _DAMAGE_DELAY;
        fLightScaleFlight = 1;
    }

    /**masa granatu*/
    public float m_fMass = 55.0f;;
    
    /**Czas liczony od rzucenia po jakim granat eksploduje - podany w sekundach*/
    public float fExplodeTime = 3.0f;
    
    /**O ile jest zmniejszana predkosc granatu podczas lotu co fSpeedUpdateTime*/
    public float fReduceSpeed = 100.0f;
    //Vector vDir = null;
    
    /**z jaka predkoscia maksymalnie moze krecic sie granat (wokol kazdej z osi)  */
    float  m_fRotateMaxSpeed  = 500.0f;
    /**wektor rotacji losowany przy wyrzucie granatu (oraz po odbiciu sie granatu od ziemi)
     * granat moze sie precic wokol kazdej z osi z predkoscia z przedzialu
     * -m_fRotateMaxSpeed .. +m_fRotateMaxSpeed */
    Vector m_vRotate          = null;
    /** czas ostatniego obrotu granatu */
    float  m_fRotateLastTime  = 0.0f;
    
    /** Zasieg [cm] 'dzwieku' wydawanego podczas lotu granata (zeby mogly do 'widziec' AI)
     *  Powinien byc wiekszy niz zasieg razenia granata
     *  (ale nie jest, bo testerom ciagle cos nie pasuje)
     */
    float fFlyingNoiseRange = 1000.0f;
    
    /** Co jaki czas [s] granat zaznacza swoja obecnosc przez MakeNoise
     */
    float fFlyingNoiseUpdateTime = 0.5f;
    
    
    /**Sila rzutu granatu*/
    public float fThrowForce = 0.0f;  
    
    
    // Identyfikatory zarejestrowanych metod
    int METHOD_FlyingNoiseUpdate = 0;
    int METHOD_Explode = 0;
    
    public void OnCreate()
    {
        super.OnCreate();
        METHOD_FlyingNoiseUpdate = RegisterCallMethod("FlyingNoiseUpdate");
        METHOD_Explode           = RegisterCallMethod("Explode");
        SetMass( WeaponGrenade.sm_bThrowOnPressKey ? 50.0f : 80.0f );
        SetPhysicsType(EPhysics._FALL);
        SetPhysicsActive(false);
        SetCollAction(ECollFlags.OBJCOL_ACTION_BOUNCE);
        ClearFlag(EFlags._FXPARTICLE_COLLISION);
		fExplosionNoiseRange = 5000f;
        
        //bylo: SetEllipsoid(7.5f, 60.f, 30.0f);
        
        // ustalamy duze extenty - granat sie obraca i to moze prowadzic do problemow z kolizjami, jesli extenty go nie obejma
        float fExtSize = 20;
        Vector vMin = GetPosition(), 
            vMax = new Vector(vMin);
        vMin.fX -= fExtSize;
        vMin.fY -= fExtSize;
        vMin.fZ -= fExtSize;
        
        vMax.fX += fExtSize;
        vMax.fY += fExtSize;
        vMax.fZ += fExtSize;
        SetExtents(vMin, vMax);
        
        // elipsoida moze juz byc malutka - nawet nieco mniejsza od granata
        // bedzie sie troche wbijal ale nie bedzie wisial w powietrzu

        // fRadius, fHeight, fYPos
        SetEllipsoidNoExtents(7.5f, 15.0f, 0);

        fDamgeShiftPos = 30.0f;
    }

    public void Acquire(Module mod, Pawn owner)
    {
        super.Acquire(mod, owner);

        // przelaczamy handlery na nowy level
        METHOD_FlyingNoiseUpdate = RegisterCallMethod("FlyingNoiseUpdate");
        METHOD_Explode           = RegisterCallMethod("Explode");
    }
    
    void Start( float fForce, Vector vPos, Vector vDir, float fTime )
    {
        //LogR("Start fForce:"+fForce+" vPos "+vPos+" vDir "+vDir+" fTime "+fTime+"\n");
        
        //juz leci, wiec nie bedziemy musieli kasowac razem z bronia
        SetStarted();
        
        //TODO: tymczasowo ustawiam tu mase (do testow)
        SetMass( m_fMass );
        
        // bullet leci, wiec musi sie zapisac do Save'a
        bSG = true;
        
        //CrashLog("[Grenade.Start] bSG=true\n");
        
        // od teraz bullet jest sobie niezalezny od broni
        
        SetOwner();
        //CrashLog(" fForce:"+fForce+" vPos:"+vPos+" vDir:"+vDir+"\n");
        
        if (Owner != null)
            ChangeConflictSide(Owner.GetConflictSide());
             
        fThrowForce = fForce;
        
        if ( m_bSetPositionWorld )
            SetPositionWorld( vPos );
        else            
            SetPosition( vPos );
        SetDir( vDir );
        
        Vector vSpeed = new Vector( vDir );
        vSpeed.Mul( fStartSpeed * fThrowForce );
        SetSpeed( vSpeed );
        //CrashLog(" fTime:"+fTime+" GetTime():"+GetTime()+" vSpeed:"+vSpeed+"\n");
        
        RotateInit( m_fRotateMaxSpeed, fTime );
        
        ActivateOnModule();
        SetPhysicsActive( fTime );
        
        DisableCallMethod( METHOD_Explode );
        // uwzgledniam roznice czasu pomiedzy klientem i serwerem
        CallMethodIn( METHOD_Explode,fExplodeTime + fTime - GetTime() );

        SetCorrectPosOnRender(true);

        SetState("Flying");
    }
    
    
    
    void Start( float fForce , Vector vDir )
    {
        Start( fForce , vDir, GetTime() );
    }
    void Start( float fForce , Vector vDir, float fTime )
    {
        Start( fForce , GetPosition(), vDir, fTime );
    }

    
    void BulletStarted()
    {
        if ( cWeaponOwner instanceof WeaponGrenade )
        {
            ((WeaponGrenade)cWeaponOwner).GrenadeStarted();
        }
    }
    
    void RotateInit(float fRotateSpeed)
    {
        RotateInit( fRotateSpeed, GetTime() );
    }
    void RotateInit(float fRotateSpeed,float fTime)
    {
        m_vRotate           = new Vector( -fRotateSpeed, -fRotateSpeed, -fRotateSpeed );
        m_vRotate.fX       += 2.0f * RandomFloat( fRotateSpeed );
        m_vRotate.fY       += 2.0f * RandomFloat( fRotateSpeed );
        m_vRotate.fZ       += 2.0f * RandomFloat( fRotateSpeed );
        m_fRotateLastTime   = fTime;
    }
    
    void Rotate()
    {
        if ( GetSpeedValue() > 50.f /*fStartSpeed * fThrowForce * 0.01f*/ )
        {
            float fTime       = GetTime();
            float fDeltaTime  = fTime - m_fRotateLastTime;
            m_fRotateLastTime = fTime;

            RotateLocal( new Vector(1,0,0), m_vRotate.fX * fDeltaTime );
            RotateLocal( new Vector(0,1,0), m_vRotate.fY * fDeltaTime );
            RotateLocal( new Vector(0,0,1), m_vRotate.fZ * fDeltaTime );
        }
    }
    
    public class Flying extends Bullet.Flying  
    {
        public void OnEnter()
        {			
            super.OnEnter();
                        
            //float fSpeed = fStartSpeed * fThrowForce;
            //vDir.Mul(fSpeed);
            //SetSpeed(vDir);
            
            
            FlyingNoiseUpdate();
        }

        void FlyingNoiseUpdate()
        {
            if (!bExploded)
            {
                MakeNoise(fFlyingNoiseRange, Pawn._NOISE_DANGEROUS_OBJECT_NEARBY);
                CallMethodIn(METHOD_FlyingNoiseUpdate, fFlyingNoiseUpdateTime);
            }
        }
        
        void SpeedUpdate()
        {
            //LogD("Zmniejszamy predkosc granatu \n");
			//LogD("pozycja: "+GetPosition()+" owner:"+cOwner.GetPosition());
            //fSpeed = fSpeed - fReduceSpeed;
            //SetLocalSpeed(new Vector(0.0f,0.0f,fSpeed));
        }
        
        void OnFrame()
        {
            Rotate();
        }

        /** Kolizja redukuje predkosc granatu */
        public void OnCollisionFullInfo(ControlObject Col,Vector v1,Vector v2)
        {
            if (Col instanceof ForceFieldFence)
            {
                Explode();
                return;
            }
            //LogR("OnCollision "+Col+"\n");
            super.OnCollisionFullInfo(Col,v1,v2);
            //SetLocalSpeed(new Vector(0.0f,0.0f,0.0f));
            PlayHitSound(Col);
            RotateInit( m_fRotateMaxSpeed, GetTime() );
            SpeedReductionOnHit(Col, v1, v2);
        }
		
		//*********************************************************
		//					SaveGame
		//*********************************************************
						
		public void SGUpdate()
		{
			FileChunk.Log("[Grenade$Flying] : SGUpdate\n");			
			super.SGUpdate();
            ActivateOnModule();
		}		
    }
    
    float m_fLastSpeedReductionTime = 0;
    float m_fMinSpeedReductionInterval = 0.2f;
    
    /** Modyfikuje predkosc granatu po uderzeniu w przeszkode
     */
    void SpeedReductionOnHit(ControlObject cObj, Vector vPos, Vector vNorm)
    {
        float fCurrentSpeed = GetSpeedValue() * 0.4f;
        if (fCurrentSpeed < 10.0f)
            SetSpeedValue(0);
        else
        {
            if (GetTime() - m_fLastSpeedReductionTime >= m_fMinSpeedReductionInterval)
            {
                m_fLastSpeedReductionTime = GetTime();
        
                SetSpeedValue(fCurrentSpeed);
            }
        }
    }
    
    /**Odgrywa dzwiek po trafieniu w przeszkode, badajac co to za przeszkoda mozna roznicowac
     * dzwieki, na razie wykorzystane tylko w klasie potomnej {@link AmmoGrenadeLevel05)}
     */
    void PlayHitSound(ControlObject cHitObject)
    {
        
    }

    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[Grenade.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_GRENADE)
        {
            super.SGLoadChunk(cFC);
            
            m_fLastSpeedReductionTime = cFC.LoadFloat();
        }
        
        cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Grenade.SGSaveChunk]\n");
        
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_GRENADE, cFCParent);
        
        super.SGSaveChunk(cFC);

        cFC.SaveFloat(m_fLastSpeedReductionTime);
        
        cFC.delete(); 
    }		

    public void SGUpdate() 
    {
        super.SGUpdate();
        FileChunk.Log("[Grenade.SGUpdate]\n");
        RotateInit( m_fRotateMaxSpeed);
    }
    
}
