public class GrenadeClusterPiece extends Grenade
{
    float _LIFE_TIME = 1.75f;

    /** Czas co ktory beda odpalane kolejne FXy
     */
    float fFXUpdateTime = 1f/8f;

    /**Nazwa FX dymu*/
    public String sFXSmokeName = "FXClusterPieceSmoke";
    
    GrenadeClusterPiece()
    {
        MeshName= "Data/meshes/equipment/grenade_cluster_part.3DA";
        fHealth = 1000.0f;
        fDamage = 10.0f;
        fPhysicsSimDamage = fDamage;
        fDirectHitDamage = 0;
        fBlastDamage = 500.0f;
        fPhysicsSimBlastDamage = fBlastDamage;
        fBlastRadius = 500f;
        fStartSpeed = 100.0f;
        sSoundExplodeName = "Data/Sounds/Weapon/GrenadeExplosion";
        sFXHitName = "FXGrenadeClusterPiece";
        fExplodeTime = _LIFE_TIME;
        fLightScaleExplosion = 600;
        fLightScaleFlight = 100;
    }
    
    public void OnCreate()
    {
        super.OnCreate();
        fExplodeTime = _LIFE_TIME + RandomFloat(0.5f);
		EnableRendering(false);
    }
        
    public class Flying extends Grenade.Flying  
    {
        public void OnCollisionFullInfo(ControlObject Col,Vector v1,Vector v2)
        {
            super.OnCollisionFullInfo(Col,v1,v2);
            if (Col != null &&
                Col instanceof ChromeActor)
                GrenadeClusterPiece.this.CallOnFrameEnd("Explode");
        }
        
        public void OnFrame()
        {
            super.OnFrame();
            FXUpdate();
        }
    }
    
    float fLastFxTime = 0;
    /**Odpalany jest FX  dymu*/
    void FXUpdate()
    {
        float fTime = GetTime();
        //nie odpalamy wiecej niz jednego fxa w ramce
        if (fLastFxTime == fTime)
            return;
            
        fLastFxTime = fTime;
        ExecuteFX(sFXSmokeName,GetPosition());
        if (!bExploded)
        {
            //CallMethodIn("FXUpdate",fFXUpdateTime);
        }
    }
    
    void ExplosionSpecialEffects()
    {
        if(!bNoLight)
        {
            cDynLight.DetachFromParentAndKeepWorldPos();
            
            cDynLight.SetScale(new Vector(1f/fLightScaleFlight,
                                          1f/fLightScaleFlight,
                                          1f/fLightScaleFlight)); 
            cDynLight.SetScale(fLightScaleExplosion, fLightScaleExplosion, fLightScaleExplosion);
            cDynLight.CallMethodIn("delete", fExplosionLightLifeTime);
        }
        
        Vector vPos = GetPosition();
        ExecuteFX( sFXHitName, vPos );
        //ExecuteParticleSystem( sFXHitName, vPos, Vector.Up );
		PlaySound( sSoundExplodeName, vPos );
    }
}
