public class GrenadeEMP extends Grenade
{
    
    /**Obrazenia zadawane ChromeActorom majacym ustawiony znacznik bIsEmpVulnerable*/
    float fBlastDamageEMP = 1000;
    
    static int nFXCount = 6;
    
    /**Fx odpalany na ofierze przy damageu emp*/
    static String sFXHitNameEMP = null;
    
    GrenadeEMP()
    {
        sName = "Grenades";
        MeshName= "Data/Meshes/Equipment/TPPGrenadeEMP.3DA";
        fHealth = 1.0f;
        fDamage = 10.0f;
        fPhysicsSimDamage = fDamage;
        fBlastDamage = 0.0f;
        fPhysicsSimBlastDamage = fBlastDamage;
        fBlastDamageEMP = 10;
        fBlastRadius = 750f;
        fStartSpeed = 100.0f;
        sSoundExplodeName = "Data/Sounds/Weapon/GrenadeExplosion";
        sFXHitName = "FXGrenadeEMP";
        sFXHitNameEMP = "FXEMPHit";
        fExplodeTime = 3f;
    }
    
    void Explode()
    {
        Vector vMyPos = GetPosition();

        //fx'y
        ExplosionSpecialEffects();

        if ( Role == ERole._AUTHORITY )
        {
            MakeDirectHit(m_DirectVictim);

            //CrashLog("MakeBlastDamage "+this+" "+Owner+"\n");
            //MakeBlastDamage(fBlastDamage, GetPosition(), fBlastRadius, true,
			//				m_DirectVictim instanceof Actor ? (Actor)m_DirectVictim : null, EnumDamageType._BLAST);
			
		    //zbieramy ofiary wybuchu
            GameObject []aVictim = GetObjectsInRadiusFromClass(fBlastRadius,"ChromeActor");
            if ( aVictim != null )
            {
                for ( int index = 0 ; index < aVictim.length ; index++ )
                {
                    Vector vVictimPos = ((ControlObject)aVictim[index]).GetPosition();
                    float fDis = vVictimPos.Distance(vMyPos);

					if ( (m_DirectVictim != null) &&
						 (m_DirectVictim == (ControlObject)aVictim[index]) )
						continue;
					
                    if (fDis < fBlastRadius) //jestesmy w zasiegu razenia
                    {
                        Vector vFromCenter = new Vector(vVictimPos);
                        vFromCenter.Sub(vMyPos);
					    vFromCenter.Normalize();
					    vFromCenter.Mul(fBlastSpeed);
                        //if (((ChromeActor)aVictim[index]).bIsEmpVulnerable)
                        {
                            //CrashLog("victim " + aVictim[index]);
                            //((ControlObject)aVictim[index]).TakeDamage( fBlastDamageEMP, Owner, GetPosition(), vFromCenter, EnumDamageType._BLAST);
                            ((ControlObject)aVictim[index]).TakeDamage(fBlastDamageEMP, fBlastDamageEMP, this, Vector.Up, vFromCenter, EBones._HEAD, EnumDamageType._ELECTRIC);
                            FXs((MeshObject)aVictim[index]);
                        }
                        //else
                         //   ((ControlObject)aVictim[index]).TakeDamage(fBlastDamage, this, Vector.Up, vFromCenter, 
                          //                                             EBones._L_FOOT, EnumDamageType._ELECTRIC);
                    }
                }
            }
        }
        DetachFromParentAndKeepWorldPos();
        DeactivateOnModuleAlways();
        bExploded = true;
		
        //TODO ustalic czas trwania rozblysku swiatla przy wybuchu, rozblysk trwa od wybuchu
        //do skasowania obiektu
		CallMethodIn("delete", 5f);
        //cOwner.CallMethodIn("RemoveBullet",0.1f);
    }
    
    static void FXs(MeshObject cObj)
    {
        Vector vMin = new Vector(), vMax = new Vector();
        cObj.GetMeshExtents(vMin, vMax);
        Vector vExtents = vMax.Sub2(vMin);

        Vector vPos = cObj.GetPosition();
        for (int i = 0; i < nFXCount; i++)
        {
            Vector vFxPos = new Vector();
            vFxPos.fX = RandomFloat(vExtents.fX/2f);
            if (RandomFloat(1) < 0.5f)
                vFxPos.fX *= -1;
            
            vFxPos.fY = vExtents.fY/2f+RandomFloat(vExtents.fY/2f);
            
            //cObj.ExecuteFX(sFXHitNameEMP, vPos.Add2(vFxPos));
			Vector vNormal = new Vector(Vector.Up);
			cObj.ExecuteParticleSystem(sFXHitNameEMP, vPos.Add2(vFxPos), vNormal);
        }
    }

    void ExplosionSpecialEffects()
    {
        Vector vPos = GetPosition();
        ExecuteFX( sFXHitName, vPos );
        //ExecuteParticleSystem( sFXHitName, vPos, Vector.Up );
		PlaySound( sSoundExplodeName, vPos );
    }
}
