
public class WeaponRack extends InvObjectInst
{

    WeaponRackController    controller = null;
    WeaponRackPawn          rack = null;

    WeaponRack()
    {
        super();

        //MeshObject
        MeshName="Data/Meshes/Equipment/stojak.3DA";

        //InvObject
        nInvIndex = InvObject._E_W_RACK;
        nInvType = EInvObjType._EQUIP;
        sName = "Weapon Rack";
        sTexFileName = "Data/Textures/CH_I_Weapons2.png";
      	nCellsWidth = 1;
	    nCellsHeight = 1;

        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 200.0f;
        nOnTexPosY = 180.0f;

        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;
    }

    public void OnCreate()
    {
        super.OnCreate();

		fHealth		= 50;

        //fizyka i kolizje
		SetPhysicsType(EPhysics._NONE);
        
        //stojak
        rack = (WeaponRackPawn)CreateObject("WeaponRackPawn");
        rack.rack = this;        

        //setup kontrolera
        controller = (WeaponRackController)CreateObject("WeaponRackController");
        controller.weaponRack = rack;

    }




    public void Use()
    {
        LogD("Used\n");

        if (Owner != null)
        {
            if (Owner instanceof PlayerHUD)
            {

                //poloz stojak na ziemi przed graczem
                rack.ActivateOnModule();                
                rack.SetPosition(Owner.ComputeDroppingPosition());
                rack.AlignToGround();

                //wyrzucamy sie, ale wczesniej zapamietujemy ownera
                rack.user = (PlayerHUD)Owner;
                Owner.cInventory.RemoveInvObject(this);

                //tworzymy kontroler, ktory pojawi sie w inventory gracza zamiast stojaka
                rack.user.cInventory.AddInvObject(controller);
                controller.ChangeInvState(Owner, EInvObjState._INVENTORY);

                rack.SetState("AssembledState");

            }
        }
    }

    //zebranie z ziemi
    //powoduje przy okazji wyrzucenie odpowiadajacego kontrolera
    void Execute( Actor executor )
    {
        //zebrac moze tylko Pawn
        Pawn pawn;
        try {
            pawn = (Pawn)executor;
        } catch ( ClassCastException e) {
                Log("[Vehicle.Execute]: Vehicle can be executed only by Pawn\n");
                return;
        }

        //zabieramy siebie do plecaka executora
        super.Execute( executor );

        //wyrzucamy kontroler
        if (nInvState == EInvObjState._INVENTORY)
        {
            // wkladamy sie, wiec konotrler powinien sie wyniesc z tego
            // samego inventory
            if ( (controller.Owner == Owner) &&
                 (controller.nInvState == EInvObjState._INVENTORY) &&
                 (controller.weaponRack == rack) )
            {
                Owner.cInventory.RemoveInvObject(controller);
                //controller.DeactivateOnModule();
            }
        }
    }

}
