
public class WeaponRackPawn extends Pawn
{
    CameraAttachedSlave camera = null;

    Weapon ActiveWeapon = null;

    WeaponRackController controller = null;
    WeaponRack rack = null;

    PlayerHUD   user = null;

    int nElemHorizRot = -1;
    int nElemVertRot = -1;

    Zoomer cZoomer = null;
    
    boolean bControlled = false;
    boolean bSet = false; //czy rozlozony?
    boolean bAssembling = false;

    WeaponRackPawn()
    {
        //MeshObject
        MeshName="Data/Meshes/Equipment/stojak.3DA";
    }

    public void OnCreate()
    {
        super.OnCreate();

		fHealth		= 50;

        //fizyka i kolizje
		SetPhysicsType(EPhysics._NONE);

        //element obracany
        nElemHorizRot = GetElementID("Zaczep");
        nElemVertRot = GetElementID("ZaczepPion");

        if ((nElemHorizRot < 0) || (nElemVertRot < 0))
            CrashLog("[WeaponRack:OnCreate] Nie ma takiego obiektu\n");
        
        //setup zoomera
        cZoomer = (ZoomerSniperSmooth)CreateObject("ZoomerSniperSmooth");
        
        //setup kamery
        camera=(CameraAttachedSlave)CreateObject("CameraAttachedSlave");
        camera.Target=this;
        camera.nElement = nElemVertRot;
        //camera.vShift = new Vector(0, 50, -50);
        camera.SetZoom(cZoomer.GetZoom());
        camera.SetClipNear(10);


        ClearFlag(EFlags._NO_ANIMATION);
        ClearFlag(EFlags._NO_ANIMATION_REFRESH);
        SetFlag(EFlags._BLOCK_TRACE);
        
        InitAnimSeq("assemble", 0, 64);
        InitAnimSeq("disassemble", 64, 0);

        SetState("InactiveState");
        
    }

//=============================================================================

    float Assemble()
    {
        //CrashLog("assembling\n");
        bSet = false;
        bAssembling = true;
        PlayAnim("", "assemble", 1);
        CallMethodIn("Assembled", GetAnimLength("assemble"));
        return GetAnimLength("assemble");
    }

    void Assembled()
    {
        bSet = true;
        bAssembling = false;
        
        //ustawiamy sie w poczatkowej pozycji
        RotateElement(  nElemVertRot, new Vector(1, 0, 0), -90 );
    }
    
    float Disassemble()
    {
        bSet = true;
        bAssembling = true;
        RotateElement( nElemVertRot, new Vector(1, 0, 0), 90 );
        Disassemble2();
        return GetAnimLength("disassemble");
    }

    void Disassemble2()
    {
        PlayAnim("", "disassemble", 1);
        CallMethodIn("Disassembled", GetAnimLength("disassemble"));
    }

    void Disassembled()
    {
        bSet = false;
        bAssembling = false;
    }

//=============================================================================
    
    Actor cExecutorGlobal = null;

    private void Wrap()
    {
        //sprawdz czy jestes dostatecznie blisko zeby sie schowac
        //(w czasie skladania stojaka gracz mogl odbiec)
        Vector pos = GetPosition();
        if ( pos.Distance(user.GetPosition()) < 150)
        {
            
            //schowaj sie (wyrzuc kontroler jesli to potrzebne)
            rack.Execute( cExecutorGlobal );

            //jesli udalo sie schowac, to zniknijz levelu
            if (rack.nInvState == EInvObjState._INVENTORY)
                DeactivateOnModuleAlways();
        }
    }

    void DetachWeapon()
    {
        //CrashLog("detaching weapon from weapon rack\n");
        DetachChild(ActiveWeapon);
        ActiveWeapon.EnableRendering(false);
        //ActiveWeapon.Owner = null;
        //ActiveWeapon = null;
    }

    //uzycie - powoduje przypiecie broni lub schowanie stojaka
    void Execute( Actor executor )
    {
        Pawn pawn;
        try {
            pawn = (Pawn)executor;
        } catch ( ClassCastException e) {
                LogD("can be executed only by Pawn\n");
                return;
        }
        
        if (!bDead)
        {
            if ( (pawn.ActiveWeapon != null) && 
                 (pawn.ActiveWeapon.bMountable) &&
                 (ActiveWeapon == null) )
            {
                if (bSet)
                {
                    //zabieramy bron playerowi i montujemy sobie
                    try{
                        Player player = (Player)pawn;
                        ActiveWeapon = player.ActiveWeapon;

                        player.WeaponToUse = player.GetBestWeapon( player.ActiveWeapon );
                        player.SetState("ChangeWeaponState");

                        player.cInventory.RemoveInvObject(ActiveWeapon);
                        //TODO: zrobic oddzielny stan - nie powinno to byc onground
                        ActiveWeapon.ChangeInvState(null, EInvObjState._ONGROUND);
                        ActiveWeapon.ClearFlag(EFlags._BLOCK_TRACE);
                        //nie pokazujemy grzebienia
                        //FIXIT zaremowane, bo sie nie kompiluje ActiveWeapon.bBlockBarrelFX = true;

                        ActiveWeapon.StopFallingDown();
                        ActiveWeapon.Owner = this;

                        AttachChild(ActiveWeapon, "ZaczepPion");

                        ActiveWeapon.SetPosition(new Vector(0, 0, 0));
                        ActiveWeapon.SetDirLocal(new Vector(0, 0, -1));                    

                    }
                    catch( ClassCastException e) {
                    }
                }
            }
            else
            {
                //przy okazji zabieramy tez bron
                if (ActiveWeapon != null)
                {
                    DetachChild(ActiveWeapon);
                    ActiveWeapon.Owner = null; //trzeba tak, bo inaczej nie chcialby sie schowac
                    //odtwarzamy stare ustawienie - grzebien pokazywany
                    //FIXIT zaremowane, bo sie nie kompiluje ActiveWeapon.bBlockBarrelFX = false;
                    ActiveWeapon.Execute( executor );
                    //jesli nie udalo sie schowac do inventory:
                    if (ActiveWeapon.nInvState == EInvObjState._ONGROUND)
                    {
                        ActiveWeapon.SetFlag(EFlags._BLOCK_TRACE);
                        ActiveWeapon.DropOnTerrain(((Pawn)executor).ComputeDroppingPosition());
                    }
                    ActiveWeapon = null;
                }

                if (bSet)
                {
                    cExecutorGlobal = executor;

                    CallMethodIn("Wrap", Disassemble());
                }
                else
                {
                    Wrap();
                }
            }
        }
        else
        {
            //bDead
            
            if (ActiveWeapon != null)
            {
                DetachChild(ActiveWeapon);
                ActiveWeapon.Execute( executor );
                ActiveWeapon = null;
            }
        }
    }


    public boolean IsActive(ControlObject Activator)
    {
        return true;
    }    
    

    public String GetTip()
    {
        String result = null;
        
        //jesli gracz ma bron - moze ja tu przypiac
        if ((ActiveWeapon == null) && (user.ActiveWeapon != null))
        {
            result = "[Weapon Rack] Attach weapon";
        }
        //chowamy sie ewentualnie
        else
        {
            result = "[Weapon Rack] Disassemble";
        }
        
        return result;
    }
 

    public void Die()
    {
        LogD("died\n");

        super.Die();

        SetState("CrashedState");
    }
    
    WeaponRackPawn This()
    {
        return this;
    }

//=============================================================================
    
    Camera oldCamera = null;
    int nPlayerCameraMode;
    
    //zaczynamy kontrolowac stojak
    void GetIn()
    {
        if (!bSet) return;

        user.InGameMovieStart();

        //widzimy gracza z TPP
        nPlayerCameraMode = user.Camera.GetMode();
        user.CameraModeChanged(CameraPlayer.CMODE_TPP);   

        RegisterKeyRequest();
        RegisterMouseAxisRequest();
        RegisterMouseButtonRequest();

        oldCamera = user.GetModule().GetActiveCamera();
        user.GetModule().ActivateCamera(camera);
       
        //ukrywamy bron, bo zastawiala widok...
        if (ActiveWeapon != null)
            ActiveWeapon.EnableRendering(false);

        ((HUDCompRack)(user.HUD.aHUDComponent[HUDManager._HUD_RACK])).cRack = This();            
        user.HUD.Activate(HUDManager._HUD_RACK);
        user.HUD.Activate(HUDManager._PLAYER_DATA);
        
        //SetState("ControlledState");
        bControlled = true;
    }
    
    //konczymy kontrole stojaka
    boolean GetOut()
    {
        //przestajemy strzelac
        if (ActiveWeapon != null)
            ActiveWeapon.StopFire();

        //porzadek z controlsami
        UnregisterKeyRequest();
        UnregisterMouseAxisRequest();
        UnregisterMouseButtonRequest();

        user.InGameMovieEnd();

        //poprzednia kamera
        user.GetModule().ActivateCamera(oldCamera);
        user.CameraModeChanged((byte)nPlayerCameraMode);
        
        if (ActiveWeapon != null)
            ActiveWeapon.EnableRendering(true);
        
        //ukrywamy HUD'a
        user.HUD.Deactivate(HUDManager._HUD_RACK);       
        
        bControlled = false;
        SetState("InactiveState");
        return true;
    }
    
//==== STATES =================================================================
    
    /** Stojak zlozony (w inventory)
     */
    public class AssembledState extends State
    {
        public void OnEnter()
        {
            LogD("\n");
            Assemble();
        }
    }   

    public class DisassembledState extends State
    {
        public void OnEnter()
        {
            LogD("\n");
            Disassemble();
        }
    }   

    
    /** Stojak rozlozony i kontrolowany przez gracza
     */
    public class ControlledState extends State
    {

        public void OnEnter()
        {
            LogD("\n");
            GetIn();
        }

        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if ( bKeyState )
            {
                if (nKeyCode == EGameControl.ACTION)
                {
                    LogD("use pressed\n");
                    
                    /*FIXIT: bug z czyszczeniem bufora klawiatury.
                    hudmanager dostaje klawisz USE po wywolaniu tej funkcji! */                    
                    GetOut();

                }

                if (nKeyCode == EGameControl.FIRE)
                {
                    if (ActiveWeapon != null)
                        ActiveWeapon.StartFire( Weapon.MODE_AUTO );
                }
            }
        }

        /** Obsluga myszy
         */
        void OnInputMouseAxis(int nAxis, int nDelta)
        {
            float fZoomerModifier = 1.0f;

            if (cZoomer != null)
            {
                fZoomerModifier = 1.0f/cZoomer.GetZoom();
            }

            switch (nAxis)
            {
            case EMouse._AXIS_X :
	            RotateElement(  nElemHorizRot, new Vector(0, 0, -1),
                                nDelta * ControlLoadSave.fMouseSensitivity * fZoomerModifier*10);
                break;

            case EMouse._AXIS_Y :
	            RotateElement(  nElemVertRot, new Vector(1, 0, 0),
                                nDelta * ControlLoadSave.fMouseSensitivity * fZoomerModifier*10);
                break;

            case EMouse._AXIS_Z:
                {
                    if (cZoomer != null)
                    {
                        cZoomer.AddZoom(-nDelta);
                        if (camera != null)
                            camera.SetZoom(cZoomer.GetZoom());
                    }
                }
                break;
            }
        }

        public void OnInputMouseButton(int nButton, int nState)
        {
            switch (nButton)
            {
            case EMouse._BUTTON_1 : 
                {
                    if (ActiveWeapon != null)
                    {
                        if (nState != 0)
                            ActiveWeapon.StartFire( Weapon.MODE_AUTO );
                        else
                            ActiveWeapon.StopFire();                            
                    }
                }
                break;
            case EMouse._BUTTON_2 :
                break;
            }
        }

    }

//=============================================================================
// data needed for weapon
    
    public Vector GetFireDir()
    {
        
        Vector fwd = GetElementForwardVector(nElemVertRot);
        fwd.Negate();
        //CrashLog("fire dir:"+fwd+"\n");
        return fwd;
    }

    public Vector GetBarrelPos()
    {
        return ActiveWeapon.vBarrelElementPos;
    }

    public Vector GetFireOrigin()
    {
        //CrashLog("fire origin:"+GetElementPos(nElemVertRot)+"\n");
        return GetElementPos(nElemVertRot);
    }     

    void ExecuteFXBarrel(String sFXName)
    {
        ExecuteFX( ActiveWeapon, sFXName, ActiveWeapon.vBarrelElementPos);
        
        // odpalamy efekt widocznego lotu pocisku
        //if(RandomInt(100) < 15) ExecuteFX(ActiveWeapon, "WeaponBeam",ActiveWeapon.vBarrel);
    }

//=============================================================================
    
/*    public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        Damage(fDamage);
        user.HUD.GetHudRack().SetDamage(fHealth);
        
        //jesli rack rozwalony, to wracamy do normalnego widoku
        if (bDead && bControlled)
        {
            GetOut();
        }
    }
*/	
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        Damage(fDamage, nDamageType);
        user.HUD.GetHudRack().SetDamage(fHealth);
        
        //jesli rack rozwalony, to wracamy do normalnego widoku
        if (bDead && bControlled)
        {
            GetOut();
        }
	}
}
