/** Klasa sterownika roznego rodzaju dzialek. Nastepca AICannon.
 */
public class CannonController extends WeaponBullet implements ICannonController
{
    /////////////////////////////////////////////////////////////////////////////
    // Meshelementy dzialka 
    //
    
    
    /** Nazwy meshelementow
     */
    String m_sElementH = "Gun_podstawa";
    String m_sElementV = "Gun_lufy";
    String m_sElementCenterOld = "Gun_podstawa";
    String m_sElementCenterNew = "OsGorna";
    String m_sElementBarrel = "Gun_lufy";
    String m_sElementBarrelExit = "Barrel";

    /** Numery meshelementow
     */
    int m_nElementH = -1;
    int m_nElementV = -1;
    int m_nElementCenter = -1;
    int m_nElementBarrel = -1;
    int m_nElementBarrelExit = -1;

    ICannonMesh m_OwnerMesh = null;
    Vector m_vForwardDelta = null;
        
    ChromeActor m_CannonUser  = null;
    
    int m_nOwnerSide = EnumConflictSide._NEUTRAL;
        
    float m_fInitAngleV = 0;

    public String sBeamName = "WeaponBeam";
    
    /** Kat rozwarcia stozka, z ktorego wyciagane sa cele dla dzialka */
    float m_fTargetFindingAngle = 35f;
    
    /** Kat rozwarcia stozka, w ktorym musi znajdowac sie aktywny cel, zeby
     *  dzialko chcialo do niego strzelac
     */
    float m_fTargetHoldingAngle = 90f;
    
    /** Cosinusy katow rozwarcia stozkow */
    float m_fTargetFindingAngleCos = 0;
    float m_fTargetHoldingAngleCos = 0;

    /** aktualny cel dziala dla stanow hunting i autonomic hunting */
    ChromeActor m_Target = null;
	/** czy w danej chwili strzelamy (czy widzimy wroga) */
	boolean m_bClearShot = false;
    
    float m_fLongDelay = 1.0f;
    
    /////////////////////////////////////////////////////////////////////////////


	/** celowanie */
	float m_fShotDeviation = 0f;
	
    float m_fAimingAngleEpsilon = (float) (1 * Math.PI / 180.0);
    float m_fAimingAngleEpsilonCos = (float) java.lang.Math.cos(m_fAimingAngleEpsilon);

    float m_fFiringAngleEpsilonCos = (float) java.lang.Math.cos(m_fAimingAngleEpsilon*5.f);

    /** Predkosc obracania sie dzialka w poziomie [deg/s]
     */
    float m_fHorizAngSpeed = 500.f;
    
    /** Predkosc obracania sie dzialka w pionie [deg/s]
     */
    float m_fVertAngSpeed = 500.f;

    /////////////////////////////////////////////////////////////////
    // Wagi poszczegolnych czynnikow przy liczeniu istotnosci celu
    /** Waga odleglosci katowej lufy od celu przy wybieraniu najlepszego celu */
    float m_fAngleImportance = 5;
    /** Waga odleglosci dzialka od celu przy wybieraniu najlepszego celu */
    float m_fDistanceImportance = 5f;
    /** Waga odleglosci katowej celu od kierunku jazdy pojazdu */
    float m_fForwardImportance = 20.f;
	
	/** czy jest to dzialko mogace sie aktywowac / deaktywowac (z dodatkowymi elementami) */
	boolean m_bGunAdvanced = false;

	/** poczatkowe ustawienie lufy dzialka (dla jeepa w tyl, dla transportera w przod) */
	Vector m_vVectorForward = null;
	Vector m_vVectorRight = null;
	Vector m_vVectorUp = null;
	
	boolean m_bInManualMode = false;
    
    float m_fMaxHAngle = 100f;//#AICannon
    
    float m_fMinVAngle = -30f;//#AICannon
    float m_fMaxVAngle = 30f;//#AICannon

	/** czas do "rozkrecenia" dzialka - dzialko juz widzi wroga,
	 * ale jeszcze przez ten czas nie strzela. Jezeli dzialko straci wroga
	 * (schowa sie on za przeszkoda) to dzialko przestaje strzelac i znowu
	 * musi poczekac ze strzelaniem m_fInitialFireDelay czasu*/
	float m_fInitialFireDelay = 0.5f;
	/** zmienne pomocnicza */
	boolean m_bFireAllowed = false;
	boolean m_bAllowMethodCalled = false;


    float m_fCannonVertMorphTime = 1.f;
    
    String m_strOldState = null;
   
	float fAimMultiplier = 1f;
	
	/** czy dzialko jest aktywne w trybie automatycznym, tzn. czy namierza sie i strzela w cel */
	boolean m_bActiveInAutoMode = true;

    String sParticleSystem = null;

    /** wielkosc fxa beama */
    float fFXBeamSizeX = 2f; 
    
    float m_fExecuteBeamProbability = 1f;
    
    /**Gdy cel jest w odleglosci mniejszej od tej to nie pokazujemy beama*/
    float fMinBeamDistance = 100;

    /////////////////////////////////////////////////////////////////////////////

    // roznica pomiedzy pozycja (getposition) mesha a pozycja dzialka (getelementpos)
    Vector m_vCannonToParentDiff = new Vector();
    
    public CannonController()
    {
        nAmmo = nCapacity = Integer.MAX_VALUE;
    }
    
    
    public void OnCreate()
    {
        super.OnCreate();
		
		bSG = false;

        eBulletType = EAmmoType._Cannon;        
        
        sSoundShoot = "data/sounds/weapon/JeepCannon";
        SetShotSoundRange( 500.0f, 5000.0f );

        SetRateOfFire(10.0f);
        nRoundShots = 10;    
        
        sFXCombName = "FXGrzebienWalker";
        
		fNoiseShot = 4000f;
		
		fAimAcc = 2.4f;
        
        
        m_bFireOnlyFromHands = false;
        
    }
    
    public void AdjustEllipsoid()
    {
        //nic tu nie robimy
    }
    
    public void InitController(ICannonMesh cOwnerMesh)
    {
        m_OwnerMesh = cOwnerMesh;
        m_OwnerMesh.SetFlag(EFlags._NOT_STATIC);
        
        //podlaczamy kontroler do ownermesh'a i wylaczamy mu renderowanie
        AttachAsChildTo( (MeshObject) m_OwnerMesh );
        EnableRendering( false );
        ClearFlag( EFlags._COLLISION );
        ClearFlag( EFlags._BLOCK_MOVE );
        
        m_nElementH = m_OwnerMesh.GetElementID(m_sElementH);
        m_nElementV = m_OwnerMesh.GetElementID(m_sElementV);
        m_nElementCenter = m_OwnerMesh.GetElementID(m_sElementCenterNew);
        if (m_nElementCenter == -1)
            m_nElementCenter = m_OwnerMesh.GetElementID(m_sElementCenterOld);
            
        m_nElementBarrel = m_OwnerMesh.GetElementID(m_sElementBarrel);
        m_nElementBarrelExit = m_OwnerMesh.GetElementID(m_sElementBarrelExit);

        m_vVectorForward = m_OwnerMesh.GetElementForwardVector(m_nElementBarrel);
        m_vVectorForward = m_OwnerMesh.VectorWorldToLocal(m_vVectorForward);
        m_vVectorForward.Normalize();
        m_vVectorUp = m_OwnerMesh.GetElementUpVector(m_nElementBarrel);
		m_vVectorUp = m_OwnerMesh.VectorWorldToLocal(m_vVectorUp);
		m_vVectorUp.Normalize();
		m_vVectorRight = m_vVectorUp.Cross(m_vVectorForward);
        m_vVectorRight.Normalize();
        
        // poczatkowy kat w pionie
        Vector forward = new Vector(m_vVectorForward);
        m_fInitAngleV = (float) (SafeACOS(forward.Dot(m_vVectorUp)) * 180/3.14f);

        m_bGunAdvanced = (m_OwnerMesh.GetElementID("Gun_ramie") != -1);
        if (m_bGunAdvanced)
            m_OwnerMesh.SetElementAnimType(m_OwnerMesh.GetElementID("Gun_ramie"), (byte) (EAnimType._SEQUENCE | EAnimType._TRANSFORM), true);
        else
            m_OwnerMesh.SetElementAnimType(m_OwnerMesh.GetElementID("Gun_podstawa"), (byte) (EAnimType._SEQUENCE | EAnimType._TRANSFORM), true);
        m_OwnerMesh.SetAnimMorphTime(0.5f);  
        
        SetTargetFindingAngle(m_fTargetFindingAngle);
        SetMaxHorizAngle(m_fMaxHAngle);
        
        if (m_bGunAdvanced)
        {
            m_OwnerMesh.SetAnimMorphTime("Gun_podstawa2", m_fCannonVertMorphTime);
            m_OwnerMesh.SetAnimMorphTime("Gun_ramie", m_fCannonVertMorphTime);        
        }
        
        SetState("IdleState");
        
        m_vCannonToParentDiff.Set(GetCannonOrigin());
        m_vCannonToParentDiff.Sub(m_OwnerMesh.GetPositionVectorVolatile());
        m_vCannonToParentDiff = VectorWorldToLocal(m_vCannonToParentDiff);
        
        MsgSendClientState();
    }

    public void Die()
    {
        FreezeCallMethods();
        DeactivateOnModuleAlways();
    }
    
    public void SetShotSound(String sSoundName)
    {
        sSoundShoot = sSoundName;
    }
    
    public void SetAccuracy(float fBase, float fAim)
    {
        fBaseAcc = fBase;
        fAimAcc = fAim;
    }
    
    public void SetParticleSystem(String sParticleSystem)
    {
        this.sParticleSystem = sParticleSystem;
    }
    
    public boolean IsActive(ControlObject Activator)
    {
        return false;
    }
	
	public void ActivateInAutoMode(boolean bActivate)
	{
		m_bActiveInAutoMode = bActivate;
	}
	
	public boolean IsActiveInAutoMode()
	{
		return m_bActiveInAutoMode;
	}

    /** Samoobsluga dzialka
     */
    public boolean StartManualControl(Pawn cUser, 
                                      float fOverGunHeight, float fOverGunBack,
                                      float fOverGunHeightAim, float fOverGunBackAim,
									  float fOverGunFOV, float fOverGunAimFOV,
                                      boolean bUseGyro)
    {
		if (m_CannonUser != null)
			return false; // ktos juz strzela z tego dzialka - moze jest w trybie automatic
		
		if (cUser == null)
			return false;

        if (cUser instanceof Player)
        {
            Player cPlayer = (Player)cUser; 
            if ( cPlayer.bNetIsOwner )
            {
                if (Math.abs(fOverGunHeight - fOverGunHeightAim) < 0.01 &&
                    Math.abs(fOverGunBack - fOverGunBackAim) < 0.01)
                {
                    cPlayer.Camera.SetCameraOverGunPosition(fOverGunHeight, fOverGunBack,
			    										   fOverGunFOV, fOverGunAimFOV);
                }
                else
                {
                    cPlayer.Camera.SetCameraOverGunPosition(fOverGunHeight, fOverGunBack,
                                                           fOverGunHeightAim, fOverGunBackAim,
			    										   fOverGunFOV, fOverGunAimFOV);
                }
                cPlayer.Camera.SetWeaponToViewOver(this, (MeshObject) m_OwnerMesh, bUseGyro);
                m_iLastCameraMode = cPlayer.Camera.GetMode();
                cPlayer.Camera.SetMode( cPlayer.Camera.CMODE_HEAVYGUN );
            
			    // mozemy wlaczac inne hudy podczas strzelania
                //((PlayerHUD) player).HUD.m_bIsUserHUDActive = true;
            
                RegisterMouseButtonRequest();
                RegisterKeyRequest();
                RegisterMouseAxisRequest();
            }
            else
            {
                if ( Role == ERole._AUTHORITY )
                    EnableIncomingReplication( true );
            }

            m_fOldVertAngSpeed = m_fVertAngSpeed;
            m_fOldHorizAngSpeed = m_fHorizAngSpeed;
            
            SetVertAngSpeed(100f);
            SetHorizAngSpeed(500f);
            
            m_strOldState = GetStateName();
            m_CannonUser = cUser;
            
            m_nOldRoundShots = nRoundShots;
            nRoundShots = 0;
            
            SetHorizAnimMorphTime(0f);        
            if (m_bGunAdvanced)
            {
                m_OwnerMesh.SetAnimMorphTime("Gun_podstawa2", 0f);
                m_OwnerMesh.SetAnimMorphTime("Gun_ramie", 0f);        
            }
            
            SetState("ManualControlState");
			
			SetPlayerManual( cPlayer );
			
            m_bInManualMode	= true;
            
            return true;
        }
        else
            return false;
    }
	
	public String GetStateName()
	{
        if (CurrentState != null)
        {
            int i = CurrentState.getClass().getName().lastIndexOf("$");
            if (i == -1)
    		    return new String(CurrentState.getClass().getName());
            else
		        return new String(CurrentState.getClass().getName().substring(i + 1));
        }	
		else
			return null;
	}
    
    public void StopManualControl()
    {
		Player player = (Player) m_CannonUser;
        if ( player != null && player.bNetIsOwner && player.Camera != null )
        {
		    player.Camera.RestoreCameraDefaults();
		    player.Camera.SetMode(m_iLastCameraMode);
            player.Camera.m_fAngleV = 0f;
	        player.Camera.m_fAngleH = 0f;
        }
        
        if ( Role == ERole._AUTHORITY )
            EnableIncomingReplication( false );
        
		RestoreParamsAfterManualMode();
		
		m_CannonUser = null;
                
		UnregisterKeyRequest();
		UnregisterMouseButtonRequest();
		UnregisterMouseAxisRequest();
	
        if (m_strOldState != null)
   		    SetState(m_strOldState);
		
		SetPlayerManual( null );
		
		SetIdlePosition();
        
        StopFire();
    }
    
    /** Rozpoczecie automatycznego wyszukiwania przeciwnikow
     */
    public void StartAutonomicHuntingByUser(ChromeActor cUser)
    {
        m_CannonUser = cUser;
        m_nOwnerSide = cUser.cConflictSide.GetValue();
        SetState("AutonomicHuntingState");
    }

    public void StartAutonomicHuntingByConflictSide(int nConflictSide)
    {
        m_CannonUser = null;
        m_nOwnerSide = nConflictSide;
        SetState("AutonomicHuntingState");
    }
    
    public void StopAutonomicHunting()
    {
        m_CannonUser = null;
        m_Target = null;
        StopDelayedFire();
        SetState("IdleState");
    }

    public ICannonMesh GetOwnerMesh()
    {
        return m_OwnerMesh;
    }
    
    public ChromeActor GetTarget()
    {
        return m_Target;
    }
    
    public boolean HasClearShot()
    {
        return m_bClearShot;
    }

    public Vector GetFireOrigin()
    {
		//CrashLog("[CannonController.GetFireOrigin]\n");
        return m_OwnerMesh.GetElementPos(m_nElementBarrelExit);
    }

    public Vector GetTargetTracingOrigin()
    {
        return m_OwnerMesh.GetElementPos(m_nElementH);
    }

    public Vector GetCannonDir()
    {
        return m_OwnerMesh.GetElementForwardVector(m_nElementV);
    }
    
    public Vector GetCannonOrigin()
    {
        return m_OwnerMesh.GetElementPos(m_nElementV);
    }
    
    Vector m_vAimAtPoint = new Vector();
    
    public void AimAtPoint(Vector target)
    {
        m_fAimX = target.fX; m_fAimY = target.fY; m_fAimZ = target.fZ;
        
        Vector forward = m_OwnerMesh.GetElementForwardVector(m_nElementBarrel);
        
/*        // liczymy przesuniecie, ktore wynika z pozycji rzeczywistej i tej wynikajacej z dosymulowania
        Vector vDiff = new Vector();
        m_OwnerMesh.GetRenderPosition(vDiff, null, null);
        vDiff.Sub(m_OwnerMesh.GetPosition());
*/        Vector pos = m_OwnerMesh.GetElementPos(m_nElementCenter);
        
//        pos.Add(vDiff);
        
		// przeliczamy wszystko na wspolrzedne lokalne
        pos = m_OwnerMesh.PointWorldToLocal(pos);
        forward = m_OwnerMesh.VectorWorldToLocal(forward);
        forward.Normalize();
        target = m_OwnerMesh.PointWorldToLocal(target);
            
        target.Sub(pos);
        Vector targetNorm = new Vector(target);
		targetNorm.Normalize();

        // rzutowanie na plaszczyzne XZ
        Vector targetXZ = new Vector(target);
        targetXZ.fY = 0;
        targetXZ.Normalize();

        Vector forwardXZ = new Vector(forward);
        forwardXZ.fY = 0;
        forwardXZ.Normalize();

        float fAngle = (float) (SafeACOS( targetXZ.Dot(m_vVectorForward)) * 180f / 3.14f );
        if (targetXZ.Dot(m_vVectorRight) < 0)
            fAngle = -fAngle;

		RotateGunHoriz(fAngle, true);

        // roznica katow do pionu
        float fAngleDiff = (float)( SafeACOS(targetNorm.Dot(m_vVectorUp))-
									SafeACOS(forward.Dot(m_vVectorUp)) );
        //obroc sie w pionie
        fAngle = (float) (SafeACOS(targetNorm.Dot(m_vVectorUp)) * 180f / 3.14f);
        fAngle -= m_fInitAngleV;

        if (fAngle > m_fMaxVAngle )
            fAngle = m_fMaxVAngle;
        else if (fAngle < m_fMinVAngle)
            fAngle = m_fMinVAngle;

        RotateGunVert(fAngle, true);
        
    }

    public void SetTargetFindingAngle(float fFindingAngle)
    {
        m_fTargetFindingAngle = fFindingAngle;
        m_fTargetFindingAngleCos = (float)Math.cos(m_fTargetFindingAngle * Math.PI / 180);
    }
        
    
    public void SetMaxHorizAngle(float fMaxHorizAngle)
    {
        m_fMaxHAngle = fMaxHorizAngle;
        m_fTargetHoldingAngleCos = (float)Math.cos(fMaxHorizAngle * Math.PI / 180);
    }
    
    public void SetMinVertAngle(float fMinVertAngle)
    {
        m_fMinVAngle = fMinVertAngle;
    }
    
    public void SetMaxVertAngle(float fMaxVertAngle)
    {
        m_fMaxVAngle = fMaxVertAngle;
    }
    
    public float GetMaxHorizAngle()
    {
        return m_fMaxHAngle;
    }
    
    public float GetMaxVertAngle()
    {
        return m_fMaxVAngle;
    }

    public float GetMinVertAngle()
    {
        return m_fMinVAngle;
    }
    
    public void SetHorizAngSpeed(float fSpeed)
    {
        m_fHorizAngSpeed = fSpeed;
    }
    
    public void SetVertAngSpeed(float fSpeed)
    {
        m_fVertAngSpeed = fSpeed;
    }

    public void SetInitialFireDelay(float fDelay)
    {
        m_fInitialFireDelay = fDelay;
    }

    
    public void SetFireParams(int nShots, float fRateOfFire, float fLongDelay, float fRange, float fDamage)
    {
        if (nShots != -1)
            nRoundShots = nShots;
        if (fRateOfFire != -1f)
            SetRateOfFire(fRateOfFire);
        if (fLongDelay != -1f)
            m_fLongDelay = fLongDelay;
        if (fRange != -1f)
            this.fRange = fRange;
        if (fDamage != -1f)
        {
            this.fDamage = fDamage;
            fPhysicsSimDamage = fDamage;
        }
    }
    
    public void SetAmmo(int nAmmoCount)
    {
        nAmmo = nAmmoCount;
    }
    
    public float GetTargetFindingAngle()
    {
        return m_fTargetFindingAngle;
    }
    
    public float GetTargetHoldingAngle()
    {
        return m_fTargetHoldingAngle;
    }
    
    
    /** Pobranie z wlasciciela kierunku, w ktory strzelamy
     */
    public Vector GetFireDir()
    {
        Vector target = null;

        if (m_Target != null)
        {
            //TODO: sprawdzanie, czy dostal dobra pozycje
            target = m_Target.GetPointToLookAt(0); 
            target.Sub(GetFireOrigin());
            target.Normalize();
        }
        else
        {
            target = m_OwnerMesh.GetElementForwardVector(m_nElementV);
        }

        float fTempAimMult;
        
        if( m_CannonUser instanceof Player)
            fTempAimMult = ((Player)m_CannonUser).fCurrentAccuracy;
        else
            fTempAimMult = fAimMultiplier * ChromeGame.GetCannonAimingDiffLevelMult();
        
        Vector vDev = new Vector( ((RandomFloat(1.0f) - 0.5f) * fTempAimMult/100.f),
                                  ((RandomFloat(1.0f) - 0.5f) * fTempAimMult/100.f), 
                                  ((RandomFloat(1.0f) - 0.5f) * fTempAimMult/100.f) );
        target.Add(vDev);
        target.Normalize();

        return target;
    }
  
    /////////////////////////////////////////////////////////////////////////////
    
    void SetRateOfFire(float fRate)
    {
        fRateOfFire = fRate;
        fDelay = 60.0f / fRateOfFire;        
    }

    /** Stan spoczynku dziala */
    public class IdleState extends State
    {
        public void OnEnter()
        {
            DisableCallMethod("AdjustOrientation");
            DisableCallMethod("AdjustCannonPosition");
            DisableCallMethod("GetAllTargets");
            DisableCallMethod("RecalculateTargets");
            
            // skladamy dzialo
            SetIdlePosition();
        }		
    }
    
	PlayerHUD m_PlayerManual = null;

	void SetPlayerManual(Player player)
	{
		if (player instanceof PlayerHUD)
        {
			m_PlayerManual = (PlayerHUD) player;
            Owner          = player;
        }
        else
        {
            m_PlayerManual = null;
            Owner          = null;
        }
	}
	
    /** Stan obslugi przez gracza */
    public class ManualControlState extends State
    {
        public void OnEnter()
        {
            m_OwnerMesh.SetElementAnimType(m_nElementH, EAnimType._OFF, false);
            m_OwnerMesh.SetElementAnimType(m_nElementV, EAnimType._OFF, false);
        }

        public void OnInputMouseButton(int nButton, int nState)
        {
            CallOnInputKey(Player.ConvertMouseButtonToKey(nButton), nState, '0');
        }
        
        void OnInputMouseAxis(int nAxis, int nDelta)
        {
            HUDManager.ProcessMouseWheel(CannonController.this, nAxis, nDelta);
        }
        
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
	        if (nKeyCode == EGameControl.FIRE)
            {
                if (bKeyState)
				{
					// jezeli mapa wlaczona, to nie reagujemy
					if ( (m_PlayerManual != null) &&
						 (m_PlayerManual.HUD.GetHUDMap() != null) &&
						 (m_PlayerManual.HUD.GetHUDMap().bActiveFlag) )
						return;
                    
                    if ( (m_PlayerManual != null) &&
                         (!m_PlayerManual.HUD.m_bActivateAllowed) )
                        return;
							
                    StartFire(Weapon.MODE_AUTO);
				}
                else
                    StopFire();                            
            }
        }
        
        void OnFrame()
        {
            if ( m_bNetModule   && 
                 m_PlayerManual != null )
            {
                if ( m_PlayerManual.bNetIsOwner )
                {
                    if (m_nFrame % 5 == 0) 
                        m_PlayerManual.CheckTriggers( true );
                }
                else
                {
                    //if ( Role < ERole._AUTHORITY )
                    {
                        if ( m_bPreFiringState != m_bPreFiring )
                        {
                            if ( m_bPreFiring )
                                StartFire( Weapon.MODE_AUTO );
                            else
                                StopFire();
                        }
                        if ( m_bFiringState != m_bFiring )
                        {
                            if ( m_bFiring )
                                SuperStartFireDo( Weapon.MODE_AUTO );
                            else
                                StopFire();
                        }
                    }
                    
                    if ( (m_vAimAtPoint.fX != m_fAimX) ||
                         (m_vAimAtPoint.fY != m_fAimY) ||
                         (m_vAimAtPoint.fZ != m_fAimZ) )
                    {
                        m_vAimAtPoint.Set( m_fAimX, m_fAimY, m_fAimZ );
                        AimAtPoint( m_vAimAtPoint );
                    }
                }
            }
        }		
    }
    
    
    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////
    
	static boolean HasCannonMounted(MeshObject mesh)
	{
		if ( (mesh.GetElementID("Gun_podstawa") == -1) ||
			 (mesh.GetElementID("Gun_lufy") == -1) )
			return false;
		else
			return true;
	}
    
    void SetHorizAnimMorphTime(float fAnimMorphTime)
    {
        m_OwnerMesh.SetAnimMorphTime("Gun_podstawa", fAnimMorphTime);
        m_OwnerMesh.SetAnimMorphTime("Gun_lufy", fAnimMorphTime);        
    }

	/** mode kamery przed wlaczeniem tego guna */
	byte m_iLastCameraMode = 0;
	/** ostatni stan dzialka */
	int m_iOldState = 0;
	/** stara dluga przerwa pomiedzy seriami */
	int m_nOldRoundShots = 0;
	/** stare szybkosci obrotow */
	float m_fOldVertAngSpeed = 0f;
	float m_fOldHorizAngSpeed = 0f;
	
	
	void RestoreParamsAfterManualMode()
	{
		if (!m_bInManualMode)
			return;
		
        //TODO - sprawdzic SetHorizAnimMorphTime(fCannonHorizMorphTime);
		if (m_bGunAdvanced)
		{
		    m_OwnerMesh.SetAnimMorphTime("Gun_podstawa2", m_fCannonVertMorphTime);
	        m_OwnerMesh.SetAnimMorphTime("Gun_ramie", m_fCannonVertMorphTime);
		}
		
		// moglismy wlaczac inne hudy podczas strzelania
		//((PlayerHUD) m_CannonUser).HUD.m_bIsUserHUDActive = false;
		
		nRoundShots = m_nOldRoundShots;
		m_fVertAngSpeed = m_fOldVertAngSpeed;
		m_fHorizAngSpeed = m_fOldHorizAngSpeed;
		
		m_bInManualMode = false;
	}

    /** Ustawienie dzialka w pozycji spoczynkowej
     */
    void SetIdlePosition()
    {
        m_OwnerMesh.SetElementAnimType(m_nElementV, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        m_OwnerMesh.SetElementAnimType(m_nElementH, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        
        // skladamy dzialo
        SetCannonPosition(0);

        ToStartPos();
    }
    
    public void ToStartPos()
    {
        if (m_fLastHorizAngle == 0f)
            return;
        if (Math.abs(m_fLastHorizAngle) < 1f)
            RotateGunHoriz(0f, false);
        float fAngle = m_fLastHorizAngle / 2f;
        RotateGunHoriz(fAngle, false);
        
        if (m_fLastVertAngle == 0f)
            return;
        if (Math.abs(m_fLastVertAngle) < 1f)
            RotateGunVert(0f, false);
        fAngle = m_fLastVertAngle / 2f;
        RotateGunVert(fAngle, false);
            
        if (m_fLastHorizAngle == 0f && m_fLastVertAngle == 0f)
            return;
        CallMethodIn("ToStartPos", 0.07f);
    }
    
    /** Ustawienie wysokosci wysiegnika dzialka (kat podniesienia ramienia)
     */
    void SetCannonPosition(float fAngle)
    {
		if (m_bGunAdvanced)
		{
            // nie ma juz takich meshelementow !!!
			//m_OwnerMesh.RotateElementWithAnim(m_OwnerMesh.GetElementID("Gun_podstawa2"), m_vVectorRight, -fAngle);
			//m_OwnerMesh.RotateElementWithAnim(m_OwnerMesh.GetElementID("Gun_ramie"), m_vVectorRight, fAngle);
		}
    }
    
    float m_fLastHorizAngle = 0;
    /** Obrot guna w poziomie o podany kat [deg]
     */
    float RotateGunHoriz(float fAngle, boolean bUltraFast)
    {
        float fTime = 0;
        float fDelta = fAngle - m_fLastHorizAngle;
        if (bUltraFast)
        {
            m_OwnerMesh.RotateElement(m_nElementH, m_vVectorUp, fDelta);
            m_fLastHorizAngle += fDelta;
        }
        else
        {
            fTime = Math.abs(fAngle) / m_fHorizAngSpeed;
            m_OwnerMesh.SetAnimMorphTime(m_nElementH, fTime, false);
            m_OwnerMesh.RotateElementWithAnim(m_nElementH, m_vVectorUp, fAngle);
            m_fLastHorizAngle = fAngle;
        }
        return fTime;
    }

    float m_fLastVertAngle = 0;
    /** Obrot guna w pionie o podany kat [deg]
     */
    float RotateGunVert(float fAngle, boolean bUltraFast)
    {
        float fTime = 0;
        if (bUltraFast)
        {
            float fDelta = fAngle - m_fLastVertAngle;
            m_OwnerMesh.RotateElement(m_nElementV, Vector.Right, fDelta);
            m_fLastVertAngle += fDelta;
        }
        else
        {
            fTime = Math.abs(fAngle) / m_fVertAngSpeed;
            m_OwnerMesh.SetAnimMorphTime(m_nElementV, fTime, false);
            m_OwnerMesh.RotateElementWithAnim(m_nElementV, Vector.Right, fAngle);
            m_fLastVertAngle = fAngle;
        }
        return fTime;
    }
    
    /** Funkcja pomocnicza do liczenia kata z wyniku Dota
     */
    float SafeACOS(float fValue)
    {
        if (fValue <= -1)
            return (float)Math.PI;
        else if (fValue >= 1)
            return 0;
        else 
            return (float) Math.acos(fValue);
    }
    
    /** Stan polowania na gracza (dla Level05, TrackedJeep) */
    public class HuntingState extends State
    {
        public void OnEnter()
        {
            CallMethodEvery("AdjustOrientation", 0.1f);
			if (m_bGunAdvanced)
	            AdjustCannonPosition();
        }

        void AdjustCannonPosition()
        {
            //LogD("Adjusting position of cannon arm\n");
            SetCannonPosition(45f + RandomFloat(20f) - 10f);
            CallMethodIn("AdjustCannonPosition", 3f + RandomFloat(3f));
        }

        void AdjustOrientation()
        {
            if (m_Target == null)
			{
				CrashLog("[AICannon] No target!");
                StopDelayedFire();
				return;
			}

            Vector target = m_Target.GetPointToLookAt(0);
            Vector forward = m_OwnerMesh.GetElementForwardVector(m_nElementBarrel);
            Vector pos = m_OwnerMesh.GetElementPos(m_nElementCenter);
            
            pos = m_OwnerMesh.PointWorldToLocal(pos);
            forward = m_OwnerMesh.VectorWorldToLocal(forward);
            forward.Normalize();
            
            target = m_OwnerMesh.PointWorldToLocal(target);
            
            target.Sub(pos);
            Vector targetNorm = new Vector(target);
			targetNorm.Normalize();

            // Sprawdz, czy mozna strzelac do celu (jesli go widac i jest niezbyt daleko (katowo) od lufy)
            if (targetNorm.Dot(forward) > m_fFiringAngleEpsilonCos)
            {
                if (m_OwnerMesh.CheckTraceAbsolute(m_Target, GetTargetTracingOrigin(), m_Target.GetPointToLookAt(0)))
				{
	                if (nCurrentMode == MODE_IDLE)
					{
						StartDelayedFire();
						m_bClearShot = true;
					}
				}
				else
				{
                    StopDelayedFire();
					m_bClearShot = false;
				}	
            }
            else
            {
				if (nCurrentMode != MODE_IDLE)
				{
	                StopDelayedFire();
					m_bClearShot = false;
				}
            }

            if (targetNorm.Dot(forward) < m_fAimingAngleEpsilonCos)
            {
                // rzutowanie na plaszczyzne XZ
                Vector targetXZ = new Vector(target);
                targetXZ.fY = 0;
                targetXZ.Normalize();

                Vector forwardXZ = new Vector(forward);
                forwardXZ.fY = 0;
                forwardXZ.Normalize();

                float fAngleDiff = targetXZ.Dot(forwardXZ);
                if (fAngleDiff < m_fAimingAngleEpsilonCos)
                {
                    float fAngle = (float) (SafeACOS(targetXZ.Dot(m_vVectorForward)) * 180f / 3.14f);
                    if (targetXZ.Dot(m_vVectorRight) < 0)
                        fAngle = -fAngle;
                    RotateGunHoriz(fAngle, false);
                }

                // roznica katow do pionu
                fAngleDiff = (float)( SafeACOS(targetNorm.Dot(m_vVectorUp)) -
									  SafeACOS(forward.Dot(m_vVectorUp)) );
                if (Math.abs(fAngleDiff) > m_fAimingAngleEpsilon)
                {
                    //obroc sie w pionie
                    float fAngle = (float) (SafeACOS(targetNorm.Dot(m_vVectorUp)) * 180f / 3.14f);
                    fAngle -= m_fInitAngleV;

                    if (fAngle > m_fMaxVAngle)
                        fAngle = m_fMaxVAngle;
                    else if (fAngle < m_fMinVAngle)
                        fAngle = m_fMinVAngle;

                    RotateGunVert(fAngle, false);
                }
            }
        }
		
 		//*********************************************************
		//					SaveGame
		//*********************************************************				
		public void SGUpdate()
		{
			FileChunk.Log("[CannonController$HuntingState] : SGUpdate\n");
			
			if (m_bGunAdvanced)
				AdjustCannonPosition();
		}				
    }
	
	public void StartDelayedFire()
	{
		if (!m_bAllowMethodCalled)
		{
			m_bAllowMethodCalled = true;
			CallMethodIn("AllowFire", m_fInitialFireDelay);
		}
		if (!m_bFireAllowed)
			return;
		StartFire(MODE_AUTO);
	}
	
	public void AllowFire()
	{
		m_bFireAllowed = true;
	}
	
	public void StopDelayedFire()
	{
		StopFire();
		DisableCallMethod("AllowFire");
		m_bFireAllowed = false;
		m_bAllowMethodCalled = false;
	}

    /** Stan strzelania do celu z automatycznym jego znajdowaniem */
    public class AutonomicHuntingState extends HuntingState
    {
        int _MAX_TARGETS = 100; // maksymalna liczba celi w tablicy
        int nTargetsCount = 0;
        ChromeActor aTargets[] = new ChromeActor[_MAX_TARGETS];
        
        float _GET_TARGETS_TIME_MIN = 0.5f; // minimalny czas pomiedzy pobraniami obiektow
        float _GET_TARGETS_TIME_MAX = 2f;   // maksymalny czas pomiedzy pobraniami obiektow

        float m_fGetTargetsDistMin = 0f; // zmienne kontrolujace przesuniecie miejsca pobierania obiektow
        float m_fGetTargetsDistMax = 0f;
        
        Vector m_vLastCannonPos = null;
        Vector m_vTargetGetPos = new Vector();
        
        float _RECALC_TARGETS_TIME = 0.5f;
        
        public void OnEnter()
        {
            super.OnEnter();
            
            GetAllTargets();
            RecalculateTargets();
			if (!m_bActiveInAutoMode)
                StopDelayedFire();
        }
        
        public void AdjustOrientation()
        {
			if (!m_bActiveInAutoMode)
			{
                StopDelayedFire();
				return;
			}
			
            if ( (m_Target != null) &&
                 (!m_Target.bDead) && 
                 (IsInsideForwardCone(m_Target, m_fTargetHoldingAngleCos)) )
            {
                super.AdjustOrientation();
            }
            else
            {
                StopDelayedFire();
                SetIdlePosition();
            }
        }

        void SetActiveIdlePosition()
        {
            m_OwnerMesh.SetAnimMorphTime(m_nElementV, m_fCannonVertMorphTime, false);
            m_OwnerMesh.SetAnimMorphTime(m_nElementH, 0.5f, false);
            
            m_OwnerMesh.RotateElementWithAnim(m_nElementV, m_vVectorRight, 0f);
            m_OwnerMesh.RotateElementWithAnim(m_nElementH, m_vVectorUp, 180f);
        }
        
        void AdjustCannonPosition()
        {
            if (CurrentState instanceof IdleState)
                SetActiveIdlePosition();
            else
                SetCannonPosition(45f + RandomFloat(20f) - 10f);
    
            CallMethodIn("AdjustCannonPosition", 3f + RandomFloat(3f));
        }
        
        public void GetAllTargets()
        {
            m_fGetTargetsDistMax = fRange * 0.5f;
            
            float fNextGetAllTargetsCall = _GET_TARGETS_TIME_MAX;
            Vector vPos = GetPosition();
            
            if (m_vLastCannonPos == null)
                m_vLastCannonPos = vPos;
            
            float fDist = vPos.Distance(m_vLastCannonPos); // przebylismy taka droge ostatnio
            if (fDist > 1f)
            {
                if (fDist > fRange)
                    fDist = fRange;
                // za ile ponownie zostanie zawolane GetAllTargets
                fNextGetAllTargetsCall = (1f - fDist / fRange) * (_GET_TARGETS_TIME_MAX - _GET_TARGETS_TIME_MIN) +
                                         _GET_TARGETS_TIME_MIN;

                // nastepna pozycja wyciagania obiektow
                m_vTargetGetPos.Set(vPos);
                m_vTargetGetPos.Sub(m_vLastCannonPos);
                m_vTargetGetPos.Normalize();
                m_vTargetGetPos.Mul( (fDist / fRange) * (m_fGetTargetsDistMax - m_fGetTargetsDistMin) +
                                         m_fGetTargetsDistMin );
                m_vTargetGetPos.Add(vPos);
            }
            else
                m_vTargetGetPos.Set(vPos);
            
            m_vLastCannonPos = vPos;
            
            DisableCallMethod("GetAllTargets");
            CallMethodIn("GetAllTargets", fNextGetAllTargetsCall + RandomFloat(fNextGetAllTargetsCall) * 0.1f);
            FindAllPossibleTargets();
        }
        
        public void RecalculateTargets()
        {
            ChromeActor cBestTarget = null;
            if (nTargetsCount > 0)
            {
                Vector vBarrelDir = m_OwnerMesh.GetElementForwardVector(m_nElementBarrel);
                Vector vOrigin = m_OwnerMesh.GetElementPos(m_nElementBarrel);
                Vector vDriveDir = m_OwnerMesh.GetForwardVector();
                
                float fMetric = 0;
                float fMinDistMetric = 2.f;
                ChromeActor cCurrTarget;
                
                for (int i = 0; i < nTargetsCount; i++)
                {
                    cCurrTarget = aTargets[i];
                    
                    if (!cCurrTarget.bDead && 
                        IsInsideForwardCone(cCurrTarget, m_fTargetFindingAngleCos))
                    {
                        fMetric = GetTargetDistanceMetric(cCurrTarget, vDriveDir, vBarrelDir, vOrigin);
                        if (fMetric < fMinDistMetric &&
                            m_OwnerMesh.CheckTraceAbsolute(cCurrTarget, GetTargetTracingOrigin(), cCurrTarget.GetPointToLookAt(0)))
                        {
                            cBestTarget = cCurrTarget;
                            fMinDistMetric = fMetric;
                        }
                    }
                }
            }
            
            m_Target = cBestTarget;
            
            DisableCallMethod("RecalculateTargets");
            CallMethodIn("RecalculateTargets", _RECALC_TARGETS_TIME + RandomFloat(_RECALC_TARGETS_TIME) * 0.1f);
        }
        
        /** Sprawdza, czy kierunek do podanego obiektu jest odchylony od 
         *  wektora do przodu o mniej niz wynika z podanego kosinusa kata
         */
        boolean IsInsideForwardCone(ControlObject cObj, float fConeAngleCos)
        {
            Vector vObjDir = cObj.GetPosition();
            vObjDir.Sub(m_OwnerMesh.GetPosition());
            vObjDir.Normalize();
            return m_OwnerMesh.GetForwardVector().Dot(vObjDir) > fConeAngleCos;                
        }
        
        /** Zwraca znormalizowana 'odleglosc' ChromeActora od kierunku lufy
         *  Przy obliczaniu tej odleglosci brane sa pod uwage (z odpowiednimi wagami):
         *    - dot kierunek_lufy, wektor lufa-cel
         *    - odleglosc celu od lufy
         *  Funkcja zwraca:
         *  0 dla lufy wycelowanej w cel polozony w jej pozycji 
         *  1 dla celu z tylu lufy polozonego na zasiegu strzalu dzialka
         *  wartosc 0..1 dla celu lezacego pomiedzy tymi skrajnymi pozycjami
         */
        float GetTargetDistanceMetric(ChromeActor cTarget, Vector vDriveDir, Vector vBarrelDir, Vector vPosition)
        {
            Vector vTgtDir = cTarget.GetPosition();
            vTgtDir.Sub(vPosition);
            float fDistance = vTgtDir.Len();
            if (fDistance > 0)
            {
                vTgtDir.Mul(1.f/fDistance); //normalizacja
                float fGunDot = vBarrelDir.Dot(vTgtDir);
                float fDriveDot = vDriveDir.Dot(vTgtDir);
                
                float fMetric = (0.5f * (1.f - fGunDot)) * m_fAngleImportance +
                                (fDistance / fRange) * m_fDistanceImportance +
                                (0.5f * (1.f - fDriveDot)) * m_fForwardImportance;
                fMetric /= (m_fAngleImportance + m_fDistanceImportance + m_fForwardImportance);
                if (fMetric < 0)
                    fMetric = 0;
                else if (fMetric > 1)
                    fMetric = 1;
                
                return fMetric;
            }
            else
                return 0.f; //lezy w tej samej pozycji co dzialko - kierunek sie nie liczy
        }
        
        void FindAllPossibleTargets()
        {
            ControlObject aActors[] =
               m_OwnerMesh.GetObjectsInRadiusOfFlagsFromClass(m_vTargetGetPos, fRange, EFlags._AI_TARGET, null);
            
            ChromeActor cCurrent = null;
            nTargetsCount = 0;
            for (int i = 0; i < aActors.length; i++)
            {
                if(aActors[i] instanceof ChromeActor)
                {
                    cCurrent = (ChromeActor) aActors[i];
                    if ( (!cCurrent.bDead) &&
                         cCurrent.IsEnemy(m_nOwnerSide))
                    {
                        // jesli jeszcze jest w stozku wylapywania to go dodaj
                        if (IsInsideForwardCone(cCurrent, m_fTargetFindingAngleCos))
                        {
                            aTargets[nTargetsCount++] = cCurrent;
                            if (nTargetsCount == _MAX_TARGETS)
                                return;
                        }
                    }
                }
            }
            //CrashLog("Targets found: " + nTargetsCount + "( from: " + aPawns.length + " Pawns)\n");
        }
        
		public void SGUpdate()
		{
			FileChunk.Log("[CannonController$AutonomicHuntingState] : SGUpdate\n");
			
            super.SGUpdate();
            
			if (IsActiveOnModule())
			{
				GetAllTargets();			
				RecalculateTargets();
			}
			
			if (!m_bActiveInAutoMode)
                StopDelayedFire();
		}				
    }
    

	
    void SendWeaponMessage(int msg)
    {
    }
    
    /////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////

    
    /** Oddanie pojedynczego strzalu 
     */
    protected void FireModeSingle()
    {
        Fire(GetFireDir());
        SendWeaponMessage(STATE_SHOT);
        nShots++;
    }

    /** Stzelanie bronia automatyczna
     */
    protected void FireModeAuto()
    {
        if (nCurrentMode == MODE_AUTO)
        {
            int nState = GetState();
            if ( ((nState & STATE_NO_AMMO) == 0 ) &&
                 // max. liczba strzalow w serii nie przekroczona:
                 ((nRoundShots == 0) || (nShots < nRoundShots)) )
            {
                SetFireModeSingle();
                //HACK by MK, zeby robil przerwy miedzy seriami
                if ( nShots == nRoundShots )
                {
                    fLastShotT += m_fLongDelay - fDelay;
                    MessageLongDelay( m_fLongDelay );
                }
            }
            else
            {  
                // koniec amunicji - zaprzestan strzelania i powiadom
                StopFire();
                SendWeaponMessage( nState );
            }
        }
    }


	/** Strzelenie w kierunku v
	 */
    void Fire(Vector v)
    {
        Vector vBarrel = GetFireOrigin();
        Vector vDir = v;
        
        if ( !CheckIfCanLocalFire( m_CannonUser, vBarrel, vDir ) )
            return;
        
        // liczymy jak pocisk leci
        Fire(vBarrel, vDir);
    }

	public void SetBeamProbability(float fProbability)
    {
        m_fExecuteBeamProbability = fProbability;
    }
    
    public void SetMinBeamDistance(float fDistance)
    {
        fMinBeamDistance = fDistance;
    }
    
    public void SetFXSizeX(float fSize)
    {
        fFXBeamSizeX = fSize;
    }
    
	public void SetBeamFX(String sBeamName)
    {
        this.sBeamName = sBeamName;
    }
    
    public void SetCombFX(String sCombName)
    {
        this.sFXCombName = sCombName;
    }
    
    /** Strzelanie pociskami
     */
    void Fire(Vector vBarrel, Vector vDir)
    {
		if (m_OwnerMesh.GetRole() == ERole._AUTHORITY)
			nAmmo -= 1;

        fLastShotT = GetTime();

        float fDist = FireBullet(vBarrel, vDir);

        // dodajemy efekty zwiazane z wystrzalem
        //wczesniej nalezy ustawic odowiednie pola FXa
        if (sFXCombName != null)
		{
            m_OwnerMesh.ExecuteFX((MeshObject) m_OwnerMesh, m_sElementBarrelExit,
                                   sFXCombName, new Vector(0, 0, 0));
		}

        m_vForwardDelta = vDir.Sub2(m_OwnerMesh.GetElementForwardVector(m_nElementBarrel)); 
        //beam z lufy tylko losowo
        
        if (CanExecuteBeam() && (RandomFloat(1) < m_fExecuteBeamProbability) )
        {
            //ustawienia fx beama 
            
            m_OwnerMesh.SetFXSizeX(fFXBeamSizeX);
            m_OwnerMesh.SetFXZero(0f);
            if (fDist <= fRange)
            {
                m_OwnerMesh.SetFXSizeY(fDist - fMinBeamDistance);
                m_OwnerMesh.SetFXPosY(fDist/2f + fMinBeamDistance/2f);
            }
            else
            {
                //brak kolizji w zasiegu, wtedy w fDist jest jakas kosmiczna liczba
                m_OwnerMesh.SetFXSizeY(fRange - fMinBeamDistance);
                m_OwnerMesh.SetFXPosY(fRange/2f + fMinBeamDistance/2f);
            }
            m_OwnerMesh.ExecuteFX(// cOwner, sElementBarrelExit,
                              sBeamName,//"LaserBeamRed", 
                              vBarrel, vDir
                              );
        }
        
        m_OwnerMesh.PlaySound(sSoundShoot, fMinShootSound, fMaxShootSound);
        m_OwnerMesh.MakeNoise(fNoiseShot, Pawn._NOISE_WEAPON_FIRING);
    }
    
    boolean CanExecuteBeam()
    {
        return (!(m_CannonUser instanceof Player && m_CannonUser.bNetIsOwner) ||
                m_OwnerMesh instanceof EnergyCannon) &&
                m_vForwardDelta.Len() < 0.02f;
    }
    
    LaserPointer cFirePointer = null;
    
    Vector vShakeImpulse = new Vector();
    
    float fShakeImpulseForce = 150;

    float FireBullet(Vector vBarrel, Vector vDir)
    {
        // ustawiamy wlasciciela
        if(m_OwnerMesh instanceof ChromeActor)
            cFBMesh = (ChromeActor)m_OwnerMesh;
        
        // ustawiamy wlasciciela trafienia
        cHitOwner = GetModule() instanceof ModuleNet ? Owner : (ChromeActor) m_OwnerMesh;
        
        if (m_CannonUser instanceof Player)
        {
            CameraPlayer cCamera = ((Player)m_CannonUser).Camera;
                        
            SetShakeImpulse();
            
            //brawo dla poprawiaczy, kto powiedzial ze gracz ma kamere?
            if ( cCamera != null )
                cCamera.ShakeImpulse(vShakeImpulse, CameraPlayer._SHAKE_CANNON , false);
            
            /*cCamera.ShakeImpulse(new Vector(70f - RandomFloat(140f),
                                            70f - RandomFloat(140f),
                                            70f - RandomFloat(140f)), CameraPlayer._SHAKE_CANNON , false);*/
        }

		// nie zadajemy sobie obrazen - na czas strzalu wylaczamy kolizje
		int iFlags = 0;
		if (m_OwnerMesh != null)
		{
			iFlags = m_OwnerMesh.GetFlags();
			m_OwnerMesh.ClearFlag(EFlags._BLOCK_TRACE);
		}

		float fDist = super.FireBullet(vBarrel, vDir);
		
		if (m_OwnerMesh != null)
			m_OwnerMesh.SetFlags(iFlags);
		
		return fDist;
    }
    
    void SetShakeImpulse()
    {
        vShakeImpulse.Set( fShakeImpulseForce/2f * RandomFloat(-1,2), 
                           RandomFloat(1f) > 0.5f ? fShakeImpulseForce : -fShakeImpulseForce, 
                           RandomFloat(1f) > 0.5f ? fShakeImpulseForce : -fShakeImpulseForce);
    }
/*    
    float FireBullet(Vector vBarrel, Vector vDir)
    {
        float fDistance = 1e10f;
        
         // wyliczamy, pobieramy, ustalamy kierunek w ktory strzelamy
        Vector vEnd = new Vector(vDir);
        vEnd.Mul(fRange);
        vEnd.Add(vBarrel);

        //CrashLog("FIRE ! from" + vBarrel + " to "+ vEnd + "\n");

        Collision stCollTerrain = m_OwnerMesh.TraceTerrain(vBarrel, vEnd);
        if (stCollTerrain != null)
        {
            fDistance = stCollTerrain.fDistance;
            // trafienie w ziemie
            //Log("   Trafiona ziemia w punkcie" + vEnd + "\n");
        }

        Collision stCollTrees = m_OwnerMesh.TraceTrees(vBarrel, vEnd);
        if (stCollTrees != null)
        {
            fDistance = stCollTrees.fDistance;
            // trafienie w drzewo
            //Log("   Trafione drzewo w punkcie" + vEnd + "\n");
        }

        Collision stCollObjects = m_OwnerMesh.TraceObjectsExclude(vBarrel, vEnd, (MeshObject) m_OwnerMesh);
        if (stCollObjects != null)
        {
            if (stCollObjects.fDistance < fDistance) fDistance = stCollObjects.fDistance;
//            CrashLog("   Trafiony obiekt <" + stCollObjects.Obstacle.getClass().getName() +">w punkcie" + vEnd + 
//                " " + stCollObjects.ObstacleElement + "\n");
            //((MeshObject)stCollObjects.Obstacle).RotateElement(stCollObjects.ObstacleElement, new Vector(0, 1, 0), 45.f);

            // trafilismy obiekt
            if( stCollObjects.Obstacle != null )
            {
                // odbieramy energie Actorowi
                Vector vSpeed=new Vector(vDir);
                vSpeed.Mul(fBulletSpeed);
                
                Vector vSpeedTmp = new Vector(vSpeed);//bo cObstacle.TakeDamage() normalizuje wektor 
                
                // jako nDamageType wysylany jest numer MeshElementu jaki zostal trafiony
                int iBoneId = ((MeshObject)stCollObjects.Obstacle).GetBoneIDFromMeshElem(stCollObjects.ObstacleElement);
                //w sieci potrzebuje dostac gracza jako assasina a nie jeepa...
                ChromeActor cOwner = GetModule() instanceof ModuleNet ? Owner : (ChromeActor) m_OwnerMesh;
                stCollObjects.Obstacle.TakeDamage(fDamage, fPhysicsSimDamage, cOwner, vEnd, vSpeed, iBoneId, EnumDamageType._BULLET);
                
				CutBodyPart((MeshObject)stCollObjects.Obstacle, stCollObjects.ObstacleElement, vSpeedTmp);
            }
			
            //zapamietujemy ostatnio trafiony controlObject
            oLastHit = stCollObjects.Obstacle;

        }
        else
			oLastHit = null;

        // gdy byla jakakolwiek kolizja to dodajemy efekt
        if ( (stCollTerrain != null) || (stCollObjects != null) || (stCollTrees != null) )
        {
            if (sParticleSystem != null)
                ExecuteParticleSystem(sParticleSystem, vEnd, Vector.Up);
                                      
            m_OwnerMesh.MakeNoiseOnPosition(vEnd, fNoiseHit, Pawn._NOISE_BULLET_HIT);

            ChromeModule cModule = (ChromeModule)GetModule();
            float fCameraDistance = cModule.GetCameraDistance(vEnd);
            
            if (stCollObjects != null)
            {
                int iMaterial = stCollObjects.nMaterial;
                if (iMaterial < 0)
                    iMaterial = 0;
				Weapon.StaticFxAndSoundManager((MeshObject) m_OwnerMesh,
										  iMaterial,vEnd,stCollObjects.vNormal, vDir, 
										  stCollObjects.Obstacle, stCollObjects.ObstacleElement,
										  eBulletType, sFXHitName, fCameraDistance );                        
            }
            else
            {
                // nie bylo kolizji z obiektem dynamicznym
                if (stCollTrees != null)
                {
                    // kolizja z drzewami
                    Weapon.StaticFxAndSoundManager((MeshObject) m_OwnerMesh,
    //powinno byc 1 bo to drzewo
                                              0,vEnd, stCollTrees.vNormal, vDir,
                                              null, 1,
                                              eBulletType, sFXHitName, fCameraDistance );
                }
                else
                {
                    // kolizja z terenem
					Weapon.StaticFxAndSoundManager((MeshObject) m_OwnerMesh, 
											  0, vEnd, stCollTerrain.vNormal, vDir,
											  null, 0,
											  eBulletType, sFXHitName, fCameraDistance );
                }
            }
        }
        
        
        return fDistance;
    }
*/

    
    void MessageLongDelay(float fTime)
    {
        
    }
	
	public float GetBaseAccuracy()
	{
		return fBaseAcc;
	}
	
	public float GetAimAccChange()
	{
		return fAimAcc;
	}
	
	public void SetAimMultiplier(float fMul)
	{
		fAimMultiplier = fMul;
	}
	
	public void SetFXHitName(String sFXHitName)
	{
		this.sFXHitName = sFXHitName;
	}
    
    public void SetShotSoundRange(float fMin, float fMax)
    {
        fMinShootSound = fMin;
        fMaxShootSound = fMax;
    }

    public Vector GetCannonToParentPositionDiff()
    {
        return new Vector(m_vCannonToParentDiff);
    }
	
    /** Metoda sluzy przelaczaniu obiektu na inny level. Nalezy ja pokryc gdy jeden z itemow
     * ma dane zalezace od levlu !
     */
    void Acquire(Module mod, Pawn owner)
    {
		// nic nie rb, to nie moe przenosi si pomidzy level'ami !!!
	}	
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
	void SaveMeshElement(FileChunk cFC, int nMeshElementID)
	{
        cFC.SaveVector(m_OwnerMesh.GetElementForwardVector(nMeshElementID));
        cFC.SaveVector(m_OwnerMesh.GetElementUpVector(nMeshElementID));
		cFC.SaveVector(m_OwnerMesh.GetElementPos(nMeshElementID));		
	}
	
	void LoadMeshElement(FileChunk cFC, int nMeshElementID)
	{
        Vector vForward = cFC.LoadVector();
        Vector vUp = cFC.LoadVector();
		Vector vPos = cFC.LoadVector();		
		m_OwnerMesh.FromUpForwardPosElementWorld(nMeshElementID,vUp,vForward,vPos);
	}	
	
	void ReInit()
	{        
        m_nElementH = m_OwnerMesh.GetElementID(m_sElementH);
        m_nElementV = m_OwnerMesh.GetElementID(m_sElementV);
        m_nElementCenter = m_OwnerMesh.GetElementID(m_sElementCenterNew);
		
        if (m_nElementCenter == -1)
            m_nElementCenter = m_OwnerMesh.GetElementID(m_sElementCenterOld);
            
        m_nElementBarrel = m_OwnerMesh.GetElementID(m_sElementBarrel);
        m_nElementBarrelExit = m_OwnerMesh.GetElementID(m_sElementBarrelExit);
	}
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[CannonController.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_CANNON_CONTROLLER)
        {	
			super.SGLoadChunk(cFC);

			m_OwnerMesh = (ICannonMesh)cFC.LoadObjectRef();
			
			ReInit();
			
			m_CannonUser = (ChromeActor)cFC.LoadObjectRef();
			m_nOwnerSide = cFC.LoadInt();		
			m_fInitAngleV = cFC.LoadFloat();
 
			// Kat rozwarcia stozka, z ktorego wyciagane sa cele dla dzialka
			m_fTargetFindingAngle = cFC.LoadFloat();
			// Kat rozwarcia stozka, w ktorym musi znajdowac sie aktywny cel, zeby dzialko chcialo do niego strzelac
			m_fTargetHoldingAngle = cFC.LoadFloat();
    
			// Cosinusy katow rozwarcia stozkow
			m_fTargetFindingAngleCos = cFC.LoadFloat();
			m_fTargetHoldingAngleCos = cFC.LoadFloat();
		
			// aktualny cel dziala dla stanow hunting i autonomic hunting 
			m_Target = (ChromeActor)cFC.LoadObjectRef();
		
			// czy w danej chwili strzelamy (czy widzimy wroga)
			m_bClearShot = cFC.LoadBool();		
		
			m_fLongDelay = cFC.LoadFloat();
		
			// celowanie
			m_fShotDeviation = cFC.LoadFloat();
		
			// Predkosc obracania sie dzialka w poziomie [deg/s]
			m_fHorizAngSpeed = cFC.LoadFloat();
    
			// Predkosc obracania sie dzialka w pionie [deg/s]
			m_fVertAngSpeed = cFC.LoadFloat();

			// czy jest to dzialko mogace sie aktywowac / deaktywowac (z dodatkowymi elementami) */
			m_bGunAdvanced = cFC.LoadBool();
		
			// poczatkowe ustawienie lufy dzialka (dla jeepa w tyl, dla transportera w przod) */
			m_vVectorForward = cFC.LoadVector();
			m_vVectorRight = cFC.LoadVector();
			m_vVectorUp = cFC.LoadVector();
	
			m_bInManualMode = cFC.LoadBool();
		
			// czas do "rozkrecenia" dzialka
			m_fInitialFireDelay = cFC.LoadFloat();
					
			// zmienne pomocnicza 
			m_bFireAllowed = cFC.LoadBool();
			m_bAllowMethodCalled = cFC.LoadBool();		
		
			m_strOldState = cFC.LoadString();		
		
			fAimMultiplier = cFC.LoadFloat();

			// czy dzialko jest aktywne w trybie automatycznym, tzn. czy namierza sie i strzela w cel */
			m_bActiveInAutoMode = cFC.LoadBool();
		
			m_PlayerManual = (PlayerHUD)cFC.LoadObjectRef();
		
			m_fLastHorizAngle = cFC.LoadFloat();
			m_fLastVertAngle = cFC.LoadFloat();		
		
			m_vAimAtPoint = cFC.LoadVector();		
		
			// mode kamery przed wlaczeniem tego guna
			m_iLastCameraMode = (byte)cFC.LoadInt();
			// ostatni stan dzialka
			m_iOldState = cFC.LoadInt();
			
			/**************************************************/
			m_fMaxHAngle = cFC.LoadFloat();
			m_fMinVAngle = cFC.LoadFloat();
			m_fMaxVAngle = cFC.LoadFloat();	
			
			m_vForwardDelta = cFC.LoadVector();					
			m_fAngleImportance = cFC.LoadFloat();			
			m_fDistanceImportance = cFC.LoadFloat();			
			m_fForwardImportance = cFC.LoadFloat();			
			//m_fCannonVertMorphTime = cFC.LoadFloat();		    
			sParticleSystem = cFC.LoadString();			
			fFXBeamSizeX = cFC.LoadFloat();
			m_fExecuteBeamProbability = cFC.LoadFloat();
			fMinBeamDistance = cFC.LoadFloat();
			
			m_nOldRoundShots = cFC.LoadInt();
			m_fOldVertAngSpeed = cFC.LoadFloat();
			m_fOldHorizAngSpeed = cFC.LoadFloat();								
			 /**************************************************/
						
			//CrashLog("[CannonController] ATTENTION1 = <"+m_OwnerMesh.GetElementPos(m_nElementBarrelExit)+">\n");
			
			LoadMeshElement(cFC,m_nElementBarrel);
			LoadMeshElement(cFC,m_nElementBarrelExit);			
			LoadMeshElement(cFC,m_nElementCenter);
			LoadMeshElement(cFC,m_nElementH);			
			LoadMeshElement(cFC,m_nElementV);		
			
			//CrashLog("[CannonController] ATTENTION2 = <"+m_OwnerMesh.GetElementPos(m_nElementBarrelExit)+">\n");
			
			if (cFC.LoadBool())
				((ChromeModuleSingle)GetModule()).MainPlayer.Camera.m_HeavyWeapon = this;
        }
		
		cFC.delete();
    }
	    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {				
		FileChunk.Log("[CannonController.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_CANNON_CONTROLLER, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveObjectRef((MeshObject)m_OwnerMesh);						
		cFC.SaveObjectRef(m_CannonUser);
		cFC.SaveInt(m_nOwnerSide);		
		cFC.SaveFloat(m_fInitAngleV);
 
		// Kat rozwarcia stozka, z ktorego wyciagane sa cele dla dzialka
		cFC.SaveFloat(m_fTargetFindingAngle);
		// Kat rozwarcia stozka, w ktorym musi znajdowac sie aktywny cel, zeby dzialko chcialo do niego strzelac
		cFC.SaveFloat(m_fTargetHoldingAngle);
    
		// Cosinusy katow rozwarcia stozkow
		cFC.SaveFloat(m_fTargetFindingAngleCos);
		cFC.SaveFloat(m_fTargetHoldingAngleCos);
		
		// aktualny cel dziala dla stanow hunting i autonomic hunting 
		cFC.SaveObjectRef(m_Target);
		
		// czy w danej chwili strzelamy (czy widzimy wroga)
		cFC.SaveBool(m_bClearShot);		
		
		cFC.SaveFloat(m_fLongDelay);
		
		// celowanie
		cFC.SaveFloat(m_fShotDeviation);
		
		// Predkosc obracania sie dzialka w poziomie [deg/s]
		cFC.SaveFloat(m_fHorizAngSpeed);
    
		// Predkosc obracania sie dzialka w pionie [deg/s]
		cFC.SaveFloat(m_fVertAngSpeed);

		// czy jest to dzialko mogace sie aktywowac / deaktywowac (z dodatkowymi elementami) */
		cFC.SaveBool(m_bGunAdvanced);
		
		// poczatkowe ustawienie lufy dzialka (dla jeepa w tyl, dla transportera w przod) */
		cFC.SaveVector(m_vVectorForward);
		cFC.SaveVector(m_vVectorRight);
		cFC.SaveVector(m_vVectorUp);
	
		cFC.SaveBool(m_bInManualMode);
		
		// czas do "rozkrecenia" dzialka
		cFC.SaveFloat(m_fInitialFireDelay);
				
		// zmienne pomocnicza 
		cFC.SaveBool(m_bFireAllowed);
		cFC.SaveBool(m_bAllowMethodCalled);		
		
		cFC.SaveString(m_strOldState);		
		
		cFC.SaveFloat(fAimMultiplier);

		// czy dzialko jest aktywne w trybie automatycznym, tzn. czy namierza sie i strzela w cel */
		cFC.SaveBool(m_bActiveInAutoMode);
		
		cFC.SaveObjectRef(m_PlayerManual);
		
		cFC.SaveFloat(m_fLastHorizAngle);
		cFC.SaveFloat(m_fLastVertAngle);		
		
		cFC.SaveVector(m_vAimAtPoint);
		
		// mode kamery przed wlaczeniem tego guna
		cFC.SaveInt((int)m_iLastCameraMode);
		// ostatni stan dzialka
		cFC.SaveInt(m_iOldState);
		
		/*************************************************/
		cFC.SaveFloat(m_fMaxHAngle);
		cFC.SaveFloat(m_fMinVAngle);
		cFC.SaveFloat(m_fMaxVAngle);							
		
		cFC.SaveVector(m_vForwardDelta);					
		cFC.SaveFloat(m_fAngleImportance);			
		cFC.SaveFloat(m_fDistanceImportance);			
		cFC.SaveFloat(m_fForwardImportance);			
		//cFC.SaveFloat(m_fCannonVertMorphTime);		    
		cFC.SaveString(sParticleSystem);			
		cFC.SaveFloat(fFXBeamSizeX);
		cFC.SaveFloat(m_fExecuteBeamProbability);
		cFC.SaveFloat(fMinBeamDistance);
		
		cFC.SaveInt(m_nOldRoundShots);
		cFC.SaveFloat(m_fOldVertAngSpeed);
		cFC.SaveFloat(m_fOldHorizAngSpeed);					
		 /**************************************************/
		
		//CrashLog("[CannonController] ATTENTION1 = <"+m_OwnerMesh.GetElementPos(m_nElementBarrelExit)+">\n");

		SaveMeshElement(cFC,m_nElementBarrel);
		SaveMeshElement(cFC,m_nElementBarrelExit);			
		SaveMeshElement(cFC,m_nElementCenter);
		SaveMeshElement(cFC,m_nElementH);			
		SaveMeshElement(cFC,m_nElementV);
		
		//CrashLog("[CannonController] ATTENTION2 = <"+m_OwnerMesh.GetElementPos(m_nElementBarrelExit)+">\n");
		
		cFC.SaveBool(((ChromeModuleSingle)GetModule()).MainPlayer.Camera.m_HeavyWeapon == this);			
							
			
        cFC.delete();
    }	    		
	
	public void SGUpdate()
	{
		FileChunk.Log("[CannonController.SGUpdate]\n");
		
		super.SGUpdate();
		
		if (m_CannonUser != null)
		{
            m_CannonUser.UnregisterMouseAxisRequest();
            m_CannonUser.UnregisterMouseButtonRequest();			
			RegisterKeyRequest();
			RegisterMouseButtonRequest();			
		}
		else
		{
			UnregisterKeyRequest();
			UnregisterMouseButtonRequest();
		}		
	}	
    
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case MSG_CLIENT_STATE:
            LogD(" MSG_CLIENT_STATE\n");
            MsgRecvClientState();
            break;
        default:
            super.OnMessage();
        }
    }
    
    void MsgSendClientState()
    {
        if ( Role < ERole._AUTHORITY )
            return;
        MessageNew( MSG_CLIENT_STATE );
        MessagePackInt( m_OwnerMesh != null ? m_OwnerMesh.GetNetId() : -1 );
        MessageSend();
    }
    
    
    void MsgRecvClientState()
    {
        m_nOwnerMeshNetId = MessageUnPackInt();
        MessageEnd();
        
        if ( m_nOwnerMeshNetId > -1 )
            TryToInitController();
    }
    
    int m_nOwnerMeshNetId = -1;
    
    void TryToInitController()
    {
        GameObject cObject = GetObjectByNetId( m_nOwnerMeshNetId );
        if ( cObject == null )
        {
            CallMethodIn("TryToInitController",0.1f);
            return;
        }
        
        if ( cObject instanceof VehicleAttacker )
        {
            VehicleAttacker cAttacker = (VehicleAttacker)cObject;
            cAttacker.InitCannonController( this );
        }
        else 
            CrashLog(" "+this+"TryToInitController()  failed \n");
    }
    
    boolean m_bPreFiring      = false;
    boolean m_bPreFiringState = false;
    
    boolean m_bFiring       = false;
    boolean m_bFiringState  = false;
    
    public void StartFire(byte nMode)
    {
        m_OwnerMesh.FireStarted(nMode);
        m_bPreFiringState = m_bPreFiring = true;
    }
    
    public void SuperStartFire(byte nMode)
    {
        if (m_bNetModule)
        {
            if ( m_PlayerManual != null &&
                 m_PlayerManual.bNetIsOwner )
            {
                SuperStartFireDo( nMode );
            }
            else
            {
                //LogR("SuperStartFire failed\n");
            }
        }
        else
            SuperStartFireDo( nMode );
    }
    
    public void SuperStartFireDo(byte nMode)
    {
        bDisableStopFire = true;
        super.StartFire( nMode );
        bDisableStopFire = false;
        m_bFiringState = m_bFiring = true;
    }
    
    
    
    boolean bDisableStopFire = false;
    
    public void StopFire()
    {
        super.StopFire();
        
        if ( bDisableStopFire )
            return;
        
        m_bFiringState    = m_bFiring = false;
        m_bPreFiringState = m_bPreFiring = false;
        m_OwnerMesh.FireStopped();
        //LogR("StopFire()\n");
        //Thread.dumpStack();
    }
    
    public void CancelFire()
    {
        super.CancelFire();
        
        if ( bDisableStopFire )
            return;
        
        m_bPreFiringState = m_bPreFiring = false;
        m_bFiringState = m_bFiring = false;
        m_OwnerMesh.FireStopped();
        //LogR("CancelFire()\n");
        //Thread.dumpStack();
    }

    int m_nFrame = 0;
    
    
    static int m_nSetState = 0;
    static int m_nSetShortState = 0;
            
    public void ReplicationInit()
    {
        super.ReplicationInit();
        m_nSetState = NewReplicationSet( "m_bPreFiring;m_bFiring;m_fAimX;m_fAimY;m_fAimZ" );
        //dodatkowo skrocona wersja tego samego seta zadeklarujemy jeszcze raz, 
        //zeby go replikowac w innym trybie (dla bezpieczenstwa,
        //gdyby cos nie doszlo)
        m_nSetShortState = NewReplicationSet( "m_bPreFiring;m_bFiring" );
        SetReplicationSetMinPeriod( m_nSetShortState,10.0f ); 
    }
    
    public void OnReplicateServer()
    {
        super.OnReplicateServer();
        
        if ( m_PlayerManual != null )
        {
            //jezeli ktos jest przy dzialku, to dla pozostalych
            //replikujemy jego stan
            if ( ! m_PlayerManual.bNetIsOwner )
            {
                Replicate( m_nSetState );
            }    
        }
        else
        {
            //jesli nikogo nie ma,
            //to replikujemy skrocony stan, ale tylko co pewien czas.
            Replicate( m_nSetShortState );
        }
        
    }
    
    public void OnReplicateClient()
    {
        super.OnReplicateServer();
        if ( m_PlayerManual != null &&
             m_PlayerManual.bNetIsOwner )
        {
            Replicate( m_nSetState );
        }
    }
    
    float m_fAimX = 0.0f;
    float m_fAimY = 0.0f;
    float m_fAimZ = 0.0f;
}
