public class EnergyCannon extends StationaryCannon
{
    public float fChargeShootDelay = 3f;//#EnergyCannon
    
    
    int nChargeMaterialsCount = 9;
    
    int nChargeMaterial = -1;
    
    String sChargeMatPrefix = "Dzialo3Ammo0";
    
    int[] aPreloadedChargeMaterials = new int[nChargeMaterialsCount];
    
        
    EnergyCannon()
    {
        super();
        
        fFireDamage = 2000f;
        fRateOfFire = 20f;
        
        m_cMeshName = "data/meshes/ai/ckmd.3da";
        m_cAnimSeqFile = null;
        m_sWreckMeshName = "data/meshes/ai/ckmdwreck.3da";
    }
    
	void InitCannon()
    {
		super.InitCannon();

		if (m_Cannon != null)
        {
            m_Cannon.SetBeamProbability(1f);
            
            m_Cannon.SetAccuracy(1.5f, 1f);
            m_Cannon.SetBeamFX("BeamEnergy");
			m_Cannon.SetFXHitName("FXBlowEnergy");
            m_Cannon.SetCombFX("FXCombEnergy");
            
            m_Cannon.SetMinBeamDistance(0f);
            m_Cannon.SetFXSizeX(6f);
            
            ((CannonController)m_Cannon).fShakeImpulseForce = 1000;
            
            m_Cannon.SetShotSound("Data/Sounds/Weapon/EnergyFire");
        }

        for(int i=0; i<nChargeMaterialsCount; ++i)
        {
            String sChargeMat = sChargeMatPrefix + i + "_SI.mat";
            aPreloadedChargeMaterials[i] = MaterialLoad(sChargeMat);
            nChargeMaterial = MaterialGetID( sChargeMatPrefix + "0_SI.mat" );
        }
        UpdateChargeSounds();
        m_Cannon.SetParticleSystem("FXBlowEnergy");
        ReplaceOriginalMaterial(nChargeMaterial, aPreloadedChargeMaterials[nChargeMaterialsCount - 1] );
	}
    
    public void FireStarted(byte nMode)
    {
        if (GetTime() - fLastShotTime < fChargeShootDelay)//jeszcze nie naladowane
            return;
        
        m_iMode = Weapon._FIREMODE_SINGLE;
        CallMethodIn("DelayStartFire", 0);
        //CallMethodIn("DelayStartFire", fChargeShootDelay);
        //CallMethodEvery("UpdateChargeSounds", 0.01f);
        fLastShotTime = GetTime();
    }
    
    /*public void FireStopped()
    {
        super.FireStopped();

        DisableCallMethod("UpdateChargeSounds");
        DisableCallMethod("DelayStartFire");
        DetachChargeSound();
        ReplaceOriginalMaterial(nChargeMaterial, aPreloadedChargeMaterials[0] );
    }*/
    
    /*void Fire(Vector vBarrel, Vector vDir)
    {
        super.Fire(vBarrel, vDir);
        CallMethodEvery("UpdateChargeSounds", 0.01f);
    }*/
    
    public void DelayStartFire()
    {
        m_Cannon.SuperStartFire(m_iMode);
        CallMethodEvery("UpdateChargeSounds", 0.01f);
    }
    
    public void Die()
    {
        super.Die();
        
        DisableCallMethod("UpdateChargeSounds");
        DisableCallMethod("DelayStartFire");
        DetachChargeSound();
    }
    
    String m_ChargeSoundName = "Data/Sounds/Weapon/EnergyCharge";
    int m_iChargeSoundId = 0;
    float m_fMinChargeFreq = 0.7f;
    float m_fMaxChargeFreq = 2f;
    float fLastShotTime = 0f;
    
    void AttachChargeSound()
    {
        if ((m_ChargeSoundName != null) && (m_iChargeSoundId == 0) )
             m_iChargeSoundId = AttachSound(m_ChargeSoundName, 1000f, 5000f);
    }
    
    void DetachChargeSound()
    {
        if (m_iChargeSoundId != 0)
        {
            DetachSound(m_iChargeSoundId);            
            m_iChargeSoundId = 0;
        }
    }
    
    public void UpdateChargeSounds()
    {
        float fTime = GetTime() - fLastShotTime;
        if (fLastShotTime == 0f)
        {
            fLastShotTime = fTime - fChargeShootDelay;
            return;
        }
        if (fTime > fChargeShootDelay)
            fTime = fChargeShootDelay;
        
        if (m_iChargeSoundId == 0)
            AttachChargeSound();
            
        if (m_iChargeSoundId != 0)
        {
            // zmieniamy czestotliwosc
            float fFreq = m_fMinChargeFreq +
                          (m_fMaxChargeFreq - m_fMinChargeFreq) * fTime / fChargeShootDelay;
            SetSoundFreq(m_iChargeSoundId, fFreq);
        }

        int nMat = (int)((float)(nChargeMaterialsCount - 1) * (fTime/fChargeShootDelay));

        if (nMat == nChargeMaterialsCount - 1)
        {
            DetachChargeSound();
            DisableCallMethod("UpdateChargeSounds");
            //Owner.AttachOneShotSound(sSoundCharged, fMinShootSound, fMaxShootSound);
        }
        ReplaceOriginalMaterial(nChargeMaterial, aPreloadedChargeMaterials[nMat] );
        
    }

    //*********************************************************
	//					SaveGame
    //*********************************************************
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        if (m_iChargeSoundId != 0)
            DetachChargeSound();
        
		FileChunk.Log("[EnergyCannon.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_ENERGY_CANNON)
        {	
			super.SGLoadChunk(cFC);

			fChargeShootDelay = cFC.LoadFloat();
            fLastShotTime = cFC.LoadFloat();
        }
		
		cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[EnergyCannon.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_ENERGY_CANNON, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveFloat(fChargeShootDelay);
        cFC.SaveFloat(fLastShotTime);
        
        cFC.delete();
    }	
    
    public void SGUpdate()
    {
        super.SGUpdate();
        FireStopped();
    }
    
    public void OnAudioReinitialize()
    {
        
        if (m_iChargeSoundId != 0)
        {
            m_iChargeSoundId = 0;
            AttachChargeSound();
            UpdateChargeSounds();
        }
    }
}
