public interface ICannonMesh
{
    void SetFlag(int iFlag);
    void SetFlags(int iFlags);
    void ClearFlag(int iFlag);
	int GetFlags();
    int GetElementID(String sElementName);
    Vector GetElementForwardVector(int iElementID);
    Vector VectorWorldToLocal(Vector vWorldVector);
    Vector PointWorldToLocal(Vector vWorldPoint);
    Vector GetElementUpVector(int iElementID);
    void SetElementAnimType(int iElementID, byte bType, boolean bPropagate);
    void SetAnimMorphTime(float fTime);  
    void SetAnimMorphTime(String sElementName, float fTime);
    void SetAnimMorphTime(int iElementID, float fTime, boolean bPropagate);
    Vector GetElementPos(int iElementID);
    void RotateElement(int iElementID, Vector vAxis, float fAngle);    
    void RotateElementWithAnim(int iElementID, Vector vAxis, float fAngle);    
    boolean CheckTraceAbsolute(ControlObject Target, Vector vStartPosition, Vector vEndPosition);
    Vector GetForwardVector();
    Vector GetPosition();
    ControlObject [] GetObjectsInRadiusOfFlagsFromClass(Vector vPos, float fRange, int iFlags, String sClassName);
    int GetRole();
    int ExecuteFX(ControlObject ctrlObj, int nMeshElement, String sFXName, Vector pos);
    int ExecuteFX(ControlObject ctrlObj, String sMeshElement, String sFXName, Vector pos);
    int ExecuteFX(String sFXName, Vector vPos, Vector vDir);
    void PlaySound(String sSoundName, float fMin, float fMax);
    void MakeNoise(float fRange, int iNoiseType);
    Collision TraceTerrain(Vector vStart, Vector vEnd);
    Collision TraceTrees(Vector vStart, Vector vEnd);
    Collision TraceObjectsExclude(Vector vStart, Vector vEnd, ControlObject cObjToExclude);
    void MakeNoiseOnPosition(Vector vPos, float fRange, int iNoiseType);
    void FromUpForwardPosElementWorld(int iMeshElementID, Vector vUp, Vector vForward, Vector vPos);
    int GetNetId();
    void SetFXSizeX(float fSizeX);
    void SetFXSizeY(float fSizeY);
    void SetFXZero(float fZero);
    void SetFXPosY(float fPosY);
    void FireStarted(byte iMode);
    void FireStopped();
    Vector GetPositionVectorVolatile();
    
    void SetFireParams(int nShots, float fRateOfFire, float fLongDelay, float fRange, float fDamage);
    
    void GetRenderPosition(Vector vRenderPos, Vector vRenderDir, Vector vRenderRight);
}
