public class RocketCannon extends StationaryCannon
{
    RocketCannon()
    {
        super();
        
        fFireDamage = 1500f;
        fRateOfFire = 30f;
        fFireRange = 10000f;
        
        m_cMeshName = "data/meshes/ai/ckmb.3da";
        m_cAnimSeqFile = null;
        m_sWreckMeshName = "data/meshes/ai/ckmbwreck.3da";
    }
        
	void InitCannon()
    {
        // inicjalizujemy guna
        m_Cannon = (ICannonController) CreateObject("RocketCannonController");
        m_Cannon.InitController(this);
        
		m_Cannon.SetHorizAngSpeed(500f);
		m_Cannon.SetVertAngSpeed(500f);
        m_Cannon.SetFireParams( nRoundShots, fRateOfFire, fLongDelay, 
							    fFireRange, fFireDamage );
		
		// ustalenie rozrzutu broni
        m_Cannon.SetAccuracy(2f, 1.5f);

		// ustalenie katow dla stationary cannon
		m_Cannon.SetTargetFindingAngle(m_fMaxHAngle);
		m_Cannon.SetMaxHorizAngle(m_fMaxHAngle);
		m_Cannon.SetMinVertAngle(m_fMinVAngle);
		m_Cannon.SetMaxVertAngle(m_fMaxVAngle);

        m_Cannon.SetInitialFireDelay(m_fShootVisibleDelay);
    }
    
    public void FireStarted(byte nMode)
    {
        m_Cannon.SuperStartFire(nMode);
    }
}
