public class StationaryCannon extends ChromeActor implements ICannonMesh, ISeatVehicle, iact_EnableDisable
{
    static boolean sm_bDisableInNetGame = true;
    
    /** Strzelajace dzialko */
    ICannonController m_Cannon = null;
	
	StationaryCannonController m_Controller = null;

	/** ilosc strzalow w serii */
    public int nRoundShots = 12;//#StationaryCannon
    /** czestotliwosc, ilosc strzalow na minute */
    public float fRateOfFire = 600f;//#StationaryCannon
    /** czas pomiedzy seriami */
    public float fLongDelay = 3f;//#StationaryCannon
    /** zasieg strzalu */
    public float fFireRange = 5000f;//#StationaryCannon
    /** sila razenia */
    public float fFireDamage = 100f;//#StationaryCannon

    public float m_fMaxHAngle = 45f;//#StationaryCannon
    public float m_fMinVAngle = -30f;//#StationaryCannon
    public float m_fMaxVAngle = 30f;//#StationaryCannon

	/** czas od zauwazenia przez dzialko goscia do strzalu */
	public float m_fShootVisibleDelay = 0.5f;//#StationaryCannon

	/** czy z dzialka strzela sie z kamery, czy trzeba na niego wsiasc */
	boolean m_bIsCameraCannon = true;//#StationaryCannon
	/** czy w tej chwili dzialko jest kontrolowane przez kogos */
	public boolean m_bIsBeingControlled = false;
	/** pawn, ktory kontroluje dzialko ciezkie (z siedzeniem) */
	public Pawn m_Owner = null;
	
	/** nazwa miejsca do siedzenia (dla dzialka z siedzeniem oczywiscie) */
	public String m_sSeatElement = "operator";
//	/** numerek miejsca do siedzenia */
//	public int m_nSeatElementID = -1;
	/** jezeli jest miejsce do siedzenia, w wektorach zapamietujemy pozycje sprzed siadania */
	Vector m_vStartPosition = null;
	Vector m_vStartDir = null;
    
    /** Parametry kamery */
    float m_fCameraOverGunHeight =  90.0f; 
    float m_fCameraOverGunBack   = 110.0f; 

	float m_fAimFOV = 60f;
	float m_fOldFOV = 82f;
    
    int m_iRevolvingBarrel = -1;
	
    String m_cMeshName = "data/meshes/ai/ckmc.3da";
    String m_cAnimSeqFile = "data/meshes/ai/ckmc.scr";

    float _MAX_ANGLE_SPEED = 1080f;
    float _ANGLE_ACCEL = 1550f;
    float m_fCurrAngle = 0f;
    float m_fCurrAngleAccel = 0f;
    float m_fCurrAngleSpeed = 0f;
    float m_fLastUpdateTime = 0f;
    boolean m_bFiring = false;
    byte m_iMode = 0;

    String sBlowFX = "FXBlowWalker";
    
    {
        fDamageThreshold = 100f;
        fHealth = 500f;
        bIsAITarget = true;
    }

    //TODO: tymczasowe, do szybkiego buila
    boolean m_bDisabled = false;

    String m_sWreckMeshName = "data/meshes/ai/ckmcwreck.3da";
    MeshObject m_Wreck = null;
    boolean m_bWreckVisible = false;
    
	void OnCreate()
    {
        LoadMesh(m_cMeshName);
        if (m_cAnimSeqFile != null)
            InitAnimSeqFile(m_cAnimSeqFile);
        
        super.OnCreate();
		
		bSG = true;
		
		InitCannon();

        DeleteAllSeatsInfos();
        
        SeatInfo seatInfo = new SeatInfo(this, m_sSeatElement, EPassengerRole._VEHICLE_DRIVER,
                                         EGetInOutAnimType._UNKNOWN, new Vector(150, 0, 0), false);
        seatInfo.m_fBeginPosRadius = 300f;
        if (GetModule() instanceof ModuleNet && sm_bDisableInNetGame)
        {
            m_bDisabled = true;
        }
        else
            AddSeatInfo( seatInfo );

		SetTraceCollType(ECollTraceFlags._HULL);
        SetCollType(ECollFlags.OBJCOL_TYPE_PERFACEOBJECT);
        SetFlag(EFlags._CAST_SHADOWS | EFlags._BLOCK_TRACE);
        SetFlag(EFlags._BLOCK_MOVE);
        
        ClearFlag(EFlags._BLOCK_PARTICLES);
        
        // wylaczamy odkladanie splatow krwi
        ClearFlag(EFlags._FXPARTICLE_COLLISION);

        ClearFlag(EFlags._NO_ANIMATION);
        ClearFlag(EFlags._NO_ANIMATION_REFRESH);
        m_iRevolvingBarrel = GetElementID("lufa_obrotowa");
        if (m_iRevolvingBarrel != -1)
        {
            SetElementAnimType(m_iRevolvingBarrel, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
            SetAnimMorphTime("lufa_obrotowa", 0f);
        }
        
        SetLighting(true);
        
        bExtendedExecutionMode = true;
        
        CreateWreck();
	}
	
	public void OnPostCreate()
	{
		// jezeli nie ma kontrolera do tego dzialka, jest to dzialko stacjonarne
		if (m_Controller == null)
			m_bIsCameraCannon = false;
	}

    public Vector GetPointToLookAt(int nPoint)
    {
        Vector vReturn = GetPosition();
        vReturn.fY += 100f;
        return vReturn;
    }
	
	void InitCannon()
    {
        // inicjalizujemy guna
        m_Cannon = (ICannonController) CreateObject("CannonController");
        m_Cannon.InitController(this);
        
		m_Cannon.SetHorizAngSpeed(500f);
		m_Cannon.SetVertAngSpeed(500f);
        m_Cannon.SetFireParams( nRoundShots, fRateOfFire, fLongDelay, 
							    fFireRange, fFireDamage );
		
		// ustalenie rozrzutu broni
        m_Cannon.SetAccuracy(3.5f, 2f);

		// ustalenie katow dla stationary cannon
		m_Cannon.SetTargetFindingAngle(m_fMaxHAngle);
		m_Cannon.SetMaxHorizAngle(m_fMaxHAngle);
		m_Cannon.SetMinVertAngle(m_fMinVAngle);
		m_Cannon.SetMaxVertAngle(m_fMaxVAngle);

        m_Cannon.SetInitialFireDelay(m_fShootVisibleDelay);
    }
	    
                              
	/** rozpoczecie kontrolowania cannona przez playera (z controlera, nie bezposrednio)
	 */
	boolean StartControllingCannonByPlayer(Pawn newOwner)
	{
		if (m_bIsBeingControlled)
			return false;
		m_bIsBeingControlled = true;
		m_Owner = newOwner;

		if (newOwner instanceof Player)
			m_fOldFOV = ((Player) newOwner).Camera.GetFOV();
		
		m_Cannon.StartManualControl(newOwner, m_fCameraOverGunHeight, m_fCameraOverGunBack,
                                    m_fCameraOverGunHeight, m_fCameraOverGunBack,
									m_fOldFOV, m_fAimFOV,
									false);
		if (newOwner instanceof Player)
			((Player) newOwner).ShowPlayer(false);
		return true;
	}
	
	/** rozpoczecie kontrolowania cannona przez playera (bezposrednio)
	 */
    public void Execute(Actor executor)
    {
        if ( m_bDisabled )
            return;
        super.Execute(executor);

        if (executor instanceof Pawn)
        {
            Pawn pawn = (Pawn) executor;

            pawn.PrepareToGetIn(m_SeatInfo);
            if (m_SeatInfo.GetReserver() == pawn)
                pawn.GetIn(m_SeatInfo);
            else
                CrashLog("[StationaryCannon.Execute] Seat not reserved for executor!\n");
        }
    }
	

    public void StartExecution(Actor executor)
    {
        if ( m_bDisabled )
            return;
        
        if (!bExtendedExecutionMode)
        {
            Execute(executor);
            return;
        }

		Pawn pawn = null;
		
		if (executor instanceof Pawn)
		{
			pawn = (Pawn) executor;
		}
		else
			return;

		if (pawn.GetSeat().GetOccupant() == null)
		{
			if (pawn.GetSeat().GetReserver() == executor)
			{
				// wsiadamy - tworzymy dynamicznie tablice akcji
				Vector vLocalStartPos = pawn.GetSeat().GetStartLocalPos();
				Vector vLocalStartDir = pawn.GetSeat().GetStartLocalDir();
				Vector vLocalEndPos = pawn.GetSeat().GetSeatLocalPos();
				Vector vLocalEndDir = pawn.GetSeat().GetSeatLocalDir();

				aExecutionSteps = new ExecutionInfo[]
									 {
                                     new ExecutionInfo(EnumExecuteMode._MOVE_TO, _IEM_EXECUTE, 
                                     vLocalStartPos, vLocalStartDir),
                                     new ExecutionInfo(EnumExecuteMode._GET_IN, _IEM_NONE,
                                     vLocalEndPos, vLocalEndDir),
									 };
				InitExecutionActions();
			}
		}
		else
		if (pawn.GetSeat().GetOccupant() == executor)
		{
            // wysiadamy
			Vector vLocalStartPos = pawn.GetSeat().GetStartLocalPos();
			Vector vLocalStartDir = pawn.GetSeat().GetStartLocalDir();
			aExecutionSteps = new ExecutionInfo[]
                                 {
                                 new ExecutionInfo(EnumExecuteMode._GET_OUT, _IEM_NONE, 
                                 vLocalStartPos, vLocalStartDir),
								 };
			InitExecutionActions();
		}
		
        ExecutionInfo currentExecutionInfo = null;
        if (aExecutionSteps != null && aExecutionSteps.length > 0)
            currentExecutionInfo = GetFirstValidExecutionInfo(aExecutionSteps[0]);
        executor.TriggerObjectNotification(this, currentExecutionInfo);
    }
    
	String GetTip()
    {
        if ( m_bDisabled )
            return "&Stationary_cannon_Cannot_Use&";
        return "&Stationary_cannon_Use&";
    }

	/** skonczenie kontrolowania cannona przez playera (posrednio)
	 */
	void StopControllingCannonByPlayer()
	{
        if (m_Owner == null)                 
            return;                          
        
        UnregisterKeyRequest();
		UnregisterMouseButtonRequest();
        // tego tu byc nie moze !!! przeciez obsluga inputow playera jest w stanach w playertriggered !!!
        //m_Owner.RegisterKeyRequest();        
        //m_Owner.RegisterMouseAxisRequest();  
        //m_Owner.RegisterMouseButtonRequest();

		if (m_Owner instanceof Player)
		{
            if (!m_Owner.bDead)
            {
			    ((Player) m_Owner).ShowPlayer(true);
            }
			((Player) m_Owner).Camera.SetFOV(m_fOldFOV);
		}
		
        m_Cannon.StopManualControl();
		
		m_bIsBeingControlled = false;
		m_Owner = null;
	}

	public void Die()
	{
		if (m_Controller != null)
		{
			// wylaczamy sterowanie kontrolerem - tylko player steruje kontrolerem
			m_Controller.StopControllingByPlayer();
			m_Controller.CannonDestroyed();
		}
		else
		{
            Vector vNormal = GetForwardVector();
            vNormal.fY -= 0.2f;
            vNormal.Negate();
            Vector vCollPoint = GetPosition();
            vCollPoint.fY += 100f;

            if (m_Owner == null)
			{
                if ((m_SeatInfo.GetOccupant() != null))
                {
                    if ( (m_SeatInfo.GetOccupant().bDead) && (m_SeatInfo.GetOccupant() instanceof NewAI) )
                        ((NewAI) m_SeatInfo.GetOccupant()).GetController().VehicleDestroyed(vCollPoint, vNormal);
                }
                    
				if (m_bIsBeingControlled)
				{
					// dzialkiem steruje wirtualne AI
					StopControllingByAI();
                    
				}
			}
			else
			{
                m_Owner.TakeDamage(m_Owner.fHealth, 1000f, m_Owner, 
                                   vCollPoint, vNormal,
                                   EBones._NON_BONE, EnumDamageType._BLAST);
                
				if (m_Owner instanceof Player)
                {
                    m_Owner.GetOut();
					StopControllingCannonByPlayer();
                }
				else
                {
					StopControllingByAI();
                }
			}
		}
		
		super.Die();
		
        ExecuteFX(sBlowFX, GetPosition(), Vector.Up);
        ExecuteParticleSystem(sBlowFX, GetPosition(), Vector.Up);
        
        PlaySound("Data/Sounds/Weapon/GrenadeExplosion");
        
		DeactivateOnModuleAlways();
		EnableRendering(false);

        if (m_Cannon != null)
            m_Cannon.Die();

        DetachCannonSound();
        
        CallMethodIn("DetachFXes", 10f);
        
        ShowWreck();
	}
    
    public void DetachFXes()
    {
        DeleteAttachedFXes();
    }
	
	/** rozpoczecie kontrolowania cannona przez AI (zywego)
	 */
	public boolean StartControllingByAI(Pawn ai)
	{
		if (m_bIsBeingControlled)
			return false;
		m_bIsBeingControlled = true;
		m_Owner = ai;
		
		m_Cannon.StartAutonomicHuntingByUser(ai);
		
		return true;
	}
	
	public void StopControllingByAI()
	{
		m_Cannon.StopAutonomicHunting();
		
		m_bIsBeingControlled = false;
		m_Owner = null;
	}

    /** Metoda wolana po przyjsciu zdarzenia act_Enable */
    public void Enable()
	{
		m_Cannon.ActivateInAutoMode(true);
	}
    
    /** Metoda wolana po przyjsciu zdarzenia act_Disable */
    public void Disable()
	{
		m_Cannon.ActivateInAutoMode(false);
	}
    
    /** Metoda sprawdza czy obiekt jest wlaczony czy wylaczony */
    public boolean IsEnabled()
	{
		return m_Cannon.IsActiveInAutoMode();
	}
	
/*DEL    
	public void TryToSeatDown()
	{
		m_vStartPosition = null;
		m_vStartDir = null;
		
		if (m_Owner == null)
			return;
		if (m_nSeatElementID == -1)
			return;
		
		m_vStartPosition = m_Owner.GetPosition();
		m_vStartDir = m_Owner.GetForwardVector();
		m_Owner.FromUpForwardPos(Vector.Up, GetForwardVector(), GetElementPos(m_nSeatElementID));
		m_Owner.SetPhysicsActive(false);
		AttachChildAndKeepWorldPos(m_Owner, m_nSeatElementID);
	}
	
	public void TryToStandUp()
	{
		if (m_vStartPosition == null)
			return;
		if (m_Owner == null)
			return;
		m_Owner.FromUpForwardPos(Vector.Up, m_vStartDir, m_vStartPosition);
		m_Owner.SetPhysicsActive(true);
		
		DetachChild(m_Owner);
	}
*/	
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
		if (bKeyState)
		{
			if (nKeyCode == EGameControl.ACTION)
                if (m_Owner != null)
                    m_Owner.GetOut();
		}
	}
	
    public void OnInputMouseButton(int nButton, int nState)
    {
        CallOnInputKey(nButton, nState, '0');
    }
    
    public boolean IsActive(ControlObject Activator)
	{
		if (m_bIsCameraCannon)
			return false;
		
        if (m_SeatInfo.GetOccupant() != null)
            return false;
        
        return !m_bIsBeingControlled;
	}
	
	public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation,
							 Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
	{
        // powiadom przeciwnika, ze trafil
        if (Assassin instanceof ChromeActor)
            ((ChromeActor)Assassin).NotifyHit(this, nDamageType);

        Damage(fDamage, nDamageType);
	}
	
	void TakeDamage(float fDamage)
	{
		OnTakeDamage(fDamage, fDamage, null, null, null, 0, EnumDamageType._BULLET);
	}
    
    
    ///////////////////////////////////////////////////////////////////////////////
    // wsiadanie / wysiadanie
    ///////////////////////////////////////////////////////////////////////////////

    SeatInfo m_SeatInfo = null;
    
    /** dodanie informacji o nowym siedzeniu */
	public void AddSeatInfo(SeatInfo info)
	{
		if (info != null)
			m_SeatInfo = info;
	}
	
	/** usuniecie informacji o wszystkich siedzeniach */
	public void DeleteAllSeatsInfos()
	{
		m_SeatInfo = null;
	}
	
	/** pobranie informacji o siedzeniu danego typu */
	public SeatInfo GetFirstFreeSeat(int nPassengerRole)
	{
        if (!m_SeatInfo.IsOccupied() && 
            m_SeatInfo.GetReserver() == null)
            return m_SeatInfo;
		return null;
	}
	
	int GetFreeSeatsNum()
	{
        if (!m_SeatInfo.IsOccupied() &&
            m_SeatInfo.GetReserver() == null)
            return 1;
        else
            return 0;
	}
	
	public SeatInfo[] GetFreeSeats()
	{
        if (m_SeatInfo == null || m_SeatInfo.IsOccupied())
			return null;
		
        SeatInfo tab[] = new SeatInfo[] { m_SeatInfo };
		return tab;
	}
	
	public SeatInfo[] GetSeats()
	{
        if (m_SeatInfo == null)
            return null;
		
        SeatInfo tab[] = new SeatInfo[] { m_SeatInfo };
		return tab;
	}
	
	/** pobranie pierwszego obiektu zajmujacego miejsce w roli nPassengerRole */
	public Pawn GetFirstOccupant(int nPassengerRole)
	{
        return m_SeatInfo.GetOccupant();
	}
	
	/** zwraca ilosc obiektow zajmujacych miejsca w podanej roli */
	int GetOccupantsNum(int nPassengerRole)
	{
        if (m_SeatInfo.IsOccupied())
            return 1;
        else
            return 0;
	}
	
	/** zwraca ilosc wszystkich obiektow zajmujacych jakies miejsca */
	int GetAllOccupantsNum()
	{
        if (m_SeatInfo.IsOccupied())
            return 1;
        else
            return 0;
	}
	
	/** zwraca wszystkie obiekty, ktore zajmuja miejsca w danej roli */
	public Pawn[] GetOccupants(int nPassengerRole)
	{
        if (m_SeatInfo.IsOccupied())
        {
            Pawn[] tab = new Pawn[] { m_SeatInfo.GetOccupant() };
            return tab;
        }
        return null;
	}
	
	/** zwraca wszystkie obiekty, ktore zajmuja miejsca */
	public Pawn [] GetAllOccupants()
	{
        if (m_SeatInfo.IsOccupied())
        {
            Pawn[] tab = new Pawn[] { m_SeatInfo.GetOccupant() };
            return tab;
        }
        return null;
	}
	
	/** czy w pojezdzie znajduje sie aktor */
	public SeatInfo GetSeatOccupiedBy(Pawn actor)
	{
        if (m_SeatInfo.GetOccupant() == actor)
            return m_SeatInfo;
        else
            return null;
	}
    
    public SeatInfo GetSeatReservedBy(Pawn actor)
    {
        if (m_SeatInfo.GetReserver() == actor)
            return m_SeatInfo;
        else
            return null;
    }

    float _CORRECTION = 150f;
    /** Matoda zwraca miejsce kolo pojazdu gdzie moze obiekt wysiasc */ 
    public Vector GetCheckedPosToGetOut(SeatInfo info)
    {
		if (info.GetOccupant() == null)
			return info.GetStartPos();

		int iFlags = GetFlags();
        ClearFlag(EFlags._BLOCK_MOVE);
        
        Vector vPos = CanGetOutToPos(info, info.GetStartPos());
        
        if (vPos != null)
        {
            SetFlags(iFlags);
            return vPos;
        }
        
        Vector vExtents[] = { new Vector(), new Vector(), new Vector(), new Vector() };
        GetMeshExtents(vExtents[0], vExtents[1]);
        
        vExtents[2].Set(vExtents[0]);
        vExtents[2].fZ = (vExtents[1].fZ + vExtents[0].fZ) / 2f;
        vExtents[2].fX -= _CORRECTION;
        
        vExtents[3].Set(vExtents[1]);
        vExtents[3].fZ = vExtents[2].fZ;
        vExtents[3].fX += _CORRECTION;
        
        vExtents[0].fX = (vExtents[3].fX + vExtents[2].fX) / 2f;
        vExtents[0].fZ -= _CORRECTION;
        
        vExtents[1].fX = vExtents[0].fX;
        vExtents[1].fZ += _CORRECTION;
        
        for (int i = 0; i < vExtents.length; i++)
        {
            vExtents[i] = PointLocalToWorld(vExtents[i]);
            vExtents[i].fY = info.GetSeatPos().fY;
        }
            
        for (int i = 0; i < vExtents.length; i++)
        {
            vPos = CanGetOutToPos(info, vExtents[i]);
            if (vPos != null)
            {
                SetFlags(iFlags);
                return vPos;
            }
        }
        
        SetFlags(iFlags);
        
        Vector vMin = new Vector();
        Vector vMax = new Vector();
        GetMeshExtentsInWorld(vMin, vMax);
        vPos = GetPosition();
        vPos.fY += Math.abs(vMax.fY - vMin.fY) + 10f;
        return vPos;
    }
    
    float _GET_OUT_TOLERANCE = 0.2f;
    float m_fDownTestVectorLen = -300f;
    
    Vector CanGetOutToPos(SeatInfo info, Vector vPos)
    {
        if (GetTerrainType(vPos.fX, vPos.fZ) == 0)
            return null;
        
        Vector vMove = new Vector(vPos);
        vMove.Sub(info.GetSeatPos());
        vMove.fY = 0;
        float fMoveLen = vMove.Len();
        
        // stara pozycja occupanta
        Vector vOldOccupantPos = info.GetOccupant().GetPosition();
        info.GetOccupant().SetPositionWorld(info.GetSeatPos());
        
        info.GetOccupant().MoveByEllipsoid(vMove);
        if (vMove.Len() < fMoveLen * (1f - _GET_OUT_TOLERANCE))
        {
            info.GetOccupant().SetPositionWorld(vOldOccupantPos);
            return null;
        }
        
        Vector vStart = new Vector(info.GetSeatPos());
        vStart.Add(vMove);
        
        vMove = new Vector(0f, m_fDownTestVectorLen, 0f);
        info.GetOccupant().SetPositionWorld(vStart);
        if (info.GetOccupant().MoveByEllipsoid(vMove))
        {
            info.GetOccupant().SetPositionWorld(vOldOccupantPos);
            return null; // nie mozna obiektu postawic na ziemi
        }
        info.GetOccupant().SetPositionWorld(vOldOccupantPos);
        
        vStart.Add(vMove);
        return vStart;
    }
	
    public void TurnOffPassengersCollisions()
    {
        if (m_SeatInfo == null)
            return;
		if (m_SeatInfo.IsOccupied())
            m_SeatInfo.GetOccupant().ClearFlag(EFlags._COLLISION);
    }
    
    public void TurnOnPassengersCollisions()
    {
        if (m_SeatInfo == null)
            return;
		if (m_SeatInfo.IsOccupied())
            m_SeatInfo.GetOccupant().SetFlag(EFlags._COLLISION);
    }

    Vector Collision(Vector vStart, Vector vEnd, MeshObject objExclude)
    {
        Vector vCollPoint = new Vector(vEnd);
        TraceObjectsExclude(vStart, vCollPoint, objExclude);
        TraceTerrain(vStart, vCollPoint);
        TraceTrees(vStart, vCollPoint);
        return vCollPoint;
    }

    public boolean CanGetOut(SeatInfo info)
    {
        return true;
    }
    
    /** komunikat wysylany przez pawnera informujacy, ze wsiadl do pojazdu */
    public void PawnGotIn(SeatInfo cSeatInfo, Pawn pawn)
    {
		//CrashLog("PawnGotIn\n");
        if (pawn instanceof Player)
        {
            if (!StartControllingCannonByPlayer(pawn))
                return;

            RegisterKeyRequest();
			RegisterMouseButtonRequest();
            // tego tu byc nie moze !!! przeciez obsluga inputow playera jest w stanach w playertriggered !!!
				//pawn.UnregisterKeyRequest();
            //pawn.UnregisterMouseAxisRequest();
            //pawn.UnregisterMouseButtonRequest();
        }
        else if (pawn instanceof NewAI)
        {
            StartControllingByAI(pawn);
        }
		
		if (m_Owner == pawn) 
		    ChangeConflictSide(pawn.GetConflictSide());

		//TODO: Invoke
    }

    /** komunikat wysylany przez pawnera informujacy, ze wysiadl on z pojazdu */
    public void PawnGotOut(SeatInfo cSeatInfo, Pawn pawn)
    {
        if (pawn instanceof Player)
        {
            StopControllingCannonByPlayer();
        }
        else if (pawn instanceof NewAI)
        {
            StopControllingByAI();
        }
		
		ChangeConflictSide(EnumConflictSide._NEUTRAL);
    }

    public int GetRole()
    {
        return Role;
    }
    
    public void SetFXSizeX(float fSizeX)
    {
        fFXSizeX = fSizeX;
    }
    
    public void SetFXSizeY(float fSizeY)
    {
        fFXSizeY = fSizeY;
    }
    
    public void SetFXZero(float fZero)
    {
        fFXZero = fZero;
    }
    
    public void SetFXPosY(float fPosY)
    {
        fFXPosY = fPosY;
    }

    public void FireStarted(byte iMode)
    {
        m_iMode = iMode;
        m_bFiring = false;
        m_fCurrAngleAccel = _ANGLE_ACCEL;
        m_fLastUpdateTime = GetTime();
    }
    
    public void FireStopped()
    {
        m_bFiring = false;
        m_fCurrAngleAccel = -_ANGLE_ACCEL;
    }
    
    public void UpdateRotationBarrel()
    {
        UpdateCannonSounds(m_fCurrAngleSpeed);
        
        if ( (m_fCurrAngleAccel != 0f) && (m_iRevolvingBarrel != -1) )
        {
            float fT = GetTime();

            m_fCurrAngleSpeed += (fT - m_fLastUpdateTime) * m_fCurrAngleAccel;
            
            if (m_fCurrAngleSpeed <= 0)
            {
                m_fCurrAngleAccel = 0f;
                m_fCurrAngleSpeed = 0f;
            }
            if (m_fCurrAngleSpeed > _MAX_ANGLE_SPEED)
            {
                if (!m_bFiring)
                {
                    m_bFiring = true;
                    m_Cannon.SuperStartFire(m_iMode);
                    m_fCurrAngleAccel = _ANGLE_ACCEL;

                }
                m_fCurrAngleSpeed = _MAX_ANGLE_SPEED;
            }
            
            m_fCurrAngle += (fT - m_fLastUpdateTime) * m_fCurrAngleSpeed;

            RotateElementWithAnim(m_iRevolvingBarrel, Vector.Forward, m_fCurrAngle);
            
            m_fLastUpdateTime = fT;
        }
    }
    
    String m_CannonSoundName = "Data/Sounds/Weapon/JeepCannonSpin";
    int m_iSoundLoopId = 0;
    float m_fMinCannonFreq = 0.7f;
    float m_fMaxCannonFreq = 1.6f;
    
    void AttachCannonSound()
    {
        if ((m_CannonSoundName != null ) && 
            (m_iSoundLoopId == 0) )
        {
             m_iSoundLoopId = AttachSound(m_CannonSoundName, 1000f, 5000f);
        }
    }
    
    void DetachCannonSound()
    {
        if (m_iSoundLoopId != 0)
        {
            DetachSound(m_iSoundLoopId);            
            m_iSoundLoopId = 0;
        }
    }
    
    void UpdateCannonSounds(float fSpeed)
    {
        if (fSpeed == 0f && m_iSoundLoopId == 0)
            return;
        if (fSpeed == 0f)
        {
            DetachCannonSound();
            return;
        }
        if (m_iSoundLoopId == 0)
            AttachCannonSound();
            
        if (m_iSoundLoopId != 0)
        {
            // zmieniamy czestotliwosc
            float fFreq = m_fMinCannonFreq +
                          (m_fMaxCannonFreq - m_fMinCannonFreq) * fSpeed / _MAX_ANGLE_SPEED;
            SetSoundFreq(m_iSoundLoopId, fFreq);
        }
    }

    public void OnFrame()
    {
        if (!bDead)
            UpdateRotationBarrel();
    }
	
	public void ReInit()
	{
		m_iRevolvingBarrel = GetElementID("lufa_obrotowa");	
	}
    
    void CreateWreck()
    {
        if (m_Wreck != null)
            return;
        if (m_sWreckMeshName == null)
            return;
        m_Wreck = (MeshObject) CreateObject("MeshObject");
		m_Wreck.LoadMesh(m_sWreckMeshName);
		m_Wreck.SetFlag(EFlags._BLOCK_TRACE | EFlags._NO_ANIMATION | EFlags._NO_ANIMATION_REFRESH);
        m_Wreck.ClearFlag(EFlags._BLOCK_MOVE);
        m_Wreck.ClearFlag(EFlags._COLLISION);
        m_Wreck.ClearFlag(EFlags._BLOCK_PARTICLES);
        m_Wreck.SetCollType(ECollFlags.OBJCOL_TYPE_PERFACEOBJECT);
        m_Wreck.SetCollHandler(ECollFlags.OBJCOL_HANDLER_NONE);
        m_Wreck.SetTraceCollType(ECollTraceFlags._HULL);
		m_Wreck.SetLighting(true);
        m_Wreck.SetFlag(EFlags._CAST_SHADOWS);
		m_Wreck.EnableRendering(false);
    }
    
    void ShowWreck()
    {
        if (m_Wreck == null)
            return;
        
        m_Wreck.ActivateOnModule();
		m_Wreck.SetFlag(EFlags._COLLISION);
        m_Wreck.EnableRendering(true);
        m_Wreck.FromUpForwardPos(Vector.Up, GetForwardVector(), GetPosition());
        m_bWreckVisible = true;
        
        ControlObject parent = GetParent();
        if (parent != null)
            m_Wreck.AttachAsChildToAndKeepWorldPos(parent);
    }
    
    void HideWreck()
    {
        if (m_Wreck == null)
            return;
        
        m_Wreck.DeactivateOnModuleAlways();
		m_Wreck.ClearFlag(EFlags._COLLISION);
        m_Wreck.EnableRendering(false);
        m_bWreckVisible = false;
    }
    
    // implementacja metody z ICannonMesh
    public void SetFireParams(int nShots, float fRateOfFire, float fLongDelay, float fRange, float fDamage)
    {
        if (m_Cannon == null)
            return;
        m_Cannon.SetFireParams( nShots, fRateOfFire, fLongDelay, fRange, fDamage );
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[StationaryCannon.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_STATIONARY_CANNON)
        {	
			super.SGLoadChunk(cFC);
			
			ReInit();

			m_fOldFOV = cFC.LoadFloat();
			// czy w tej chwili dzialko jest kontrolowane przez kogos
			m_bIsBeingControlled = cFC.LoadBool();
			// pawn, ktory kontroluje dzialko ciezkie (z siedzeniem)
			m_Owner = (Pawn)cFC.LoadObjectRef();
			m_SeatInfo = (SeatInfo)cFC.LoadObjectRef();
			// jezeli jest miejsce do siedzenia, w wektorach zapamietujemy pozycje sprzed siadania
			m_vStartPosition = cFC.LoadVector();
			m_vStartDir = cFC.LoadVector();
			
			m_Cannon = (ICannonController)cFC.LoadObjectRef();
			
			//((ISaveGame)m_Cannon).SGLoadChunk(cFC);
            
            m_fCurrAngle = cFC.LoadFloat();
            m_fCurrAngleAccel = cFC.LoadFloat();
            m_fCurrAngleSpeed = cFC.LoadFloat();
            m_fLastUpdateTime = cFC.LoadFloat();
            m_bFiring = cFC.LoadBool();
            m_iMode = (byte) cFC.LoadInt();
			
			m_fMaxHAngle = cFC.LoadFloat();
			m_fMaxVAngle = cFC.LoadFloat();
			m_fMinVAngle = cFC.LoadFloat();			
			
			m_fCameraOverGunHeight = cFC.LoadFloat();
			m_fCameraOverGunBack = cFC.LoadFloat();
		
			m_fAimFOV = cFC.LoadFloat();											
			
			_MAX_ANGLE_SPEED = cFC.LoadFloat();
			_ANGLE_ACCEL = cFC.LoadFloat();			
			
			m_fMinCannonFreq = cFC.LoadFloat();
			m_fMaxCannonFreq = cFC.LoadFloat();			
            
			if (cFC.LoadBool())
				m_Wreck = (MeshObject) cFC.LoadObject(m_Wreck, this);
            m_bWreckVisible = cFC.LoadBool();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[StationaryCannon.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_STATIONARY_CANNON, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveFloat(m_fOldFOV);
		// czy w tej chwili dzialko jest kontrolowane przez kogos
		cFC.SaveBool(m_bIsBeingControlled);
		// pawn, ktory kontroluje dzialko ciezkie (z siedzeniem)
		cFC.SaveObjectRef(m_Owner);
		cFC.SaveObjectRef(m_SeatInfo);
		// jezeli jest miejsce do siedzenia, w wektorach zapamietujemy pozycje sprzed siadania
		cFC.SaveVector(m_vStartPosition);
		cFC.SaveVector(m_vStartDir);
		
		cFC.SaveObjectRef((ISaveGame)m_Cannon);
					
		//((ISaveGame)m_Cannon).SGSaveChunk(cFC);
    
        cFC.SaveFloat(m_fCurrAngle);
        cFC.SaveFloat(m_fCurrAngleAccel);
        cFC.SaveFloat(m_fCurrAngleSpeed);
        cFC.SaveFloat(m_fLastUpdateTime);
        cFC.SaveBool(m_bFiring);
        cFC.SaveInt((int) m_iMode);
		
		cFC.SaveFloat(m_fMaxHAngle);
		cFC.SaveFloat(m_fMaxVAngle);
		cFC.SaveFloat(m_fMinVAngle);
		
		cFC.SaveFloat(m_fCameraOverGunHeight);
		cFC.SaveFloat(m_fCameraOverGunBack);
		
		cFC.SaveFloat(m_fAimFOV);	
		
		cFC.SaveFloat(_MAX_ANGLE_SPEED);
		cFC.SaveFloat(_ANGLE_ACCEL);

		cFC.SaveFloat(m_fMinCannonFreq);
		cFC.SaveFloat(m_fMaxCannonFreq);
			        
		cFC.SaveBool(m_Wreck != null);
		if (m_Wreck != null)
			cFC.SaveObject(m_Wreck);
        cFC.SaveBool(m_bWreckVisible);
        
        cFC.delete();
    }	    				
	
	public void SGUpdate()
	{
		FileChunk.Log("[StationaryCannon.SGUpdate]\n");
		
		super.SGUpdate();
		
		((ISaveGame)m_Cannon).SGUpdate();
					
        if (m_Owner instanceof Player)
		{
			RegisterKeyRequest();
			RegisterMouseButtonRequest();			
            m_Owner.UnregisterKeyRequest();
            m_Owner.UnregisterMouseAxisRequest();
            m_Owner.UnregisterMouseButtonRequest();			
		}
		else
		{
			UnregisterKeyRequest();
			UnregisterMouseButtonRequest();
		}		
		
        m_iSoundLoopId = 0;
        
		if (m_bWreckVisible)
            ShowWreck();
	}
    
    public void OnAudioReinitialize()
    {
        if (m_iSoundLoopId != 0)
        {
            m_iSoundLoopId = AttachSound(m_CannonSoundName, 1000f, 5000f);
            UpdateRotationBarrel();
        }
        

    }
    
}

