/**Weapon bazowy. Realizuje strzelanie pojedynczymi pociskami (pistol).
 */
public abstract class Weapon extends InvObjectInst implements ipar_WeaponParams
{
    final static byte _NO_FIRING        = 0x00;
    final static byte _FIRING_PRIMARY   = 0x01;
    final static byte _FIRING_SECONDARY = 0x02;
    
    // do debugowania - wlaczenie pozwala ogladac jaki byl ostatni strzal broni
    boolean bShowFireTrace = false;
    
    boolean _bShowTestBeam = false;
    LaserPointer _cTestLaser = null;
    boolean _bTestBeamSingle = false;//jesli false to po kazdym strzale nowy beam wpp. po kazdym strzale osobny
    //////////////
    // atrybuty //
    //////////////
	boolean m_bShowFXBeam = true;
	
    boolean m_bFireModeSingle = false;

    //czy _dany typ_ broni potrafi:
    //strzelac
    protected boolean m_bFireEnabled   = true;
    //przycelowywac
    protected boolean m_bAimEnabled    = true;
    //przeladowywac
    protected boolean m_bReloadEnabled = true;
    //czy mozna strzelac "na drugi" sposob (pod prawym klawiszem myszki)
    protected boolean m_bCanSecondaryFire = false;
        
    boolean IsFireEnabled(){ return m_bFireEnabled; }
    boolean IsAimEnabled(){ return m_bAimEnabled; }
    boolean IsReloadEnabled(){ return m_bReloadEnabled; } 
    boolean CanSecondaryFire(){ return m_bCanSecondaryFire; }
    
    
    /**
     * Metoda zwraca informacje ze nalezy przeladowac bron
     * bo braklo amunicji
     */
    boolean IsReloadRequired()
    { 
        return IsReloadEnabled() && GetState() == STATE_NO_AMMO; 
    }
    
    ///////////////////////////////////////////////////////////////////////////
    // parametry broni
    ///// 
#if false
        
    /** Pogorszenie celnosci po otrzymaniu obrazen */
    //public float fInjuryAcc = 0.1f;
    
    /** Bazowa celnosc broni do ktorej dodawane sa wspolczynniki modyfikujace
     * w zaleznosci od dzialan gracza np. kucanie, przycelowanie, chodzenie */
    public float fBaseAcc = 0.5f;
    
//--------- modyfikatory celnosci
    
    /** modyfikator dodawany przy bieganiu */
    public float fRunAcc = 0.3f;
    
    /** modyfikator dodawany przy duckowaniu */
    public float fDuckAcc = 0.55f;
    
    /** modyfikator dodawany przy chodzeniu w duckowaniu */
    public float fDuckSnakeAcc = 0.55f;
    
    /** modyfikator dodawany przy lezeniu */
    public float fProneAcc = 0.4f;

    /** modyfikator dodawany przy czolganiu sie */
    public float fCrawlAcc = 0.4f;
        
    /** modyfikator dodawany przy przycelowaniu */
    public float fAimAcc   = 0.4f;

//--------- recoil
    /** Modyfikacja kierunku znoszenia podczas strzelania w plaszczyznie XY 
     * prostopadlej do kierunku strzelania (wspolrzedna Z jest ignorowana), standardowo
     * znoszenie w poziomie jest zmniejszane, 
     * nie jest to kierunek!!*/
    public Vector vRecoilShift = new Vector(0.25f, 1f, 0f);

    // Sila odrzutu po strzale w kierunku vRecoilShift
    public float fRecoilAccChange = -0.1f;
//------------------------------
#endif

    // parametry amplitudy ruszania kamera przy chodzeniu
    float fBobAmplitudeX = 2f;
    float fBobAmplitudeY = 5f;
    
    // parametry amplitudy ruszania kamera przy chodzeniu z przycelowaniem
    float fBobAmplitudeGunX = 2.2f;
    float fBobAmplitudeGunY = 5.3f;

    // parametry amplitudy ruszania modelem fpp guna przy chodzeniu
    float fBobAmplitudeAimX = 0.8f;
    float fBobAmplitudeAimY = 2f;
    
    // parametry amplitudy ruszania modelem fpp guna przy chodzeniu z przycelowaniem
    float fBobAmplitudeAimGunX = 0.9f;
    float fBobAmplitudeAimGunY = 1.75f;
    
    // okres trwania jednego zabujania kamera i bronia na widoku fpp
    float fBobPeriod = 0.5f;
    
    //Parametry dla kazdego typu broni

    /** Celnosc broni przy staniu jako podstawa obliczania wszystkich wartosci */
    public float fBaseAcc = 3.5f;//0.4f;
	
    /** Zmiana celnosci broni przy biegu i skoku*/
/*deprecated*/    public float fRunJumpAccChange = -0.4f;
	
    /** Zmiana celnosci broni przy kucaniu i leeniu */
/*deprecated*/    public float fDuckSnakeAccChange = 0.05f; // z PZ 0.15f
	
    /** Zmiana celnosci broni podczas chodzenia (chodzenie w ducku i czoganie si) */	
/*deprecated*/    public float fWalkSnakeAccChange = -0.2f; // z PZ -0.1
	
    /** Zmiana celnosci podczas przycelowania (wart. dodawana) */
    public float fAimAcc    = 1.5f;//0.35f;
	
    /** Zmiana celnosci po kazdym strzale (wart. dodawana) */
    public float fRecoilAccChange = 0.5f;
	
    /** predkosc zmiany celnosci */
    float fAccuracyChangeSpeed = 20.0f;
    
    /** Modyfikacja kierunku znoszenia podczas strzelania w plaszczyznie XY 
     * prostopadlej do kierunku strzelania (wspolrzedna Z jest ignorowana), standardowo
     * znoszenie w poziomie jest zmniejszane, 
     * nie jest to kierunek!!*/
    public Vector vRecoilShift = new Vector(0.25f, 1f, 0f);

    // wielkosc odchylenia guna po strzale
    public float fRecoilShiftChange = 0.0f;
    
    public Vector vBarrelElementPos =  new Vector(0,0,0);

    /** Sposob trzymania broni. Determinuje jakich animacji uzywac. */
    //TODO: rename na eWeaponType
    public byte nType = EWeaponType._MINIGUN;
    /** Dla shotgunow true*/
    public boolean bPumpAction = false;
    /** Ilosc odjemowanej energii po trafieniu */
    public float fDamage = 10.0f;
    /**Damage przekazywany do symulacji fizyki*/
    public float fPhysicsSimDamage = 10f;
    /** Mnoznik obrazen zadawanych przez ta bron (do szybkiej podmiany parametrow) */
    public float fDamageMult = 1.f;
    /** Zasieg broni. */
    public float fRange = 10000.0f;
    /** Szybkosc lotu pocisku broni */
    public float fBulletSpeed = 100.0f;
    /** Czestotliwosc strzelania broni */
    public float fRateOfFire = 10.0f;
    /** Rodzaj uzywanej amunicji */
    public byte eBulletType = EAmmoType._9mmShort;
    /** pojemnosc magazynka */
    public int nCapacity = 60;
    /** liczba strzalow w serii */
    public int nRoundShots = 0;    //0 - full auto, >0 - semi auto

    public float fShootLightScale = 400;
    public Vector vShootLightColor = new Vector(111f/255f,
                                                73f/255f,
                                                21f/255f);
    /** true jesli da sie bron zamontowac do stojaka */
    public boolean bMountable = false;
    
    /** okresla czy przy postrzale z danej broni maja byc urywane czesci ciala */
    public boolean bCutBodyParts = false;
    /** okresla czy przy postrzale z danej broni maja byc uruchamiany system czastek symulujacy bryzgi krwi od urywanej konczyny */
    public boolean bCutBodyPartsBlood = true && bCutBodyParts;

    public boolean bCutBodyPartsCutPart = true && bCutBodyParts;
    
    /**Halas jaki powoduje bron przy wystrzale*/
    public float fNoiseShot = 4000.0f;
    
    /**Halas jaki powoduje pocisk przy trafieniu*/
    // by MK, bylo 1000.0f
    public float fNoiseHit  = 1000.0f;
    
    /**Nazwa Fx jaki ma byc otpalany przy wystrzale(grzebien)*/
    public String sFXCombName = "FXGrzebien";
    
    /**Nazwa Fx jaki ma byc otpalany przy trafieniu*/
    public String sFXHitName = null; //chwilowo nie ma efektu
    
    /** Nazwa FXa odpalanego przy trafieniu w wode */
    public String sFXHitWater = null;//"FXWaterHit";
    
    /** Okresla ilosc dzwiekow w zestawie */
    int nSoundShoot = 1;

    /** Zakresy slyszalnosci dzwieku strzalu */
    public float fMinShootSound = 400.f;
    public float fMaxShootSound = 1000.f;
    
    /** Zakresy slyszalnosci dzwieku przeladowania */
    public float fMinReloadSound = 200.f;
    public float fMaxReloadSound = 500.f;
    
    /** Zakresy slyszalnosci dzwieku clicku bez amunicji */
    public float fMinEmptySound = 100.f;
    public float fMaxEmptySound = 400.f;
    
    /**Nazwa dzieku odpalanego przy wystrzale */
    public String sSoundShoot = "Data/Sounds/Ai/sgshot";
    
    /**Dzwike pustego magazynku */
    public String sSoundEmpty = "Data/Sounds/menu/Out_gren";
    
    /**Nazwa dzieku odpalanego przy przeladowaniu */
    public String sSoundReload = "Data/Sounds/Ai/sgshot";
    
    /**Nazwa dzieku odpalanego przy zoomowaniu */
    public String sSoundZoomIn  = "Data/Sounds/Weapon/zoomIn";
    /**Nazwa dzieku odpalanego przy zoomowaniu */
    public String sSoundZoomOut = "Data/Sounds/Weapon/zoomOut";    
    
    /** Dzwiek trafienia w wode */
    public String sSoundHitWater = "Data/Sounds/Weapon/RicWaterRifle.wav";
    
    //////////////////////////////////////////////////////////////////////////////////
    // Atrybuty broni modyfikujace strzelanie AI
    // (musza byc tutaj, zeby dostosowac zachowanie AI do posiadanej przez nie broni)
    //
    
    /** Stale oznaczajace tryby w jakich moze strzelac ta bron (pola bitowe)
     */
    final static int _FIREMODE_NONE     = 0;
    final static int _FIREMODE_SINGLE   = 1;
    final static int _FIREMODE_BURST    = 2;
    
    public int m_nFireMode = _FIREMODE_SINGLE;
    
    /** [AI] Flagi oznaczajace jakich trybow strzelania z tej broni moze uzywac AI
     *  (suma logiczna stalych _FIREMODE_*)
     */
    public int nAIFireModes = _FIREMODE_SINGLE | _FIREMODE_BURST;
    
    /** [AI] Minimalny odstep czasu pomiedzy seriami pojedynczych strzalow [s]*/
    public float fAISingleFireDelay = 0.5f;
    /** [AI] Losowy modyfikator dla fAISingleFireDelay [s]*/    
    public float fAIRandomSingleFireDelay = 2.f;
    
    /** [AI] Minimalny odstep czasu pomiedzy pojedynczymi kulami podczas pojedynczych strzalow [s]*/
    public float fAISingleBulletDelay = 0.1f;
    /** [AI] Losowy modyfikator dla fAISingleBulletDelay [s]*/    
    public float fAIRandomSingleBulletDelay = 0.3f;

    /** [AI] Minimalny odstep czasu miedzy seriami strzalow w trybie burst (jesli nic innego nie podbiega) */
    public float fAIBurstFireDelay = 0.5f;
    /** [AI] Losowy modyfikator dla fAIBurstFireDelay */
    public float fAIRandomBurstFireDelay = 1.5f;

    /** [AI] Minimalna ilosc kul w serii zlozonej z pojedynczych strzalow */
    public int nAIMinSingleFireBullets = 2;

    /** [AI] Maksymalna (max-1) ilosc kul w serii zlozonej z pojedynczych strzalow */
    public int nAIMaxSingleFireBullets = 5;
    
    /** [AI] Dlugosc trwania serii [s]*/
    public float fAIBurstTime = 0.2f;
    /** [AI] Zakres losowania dlugosci trwania serii */
    public float fAIRandomBurstTime = 1.8f;

    /** [AI] Odleglosc, ponizej ktorej AI probuje strzelac seria [cm]*/
    public float fAIMaxBurstDistance = 1500;

    /** [AI] Prawdopodobienstwo, ze AI bedzie przycelowywac przy strzelaniu [%] */
    public int nAIReadinessToAim = 99;
    
    /** [AI] Prawdopodobienstwo, ze AI przestanie przycelowywac po strzale
     *  nawet, gdy nie biegnie [%]
     */
    public int nAIReadinessToStopAiming = 100;

    /** [AI] Odleglosc do celu, zeby ai uznalo go za bliski dla tej broni
     *  (do przycelowania, dlugosci serii itp) */
    public float fAINearTargetDistance = 300.f;
    /** [AI] Odleglosc do celu, powyzej ktorej AI przycelowuje z maksymalnym mozliwym prawdopodobienstwem
     *  (do przycelowania, dlugosci serii itp) */
    public float fAIMaxAimingChanceDistance = 1000.f;
    /** [AI] Odleglosc do celu, zeby ai uznalo go za daleki dla tej broni
     *  (do przycelowania, dlugosci serii itp) */
    public float fAIFarTargetDistance = 3000.f;
    
    /** [AI] Efektywna maksymalna odleglosc, z jakiej z tej broni strzela AI */
    public float fAIEffectiveRange = 6000.f;

    /////////////////////////////////////////////////////////////////
    // CELNOSC BRONI
    
    /** Minimalne prawdopodobienstwo [%] trafienia celu przez AI (przy najmniej sprzyjajacych warunkach) */
    public float fAIMinDesiredHitRatio = 5.f;
    
    /** Maksymane prawdopodobienstwo [%] trafienia celu przez AI (przy najbardziej sprzyjajacych warunkach) */
    public float fAIMaxDesiredHitRatio = 99.f;

    /** Poprawa celnosci dla strzelania z przycelowaniem */
    public float fAIAimingAccAdd = 0.1f;
    
    /** Poprawa celnosci dla strzelania pojedynczymi kulami */
    public float fAISingleFireAccAdd = 0.1f;


    //////////////////////////////////////////////////////////////////////////
    // atrybuty wylacznie dla starego ai
    
    /** @deprecated [AI] Maksymalny rozrzut przy strzelaniu w stosunku do odleglosci [cm/cm] 
     *  dla pojedynczych strzalow
     */
    public float fAIAimingDeviation = 0.1f;
    /** @deprecated [AI] Maksymalny rozrzut przy strzelaniu w stosunku do odleglosci [cm/cm] 
     *  dla strzelania seriami w trybie burst
     */
    public float fAIBurstAimingDeviation = 0.5f;

    /** @deprecated [AI] Czas, przez jaki AI pozostaje w ukryciu, gdy ma chowacza [s]*/
    public float fAIHidingPosTime = 1.1f;
    /** @deprecated [AI] Losowy modyfikator dla fAIHidingPosTime */
    public float fAIRandomHidingPosTime = 0.5f;
    
    /** @deprecated [AI] Czas, przez jaki AI pozostaje wychylone z ukrycia, gdy ma chowacza [s] */
    public float fAIFiringPosTime = 1.1f;
    /** @deprecated [AI] Losowy modyfikator dla fAIFiringPosTime */
    public float fAIRandomFiringPosTime = 0.5f;
    
    //
    //////////////////////////////////////////////////////////////////////////
    
    
    /**Ostatnio trafiony controlObject*/
    ControlObject oLastHit;

    /** Nazwa klasy obslugujacej tego guna w widoku fpp gracza */
    String sFPPHandsClass = "FPPHands";
    
    ///////////////////////////////////////////////////////////////////////////
    // pozostale atrybuty - zmienne
    /////

    int METHOD_CheckSendClientAmmo = 0;
    int METHOD_DelayedStartFire             = 0;
    int METHOD_FireModeAuto                 = 0;
    
    /** Ilosc amunicji */
    int nAmmo;
    
    /**
     * Server
     */
    /** Ostatnio wyslany stan aminicji do klientow*/
    int nAmmoSent;
    /** Minimalny czas pomiedzy wyslaniem update'u stanu aminicji*/
    static float sm_fMinUpdateClientAmmoTime = 0.3f;


    ///////////////////////////////////////////////////////////////////////////
    // Stan broni zwracany ownerowi - flagi.
    /////
    
    //co sie stalo
    final static int STATE_SHOT            = 0x01;    //po strzale
    final static int STATE_END_OF_ROUND    = 0x04;    //koniec serii, zwykle z RELOADED
    //co jest grane
    final static int STATE_NO_AMMO         = 0x02;    //brak amunicji
    final static int STATE_STUCK           = 0x10;    //shit!    
    final static int STATE_OVERHEAT        = 0x80;    //shit2!
    final static int STATE_READY           = 0x20;    //gotowy do strzalu
    final static int STATE_ERROR           = 0x40;    //nie mozna strzelac

    /**Tryby strzelania
     */
    final static byte MODE_IDLE       = 0;    //bron w spoczynku
    final static byte MODE_SINGLE     = 1;    //single
    final static byte MODE_AUTO       = 2;    //auto ze skomplikowana animacja strzalu
    final static byte MODE_FAST_AUTO  = 3;    //brak synchronizacji animacji i strzalu
    final static byte MODE_ALT        = 4;    //alternate?

    /**Aktualny tryb strzelania */
    public byte nCurrentMode;
    /**Czy strzelamy na "drugi" sposob */
    boolean bSecondaryMode = false;

    /**Liczba pociskow wystrzelonych w tej serii */
    public int nShots = 0;

    /**Czas ostatniego strzalu */
    protected float fLastShotT = 0;
    /**Czas ostatniego strzalu pamietany na serwerze */
    protected float fLastShotOnServerTime;

    /** 1.0/fRateOfFire */
    protected float fDelay;

    /** Rodzaj przycelowania - obiekt tworzony i inicjowany
     *  w OnCreate odpowiedniej broni
     */
    public Zoomer cZoomer = null;

    
    /** Bullet weapona, wykorzystywany w przypadku granatow i pewnie rakiet
     */
    public Bullet cBullet = null;
    
    public void ClearBulletRef()
    {
        if (cBullet != null)
        {
            //LogR("ClearBulletRef " + this + " cBullet " + cBullet);
            //Thread.dumpStack();
        }
        cBullet = null;
        
    }
    
    /** Replikacja odpowiednich zestawow dla odpowiednich warunkow
     */
    public void OnReplicateServer()
    {
        super.OnReplicateServer();
        
        if ( bNetInit )
            MsgSendClientAmmo();
    }

    boolean m_bNetModule = false;
    
    
    ////////////
    // metody //
    ////////////

    Weapon()
    {
        //defaultowe wartosci MeshObject
        
        //defaultowe wartosci TriggerObject
        
        //defaultowe wartosci InventoryObject
        nInvType = EInvObjType._GUN;
        sName = "Generic Weapon";
        sTexFileName = "Data/Textures/gun1_tex.png";
        
        // wszystkie bronie sa ulozone
        vUpOnGround = new Vector(1, 0, 0);
    }

    String GetInfoString()
    {
        if (cBullet != null)
            return Text.Get("&W_D_AMMO&") + EAmmoType.GetAmmoName(eBulletType) + "\n" +
                    Text.Get("&W_D_CAPACITY&") + String.valueOf(nCapacity) + "\n" +
                    Text.Get("&W_D_DAMAGE&") + String.valueOf((int)cBullet.fBlastDamage) + "\n" +
                    Text.Get("&W_D_RANGE&") + String.valueOf((int)((cBullet.fStartSpeed * cBullet.fTimeToLive)/100)) + "m";
        else
            return  Text.Get("&W_D_AMMO&") + EAmmoType.GetAmmoName(eBulletType) + "\n" +
                    Text.Get("&W_D_CAPACITY&") + String.valueOf(nCapacity) + "\n" +
                    Text.Get("&W_D_DAMAGE&") + String.valueOf((int)fDamage) + "\n" +
                    Text.Get("&W_D_RANGE&") + String.valueOf((int)(fRange/100)) + "m";
    }
       
    
    public void OnCreate()
    {
        //ProfileIntervalStart();
        
        RegisterCallMethods();
        
        super.OnCreate();
		
		bSG = true;

        Owner=null;
        oLastHit = null;

        fDelay = 60/fRateOfFire;
        nAmmoSent = nAmmo = nCapacity;

        nCurrentMode = MODE_IDLE;

        //float fDeltaTime = ProfileIntervalEnd();
        //LogR("Weapon.OnCreate.RegisterCallMethods="+fDeltaTime+"\n");
                
        //ProfileIntervalStart();
        
        // Zainicjuj odpowiedniego zoomerka
        InitializeZoomer(); 
        
        //nCellsHeight = 1;
        //nCellsWidth = 1;
        SetLighting(true);
        
        if (_bShowTestBeam)
            CreateTestBeamLaser();
        ActivateOnModule();
        
        // pobieramy pozycje lufy
        int nBarrelElem = GetElementID("Barrel");
        if(nBarrelElem > -1)
        {
            vBarrelElementPos.Set( GetElementPos(nBarrelElem) );
        }
        
        m_bNetModule = GetModule() instanceof ModuleNet;
        
        sFXHitWater = EAmmoType.GetFXHitWater(eBulletType);
        
        //fDeltaTime = ProfileIntervalEnd();
        //LogR("Weapon.OnCreate.end="+fDeltaTime+"\n");
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        if ( cBullet != null )
             cBullet.ScheduleDeleteOnWeaponDelete();
        Owner = null;
        oLastHit = null;
        nAmmoSent = nAmmo = nCapacity;
    }
    
    void Clean()
    {
        super.Clean();
        Owner = null;
        oLastHit = null;
        nAmmoSent = nAmmo = nCapacity;
        bSendingAmmo = false;
        DisableCallMethod( METHOD_CheckSendClientAmmo );
        DisableCallMethod( METHOD_DelayedStartFire );
        DisableCallMethod( METHOD_FireModeAuto );
        
        FromUpForwardPos( Vector.Up, Vector.Forward, GetPosition() );
    }
    
    void RegisterCallMethods()
    {
        METHOD_CheckSendClientAmmo = RegisterCallMethod( "CheckSendClientAmmo" );
        METHOD_DelayedStartFire    = RegisterCallMethod("DelayedStartFire");
        METHOD_FireModeAuto        = RegisterCallMethod("FireModeAuto");
    }
    
    void CreateTestBeamLaser()
    {
        if (_cTestLaser == null)
            _cTestLaser = Tools.CreateLaserPointer(GetModule(), 
                                                   LaserPointer._BEAM_RED, 
                                                   1,//szerokosc 
                                                   fRange, //zasieg
                                                   _bTestBeamSingle);//single czy multi beams);
    }

    void UpdateTestBeamParams()
    {
        _cTestLaser.SetRange(fRange);
        _cTestLaser.m_bSingleBeam = _bTestBeamSingle;
    }
    
    /** Inicjalizacja lunetki/trybu przycelowania - musi byc przesloniete
     *  w kazdym weaponie, ktory ma jakias inna mozliwosc przycelowania (np. zoom)
     */
    void InitializeZoomer()
    {
        // Domyslny zoomer - bez powiekszenia
        /* NIE MA DOMYSLENEGO ZOOMERA!!
        cZoomer = (Zoomer)CreateObject("Zoomer");
        cZoomer.cOwner = this;
        */
    }


    /** Metoda sluzy przelaczaniu obiektu na inny level. Nalezy ja pokryc gdy jeden z itemow
     * ma dane zalezace od levlu !
     */
    void Acquire(Module mod, Pawn owner)
    {
        super.Acquire(mod, owner);
        
        if(cZoomer != null)
            mod.AcquireObjectModule(cZoomer);
        
        // gdy nie ma nowego ownera to odlaczamy weapon od dotychczasowego ownera
        if(owner==null)
        {
            DetachFromParent();
        }

        // updejtujemy handlery
        RegisterCallMethods();
        
        fLastShotT = GetTime();
        oLastHit = null;
    }
    
    /** Strzelanie z broni
     * @param v wektor kierunku w ktorym strzelamy
     */
    void Fire(Vector v)
    {
        // HACK by MK jesli gostkowy nagle wypadnie bron z reki, to
        // bron powinna przestac strzelac
        
        if ( Owner == null )
        {
            //MK: przetestowac skad to przychodzi
            LogR(" "+this+" Fire() Owner == null! (bNetIsOwner:"+bNetIsOwner+")\n");
            CancelFire();
            return;
        }
        //Log("[Weapon.Fire] Weapon fired! Prepare to die!\n");
        
        //Vector vBarrel=new Vector(GetPosition());
        Vector vBarrelLocal = GetOwnerFireOrigin();
        Vector vDir    = new Vector(v);
        vDir.Normalize();
        
        if ( !CheckIfCanLocalFire( Owner, vBarrelLocal, vDir ) )
            return;
        
        
        if(bShowFireTrace)
        {
            if(a==null) a=Tools.CreateLaserPointer(GetModule(), LaserPointer._BEAM_GREEN);
        
            Vector vEnd = new Vector(vDir);
            vEnd.Mul(10000.f);
            vEnd.Add(vBarrelLocal);
            a.PointFromTo(vBarrelLocal, vEnd);
        }
        
        // liczymy jak pocisk leci
        Fire( vBarrelLocal, vDir );
    }
    
    /** Metoda sprawdza czy mozna kontynuowac dalsze strzelanie
     * Istotne jest to w grze sieciowej, gdzie 
     * 1. klientach odgrywa sie calosc
     * 2. na serwerze tylko do pewnego momentu, a reszta po replikacji
     * dokladniejszych danych o strzale
     */
    boolean CheckIfCanLocalFire( ChromeActor cUser,Vector vBarrelLocal, Vector vDir )
    {
        boolean bReturn = true;
                
        if ( !m_bNetModule )
            return bReturn;
        
        if ( cUser == null )
        {
            CrashLog("ERROR: cUser == null\n");
            return false;
        }
        /*
        CrashLog(" cUser:"+cUser+
                 " bNetIsOwner:"+cUser.bNetIsOwner+
                 " AUTHORITY "+(cUser.Role == ERole._AUTHORITY)+
                 "\n");*/
        
        if (cUser.bNetIsOwner)
        {
            //wlasciciel
            if (cUser.Role == ERole._AUTHORITY)
            {
                //serwer
                //jezeli to byl istotny strzal to trzeba wyslac klientom
                /*
                if ( nCurrentMode != MODE_AUTO || m_bFirstFireModeAuto )
                    MsgSendClientFire( vBarrelLocal, vDir, -1 );*/
                cUser.WeaponFireOnServer();
            }
            else
            {
                //klient
                //Wyslac do serwera parametry
                MsgSendServerFire( vBarrelLocal, vDir );
            }
        }
        else
        {
            //nie jest wlascicielem
            if (cUser.Role == ERole._AUTHORITY)
            {
                //serwer
                //dalej nie pojdzie
                bReturn = false;
                if (cUser instanceof PlayerNetTestBot)
                {
                    //no chyba ze to bot sterowany lokalnie
                    if (((PlayerNetTestBot)cUser).IsLocalAutoControl())
                        bReturn = true;
                }
            } 
            else
                cUser.WeaponFireOnClientNotOwner();
        }
        
        return bReturn;
    }
    
    LaserPointer a = null;
    
    final static int MSG_SERVER_FIRE = 100;
    final static int MSG_CLIENT_FIRE = 101;
    final static int MSG_CLIENT_AMMO = 102;
    
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case MSG_SERVER_FIRE:
            NetLog.MsgIn("MSG_SERVER_FIRE", this );
            MsgRecvServerFire();
            break;
            
        case MSG_CLIENT_FIRE:
            NetLog.MsgIn("MSG_CLIENT_FIRE", this );
            MsgRecvClientFire();
            break;            
            
        case MSG_CLIENT_AMMO:
            NetLog.MsgIn("MSG_CLIENT_AMMO", this );
            MsgRecvClientAmmo();
            break;            
            
        default:
            super.OnMessage();
        }
    }
    
    void MsgSendServerFire( Vector vBarrel, Vector vDir )
    {
        NetLog.MsgOut("MSG_SERVER_FIRE", this );
        MessageNewUnreliable( MSG_SERVER_FIRE );
        MessagePackVector( vBarrel );
        MessagePackVector( vDir );
        MessageSend();
    }
    
    void MsgRecvServerFire()
    {
        Vector vBarrel      = MessageUnPackVector();
        Vector vDir         = MessageUnPackVector();
        MessageEnd();
     
        if ( (m_bFireOnlyFromHands && (nInvState != EInvObjState._HANDS)) ||
             (Owner == null)                                              ||
              bDeleted )
        {
            NetLog.Error("Fire canceled "+GetNetInfo());
            
            //wyslamy graczowi stan jego faktycznej broni ktora
            //powinien miec w rece
            //MK: zaremowalem bo sie jednak cos walilo...
            /*if ( Owner != null &&
                 Owner.ActiveWeapon != null )
            {
                Owner.ActiveWeapon.MsgSendClientState();
            }*/
            return;
        }
                
        
        if ( GetState() == STATE_NO_AMMO )
        {
            NetLog.Warning("Fire canceled - no ammo "+GetNetInfo());
            //wymusmy jeszcze raz wyslanie, bo z jakis przyczyn nie doszedl
            //pakiet z Ammo == 0, 
            //TODO: zastanowic sie po demie jak to moglo sie stac.
            //a moglo sie stac z dwoch powodow:
            //- stan Ammo == 0 jeszcze byl w drodze
            //- stan Ammo == 0 doszedl wczesniej jeszcze _przed_ pakietem
            // Ammo == ilestam i zostal nadpisany!!!
            nAmmoSent = nAmmo + 1;
            StartCheckSendClientAmmo();
            return;
        }
        
        //if ( ServerVerifyFire( vBarrel ) )
        {
            Owner.WeaponFireOnServer();
            PerformIncomingFire( vBarrel, vDir );
        }
    }
    
    void MsgSendClientFire( Vector vBarrel, Vector vDir, int nHostId )
    {
        NetLog.MsgOut("MSG_CLIENT_FIRE", this );
        MessageNewUnreliable( MSG_CLIENT_FIRE );
        MessagePackVector( vBarrel );
        MessagePackVector( vDir );
        MessageSendNotHost( nHostId );
    }
    
    void MsgRecvClientFire()
    {
        Vector vBarrel = MessageUnPackVector();
        Vector vDir    = MessageUnPackVector();
        MessageEnd();
        PerformIncomingFire( vBarrel, vDir );
    }
    
    void PerformIncomingFire( Vector vBarrel,Vector vDir )
    {
        //taki maly myk z czasem
        //zapamietujemy sobie czas ostatniego strzalu
        float fTemp = fLastShotT;
        //strzelamy
        //TODO: dorobic weryfikacje, czy czasem nie bylo jakis oszustw z barrelem i kierunkiem
        Fire( vBarrel, vDir );
        //tu sobie zapamietujemy czas tego strzalu ktory byl przed chwila
        fLastShotOnServerTime = fLastShotT;
        //i tak jakby go nie bylo, wstawiamy ten poprzedni
        fLastShotT = fTemp;
    }
        

     /**
     * Globalny licznik zmian stanow obiektow
     * Bedzie on wykorzystywany na klientach do rozstrzygania czy dana
     * akcja (ktora zleca nam serwer) ma sie wykonac czy nie (bo jest stara)
     * TODO: dac szerszy opis
     */
    private static 
    ChangeStateCounter sm_cGlobalChangeAmmoCounter = new ChangeStateCounter();
    static void CleanGlobalChangeAmmoCounter() { sm_cGlobalChangeAmmoCounter.Clean(); }
    static int  GetNextGlobalChangeAmmoCounter(){ return sm_cGlobalChangeAmmoCounter.GetNext(); }
    
    /**
     * Indywidualny licznik zapamietujacy ostatnio
     * odebrana i wykonana akcje na tym obiekcie
     */
    private 
    ChangeStateCounter m_cChangeAmmoCounter = new ChangeStateCounter(this);
    boolean VerifyChangeAmmoCounter( int nCounter ){ return m_cChangeAmmoCounter.Verify( nCounter ); }

    
    void MsgSendClientAmmo()
    {
        //najpierw ustalam jakim kanalem wysle dane
        SetSendClientAmmoMode();
        //wysylam odpowiednim kanalem
        NetLog.MsgOut("MSG_CLIENT_AMMO "+((!bSendClientAmmoReliable)?"un":"")+"reliable", this );
        if ( bSendClientAmmoReliable )
            MessageNew( MSG_CLIENT_AMMO );
        else
            MessageNewUnreliable( MSG_CLIENT_AMMO );
        //MessagePackInt( Get
        PackAmmo();
        MessageSend(); 
    }
    
   
    void MsgRecvClientAmmo()
    {
        UnPackAmmo();
        MessageEnd(); 
        
        if ( VerifyChangeAmmoCounter( m_nReceivedAmmoCounter ) )
            ApplyAmmo();
        
        if ( Owner instanceof PlayerHUD )
        {
            ((PlayerHUD)Owner).RefreshAmmoLeft();    
            //jesli to aktualna bron, to warto tez przeliczyc to:
            ((PlayerHUD)Owner).CountAmmo();    
        }
    }
    
    void PackAdditionalData()
    {
        super.PackAdditionalData();
        PackAmmo();
    }
    void UnPackAdditionalData()
    {
        super.UnPackAdditionalData();
        UnPackAmmo();
    }
    
    void ApplyAdditionalData(boolean bVerified)
    {
        super.ApplyAdditionalData( bVerified );
        
        if ( VerifyChangeAmmoCounter( m_nReceivedAmmoCounter ) )
            ApplyAmmo();
    }
    
    void PackAmmo()
    {
        MessagePackInt( GetNextGlobalChangeAmmoCounter() );
        MessagePackInt( nAmmo > 0 ? nAmmo : 0 );//dodatkowe zabezpieczenie przed wyslaniem wartosci ujemnej
        //zapamietania wyslanej amunicji po zawolaniu MsgSendClientAmmo
        //nAmmoSent = nAmmo;
    }
    
    int m_nReceivedAmmoCounter = 0;
    int m_nReceivedAmmo        = 0;
    void UnPackAmmo()
    {
        m_nReceivedAmmoCounter = MessageUnPackInt();
        m_nReceivedAmmo        = MessageUnPackInt();
    }
    void ApplyAmmo()
    {
        nAmmo = m_nReceivedAmmo;
    }
    
    
    boolean m_bFireOnlyFromHands = true;
    
    
    /** Metoda pomocnicza obliczajaca wlasciwy tor lotu pocisku
     * W grze sieciowej bezposrednio wolana po otrzymaniu sygnalu od klienta o strzale.
     * 
     * Fire w pochodnych klasach (Bullet, Shotgun, HEX, Energy, Throw)
     *  implementuje rzeczywisty strzal
     * i odebranie energii celowi.
     */
    void Fire(Vector vBarrelPos, Vector vDir)
    {
        if ( Role == ERole._AUTHORITY && nAmmo > 0 )
        {
            nAmmo --;
            StartCheckSendClientAmmo();
        }
        fLastShotT = GetTime();
    }
    
    void FxAndSoundManager( MeshObject obj,
                            int iMaterialType, Vector vPos, Vector vNormal, Vector vSpeed,
                            ControlObject cObstacle, int ObstacleElement,
                            int eBulletType, String sFXHitName, boolean bNoTrace )
    {
        if ( obj == null )
        {
            LogD(" ERROR: "+this+" nInvState:"+nInvState+" cInventory:"+cInventory+"\n");
            return;
        }
        
        // obliczamy odleglosc do kamery
        ChromeModule cModule = (ChromeModule)GetModule();
        float fCameraDistance = cModule.GetCameraDistance(vPos);

        // jesli strzela glowny gracz to zawsze widac efekty
        if( Owner == cModule.GetMainPlayer() )
            fCameraDistance = 0.f;
        
        StaticFxAndSoundManager( obj, iMaterialType, vPos, vNormal, vSpeed,
                                 cObstacle, ObstacleElement,
                                 eBulletType, sFXHitName, bNoTrace, fCameraDistance );
    }
    
    static float fMinHitSound = 800.f;
    static float fMaxHitSound = 2500.f;
    
    // powyzej tej odleglosci od kamery nie beda odpalane FXy trafien z guna
    static float fMaxDistanceToCamera = 3500.f;

    static float fMinGlassSound = 1000.f;
    static float fMaxGlassSound = 5000.f;
    
    /** Metoda bije szybe w podnym obiekcie i meshelemencie
     */
    static void StaticExecBreakGlass(Vector vPos, Vector vNormal, Vector vSpeed,
                        ControlObject cObstacle, int ObstacleElement)
    {
        if (cObstacle != null && ObstacleElement != -1 && (cObstacle instanceof MeshObject))
        {
            //efekt rozbijanej szyby (sam sprawdza czy element jest szyba)
            MeshObject mo = (MeshObject)cObstacle;
            
            float fVelocity = 1000.0f;   //predkosc
            float fRadius = 40.0f;      //wielkosc dziury
            
            vSpeed.Normalize();
            
            if (mo.FXBrokenGlass_ShotABulletToElement(ObstacleElement, vPos, vSpeed, fVelocity, fRadius))
            {
                // szyba sie stlukla - odpalamy dzwiek
                mo.PlaySound("Data/Sounds/GlassShatter.wav", vPos, fMinGlassSound, fMaxGlassSound);
            }
        }
    }

    /** Powoduje odpalenie efektu trafienia w podany material.
     * @param iMaterialType typ materialu powierzchni ktora zostala trafiona
     * @param vPos pozycja trafienia
     * @param vNormal normalana w punkcie trafienia
     * @param vSpeed wektor predkosci pocisku w pkt. trafienia 
     * @param cObstacle obiekt ktory zostal trafiony, gdy null to trafione cos co jest statyczne
     * @param ObstacleElement id meshElementu ktory dostal trafienie
     * @param bNoTrace okresla czy ma byc odlozony trace w miejscu trafienia
     */
    static void StaticFxAndSoundManager( MeshObject obj,
                                   int iMaterialType, Vector vPos, Vector vNormal, Vector vSpeed,
                                   ControlObject cObstacle, int ObstacleElement,
                                   int eBulletType, String sFXHitName, boolean bNoTrace, float fCameraDistance )
    {          
        if(obj == null) return;

        if( fCameraDistance < fMaxHitSound)
        {
            // odegranie dziweku trafienia
            obj.PlaySound(EAmmoType.GetSoundName(eBulletType,iMaterialType), vPos, fMinHitSound, fMaxHitSound);
        }
        
        // sprawdzamy czy efekt nie odpalany za daleko od kamery
        if( fCameraDistance > fMaxDistanceToCamera) return;
        
        // odpalenie efektu trafienia
        if(sFXHitName!=null) obj.ExecuteFX(sFXHitName,vPos);
        
        // dodanie trace'a
        if(cObstacle==null || cObstacle.getClass()==MeshObject.class)
        {
            // statyczna geometria
            obj.ExecuteFX(EAmmoType.GetFXName(eBulletType,iMaterialType), vPos, vNormal);
            obj.ExecuteParticleSystem(EAmmoType.GetFXName(eBulletType,iMaterialType), vPos, vNormal);
            if(!bNoTrace)
                obj.ExecuteFXTrace(EAmmoType.GetFXName(eBulletType,iMaterialType), vPos, vNormal);
        }
        else
        {
            // dodanie trace'a na obiekcie dynamicznym
            if( ( (cObstacle instanceof Pawn) &&
                  !(cObstacle instanceof NewAIWalker) &&
                  !(cObstacle instanceof Walker) &&
                  !(cObstacle instanceof FlyingRobot) ) ||
                (cObstacle instanceof Individual) )
            {
                // nie ma trace'ow na dziwnych obiektach
            }
            else
            {
                obj.ExecuteFX(EAmmoType.GetFXName(eBulletType,iMaterialType), vPos, vNormal);
                obj.ExecuteParticleSystem(EAmmoType.GetFXName(eBulletType,iMaterialType), vPos, vNormal);

                Vector vPosInObstacle = null;
                Vector vNormalInObstacle = null;

                if ( bNoTrace || (iMaterialType <= -1) ||
                     (cObstacle instanceof NewAIWalker) ||
                     (cObstacle instanceof StationaryCannon) )
                {
                    return; // nie chcemy odkladac trace'a
                }
                
                if (ObstacleElement == -1)
                {
                    vPosInObstacle = cObstacle.PointWorldToLocal( vPos );
                    vNormalInObstacle = cObstacle.VectorWorldToLocal( vNormal );
                    
                    obj.ExecuteFXTrace( cObstacle, EAmmoType.GetFXName(eBulletType,iMaterialType), vPosInObstacle, vNormalInObstacle);
                }
                else
                {
                    vPosInObstacle = ((MeshObject)cObstacle).PointWorldToLocal(ObstacleElement, vPos );
                    vNormalInObstacle = ((MeshObject)cObstacle).VectorWorldToLocal(ObstacleElement, vNormal );

                    obj.ExecuteFXTrace( cObstacle, ObstacleElement, EAmmoType.GetFXName(eBulletType,iMaterialType), vPosInObstacle, vNormalInObstacle);
                }                             
            }            
        }      
    }
    
    public void CutBodyPart(MeshObject obj, int iElement, Vector vSpeed)
    {      
     if(!(obj instanceof Pawn))
      return;
     
     byte eBone = obj.GetBoneIDFromMeshElem(iElement);
     if(eBone == EBones._NON_BONE)
      return;
     
     if(((Pawn)obj).CanCutBodyPart(eBone, fDamage * fDamageMult) == false)     
      return;
               
     if(bCutBodyPartsCutPart)
     {     
      //vSpeed.Mul(0.001f);        
      //vSpeed.fY += 1000.0f;
      vSpeed.Mul(0.001f);
      vSpeed.fY += 400.0f;
      obj.ExecuteFXMeshPart(obj, iElement, vSpeed, 1.0f, "CutBodyPartMeshPart", new Vector(0, 0, 0), new Vector(0, 0, 1));            
     }

     //uciecie konczyny
     boolean bCut = false;
     if(bCutBodyParts)
      bCut = ((Pawn)obj).CutBodyPart(eBone, fDamage * fDamageMult);
     
     if(bCut == false)
      return; //nie obcieta wiec nie bryzgamy krwia i nie rzucamy miesem
     
     //i bryzganie krwia
     if((bCutBodyPartsBlood) && (((Pawn)obj).sCutBodyPartsBlood[eBone].length() != 0))
     {
      Vector vPos = obj.PointWorldToLocal(iElement, obj.GetBoneJointPos(eBone));
      Vector vNormal = obj.VectorWorldToLocal(iElement, obj.GetBoneDirVector(eBone));
      obj.ExecuteParticleSystem(obj, iElement, ((Pawn)obj).sCutBodyPartsBlood[eBone], vPos, vNormal);
     }        
    }
    
    
    // interfejs dla pawna
    boolean CanFire()
    {
        return ( (nAmmo > 0) && 
                 (GetTime() - fLastShotT >= (1.0f/fRateOfFire)) );
    }

    /** Jaki jest stan broni?
     */
    int GetState()
    {
        if (nAmmo <= 0)
            return STATE_NO_AMMO;

        if (GetTime() - fLastShotT >= fDelay)
            return STATE_READY;
        else 
            return STATE_OVERHEAT;
    }

    /**Nacisniecie spustu
     */
    public void StartFire( byte nMode )
    {
        //Log("[Weapon.StartFire] Starting fire.\n");

        StopFire(); //gdyby jeszcze strzelal w trybie auto
        nCurrentMode   = nMode;
        
        nShots         = 0;

        int iWeaponState = GetState();
        if ( iWeaponState != STATE_READY )
        {
            if ( iWeaponState == STATE_NO_AMMO )
                Owner.AttachOneShotSound(sSoundEmpty, fMinEmptySound, fMaxEmptySound);
            
            // zignoruj overheated w auto bo strzeli jak ostygnie
            if ( (iWeaponState == STATE_OVERHEAT) &&
                 (nMode == MODE_AUTO) )
            {
                float fCoolDownTime = fDelay - (GetTime() - fLastShotT);
                if (fCoolDownTime < 0.f)
                    fCoolDownTime = 0.f;
                
                //LogD("CallMethodIn( METHOD_DelayedStartFire "+fCoolDownTime+"\n");
                CallMethodIn( METHOD_DelayedStartFire, fCoolDownTime);
            }
            else
            {
                //LogD("SendWeaponMessage "+iWeaponState+"\n");
                SendWeaponMessage( iWeaponState ); // powiadom o 'zlym' stanie;
            }
        }
        else
            DelayedStartFire(); // wszystko ok, zacznij strzelac
    }

    public void StartFire(byte nMode, boolean bSecondary)
    {
        bSecondaryMode = bSecondary;
        
        StartFire( nMode );
    }

        
    /**
     * Flaga mowiaca o tym, czy wlasnie jestesmy podczas
     * pierwszego wystrzalu w trybie AUTO
     */
    boolean m_bFirstFireModeAuto = false; // Net only -> not SG
    
    protected void DelayedStartFire()
    {
        //LogD(" "+nCurrentMode+"\n");
        switch (nCurrentMode)
        {
            //pojedynczy strzal
        case MODE_SINGLE :
            //LogD(" MODE_SINGLE\n");
            SetFireModeSingle();
            break;

            //automat - strzela az do pustego magazynka albo zatrzymania przez StopFire
        case MODE_AUTO :
            //LogD(" MODE_AUTO\n");
            
            m_bFirstFireModeAuto = true;
            FireModeAuto();
            
            
            //LogD(" CallMethodEvery( METHOD_FireModeAuto "+fDelay+")\n");
            CallMethodEvery( METHOD_FireModeAuto, fDelay );
            break;
        }
    }
    
    void OnPostUpdate()
    {
        if (m_bFireModeSingle)
		{
            FireModeSingle();
			m_bFireModeSingle = false;
		}
        m_bFirstFireModeAuto = false;
    }
    
    
    boolean m_bSetSendClientStateOnPlayerGotInHands = false; //not SG - net only
    
    void SetSendClientStateOnPlayerGotInHands()
    {
        m_bSetSendClientStateOnPlayerGotInHands = true;
    }
        
    /**
     * Callback mowiacy o tym, ze bron wlasnie znalazla sie w rekach gracza
     */
    void OnPlayerGotInHands()
    {
        if ( m_bSetSendClientStateOnPlayerGotInHands )
        {
            m_bSetSendClientStateOnPlayerGotInHands = false;
            if ( Role < ERole._AUTHORITY )
                return;
            MsgSendClientState();
        }
    }
    
    /**Stzelanie bronia automatyczna
     */
    protected void FireModeAuto()
    {
        //LogD(" time:"+GetTime()+"\n");
        if (nCurrentMode == MODE_AUTO)
        {
            int nState = GetState();
            if ( ((nState & STATE_NO_AMMO) == 0 ) &&
                 // max. liczba strzalow w serii nie przekroczona:
                 ((nRoundShots == 0) || (nShots < nRoundShots)) )
            {
                //LogD(" FireModeSingle\n");
                SetFireModeSingle();
            }
            else
            {  
                // koniec amunicji - zaprzestan strzelania i powiadom
                //LogD(" StopFire\n");
                StopFire();
                SendWeaponMessage( nState );
            }
        }
    }
    
    protected void SetFireModeSingle()
    {
        /*robimy w ten sposob, bo rakietnica musi strzelac na onpostupdate, zeby nie bylo
        widac rakiet przy strafe'owaniu, 
        */
        m_bFireModeSingle = true;
    }
    
    /**Oddanie pojedynczego strzalu 
     */
    protected void FireModeSingle()
    {
        //LogD("\n");
        Fire( GetOwnerFireDir() );
        SendWeaponMessage( STATE_SHOT );
        nShots++;
    }

    
    

    

    /**Puszczenie spustu - koniec strzelania
     * Robi to samo co CancelFire, ale mozna jeszcze ja pokryc 
     * i zrobic cos dodatkowego
     */
    public void StopFire()
    {
        CancelFire();
    }
    
    public void CancelFire()
    {
        //LogD("\n");
        nCurrentMode = MODE_IDLE;
        nShots = 0;
        DisableCallMethod(METHOD_DelayedStartFire);
        DisableCallMethod(METHOD_FireModeAuto);
        //Log("[Weapon.StartFire] Fire stopped.\n");
    }

    /** Przeladowanie magazynka konkretnym pudelkiem amunicji.
     */
    void Reload(Ammo ammo)
    {
        if (ammo.eAmmoType == eBulletType)
        {
            if (ammo.nCount >= nCapacity)
                nAmmo = nCapacity;
            else
                nAmmo = ammo.nCount;
            ammo.nCount -= nAmmo;
            //po kazdym przeladowaniu serwer i tak wysle MsgSencClientAmmo, wiec:
            nAmmoSent    = nAmmo;

            Log("[Weapon.Reload] Weapon reloaded!\n");
        }
        else
            Log("[Weapon.Reload] Attempt to reload with wrong bullet type!\n");
    }

    /**Przeladowanie magazynka
     */
    void Reload(int nCount)
    {
        if (nCount <= nCapacity)
        {
            nAmmo        = nCount;
            //po kazdym przeladowaniu serwer i tak wysle MsgSencClientAmmo, wiec:
            nAmmoSent    = nAmmo;
            Log("[Weapon.Reload] Weapon reloaded!\n");
        }
        else
            Log("[Weapon.Reaload] Attempt to reload with too many bullets!\n");
    }
    
    /**Pokryta metoda TriggerObject. W Weapon umieszcza obiekt w inventory Pawna.
     * @param executor Pawn wykonujacy akcje. Jesli executor nie jest pawnem, metoda nie robi nic. (<code>Actor</code>)
     */
    void Execute( Actor executor )
    {
        // FIXIT wlaczamy broni malutkie kratki
        //nCellsHeight = 1;
        //nCellsWidth = 1;
        
        super.Execute( executor );
        
        try
        {
            Owner = (Pawn)executor;
        } catch( ClassCastException e) {
            Log("[Weapon.Execute]: Weapon can be executed only by Pawn\n");
            return;
        }
    }
    
    ///////////////////////////////////////////////////////////
    // Metody do pokrycia dla broni wlasciciela z kilkoma gunami
    //
    
    /** Pobranie z wlasciciela pozycji, z ktorej strzelamy
     */
    Vector GetOwnerFireOrigin()
    {
        if ( Owner == null )
        {
            CancelFire();
            return Vector.Zero;
        }
        return Owner.GetFireOrigin();
    }
    
    /** Pobranie z wlasciciela kierunku, w ktory strzelamy
     */
    Vector GetOwnerFireDir()
    {
        if ( Owner == null )
        {
            CancelFire();
            return Vector.Forward;
        }
        
        return Owner.GetFireDir();
    }

    /** Wyslanie message'a do Ownera
     */
    void SendWeaponMessage(int nState)
    {
        if ( Owner == null )
        {
            CancelFire();
            return;
        }
        Owner.MessageWeapon(nState);
    }
    
    private int nWeaponID = 0;
    
    /** Ustawienie identyfikatora dla broni
     */
    void SetWeaponID(int nID)
    {
        nWeaponID = nID;
    }
    
    /** Pobranie identyfikatora ustawionego przes SetWeaponID
     */
    int GetWeaponID()
    {
        return nWeaponID;
    }
    
    
    void JustAddedToInventory()
    {
        //Owner.WeaponAddedToInventory(this);
    }
        
    ControlObject l_aTmpObject[] = new ControlObject[1];
    
    /**Zwraca obiekt w ktory celujemy, (jesli jest w zasiegu)*/
    ControlObject GetObjectInSight()
    {
        if (Owner == null)
            return null;
        
        // wyliczamy, pobieramy, ustalamy kierunek w ktory strzelamy    
        Vector vDir = Owner.GetAimDir();
        Vector vOrigin = Owner.GetFireOrigin();
        Vector vEnd = new Vector(vDir);
        vEnd.Mul(fRange);
        vEnd.Add(vOrigin);

        l_aTmpObject[0] = GetObjectDamageExclude();
        Collision stCollObjects = NewAI.AITrace(this, vOrigin, vEnd, NewAI._AITRACE_IGNORE_GLASS, l_aTmpObject);

/*      // bylo
        Collision stCollTerrain=TraceTerrain(vOrigin, vEnd);
        Collision stCollTrees=TraceTrees(vOrigin, vEnd);
        Collision stCollObjects=TraceObjectsExclude(vOrigin, vEnd, GetObjectDamageExclude());
*/        
        if(stCollObjects != null)
            return stCollObjects.Obstacle;
        else 
            return null;
    }
    
    /////////////////////////////////////////////////////////////////
    // Implementacja interface'u ipar_WeaponParams

    public void SetWeaponParams(ParamWeaponParams params)
    {
        if (params.fAIEffectiveRange >= 0)
            fAIEffectiveRange = params.fAIEffectiveRange;

        if (params.fAIBurstTime >= 0)
            fAIBurstTime = params.fAIBurstTime;
        if (params.fAIRandomBurstTime >= 0)
            fAIRandomBurstTime = params.fAIRandomBurstTime;
        if (params.fAIMaxBurstDistance >= 0)
            fAIMaxBurstDistance = params.fAIMaxBurstDistance;
        if (params.fAIBurstFireDelay >= 0)
            fAIBurstFireDelay = params.fAIBurstFireDelay;
        if (params.fAIRandomBurstFireDelay >= 0)
            fAIRandomBurstFireDelay = params.fAIRandomBurstFireDelay;

        if (params.fDamageMult >= 0)
            fDamageMult = params.fDamageMult;
        
        if (params.nAIReadinessToAim >= 0)
            nAIReadinessToAim = params.nAIReadinessToAim;
        if (params.nAIReadinessToStopAiming >= 0)
            nAIReadinessToStopAiming = params.nAIReadinessToStopAiming;
    }
    
    //metody obslugujace strzelanie z walkera-vehicla
    void StartFire()
    {
    }
    void SetWalkerMode( Walker cWalker )
    {
	    m_cWalker = cWalker;
        SetPosition(Vector.Zero);
		SetDirLocal(Vector.Forward);
		EnableRendering(false);
		ClearFlag(EFlags._BLOCK_TRACE | EFlags._BLOCK_MOVE);
        m_bFireOnlyFromHands = false;
    }
    
    Walker m_cWalker = null;
    boolean IsInWalkerMode(){ return ( m_cWalker != null ); }
    
    Vector GetWalkerFireDir()
    {
        if ( m_cWalker == null )
            return null;
        
        Vector vDir = new Vector( m_cWalker.GetTargetPoint() );
        vDir.Sub( GetPosition() );
        vDir.Normalize();

        // vDev powinien byc prostopadly do v, ale to nie jest chyba 
        // az tak istotne..
        Vector vDev = new Vector( (float) ((RandomFloat(2.0f)-1f) * fBaseAcc/100.f),
                                  (float) ((RandomFloat(2.0f)-1f) * fBaseAcc/100.f),
                                  (float) ((RandomFloat(2.0f)-1f) * fBaseAcc/100.f) );
        vDir.Add(vDev);
        return vDir;
    }

    void WalkerExecuteFXBarrel(String sFXCombName)
    {
        if ( m_cWalker != null )
        {
            ExecuteFX( this, sFXCombName,  vBarrelElementPos );
            //ExecuteFX( this, "WeaponBeam", vBarrelElementPos );
        }
    }
    
    
    void MsgSendClientState()
    {
        if ( !IsInWalkerMode() )
            super.MsgSendClientState();
    }
    void MsgSendClientStateToHost(int nHostId)
    {
        if ( !IsInWalkerMode() )
            super.MsgSendClientStateToHost(nHostId);
    }
        
    /**
     * Zwraca obiekt ktory ma byc pomijamy do kolizji (do damagu)
     * Zwykle jest to Owner, natomiast w trybie walkera-vehicla
     * jest to sam walker
     */
    ChromeActor GetObjectDamageExclude()
    {
        if ( m_cWalker != null ) 
            return m_cWalker;
        return Owner ;
    }
    
    
    boolean AddToInventory(Actor executor, boolean bLoud)
    {
        if (super.AddToInventory(executor, bLoud))
        {
            ChangeNetOwner( executor );
            //bNetIsOwner = executor.bNetIsOwner;
            if (cBullet != null)
            {
                cBullet.SetOwner( this );
                
                //cBullet.bNetIsOwner = bNetIsOwner;
                cBullet.Init(this);
            }
            
            return true;
        }
        else
            return false;
    }
    

    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Weapon.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_WEAPON)
        {	
			super.SGLoadChunk(cFC);
			
			m_bFireModeSingle = cFC.LoadBool();
			
			// ile jest obecnie w pudelku
			nAmmo = cFC.LoadInt();		
			
			// Ostatnio trafiony controlObject
			oLastHit = (ControlObject)cFC.LoadObjectRef();			
			
			// Aktualny tryb strzelania
			nCurrentMode = (byte)cFC.LoadInt();
			// Liczba pociskow wystrzelonych w tej serii
			nShots = cFC.LoadInt();
			// Czas ostatniego strzalu
			fLastShotT = cFC.LoadFloat();
			// Czas ostatniego strzalu pamietany na serwerze
			fLastShotOnServerTime = cFC.LoadFloat();

			// 1.0/fRateOfFire
			fDelay = cFC.LoadFloat();
    
			nWeaponID = cFC.LoadInt();
        
            // ODCZYTUJEMY cBullet
            boolean bBullet = cFC.LoadBool();
            if(bBullet)
            {
                if(cBullet == null)
                {
                    CrashLog("ERROR! Bullet in save but no bullet in weapon <"+GetName()+":"+GetUniqueID()+"> \n");
                    // skipujemy chunka
                    FileChunk cFCDumpChunk = GameObject.LoadChunk(cFC);
                    cFCDumpChunk.delete();
                }
                else
				{
					FileChunk.Log("[Weapon.SGLoadChunk] Bullet -> Name = <"+cBullet.GetName()+"> ClassName = <"+cBullet.getClass().getName()+"> \n");
                    cBullet.SGLoadChunk(cFC);
				}
            }
            else
            {
                if(cBullet != null)
                {
                    // nie ma bulleta w zapisanych danych - kasujemy aktualnego bulleta
                    //TODO normalne delete
                    cBullet.DeactivateOnModuleAlways();
                    cBullet.EnableRendering(false);
                    ClearBulletRef();
                }
            }
            
            // ODCZYTUJEMY cZoomer
            boolean bZoomer = cFC.LoadBool();
            if(bZoomer)
            {
			    if (cZoomer == null)
			    {			    	
					cZoomer = (Zoomer)CreateObject("Zoomer");
					cZoomer.cOwner = this;
			    }
                cZoomer.SGLoadChunk(cFC);
            }
            
            // odczytujemy parametry mogace sie zmienic z ParamWeaponParams
            fAIEffectiveRange=cFC.LoadFloat();
            fAIBurstTime=cFC.LoadFloat();
            fAIRandomBurstTime=cFC.LoadFloat();
            fAIMaxBurstDistance=cFC.LoadFloat();
            fAIBurstFireDelay=cFC.LoadFloat();
            fAIRandomBurstFireDelay=cFC.LoadFloat();
            fDamageMult=cFC.LoadFloat();
            nAIReadinessToAim=cFC.LoadInt();
            nAIReadinessToStopAiming=cFC.LoadInt();
			
			m_cWalker = (Walker)cFC.LoadObjectRef();
			m_bFireOnlyFromHands = cFC.LoadBool();
			
			// liczba strzalow w serii
			nRoundShots = cFC.LoadInt();
			// czestotliwosc strzelania broni
			fRateOfFire = cFC.LoadFloat();					
			fRange = cFC.LoadFloat();		
            
            fDamage = cFC.LoadFloat();
            fPhysicsSimDamage = cFC.LoadFloat();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Weapon.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_WEAPON, cFCParent);
		
		super.SGSaveChunk(cFC);

		cFC.SaveBool(m_bFireModeSingle);
				
		// ile jest obecnie w pudelku
		cFC.SaveInt(nAmmo);

		// Ostatnio trafiony controlObject
		cFC.SaveObjectRef(oLastHit);

		// Aktualny tryb strzelania
		cFC.SaveInt((int)nCurrentMode);
		// Liczba pociskow wystrzelonych w tej serii
		cFC.SaveInt(nShots);
		// Czas ostatniego strzalu
		cFC.SaveFloat(fLastShotT);
		// Czas ostatniego strzalu pamietany na serwerze
		cFC.SaveFloat(fLastShotOnServerTime);

		// 1.0/fRateOfFire
		cFC.SaveFloat(fDelay);

		cFC.SaveInt(nWeaponID);
    	
        // ZAPISUJEMY cBullet
        if(cBullet!=null && !cBullet.bSG)
        {
            cFC.SaveBool( true );
			FileChunk.Log("[Weapon.SGSaveChunk] Bullet -> Name = <"+cBullet.GetName()+"> ClassName = <"+cBullet.getClass().getName()+"> \n");
            cBullet.SGSaveChunk(cFC);
        }
        else
        {
            /*
            if (cBullet == null)
                CrashLog("BULLET NOT SAVED cBullet " + null + " sg N/A");
            else
                CrashLog("BULLET NOT SAVED cBullet " + cBullet + " sg " + cBullet.bSG);
            */
            cFC.SaveBool( false );
        }

        // ZAPISUJEMY cZoomer
        cFC.SaveBool( cZoomer != null );
        if(cZoomer != null) cZoomer.SGSaveChunk(cFC);
        
        // zapisujemy parametry mogace sie zmienic z ParamWeaponParams
        cFC.SaveFloat(fAIEffectiveRange);
        cFC.SaveFloat(fAIBurstTime);
        cFC.SaveFloat(fAIRandomBurstTime);
        cFC.SaveFloat(fAIMaxBurstDistance);
        cFC.SaveFloat(fAIBurstFireDelay);
        cFC.SaveFloat(fAIRandomBurstFireDelay);
        cFC.SaveFloat(fDamageMult);
        cFC.SaveInt(nAIReadinessToAim);
        cFC.SaveInt(nAIReadinessToStopAiming);

		cFC.SaveObjectRef(m_cWalker);
		cFC.SaveBool(m_bFireOnlyFromHands);
		
		// liczba strzalow w serii
		cFC.SaveInt(nRoundShots);
		// czestotliwosc strzelania broni
		cFC.SaveFloat(fRateOfFire);
		cFC.SaveFloat(fRange);		

        cFC.SaveFloat(fDamage);
        cFC.SaveFloat(fPhysicsSimDamage);
        
        // kasujemy
        cFC.delete();
    }	   
	
	public void SGUpdate()
	{
		FileChunk.Log("[Weapon.SGUpdate]\n");
		super.SGUpdate();
		
		if (cBullet != null) cBullet.SGUpdate();
	}
    
    /**
     * Flaga wlaczana przy pierwszym wyslaniu
     * komunikatu o zmianie broni, od tego momentu
     * co jakis czas (sm_fMinUpdateClientAmmoTime)
     * sprawdzane bedzie czy znowu wyslac stan amunicji 
     * (jesli sie zmienila)
     * Sprawdzanie konczy sie w momencie gdy w ciagu tego
     * czasu stan amunicji sie nie zmieni (czyli skonczylo
     * sie strzelanie)
     */
    boolean bSendingAmmo = false;

    void StartCheckSendClientAmmo()
    {
        if (!(GetModule() instanceof ModuleNet))
            return;
        
        if ( bSendingAmmo )
            return;
        
        CheckSendClientAmmo();
    }
        
    void CheckSendClientAmmo()
    {
        if ( nAmmoSent != nAmmo )
        {
            MsgSendClientAmmo();
            nAmmoSent = nAmmo;
            
            bSendingAmmo = true;
            CallMethodIn( METHOD_CheckSendClientAmmo, sm_fMinUpdateClientAmmoTime );
        }
        else
        {
            bSendingAmmo = false;
            DisableCallMethod( METHOD_CheckSendClientAmmo );
        }
    }
    
    /**
     * Flaga mowiaca o tym, czy komunikat zmiany
     * broni ma byc wyslany kanalem pewnym czy nie
     * Ustawiana przez metode SetSendClientAmmoMode()
     */
    boolean bSendClientAmmoReliable = false;
        
    /**
     * Kanalem pewnym wysylamy, w kazdym z przypadkow jezeli:
     * - amunicja sie skonczyla
     * - amunicja jest na full (przeladowano bron)
     * - po pierszym strzale w serii (dopiero rozpoczynamy cykl wysylania - !bSendingAmmo) 
     * - inicjalizujemy graczowi obiekt,     
     * W pozostalych przypadkach wysylamy kanalem niepewnym
     */
    void SetSendClientAmmoMode()
    {
        bSendClientAmmoReliable = ( (nAmmo <= 0) || 
                                    (nAmmo == nCapacity) || 
                                    (!bSendingAmmo)||
                                     bNetInit );
    }
    
    void CheatGiveAmmo()
    {
        if (Owner instanceof PlayerSingle)
            nAmmo = 500;
    }
    
    void CheatTune()
    {
        if (Owner instanceof PlayerSingle)
        {
            fBaseAcc = 0.8f;
            fAimAcc = 0.6f;
            fRecoilAccChange = fRecoilShiftChange = fWalkSnakeAccChange = fRunJumpAccChange = 0;
            
            if (fDamage < 500)
                fDamage = 500;  
            if (fDelay > 0.5f)
                fDelay = 0.5f;
            
        }
    }
    
    boolean CanBeUsedByPlayer()
    {
        return nType != EWeaponType._BINOCULARS;
    }
    
    public void SetPositionOnGroundDrop(Vector vPos, Vector vDroppingPawnPos)
    {
        // setup gun orientation
        Vector vDir = Vector.Forward;
        vUpOnGround.fX = -1.f;
        vUpOnGround.fY = 0.f;
        vUpOnGround.fZ = 1 - RandomFloat(2);
        vUpOnGround.Normalize();
        FromUpForwardPos(vUpOnGround, vDir, vPos);

        // modify pos considering mesh extents
        Vector vMin = new Vector(), vMax = new Vector();
        GetMeshExtents(vMin, vMax);
            
        vPos.fY += (float)Math.abs(vMin.fY);
        
        super.SetPositionOnGroundDrop(vPos, vDroppingPawnPos);
    }

    Vector m_vReqUpOnGround = null; 
    
    void ApplyPosition()
    {
        FromUpForwardPos(m_vReqUpOnGround, Vector.Forward, m_vReqPos);
        vUpOnGround = m_vReqUpOnGround;
    }
    
    void PackStateOnGround()
    {
        MessagePackVector( GetPosition() );
        MessagePackVector( vUpOnGround );
    }
    
    // odebranie stanu
    void UnPackStateOnGround()
    {
        m_vReqPos = MessageUnPackVector();
        m_vReqUpOnGround = MessageUnPackVector();
    }

    /**
     * Kwadrat maksymalnej odleglosci pomiedzy graczem o miejscem wystrzalu
     * (mierzony na serwerze w momencie odebrania komunikatu o strzale)
     * przy ktorej jeszcze strzal zostanie zaakceptowany
     * Domyslnie ustawiony na 550.0f * 550.0f czyli tyle ile gracz moze
     * przebiec w ciagu jednej sekundy
     */
    private static float sm_fMaxDistance2ToVerifyFire = 550.0f * 550.0f;
    static void SetMaxDistanceToVerifyFire(float fDist)
    {
        sm_fMaxDistance2ToVerifyFire = fDist * fDist;
    }

    /**
     * Flaga mowiaca o tym, czy podczas weryfikacji miejsca strzalu
     * bierzemy pod uwage wspolrzedna Y
     */
    static boolean  sm_bUseAxisYToVerifyFire    = false;
    

    static Vector   sm_vCurrentOwnerPos         = new Vector();
        
    /**
     * Metoda weryfikujaca mozliwosc strzalu z klienta
     * Sprawdza czy Owner jest zywy, oraz czy jego pozycja
     * nie odbiega znacznie (jak mocno!?) od pozycji podanej
     * jako vBarrel
     */
    boolean ServerVerifyFire( Vector vBarrel )
    {
        //jak nie ma ownera albo marwy to nie mozna uznac strzalu
        if ( Owner == null || Owner.bDead )
        {
            NetLog.Test("ServerVerifyFire FAILED "+Owner+
                        " "+((Owner!=null)?Owner.GetNetInfo():""));
            return false;
        }
        
        //dla broni ktora strzela z reki ownera (czyli nie bron
        //w walkerze, czy stationary cannon) sprawdzamy czy
        //na pewno jestesmy aktywna bronia naszego ownera
        if ( m_bFireOnlyFromHands && Owner.ActiveWeapon != this )
        {
            NetLog.Test("ServerVerifyFire FAILED FireOnlyFromHands "+
                        ((Owner.ActiveWeapon!=null)?Owner.ActiveWeapon.GetNetInfo():"null")+
                        " != "+GetNetInfo());
            return false;
        }
        
        Owner.GetPosition( sm_vCurrentOwnerPos );
        
        if ( ! sm_bUseAxisYToVerifyFire )
            sm_vCurrentOwnerPos.fY = vBarrel.fY;
        
        if ( NetLog.IsEnabled( NetLog._TYPE_TEST ) )
        {
            float fDist2 = vBarrel.Distance2( sm_vCurrentOwnerPos );
            if ( fDist2 >= sm_fMaxDistance2ToVerifyFire )    
            {
                NetLog.Test("ServerVerifyFire FAILED Distance2 "+fDist2+
                            " "+GetNetInfo()+" Owner: "+Owner.GetNetInfo());        
            }
        }
            
        
        return ( vBarrel.Distance2( sm_vCurrentOwnerPos ) < sm_fMaxDistance2ToVerifyFire );
    }
    
    
}
