/** Dzialo. Nie jest, jak reszta broni, InvObjectem, ale posiada podobne parametry.
 */
public class WeaponCannon extends GameObject
{
    /** Aktualny tryb strzelania */
    public byte nCurrentMode;
    /** Liczba pociskow wystrzelonych w tej serii */
    public int nShots = 0;
    /** Czas ostatniego strzalu */
    protected float fLastShotT = 0;
    /** 1.0/fRateOfFire */
    protected float fDelay;
    /** Ilosc odjemowanej energii po trafieniu */
    public float fDamage = 10.0f;
    /**damage przekazywany do fizyki*/
    public float fPhysicsSimDamage = 10f;
    /** Zasieg broni. */
    public float fRange = 10000.0f;
    /** Szybkosc lotu pocisku broni (sila uderzenia pocisku ???) */
    public float fBulletSpeed = 100.0f;
	/** Czestotliwosc strzelania broni */
    public float fRateOfFire = 100.0f;
	/** Rodzaj uzywanej amunicji */
	public byte eBulletType = EAmmoType._Cannon;//EAmmoType._9mmShort;
    /** poczatkowa pojemnosc magazynka */
    public int nCapacity = 1000;
    /** liczba strzalow w serii */
    public int nRoundShots = 0;    //0 - full auto, >0 - semi auto
    /** czas pomiedzy seriami */
    public float fLongDelay = 1.0f;
	/** lufa i numerek elementu */
    String sElementBarrelExit = "Barrel";
    int nElementBarrelExit = -1;

    float fMinShootSound = 800f;
    float fMaxShootSound = 6000f;
    
    float fMinEmptySound = 100f;
    float fMaxEmptySound = 400f;
    
    /** okresla czy przy postrzale z danej broni maja byc urywane czesci ciala */
    public boolean bCutBodyParts = false;
    /** okresla czy przy postrzale z danej broni maja byc uruchamiany system czastek symulujacy bryzgi krwi od urywanej konczyny */
    public boolean bCutBodyPartsBlood = true && bCutBodyParts;    
    public boolean bCutBodyPartsCutPart = true && bCutBodyParts;
    
    int METHOD_DelayedStartFire     = 0;
    int METHOD_FireModeAuto         = 0;
    
    /** Biezaca ilosc amunicji */
    int nAmmo;
    
    /**Gdy cel jest w odleglosci mniejszej od tej to nie pokazujemy beama*/
    float fMinBeamDistance = 100;
    
    ControlObject oLastHit = null;

    ///////////////////////////////////////////////////////////////////////////
    // Stan broni zwracany ownerowi - flagi.
    ///////////////////////////////////////////////////////////////////////////
    /** co sie stalo */
    final static int STATE_SHOT            = 0x01;    //po strzale
    final static int STATE_END_OF_ROUND    = 0x04;    //koniec serii, zwykle z RELOADED
    /** co jest grane */
    final static int STATE_NO_AMMO         = 0x02;    //brak amunicji
    final static int STATE_OVERHEAT        = 0x80;    //shit2!
    final static int STATE_READY           = 0x20;    //gotowy do strzalu
    /** Tryby strzelania */
    final static byte MODE_IDLE       = 0;    //bron w spoczynku
    final static byte MODE_SINGLE     = 1;    //single
    final static byte MODE_AUTO       = 2;    //auto ze skomplikowana animacja strzalu

    /* FXy */
    /** Halas jaki powoduje bron przy wystrzale*/
	public float fNoiseShot = 5000.0f;
    
    /** Halas jaki powoduje pocisk przy trafieniu*/
    public float fNoiseHit  = 1000.0f;
    
    /** Nazwa Fx jaki ma byc otpalany przy wystrzale(grzebien) */
    public String sFXCombName = "FXGrzebienRifle";
    
    /** Nazwa Fx jaki ma byc odpalany przy trafieniu*/
    public String sFXHitName = null; 
    
    /** Nazwa dzieku odpalanego przy wystrzale */
    public String sSoundShoot = "Data/Sounds/Weapon/C01_Fire";
    
    /** Dzwike pustego magazynku */
    public String sSoundEmpty = "Data/Sounds/menu/Out_gren";
    
    /** Nazwa dzieku odpalanego przy przeladowaniu */
    public String sSoundReload = "Data/Sounds/Ai/sgshot";
    
    /** Wlasciciel, ktory posiada mesha broni strzelajacy */
    ChromeActor cOwner = null;
    
    /**Prawdopodobienstwo odpalenia fxa beamu z lufy*/
    float m_fExecuteBeamProbability = 0.1f;
    
    public void OnCreate()
    {
        if (cOwner == null) 
            GameObject.CrashLog("[WeaponCannon.OnCreate] Got null owner!!!!!\n");
    
        nElementBarrelExit = cOwner.GetElementID(sElementBarrelExit);
        
        METHOD_DelayedStartFire     = RegisterCallMethod("DelayedStartFire");
        METHOD_FireModeAuto         = RegisterCallMethod("FireModeAuto");
        
        // do przeliczenia fDelay
        SetRateOfFire(fRateOfFire);
        
        nAmmo = nCapacity;

        nCurrentMode = MODE_IDLE;
    }    

    /** interfejs dla pawna
     */
    boolean CanFire()
    {
        return ( (nAmmo > 0) && 
                 (GetTime() - fLastShotT >= fDelay) );
    }

    /** Jaki jest stan broni?
     */
    int GetState()
    {
        if (nAmmo <= 0)
            return STATE_NO_AMMO;

        if (GetTime() - fLastShotT >= fDelay)
            return STATE_READY;
        else 
            return STATE_OVERHEAT;
    }
    
    public void StartFire(byte nMode)
    {
        //Log("[Weapon.StartFire] Starting fire.\n");

        StopFire(); // gdyby jeszcze strzelal w trybie auto
        nCurrentMode = nMode;
        nShots = 0;

        int iWeaponState = GetState();
        if ( iWeaponState != STATE_READY )
        {
            if ( iWeaponState == STATE_NO_AMMO )
                cOwner.AttachOneShotSound(sSoundEmpty, fMinEmptySound, fMaxEmptySound);
            // zignoruj overheated w auto bo strzeli jak ostygnie
            if ( (iWeaponState == STATE_OVERHEAT) &&
                 (nMode == MODE_AUTO) )
            {
                float fCoolDownTime = fDelay - (GetTime() - fLastShotT);
                if (fCoolDownTime < 0.f)
                    fCoolDownTime = 0.f;
                
                //LogD("METHOD_FireModeAuto="+METHOD_FireModeAuto+"\n");
                CallMethodIn( METHOD_DelayedStartFire, fCoolDownTime);
            }
            else
                WeaponMessage( iWeaponState ); // powiadom o 'zlym' stanie;
        }
        else
            DelayedStartFire(); // wszystko ok, zacznij strzelac
    }

    protected void DelayedStartFire()
    {
        switch (nCurrentMode)
        {
            //pojedynczy strzal
            case MODE_SINGLE :
                FireModeSingle();
                break;

            //automat - strzela az do pustego magazynka albo zatrzymania przez StopFire
            case MODE_AUTO :
                FireModeAuto();
                
                //LogD("METHOD_FireModeAuto="+METHOD_FireModeAuto+"\n");
                CallMethodEvery( METHOD_FireModeAuto, fDelay);
                break;
        }
    }
    
    /** Oddanie pojedynczego strzalu 
     */
    protected void FireModeSingle()
    {
        Fire(GetFireDir());
        WeaponMessage(STATE_SHOT);
        nShots++;
    }

    /** Stzelanie bronia automatyczna
     */
    protected void FireModeAuto()
    {
        if (nCurrentMode == MODE_AUTO)
        {
            int nState = GetState();
            if ( ((nState & STATE_NO_AMMO) == 0 ) &&
                 // max. liczba strzalow w serii nie przekroczona:
                 ((nRoundShots == 0) || (nShots < nRoundShots)) )
            {
                FireModeSingle();
                //HACK by MK, zeby robil przerwy miedzy seriami
                if ( nShots == nRoundShots )
                {
                    fLastShotT += fLongDelay - fDelay;
                    MessageLongDelay( fLongDelay );
                }
            }
            else
            {  
                // koniec amunicji - zaprzestan strzelania i powiadom
                StopFire();
                WeaponMessage( nState );
            }
        }
    }

    /** Puszczenie spustu - koniec strzelania
     */
    public void StopFire()
    {
        nCurrentMode = MODE_IDLE;
        nShots = 0;
        DisableCallMethod(METHOD_DelayedStartFire);
        DisableCallMethod(METHOD_FireModeAuto);
        //GameObject.LogD("Fire stopped.\n");
    }    

	/** Strzelenie w kierunku v
	 */
    void Fire(Vector v)
    {
        //Log("[Weapon.Fire] Weapon fired! Prepare to die!\n");

        //Vector vBarrel=new Vector(GetPosition());
        Vector vBarrel = GetFireOrigin();
        Vector vDir = v;

        // liczymy jak pocisk leci
        Fire(vBarrel, vDir);
    }

    /** Strzelanie pociskami
     */
    void Fire(Vector vBarrel, Vector vDir)
    {
		if (cOwner.Role == ERole._AUTHORITY)
			nAmmo -= 1;

        fLastShotT = GetTime();

        float fDist = FireBullet(vBarrel, vDir);

        // dodajemy efekty zwiazane z wystrzalem
        //wczesniej nalezy ustawic odowiednie pola FXa
        if(sFXCombName != null)
		{
            cOwner.ExecuteFX( cOwner, sElementBarrelExit,
                              sFXCombName, new Vector(0, 0, 0));
		}

        //beam z lufy tylko losowo
        if (RandomFloat(1) < m_fExecuteBeamProbability && fDist > fMinBeamDistance)
        {
            //ustawienia fx beama 
            
            cOwner.fFXSizeX = 2.0f;
            cOwner.fFXZero = 0f;
            if (fDist <= fRange)
            {
                cOwner.fFXSizeY = fDist - fMinBeamDistance;
                cOwner.fFXPosY = fDist/2f + fMinBeamDistance/2f;
            }
            else
            {
                //brak kolizji w zasiegu, wtedy w fDist jest jakas kosmiczna liczba
                cOwner.fFXSizeY = fRange - fMinBeamDistance;
                cOwner.fFXPosY = fRange/2f + fMinBeamDistance/2f;
            }
            cOwner.ExecuteFX(// cOwner, sElementBarrelExit,
                              //"WeaponBeam"
                                "LaserBeamRed", vBarrel, vDir
                              );
        }
        
        cOwner.AttachOneShotSound(sSoundShoot, fMinShootSound, fMaxShootSound);
        cOwner.MakeNoise(fNoiseShot, Pawn._NOISE_WEAPON_FIRING);
    }

    float FireBullet(Vector vBarrel, Vector vDir)
    {
        float fDistance = 1e10f;
        
         // wyliczamy, pobieramy, ustalamy kierunek w ktory strzelamy
        Vector vEnd = new Vector(vDir);
        vEnd.Mul(fRange);
        vEnd.Add(vBarrel);

        //CrashLog("FIRE ! from" + vBarrel + " to "+ vEnd + "\n");

        Collision stCollTerrain = cOwner.TraceTerrain(vBarrel, vEnd);
        if (stCollTerrain != null)
        {
            fDistance = stCollTerrain.fDistance;
            // trafienie w ziemie
            //Log("   Trafiona ziemia w punkcie" + vEnd + "\n");
        }

        Collision stCollTrees = cOwner.TraceTrees(vBarrel, vEnd);
        if (stCollTrees != null)
        {
            fDistance = stCollTrees.fDistance;
            // trafienie w drzewo
            //Log("   Trafione drzewo w punkcie" + vEnd + "\n");
        }

        Collision stCollObjects=cOwner.TraceObjectsExclude(vBarrel, vEnd, cOwner);
        if (stCollObjects != null)
        {
            if (stCollObjects.fDistance < fDistance) fDistance = stCollObjects.fDistance;
            
            //CrashLog("   Trafiony obiekt <" + stCollObjects.Obstacle.getClass().getName() +">w punkcie" + vEnd + 
            //    " " + stCollObjects.ObstacleElement + "\n");
            //((MeshObject)stCollObjects.Obstacle).RotateElement(stCollObjects.ObstacleElement, new Vector(0, 1, 0), 45.f);

            // trafilismy obiekt
            if( stCollObjects.Obstacle != null )
            {
                // odbieramy energie Actorowi
                Vector vSpeed=new Vector(vDir);
                vSpeed.Mul(fBulletSpeed);
                
                Vector vSpeedTmp = new Vector(vSpeed);//bo cObstacle.TakeDamage() normalizuje wektor 
                
                // jako nDamageType wysylany jest numer MeshElementu jaki zostal trafiony
                int iBoneId = ((MeshObject)stCollObjects.Obstacle).GetBoneIDFromMeshElem(stCollObjects.ObstacleElement);
                stCollObjects.Obstacle.TakeDamage(fDamage, fPhysicsSimDamage, cOwner, vEnd, vSpeed, iBoneId, EnumDamageType._BULLET);
                
				CutBodyPart((MeshObject)stCollObjects.Obstacle, stCollObjects.ObstacleElement, vSpeedTmp);
            }
			
            //zapamietujemy ostatnio trafiony controlObject
            oLastHit = stCollObjects.Obstacle;

        }
        else
			oLastHit = null;

        // gdy byla jakakolwiek kolizja to dodajemy efekt
        if ( (stCollTerrain != null) || (stCollObjects != null) || (stCollTrees != null) )
        {
            cOwner.MakeNoiseOnPosition(vEnd, fNoiseHit, Pawn._NOISE_BULLET_HIT);

            ChromeModule cModule = (ChromeModule)GetModule();
            float fCameraDistance = cModule.GetCameraDistance(vEnd);
            
            boolean bNoTraceFX;
            if (stCollObjects != null)
            {
                int iMaterial = stCollObjects.nMaterial;
                if (iMaterial < 0)
                    iMaterial = 0;
                /*
                if ( stCollObjects.Obstacle instanceof TrackedVehicle )
                    iMaterial = 2;
                */
                bNoTraceFX = (stCollObjects.nMaterialFlags & EFaceFlags.SHOOT_THROUGH) != 0;
				Weapon.StaticFxAndSoundManager( cOwner,
										  iMaterial,vEnd,stCollObjects.vNormal, vDir, 
										  stCollObjects.Obstacle, stCollObjects.ObstacleElement,
										  eBulletType, sFXHitName, bNoTraceFX, fCameraDistance );                        
            }
            else
            {
                // nie bylo kolizji z obiektem dynamicznym
                if (stCollTrees != null)
                {
                    bNoTraceFX = (stCollTrees.nMaterialFlags & EFaceFlags.SHOOT_THROUGH) != 0;
                    // kolizja z drzewami
                    Weapon.StaticFxAndSoundManager( cOwner,
                                              0/*powinno byc 1 bo to drzewo*/,vEnd, stCollTrees.vNormal, vDir,
                                              null, 1,
                                              eBulletType, sFXHitName, bNoTraceFX, fCameraDistance );
                }
                else
                {
                    bNoTraceFX = (stCollTrees.nMaterialFlags & EFaceFlags.SHOOT_THROUGH) != 0;
                    // kolizja z terenem
					Weapon.StaticFxAndSoundManager( cOwner, 
											  0, vEnd, stCollTerrain.vNormal, vDir,
											  null, 0,
											  eBulletType, sFXHitName, bNoTraceFX, fCameraDistance );
                }
            }
        }
        
        return fDistance;
    }

    public void CutBodyPart(MeshObject obj, int iElement, Vector vSpeed)
    {      
		if ( !(obj instanceof Pawn) )
			return;
		
		byte eBone = obj.GetBoneIDFromMeshElem(iElement);
		if (eBone == EBones._NON_BONE)
			return;
		
		if ( ((Pawn) obj).CanCutBodyPart(eBone, fDamage) == false)
			return;
		
		if (bCutBodyPartsCutPart)
		{
			//vSpeed.Mul(0.001f);        
			//vSpeed.fY += 1000.0f;
			vSpeed.Mul(0.001f);
			vSpeed.fY += 400.0f;

			obj.ExecuteFXMeshPart(obj, iElement, vSpeed, 1.0f, "CutBodyPartMeshPart", new Vector(0, 0, 0), new Vector(0, 0, 1));
		}

		// uciecie konczyny
		boolean bCut = false;
		if (bCutBodyParts)
			bCut = ((Pawn) obj).CutBodyPart(eBone, fDamage);
		
		if (!bCut)
			return; // nie obcieta wiec nie bryzgamy krwia i nie rzucamy miesem
		
		//i bryzganie krwia
		if ( (bCutBodyPartsBlood) &&
			 (((Pawn) obj).sCutBodyPartsBlood[eBone].length() != 0) )
		{
			Vector vPos = obj.PointWorldToLocal(iElement, obj.GetBoneJointPos(eBone));
			Vector vNormal = obj.VectorWorldToLocal(iElement, obj.GetBoneDirVector(eBone));
			obj.ExecuteParticleSystem(obj, iElement, ((Pawn) obj).sCutBodyPartsBlood[eBone], vPos, vNormal);
		}
	}

    ///////////////////////////////////////////////////////////////////////////
    // Do nadpisania w nastepnych klasach.

    /** Punkt, z ktorego wylatuje pocisk.
     */
    Vector GetFireOrigin()
    {
        return new Vector();
    }

    /** Pobranie z wlasciciela kierunku, w ktory strzelamy
     */
    Vector GetFireDir()
    {
        return new Vector();
    }

    void WeaponMessage(int msg)
    {
        
    }
    
    void MessageLongDelay(float fTime)
    {
        
    }
    
    public void SetFireParams(int nShots, float fRate, float fLongDel, float fRan, float fDam)
    {
        nRoundShots = nShots;
        SetRateOfFire(fRate);
        fLongDelay = fLongDel;
        fRange = fRan;
        fDamage = fDam;
        fPhysicsSimDamage = fDamage;
    }
        
    void SetRateOfFire(float fRate)
    {
        fRateOfFire = fRate;
        fDelay = 60.0f / fRateOfFire;        
    }
}
