public class WeaponGrenade extends Weapon
{
    /**Nazwa dzieku odpalanego przed wyrzutem (odbezpieczenie) */
    // jak Tomek znajdzie czas to obiecal ze ten dzwiek dorobi :-)
    // na razie jego odgrywanie jest zaremowowane...
    public String sSoundPreShoot = "Data/Sounds/Weapon/GrenadePreShoot";
    public String sBulletClassName = "Grenade";
    
    /**
     * Wyrzucanie granawa od razu po nacisnieciu klawisza,
     * a nie dopiero po "naciagnieciu" i puszczeniu
     * TODO: zastanowic sie co sie stanie jak gracz zginie w czasie pomiedzy
     * zawolaniem StartFire a DelayedThrow ...
     */
    //czy granaty wylatuja od razu po nacisnieciu klawisza
    static boolean sm_bThrowOnPressKey = false;
    //parametry dotyczace tego trybu
    //opoznienie faktycznego wyrzucenia od momentu nacisniecia
    //fire, powinien to byc czas trwania animacji zamachu
    float m_fThrowDelay    = 1.2f;
    
//DEL INFO - teraz pozycja wyrzutu zawarta w graczu - GetFireOrigin
//DEL    //o ile podniesc miesce wyrzutu
//DEL    float m_fThrowPosUp      = 30.0f;
//DEL    //o ile podniesc miesce wyrzutu w trybie secondary
//DEL    float m_fThrowPosUpSec   = -100.0f;
    
    //o ile podniesc kierunek wyrzutu
    float m_fThrowAngleUp    = 0.25f;
    //o ile podniesc kierunek wyrzutu w trybie secondary
    float m_fThrowAngleUpSec = 0.25f;
    //sila wyrzutu granata
    float m_fThrowForce      = 13.0f;
    //sila wyrzutu granata w trybie secondary
    float m_fThrowForceSec   = 10.0f;
    //flaga mowiaca o tym, czy w danej chwili mozliwe jest dokonanie
    //wyrzutu, istotne w trybie sm_bThrowOnPressKey
    //domyslnie flaga musi byc na false,
    //wartosci true beda ustawiane tylko na chwile w momencie zaplanowanego
    //wyrzutu (patrz metoda DelayedThrow())
    boolean m_bThrowAllowed = false;
    
    WeaponGrenade()
    {
        super();
        m_nFireMode = _FIREMODE_BURST;//burst bo przy singlu zaraz po nacisnieciu
        //fire jest puszczany
        
        //MeshObject
        MeshName="Data/Meshes/Equipment/granat_zaczepny.3DA";

       
        //Weapon
        nType = EWeaponType._GRENADE;
        sBulletClassName = "Grenade";
        
        //InvObject properites
        nInvIndex = InvObject._W_GRENADE;;
        sName = "&W_N_GRENADE_OFFENSIVE&";
        sInfo = "&W_N_GRENADE_OFFENSIVE&";//"Granat obronny";
        sTexFileName = "Data/Textures/CH_I_Weapons1.png";
        
        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 180.0f;
        nOnTexPosY = 120.0f;
        
        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;

		// Ilosc kratek zajmowanych w plecaku
	    nCellsHeight = 2;
	    nCellsWidth = 2;
		
        //WeaponPistol properties
        fAimAcc = fBaseAcc;

        fDamage             = 37.0f;
        fPhysicsSimDamage   = fDamage;
        fRange              = 65000.0f;
        fBulletSpeed        = 100000.0f;
	    fRateOfFire         = 500.0f;
	    eBulletType         = EAmmoType._Grenades;
		nCapacity		    = 100;

		fNoiseShot = 300.0f; 
		fNoiseHit  = 500.0f;

        /** Klasa mesha pokazywanego w FPP */
        sFPPHandsClass = "FPPHandsGrenadeNormal";
                
        /**Nazwa dzieku odpalanego przy wyrzucie */
        sSoundShoot     = "Data/Sounds/Weapon/GrenadeShoot";
        /**Nazwa dzieku odpalanego przed wyrzutem */
        sSoundPreShoot  = "Data/Sounds/Weapon/GrenadePreShoot";
        
		/**Nazwa FX odpalanego przy wyrzucie (grzebien)*/
		sFXCombName = "FXGrzebienH01";
		
		vBarrelElementPos = new Vector(0.0f, 10.0f, 60.0f);
        
        m_bCanSecondaryFire = true;
    }

    String GetInfoString()
    {
        //nie znamy sily granatu wiec nic nie podajemy
        return  "";
    }
    
    /**Czas po jakim jest pierwsze zwiekszenie sily wyrzutu granatu*/
    public float fUpdateGrenadeForceTime = 0.1f;
    /**O ile jest zwiekszana w czasie sila wyrzutu granata*/
    public float fIncGrenadeForce = 1.0f;
    /**Sila wyrzutu granatu jest zwiekszana od nacisniecia przycisku fire co fUpdateGrenadeForceTime*/
    public float fGrenadeForce = 0.0f;
    /**Maksymala sila wyrzutu granata*/
    public float fMaxGrenadeForce = 15.0f;
    /**flaga czy zostalo puszczone fire*/
    boolean bStopFire = false;
        
    // Identyfikatory zarejestrowanych metod
    int METHOD_ThrowAnimEnded   = 0;
    
    public void OnCreate()
    {
        METHOD_ThrowAnimEnded  = RegisterCallMethod("ThrowAnimEnded");
        
        super.OnCreate();

        CreateBullet();
    }
    
    void CreateBullet()
    {
        if ( Role == ERole._AUTHORITY )
        {
            //tworzymy na serwerze nowy granat
            if ( GetModule() instanceof ModuleNet &&
                 ((ModuleNet)GetModule()).GetObjectsManager() != null )
            {
                cBullet = (Grenade)((ModuleNet)GetModule()).GetObjectsManager().CreateNewObject( sBulletClassName, this );
                cBullet.SetOwner( this );
                                
                //ustawiamy na chama tylko 2 sample dla granatu
                cBullet.nBlastDamageSamples = 2;
            }
            else
                cBullet = (Grenade)CreateObject(sBulletClassName);
            if ( cBullet != null )
                cBullet.Init( this );
            else
                LogD("ERROR:Grenade not created\n");
        }
    }
    
    void Clean()
    {
        super.Clean();
        if ( cBullet == null )
            CreateBullet();
        bGrenadeStarted = false;
    }
    
    /**Nadpisana metoda po weponie po to by moc zliczac czas od mometu ncisniecia
     */
    public void StartFire(byte nMode)
    {
        bStopFire = false;
            
        //mniej wiecej po tym czasie powinna zakonczyc
        //sie czesc "naciagajaca" animacji
        //wtedy zawolamy odpowiednia metode
        CallMethodIn( METHOD_ThrowAnimEnded, m_fThrowDelay );
        
        SendWeaponMessage( STATE_SHOT );
    }
    
    // wlaczenie flagi powoduje ignorowanie jednego stopFire
    boolean bDisableStopFireOnce = false;
    
    /** StopFire, czyli tak naprawde teraz rzucamy granat
     */
    public void StopFire()
    {
        if(bDisableStopFireOnce)
        {
            bDisableStopFireOnce = false;
            return;
        }
        
        if ( ! m_bThrowAllowed )
        {
            //z jakis przyczyn nie mozemy dokonca rzutu
            if ( sm_bThrowOnPressKey )
            {
                //jesli jestetsmy w trybie rzucania na WCISNIECIE to powinnismy 
                //wykonac rzut tylko na specjalne "zyczenie" metody DelayedThrow() 
                //ktora to zawola sie po zakonczeniu animacji naciagania granatu 
                //(ona ustawi nam m_bThrowAllowed na true 
                
                //niestety widac ze animacja sie nie skonczyla,
                //wiec spadamy
                return;
            }
            else
            {
                //jesli jestetsmy w trybie rzucania na PUSZCZENIE to mozemy
                //dokonac rzutu po przyjsciu StopFire, ale nie wczesniej niz
                //zakonczy sie odgrywanie animacji naciagania, to wlasnie
                //animacja zakonczenia naciagania ustawi flage m_bThrowAllowed na true
                
                //jezeli jestesmy w tym miejscu, to oznacza ze to jeszcze nie
                //nastapilo (a gracz juz puscil klawisz), zatem musimy sobie
                //zapamietac, zeby na zakonczenie animacji wymusic rzut
                m_bForceStopFireOnEnfOfAnim = true;
                //i spadamy
                return;
            }                
        }

        //mozna dokonac StopFire, co w przypadku
        //granatu oznacza prawdziwy wyrzut
        
        bStopFire = true;
        
        // hack na to zeby sie nie walilo w sieci, bo w GetOwnerFireDir
        // wolane jest StopFire jesli Owner == null
        if ( Owner == null )
        {
            //jesli granat juz leci to bierzemy ownera z bulleta, zeby mogla sie 
            //odpalic animacja rzutu w sieci
            //TODO: dlaczego tu jest !bNetIsOwner
            if ( cBullet != null && cBullet.Owner != null && !bNetIsOwner)
            {
                //printStackTrace("");
                cBullet.Owner.MessageWeapon( STATE_END_OF_ROUND );
            }
            return;
        }
        
        SendWeaponMessage( STATE_END_OF_ROUND );
        
        SayFireInTheHole();
        
        Vector vOwnerFireDir = GetOwnerFireDir();
        
        //ustawmy parametry wyrzutu w zaleznosci od trybu
        vOwnerFireDir.fY += bSecondaryMode ? m_fThrowAngleUpSec : m_fThrowAngleUp;
        fGrenadeForce     = bSecondaryMode ? m_fThrowForceSec   : m_fThrowForce;
        
        // i oddajemy strzal
        Fire( vOwnerFireDir );
    }
    
     
    /***
     * Metoda informujaca o tym, ze skonczyla sie juz animacja
     * naciagania granatu
     */
    void ThrowAnimEnded()
    {
        if ( sm_bThrowOnPressKey || (GetModule() instanceof ChromeModuleSingle && !IsLeaning_()))
            DelayedThrow();
        else
            AllowThrowOnAnimEnd();
    }
    

    /***
     * 
     * Obsluga rzutu w wersji na WCISNIECIE klawiszem
     * 
     */
    /***
     * Wyszmuszenie rzutu po zakonczeniu animacji
     */
    void DelayedThrow()
    {
        //odblokowujemy mozliwosc dokonania rzutu
        m_bThrowAllowed = true;
        //dokonujemu wyrzucenia granatu
        StopFire();
        //i zablokowujemy mozliwosc dokonania rzutu
        m_bThrowAllowed = false;
        //Uwaga, powyzsza flaga ma wartosc true tylko na chwile 
        //wykonania rzutu dlatego, ze wcale nie jest powiedziane 
        //ze gracz puscil juz klawisz, wiec jak to zrobi dopiero 
        //pozniej to StopFire by sie zawolalo (i wykonalo) jeszcze raz
    }

    /***
     * 
     * Obsluga rzutu w wersji na PUSZCZENIE klawiszem
     * 
     */

    /** Flaga zezwalajaca na rzucenie klawiszem (ustawiana na zakonczenie
     *  animacji "naciagania" granatu" */
    boolean m_bForceStopFireOnEnfOfAnim = false;
    
    /***
     * Metoda informujaca o tym, ze skonczyla sie juz animacja
     * naciagania granatu
     */
    void AllowThrowOnAnimEnd()
    {
        //odblokowujemy mozliwosc dokonania rzutu
        m_bThrowAllowed = true;
        
        //czy gosc juz puscil klawisz?
        if ( m_bForceStopFireOnEnfOfAnim )
        {
            //dokonujemu wyrzucenia granatu
            StopFire();
        }
    }
    
    /**
     * Przy rzucaniu z granatu w grze sieciowej gracz 
     * automatycznie informuje swoich kolesi o tym fakcie
     */
    void SayFireInTheHole()
    {
        //sprawdzenie czy granata wyrzuca lokalny gracz
        if ( Owner != null && Owner.bNetIsOwner )
        {
            //czy to jest w ogole w sieci?
            if ( GetModule() instanceof ModuleNet &&
                ((ModuleNet)GetModule()).GetGameInfo() != null )
            {
                //wolamy voice'a
                ((ModuleNet)GetModule()).GetGameInfo().LocalEventVoiceMessageOnGrenadeThrow();
            }
        }
    }
    
    /** Wyslanie message'a do Ownera
     * przeciazone z weapon
     */
    void SendWeaponMessage(int nState)
    {
        if ( Owner == null )
        {
            //nie wolamy tego, bo w sieci sie sypie
            //StopFire();
            return;
        }
        Owner.MessageWeapon(nState);
    }
    
    void InGameMovieStart()
    {
        if (Owner instanceof Player)
        {
            m_bThrowAllowed = false;
            m_bForceStopFireOnEnfOfAnim = false;
            bStopFire = false;
            super.InGameMovieStart();
            DisableCallMethod( METHOD_ThrowAnimEnded );
            if (Owner.ActiveWeapon == this)
                SendWeaponMessage(STATE_READY);
               
        }
    }
    
    void InGameMovieEnd()
    {
        if (Owner instanceof Player)
        {
            m_bForceStopFireOnEnfOfAnim = false;
            super.InGameMovieEnd();
            if (Owner.ActiveWeapon == this)
                SendWeaponMessage(STATE_READY);
        }
    }
    
    
    
    void Fire(Vector vBarrel, Vector vDir)
    {
//DEL (teraz jest to zawarte w vBarrel)  vBarrel.fY += bSecondaryMode ? m_fThrowPosUpSec : m_fThrowPosUp ;
        //
        //sprawdzamy czy granat na pewno startuje z pozycji wyzszej 
        //niz pozycja nog gracza, zabezpieczajac sie przed tym
        //zeby granat czasem nie byl rzucony pod "ziemia" (np jak gracz lezy)
        if ( Owner != null )
        {
            Vector vPos = Owner.GetPosition();
            if ( vBarrel.fY < vPos.fY + 5.0f )
                 vBarrel.fY = vPos.fY + 5.0f;    
        }

        super.Fire(vBarrel, vDir);
        
        GrenadeThrow(vBarrel,vDir);
    }
    
    void GrenadeThrow(Vector vBarrel, Vector vDir)
    {
        if ( cBullet != null && Owner != null )
        {
            cBullet.SetOwner( this );
            if ( bNetIsOwner )
                cBullet.ActionStart( this, fGrenadeForce, vBarrel, vDir );
        }
        
        GrenadeStarted();
    }
    
    boolean bGrenadeStarted = false;
    
    void GrenadeStarted()
    {
        if ( bGrenadeStarted )
            return;
        
        bGrenadeStarted = true;
        //cBullet = null;
        
        // dzwiek wyrzutu (zamach playera)
        AttachOneShotSound( sSoundShoot, fMinShootSound, fMaxShootSound );
        
        Owner.MakeNoise( fNoiseShot, Pawn._NOISE_WEAPON_FIRING );
        
        // ukrycie granatu w rekach
        Owner.WeaponGrenadeThrown();
        
        //usuwamy siebie z inventory wlasciciela z opoznieniem
        //Owner.WeaponAnnihilate(this);
		WeaponAnnihilate();
    }

    void WeaponAnnihilate()
    {
        if(Owner != null)
            Owner.WeaponAnnihilate(this);
    }
    
    void Unacquire()
    {
        if (cBullet != null)
        {
            cBullet.delete();
            ClearBulletRef();
        }
    }
    
    
    void Acquire(Module mod, Pawn owner)
    {
        super.Acquire(mod, owner);

        if (cBullet == null)
        {
            CreateBullet();
        }

        // updejtujemy handlery
        METHOD_ThrowAnimEnded  = RegisterCallMethod("ThrowAnimEnded");
        
        if (cBullet == null)
            LogR("cBullet ==  null");    
        
        cBullet.Acquire(mod, owner);
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        //mk: do kiego ch...ja to tu jest robione jak w 
        //Weapon.OnDestroy tez bulet jest kasowany!
        //TODO: zastanowic sie czy ma byc kasowany tu czy w Weaponie!!!!!
        if (cBullet != null)
        {
            cBullet.delete();
            ClearBulletRef();
        }
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    public void SGUpdate()
	{
		FileChunk.Log("[WeaponGrenade.SGUpdate]\n");
		super.SGUpdate();

        // wylaczamy naciaganie granatu!
        bStopFire = false;
        m_bThrowAllowed = false;
        m_bForceStopFireOnEnfOfAnim = false;

        DisableCallMethods();

        SendWeaponMessage(STATE_READY);
	}
}
