public class WeaponKnife extends Weapon
{
    static float _DAMAGE_DELAY = 0.1f;
    static int _DAMAGE_TRIALS = 5;
    
    int nDamageTrial = 0;
    
    /** Kat razenia nozem */
    float fRangeDir = 20.0f;
    
    float fRangeDirCos = 20.0f;
        
    /** Opoznienie zadawania ran,
     * domyslnie wartosc ujemna, co zagwarantuje natychmiastowe wykonanie
     * MakeDamage (tak jak dotychczas)
     */
    float  m_fDamageDelay      = -1.0f;
    
    WeaponKnife()
    {
        super();

        //MeshObject
        MeshName="Data/Meshes/Equipment/TPPknife.3DA";

        m_nFireMode = _FIREMODE_BURST;//mozna machac bez przerwy
        
        //Weapon
        nType = EWeaponType._KNIFE;

        //InvObject properites
        nInvIndex = InvObject._W_KNIFE;
        sName = "&W_N_KNIFE&";
        sInfo = "&W_D_KNIFE&";
        sTexFileName = "Data/Textures/CH_I_Weapons2.png";
        
        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 140.0f;
        nOnTexPosY = 0.0f;
        
        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;

		// Ilosc kratek zajmowanych w plecaku
	    nCellsHeight = 1;
	    nCellsWidth = 4;
		
        // nozyk jest 100% celnosci
        fBaseAcc = 1.0f;
        fRunJumpAccChange = 0.0f;
        fDuckSnakeAccChange = 0.0f;
        fWalkSnakeAccChange = 0.0f;
        
        fAimAcc = 0.0f;
        fRecoilAccChange= 0.0f;
        vRecoilShift = new Vector(0, 0, 0);
        
        // jednorazowy damage jaki scyzoryk zabiera przy haknieciu
        fDamage         = 150.0f;
        fPhysicsSimDamage    = 10f;
        
        // promien w jakim kozik razi koluni
        fRange          = 180.0f;
        
        fRateOfFire     = 50.0f;
	    eBulletType     = EAmmoType._Unlimited;

		fNoiseShot = 300.0f;
		fNoiseHit  = 500.0f;

        /** Klasa mesha pokazywanego w FPP */
        sFPPHandsClass = "FPPHandsKnife";
        
        /**Nazwa dzieku odpalanego przy wystrzale */
        sSoundShoot = "Data/Sounds/Weapon/knife_slash1.wav";

		/**Nazwa FX odpalanego przy wystrzale (grzebien)*/
		sFXCombName = "FXGrzebienH01";
		
        //teraz bedzie trzeba recznie ustawic czy
        //dana bron jest blokowana w inwentory czy nie
        bLocked = false;
        
        m_fDamageDelay = _DAMAGE_DELAY;
		
		m_bShowFXBeam = false;
        
        fRangeDirCos = (float)java.lang.Math.cos( java.lang.Math.toRadians(fRangeDir) );
        
        //ta "bronia" nie da sie ani przycelowac ani przeladowac
        m_bAimEnabled    = false;
        m_bReloadEnabled = false;
    }
    
    String GetInfoString()
    {
        return  Text.Get("&W_D_AMMO&") + "N/A" + "\n" +
                Text.Get("&W_D_CAPACITY&") + "N/A" + "\n" +
                Text.Get("&W_D_DAMAGE&") + String.valueOf((int)fDamage) + "\n" +
                Text.Get("&W_D_RANGE&") + String.valueOf((int)(fRange/100)) + "m";
    }
    /** Strzelanie z norzownika
     */
    void Fire(Vector vBarrel, Vector vDir)
    {
        nDamageTrial = 0;
        
        super.Fire(vBarrel, vDir);

        // z noza to mozna walic w wegorza
        nAmmo += 1;
        
        // dzwiek machniecia nozem
        AttachOneShotSound(sSoundShoot, fMinShootSound, fMaxShootSound);
        
        Owner.MakeNoise(fNoiseShot, Pawn._NOISE_WEAPON_FIRING);

        //cios zadawany z malym opoznieniem
        MakeDamageInTime( m_fDamageDelay, vBarrel, vDir );
          
        // TODO badamy czy kozikiem w sciane nie przyjebalismy
        
        // TODO odpalamy efekt trafienia w material
        //FxAndSoundManager(0,vEnd,stCollObjects.vNormal, stCollObjects.Obstacle, stCollObjects.ObstacleElement);
        
        // TODO ewentualnie dodac efekty przy ruszaniu nozem
        //Owner.ExecuteFXBarrel(sFXCombName);
        
        
        //SendWeaponMessage(STATE_SHOT);
    }
    
    
    
    
    void MakeDamageInTime( float fTimeDelay, Vector vBarrel, Vector vDir )
    {
        if ( fTimeDelay < 0.0f )
            MakeDamage( new Vector(vBarrel), new Vector(vDir) );
        else
        {
            m_vBarrel   = new Vector(vBarrel);
            m_vDir      = new Vector(vDir);
            CallMethodIn( "MakeDamage", fTimeDelay );
        }
    }
    
    Vector m_vBarrel = null;
    Vector m_vDir    = null;
    
    void MakeDamage()
    {   
        DisableCallMethod("MakeDamage");
        nDamageTrial++;
        if (nDamageTrial <= _DAMAGE_TRIALS)
            MakeDamage( m_vBarrel, m_vDir );
    }
        
    void MakeDamage( Vector vBarrel, Vector vDir )
    {
        // pobieramy wszyskie cele w kierunku strzala
        ControlObject[] aVictims = GetObjectsInRadiusFromClass( fRange, "Pawn" );
        
        // sprowadzamy walke do parteru
        vBarrel.fY = 0;
        vDir.fY = 0;
        
        vDir.Normalize();
        
        //CrashLog("2 vDir="+vDir+" Owner.Dir="+Owner.GetForwardVector()+"\n");
        boolean bHit = false;
        for (int i=0; i<aVictims.length; i++)
        {
            if ( aVictims[i] ==Owner )  
                continue;
            
            Vector vDirToVictim = aVictims[i].GetPosition();
            vDirToVictim.fY = 0;
            vDirToVictim.Sub( vBarrel );
            vDirToVictim.Normalize();
        
            //CrashLog("aVictims[i]="+aVictims[i]+" vDirToVictim.Dot( vDir )="+vDirToVictim.Dot( vDir )+" fRangeDirCos="+fRangeDirCos+"\n");
            // sprawdzamy czy cel bezporednio przed graczem
            //LogD("vDirToVictim.Dot(vDir)="+vDirToVictim.Dot(vDir)+"\n");
            //LogD("cos(fRangeDir)="+java.lang.Math.cos(fRangeDir)+"\n");
            if( vDir.Dot( vDirToVictim ) > fRangeDirCos)
            {
                bHit = true;
                // walimy kolesiowi
                //((Pawn)aVictims[i]).TakeDamage(fDamage, Owner, new Vector(), new Vector(), -1);
                ((Pawn)aVictims[i]).TakeDamage( fDamage, fPhysicsSimDamage, Owner,
                                                null, Owner.GetForwardVector(), 
                                                EBones._SPINE, EnumDamageType._KNIFE);
                                 //zmienione z _NON_BONE na _SPINE, 
                                 //bo goscie fruwali jak przy granacie
                                 
                //TODO robimy ladny halas
                //MakeNoise(vEnd,fNoiseHit, Pawn._NOISE_BULLET_HIT);
            }
        }
        if (!bHit)
            CallMethodIn( "MakeDamage", m_fDamageDelay );
    }
    
    void OnRemoveFromInventory()
    {
        super.OnRemoveFromInventory();
        DisableCallMethod("MakeDamage");
    }
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[WeaponKnife.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_WEAPON_KNIFE)
        {
            super.SGLoadChunk(cFC);
        
            nDamageTrial = cFC.LoadInt();
		}
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[WeaponKnife.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_WEAPON_KNIFE, cFCParent);
		
		super.SGSaveChunk(cFC);

		cFC.SaveInt(nDamageTrial);

        // kasujemy
        cFC.delete();
    }	   
	
	/*public void SGUpdate()
	{
		FileChunk.Log("[Weapon.SGUpdate]\n");
		super.SGUpdate();
		

	}*/
    
    void CheatGiveAmmo(){}
}
