/** klasa reprezentujaca sprite'a w Inventory
 */
public class SpriteInvObj extends Sprite
{

////////////////////////////////
// atrybuty
///////////////////////////////
	
    boolean m_bCanProcessMouse = true;
    
    void DontProcessMouse()
    {
        m_bCanProcessMouse = false;
    }
    
	/** flaga mowiaca czy  przeciagac Sprite'a wraz z ruchem myszy
	 */
	public boolean bDrag = false;
    
    
//-- ATRYBUTY OBSLUGUJACE  2 CLICK ---------------------------------------------------------
    
    /** flaga mowiaca czy na spricie dokonano 2Click
     */
    public boolean bDoubleClick = false;
    
    /** odstep w sec miedzy klikami - jesl jest mniejszy od podanego to jest DoubleClick
     */
    float fDoubleClickTime = 0.25f;
    
    /** czas poprzedniego clicku
     */
    float fPrevClick = 0.0f;
    
    /** aktualny czas clicku
     */
    float fActualClick = 0.0f;

//-- ATRYBUTY OBSLUGUJACE  2 CLICK ---------------------------------------------------------    

    
	/** poprzednia stabilna pozycja sprite'a
	 */
	Vector cLastPos = new Vector(0,0,0);
	Vector cClickPoint = new Vector(0,0,0);
	Vector cActualSpritePos = new Vector(0,0,0);
	float fDeltaX = 0.0f;
	float fDeltaY = 0.0f;
	
    /** Sprite tla potrzebny do przechwytywania komunikatw
     */
    SpriteInvObjBack cSprBack = null;
    
	/** pomocnicze wartosci
	 */
	float skok = 1.0f;

	/** referencja do InvObjecta
	 */
	InvObject cInvObj = null;
    
    /** flaga mowiaca czy trzeba usunac inv_object
     */
    boolean bDeleteInvObj = false;

////////////////////////////////////////////////////////////////////////
// te zmienne i na ich podstawie obsluga zdarzen myszy to wiekie G 
// ale inne wyjscie to propagowac zdarzenia myszy 
// sprite -> invobject -> invgrid -> inventory -> hud :(
// jezeli chesz by inne hud'y (albo cokolwiek) mialo ta samo mozliwosc
// nalezy dodac referencje do niego oraz odpowiedni "if"
// w zdarzeniach myszy
    
	/** referencja do HUDCompInvPL
	 */
	HUDCompInvPl cHUDInvPl = null;
    
    /** referencja do HUDInvMenu
     */
    ChromeInventoryMenu cInvMenu = null;
    
//-------------------------------------------------------------
    public void OnCreate()
    {
     
     //super.OnCreate();
     cSprBack = (SpriteInvObjBack)CreateObject("SpriteInvObjBack");
     cSprBack.SetNoTexture();
     cSprBack.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(),0));
     cSprBack.ProcessMouse(false);
     AddSprite(cSprBack);
     cSprBack.SetSprInvObj(this);
     
    }
    
    public void OnDestroy()
    {
        //CrashLog("[SpiteInvObj.OnDestroy] cSprBack="+cSprBack+"\n");
        
        //RemoveSprite(this);
        
        if(cSprBack != null)
        {
            GetModule().RemoveSprite(cSprBack);
            cSprBack.delete();
            cSprBack = null;
        }
    }
    
//-------------------------------------------------------------
	/** ustawienie referencji na HUDInvPl
	 */
	public void SetHUDInvPl(HUDCompInvPl HUDPl)
	{
		cHUDInvPl = HUDPl;	
		cInvMenu = null;	
	}
//-------------------------------------------------------------
	/** ustawienie referencji na HUDInvMenu
	 */
	public void SetInvMenu(ChromeInventoryMenu Menu)
	{
		cInvMenu = Menu;	
		cHUDInvPl = null;	
	}
//-------------------------------------------------------------
////////////////////////////////////////////////////////////////////////

	/** ustawienie referencji do InvObject
	 */
	public void SetInvObj(InvObject invobj)
	{
		cInvObj = invobj;
        SetName("spr:"+cInvObj.GetName());
	}

//-------------------------------------------------------------
	/** handler na click na spricie
	 */

	void OnLBDown(float fMouseX, float fMouseY)
	{
        if (!m_bCanProcessMouse || 
            (cInvObj.bMissionCritical && (cInvObj.cInventory instanceof InventoryPlayer))||
             cInvObj.bHidden || cInvObj.bHiddenButUsable)
            return;
        
        if (!cInvObj.IsAvailableInDemo())
        {
            if (GetModule() instanceof ChromeModuleSingle)
            {
                PlayerHUD cPlayer = (PlayerHUD)((ChromeModuleSingle)GetModule()).GetMainPlayer();
                cPlayer.HUD.GetHudUniversal().ShowDemoOKDialog(cInvObj.GetDemoInfoText());
                return;
            }
        }
        
        fPrevClick = fActualClick;
        fActualClick = GetTime();

        if (fActualClick - fPrevClick < fDoubleClickTime)
        {
            fActualClick = 0.0f;
            InitializeDoubleClick(fMouseX, fMouseY);
            DoubleClick();
        }
        else
        {
            if (!CanBeDragged())
                return;
            bDrag = true;
            CallMethodIn("CallDetach", 0);
            InitializeClickOnSprite(fMouseX, fMouseY);
		    if(cHUDInvPl != null)
			    cHUDInvPl.OnLBDownInvObj(fMouseX, fMouseY, cInvObj);
		    if(cInvMenu != null)
			    cInvMenu.OnLBDownInvObj(fMouseX, fMouseY, cInvObj);
        }
	}
    
    boolean CanBeDragged()
    {
        if(cHUDInvPl != null)
            return !cHUDInvPl.bDragingInvObj;
        if(cInvMenu != null)
            return !cInvMenu.bDragingInvObj;
        else 
            return false;
    }
    
    
    void CallDetach()
    {
        DetachFromParent();
        GetModule().AddSprite(this);
    }
        
//-------------------------------------------------------------
	/** handler na puszczenie muszona byszy
	 */
	void OnLBUp(float fMouseX, float fMouseY)
	{
        if (!m_bCanProcessMouse || 
            (cInvObj.bMissionCritical && (cInvObj.cInventory instanceof InventoryPlayer)) || 
            cInvObj.bHidden || cInvObj.bHiddenButUsable ||
            !cInvObj.IsAvailableInDemo())
            return;
		if (bDrag)
        {
			bDrag = false;
            //wlaczam spritea tla
            cSprBack.ProcessMouse(false);
            cSprBack.Hide();
        }

		if(cHUDInvPl != null)
			cHUDInvPl.OnLBUpInvObj(fMouseX, fMouseY, cInvObj);
		if(cInvMenu != null)
			cInvMenu.OnLBUpInvObj(fMouseX, fMouseY, cInvObj);		
	}
	
//-------------------------------------------------------------	
    /** handler na ruszanie mysza
	 */
	void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
	{
        if (!m_bCanProcessMouse || cInvObj.bHidden || cInvObj.bHiddenButUsable)
            return;
        
        if (bDrag) 
        {
            cActualSpritePos = new Vector(fMouseX+fDeltaX, fMouseY+fDeltaY, 0);
            SetPos(cActualSpritePos);
        }
	
		if(cHUDInvPl != null)
			cHUDInvPl.OnMouseMoveInvObj(fMouseX, fMouseY, iButtonsFlags, cInvObj);
		if(cInvMenu != null)
			cInvMenu.OnMouseMoveInvObj(fMouseX, fMouseY, iButtonsFlags, cInvObj);		
	}

    /** handler na ruszanie mysza
	 */
	void OnMouseMoveOut(float fMouseX, float fMouseY, int iButtonsFlags)
	{
        if (!m_bCanProcessMouse || cInvObj.bHidden || cInvObj.bHiddenButUsable)
            return;
        
        if (bDrag) 
        {
            cActualSpritePos = new Vector(fMouseX+fDeltaX, fMouseY+fDeltaY, 0);
            SetPos(cActualSpritePos);
        }
	
		//if(cHUDInvPl != null)
		//	cHUDInvPl.OnMouseMoveInvObj(fMouseX, fMouseY, iButtonsFlags, cInvObj);
		//if(cInvMenu != null)
		//	cInvMenu.OnMouseMoveInvObj(fMouseX, fMouseY, iButtonsFlags, cInvObj);		
	}

    
//-------------------------------------------------------------	
	void OnMouseEnter(float fMouseX, float fMouseY)
	{
        if (!m_bCanProcessMouse || cInvObj.bHidden || cInvObj.bHiddenButUsable)
            return;
        
		if(cHUDInvPl != null)
			cHUDInvPl.OnMouseEnterInvObj(fMouseX, fMouseY, cInvObj);
		if(cInvMenu != null)
			cInvMenu.OnMouseEnterInvObj(fMouseX, fMouseY, cInvObj);		
	}
//-------------------------------------------------------------		
	void OnMouseLeave(float fMouseX, float fMouseY)
	{
        if (!m_bCanProcessMouse || cInvObj.bHidden || cInvObj.bHiddenButUsable)
            return;
        
		if(cHUDInvPl != null)
			cHUDInvPl.OnMouseLeaveInvObj(fMouseX, fMouseY, cInvObj);
		if(cInvMenu != null)
			cInvMenu.OnMouseLeaveInvObj(fMouseX, fMouseY, cInvObj);		
	}
//-------------------------------------------------------------
    /** metoda ustawia (inicjalizuje) wspolrzedne polozenia spritea
     *  po zdarzeniu klikniecia na nim 
     */
    void InitializeClickOnSprite(float fMouseX, float fMouseY)
    {
        cLastPos = new Vector(GetPos());
        cClickPoint = new Vector(fMouseX, fMouseY,0);
        fDeltaX = cLastPos.fX - cClickPoint.fX;
        fDeltaY = cLastPos.fY - cClickPoint.fY;
        
        //Log("Kliknalem na spricie w pozycji x = "+fMouseX+" "+fMouseY+"\n");	
        SetPos(new Vector(cLastPos.fX-skok, cLastPos.fY-skok, 0));
        cActualSpritePos = new Vector(cLastPos.fX-skok, cLastPos.fY-skok, 0);
        fDeltaX = GetPos().fX - cClickPoint.fX;
        fDeltaY = GetPos().fY - cClickPoint.fY;
        
        //wlaczam spritea tla
        cSprBack.ProcessMouse(true);
        cSprBack.Show();
    }
//-------------------------------------------------------------
    /** inicjalizacja DoubleClicka 
     */
    void InitializeDoubleClick(float fMouseX, float fMouseY)
    {
        //wlaczam spritea tla
        cSprBack.ProcessMouse(false);
        cSprBack.Show();
        
    }
//-------------------------------------------------------------    
    /** metoda wywolywa gdy podwojne klikniecie na spricie
     */
    void DoubleClick()
    {
        if(cHUDInvPl != null)
			cHUDInvPl.DoubleClickOnInvObj(cInvObj);
        if(cInvMenu != null)
            cInvMenu.DoubleClickOnInvObj(cInvObj);
        
    }
    
    public void SGUpdate()
    {
        super.SGUpdate();
        fActualClick = GetTime();
    }
}
