/** informacja o obiekcie w inventory room
 */
public class InventoryObjectInfo
{
	/** typ obiektu */
	int m_iType = EInvObjType._NONE;
	
	/** obiektu */
	String m_Name = null;
	
	/** liczba obiektow (elementow obiektu) */
	int m_iAmount = 0;
    
    /** domyslna (poczatkowa) liczba obiektow (elementow obiektu) */
	int m_iDefaultAmount = 0;
    
	/** czy obiekt mozna przeniesc z room do inventory */
	boolean m_bDisabled = false;
    
    InventoryRoom m_cInventoryRoom = null;
	
	InventoryObjectInfo(int iType, String name, int iAmount)
	{
		m_iType = iType;
		m_Name = name;
		m_iAmount = iAmount;
        m_cInventoryRoom = null;
	}

    InventoryObjectInfo(int iType, String sName,InventoryRoom cRoom)
	{
		m_iType = iType;
		m_Name = sName;
		m_iAmount = 0;
        m_cInventoryRoom = cRoom;
	}
    
	InventoryObjectInfo(InventoryObjectInfo obj)
	{
		m_iType = obj.m_iType;
		m_Name = obj.m_Name;
		m_iAmount = obj.m_iAmount;
        m_cInventoryRoom = null;
	}

	
	
	void Modify(InventoryRoomModifier mod)
	{
		switch (mod.m_Command)
		{
			case EInventoryRoomModifiers._ADD:
				m_iAmount += mod.m_Object.m_iAmount;
			break;
			
			case EInventoryRoomModifiers._DEL:
				m_iAmount -= mod.m_Object.m_iAmount;
				if (m_iAmount < 0)
					m_iAmount = 0;
			break;

			case EInventoryRoomModifiers._SET:
				m_iAmount = mod.m_Object.m_iAmount;
				if (m_iAmount < 0)
					m_iAmount = 0;
            break;
                
			case EInventoryRoomModifiers._DISABLE:
				m_bDisabled = true;
			break;
			
			default:
			return;
		}
	}
	
	void ChangeAmount(int iAmountChange)
	{
		m_iAmount += iAmountChange;
		if (m_iAmount < 0)
			m_iAmount = 0;

		if (m_cInventoryRoom != null)
			m_cInventoryRoom.AmountChanged();
	}
	
	public String toString()
	{
		return "Type:" + m_iType + ", name:" + m_Name + ", amount:" + m_iAmount;
	}
    
    
    void RememberDefaultAmount()
    {
        m_iDefaultAmount = m_iAmount;
    }
    
    void ApplyDefaultAmount()
    {
        m_iAmount = m_iDefaultAmount;
    }
    
    
}
