/** klasa, ktorej obiekt (jedyny w grze) zajmuje sie
 * przechowywaniem informacji, co gracz posiada w magazynie
 * broni i wyposazenia. Obiekt tej klasy jest modyfikowany ze skryptu
 */
public class InventoryRoom
{
	/** dostepny w grze obiekt inventory room z aktualnymi danymi */
	InventoryRoom m_InventoryRoom = null;
	
	/** referencja do okna, ktore obsluguje przenoszenie rzeczy pomiedzy
	 * inventory room a inventory gracza
	 */
	ChromeInventoryMenu m_ChromeInventoryMenu = null;
	
	/** wektor obiektow typu InventoryObjectInfo */
	java.util.Vector m_Objects = new java.util.Vector(10);

	InventoryRoom()
	{
		m_InventoryRoom = this;
	}
	
	/** wyszukuje obiekt typu iType i nazwie name w wektorze obiektow objects
	 */
	static InventoryObjectInfo FindObject(java.util.Vector objects, int iType, String name)
	{
		for (int i = 0; i < objects.size(); i++)
		{
			InventoryObjectInfo obj = (InventoryObjectInfo) objects.elementAt(i);
			if (obj.m_iType == iType && obj.m_Name.equals(name))
				return obj;
		}
		return null;
	}
	
	InventoryObjectInfo FindObject(int iType, String name)
	{
		return FindObject(m_Objects, iType, name);
	}
	
	static InventoryObjectInfo FindObject(java.util.Vector objects, String name)
	{
		for (int i = 0; i < objects.size(); i++)
		{
			InventoryObjectInfo obj = (InventoryObjectInfo) objects.elementAt(i);
			if (obj.m_Name.equals(name))
				return obj;
		}
		return null;
	}

	InventoryObjectInfo FindObject(String name)
	{
		return FindObject(m_Objects, name);
	}
	
	/** dodaje obiekt do inventory room. Jezeli typ takiego obiektu istnieje,
	 * to zwiekszany jest jego amount w room, jezeli nie, dodawana jest informacja
	 * o obiekcie (czyli zupelnie nowy wpis).
	 */
	void AddObject(InventoryObjectInfo obj)
	{
		AddObject(obj.m_iType, obj.m_Name, obj.m_iAmount);
	}
	
	/** dodaje obiekt do inventory room. Jezeli typ takiego obiektu istnieje,
	 * to zwiekszany jest jego amount, jezeli nie, dodawana jest informacja
	 * o obiekcie (i ich liczba ustawiana na 1).
	 */
	void AddObject(int iType, String sName, int iAmount)
	{
		InventoryObjectInfo infoObj = FindObject(iType, sName);
		if (infoObj != null)
			infoObj.ChangeAmount(iAmount);
		else
		{
			// dodajemy obiekt do inventory room
			infoObj = new InventoryObjectInfo( iType, sName, this );
			infoObj.ChangeAmount(iAmount);
			m_Objects.addElement(infoObj);
			
			// ale tez musimy obiekt dodac do wyswietlanej listy
			AddObjectToInventoryWindow(infoObj);
		}
	}

	void AddObjectToInventoryWindow(InventoryObjectInfo infoObj)
	{
		if (m_ChromeInventoryMenu == null)
			return;
		switch (infoObj.m_iType)
		{
			case EInvObjType._GUN:
			{
				if (m_ChromeInventoryMenu.m_Weapon == null)
					return;
				m_ChromeInventoryMenu.m_Weapon.addElement(infoObj);
				
                if (m_ChromeInventoryMenu.ListBox_Weapon == null)
                    return;
				m_ChromeInventoryMenu.ListBox_Weapon.AddWeaponObjectToList(m_ChromeInventoryMenu.ListBox_Weapon.WeaponList.size());
			}
			break;
			
			case EInvObjType._AMMO:
			{
				if (m_ChromeInventoryMenu.m_Ammo == null)
					return;
				m_ChromeInventoryMenu.m_Ammo.addElement(infoObj);
                
                if (m_ChromeInventoryMenu.ListBox_Ammo == null)
                    return;
				m_ChromeInventoryMenu.ListBox_Ammo.AddWeaponObjectToList(m_ChromeInventoryMenu.ListBox_Ammo.WeaponList.size());
                
				/*
                if (m_ChromeInventoryMenu.ListBox_Weapon == null)
                    return;
				m_ChromeInventoryMenu.ListBox_Weapon.AddWeaponObjectToList(m_ChromeInventoryMenu.ListBox_Ammo.WeaponList.size());
                */
			}
			break;
			
			default:
			{
				if (m_ChromeInventoryMenu.m_Equipment == null)
					return;
				m_ChromeInventoryMenu.m_Equipment.addElement(infoObj);

                if (m_ChromeInventoryMenu.ListBox_Equipment == null)
                    return;
				m_ChromeInventoryMenu.ListBox_Equipment.AddWeaponObjectToList(m_ChromeInventoryMenu.ListBox_Equipment.WeaponList.size());
                
                /*
                if (m_ChromeInventoryMenu.ListBox_Weapon == null)
                    return;
				m_ChromeInventoryMenu.ListBox_Weapon.AddWeaponObjectToList(m_ChromeInventoryMenu.ListBox_Equipment.WeaponList.size());
                */
			}
		}
	}
	
	void DisableObjects(java.util.Vector mods)
	{
		for (int i = 0; i < mods.size(); i++)
		{
			InventoryRoomModifier mod = (InventoryRoomModifier) mods.elementAt(i);
			if (mod.m_Command == EInventoryRoomModifiers._DISABLE)		
			{
				InventoryObjectInfo info = FindObject(mod.m_Object.m_Name);
				if (info != null)
				{
					// modyfikujemy
					info.Modify(mod);
				}
			}
		}
	}
	
	void FillWeaponsInfo(java.util.Vector weaponsList, java.util.Vector mods)
	{
		if (mods != null)
		{
			// najpierw modyfikujemy liste modami ze skryptw
			for (int i = 0; i < mods.size(); i++)
			{
				InventoryRoomModifier mod = (InventoryRoomModifier) mods.elementAt(i);
				if (mod.m_Object.m_iType == EInvObjType._GUN)
				{
					// znalezlismy modyfikator broni, sprawdzamy, czy w roomie jest taka bron 
					InventoryObjectInfo info = FindObject(EInvObjType._GUN, mod.m_Object.m_Name);
					if (info != null)
					{
						// modyfikujemy bron
						info.Modify(mod);
						continue; // zalozenie jest takie, ze dana bron wystepuje w room tylko raz
					}
					else
					{
						// nie ma takiego obiektu w inventory, ale moze chcemy go dodac
						if (mod.m_Command == EInventoryRoomModifiers._ADD)
						{
							AddObject(mod.m_Object);
							continue; // zrealizowalismy ten modyfikator
						}
                        
                        //by MK w porozumieniu z MZM
                        if (mod.m_Command == EInventoryRoomModifiers._SET)
						{
							AddObject(mod.m_Object);
							continue; // zrealizowalismy ten modyfikator
						}
					}
				}
			}
			DisableObjects(mods);
		}
		
		// teraz uzupelniamy liste, ktora wyslemy do wizualizacji
		for (int i = 0; i < m_Objects.size(); i++)
		{
            InventoryObjectInfo roomObj = (InventoryObjectInfo) m_Objects.elementAt(i);
			if (roomObj.m_iType == EInvObjType._GUN)
				weaponsList.addElement(roomObj);
		}
	}

	void FillAmmoInfo(java.util.Vector ammoList, java.util.Vector mods)
	{
		if (mods != null)
		{
			// najpierw modyfikujemy liste modami ze skryptw
			for (int i = 0; i < mods.size(); i++)
			{
				InventoryRoomModifier mod = (InventoryRoomModifier) mods.elementAt(i);
				if (mod.m_Object.m_iType == EInvObjType._AMMO)
				{
					// znalezlismy modyfikator ammo, sprawdzamy, czy w roomie jest taka bron 
					InventoryObjectInfo info = FindObject(EInvObjType._AMMO, mod.m_Object.m_Name);
					if (info != null)
					{
						// modyfikujemy bron
						info.Modify(mod);
						continue; // zalozenie jest takie, ze dana bron wystepuje w room tylko raz
					}
					else
					{
						// nie ma takiego obiektu w inventory, ale moze chcemy go dodac
						if (mod.m_Command == EInventoryRoomModifiers._ADD)
						{
							AddObject(mod.m_Object);
							continue; // zrealizowalismy ten modyfikator
						}
                        
                        //by MK w porozumieniu z MZM
                        if (mod.m_Command == EInventoryRoomModifiers._SET)
						{
							AddObject(mod.m_Object);
							continue; // zrealizowalismy ten modyfikator
						}
					}
				}
			}
			DisableObjects(mods);
		}
		
		// uzupelniamy liste do wizualizacji
		for (int i = 0; i < m_Objects.size(); i++)
		{
            InventoryObjectInfo roomObj = (InventoryObjectInfo) m_Objects.elementAt(i);
			if (roomObj.m_iType == EInvObjType._AMMO)
				ammoList.addElement(roomObj);
		}
	}
	
	void FillEquipInfo(java.util.Vector equipList, java.util.Vector mods)
	{
		if (mods != null)
		{
			// najpierw modyfikujemy liste modami ze skryptw
			for (int i = 0; i < mods.size(); i++)
			{
				InventoryRoomModifier mod = (InventoryRoomModifier) mods.elementAt(i);
				
				if ( (mod.m_Object.m_iType != EInvObjType._GUN) &&
					 (mod.m_Object.m_iType != EInvObjType._AMMO) )
				{
					// znalezlismy modyfikator ekwipunku, sprawdzamy, czy w roomie jest taka bron 
					InventoryObjectInfo info = FindObject(mod.m_Object.m_iType, mod.m_Object.m_Name);
					if (info != null)
					{
						// modyfikujemy
						info.Modify(mod);
						continue; // zalozenie jest takie, ze dana bron wystepuje w room tylko raz
					}
					else
					{
						// nie ma takiego obiektu w inventory, ale moze chcemy go dodac
						if (mod.m_Command == EInventoryRoomModifiers._ADD)
						{
							AddObject(mod.m_Object);
							continue; // zrealizowalismy ten modyfikator
						}
                        
                        //by MK w porozumieniu z MZM
                        if (mod.m_Command == EInventoryRoomModifiers._SET)
						{
							AddObject(mod.m_Object);
							continue; // zrealizowalismy ten modyfikator
						}
					}
				}
			}
			DisableObjects(mods);
		}
		
		// uzupelniamy liste do wizualizacji
		for (int i = 0; i < m_Objects.size(); i++)
		{
            InventoryObjectInfo roomObj = (InventoryObjectInfo) m_Objects.elementAt(i);
			if ( (roomObj.m_iType != EInvObjType._GUN) &&
				 (roomObj.m_iType != EInvObjType._AMMO) )
				equipList.addElement(roomObj);
		}
	}
	
    /** Pobranie tablicy z bronmi
     */
    java.util.Vector GetCurrentWeaponArray(java.util.Vector mods)
    {
        java.util.Vector aWeaponList = new java.util.Vector();

		// wypelniamy wektor informacjami z inventoryroom
		FillWeaponsInfo(aWeaponList, mods);

		return aWeaponList;
    }
	
    /** Pobranie tablicy z amunicja
     */
    java.util.Vector GetCurrentAmmoArray(java.util.Vector mods)
    {
        java.util.Vector aAmmoList = new java.util.Vector();

		// wypelniamy wektor informacjami z inventoryroom
		FillAmmoInfo(aAmmoList, mods);

		return aAmmoList;
    }
	
    /** Pobranie tablicy ze sprzetem
     */
    java.util.Vector GetCurrentEquipmentArray(java.util.Vector mods)
    {
        java.util.Vector aEquipList = new java.util.Vector();

		// wypelniamy wektor informacjami z inventoryroom
		FillEquipInfo(aEquipList, mods);

		return aEquipList;
    }
    
	void SetMenuWindow(ChromeInventoryMenu menuWindow)
	{
		m_ChromeInventoryMenu = menuWindow;
	}
	
	void AmountChanged()
	{
		if (m_ChromeInventoryMenu == null)
			return;
		if (m_ChromeInventoryMenu.ListBox_Weapon != null)
			m_ChromeInventoryMenu.ListBox_Weapon.UpdateList();
		if (m_ChromeInventoryMenu.ListBox_Ammo != null)
			m_ChromeInventoryMenu.ListBox_Ammo.UpdateList();
		if (m_ChromeInventoryMenu.ListBox_Equipment != null)
			m_ChromeInventoryMenu.ListBox_Equipment.UpdateList();
        if (m_ChromeInventoryMenu.cCurrentList != null)
            m_ChromeInventoryMenu.cCurrentList.UpdateList();
	}

    void Clean()
    {
        m_Objects.removeAllElements();
    }
    
    void Restart(java.util.Vector aInvMods)
    {
        if (m_ChromeInventoryMenu != null)
			//m_ChromeInventoryMenu.ClearLists();
            m_ChromeInventoryMenu.ClearCounters();
        //Clean();
        GetCurrentWeaponArray( aInvMods );
		GetCurrentAmmoArray( aInvMods );
		GetCurrentEquipmentArray( aInvMods );
    }
    
    void RememberDefaultAmounts()
    {
        for (int i = 0; i < m_Objects.size(); i++)
		{
            if ( !(m_Objects.elementAt(i) instanceof InventoryObjectInfo) ) 
                continue;
			((InventoryObjectInfo) m_Objects.elementAt(i)).RememberDefaultAmount();
		}
    }
    
    void ApplyDefaultAmounts()
    {
        for (int i = 0; i < m_Objects.size(); i++)
		{
            if ( !(m_Objects.elementAt(i) instanceof InventoryObjectInfo) ) 
                continue;
			((InventoryObjectInfo) m_Objects.elementAt(i)).ApplyDefaultAmount();
		}
    }
    
    
}
