/** Klasa obiektu, ktory reprezentuje komende mowiaca
 * jaka i ile broni i ekwipunkunalezy dodac / usunac
 * do InventoryRoom na poszczegolnym levelu*/
public class InventoryRoomModifier
{
	/** typ komendy */
	byte m_Command = EInventoryRoomModifiers._NONE;

	/** defaultowy obiekt */
	InventoryObjectInfo m_Object = new InventoryObjectInfo(EInvObjType._NONE,
														   null,
														   0);
    
	InventoryRoomModifier(byte command, int type, String name, int iAmount)
	{
		m_Command = command;
		m_Object.m_iType = type;
		m_Object.m_Name = name;
		m_Object.m_iAmount = iAmount;
	}
	
	InventoryRoomModifier(byte command, int type, String name)
	{
		m_Command = command;
		m_Object.m_iType = type;
		m_Object.m_Name = name;
		m_Object.m_iAmount = 0;
	}
        
    
    /**
     * Stworzenie obiektu na podstawie danych 
     * zawartych w kontenerze (odebranym z komunikatu sieciowego)
     */
    InventoryRoomModifier(NetDataContainer cContainer)
	{
        m_Command           = (byte)cContainer.UnPackInt();
        m_Object.m_iType    = cContainer.UnPackInt();
        m_Object.m_iAmount  = cContainer.UnPackInt();
        int nObjectNameId   = cContainer.UnPackInt();
        m_Object.m_Name     = (nObjectNameId > 0) ? GameObject.GetClassByGUID( nObjectNameId ) : null ;
	}

    /**
     * Wrzucenie stanu obiektu do kontenere 
     * (po to, zeby wyslac to pozniej w siec)
     */
    void PackToContainer( NetDataContainer cContainer )
    {
        cContainer.PackInt( m_Command );
        cContainer.PackInt( m_Object.m_iType );
        cContainer.PackInt( m_Object.m_iAmount );
        int nObjectNameId = (m_Object.m_Name != null) ? GameObject.GetClassGUID( m_Object.m_Name ) : 0;
        cContainer.PackInt( nObjectNameId );
    }
}
