
public class Butterfly extends Destroyable
{
    int i = 0;

    float m_fUpdatePeriod = 2.0f;
    float m_fUpdatePeriodDelta = 1.5f;
    float m_fLastUpdateTime = 0;
    float m_fDeltaRay = 200;// fixit, bylo 200

    Vector m_vPos;
    Vector m_vDir;

    Vector m_vDeltaPos = new Vector(0,0,0);
    Vector m_vDeltaDir = new Vector(0,0,0);

    float fXRadius = 300;
    float fYRadius = 300;
    float fZRadius = 300;

    float fXMin, fXMax;
    float fYMin, fYMax;
    float fZMin, fZMax;
    
    float m_fUpdatePeriodCurrent;

    Vector vLevelExtents = null;
    
    Butterfly()
    {
        MeshName = "data/meshes/animals/MotylekNieruchomy.3da";
        
        fHealth = 1.0f;
        fBlastRange = 100.0f;
        fBlastDamage = 1.0f;
        fDelayTime = 0.0f;
        bDeleteAfterDestroy = true;
        
        sBlowFX = "FXWoodAmmo";
        sBlowSound = null;
    }

    // co jaki czas mamy dokonywac sprawdzenia czy nie wylecielismy
    // motylkiem poza grida, jesli damy < 0.0f nie bedzie sie wolalo wcale
    static float m_fCheckWorldExtentsTime = 5.0f;
    
    public void OnCreate()
    {
        super.OnCreate();

        //ShowCoarseBox(true);
        //ClearFlag(EFlags._COLLISION);
        ClearFlag(EFlags._BLOCK_MOVE);
        ClearFlag(EFlags._NO_ANIMATION);
        
        // FIXIT, do testow
        //Vector vPos = new Vector(300,300,300);
        //vPos.fY = TerrainHeight( vPos.fX,vPos.fZ );
        //SetPosition(vPos);
        //SetDir(Vector.Forward);
        
        m_vPos = GetPosition();
        m_vDir = GetForwardVector();
        
        fXMin = m_vPos.fX - fXRadius;
        fXMax = m_vPos.fX + fXRadius;
        fYMin = m_vPos.fY - fYRadius;
        fYMax = m_vPos.fY + fYRadius;
        fZMin = m_vPos.fZ - fZRadius;
        fZMax = m_vPos.fZ + fZRadius;

        InitAnimSeq("fly", 0, 10);
        PlayAnim("fly", 0);
        
        m_fUpdatePeriodCurrent = m_fUpdatePeriod;
        m_fUpdatePeriodCurrent += (java.lang.Math.random()-.5f) * 2.f * m_fUpdatePeriodDelta;
        
        vLevelExtents = GetTerrainSize();
        
        // sprawdzanie extentow co jakis czas
        if ( m_fCheckWorldExtentsTime >= 0.0f )
            CallMethodEveryMinMax("CheckWorldExtents", m_fCheckWorldExtentsTime, 3*m_fCheckWorldExtentsTime );
        
        // sledzenie playera
        if ( m_bFollowPlayer )
            InitFollowPlayer();
    }
    
    void OnDestroy()
    {
        DisableCallMethod("CheckWorldExtents");
    }
    
/*	public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
	{
		super.OnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
	}
*/      
 	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
	}
		
    /** Odpalamy efekt wybuchu. Do pokrycia w klasach pochodnych, gdy
     * ma byc niestandardowy efekt wybuchu.
     */
    public void SpawnFX()
    {
        if( sBlowFX != null)
        {
            ExecuteFX(sBlowFX, GetPosition(), Vector.Up);
            ExecuteFXTrace(sBlowFX, GetPosition(), Vector.Up);
            ExecuteParticleSystem(sBlowFX, GetPosition(), Vector.Up);
        }

        if( sBlowSound != null)
            PlaySound(sBlowSound);
    }

    
    
    public void OnFrame()
    {
        float fTime = GetTime();
        
        if (fTime - m_fLastUpdateTime >= m_fUpdatePeriodCurrent)
        {
            m_fUpdatePeriodCurrent = m_fUpdatePeriod;
            m_fUpdatePeriodCurrent += (java.lang.Math.random()-.5f) * 2.f * m_fUpdatePeriodDelta;

            //CrashLog( this + "OnFrame()\n");

            int counter = 5;
            do
            {
                // MK: dlaczego tu tak jest?
                m_vPos.Add(m_vDeltaPos);
                m_vDir.Add(m_vDeltaDir);
                
                float x = (float)Math.random() - 0.5f;
                float y = (float)Math.random() - 0.5f;
                float z = (float)Math.random() - 0.5f;
            
                x *= m_fDeltaRay;
                y *= m_fDeltaRay;
                z *= m_fDeltaRay;
            
                                    
                Vector vEnd = new Vector(m_vPos);
                vEnd.fX += x;
                vEnd.fY += y;
                vEnd.fZ += z;
            
                Module cModule = GetModule();
                    
                if (null != TraceTerrain(m_vPos, vEnd)) continue;
                if (null != TraceTrees(m_vPos, vEnd)) continue;
                if (null != TraceObjectsExclude(m_vPos, vEnd, this)) continue;
                if ( cModule != null && 
                     cModule.GetWaterLevel() > vEnd.fY && 
                     y < 0.0f ) 
                    y = -y;
                
                counter = 0;
                m_fLastUpdateTime = fTime;
                
                m_vDeltaPos = new Vector(x,y,z);
                m_vDeltaDir = new Vector(x,y,z);
                m_vDeltaDir.Sub(m_vDir);
                m_vDeltaDir.fY = 0;
           
                //Log("deltapos: " + m_vDeltaPos.fX + "," + m_vDeltaPos.fY + "," + m_vDeltaPos.fZ + "\n");
                //Log("deltadir: " + m_vDeltaDir.fX + "," + m_vDeltaDir.fY + "," + m_vDeltaDir.fZ + "\n");
            
            } while (counter-- > 0);
            
        }

        float t = (fTime - m_fLastUpdateTime) / m_fUpdatePeriodCurrent;
        if (t > 1.0f) t = 1.0f;
        
        Vector vPos = new Vector(m_vDeltaPos);
        vPos.Mul(t);
        vPos.Add(m_vPos);

        Vector vDir = new Vector(m_vDeltaDir);
        vDir.Mul(t);
        vDir.Add(m_vDir);

        // tu jest sprawdzenie czy motylek nie wylecial poza okreslony
        // zakres (w stosunku do miejsca startu)
        // jezeli zastosujemy sledzenie gracza, to trzeba bedzie z tego zrezygnowac
        if ( m_bFollowPlayer == false )
        {
            if (vPos.fX > fXMax) vPos.fX = fXMax;
            if (vPos.fX < fXMin) vPos.fX = fXMin;
            if (vPos.fY > fYMax) vPos.fY = fYMax;
            if (vPos.fY < fYMin) vPos.fY = fYMin;
            if (vPos.fZ > fZMax) vPos.fZ = fZMax;
            if (vPos.fZ < fZMin) vPos.fZ = fZMin;
        }
        
        
        
        //Log("pos: " + vPos.fX + "," + vPos.fY + "," + vPos.fZ + "\n");
        //Log("dir: " + vDir.fX + "," + vDir.fY + "," + vDir.fZ + "\n");
        
        SetPosition(vPos);
        SetDir(vDir);
    }

    /** Sledzenie gracza
     */
    // flaga mowiaca czy ma byc stosowane sledzenia gracza
    boolean m_bFollowPlayer = false;
    // gracz ktorego motylek ma sledzic
    Player m_PlayerToFollow = null;
    // co jaki czas bedziemy sprawdzali odleglosc od gracza
    float m_fCheckPlayerDistaceTime = 10.0f;
    // jaki jest maksymalna dopuszczalna odleglosc od gracza
    float m_fMaxPlayerDistance      = 100.0f;
    
    // do losowania nowej pozycji
    // minimalna odleglosc od gracza "po osi" x i z
    float m_fMinStartDistance      = m_fMaxPlayerDistance * 0.25f;
    // maksymalna odleglosc od gracza "po osi" x i z
    float m_fMaxStartDistance      = m_fMaxPlayerDistance * 0.75f;
    // roznica dwoch powyzszych
    float m_fDeltaStartDistance    = m_fMaxStartDistance - m_fMinStartDistance;
    // maksymalna poczatkowa wysokosc motylka
    float m_fMaxStartHeight        = 100.0f;
    
    /** Inicjalizacja sledzenia gracza
     *  - znalezienie gracza do sledzenia
     *  - sprawdzenie odleglosci
     */
    void InitFollowPlayer()
    {
        m_PlayerToFollow = GetPlayerToFollow();
        CheckPlayerDistance();
    }
    
    /** Sprawdza odleglosc od playera ktorego ma motylek "sledzic"
     * jesli odleglosc jest wieksza niz m_fMaxPlayerDistance, to losyje nowa pozycje
     * funkcja sama wola sie co czas m_fCheckPlayerDistaceTime
     */
    void CheckPlayerDistance()
    {
        if ( m_PlayerToFollow == null ) 
            return;
        
        Vector vPlayerPos = m_PlayerToFollow.GetPosition();
        
        if ( vPlayerPos.Distance( GetPosition() ) > m_fMaxPlayerDistance )
        {
            // wylosowac nowa pozycje
            
            // wezmy wektor jednostkowy,
            Vector vDelta = new Vector( Vector.Forward );
            // wylosujmy jego dlugosc z zadanego przedzialu
            vDelta.Mul( m_fMinStartDistance + m_fDeltaStartDistance * RandomFloat(1.0f) );
            // obrocmy go terac o losowy kat
            vDelta = RotateVector( vDelta, RandomFloat(360.0f), Vector.Up );
            // mamy wyliczona delte, teraz dodajmy to do pozycji playera
            Vector vNewPos = new Vector(vPlayerPos);
            vNewPos.Add( vDelta );
            // sprawdzmy czy ten punkt nie jest czasami poza gridem, ewentualnie bedzie przyciecie
            CheckWorldExtents( vNewPos );
            // znajdzmy wysokosc terenu w tym miejscu
            vNewPos.fY = TerrainHeight( vNewPos.fX,vNewPos.fZ );
            // podniesmy motylka na wysokosc losowa wysokosc
            vNewPos.fY += RandomFloat(m_fMaxStartHeight);
            // vNewPos jest nowa pozycja
                        
            //sprawdzamy czy ta wylosowana pozycja nie jest w budynku
            
            //wezmy wektor w gore
            Vector vUp = new Vector(0, 1000.0f, 0);
            vUp.Add(vNewPos);
        
            // puszczamy tracea w gore
            Collision stCollObject = TraceObjectsExclude(vNewPos, vUp, this);
        
            // jezeli nie ma kolizji z obiektem DoorableObject
            if (stCollObject != null)
            {
                // no nie wiem, moze poprostu olejemy sprawe
                // moze nastepnym razem wylosuje sie lepsze miejsce (?)
            }
            else
            {
                // podmieniamy pozycje
                SetPosition( vNewPos );
                //CrashLog( this + " SetPosition("+vNewPos+") vPlayerPos "+vPlayerPos+"\n");
            }
        }
            
        CallMethodIn("CheckPlayerDistance", m_fCheckPlayerDistaceTime );
    }
    
    /** Pobiera z modulu gracza do sledzenia
     */
    Player GetPlayerToFollow()
    {
        Module cModule = GetModule();
        if ( cModule == null )
        {
            return null;
        }
        
        if ( cModule instanceof ChromeModuleSingle )
        {
            ChromeModuleSingle mod = ((ChromeModuleSingle)cModule);
            return mod.MainPlayer;
        }
        
        if ( cModule instanceof ModuleNet )
        {
            ModuleNet mod = ((ModuleNet)cModule);
            // TODO: pobrac losowego playera z PlayerManagera
            //mod.cPlayerManager.
        }
        
        return null;
    }

    void CheckWorldExtents()
    {
        Vector vPos = GetPosition();
        
        if ( CheckWorldExtents( vPos ) )
            SetPosition( vPos );
    }
    
    float fMarginExtents = 200.0f;
    boolean CheckWorldExtents(Vector vPos)
    {
        boolean bChanged = false;
        
        if ( vPos.fX < 0.0f )
        {
            vPos.fX = fMarginExtents;
            bChanged = true;
        }
        if ( vPos.fZ < 0.0f )
        {
            vPos.fZ = fMarginExtents;
            bChanged = true;
        }
        if ( vPos.fX > vLevelExtents.fX )
        {
            vPos.fX = vLevelExtents.fX - fMarginExtents;
            bChanged = true;
        }
        if ( vPos.fZ > vLevelExtents.fZ )
        {
            vPos.fZ = vLevelExtents.fZ - fMarginExtents;
            bChanged = true;
        }
        
        float fHeight = TerrainHeight( vPos.fX,vPos.fZ );
        // jezeli przesynelismy motylka, ewentualnie jest on pod ziemia,
        // to wyrownujemy do do powierzchni
        if ( vPos.fY < fHeight || vPos.fY > fHeight + m_fMaxStartHeight * 2.0f )
        {
            vPos.fY = fHeight;
            bChanged = true;
        }
        
        return bChanged;
    }
    
}
