public class Barrel extends Destroyable
{
    Barrel()
    {
        SetBarrelParams( this );

        fBlowUpShakeStrength = 300;
        fBlowUpShakeDistMin = 50;
        fBlowUpShakeDistMax = 800;
    }

    /**Metoda ustawiajaca parametry podanego obiektu Destroyable
     * w tym przyopadku Barrel'a
     * Zrobilem to tak dziwnie dlago zeby moze _tymi samymi_
     * parametrami zainicjowac obiekt klasy BarrelNet, ktory nie
     * dziedziczy po Barrel (bo musi "przejsc" przez DestroyableNet
     */
    static void SetBarrelParams( Destroyable cBarrel )
    {
        if ( cBarrel == null )
            return;
        cBarrel.fHealth         = 88.0f;
        cBarrel.fBlastRange     = 350.0f;
        cBarrel.fBlastDamage    = 1000.0f;
        
        cBarrel.sBlowFX         = "FXBlowBarrel";
        cBarrel.sBlowSound      = "Data/Sounds/Demolish/BarrelExplosion";

        /** Beczka nie zmienia mesha (=sie nie demoluje...) i wybucha 
         *  nawet od malego Damage'a jesli tylko jest odpowiednio slaba
         */
        cBarrel.fDemolishThreshold  = 0;
        cBarrel.fBlowThreshold      = 0;
    }
    
}
