
import java.io.*;

public class ChromeMenuLoad extends ChromeMenuWindow 
{
    final static int ID_BTN_SAVE_ITEM = 1000;
	final static int ID_BTN_SAVE_REPLACE = 1001;
	final static int ID_BTN_SAVE_DELETE = 1002;
	final static int ID_BTN_LOAD = 1003;
	final static int ID_DIALOG_OK = 1010;
	
    UIButton btnLoad	= null;
    UIButton btnSave	= null;
	UIButton btnDelete	= null;
	UIButton btnBack	= null;
	UIButton btnMissons	= null;
	
    UIListBox lbMenuSaves	= null;
	UIListBox lbQuickSaves	= null;
	
	UIWindow wndPicture = null;
	
	// YesNoDialog cDialog = null;
	
	static String sSaveDir = "Save";
	
    boolean bOverwrite = false;
	boolean bRemove = false;
    
    {
	nMovieIn = 24;
    nMovieLoop = 25;
	nMovieOut = 26;
	} 
	
    void Init(MenuBackground cBack)
    {
        MenuModule = (ChromeMenuModule)GetModule();
		
        lbMenuSaves  = (UIListBox)GetElem("ID_LISTBOX_MENU_SAVES");
        lbQuickSaves = (UIListBox)GetElem("ID_LISTBOX_QUICK_SAVES");		
		
		btnLoad   = (UIButton)GetElem("ID_BTN_LOAD");
		btnSave   = (UIButton)GetElem("ID_BTN_SAVE");
		btnDelete = (UIButton)GetElem("ID_BTN_DELETE");
		btnBack = (UIButton)GetElem("ID_BTN_BACK");
		btnMissons = (UIButton)GetElem("ID_BTN_MISSIONS");
		
		wndPicture = (UIWindow)GetElem("ID_PICTURE");
        
        InitLists();
        
        LoadList();
        
        UpdateButtons();
        ShowPicture(null);
        
    }
	
    static String GetMenuSaveFileName(int nSlot)
    {
        String sNum = "0" + String.valueOf(nSlot);        
        return sSaveDir + "\\Save" + sNum + ".sav";
    }
	
    static String GetQuickSaveFileName(int nSlot)
    {
        String sNum = "0" + String.valueOf(nSlot);        
        return sSaveDir + "\\Quick" + sNum + ".sav";
    }		
	
    String GetSaveName(File cFile)
    {
        BufferedReader cReader = null;
        String sNameFile = cFile.getPath() + ".lev";
        String sBuffer = new String();
		
        try
        {
            cReader = new BufferedReader( new FileReader( sNameFile ));
            if (cReader != null)
            {
                sBuffer = cReader.readLine();
                cReader.close();
                cReader = null;
            }
        }
        catch (IOException e)
        { 
            GameObject.LogD("ERROR "+this+" " + e.getMessage() +"\n"); 
        }
        return sBuffer + ", " + GetFileDate(cFile);
    }	
	
    void InitLists()
    {
        for (int index = 0; index < 10; index++)
        {
            lbMenuSaves.AddItem(Text.Get("&SAVE_SLOT_EMPTY&"),null);
        }
        for (int index = 0; index < 4; index++)
        {
            lbQuickSaves.AddItem(Text.Get("&SAVE_SLOT_EMPTY&"),null);
        }		
    }
    
    /**Poszukiwanie save'w domyslnym katalogu 
     */
    void LoadList()
    {
        /*lbMenuSaves.Clear();
		lbQuickSaves.Clear();*/
		
        File fSaveDir = new File(sSaveDir);
		
        if (!fSaveDir.exists())
            fSaveDir.mkdir();

        for (int index = 0; index < 10; index++)
        {
            String sName = GetMenuSaveFileName(index);
            File sFile = new File(sName);
            UIButton cItem = lbMenuSaves.GetItem(index);
            if (sFile.exists())
            {
				cItem.SetText(GetSaveName(sFile)); 
                cItem.SetData(sName);
            }
            else
            {
                cItem.SetText(Text.Get("&SAVE_SLOT_EMPTY&")); 
                cItem.SetData(null);
            }
        }
		
        for (int index = 0; index < 4; index++)
        {
            String sName = GetQuickSaveFileName(index);
            File sFile = new File(sName);
            UIButton cItem = lbQuickSaves.GetItem(index);
            if (sFile.exists())
            {
				cItem.SetText(GetSaveName(sFile)); 
                cItem.SetData(sName);
            }
            else
            {
                cItem.SetText(Text.Get("&SAVE_SLOT_EMPTY&")); 
                cItem.SetData(null);
            }
        }		
    }   	
    
    void UpdateButtons()
    {
        UIButton cSelected = null;
		if (lbMenuSaves.GetSelection() != -1)
        {
            cSelected = lbMenuSaves.GetSelected();
            btnSave.SetDisabled(!MenuModule.bInGameMenuAct || cSelected == null );
        }
        else
        {
            //qsave'ow nie mozna sejwowac
            btnSave.SetDisabled(true);
            if (lbQuickSaves.GetSelection() != -1)
                cSelected = lbQuickSaves.GetSelected();
        }
            
        boolean bEmpty = (cSelected == null) || cSelected.GetText().equals(Text.Get("&SAVE_SLOT_EMPTY&"));
        
        
        if (!bEmpty)
        {
            btnLoad.SetDisabled(false);
            btnDelete.SetDisabled(false);
        }
        else
        {
            //slot empty lub brak wyboru
            btnLoad.SetFocus(false);
            btnLoad.SetDisabled(true);
            btnDelete.SetDisabled(true);
        }

		btnBack.SetDisabled(false);
        
        if (MenuModule.bInGameMenuAct)
        {
			btnMissons.SetDisabled(true);
            if (MenuModule.ActiveLevelModule != null &&
                MenuModule.ActiveLevelModule instanceof ChromeModuleSingle &&
                (((ChromeModuleSingle)MenuModule.ActiveLevelModule).IsHudStatsActive() ||
                 ((ChromeModuleSingle)MenuModule.ActiveLevelModule).GetMainPlayer().bDead))
            {
                //koniec misji 
                btnSave.SetDisabled(true);
            }
        }
        else
			btnMissons.SetDisabled(false);
    }
    
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
		
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {		
			if (cSender.m_sId.equals("ID_BTN_LOAD")) 
			{
				if (btnLoad.GetCheck())
				{		
					if(IsGameInProgress())
						ShowYesNoDialog(ID_BTN_LOAD, "&LOAD GAME&", "&LOAD_GAME_Q&", "&BtnYes&", "&BtnNo&");
					else
						{
							Hide();
							LoadGame();	
						}
				}
			}
			else if (cSender.m_sId.equals("ID_BTN_SAVE")) 
			{
				if (btnSave.GetCheck())
				{		
                    boolean bTermoIsActive = MenuModule.ActiveLevelModule.GetMainPlayer().GetImplantSystem().GetImplantTermovision().IsActive();
                    if (bTermoIsActive)
                        MenuModule.ActiveLevelModule.GetMainPlayer().GetImplantSystem().GetImplantTermovision().DeactivateToSave();
					SaveGame();	
                    if (bTermoIsActive)
                        MenuModule.ActiveLevelModule.GetMainPlayer().GetImplantSystem().GetImplantTermovision().ActivateAfterSave();
				}
			}
			else if (cSender.m_sId.equals("ID_BTN_DELETE")) 
			{
				if (btnDelete.GetCheck())
				{									
					RemoveSave();
				}
			}
			else if (cSender.m_sId.equals("ID_BTN_BACK")) 
			{
				if (btnBack.GetCheck())
				{									
					Discard();
				}
			}
			else if (cSender.m_sId.equals("ID_BTN_MISSIONS")) 
			{
				if (((UIButton)cSender).GetCheck())
				{						
                    ChromeMenuLevelSelection.s_bCheatLevelsMenu = false;
					MenuModule.SetMenu("ChromeMenuLevelSelection");					
				}
			}
			
			String sSaveName = null;
			
            if (cSender instanceof UIButton)
            {
                if (lbMenuSaves.FindItem((UIButton)cSender) != -1)
                {
                    UIButton btn = lbMenuSaves.GetSelected();
                    if (btn != cSender)
                    {
                        btn.SetCheck(false);
                    }
                    if (btn != null)
                        sSaveName = (String)btn.GetData();
                    lbQuickSaves.SetSelection(-1);
                    if (nCommand == EUIConst.CM_DBCLICK && 
                        sSaveName != null)
                    {
                        LoadGame();
                        return;
                    }
                }
                else 
                    if (lbQuickSaves.FindItem((UIButton)cSender) != -1)
                    {
                        UIButton btn = lbQuickSaves.GetSelected();
                        if (btn != cSender)
                        {
                            btn.SetCheck(false);
                        }
                        if (btn != null)
                            sSaveName = (String)btn.GetData();
                        lbMenuSaves.SetSelection(-1);
                        if (nCommand == EUIConst.CM_DBCLICK && 
                            sSaveName != null)
                        {
                            LoadGame();
                            return;
                        }
                    }
            }	
            UpdateButtons();
			ShowPicture(sSaveName);			
		}		
		
    }
	
	void ShowPicture(String sSaveName)
	{
		if (sSaveName == null) 
        {
            wndPicture.Hide();
            return;
        }
        wndPicture.Show();

		sSaveName = sSaveName + ".tga";
		File sFile = new File(sSaveName);
		if (!sFile.exists())
			return;
		
		int iOldPictureID = -1;
		if (wndPicture.m_cCurTexture != null)
			iOldPictureID = wndPicture.m_cCurTexture.m_nId;            
	
        int iNewPictureID = wndPicture.AddTexture(sSaveName);
        wndPicture.SetTexture(iNewPictureID,new Rect(0.f,0.f,1.0f,1.0f));		
            
        //usuniecie starej textury
		if (iOldPictureID != -1)
			wndPicture.ReleaseTexture(iOldPictureID);
        
        if (wndPicture.m_cCurTexture != null)
            wndPicture.m_cCurTexture.m_nId = iNewPictureID;
        wndPicture.Show();		
	}
    
	/*
    void RemoveYesNoDialog()
    {
        if( cDialog != null )
        {
            cDialog.Hide();
            cDialog.Destroy();
            GetModule().RemoveSprite(cDialog);
            cDialog.delete();
            cDialog = null;
            bOverwrite = false;
        }
    }
	*/
        
    void Discard()
    {
		if(!CanDiscard())
			return;
		if(m_cYesNoDlg != null)
		{
			return;
		}
		if ( MenuModule.bInGameMenuAct )
        {
            MenuModule.SetMenu("InGameMenu");
            return;
        }
        MenuModule.SetMenu("ChromeMainMenu");
    }
    
    void LoadGame()
    {
        int nSlot = lbMenuSaves.GetSelection();
				
        String sSaveName = null ;
		
		if (nSlot != -1)
		 	sSaveName = GetMenuSaveFileName(nSlot);
		else
		{
		 	nSlot = lbQuickSaves.GetSelection();
		 	if (nSlot != -1)
		 		sSaveName = GetQuickSaveFileName(nSlot);
		}
		
		int nValid = GetModule().cSG.IsValidSaveVersion(sSaveName,ChromeModuleSingle._SAVE_VERSION_NUMBER);
			
		if (nValid == SGController._WRONG_SAVE_VERSION_NUMBER)
		{			
			ShowOKDialog(ID_DIALOG_OK, "&SAVE_INVALID_VERSION_NUMBER&", "&SAVE_INVALID_VERSION_NUMBER_INFO&", null);
			Show();
			return;
		}	
		if (nValid == SGController._DECOMPRESSION_FAILED)
		{			
			ShowOKDialog(ID_DIALOG_OK, "&ERROR&", "&SAVE_INVALID_VERSION_NUMBER_INFO&", null);
			Show();
			return;
		}	
		
        Hide();
        ForceRender();
		FileChunk.Log("Loading <"+sSaveName+">\n");
				
		MenuModule.sSaveGameName = sSaveName;
		MenuModule.StartGame();
		
		if ( MenuModule.bInGameMenuAct )
		{
			if(MenuModule.ActiveLevelModule != null)
            {
                // wylaczamy ewentualnego huda statystyk
                ((ChromeModuleSingle)MenuModule.ActiveLevelModule).DisableMissionEnd();
            }
		}
    }
        
    void RemoveSave()
    {
        if (!bRemove)
        {
			ShowYesNoDialog(ID_BTN_SAVE_DELETE, "&DELETE&", "&ChromeMenuLoadRemoveQuestion&", "&BtnYes&", "&BtnNo&");
            return;
        }
		
		bRemove = false;
		
		String sNumber = null;
		String sFile = null;
				
		int nSelect = lbMenuSaves.GetSelection();	
				
		if (nSelect == -1)
		{
			nSelect = lbQuickSaves.GetSelection();			
			if (nSelect == -1)
				return;
			UIButton btn = lbQuickSaves.GetItem(lbQuickSaves.GetSelection());
			if (btn != null)
				sFile = (String)btn.GetData();
		}
		else
		{
			UIButton btn = lbMenuSaves.GetItem(lbMenuSaves.GetSelection());
			if (btn != null)
				sFile = (String)btn.GetData();
		}
			
        File fSave = new File(sFile);
        if (fSave.delete())
            LogD("Given save was removed !\n");
		fSave = new File(sFile+".lev");
        if (fSave.delete())
            LogD("Given save was removed !\n");
		fSave = new File(sFile+".tga");
        if (fSave.delete())
            LogD("Given save was removed !\n");
		
		
		LoadList();
		
		UpdateButtons();			
    }
	
	String sSaveNameSG = null;
	Module cModuleSG = null;
	SGPreObject cPreObjectSG = null;
	
	void SaveOnFrameEnd()
	{
		cSG.Save(sSaveNameSG,cModuleSG,cPreObjectSG);				
	}
    
    
    /**Robimy sava*/
    void SaveGame()
    {
        String temp = "";
        int nSel = lbMenuSaves.GetSelection();
        if (nSel == -1) 
            return;
		
        String sSaveName = GetMenuSaveFileName(nSel);
		
        File SaveCheck = new File(sSaveName);
        if (SaveCheck.exists() && !bOverwrite)
        {
			SaveCheck = null;			
			ShowYesNoDialog(ID_BTN_SAVE_REPLACE, "&SAVE GAME&", "&SAVE_REPLACE_Q&", "&BtnYes&", "&BtnNo&");
            return;
        }
		try
        {
			MenuModule.StopMenuMusic();
			
			SaveScreenshot(sSaveName);
			
            FileOutputStream jMiniSave = new FileOutputStream(sSaveName,false);
			
            BufferedWriter cWriter = null; 
            
            String sNameFile = sSaveName + ".lev";
            try
            {
                cWriter = new BufferedWriter( new FileWriter( sNameFile ));
            }
			catch (IOException e)
            { 
                GameObject.LogD("ERROR "+this+" " + e.getMessage() +"\n"); 
            }
            LevelContent cLevel = MenuModule.cGameInitInfo.cLevels.GetCurrent();
            String sBuffer = cLevel.sSaveName;
            if (cWriter != null)
            {
                cWriter.write( sBuffer, 0, sBuffer.length() );
                cWriter.close();
                cWriter = null;
            }
            
            InfoText(Text.Get("&MENU_SAVE_SAVING&"));
            ForceRender();                              
			FileChunk.Log("----------------------------\n");
			FileChunk.Log("ChromeGame has started saving <"+sSaveName+"> !\n");
			
			cSG.Save(sSaveName,(ChromeModuleSingle)MenuModule.ActiveLevelModule,((ChromeModuleSingle)MenuModule.ActiveLevelModule).cGameInitInfo);				
			
			/*
			sSaveNameSG = sSaveName;
			cModuleSG = (ChromeModuleSingle)MenuModule.ActiveLevelModule;
			cPreObjectSG = ((ChromeModuleSingle)MenuModule.ActiveLevelModule).cGameInitInfo;			
			CallOnFrameEnd("SaveOnFrameEnd");			
			*/
			
			FileChunk.Log("ChromeGame has finished saving <"+sSaveName+"> !\n");		
			FileChunk.Log("----------------------------\n");
			InfoText("");
            jMiniSave.close();
            MenuModule.SetState("DuringGame");
			
			return;
        }
        catch (IOException e)
        { 
            LogD("Error during saving " + e.getMessage()); 
        }
		
        // ustawiamy flage nadipsywania na false by zawsze zadawal pytanie
        bOverwrite = false;
        LoadList();
		ShowPicture(sSaveName);
    }
	 
	boolean IsGameInProgress()
    {
        return MenuModule.ActiveLevelModule != null &&
               !((ChromeModuleSingle)MenuModule.ActiveLevelModule).m_bMissionEnded;
    }
    
    public String GetFileDate(File aFile)
    {
        long time = aFile.lastModified();
        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat("dd MMM yyyy, H:mm", java.util.Locale.getDefault());
        return sdf.format(new java.util.Date(time));
    }
	
	static boolean bFirstUse = true;
	static int nActiveSave = 0;
	
    static int GetFirstFreeQuickSave()
    {
        File fSaveDir = new File(sSaveDir);
		
        if (!fSaveDir.exists())
            fSaveDir.mkdir();
		
        long nOldestTime = -1;
        int nOldest = -1;
        for (int index = 0; index < 4; index++)
        {
            
            String sName = GetQuickSaveFileName(index);
            File sFile = new File(sName);
            if (!sFile.exists())
            {
                return index;
            }
            else
            {
                if (nOldest == -1 || nOldestTime > sFile.lastModified())
                {
                    nOldest = index;
                    nOldestTime = sFile.lastModified();
                }
            }
        }		
		
		return nOldest;
    }   		
	
	static String GetNextQuickSave()
	{
		nActiveSave = GetFirstFreeQuickSave();
		
		String sNumber = Integer.toString(nActiveSave);
		
		if (sNumber.length() == 1)
			sNumber = "0" + sNumber;
		
		return "save/Quick" + sNumber + ".sav";
	}
	
	static String GetActiveQuickSave()
	{
        long nNewestTime = -1;
        int nNewest = -1;
        for (int index = 0; index < 4; index++)
        {
            String sName = GetQuickSaveFileName(index);
            File sFile = new File(sName);
            if (sFile.exists())
            {
                if (nNewest == -1 || nNewestTime < sFile.lastModified())
                {
                    nNewest = index;
                    nNewestTime = sFile.lastModified();
                }
            }
        }
        
        if (nNewest != -1)
        {
            String sNumber = Integer.toString(nNewest);
		
		    if (sNumber.length() == 1)
			    sNumber = "0" + sNumber;
		
		    return "save/Quick" + sNumber + ".sav";
        }
        else
        {
            return null;
        }
	}	
	
	public static void SaveScreenshot(String sFile)
	{
		File fSave = new File(sFile+".tga");
		File file = new File("save.tga");
        if (fSave.exists())
            fSave.delete();
		file.renameTo(fSave);
	}	
	
    void OnYesFromDlg(int nID)
    {
        super.OnYesFromDlg(nID);
        switch(nID)
        {
		case ID_BTN_LOAD:
			Hide();
			LoadGame();			
			break;
        case ID_BTN_SAVE_REPLACE:
			bOverwrite = true;
			CallMethodIn("SaveGame",0.1f);
            break;
        case ID_BTN_SAVE_DELETE:
			bRemove = true;
			CallMethodIn("RemoveSave",0.1f);			
            break;			
        }
    }
    
    void OnNoFromDlg(int nID)
    {
        super.OnNoFromDlg(nID);
        switch(nID)
        {
		case ID_BTN_LOAD:
			break;
        case ID_BTN_SAVE_REPLACE:
			bOverwrite = false;
            break;
        case ID_BTN_SAVE_DELETE:
			bRemove = false;
            break;						
        }
    }		
}
