public class ChromeMenuWindow extends UserInterface
{
	static final String _DIGITS_ONLY = "0123456789";
	
	int nMovieIn = -1;
	int nMovieLoop = -1;
	int nMovieOut = -1;
    
    MenuYesNoDialog m_cYesNoDlg = null;
	
    ChromeMenuModule MenuModule=null;
	
	java.util.Vector vParams = null;
    
    void SetModule(Module cModule)
    {
        
    }
	 
	void SetParams(java.util.Vector vParams)
	{
		this.vParams = vParams;	
	}	
	
	public void OnDestroy()
	{
		super.OnDestroy();
		DeactivateOnModuleAlways();
		Remove();
		GetModule().RemoveSprite(this);
	}
	
	void Init(MenuBackground cBack)
    {
        ProcessKb(true);
        Log("[ChromeMenuWindow.Init] called\n");
    }
    
    public void OnCreate()
    {
        super.OnCreate();
        
        if (GetScriptName() == null)
            return;
        
        java.io.File scrFile = new java.io.File(GetScriptName());
        
        if (!scrFile.exists())
        {
            Tools.CrashLogError("Unable to find file " + GetScriptName());
            Thread.dumpStack();
        }
        Load(GetModule(), GetScriptName(), true);
    }
    
    String GetScriptName()
    {
        return "data/menu/" + getClass().getName() + ".scr";
    }
    
    // Wolane przez ChromeMenuModule gdy uzytkownik canceluje item lub cale menu zalezy od akcji
    // Tak jaky ktos nacisnal ESC
     
    void Discard()
    {
        Log("[ChromeMenuWindow.Discard] called\n");
    }
	
	boolean CanDiscard()
	{
		//jesli wcisniety LMB to Discard sie kaszani
		if (GetKeyState(EKey._MOUSE_BUTTON1)) 
			return false;
		else 
			return true;
	}
    
    
    public void Dump()
    {
        ScriptWriter cScriptWriter = new ScriptWriter();
        String sFileName = "data/menu/" + getClass().getName() + ".scr";
        cScriptWriter.Open( sFileName );
        cScriptWriter.Write("!include(\"ui.def\")");
        cScriptWriter.NewLine();
        
            //super.Dump(cScriptWriter);

        cScriptWriter.Close();
    }
    
    public void DumpHeader(ScriptWriter cWriter) 
    {
        cWriter.Write("Interface(\"" + getClass().getName() + "\")");
    }
    
    int GetButtonId(String sId)
    {
        String sNumber = "";
        if (sId != null &&
            sId.startsWith("ID_"))
            sNumber = sId.substring(3, sId.length());
        
        int nID = 0;
        if (sNumber.length() > 0)
            nID = Integer.parseInt(sNumber);
        return nID;
    }

	public void Hide()
	{
		super.Hide();
		if ((MenuModule != null) && (MenuModule.cMenuBackground != null))
        {
			//MenuModule.cMenuBackground.Hide();
            MenuModule.cMenuBackground.FullView(true);
            MenuModule.cCursor.Hide();
        }
        UnregisterKeyRequest();
	}
	
	public void Show()
	{
		super.Show();
		if ((MenuModule != null) && (MenuModule.cMenuBackground != null))
        {
			MenuModule.cMenuBackground.Show();
            MenuModule.cCursor.Show();
            if (this instanceof ChromeMainMenu ||
                this instanceof ChromeNetMainMenu ||
                this instanceof InGameMenu ||
                this instanceof ChromeOptionsMenu ||
                this instanceof ChromeNewGameMenu ||
                this instanceof ChromeNewGameMenuTest)
                
                MenuModule.cMenuBackground.FullView(true);
            else
                MenuModule.cMenuBackground.FullView(false);
        }
        CallMethodIn("RegisterKeyRequest",0.01f);
	}
    
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (nKeyCode == EKey._ESCAPE && bKeyState)
            Discard();//CallMethodIn("Discard", 0.0f);
    }
    
    void ShowYesNoDialog(int nID, String sTitle, String sQuestion, String sYesBtn, String sNoBtn)
    {
        if (GetModule() instanceof ChromeMenuModule)
		{
			m_cYesNoDlg = ((ChromeMenuModule)GetModule()).GetYesNoDlg(this);
		}
        if (m_cYesNoDlg != null)
        {
			//CrashLog("YesNoDlg:" + m_cYesNoDlg ); 
			m_cYesNoDlg.InitYesNo(nID, sTitle, sQuestion, sYesBtn, sNoBtn);
            m_cYesNoDlg.CallOnFrameEnd("Show");
            ProcessMouse(false);
            ProcessKb(false);
        }
    }
    
    void ShowOKCancelDialog(int nID, String sTitle, String sQuestion, String sOKBtn, String sCancelBtn)
    {
        if (GetModule() instanceof ChromeMenuModule)
		{
			m_cYesNoDlg = ((ChromeMenuModule)GetModule()).GetYesNoDlg(this);
		}
        if (m_cYesNoDlg != null)
        {
			//CrashLog("YesNoDlg:" + m_cYesNoDlg ); 
			m_cYesNoDlg.InitOkCancel(nID, sTitle, sQuestion, sOKBtn, sCancelBtn);
            m_cYesNoDlg.Show();
            ProcessMouse(false);
            ProcessKb(false);
        }
    }
    
    void ShowOKDialog(int nID, String sTitle, String sQuestion, String sOKBtn)
    {
        if (GetModule() instanceof ChromeMenuModule)
		{
			m_cYesNoDlg = ((ChromeMenuModule)GetModule()).GetYesNoDlg(this);
		}
        if (m_cYesNoDlg != null)
        {
			//CrashLog("YesNoDlg:" + m_cYesNoDlg ); 
			m_cYesNoDlg.InitOk(nID, sTitle, sQuestion, sOKBtn);
            m_cYesNoDlg.Show();
            ProcessMouse(false);
            ProcessKb(false);
        }
    }
    
    void ShowCancelDialog(int nID, String sTitle, String sQuestion, String sCancelBtn)
    {
        if (GetModule() instanceof ChromeMenuModule)
		{
			m_cYesNoDlg = ((ChromeMenuModule)GetModule()).GetYesNoDlg(this);
		}
        if (m_cYesNoDlg != null)
        {
			//CrashLog("YesNoDlg:" + m_cYesNoDlg ); 
			m_cYesNoDlg.InitCancel(nID, sTitle, sQuestion, sCancelBtn);
            m_cYesNoDlg.Show();
            ProcessMouse(false);
            ProcessKb(false);
        }
    }
    
    void OnYesFromDlg(int nID)
    {
        LogR("YES FROM DIALOG");
        ReleaseYesNoDialog();
    }       
    
    void OnNoFromDlg(int nID)
    {
        LogR("NO FROM DIALOG");
        ReleaseYesNoDialog();
    }
    
    void OnOKFromDlg(int nID)
    {
        LogR("OK FROM DIALOG");
        ReleaseYesNoDialog();
    }       
    
    void OnCancelFromDlg(int nID)
    {
        LogR("CANCEL FROM DIALOG");
        ReleaseYesNoDialog();
    }
    
    void ReleaseYesNoDialog()
    {
        if (m_cYesNoDlg == null)
            return;
        
        m_cYesNoDlg.Hide();
        if(GetModule() instanceof ChromeMenuModule)
            ((ChromeMenuModule)GetModule()).ReleaseYesNoDlg(this);
        ProcessMouse(true);
        ProcessKb(true);
        m_cYesNoDlg = null;
    }
    
    ChromeMenuWindow GetYesNoDialogOwner()
    {
        if (m_cYesNoDlg == null)
            return null;
        else
            return m_cYesNoDlg.GetOwner();
    }
    
    void InfoText(String sText)
    {
        SetFont(ChromeFonts.FONT_VERDANA_22);
        SetTextPosFlags(ESpriteText.HORIZ_MIDDLE);
        SetText(sText);
        Vector vTextPos = GetTextPos();
        vTextPos.fY = GetSize().fY - GetSize().fY/10f;
        SetTextPos(vTextPos.fX, vTextPos.fY);
    }

    public void MoveTop()
    {
        super.MoveTop();
        MenuModule.cCursor.CallMethodIn("MoveTop",0);
            
    }
}
