import java.io.*;
public class ChromeControlsMenu extends ChromeMenuWindow
{
    UIListBoxButtonDouble List_Controls;
        
    static String sm_sCurrentControlsFile = ControlLoadSave.sm_sUserControlsFile;
    
	ChromeControlsImplants m_cImplantsMenu = null;
	ChromeControlsMouseMenu m_cMouseMenu = null;
	
    {
	nMovieIn = 3;
	nMovieLoop = 4;
	nMovieOut = 5;
	} 
    
    void Init(MenuBackground cBack)
    {
		MenuModule              = (ChromeMenuModule)GetModule();
        //po to zeby po "pobicie" w sieciowym MenuControls nie stracic tego
        //statica
        sm_sCurrentControlsFile = ControlLoadSave.sm_sUserControlsFile;
            
        
		List_Controls = (UIListBoxButtonDouble)GetElem("ID_LIST_CONTROLS");
		List_Controls.Reload();
		
		LoadActual();
		RefreshListControls();
		//LogR("INITED");
        //SetMouseJoySeting();
    }
	
    float m_fStartTime = 0;
    public void OnCreate()
    {
        m_fStartTime = GetAbsoluteTime();
        //LogR("START TIME " + m_fStartTime);
        super.OnCreate();
        //LogR("END TIME " + GetAbsoluteTime());
    }
    
	public void OnDestroy()
    {
        super.OnDestroy();
        
        if(m_cImplantsMenu != null)
        {
            m_cImplantsMenu.Remove();
            RemoveSprite(m_cImplantsMenu);
            m_cImplantsMenu.delete();
            m_cImplantsMenu = null;
        }
		if(m_cMouseMenu != null)
        {
            m_cMouseMenu.Remove();
            RemoveSprite(m_cMouseMenu);
            m_cMouseMenu.delete();
            m_cMouseMenu = null;
        }
	}
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
		     
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
           if(cSender.m_sId.equals("ID_OK"))
			{
			        /*
			        ControlLoadSave.Invert_Mouse = MouseAndJoy.Button_Invert.GetCheck();
                    ControlLoadSave.SetMouseSens( MouseAndJoy.ButtonLR_Mouse_S.iValue );
                    ControlLoadSave.Joy_SensitivitiX = MouseAndJoy.ButtonLR_JoyX_S.iValue;
                    ControlLoadSave.Joy_SensitivitiY = MouseAndJoy.ButtonLR_JoyY_S.iValue;
                    */
                    ControlLoadSave.SaveControls(sm_sCurrentControlsFile);
                    ControlLoadSave.SetGameControls();
                    Discard();
            }else
			if(cSender.m_sId.equals("ID_CANCEL"))
			{
			        LoadActual();
                    ControlLoadSave.SetGameControls();
                    Discard();
			}else
			if(cSender.m_sId.equals("ID_DEFAULT"))
			{
			        LoadDefault();
                    ControlLoadSave.SetGameControls();
                    //SetMouseJoySeting();
                    CallMethodIn("RefreshListControls", 0);
            }else
		    if(cSender.m_sId.equals("ID_MOUSE"))
			{
				CallMethodIn("ShowMouseControlsMenu",0);
				//MenuModule.SetMenuUnnoticed("ChromeControlsMouseMenu");
			}else
		    if(cSender.m_sId.equals("ID_IMPLANTS"))
			{
				CallMethodIn("OnInplantsButton",0);
			}
        }
    }
	
	void ShowMouseControlsMenu()
	{
		if(m_cMouseMenu != null)
        {
            m_cMouseMenu.Remove();
            RemoveSprite(m_cMouseMenu);
            m_cMouseMenu.delete();
        }
        m_cMouseMenu = (ChromeControlsMouseMenu)CreateObjectNoInit("ChromeControlsMouseMenu");
        m_cMouseMenu.InitObject();
		m_cMouseMenu.SetServerWindow(this,MenuModule);
		Hide();
        m_cMouseMenu.MoveTop();
        m_cMouseMenu.CallMethodIn( "Show", 0.0f );
	}
    
	void RefreshListControls()
	{
        boolean bCreateItems = List_Controls.GetItemCount() == 0;
        for (int index = 0 ; index < ControlLoadSave.ControlsName.length ; index++ )
        {
            String sName = "";//"&"+ControlLoadSave.ControlsName[index]+"&";
            if (ControlLoadSave.ControlsName[index].startsWith("IMPLANT") &&
                ControlLoadSave.ControlsName[index].length() == 8)
            {
                //UWAGA dziala przy zalozeniu ze nie ma wiecej niz 10 implantow
                sName = new String(ControlLoadSave.ControlsName[index]);
                int nImplant = Integer.parseInt(sName.substring(sName.length() - 1, sName.length()));
                nImplant ++;//hack jest pierwszy a jego sie nie wlacza
                sName = "&" + ImplantSystem.GetImplantName(nImplant) + "&";
            }
            else
            {
                sName = ControlLoadSave.ControlsLocalizedName[index];
            }
            int iItemID = -1;
            if (bCreateItems)
                iItemID = List_Controls.AddItem("",null);// (Object)ControlLoadSave.KeyId[index]);
            else
                iItemID = index;
            MenuButtonDouble cItem = (MenuButtonDouble)List_Controls.GetItem(iItemID);
            cItem.SetDoubleText(sName, ControlLoadSave.KeyId[index]);
        }
		//List_Controls.Refresh();
	}
	
    static void LoadDefault()
    {
        LogD("Reading \"" + "Data/DefaultControls.scr" + "\" default controls\n");
        ControlLoadSave.LoadDefaultKeySettings();
    }
    
    void LoadActual()
    {
        LogD("Tu odczytujemy ze skryptu \"" + sm_sCurrentControlsFile + "\" aktualne kontrolsy\n");
        ControlLoadSave.LoadKeySettings(sm_sCurrentControlsFile);
    }
  
	void OnInplantsButton()
	{
		if(m_cImplantsMenu == null)
		{
			m_cImplantsMenu = (ChromeControlsImplants)CreateObjectNoInit( "ChromeControlsImplants" );
			m_cImplantsMenu.InitObject();
			m_cImplantsMenu.SetServerWindow(this,MenuModule);
		}
        Hide();
        m_cImplantsMenu.MoveTop();
        m_cImplantsMenu.CallMethodIn( "Show", 0.0f );
	}
		
    void Discard()
    {
        if(!CanDiscard())
			return;
		MenuModule.SetMenu(MenuModule.sMenuBackName);
    }
}
