public class MovieModule extends Module
{
    //lista plikow avi do odegrania
    String m_sTechlandIntro = "Data/menu/Techland.avi";
    String m_sPublisherIntro = "Data/menu/publisher.avi";
           
    int m_nCurLogo = -1;
    String m_sLogoTextures[] = new String[]{"data\\menu\\Techland_1024x512.jpg", 
                                            "data\\menu\\publisher1_1024x512.jpg",
                                            "data\\menu\\publisher2_1024x512.jpg"};

    float SPLASH_DURATION = 4.0f;
    
    IntroMovieWindow m_cScreen = null;
    boolean bMoviePlaying = false;
    int nCurAvi = 0;

    Sprite m_cLogoScreen = null;
    float m_fLogoAlpha = 0;
    float m_fLogoDestAlpha = 0;
    int m_nLogoCurTex = 0;
    float _LOGO_BLEND_TIME = 1f;
    float _LOGO_STAY_TIME = 3.5f;
    int m_nBlackTex = 0;
    
	void OnCreate()
	{
        CheckLogoTextures();
        
		m_cScreen = (IntroMovieWindow)CreateObject("IntroMovieWindow");
        AddSprite(m_cScreen);
        m_cScreen.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
        m_cScreen.Show();
        m_cScreen.SetModule(this);
        m_cScreen.SetPos(new Vector());
        m_cScreen.MoveTop();
        if (m_sLogoTextures == null)
        {
            TimerStart();
            PlayTechlandIntro();
        }
        else
        {        
            m_nBlackTex = m_cScreen.AddTexture("er_t_black.png");
            m_cScreen.SetTexture(m_nBlackTex, Rect.WHOLE_TEX);
            
            m_cLogoScreen = (Sprite)CreateObject("Sprite");
            AddSprite(m_cLogoScreen);
            m_cLogoScreen.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            m_cLogoScreen.Show();
            m_cLogoScreen.SetPos(new Vector());
            m_cLogoScreen.MoveTop();
            TimerStart();
            NextLogo();
            RegisterKeyRequest();

        }
	}
    
    void CheckLogoTextures()
    {
        if (m_sLogoTextures == null)
            return;
        
        java.util.Vector vTexes = new java.util.Vector();
        for (int i = 0; i < m_sLogoTextures.length; i++)
        {
            java.io.File cFile = new java.io.File(m_sLogoTextures[i]);
            if(cFile.exists())
            {
                vTexes.addElement(m_sLogoTextures[i]);
            }
        }
        if (vTexes.size() > 0)
        {
            m_sLogoTextures = new String[vTexes.size()];
            for (int i = 0; i < vTexes.size(); i++)
            {
                m_sLogoTextures[i] = (String)vTexes.elementAt(i);    
            }
        }
        else
        {
            m_sLogoTextures = null;
        }
    }
    
    public void NextLogo()
    {
        DisableCallMethod("NextLogo");
        DisableCallMethod("FadeOutCurLogo");
        m_nCurLogo++;
        if (m_nCurLogo >= m_sLogoTextures.length)
        {
            MenuSpawn();
            return;
        }
        if (m_nLogoCurTex != 0)
            m_cLogoScreen.ReleaseTexture(m_nLogoCurTex);
        m_nLogoCurTex = m_cLogoScreen.AddTexture(m_sLogoTextures[m_nCurLogo],true, true, ETextureQuality.HIGH);
        m_cLogoScreen.SetTexture(m_nLogoCurTex, Rect.WHOLE_TEX);
        
        /*float fSizeCoeff = GetScreenWidth()/m_cLogoScreen.GetTextureWidth(m_nLogoCurTex);
        m_cLogoScreen.SetSize(new Vector(GetScreenWidth(), fSizeCoeff * m_cLogoScreen.GetTextureHeight(m_nLogoCurTex), 0));
        m_cLogoScreen.SetPos(new Vector((GetScreenWidth() - m_cLogoScreen.GetSize().fX )/2f, 
                         (GetScreenHeight() - m_cLogoScreen.GetSize().fY)/2f,0));
        */ 
        m_cLogoScreen.SetAlpha(0);
        m_fLogoAlpha = 0;
        m_fLogoDestAlpha = 1;
        CallMethodIn("FadeOutCurLogo", _LOGO_BLEND_TIME + _LOGO_STAY_TIME);
    }
    
    public void FadeOutCurLogo()
    {
        m_fLogoDestAlpha = 0;
        CallMethodIn("NextLogo", _LOGO_BLEND_TIME);
    }
    
    float m_fLastTime = 0;
    float fTotalTime = 0;
    public void OnFrame()
    {
        if (m_cLogoScreen == null)
            return;
        
        float fTime = GetTime();
        if (m_fLastTime == 0)
            m_fLastTime = fTime;
        float fTimeDelta = fTime - m_fLastTime;
        if (m_fLogoAlpha > m_fLogoDestAlpha)
        {
            m_fLogoAlpha -= (1f/_LOGO_BLEND_TIME) * fTimeDelta;
            if (m_fLogoAlpha < m_fLogoDestAlpha)
                m_fLogoAlpha = m_fLogoDestAlpha;
        }
        else
        {
            if (m_fLogoAlpha < m_fLogoDestAlpha)
            {
                m_fLogoAlpha += (1f/_LOGO_BLEND_TIME) * fTimeDelta;
                if (m_fLogoAlpha > m_fLogoDestAlpha)
                    m_fLogoAlpha = m_fLogoDestAlpha;
            }
        }
        fTotalTime += fTimeDelta;
        m_cLogoScreen.SetBackgroundAlpha(m_fLogoAlpha);
        m_cLogoScreen.SetAlpha(m_fLogoAlpha);

        
        m_fLastTime = fTime;
    }
    
    void OnDestroy()
    {
        //CrashLog("==--> LogoWindow.OnDestroy\n");
        DestroySprites();
        ((ChromeGame)ChromeGame.cSingleton).movieModule = null;
    }

    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        
		if (!bKeyState)
		{
			if (nKeyCode == EKey._ESCAPE ||				
				nKeyCode == EKey._SPACE)
			{
				if (bMoviePlaying)
					CallMethodIn(m_cScreen.sCallBackMethod, 0.0f);
                else
                    if (m_nCurLogo != -1)
                        NextLogo();
			}
		}
	}
    
////////////////////////
// metody pomocnicze

    void DestroySprites()
    {
        if(m_cScreen != null)
        {
            if (m_nBlackTex!= 0)
                m_cScreen.ReleaseTexture(m_nBlackTex);
            RemoveSprite(m_cScreen);
            m_cScreen.delete();
            m_cScreen = null;
        }
        if (m_cLogoScreen != null)
        {
            if (m_nLogoCurTex!= 0)
                m_cLogoScreen.ReleaseTexture(m_nLogoCurTex);
            RemoveSprite(m_cLogoScreen);
            m_cLogoScreen.delete();
            m_cLogoScreen = null;
        }
    }
    
    void PlayAvi(String sAVI, String sMethod, int nMode)
    {
        java.io.File fAVI = new java.io.File(sAVI);
        if(!fAVI.exists())
        {
            CallMethodIn(sMethod, 0.0f);
            return;
        }
        
        RegisterKeyRequest();
        bMoviePlaying = true;
        
        SpriteClearColor(0,0,0);
        SpriteClearScreen(true);
        
        m_cScreen.PlayAVI(sAVI, nMode, sMethod);
    }
    
    void MovieFinished()
    {
        DisableCallMethod(m_cScreen.sCallBackMethod);
		
        if (!bMoviePlaying)
            return;				
		
        m_cScreen.StopAVI();
        bMoviePlaying = false;
    }
    
////////////////////////////////////////////////////////////////
// TE METODY WOLANE SA POKOLEI TAK JAK SA TERAZ ZAPISANE
    
    void PlayTechlandIntro()
    {
        float fSizeCoeff = GetScreenWidth()/640f;
        
        m_cScreen.SetSize(new Vector(GetScreenWidth(), fSizeCoeff * 480, 0));
        m_cScreen.SetPos(new Vector((GetScreenWidth() - m_cScreen.GetSize().fX )/2f, 
                         (GetScreenHeight() - m_cScreen.GetSize().fY)/2f,0));
        // wlaczamy pierwszego avika
        PlayAvi(m_sTechlandIntro, "MovieFinishedTechland", Sprite._MOVIE_MODE_FITTOSPRITE);
    }
    
    void MovieFinishedTechland()
    {
		MovieFinished();
        
        PlayPublisherIntro();
    }
    
    void PlayPublisherIntro()
    {
        float fSizeCoeff = GetScreenWidth()/640f;
        
        m_cScreen.SetSize(new Vector(GetScreenWidth(), fSizeCoeff * 480f, 0));
        m_cScreen.SetPos(new Vector((GetScreenWidth() - m_cScreen.GetSize().fX )/2f, 
                         (GetScreenHeight() - m_cScreen.GetSize().fY)/2f,0));
        PlayAvi(m_sPublisherIntro, "MovieFinishedPublisher", Sprite._MOVIE_MODE_FITTOSPRITE);
    }
    
    void MovieFinishedPublisher()
    {
        MovieFinished();
        
        // wylaczamy tlo, zeby bylo czarno
        SpriteClearColor(0,0,0);
        SpriteClearScreen(false);
        ForceRender();
        
        // wlaczamy menu
        MenuSpawn();
    }

    void MenuSpawn()
    {
        Deactivate();
        DestroySprites();
        UnregisterKeyRequest();
        CallOnFrameEnd("delete");
        ((ChromeGame)ChromeGame.cSingleton).CallOnFrameEnd("CreateMenu");
    }
}
