public class AIAlarmer extends AIAttacker implements IAlarmID
{
    public Alarm cAlarm = null;//#\AIALARMER;Alarm connected with this AI
    
	public int m_iAlarmID = AlarmsManager._DEFAULT_ALARM_ID;//#AI_ALARMER
	
    final static int _ACTION_PRESS_BUTTON = 1001;
	
	ChromeModuleSingle m_cLevel = null;

	public void OnCreate()
	{
		super.OnCreate();
		
		m_cLevel = (ChromeModuleSingle) GetModule();
		if (aPath != null)
			aPath.nFlags |= AIPatrolerPath._PATROLPATH_ONCE;
	}
    
    public void OnPostCreate()
    {
        if (cAlarm != null)
            cAlarm.AddAlarmObject(this);
    }
    
    public void SetAlarmID(int iAlarmID)
    {
        m_iAlarmID = iAlarmID;
    }
    
    public int GetAlarmID()
    {
        return m_iAlarmID;
    }
    
	public void Run()
	{
		super.Run();
		
		if (aPath != null)
			aPath.nFlags |= AIPatrolerPath._PATROLPATH_ONCE;
		SetState("Idle");
	}

    public class Patrol extends AIAttacker.Patrol
    {
		public void OnReact()
		{
			if (bDead)
				return;
			if (m_cLevel.m_AlarmsManager.IsAlarmEnabled(m_iAlarmID))
				AttackEnemy(m_cLevel.MainPlayer);
		}
		
/*		public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
		{
			if (bDead)
				return;
			if (Assassin instanceof Player)
				SuperOnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
		}
*/		
		// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
		public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
		{
			if (bDead)
				return;
			if (Assassin instanceof Player)
				SuperOnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
		}
		
		public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
		{
		}
    }
	
    void PatrolPointReached()
    {
		super.PatrolPointReached();
		
		if (nCurrentNode == aPath.GetPointsNum() - 1)
			TurnOnAlarm();
    }
		
    public void TurnOnAlarm()
    {
		if (bDead)
			return;
		if (!m_cLevel.m_AlarmsManager.IsAlarmEnabled(m_iAlarmID))
			SetState("TurnigAlarm");
    }
	
    public class Idle extends AIAttacker.Idle
    {
        public void OnReact()
        {
			if (bDead)
				return;
			
			super.OnReact();
		
            ChromeActor cTarget = GetNearestEnemyInSight();
            if (cTarget != null)
			{
				if (!m_cLevel.m_AlarmsManager.IsAlarmEnabled(m_iAlarmID))
				{
					nReadinessToSearch = 100;
					SetState("Patrol");
				}
				else
					AttackEnemy(cTarget);
			}
		}

/*		public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
		{
			if (bDead)
				return;
			
			if (Assassin instanceof Player)
				SuperOnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
			if (Assassin instanceof Player)
			{
				if (!m_cLevel.m_AlarmsManager.IsAlarmEnabled(m_iAlarmID))
				{
					nReadinessToSearch = 100;
					SetState("Patrol");
				}
				else
					AttackEnemy((Player) Assassin);
			}
		}
*/		
		// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
		public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
		{
			if (bDead)
				return;
			
			if (Assassin instanceof Player)
				SuperOnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
			if (Assassin instanceof Player)
			{
				if (!m_cLevel.m_AlarmsManager.IsAlarmEnabled(m_iAlarmID))
				{
					nReadinessToSearch = 100;
					SetState("Patrol");
				}
				else
					AttackEnemy((Player) Assassin);
			}
		}
		
		public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
		{
			if (bDead)
				return;
			
			if (Noisy instanceof Player)
			{
				ClearTasks();
				vDesiredDir = Noisy.GetPosition();
				vDesiredDir.Sub(GetPosition());
				vDesiredDir.Normalize();
				NewTask(_ACTION_TURN_QUICK);
			}
		}
    }

	void AttackEnemy(ChromeActor enemy)
	{
		if (bDead)
			return;
		nReadinessToSearch = 100;
        UpdateLastKnownEnemyPos(enemy, false);
        StartEnemyInSightTimers();
        nAttackCause = _ATTACK_CAUSE_SIGHT;
        Attack(enemy);
	}
	
    public class TurnigAlarm extends AIBaseState
    {
		Vector m_vToAlarmDir = null;
		
		public void OnEnter()
		{
			if (bDead)
				return;
			
			super.OnEnter();
			
			if (m_cLevel.m_AlarmsManager.GetTerminalsByID(m_iAlarmID) == null)
			{
				AttackEnemy(m_cLevel.MainPlayer);
				return;
			}
			
			m_vToAlarmDir = FindNearestTerminalPos();
			m_vToAlarmDir.Sub(GetPosition());
			m_vToAlarmDir.Normalize();
		}
		
		Vector FindNearestTerminalPos()
		{
			Vector vPos = GetPosition();
			
			java.util.Vector terminals = m_cLevel.m_AlarmsManager.GetTerminalsByID(m_iAlarmID);
			
			Vector vNearest = ((AlarmTerminal) terminals.elementAt(0)).GetPosition();
			float fMinDist = vPos.Distance(vNearest);
			
			for (int i = 1; i < terminals.size(); i++)
			{
				if (((AlarmTerminal) terminals.elementAt(i)).GetPosition().Distance(vPos) < fMinDist)
				{
					vNearest = ((AlarmTerminal) terminals.elementAt(i)).GetPosition();
					fMinDist = vPos.Distance(vNearest);
				}
			}
			return vNearest;
		}
		
		public void OnMakeDecisionEntering()
		{
			if (bDead)
				return;
			ClearTasks();
			vDesiredDir = m_vToAlarmDir;
			NewTask(_ACTION_TURN_QUICK);
			NewTask(_ACTION_PRESS_BUTTON);
		}
		
		public void OnMakeDecision()
		{
		}
		
        public void OnReact()
        {
		}
		
		public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
		{
		}
		
/*		public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
		{
			if (Assassin instanceof Player)
				SuperOnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
		}
*/		
		// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
		public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
		{
			if (Assassin instanceof Player)
				SuperOnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
		}
	}
	
	void AlarmOthers()
	{
		if (m_cLevel == null)
			return;
		m_cLevel.m_AlarmsManager.EnableAlarm(true, m_iAlarmID);
		AttackEnemy(m_cLevel.MainPlayer);
	}
	
    void TakeAction(int nAction)
    {
        bActionInProgress = true;
        switch (nAction)
        {
	        case _ACTION_PRESS_BUTTON:
			{
                PerformAnimTask(Anims[A_IDLE_KEYBOARD], 1);
				CallMethodOnceIn("AlarmOthers", GetAnimLength(Anims[A_IDLE_KEYBOARD]));
			}
            break;
            
        default:
            super.TakeAction(nAction);
        }
    }
	
	void CancelAction(int nAction)
	{
        if (bActionInProgress)
        {
            switch(nAction)
            {
	            case _ACTION_PRESS_BUTTON:
                {
                    StopAnim("");
                    DisableCallMethod(METHOD_AnimationTaskFinished);
					DisableCallMethod("AlarmOthers");
				}
				break;
				
	            default:
		            super.CancelAction(nAction);
			}
		}
        bActionInProgress = false; // juz sie nie wykonuje
	}
}
