/** Dodanie wskazanych przedmiotow do Inventory podanego obiektu. 
 *  Po wykonaniu tego dodawania 
 */
public class InstantAddToInventory extends InstantAction
{
    {sEditorComment = "Adds given objects to targets inventory";}

    public Pawn cTarget = null;//#\;Object with destination inventory

    public InvObjectInst[] aItemsToAdd = null;//#\;Items from module to add to inventory
    
    public Action[] aOnSuccess = null;//#\;Actions performed when all items are successfully added

    public Action[] aOnFailure = null;//#\;Actions performed when at least one object can't fit in inventory

    public void Invoke()
    {
        boolean bSuccess = true;
        if (aItemsToAdd != null && cTarget != null)
        {
            InvObjectInst cItem = null;
            for (int i=0; i<aItemsToAdd.length; i++)
            {
                cItem = aItemsToAdd[i];
                if (cItem != null)
                {
                    cItem.Appear(null);
                    cItem.bJustTakenToInventory = false;
                    cItem.Execute(cTarget);
                    bSuccess &= cItem.bJustTakenToInventory;
                }
            }
            InvokeActionChain(bSuccess ? aOnSuccess : aOnFailure);
        }
    }
}
