/** Podpiecie jednego obiektu do drugiego z mozliwoscia dopasowania podanych meshelementow
 */
public class InstantAttachTo extends InstantAction
{
    public MeshObject cParentObject = null;//#;
    public MeshObject cChildObject = null;//#;
    public String sParentsElement = null;//#;
    public String sChildsElement = null;//#;
    public boolean bKeepWorldPos = false;//#;
    
    public void Invoke()
    {
        if (cParentObject == null ||
            cChildObject == null)
            return;
        
        if (bKeepWorldPos)
            cParentObject.AttachChildAndKeepWorldPos(cChildObject);
        else
        {
            int nParentDummy = -1,
                nChildDummy = -1;
            if (sParentsElement != null)
            {
                nParentDummy = cParentObject.GetElementID(sParentsElement);
                if (nParentDummy < 0)
                    GameObject.CrashLog("[InstantAttachTo.Invoke] ERROR: Can't find element '" +
                                        sParentsElement + "' in object '" +
                                        cParentObject.GetName() + "'!\n");
            }
            if (sChildsElement != null)
            {
                nChildDummy = cChildObject.GetElementID(sChildsElement);
                if (nChildDummy < 0)
                    GameObject.CrashLog("[InstantAttachTo.Invoke] ERROR: Can't find element '" +
                                        sChildsElement + "' in object '" +
                                        cChildObject.GetName() + "'!\n");
            }
  
            if (nChildDummy != -1)
                cChildObject.SetPivotPointFromElement(nChildDummy);

            if (nParentDummy != -1)
                cParentObject.AttachChild(cChildObject, nParentDummy);
            else
                cParentObject.AttachChild(cChildObject);
        }
    }
}
