public class Movie extends GameObject
{
    // okresla czy ma zostac ostatnia ramka po filmie
    public boolean bLeaveLastFrame = true;//#PARAMS;
    
    // okresla czy gra miec zatrzymany czas podczas filmu
    public boolean bFreezeGame = false;//#PARAMS;
    
    // wylaczanie napisow podczas filmu
    public boolean bNoSubtitles = false;//#PARAMS;
    
    // pozwala na zablokowanie przerywania filmu
    public boolean bBreakable = true;//#PARAMS;
    
    // przelacza blokowanie gracza, przydaje sie w filmach bez kamer
    public boolean bLockPlayer = true;//#PARAMS;
    
    // gdy true po przerwaniu filmu zostanie ustawiony stan obiektow z ostatniej ramki
    public boolean bUpdateToEndOnBreak = false;//#PARAMS;
    
    public float fWorldFadeIn = 0.5f;//#FADE;Time of fading in world after movie
    public float fWorldFadeOut = 0.5f;//#FADE;Time of fading out world before movie
    
    public float fMovieFadeIn = 0.5f;//#FADE;Time of fading in movie on start
    public float fMovieFadeOut = 0.5f;//#FADE;Time of fading out movie before end
    
    // akcje wykonywane przed odpaleniem filmu
    public Action[] aPreActions = null;//#\ACTIONS;
    
    // akcje wykonywane po zakonczeniu filmu
    public Action[] aPostActions = null;//#\ACTIONS;
    
    // numerek filmu do odegrania
    public int nMovie = -1;//#MOVIE;
    
    // muzyka odgrywana podczas filmu
    public Music cMusic = null;//#MOVIE;
    
    // komentarz do filmu
    public String sComment = null;//#MOVIE;

    public boolean bDisableAIRadioCommunication = true;//#MOVIE;

    // ustawienie guna Logana w czasie filmu
    public EnumMovieGun cGun = new EnumMovieGun(EnumMovieGun._DONT_CARE);//#MOVIE;
    
    private GameObject cBackObject = null;
    private String sBackMethod = null;
    
    private int nMusic = 0;
	
	Movie()
	{
		bSG = true;		
	}
    
    public void Play(GameObject cBackObj, String sBackMth)
    {
        cBackObject = cBackObj;
        sBackMethod = sBackMth;
        
        ChromeModule cModule = (ChromeModule)GetModule();
        
        if(cModule instanceof ChromeModuleSingle)
        {
            // po zakonczeniu misji nie ma juz filmow!
            if(((ChromeModuleSingle)cModule).m_bMissionEnded)
                return;
        }
        
        cModule.PlayMovie(this);
    }
	
	//GameObject[] aObjs = null;
	//boolean[] aUpdatingPathMap = null;
	
	boolean bMovieStarted = false;
    
    void OnMovieStart()
    {		
        //CrashLog("[Movie.OnMovieStart] "+GetTime()+"\n");
		
		ChromeModule cModule = (ChromeModule)GetModule();
		
		/* TO BYO NA POTRZEBY BROWN'S DAUGHTER !!! ZOSTAWA STAMP 
		// i nie mozna bylo skonczyc levelu. Teraz to wywalam, bo jest to robione
		// w edytorze
		
		aObjs = cModule.GetObjectsFromClassModule("NewAIHuman", cModule);
		aUpdatingPathMap = new boolean[aObjs.length];
		
		for (int i=0; i < aObjs.length; i++)
			if ((aObjs[i] instanceof ControlObject) && (((ControlObject)aObjs[i]).IsUpdatingPathMap() == true))
			{
				aUpdatingPathMap[i] = true;
				((ControlObject)aObjs[i]).UpdatePathMap(false);
			}
			else
				aUpdatingPathMap[i] = false;			
		
		*/
		
		if (bMovieStarted)
			return;
        
        InvokeActionChain(aPreActions);

        // ustawiamy graczowi odpowiednio guna        
        ShowPlayerGun(cModule.GetMainPlayer());
		            
        if(cMusic != null)
            cMusic.Start();
		
		bMovieStarted = true;
    }
    
    void OnMovieEnd()
    {
        //CrashLog("[Movie.OnMovieEnd] "+GetTime()+"\n");
        if(cBackObject != null)
            cBackObject.CallMethodIn(sBackMethod, 0.0f);

		/* TO BYO NA POTRZEBY BROWN'S DAUGHTER !!! ZOSTAWA STAMP 
		// i nie mozna bylo skonczyc levelu. Teraz to wywalam, bo jest to robione
		// w edytorze
		
		/*
		for (int i=0; i < aObjs.length; i++)
			if (aUpdatingPathMap[i] == true)
				((ControlObject)aObjs[i]).UpdatePathMap(true);				
		*/
        
        // zatrzymujemy muzyke
        if(cMusic != null)
            cMusic.Stop();			
        
        // ustawiamy graczowi odpowiednio guna
        ChromeModule cModule = (ChromeModule)GetModule();		
		HidePlayerGun(cModule.GetMainPlayer());
        
        // wykonujemy akcje po filmie
        InvokeActionChain(aPostActions);
		
		bMovieStarted = false;
    }
    
    public void OnDestroy()
    {
        if(cMusic != null)
            cMusic.Stop();
    }
	
    //*********************************************************
    Weapon cMovieCAFS = null;
    
    Weapon cGameWeapon = null;
    Weapon cMovieWeapon = null;
    
    void ShowPlayerGun(Player cPlayer)
    {
        if(cGun.GetValue() == EnumMovieGun._DONT_CARE) return;
        
        // zapamietujemy co ma gracz w rece
        
        if (cPlayer.ActiveWeapon == null && cPlayer.cBinoculars != null)
            cGameWeapon = cPlayer.PreviousActiveWeapon;
        else
            cGameWeapon = cPlayer.ActiveWeapon;

        if (cGameWeapon != null)
            cGameWeapon.InGameMovieStart();
        
        if(cGun.GetValue() == EnumMovieGun._CAFS)
        {
            // jak jeszcze nie ma broni to tworzymy nowa
            if(cMovieCAFS == null)
            {
                cMovieCAFS  = (Weapon)CreateObject("WeaponRifle");
                ((InvObject)cMovieCAFS).bHidden = true;
                ((InvObject)cMovieCAFS).bLocked = true;
                cMovieCAFS.bSG = false;
            }
            
            cMovieCAFS.ActivateOnModule();
            
            cMovieWeapon = cMovieCAFS;
            cMovieWeapon.AddToInventory(cPlayer);
        }
        
        
        if(cGun.GetValue() == EnumMovieGun._HANDS)
        {
            // pobieramy rece z gracza
            cMovieWeapon = cPlayer.GetNextWeapon( EWeaponType._HAND );
        }
        
        cPlayer.StopAiming();
        // ustawiamy graczowi bron
        cPlayer.UseWeapon(cMovieWeapon);
    }
    
    void HidePlayerGun(Player cPlayer)
    {
        if(cGun.GetValue() == EnumMovieGun._DONT_CARE) return;
        
        if(cGun.GetValue() == EnumMovieGun._HANDS)
        {
        }
        
        // uzywamy startej broni
        cPlayer.UseWeapon(cGameWeapon);
        
        if(cGun.GetValue() == EnumMovieGun._CAFS)
        {
            // wyrzucamy z inventory CAFSa
            cPlayer.cInventory.RemoveInvObject(cMovieWeapon);
            
            cMovieCAFS.DeactivateOnModuleAlways();
        }

        cMovieWeapon = null;
        cGameWeapon = null;
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Movie.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_MOVIE)
        {
			super.SGLoadChunk(cFC);

			cBackObject = (GameObject)cFC.LoadObjectRef();
			sBackMethod = cFC.LoadString();					
			
			//cMovieCAFS = (Weapon)cFC.LoadObjectRef();
			cGameWeapon = (Weapon)cFC.LoadObjectRef();
			//cMovieWeapon = (Weapon)cFC.LoadObjectRef();					
			
			bMovieStarted = cFC.LoadBool();			
        }
		
		cFC.delete();
	}
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Movie.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_MOVIE, cFCParent);
		
		super.SGSaveChunk(cFC);
	
		cFC.SaveObjectRef(cBackObject);
		cFC.SaveString(sBackMethod);
		
		//cFC.SaveObjectRef(cMovieCAFS);
		cFC.SaveObjectRef(cGameWeapon);
		//cFC.SaveObjectRef(cMovieWeapon);		
		
		cFC.SaveBool(bMovieStarted);			
					
		cFC.delete(); 
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[Movie.SGUpdate]\n");
		
		super.SGUpdate();
	}	
}
