public class MasterServerAuthConnection extends ConnectionHelper
{
    MasterClient m_Client;
    
    String m_sKey = null;
    
    public boolean Init(MasterClient client, String sKey, IConnectionCallback back, float fTimeOut, float fCheckTime)
    {
        if (super.Init(back, fTimeOut, fCheckTime) == true)
        {
            if (client != null)
            {
                m_Client = client;
                float TimeOut = m_Client.SetFirstMasterServer();
                //LogR("SetFirstMasterServer "+m_Client.GetMasterServerName()+" "+TimeOut+"\n");
                
                //_bMultiplayerDemo
                //m_Client.AuthorizeMeDemo();
                m_Client.AuthorizeMe(sKey);
                m_sKey = sKey;
                
                DisableCallMethod("SetNextMasterServer");
                CallMethodIn( "SetNextMasterServer", TimeOut );
                return true;
            }
        }
        
        return false;
    }
    
    public void CheckDo()
    {
        if (m_Client != null)
        {
            if (m_Client.ServerAnswered() == true ||
                m_Client.GetAuthState() == MasterClient.AuthState_MSERVER_NOT_FOUND)
            {
                DisableCallMethod( "SetNextMasterServer" );
                if (m_IConnectionCallback != null)
                {
                    DisableCallMethod("Check");
                    DisableCallMethod("Failed");
                    
                    //TODO - mamy zapodac wynik laczenia!!!
                    m_IConnectionCallback.Succeeded(0);
                }
            }            
        }
    }
    
    void SetNextMasterServer()
    {
        float TimeOut = m_Client.NextMasterServer();
        //LogR("GetNextMasterServer "+m_Client.GetMasterServerName()+" "+TimeOut+"\n");
        m_Client.AuthorizeMe(m_sKey);
        
        
        DisableCallMethod( "SetNextMasterServer" );
        CallMethodIn( "SetNextMasterServer", TimeOut );
    }
    
    public void Cancel()
    {
        DisableCallMethod( "SetNextMasterServer" );
        if (m_Client != null)
        {
            m_Client.CancelAuthorization();
        }
        super.Cancel();
    }
    
    public void Failed()
    {
        DisableCallMethod( "SetNextMasterServer" );
        super.Failed();
    }
}
