public class MasterServersMngr
{
    final static String sm_sMasterServersFile = "Data/MasterServers.scr";
    final static float  sm_fDefaultTimeOut    = 15.0f;
    
    
    private 
    float m_fTimeOut = sm_fDefaultTimeOut;
    float GetTimeOut(){ return m_fTimeOut; }
    
    private
    StringsList m_cMSList = new StringsList();
    
    MasterServersMngr()
    {
        this( sm_sMasterServersFile );
    }
    
    MasterServersMngr(String sFile)
    {
        //parsujemy plik
        ParseKeyword cRoot = GameObject.ParseFile( sFile );
        if ( cRoot != null )
        {
            for ( ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext() )
            {
                if (cKey.Equals("TimeOut"))
                    m_fTimeOut = cKey.GetIParam(0);
                
                if (cKey.Equals("MasterServer"))
                    m_cMSList.Add( cKey.GetSParam(0) );    
            }
            cRoot.delete();
        }
        else
        {
            NetLog.Error("Read or parse error in file " + sFile);
        }
    }
    
    String[] GetMasterServers()
    {
        String []aList = null;
        int nCnt = m_cMSList.GetSize();
        if ( nCnt > 0 )
        {
            aList = new String[ nCnt ];
            NetLog.Test(" Servers "+nCnt);
            for ( int i=0; i<nCnt; ++i )
                aList[ i ] = m_cMSList.GetStringAt( i );    
        }
        /*
        if ( aList != null )
        {
            GameObject.LogR(" MasterServers "+aList.length+" TimeOut:"+m_fTimeOut+"\n");
            for ( int i=0 ; i < aList.length; ++i )
            {
                GameObject.LogR(aList[i]+"\n");
            }
        }*/
        return aList;
    }
    
}
