/**
 * Wyrzucenie z gry gracza o podanym nicku lub PIDzie
 */
public class CommandKick extends ConsoleCommandParams
{
    CommandKick()
    {
        super();
        m_nRequiredAdminRights  = EAdminRights._STANDARD;
        m_nMinParams            = 1;
        m_nMaxParams            = 2;
        m_cPlayerToKick         = null;
    }
    
    final static int _PARAM_NICK_OR_PID = 0;
    final static int _PARAM_REASON      = 1;
    
    NetPlayerInfo m_cPlayerToKick = null;
    
    void InitPerform()
    {
        super.InitPerform();
        
        String sNickOrPID = GetSParam( _PARAM_NICK_OR_PID );
        if ( ! NetGameTools.IsStringValid( sNickOrPID ) )
        {
            SetErrorId( EConsoleCommandError._WRONG_PARAMS_CNT );
            return;
        }
        
        m_cPlayerToKick = m_cGameInfo.GetPlayerInfoList().GetPlayerByNickOrPID( sNickOrPID );
        if ( m_cPlayerToKick == null )
        {
            SetErrorId( EConsoleCommandError._PLAYER_NOT_FOUND );
            return;
        }
        
        //TODO: tu odrzucic boty i serwer i zwrocic ew blad
    }
    
    void PostPerform()
    {
        if ( m_cPlayerToKick != null && 
             m_cPlayerToKick.GetClientOwnerId() > 0 && 
             m_cPlayerToKick.GetClientOwnerId() < ModuleNet.sm_nBotsIdMin )
        {
            String sReason = GetParamsToEnd( _PARAM_REASON );
            m_cGameInfo.EventPlayerToKick( m_cPlayerToKick.GetClientOwnerId(), 
                                           sReason );
        }            
    }
}
