public class ConsoleCommandsList extends ObjectsList
{
    int AddCommand(ConsoleCommand cObj)
    {
        Add( cObj );
        cObj.SetId( IndexOf( cObj ) );
        return cObj.GetId();
    }
    
    ConsoleCommand GetCommandAt(int nIndex)
    {
        Object cObj = GetObjectAt( nIndex );
        return (cObj instanceof ConsoleCommand) ? (ConsoleCommand)cObj : null;
    }
    
    ConsoleCommand GetCommandByName(String sName)
    {
        for ( int i=0; i<GetSize(); ++i )
        {
            ConsoleCommand cCmd = GetCommandAt( i );
            
            if ( (cCmd != null) && cCmd.IsEqual( sName ))
                return cCmd;
        }
        return null;
    }
    
    ConsoleCommand GetCommandById(int nCommandId)
    {
        for ( int i=0; i<GetSize(); ++i )
        {
            ConsoleCommand cCmd = GetCommandAt( i );
            
            if ( (cCmd != null) && cCmd.IsEqual( nCommandId ))
                return cCmd;
        }
        return null;
    }
    
    void SetGameInfo(NetGameInfoHud cGameInfo)
    {
        for ( int i=0; i<GetSize(); ++i )
        {
            ConsoleCommand cCmd = GetCommandAt( i );
            
            if (cCmd != null)
               cCmd.SetGameInfo( cGameInfo );
        }
    }
    
    void Destroy()
    {
        SetGameInfo( null );
        super.Destroy();
    }
}
