/**
 * Klasa po ktorej powinny dziedziczyc wszystkie komendy
 * ktore znane sa tylko serwerowi
 * Takie komendy moga byc dolaczane do systemu poprzez
 * mutatory.
 * 
 * Klasa ta wykorzystywana jest przy wysylaniu klientom 
 * rezultatow dzialania komendy ktora na klientach nie jest znana. 
 * Z tego powodu zarowno ta klasa jak i jej potomne nie moga
 * zmieniac metod obslugi rezultatow i bledow (patrz ponizsze
 * metody final)
 * 
 * Uwaga! Jak juz napisano w ConsoleCommand kazda komenda
 * ktora ma byc wykonuwana musi(!) miec nazwe klasy rozpoczynajaca
 * sie od slowa "Command"!
 */
public class ConsoleCommandServer extends ConsoleCommandParams
{
    void Perform()
    {
        NetLog.Warning("ServerCommand "+GetName()+" -can't find Perform() method");
    }
    
    /** Tych metod juz nadpisywac nie wolno, bo klient
     * tego nie bedzie potrafil zinterpretowac */
    final void PackResults(GameObject cMessager)
    {
        super.PackResults( cMessager );
        cMessager.MessagePackStringBool( GetName() );
    }
    final void UnPackResults(GameObject cMessager)
    {
        super.UnPackResults( cMessager );
        SetName( cMessager.MessageUnPackStringBool( "" ) );
    }
    final void ShowResults()  
    {  
        super.ShowResults(); 
    }
    final void PackErrors(GameObject cMessager)
    {
        super.PackErrors( cMessager );
        cMessager.MessagePackStringBool( GetName() );
    }
    final void UnPackErrors(GameObject cMessager)
    {
        super.UnPackErrors( cMessager );
        SetName( cMessager.MessageUnPackStringBool( "" ) );
    }
    final void ShowErrors()
    {
        super.ShowErrors();
    }
}
