/**
 * Klasa komendy nieznanej.
 * Potrzebna po to, zeby na kliencie mozna bylo wywolywac
 * metody znane tylko serwerowi. 
 * Wtedy wysyla sie do serwera taka matode "po nazwie"
 * Serwer wtedy jest tez zobowiazany odpowiedziec "zwyklym stringiem"
 */
public class ConsoleCommandUnknown extends ConsoleCommandParams
{
    ConsoleCommandUnknown()
    {
        super();
        //nieznanej komendy nie da sie wykonac lokalnie
        m_bShouldExecuteOnlyOnServer = true;
    }
    
    void InitStreamParams( String sTypedText )
    {
        String sCommandName = ConsoleCommandsManager.ParseCommandName( sTypedText );
        //wyjatkowo tu modyfikujemy nazwe
        SetName( sCommandName );   
        
        //zanim sie ustawi parametry to trzeba odczytac nazwe
        super.InitStreamParams( sTypedText );
    }
    
    void PackParams(GameObject cMessager)
    {
        super.PackParams( cMessager );
        cMessager.MessagePackStringBool( GetName() );
    }
    
    void UnPackParams(GameObject cMessager)
    {
        super.UnPackParams( cMessager );
        SetName( cMessager.MessageUnPackStringBool( "" ) );
    }
        
    
    void Clean()
    {
        super.Clean();
        SetName( null );   
    }
    
    /**
     * Zapakowanie bledu w komunikat (do klienta)
     */
    void PackErrors(GameObject cMessager)
    {
        super.PackErrors( cMessager );
        cMessager.MessagePackStringBool( GetName() );
    }
    
    /**
     * Odpakowanie bledu wykonania metody z komunikatu (od serwera)
     */
    void UnPackErrors(GameObject cMessager)
    {
        super.UnPackErrors( cMessager );
        SetName( cMessager.MessageUnPackStringBool( "" ) );
    }
    
    //ta komenda nie moze sie nigdy wywolac.
    void Perform()
    {
        SetErrorId( EConsoleCommandError._COMMAND_UNKNOWN );
    }
}
