public class NetGameInfoASSAULT extends NetGameInfoRound
{
    //maksymalna ilosc baz jaka moze byc obslugiwana (tu, w hudmap, itp)
    final static int  sm_nMaxBases = 8;
    
    int METHOD_ServerRestartRound   = 0;
    
    NetGameInfoASSAULT()
    {
        super();
        
        SetGameType( ENetGameType.ASSAULT );
    }

    int PROFILE_RespawnAssaultDestroyable = 0;
        
    void OnCreate()
    {
        METHOD_ServerRestartRound   = RegisterCallMethod("ServerRestartRound");
        
        PROFILE_RespawnAssaultDestroyable = ProfileAdd(PROF_RESTARTROUND_TAB, "RespawnAssaultDestroyable");
        
        super.OnCreate();
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        m_cGameStatusMsgMngrASSAULT = null;
    }

    GameStatusMsgMngrASSAULT m_cGameStatusMsgMngrASSAULT = null;
    
    void SetGameStatusMsgManager(GameStatusMsgManager cManager)
    {
        super.SetGameStatusMsgManager( cManager );
        
        if ( cManager instanceof GameStatusMsgMngrASSAULT )
            m_cGameStatusMsgMngrASSAULT = (GameStatusMsgMngrASSAULT)cManager;
        else
            CrashLog(" Niepoprawny obiekt GameStatusMsgManager "+cManager+
                     " dla NetGameInfoASSAULT "+this+"\n");
    }

 
    //lista obiektow destroyable
    protected java.util.Vector  m_aAssaultDestroyableObjects    = new java.util.Vector();
    
    
    void ServerInitGame() 
    {
        super.ServerInitGame();
        SetAssaultTeamRole();
    }

    void SetAssaultTeamRole()
    {
        m_nTeamAttacker = m_bRevengeRound ?
                          NetTeamInfo.BLUE : NetTeamInfo.RED ;
        m_nTeamDefender = m_bRevengeRound ?
                          NetTeamInfo.RED  : NetTeamInfo.BLUE ;
        
        NetLog.Assault("SetTeamRole "+
                       " Attacker "+NetTeamInfo.GetLocName(m_nTeamAttacker)+
                       " Defender "+NetTeamInfo.GetLocName(m_nTeamDefender)+
                       " (RevengeRound:"+m_bRevengeRound+")");
        
        if ( Role == ERole._AUTHORITY )
        {
            MsgSendClientTeamRole();
            StartSendingClientTeamRole();
        }
    }
    
    //zeby miec pewnosc ze doszlo
    void StartSendingClientTeamRole()
    {
        StopSendingClientTeamRole();
        CallMethodEvery("MsgSendClientTeamRole",3.0f);
        CallMethodIn("StopSendingClientTeamRole",15.0f);
    }
    void StopSendingClientTeamRole()
    {
        DisableCallMethod("StopSendingClientTeamRole");
        DisableCallMethod("MsgSendClientTeamRole");
    }
    
    int GetTeamAttacker(){ return m_nTeamAttacker; }
    int GetTeamDefender(){ return m_nTeamDefender; }
    
    void ServerInitObjects()
    {
        super.ServerInitObjects();
        ServerInitAssaultDestroyableObjects();
    }
    
    void ServerRespawnObjects()
    {
        super.ServerRespawnObjects();
        ProfileBegin( PROFILE_RespawnAssaultDestroyable );
        ServerRespawnAssaultDestroyableObjects();
        NetLog.Profile("-RespawnAssaultDestroyable "+ProfileEnd(PROFILE_RespawnAssaultDestroyable));
    }
    
    
    void ServerInitAssaultDestroyableObjects()
    {
        GameObject []aObjects = GetObjectsOfClass("ASSAULTDestroyable");
        if ( aObjects == null )
        {
            CrashLog("Brak obiektow assault destroyable\n");
            return;
        }
        
        for (int i=0; i<aObjects.length; i++)
        {
            ASSAULTDestroyable cObj  = (ASSAULTDestroyable)aObjects[ i ];
            InitASSAULTDestroyable( cObj ); 
        }
    }
    
    
    void ServerRespawnAssaultDestroyableObjects()
    {
        for ( int i=0; i<m_aAssaultDestroyableObjects.size(); i++ )
        {
            if ( m_aAssaultDestroyableObjects.elementAt( i ) instanceof ASSAULTDestroyable )
            {
                ASSAULTDestroyable cObj = (ASSAULTDestroyable)m_aAssaultDestroyableObjects.elementAt( i );
                cObj.ServerRespawn();    
            }
        }
    }
        
    void InitASSAULTDestroyable(ASSAULTDestroyable cObj) 
    {
        if ( m_aAssaultDestroyableObjects.size() < sm_nMaxBases )
        {
            m_aAssaultDestroyableObjects.addElement( cObj );
            cObj.Init( this );
            
            if ( m_aDestroyableObjects.indexOf( cObj ) > -1 )
                m_aDestroyableObjects.removeElement( cObj );
        }
    }
    
    int GetASSAULTBaseCnt(){ return m_aAssaultDestroyableObjects.size(); };
    
    //TODO: uwzglednic w przyszlosc fakt, jak do zdobycia moga byc takze inne
    //obiekty niz destryable
    ASSAULTDestroyable GetASSAULTBase( int i )
    {
        if ( i >= 0 && i < m_aAssaultDestroyableObjects.size() && 
             m_aAssaultDestroyableObjects.elementAt( i ) instanceof ASSAULTDestroyable )
        {
            return (ASSAULTDestroyable)m_aAssaultDestroyableObjects.elementAt( i );
        }
        return null;
    }
    
    
    int m_nTeamAttacker = NetTeamInfo.NONE;
    int m_nTeamDefender = NetTeamInfo.NONE;
        
    void ServerStartGame()
    {
        super.ServerStartGame();
        
        SetAssaultTeamRole();
    }
    
    
    
    final static int _MSG_OBJECT_UNDER_ATTACK = 100;
    final static int _MSG_OBJECT_DESTROYED    = 101;
    final static int _MSG_OBJECTIVE_COMPLETED = 102;
    final static int _MSG_OBJECTIVE_FAILED    = 103;
    final static int _MSG_TEAM_ROLE           = 104;
        
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case _MSG_OBJECT_UNDER_ATTACK:
            LogD("_MSG_OBJECT_UNDER_ATTACK\n");
            MsgRecvClientObjectUnderAttack();
            break;            
        
        case _MSG_OBJECT_DESTROYED:
            LogD("_MSG_OBJECT_DESTROYED\n");
            MsgRecvClientObjectDestroyed();
            break;            
            
        case _MSG_OBJECTIVE_COMPLETED:
            LogD("_MSG_OBJECTIVE_COMPLETED\n");
            MsgRecvClientObjectiveCompleted();
            break;
        
        case _MSG_OBJECTIVE_FAILED:
            LogD("_MSG_OBJECTIVE_FAILED\n");
            MsgRecvClientObjectiveFailed();
            break;
            
        case _MSG_TEAM_ROLE:
            LogD("_MSG_TEAM_ROLE\n");
            MsgRecvClientTeamRole();
            break;            
        
        default:
            super.OnMessage();
        }
    }
    
    void MsgSendClientObjectUnderAttack(int nObjectNetId)
    {
        // upewniamy sie ze sie nie zawola na cliecie
        if (Role < ERole._AUTHORITY) 
			return;
        
        MessageNew(_MSG_OBJECT_UNDER_ATTACK);
        MessagePackInt( nObjectNetId );
        MessageSend();
    }
    
    
    void MsgRecvClientObjectUnderAttack()
    {
        int nObjectNetId = MessageUnPackInt();
        MessageEnd();
        
        AddIncomingMessage( NetIncomingMsg._ASSAULT_OBJECT_UNDER_ATTACK, 
                            -1, -1, -1, -1, nObjectNetId );
    }    
    
    void MsgSendClientObjectDestroyed(int nObjectNetId,int nAssassinNetId)
    {
        // upewniamy sie ze sie nie zawola na cliecie
        if (Role < ERole._AUTHORITY) 
			return;
        
        MessageNew(_MSG_OBJECT_DESTROYED);
        MessagePackInt( nObjectNetId );
        MessagePackInt( nAssassinNetId );
        MessageSend();
    }
        
    void MsgRecvClientObjectDestroyed()
    {
        int nObjectNetId   = MessageUnPackInt();
        int nAssassinNetId = MessageUnPackInt();
        MessageEnd();
        
        AddIncomingMessage( NetIncomingMsg._ASSAULT_OBJECT_DESTROYED, 
                            nAssassinNetId, -1, -1, -1, nObjectNetId );
    }    
    
    void MsgSendClientObjectiveCompleted( int nScoredTeamInfoId )
    {
        // upewniamy sie ze sie nie zawola na cliecie
        if (Role < ERole._AUTHORITY) 
			return;
        
        MessageNew(_MSG_OBJECTIVE_COMPLETED);
        MessagePackInt( nScoredTeamInfoId );
        MessageSend();
    }
    
    
    void MsgRecvClientObjectiveCompleted()
    {
        int nScoredTeamInfoId = MessageUnPackInt();
        MessageEnd();
        
        AddIncomingMessage( NetIncomingMsg._ASSAULT_OBJECTIVE_COMPLETED, 
                            -1, 
                            -1, 
                            nScoredTeamInfoId );        
    }
    
    void MsgSendClientObjectiveFailed( int nScoredTeamInfoId )
    {
        // upewniamy sie ze sie nie zawola na cliecie
        if (Role < ERole._AUTHORITY) 
			return;
        
        MessageNew(_MSG_OBJECTIVE_FAILED);
        MessagePackInt( nScoredTeamInfoId );
        MessageSend();
    }
    
    
    void MsgRecvClientObjectiveFailed()
    {
        int nScoredTeamInfoId = MessageUnPackInt();
        MessageEnd();
        
        AddIncomingMessage( NetIncomingMsg._ASSAULT_OBJECTIVE_FAILED, 
                            -1, 
                            -1, 
                            nScoredTeamInfoId );        
    }
    
    void MsgSendClientTeamRole()
    {
        // upewniamy sie ze sie nie zawola na cliecie
        if (Role < ERole._AUTHORITY) 
			return;
        
        MessageNew(_MSG_TEAM_ROLE);
        MessagePackTeamRole();
        MessageSend();
    }
    
    
    void MsgRecvClientTeamRole()
    {
        MessageUnPackTeamRole();
        MessageEnd();
        
        if ( m_bVerifiedRevengeRound )
        {
            m_bRevengeRound = m_bReceivedRevengeRound;
            SetAssaultTeamRole();
        }
    }
    
    
    /**
     * Globalny licznik zmian stanow obiektow
     * Bedzie on wykorzystywany na klientach do rozstrzygania czy dana
     * akcja (ktora zleca nam serwer) ma sie wykonac czy nie (bo jest stara)
     * TODO: dac szerszy opis
     */
    private static 
    ChangeStateCounter sm_cGlobalRoundCounter = new ChangeStateCounter();
    static void CleanGlobalRoundCounter() { sm_cGlobalRoundCounter.Clean(); }
    static int  GetNextGlobalRoundCounter()
    { 
        int nVal = sm_cGlobalRoundCounter.GetNext();
        NetLog.Counter("ASSAULT GetNextGlobal: "+nVal);
        return nVal; 
    }
    
    /**
     * Indywidualny licznik zapamietujacy ostatnio
     * odebrana i wykonana akcje na tym obiekcie
     */
    private 
    ChangeStateCounter m_cRoundCounter = new ChangeStateCounter(this);
    int     GetRoundCounter(){ return m_cRoundCounter.Get(); }
    boolean VerifyRoundCounter( int nCounter ){ return m_cRoundCounter.Verify( nCounter ); }
    
    
    boolean m_bReceivedRevengeRound = false;
    boolean m_bVerifiedRevengeRound = false;

    void MessagePackTeamRole()
    {
        MessagePackInt( GetNextGlobalRoundCounter() );
        MessagePackBoolean( m_bRevengeRound );
        NetLog.Assault("PackTeamRole (RevengeRound:"+m_bRevengeRound+")");
    }
    
    void MessageUnPackTeamRole()
    {
        int nRoundCounter       = MessageUnPackInt();
        m_bReceivedRevengeRound = MessageUnPackBoolean();
        NetLog.Assault("UnPackTeamRole (RevengeRound:"+m_bReceivedRevengeRound+")");
        m_bVerifiedRevengeRound = VerifyRoundCounter( nRoundCounter );
    }
    
    void OnSetGameSettings()
    {
        super.OnSetGameSettings();
        
        if ( m_bVerifiedRevengeRound )
        {
            m_bRevengeRound = m_bReceivedRevengeRound;
            SetAssaultTeamRole();
        }
    }
    
    void EventObjectUnderAttack(ASSAULTDestroyable cObject, PlayerNet cPlayer)
    {
        //jesli to jakies przypadkowe zdarzenie po skonczeniu rundy to ignorujemy
        if ( ! IsScoringEnabled() )
            return;
        
               
        //sprawdzmy czy to obiekt z listy
        for ( int i=0; i<m_aAssaultDestroyableObjects.size(); i++ )
        {
            if ( m_aAssaultDestroyableObjects.elementAt( i ) instanceof ASSAULTDestroyable )
            {
                ASSAULTDestroyable cObj = (ASSAULTDestroyable)m_aAssaultDestroyableObjects.elementAt( i );
                if ( cObj == cObject )
                {
                    AddIncomingMessage( NetIncomingMsg._ASSAULT_OBJECT_UNDER_ATTACK, 
                                        -1, -1, -1, -1, cObj.GetNetId() );
                    
                    MsgSendClientObjectUnderAttack( cObj.GetNetId() );    
                    return;
                }
            }
        }
    }
    
    void EventPlayerDestroyedObject(ASSAULTDestroyable cObject, PlayerNet cPlayer)
    {
        //jesli to jakies przypadkowe zdarzenie po skonczeniu rundy to ignorujemy
        if ( ! IsScoringEnabled() )
            return;
        
        //sprawdzmy czy to obiekt z listy, jesli tak to dajemy komunikat
        //przy okazji sprawdzmy czy wszystkie obiekty sa juz rozwalone
        boolean bAllDestroyed = true;
        for ( int i=0; i<m_aAssaultDestroyableObjects.size(); i++ )
        {
            if ( m_aAssaultDestroyableObjects.elementAt( i ) instanceof ASSAULTDestroyable )
            {
                ASSAULTDestroyable cObj = (ASSAULTDestroyable)m_aAssaultDestroyableObjects.elementAt( i );
                if ( cObj == cObject )
                {
                    int nAssassinId = -1;
                    if ( cPlayer != null )
                    {
                        NetPlayerInfo cAssassinInfo = cPlayer.GetPlayerInfo();
                        if (cAssassinInfo != null)
                            nAssassinId = cAssassinInfo.GetNetId();
                        else
                            CrashLog("ERROR: "+this+" EventPlayerDestroyedObject "+cPlayer+" cNetPlayerInfo == null\n");
                    }
        
                    AddIncomingMessage( NetIncomingMsg._ASSAULT_OBJECT_DESTROYED, 
                                        nAssassinId, -1, -1, -1, cObj.GetNetId() );
                    
                    MsgSendClientObjectDestroyed( cObj.GetNetId(), nAssassinId );    
                }
                
                if ( ! cObj.bDead )
                    bAllDestroyed = false;
            }
        }
        
        if ( bAllDestroyed && IsScoringEnabled() )
        {
            //jezeli tu przeszedl, to znaczy ze wszystkie juz sa zniszczone
            EventObjectiveCompleted( cPlayer );
        }
    }
    
    void EventObjectiveCompleted( PlayerNet cPlayer )
    {
        DisableCallMethod( "EventObjectiveFailed" );
        
        int nScoredTeamId = m_nTeamAttacker;
        
        NetTeamInfo cScoredTeamInfo     = GetTeamInfoById( m_nTeamAttacker );
        int         nScoredTeamInfoId   = -1;
        if ( cScoredTeamInfo != null )
        {
            cScoredTeamInfo.IncPoints();
            nScoredTeamInfoId = cScoredTeamInfo.GetNetId();
            
            AddIncomingMessage( NetIncomingMsg._ASSAULT_OBJECTIVE_COMPLETED, 
                            -1, 
                            -1, 
                            nScoredTeamInfoId );
            MsgSendClientObjectiveCompleted( nScoredTeamInfoId );    
        }
        
        if ( cPlayer != null )
        {
            NetPlayerInfo cPlayerInfo = cPlayer.GetPlayerInfo();
            if ( cPlayerInfo.GetTeamId() == m_nTeamAttacker )
                cPlayerInfo.IncPoints();
            else
                cPlayerInfo.DecPoints();
        }
            
        ServerRoundOver();
    }
    
    void EventObjectiveTimeOut()
    {
        if ( IsScoringEnabled() )
        {
            EventObjectiveFailed();
        }
    }
    
    void EventObjectiveFailed()
    {
        DisableCallMethod( "EventObjectiveCompleted" );
        int nScoredTeamId = m_nTeamDefender;
        
        NetTeamInfo cScoredTeamInfo     = GetTeamInfoById( nScoredTeamId );
        int         nScoredTeamInfoId   = -1;
        if ( cScoredTeamInfo != null )
        {
            cScoredTeamInfo.IncPoints();
            nScoredTeamInfoId = cScoredTeamInfo.GetNetId();
            
            AddIncomingMessage( NetIncomingMsg._ASSAULT_OBJECTIVE_FAILED, 
                            -1, 
                            -1, 
                            nScoredTeamInfoId );
            MsgSendClientObjectiveFailed( nScoredTeamInfoId );
        }
        ServerRoundOver();
    }
    
    
        
    void ServerRestartRound(float fTime)
    {
        CallMethodIn( METHOD_ServerRestartRound, fTime );
    }
    
    void ServerRestartRound()
    {
        NetLog.Assault("---------------- RESTART ROUND -------------------- ");
        super.ServerRestartRound();
        CleanGameTime();
    }
    
    void ServerRestartMatch()
    {
        NetLog.Assault("---------------- RESTART MATCH -------------------- ");
        super.ServerRestartMatch();
        CleanGameTime();
    }
}
