public class NetGameInfoIndividual extends NetGameInfoCommon
{
    public void OnDestroy()
    {
        super.OnDestroy();
        m_cGameSettingsIndividual = null;
    }
    
    NetGameSettingsIndividual m_cGameSettingsIndividual = null;
    NetGameSettingsIndividual GetGameSettingsIndividual(){ return m_cGameSettingsIndividual; }
    void SetGameSettings( NetGameSettings cGameSettings )
    {
        super.SetGameSettings( cGameSettings );
        if ( cGameSettings instanceof NetGameSettingsIndividual )
             m_cGameSettingsIndividual = (NetGameSettingsIndividual)GetGameSettings(); 
        else
            CrashLog(" Niepoprawny obiekt GameSettings "+cGameSettings+
                     " dla NetGameInfoIndividual "+this+"\n");
    }    

    void EventPlayerDied( PlayerNetBaseMortal victim, PlayerNetBaseMortal assassin, int nMode )
    {
        // upewniamy sie ze sie nie zawola na cliecie
        if (Role < ERole._AUTHORITY) 
			return;

        //Klasa bazowa wyswietli odpowiednie komunikaty        
        super.EventPlayerDied( victim, assassin, nMode );
        
        //kazmy przeliczyc punkty, dla gry indywidualnej
        CountIndividualFragsOnDie( victim, assassin, nMode );
    }
    
        
    //fragi dla gry indywidualnej
    void CountIndividualFragsOnDie( PlayerNetBaseMortal victim, PlayerNetBaseMortal assassin, int nMode )
    {
        if ( nMode == EPlayerAction.DIE_MODE_GAMEOVER ||
             nMode == EPlayerAction.DIE_MODE_GAMERESTART )
            return;
        
        NetPlayerInfo cVictimInfo   = victim != null   ? victim.GetPlayerInfo()   : null;
        NetPlayerInfo cAssassinInfo = assassin != null ? assassin.GetPlayerInfo() : null;
                
        // dodajemy graczowi jedna smierc
        if ( cVictimInfo != null )
             cVictimInfo.IncDeaths();
        else
            CrashLog("ERROR: "+this+" PlayerDied "+victim+" ( cVictimInfo == null )\n");
        
        if (cAssassinInfo != null)
        {
			// ktos go zabil, tylko kto?
			
            if (cAssassinInfo != cVictimInfo) 
            {
				// juz wiemy kto
				// zabojca dostaje jednego fraga
                cAssassinInfo.IncFrags();
            }
			else 
            {
				// gracz zabil sam siebie
				// zabieramy mu jednego fraga
                cAssassinInfo.DecFrags();
            }
        }
        else
        {
			// gracz nie zyje, ale nie wiadomo nic wiecej na ten temat
        }
    }
    
    
    
    boolean CheckGameShouldStarted()
    {
        LogD(" "+GetPlayerInfoList().GetSize()+
             " >= "+
             " "+GetGameSettingsIndividual().GetMinPlayersToStartGame()+
             " ? \n");
        return ( GetPlayerInfoList().GetSize() >= 
                 GetGameSettingsIndividual().GetMinPlayersToStartGame() );
    }
    
    //czy ktos juz skonczyl gre?
    boolean CheckGameWon()
    {
        return GetPlayerInfoList().CheckPlayerWon();
    }
    /** Zwraca ilosc punktow gracza prowadzacego
     */
    int GetLeaderPoints() 
    { 
        return GetPlayerInfoList().GetLeaderPoints();
    }
    /** Zwraca ilosc fragow gracza prowadzacego
     */
    int GetLeaderFrags()  
    { 
        return GetPlayerInfoList().GetLeaderFrags();
    }
    int[] GetGameScoreStatus()
    {
        return GetPlayerInfoList().GetGameScoreStatus();
    }
        
    //sprawdzamy czy sa jeszcze minimum 2 obiekty po przeciwnej stronie
    boolean CheckGameFailed()
    {
        //NetTeamInfo.NONE zagwarantuje ze beda sprawdzani 
        //wszyscy gracze bez wzgledu na druzyne w ktorej sie znajduja
        return CheckPlayersTeamFailed( NetTeamInfo.NONE );
    }
    
    void UpdateEnableObjectives(NetPlayerInfo cPlayerInfo)
    {
        //LogD("\n");
        m_cModule.m_ObjectivesManager.SetEnableNet( false, NetTeamInfo.NONE );
    }
    
    void OnScoreChange()
    {
        GetPlayerInfoList().Sort();
        super.OnScoreChange();
    }
    
    //TODO: tymczasowe
    void Cheat()
    {
        GetPlayerInfoList().Cheat();
    }

    
}
