public class NetGameInfoTD extends NetGameInfoTeam
{
    NetGameInfoTD()
    {
        super();
        
        SetGameType( ENetGameType.TD );
    }
        
    public void OnDestroy()
    {
        super.OnDestroy();
        m_cGameSettingsTD = null;
        m_cGameStatusMsgMngrTD = null;
    }
    
    NetGameSettingsTD m_cGameSettingsTD = null;
    NetGameSettingsTD GetGameSettingsTD(){ return m_cGameSettingsTD; }
    void SetGameSettings( NetGameSettings cGameSettings )
    {
        super.SetGameSettings( cGameSettings );
        if ( cGameSettings instanceof NetGameSettingsTD )
             m_cGameSettingsTD = (NetGameSettingsTD)GetGameSettings(); 
        else
            CrashLog(" Niepoprawny obiekt GameSettings: "+cGameSettings+
                     " dla GameInfoTD: "+this+"\n");
    }
    
    GameStatusMsgMngrTD m_cGameStatusMsgMngrTD = null;
    void SetGameStatusMsgManager(GameStatusMsgManager cManager)
    {
        super.SetGameStatusMsgManager( cManager );
        
        if ( cManager instanceof GameStatusMsgMngrTD )
            m_cGameStatusMsgMngrTD = (GameStatusMsgMngrTD)cManager;
        else
            CrashLog(" Niepoprawny obiekt GameStatusMsgManager "+cManager+
                     " dla NetGameInfoTD "+this+"\n");
    }
        
    void ServerInitGame() 
    {
        super.ServerInitGame();
        
        ServerInitDominationGame();
    }
    
    float GetDominationScoreUpdateTime()
    {
        return m_cGameSettingsTD.GetScoreUpdateTime();
    }
    
    final static int _MSG_BASE_CAPTURED                 = 100;
    //final static int _MSG_BASE_LOST                     = 101;
    
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case _MSG_BASE_CAPTURED:
            LogD("_MSG_BASE_CAPTURED\n");
            MsgRecvClientBaseCaptured();
            break;
        
        default:
            super.OnMessage();
        }
    }
        
    void MsgSendClientBaseCaptured( int nPlayerInfoId, int nTeamInfoId )
    {
        // upewniamy sie ze sie nie zawola na cliecie
        if (Role < ERole._AUTHORITY) 
			return;
        
        MessageNew(_MSG_BASE_CAPTURED);
        MessagePackInt( nPlayerInfoId );
        MessagePackInt( nTeamInfoId );
        MessageSend();
    }
        
    void MsgRecvClientBaseCaptured()
    {
        int nPlayerInfoId = MessageUnPackInt();
        int nTeamInfoId   = MessageUnPackInt();
        MessageEnd();
        
        AddIncomingMessage( NetIncomingMsg._TD_BASE_CAPTURED, 
                            nPlayerInfoId,
                            -1,
                            nTeamInfoId );
    }
    
    
    void EventPlayerReachedBase( DominationBase cBase, PlayerNet cPlayer )
    {
        if ( cBase == null )
            return;
        
        //sprawdzic czy baza jest na liscie
        if ( cBase != (DominationBase) m_aDominationBases.elementAt( cBase.GetIndex() )  )
            return;
        
        //TODO
        //sprawdzic, czy gracz jest w sensownej odleglosci od bazy
        
        NetPlayerInfo cPlayerInfo   = null;
        int           nPlayerInfoId = -1;
        NetTeamInfo   cTeamInfo     = null;
        int           nTeamInfoId   = -1;
        if ( cPlayer != null )
        {
            cPlayerInfo = cPlayer.GetPlayerInfo();
            if (cPlayerInfo != null)
            {
                nPlayerInfoId = cPlayerInfo.GetNetId();
                                
                cTeamInfo     = GetTeamInfoById( cPlayerInfo.GetTeamId() );
                if ( cTeamInfo != null )
                    nTeamInfoId   = cTeamInfo.GetNetId();
                else
                {
                    CrashLog("ERROR: "+this+
                             " PlayerReachedBase "+cPlayer+
                             " playerinfo:"+cPlayerInfo+
                             " teamid:"+cPlayerInfo.GetTeamId()+
                             " cTeamInfo == null\n");
                    return;
                }
                
            }
            else
            {
                CrashLog("ERROR: "+this+" PlayerReachedBase "+cPlayer+" cNetPlayerInfo == null\n");
                return;
            }
        }
        else
        {
            CrashLog("ERROR: "+this+" PlayerReachedBase "+cPlayer+"\n");
            return;
        }
        
        if ( cBase.GetTeamOwner() != cTeamInfo )
        {
            //zmienic wlasciciela bazy
            SetBaseOwner( cBase, cTeamInfo, cPlayerInfo );
            
            //zmienic kolor bazy
            cBase.UpdateState();
            
            //policz na nowe warunki zapunktowania
            UpdateTimeToNextDominationScore();
            
            //wyswietlic komunikaty
            //TODO: ktora baza?
            AddIncomingMessage( NetIncomingMsg._TD_BASE_CAPTURED, 
                                nPlayerInfoId,
                                -1, 
                                nTeamInfoId );
            MsgSendClientBaseCaptured( nPlayerInfoId, nTeamInfoId );
            
            //a moze komunikat tylko jak przejmnie sie _wszyskie_ bazy?
            //oczywiscie jak sie gra w trybie total
        }
        else if ( cBase.GetPlayerOwner() != cPlayerInfo )
        {
            //gosc staje sie indywidualnym wlascicielem
            //TODO: czy ma to byc?
            SetBaseOwner( cBase, cPlayerInfo );
        }
    }
    
    void EventPlayerDied( PlayerNetBaseMortal victim, PlayerNetBaseMortal assassin, int nMode )
    {
        // upewniamy sie ze sie nie zawola na cliecie
        if (Role < ERole._AUTHORITY) 
			return;

        //Klasa bazowa wyswietli odpowiednie komunikaty        
        super.EventPlayerDied( victim, assassin, nMode );
        
        EventPlayerLostBaseIfBaseOwner( victim );
    }
    
    void EventPlayerLeft(PlayerNet player)
    {
        super.EventPlayerLeft( player );
        
        EventPlayerLostBaseIfBaseOwner( player );
    }
    
    void EventPlayerLostBaseIfBaseOwner( PlayerNetBaseMortal player )
    {
        NetPlayerInfo cPlayerInfo   = null;
        int           nPlayerInfoId = -1;
        if ( player != null )
            cPlayerInfo = player.GetPlayerInfo();
        else
        {
            CrashLog("ERROR: "+this+" PlayerDied "+player+"\n");
            return;
        }
        
        //jak zgninie i byl indywidualnym wlascicielem to przestaje nim byc
        for ( int i=0; i<m_aDominationBases.size(); i++ )
        {
            DominationBase cBase = (DominationBase)m_aDominationBases.elementAt(i);
            if ( cBase.GetPlayerOwner() == cPlayerInfo )
            {
                SetBaseOwner( cBase, (NetPlayerInfo)null );
            }
        }   
    }
        
    
    void SetBaseOwner( DominationBase cBase, NetTeamInfo cTeamInfo, NetPlayerInfo cPlayerInfo )
    {
        SetBaseOwner( cBase, cTeamInfo );
        SetBaseOwner( cBase, cPlayerInfo );
    }

    boolean HasBaseOwner(DominationBase cBase)
    { 
        return cBase != null && cBase.GetTeamOwner() != null; 
    }
    
    void ServerUpdateGame()
    {
        super.ServerUpdateGame();
        
        if (Role < ERole._AUTHORITY) 
			return;
        
        if ( GetTimeToNextDominationScore()  > -1.0       && 
             GetTimeToNextDominationScore() <= GetGameTime() )
        {
            //policz punkty
            ServerScore();
            
            //policz na nowe warunki zapunktowania
            UpdateTimeToNextDominationScore();
        }
    }
    
    
        
    void ServerScore()
    {
        float fGameTime = GetGameTime();
        //w przypadku gdy gramy w trybie Total, bedziemy zliczali
        //punkty druzynynowe tylko dla jednej (pierwszej) bazy
        boolean bScored = false;
            
        for (int i=0; i<m_aDominationBases.size() ; i++ )
        {
            DominationBase cBase = (DominationBase)m_aDominationBases.elementAt( i );
                
            if ( cBase                       == null ||
                 cBase.GetTeamOwner()        == null ||
                 cBase.GetTimeToNextScore()  <= -1.0f )
                continue;
            
            while ( cBase.GetTimeToNextScore() <= fGameTime )
            {
                /*LogD(" "+i+" "+
                     cBase.GetTimeToNextScore()+" "+fGameTime+" "+
                     bScored+" "+cBase.GetPlayerOwner()+
                     "\n");*/
                
                if ( !IsModeDominationTotal() || !bScored )
                {
                    cBase.GetTeamOwner().IncPoints();
                }
                                        
                if ( GetGameSettingsTD().GetScoreIndividualPoints() && 
                     cBase.GetPlayerOwner() != null )
                {
                    cBase.GetPlayerOwner().IncPoints(); 
                }
                
                cBase.AddTimeToNextScore( GetDominationScoreUpdateTime() );    
            }
            
            bScored = true;
        }
    }
    
    void ServerStopGame()
    {
        super.ServerStopGame();
                
        for ( int i=0; i<m_aDominationBases.size(); i++ )
        {
            DominationBase cBase = (DominationBase)m_aDominationBases.elementAt(i);
            
            //kasujemy wlasciciela
            SetBaseOwner( cBase, (NetTeamInfo)null, (NetPlayerInfo)null );
            
            //zmienic kolor bazy
            cBase.UpdateState();
        }
            
        //policz na nowe warunki zapunktowania
        UpdateTimeToNextDominationScore();
    }
    
    boolean HasAllBasesTheSameOwner()
    {
        //przegladamy wszystkie bazy, czy maja tego samego wlasciciela
        NetTeamInfo cTeamOwner = null;
        int           nCntBases  = 0;
        for ( int i=0; i<m_aDominationBases.size(); i++ )
        {
            DominationBase cBase = (DominationBase)m_aDominationBases.elementAt( i ) ;
                
            //jesli baza nie ma wlasciciela, to ja omijamy
            if ( cBase == null || cBase.GetTeamOwner() == null )
                continue;
            
            //pierwszego znalezionego zapamietujemy jako "wzor"
            if ( cTeamOwner == null )
                 cTeamOwner = cBase.GetTeamOwner();
            
            //zliczamy tych co maja "wzrocowego" wlasciciela
            if ( cTeamOwner == cBase.GetTeamOwner() )
                nCntBases ++;
        }
        return nCntBases == m_aDominationBases.size();
    }
    
    int GetDominationBaseLocalState( DominationBase cBase , NetPlayerInfo cPlayerInfo)
    {
        if ( cBase != null )
        {
            if ( cBase.GetTeamOwner() == null )
                return DominationBase._STATE_FREE;
            else
            {
                int nTeamId = cBase.GetTeamOwner().GetTeamId();
                
                if ( nTeamId == NetTeamInfo.RED )
                    return DominationBase._STATE_RED;
                    
                if ( nTeamId == NetTeamInfo.BLUE )
                    return DominationBase._STATE_BLUE;
            }
        }
        
        return DominationBase._STATE_UNKNOWN;
    }
        
    void LoadUsingMaterials()
    {
        super.LoadUsingMaterials();
        LoadDominationUsingMaterials();
    }

    void OnGetActiveTrigger()
    {
        //gracz szuka aktywnych triggerow, umozliwmy
        //mu odnalezienie obiektw DominationBase
        StoreFlagsAndEnableGetActiveTriggerForDominationObjs();
    }
    
    void OnPostGetActiveTrigger()
    {
        //gracz skonczyl szukac aktywnych triggerow, 
        //przywrocmy obiektom DominationBase zapamietane wczesniej flagi
        RestoreFlagsForDominationObjs();
    }
}

