/** klasa za pomoca ktorej na podstawie NetGameSettings
 * bedzie mozna wyswiatlic ktorki komunikat o zasadach gry, 
 * komunikat bedzie typu:
 * "gra do 10 punktow w czasie 15 minut".
 */
public class NetGameRule
{
    final static int _MSG_Unknown      = 0;
    final static int _MSG_FragsAndTime = 1;
    final static int _MSG_PointsAndTime= 2;
    final static int _MSG_FragsOnly    = 3;
    final static int _MSG_PointsOnly   = 4;
    final static int _MSG_TimeOnly     = 5;
    final static int _MSG_AssaultPointsAndTime= 6;
    
    
    private int m_nMessageId = _MSG_Unknown;
    private int m_aParams[]  = null;
        
    
    NetGameRule(int nMessageId,int nParam1)
    {
        m_nMessageId    = nMessageId;
        
        m_aParams       = new int[1];
        m_aParams[0]    = nParam1;
    }
    
    NetGameRule(int nMessageId,int nParam1,int nParam2)
    {
        m_nMessageId    = nMessageId;
        
        m_aParams       = new int[2];
        m_aParams[0]    = nParam1;
        m_aParams[1]    = nParam2;
    }
    
    NetGameRule(int nMessageId,int nParam1,int nParam2,int nParam3)
    {
        m_nMessageId    = nMessageId;
        
        m_aParams       = new int[3];
        m_aParams[0]    = nParam1;
        m_aParams[1]    = nParam2;
        m_aParams[2]    = nParam3;
    }
    
    String GetGameRuleString()
    {
        return NetGameTools.MixString( GetMessageById( m_nMessageId ), 
                                       m_aParams );
    }         
    
    private static String GetMessageById(int nId)
    {
        switch ( nId )
        {
        case _MSG_Unknown:      return  NetMsg.sGameRuleUnknown;
        case _MSG_FragsAndTime: return  NetMsg.sGameRuleFragsAndTime;
        case _MSG_PointsAndTime:return  NetMsg.sGameRulePointsAndTime;
        case _MSG_FragsOnly:    return  NetMsg.sGameRuleFragsOnly;
        case _MSG_PointsOnly:   return  NetMsg.sGameRulePointsOnly;                                
        case _MSG_TimeOnly:     return  NetMsg.sGameRuleTimeOnly;
        case _MSG_AssaultPointsAndTime: return NetMsg.sGameRuleAssaultPointsAndTime;        
        }
        return null;
    }

}
