public class NetGameSettingsRound extends NetGameSettingsTeam
{
    //czy przy nastepnej rundzie zmieniamy strony
    boolean _CHANGE_SIDE_ON_NEXT_ROUND    = false;
    //czy ma byc rewanzowy mecz ze zmienionymi stronami
    boolean _REVENGE_MATCH                = false;
    
    private boolean m_bChangeSideOnNextRound    = false;
    private boolean m_bRevengeMatch             = false;
    
    void SetChangeSideOnNextRound(boolean bChange){ m_bChangeSideOnNextRound = bChange;}
    void SetRevengeMatch(boolean bRevengeMatch){ m_bRevengeMatch = bRevengeMatch; } 

    boolean GetChangeSideOnNextRound(){ return m_bChangeSideOnNextRound;}
    boolean GetRevengeMatch(){ return m_bRevengeMatch; } 

    void Init()
    {
        super.Init();
        
        SetChangeSideOnNextRound( _CHANGE_SIDE_ON_NEXT_ROUND );
        SetRevengeMatch( _REVENGE_MATCH );
    }
    
    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        boolean bOk = true;
        
        switch ( cModifier.GetId() )
        {
        case EModifiersNetGameSettings._CHANGE_SIDE_ON_NEXT_ROUND:            
            SetChangeSideOnNextRound( cModifier.GetBooleanParam() );
            break;
        case EModifiersNetGameSettings._REVENGE_MATCH:            
            SetRevengeMatch( cModifier.GetBooleanParam() );
            break;
        default:
            bOk = super.ApplyModifier( cModifier );
        }
        return bOk;
    }
    
    void SaveSettings()
    {
        super.SaveSettings();
        
        m_cScriptWriter.Write("ChangeSideOnNextRound("+Bool2String(m_bChangeSideOnNextRound)+")");
        m_cScriptWriter.Write("RevengeMatch("+Bool2String(m_bRevengeMatch)+")");
    }
    
    
    void CopyDataFromContainer()
    {
        super.CopyDataFromContainer();
        
        SetChangeSideOnNextRound( m_cContainer.UnPackBoolean() );
        SetRevengeMatch( m_cContainer.UnPackBoolean() );
    }

    void CopyDataToContainer()
    {
        super.CopyDataToContainer();
        
        m_cContainer.PackBoolean( GetChangeSideOnNextRound() );
        m_cContainer.PackBoolean( GetRevengeMatch() );
    }
}
