public class NetGameSettingsTeam extends NetGameSettings
{
    //czy wlaczony jest tryb TeamBalance
    boolean _TEAM_BALANCE                 = false;
    //czy biezemy pod uwage FriendlyFire
    boolean _FRIENDLY_FIRE                = true;
    //z jakim wspolczynnikiem dziala friendly fire
    float   _FRIENDLY_FIRE_MUL            = 0.25f;
    
    //czy pozycja graczy z wlasnej druzyny ma byc pokazywana na mapie
    //last added
    boolean _FRIENDS_VISIBLE_ON_HUD_MAP   = true;
    //ilosc druzyn potrzebna do wystartowania gry
    int     _MIN_TEAMS_TO_START_GAME      = 1;
    
    NetGameSettingsTeam()
    {
        super();
    }
    
    private boolean m_bTeamBalance              = false;
    private boolean m_bFriendlyFire             = false;
    private float   m_fFriendlyFireMul          = 0.1f;
    private int     m_nMinTeamsToStartGame      = 1;
    private boolean m_bFriendsVisibleOnHudMap   = true;
    
    void SetTeamBalance(boolean bBalance){ m_bTeamBalance = bBalance ; }
    void SetFriendlyFire(boolean bFriendlyFire){ m_bFriendlyFire = bFriendlyFire ; }
    void SetFriendlyFireMul(float fMul){ m_fFriendlyFireMul = fMul ; }
    void SetMinTeamsToStartGame(int nMin){ m_nMinTeamsToStartGame = nMin; }
    void SetFriendsVisibleOnHudMap(boolean bVisible){ m_bFriendsVisibleOnHudMap = bVisible; }
    
    boolean GetTeamBalance(){ return m_bTeamBalance; }
    boolean GetFriendlyFire(){ return m_bFriendlyFire; }
    float   GetFriendlyFireMul(){ return m_fFriendlyFireMul; }
    int     GetMinTeamsToStartGame(){ return m_nMinTeamsToStartGame; }
    boolean GetFriendsVisibleOnHudMap(){ return m_bFriendsVisibleOnHudMap; }
    
    void Init()
    {
        super.Init();
        
        SetTeamBalance( _TEAM_BALANCE );
        SetFriendlyFire( _FRIENDLY_FIRE );
        SetFriendlyFireMul( _FRIENDLY_FIRE_MUL );
        SetMinTeamsToStartGame( _MIN_TEAMS_TO_START_GAME );
        SetFriendsVisibleOnHudMap( _FRIENDS_VISIBLE_ON_HUD_MAP );
    }
    
    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        boolean bOk = true;
        
        switch ( cModifier.GetId() )
        {
        case EModifiersNetGameSettings._TEAM_BALANCE:
            SetTeamBalance( cModifier.GetBooleanParam() );
            break;
        case EModifiersNetGameSettings._FRIENDLY_FIRE:
            SetFriendlyFire( cModifier.GetBooleanParam() );
            break;
        case EModifiersNetGameSettings._FRIENDS_VISIBLE_ON_HUD_MAP:
            SetFriendsVisibleOnHudMap( cModifier.GetBooleanParam() );
            break;
        case EModifiersNetGameSettings._MIN_TEAMS_TO_START_GAME:
            SetMinTeamsToStartGame( cModifier.GetIntParam() );
            break;            
        //aktualnie nie wykorzystywane w menu i skryptach            
        case EModifiersNetGameSettings._FRIENDLY_FIRE_MUL:
            SetFriendlyFireMul( cModifier.GetFloatParam() );
            break;
        default:
            bOk = super.ApplyModifier( cModifier );
        }
        
        return bOk;
    }
    
    void SaveSettings()
    {
        super.SaveSettings();
                    
        m_cScriptWriter.Write("TeamBalance("+Bool2String(m_bTeamBalance)+")");
        m_cScriptWriter.Write("FriendlyFire("+Bool2String(m_bFriendlyFire)+")");
        //m_cScriptWriter.Write("FriendlyFireMul("+m_fFriendlyFireMul+")");
        m_cScriptWriter.Write("FriendsVisibleOnHudMap("+Bool2String(m_bFriendsVisibleOnHudMap)+")");
        m_cScriptWriter.Write("MinTeamsToStartGame("+m_nMinTeamsToStartGame+")");
        
    }
    
    
    void CopyDataFromContainer()
    {
        super.CopyDataFromContainer();
        
        SetTeamBalance( m_cContainer.UnPackBoolean() );
        SetFriendlyFire( m_cContainer.UnPackBoolean() );
        //SetFriendlyFireMul( m_cContainer.UnPackFloat() );
        SetFriendsVisibleOnHudMap( m_cContainer.UnPackBoolean() );
        SetMinTeamsToStartGame( m_cContainer.UnPackInt() );
    }

    void CopyDataToContainer()
    {
        super.CopyDataToContainer();
        
        m_cContainer.PackBoolean( GetTeamBalance() );
        m_cContainer.PackBoolean( GetFriendlyFire() );
        //m_cContainer.PackFloat( GetFriendlyFireMul() );
        m_cContainer.PackBoolean( GetFriendsVisibleOnHudMap() );
        m_cContainer.PackInt(    GetMinTeamsToStartGame()  );
    }
    
}
