/**
 * Pojedynczy skin dla wybranej czesci mesha (dla glowy, reki, itp)
 */
public class SkinPartial
{
    final static int _UNKNOWN    =-1;
    final static int _BODY       = 0;
    final static int _HAND       = 1;
    final static int _HEAD       = 2;
    final static int _HELMET     = 3;
    final static int _EYEGLASS   = 4;
    final static int _IROKEZ     = 5;
    final static int _SKINS_CNT_ = 6;
    
    //nazwy przyciskow w PlayerProfileMenu
    static String [] sm_aElementSkinName = 
    {
        "&PlayerNetSkinBody&",//_BODY
        "&PlayerNetSkinHand&",//_HAND
        "&PlayerNetSkinHead&",//_HEAD
        "&PlayerNetSkinHelmet&",//_HELMET
        "&PlayerNetSkinEyeGlass&",//_EYEGLASS
        "&PlayerNetSkinIrokez&"//_IROKEZ
    };
    
    static String GetElementSkinName(int i)
    { 
        if ( i >= 0 && i <sm_aElementSkinName.length )
            return sm_aElementSkinName[i]; 
        return "";
    }
    
    
    //nazwy skinow poszczegolnych w skrypcie (roznia sie koncowka)
    static String [] sm_aScriptSkinBaseName =
    {
        "@Body",//_BODY;
        "@Hand",//_HAND;
        "@Head", //_HEAD;
        "@Helmet",//_HELMET;
        "@EyeGlass",//_EYEGLASS;
        "@Irokez"//_IROKEZ;
    };
    
    static int GetElementIdBySkinName( String sName )
    {
        for ( int i=0; i<sm_aScriptSkinBaseName.length; i++ )
            if ( sName != null && sName.startsWith( sm_aScriptSkinBaseName[i] ) )
                return i;
        return _UNKNOWN;
    }
    
    
    private String m_sName = "";
    String  GetName(){ return m_sName; }
    
    SkinPartial(String sName)
    {
        m_sName = sName;
    }
    
    //flagi informacyjne
    byte m_nFlags = 0x00;
    
    final public static byte _FLAG_NOHELMET   = 0x01;
    final public static byte _FLAG_BALD       = 0x02;
    final public static byte _FLAG_NOEYEGLASS = 0x04;
    final public static byte _FLAG_NOIROKEZ   = 0x08;
    
    //dotyczy kasku
    void    SetNoHelmet() { m_nFlags |= _FLAG_NOHELMET; }
    boolean HasHelmet(){ return ( (m_nFlags & _FLAG_NOHELMET) == 0 ); }
    
    //dotyczy glowy
    void    SetBald() { m_nFlags |= _FLAG_BALD; }
    boolean IsBald(){ return ( (m_nFlags & _FLAG_BALD) != 0 ); }
        
    //dotyczy okularow
    void    SetNoEyeGlass(){ m_nFlags |= _FLAG_NOEYEGLASS; }
    boolean HasEyeGlass(){ return ( (m_nFlags & _FLAG_NOEYEGLASS) == 0 ); }
    
    //dotyczy irokeza
    void    SetNoIrokez(){ m_nFlags |= _FLAG_NOIROKEZ; }
    boolean HasIrokez(){ return ( (m_nFlags & _FLAG_NOIROKEZ) == 0 ); }
    
    
    static String GetFlagName(byte nFlag)
    {
        return GameObject.GetFieldNameForIntValue( SkinPartial.class, 
                                                   nFlag,
                                                   "_FLAG" );    
    }
    
    String GetInfo()
    {
        return m_sName+
               ", HasHelmet() "+HasHelmet()+
               ", IsBald() "+IsBald()+
               ", HasIrokez() "+HasIrokez()+
               ", HasEyeGlass() "+HasEyeGlass();
    }
}
