/**
 * Klasa sluzaca do przechowywania i wyswietlania informacji
 * o serwerze na ekranie JoinGame
 */
public class NetServerInfo implements Comparable
{
    public String sServerAddr = null;
    public String sServerName = null;
    private int iGamePort = NetServerInitInfo.sm_nDefaultGamePort;
    public String sCurrentLevelName = null;
    public int nNumberPlayerInGame = 0;
    public int nMaxPlayersInGame = 0;    
    public int nPing;
    public int nGameType;
    public int nGameVersion = 0;
    public boolean bPassword=false;
    //TODO tu ma trafic wyliczone CRC mapy, ktora jest aktualnie grana
    public int nMapCRC = 0;
    public boolean bInternetServer = false;
    //czy serwer jest dostepny (istotne na ekranie favorites)
    public boolean bAvailable = false;
    
    //po czym ma byc sortowana lista NetServerinfo w compareTo
    private static int m_iSortMode = 0;
    //czy sortowac dla wzrastajacych elementow
    private static boolean m_bSortModeIncreasing = true;
    
    final static int _SERVER_NAME = 0,
                     _SERVER_ADRESS = 1,
                     _MAP_NAME = 2,
                     _MAP_TYPE = 3,
                     _PING = 4,
                     _NUMBER_OF_PLAYERS = 5;
    
    // pomocnicze
    public boolean bValid = false;
    public int nItemID = 0;
    
    NetServerInfo(String sServerAddr, String sServerName, int iGamePort, String sCurrentLevelName, 
                  int nNumberPlayerInGame, int nMaxPlayersInGame, int nGameType, 
                  int nPing,int nGameVersion,boolean bPassword, int nItemID, int nMapCRC,
                  boolean bInternetServer,boolean bAvailable)
    {
        this.sServerAddr = sServerAddr;
        this.sServerName = sServerName;
        this.iGamePort = iGamePort;
        this.sCurrentLevelName = sCurrentLevelName;
        this.nNumberPlayerInGame = nNumberPlayerInGame;
        this.nMaxPlayersInGame = nMaxPlayersInGame;
        this.nGameType = nGameType;
        this.nPing = nPing;
        this.nGameVersion = nGameVersion;
        this.bPassword = bPassword;
        this.nMapCRC = nMapCRC;
        this.bInternetServer = bInternetServer;            
        this.bAvailable = bAvailable;
        
        this.bValid = true;
        this.nItemID = nItemID;
    }
    
    NetServerInfo(String sServerAddr, String sServerName, int iGamePort, String sCurrentLevelName, 
                  int nNumberPlayerInGame, int nMaxPlayersInGame, int nGameType, 
                  int nPing,int nGameVersion,boolean bPassword, int nItemID, int nMapCRC,
                  boolean bInternetServer)
    {
        this ( sServerAddr, sServerName, iGamePort, sCurrentLevelName, 
               nNumberPlayerInGame, nMaxPlayersInGame, nGameType, 
               nPing,nGameVersion,bPassword,nItemID,nMapCRC,
               bInternetServer, true );
    }
    
    NetServerInfo(String sServerAddr, String Name, int GamePort)
    {
        this.sServerAddr = sServerAddr;
        this.iGamePort = GamePort;
        //TODO: trzeba to zmienic i jezeli bAvailable jest false, to nigdzie
        // nie odczytywac tych wartosci
        sServerName = Name;
        //sServerName = new String("");
        sCurrentLevelName = new String("");
        bAvailable = false;
    }
    
    NetServerInfo()
    {
    }
    
    public void Update(NetServerInfo netServerInfo)
    {
        this.sServerAddr = netServerInfo.sServerAddr;
        this.sServerName = netServerInfo.sServerName;
        this.iGamePort = netServerInfo.iGamePort;
        this.sCurrentLevelName = netServerInfo.sCurrentLevelName;
        this.nNumberPlayerInGame = netServerInfo.nNumberPlayerInGame;
        this.nMaxPlayersInGame = netServerInfo.nMaxPlayersInGame;
        this.nGameType = netServerInfo.nGameType;
        this.nPing = netServerInfo.nPing;
        this.nGameVersion = netServerInfo.nGameVersion;
        this.bPassword = netServerInfo.bPassword;
        this.nMapCRC = netServerInfo.nMapCRC;
        this.bInternetServer = netServerInfo.bInternetServer;
        this.bAvailable = netServerInfo.bAvailable;
        this.bValid = true;
    }
    
    public int GetGamePort()
    {
        return iGamePort;
    }
    
    int GetGameVersion()
    {
        return nGameVersion;
    }

    String GetNetGameVersionNumberString()
    {
        return ENetGameVersion.GetNetNumber( nGameVersion ); 
    }
    
    public String GetLevelName()
    {
        String sGameType   = " "+ENetGameType.GetGameNameShort( nGameType );
        return GetShortLevelName() + sGameType;
    }
    
    static void SetSortMode(int iMode)
    {
        if(m_iSortMode == iMode)
        {
            m_bSortModeIncreasing = !m_bSortModeIncreasing;
        }else
        {
            m_iSortMode = iMode;
            m_bSortModeIncreasing = true;
        }
    }
    
    //funkcja potrzebna do sortowania
    public int compareTo(Object o)
    {
        NetServerInfo cCompareObj = (NetServerInfo) o;
        
        switch(m_iSortMode)
        {
        case _SERVER_NAME:    
            if(m_bSortModeIncreasing)
                return sServerName.compareTo(cCompareObj.sServerName);
            else
                return cCompareObj.sServerName.compareTo(sServerName);
        case _SERVER_ADRESS:    
            if(m_bSortModeIncreasing)
                return sServerAddr.compareTo(cCompareObj.sServerAddr);
            else
                return cCompareObj.sServerAddr.compareTo(sServerAddr);
        case _MAP_NAME:    
            if(m_bSortModeIncreasing)
                return GetShortLevelName().compareTo(cCompareObj.GetShortLevelName());
            else
                return cCompareObj.GetShortLevelName().compareTo(GetShortLevelName());
        case _MAP_TYPE:
            if(m_bSortModeIncreasing)
                return ENetGameType.GetGameNameShort( nGameType ).compareTo(ENetGameType.GetGameNameShort( cCompareObj.nGameType ));
            else
                return ENetGameType.GetGameNameShort( cCompareObj.nGameType ).compareTo(ENetGameType.GetGameNameShort( nGameType ));
        case _PING:
            if(m_bSortModeIncreasing)
                return (cCompareObj.nPing < nPing ? 1 : (cCompareObj.nPing == nPing ? 0 : -1));
            else
                return (cCompareObj.nPing > nPing ? 1 : (cCompareObj.nPing == nPing ? 0 : -1));
        case _NUMBER_OF_PLAYERS:    
            if(m_bSortModeIncreasing)
                return (cCompareObj.nNumberPlayerInGame < nNumberPlayerInGame ? 1 : (cCompareObj.nNumberPlayerInGame == nNumberPlayerInGame ? 0 : -1));
            else
                return (cCompareObj.nNumberPlayerInGame > nNumberPlayerInGame ? 1 : (cCompareObj.nNumberPlayerInGame == nNumberPlayerInGame ? 0 : -1));
        default:
            return (cCompareObj.nPing < nPing ? 1 : (cCompareObj.nPing == nPing ? 0 : -1));
        }
    }
    
    //bez typu mapy
    public String GetShortLevelName()
    {
        int     nSlashIndex = sCurrentLevelName.lastIndexOf('/');
        int     nDotIndex   = sCurrentLevelName.lastIndexOf('.');
        if ((nSlashIndex != -1) && (nSlashIndex != -1))
            return sCurrentLevelName.substring(nSlashIndex+1, nDotIndex);
        return sCurrentLevelName;
    }
    
    /**
     * Czy moge sie probowac podlaczyc do gry?
     * Na tej podstawie bedziemy ustawiali znaczek zielony
     * albo czerwony w menu join
     */
    boolean CanITryToJoin()
    {
        return ( DoesMapFileExist()     && 
                 IsCorrectGameVersion() && 
                 IsServerResponding()   && 
                 (!IsPlayersLimitOut() )
                );
    }
    
    boolean IsPasswordRequired()
    {
        return bPassword;
    }
    
    /**
     * Czy serwer odpowiedzial?
     * Na zakladce favorites bedzie domyslnie na false
     * na pozostalych jak sie wyswietlil do znaczy 
     * ze odpowiedziel :-)
     */
    boolean IsServerResponding()
    {
        return bAvailable;
    }
    
    
    /**
     * Czy istnieje plik z mapa?
     */
    boolean DoesMapFileExist()
    {
        return GameObject.DoesFileExist( sCurrentLevelName );
    }
    
    /**
     * Czy posiadamy odpowiednia wersje gry?
    */
    boolean IsCorrectGameVersion()
    {
        return NetGameInfo.GetGameVersion() == this.nGameVersion;
    }
    
    /**
     * Czy limit graczy wyczerpany?
     */
    boolean IsPlayersLimitOut()
    {
        return (nNumberPlayerInGame >= nMaxPlayersInGame);
    }
}
