public class HUDWaypointsManagerNet extends HUDWaypointsManager
{
    
    int AddWaypoint(Vector vPos, boolean bActive, NetHudMapSprite cNetHudMapSprite)
    {
        if( m_cWaypoints == null )
        {
            m_cWaypoints = new java.util.Vector();
        }
        return AddWaypoint( vPos, bActive, cNetHudMapSprite, m_cWaypoints );
    }
    
    /** dodawanie waypointa
     * @param sName nazwa waypointa
     * @param vPos pozycja
     * @param bActive czy ma byc aktywny - pokazywany na mapie
     * @param cList lista do ktorej ma byc dodany
     */
    public int AddWaypoint(Vector vPos, boolean bActive, NetHudMapSprite cNetHudMapSprite, java.util.Vector cList )
    {
        if( cList == null )
        {
            cList = new java.util.Vector();
        }
        
        HUDWaypoint cElem = null;
        
        if (cNetHudMapSprite != null)
            cElem = new HUDWaypointNet(cNetHudMapSprite);
        else
            cElem = new HUDWaypointNet(vPos, bActive );
        
        cList.addElement( cElem );
        
        return cList.indexOf( cElem );
    }
    
    HUDWaypoint FindWaypoint(NetHudMapSprite cHudNetMapSprite)
    {
        if (m_cWaypoints == null)
            return null;
        
        HUDWaypoint cPoint = null;
        for (int i = 0; i < m_cWaypoints.size(); i++)
        {
            if (m_cWaypoints.elementAt(i) instanceof HUDWaypointNet &&
                ((HUDWaypointNet)m_cWaypoints.elementAt(i)).GetNetHudMapSprite() == cHudNetMapSprite)
            {
                cPoint = (HUDWaypoint)m_cWaypoints.elementAt(i);
                break;
            }
        }        
        return cPoint;
    }
    
    public class HUDWaypointNet extends HUDWaypoint
    {
        NetHudMapSprite m_cNetHudMapSprite = null;
        
        HUDWaypointNet(NetHudMapSprite cNetHudMapSprite)
        {
            m_cNetHudMapSprite = cNetHudMapSprite;
            m_vPos = cNetHudMapSprite.GetWorldPosRef();
            m_bActive = cNetHudMapSprite.CanBeVisible();
        }
        
        HUDWaypointNet(Vector vPos, boolean bActive )
        {
            m_vPos = new Vector(vPos );
            m_bActive = bActive;
        }
        
        NetHudMapSprite GetNetHudMapSprite()
        {
            return m_cNetHudMapSprite;
        }
    }
}
