public class HUDNetStatistics extends HUDNetMain 
{
    
    float fTeamRowFontScale = 1.0f;
    
    /** Na liscie bedziemy pomijali niektorych graczy
     * ze wzgledu na ograniczona wielkosc huda
     * W tym celu nalezy pamietac to czy poprzedni gracz byl wyswietlony
     * czy nie
     * jesli tak, a biezacy gracz juz nie ma byc wyswietlany to
     * nalezy wyswietlic linie "wykropkowana"
     */
    boolean m_bLastRowEmpty = true;
    
    static Vector sm_vEmptyRowColor = new Vector( 0.5f,0.5f,0.5f );
         
    //32 graczy plus 2 naglowki dla teamow
    UIControlObject m_tRowsTeam1[] = null;
    UIControlObject m_tRowsTeam2[] = null;
    
    UIStatic m_tColumns[] = null;
    UIControlObject m_cRowPatternTeam1 = null;
    UIControlObject m_cRowPatternTeam2 = null;
    
    UIStatic m_cInfo = null;
    UIStatic m_cTime = null;
    
    int m_nRowsTeam1 = 0;
    int m_nRowsTeam2 = 0;
    
    String m_sScriptName = "data/hudnet/HUDNetStatistics.scr";
    
    boolean m_bShowingNextPageNeeded = false;
    float m_fPageStayingTime = 2f;
    float m_fCurPageStartTime = 0;
    int m_nCurPageTeam1 = 0;
    int m_nCurPageTeam2 = 0;
    
    //gdy jeden team zmienia wyswietlana strone, to drugi tez musi
    boolean m_bPageChange = false;
    
    public void OnCreate()
    {
        super.OnCreate();
  
        Load(GetModule(), m_sScriptName, false);
        
        InitializeStatistics();
    }
    
    public void OnInit()
    {
        super.OnInit();
        
        InitColumns();
       
        m_cInfo = (UIStatic)GetElem("ID_TITLE");
        m_cTime = (UIStatic)GetElem("ID_TIME");
        
        m_cRowPatternTeam1 = (UIControlObject)GetElem("ID_ROW_1");
        m_cRowPatternTeam2 = (UIControlObject)GetElem("ID_ROW_2");
        m_cRowPatternTeam1.Reload();
        if (m_cRowPatternTeam2 != null)
        {
            m_cRowPatternTeam2.Reload();
        }
            
        InitRows();
        
    }
    
    void InitializeStatistics()
    {

    }
    
    void InitColumns()
    {
        //Pokryc w klasie potomnej
    }
    
    void InitRows()
    {
        InitRowPattern(m_cRowPatternTeam1);
        
        if (m_cRowPatternTeam2 != null)
        {
            m_tRowsTeam1 = new UIControlObject[17];
            m_tRowsTeam2 = new UIControlObject[17];
            
            InitRowPattern(m_cRowPatternTeam2);
        }
        else
        {
            m_tRowsTeam1 = new UIControlObject[32];
        }
        
        Vector vPos = m_cRowPatternTeam1.GetPos();
        for (int i = 0; i < m_tRowsTeam1.length; i ++)
        {
            if (i > 0)
            {
                UIWindow cTeam = GetElem("ID_TEAM_1");
                if (cTeam == null)
                    LogR("NIE MA ID_TEAM_1");
                if (m_tRowsTeam1[i-1] == null ||
                    (m_tRowsTeam1[i-1] != null &&
                        vPos.fY + m_tRowsTeam1[i-1].GetSize().fY > cTeam.GetPos().fY + cTeam.GetSize().fY))
                    continue;
                //kolejny rzad sie nie zmiesci, zostawiamy null
            }
            UIControlObject cNewRow = (UIControlObject)CreateObject("UIControlObject");
            cNewRow.Copy(cNewRow, m_cRowPatternTeam1);
            cNewRow.m_sId = "_ROW_1_" + String.valueOf(i);
            ((UIControlObject)GetElem("ID_TEAM_1")).AddElement(cNewRow);
            //SetRow(cNewRow, "Nick " + String.valueOf(i + 1), RandomInt(100), RandomInt(100), RandomInt(1000));
            cNewRow.Show();
            Vector vRowSize = new Vector(cNewRow.GetSize().fX, ((UIWindow)cNewRow.m_vChildWindows.elementAt(0)).GetSize().fY, 0);
            cNewRow.UpdateLogicSizeAndPos(vRowSize, vPos);
            cNewRow.OnSizeAndPos();
            vPos.fY += cNewRow.GetSize().fY;
            m_tRowsTeam1[i] = cNewRow;
            m_nRowsTeam1++;
        }
        
        if (m_cRowPatternTeam2 != null)
        {
            vPos = m_cRowPatternTeam2.GetPos();
            for (int i = 0; i < m_tRowsTeam2.length; i ++)
            {
                if (i > 0)
                {
                    UIWindow cTeam = GetElem("ID_TEAM_2");
                    if (m_tRowsTeam1[i-1] == null ||
                        m_tRowsTeam2[i-1] != null &&
                        vPos.fY + m_tRowsTeam2[i-1].GetSize().fY > cTeam.GetPos().fY + cTeam.GetSize().fY)
                        continue;
                    //kolejny rzad sie nie zmiesci, zostawiamy null
                }      
                
                UIControlObject cNewRow = (UIControlObject)CreateObject("UIControlObject");
                cNewRow.Copy(cNewRow, m_cRowPatternTeam2);
                cNewRow.m_sId = "_ROW_2_" + String.valueOf(i);
                ((UIControlObject)GetElem("ID_TEAM_2")).AddElement(cNewRow);
                //SetRow(cNewRow, "Nick " + String.valueOf(i + 1), RandomInt(100), RandomInt(100), RandomInt(1000));
                cNewRow.Show();
                Vector vRowSize = new Vector(cNewRow.GetSize().fX, ((UIWindow)cNewRow.m_vChildWindows.elementAt(0)).GetSize().fY, 0);
                cNewRow.UpdateLogicSizeAndPos(vRowSize, vPos);
                cNewRow.OnSizeAndPos();
                vPos.fY += cNewRow.GetSize().fY;
                m_tRowsTeam2[i] = cNewRow;
                m_nRowsTeam2++;
            }
        }
    }
    
    void InitRowPattern(UIControlObject cPattern)
    {
        for(int i = 0; i < cPattern.m_vChildWindows.size(); i ++)
        {
            UIStatic cChild = (UIStatic)cPattern.m_vChildWindows.elementAt(i);
            for (int j = 0; j < m_tColumns.length; j++)
            {
                if (m_tColumns[j].m_sId.endsWith(cChild.m_sId))
                {
                    cChild.SetText("N");
                    float fFontY = cChild.GetTextExtent("N").fY;
                    cChild.SetText("");
                    Vector vElemSize = new Vector(m_tColumns[j].GetSize().fX,fFontY,0);
                    Vector vElemPos = new Vector(m_tColumns[j].GetPos().fX, cPattern.GetPos().fY, 0);
                    cChild.UpdateLogicSizeAndPos(vElemSize, vElemPos);
                    cChild.OnSizeAndPos();
                }
            }
        }
    }
    
    void SetRow(UIControlObject cRow, String sNick, int nFrags, int nDeaths, int nPing)
    {
        ((UIStatic)cRow.GetElem("_NICK")).SetText(sNick);
        ((UIStatic)cRow.GetElem("_FRAGS")).SetText(String.valueOf(nFrags));
        ((UIStatic)cRow.GetElem("_DEATHS")).SetText(String.valueOf(nDeaths));
        ((UIStatic)cRow.GetElem("_PING")).SetText(String.valueOf(nPing));
    }
    
    void SetRow(UIControlObject cRow, NetPlayerInfo cPlayer, int nFrags, int nDeaths, int nPing)
    {
        UIStatic cNick = (UIStatic)cRow.GetElem("_NICK");
        cNick.SetText(cPlayer.GetNickClamped(cNick));
        ((UIStatic)cRow.GetElem("_FRAGS")).SetText(String.valueOf(nFrags));
        ((UIStatic)cRow.GetElem("_DEATHS")).SetText(String.valueOf(nDeaths));
        ((UIStatic)cRow.GetElem("_PING")).SetText(String.valueOf(nPing));
    }
    
    void UpdateStatistics()
    {
    }
    
    //w grach singlowych jako team wstawiamy null
    void UpdateTeam(int nTeam, NetTeamInfo cTeam, java.util.Vector vPlayers)
    {
        UIControlObject tRows[] = null;
        int nRows = 0;
        int nCurRow = 0;
        int nPage = 0;
        
        
        if (nTeam == 0)
        {
            tRows = m_tRowsTeam1;
            nRows = m_nRowsTeam1;
            nPage = m_nCurPageTeam1;
        }
        
        else
            if (nTeam == 1)
            {
                tRows = m_tRowsTeam2;
                nRows = m_nRowsTeam2;
                nPage = m_nCurPageTeam2;
            }
            else 
                LogR("LICZBA TEAMOW WIEKSZA OD 2!!!");
        
        //chowamy wszystko
        for (int k = 0; k < tRows.length; k++)
        {
            if (tRows[k] != null)
                tRows[k].Hide();
        }
        
        if (cTeam != null)
        {
            SetTeamRow(tRows[0], cTeam);
            nRows --;
            nCurRow ++;
        }
        
        int nPageCount = GetPageCount(nRows, vPlayers.size());
        
        //LogR(nTeam + ". PLAYERS " + vPlayers.size() + " ROWS " + nRows + " PAGES " + nPageCount);
        
        if (GetTime() - m_fCurPageStartTime > m_fPageStayingTime ||
            m_bPageChange)
        {
            if (vPlayers.size() > nRows ||
                m_bPageChange)
            {
                if (m_bPageChange)
                    m_bPageChange = false;
                else
                    m_bPageChange = true;
                        
                m_fCurPageStartTime = GetTime();
                nPage ++;
                if (nPage >= nPageCount)
                    nPage = 0;
            }
            
            if (nTeam == 0)
                m_nCurPageTeam1 = nPage;
            else
                if (nTeam == 1) 
                    m_nCurPageTeam2 = nPage;
        }

        if (vPlayers.size() == 0)
            return;
        
        Vector vColor = null;
        
        int nFirstPlayer = 0;
        if (nPage > 0)
        {
            nFirstPlayer = nRows - 1; //pierwsza strona;
            for (int i = 1; i < nPage; i ++)
                nFirstPlayer += (nRows - 2);//strony posrednie
        }
        
        
        if (nPage > 0)
        {
            //wstawiamy kropki
            SetRow(0, tRows[nCurRow], 1, null);
            
            nCurRow ++;
            nRows --;//kropki na gorze
            /*if (nPage < nPageCount - 1)
                nRows --;//kropki na dole*/
        }
        
        
        int nCurPlayer = 0;
        for (int j = nFirstPlayer; j < nFirstPlayer + nRows; j++)
        { 
            if (j >= vPlayers.size())
                continue;
            
            if (j == nFirstPlayer + nRows - 1 &&
                !(j == vPlayers.size() - 1))
            {
                SetRow(0, tRows[nCurRow], 1, null);
                return;
            }
            
            NetPlayerInfo cPlayer = (NetPlayerInfo)vPlayers.elementAt( j );
            
            float fAlpha = 1f;
            
            if (nCurPlayer % 2 == 0)
                fAlpha = 0.66f;
            nCurPlayer ++;
            
            SetRow(j + 1, tRows[nCurRow], fAlpha, cPlayer);
            nCurRow++;
            
            
        }
    }
    
    int GetPageCount(int nRows, int nPlayers)
    {
        if (nRows >= nPlayers)
            return 1;
       
        //pierwsza strona -1 na kropki
        nRows --;
        
        int nPages = 1;
        nPlayers -= nRows;
        
        while (nPlayers > 0)
        {
            nPages++;
            nPlayers -= nRows;
            if (nPlayers <= 0)
                return nPages;
            else
                nPlayers++;//jeden rzad na kropki
        }
        return nPages;
    }
    
    public void Activate()
    {
        super.Activate();   
        
        m_fCurPageStartTime = GetTime();
        m_nCurPageTeam1 = 0;
        m_nCurPageTeam2 = 0;
        
        //DeletePlayersInfo();
        InitializePlayersInfo();
        
        Draw();
        
        HUDNetIncomingMessage cMsg = (HUDNetIncomingMessage)((HUDNetManager)m_cHudNetManager).m_aHUDComponentNet[HUDNetManager._INCOMING_MESSAGE];
        if (cMsg != null)
            cMsg.MoveTop();
        
        HUDNetSystemMessage cMsgSys = (HUDNetSystemMessage)((HUDNetManager)m_cHudNetManager).m_aHUDComponentNet[HUDNetManager._SYSTEM_MESSAGE];
        if (cMsgSys != null)
            cMsgSys.MoveTop();
    }
    
    void Refresh()
    {
        if ( m_cHudNetManager.IsLocked() )
            bActiveFlag = true;
        else
            if (bActiveFlag)
		        Draw();
    }
    
    //do nadpisania
    void InitializePlayersInfo()
    {
    }
    
    public void Draw()
    {
        super.Draw();
        
        //wyswietlam dane playerow
        UpdateStatistics();
        //i teksty ( w tym czas)
        UpdateText();
        
        /*if ( m_aPlayerInfoRows != null )
            for (int i=0; i<m_aPlayerInfoRows.size(); i++)
            {
                if ( ! (m_aPlayerInfoRows.elementAt(i) instanceof HUDNetStatsRow))
                    continue;
                HUDNetStatsRow cRow = (HUDNetStatsRow)m_aPlayerInfoRows.elementAt(i);
                cRow.Show();
            }*/
    }
    
    public void HideAll()
    {
        super.HideAll();
        
        /*if ( m_aPlayerInfoRows != null )
            for (int i=0; i<m_aPlayerInfoRows.size(); i++)
            {
                if ( ! (m_aPlayerInfoRows.elementAt(i) instanceof HUDNetStatsRow))
                    continue;
                HUDNetStatsRow cRow = (HUDNetStatsRow)m_aPlayerInfoRows.elementAt(i);
                cRow.Hide();
            }*/
    }
        
    public void Hide()
    {
        super.Hide();
    }
    
    
    public void Deactivate()
    {
        super.Deactivate();   
        //DeletePlayersInfo();
    }
        
    int m_nSpaceRowCount = 0;
    
        
    void AddEmptyRowIfPossible()
    {
        /*if ( m_bLastRowEmpty )
            return;
        String []aTexts = new String[ GetColumnCnt() ];
        for (int i=0; i<aTexts.length; i++)
            aTexts[i] = "...";
        AddRow( aTexts, sm_vEmptyRowColor );
        m_bLastRowEmpty = true;*/
    }
    
    
    
    String l_sTimeString = null;
    void SetTime( String sTxt )
    {
        if (l_sTimeString == null)
            l_sTimeString = Text.Get("&TIME&");
        
        //m_cTime.SetText(l_sTimeString + "(" + sTxt + ")");
        m_cTime.SetText("(" + sTxt + ")");    
    }
    
    void UpdateText()
    {
        super.UpdateText();
        m_cInfo.SetText((Text.Get(m_sTitle) + "\n" + TextToUpperCase(Text.Get(m_sRule))));
    }
    
    void SetElemText(UIStatic cElem, String sText, Vector vColor, float fAlpha, float fFontScale)
    {
        cElem.SetTextColor(vColor.fX, vColor.fY, vColor.fZ, fAlpha);
        cElem.SetFontScale(fFontScale);
        cElem.SetText(sText);
    }
    
    void SetRow(int nPlace, UIControlObject cRow, float fAlpha, NetPlayerInfo cPlayer)
    {
        cRow.Show();
        if (cPlayer != null)
        {
            
        }
        else
        {
            Vector vColor = new Vector(1,1,1);
            //SetRow(cRow, vColor, fAlpha, 1, "...", "...", "...", "...", "...", "...");
        }
    }
    
    void SetTeamRow(UIControlObject cRow, NetTeamInfo cTeam)
    {
        cRow.Show();
    }
}
