public class HUDNetStatisticsSMD extends HUDNetStatisticsDomination 
{
    final static String _COL_TEXTS[] = {"&NetHudStatsCH_Nick&",
                                        "&NetHudStatsCH_Points&",
                                        "&NetHudStatsCH_Frags&",
                                        "&NetHudStatsCH_Dominate&",
                                        "&NetHudStatsCH_Ping&"};
    final static int    _COL_WIDTH[] = { 50,    50 ,     50,     50,    50   };
    final static int    _COL_POS  [] = { 50,    170,     250,    330,   440  };
    
    {
        m_sScriptName = "data/hudnet/HUDNetStatisticsSMD.scr";
    }
    
    void InitializeStatistics()
    {
        super.InitializeStatistics();
        
        SetTitle("&NetGameNameSMD&");
    }
    
    void UpdateStatistics()
    {
        if ( m_cNetGameInfo == null)
            return;
         
        NetPlayerInfoList cPlayerInfoList = m_cNetGameInfo.GetPlayerInfoList();
        
        if ( cPlayerInfoList == null )
            return;
        
        cPlayerInfoList.Sort();
        
        java.util.Vector vPlayers = new java.util.Vector();
        
        for (int i = 0; i < cPlayerInfoList.GetSize(); i++)
        {
            NetPlayerInfo cPlayerInfo = cPlayerInfoList.GetPlayerByIndex( i );
            if (cPlayerInfo != null)
                vPlayers.addElement(cPlayerInfo);
            
        } 
        UpdateTeam(0, null, vPlayers);
    }
    
    void InitializePlayersInfo()
    {
        if ( m_cNetGameInfo == null)
            return;
     
        NetPlayerInfoList cPlayerInfoList = m_cNetGameInfo.GetPlayerInfoList();
        
        if ( cPlayerInfoList == null )
            return;
        
        cPlayerInfoList.Sort();
               
        for (int i=0; i<cPlayerInfoList.GetSize(); i++)
        {
            /*NetPlayerInfo cPlayerInfo = cPlayerInfoList.GetPlayerByIndex( i );
            
            if ( cPlayerInfo == null )
                continue;
            
            if ( ! cPlayerInfo.IsVisibleOnHudNet() )
            {
                AddEmptyRowIfPossible();
                continue;
            }
            
            String aTexts[] = new String[ GetColumnCnt() ];
            aTexts[0] = cPlayerInfo.GetNick();
            aTexts[1] = Integer.toString( cPlayerInfo.GetPoints() );
            aTexts[2] = Integer.toString(  );
            aTexts[3] = GetDominationBaseText( cPlayerInfo );
            aTexts[4] = Integer.toString( cPlayerInfo.GetLatencyAndLoss() );
        
            Vector vColor = HUDNetManager.GetColorForPlayerInfo( cPlayerInfo );
            
            AddRow( aTexts, vColor );*/
        } 
    }

    void InitColumns()
    {
        m_tColumns = new UIStatic[6];
        m_tColumns[0] = (UIStatic)GetElem("ID_COLUMN_PLACE");
        m_tColumns[1] = (UIStatic)GetElem("ID_COLUMN_NICK");
        m_tColumns[2] = (UIStatic)GetElem("ID_COLUMN_POINTS");
        m_tColumns[3] = (UIStatic)GetElem("ID_COLUMN_FRAGS");
        m_tColumns[4] = (UIStatic)GetElem("ID_COLUMN_DOMINATE");
        m_tColumns[5] = (UIStatic)GetElem("ID_COLUMN_PING");
    }
    void SetRow(int nPlace, UIControlObject cRow, float fAlpha, NetPlayerInfo cPlayer)
    {
        cRow.Show();
        if (cPlayer != null)
        {
            Vector vColor = HUDNetManager.GetColorForPlayerInfo( cPlayer );
            SetRow(cRow, vColor, fAlpha, 1,
                   String.valueOf(nPlace), 
                   cPlayer, 
                   String.valueOf(cPlayer.GetPoints()), 
                   String.valueOf(cPlayer.GetFrags()),
                   String.valueOf(cPlayer.GetLatencyAndLoss()),
                   GetDominationBaseText( cPlayer )
                   );
        }
        else
        {
            Vector vColor = new Vector(1,1,1);
            SetRow(cRow, vColor, fAlpha, 1, "...", "...", "...", "...", "...", "...");
        }
        
    }
    
    void SetRow(UIControlObject cRow, Vector vColor, float fAlpha, float fFontScale, String sPlace, String sNick, String sPoints, String sFrags, String sPing, String sDominate)
    {
        SetElemText((UIStatic)cRow.GetElem("_PLACE"), sPlace, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_NICK"), sNick, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_POINTS"), sPoints, vColor, fAlpha, fFontScale);        
        SetElemText((UIStatic)cRow.GetElem("_FRAGS"), sFrags, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_DOMINATE"), sDominate, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_PING"), sPing, vColor, fAlpha, fFontScale);
    }
    
    void SetRow(UIControlObject cRow, Vector vColor, float fAlpha, float fFontScale, String sPlace, NetPlayerInfo cPlayer, String sPoints, String sFrags, String sPing, String sDominate)
    {
        SetElemText((UIStatic)cRow.GetElem("_PLACE"), sPlace, vColor, fAlpha, fFontScale);
        UIStatic cNick = (UIStatic)cRow.GetElem("_NICK");
        SetElemText(cNick, cPlayer.GetNickClamped(cNick), vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_POINTS"), sPoints, vColor, fAlpha, fFontScale);        
        SetElemText((UIStatic)cRow.GetElem("_FRAGS"), sFrags, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_DOMINATE"), sDominate, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_PING"), sPing, vColor, fAlpha, fFontScale);
    }
}

