/** klasa reprezentuje jeden wiersz HUD z statystykami sieciowymi
 */

public class HUDNetStatsRow extends GameObject
{
    static int    sm_aColWidth[] =  null;
    static int    sm_aColPos  [] =  null;
    
    /** ilosc kolumn w wierszu
     */
    private int nColumnCnt = 0;
    
    void  SetColumnCnt(int nCnt){nColumnCnt = nCnt; }
    int   GetColumnCnt()        {return nColumnCnt;}
    
    /** tablica stringow-tekstow w kolumnie
     */
    String aTexts[] = null;
    /** tablica z spritami dla poszczegolnych kolumn
     */
    Sprite aSprColumns[] = null;
    /** flaga mowiaca czy kolumna przedstawia wlasne statystyki gracza
     */
    boolean bPlayerCol = false;
    
    /** Wwektor z wspolrzednymi polozenia na ekranie pierszej kolumny
     */
    Vector vRowPos = new Vector();
    
    /** tablica z wartosciami odstepow pomiedzy poszczegolnymi kolumnami wzgledem 1-szej kolumny
     */
    int aColumnPosition[] = null;
    /** tablica z rozmiarem (w poziomie) spritow-tekstow reprezentujacaych poszczegolne kolumny w wierszu
     */
    int aColumnWidth[] = null;
    
    /** rozmiar (w pionie) spritow-tekstow z kolumn 
     */
    int nColumnHeight = 10;
    
    
//-----------------------------------------------------------------
    HUDNetStatsRow()
    {
    }
    
    void OnCreate()
    {
        if ( GetColumnCnt() > 0 )
        {
            aColumnWidth    = new int[ GetColumnCnt() ];
            aColumnPosition = new int[ GetColumnCnt() ];
        }
    }
    
    void OnDestroy()
    {
        aColumnWidth    = null;
        aColumnPosition = null; 
        
        //kasowanie spritow
        if ( aSprColumns != null )
        {
            for (int i=0; i<aSprColumns.length; i++)
            {
                if ( aSprColumns[i] != null )
                {
                    RemoveSprite( aSprColumns[i] );
		            aSprColumns[i].delete();
                    aSprColumns[i] = null;       
                }
            }
            aSprColumns = null;
        }
    }
    
//-----------------------------------------------------------------
    
    /** metoda ustawia pozycje wiersza, teksty dla kolejnych kolumn i kolor czcionki w wierszu
     */
    public void Init(String[] aColText, Vector vPos, Vector vColor, Sprite cParentSprite )
    {
        aTexts = aColText;
        SetRowPos( vPos );
        InitializeParams();
        InitializeSprites( vColor, cParentSprite );
    }
    
    /** metoda ustawiajaca wzgledna pozycje na ekranie wiersza z statystykami
     */
    public void SetRowPos(Vector vRow_pos)
    {
        vRowPos.fX = vRow_pos.fX;
        vRowPos.fY = vRow_pos.fY;
    }

    //do nadpisania
    void InitializeParams()
    {
        for (int i=0; i<aColumnWidth.length; i++)
        {
            aColumnWidth[i]    = GetColWidth( i );
            aColumnPosition[i] = GetColPos( i );
        }
    }
    
    int GetColPos(int nCol)
    {
        if ( sm_aColPos != null  && 
             nCol       >= 0     && 
             nCol       <  sm_aColPos.length )
            return sm_aColPos[ nCol ]+(int)vRowPos.fX;
        else
            return 0;
    }
    
    int GetColWidth(int nCol)
    {
        if ( sm_aColWidth != null && 
             nCol         >= 0    && 
             nCol         <  sm_aColWidth.length )
            return sm_aColWidth[ nCol ];
        else
            return 0;
    }
        
    //tworze sprity tekstow w kolumnach
    void InitializeSprites(Vector vColor, Sprite cParentSprite)
    {
        if ( GetColumnCnt() <= 0 )
            return;
        
        aSprColumns = new Sprite[ GetColumnCnt() ];
        for (int i=0; i<aSprColumns.length; i++)
        {
            aSprColumns[i] = (Sprite)CreateObject("Sprite");
		    aSprColumns[i].SetNoTexture();
		    aSprColumns[i].ProcessMouse(false);
            aSprColumns[i].SetSize( new Vector(aColumnWidth[i],nColumnHeight,0));
            aSprColumns[i].SetPos( new Vector(aColumnPosition[i],vRowPos.fY,0));
            cParentSprite.AddChild(aSprColumns[i]);        
                        
            aSprColumns[i].SetFont(ChromeFonts.FONT_HUD);
            aSprColumns[i].SetTextColorV( vColor );
            aSprColumns[i].DisplayText(aTexts[i]);   
        }
    }
    
    public void Show()
    {
        if ( aSprColumns != null )
            for (int i=0; i<aSprColumns.length; i++)
                aSprColumns[i].Show();
    }
    
    public void Hide()
    {
        if ( aSprColumns != null )
            for (int i=0; i<aSprColumns.length; i++)
                aSprColumns[i].Hide();
    }
    
    
    /*
    public void SetFont(String sFont)
    {
        for (int i=0; i<aSprColumns.length; i++)
        {
            aSprColumns[i].SetFont(sFont);
            aSprColumns[i].DisplayText(aTexts[i]);
        }
    }*/
    
    /** metoda ustwia kolor tekstu
     */
    /*
    public void SetTextColor(Vector vColor)
    {
        for (int i=0; i<aSprColumns.length; i++)
            aSprColumns[i].SetTextColorV( vColor );
    }*/
}
