public class HUDMapCTF extends HUDMapTeam 
{
    NetGameInfoCTF m_cGameInfoCTF = null;
    
    int METHOD_ComputeFlagsPos = 0;
    int METHOD_ComputeBasesPos = 0;
        
    boolean m_bFlagVisible = true;

    /** sprite punktu niebieskiej flagi */
    NetHudMapSprite m_cBlueFlagSpr = null;
    boolean m_bBlueFlagPosVisible = false;
    boolean m_bBlueFlagHasOwner   = false;
    /** to, czy znamy juz pozycje spritea i mamy wyswietlac go na mapie*/
    boolean m_bBlueFlagPosKnown = false;
        
    /** sprite punktu czerwonej flagi */
    NetHudMapSprite m_cRedFlagSpr = null;
    boolean m_bRedFlagPosVisible = false;
    boolean m_bRedFlagHasOwner   = false;
    /** to, czy znamy juz pozycje spritea i mamy wyswietlac go na mapie*/
    boolean m_bRedFlagPosKnown   = false;
    
    /** sprite punktu niebieskiej bazy */
    NetHudMapSprite m_cBlueBaseSpr = null;
    /** to, czy znamy juz pozycje spritea i mamy wyswietlac go na mapie*/
    boolean         m_bBlueBasePosKnown = false;
    /** sprite punktu czerwonej bazy */
    NetHudMapSprite m_cRedBaseSpr = null;
    /** to, czy znamy juz pozycje spritea i mamy wyswietlac go na mapie*/
    boolean         m_bRedBasePosKnown = false;
    
    public void OnCreate()
    {
        METHOD_ComputeFlagsPos = RegisterCallMethod( "ComputeFlagsPos" );
        METHOD_ComputeBasesPos = RegisterCallMethod( "ComputeBasesPos" );
        
        super.OnCreate();   
        
        if (m_bDisableInNetGame)
            return;
        
        m_cBlueFlagSpr = (NetHudMapSprite) CreateObject("HudNetMapSpriteFlagCTF");
        m_cBlueFlagSpr.SetMode( NetHudMapSprite._MODE_BLUE );
		m_cMap.AddChild( m_cBlueFlagSpr );

        
        m_cRedFlagSpr = (NetHudMapSprite) CreateObject("HudNetMapSpriteFlagCTF");
        m_cRedFlagSpr.SetMode( NetHudMapSprite._MODE_RED );
        m_cMap.AddChild( m_cRedFlagSpr );
        
        m_cBlueBaseSpr = (NetHudMapSprite) CreateObject("HudNetMapSpriteBaseCTF");
        m_cBlueBaseSpr.SetMode( NetHudMapSprite._MODE_BLUE );
		m_cMap.AddChild( m_cBlueBaseSpr );
        
        m_cRedBaseSpr = (NetHudMapSprite) CreateObject("HudNetMapSpriteBaseCTF");
        m_cRedBaseSpr.SetMode( NetHudMapSprite._MODE_RED );
        m_cMap.AddChild( m_cRedBaseSpr );
    }
    
    void StartComputeObjectsPos()
    {
        super.StartComputeObjectsPos();
        
        DisableCallMethod( METHOD_ComputeFlagsPos );   
        DisableCallMethod( METHOD_ComputeBasesPos );
        
        CallMethodEvery( METHOD_ComputeFlagsPos, 0.05f );   
        CallMethodEvery( METHOD_ComputeBasesPos, 0.10f );
    }

    void SetCompassRef(HUDCompass cCompass)
    {
        if (m_bDisableInNetGame)
            return;
        
        super.SetCompassRef( cCompass );
        
        m_cBlueBaseSpr.m_cCompassElement = ((HUDCompassNet)cHUDCompasRef).AddWaypointNet(new Vector(), true, m_cBlueBaseSpr);
        m_cBlueFlagSpr.m_cCompassElement = ((HUDCompassNet)cHUDCompasRef).AddWaypointNet(new Vector(), true, m_cBlueFlagSpr);
        m_cRedBaseSpr.m_cCompassElement  = ((HUDCompassNet)cHUDCompasRef).AddWaypointNet(new Vector(), true, m_cRedBaseSpr);
        m_cRedFlagSpr.m_cCompassElement  = ((HUDCompassNet)cHUDCompasRef).AddWaypointNet(new Vector(), true, m_cRedFlagSpr);
        
        ShowFlags();
    }
    
    public void OnDestroy()
    {
        if (m_bDisableInNetGame)
            return;
        
        if ( m_cBlueFlagSpr != null )
        {
            RemoveSprite(m_cBlueFlagSpr);
            m_cBlueFlagSpr.delete();
            m_cBlueFlagSpr = null;	
        }
        
        if ( m_cRedFlagSpr != null )
        {
            RemoveSprite(m_cRedFlagSpr);
            m_cRedFlagSpr.delete();
            m_cRedFlagSpr = null;	
        }

        if ( m_cBlueBaseSpr != null )
        {
            RemoveSprite(m_cBlueBaseSpr);
            m_cBlueBaseSpr.delete();
            m_cBlueBaseSpr = null;	
        }
        
        if ( m_cRedBaseSpr != null )
        {
            RemoveSprite(m_cRedBaseSpr);
            m_cRedBaseSpr.delete();
            m_cRedBaseSpr = null;	
        }
        
		super.OnDestroy();
    }
    
    void SetNetGameInfo(NetGameInfo cGameInfo)
    {
        super.SetNetGameInfo( cGameInfo );
        
        if ( cGameInfo instanceof NetGameInfoCTF )
            m_cGameInfoCTF = (NetGameInfoCTF) cGameInfo;
    }
        
    
    
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
		
        super.Activate();   
		
    }
    
    
    void DrawDoUnderCursor()
    {
        super.DrawDoUnderCursor();
        //najpierw nasze spritey
        
        ShowFlags();
            
        //teraz te nadrzedne, zeby ich nie przykryc
        super.DrawDoUnderCursor();
    }
    
    void ShowFlags()
    {
        m_cBlueBaseSpr.MoveTop();
        if ( m_bBlueBasePosKnown )
		    m_cBlueBaseSpr.Show();
        else
            m_cBlueBaseSpr.Hide();
        
        
        m_cRedBaseSpr.MoveTop();
        if ( m_bRedBasePosKnown )
		    m_cRedBaseSpr.Show();
        else
            m_cRedBaseSpr.Hide();        
            
        m_cBlueFlagSpr.MoveTop();
        if ( m_bFlagVisible         &&
             m_bBlueFlagPosKnown    && 
             m_bBlueFlagPosVisible )
		    m_cBlueFlagSpr.Show();
        else
            m_cBlueFlagSpr.Hide();
            
        m_cRedFlagSpr.MoveTop();
        if ( m_bFlagVisible         &&
             m_bRedFlagPosKnown     &&
             m_bRedFlagPosVisible )
		    m_cRedFlagSpr.Show();
        else
            m_cRedFlagSpr.Hide();
    }
    
    public void HideAll()
	{
        super.HideAll();
        
        //m_cBlueFlagSpr.Hide();
        //m_cRedFlagSpr.Hide();
        
    }
    
	
		
        
    void ComputeFlagsPos()
    {
        if ( m_cGameInfoCTF == null )
            return;
        
        CTFFlagInfo cFlagInfo = m_cGameInfoCTF.GetCTFFlagInfo( NetTeamInfo.BLUE );
        if ( cFlagInfo != null )
        {
            m_bBlueFlagHasOwner = cFlagInfo.HasOwner();
            ComputeSpritePos( m_cBlueFlagSpr, cFlagInfo.GetPos() );
                
            if ( !m_bBlueFlagPosKnown )
            {
                m_cBlueFlagSpr.Show();
                m_bBlueFlagPosKnown = true;
            }
        }
        else
        {
            if ( m_bBlueFlagPosKnown )
            {
                m_cBlueFlagSpr.Hide();
                m_bBlueFlagPosKnown = false;
            }
        }
                
            
        cFlagInfo = m_cGameInfoCTF.GetCTFFlagInfo( NetTeamInfo.RED );
        if ( cFlagInfo != null )
        {
            m_bRedFlagHasOwner = cFlagInfo.HasOwner();
            ComputeSpritePos( m_cRedFlagSpr, cFlagInfo.GetPos());
            if ( !m_bRedFlagPosKnown )
            {
                m_cRedFlagSpr.Show();
                m_bRedFlagPosKnown = true;
            }
        }
        else
        {
            if ( m_bRedFlagPosKnown )
            {
                m_cRedFlagSpr.Hide();
                m_bRedFlagPosKnown = false;
            }
        }
    }
    
    void ComputeBasesPos()
    {
        if ( m_cGameInfoCTF == null )
            return;
        
        if ( ! m_bBlueBasePosKnown )
        {
            CTFBaseInfo cBaseInfo = m_cGameInfoCTF.GetCTFBaseInfo( NetTeamInfo.BLUE );
            if ( cBaseInfo != null )
            {
                ComputeSpritePos( m_cBlueBaseSpr, cBaseInfo.GetPos() );
                
                m_bBlueBasePosKnown = true;
                ShowFlags();
            }
        }
         
        if ( ! m_bRedBasePosKnown )
        {
            CTFBaseInfo cBaseInfo = m_cGameInfoCTF.GetCTFBaseInfo( NetTeamInfo.RED );
            if ( cBaseInfo != null )
            {
                ComputeSpritePos( m_cRedBaseSpr, cBaseInfo.GetPos() );

                m_bRedBasePosKnown = true;
                ShowFlags();
            }
        }
        
        //jak juz taz poznamy pozycja obu baz, to mozemy
        //juz zakonczyc dzialanie tej procki
        if ( m_bBlueBasePosKnown && m_bRedBasePosKnown )
            DisableCallMethod( METHOD_ComputeBasesPos );
    }
    
    
    public void PlayerPosBlink()
    {
        super.PlayerPosBlink();
        
        if ( m_bBlueFlagHasOwner )
        {
            //pozycja bedzie sie na zmiane pojawiala z graczem
            m_bBlueFlagPosVisible = !m_bPlayerPosVisible;
            
            if (m_bBlueFlagPosVisible)    
                m_cBlueFlagSpr.Show();
            else
                m_cBlueFlagSpr.Hide();
        }
        else
        {
            if (!m_bBlueFlagPosVisible)
            {
                m_cBlueFlagSpr.Show();
                m_bBlueFlagPosVisible = true;
            }
        }
        
        
        if ( m_bRedFlagHasOwner )
        {
            //pozycja bedzie sie na zmiane pojawiala z graczem
            m_bRedFlagPosVisible = !m_bPlayerPosVisible;
            
            if (m_bRedFlagPosVisible)    
                m_cRedFlagSpr.Show();
            else
                m_cRedFlagSpr.Hide();
        }
        else
        {
            if (!m_bRedFlagPosVisible)
            {
                m_cRedFlagSpr.Show();
                m_bRedFlagPosVisible = true;
            }
        }
    }
}
