public class HUDMapNet extends HUDMap
{
    //TODO: dorobic flagi ustawiajace czy ma byc wyswietlany
    //dany sprite playera
    
    NetGameInfo m_cGameInfo = null;
        
    HudNetMapSpritePlayer m_aPlayers[] = null;
    
    HudNetMapSpriteVehicle m_aVehicles[] = null;
    
    int METHOD_ComputePlayersPos        = 0;
    int METHOD_ComputeVehiclesPos       = 0;
    int METHOD_ComputePlayerPos         = 0;
    int METHOD_TryToSetNetGameInfo      = 0;
    int METHOD_PlayerPosBlink           = 0;
    int METHOD_StartComputeObjectsPos   = 0;
    
    public void OnCreate()
    {
        METHOD_ComputePlayersPos      = RegisterCallMethod( "ComputePlayersPos" );
        METHOD_ComputeVehiclesPos     = RegisterCallMethod( "ComputeVehiclesPos" );
        METHOD_ComputePlayerPos       = RegisterCallMethod( "ComputePlayerPos" );
        METHOD_TryToSetNetGameInfo    = RegisterCallMethod( "TryToSetNetGameInfo" );
        METHOD_PlayerPosBlink         = RegisterCallMethod( "PlayerPosBlink" );
        METHOD_StartComputeObjectsPos = RegisterCallMethod( "StartComputeObjectsPos" );
        
        super.OnCreate();
        
        if (m_bDisableInNetGame)
            return;
        
        m_aPlayers = new HudNetMapSpritePlayer[ GetPlayersCnt() ];
        
        for ( int i=0; i<m_aPlayers.length; i++ )
        {
            HudNetMapSpritePlayer cPlayer = (HudNetMapSpritePlayer)CreateObject("HudNetMapSpritePlayer");
            
            m_cMap.AddChild( cPlayer );
            m_aPlayers[i] = cPlayer;
        }
        
        m_aVehicles = new HudNetMapSpriteVehicle[ GetVehiclesCnt()];
        for ( int i=0; i<m_aVehicles.length; i++ )
        {
            HudNetMapSpriteVehicle cVehicle = (HudNetMapSpriteVehicle)CreateObject("HudNetMapSpriteVehicle");
            
            m_cMap.AddChild( cVehicle );
            m_aVehicles[i] = cVehicle;
        }
        
        TryToSetNetGameInfo();
        
        CallMethodEvery( METHOD_PlayerPosBlink, m_fBlinkTime);
        CallMethodIn( METHOD_StartComputeObjectsPos, 0.0f );
    }
    
    /**
     * Called from GameInfo when GameSettings changes
     */
    void OnUpdateGameSettings()
    {
        StartComputeObjectsPos();
    }
    
    void StartComputeObjectsPos()
    {
        DisableCallMethod( METHOD_ComputePlayersPos );  
        DisableCallMethod( METHOD_ComputeVehiclesPos );   
        
        CallMethodEvery( METHOD_ComputePlayersPos, 0.05f);  
        if (m_aVehicles.length > 0)
            CallMethodEvery( METHOD_ComputeVehiclesPos, 0.045f);  
    }
    
    void SetCompassRef(HUDCompass cCompass)
    {
        super.SetCompassRef(cCompass);
        if (!m_bDisableInNetGame)
        {
            for ( int i = 0; i < m_aPlayers.length; i++ )
            {
                m_aPlayers[i].m_cCompassElement = ((HUDCompassNet)cHUDCompasRef).AddWaypointNet(new Vector(), true, m_aPlayers[i]);
            }

            for ( int i=0; i<m_aVehicles.length; i++ )
            {
                m_aVehicles[i].m_cCompassElement = ((HUDCompassNet)cHUDCompasRef).AddWaypointNet(new Vector(), true, m_aVehicles[i]);
            }
        }
    }
        
    
       
    
    void TryToSetNetGameInfo()
    {
        NetGameInfo cGameInfo = cModule instanceof ModuleNet ?
                                ((ModuleNet)cModule).GetGameInfo() :
                                null;
        
        if ( cGameInfo != null )
            SetNetGameInfo( cGameInfo );
        else
            CallMethodIn( METHOD_TryToSetNetGameInfo, 0.2f );
    }
    
    void SetNetGameInfo(NetGameInfo cGameInfo)
    {
        m_cGameInfo = cGameInfo;
    }
    
    public void OnDestroy()
    {
        if (m_bDisableInNetGame)
            return;
        
        if ( m_aPlayers != null )
        {
            for ( int i=0; i<m_aPlayers.length; i++ )
            {
                if ( m_aPlayers[i] != null )
                {
                    RemoveSprite( m_aPlayers[i] );
                    m_aPlayers[i].delete();
                    m_aPlayers[i] = null;
                }
            }
            m_aPlayers = null;
        }
        
        super.OnDestroy();
    }
    
    int m_nVisiblePlayers = 0;
    
    void HideRemainingPlayers( int nVisiblePlayers )
    {
        m_nVisiblePlayers = nVisiblePlayers;
        
        for ( int i=nVisiblePlayers; i<m_aPlayers.length; i++ )
        {
            HudNetMapSpritePlayer cPlayer = m_aPlayers[i];
            if ( cPlayer == null )
                continue;
            
            cPlayer.SetMode( HudNetMapSpritePlayer._MODE_UNKNOWN );
            cPlayer.Hide();
        }
    }
    
    void HideRemainingVehicles( int nVisibleVehicles )
    {
        for ( int i=nVisibleVehicles; i<m_aVehicles.length; i++ )
        {
            HudNetMapSpriteVehicle cVehicle = m_aVehicles[i];
            if ( cVehicle == null )
                continue;
            
            //cVehicle.SetMode( HudNetMapSpritePlayer._MODE_UNKNOWN );
            cVehicle.Hide();
        }
    }
    
    public void PlayerPosBlink()
	{
        super.PlayerPosBlink();
        
        for ( int i=0; i<m_nVisiblePlayers; i++ )
        {
            HudNetMapSpritePlayer cPlayerSpr = m_aPlayers[i];
            if ( cPlayerSpr == null )
                continue;
            
            if (m_bPlayerPosVisible)
			    cPlayerSpr.Show();
		    else
			    cPlayerSpr.Hide();
        }
	}
    
    void ComputePlayersPos()
    {
        ComputePlayerPos();
        ComputePlayersPosIndividual();
    }
    
    void ComputePlayersPosIndividual()
    {
        int nPlayerSpriteIndex = 0;
        
        //TODO: czy trzeba wyciagac z modulu gameinfo?
        NetGameInfo cGameInfo = cModule instanceof ModuleNet ?
                                ((ModuleNet)cModule).GetGameInfo() :
                                null;
        
        NetGameSettings cGameSettings = cGameInfo instanceof NetGameInfo ?
                                        cGameInfo.GetGameSettings() :
                                        null;
        
        if ( cGameSettings == null ||
             !cGameSettings.IsValid() ||
             !cGameSettings.GetEnemiesVisibleOnHudMap() )
        {
            HideRemainingPlayers( nPlayerSpriteIndex );
            
            if ( cGameSettings != null && cGameSettings.IsValid() )
            {
                DisableCallMethod( METHOD_ComputePlayersPos );
                CallMethodEvery(METHOD_ComputePlayerPos, 0.05f);
            }
            return;
        }
                
        NetPlayerInfoList cPlayersList = cGameInfo.GetPlayerInfoList();
        if ( cPlayersList == null )
        {
            HideRemainingPlayers( nPlayerSpriteIndex );
            return;
        }
                
        for ( int i=0; i<cPlayersList.GetSize() && nPlayerSpriteIndex < m_aPlayers.length; i++ )
        {
            NetPlayerInfo cPlayerInfo = cPlayersList.GetPlayerByIndex( i );
            
            //swojego omijamy
            if ( cPlayerInfo == null ||
                 cPlayerInfo.bNetIsOwner )
                continue;
            
            PlayerNet cPlayer = cPlayerInfo.GetPlayer();
            if ( cPlayer             == null  ||
                 cPlayer.IsSpawned() == false )
                continue;
            
            HudNetMapSpritePlayer cPlayerSprite = m_aPlayers[ nPlayerSpriteIndex ];
            cPlayerSprite.SetMode( HudNetMapSpritePlayer._MODE_ENEMY );
            
            ComputeSpritePos( cPlayerSprite, cPlayer.GetPositionVectorVolatile() );
            
            if (m_bPlayerPosVisible)
                cPlayerSprite.Show();
            else
                cPlayerSprite.Hide();
            
            nPlayerSpriteIndex++;
        }
        
        
        HideRemainingPlayers( nPlayerSpriteIndex );
    }

    void ComputeVehiclesPos()
    {
        int nVehicleSpriteIndex = 0;
        
        NetGameInfo cGameInfo = cModule instanceof ModuleNet ?
                                ((ModuleNet)cModule).GetGameInfo() :
                                null;
        
        NetGameSettings cGameSettings = cGameInfo instanceof NetGameInfo ?
                                        cGameInfo.GetGameSettings() :
                                        null;
        
        if ( (cGameSettings == null) ||
             (!cGameSettings.IsValid()) || 
             (!cGameSettings.GetVehiclesVisibleOnHudMap()) )
        {
            HideRemainingVehicles( nVehicleSpriteIndex );
            
            if ( cGameSettings != null && cGameSettings.IsValid() )
            {
                //MK: cos tu jest namieszane!!! wrocic do tego jak 
                //widocznosc pojazdow bedzie w gamesettings
                DisableCallMethod( METHOD_ComputeVehiclesPos );
                CallMethodEvery(METHOD_ComputeVehiclesPos, 0.045f);
            }
            return;
        }
                
        java.util.Vector vVehicles = ((ModuleNet)GetModule()).GetVehicles();                
        for ( int i=0; i < vVehicles.size() && nVehicleSpriteIndex < m_aVehicles.length; i++ )
        {
            Vehicle cVehicle = (Vehicle)vVehicles.elementAt(i);
            if ( ( cVehicle == null ) || ( !cVehicle.DoesCanDrive() ) )
                continue;
            
            HudNetMapSpriteVehicle cVehicleSprite = m_aVehicles[ nVehicleSpriteIndex ];
            cVehicleSprite.SetMode( HudNetMapSpriteVehicle._MODE_VEHICLE );
            
            ComputeSpritePos( cVehicleSprite, cVehicle.GetPositionVectorVolatile() );
            
            if (CanShowVehicle(cVehicle, cGameSettings))
                cVehicleSprite.Show();
            else
                cVehicleSprite.Hide();
            
            nVehicleSpriteIndex++;
        }
        
        HideRemainingVehicles( nVehicleSpriteIndex );
    }
    
    boolean CanShowVehicle(Vehicle cVehicle, NetGameSettings cGameSettings)
    {
        return CanShowVehicleIndividual( cVehicle, cGameSettings );
    }
    
    boolean CanShowVehicleIndividual(Vehicle cVehicle, NetGameSettings cGameSettings)
    {
        Pawn []tOccupants = cVehicle.GetAllOccupants();
        boolean bEnemiesVisible = cGameSettings.GetEnemiesVisibleOnHudMap();
        if (tOccupants != null && tOccupants.length > 0)
        {
            for (int i = 0; i < tOccupants.length; i++)
            {
                if (tOccupants[i] == cPlayer)
                    return true;
            }
            //w samochodzie sa wrogowie
            return bEnemiesVisible;
        }
        return true;
    }
    
    void DrawDoUnderCursor()
    {
        super.DrawDoUnderCursor();
        
        for ( int i=0; i<m_aPlayers.length; i++ )
        {
            HudNetMapSpritePlayer cPlayer = m_aPlayers[i];
            if ( cPlayer == null )
                continue;
            if ( cPlayer.CanBeVisible() )
            {
                cPlayer.MoveTop();
                cPlayer.Show();
            }
            else
                cPlayer.Hide();
        }
    }
    
    void ComputeSpritePos( NetHudMapSprite cSprite, Vector vPos )
    {
        if ( cSprite == null || vPos    == null )
            return;

        int nSprSizeX = cSprite.GetCurrentSizeX();
        int nSprSizeY = cSprite.GetCurrentSizeY();
        
        cSprite.SetWorldPos(vPos);
        
        float fX = nMapWidth  - vPos.fX * nXcmIsPixls;
        float fZ = nMapHeight - vPos.fZ * nZcmIsPixls;
        
        cSprite.SetRelativePos(new Vector( fX - (float) nSprSizeX / 2.0f,
										   fZ - (float) nSprSizeY / 2.0f,
										   0.0f )
                               );               
    }
    
    void CallMethodsAfterActivate()
    {
        //tu nic nie wolamy 
    }
    
    void DisableCallMethodsAfterDeactivate()
    {
        //tu nic nie wolamy
    }
}



