public class ChromeServerList extends Window 
{
    final static int ID_LIST_ITEM = 4000;
    
    private ChromeListSort ListBox_Server  = null;
    private ChromeListSort ListBox_IP      = null;
    private ChromeListSort ListBox_Map     = null;
    private ChromeListSort ListBox_Ping    = null;
    private ChromeListSort ListBox_Players = null;
    
    private Button btnUpArrow = null;
    private Button btnDnArrow = null;
    private Button btnScrollBar = null;
    
    public int nServerCount = 0;
    
    void Init()
    {
        SetRelativePos(new Vector(25.0f,72.0f,0));
        SetSize(new Vector(560.0f,334.0f,0));
        
        ProcessMouse(true);
        ProcessKb(true);
        
        module = GetModule();
        
        ListBox_Server = (ChromeListSort)CreateObject("ChromeListSort");
        AddChildWnd(ListBox_Server,this);
        AddChild(ListBox_Server);
        ListBox_Server.Init(EChromeServerListUI.ListBox_Server,module);
        ListBox_Server.Show();
        
        ListBox_IP = (ChromeListSort)CreateObject("ChromeListSort");
        AddChildWnd(ListBox_IP,this);
        AddChild(ListBox_IP);
        ListBox_IP.Init(EChromeServerListUI.ListBox_IP,module);
        ListBox_IP.Show();
        
        ListBox_Map = (ChromeListSort)CreateObject("ChromeListSort");
        AddChildWnd(ListBox_Map,this);
        AddChild(ListBox_Map);
        ListBox_Map.Init(EChromeServerListUI.ListBox_Map,module);
        ListBox_Map.Show();
        
        ListBox_Ping = (ChromeListSort)CreateObject("ChromeListSort");
        AddChildWnd(ListBox_Ping,this);
        AddChild(ListBox_Ping);
        ListBox_Ping.Init(EChromeServerListUI.ListBox_Ping,module);
        ListBox_Ping.nDataType = ChromeListSort._NUMERICAL;
        ListBox_Ping.Show();
        
        ListBox_Players = (ChromeListSort)CreateObject("ChromeListSort");
        AddChildWnd(ListBox_Players,this);
        AddChild(ListBox_Players);
        ListBox_Players.Init(EChromeServerListUI.ListBox_Players,module);
        ((ListBox)ListBox_Players).ShowScroll(true);
        ListBox_Players.Show();
        
        //---przypisanie zaleznosci miedzdzy listami
        ListBox_Players.aListToSort.addElement(ListBox_Server);
        ListBox_Players.aListToSort.addElement(ListBox_IP);
        ListBox_Players.aListToSort.addElement(ListBox_Map);
        ListBox_Players.aListToSort.addElement(ListBox_Ping);
        
        ListBox_Server.aListToSort.addElement(ListBox_IP);
        ListBox_Server.aListToSort.addElement(ListBox_Map);
        ListBox_Server.aListToSort.addElement(ListBox_Ping);
        ListBox_Server.aListToSort.addElement(ListBox_Players);
        
        ListBox_IP.aListToSort.addElement(ListBox_Server);
        ListBox_IP.aListToSort.addElement(ListBox_Map);
        ListBox_IP.aListToSort.addElement(ListBox_Ping);
        ListBox_IP.aListToSort.addElement(ListBox_Players);
        
        ListBox_Map.aListToSort.addElement(ListBox_Server);
        ListBox_Map.aListToSort.addElement(ListBox_IP);
        ListBox_Map.aListToSort.addElement(ListBox_Ping);
        ListBox_Map.aListToSort.addElement(ListBox_Players);
        
        ListBox_Ping.aListToSort.addElement(ListBox_Server);
        ListBox_Ping.aListToSort.addElement(ListBox_IP);
        ListBox_Ping.aListToSort.addElement(ListBox_Map);
        ListBox_Ping.aListToSort.addElement(ListBox_Players);
    }
    
    int AddServerToList(NetServerInfo cServerInfo)
    {
        nServerCount = ListBox_Players.nItemCount;
        ListBox_Server.AddString(cServerInfo.sServerName,ID_LIST_ITEM + nServerCount);
        ListBox_IP.AddString(cServerInfo.sServerAddr,ID_LIST_ITEM + nServerCount);
        ListBox_Map.AddString(cServerInfo.GetLevelName(),ID_LIST_ITEM + nServerCount);
        ListBox_Ping.AddString(String.valueOf(cServerInfo.nPing),ID_LIST_ITEM + nServerCount);
        ListBox_Players.AddString(String.valueOf(cServerInfo.nNumberPlayerInGame) + "/" + cServerInfo.nMaxPlayersInGame , ID_LIST_ITEM + nServerCount);
        nServerCount = ListBox_Players.nItemCount;
        return nServerCount;
    }
    
    void Clear()
    {
        nServerCount = 0;
        ListBox_Server.Clear();
        ListBox_IP.Clear();
        ListBox_Map.Clear();
        ListBox_Ping.Clear();
        ListBox_Players.Clear();
    }
    /**Zwraca index wybranej pozycji
     */
    int GetSelection()
    {
        return ListBox_Server.GetSelection();
    }
    
    void SetSelect( int nIndex )
    {
        ListBox_Server.SetSelection(nIndex);    
    }
    
    int GetSelectionItemID()
    {
        return (ListBox_Server.GetItem(ListBox_Server.GetSelection()).nID - ID_LIST_ITEM);
    }
    
    /**Updatetuje pozycje na liscie jako parametr podajemy index w liscie jaki aktualnie ma ta
     * pozycja*/
    void UpdateServerOnListIndex(NetServerInfo cServerInfo, int nIndex)
    {
        ListBox_Server.ChangeString(cServerInfo.sServerName,nIndex);
        ListBox_IP.ChangeString(cServerInfo.sServerAddr,nIndex);
        ListBox_Map.ChangeString(cServerInfo.GetLevelName(),nIndex);
        ListBox_Ping.ChangeString(String.valueOf(cServerInfo.nPing),nIndex);
        ListBox_Players.ChangeString(String.valueOf(cServerInfo.nNumberPlayerInGame) + "/" + cServerInfo.nMaxPlayersInGame , nIndex);
    }
    
     /**Updatetuje pozycje na liscie jako parametr podajemy index w liscie jaki aktualnie ma ta
     * pozycja*/
    void UpdateServerOnListID(NetServerInfo cServerInfo, int nIDItem)
    {
        int nIndex = ListBox_Server.FindItemFromID(nIDItem + ID_LIST_ITEM);
        ListBox_Server.ChangeString(cServerInfo.sServerName,nIndex);
        ListBox_IP.ChangeString(cServerInfo.sServerAddr,nIndex);
        ListBox_Map.ChangeString(cServerInfo.GetLevelName(),nIndex);
        ListBox_Ping.ChangeString(String.valueOf(cServerInfo.nPing),nIndex);
        ListBox_Players.ChangeString(String.valueOf(cServerInfo.nNumberPlayerInGame) + "/" + cServerInfo.nMaxPlayersInGame , nIndex);
    }
    
    /**Metoda wyszukuje w liscie element po jego identyfikatorze( nie indexie)  i zwraca NetServerInfo
     * na podstawie jego zawartosci
     */
    NetServerInfo GetServerInfoID(int nIDItem)
    {
        NetServerInfo cItmeInfo = new NetServerInfo();
        cItmeInfo.sServerName = ListBox_Server.GetStringItmeID(nIDItem + ID_LIST_ITEM);
        cItmeInfo.sServerAddr = ListBox_IP.GetStringItmeID(nIDItem + ID_LIST_ITEM);
        cItmeInfo.sCurrentLevelName = ListBox_Map.GetStringItmeID(nIDItem + ID_LIST_ITEM); 
        cItmeInfo.nPing = Integer.parseInt(ListBox_Ping.GetStringItmeID(nIDItem + ID_LIST_ITEM));
        return cItmeInfo;
    }
    /**Zwraca informacje o danym Itemi, szuka po indexie 
     */
    NetServerInfo GetServerInfoIndex(int nIndex)
    {
        NetServerInfo cItmeInfo = new NetServerInfo();
        cItmeInfo.sServerName = ListBox_Server.GetItem(nIndex).sText;
        cItmeInfo.sServerAddr = ListBox_IP.GetItem(nIndex).sText;
        cItmeInfo.sCurrentLevelName = ListBox_Map.GetItem(nIndex).sText; 
        cItmeInfo.nPing = Integer.parseInt(ListBox_Ping.GetItem(nIndex).sText);
        return cItmeInfo;
    }
    
    /**Metoda sprawdza czy dany przycisk jest na liscie, sprawdza referencje*/
    boolean IsInList(Button btn_find)
    {
        boolean bRet = false;
        bRet = ListBox_IP.IsInList(btn_find);
        bRet = ListBox_Map.IsInList(btn_find);
        bRet = ListBox_Ping.IsInList(btn_find);
        bRet = ListBox_Players.IsInList(btn_find);
        bRet = ListBox_Server.IsInList(btn_find);
        return bRet;
    }
}
