/** Klasa okienka ktore obsluguje obiekty typu MenuNetEditControlsSet
 * Obsluga ta polega na kolejnym przydzielaniu kontrolkom miejsca 
 * na ekranie.
 */
public class MenuNetEditWindow extends MenuNetModalWindow
{
    private boolean m_bEditMode = true;
    void SetEditMode(boolean bMode){ m_bEditMode = bMode; }
    boolean GetEditMode(){ return m_bEditMode; }
    
    
    private Vector  m_vStartPos   = new Vector(100,120,0);
    void SetStartPos(Vector vPos){ m_vStartPos = vPos; }
    
	private Vector  m_vStopPos    = new Vector(800-128,600-32,0);
    void SetStopPos(Vector vPos){ m_vStopPos = vPos; }

    private Vector  m_vControlSize    = new Vector(0,0,0);

    private int     m_nOffsetY    = 6;
    //private int     m_nSpaceY     = 32;
    
    private int     m_nOffsetX    = 320;
    
        
    private int     m_nCurrentElement = 0;
    int GetCurrentElement(){ return m_nCurrentElement; }
    
    private Vector  m_vCurrentPos = new Vector( m_vStartPos );
    Vector GetCurrentSetPos(){ return m_vCurrentPos; }
    
    
    void SetControlSize(Vector vSize)
    { 
        SetStartPos(new Vector(GameObject.GetScreenWidth() * 0.1085f,GameObject.GetScreenHeight() * 0.22333333f,0.0f));
        SetStopPos(new Vector(GameObject.GetScreenWidth() * 0.84f,GameObject.GetScreenHeight() * 0.9033f,0.0f));
        m_vCurrentPos = new Vector( m_vStartPos );
 
        m_vControlSize = vSize; 
        //wylicznenie offsetu
        float fFreeSpace = (GameObject.GetScreenWidth() * 0.78f - 2.0f * m_vControlSize.fX ) / 3.0f;
        m_nOffsetX = (int)( m_vControlSize.fX + fFreeSpace);
        m_vStartPos.fX = fFreeSpace; 
        m_vCurrentPos.fX = m_vStartPos.fX;
    }
    
    boolean m_bNewColumn = false;
    
    void NextElement()
    {
        m_nCurrentElement++;
        m_vCurrentPos.fY += m_nOffsetY;
        m_vCurrentPos.fY += m_vControlSize.fY;
        m_bNewColumn = false;
        VerifyPos();
    }
    
    void NewColumn()
    {
        if ( !m_bNewColumn ) 
        {
            m_vCurrentPos.fY += m_vStopPos.fY;
            VerifyPos();
        }
    }
    
    /*
    void NewSet()
    {
        m_vCurrentPos.fY += 2.0 * m_nOffsetY;
        m_vCurrentPos.fY += 2.0 * m_vControlSize.fY;
        m_bNewColumn = false;
        VerifyPos();
    }*/
    
    void NewSet()
    {
        m_vCurrentPos.fY += m_nOffsetY;
        m_vCurrentPos.fY += 1.5f * m_vControlSize.fY;
        m_bNewColumn = false;
        VerifyPos();
    }
    
    void VerifyPos()
    {
        if ( m_vCurrentPos.fY > m_vStopPos.fY )
        {
            float fX = m_vCurrentPos.fX;
            m_vCurrentPos = new Vector( m_vStartPos );
            m_vCurrentPos.fX = fX + m_nOffsetX;
            m_bNewColumn = true;
            
            if ( m_vCurrentPos.fX > m_vStopPos.fX )
            {
                LogD(" Brak miejsca na nastepna kontrolke!\n");
                m_vCurrentPos = new Vector( m_vStartPos );
                m_vCurrentPos.fY += m_nOffsetY/2;
            }
        }
    }
    
    //handler przychodzacy po kliknieciu na check boxa kontrolki
    void OnCheckButtonPushed( MenuNetEditControlsSet cControls )
    {
        
    }
    
    //handler przychodzacy po wpisaniu cos do pola edit kontrolki
    void OnTypedValue( MenuNetEditControlsSet cControls )
    {
        
    }
    
}
