public class UIListBoxFiveStatics extends UIListBox
{
	int m_nNumberOfActiveElements = 0;
	
	//calkowita eliczba elementow trzymanych w liscie
	int m_iNumberOfVirtualElements = 0;
	
	//wszystkie dane przechowywane w liscie
	java.util.ArrayList m_aItemsData = new java.util.ArrayList();
	
	int m_iFirstVisibleFromList = 0;
	
	int m_iVirtualSelectedID = -1;
	
    //filtry
    //czy pokazywac tylko dostepne do podlaczenia
    boolean m_bAvailable = false;
    
    //czy pokazywac tylko bez hasla
    boolean m_bWithoutPassword = false;
    
    //jaki max ping 0 - off
    int m_iMaxPing = 0;
    
    //jaka minimalna liczba graczy
    int m_iMinPlayers = 0;
	
	boolean m_bFiltersOn = false;
    
	public void OnInit()
    {
        super.OnInit();
        RegisterMouseAxisRequest();
        RegisterMouseButtonRequest();
    }
	
	UIMenuButton CreateButton()
    {
        return (UIMenuButton)CreateObject("MenuButtonFiveStatics");
    }    
	
	//***********************************************************
	//metody przeciazone 
	//***********************************************************
	void OnScrollDown()
    {
        m_fMouseAxisDelta = 0.f;
        //ostatni element ktory moze byc na szczycie listy
        int nLastFirstVisible = m_iNumberOfVirtualElements - m_nCapacity;
        if (m_iFirstVisibleFromList < nLastFirstVisible) 
        {
            m_iFirstVisibleFromList++;
            UpdateButtonsOnList();
			int iSelection = GetSelection();
			if (iSelection != -1)
			{
				if(iSelection == 0)
				    super.SetSelection( -1 );
				else
					SetSelection( --iSelection );
			} else
				if (m_iVirtualSelectedID != -1)
				{
					if (m_iFirstVisibleFromList + m_nNumberOfActiveElements -1 == m_iVirtualSelectedID)
						SetSelection( m_nNumberOfActiveElements -1 );
				}
        }
    }
    
    void OnScrollUp()
    {
        m_fMouseAxisDelta = 0.f;
        if (m_iFirstVisibleFromList > 0) 
        {
            m_iFirstVisibleFromList--;
            UpdateButtonsOnList();
			
			int iSelection = GetSelection();
			if (iSelection != -1)
			{
				if(iSelection == GetItemCount()-1 )
				    super.SetSelection( -1 );
				else
					SetSelection( ++iSelection );
			}else
				if (m_iVirtualSelectedID != -1)
				{
					if (m_iFirstVisibleFromList == m_iVirtualSelectedID)
						SetSelection( 0 );
				}
        }
    }
    
	void UpdateList()
    {
		super.UpdateList();
		UIWindow wndTmp;
        for (int i = 0; i < vItems.size(); i++)
        {
            wndTmp = ((UIWindow)vItems.elementAt(i));
			if (wndTmp.IsActuallyVisible())
				wndTmp.Reload();
        }
	}
	
    void ChangeScrollBarPos()
    {
        if (!m_bNoScroll) 
		{
			Vector vScrollSize = m_ctrlScroll.GetSize();
			Vector vUpSize = m_btnUp.GetSize();
			Vector vThumbSize = m_btnThumb.GetSize();
			Vector vDownSize = m_btnDown.GetSize();
			Vector vThumbPos = new Vector();
			float fThumbMinPos = vUpSize.fY;
			float fThumbMaxPos = vScrollSize.fY - vDownSize.fY - vThumbSize.fY;
			vThumbPos.fX = vScrollSize.fX/2f - vThumbSize.fX/2f;
			if (m_iNumberOfVirtualElements > m_nCapacity)
				vThumbPos.fY = fThumbMinPos + (m_iFirstVisibleFromList)*(fThumbMaxPos - fThumbMinPos)/(m_iNumberOfVirtualElements - m_nCapacity);
			else
				vThumbPos.fY = fThumbMinPos;
			
			
            float fScrollRange = m_ctrlScroll.GetSize().fY - m_btnDown.GetSize().fY - m_btnUp.GetSize().fY;
            if (m_iNumberOfVirtualElements < m_nCapacity)
                vThumbSize.fY = fScrollRange;
            else
                vThumbSize.fY = fScrollRange * ((float)m_nCapacity)/((float)m_iNumberOfVirtualElements);
			m_btnThumb.SetRelativePos(vThumbPos);
            m_btnThumb.SetSize(vThumbSize);
			m_btnThumb.UpdateLogicSizeAndPos( m_btnThumb.GetSize(), m_btnThumb.GetPos());
			m_btnThumb.OnSizeAndPos();
        }
    }
    
	void EnsureVisible(int nPos)
    {
        if ((nPos < 0)||(nPos >= m_nCapacity)) return;
		nPos += m_iFirstVisibleFromList;
        int nLastFirstVisible = m_iNumberOfVirtualElements - m_nCapacity;
        if (nPos < m_iFirstVisibleFromList) 
        {
            m_iFirstVisibleFromList = nPos;
            UpdateButtonsOnList();
        }
        if (nPos >= m_iFirstVisibleFromList + m_nCapacity)
        {
            if (nPos > nLastFirstVisible) 
				m_iFirstVisibleFromList = nLastFirstVisible;
            else 
				m_iFirstVisibleFromList = nPos;
            UpdateButtonsOnList();
        }
    }
	
	//przy dodawaniu od razu wypelniane statiki w buttonie
	int AddItem(String sText, NetServerInfo cServerInfo)
	{
	    if (IsFilterNeeded(cServerInfo))
            return -1;
        
		m_aItemsData.add(cServerInfo);
		m_iNumberOfVirtualElements = m_aItemsData.size();
		
		//dodaje tylko pierwsze (m_nCapacity+1) elementow
		if (m_nNumberOfActiveElements >= m_nCapacity)
		{
			ChangeScrollBarPos();
			return m_iNumberOfVirtualElements - 1;
		}
		
		//Jesli mamy wiecej elementow od m_nNumberOfActiveElements to korzystamy z nich
		if(nItemCount > m_nNumberOfActiveElements)
		{
			UpdateServerOnListID(cServerInfo, m_nNumberOfActiveElements);
			((UIButton)vItems.elementAt(m_nNumberOfActiveElements)).Show();
			
			m_nNumberOfActiveElements++;	
			if (m_iNumberOfVirtualElements != m_nNumberOfActiveElements)
				CrashLog("UIListBoxFiveStatic::Error::m_iNumberOfVirtualElements != m_nNumberOfActiveElements-1 \n");
			return (m_nNumberOfActiveElements-1);
		}
		
		m_nNumberOfActiveElements++;
		
		int iIndex = super.AddItem(sText, (Object)cServerInfo);
		MenuButtonFiveStatics cItem = (MenuButtonFiveStatics)GetItem(iIndex);
		cItem.SetAllTexts(cServerInfo.sServerName, 
						  cServerInfo.sServerAddr, 
						  cServerInfo.GetShortLevelName(),
                          ENetGameType.GetGameNameShort( cServerInfo.nGameType ),
						  String.valueOf(cServerInfo.nPing),
						  String.valueOf(cServerInfo.nNumberPlayerInGame) + "/" + cServerInfo.nMaxPlayersInGame,
                          cServerInfo.CanITryToJoin(),
                          cServerInfo.IsPasswordRequired(),
                          cServerInfo.IsServerResponding());
        
		cServerInfo.nItemID = iIndex;
		
		if (m_iNumberOfVirtualElements - 1 != iIndex)
				CrashLog("UIListBoxFiveStatic::Error::m_iNumberOfVirtualElements != iIndex \n");
        return iIndex;
    }
	
	void SetSelection(int nIndex)
    {
		super.SetSelection(nIndex);		
		if(nIndex >= 0 && nIndex <= m_nNumberOfActiveElements)
			m_iVirtualSelectedID = m_iFirstVisibleFromList + nIndex;
		else
			m_iVirtualSelectedID = -1;
	}
	//***********************************************
	//metody przeciazone, nieuzywane do czasu kiedy bedzie mozna sie 
	//bez nich obejsc a metody rodzica wymagaja poprawek
	void RemoveItem(int nIndex)
    {
    }
	
	int InsertItem(UIButton btnItem, int nIndex)
    {
        if ((btnItem == null)||(nIndex < 0)) 
            return -1;
        return -1;  
    }
    
    int InsertItem(String sText, Object data, int nIndex)
	{
		return -1;
	}
	
	void MoveSelectedDown(){}
	
	void MoveSelectedUp(){}
    
	//***********************************************************
	//koniec metod przeciazonych 
	//***********************************************************
	
	//ustawia selekcje na zadany konkretny element - indeks jest z listy globalnej m_aItemsData
	//ten sam ktory zwraca AddElement
	void SetSelectionFromVirtual(int nPos)
    {
        if ((nPos < 0)||(nPos >= m_iNumberOfVirtualElements)) return;
        int nLastFirstVisible = m_iNumberOfVirtualElements - m_nCapacity;
		if (nPos < m_iFirstVisibleFromList) 
		{
			m_iFirstVisibleFromList = nPos;
			UpdateButtonsOnList();
			SetSelection(0);
		}else
			if (nPos >= m_iFirstVisibleFromList + m_nCapacity)
			{
				if (nPos > nLastFirstVisible) 
				{
					m_iFirstVisibleFromList = nLastFirstVisible;
					UpdateButtonsOnList();
					SetSelection(nPos - m_iFirstVisibleFromList);
				}
				else 
				{
					m_iFirstVisibleFromList = nPos;
					UpdateButtonsOnList();
					SetSelection(0);
				}
			}else
				SetSelection(nPos);
	}
	
	int GetVirtualSelection()
	{
		return m_iVirtualSelectedID;
	}
	
	Object GetDataFromSelected()
	{
		if(m_iVirtualSelectedID == -1)
			return null;
		
		return m_aItemsData.get(m_iVirtualSelectedID);
	}
	
    boolean SetFilters(boolean bAvailable, boolean bWithoutPassword, int iMaxPing, int iMinPlayers, boolean bFiltersOn)
    {
        boolean bChange = false;
		if (m_bFiltersOn != bFiltersOn)
		{
			bChange = true;
			m_bFiltersOn = bFiltersOn;
		}
		if(!m_bFiltersOn)
		{
			bAvailable = false;
			bWithoutPassword = false;
			iMaxPing = 0;
			iMinPlayers = 0;
		}
		if(m_bAvailable != bAvailable)
		{
			bChange = true;
			m_bAvailable = bAvailable;
		}
		if(m_bWithoutPassword != bWithoutPassword)
		{
			bChange = true;
			m_bWithoutPassword = bWithoutPassword;
		}
		if(m_iMaxPing != iMaxPing)
		{
			m_iMaxPing = iMaxPing;
			bChange = true;
		}
        if(m_iMinPlayers != iMinPlayers)
		{
			m_iMinPlayers = iMinPlayers;
			bChange = true;
		}
		return bChange;
    }
    
    boolean IsFilterNeeded(NetServerInfo cServerInfo)
    {
       if (m_bAvailable)
           if(!cServerInfo.CanITryToJoin())
               return true;
       
       if(m_bWithoutPassword)
           if(cServerInfo.IsPasswordRequired())
               return true;
           
       if(m_iMaxPing>0)
          if (cServerInfo.nPing > m_iMaxPing)
              return true;
       
       if(cServerInfo.nNumberPlayerInGame<m_iMinPlayers)
           return true;
       
       return false;
    }
    
	void UpdateButtonsOnList()
	{
		for (int i = m_iFirstVisibleFromList, j = 0; i < m_aItemsData.size() && j < GetItemCount(); ++i, ++j )
		{
			NetServerInfo cInfo = (NetServerInfo)m_aItemsData.get( i ); 
			UpdateServerOnListID(cInfo, j);
		}
		ChangeScrollBarPos();
	}
	
	void UpdateServerOnListID(NetServerInfo cServerInfo, int iIndex)
	{
		cServerInfo.nItemID = iIndex;
		MenuButtonFiveStatics cItem = (MenuButtonFiveStatics)GetItem(iIndex);
	    cItem.m_cData = (Object)cServerInfo;
		cItem.SetAllTexts(cServerInfo.sServerName, 
						  cServerInfo.sServerAddr, 
						  cServerInfo.GetShortLevelName(),
                          ENetGameType.GetGameNameShort( cServerInfo.nGameType ),
						  String.valueOf(cServerInfo.nPing),
						  String.valueOf(cServerInfo.nNumberPlayerInGame) + "/" + cServerInfo.nMaxPlayersInGame,
                          cServerInfo.CanITryToJoin(),
                          cServerInfo.IsPasswordRequired(),
                          cServerInfo.IsServerResponding());
	}
	
	/*int GetVirtualSelection()
	{
		int iSelection = GetSelection();
		if (iSelection == -1)
			return -1;
		
		return m_iFirstVisibleFromList + iSelection;
	}*/
	
	void UpdateServerOnVirtualID(NetServerInfo cServerInfo, int iIndex)
	{
		if (iIndex < 0)
		{
			if(iIndex == -1)
			{
				//proba dodania po updacie
				cServerInfo.nItemID = AddItem("",cServerInfo);
				return;
			}else
				return;
		}else
			if (iIndex >= m_iNumberOfVirtualElements)
			{
				CrashLog("UIListBoxFiveStatic::Error::m_iNumberOfVirtualElements >= iIndex \n");
				return;
			}
	
		m_aItemsData.set(iIndex, cServerInfo);
	
		if (iIndex >= m_iFirstVisibleFromList && iIndex < m_iFirstVisibleFromList + m_nNumberOfActiveElements)
			UpdateServerOnListID(cServerInfo, iIndex - m_iFirstVisibleFromList);
	}
	
	void ClearList()
	{
        SetSelection(-1);
		m_nNumberOfActiveElements = 0;
		m_aItemsData.clear();
		m_iNumberOfVirtualElements = 0;
		m_iFirstVisibleFromList = 0;
		
		 for(int i = 0; i < nItemCount; i++)
         {
            UIButton btn = (UIButton)vItems.elementAt(i);
			btn.m_cData = null;
			btn.Hide();
		 }
	}
}
