public class ENetPlayerProfileUI extends EUI 
{
    final static float P256 = 1.0f/256.0f;
    final static float P1024 = 1.0f/1024.0f;
    
    final static int ID_EDIT_NAME     = 341; 
    final static int ID_EDIT_MESH     = 342;
    
    final static int ID_LABEL_NAME    = 371; 
    final static int ID_LABEL_MESH    = 372;
    final static int ID_LABEL_SKIN    = 373;
    
    final static int ID_BTN_SAVE      = 345;
    final static int ID_BTN_CANCEL    = 346;
    final static int ID_BTN_BACK      = 347;
    final static int ID_BTN_NEWPROFILE= 348;
	final static int ID_BTN_DELEEPROFILE = 349;
    
    final static int ID_BTN_PREVIOUS_0    = 150;
    final static int ID_BTN_PREVIOUS_1    = 151;
    final static int ID_BTN_PREVIOUS_2    = 152;
    final static int ID_BTN_PREVIOUS_3    = 153;
    final static int ID_BTN_PREVIOUS_4    = 154;
    final static int ID_BTN_PREVIOUS_5    = 155;
    
    final static int ID_BTN_NEXT_0   = 160;
    final static int ID_BTN_NEXT_1   = 161;
    final static int ID_BTN_NEXT_2   = 162;
    final static int ID_BTN_NEXT_3   = 163;
    final static int ID_BTN_NEXT_4   = 164;
    final static int ID_BTN_NEXT_5   = 165;
    
    final static int ID_BTN_LEFT   = 170;
    final static int ID_BTN_RIGHT   = 171;
    
    final static int ID_BTN_CONTROLS  = 301;
    
    //----------------------------------------
    
    static UIElement Label_Name = new UIElement(
            ID_LABEL_NAME,0,
            new Vector(20,40,0),
            new Vector(128,32,0),
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala,
            EButtonFlags.BTN_TYPE_PRESSBUTTON,
            "&PLAYER NAME&"
            );
    
    static UIElement Label_Mesh = new UIElement(
            ID_LABEL_MESH,0,
            new Vector(20,124-42,0),
            new Vector(128,32,0),
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala,
            EButtonFlags.BTN_TYPE_PRESSBUTTON,
            "&MODEL MESH&"
            );
    
    static UIElement Edit_Name = new UIElement(
            ID_EDIT_NAME,0,
            new Vector(20+138,40,0),
            new Vector(128,32,0),
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamka2Mala, 
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamka2Mala, 
            EButtonFlags.WND_TYPE_EDIT,
            ""
            );
    
    static UIElement Edit_Mesh = new UIElement(
            ID_EDIT_MESH,0,
            new Vector(20+138,124-42,0),
            new Vector(128,32,0),
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamka2Mala, 
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamka2Mala, 
            EButtonFlags.WND_TYPE_EDIT,
            ""
            );
    
    static UIElement cRamka = new UIElement(
        0,0,
        new Vector(383,33,0),
        new Vector(223,302,0),
        MenuTextures.sNetMenuMapListBox,
        new Rect( 11.0f * P256, 54.0f * 1.0f/512.0f, 251.0f * P256, 307.0f * 1.0f/512.0f),
        "",
        new Rect(),
        "", 
        new Rect(),
        "", 
        new Rect(),
        EButtonFlags.BTN_TYPE_LISTBOX,
        ""
        );
    
    static float fButtonHeight = 30.0f;
    
    static UIElement GetLabelSkin(int i)
    {
        return new UIElement(
            ID_LABEL_SKIN,0,
            new Vector(20,124-21+ fButtonHeight*(i+1),0),
            new Vector(128,32,0),
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala, 
            MenuTextures.sRamkaMala,
            EButtonFlags.BTN_TYPE_PRESSBUTTON,
            SkinPartial.GetElementSkinName(i)
            );
    }
    
    static UIElement GetButtonPrevious(int i)
    {
        return new UIElement(
        ID_BTN_PREVIOUS_0+i,0,
        new Vector(20+138,124-21+ fButtonHeight*(i+1),0),
        new Vector(32,32,0),
        MenuTextures.sGuzikLewo, 
        MenuTextures.sGuzik2Lewo, 
        MenuTextures.sGuzikLewo, 
        MenuTextures.sGuzik2Lewo, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    }
    
    static UIElement GetButtonNext(int i)
    {
        return new UIElement(
        ID_BTN_NEXT_0+i,0,
        new Vector(20+138+32,124-21 + fButtonHeight*(i+1),0),
        new Vector(32,32,0),
        MenuTextures.sGuzikPrawo, 
        MenuTextures.sGuzik2Prawo, 
        MenuTextures.sGuzikPrawo, 
        MenuTextures.sGuzik2Prawo, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    }
        
    static UIElement Button_Left = new UIElement(
        ID_BTN_LEFT,0,
        new Vector(383,340,0),
        new Vector(32,32,0),
        MenuTextures.sGuzikLewo, 
        MenuTextures.sGuzik2Lewo, 
        MenuTextures.sGuzikLewo, 
        MenuTextures.sGuzik2Lewo, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Button_Right = new UIElement(
        ID_BTN_RIGHT,0,
        new Vector(383 + 223 - 32 ,340,0),
        new Vector(32,32,0),
        MenuTextures.sGuzikPrawo, 
        MenuTextures.sGuzik2Prawo, 
        MenuTextures.sGuzikPrawo, 
        MenuTextures.sGuzik2Prawo, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    
    
    static UIElement Button_Controls = new UIElement(
        ID_BTN_CONTROLS,0,
        new Vector(20,340,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka2, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka2, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&CONTROLS&"
        );
    
    static UIElement Button_Save = new UIElement(
        ID_BTN_SAVE,0,
        new Vector(324+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&SAVE PROFILE&"
        );
    
    static UIElement Button_Cancel = new UIElement(
        ID_BTN_CANCEL,0,
        new Vector(186+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&CANCEL&"
        );
    
    static UIElement Button_NewProfile = new UIElement(
        ID_BTN_NEWPROFILE,0,
        new Vector(324+14 + 138,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&NEW PROFILE&"
        );
    
    static UIElement Button_Back = new UIElement(
        ID_BTN_BACK,0,
        new Vector(48+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala,  
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&OK&"
        );
    
}

