import java.io.*;
public class ChromeNetCreatMenu extends ChromeMenuWindow implements IConnectionCallback
{
    UIListBox ListBox_AvailableMap = null;
	UIListBox ListBox_Maplist      = null;
    
	//MenuNetGameSettings m_cMenuNetGameSettings = null;
    
    /** identyfikator dialogu tworzenia servera */
    final static int ID_DIALOG_CREATING_SERVER = 1;
    final static int ID_DIALOG_MS_AUTHORIZATION_FAILED = 2;
    
    final static int ID_MAP_ITEM = 8000;
    /**ogolna liczba map*/
    int nCount = 0;
    
    /**Sciezka do katalogu z mapami do multiplayera */
    static final String sMapDir = "Data/LevelsNet";
    
    String m_sLevelsNetFile = null;
    
    {
        nMovieLoop = 16;
    }
    
    void Init(MenuBackground cBack)
    {
        MenuModule=(ChromeMenuModule)GetModule(); 
        ListBox_AvailableMap = (UIListBox)GetElem("ID_AVAILABLE_MAP");
        ListBox_Maplist = (UIListBox)GetElem("ID_MAP_LIST");
        
        m_sLevelsNetFile = NetPlayerProfile.GetCurrentFavoritesMapsFileName();
        
        if (sm_bAutoCreateServer == true)
        {
            FindAvailableMap();
            if (ListBox_Maplist.GetItemCount() == 0)
            {
                while ( ListBox_AvailableMap.GetItemCount() > 0 )
                {
                    UIButton cItem        = ListBox_AvailableMap.GetItem( 0 );
                    if ( ! (cItem.GetData() instanceof NetMapInfo) )
                        continue;
                    
                    NetMapInfo cMapInfo = (NetMapInfo)cItem.GetData();
                    
                    if ( cMapInfo.GetFileName() != null)
                    {
                        FromAvailableToMapList( 0 );
                    }
                }    
                SaveMaps();
            }
            
            StartServer();
            sm_bAutoCreateServer = false;//zaby nastepnym razem nie ladowalo na chama
        }
        else
        {
            FindAvailableMap();
            UpdateButtons();
			MenuModule.cCursor.CallOnFrameEnd("Show");
        }
    }
	
	void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
		
		if(cSender.m_sId.equals("ID_BUTTON"))
			{
			if(nCommand == EUIConst.CM_DBCLICK || nCommand == EUIConst.CM_CLICK)
			{
				if(cSender.IsChildOf(ListBox_AvailableMap))	
				{
                    if (nCommand == EUIConst.CM_DBCLICK)
                    {
    					CallMethodIn("FromAvailableToMapList", 0);
	    				CallMethodIn("UpdateButtons", 0);
                    }
                    else
                    {
                        ListBox_Maplist.SetSelection(-1);
                    }
				}
                else
                {
					if(cSender.IsChildOf(ListBox_Maplist))
					{
                        if (nCommand == EUIConst.CM_DBCLICK)
                        {
                            CallMethodIn("FromMapToAvailableList", 0);
                            CallMethodIn("UpdateButtons", 0);
                        }
                        else
                        {
                            ListBox_AvailableMap.SetSelection(-1);
                        }
                    }
                }
    		}
			UpdateButtons();
			return;
			}else
				if(cSender.m_sId.equals("ID_UP")
				   ||cSender.m_sId.equals("ID_DOWN")
                   ||cSender.m_sId.equals("ID_THUMB")
				   ||cSender.m_sId.equals("ID_AVAILABLE_MAP")
				   ||cSender.m_sId.equals("ID_MAP_LIST"))
					return;
		
		int nID = GetButtonId(cSender.m_sId);
            
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
			switch(nID)
        {
            case EChromeNetCreatMenuUI.ID_BTN_SERVERSETTINGS:
            {
                SaveMaps();
                MenuModule.SetMenu("MenuNetServerSettings");
                //MenuNetServerSettings cMenu = (MenuNetServerSettings)CreateObjectNoInit( "MenuNetServerSettings" );
                //cMenu.SetParams( MenuModule, this );
                //cMenu.InitObject();
                //cMenu.CallMethodIn( "Show", 0.0f );
                break;
            }
            case EChromeNetCreatMenuUI.ID_BTN_ADDMAP:
            {
                CallMethodIn("FromAvailableToMapList", 0);
                break;
            }
            case EChromeNetCreatMenuUI.ID_BTN_REMOWEMAP:
            {
                CallMethodIn("FromMapToAvailableList", 0);
                break;
            }
            case EChromeNetCreatMenuUI.ID_BTN_MAPSETTINGS:
            {
                MapSettings();
                break;
            }
            case EChromeNetCreatMenuUI.ID_BTN_BACK:
            {
                SaveMaps();
				Discard();
                break;    
            }
            
            case EChromeNetCreatMenuUI.ID_BTN_MOVEMAPDOWN:
            {
                MoveMapDown();
                break;    
            }
            
            case EChromeNetCreatMenuUI.ID_BTN_MOVEMAPUP:
            {
                MoveMapUp();
                break;    
            }
            
            
            case EChromeNetCreatMenuUI.ID_BTN_STARTGAME:
            {
                SaveMaps();
                
                //TODO: dorobic wylaczanie tego cuda...
                SetMaxTimerUpdate(10000000);
                
                StartServer();
                //ModuleNet.CreateServer( MenuModule, NetGameInitInfo.GetOnServer() );
                break;    
            }
        }
        CallMethodIn("UpdateButtons", 0);
		}
	}
    
    /**
     *   TWORZENIE SERVERA
     */
    
    String sCreatingServerProgress = ".";
    MasterServerAuthConnection cMasterServerAuthConn = null;
    
    void StartServer()
    {
        /** jesli tworzymy server internetowy, to wczesniej musimy uzyskac autoryzacje
         * z Master Servera; dla serverow LANowych od razu przechodzimy do tworzenia servera
         */
        SetGlobalTimerSpeedUp( ModuleNet.sm_m_fTimerSpeedUp );
        
        if (NetGameInitInfo.GetOnServer().GetServerInfo().IsInternetGame() == true)
        {
            CrashLog("Creating internet server. Master Server authorization required\n");
            
            CallMethodIn("StartingServer", 1.0f);
            sCreatingServerProgress = ".";
            
            Hide();

            ShowCancelDialog(ID_DIALOG_CREATING_SERVER, "&CREATING_SERVER&", sCreatingServerProgress, null);
            
            if (sm_bAutoCreateServer == true)
            {
                //kosmicznie, bo sytuacja jest kosmiczna
                //CallMethodIn("Hide",0);
                MenuModule.cMenuBackground.CallMethodIn("Show",0);// 
                MenuModule.cCursor.CallMethodIn("Show",0);
            }
            
            cMasterServerAuthConn = (MasterServerAuthConnection)CreateObject("MasterServerAuthConnection");
            
            MasterServersMngr cMSMngr = new MasterServersMngr();
            MasterClient.GetMasterClient().SetAvailableMasterServers(
                                            cMSMngr.GetMasterServers(), 
                                            cMSMngr.GetTimeOut() );
            //rozpoczynamy proces autoryzacji
            //FIX - CDKey pobierany na podstawie zahardcodowanego stringa            
            
            //*
            String sCDKey = RegKeyReadString("SOFTWARE\\Techland\\Chrome", "SerialNumber");
            cMasterServerAuthConn.Init(MasterClient.GetMasterClient(),
                                     sCDKey,
                                     this,
                                     180.0f,//MP - przedluzylem czas, bo na forum ktos sie buntowal o timeouty
                                     2.0f);            
            //*/
            
            /*_bMultiplayerDemo
            cMasterServerAuthConn.Init(MasterClient.GetMasterClient(), null, this,
                                       180.0f,
                                       2.0f);            
            */
        }
        else
        {
            CrashLog("Creating LAN server or Master Server authorization is not required\n");
            
            ConfirmedStartServer();
        }
    }
    
    void ConfirmedStartServer()
    {
        ModuleNet.CreateServer( MenuModule, NetGameInitInfo.GetOnServer() );
    }
    
    void StartingServer()
    {
        if (sCreatingServerProgress.length() < 15)
        {
            sCreatingServerProgress += ".";
        }
        else
        {
            sCreatingServerProgress = ".";
        }
        
        m_cYesNoDlg.SetQuestionText(sCreatingServerProgress);
        
        CallMethodIn("StartingServer", 1.0f);
    }
    
    void OnCancelFromDlg(int nID)
    {
        super.OnCancelFromDlg(nID);
        
        switch (nID)
        {
        case ID_DIALOG_CREATING_SERVER:
            
            CrashLog("[ChromeNetCreatMenu] cancelling server creation\n");
            
            if (cMasterServerAuthConn != null)
            {
                cMasterServerAuthConn.Cancel();
            }
            
            break;
        }
    }
    
    public void Succeeded(int iResult)
    {
        StopStartingServerProcess();
        ReleaseYesNoDialog();
        
        MasterClient MClient = MasterClient.GetMasterClient();
        
        CrashLog("[ChromeNetCreatMenu] " + MasterClient.GetAuthState(MClient.GetAuthState()) + "\n");
        
        if (MClient.IsAuthorized() == true)
        {
            ConfirmedStartServer();
        }
        else
        {
            ShowOKDialog(ID_DIALOG_MS_AUTHORIZATION_FAILED, "&MS_AUTHENTICATION_FAILED&", MasterClient.GetAuthState(MClient.GetAuthState()), null);
        }
    }
    
    public void Failed()
    {
        StopStartingServerProcess();
        ReleaseYesNoDialog();
        
        ShowOKDialog(ID_DIALOG_MS_AUTHORIZATION_FAILED, "&MS_AUTHENTICATION_FAILED&", "&CONNECTION_TIMEOUT&", null);
        
        CrashLog("[ChromeNetCreatMenu] starting server failed due to time out with authorizing in Master Server\n");
    }
    
    public void Canceled()
    {
        StopStartingServerProcess();
        
        CrashLog("[ChromeNetCreatMenu] server creation canceled\n");
    }
    
    void StopStartingServerProcess()
    {
        DisableCallMethod("StartingServer");
        cMasterServerAuthConn = null;
        Show();
    }
    
    /**
     *  KONIEC TWORZENIA SERVERA
     */
	  
	
   
	/**Znajduje mapy w domyslnym katalogu i dodaje zapamietane mapy do MapListy*/
    void FindAvailableMap()
    {
		ListBox_AvailableMap.Clear();
        File MapDirec = new File( sMapDir );
        if (!MapDirec.exists())
        {
            MapDirec.mkdir();
            return;
        }
        String []aMapName = MapDirec.list();
        
        java.util.Vector aChoosenMapList = new java.util.Vector();
        ParseKeyword Root=ParseFile( m_sLevelsNetFile );
        
        if(Root==null)
        {
            LogD("Error while read/parse " + m_sLevelsNetFile + " file !\n");
        }
        else
        {
            for (ParseKeyword cKey=Root; cKey!=null; cKey=cKey.GetNext())
            {
                if (cKey.Equals("LevelMapNet"))
                {
                    NetMapInfo cMapInfo = new NetMapInfo( cKey.GetSParam( 0 ) );
                    if (cMapInfo.SetGameType( cKey.GetIParam( 1 ) ) )
                        aChoosenMapList.addElement( (Object)cMapInfo );
                }
            }
            Root.delete();
        }
        
        if (aMapName == null )  
            return;
        //najpierw uzupelniam lista dostepnych map
        for ( int i = 0 ; i < aMapName.length ; i++ )
        {
            String sDir        = sMapDir + "/" + aMapName[ i ];
            File   cDirToCheck = new File( sDir );
            if ( cDirToCheck.isDirectory() )
            {
                //sprawdzamy mape z katalogu sDir
                String sMapFile = sDir + "/"+ aMapName[i] + ".map";
                for ( int iGameType = 0; iGameType < ENetGameType.TYPES_COUNT; iGameType++)
                {
                    NetMapInfo cMapInfo = new NetMapInfo( sMapFile );
                    if (cMapInfo.SetGameType( iGameType ))
					{
                         AddMapInfoToAvailableMap(cMapInfo);
					}
                }
            }
        }
        
        //a teraz niektore z nich wrzuce do wybranych
        for ( int i=0; i < aChoosenMapList.size() ; i++ )
        {
            if ( ! (aChoosenMapList.elementAt(i) instanceof NetMapInfo) )
                continue;
            NetMapInfo cChoosenMapInfo = (NetMapInfo)aChoosenMapList.elementAt(i);
            
            //sprawdze czy jest taki na liscie
            for ( int j=0; j<ListBox_AvailableMap.GetItemCount(); j++ )
            {
                UIButton cItem        = ListBox_AvailableMap.GetItem( j );
                if ( ! (cItem.GetData() instanceof NetMapInfo) )
                    continue;
                    
                NetMapInfo cMapInfo = (NetMapInfo)cItem.GetData();
                
                if ( cMapInfo.GetFileName() != null
                     &&
                     cMapInfo.GetFileName().equals( cChoosenMapInfo.GetFileName() )
                     &&                                                        
                     cMapInfo.GetGameType() == cChoosenMapInfo.GetGameType() )
                {
                    FromAvailableToMapList( j );
                    break;
                }
            }    
        }
    }
    
    //nie chce tworzyc specjalnie nowej klasy wiec zrobie to w ten sposob
    void AddMapInfoToAvailableMap(NetMapInfo cMapInfo)
    {
        String sLevelName = cMapInfo.GetLevelName();
        String sGameType = ENetGameType.GetGameNameShort(cMapInfo.GetGameType());
        
        int j;
        for ( j=0 ; j<ListBox_AvailableMap.GetItemCount(); j++ )
            {
                UIButton cItem        = ListBox_AvailableMap.GetItem( j );
                
                if ( ! (cItem.GetData() instanceof NetMapInfo) )
                    continue;
                    
                NetMapInfo cMapTestInfo = (NetMapInfo)cItem.GetData();
                String sTestGameType = ENetGameType.GetGameNameShort(cMapTestInfo.GetGameType());
                
                if ( sTestGameType.compareTo(sGameType) > 0 
                  || sTestGameType.equals(sGameType) && (cMapTestInfo.GetLevelName()).compareTo(sLevelName) > 0)
                {
                    break;
                }
            }
        
        ListBox_AvailableMap.InsertItem( sLevelName + " " + 
                            sGameType, (Object)cMapInfo, j );
    }
    
    /**Dodaje do ListBox stringi*/
    /*void AddMapToList(NetMapInfo cMap, ListBox cList)
    {
        Button item = (Button)CreateObject("Button");
        String sLabel = cMap.GetLevelName() + " " + 
                        ENetGameType.GetGameNameShort( cMap.GetGameType() );
        item.Init(new UIElement(ID_MAP_ITEM + nCount ,0,
                                    new Vector(0,0,0),
                                    new Vector(0,0,0),
                                    "",
                                    "",
                                    "",
                                    "",
                                    EButtonFlags.BTN_TYPE_LISTBOX_ITEM,
                                    sLabel
                                    ),GetModule());
        item.SetData((Object)cMap);
        cList.AddItem(item);
        item.SetTextPosFlags(ESpriteText.VERT_MIDDLE);
        item.DisplayText(sLabel);
        nCount++;
    }*/
    
    /**Dodaje wybrana mape do MapList i wywala ja z MapAvailable
     */
    void FromAvailableToMapList()
    {
        int nSelect = ListBox_AvailableMap.GetSelection();
        if (nSelect < 0)
            return;
        FromAvailableToMapList(nSelect);
    }
    
    void FromAvailableToMapList(int nSelect)
    {
        UIButton cItem = ListBox_AvailableMap.GetItem(nSelect);
		if (cItem != null)
        {
            ListBox_Maplist.AddItem(cItem.m_sText, cItem.m_cData);
            cItem.SetCheck(false);
            ListBox_AvailableMap.RemoveItem(nSelect);
        }
    }
    
	void DeselectSelectedFromMapList()
	{
		UIButton cItem = ListBox_Maplist.GetSelected();
		if(cItem != null)
		{
			cItem.SetCheck(false);
		}
	}
	
    /**Usowa mape z listy wybranych leveli i dodaje ja do listy dostepnych
     */
    void FromMapToAvailableList()
    {
        int nSelect = ListBox_Maplist.GetSelection();
        if (nSelect < 0)
            return;
		
		UIButton cItem = ListBox_Maplist.GetItem(nSelect);
        AddMapInfoToAvailableMap((NetMapInfo)cItem.m_cData);
        //ListBox_AvailableMap.AddItem(cItem.m_sText, cItem.m_cData);
        
        ListBox_Maplist.RemoveItem(nSelect);
    }

	void DeselectSelectedFromAvailableMapList()
	{
		UIButton cItem = ListBox_AvailableMap.GetSelected();
		if(cItem != null)
		{
			cItem.SetCheck(false);
		}
	}
    
    void Discard()
    {
		if(!CanDiscard())
			return;
        MenuModule.SetMenu("ChromeNetMainMenu");
    }
    
    void SaveMaps()
    {
		try
        {
            BufferedWriter Buff = new BufferedWriter(new FileWriter( m_sLevelsNetFile ));
            
            //--------Zapisywanie listy map dolozonych do servera
            String sBuffor = "!LevelMapNet(s, i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            Buff.newLine();
            LogLine("ilosc elementow w liscie  = " + ListBox_Maplist.vItems.size());
            for ( int nIndex = 0 ; nIndex < ListBox_Maplist.vItems.size() ; nIndex++ )
            {
                NetMapInfo cMap = ((NetMapInfo)((UIButton)ListBox_Maplist.vItems.elementAt(nIndex)).GetData());
                sBuffor = cMap.GetFileName();
                sBuffor = "LevelMapNet(\"" + sBuffor + "\"" + ", " + cMap.GetGameType() + ")";
                Buff.write(sBuffor, 0, sBuffor.length());
                Buff.newLine();
            }
            Buff.close();
        }
        catch (IOException e)
        { 
            Log("ERROR definig sequences" + e.getMessage()); 
        }
    }
    
    void MoveMapDown()
    {
         ListBox_Maplist.MoveSelectedDown();
    }
    
    void MoveMapUp()
    {
        ListBox_Maplist.MoveSelectedUp();
    }
    
   
    void UpdateButtons()
    {
		boolean bAvailableMapSelected = (ListBox_AvailableMap.GetSelected() != null);
        boolean bMapListSelected      = (ListBox_Maplist.GetSelected() != null);
        
        int iSelection = ListBox_Maplist.GetSelection();
        
		//Button_AddMap.Enable( bAvailableMapSelected );
		UIButton cUIButton = (UIButton)GetElem("ID_153");
		cUIButton.SetDisabled(!bAvailableMapSelected); 
        
		//Button_RemoveMap.Enable( bMapListSelected );
		cUIButton = (UIButton)GetElem("ID_155");
		cUIButton.SetDisabled(!bMapListSelected); 
        
        cUIButton = (UIButton)GetElem("ID_156");
		cUIButton.SetDisabled(!bMapListSelected || iSelection==0); 

        cUIButton = (UIButton)GetElem("ID_157");
		cUIButton.SetDisabled(!bMapListSelected || ListBox_Maplist.vItems.size()-1 == iSelection); 
        
		//Button_MapSettings.Enable( bAvailableMapSelected || bMapListSelected );
		UIMenuButton cButton = (UIMenuButton)GetElem("ID_152");
		cButton.SetDisabled(!bAvailableMapSelected && !bMapListSelected); 
        
        //Button_Start.Enable( ListBox_Maplist.GetItemCount() > 0 );
		cButton = (UIMenuButton)GetElem("ID_154");
		cButton.SetDisabled( !(ListBox_Maplist.GetItemCount() > 0) );
    }
    
    void MapSettings()
    {
        UIButton cSelectedButton = ListBox_Maplist.GetSelected();
        if ( cSelectedButton == null )
             cSelectedButton = ListBox_AvailableMap.GetSelected();
        
        if ( cSelectedButton == null )
            return;
        
        if ( ! (cSelectedButton.GetData() instanceof NetMapInfo) )
            return;
        
        NetMapInfo cMapInfo  = (NetMapInfo)cSelectedButton.GetData();
        int        nGameType = cMapInfo.GetGameType();
            
        String sMenuClassName = ENetGameType.GetMenuGameSettingsClassName( nGameType );

        //tworzymy nowe menu
        MenuNetGameSettings cMenu = (MenuNetGameSettings)CreateObjectNoInit( sMenuClassName );
        cMenu.SetParams( MenuModule, this, cMapInfo );
        LogD(" 1\n");
        cMenu.InitObject();
        LogD(" 2\n");
        cMenu.Show();
    }
    
    static boolean sm_bAutoCreateServer = false;
    static void AutoCreateServer(ChromeMenuModule cMenu)
    {
        sm_bAutoCreateServer = true;
        cMenu.SetMenu("ChromeNetCreatMenu");
    }
}