public class MenuNetGameSettingsSMD extends MenuNetGameSettingsIndividual
{
    NetGameSettingsSMD m_cNetGameSettingsSMD = null;
    void SetGameSettings(NetGameSettings cGameSettings)
    {
        super.SetGameSettings( cGameSettings );
        
        if ( cGameSettings instanceof NetGameSettingsSMD )
            m_cNetGameSettingsSMD = (NetGameSettingsSMD)cGameSettings;
        else
            LogD(" Nieodpowiedni obiekt game settings "+cGameSettings+"\n");
    }
    
    
    public void OnCreate()
    { 
        super.OnCreate();
        
        m_cPoints.InitControl(this);
        NextElement();
        m_cTime.InitControl(this);
        NewSet();
        
        m_cAvailableInventoryRoom.InitControl(this);
        NewSet();
        
        m_cDominationScoreUpdateTime.InitControl(this);
        NextElement();
        m_cAllowDominateByDeadPlayer.InitControl(this);
        NextElement();
                
        NewColumn();
        
        m_cIdentifyEnemies.InitControl(this);        
        NewSet();
        
        m_cEnemiesVisibleOnHudMap.InitControl(this);
        if ( m_cNetGameSettings.GetAvailableVehicles() )
        {
            NextElement();
            m_cVehiclesVisibleOnHudMap.InitControl(this);
        }
        NextElement();        
        m_cBasesVisibleOnHudMap.InitControl(this);
        NewSet();
        
        m_cRespawns.InitControl(this);
        NextElement();
        m_cRespawnTime.InitControl(this);
        
        if ( m_cNetGameSettings.GetAvailableVehicles() )
        {
            NewSet();
        
            m_cVehicleRespawns.InitControl(this);
            NextElement();
            m_cVehicleRespawnTime.InitControl(this);
            NextElement();
            m_cVehicleAutoReturnTime.InitControl(this);
            NextElement();                
        }
    }
    
    void CopyDataFromObjectToMenu()
    {
        super.CopyDataFromObjectToMenu();
        
        if ( m_cDominationScoreUpdateTime.Initialized() )
            m_cDominationScoreUpdateTime.SetValue( (int)m_cNetGameSettingsSMD.GetScoreUpdateTime() );
        if ( m_cAllowDominateByDeadPlayer.Initialized() )
            m_cAllowDominateByDeadPlayer.SetValue( m_cNetGameSettingsSMD.GetAllowDominateByDeadPlayer() );
        if ( m_cBasesVisibleOnHudMap.Initialized() )
            m_cBasesVisibleOnHudMap.SetValue( m_cNetGameSettingsSMD.GetBasesVisibleOnHudMap() );
    }
    
    void CopyDataFromMenuToObject()
    {
        super.CopyDataFromMenuToObject();
        
        if ( m_cDominationScoreUpdateTime.Initialized() )
            m_cNetGameSettingsSMD.SetScoreUpdateTime( (float)m_cDominationScoreUpdateTime.GetInt() );
        if ( m_cAllowDominateByDeadPlayer.Initialized() )
            m_cNetGameSettingsSMD.SetAllowDominateByDeadPlayer( m_cAllowDominateByDeadPlayer.GetBoolean() );
        if ( m_cBasesVisibleOnHudMap.Initialized() )
            m_cNetGameSettingsSMD.SetBasesVisibleOnHudMap( m_cBasesVisibleOnHudMap.GetBoolean() );
    }
}
