public class GameInfoMsgCTF extends GameInfoMsg
{
    final static int _ENEMY_FLAG_OFFSET = 5;
    
    final static int _PRIORITY_YOUR_FLAG  = 20;
    final static int _PRIORITY_ENEMY_FLAG = 10;
    
    final static int _FLAG_INBASE   = 0;
    final static int _FLAG_CAPTURED = 1;
    final static int _FLAG_DROPPED  = 2;
    
    
    GameInfoMsgDataCTFFlag m_cFlagData = null;
        
    TextGameInfoMsgCondition m_cMix1 = null,
                             m_cMix2 = null;
    
    GameInfoMsgCTF(GameInfoMsgDataCTFFlag cFlagData)
    {
        m_cFlagData = cFlagData;
        
        m_bModeId = true;
        
        AddText( m_cMix1 = new TextGameInfoMsgConditionId( 
                     _FLAG_CAPTURED, 
                     "Your flag has been captured by '%s'",
                     _PRIORITY_YOUR_FLAG ) );
        
        AddText( new TextGameInfoMsgConditionId( 
                     _FLAG_DROPPED , 
                     "Your flag has been dropped",
                     _PRIORITY_YOUR_FLAG ) );
        
        AddText( m_cMix2 = new TextGameInfoMsgConditionId( 
                     _FLAG_CAPTURED + _ENEMY_FLAG_OFFSET, 
                     "Enemy flag has been captured by '%s'",
                     _PRIORITY_ENEMY_FLAG ) );
        
        AddText( new TextGameInfoMsgConditionId( 
                     _FLAG_DROPPED + _ENEMY_FLAG_OFFSET, 
                     "Enemy flag has been dropped",
                     _PRIORITY_ENEMY_FLAG ) );
        
        m_cMix1.SetMixMode();
        m_cMix2.SetMixMode();
    }
    
    void Update(int nId,boolean bEnemy)
    {
        if ( bEnemy )
            nId += _ENEMY_FLAG_OFFSET;
        SetMix();
        super.Update( nId );
    }
    
    void Captured(int nOwnerId)
    {
        m_cFlagData.m_nStatus = _FLAG_CAPTURED;
        m_cFlagData.m_nOwner  = nOwnerId;
        SetMix();
    }
    
    void Dropped()
    {
        m_cFlagData.m_nStatus = _FLAG_DROPPED;
    }
    void Returned()
    {
        m_cFlagData.m_nStatus = _FLAG_INBASE;
    }
    void Delivered()
    {
        m_cFlagData.m_nStatus = _FLAG_INBASE;
    }
    
    void SetMix()
    {
        GameObject cObject = m_cManager.GetObjectByNetId( m_cFlagData.m_nOwner );
        if ( cObject instanceof NetPlayerInfo )
        {
            NetPlayerInfo cInfo = (NetPlayerInfo)cObject;
            String sNick = cInfo.GetNick();
            m_cMix1.SetMixText( sNick );
            m_cMix2.SetMixText( sNick );
        }
    }
    
}

