public class NetIncomingMsgBase
{
    /** 
     * Dane wejsciowe
     */
    
    /** NetGameInfo do ktorego odnosci sie ten komunikat */
    NetGameInfoBase m_cGameInfo = null;
    
    /** identyfikator komunikatu */
    int             m_nId       = -1;
    
    /** 
     * parametry komunikatu
     */
    /** identyfikatory sieciowe obiektow NetPlayerInfo */
    int             m_nPlayerInfoId1    = -1;
    int             m_nPlayerInfoId2    = -1;
    int             m_nTeamInfoId       = -1;
    
    /** identyfikator sieciowy dodatkowego obiektu */
    int             m_nAddObjectId      = -1;
    
    /** obiekty NetPlayerInfo */
    NetPlayerInfo   m_cPlayerInfo1      = null;
    NetPlayerInfo   m_cPlayerInfo2      = null;
    NetTeamInfo     m_cTeamInfo         = null;
    
    /** dodatkowy obiekt, wykorzystywany uniwersalnie */
    GameObject      m_cAddObject        = null;
    
    
    /** dodatkowy parametr calkowity, wykorzystywany uniwersalnie */
    int m_nAddInfo = 0;
    
    /** tekst */
    String          m_sText             = null;
    String          m_sText2            = null;
    
    /** kolor jaki zostal narzucony temu komunikatowi */
    Vector          m_vRequestedColor   = null;
    /** kolor dzwiek zostal narzucony temu komunikatowi */
    String          m_sRequestedWave    = null;

    
    
    
    
    /** 
     * Dane wyjsciowe
     */
    
    /** Flaga mowiaca o tym ze komunikat jest gotowy do wyswietlenia*/
    boolean         m_bValid        = false;
    /** Tekst "zlozonego" komunikatu, istotny gdy m_bValid == true */
    String          m_sMessage      = null; 
    /** Dzwiek jaki ma towarzyszyc pojawieniu sie komunikatu */
    String          m_sWave         = null;
    /** Docelowe miejsce gdzie ma sie ten tekst pojawic, 
     * domyslnie na liscie incoming message'y*/
    int             m_nTargetHudId  = NetMsg._TARGETHUD_INCOMING;
    /** kolor jakim bedzie wyswietlany dany tekst */
    Vector          m_vColor        = new Vector( NetMsg._COLOR_DEFAULT );
    
    
    
    /** Pomocnicza flaga informujaca czy gracz na tym kompie jest 
     * glownym podmiotem w komunikacie (ogolnie czy pelni jakas
     * specjalna role w nim)
     * Przydatna w okreslaniu koloru i dzwieku komunikatu.
     * Ustawiana podczas "skladania" komunikatu
     */
    boolean         m_bYouAreMainSubject    = false;
    
    
    /** Sprawdzamy, czy posiadamy juz wszystkie potrzebne dane do zlozenia
     * stringa (wyspawnowane odpowiednie obiekty PlayerInfo z aktualnymi
     * nickami graczy). Jesli tak to wolamy metode skladajaca stringa.
     * @return informacja czy pomyslnie zostal zlozony string (<code>boolean</code>),
     * jesli tak, to mozna go pobrac metoda GetMessage()
     */
    boolean Validate()
    {
        if ( m_bValid )
        {
            // juz jest wszystko przeliczone, mozna spadac
            return true;
        }
        
        // zakladamy ze wszysko bedzie ok :-)
        boolean bOk = true;
        
        // czy potrzebny jest playerinfo?
        if ( m_nPlayerInfoId1 > -1 )
        {
            // tak, spraqwdzmy czy go mamy
            m_cPlayerInfo1 = m_cGameInfo.GetPlayerInfoByNetId( m_nPlayerInfoId1 );
            
            if ( m_cPlayerInfo1 == null || m_cPlayerInfo1.IsNickValid() == false )
            {
                // niestety, nie mamy tego jeszcze gotowego
                bOk = false;
            }
        }
    
        // a potrzebne playerinfo2
        if ( m_nPlayerInfoId2 > -1 )
        {
            // tak, odszukajmy...
            m_cPlayerInfo2 = m_cGameInfo.GetPlayerInfoByNetId( m_nPlayerInfoId2 );
            
            if ( m_cPlayerInfo2 == null || m_cPlayerInfo2.IsNickValid() == false )
            {
                // niestety, nie mamy tego jeszcze gotowego
                bOk = false;
            }
        }
        
        if ( m_nTeamInfoId > -1 )
        {
            // tak, odszukajmy...
            m_cTeamInfo   = m_cGameInfo.GetTeamInfoByNetId( m_nTeamInfoId );
            
            if ( m_cTeamInfo == null || m_cTeamInfo.IsNameValid() == false )
            {
                // niestety, nie mamy tego jeszcze gotowego
                bOk = false;
            }
        }
        
        if ( m_nAddObjectId > -1 )
        {
            // tak, odszukajmy...
            m_cAddObject   = m_cGameInfo.GetObjectByNetId( m_nAddObjectId );
            
            if ( m_cAddObject == null /*|| m_cTeamInfo.IsNameValid() == false*/ )
            {
                // niestety, nie mamy tego jeszcze gotowego
                bOk = false;
            }
        }
        
        
            
        // to co, mamy juz wszystkie dane?
        if ( bOk )
        {
            // mamy, wiec poskladajmy stringa    
            SetMessage();
            // zdecydujmy gdzie ma ten komunikat trafic
            SetTargetHud();
            // i pobiezmy dzwiek do odegrania
            SetSound();
            // ustalmy kolor
            SetColor();
        }

        // zwrocmy informacje, czy string juz jest poprawnie zlozony
        return m_bValid;
    }
    
    void SetRequestedColor(Vector vColor)
    {
        m_vRequestedColor = vColor;
    }
    void SetRequestedSound(String sWave)
    {
        m_sRequestedWave = sWave;
    }
    
   
    String GetMessage()
    {
        if ( Validate() )
            return m_sMessage;
        return null;
    }

    String GetSound()
    {
        return m_sWave;
    }
    
    int GetTargetHudId()
    {
        return m_nTargetHudId;
    }
    
    Vector GetColor()
    {
        return m_vColor;
    }
    
    //do nadpisania w klasie potomnej    
    void SetMessage()
    {
    }
    void SetTargetHud()
    {
    }
    void SetSound()
    {
    }
    void SetColor()
    {
    }
}
