public class DominationBaseFlag extends DominationBase
{
    static String   sm_sOriginalMaterialName = "FlagN.mat";
    
    static String[] sm_aUsingMaterials = {  "FlagN.mat",
                                            "FlagR.mat", 
                                            "FlagB.mat",
                                            "FlagG.mat",
                                            "FlagR2.mat" };
    
    public DominationBaseFlagStand m_cFlagStand = null;//#Net
    
    NetObjectPositionController m_cPositionController = null;
    
    DominationBaseFlag()
    {
        super();
                
        MeshName = "Data/Meshes/Equipment/flag.3da";
        
        m_sOriginalMaterialName = sm_sOriginalMaterialName;
        m_aUsingMaterials       = sm_aUsingMaterials;
    }

    public void OnCreate()
    {
        super.OnCreate();
        
        //Uwaga, flagi EFlags._BLOCK_TRACE i EFlags._COLLISION sa z jednej
        //strony potrzebne (zeby mozna bylo ustawiac ja jako activetrigger
        //z drugiej strony nie chcemy zeby odkladaly sie na niej trace'y
        //oraz zeby gracz z nia kolidowal
        //Z tego powodu flagi ta bedza domyslnie wylaczone, natomiast
        //beda wlaczane przez NetGameInfo tylko na sama chwile 
        //trace'owania otoczenia przez gracza w poszukiwaniu triggera
        ClearFlag( EFlags._BLOCK_TRACE );
        ClearFlag( EFlags._COLLISION );
        
        m_cPositionController = (NetObjectPositionController)CreateObject("NetObjectPositionController");
        m_cPositionController.SetControlledObject( this );
        m_cPositionController.StartRotateAndSwingSlow();
    }
    
    public void OnDestroy()
    {
        if ( m_cPositionController != null )
        {
            m_cPositionController.delete();
            m_cPositionController = null;
        }
        
        if ( m_cFlagStand != null && (!m_cFlagStand.bDeletedInEngine) )
        {
            m_cFlagStand.DeactivateOnModuleAlways();
            m_cFlagStand.delete();
            m_cFlagStand = null;
        }
        
        super.OnDestroy();
    }
    
    boolean CheckActive()
    {
        boolean bActive = super.CheckActive();
        if ( m_cFlagStand != null )
        {
            if ( bActive )
                m_cFlagStand.ActivateOnModule();
            else
                m_cFlagStand.DeactivateOnModuleAlways();
            SetPosition( m_cFlagStand.GetFlagPos() );
        }
        return bActive;
    }
    
    void SetLocalState(int nState)   
    {   
        super.SetLocalState( nState );

        if ( m_cFlagStand != null )
            m_cFlagStand.SetLocalState( nState );
    }
}
