public class DeadBody extends PawnAnimated
{
    static boolean sm_bUsePhysics             = false;
    static boolean sm_bReplicateParticleState = false;
    
    //czas przez jaki trupek bedzie aktywny
    //TODO, ustalic ten czas, 
    static float sm_fTimeToDeactivate = 5.0f;
    //TODO, zrobic jakies ladne znikanie trupka
    
    DeadBody()
    {
        super();
        
        //MeshName     = NetPlayerProfile.sm_sModelDir+"HSoldier.3DA";
        MeshName     = NetPlayerProfile.sm_sModelDir+"HSoldierNetDead.3DA";
        //if ( !sm_bUsePhysics )
        //    sAnimIniFile = "Data/Meshes/AI/HSoldier.scr";
    }

    PlayerNetBaseMortal m_cOwner     = null;
    int                 m_nOwnerId   = -1;
    String              m_sOwnerName = null;//TODO: wywalic, bo chyba sie nie przyda.
    int[]               m_aSkins     = new int [ NetPlayerModelInfo.GetSkinsPartialCnt() ]; 
    
    int             m_nOwnerRespawnCnt = 0;
    
    boolean         m_bActivated = false;
    int             m_nDieMode   = EPlayerAction.DIE_MODE_NORMAL;
    int             m_nAnim      = BaseAnimations.A_DEATH_BACK;
    boolean         m_bLoopAnim  = false;
    
    final public static int _ACTIVATE_MODE_NONE  = 0;        
    final public static int _ACTIVATE_MODE_INIT  = 1;
    final public static int _ACTIVATE_MODE_DIE   = 2;
    final public static int _ACTIVATE_MODE_STILL = 3;
    int             m_nActivateMode = _ACTIVATE_MODE_NONE;

    DamageInfo      m_cDamageInfo = new DamageInfo();
    
    Vector          m_vPos        = null;
    Vector          m_vDir        = null;
    ControlObject   m_cParent     = null;       
    int             m_nParentId   = -1;
    int             m_nTeamSkins  = NetTeamInfo.NONE;

    
    
    int METHOD_TryToFindOwner               = 0;
    int METHOD_TryToClientActivate          = 0;
    int METHOD_StartReplicateParticleState  = 0;
    int METHOD_StopReplicateParticleState   = 0;
    int METHOD_ReplicateParticleState       = 0;
    int METHOD_ServerDeactivate             = 0;
    int METHOD_PlayDropSound                = 0;
    int METHOD_TryToSetYourName             = 0;
    
    /**
     * Flaga blokujaca wolanie OnCreate, wykorzystywana na kliencie
     * po odebraniu replikacji tworzenia obiektu, w tym przypadku 
     * OnCreate ma sie zawolac dopiero po InitObject(), ktore jest
     * wolane "recznie" po odebraniu danych inicjujacych z serwera.
     */
    boolean m_bOnCreateAllowed = false;
    
    
    public void OnCreate()
    {
        if ( ! m_bOnCreateAllowed )
            return;
            
        METHOD_TryToFindOwner               = RegisterCallMethod( "TryToFindOwner" );
        METHOD_TryToClientActivate          = RegisterCallMethod( "TryToClientActivate" );
        METHOD_StartReplicateParticleState  = RegisterCallMethod( "StartReplicateParticleState" );
        METHOD_StopReplicateParticleState   = RegisterCallMethod( "StopReplicateParticleState" );
        METHOD_ReplicateParticleState       = RegisterCallMethod( "ReplicateParticleState" );
        METHOD_ServerDeactivate             = RegisterCallMethod( "ServerDeactivate");
        METHOD_PlayDropSound                = RegisterCallMethod( "PlayDropSound" );
        METHOD_TryToSetYourName             = RegisterCallMethod( "TryToSetYourName" );
        
        //TODO: dlaczego to jest przed super'em?
        SetFlag( EFlags._PHYSICS_COL_CORRECTION );
        
        // dla trupow noszonych przez graczy w kieszeni fizyka jest wylaczana i ew. wlaczana podczas smierci
        nGravityPhysics = EPhysics._NONE;
        
        
        //ProfileIntervalStart();
        
        super.OnCreate();
        
        //float fFppTime = ProfileIntervalEnd();
        //LogR("super.OnCreate="+fFppTime+"\n");
        
        //ProfileIntervalStart();
        
        ReloadPartialSkins();
        
        //fFppTime = ProfileIntervalEnd();
        //LogR("ReloadPartialSkins="+fFppTime+"\n");
        
        SetPhysicsActive( false );
        fHealth   = 0.0f;
        bDead     = true;
                
        SetFlag( EFlags._PORTAL_INDEPENDENT );
        SetFlag(EFlags._COLLISION);
        SetCollAction(ECollFlags.OBJCOL_ACTION_STOP);
        SetCollHandler(ECollFlags.OBJCOL_HANDLER_FULLINFOMOVE);
        SetPhysicsType(EPhysics._FALL);
        ClearFlag( EFlags._BLOCK_MOVE);//EFlags._COLLISION );
        SetAnimMorphTime( 0.0f );
        
        if ( ! sm_bUsePhysics )
        {
            ClearFlag( EFlags._NO_ANIMATION );
            ClearFlag( EFlags._NO_ANIMATION_REFRESH );
        }
        
        //ProfileIntervalStart();
        
        //TODO: ro stworzyc tylko dla wlasciciela
        if(bNetIsOwner)
            InitDeathCameraEyeDummy();
        
        //fFppTime = ProfileIntervalEnd();
        //LogR("bNetIsOwner="+bNetIsOwner+" InitDeathCameraEyeDummy="+fFppTime+"\n");
        
        
        float fHeigth = 20.0f;
        SetMass(100);
        SetEllipsoid( 180, 180, 180f*0.5f );
        SetEllipsoidNoExtents( fHeigth, fHeigth, fHeigth*0.5f );
    }

    public void OnCollisionFullInfoMove(ControlObject obj, Vector vPoint, Vector vNormal, Vector vMove)
    {
        if (vMove.Len() < 1)
            SetPhysicsActive(false);
        //LogR("Collision with " + obj + " vNormal " + vNormal + " vMove " +  vMove);
    }
    
    public void SetEllipsoid(float fHeight)
    {
        SetEllipsoid( fHeight, fHeight, fHeight*0.5f );
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        if (m_cDummyMesh != null)
        {   
            m_cDummyMesh.delete();
            m_cDummyMesh = null;
        }
        DeleteAttachedFXes();
        ImplantTermovision.RemoveFromSystem(this);
        
        m_cOwner      = null;
        m_sOwnerName  = null;
        m_aSkins      = null;
        m_cDamageInfo = null;
        m_vPos        = null;
        m_vDir        = null;
        m_cParent     = null;       
    }
    
    void ServerInit( PlayerNetBaseMortal cOwner )
    {
        m_cOwner            = cOwner;
        m_nOwnerId          = m_cOwner.GetNetId();
        m_sOwnerName        = m_cOwner.GetName();
        MeshName            = m_cOwner.MeshName;
        m_nOwnerRespawnCnt  = m_cOwner.GetRespawnCnt();
        //if ( !sm_bUsePhysics )
        //    sAnimIniFile    = m_cOwner.sAnimIniFile;
        m_aSkins            = m_cOwner.GetModelInfo().GetCurrentPartialSkins();
        m_cModelInfo        = new NetPlayerModelInfo( MeshName, m_aSkins );
        
        m_bOnCreateAllowed  = true;
        InitObject();
        TryToSetYourName();
        
        DeactivateOnModuleAlways();
    }
    
    // procka przepisujaca zawartosc inventory do trupka i aktywujaca go
    void ServerActivate(int nMode, int nAnim, boolean bLoopAnim)
    {
        if ( ! ModuleNet.IsGameGoing() )
            return;
        LogD(" "+nMode+"\n");
        
        m_nActivateMode    = _ACTIVATE_MODE_DIE;
        m_nDieMode         = nMode;
        m_nAnim            = nAnim;
        m_bLoopAnim        = bLoopAnim;
        
        // pobieramy z playera pozycje i ustawienia kosci
        GetPosAndDir( m_cOwner );
        // aktualnny mesh i skiny
        GetMeshAndSkins( m_cOwner );
        // oraz informacje o postrzale
        GetDamageInfo( m_cOwner );
        // pobieramy tez ustawienia kosci, od razu zastosowujac w trupku
        CopyElementsPosition( m_cOwner );
        // zapamietajmy tez ile razy gostek sie respawnowal do tego czasu
        m_nOwnerRespawnCnt = m_cOwner.GetRespawnCnt();
            
        // aktywujemy trupka 
        ServerActivate();
    }
    
        
    void ServerActivate()
    {
        DisableCallMethod( METHOD_ServerDeactivate );
        Activate();
        
        if ( sm_bUsePhysics )
        {
            // TODO: gdy bedzie wykorzystywana fizyka to trzeba bedzie zrobic tworzenie fizyki ODE_GRAVITYWALK w tym miejscu
            PhysicsOn();
            ForceParticleSimulate();
        }
        else
            PhysicsOff();
                
        MsgSendClientActivate();
        
        //TODO: dlaczego nie ma rozrozniania DieMode...???
        if ( sm_bUsePhysics )
        {
            ApplyDamage();
            ScheduleReplicateParticleState();
        }
        else
            PlayAnim();
        CallMethodIn( METHOD_ServerDeactivate, sm_fTimeToDeactivate );
    }
    
    void ClientActivate()
    {
        DisableCallMethod( METHOD_TryToClientActivate );
        
        Activate();
     
        if ( sm_bUsePhysics )
        {
            // TODO: gdy bedzie wykorzystywana fizyka to trzeba bedzie zrobic tworzenie fizyki ODE_GRAVITYWALK w tym miejscu
            ApplyReceivedParticleState();
        }
        else
            PhysicsOff();
        
        switch ( m_nActivateMode )
        {
        case _ACTIVATE_MODE_INIT:
            if ( sm_bUsePhysics )
                ApplyDamage();
            else
                PlayAnimLastFrame();
            break;
        case _ACTIVATE_MODE_DIE:
            if ( sm_bUsePhysics )
                ApplyDamage();
            else
                PlayAnim();
            break;
        case _ACTIVATE_MODE_STILL:
        default:
            PhysicsOff();
        }
    }
    
    // aktywacja trupka (ustalenie pozycji, mesha i aktywacja na module)
    void Activate()
    {
        PhysicsOff();
        
        SetPhysicsActive(true);
        
        ApplyPosAndDir();
        ApplyMeshAndSkins();
                
        DeleteAttachedFXes();
        ActivateOnModule();
        
        //zwracam uwage, zeby nie bylo sytuacji
        //ze gracz sie w miedzy czasie wyspawnuje a my
        //go ukryjemy...
        if ( m_cOwner                 != null  &&
             m_cOwner.GetRespawnCnt() == m_nOwnerRespawnCnt ) 
        {
            /*
            m_cOwner.TakeDamageSpecialEffects( 300.0f,
                                               m_cOwner.GetPosition(), 
                                               Vector.Zero, Vector.Up, 
                                               EBones._NON_BONE, 0 );*/
            m_cOwner.DeactivateOnActivateDeadBody();
        }
        else if ( m_cOwner == null )
        {
            NetLog.DeadBody("ERROR "+GetNetInfo()+" Nie znam jeszcze ownera wiec go nie deaktywuje\n");
        } 
        else if ( m_cOwner.GetRespawnCnt() > m_nOwnerRespawnCnt )
        {
            if ( m_nActivateMode != _ACTIVATE_MODE_INIT )
                NetLog.DeadBody("Gracz "+m_cOwner.GetNetInfo()+
                                " jest wyspawnowany, nie ukrywam go z trupka");
            else
                NetLog.DeadBody("WARNING: Gracz "+m_cOwner.GetNetInfo()+
                                " juz sie zdazyl wyspawnowac, nie ukrywam go z trupka "+
                                m_cOwner.GetRespawnCnt()+">"+m_nOwnerRespawnCnt+
                                "\n");
        }
        else if ( m_cOwner.GetRespawnCnt() < m_nOwnerRespawnCnt )
        {
            NetLog.Error("Gracz "+m_cOwner.GetNetInfo()+
                         " sie mniej spawnowal niz trup "+GetNetInfo()+
                         " "+m_cOwner.GetRespawnCnt()+"<"+m_nOwnerRespawnCnt+
                         " _ACTIVATE_MODE_INIT "+(m_nActivateMode != _ACTIVATE_MODE_INIT)+
                         "\n");
        }
        
            
        if ( m_nActivateMode != _ACTIVATE_MODE_INIT &&
             m_nDieMode      == EPlayerAction.DIE_MODE_NORMAL )
        {
            PlayDieSound();
            CallMethodIn( METHOD_PlayDropSound, 0.6f );
        }
        
        //DeleteAttachedFXes();
        //ActivateOnModule();
        ImplantTermovision.AddToSystem( this );
        m_bActivated = true;
        
        if (m_cOwner.bNetIsOwner)
        {
            //TODO: zastanowic sie, _jak_ pokazac "cieszacych" sie graczy
            /*if ( (m_nDieMode != EPlayerAction.DIE_MODE_GAMEOVER)&&
                 (m_nDieMode != EPlayerAction.DIE_MODE_GAMERESTART) )*/
            {
                EnableRendering(false);
            }
            
            if (nEyeId == -1)
            {
                for (int i=0; i<sm_aEyeElements.length; i++ )
                {
                    nEyeId = GetElementID( sm_aEyeElements[i] );
                    if (nEyeId != -1)
                        break;
                }
            }
            if (nEyeId > -1)
            {
                NetLog.DeadBody("PlayerPos " + m_cOwner.GetPosition() + " eye Pos " + m_cOwner.GetElementPos(nEyeId));
                NetLog.DeadBody("Terrain " + TerrainHeight(m_cOwner.GetPosition().fX, m_cOwner.GetPosition().fZ));
                m_cDeathCameraEyeDummy.SetPosition(m_cOwner.GetElementPos(nEyeId));
                m_cDeathCameraEyeDummy.ActivateOnModule();
                //Tools.ShowMeshelemOrientation(this, nEyeId);
                //Tools.ShowMeshOrientation(this);
            }
            
            if ( ! sm_bUsePhysics )
            {
                ClearFlag( EFlags._NO_ANIMATION );
                ClearFlag( EFlags._NO_ANIMATION_REFRESH );
            }
        }
    }

    void ServerDeactivate()
    {
        DisableCallMethod( METHOD_ServerDeactivate );
        Deactivate();
        MsgSendClientDeactivate();
    }

    void Deactivate()
    {
        CharacterAnims.StopAll();
        DeactivateOnModuleAlways();
        m_bActivated = false;
        ImplantTermovision.RemoveFromSystem(this);
    }
    
    boolean IsActivated(){ return m_bActivated; }
    
    void ApplyDamage()
    {
        if ( sm_bUsePhysics )
        {
            //TODO: uwaga: chwilowo vHitLocation nie jest przesylane w komunikacie!
            Vector vHitLocation = m_cDamageInfo.vHitLocation; 
            Vector vSpeed       = new Vector( m_cDamageInfo.vSpeed );
            float  fDamage      = m_cDamageInfo.fPhysicsSimDamage;
            int    nBoneId      = m_cDamageInfo.nBoneId;
        
            //taki hack, ze zawsze trafiamy w to samo miejsce...
            vHitLocation = GetBoneJointPos( EBones._NECK );
            // no i przeskalowanie do stlumienia fizyki bo wszystko lata 
            vSpeed.Mul( _PHYSICS_SPEED_MUL );
            fDamage *= _PHYSICS_DAMAGE_MUL;
            //TODO: jak te powyzsze hacki wyleca, to mozna bedzie
            //zawolac Simulate bezposrednio
            Physics.Simulate( this, vHitLocation, vSpeed, fDamage, nBoneId );
        }
        else
            PhysicsOff();
    }
    
    
    float  _PHYSICS_SPEED_MUL  = 0.1f;
    float  _PHYSICS_DAMAGE_MUL = 0.1f;
        
    static float _REPLICATE_PARTICLE_STATE_TIME_DELAY  =  3.0f;
    static float _REPLICATE_PARTICLE_STATE_TIME_UPDATE =  2.0f;
    static float _REPLICATE_PARTICLE_STATE_TIME_LIMIT  = 10.0f;
   

    void ScheduleReplicateParticleState()
    {
        if ( sm_bReplicateParticleState && sm_bUsePhysics )
        {
            CallMethodIn( METHOD_StartReplicateParticleState, 
                          _REPLICATE_PARTICLE_STATE_TIME_DELAY );    
        }
    }
        
    void StartParticleReplication()
    {
        CallMethodEvery( METHOD_ReplicateParticleState,
                         _REPLICATE_PARTICLE_STATE_TIME_UPDATE );
        CallMethodIn( METHOD_StopReplicateParticleState,
                      _REPLICATE_PARTICLE_STATE_TIME_LIMIT );
    }
   
    void StopReplicateParticleState()
    {
        DisableCallMethod( METHOD_ReplicateParticleState );
    }
        
   
    public void ReplicationInit()
    {
        SetNetPriority( 1.0f );
        SetMinRelevantLevel( 0.01f );
    }
 
    public boolean IsRelevantConstans(){ return false; }
    
    public float GetRelevantLevel()
    {
        float fRel = (GetCurrentClientDistance() - GetModule().fMinDistToCalculateRelevant)/
                     (GetModule().fMaxDistToCalculateRelevant-GetModule().fMinDistToCalculateRelevant);
        if ( fRel > 1.0f )
             fRel = 1.0f;
        return fRel;
    }    
   
    public void OnReplicateServer()
    {
        if ( bNetInit )
        {
            MsgSendClientInit();
        }
    }

    static final int MSG_CLIENT_INIT         =0; // serwer wysyla inicjalizacje obiektu
    static final int MSG_CLIENT_ACTIVATE     =1; // serwer wysyla info o aktywacji trupka
    static final int MSG_CLIENT_DEACTIVATE   =2; // serwer wysyla info o deaktywacji trupka
    
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case MSG_CLIENT_INIT:
            NetLog.MsgIn( "MSG_CLIENT_INIT", this );
            MsgRecvClientInit();
            break;
                
        case MSG_CLIENT_ACTIVATE:
            NetLog.MsgIn( "MSG_CLIENT_ACTIVATE", this );
            MsgRecvClientActivate();
            break;
            
        case MSG_CLIENT_DEACTIVATE:
            NetLog.MsgIn( "MSG_CLIENT_DEACTIVATE", this );
            MsgRecvClientDeactivate();
            break;
        
        default:
            NetLog.MsgIn( "CANCEL "+MessageGetId(), this );
            MessageCancel();
        }
    }
        
    // wysylamy klientow stan na "dzien dobry"
    void MsgSendClientInit()
    {
        NetLog.MsgOut( "MSG_CLIENT_INIT", this );
        MessageNew( MSG_CLIENT_INIT );
        MessagePackInt( GetNextGlobalDeadBodyCounter() );
        MessagePackString( MeshName );
        for ( int i=0; i<m_aSkins.length; i++ )
            MessagePackInt( m_aSkins[ i ] );
        //MessagePackString( sAnimIniFile );
        MessagePackInt( m_nOwnerId );
        MessagePackString( m_sOwnerName );
        MessagePackInt( m_nOwnerRespawnCnt );
        MessagePackBoolean( m_bActivated ); 
        if ( m_bActivated ) 
        {
            MessagePackInt( m_nDieMode ); 
            MessagePackInt( m_nAnim );
            MessagePackBoolean( m_bLoopAnim );
            GetPosAndDir();
            PackPosAndDir();
            //MessagePackParticleState();
        }
        MessageSend();
    }
    
    // odebranie na kliencie stanu poczatkowego
    void MsgRecvClientInit()
    {
        int nStateCounter    = MessageUnPackInt();
        MeshName             = MessageUnPackString();
        for ( int i=0; i<m_aSkins.length; i++ )
            m_aSkins[ i ]    = MessageUnPackInt();
        //sAnimIniFile       = MessageUnPackString();
        m_nOwnerId           = MessageUnPackInt();
        m_sOwnerName         = MessageUnPackString();
        int nOwnerRespawnCnt = MessageUnPackInt();
        if ( MessageUnPackBoolean() )
        {
            m_nActivateMode = _ACTIVATE_MODE_INIT;
            m_nDieMode      = MessageUnPackInt(); 
            m_nAnim         = MessageUnPackInt();
            m_bLoopAnim     = MessageUnPackBoolean();
            UnPackPosAndDir();
            //MessageUnPackParticleState();
        }
        else
            m_nActivateMode = _ACTIVATE_MODE_NONE;
        MessageEnd();
        
        m_cModelInfo        = new NetPlayerModelInfo( MeshName, m_aSkins );
        m_bOnCreateAllowed  = true;
        InitObject();
        DeactivateOnModuleAlways();
        TryToFindOwner();
        
        if ( ! VerifyDeadBodyCounter( nStateCounter ) )
            return;
               
        m_nOwnerRespawnCnt  = nOwnerRespawnCnt;
        
        /** Jesli podczas przesylania nam inicjalizacji trupek byl aktywny, 
         * to go teraz bedziemy chcieli pokazac. Z tym ze do tego miejsca
         * mozemy nie dojsc, bo licznik stanow nam zasugeruje ze inicjalizacja
         * przyszla w zlej kolejnosci, aktywacja nie ma szans sie odbyc. 
         * To rozwiazania ma jedna wade i jadna zalete:
         * Wada: Istnieje tu ryzyko, ze u nas nie bedzie widac trupka 
         * a faktycznie byc on powinien. Wada malo istotna bo trupek pojawia
         * sie tylko na chwilke i nie wnosi nic do gry...
         * Zaleta: Unikamy sytuacji ze trupka wyswietlimy, a tak naprawde 
         * byc go tam nie powinno. To jest bardzo istotne bo ten ghost moglby
         * tkwic aktywny az do czasu nastepnej smierci jego zywego odpowiednika
         */
        if ( m_nActivateMode == _ACTIVATE_MODE_INIT )
            TryToClientActivate();
    }
    
    void MsgSendClientActivate()
    {
        NetLog.MsgOut( "MSG_CLIENT_ACTIVATE", this );
        MessageNew( MSG_CLIENT_ACTIVATE );
        MessagePackInt( GetNextGlobalDeadBodyCounter() );
        MessagePackInt( m_nOwnerRespawnCnt );
        MessagePackInt( m_nDieMode ); 
        MessagePackInt( m_nAnim );
        MessagePackBoolean( m_bLoopAnim );
        PackPosAndDir();
        //MessagePackParticleState();
        PackMeshAndSkins();
        PackDamageInfo();
        MessageSend();
    }
    
       
    void MsgRecvClientActivate()
    {
        int nStateCounter    = MessageUnPackInt();
        int nOwnerRespawnCnt = MessageUnPackInt();
        m_nDieMode           = MessageUnPackInt(); 
        m_nAnim              = MessageUnPackInt();
        m_bLoopAnim          = MessageUnPackBoolean();
        UnPackPosAndDir();
        //MessageUnPackParticleState();
        UnPackMeshAndSkins();
        UnPackDamageInfo();
        MessageEnd();
        
        if ( ! VerifyDeadBodyCounter( nStateCounter ) )
            return;

        m_nOwnerRespawnCnt = nOwnerRespawnCnt;
        
        //jesli jeszcze nie zostal zainicjowany to wychodzimy
        if ( !m_bOnCreateAllowed )
            return;
        
        m_nActivateMode = _ACTIVATE_MODE_DIE;
            
        if ( PlayerNet.sm_bIgnoreDie )
            return;
        
        if ( Role < ERole._AUTHORITY )
            TryToClientActivate();
    }
    
    void MsgSendClientDeactivate()
    {
        NetLog.MsgOut( "MSG_CLIENT_DEACTIVATE", this );
        MessageNew( MSG_CLIENT_DEACTIVATE );
        MessagePackInt( GetNextGlobalDeadBodyCounter() );
        MessageSend();
    }
    
    void MsgRecvClientDeactivate()
    {
        int nStateCounter = MessageUnPackInt();
        MessageEnd();
        
        if ( ! VerifyDeadBodyCounter( nStateCounter ) )
            return;
        
        //jesli jeszcze nie zostal zainicjowany to wychodzimy
        if ( !m_bOnCreateAllowed )
            return;
        
        if ( Role < ERole._AUTHORITY )
            ClientDeactivate();
    }
    
    // odnajduje (do skutku) obiekt playera ownera
    void TryToFindOwner()
    {
        m_cOwner = GetPlayerNetByNetId( m_nOwnerId );
        
        if ( m_cOwner == null )
            CallMethodIn( METHOD_TryToFindOwner, 0.1f );
        else
        {
            m_cOwner.SetDeadBody( this );    
            DisableCallMethod( METHOD_TryToFindOwner );
            
            TryToSetYourName();
        }
    }
    
    void TryToSetYourName()
    {
        if ( m_cOwner                 != null &&
             m_cOwner.GetPlayerInfo() != null && 
             m_cOwner.GetPlayerInfo().IsNickValid() )
            SetName( "Dead"+m_cOwner.GetPlayerInfo().GetNick() );
        else
            CallMethodIn( METHOD_TryToSetYourName, 0.2f );
    }    
    
    void TryToClientActivate()
    {
        if ( m_cOwner == null )
        {
            CallMethodIn( METHOD_TryToClientActivate, 0.1f );
            return;
        }
        
        if ( m_nParentId != -1 )
        {
            GameObject cObj = GetObjectByNetId( m_nParentId );
            
            if ( cObj instanceof ControlObject )
                m_cParent = (ControlObject) cObj;
            else
            {
                CallMethodIn( METHOD_TryToClientActivate, 0.1f );
                return;
            }
        }
        else
            m_cParent = null;
        
        DisableCallMethod( METHOD_TryToClientActivate );
        
        ClientActivate();
    }
      
        
    void ClientDeactivate()
    {
        DisableCallMethod( METHOD_TryToClientActivate );
        Deactivate();
    }
    
    //pobranie z playera jego pozycji, ustawien kosci
    void GetPosAndDir(PlayerNetBaseMortal cOwner)
    {
        if ( cOwner == null )
            return;
        m_cParent     = cOwner.GetParent();
        m_nParentId   = (m_cParent != null)? m_cParent.GetNetId() : -1;
        m_vPos        = cOwner.GetLocalPosition();
        m_vDir        = cOwner.GetForwardVector();
        
        //TMP
        //m_vPos.fX += 150.0f;
    }
    
    //pobranie z trupka pozycji kosci i zapamietanie na liscie
    void GetPosAndDir()
    {
        m_vPos        = GetLocalPosition();
        m_vDir        = GetForwardVector();
    }

    //pobranie z gracza nazwy mesha i aktualnego skina
    void GetMeshAndSkins(PlayerNetBaseMortal cOwner)
    {
        if ( cOwner == null )
            return;
        m_nTeamSkins        = m_cOwner.GetTeamSkinSet();
        //TODO: "obrobic" (skrocic) nazwe mesha
    }
    
    //pobranie z gracza informacji o postrzale
    void GetDamageInfo(PlayerNetBaseMortal cOwner)
    {
        if ( cOwner == null )
            return;
        m_cDamageInfo   = new DamageInfo( cOwner.GetDamageInfo() );
    }
            
        
    void PackPosAndDir()
    {
        MessagePackInt( m_nParentId );
        MessagePackVector( m_vPos );
        MessagePackVector( m_vDir );
    }
    
    void PackMeshAndSkins()
    {
        //TODO: dorzucic mesha, jak bedzie zmiana w grze        
        MessagePackInt( m_nTeamSkins );
    }
    
    void PackDamageInfo()
    {
        MessagePackFloat( m_cDamageInfo.fPhysicsSimDamage );
        MessagePackVector( m_cDamageInfo.vSpeed );
        MessagePackInt( m_cDamageInfo.nBoneId );
        MessagePackInt( m_cDamageInfo.nDamageType );
    }
        
    void UnPackPosAndDir()
    {
        m_nParentId                 = MessageUnPackInt();
        m_vPos                      = MessageUnPackVector();
        m_vDir                      = MessageUnPackVector();
    }
    
    void UnPackMeshAndSkins()
    {
        //TODO: odczytac z komunikatu mesha
        m_nTeamSkins                = MessageUnPackInt();
    }
    
    void UnPackDamageInfo()
    {
        m_cDamageInfo.fPhysicsSimDamage = MessageUnPackFloat();
        m_cDamageInfo.vSpeed            = MessageUnPackVector();
        m_cDamageInfo.nBoneId           = MessageUnPackInt();
        m_cDamageInfo.nDamageType       = MessageUnPackInt();
    }
    
    // zastosowanie pozycji kosci na liscie
    void ApplyPosAndDir()
    {
        //odlaczamy od "starego" parenta
        DetachFromParent();
        if ( m_cParent != null )
            AttachAsChildTo( m_cParent );
        SetPosition( m_vPos );
        SetDir( m_vDir );
        //TODO: na pale odlaczam goscia zeby sie nie "wloczyl" za pojazdem
        DetachFromParentAndKeepWorldPos();
        m_vWorldPos = GetPosition();
    }
    
    void ApplyMeshAndSkins()
    {
        //TODO: przeladowac mesha jesli trzeba
        if ( m_nTeamSkins != GetTeamSkinSet() )
            ReloadTeamSkins( m_nTeamSkins );
    }
    
        
    public boolean IsActive(ControlObject Activator)
    {
        return false;
    }
    
    void Execute( Actor executor )
    {
    }

    String GetTip()
    {
        if ( m_sOwnerName != null )
            return "Killed " + m_sOwnerName;
        else
            return "Killed player";
    }
    
    
    // tmp
    Pawn GetPawnByNetId(int nNetId)
    {
        GameObject object = GetObjectByNetId( nNetId );
        try 
        {
            Pawn pawn = (Pawn) object;
            return pawn;    
        } 
        catch( ClassCastException e) 
        {
            LogD(": Object "+object+" (id "+String.valueOf(nNetId)+") should have been inherited from Pawn\n");
        }
        
        return null;
    }
    
    
    static String[] sm_aDieSounds = {   "Data/Sounds/Player/die1",
                                        "Data/Sounds/Player/die2", 
                                        "Data/Sounds/Player/die3", 
                                        "Data/Sounds/Player/death6" };

    float fMinDieSound = 1000f;
    float fMaxDieSound = 2500f;
    
    void PlayDieSound()
    {
        PlaySound( sm_aDieSounds[ RandomInt( sm_aDieSounds.length ) ], fMinDieSound, fMaxDieSound);
    }
    
    static String[] sm_aDropSounds = {  "Data/Sounds/Player/bodydrop1",
                                        "Data/Sounds/Player/bodydrop2", 
                                        "Data/Sounds/Player/bodydrop3",
                                        "Data/Sounds/Player/bodydrop4" };
    
    float fMinDropSound = 500f;
    float fMaxDropSound = 1500f;
    
    void PlayDropSound()
    {
        PlaySound( sm_aDropSounds[ RandomInt( sm_aDropSounds.length ) ], fMinDropSound, fMaxDropSound);
    }
    
    public void OnTakeDamage(float fDamage, float fPhSimDamage,  GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
    }
    
    void PlayAnim()
    {
        if ( m_bLoopAnim )
            CharacterAnims.PlayLoop( m_nAnim );
        else
            CharacterAnims.Play( m_nAnim );
    }

    void PlayAnimLastFrame()
    {
        if ( m_bLoopAnim )
            CharacterAnims.PlayLoop( m_nAnim );
        else
        {
            SetFrame( CharacterAnims.Anims[ m_nAnim ], GetLastFrame( CharacterAnims.Anims[ m_nAnim ]), -1);
            //CharacterAnims.Play( m_nAnim );
        }
    }
    
        
    /*boolean InitDeathCameraEyeDummy()
    {
        if ( super.InitDeathCameraEyeDummy() )
        {
            PrepareCameraEllipsoid();
            Vector vDir = GetForwardVector();
            //odsuwamy od glowy o pare centymetrow
            vDir.Mul( -20.0f );
            m_cDeathCameraEyeDummy.SetPosition( vDir );    
            return true;
        }
        return false;
    }*/
    
    /** dummy, ktorego ellipsoide uzywamy */
	MeshObject m_cDummyMesh = null;
    /** Promiem elipsoidy*/
    static float sm_fDummyRadius = 15.0f;
    
	/*void PrepareCameraEllipsoid()
	{
		if (m_cDummyMesh != null)
			return;
		
    	m_cDummyMesh = (MeshObject) CreateObject("MeshObject");
    	m_cDummyMesh.LoadMesh("Data/Interface/zarowka.3da");
        m_cDummyMesh.ActivateOnModule();
    	m_cDummyMesh.ClearFlag(EFlags._BLOCK_MOVE);
    	m_cDummyMesh.ClearFlag(EFlags._BLOCK_TRACE);
    	m_cDummyMesh.ClearFlag(EFlags._BLOCK_TRACE);
        m_cDummyMesh.SetCollAction(ECollFlags.OBJCOL_ACTION_STOP);
        m_cDummyMesh.SetCollHandler(ECollFlags.OBJCOL_HANDLER_NONE);
    	m_cDummyMesh.SetLighting(false);
        m_cDummyMesh.EnableRendering(false);
        if (m_cDummyMesh != null)
			m_cDummyMesh.SetEllipsoid( sm_fDummyRadius, sm_fDummyRadius, 0f );
	}*/

    Vector m_vWorldPos = null;
    
    static Vector m_vCameraEyeStart = new Vector();
    
    /**
     * Nadpisana metoda zwracajaca pozycje kamery umieszczonej w oku.
     * Trupek moze czasem przewrocic sie glowa "pod ziemie" lub "z wsiane"
     * Pozycja kamery jest liczona na kolizji elipsoidy (przesuwana
     * jest z nad pozycji gracza (na jego nogami) w kierunku
     * faktycznej pozycji oka.
     * Jesli elipsoida sie zatrzyma to na tej pozycji ustawiamy kemare
     */
    /*void GetEyePos(Vector vPos)
    {
        //pobierzmy pozycje oka
        super.GetEyePos( vPos );
        
        //i policzmy czy ta pozycjea jest ok
        
        //zapamietujemy flagi trupka
    	int nFlags = GetFlags();
        
        //wylaczamy mu kolizje
		ClearFlag( EFlags._COLLISION );

        //gdyby z jakiejs przyczyny nie znal swojej pozycji to pobieramy
        if ( m_vWorldPos == null )
             m_vWorldPos = GetPosition();
            
        //policzmy sobie pozycje z ktorej bedziemy "pchac" elipsoide 
        //w kierunku oka
        m_vCameraEyeStart.Set( Vector.Up );
        m_vCameraEyeStart.Mul( 180.0f );
        m_vCameraEyeStart.Add( m_vWorldPos );
        //ok, za pozycje startowa obieram punkt 180 cm na ziemia w pozycji trupka
                
        //sprawdzamy kolizje w gore od ziemi w miejscu gdzie stoi
        //zeby znalesc miejsce z ktorego bedziemy faktycznie przesuwac elipsoide
        //(trupek mogl umrzec lezac pod jakim obiektem i trzeba to wykryc)
        TraceForCollision( m_vWorldPos, m_vCameraEyeStart, null );
        //mamy juz pozycje poczatkowa elipsoide
		m_cDummyMesh.SetPositionWorld( m_vCameraEyeStart );
        //teraz liczmy wektor przesuniecia do pozycji oka
        vPos.Sub( m_vCameraEyeStart );
        
        //na czas przesuwania elipsoida wlaczmy flage kolizji, 
        //zeby uwzgledniac trupka przy jej przesuwaniu
        SetFlag( EFlags._COLLISION );
        
        //dokonujemy przesuniecia
		m_cDummyMesh.MoveByEllipsoidPure( vPos );
        
        //i z powrotem wyliczamy pozycje koncowa
        vPos.Add( m_vCameraEyeStart );
		
        //przywracamy flagi z poczatku operacji.
	    SetFlags( nFlags );
    }*/

    
    int nEyeId = -1;
    Vector vPrevDir = new Vector();
    float fPrevTime = 0;
    float fDirSpeed = 1f;
    public void OnFrame()
    {
        if ( m_cOwner == null || !m_cOwner.bNetIsOwner )
            return;
        
        if (m_cDeathCameraEyeDummy != null)
        {
            
            if (nEyeId == -1)
            {
                for (int i=0; i<sm_aEyeElements.length; i++ )
                {
                    nEyeId = GetElementID( sm_aEyeElements[i] );
                    if (nEyeId != -1)
                        break;
                }
            }
            if (nEyeId > -1)
            {
                if (fPrevTime == 0)
                {
                    fPrevTime = GetTime();
                    //vPrevDir = GetElementRightVector(nEyeId);
                    vPrevDir = GetElementForwardVector(nEyeId).Negate2();
                    m_cDeathCameraEyeDummy.SetDir(vPrevDir);
                }
                
                Vector vPos = GetElementPos(nEyeId);
                Vector vMove = vPos.Sub2(m_cDeathCameraEyeDummy.GetPositionVectorVolatile());
                if (vMove.Len() > 1000f)
                {
                    NetLog.DeadBody("Ruch " + vMove.Len());
                    vMove.Normalize();
                    vMove.Mul(1000f);
                    vMove = new Vector();
                }
                /*Vector vDir = m_cDeathCameraEyeDummy.GetForwardVector();
                Vector vDirMove = GetElementForwardVector(nEyeId).Negate2().Sub2(vDir);//(GetElementRightVector(nEyeId)).Sub2(vDir);
                vDirMove.Mul(fDirSpeed * (GetTime() - fPrevTime));
                vDir.Add(vDirMove);
                m_cDeathCameraEyeDummy.SetDir( vDir );   */
                
                m_cDeathCameraEyeDummy.MoveByEllipsoidPure(vMove);
                
                if (fPrevTime == 0)
                    NetLog.DeadBody("camera first pos " + m_cDeathCameraEyeDummy.GetPositionVectorVolatile());
                m_cDeathCameraEyeDummy.FromUpForwardPos(GetElementRightVector(nEyeId), GetElementForwardVector(nEyeId).Negate2(), m_cDeathCameraEyeDummy.GetPositionVectorVolatile().Add2(vMove));
                                                           //SetPosition();
                //m_cDeathCameraEyeDummy.SetWorldPosByEllipsoid(vPos);
                //LogR("Move = " + vMove + " expected " + m_cDeathCameraEyeDummy.GetPositionVectorVolatile());
                
                //vPrevDir.Set(vDir);
                fPrevTime = GetTime();
            }
            
        }
    }
    
    void ShowEye()
    {
        Tools.ShowMeshelemOrientation(this, nEyeId);
    }
    
    void OnPlayerRespawn()
    {
        if (m_bActivated)
            EnableRendering(true);
    }
        
    
    /**
     * Ile minimum kamera patrzaca z oka musi
     * byc nad ziemia
     */
    /* stara wersja wyrownujaca kamera tylko do ziemi
    static float sm_fGetEyePosMarginTerrain = 5.0f;
    
    void GetEyePos(Vector vPos)
    {
        super.GetEyePos( vPos );
                
        //na razie pokombinuje zeby nie wpadalo pod ziemie
        float fY = TerrainHeight( vPos.fX, vPos.fZ );
        if ( vPos.fY < fY + sm_fGetEyePosMarginTerrain )
             vPos.fY = fY + sm_fGetEyePosMarginTerrain;
    }*/


        /**
     * Globalny licznik zmian stanow obiektow
     * Bedzie on wykorzystywany na klientach do rozstrzygania czy dana
     * akcja (ktora zleca nam serwer) ma sie wykonac czy nie (bo jest stara)
     * TODO: dac szerszy opis
     */
    private static 
    ChangeStateCounter sm_cGlobalDeadBodyCounter = new ChangeStateCounter();
    static void CleanGlobalDeadBodyCounter(){ sm_cGlobalDeadBodyCounter.Clean();}
    
    /**
     * Indywidualny licznik zapamietujacy ostatnio
     * odebrana i wykonana akcje na tym obiekcie
     */
    private 
    ChangeStateCounter m_cDeadBodyCounter = new ChangeStateCounter(this);
    int     GetDeadBodyCounter(){ return m_cDeadBodyCounter.Get(); }
    
    int     GetNextGlobalDeadBodyCounter(){ return sm_cGlobalDeadBodyCounter.GetNext(); }
    boolean VerifyDeadBodyCounter( int nCounter ){ return m_cDeadBodyCounter.Verify( nCounter ); }

}

class DamageInfo
{
    float   fPhysicsSimDamage   = 0.0f; 
    Vector  vHitLocation        = null;
    Vector  vSpeed              = null;
    int     nDamageType         = 0;
	int     nBoneId             = 0;
    
    DamageInfo(float   fPhysicsSimDamage, 
               Vector  vHitLocation,
               Vector  vSpeed,
               int     nDamageType,
               int     nBoneId )
    {
        Set( fPhysicsSimDamage, 
             vHitLocation,
             vSpeed,
             nDamageType,
             nBoneId );
    }
    
    DamageInfo()
    {
        Set( 100.0f,
              new Vector( 0.0f,  1.0f, 0.0f ),
              new Vector( 0.0f, -1.0f, 0.0f ),
              0, 0 );
    }
        
    
    DamageInfo(Vector vPos)
    {
        this();
        this.vHitLocation   = vPos;
    }
    
    DamageInfo(DamageInfo cInfo)
    {
        Set( cInfo.fPhysicsSimDamage,
             cInfo.vHitLocation,
             cInfo.vSpeed,
             cInfo.nDamageType,
	         cInfo.nBoneId );
        
        Verify();
    }
    
    
    void Set(float   fPhysicsSimDamage, 
             Vector  vHitLocation,
             Vector  vSpeed,
             int     nDamageType,
             int     nBoneId )
    {
        this.fPhysicsSimDamage  = fPhysicsSimDamage;
        this.vHitLocation       = vHitLocation;
        this.vSpeed             = vSpeed;
        this.nDamageType        = nDamageType;
	    this.nBoneId            = nBoneId;
    }
    
    void Verify()
    {
        if ( vSpeed == null )
            vSpeed = new Vector();
    }

}
