/** Kontener danych umozliwiajacy przesylanie ich przez siec
 * za pomoca systemu komunikatow
 */
public class NetDataContainer
{
    //lista z zapamietanymi Int'ami
    private java.util.Vector m_aDataInt     = new java.util.Vector();
    //ile z tej listy juz odczytalismy wartosci?
    private int              m_nReadInt     = 0;
    
    //lista z zapamietanymi Float'ami
    private java.util.Vector m_aDataFloat   = new java.util.Vector();
    //ile z tej listy juz odczytalismy wartosci?
    private int              m_nReadFloat   = 0;
    
    //lista z zapamietanymi Bool'ami
    private java.util.Vector m_aDataBoolean = new java.util.Vector();
    //ile z tej listy juz odczytalismy wartosci?
    private int              m_nReadBoolean = 0;
    
    //lista z zapamietanymi String'ami
    private java.util.Vector m_aDataString  = new java.util.Vector();
    //ile z tej listy juz odczytalismy wartosci?
    private int              m_nReadString  = 0;
    
    //obiekt ktory bedzie posredniczyl w wyslaniu/odebraniu komunikatu
    private GameObject m_cMessenger   = null;
    //tryb w ktorym wysylamy NewFreeMessage( / NewMessage(
    private boolean    m_bFreeMessageMode = false;
    
    NetDataContainer()
    {
        Clear();
    }
    
    void Clear()
    {
        m_aDataInt.clear();
        m_nReadInt = 0;
    
        m_aDataFloat.clear();
        m_nReadFloat = 0;
    
        m_aDataBoolean.clear();
        m_nReadBoolean = 0;
        
        m_aDataString.clear();
        m_nReadString = 0;
    }
    
    /**
     * Metody dopisywanie danych
     */
    void PackInt(int nValue)
    {
        m_aDataInt.addElement( new Integer( nValue ) );
    }
    
    void PackFloat(float fValue)
    {
        m_aDataFloat.addElement( new Float( fValue ) );
    }
    
    void PackBoolean(boolean bValue)
    {
        m_aDataBoolean.addElement( new Boolean( bValue ) );
    }
    
    void PackString(String sValue)
    {
        m_aDataString.addElement( sValue );
    }
    
    /**
     * Metody odczytywania danych
     */
    int UnPackInt()
    {
        int nValue = 0;
        if ( m_nReadInt < m_aDataInt.size() )
            nValue = GetInt( m_nReadInt++ );
        else
            GameObject.LogD(" Lista nie ma elementu "+m_nReadInt+"\n");
        return nValue;
    }
    
    float UnPackFloat()
    {
        float fValue = 0.0f;
        if ( m_nReadFloat < m_aDataFloat.size() )
            fValue = GetFloat( m_nReadFloat++ );
        else
            GameObject.LogD(" Lista nie ma elementu "+m_nReadFloat+"\n");
        return fValue;
    }
    
    boolean UnPackBoolean()
    {
        boolean bValue = false;
        if ( m_nReadBoolean < m_aDataBoolean.size() )
            bValue = GetBoolean( m_nReadBoolean++ );
        else
            GameObject.LogD(" Lista nie ma elementu "+m_nReadBoolean+"\n");
        return bValue;
    }
    
    String UnPackString()
    {
        String sValue = "";
        if ( m_nReadString < m_aDataString.size() )
            sValue = GetString( m_nReadString++ );
        else
            GameObject.LogD(" Lista nie ma elementu "+m_nReadString+"\n");
        return sValue;
    }
    
    boolean CheckUnPackEnd()
    {
        if ( m_nReadFloat < m_aDataFloat.size() )
            GameObject.LogD(" m_nReadFloat"+m_nReadFloat+" "+m_aDataFloat.size()+"\n");
        if ( m_nReadInt < m_aDataInt.size() )
            GameObject.LogD(" m_nReadInt"+m_nReadInt+" "+m_aDataInt.size()+"\n");
        if ( m_nReadString < m_aDataString.size() )
            GameObject.LogD(" m_nReadString"+m_nReadString+" "+m_aDataString.size()+"\n");
        if ( m_nReadBoolean < m_aDataBoolean.size() )
            GameObject.LogD(" m_nReadBoolean"+m_nReadBoolean+" "+m_aDataBoolean.size()+"\n");
            
        return(( m_nReadFloat   >= m_aDataFloat.size() )&&
               ( m_nReadInt     >= m_aDataInt.size() )&&
               ( m_nReadString  >= m_aDataString.size() )&&
               ( m_nReadBoolean >= m_aDataBoolean.size() ));
    }

    int GetInt(int i)
    {
        return ((Integer)m_aDataInt.elementAt( i )).intValue();
    }
    
    float GetFloat(int i)
    {
        return ((Float)m_aDataFloat.elementAt( i )).floatValue();
    }
    
    boolean GetBoolean(int i)
    {
        return ((Boolean)m_aDataBoolean.elementAt( i )).booleanValue();
    }
    
    String GetString(int i)
    {
        return (String)m_aDataString.elementAt( i );
    }
    
    void FromMessage(GameObject cMessenger)
    {
        SetMessageParams( cMessenger, false );
        FromMessage();
    }
    
    void FromFreeMessage(GameObject cMessenger)
    {
        SetMessageParams( cMessenger, true );
        FromMessage();
    }
    
    private void FromMessage()
    {
        int nIntCnt     = MessageUnPackInt();
        for ( int i=0; i<nIntCnt; i++ )
            PackInt( MessageUnPackInt() );
        int nFloatCnt   = MessageUnPackInt();
        for ( int i=0; i<nFloatCnt; i++ )
            PackFloat( MessageUnPackFloat() );
        int nBooleanCnt = MessageUnPackInt();
        for ( int i=0; i<nBooleanCnt; i++ )
            PackBoolean( MessageUnPackBoolean() );
        int nStringCnt = MessageUnPackInt();
        for ( int i=0; i<nStringCnt; i++ )
            PackString( MessageUnPackString() );
    }
    
    int MessageUnPackInt()
    {
        if (m_bFreeMessageMode)
            return m_cMessenger.FreeMessageUnPackInt();
        return m_cMessenger.MessageUnPackInt();
    }
    float MessageUnPackFloat()
    {
        if (m_bFreeMessageMode)
            return m_cMessenger.FreeMessageUnPackFloat();
        return m_cMessenger.MessageUnPackFloat();
    }
    boolean MessageUnPackBoolean()
    {
        if (m_bFreeMessageMode)
            return m_cMessenger.FreeMessageUnPackBoolean();
        return m_cMessenger.MessageUnPackBoolean();
    }
    String MessageUnPackString()
    {
        if (m_bFreeMessageMode)
            return m_cMessenger.FreeMessageUnPackString();
        return m_cMessenger.MessageUnPackString();
    }    
    
    void ToMessage(GameObject cMessenger)
    {
        SetMessageParams( cMessenger, false );
        ToMessage();
    }
    
    void ToFreeMessage(GameObject cMessenger)
    {
        SetMessageParams( cMessenger, true );
        ToMessage();
    }
    void ToMessage()
    {
        int nIntCnt     = m_aDataInt.size();
        int nFloatCnt   = m_aDataFloat.size();
        int nBooleanCnt = m_aDataBoolean.size();
        int nStringCnt  = m_aDataString.size();
        
        MessagePackInt( nIntCnt );
        for ( int i=0; i<nIntCnt; i++ )
            MessagePackInt( GetInt( i ) );
        MessagePackInt( nFloatCnt );
        for ( int i=0; i<nFloatCnt; i++ )
            MessagePackFloat( GetFloat( i ) );
        MessagePackInt( nBooleanCnt );
        for ( int i=0; i<nBooleanCnt; i++ )
            MessagePackBoolean( GetBoolean( i ) );
        MessagePackInt( nStringCnt );
        for ( int i=0; i<nStringCnt; i++ )
            MessagePackString( GetString( i ) );
    }
    
    
    void MessagePackInt(int nValue)
    {
        if (m_bFreeMessageMode)
            m_cMessenger.FreeMessagePackInt( nValue );
        else
            m_cMessenger.MessagePackInt( nValue );
    }
    void MessagePackFloat(float fValue)
    {
        if (m_bFreeMessageMode)
            m_cMessenger.FreeMessagePackFloat( fValue );
        else
            m_cMessenger.MessagePackFloat( fValue );
    }
    void MessagePackBoolean(boolean bValue)
    {
        if (m_bFreeMessageMode)
            m_cMessenger.FreeMessagePackBoolean( bValue );
        else
            m_cMessenger.MessagePackBoolean( bValue );
    }
    void MessagePackString(String sValue)
    {
        if (m_bFreeMessageMode)
            m_cMessenger.FreeMessagePackString( sValue );
        else
            m_cMessenger.MessagePackString( sValue );
    }    
    
    void SetMessageParams( GameObject cMessenger, boolean bFreeMessageMode )
    {
        m_cMessenger        = cMessenger;
        m_bFreeMessageMode  = bFreeMessageMode;
    }
    
    
}
