public class NewAIWolfBeast extends NewAIAnimal
{
    NewAIWolfBeast()
    {
        MeshName = "Data/Meshes/Animals/Wolfbeast.3DA";

        m_aMotionVelocity = new float[] {130, 130, 130, 130, 130, 800};
        m_aMotionAngularVelocity = new float[] { 60, 60, 60, 60, 60, 300 };
        
        m_aAggressiveMotionVelocity = new float[] {130, 130, 130, 130, 130, 800};
        m_aAggressiveMotionAngularVelocity = new float[] { 300, 300, 300, 300, 300, 300 };
        
        aDamageMultipliers = new float[] { .3f, 1.f, 1.f, 1.f};
        fHealth = fMaxHealth = 300;

        fSightRange = 4000;
        fSightRangeRecognitionMult = 1f;
        fSightAngle = 230;
        fMaxEnemyRecognitionTime = 0.f;
        fMaxEnemyKeepingDistance = 3000;
        
        fBiteDamage = 200;
        fBiteAttackRange = 170.f;
        sJawElementName = "Bip01 PonyTail1";
        fJawSize = 80;
        fBiteAnimDelay = 0.2f;
        m_fTimeBtwBites = 0.5f;
        
        sDeathSound = "Data/Sounds/Animals/WolfBeastDeath";
        sHitSound = "Data/Sounds/Animals/WolfBeastHit";
        sAttackSound = "Data/Sounds/Animals/WolfBeastAttack";
        sStepSoundAttack = "Data/Sounds/Animals/WolfBeastAttackStep";
        sBlobMaterial = "blob_wolfbeast.mat";
        fBlobMapSize = 120;
    }
    
    
    public void OnCreate()
    {
        super.OnCreate();
        
        m_Anims = new AIAnimationsWolfBeast(0);
        m_Anims.Initialize(this, sAnimSeqFile, "", "");

        SetAnimMorphTime(0.5f);
        SetEllipsoid(150, 150, 75); 
        SetEllipsoidNoExtents(75, 150, 75); 
    }
}
