/**
 * Klasa obejmuje:
 * 1. zdarzenia wysylane do AIControllera, powdujace przeliczanie 
 *     generatorow
 * 2. komunikaty dla biezacych Taskow
 */
public class AIEvents
{
    /** zdarzenia powodujace przeliczanie generatorow */
    final public static int _EV_UNDEFINED = 0;
    final public static int _EV_START = 1;
    final public static int _EV_NOISE_BULLET_HIT = 2;
    final public static int _EV_OBJECTS_CHANGE = 3;
    final public static int _EV_ACTIVE_ENEMY_CHANGED = 4;
    final public static int _EV_FRIENDS_CHANGE = 5;            
    final public static int _EV_PAIN = 6;            
    final public static int _EV_FREEDOM = 7; // swoboda (nie ma wrogow w poblizu)
    final public static int _EV_SCENARIO_END = 8; // skonczyl sie scenariusz
    final public static int _EV_NO_AMMO = 9; // skonczyla sie amunicja    
    final public static int _EV_NOISE_ENEMY_SHOT = 10;
    final public static int _EV_NOISE_FRIEND_SHOT = 11;
	final public static int _EV_NOISE_SCREAM = 12;
	final public static int _EV_DANGEROUS_OBJECT = 13;
	final public static int _EV_NOISE_STEPS = 14;
    final public static int _EV_NOISE_PASSAGE = 15;
    final public static int _EV_ACTIVE_ENEMY_VISIBLE_FROM_GUN_CHANGE = 16;
    final public static int _EV_EDITOR_ACTIVITY = 17;
    final public static int _EV_NOISE_EXPLOSION = 18;
    final public static int _EV_TEST = 19; // zdarzenie testowe    
    
    /** komunikaty wysylane do biezacych Taskow  > 100   */
    final public static int _NOTICE_END_TASK = 100;  // informacja od zadania, ze sie zakonczylo
    final public static int _NOTICE_ANIM_END = 101; // zakonczenie odtwarzania animacji
    final public static int _NOTICE_ANGLE_REACHED = 102;
    final public static int _NOTICE_DEST_POS = 103;
    final public static int _NOTICE_GLOBAL_TIME_PASSED = 104;  // uplynal czas dla calego scenariusza
    final public static int _NOTICE_TASK_TIME_PASSED = 105;    // uplynal czas dla biezacego zadania
	final public static int _NOTICE_VEHICLE_REACHED_WAYPOINT = 106; // pojazd, ktorym jedzie ai dojechal do waypointa
	final public static int _NOTICE_WAIT_FOR_EXTERNAL_NOTICE = 107;
    final public static int _NOTICE_TRIGGER_OBJECT_NOTIFICATION = 108; // notice w czasie wykonywania StartExecution na TriggerObject
    final public static int _NOTICE_WEAPON_STATE_CHANGED = 109; // zmiana stanu broni (rozpoczecie | zakonczenie strzelania)
    final public static int _NOTICE_ANIM_STOPPED = 110; // przerwanie animacji przed zakonczneiem
        
/** zwraca nazwe zdarzenia  */
	static String GetEventName(int nEvent)
	{
        return GameObject.GetFieldNameForIntValue(AIEvents.class, nEvent, null);
	}
		
}


