public class AIControllerHuman extends AIController
{
    /////////////////////////////////////////////////////////////////////
    // HIDEOUTY
    /* lista hideoutow ai */
    java.util.ArrayList m_aHideouts = new java.util.ArrayList();
    /** biezacy hideout */
    ChromeActor m_CurrentHideout = null;
    /** pozycja do schowania za biezacym hideoutem */
    Vector m_vCurrHideout = null;
    /** czy zza biezacego hideouta mozna trafic wroga */
    boolean m_bCanHitActiveEnemyFromHideout = false;
    /** ostatni czas przeliczenia, czy biezacego przeciwnika mozna trafic zza hideouta */
    float m_fHideoutHitCalcTime = _INIT_TIME;
    /** min czas pomiedzy przeliczeniami pozycji do schowania za hideoutem */
    static float _MIN_TIME_BTW_HIDEOUT_POS_CALC = 3f;
    /** min czas pomiedzy przeliczeniami czy mozna trafic aktywnego wroga zza hideouta */
    static float _MIN_TIME_BTW_HIDEOUT_HIT_CALC = 1f;
    /**	do jakiej odleglosci za chowaczem ma podbiec ai */
    static float _HIDEOUT_HIDE_DIST = 150f;
    /** odleglosc od wybranej pozycji za chowaczem, dla ktorej uznajemy, ze AI jest jeszcze za nim */
    static float _BEHIND_HIDEOUT_FREEDOM = 100f;
    /** odleglosc, dla ktorej stwierdzamy, ze hideouty sa blisko */
    static float _SHORT_HIDEOUT_DIST = 2000f;
    /** ostatni czas przeliczenia pozycji za biezacym hideoutem */
    float m_fHideoutPosCalcTime = -_MIN_TIME_BTW_HIDEOUT_POS_CALC;
    /** hideout, ktory trace'owalismy, czy mozemy zza niego wstawac i strzelac */
    ChromeActor m_LastTrackedHideout = null;
    /** czy po ostatnim trace'owaniu stwierdzilismy, ze mozemy atakowac zza hideout */
    boolean m_bCanAttackFromCurrHideout = false;
    /** czas po uslyszeniu rykoszetu, jaki ai moze biec do hideouta */
    static float _TIME_AFTER_RICOCHET_TO_GO_TO_HIDEOUT = 20f;
    /** nr metody */
    int METHOD_UpdateCurrHideout = 0;
    /////////////////////////////////////////////////////////////////////
    // Komunikaty radiowe
    public static int _ENEMY_HIT_MSG_CHANCE = 20;
    public static int _WOUNDED_MSG_CHANCE   = 20;
    
    /////////////////////////////////////////////////////////////////////
    // BRON I STRZELANIE
    int METHOD_FireOneBullet = 0;
    int METHOD_FireDone = 0;
    int METHOD_Fire = 0;
    int METHOD_UpdateShootDecision = 0;
    int METHOD_TryToStartFiring = 0;

    int m_nBulletsToFire = 0;
    boolean m_bFireModeSingle;
    
    float _SHARP_ANGLE_TO_SHOOT = 20f;
    float _SHARP_Y_DIFF_TO_SHOOT = 0.4f;
    float _MIN_DIST_TO_START_INC_Y_DIFF_ALLOWED = 300.f;
    float _SHARP_ANGLE_TO_SHOOT_COS = 0;
    
    
    boolean m_bIsShooting = false;
    float m_fNextShootTime = 0;
    

    /** Wartosc dodawana do celnosci ai gdy strzela kucajac lub lezac */
    float m_fDuckCrawlAccAdd = 0.1f;
    
    /** Wartosc dodawana do celnosci ai gdy strzela poruszajac sie */
    float m_fMoveAccAdd = -0.2f;
    
    /** Wplyw (mnoznik) ShootVisibilityFactor celu na celnosc ai */
    float m_fTargetShootVisibilityFactorImportance = 0.2f;
    
    ///////////////////////////////////////////////
    // Parametry ustawiane na podstawie broni
    //
    
    /** Prawdopodobienstwo, ze stojace odpowiednio daleko AI przyceluje przed strzalem
     *  (gdy 100 - zawsze probuje przycelowac, nawet blisko) [%] */
    int m_nReadinessToStartAiming = 100;
    
    /** Prawdopodobienstwo, ze konczac serie AI przestanie przycelowywac */
    int m_nReadinessToStopAiming = 100;
    
    /** Dystans ^2, ponizej ktorego ai uznaje cel za bliski
     * (do przycelowania i dlugosci serii)*/
    float m_fNearTargetDistance2 = 1;

    /** Dystans ^2, powyzej ktorego ai uznaje cel za odlegly 
     * (do przycelowania i dlugosci serii)*/
    float m_fMaxAimingChanceDistance2 = 2;

    /** Dystans ^2, powyzej ktorego ai uznaje cel za odlegly 
     * (do przycelowania i dlugosci serii)*/
    float m_fFarTargetDistance2 = 3;
    
    /** Maksymalna odleglosc ^2, ponizej ktorej AI strzela z broni w trybie auto [cm^2] */
    float m_fMaxBurstFireDistance2 = 1000*1000;

    /** Minimalna ilosc kul do wystrzelenia z broni w trybie single */
    int m_nMinBulletsToFire;
    /** Maksymalna ilosc kul do wystrzelenia z broni w trybie single */
    int m_nMaxBulletsToFire;
    
    /** Minimalny czas strzelania seria */
    float m_fMinBurstFiringTime;
    /** Losowy modyfikator fla m_fMinBurstFiringTime */
    float m_fRandomBurstFiringTime;
    
    /** Minimalna przerwa miedzy 'seriami' pojedynczych strzalow */
    float m_fMinSingleFireDelay;
    /** Losowy modyfikator dla m_fMinSingleFireDelay */
    float m_fRandomSingleFireDelay;

    /** Minimalny odstep czasu pomiedzy pojedynczymi kulami podczas pojedynczych strzalow [s]*/
    float m_fSingleBulletDelay;
    /** Losowy modyfikator dla fAISingleBulletDelay [s]*/    
    float m_fRandomSingleBulletDelay;

    /** Poprawa celnosci dla strzelania z przycelowaniem */
    float m_fAimingAccAdd;
    
    /** Poprawa celnosci dla strzelania pojedynczymi kulami */
    float m_fSingleFireAccAdd;

    /** Minimalna przerwa miedzy seriami strzalow w trybie auto */
    float m_fMinBurstFireDelay;
    /** Losowy modyfikator dla m_fMinBurstFireDelay */
    float m_fRandomBurstFireDelay;
    
    /** Efektywy zasieg broni ^2 */
    float m_fWeaponEffectiveRange2;
    
    
    /** Minimalne prawdopodobienstwo trafiania przez AI w cel */
    public float m_fMinDesiredHitRatio;
    
    /** Maksymalne prawdopodobienstwo trafiania przez AI w cel */
    public float m_fMaxDesiredHitRatio;
    
    
    /////////////////////////////////////////////////////////////////////////////
    
    /** pojazd, ktory jest sterowany przez to AI */
    IDrivenVehicle m_DrivenVehicle = null;
    /** czy AI jest w pojezdzie - czy w nim siedzi */
    boolean m_bSitsInVehicle = false;
    /** czy AI jest w stationary cannon */
    boolean m_bSitsInCannon = false;
    
    
    //////////////////////////////////////////////////////////////////////////////////
    // RZUCANIE GRANATAMI
    //

    /** odleglosci zwiazane z rzutem granatem */
    static float _MIN_DIST_TO_THROW_GRENADE = 1000f;
    static float _MAX_DIST_TO_THROW_GRENADE = 2500f;
    
    /** czas, przez jaki cel musi pozostawac nieruchomy, zeby ai rzucilo granatem */
    public static float _GRENADE_TARGET_STILL_TIME = 1.f;
    /** odleglosc, jaka moze maksymalnie przebyc cel, zeby ai jeszcze uznalo, ze sie nie poruszyl */
    public static float _GRENADE_TARGET_POS_TOLERANCE = 10.f;

    /** Co jaki czas mozna rzucac granatem */
    public float _MIN_TIME_BTW_GRENADES_THROW = 5.f;
    /** Co jaki czas mozna traceowac trajektorie */
    public float _MIN_TIME_BTW_GRENADES_CHECK = 1.f;
    /** Maksymalna wysokosc, na jaka moze wzniesc sie granat */
    public float _MAX_GRENADE_TRAJECTORY_HEIGHT = 500.f;
    /** O ile cm ma sie wzniesc granat na kazdy cm odleglosci do celu (wartosc domyslna, gdy nie ma przeszkod)*/
    public float _DEF_GRENAGE_TRAJECTORY_TAN = 0.5f;
    /** Tolerancja odleglosci do celu na jaka doleci granat z traceowania trajektorii */
    public float _MAX_GRENADE_TRAJECTORY_END_DISTANCE = 200.f;
    

    /** Kiedy ostatnio byla sprawdzana trajektoria */
    protected float m_fLastGrenadeCheck = _INIT_TIME;
    /** Kiedy ostatnio byl rzucony granat */
    protected float m_fLastGrenadeThrow = _INIT_TIME;
    /** Ostatnio obliczona wysokosc trajektorii lotu granata */
    protected float m_fLastCheckedGrenadeTrajectoryHeight = _MAX_GRENADE_TRAJECTORY_HEIGHT;
    /** Ostatni wynik sprawdzania trajektorii granata */
    protected boolean m_bLastGrenadeTrajectoryCheckResult = false;

    
    ////////////////////////////////////////////////////////////////////////////////
    
    AIControllerHuman()
    {    
        super();
        
        _MANY_ATTACKING_ENEMIES = 2;
    }
    
    public void OnCreate()
    {
        METHOD_UpdateCurrHideout = RegisterCallMethod("UpdateCurrHideout");
        
        super.OnCreate();
        
        METHOD_FireOneBullet = RegisterCallMethod("FireOneBullet");
        METHOD_FireDone = RegisterCallMethod("FireDone");
        METHOD_Fire = RegisterCallMethod("Fire");
        METHOD_UpdateShootDecision = RegisterCallMethod("UpdateShootDecision");
        METHOD_TryToStartFiring = RegisterCallMethod("TryToStartFiring");
        
        _SHARP_ANGLE_TO_SHOOT_COS = (float) Math.cos(_SHARP_ANGLE_TO_SHOOT * Math.PI / 180f);
    }
    
    public void InitController(NewAI ai)
    {
        super.InitController(ai);
        
        UpdateCurrHideout();
        CallMethodEveryMinMax(METHOD_UpdateCurrHideout, 1f, 4f, 1f * GetMesh().GetTimeDeviation());
        
        m_HearingSense = (HearingSense) CreateObject("HearingSense");
        m_HearingSense.Init(this);

        m_PainSense = (PainSense) CreateObject("PainSense");
        m_PainSense.Init(this);

        m_ObjectsSense = (ObjectsSense) CreateObjectNoInit("ObjectsSense");
        m_ObjectsSense._AI_SIGHT_RANGE = ((NewAIHuman) ai).fSightRange;
        m_ObjectsSense._AI_RECOGNIZE_RANGE = ((NewAIHuman) ai).fSightRange * ((NewAIHuman) ai).fSightRangeRecognitionMult;
        m_ObjectsSense._AI_SIGHT_ANGLE = ((NewAIHuman) ai).fSightAngle;
        m_ObjectsSense.InitObject();
        m_ObjectsSense.Init(this);

        fMaxEnemyRecognitionTime = ((NewAIHuman)m_MeshAI).fMaxEnemyRecognitionTime;
        fMaxEnemyRecognitionTimeAlarmed = ((NewAIHuman)m_MeshAI).fMaxEnemyRecognitionTimeAlarmed;
    }
    
    public void AddGenerators()
    {
        super.AddGenerators();

#if AI_DEBUG
        Generator debugFilter = new ScenariosFilterHuman(this);
        m_DebugScenariosFilter.Set(debugFilter.m_GenScenarios);
#endif

        m_aGenerators = new Generator[] {
                           new CanMove(this),
                           new CanShoot(this),
                           new CanThrowGrenade(this),
                           new EnemySpotted(this),
                           new EnemyStronger(this),
                           new FallDownCheck(this),
                           new HasToKeepDistance(this),
                           new HasToReload(this),
                           new HideoutsCheck(this),
                           new IdleAllowed(this),
                           new InVehicle(this),
                           new IsUnarmed(this),
                           new LongEnemyDistance(this),
                           new NoiseShotEnemy(this),
                           new PerformEditorActivity(this),
                           new RunAwayCheck(this),
                           new ScenariosFilterHuman(this),
                           new ShortEnemyDistance(this),
                           new ShouldAttackFromHideout(this),
                           new ShouldCheckBody(this),
                           new ShouldLookForEnemy(this),
                           new ShouldWaitForEnemyAction(this),
                           new SilenceBroken(this),
                           new SuspectSpotted(this),
//*/                           new TestGenerator(this)
                           };
    }
    
    public void Die()
    {
        super.Die();
        
        DisableCallMethod(METHOD_UpdateCurrHideout);
        
        FireDone();
        DisableCallMethod(METHOD_UpdateShootDecision);
    }
    
    public void Respawn()
    {
        super.Respawn();
        
        UpdateCurrHideout();
        CallMethodEvery(METHOD_UpdateCurrHideout, 1f, 1f * GetMesh().GetTimeDeviation());
    }
    
    public void UpdateObjectsInformation()
    {
        // wyszukanie hideouta
        RecalculateHideouts();
        
        super.UpdateObjectsInformation();
    }

    public boolean ShouldPerformEditorActivity()
    {
        return ( (GetCurrWaypoint() != null) && (m_bPerformCurrActivity) &&
                 ((m_CurrActivity != null) && (m_CurrActivity.IsCritical()) ||
                  ((GetActiveEnemy() == null) && TimeFromImpulsePassed() && !IsSuspectValid()) || 
                  ((m_bSitsInVehicle) && (m_CurrActivity instanceof mt_Move))) );
        // jezeli jestesmy w pojezdzie, to kazde move jest krytyczne
    }
    
    /** wrzucenie przekazanych przez zmysl ObjectsSense obiektow */
    void RedistributeObjects(ControlObject [] aObjs)
    {
        m_aHideouts.clear();
        float fTime = GetTime();
        
        for (int i = 0; i < aObjs.length; i++)
        {
            if (aObjs[i] == m_MeshAI)
                continue;
            
            ChromeActor actor = (ChromeActor) aObjs[i];
            
            if (actor.bIsHideout)
                m_aHideouts.add(actor);
            else
                if ( (actor instanceof NewAI) ||
                     (actor instanceof Vehicle) ||
                     (actor instanceof Player) )
                {
                    AddToProperList(actor, fTime);
                }
        }
    }

    
    /** Notyfikacja o kolizji z obiektem */
    public void CollisionMsg(ControlObject obstacle, Vector point, Vector normal)
    {
        super.CollisionMsg(obstacle, point, normal);
        if (obstacle instanceof ChromeActor)
        {
            ChromeActor actor = (ChromeActor)obstacle;
            EnemyInfo info = AddEnemy(actor);
            if (info != null)
                RecognizeEnemy(info);
        }
    }

    public void PainMsg(float fDamage, float fPhSimDamage, GameObject Assassin,Vector vHitLocation,
                        Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        super.PainMsg(fDamage, fPhSimDamage, Assassin, vHitLocation,
                      vSpeed, nMeshElementorBoneID, nDamageType);
        
        boolean bMaySendRadioMsg = m_MeshAI.bCanUseRadioCommunication &&  MathUtils.CanHappen(_WOUNDED_MSG_CHANCE);
        if (bMaySendRadioMsg)
            m_MeshAI.SendRadioMessage(RadioCommunicationSystem._RADIO_MSG_WOUNDED);
    }

    void SetActiveEnemy(ChromeActor cEnemy)
    {
        if (m_MeshAI.bCanUseRadioCommunication && 
            GetAlarmLevel() >= _ALARM_LEVEL_HIGH &&
            cEnemy == null)
        {
            m_MeshAI.SendRadioMessage(RadioCommunicationSystem._RADIO_MSG_CLEAR);
        }
        super.SetActiveEnemy(cEnemy);
    }
    
    /////////////////////////////////////////////////////////////////////
    public final static float _LIE_DOWN_CHECK_INTERVAL = 0.5f;
    public final static float _LIE_DOWN_CHECK_RADIUS   = 250f;
    public final static float _LIE_DOWN_MIN_Y          = 15.f;
    public final static float _LIE_DOWN_MAX_Y          = 200.f;
    
    protected float m_fLastLieDownCheckTime = _INIT_TIME;
    protected boolean m_bLastLieDownCheckResult = false;
    private Vector m_vCLDMinExt = new Vector(),
                   m_vCLDMaxExt = new Vector();
    
    public boolean CanLieDown()
    {
        float fTime = GetTime();
        if (TimePassed(m_fLastLieDownCheckTime, _LIE_DOWN_CHECK_INTERVAL, fTime))
        {
            m_fLastLieDownCheckTime = fTime;
            m_MeshAI.GetPosition(m_vCLDMinExt);
            m_vCLDMaxExt.Set(m_vCLDMinExt);
            m_vCLDMinExt.fX -= _LIE_DOWN_CHECK_RADIUS;
            m_vCLDMinExt.fY += _LIE_DOWN_MIN_Y;
            m_vCLDMinExt.fZ -= _LIE_DOWN_CHECK_RADIUS;
            
            m_vCLDMaxExt.fX += _LIE_DOWN_CHECK_RADIUS;
            m_vCLDMaxExt.fY += _LIE_DOWN_MAX_Y;
            m_vCLDMaxExt.fZ += _LIE_DOWN_CHECK_RADIUS;
            
            m_bLastLieDownCheckResult = !AreTerrainFacesInExtents(m_vCLDMinExt, m_vCLDMaxExt);

            if (m_bLastLieDownCheckResult)
            {
                ControlObject[] aObjs = GetObjectsInExtents(m_vCLDMinExt, m_vCLDMaxExt);
                m_bLastLieDownCheckResult = true;
                if (aObjs != null)
                {
                    ControlObject obj;
                    for (int i = 0; i < aObjs.length; i++)
                    {
                        obj = aObjs[i];
                        if (obj != m_MeshAI &&
                            !(obj instanceof InvObject))
                        {
                            m_bLastLieDownCheckResult = false;
                            break;
                        }
                    }
                }
            }
        }
        return m_bLastLieDownCheckResult;
    }
    
    /////////////////////////////////////////////////////////////////////
    // STRZELANIE
    /** Strzela jeden pocisk lub serie, w zaleznosci od okolicznosci */
    /** wlaczenie strzelania */
    void SetCanFire(boolean bCanAim)
    {
        super.SetCanFire(bCanAim);
        
        m_bIsShooting = false;
        m_fNextShootTime = 0;
        UpdateShootDecision();
        CallMethodEvery(METHOD_UpdateShootDecision, 0.5f, 0.5f * GetMesh().GetTimeDeviation());
    }

    /** wylaczenie strzelania */
    void ResetCanFire()
    {
        super.ResetCanFire();
        DisableCallMethod(METHOD_UpdateShootDecision);
        FireDone();
    }

    /** wylaczenie przycelowania */
    void ResetCanAim()
    {
        super.ResetCanAim();
        TryToStopAiming();
        GetMesh().m_Motion.bAiming = false;
    }
    
    float TryToStartAiming()
    {
        // jesli nie moze strzelac bez przycelowania to wymus przycelowanie, jesli to mozliwe
        boolean bHasToAim = (m_nReadinessToStartAiming > 0) &&
                            ((GetValidFiringPositions() &
                              (_FIRINGPOS_STAND | _FIRINGPOS_DUCK)) == 0);
        if (m_bCanAim &&
            !GetMesh().m_Motion.bAiming &&
            (bHasToAim || ChooseBestAimingStrategy()))
        {
            if (MathUtils.CanHappen(m_nReadinessToStartAiming))
            {
                GetMesh().m_Motion.bAiming = true;
                return GetMesh().UpdateMotion();
            }
        }
        return 0;
    }
    
    /** Zwraca 0 jesli aktywny wrog jest blisko (ponizej fNearDistance2),
     *  1 jesli daleko (powyzej fFarDistance2) i wartosc pomiedzy 0-1 gdy 
     *  pomiedzy tymi odleglosciami
     */
    float CalcActiveEnemyDistCoef(float fNearDistance2, float fFarDistance2)
    {
        return Tools.InterpLinear(fNearDistance2,
                                  fFarDistance2, 
                                  GetActiveEnemyDistance2());
    }
    
    /** Podjecie decyzji o tym, czy nalezy przycelowac
     */
    boolean ChooseBestAimingStrategy()
    {
        if (m_nReadinessToStartAiming < 100)
        {
            float fDistCoef = CalcActiveEnemyDistCoef(m_fNearTargetDistance2, 
                                                      m_fMaxAimingChanceDistance2); 
            //wez pod uwage MotionState
            float fMotionCoef;
            AIMotionState cMotion = GetMesh().m_Motion;
            if (cMotion.IsMovingLinear() &&
                cMotion.GetSpeed() == MotionState.SPEED_RUN)
                fMotionCoef = 0.7f;
            else
                fMotionCoef = 1.f;

            return RandomFloat(1.f) <= fMotionCoef * fDistCoef;
        }
        else // jesli m_nReadinessToStartAiming == 100 - zawsze przyceluj
            return true; 
    }
    
    float TryToStopAiming()
    {
        if (GetMesh().m_Motion.bAiming)
        {
            if (MathUtils.CanHappen(m_nReadinessToStopAiming))
            {
                GetMesh().m_Motion.bAiming = false;
                return GetMesh().UpdateMotion();
            }
        }
        return 0;
    }
    
    public void UpdateShootDecision()
    {
        if (!IsDead())
        {
            if (!m_bIsShooting)
            {
                if (GetTime() > m_fNextShootTime)
                {
                    // sprawdzamy, czy widac przeciwnika
                    if (m_cActiveEnemy != null 
                        && GetActiveEnemyDistance2() < m_fWeaponEffectiveRange2)
                    {
                        Vector vTargetPos = m_cActiveEnemy.GetPointToLookAt(0);
                        if (vTargetPos != null)
                        {
                            if (SharpAngleToShoot(vTargetPos))
                            {
                                if (ActiveEnemyVisibleFromGun())
                                {
                                    float fDelayTime = TryToStartAiming();
                                    CallMethodOnceIn(METHOD_Fire, fDelayTime); // widac wroga, mozemy strzelac
                                }
                                else if (!m_MeshAI.m_ActualMotion.bAiming && // sprawdz czy przycelowanie moze cos poprawic
                                         (((m_MeshAI.m_ActualMotion.iSpeed == MotionState.SPEED_DUCK) &&
                                           IsValidFiringPosition(_FIRINGPOS_DUCK_AIMING)) ||
                                          ((m_MeshAI.m_ActualMotion.iSpeed == MotionState.SPEED_WALK ||
                                            m_MeshAI.m_ActualMotion.iSpeed == MotionState.SPEED_RUN) &&
                                           IsValidFiringPosition(_FIRINGPOS_STAND_AIMING))))
                                {
                                    float fDelayTime = TryToStartAiming();
                                    CallMethodOnceIn(METHOD_TryToStartFiring, fDelayTime);
                                }
                                
                            }
                        }
                    }
                }
            }
            else
            {
                if (m_cActiveEnemy != null)
                {
                    Vector vTargetPos = m_cActiveEnemy.GetPointToLookAt(0);
                    if (vTargetPos != null)
                    {
                        if (!SharpAngleToShoot(vTargetPos))
                        {
                            FireDone();
                            TryToStopAiming();
                        }
                        else
                        {
                            if (!AICheckTraceAbsoluteVehicleCheck(m_cActiveEnemy,
                                                                  vTargetPos,
                                                                  m_MeshAI.GetFireOrigin()))
                            {
                                FireDone(); // nie widac wroga
                                TryToStopAiming();
                            }
                        }
                    }
                }
            }
        }
        else if (GetActiveWeapon() != null)
            GetActiveWeapon().StopFire();
    }
    
    public void TryToStartFiring()
    {
        if (ActiveEnemyVisibleFromGun())
            Fire();
    }
    
    public void Fire()
    {
        ComputeAccuracy(); // przeliczenie celnosci, bo teraz zalezy od odleglosci i widocznosci przeciwnika
        switch (ChooseBestFireMode())
        {
        case Weapon._FIREMODE_SINGLE:
            FireSingle();
            break;
        case Weapon._FIREMODE_BURST:
            FireAuto();
            break;
        default:
            // chyba sobie nie postrzela...
            break;
        }
        m_bIsShooting = true;   
    }

    int ChooseBestFireMode()
    {
        int nWeaponFireModes = GetActiveWeapon().nAIFireModes;
        
        // jesli jest tryb burst
        if ((nWeaponFireModes & Weapon._FIREMODE_BURST) != 0)
        {
            // jesli nie ma trybu single albo przeciwnik jest blisko to burst
            if ((nWeaponFireModes & Weapon._FIREMODE_SINGLE) == 0 ||
                GetActiveEnemyDistance2() < m_fMaxBurstFireDistance2)
            {
                return Weapon._FIREMODE_BURST;
            }
        }
        
        // jesli jest tryb single
        if ((nWeaponFireModes & Weapon._FIREMODE_SINGLE) != 0)
            return Weapon._FIREMODE_SINGLE;
        else
            return Weapon._FIREMODE_NONE;
    }
    
    
    /** Wystrzelenie jednego pocisku */
    void FireSingle()
    {
        m_bFireModeSingle = true;
        ((NewAIHuman)m_MeshAI).StartFiring();
        FireBullets(m_nMinBulletsToFire +
                    (int)(RandomFloat(m_nMaxBulletsToFire - m_nMinBulletsToFire) *
                              (1 - CalcActiveEnemyDistCoef(m_fMaxBurstFireDistance2,
                                                           m_fFarTargetDistance2))));
    }
	
	void FireBullets(int nBullets)
	{
        m_nBulletsToFire = nBullets;
        FireOneBullet();
	}
    
    public void FireOneBullet()
    {
        if (m_nBulletsToFire > 0)
        {
            Weapon weapon = GetActiveWeapon();
            if ((weapon.GetState() & Weapon.STATE_NO_AMMO) == 0)
            {
	            m_nBulletsToFire--;

                int nPrevMode = weapon.nCurrentMode;
                weapon.StartFire(Weapon.MODE_SINGLE);
                // jesli zmiana trybu - notyfikacja
                if (nPrevMode != Weapon.MODE_SINGLE)
                    Notify(AIEvents._NOTICE_WEAPON_STATE_CHANGED);

                CallMethodOnceIn(METHOD_FireOneBullet, m_fSingleBulletDelay + RandomFloat(m_fRandomSingleBulletDelay));
            }
            else
                FireDone();
        }
		else
			FireDone();
    }
	
    /** Wystrzelenie serii o losowej dlugosci */
    void FireAuto()
    {
        m_bFireModeSingle = false;

        ((NewAIHuman)m_MeshAI).StartFiring();
        Weapon weapon = GetActiveWeapon();
        if ((weapon.GetState() & Weapon.STATE_NO_AMMO) == 0)
        {
            float fFiringTime = m_fMinBurstFiringTime + 
                                RandomFloat(m_fRandomBurstFiringTime) *
                                (1 - CalcActiveEnemyDistCoef(m_fNearTargetDistance2,
                                                             m_fMaxBurstFireDistance2));
            int nPrevMode = weapon.nCurrentMode;
            weapon.StartFire(Weapon.MODE_AUTO);
            // jesli zmiana trybu - notyfikacja
            if (nPrevMode != Weapon.MODE_AUTO)
                Notify(AIEvents._NOTICE_WEAPON_STATE_CHANGED);

            CallMethodOnceIn(METHOD_FireDone, fFiringTime);
        }
        else
            FireDone();
    }
    
    /** Zakonczenie strzelania, wolane po pojedynczym strzale lub po uplywie czasu 
     */
    public void FireDone()
    {
        DisableCallMethod(METHOD_Fire);
        DisableCallMethod(METHOD_FireDone);
        DisableCallMethod(METHOD_FireOneBullet);
        m_nBulletsToFire = 0;
        Weapon weapon = GetActiveWeapon();

        float fFireDelay = 1;
        if (weapon != null)
        {
            switch (weapon.nCurrentMode)
            {
            case Weapon.MODE_SINGLE:
                fFireDelay = m_fMinSingleFireDelay +
                             RandomFloat(m_fRandomSingleFireDelay) * 
                             CalcActiveEnemyDistCoef(m_fNearTargetDistance2,
                                                     m_fFarTargetDistance2);
                break;
            case Weapon.MODE_AUTO:
                fFireDelay = m_fMinBurstFireDelay +
                             RandomFloat(m_fRandomBurstFireDelay) * 
                             CalcActiveEnemyDistCoef(m_fNearTargetDistance2,
                                                     m_fFarTargetDistance2);
                break;
            }

            int nPrevMode = weapon.nCurrentMode;
            weapon.StopFire();
            // jesli strzelal a ma przestac - notyfikacja
            if (nPrevMode != Weapon.MODE_IDLE)
                Notify(AIEvents._NOTICE_WEAPON_STATE_CHANGED);
        }
        else if (IsDead())
            LogR(GetName() + ": Fire done for null weapon in dead AI - possible zombie shooting!\n");
            
        
        m_bIsShooting = false;
        m_fNextShootTime = GetTime() + fFireDelay;
    }
    
    void MessageWeapon(int nState)
    {
        // zgloszenie zdarzenia ze skonczyla sie amunicja oraz nie zgloszone
        // jeszcze zdarzenie
        if ((nState & Weapon.STATE_NO_AMMO) != 0)//  && !GetMesh().m_bAmmoStateKnown)      
        {
            if (GetActiveWeapon() != null)
                Notify(AIEvents._NOTICE_WEAPON_STATE_CHANGED);
            RequestEvent(AIEvents._EV_NO_AMMO);
        }
    }

    
    void TargetHitNotification(ChromeActor victim, int damageType)
    {
        super.TargetHitNotification(victim, damageType);
        if (m_MeshAI.bCanUseRadioCommunication && MathUtils.CanHappen(_ENEMY_HIT_MSG_CHANCE))
            m_MeshAI.SendRadioMessage(RadioCommunicationSystem._RADIO_MSG_ENEMY_HIT);
    }

    public void ReloadWeapon()
    {
        super.ReloadWeapon();
        m_bIsShooting = false;
    }
    
    private static Vector l_SATS_vDir = new Vector();
    private static Vector l_SATS_vWpn = new Vector();
    boolean SharpAngleToShoot(Vector vPointToShoot)
    {
        boolean bIsSharp = false;
        
        l_SATS_vDir.Set(vPointToShoot);
        l_SATS_vDir.Sub(m_MeshAI.GetFireOrigin());
        float fDist = l_SATS_vDir.Len();
        l_SATS_vDir.Mul(1.f / fDist);
        
        float fMaxYDiff = _SHARP_Y_DIFF_TO_SHOOT + 
                          (2.f - _SHARP_Y_DIFF_TO_SHOOT) * Tools.InterpLinear(0, 
                                                                            _MIN_DIST_TO_START_INC_Y_DIFF_ALLOWED, 
                                                                            fDist);
        
        if (GetActiveWeapon() != null)
        {
            GetActiveWeapon().GetForwardVector(l_SATS_vWpn);
            l_SATS_vWpn.Normalize();
            bIsSharp = (MathUtils.dot2D(l_SATS_vWpn, l_SATS_vDir) > _SHARP_ANGLE_TO_SHOOT_COS) &&
                       Math.abs(l_SATS_vWpn.fY - l_SATS_vDir.fY) < fMaxYDiff;
        }
        
        return bIsSharp;
    }
    
    public void ActiveWeaponChanged()
    {
        super.ActiveWeaponChanged();
        Weapon weapon = GetActiveWeapon();
        if (weapon != null)
        {
            m_nReadinessToStartAiming = weapon.nAIReadinessToAim;
            m_nReadinessToStopAiming = weapon.nAIReadinessToStopAiming;

            m_fNearTargetDistance2 = weapon.fAINearTargetDistance * 
                                     weapon.fAINearTargetDistance;
            m_fMaxAimingChanceDistance2 = weapon.fAIMaxAimingChanceDistance * 
                                          weapon.fAIMaxAimingChanceDistance;
            m_fFarTargetDistance2 = weapon.fAIFarTargetDistance * 
                                    weapon.fAIFarTargetDistance;

            m_fMaxBurstFireDistance2 = (float)Math.min(weapon.fAIMaxBurstDistance * 
                                                       weapon.fAIMaxBurstDistance,
                                                       m_fFarTargetDistance2);

            m_nMinBulletsToFire = (int)Math.max(1, weapon.nAIMinSingleFireBullets * m_MeshAI.mod_fFiringTimeMult);
            m_nMaxBulletsToFire = (int)Math.max(m_nMinBulletsToFire, weapon.nAIMaxSingleFireBullets * m_MeshAI.mod_fFiringTimeMult);
            
            m_fMinBurstFiringTime = weapon.fAIBurstTime * m_MeshAI.mod_fFiringTimeMult;
            m_fRandomBurstFiringTime = weapon.fAIRandomBurstTime * m_MeshAI.mod_fFiringTimeMult;
            
            m_fMinSingleFireDelay = weapon.fAISingleFireDelay * m_MeshAI.mod_fFireDelayMult;
            m_fRandomSingleFireDelay = weapon.fAIRandomSingleFireDelay * m_MeshAI.mod_fFireDelayMult;
            
			m_fSingleBulletDelay = weapon.fAISingleBulletDelay;
			m_fRandomSingleBulletDelay = weapon.fAIRandomSingleBulletDelay;

			m_fSingleFireAccAdd = weapon.fAISingleFireAccAdd;
            m_fAimingAccAdd = weapon.fAIAimingAccAdd;
			
            m_fMinBurstFireDelay = weapon.fAIBurstFireDelay * m_MeshAI.mod_fFireDelayMult;
            m_fRandomBurstFireDelay = weapon.fAIRandomBurstFireDelay * m_MeshAI.mod_fFireDelayMult;
            
            m_fWeaponEffectiveRange2 = weapon.fAIEffectiveRange *
                                       weapon.fAIEffectiveRange;
            
            m_fMinDesiredHitRatio = MathUtils.crop(weapon.fAIMinDesiredHitRatio *
                                                   m_MeshAI.mod_fMinHitRatioMult / 100, 0, 1);
            m_fMaxDesiredHitRatio = MathUtils.crop(weapon.fAIMaxDesiredHitRatio *
                                                   m_MeshAI.mod_fMaxHitRatioMult / 100, m_fMinDesiredHitRatio, 1);
        }

    }
    

    public void ComputeAccuracy()
    {
        Weapon weapon = GetActiveWeapon();
        NewAIHuman mesh = (NewAIHuman)GetMesh();
        if (weapon != null)
        {
            ChromeActor enemy = GetActiveEnemy();
            if (enemy != null)
            {
                m_fCurrAccuracy = 1 - Tools.InterpLinear(weapon.fAINearTargetDistance, weapon.fAIEffectiveRange,
                                                         mesh.GetDistanceTo(enemy));
                m_fCurrAccuracy += m_fTargetShootVisibilityFactorImportance * (enemy.GetShootVisibilityFactor(mesh) - 1);
            }
            else
                m_fCurrAccuracy = 0;
            
            
            AIMotionState motion = mesh.m_ActualMotion;
            
            //motion
            if (motion.GetSpeed() == MotionState.SPEED_CRAWL ||
                motion.GetSpeed() == MotionState.SPEED_DUCK)
            {
                m_fCurrAccuracy += m_fDuckCrawlAccAdd;
            }
            if (motion.IsMoving())
                m_fCurrAccuracy += m_fMoveAccAdd; 

            //aiming
            if (motion.bAiming)
                m_fCurrAccuracy += m_fAimingAccAdd;

            if (m_bFireModeSingle)
                m_fCurrAccuracy += m_fSingleFireAccAdd;
            
            m_fCurrAccuracy *= mesh.fOverallAIAccMult * mesh.mod_fAccuracyMult;
            if (enemy != null)
                m_fCurrAccuracy *= enemy.GetHitChanceMult(mesh);

//            Tools.ShowInfoTop("Accuracy: " + m_fCurrAccuracy, GetModule());

            //clamp to 0-1
            if (m_fCurrAccuracy > 1.0f) m_fCurrAccuracy = 1.0f;
            else if (m_fCurrAccuracy < 0.0f) m_fCurrAccuracy = 0.0f;

            mesh.m_fDesiredHitRatio = (m_fMinDesiredHitRatio +
                                       m_fCurrAccuracy *
                                       (m_fMaxDesiredHitRatio - m_fMinDesiredHitRatio));
        }
        else
        {
            m_fCurrAccuracy = 0;
            mesh.m_fDesiredHitRatio = 0;
        }
    }

    /////////////////////////////////////////////////////////////////////

    /** Przelicznie warunkow sprawdzanych przez generatory
     */
    void RecalcState()
    {
        super.RecalcState();
        // przelicz dostepne pozycje z jakich ai moze strzelac
        RecalcValidFiringPositions();
    }
    
    // odleglosc na jaka trace'uje ai sprawdzajac jaka ma miec pozycje przy strzelaniu
    public final static float _NEARBY_OBSTACLE_DISTANCE = 500.f; 
    int m_nValidFiringPositions;


    public int GetValidFiringPositions()
    {
        return m_nValidFiringPositions;
    }

    public boolean IsValidFiringPosition(int nFiringPos)
    {
        return (m_nValidFiringPositions & nFiringPos) != 0;
    }
    
    /** Przeliczenie dostepnych pozycji strzeleckich
     */
    void RecalcValidFiringPositions()
    {
        m_nValidFiringPositions = 0;
        if (m_cActiveEnemy != null)
        {
            if (m_nReadinessToStartAiming > 0) // moze przycelowac
            {
                if (CheckTraceFromBarrelPosToActiveEnemy(MotionState.SPEED_WALK, true))
                    m_nValidFiringPositions |= _FIRINGPOS_STAND_AIMING;
                if (CheckTraceFromBarrelPosToActiveEnemy(MotionState.SPEED_DUCK, true))
                    m_nValidFiringPositions |= _FIRINGPOS_DUCK_AIMING;
            }
            if (m_nReadinessToStartAiming < 100) // nie musi przycelowac
            {
                if (CheckTraceFromBarrelPosToActiveEnemy(MotionState.SPEED_WALK, false))
                    m_nValidFiringPositions |= _FIRINGPOS_STAND;
                if (CheckTraceFromBarrelPosToActiveEnemy(MotionState.SPEED_DUCK, false))
                    m_nValidFiringPositions |= _FIRINGPOS_DUCK;
            }
        }
    }

    /** Sprawdzenie krotkiego trace'a od pozycji guna dla danego motion state'a do wroga
     *  (do szukania poprawnych pozycji strzeleckich)
     */
    boolean CheckTraceFromBarrelPosToActiveEnemy(byte iSpeed, boolean bAim)
    {
        Vector vEnd = m_cActiveEnemy.GetPointToLookAt(0);
        Collision coll = ShortTraceForCollision(m_MeshAI.GetBarrelPos(iSpeed, bAim), 
                                                vEnd,
                                                _NEARBY_OBSTACLE_DISTANCE,
                                                m_MeshAI);
        return (coll == null || coll.Obstacle == m_cActiveEnemy);
    }
    
    
    /** Puszczenie trace'a o dlugosci fTraceLenFromStart od vStart do vEnd z pominieciem obiektu cExclude
     *  UWAGA: vEnd jest modyfikowany nawet, gdy nie wystapi kolizja...
     */
    private static Vector m_vSTFC_Dir = new Vector();
    Collision ShortTraceForCollision(Vector vStart, Vector vEnd, float fTraceLenFromStart, ControlObject cExclude)
    {
        m_vSTFC_Dir.Set(vEnd);
        m_vSTFC_Dir.Sub(vStart);
        float len = m_vSTFC_Dir.Len();
        if (len < 1e-06)
            return null;
        
        m_vSTFC_Dir.Mul(fTraceLenFromStart / len);
        m_vSTFC_Dir.Add(vStart);
        vEnd.Set(m_vSTFC_Dir);

        m_aTraceExcludeObjects[0] = cExclude;
        m_aTraceExcludeObjects[1] = null;
        return m_MeshAI.AITrace(vStart, vEnd, NewAI._AITRACE_IGNORE_GLASS, m_aTraceExcludeObjects);
    }

    
    /** rzucenie granata do punktu vDest z maksymalna wysokoscia fMaxHeight 
     *  @param cGrenade granat, ktorym nalezy rzucic
     *  @parma vStart pozycja, z ktorej zaczyna lot granat
     *  @parma vDest docelowa pozycja lotu granata
     *  @param fMaxHeight maksymalna wyskosc, na jaka poleci granat
     */
    public void ThrowGrenade(Grenade cGrenade, Vector vStart, Vector vDest, float fMaxHeight)
    {
        m_fLastGrenadeThrow = GetTime();
        
        cGrenade.SetPosition(vStart);
        
        float fHeightDiff = vDest.fY - vStart.fY;
        
        Vector vTemp = new Vector(vDest);
        vTemp.Sub(vStart);
        vTemp.fY = 0;
        float fDist = vTemp.Len(); // odleglosc, jaka przebedzie granat w poziomie

        float fMaxHeightTime = (float) Math.sqrt(2f * fMaxHeight / (10f * cGrenade.GetMass()));
        float fDiffTime = 0f;
        float fAllTime = 0f;
        
        if (fHeightDiff >= 0)
        {
            fDiffTime = (float) Math.sqrt(2f * Math.abs(fHeightDiff) / (10f * cGrenade.GetMass()));
            fAllTime = 2 * fMaxHeightTime - fDiffTime;
        }
        else
        {
            fDiffTime = (float) Math.sqrt(2f * (fMaxHeight - fHeightDiff) / (10f * cGrenade.GetMass()));
            fAllTime = fMaxHeightTime + fDiffTime;
        }
                
        float fSpeedX = fDist / fAllTime;
        float fSpeedY = 10f * cGrenade.GetMass() * fMaxHeightTime;
                
        // skladowe predkosci
        vTemp.Normalize();
        vTemp.Mul(fSpeedX);
        vTemp.fY += fSpeedY;
        float fForce = vTemp.Len() / 100f;
        vTemp.Normalize();
        cGrenade.Start(fForce, vTemp);
        
        if (Grenades() > 0)
            GetMesh().m_nGrenadesLeft--;
    }
    
    
    protected class TrajectoryInfo
    {
        /* wysokosc na jakiej wystapila kolizja (ew. wysokosc zadana, jesli kolizja nie 
         * wystapila podczas wznoszenia */
        public float fMaxHeight;
        /** Punkt, w ktorym zakonczyla sie trajektoria */
        public Vector vEndPoint;
        /** Znacznik, ze trajektoria ma zbyt plaski przebieg (zbyt niski rzut) */
        public boolean bToLow;
    }
    
    public final static float _COS_1_PI_BY_4 = (float)Math.cos(Math.PI * 0.25f);
    private TrajectoryInfo m_cCGTRet = new TrajectoryInfo();
    private Vector m_vCGTMiddle = new Vector();
    private Vector m_vCGTEnd = new Vector();
    private Vector m_vCGTDir = new Vector();
    /** Sprawdza, przy uzyciu dwoch trace'ow ("/\") czy na bardzo przyblizonej 
     *  trajektorii lotu granata do podanego celu nie ma przeszkod
     * @param vStart - poczatek trajektorii
     * @param vDest - koniec trajektorii
     * @param fMaxHeight - maksymalna wysokosc na jaka ma wzniesc sie granat
     * @return TrajectoryInfo z danymi o wyniku sprawdzania trajektorii
     */
    public TrajectoryInfo CheckGrenadeTrajectory(Vector vStart, Vector vDest, float fMaxHeight)
    {
        m_cCGTRet.fMaxHeight = fMaxHeight;
        m_cCGTRet.bToLow = false;
        
        m_vCGTMiddle.Set(vDest);
        m_vCGTMiddle.Sub(vStart);
        m_vCGTMiddle.Mul(0.5f);
        m_vCGTMiddle.Add(vStart);
        m_vCGTMiddle.fY = vStart.fY + fMaxHeight;
        m_vCGTEnd.Set(vDest);

        Collision col = GetMesh().TraceForCollision(vStart, m_vCGTMiddle, GetMesh());
        if (col != null) // jesli kolizja na wznoszacej sie czesci trajektorii
        {
            m_cCGTRet.vEndPoint = m_vCGTMiddle;
            // sprawdz normalna, zeby okreslic, czy przeszkoda do ominiecia gora (skrzynka)
            // czy dolem (sufit)
            Vector vNormal = col.vNormal;
            vNormal.Normalize();
            if (vNormal.Dot(Vector.Down) > _COS_1_PI_BY_4) 
            {
                // raczej sufit
               m_cCGTRet.fMaxHeight = m_vCGTMiddle.fY - vStart.fY;
            }
            else
            {
                //raczej skrzynka
                m_cCGTRet.bToLow = true;
            }
        }
        else
        {
            col = GetMesh().TraceForCollision(m_vCGTMiddle, m_vCGTEnd, GetMesh());
            m_cCGTRet.vEndPoint = m_vCGTEnd;
        }
        return m_cCGTRet;
    }
    
    
    
    public float GetLastCheckedGrenadeTrajectoryHeight()
    {
        return m_fLastCheckedGrenadeTrajectoryHeight;
    }
    
    protected Vector m_vLastGrenadeTargetPos = new Vector();
    protected float m_fLastGrenadeTargetPosTime = -1;
    protected boolean m_bLastGrenadeTargetPosChangedResult = false;
    
    protected boolean GrenadeTargetPosChanged(ChromeActor cTarget, float fTime)
    {
        if (TimePassed(m_fLastGrenadeTargetPosTime, _GRENADE_TARGET_STILL_TIME, fTime))
        {
            boolean bPositionChanged = false;
            if (m_fLastGrenadeTargetPosTime > 0)
            {
                if (cTarget.GetDistance2To(m_vLastGrenadeTargetPos) > _GRENADE_TARGET_POS_TOLERANCE * 
                                                                  _GRENADE_TARGET_POS_TOLERANCE)
                {
                    bPositionChanged = true; 
                }
            }
            else 
                bPositionChanged = true;
            
            m_fLastGrenadeTargetPosTime = fTime;
            cTarget.GetPosition(m_vLastGrenadeTargetPos);
            m_bLastGrenadeTargetPosChangedResult = bPositionChanged;
        }
        return m_bLastGrenadeTargetPosChangedResult;
    }
    
    
    public boolean CanThrowGrenade()
	{
        ChromeActor cTarget = GetActiveEnemy();
        if (cTarget == null || 
            !cTarget.IsActiveOnModule())
        {
            m_fLastGrenadeTargetPosTime = -1;
            return false;
        }
        float fTime = GetTime();
        
        if (GrenadeTargetPosChanged(cTarget, fTime))
            return false;
        
        // czy uplynal odpowiednio duzy czas od ostatniego rzutu?
        if (TimePassed(m_fLastGrenadeThrow, _MIN_TIME_BTW_GRENADES_THROW, fTime))
        {
            // sprawdz, czy cel w odpowiedniej odleglosci
            float fDist = GetMesh().GetDistanceTo(cTarget);
            if ( (fDist > _MIN_DIST_TO_THROW_GRENADE) &&
                 (fDist < _MAX_DIST_TO_THROW_GRENADE) )
            {
                // sprawdz, czy widzisz cel
                if (ActiveEnemyCanBeTraced())
                {
                    // widzi - rzuc z prawdopodoienstwem dla widocznego
                    if (!MathUtils.CanHappen(((NewAIHuman)GetMesh()).fGrenadeChanceWhenEnemyVisible))
                        return false;
                }
                else
                {
                    // nie widzi - sprawdz, czy ostatnio widzial
                    EnemyInfo enemyInfo = (EnemyInfo)m_aEnemies.get(cTarget);
                    if ( enemyInfo == null || // cos nie tak z przeciwnikiem
                         TimePassed(enemyInfo.m_fLastTraceVisibilityTime, // uplynal za dlugi czas
                                    _TIME_TO_CALM_DOWN_AFTER_ENEMY_LOST, 
                                    fTime) ||
                         !MathUtils.CanHappen(((NewAIHuman)GetMesh()).fGrenadeChanceWhenEnemyNotVisible) ) // rzuc z prawdopodobienstwem dla niewidocznego
                    {
                        return false;
                    }
                }
                
                
                // sprawdz, czy za czesto nie jest sprawdzana trajektoria, jesli tak - zwroc poprzednia wartosc
                if (TimePassed(m_fLastGrenadeCheck, _MIN_TIME_BTW_GRENADES_CHECK, fTime))
                {
                    m_fLastGrenadeCheck = fTime;
                    
                    float fHeight = fDist * _DEF_GRENAGE_TRAJECTORY_TAN;
                    if (fHeight > _MAX_GRENADE_TRAJECTORY_HEIGHT)
                        fHeight = _MAX_GRENADE_TRAJECTORY_HEIGHT;
                    Vector vStartPos = GetMesh().GetPosition();
                    vStartPos.fY += 150.f; //przesun troche wyzej
                    Vector vEndPos = cTarget.GetPosition();

                    // sprawdz trajektorie z zadana wysokoscia
                    TrajectoryInfo info = CheckGrenadeTrajectory(vStartPos, vEndPos, fHeight);
                    
                    if (info.bToLow) // rzut zbyt niski - sprobuj wysoko
                        info = CheckGrenadeTrajectory(vStartPos, vEndPos, _MAX_GRENADE_TRAJECTORY_END_DISTANCE);
                    else if (info.fMaxHeight < fHeight) // za wysoko - sprawdz nizej
                        info = CheckGrenadeTrajectory(vStartPos, vEndPos, info.fMaxHeight - 50.f);

                    if (info.vEndPoint.Distance(vEndPos) < _MAX_GRENADE_TRAJECTORY_END_DISTANCE)
                    {
                        m_fLastCheckedGrenadeTrajectoryHeight = info.fMaxHeight;
                        m_bLastGrenadeTrajectoryCheckResult = true;
                    }
                    else
                        m_bLastGrenadeTrajectoryCheckResult = false;
                }
                return m_bLastGrenadeTrajectoryCheckResult;
            }
        }
        return false;
	}
	
    /** czy w poblizu jest jakas wolna kryjowka */
    public ChromeActor HideoutsNear()
    {
        if ( (m_CurrentHideout != null) &&
             (m_CurrentHideout.GetDistanceTo(GetMesh()) < _SHORT_HIDEOUT_DIST) )
            return m_CurrentHideout;
        else
            return null;
    }
    
    /** czy jestem schowany za biezacym chowaczem przed biezacym wrogiem */
    public boolean IsBehindHideout()
    {
        UpdateCurrHideout();
        if ( (GetDestHideoutPos() != null) && 
             (m_CurrentHideout.cHideoutInvader == GetMesh()) )
            return true;
        return false;
    }

    /** czy jestem za chowaczem i czy jestem za nim schowany */
    public boolean IsHidingBehindHideout()
    {
        return (IsBehindHideout() &&
                ((GetMotionState().GetSpeed() == MotionState.SPEED_CRAWL) ||
                 (GetMotionState().GetSpeed() == MotionState.SPEED_DUCK)));
    }
    
    /** czy moge strzelac znad biezacego chowacza */
    public boolean CanAttackFromCurrentHideout()
    {
        if (!IsBehindHideout())
            return false;
        if (GetActiveEnemy() == null)
            return false;
        if (m_LastTrackedHideout == m_CurrentHideout)
            return m_bCanAttackFromCurrHideout;
        else
        {
            m_LastTrackedHideout = m_CurrentHideout;

            m_bCanAttackFromCurrHideout = (AICheckTraceAbsoluteVehicleCheck(GetActiveEnemy(),
                                                                            GetActiveEnemy().GetPointToLookAt(0),
                                                                            m_MeshAI.GetBarrelPos(MotionState.SPEED_WALK, (m_nReadinessToStartAiming > 0))) &&
                                           !AICheckTraceAbsoluteVehicleCheck(GetActiveEnemy(),
                                                                             GetActiveEnemy().GetPointToLookAt(0),
                                                                             m_MeshAI.GetTopmostPoint(MotionState.SPEED_DUCK, false)));

            return m_bCanAttackFromCurrHideout;
        }
    }
    
    public Vector GetDestHideoutPos()
    {
        CalcDestHideoutPos();
        CalcCanHitActiveEnemyFromHideout();
        
        return m_vCurrHideout;
    }
    
    protected void CalcDestHideoutPos()
    {
        if (m_CurrentHideout == null)
        {
            m_vCurrHideout = null;
            return;
        }
        float fTime = GetTime();
        if ((GetActiveEnemy() == null) &&
            ((m_vLastHeardRicochetMakerPos == null) ||
             TimePassed(m_fLastHeardRicochetTime, _TIME_AFTER_RICOCHET_TO_GO_TO_HIDEOUT, fTime)))
        {
            m_vCurrHideout = null;
            return;
        }
        if (!TimePassed(m_fHideoutPosCalcTime, _MIN_TIME_BTW_HIDEOUT_POS_CALC, fTime))
            return;
        m_fHideoutPosCalcTime = fTime;

        // obliczamy ekstenty obieku w swiecie (2d)
        Vector vTmp [] = { new Vector(), new Vector(), new Vector(), new Vector() };
        m_CurrentHideout.GetMeshExtents(vTmp[0], vTmp[1]);
        vTmp[2].Set(vTmp[0]);
        vTmp[2].fZ = vTmp[1].fZ;
        vTmp[3].Set(vTmp[0]);
        vTmp[3].fX = vTmp[1].fX;
        for (int i = 0; i < vTmp.length; i++)
        {
            vTmp[i] = m_CurrentHideout.PointLocalToWorld(vTmp[i]);
            vTmp[i].fY = 0;
        }
        // obliczamy srodek kryjowki
        Vector vHideoutCenter = new Vector(vTmp[1]);
        vHideoutCenter.Sub(vTmp[0]);
        float fTmp = vHideoutCenter.Len() / 2f;
        vHideoutCenter.Normalize();
        vHideoutCenter.Mul(fTmp);
        vHideoutCenter.Add(vTmp[0]);
        
        Vector vEnemyPos = null;
        if (GetActiveEnemy() != null)
            vEnemyPos = GetActiveEnemy().GetPositionVectorVolatile();
        else
	        vEnemyPos = m_vLastHeardRicochetMakerPos;
		
		if (vEnemyPos == null)
			CrashLog("ERROR: AI nie ma ani przeciwnika ani nie slyszalo rykoszetu\n");

        Vector vHideoutToEnemyDir = new Vector(vEnemyPos);
        vHideoutToEnemyDir.Sub(vHideoutCenter);
        float fMaxDist = vHideoutToEnemyDir.Len();
        vHideoutToEnemyDir.Normalize();

        int iFarNdx = 0;
        for (int i = 0; i < vTmp.length; i++)
        {
            vTmp[i] = MathUtils.ProjVector(vHideoutCenter, vTmp[i], vHideoutToEnemyDir);
            fTmp = vTmp[i].Distance(vEnemyPos);
            if (fMaxDist < fTmp)
            {
                fMaxDist = fTmp;
                iFarNdx = i;
            }
        }
        vHideoutToEnemyDir.Negate();
        vHideoutToEnemyDir.Mul(_HIDEOUT_HIDE_DIST);
        m_vCurrHideout = new Vector(vTmp[iFarNdx]);
        m_vCurrHideout.Add(vHideoutToEnemyDir);
        
        Vector vTraceStart = new Vector(m_vCurrHideout), 
            vTraceEnd = new Vector(m_vCurrHideout);
        vTraceStart.fY = m_CurrentHideout.GetPositionVectorVolatile().fY + 150;
        vTraceEnd.fY = vTraceStart.fY - 300;

        m_aTraceExcludeObjects[0] = m_MeshAI;
        m_aTraceExcludeObjects[1] = null;
        
        m_MeshAI.AITrace(vTraceStart, vTraceEnd,
                         NewAI._AITRACE_IGNORE_GLASS,
                         m_aTraceExcludeObjects);
        
        m_vCurrHideout.fY = vTraceEnd.fY;
        
        // uff, mamy wreszcie pozycje, gdzie sie mozemy schowac za hideoutem,
        // sprawdzamy, czy mozna tam dojsc
        if (GetMesh().IsUpdatingPathMap())
        { 
            GetMesh().UpdatePathMap(false);
            if (!GetMesh().CanStandAtPos(m_vCurrHideout))
                m_vCurrHideout = null;
            GetMesh().UpdatePathMap(true);
        }
    }
    
    void CalcCanHitActiveEnemyFromHideout()
    {
        if (m_vCurrHideout == null || 
            GetActiveEnemy() == null)
        {
            m_bCanHitActiveEnemyFromHideout = false;
            return;
        }
        
        float fTime = GetTime();
        if (!TimePassed(m_fHideoutHitCalcTime, _MIN_TIME_BTW_HIDEOUT_HIT_CALC, fTime))
            return;
        m_fHideoutHitCalcTime = fTime;

        Vector vTemp = new Vector(m_vCurrHideout);
        vTemp.fY += GetMesh().GetBarrelHeightOverGround(MotionState.SPEED_WALK, (m_nReadinessToStartAiming > 0));

        m_aTraceExcludeObjects[0] = GetActiveEnemy();
        m_aTraceExcludeObjects[1] = m_MeshAI;
        m_bCanHitActiveEnemyFromHideout = AICheckTraceAbsoluteVehicleCheck(GetActiveEnemy(),
                                                                           vTemp,
                                                                           GetActiveEnemy().GetPointToLookAt(0));
    }
    
    public boolean CanHitActiveEnemyFromHideout()
    {
        return m_bCanHitActiveEnemyFromHideout;
    }
	
    void RecalculateHideouts()
    {
        m_CurrentHideout = null;
        float fMinDist = 10000000f;
        ChromeActor actor = null;
        for (int i = 0; i < m_aHideouts.size(); i++)
        {
            actor = (ChromeActor) m_aHideouts.get(i);
            if ( (actor.cHideoutInvader == null) ||
                 (actor.cHideoutInvader == GetMesh()) )
            {
                float fDistance = GetMesh().GetDistanceTo(actor);
                if (fDistance < fMinDist)
                {
                    fMinDist = fDistance;
                    m_CurrentHideout = actor;
                }
            }
        }
    }
    
    public void UpdateCurrHideout()
    {
        if (m_CurrentHideout == null)
            return;
        Vector vDestHideoutPos = GetDestHideoutPos();
        if (vDestHideoutPos == null)
            return;
        if (m_CurrentHideout.cHideoutInvader == null)
        {
            if (GetMesh().GetPosition().Distance(vDestHideoutPos) <= _BEHIND_HIDEOUT_FREEDOM)
                m_CurrentHideout.cHideoutInvader = GetMesh();
        }
        else
        {
            if (m_CurrentHideout.cHideoutInvader == GetMesh())
            {
                if (GetMesh().GetDistanceTo(vDestHideoutPos) > _BEHIND_HIDEOUT_FREEDOM)
                    m_CurrentHideout.cHideoutInvader = null;
            }
        }
    }
	
	/** czy AI jest w samochodzie */
	boolean InsideVehicle()
	{
		return m_bSitsInVehicle;
	}
	
    public boolean InsideCannon()
    {
        return m_bSitsInCannon;
    }
    
    void SetInCannon(boolean bInCannon)
    {
        m_bSitsInCannon = bInCannon;
    }
    
	void SetObjectToDrive(IDrivenVehicle cObjectToDrive)
	{
		m_DrivenVehicle = cObjectToDrive;
	}
	
	IDrivenVehicle GetDrivenVehicle()
	{
		return m_DrivenVehicle;
	}
	
	/** rozkaz patrolowania dla pojazdu */
	void Drive()
	{
		if (GetDrivenVehicle() != null)
			GetDrivenVehicle().EditorPatrol(GetCurrWaypoint(), m_MeshAI);
		else
			CrashLog("AIController.Drive(): GetDrivenVehicle() == null\n");
	}

	public void Checkpoint()
	{
        if (IsDead())
            return;
        
		// dojechalismy pojazdem do waypointa, probujemy wykonac nastepna akcje
		if (GetDrivenVehicle() != null)
			GetDrivenVehicle().PatrolBreak(); // tylko sie zatrzymujemy, byc moze wznowimy jazde
		Notify(AIEvents._NOTICE_VEHICLE_REACHED_WAYPOINT); // informujemy o dojechaniu
	}
	
	public void MovingEnd()
	{
		if (GetDrivenVehicle() != null)
		{
			GetDrivenVehicle().PatrolResume(); // doprowadzenie do stanu poczatkowego
			GetDrivenVehicle().FinishDrive();
		}
		else
			CrashLog("AIController.DriverMovingEnd(): GetDrivenVehicle() == null\n");
        
		Notify(AIEvents._NOTICE_WAIT_FOR_EXTERNAL_NOTICE); // wysiadamy - tutaj bedzie przegenerowanie scenariuszy
	}
	
	void SetObjectToGetIn(ISeatVehicle cObjectToGetIn, EnumGetInType cGetInAs)
	{
		if (cObjectToGetIn == null)
		{
			GetMesh().cSeatInfo = null;
			return;
		}
		
		GetMesh().cSeatInfo = cObjectToGetIn.GetFirstFreeSeat(cGetInAs.GetValue());
		if (GetMesh().cSeatInfo == null)
		{
			CrashLog("AIController.SetObjectToGetIn(): no seat to getIn\n");
			return;
		}
		else
			GetMesh().cSeatInfo.Reserve(GetMesh());
	}
	
	SeatInfo GetSeat()
	{
		return GetMesh().cSeatInfo;
	}
	
	/** ustawienie, ze AI wsiadl do samochodu */
	public void GotIn()
	{
		m_bSitsInVehicle = true;
		
		if ( (GetMesh().cSeatInfo != null) &&
			 (GetMesh().cSeatInfo.GetOccupiedObject() instanceof ISeatVehicle) )
		{
			ISeatVehicle vehicle = (ISeatVehicle) GetMesh().cSeatInfo.GetOccupiedObject();
			vehicle.PawnGotIn(GetMesh().cSeatInfo, GetMesh());
            
            if (GetActiveWeapon() != null)
                GetActiveWeapon().EnableRendering(false);

            // Wylaczenie fizyki - inaczej trudno jest zatrzymac nakierowywanie obiektu na kierunek
            GetMesh().SetPhysicsActive(false);
            GetMesh().m_bHitReactionDisabled = true;
		}
		else
			CrashLog("Error in AIController: GotIn()\n");
	}
	
	/** ustawienie, ze AI wysiadl do samochodu */
	public void GotOut()
	{
		m_bSitsInVehicle = false;
		
		if ( (GetMesh().cSeatInfo != null) && 
			 (GetMesh().cSeatInfo.GetOccupiedObject() instanceof ISeatVehicle) )
		{
			ISeatVehicle vehicle = (ISeatVehicle) GetMesh().cSeatInfo.GetOccupiedObject();
			vehicle.PawnGotOut(GetMesh().cSeatInfo, GetMesh());
            
            if (GetActiveWeapon() != null)
                GetActiveWeapon().EnableRendering(true);

            // Przywrocenie fizyki po jezdzie
            GetMesh().SetPhysicsActive(true);
            // Wylaczenie nakierowywania po tym, jak pojazd sie zatrzymal
            // konieczne, bo ClearDestinationDir tak na prawde robi SetDestDir(GetForward()) co
            // powoduje obroty gdy pojazd skreca
            GetMesh().ClearDestinationDir();
            GetMesh().SetAngSpeed(0);
            GetMesh().TryToVerticalize();
		}
		else
			CrashLog("Error in AIController: GotOut()\n");
	}
    
    public void VehicleDestroyed(Vector vCollPoint, Vector vNormal)
    {
        super.VehicleDestroyed(vCollPoint, vNormal);
        
        GetMesh().bUsePhysicsToDeathFall = true;
        Physics.Simulate(GetMesh(), vCollPoint, vNormal, 1, EBones._NECK, true);
        
		GetMesh().cSeatInfo.Occupy(null);
		GetMesh().cSeatInfo.Reserve(null);
        GetMesh().cSeatInfo = null;
        
        m_bSitsInVehicleOnSeat = false;
        
        ControlObject newParent = GetMesh().GetParent(); // to powinien byc pojazd
        if (newParent != null)
            newParent = newParent.GetParent(); // a to powinien byc parent pojazdu (dzialka - np. budynek)
        if (newParent == null)
            GetMesh().DetachFromParentAndKeepWorldPos(); // odlaczamy sie od pojazdu
        else
            GetMesh().AttachAsChildToAndKeepWorldPos(newParent);
    }
    
    public final int m_nMaxNearbyTrees = 10;
    public float m_fMaxNearbyTreeDistance = 5000.f;
    
    protected int[] m_aNearbyTrees = new int[m_nMaxNearbyTrees];
    protected int m_nNearbyTrees;
 
    /** Wyciagniecie z grida pobliskich drzew (wyciaga posortowane po odleglosci)
     */
    protected void FindNearbyTrees()
    {
        m_nNearbyTrees = GetNearestTreesInRadius(GetMesh().GetPositionVectorVolatile(),
                                                 m_fMaxNearbyTreeDistance,
                                                 m_aNearbyTrees, m_nMaxNearbyTrees);
LogR("  m_nNearbyTrees = " + m_nNearbyTrees + "\n");      
    }

    /** Pobranie indeksu nastepnego w tablicy m_aNearbyTrees drzewa w podanym kierunku.
     * @param nStartIndex indeks, od ktorego ma byc rozpoczete przeszukiwanie
     * @param vDir kierunek, w ktorym ma byc drzewo (jesli null - dowolny)
     * @return indeks szukanego drzewa lub -1 jesli nie znalazl
     */
    private Vector m_vGNNTI_TreeDir = new Vector();
    protected int GetNextNearbyTreeIndex(int nStartIndex, Vector vSearchDir)
    {
        int iNdx = nStartIndex;
        while (iNdx < m_nNearbyTrees)
        {
            GetTreePos(m_aNearbyTrees[iNdx], m_vGNNTI_TreeDir);
            m_vGNNTI_TreeDir.Sub(GetMesh().GetPositionVectorVolatile());
            if (vSearchDir == null || vSearchDir.Dot(m_vGNNTI_TreeDir) > 0)
                return iNdx;
            iNdx++;
        }
        return -1;
    }
    
    java.util.LinkedList aTracesList = new java.util.LinkedList();
    
    private void ShowTrace(Vector vFrom, Vector vTo, String sType)
    {
        LaserPointer lazer = Tools.CreateLaserPointer(GetModule(), sType);
        lazer.PointFromTo(vFrom, vTo);
        aTracesList.add(lazer);
    }
    
    private void RemoveAllTraces()
    {
        while (aTracesList.size() > 0)
        {
            LaserPointer lazer = (LaserPointer)aTracesList.removeFirst();
            lazer.delete();
        }
    }
    
    public float _MIN_STATIC_HIDEOUT_DIST = 200.f;
    
    protected boolean CalcTreeHideoutData(int nTree, Vector vTarget)
    {
        RemoveAllTraces();
        Vector[] aExtents = new Vector[] { new Vector(), new Vector(), 
                               new Vector(), new Vector() };
        GetTreeExtents(nTree, aExtents[0], aExtents[1]);
        aExtents[1].fY = aExtents[0].fY;
        aExtents[2].Set(aExtents[0]);
        aExtents[2].fZ = aExtents[1].fZ;
        aExtents[3].Set(aExtents[0]);
        aExtents[3].fX = aExtents[1].fX;

        Vector vMid = new Vector();
        vMid.Set(aExtents[0]);
        vMid.Add(aExtents[1]);
        vMid.Mul(0.5f);
        
        for (int i = 0; i < 4; i++)
        {
            MeshObject c1 = Tools.AddHelperMesh(GetMesh(), Tools._HM_MESH_FLAG);
            c1.SetPositionWorld(aExtents[i]);            
        }

        MeshObject c1 = Tools.AddHelperMesh(GetMesh(), Tools._HM_MESH_FLAG);
        c1.SetPositionWorld(vMid);            
        
        
        // znajdz punkt najdalej polozony od celu
        float fMaxDist = MathUtils.dist2D2(aExtents[0], vTarget);
        float fDist;
        for (int i = 1; i < 4; i++)
        {
            fDist = MathUtils.dist2D2(aExtents[i], vTarget);
            if (fDist > fMaxDist)
                fMaxDist = fDist;
        }
        fMaxDist = (float)Math.sqrt(fMaxDist);
LogR("fMaxDist = " + fMaxDist + "\n");
        
        // do tej odleglosci dodaj jeszcze troche zapasu
        float fStartDist = fMaxDist + _MIN_STATIC_HIDEOUT_DIST;
LogR("fStartDist 1 = " + fStartDist + "\n");     
        // teraz oblicz pozycje startowa
        Vector vFromTgtDir = new Vector();
        vFromTgtDir.Set(vMid);
        vFromTgtDir.Sub(vTarget);
        vFromTgtDir.Normalize();
        Vector vStartPos = new Vector();
        vStartPos.Set(vFromTgtDir);
        vStartPos.Mul(fStartDist);
        vStartPos.Add(vTarget);
        // wektor konca trace'a
        Vector vTraceEnd = new Vector();
        vTraceEnd.Set(vMid);
        // ustaw wysokosci traceowania
        float fDuckHeadHeight = 70.f + TerrainHeight(vStartPos.fX, vStartPos.fZ);
        vStartPos.fY = fDuckHeadHeight;
        vTraceEnd.fY = fDuckHeadHeight;

        GetMesh().SetPositionWorld(vStartPos);//TST
        // sprawdz tracem od pozycji startowej do srodka chowacza
        if (!RaytraceTree(nTree, vStartPos, vTraceEnd, null))
        {
            ShowTrace(vStartPos, vTraceEnd, LaserPointer._BEAM_YELLOW_NDT);
LogR("Odpadl przez 1 RaytraceTree!\n");            
            return false; // nie ma kolizji - zaden chowacz
        }        
        else
            ShowTrace(vStartPos, vTraceEnd, LaserPointer._BEAM_YELLOW_NDT);

        // byla kolizja - dodaj przesuniecie i oblicz nowy punkt startowy
        fStartDist = MathUtils.dist2D(vTarget, vTraceEnd) + _MIN_STATIC_HIDEOUT_DIST;
        vStartPos.Set(vFromTgtDir);
        vStartPos.Mul(fStartDist);
        vStartPos.Add(vTarget);
        
        int nStampSize = GetMesh().m_iPathFinderStampSize;

        vStartPos.fY = 5 + TerrainHeight(vStartPos.fX, vStartPos.fZ);
        GetMesh().SetPositionWorld(vStartPos);//TST
        GetMesh().UpdatePathMap(false);
        
        // sprawdz, czy mozna tam pojsc
        if (!IsPlaceMoveable(vStartPos, nStampSize))
        {
LogR("Odpadl przez 1 pathmap test!\n");            
            return false;
        }
LogR("Pozycja OK!\n");        
        GetMesh().UpdatePathMap(true, nStampSize);
        return true;
    }
    
    void Test()
    {
        FindNearbyTrees();
        CalcTreeHideoutData(m_aNearbyTrees[0], ((ChromeModuleSingle)GetModule()).MainPlayer.GetPosition());
    }
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[AIControllerHuman.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_AICONTROLLER_HUMAN)
        {
			super.SGLoadChunk(cFC);
            
            m_aHideouts.clear();
            int size = cFC.LoadInt();
            for (int i = 0; i < size; i++)
                m_aHideouts.add((ChromeActor)cFC.LoadObjectRef());

            m_CurrentHideout = (ChromeActor)cFC.LoadObjectRef();
            m_vCurrHideout = cFC.LoadVector();
            m_bCanHitActiveEnemyFromHideout = cFC.LoadBool();
            m_fHideoutHitCalcTime = cFC.LoadFloat();
            m_fHideoutPosCalcTime = cFC.LoadFloat();
            m_LastTrackedHideout = (ChromeActor)cFC.LoadObjectRef();
            m_bCanAttackFromCurrHideout = cFC.LoadBool();
            m_nBulletsToFire = cFC.LoadInt();
            m_bFireModeSingle = cFC.LoadBool();
            m_bIsShooting = cFC.LoadBool();
            m_fNextShootTime = cFC.LoadFloat();

            m_DrivenVehicle = (IDrivenVehicle)cFC.LoadObjectRef();
            m_bSitsInVehicle = cFC.LoadBool();
            m_bSitsInCannon = cFC.LoadBool();

            m_vLastGrenadeTargetPos = cFC.LoadVector();
            m_fLastGrenadeTargetPosTime = cFC.LoadFloat();
            m_bLastGrenadeTargetPosChangedResult = cFC.LoadBool();
            m_fLastGrenadeCheck = cFC.LoadFloat();
            m_fLastGrenadeThrow = cFC.LoadFloat();
            m_fLastCheckedGrenadeTrajectoryHeight = cFC.LoadFloat();
            m_bLastGrenadeTrajectoryCheckResult = cFC.LoadBool();
            m_nValidFiringPositions = cFC.LoadInt();

            m_fLastLieDownCheckTime = cFC.LoadFloat();
            m_bLastLieDownCheckResult = cFC.LoadBool();
        }
		
		cFC.delete();
	}
    

    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[AIControllerHuman.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_AICONTROLLER_HUMAN, cFCParent);
		
		super.SGSaveChunk(cFC);

        cFC.SaveInt(m_aHideouts.size());
        for (int i = 0; i < m_aHideouts.size(); i++)
            cFC.SaveObjectRef((ChromeActor)m_aHideouts.get(i));

        cFC.SaveObjectRef(m_CurrentHideout);
        cFC.SaveVector(m_vCurrHideout);
        cFC.SaveBool(m_bCanHitActiveEnemyFromHideout);
        cFC.SaveFloat(m_fHideoutHitCalcTime);
        cFC.SaveFloat(m_fHideoutPosCalcTime);
        cFC.SaveObjectRef(m_LastTrackedHideout);
        cFC.SaveBool(m_bCanAttackFromCurrHideout);
        cFC.SaveInt(m_nBulletsToFire); 
        cFC.SaveBool(m_bFireModeSingle);
        cFC.SaveBool(m_bIsShooting);
        cFC.SaveFloat(m_fNextShootTime);

        cFC.SaveObjectRef((GameObject)m_DrivenVehicle);
        cFC.SaveBool(m_bSitsInVehicle);
        cFC.SaveBool(m_bSitsInCannon);

        cFC.SaveVector(m_vLastGrenadeTargetPos);
        cFC.SaveFloat(m_fLastGrenadeTargetPosTime);
        cFC.SaveBool(m_bLastGrenadeTargetPosChangedResult);
        cFC.SaveFloat(m_fLastGrenadeCheck);
        cFC.SaveFloat(m_fLastGrenadeThrow);
        cFC.SaveFloat(m_fLastCheckedGrenadeTrajectoryHeight);
        cFC.SaveBool(m_bLastGrenadeTrajectoryCheckResult);
        cFC.SaveInt(m_nValidFiringPositions);
        
        cFC.SaveFloat(m_fLastLieDownCheckTime);
        cFC.SaveBool(m_bLastLieDownCheckResult);

        cFC.delete(); 
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[AIControllerHuman.SGUpdate]\n");
		super.SGUpdate();
        ActiveWeaponChanged();
	}
}
