import java.lang.reflect.*; 

public class NewAIHuman extends NewAI
{
    ////////////////////////////////////////////////////////////////////////
    // Nazwy meshelementow potrzebnych do animacji
    //
    protected String m_sRootElementName = "";
    protected String m_sTorsoElementName = "Spine";
	protected String m_sRightHandName = "Right_hand";
	protected String m_sLeftHandName = "Left_hand";
										   
    protected int m_nLeftHandID = -1;
    protected int m_nRightHandID = -1;

    ////////////////////////////////////////////////////////////////////////
    // Parametry skrecania ciala AI
    //
    

    /** Maksymalny kat o jaki moze skrecic w bok glowe AI zaleznie od MotionState.iSpeed */
    public float[] m_aMaxHeadTurnAngleH = { 45.f, 0, 0, 30, 45, 45 };

    /** Maksymalny kat o jaki moze skrecic w bok tulow AI zaleznie od MotionState.iSpeed */
    public float[] m_aMaxTorsoTurnAngleH = { 45.f, 1, 1, 30, 45, 45 };

    /** Maksymalny kat o jaki AI moze przekrecic glowe w pionie
     */
    public float m_fMaxHeadTurnAngleV = 25.f;


    /** Maksymalny kat o jaki AI moze przekrecic tulow w pionie
     */
    public float m_fMaxTorsoTurnAngleV = 90.f;

    ////////////////////////////////////////////////////////////////////////

    public float fEllipsoidRadius = 45.f;//#NEWAIHUMAN;
    public float fSightRange = 4000;//#NEWAIHUMAN;AI sight range in centimeters
    public float fSightRangeRecognitionMult = 0.25f;//#NEWAIHUMAN;fSightRangeRecognitionMult * fSightRange = distance of recognizing object as enemy (if it is enemy)
    public float fSightAngle = 180;//#NEWAIHUMAN;AI sight angle in degrees
    public float fMaxEnemyRecognitionTime = 3.f;//#NEWAIHUMAN;Time to recognize enemy when distance is fSightRange
    public float fMaxEnemyRecognitionTimeAlarmed = 0.f;//#NEWAIHUMAN;Time to recognize enemy when distance is fSightRange and AI is already alarmed
    public float fMaxFireDeviation = 0.1f;
    
    public float fEnemySpottedNoiseRange = 0;//#NEWAIHUMAN;Range of 'enemy spotted' message
    
    ///////////////////////////////////////////////
    // Parametry strzelania
    //
    
    /** Mnoznik celnosci AI niezalezny od broni ani jego stanu */
    public float fOverallAIAccMult   = 1.0f;//#NEWAIHUMAN;Multiplier of overall AI accuracy
    
    /////////////////////////////////////////////////////////////////////////////
    // GRANATY
    //
    
    /** Prawdopodobienstwo rzucenia granatem gdy WIDZI przeciwnika [%]  */
    public int fGrenadeChanceWhenEnemyVisible     = 50;//#NEWAIHUMAN;Probability of alowing to throw grenade when enemy is visible
    /** Prawdopodobienstwo rzucenia granatem gdy NIE WIDZI przeciwnika [%]  */
    public int fGrenadeChanceWhenEnemyNotVisible = 90;//#NEWAIHUMAN;Probability of alowing to throw grenade when enemy is NOT visible

    /** Znacznik, ze AI ma odpalac animacje mrugania oczami, jesli jest ona dostepna */
    public boolean bEyesBlink = true;//#NEWAIHUMAN;true means that AI may use eyes blink animation
    
    /** Zakres przerw miedzy mrugnieciami */
    float m_fMinTimeBtwEyeBlinks = 0.5f;
    float m_fMaxTimeBtwEyeBlinks = 5.f;
    
    /** Czas, po dojsciu do ktorego mozna znow mrugnac */
    float m_fNextBlinkTime = 0;
    
    int m_nEyelidsID = -1;

    /////////////////////////////////////////////////////////////////////////////

    /** Minimalny przedzial czasu miedzy okrzykami obrywajacego AI */
    float m_fPainScreamInterval = 5.f; 
    float m_fLastPainScreamTime = AIController._INIT_TIME;
    
    

    
    float m_fNormalMorphTime = 0.2f; // normalny czas morphingu

    float m_fLongMorphTime = 0.7f; // morphing dla Idle'i i 'stanu beztroski' ;)

    
    
    float fAIMinStepSoundDist = 50;
    float fAIMaxStepSoundDist = 500;
    float fAIMaxStepSoundDist2 = fAIMaxStepSoundDist * fAIMaxStepSoundDist;
    
    ///////////////////////////////////////////////////////////////////////////////
    int METHOD_StepDone = 0;


    
    
    NewAIHuman()
    {
        super();

        MeshName = "Data/Meshes/AI/LSoldier.3da";
        ActiveElement = "Bip01 Spine1";
        sDefaultSoundsPaths = "Data/Sounds/AI/Soldier1;Data/Sounds/AI/Soldier2;Data/Sounds/AI/Soldier3";
        /** Definicje dzwiekow wydawanych przez ai dla poszczegolnych _SCREAMTYPE_*
        */
        m_aSoundsGroups = new SoundsGroup[] {
                             new SoundsGroup("shot", 0),                    //_SCREAMTYPE_PAIN_FRIEND
                             new SoundsGroup("shot", 3000.f),               //_SCREAMTYPE_PAIN_ENEMY
                             new SoundsGroup("dead", 3000.f),               //_SCREAMTYPE_DEATH 
                             new SoundsGroup("hostile", 0),                 //_SCREAMTYPE_ENEMY_SPOTTED
                             new SoundsGroup("body_found", 0),              //_SCREAMTYPE_DEAD_BODY_SPOTTED
                             new SoundsGroup("fireinthehole", 0),           //_SCREAMTYPE_GRENADE_THROW
                             new SoundsGroup("grenade", 0),                 //_SCREAMTYPE_GRENADE_SPOTTED
                             null,                                          //_SCREAMTYPE_INFO
                             new SoundsGroup("stranger", 1000, 10, 10),     //_SCREAMTYPE_STRANGER_SPOTTED
                             };

        m_sControllerClassName = AIControllerHuman.class.getName();
        /** Tablica predkosci poruszania sie w zaleznosci od MotionState.iSpeed
        *  STILL, SWIM, CRAWL, DUCK, WALK, RUN */
        m_aMotionVelocity = new float [] {0, 70, 70, 100, 165, 500};
        /** Mnozniki predkosci dla strafowania */
        m_aMotionVelocityStrafeMultiplier = new float[] {0.f, 1.0f, 1.f, .6f, .5f, .5f};
        /** Tablica predkosci katowych w zaleznosci od MotionState.iSpeed (dla Turn) */
        m_aMotionAngularVelocity = new float[] { 0, 0, 60, 150, 280, 500 };

        /** Cosinus kata, powyzej jakiego AI powinno sie obracac przez turn gdy porusza sie 'po sciezce' */
        m_fMinAngleToTurnWhileMovingCos = (float)Math.cos(130 * Tools.DEG2RAD);
        bUsePhysicsToDeathFall = true;
        bHitReactionAllowed = true;
        m_bHitReactionDisabled = false;
        bCanUseRadioCommunication = true;
    }

    
    public void OnCreate()
    {
        super.OnCreate();
        METHOD_StepDone = RegisterCallMethod("StepDone");

        m_Anims = new AIAnimationsHuman(0);
        m_Anims.Initialize(this, sAnimSeqFile, m_sRootElementName, m_sTorsoElementName);
        
        m_Motion.SetSpeed(MotionState.SPEED_WALK);
        
        SetAnimMorphTime(0.2f); 
        // HACK
		for (int elem = 0; elem < GetElementsNumber(); elem++)
            SetAnimMorphTime(elem, 0.2f, true);
        
        m_nLeftHandID = GetElementID(m_sLeftHandName);
        m_nRightHandID = GetElementID(m_sRightHandName);
        m_nEyelidsID = GetElementID("Eyelids");
        
        // wymuszamy aktywowanie obiektu gdy jest kolizja na nim calym
        bForceWholeObjectCollision = true;

        // drobna modyfikacja mesha - zeby zalatac wieksze dziury w szkielecie AI
        MoveElementBoxSide(GetMeshElemFromBoneID(EBones._SPINE), 0, -10);
        MoveElementBoxSide(GetMeshElemFromBoneID(EBones._SPINE1), 0, -10);

        ImplantTermovision.AddToSystem(this);
        
        if (m_aSoundsGroups != null &&
            m_aSoundsGroups[_SCREAMTYPE_ENEMY_SPOTTED] != null)
        {
            m_aSoundsGroups[_SCREAMTYPE_ENEMY_SPOTTED].fNoiseRange = fEnemySpottedNoiseRange;
        }
    }

    public void OnPostCreate()
    {
        StartGym();
        SetEllipsoid(45f,
                     m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY,
                     m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY / 2);
        SetEllipsoidNoExtents(fEllipsoidRadius,
                     m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY,
                     m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY / 2);

        super.OnPostCreate();
        CallMethodIn(METHOD_CallUpdateMotion, 0);
    }
    
    public void InitParamsFromMesh()
    {
        String meshName = MeshName.toLowerCase();
        if (meshName.endsWith("hsoldier.3da"))
        {
            if (fHealth == -1)
                fHealth = RandomFloat(200, 250);
            int helmetID = GetElementID("HSHelm");
            if (helmetID >= 0 && !IsElementHidden(helmetID))
            {
                aDamageMultipliers[BODY_PART_HEAD] = 2.f;
            }
        }
        else if (meshName.endsWith("lsoldier.3da"))
        {
            if (fHealth == -1)
                fHealth = RandomFloat(100, 130);
            int helmetID = GetElementID("Helm");
            if (helmetID >= 0 && !IsElementHidden(helmetID))
            {
                aDamageMultipliers[BODY_PART_HEAD] = 2.f;
            }
        }
        else
        {
            if (fHealth == -1)
                fHealth = fDefaultAIHealth;
        }
    }

    ////////////////////////////////////////////////////////////////////////
    
    protected Vector[][] m_aBarrelLocalPos = null;
    protected Vector[][] m_aTopmostLocalPos = null;
    
    /** Ustawienie AI w roznych mozliwych pozycjach i wpisanie w odpowiednie tablice
     *  polozenia dummy'ego od prawej reki, punktu powyzej srodka glowy oraz promienia
     *  elipsoidy
     */
    void StartGym()
    {
        Weapon cWeapon = ActiveWeapon;
        
        ActiveWeapon = cAIWeapon; // zeby setupanims zadzialalo

        if (m_aBarrelLocalPos == null)
        {
            m_aBarrelLocalPos = new Vector[2][];
            m_aBarrelLocalPos[0] = new Vector[MotionState.SPEED_COUNT];
            m_aBarrelLocalPos[1] = new Vector[MotionState.SPEED_COUNT];
        }
        
        if (m_aTopmostLocalPos == null)
        {
            m_aTopmostLocalPos = new Vector[2][];
            m_aTopmostLocalPos[0] = new Vector[MotionState.SPEED_COUNT];
            m_aTopmostLocalPos[1] = new Vector[MotionState.SPEED_COUNT];
        }
        
        byte nOldSpeed = m_Motion.GetSpeed();
        boolean bOldAiming = m_Motion.bAiming;
        float fFrame;
        
        int nTopmostID = GetElementID("Head");
        
        Vector vMin = new Vector(),
            vMax = new Vector();
        
        // Zrob gimnastyke AI
        for (byte iSpeed = MotionState.SPEED_STILL; iSpeed <= MotionState.SPEED_RUN; iSpeed++)
        {
            m_Motion.SetSpeed(iSpeed);
            for (int nAiming = 0; nAiming <=1; nAiming++)
            {
                m_Motion.bAiming = nAiming != 0;
                m_Anims.SetupAnimations(m_Motion);
                int nNonAIAnimID = m_Anims.m_aAnims[AIAnimationsHuman.A_STAND];
#if DEBUG                
//                if (nNonAIAnimID < 0)
//                {
//                    GameObject.CrashLog("WARNING: Incorrect anim ID in StartGym (speed = " + 
//                                        MotionState.aSpeedNames[iSpeed] + ", bAiming = " +
//                                        m_Motion.bAiming + ")\n");
//                }
#endif                
                
                fFrame = GetLastFrame(nNonAIAnimID);
                SetFrame(nNonAIAnimID, fFrame, -1);
                
                if (m_nRightHandID == -1)
                    m_aBarrelLocalPos[nAiming][iSpeed] = new Vector(0f, 100f, 0f);
                else
                    m_aBarrelLocalPos[nAiming][iSpeed] = PointWorldToLocal(GetElementPos(m_nRightHandID));

                GetElementExtentsInWorld(vMin, vMax, nTopmostID);
                m_aTopmostLocalPos[nAiming][iSpeed] = new Vector(vMax);
                m_aTopmostLocalPos[nAiming][iSpeed].Add(vMin);
                m_aTopmostLocalPos[nAiming][iSpeed].Mul(0.5f);
                m_aTopmostLocalPos[nAiming][iSpeed].fY += (vMax.fY - vMin.fY) * 0.3f;
                m_aTopmostLocalPos[nAiming][iSpeed] = PointWorldToLocal(m_aTopmostLocalPos[nAiming][iSpeed]);
            }
        }
        m_Motion.SetSpeed(nOldSpeed);
        m_Motion.bAiming = bOldAiming;
        
        ActiveWeapon = cWeapon;
    }
    
    public Vector GetBarrelPos(byte iSpeed, boolean bAiming)
    {
        return PointLocalToWorld(m_aBarrelLocalPos[bAiming ? 1 : 0][iSpeed]);
    }
    
    public float GetBarrelHeightOverGround(byte iSpeed, boolean bAiming)
    {
        return m_aBarrelLocalPos[bAiming ? 1 : 0][iSpeed].fY;
    }
    
    public Vector GetTopmostPoint(byte iSpeed, boolean bAiming)
    {
        return PointLocalToWorld(m_aTopmostLocalPos[bAiming ? 1 : 0][iSpeed]);
    }

    private Vector m_vFXBarrelPos = new Vector();
	/** pokryte, by AI odpalalo efekt dokladnie tam, gdzie strzela
	 */
    void ExecuteFXBarrel(String sFXName)
    {
        if (ActiveWeapon != null)
        {
            m_vFXBarrelPos.Set(Vector.Zero);
            ExecuteFX(ActiveWeapon, "Barrel", sFXName, m_vFXBarrelPos);
            
            if (ActiveWeapon.m_bShowFXBeam)
            {
                if (GetLastFireDir().Len2() > 0f)
                    ActiveWeapon.ExecuteFX(ActiveWeapon, "WeaponBeam", ActiveWeapon.vBarrelElementPos, 
                                           ActiveWeapon.VectorWorldToLocal(GetLastFireDir()));
                else
                    ActiveWeapon.ExecuteFX(ActiveWeapon, "WeaponBeam", ActiveWeapon.vBarrelElementPos);
            }
            
        }

    }

    ////////////////////////////////////////////////////////////////////////
    
    void PlaceWeapons()
    {
		super.PlaceWeapons();
		
        if (m_nRightHandID == -1)
            return;
        
        if ( ActiveWeapon == null )
            return;

        Vector vGunAxis;

        ActiveWeapon.FromUpForwardPos(GetElementUpVector(m_nRightHandID), 
                                      GetElementForwardVector(m_nRightHandID), 
                                      GetElementPos(m_nRightHandID));
		
		AttachChildAndKeepWorldPos(ActiveWeapon, m_nRightHandID);
    }

    
    public Vector GetLookFromPoint()
    {
        return GetBoneJointPos(EBones._HEAD);
    }


    public Vector GetLookDir()
    {
        return GetBonePerpVector(EBones._HEAD);
    }

    
    /////////////////////////////////////////////////////////////////////////////////////
    // Metoda do odpalenia strzalu na filmie w kierunku celowania gunem
    //
    boolean m_bShootingDuringMovie = false;
    public void MovieShoot()
    {
        if (ActiveWeapon == null)
        {
            LogR("[NewAIHuman.MovieShoot]@" + GetName() + ": ActiveWeapon == null!!!");
            return;
        }
        
        if ((ActiveWeapon.nAIFireModes & Weapon._FIREMODE_SINGLE) != 0)
        {
            if (ActiveWeapon.nAmmo < 1)
                ActiveWeapon.nAmmo = 1;
            ActiveWeapon.StartFire(Weapon.MODE_SINGLE);
            m_bShootingDuringMovie = true;
        }
        else
            LogR("[NewAIHuman.MovieShoot]@" + GetName() + ": Weapon doesn't have single fire mode!!!");
    }
    //////////////////////////////////////////////////////////////////////////////////////

    void MessageWeapon(int nState)
    {
        super.MessageWeapon(nState);
        if ((nState & Weapon.STATE_SHOT) != 0)
        {
            m_bShootingDuringMovie = false; // po strzale trzeba skasowac znacznik
        }
    }

    
    public Vector GetFireOrigin()
    {
        if (m_nRightHandID == -1)
            return super.GetFireOrigin();
        return GetElementPos(m_nRightHandID);
    }

    private Vector m_vDev = new Vector();
    private Vector m_vLastFireDir = new Vector();

    public Vector GetFireDir()
    {
        ChromeActor cEnemy = m_Controller.GetActiveEnemy();
        Vector vDir;
        if ((cEnemy != null || m_bShootingDuringMovie) && ActiveWeapon != null)
        {
            if (m_bShootingDuringMovie)
                vDir = ActiveWeapon.GetForwardVector();
            else
            {
                vDir = cEnemy.GetPointToLookAt(0);
                vDir.Sub(GetFireOrigin());
                
                vDir.CrossStatic(Vector.Up, m_vDev);
                RotateVector(m_vDev, m_fFiringDevLineAngle, vDir, m_vDev);

                m_vDev.Mul(fMaxFireDeviation * m_fFiringDeviation);
                vDir.Add(m_vDev);
            }
            vDir.Normalize();
            m_vLastFireDir.Set(vDir);
        }
        else
            vDir = super.GetFireDir();

        return vDir;
    }

	public Vector GetLastFireDir()
	{
		return m_vLastFireDir;
	}
    
    /** Skrecenie ciala AI */
    void TwistBody(float fHorizAngle, float fVertAngle, boolean bLookTwist)
    {
        float fAbsAngleH = Math.abs(fHorizAngle),
              fAbsAngleV = Math.abs(fVertAngle);
        
        float fMaxHeadTurnAngleH = m_aMaxHeadTurnAngleH[m_ActualMotion.GetSpeed()];
        float fMaxTorsoTurnAngleH = m_aMaxTorsoTurnAngleH[m_ActualMotion.GetSpeed()];
        if (bLookTwist) // ma obrocic do kierunku glowe
        {
            if (fAbsAngleH > fMaxHeadTurnAngleH)
            {
                m_fTwistHeadAngleH = fMaxHeadTurnAngleH * MathUtils.sign(fHorizAngle);
                m_fTwistTorsoAngleH = Math.min(fMaxTorsoTurnAngleH, 
                                                fAbsAngleH - fMaxHeadTurnAngleH) *
                                       MathUtils.sign(fHorizAngle);
            }
            else
            {
                m_fTwistHeadAngleH = fHorizAngle;
                m_fTwistTorsoAngleH = 0;
            }

            if (fAbsAngleV > m_fMaxHeadTurnAngleV)
            {
                m_fTwistHeadAngleV = m_fMaxHeadTurnAngleV * MathUtils.sign(fVertAngle);
                m_fTwistTorsoAngleV = Math.min(m_fMaxTorsoTurnAngleV, 
                                               fAbsAngleV - m_fMaxHeadTurnAngleV) *
                                      MathUtils.sign(fVertAngle);
            }
            else
            {
                m_fTwistHeadAngleV = fVertAngle;
                m_fTwistTorsoAngleV = 0;
            }
        }
        else
        {
            m_fTwistHeadAngleH = m_fTwistHeadAngleV = 0;
            m_fTwistTorsoAngleH = Math.min(fMaxTorsoTurnAngleH, fAbsAngleH) * MathUtils.sign(fHorizAngle);
            m_fTwistTorsoAngleV = Math.min(m_fMaxTorsoTurnAngleV, fAbsAngleV) * MathUtils.sign(fVertAngle);
        }

        UpdateBodyDeformations();
    }

    
    
    /** Deformacja przy strafeowaniu */
    void BodyDeformStrafe(byte byDir)
    {
        if (m_byLastBodyDeformStrafeDir != byDir || byDir == 0)
        {
            m_byLastBodyDeformStrafeDir = byDir;
            UpdateBodyDeformations();
        }
    }

    protected float m_fTwistHeadAngleH;
    protected float m_fTwistHeadAngleV;
    protected float m_fTwistTorsoAngleH;
    protected float m_fTwistTorsoAngleV;
    protected byte  m_byLastBodyDeformStrafeDir = 0;
    
    void UpdateBodyDeformations()
    {
        // Skrecenie w poziomie (twist + deformacja dla biegania)
        BoneRotate(EBones._HEAD, Vector.Right, m_fTwistHeadAngleH);
        BoneRotate(EBones._SPINE, Vector.Right, m_fTwistTorsoAngleH * .5f - 
                                                m_byLastBodyDeformStrafeDir * 15.f);
        BoneRotate(EBones._SPINE1, Vector.Right, m_fTwistTorsoAngleH * .5f - 
                                                 m_byLastBodyDeformStrafeDir * 15.f);
        BoneRotate(EBones._PELVIS, Vector.Right, m_byLastBodyDeformStrafeDir*30.f);

        // Skrecenie w pionie - zlozenia z poprzednim
        BoneRotate(EBones._HEAD, Vector.Up, m_fTwistHeadAngleV, true);

        BoneRotate(EBones._NECK, Vector.Up, m_fTwistTorsoAngleV * .4f);
        BoneRotate(EBones._SPINE, Vector.Up, m_fTwistTorsoAngleV * .3f, true);
        BoneRotate(EBones._SPINE1, Vector.Up, m_fTwistTorsoAngleV * .3f, true);
    }
    

    private boolean l_bWeaponRenderable = true;
    void TermovisionOn()
    {
        super.TermovisionOn();
        if (ActiveWeapon != null)
        {
            l_bWeaponRenderable = ActiveWeapon.IsRenderable();
            if (l_bWeaponRenderable)
                ActiveWeapon.EnableRendering(false);
        }
    }
    
    void TermovisionOff()
    {
        super.TermovisionOff();
        if (ActiveWeapon != null && l_bWeaponRenderable)
            ActiveWeapon.EnableRendering(true);
    }
    
    protected void UpdateAllTrackings()
    {
        super.UpdateAllTrackings();
        if (bEyesBlink && !IsDead() && !IsFrozen())
        {
            int nAnimID = m_Anims.m_aAnims[AIAnimationsHuman.A_EYES_BLINK];
            float fTime = GetTime();
            if (nAnimID > -1 && fTime > m_fNextBlinkTime)
            {
                m_fNextBlinkTime = fTime + RandomFloat(m_fMinTimeBtwEyeBlinks, m_fMaxTimeBtwEyeBlinks);
                PlayAnim(nAnimID, 1);
            }
        }
    }
    
    protected void UpdateTrackingObject()
    {
        Vector vWorldDir = m_TrackedObject.GetPointToLookAt(0);
        vWorldDir.Sub(GetLookFromPoint());
        Vector vLocalDir = VectorWorldToLocal(vWorldDir);

        float fHorizAngle = (float)(Math.atan2(vLocalDir.fX, vLocalDir.fZ) * 180 / Math.PI),
              fLenXZ = (float)Math.sqrt(vLocalDir.fX * vLocalDir.fX + vLocalDir.fZ * vLocalDir.fZ),
              fVertAngle = (float)(-Math.atan2(vLocalDir.fY, fLenXZ) * 180 / Math.PI);

        
        if (m_ActualMotion.IsMovingLinear()) //porusza sie
        {
            TwistBody(0, fVertAngle, m_bTrackLookOnly);        
            if (m_bTrackLookOnly) // jesli nie sledzi gunem
            {
                //TODO: w czasie chodzenia tylko obrot glowy
            }
            else
            {
                TryToVerticalize();
                SetMaxAngSpeed(m_aMotionAngularVelocity[m_Motion.GetSpeed()]);
                SetFacingDestDir(vWorldDir);
            }
        }
        else
        {
            float fMaxTwistAngle = m_aMaxTorsoTurnAngleH[m_ActualMotion.GetSpeed()];
            if (m_bTrackLookOnly)
                fMaxTwistAngle += m_aMaxHeadTurnAngleH[m_ActualMotion.GetSpeed()];
            float fAbsAngle = Math.abs(fHorizAngle);

            if (fAbsAngle > fMaxTwistAngle)
            {
                if (m_bTrackCanTurn)
                {
                    TwistBody(0, fVertAngle, m_bTrackLookOnly);
                    Turn(fHorizAngle);
                }
                else
                {
                    TurnDone();
                    TwistBody(fMaxTwistAngle * MathUtils.sign(fHorizAngle), fVertAngle, m_bTrackLookOnly);
                }
            }
            else
            {
                TurnDone();
                TwistBody(fHorizAngle, fVertAngle, m_bTrackLookOnly);        
            }
        }
    }
    
    public boolean StartTrackingObject(ChromeActor cTarget, boolean bLookOnly, boolean bCanTurn)
    {
        boolean bRet = super.StartTrackingObject(cTarget, bLookOnly, bCanTurn);
        if (m_TrackedObject != null)
            UpdateTrackingObject();
        return bRet;
    }

    public boolean StopTrackingObject()
    {
        if (m_TrackedObject != null)
            TwistBody(0,0,m_bTrackLookOnly);
        return super.StopTrackingObject();
    }
    
    
    /////////////////////////////////////////////////////////////////////////////

    /** Zwraca zmodyfikowany odpowiednio MotionState
     */
    AIMotionState GetCorrectMotionState(AIMotionState cMotion)
    {
        AIMotionState cResult = new AIMotionState(cMotion);
        // zmniejsz predkosc jesli probuje biec celujac albo do tylu
        if (cMotion.GetSpeed() == MotionState.SPEED_RUN &&
            (cMotion.bAiming /*|| cMotion.iMoveZ < 0*/))
            cResult.SetSpeed(MotionState.SPEED_WALK);
        
        // jesli sie nie porusza, to zmien predkosc z Run na Walk, 
        // bo nie ma animacji stania i obrotow
        if (cResult.GetSpeed() == MotionState.SPEED_RUN &&
            !cMotion.IsMoving())
            cResult.SetSpeed(MotionState.SPEED_WALK);
        
        return cResult;
    }
    
    
    /** UpdateMotion dla poruszajacego sie AI
     */
    protected float UpdateMotion_Moving(AIMotionState cMotion)
    {
        int nAnimID = -1;
        if (cMotion.IsMovingLinear())
        {
            switch ((int)cMotion.iMoveZ)
            {
            case -1 : //backward
                nAnimID = AIAnimationsHuman.A_BACKWARD;
                if (cMotion.GetSpeed() >= MotionState.SPEED_WALK)
                    BodyDeformStrafe((byte)-cMotion.iMoveX);
                else
                    BodyDeformStrafe((byte)0);
                break;
            case 0 : //strafe
                if (cMotion.GetSpeed() == MotionState.SPEED_RUN)
                {
                    nAnimID = AIAnimationsHuman.A_FORWARD;
                    BodyDeformStrafe((byte)cMotion.iMoveX);
                }
                else 
                {
                    BodyDeformStrafe((byte)0);
                    if (cMotion.iMoveX > 0)
                        nAnimID = AIAnimationsHuman.A_STRAFE_LEFT;
                    else
                        nAnimID = AIAnimationsHuman.A_STRAFE_RIGHT;
                }
                break;
            case 1 : //forward
                nAnimID = AIAnimationsHuman.A_FORWARD;
                if (cMotion.GetSpeed() >= MotionState.SPEED_WALK)
                    BodyDeformStrafe(cMotion.iMoveX);
                else
                    BodyDeformStrafe((byte)0);
                break;
            }
        } 
        else if (cMotion.iTurn != 0) //obroty
        {
            BodyDeformStrafe((byte)0);
            if (cMotion.iTurn > 0)
            {
                if (cMotion.GetSpeed() == MotionState.SPEED_RUN)
                    nAnimID = AIAnimationsHuman.A_BACK_ROTATE_LEFT;
                else
                    nAnimID = AIAnimationsHuman.A_ROTATE_LEFT;
            }
            else
            {
                if (cMotion.GetSpeed() == MotionState.SPEED_RUN)
                    nAnimID = AIAnimationsHuman.A_BACK_ROTATE_RIGHT;
                else
                    nAnimID = AIAnimationsHuman.A_ROTATE_RIGHT;
            }
        }

        if (nAnimID != -1)
        {
            if (m_OldMotion.iMoveX != cMotion.iMoveX ||
                m_OldMotion.iMoveZ != cMotion.iMoveZ ||
                m_OldMotion.GetSpeed() != cMotion.GetSpeed() ||
                m_OldMotion.iTurn != cMotion.iTurn)
            {
                PlayAIAnimLoop( nAnimID );
                float fAnimLength = GetAIAnimLength(nAnimID);
                if (fAnimLength > 0.1f)
                {
                    StepDone();
                    CallMethodEvery( METHOD_StepDone, fAnimLength / 2.f);
                }
            }
            
        }
        return 0; //TODO moze zwracac animmorphtime
    }
    
    private Vector m_vSD_Start = new Vector();
    private Vector m_vSD_End = new Vector();
    
    void StepDone()
    {
        if ( (SoundEmitter.bListenerInsideBuilding == IsSetFlag(EFlags._LINKED_TO_PORTAL_OBJECT)) ||
             IsSetFlag(EFlags._PORTAL_INDEPENDENT))
        {
            Camera cam = ((ChromeModule)GetModule()).GetActiveViewCamera();
            float fDist2 = GetDistance2To( cam.GetPositionVolatile() );
            if (fDist2 < fAIMaxStepSoundDist2)
            {
                // sprawdz material
                GetPosition(m_vSD_Start);
                m_vSD_End.Set(m_vSD_Start);
                
                m_vSD_Start.fY += 20;
                m_vSD_End.fY -= 50;
        
                Collision coll = TraceForCollision(m_vSD_Start, m_vSD_End, this);
            
                int nMaterial;
                if (coll != null)
                    nMaterial = coll.nMaterial;
                else
                    nMaterial = EMaterialType._GROUND;
                
                PlayStepSound(m_ActualMotion, nMaterial, fAIMinStepSoundDist, fAIMaxStepSoundDist);
            }
        }
    }    

    /** UpdateMotion dla stojacego AI
     */
    protected float UpdateMotion_Still(AIMotionState cMotion)
    {
        BodyDeformStrafe((byte)0);

        int nAnimID = -1;
        boolean bIsPlayingAnim = true;
        float fChangeTime = 0;
        
        //czy wstajemy z czolgania?
        if ( (m_OldMotion.GetSpeed() == MotionState.SPEED_CRAWL) &&
             (cMotion.GetSpeed() != MotionState.SPEED_CRAWL) )
        {
            //animacja przejscia miedzy odpowiednimi stanami
            if (cMotion.GetSpeed() == MotionState.SPEED_DUCK)
                nAnimID = AIAnimationsHuman.A_CRAWL2DUCK;
            else
                nAnimID = AIAnimationsHuman.A_CRAWL2STAND;
        } // czy kladziemy sie do czolgania?
        else if ( (m_OldMotion.GetSpeed() != MotionState.SPEED_CRAWL) &&
                  (m_Motion.GetSpeed() == MotionState.SPEED_CRAWL) )
        {
            if (cMotion.GetSpeed() == MotionState.SPEED_DUCK)
                nAnimID = AIAnimationsHuman.A_CRAWL2STAND;
            else
                nAnimID = AIAnimationsHuman.A_STAND2CRAWL;
        } 
        else
        {
            bIsPlayingAnim = false;    
            nAnimID = AIAnimationsHuman.A_STAND;
        }

        if (m_OldMotion.IsMoving())
            DisableCallMethod( METHOD_StepDone );

        // odpal odpowiednia animacje
        if (nAnimID != -1)
        {
            if (bIsPlayingAnim)
            {
                PlayAIAnim(nAnimID);
                fChangeTime = GetAIAnimLength(nAnimID);
                CallMethodOnceIn(METHOD_CallUpdateMotion, fChangeTime);
            }
            else
            {
                PlayAIAnimLoop(nAnimID);
                fChangeTime = GetAnimMorphTime(0);
            }
        }
        return fChangeTime;
    }

    public float UpdateMotion()
    {
        DisableCallMethod(METHOD_CallUpdateMotion);
        float fTime = 0;
        m_ActualMotion = GetCorrectMotionState(m_Motion);

/*        
LogR("m_Motion = " + DescribeMotionState(m_Motion) + "\n" +
         "m_ActualMotion = " + DescribeMotionState(m_ActualMotion) + "\n" +
         ((m_ActualMotion.IsEqual(m_OldMotion)) ? "==" : "!=") + 
         " m_OldMotion = " + DescribeMotionState(m_OldMotion) + "\n");
CrashLog("IsPlaying() = " + IsPlaying("") + "\n");
*/        

        if (!IsDead() && !IsFrozen() && 
            (!m_ActualMotion.IsEqual(m_OldMotion) || !IsPlaying("")))
        {
			// przelaczenie odpowiednio animacji
            m_Anims.SetupAnimations(m_ActualMotion);
            if ( m_ActualMotion.IsMoving() )
                fTime = UpdateMotion_Moving(m_ActualMotion);
            else
                fTime = UpdateMotion_Still(m_ActualMotion);
            
            m_OldMotion = new AIMotionState(m_ActualMotion);
            
            m_Controller.MotionStateChanged();
        }
        return fTime;
    }

    void UpdateMorphTime()
    {
        if (m_Controller == null ||
            m_Controller.GetAlarmLevel() > AIController._ALARM_LEVEL_LOW ||
            m_Motion.IsMoving())
        {
            SetAnimMorphTime(m_fNormalMorphTime); // normalny czas morphingu
        }
        else
            SetAnimMorphTime(m_fLongMorphTime); // morphing dla Idle'i i 'stanu beztroski' ;)
        
        if (m_nEyelidsID > 0) // dla bezpieczenstwa - i tak nie moze byc root bone (0)
            SetAnimMorphTime(m_nEyelidsID, 0, false); // jest false, bo i tak dziala, a propagowanie flag jest zwalone ;)
    }
    
    
    
    
	public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
	{
        super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
		
        Bleed(fDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
	}

    
    public void HitReaction(Vector vHitDir)
    {
        if (!IsFrozen() && !IsDead())
        {
            // sprawdz, jaka animacje odpalic (zalezne od kierunku postrzalu)
            int nHitAnimID = AIAnimationsHuman.A_TAKE_HIT_FRONT;
            if (vHitDir != null)
            {
                vHitDir.Normalize();
                vHitDir.Negate();
                float fFwdDot = vHitDir.Dot(GetForwardVectorVolatile());
                if (fFwdDot > _COS_2_PI_BY_8)
                    nHitAnimID = AIAnimationsHuman.A_TAKE_HIT_FRONT;
                else if (fFwdDot < _COS_6_PI_BY_8)
                    nHitAnimID = AIAnimationsHuman.A_TAKE_HIT_BACK;
                else if (vHitDir.Dot(GetRightVectorVolatile()) > 0)
                    nHitAnimID = AIAnimationsHuman.A_TAKE_HIT_LEFT;
                else
                    nHitAnimID = AIAnimationsHuman.A_TAKE_HIT_RIGHT;
            }
            // jesli jeszcze nie przymrozil kontrolera
            if (!m_Controller.IsFrozen())
            {
                m_Controller.Freeze();
                if (ActiveWeapon != null)
                    ActiveWeapon.FreezeCallMethods();
            }
            // jesli sie porusza - zatrzymaj
            if (m_Motion.IsMoving())
                StopGoTo();
            // odswiez animacje (force - StopAnim)
            StopAIAnim(true); // true - notyfikacja kontrolera - przerwanie animacji
            CallUpdateMotion();
            // odegraj animacje postrzalu
            m_Anims.Play(nHitAnimID);
            // zawolaj dalsza czesc obslugi postrzalu
            DisableCallMethod("HitReactionEnd");
            DisableCallMethod("HitReactionCont");
            CallMethodIn("HitReactionCont", GetAnimMorphTime(0) / 2);
        }
    }
    
    public void HitReactionCont()
    {
        // odswiez animacje
        StopAIAnim(false); // bez notyfikacji kontrolera
        CallUpdateMotion();
        // zawolaj dalsza czesc
        DisableCallMethod("HitReactionEnd");
        CallMethodIn("HitReactionEnd", GetAnimMorphTime(0) / 2);
    }
    
    public void HitReactionEnd()
    {
        // przywroc dzialanie kontrolera i broni
        if (ActiveWeapon != null)
            ActiveWeapon.UnfreezeCallMethods();
        m_Controller.Unfreeze();
        // przegenerowanie scenariuszy
        m_Controller.RequestEvent(AIEvents._EV_PAIN, true);
    }
    
    
    public void MakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation,
                           Vector vSpeed, int nMeshElementorBoneID, int nDamageType, boolean bClampDamage)
    {
        // to musi byc na poczatku, bo potem zmieniamy kosc
		boolean bHitInHead = (nMeshElementorBoneID == EBones._HEAD) || (nMeshElementorBoneID == EBones._NECK);
		
        float fMultiplier = GetDamageMultiplier(nMeshElementorBoneID);

        boolean bDeadBeforeDamage = bDead;
        fDamage *= fMultiplier;

        /** Wylacz obrazenia od rakiet wystrzeliwanych przez przyjazne AI */
        if (Assassin instanceof Bullet)
        {
            Pawn bulletsOwner = ((Bullet)Assassin).Owner;
            if (bulletsOwner instanceof NewAI &&
                IsFriend(((Bullet)Assassin).Owner))
            {
                fDamage = 0; // wylacz tylko damage - reszta bez zmian
            }
        }
        Damage(fDamage, nDamageType);

        if (bDead && bUsePhysicsToDeathFall)
        {
			// jezeli go wlasnie usmiercilismy i dostal w kosc
            if ( (!bDeadBeforeDamage) && (nMeshElementorBoneID != EBones._NON_BONE) )
            {
                // uderzamy sztucznie w szyje
                // nMeshElementorBoneID = EBones._NECK; 
                // vHitLocation = GetBoneJointPos((byte) nMeshElementorBoneID);
            }
            
            if ( (nDamageType == EnumDamageType._BLAST) || (nDamageType == EnumDamageType._BLAST_SPECIAL) )
            {
                // zwiekszamy sile odrzutu
                fDamage *= 100.5f;
                if (vSpeed != null)
                    vSpeed.Mul(10f);
                nMeshElementorBoneID = EBones._NECK;
                vHitLocation = GetBoneJointPos((byte) nMeshElementorBoneID);
            }
			else
			if (nDamageType == EnumDamageType._COLLISION)
			{
                if (vSpeed != null)
                    vSpeed.fY = 0f;
                nMeshElementorBoneID = EBones._NECK;
                vHitLocation = GetBoneJointPos((byte) nMeshElementorBoneID);
			}
            else
            {
                fDamage /= 3f;
                if (vSpeed != null)
                    vSpeed.fY = 0f;
            }
            
            if (!(bDeadBeforeDamage && s_nLocale == ELocale._GERMAN))
                Physics.Simulate(this, vHitLocation, vSpeed, fPhSimDamage, nMeshElementorBoneID, bClampDamage);
        }
		
		if ( (!bDeadBeforeDamage) && (bDead) )
		{
			if (Assassin instanceof ChromeActor)
				m_Killer = (ChromeActor) Assassin;
			
			if (!bHitInHead)
				Scream(_SCREAMTYPE_DEATH);
			else
				MakeNoise(m_fDeathBodyFallRange * GetMakeNoiseMult(), Pawn._NOISE_BODY_FALL);
		}
        else if (!bDead)
        {
            float fTime = GetTime();
            if (AIController.TimePassed(m_fLastPainScreamTime, m_fPainScreamInterval, fTime))
            {
                m_fLastPainScreamTime = fTime;
                if (Assassin instanceof ChromeActor &&
                    IsFriend((ChromeActor)Assassin))
                    Scream(_SCREAMTYPE_PAIN_FRIEND);
                else
                    Scream(_SCREAMTYPE_PAIN_ENEMY);
            }
        }
    }
	
    
    void DisableBodyActivities()
    {
        DisableCallMethod(METHOD_StepDone);
        super.DisableBodyActivities();
    }
    
    public void Die()
    {
        if (!IsDead())
        {
            boolean bDieInVehicle = false;
            
			if ( (cSeatInfo != null) && (cSeatInfo.GetOccupant() == this) )
			{
				if (cSeatInfo.GetRole() == EPassengerRole._VEHICLE_DRIVER)
                {
                    if (GetController().GetDrivenVehicle() != null)
    					GetController().GetDrivenVehicle().FinishDrive();
                    if (cSeatInfo.GetOccupiedObject() instanceof StationaryCannon)
                    {
                        StationaryCannon cannon = (StationaryCannon) cSeatInfo.GetOccupiedObject();
                        
                        cannon.StopControllingByAI();
                    }
                }
				else
				if (cSeatInfo.GetRole() == EPassengerRole._VEHICLE_PASSENGER)
				{
					if (cSeatInfo.GetOccupiedObject() instanceof VehicleAttacker)
					{
						VehicleAttacker vehicle = (VehicleAttacker) cSeatInfo.GetOccupiedObject();
						vehicle.StopControllingCannonByAI();
					}
				}
                
                if (GetController().m_bSitsInVehicleOnSeat)
                    bDieInVehicle = true;
                else
                    GetOut(); // odrejestrowujemy siedzenia
            }
			
            ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_DEAD_BODY );
            
            super.Die();

            ClearFlag(EFlags._BLOCK_MOVE);
            SetCollFlags(ECollFlags.OBJCOL_FLAG_AUTOATTACH);
            UpdatePathMap(false);

            Vector vPos = GetPosition();
            
            // ustawiamy duze ekstenty, ale zostawiamy normalna ellipsoide
            SetEllipsoid(m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY,
                         m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY * 2,
                         0);
            SetEllipsoidNoExtents(fEllipsoidRadius,
                         m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY,
                         m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY / 2);
            
            SetPositionWorld(vPos);

            if ( (!bUsePhysicsToDeathFall) && (!bDieInVehicle) )
            {
                m_Anims.SetupAnimations(m_ActualMotion);
                int nAnimID = AIAnimationsHuman.A_DIE_FRONT;
                float fTime = GetAIAnimLength(nAnimID); //TODO: odpalanie odpowiedniego kierunku
                PlayAIAnim(nAnimID);
                CallMethodIn("DyingEnd", fTime);
            }
            
            if (bDieInVehicle)
            {
                ChromeActor vehicle = null;
                if (cSeatInfo.GetOccupiedObject() instanceof ChromeActor)
                   vehicle = (ChromeActor) cSeatInfo.GetOccupiedObject();
                
                if (vehicle.fHealth > 0)
                {
                    m_Anims.SetupAnimations(m_ActualMotion);
                    int nAnimID = cSeatInfo.GetDieAnimID();
                    float fTime = GetAIAnimLength(nAnimID);
                    PlayAIAnim(nAnimID);
                    CallMethodIn("DyingEnd", fTime);
                    bUsePhysicsToDeathFall = false;
                }
                else
                {
		            cSeatInfo.Occupy(null);
			        cSeatInfo.Reserve(null);
                    cSeatInfo = null;
            
                    GetController().m_bSitsInVehicleOnSeat = false;
                        
                    ControlObject newParent = GetParent(); // to powinien byc pojazd
                    if (newParent != null)
                        newParent = newParent.GetParent(); // a to powinien byc parent pojazdu (dzialka - np. budynek)
                    if (newParent == null)
                        DetachFromParentAndKeepWorldPos(); // odlaczamy sie od pojazdu
                    else
                        AttachAsChildToAndKeepWorldPos(newParent);
            
		            bUsePhysicsToDeathFall = true;
                }
            }
        }
    }

    void Execute( Actor executor )
    {
        if (GetController().m_bSitsInVehicleOnSeat)
        {
            Vector vPos = null;
            if (cSeatInfo.GetOccupiedObject() instanceof ISeatVehicle)
                vPos = ((ISeatVehicle) cSeatInfo.GetOccupiedObject()).GetCheckedPosToGetOut(cSeatInfo);

		    cSeatInfo.Occupy(null);
			cSeatInfo.Reserve(null);
            cSeatInfo = null;
            GetController().m_bSitsInVehicleOnSeat = false;
            
            ControlObject newParent = GetParent(); // to powinien byc pojazd
            if (newParent != null)
                newParent = newParent.GetParent(); // a to powinien byc parent pojazdu (dzialka - np. budynek)
            if (newParent == null)
                DetachFromParentAndKeepWorldPos(); // odlaczamy sie od pojazdu
            else
                AttachAsChildToAndKeepWorldPos(newParent);
            
            if (vPos != null)
                SetPositionWorld(vPos);
            
		    bUsePhysicsToDeathFall = true;
            Physics.Simulate(this, new Vector(0f, 0f, 0f), new Vector(0f, -1f, 0f), 1, EBones._NECK, true);
        }
        else
            super.Execute(executor);
    }
    
    String GetTip()
    {
        if (GetController().m_bSitsInVehicleOnSeat)
            return "&REMOVE_BODY&";
        else
            return "&SEARCH_BODY&";
    }    
    
	void VehicleCrashed()
	{
        Deactivate();
	}
    
    public void Respawn()
    {
        super.Respawn();
        // czyscimy po fizyce
        SetFlag(EFlags._BLOCK_MOVE |
                EFlags._NO_BODY_PHYSICS);
        ClearFlag(EFlags._NO_ANIMATION_REFRESH);
        ClearFlag(EFlags._NO_ANIMATION);
    }
    
    
    public void DyingEnd()
    {
        StopAIAnim(false);
        DisableCallMethod("DyingEnd");
    }
    
    
    
    protected boolean m_bWeaponRenderableBeforeDisappear = true;
    protected boolean m_bWeaponActivatedBeforeDisappear = true;
    public void Activate()
    {
        if (!m_bIsActive)
        {
            super.Activate();
            if (ActiveWeapon != null)
            {
                if (m_bWeaponActivatedBeforeDisappear)
                    ActiveWeapon.ActivateOnModule();
                if (m_bWeaponRenderableBeforeDisappear)
                    ActiveWeapon.EnableRendering(true);
            }
            ImplantTermovision.AddToSystem(this);
        }
    }

    
    public void Deactivate()
    {
        if (m_bIsActive)
        {
            super.Deactivate();
            if (ActiveWeapon != null)
            {
                m_bWeaponActivatedBeforeDisappear = ActiveWeapon.IsActiveOnModule();
                m_bWeaponRenderableBeforeDisappear = ActiveWeapon.IsRenderable();
                ActiveWeapon.DeactivateOnModuleAlways();
                ActiveWeapon.EnableRendering(false);
            }
            ImplantTermovision.RemoveFromSystem(this);
        }
    }

    
    /////////////////////////////////////////////////////////////////////////////
    // DEBUG'N'TEST
    // 
    public void CM_Move(int iMoveZ, int iMoveX)
    {
        m_Motion.iMoveZ = (byte)iMoveZ;
        m_Motion.iMoveX = (byte)iMoveX;
        UpdateMotion();
    }
    
    public void CM_Rotate(int iTurn)
    {
        m_Motion.iTurn = (byte)iTurn;
        UpdateMotion();
    }
    
    public void CM_Speed(int iSpeed)
    {
        m_Motion.SetSpeed((byte)iSpeed);
        UpdateMotion();
    }
    
    public void CM_Fire(boolean bFiring, boolean bAiming)
    {
        m_Motion.bFiring = bFiring;
        m_Motion.bAiming = bAiming;
        UpdateMotion();
    }
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[NewAIHuman.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_NEWAI_HUMAN)
        {
			super.SGLoadChunk(cFC);
            m_fLastPainScreamTime = cFC.LoadFloat();
            m_vLastFireDir = cFC.LoadVector();
            
            m_fTwistHeadAngleH = cFC.LoadFloat();
            m_fTwistHeadAngleV = cFC.LoadFloat();
            m_fTwistTorsoAngleH = cFC.LoadFloat();
            m_fTwistTorsoAngleV = cFC.LoadFloat();
            m_byLastBodyDeformStrafeDir = (byte)cFC.LoadInt();

            l_bWeaponRenderable = cFC.LoadBool();
            m_bWeaponRenderableBeforeDisappear = cFC.LoadBool();
            m_bWeaponActivatedBeforeDisappear = cFC.LoadBool();
            
            m_bShootingDuringMovie = cFC.LoadBool();
        }
		
		cFC.delete();
	}
    

    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[NewAIHuman.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_NEWAI_HUMAN, cFCParent);
		
		super.SGSaveChunk(cFC);

        cFC.SaveFloat(m_fLastPainScreamTime);
        cFC.SaveVector(m_vLastFireDir);

        cFC.SaveFloat(m_fTwistHeadAngleH);
        cFC.SaveFloat(m_fTwistHeadAngleV);
        cFC.SaveFloat(m_fTwistTorsoAngleH);
        cFC.SaveFloat(m_fTwistTorsoAngleV);
        cFC.SaveInt((int) m_byLastBodyDeformStrafeDir);

        cFC.SaveBool(l_bWeaponRenderable);
        cFC.SaveBool(m_bWeaponRenderableBeforeDisappear);
        cFC.SaveBool(m_bWeaponActivatedBeforeDisappear);
        
        cFC.SaveBool(m_bShootingDuringMovie);
        
        cFC.delete(); 
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[NewAIHuman.SGUpdate]\n");
		super.SGUpdate();
        
        //usuwamy, zeby nie zostal syf
        ImplantTermovision.RemoveFromSystem(this);
        if (m_bIsActive)
            ImplantTermovision.AddToSystem(this);
        
        // paramter malo istotny - po co go zapisywac - lepiej odswiezyc...
        m_fNextBlinkTime = GetTime() + RandomFloat(m_fMinTimeBtwEyeBlinks, m_fMaxTimeBtwEyeBlinks);
        
        
            

//        PlaceWeapons(); //HACK - bo nie dziala jeszcze serializacja attachowania do meshelementow
/*
        if (IsDead()) //HACK - odswiezenie extentow i ellipsoidy
            SetEllipsoid(m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY,
                         m_aTopmostLocalPos[0][MotionState.SPEED_CRAWL].fY * 2,
                         m_aTopmostLocalPos[0][MotionState.SPEED_CRAWL].fY);
        else
            SetEllipsoid(45f,
                         m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY,
                         m_aTopmostLocalPos[0][MotionState.SPEED_WALK].fY / 2);
*/        
	}
}
