public class IdleAllowed_Animal extends Generator
{
    IdleAllowed_Animal(AIController controller)
    {
        super(controller);
        
        m_GenScenarios.SetAllBits();
        
        m_GenScenarios.ClearBit(IdlePlayAnim_Animal._ID);
        m_GenScenarios.ClearBit(IdleWalk._ID);
    }
    
    void UpdateScenarios()
    {
        super.UpdateScenarios();
        
        if (m_Controller.GetAlarmLevel() > AIController._ALARM_LEVEL_LOW)
        {
#if AI_DEBUG        
            DebugUtils.AddLog(m_Controller.m_MeshAI, "GetAlarmLevel() > _ALARM_LEVEL_LOW");
#endif            
            m_CurrScenarios.Set(m_GenScenarios);
        }
        else
        {
            m_CurrScenarios.SetAllBits();
            if (!m_Controller.GetMesh().bRandomWalkAllowed)
                m_CurrScenarios.ClearBit(IdleWalk._ID);
        }
        
#if AI_DEBUG        
        DebugUtils.AddLog(m_Controller.m_MeshAI, "\n");
#endif
    }

}
