/** Pomocniczy generator wrzucajacy w specyficznym przypadku utkniecia na granicy guardowanego obszaru
 *  jeden ze scenariuszy padania na ziemie
 */

public class FallDownCheck extends Generator
{
	FallDownCheck(AIController controller)
	{
		super(controller);
        
		m_GenScenarios.SetAllBits();
		m_GenScenarios.ClearBit(FallDownToHide._ID);
		m_GenScenarios.ClearBit(FallDownToShoot._ID);
	}
	
	void UpdateScenarios()
	{
		super.UpdateScenarios();

        NewAI mesh = m_Controller.GetMesh();
        
        // zalozmy, ze nie trzeba pasc
        m_CurrScenarios.Set(m_GenScenarios);

        if ((m_Controller.GetAlarmLevel() > AIController._ALARM_LEVEL_LOW) &&
            (mesh.m_GuardedObject != null) &&
            !mesh.m_bLastGoToSuccessfull &&
            (mesh.GetDistanceTo(mesh.m_GuardedObject) > mesh.m_fGuardedAreaRadius - 150.f) &&
            !m_Controller.JustHeardDangerousObject() &&
            m_Controller.GetActiveEnemy() == m_Controller.m_Player &&
            m_Controller.IsFarAwayFromActiveEnemy() &&
            ((AIControllerHuman)m_Controller).CanLieDown())
        {
            m_CurrScenarios.ClearAllBits(); // wyczysc wszystko - wybierzemy tylko ktorys z FallDown...

#if AI_DEBUG        
            DebugUtils.AddLog(m_Controller.m_MeshAI, "Should FallDownToShoot\n");
#endif            
            m_CurrScenarios.SetBit(FallDownToShoot._ID);
        }

#if AI_DEBUG        
        DebugUtils.AddLog(m_Controller.m_MeshAI, "\n");
#endif        
	}
}
