// Zdefiniowanie '#define DEBUG_ANIMATIONS' powoduje wyswietlanie crashlogow przy problemach z animacjami
/* <-- konieczna forma komentarza, bo na //# wiesza sie edytor!!!
#define DEBUG_ANIMATIONS
//*/

import java.util.*;
import java.lang.reflect.*;
import java.io.*;

class NewAI extends Pawn 
    implements IFreezable, IObjCount, iact_Appear, iact_Freeze, ipar_PathFinder, 
    iact_ChangeWaypoint, ipar_WeaponParams, ipar_MotionSpeed, ipar_HitReaction,
    IVehiclePassenger
{
    ///////////////////////////////////////////////////////////
    // DEBUG
    //
    boolean bDebugLog = false;
    boolean bLogEditorScenarios = false;

    /** Ilosc zycia AI, jaka jest ustawiana jesli nigdzie indziej fHealth nie zostanie zmienione */
    public float fDefaultAIHealth = 100;//#NewAI;
    
    ///////////////////////////////////////////////////////////
    // Obrywanie
    /** Znacznik, ze ai ma reagowac na obrywanie (animacja postrzalu, opoznienie reakcji) */
    public boolean bHitReactionAllowed = false;//#NewAI;
    /** Znacznik, ze reakcja na postrzal (animacje itp.) chwilowo zostaly wylaczone */
    public boolean m_bHitReactionDisabled = false;
    
    public Action[] aOnEnemyDetected;//#\NewAI;Actions run when AI detects enemy (got hit or saw enemy or hear friend dying)
    public float fDetectionDelay = 5f;//#\NewAI;Delay from enemy detection to call aOnEnemyDetected actions

    public Action[] aOnDamageFromFriend;//#\NewAI;Actions run when AI got hit from friend
    public Action[] aOnDamageFromEnemy;//#\NewAI;Actions run when AI got hit from enemy
    public Action[] aOnDamageFromPlayer;//#\NewAI;Actions run when AI got hit from player
    
    /** Plik z sekwencjami animacji AI */
    String sAnimSeqFile = "";
    
    /** typy okrzykow wydawanych przez AI */
    final static int _SCREAMTYPE_PAIN_FRIEND        = 0; // postrzal od przyjaciela
    final static int _SCREAMTYPE_PAIN_ENEMY         = 1; // postrzal od wroga
    final static int _SCREAMTYPE_DEATH              = 2;
    final static int _SCREAMTYPE_ENEMY_SPOTTED      = 3;
    final static int _SCREAMTYPE_DEAD_BODY_SPOTTED  = 4; // zauwazylismy trupa
    final static int _SCREAMTYPE_GRENADE_THROW      = 5; // fire in the hole
    final static int _SCREAMTYPE_GRENADE_SPOTTED    = 6; // uwaga, czy leci z nami granat ?
    final static int _SCREAMTYPE_INFO               = 7; // informacyjne (nice shot)
    final static int _SCREAMTYPE_STRANGER_SPOTTED   = 8; // zauwazenie nierozpoznanego 
    final static int _NUM_OF_SCREAMTYPES            = 9;

    /** Minimalny zasieg dzwieku (do tej wartosci nie wygasa glosnosc) */
    public float m_fMinScreamRange = 500;
    /** Maksymalny zasieg dzwieku (powyzej tej wartosci dzwieku nie slychac) */
    public float m_fMaxScreamRange = 5000;

    /** Lista nazw katalogow (oddzielonych przecinkami) z dzwiekami AI (do losowania, jesli nie jest podany konkretny)
     */
    public String sDefaultSoundsPaths = "";//#NewAI;List (semicolon separated) of default AI sounds directories (sSoundsPath has higher priority)

    /** Katalog z dzwiekami dla tego konkretnego AI  */
    public String sSoundsPath = null;//#NewAI;Directory with this AI sounds
    
    /** Wersja sSoundsPath przygotowana do doklejenia nazwy pliku */
    private String m_sSoundsPathPrefix = null;

    /** Rodzaj ostatniego dzwieku wydanego przez AI */
    private int m_nLastScreamType = -1;
    /** Kiedy moze byc odpalony nastepny krzyk (czas) */
    private float m_fNextScreamTime = 0;
    
    /** Tablica z czasami odpalenia krzykow o okreslonym type (indeksowana przez _SCREAMTYPE_*)
     */
    float m_aNextScreamTypeTime[] = new float[_NUM_OF_SCREAMTYPES];
    
    /** Definicje dzwiekow wydawanych przez ai dla poszczegolnych _SCREAMTYPE_*
     */
    SoundsGroup[] m_aSoundsGroups = null;

    /** Znacznik, ze to AI moze komunikowac sie przez radio */
    public boolean bCanUseRadioCommunication = false;//#NewAI;
    /** Znacznik blokujacy komunikacje radiowa podczas odtwarzania filmu (jesli film tego wymaga) */
    public static boolean s_bRadioCommDisabledForMovie = false;
    /** Kwadrat odleglosci pomiedzy ai, ponizej ktorej AI uznane moze byc za peera w komunikacji radiowej bez szukania blizszego */
    public float _TEAM_RADIO_MSG_ACCEPTABLE_DIST2 = 1500 * 1500;
    /** Kwadrat odleglosci pomiedzy ai, ponizej ktorej AI moze brac udzial w komunikacji radiowej */
    public float _TEAM_RADIO_MSG_MAX_DIST2 = 4000 * 4000;
    /** Kwadrat odleglosci od sluchacza, powyzej ktorej nie sa odpalane komunikaty radiowe  */
    public float _LISTENER_RADIO_MSG_MAX_DIST2 = 5000 * 5000;

    
    /** Kontroler AI */
    AIController m_Controller = null;
    /** Nazwa klasy kontrolera AI */
    String m_sControllerClassName = null;

    /** Referencje do zmyslow AI */
    IAIHearingSense m_Hearing = null;
    IAIPainSense m_Pain = null;
    
    /** referencja na aktualny waypoint AI */
    public Waypoint cWaypoint = null;//#\AI;Reference to current AI Waypoint

    /** zapamietana referencja na pierwszy (ustawiony w edytorze) waypoint AI */
    public Waypoint cFirstWaypoint = null;
    
    /** kolejny waypoint (potrzebne przy zmianie przez ChangeWaypoint) */
    protected Waypoint m_NewWaypoint = null;
    /** zmacznik, ze zmieniono sciezke AI */
    protected boolean m_bWaypointChanged = false;
    
    /** znacznik, ze AI ma ustawiec flage _PORTAL_INDEPENDENT */
    public boolean bPortalIndependent = false;//#NewAI;
    /** znacznik, ze AI moze uzywac waypointow budynkowych */
    public boolean bAllowUsingIndoorPathfinder = true;//#NewAI;

    /** znacznik, ze AI ma zawolac Disapear na starcie */
    public boolean bDisappearOnStart = false;//#\NewAI

    public boolean bCastShadows = true;//#\NewAI

    /** Znacznik, ze AI moze sobie odpalac losowe spacerki */
    public boolean bRandomWalkAllowed = true;//#\NewAI

    /** Minimalna odleglosc na jaka AI moze podejsc do gracza idac w jego strone (0 - brak ograniczenia) */
    public float fMinWalkOnPlayerDistance = 0;//#NewAI;Min distance to player before stopping while walking in his direction
    
    /** Kosinus kata stozka, w jakim sprawdzane jest, czy gracz nie blokuje chodzenia */
    float _WALK_ON_PLAYER_ANGLE_COS = 0.85f;
    
    
    /** Znacznik, ze AI moze sie obracac podczas chodzenia */
    boolean bCanTurnWhileMoving = true;
    
    /** czy AI ma wolac akcje aOnEnemyDetected po uslyszeniu noisa strzalu lub wybuchu granata przeciwnika */
    public boolean bDetectEnemyOnNoise = true;//#\NewAI
    
    /** chromeactor, ktory zabil tego ai */
    ChromeActor m_Killer = null;
    
    /** Wspolczynnik update'owania AI */
    public float fUnimportanceFactor = 0.0015f; //#NewAI;
    
    // skin ai
    public FileName m_cSkin = null;//#NewAI;Skin of AI mesh (DEPRECATED, DO NOT USE!!!)
    
    /////////////////////////////////////////////////////////////////////////////
    // wsiadanie / wysiadanie AI
    public EnumGetInType cGetInAs = new EnumGetInType(EnumGetInType._DRIVER); //#\NewAI
    
    /////////////////////////////////////////////////////////////////////////////
    // PRZEDMIOTY W INVENTORY AI
    /** Przedmioty, ktore moze posiadac kazde AI
     *  Skladnia: nazwy przedmiotow oddzielone sa przecinkami, 
     *  przedmioty tworzace grupe (np fajki i zapalki) laczone sa przez '+' lub ' '
     *  Przed grupa moze znajdowac poprzedzony znakiem '%' procentowe 
     *  prawdopodobienstwo, ze przedmiot bedzie wrzucany do inventory 
     *  (domyslnie - m_nDefaultItemProbability [%])
     *  np m_sItems = "%5 dziurawa_gumowa_lala + pompka, %80 mlotek"
     *  UWAGA: moze sie zdarzyc, ze ktorys z przedmiotow tworzacych grupe 
     *         nie zmiesci sie do inventory
     *  UWAGA2: Healthexy maja duzy wplyw na poziom trudnosci i dodawane sa w innym miejscu (patrz FillInventory)
     */
    public String sDefaultItems = "%2 Radio";//#NewAI
    
    /** Domyslne prawdopodobienstwo wrzucania itema z m_sDefaultItems do 
     *  inventory [%]
     */
    public int nDefaultItemProbability = 50;//#NewAI
    
    /** Bron jaka AI posiada defaultowo */
    public Weapon cAIWeapon = new WeaponRifle();//#NewAI
    
    /** Wspolczynnik  */
    public float fAIWeaponLODCoef = 0.3f;//#NewAI
    
    /** Przedmioty, ktore AI pobiera sobie z levelu */
    public InvObjectInst[] aItemsFromModule = null;//#NewAI
    
    /** Przedmioty, ktore beda wrzucane do inventory konkretnego AI */
    public InvObject[] aItems = null;//#NewAI

    /** Ilosc granatow w inventory AI */
    public int nGrenades = 0;//#NewAI

    /** Ile jeszcze granatow pozostalo AI */
    int m_nGrenadesLeft = 0;

    
    ///////////////////////////////////////////////////////////////////////////////////////////////////
    // STATYSTYKI STRZELANIA
    //
    
    /** ilosc kul, ktore trafily w aktualny cel */
    int m_nRoundsHit;
    /** ilosc kul, ktore trafily w aktualny cel */
    int m_nRoundsShot;
    
    /** zamierzony wspolczynnik trafiania w cel */
    float m_fDesiredHitRatio;
    /** zapamietana wartosc m_fDesiredHitRatio */
    float m_fLastDesiredHitRatio = 0;

    /** Kat nachylenia prostej rozrzutu przy strzelaniu */
    float m_fFiringDevLineAngle;
    /** Aktualny rozrzut (pozycja na prostej: 0-1) */
    float m_fFiringDeviation;
    /** Maksymalna wartosc rozrzutu, przy ktorej jeszcze ai trafia w cel */
    float m_fMaxHitFiringDeviation = 0;

    /** Szybkosc przesuwania sie po prostej rozrzutu */
    public float m_fHitRatioChangeSpeed = 1f;
    /** Zmiana DesiredHitRatio, powyzej ktorej nastepuje wyzerowanie statystyk strzelania  */
    public float m_fCriticalDesiredHitRatioChangeThreshold = 0.1f;

    /** Czas, kiedy ostatnio sprawdzane bylo czy DesiredHitRatio za bardzo sie nie zmienilo */
    float m_fLastDesiredHitRatioChangeCheckTime;

    /** Czas, kiedy ostatnio resetowne byly statystyki strzelania (zawor bezpieczenstwa) */
    float m_fLastResetFiringStatisticsTime;
    
    /** Interwal, co jaki powinno nastepowac */
    float _DESIRED_HIT_RATIO_CHANGE_CHECK_INTERVAL = 1.f;

    /** Interwal, co jaki powinno nastepowac */
    float _MAX_RESET_FIRING_STATISTICS_INTERVAL = 8.f;

    /////////////////////////////////////////////////////////////////////////////
    
    /** Znacznik, ze po uplynieciu odpowiednio dlugiego czasu AI moze sobie odpuscic 
     * przeciwika, jesli go nie widzi
     */
    public boolean bCanForgetAboutEnemy = true;//#NewAI
    
    
    /////////////////////////////////////////////////////////////////////////////
    // MOTION STATE
    //
    
    /** Ustawiony MotionState AI */
    AIMotionState m_Motion = new AIMotionState();
    
    /** Zapamietana wartosc MotionState z poprzedniego UpdateMotion*/
    AIMotionState m_OldMotion = new AIMotionState();
    
    /** Zmodyfikwany w UpdateMotion MotionState - dostosowany do mozliwosci AI */
    AIMotionState m_ActualMotion = new AIMotionState();
    
    /** Tablica predkosci poruszania sie w zaleznosci od MotionState.iSpeed
     *  STILL, SWIM, CRAWL, DUCK, WALK, RUN
     */
    public float[] m_aMotionVelocity = {0, 70, 70, 100, 165, 500};
    
    /** Mnozniki predkosci dla strafowania */
    public float[] m_aMotionVelocityStrafeMultiplier = {0.f, 1.0f, 1.f, .6f, .5f, .5f};

    /** Tablica predkosci katowych w zaleznosci od MotionState.iSpeed (dla Turn) */
    public float[] m_aMotionAngularVelocity = { 0, 0, 30, 90, 180, 300 };

    /** Minimalny kat, dla ktorego do wykonania obrotu wlaczane sa animacje
     */
    public float m_fMinTurnAngleToUpdateMotion = 5.f;

    /** Opoznienie zawolania UpdateMotion przy zatrzymaniu (chodzenia albo obrotow) */
    public float m_fStopUpdateMotionDelay = 0.3f;
    
    /** Cosinus kata, powyzej jakiego AI powinno sie obracac przez turn gdy porusza sie 'po sciezce' */
    public float m_fMinAngleToTurnWhileMovingCos = 1.f;
    
    /////////////////////////////////////////////////////////////////////////////
    // ANIMACJE
    //
    
    /** Obiekt odpowiedzialny za odpalanie animacji AI */
    AIAnimations m_Anims = null;
    
    
    public static int _ANIM_ID_NONE   = -1;
    public static int _ANIM_ID_STRING = -2;

    /** Identyfikator aktualnie odtwarzanej (jednorazowo, nie w loopie) animacji
     */
    protected int m_nCurrentAnimID = _ANIM_ID_NONE;
    

    /////////////////////////////////////////////////////////////////////////////
    // IDENTYFIKATORY METOD
    protected int METHOD_UpdateAllTrackings = 0;
    protected int METHOD_AnimationFinished  = 0;
    protected int METHOD_CallUpdateMotion = 0;
    protected int METHOD_TurnDone = 0;
    protected int METHOD_InterpolatePositionDone = 0;
    
    /////////////////////////////////////////////////////////////////////////////
    /** Obiekt, na ktory nakierowuje cialo AI
     */
    protected ChromeActor m_TrackedObject = null;
    
    /** Znacznik, AI wodzi za cTrackedObject wzrokiem, a nie nakierowuje cale cialo
     *  (i guna)
     */
    protected boolean m_bTrackLookOnly = false;
    
    /** Znacznik, ze podczas sledzenia celu AI moze sie obrocic na fizyce */
    protected boolean m_bTrackCanTurn = true;
    
    /////////////////////////////////////////////////////////////////////////////

    /** Minimalny czas, co jaki AI updateuje nakierowanie ciala na obiekt
     */
    public float m_fMinTrackingUpdateTime = 0.3f;
    
    /** Maksymalny czas, co jaki AI updateuje nakierowanie ciala na obiekt
     */
    public float m_fMaxTrackingUpdateTime = 3.f;

    /////////////////////////////////////////////////////////////////////////////

    /** Odleglosc, na jaka slychac krzyk AI ktore wlasnie oberwalo */
    public float m_fPainScreamRange = 3000.f;
    /** Odleglosc, na jaka slychac krzyk umierajacego AI */
    public float m_fDeathScreamRange = 3000.f;
    /** Odleglosc, na jaka slychac krzyk upadajacego ciala AI */
    public float m_fDeathBodyFallRange = 1500.f;

    /** mnoznik zasiegu wydawania dzwieku (make noise) - potrzebne np. w pomieszczeniach */
    public float fMakeNoiseMult = 1f;//#NewAI;Make noise multiplier
    
    /** system waypointow dla AI w budynkach */
    WaypointSystem m_WpSystem = null;
    
    /** grupa, do ktorej nalezy to AI */
    AIGroup m_AIGroup = null;

    public int m_iPathFinderStampSize = 3;
    
    // definiujemy rysowanie kresek miedzy kolejnymi Waypointami
    public static void DefineVisualisation()
    {
        DefineDebugLine("cWaypoint", new Vector(1,1,1));
    }
    
    public static int m_nInstances = 0;
    public int m_nInstanceNumber = 0;
    
    /////////////////////////////////////////////////////////////////////////////
    // PROFILING
    String sAIProfilingPage = "AI Profiling";
    static int PROFILE_RequestEvent = 0;
    static int PROFILE_ObjectsMsg = 0;
    static int PROFILE_CalcProfile = 0;
    static int PROFILE_NoiseMsg = 0;
    static int PROFILE_PainMsg = 0;
    static int PROFILE_Recognition = 0;
    /////////////////////////////////////////////////////////////////////////////
    // BLOBS
    //
    String sBlobMaterial = null;
    float fBlobMapSize = 55;
    boolean bBlobHasFixedOrientation = true;
    
    /////////////////////////////////////////////////////////////////////////////
    // Inicjalizacja AI przy tworzeniu
    //
    NewAI()
    {
        cConflictSide = new EnumConflictSide(EnumConflictSide._COUNTER_PLAYER);
        bIsActiveTarget = true;
        bIsAITarget = true;
        fHealth = -1;
    }
    
    public void OnCreate()
    {
        //pobierz modyfikatory z leveli
        if (s_ModifiersList.size() == 0)
        {
            //jesli jeszcze nie ma
            //przy ladowaniu parametrow ze skryptu klirujemy ta tablice, wiec powinno byc ok
            java.util.Vector vModifiers = LevelsManager.GetDiffModifiers(ChromeGame.GetDiffLevel());
            for (int i = 0; i < vModifiers.size(); i++)
                AddModifier((AIParamsMod)vModifiers.elementAt(i));
        }
        // zastosuj zapodane modyfikatory
        ApplyModifiers();
        
        m_nInstanceNumber = m_nInstances++;
        
        // zainicjowanie nazwy pliku z animacjami
        int nDotPos = MeshName.lastIndexOf('.');
        if (nDotPos > 0)
            sAnimSeqFile = MeshName.substring(0, nDotPos) + ".scr";
        else
            CrashLog("[NewAI.OnCreate] ERROR: Incorrect mesh name (" + MeshName + ")\n");

        super.OnCreate();
        
        // zainicjuj waypointy
        cFirstWaypoint = cWaypoint;
        cWaypoint = null; //zeby Controller mogl wykryc poczatek sciezki
        
        // ustawienie typu kolizji
        SetCollType(ECollFlags.OBJCOL_TYPE_ELLIPSOID);
        SetCollAction(ECollFlags.OBJCOL_ACTION_SLIDE);
        SetCollHandler(ECollFlags.OBJCOL_HANDLER_FULLINFO);
        SetTraceCollType(ECollTraceFlags._ELEMENT_BOX);
        SetCollFlags(ECollFlags.OBJCOL_FLAG_NONAUTOATTACHABLE);
        
        // ustawienie flag
        if (bCastShadows)
            SetFlag(EFlags._CAST_SHADOWS);
        else
            ClearFlag(EFlags._CAST_SHADOWS);
        SetFlag(EFlags._COLLISION | EFlags._BLOCK_MOVE | EFlags._BLOCK_TRACE | 
                EFlags.USE_TERRAIN_LIGHTMAP_FOR_LIGHTING);
        ClearFlag(EFlags._NO_ANIMATION | EFlags._NO_ANIMATION_REFRESH | EFlags._RECEIVE_SHADOWS);
        
        SetPhysicsType(EPhysics._WALK);
        SetPhysicsActive(true);
        SetAngSpeed(0);
        SetSpeedValue(0);
        
        SetUnImportanceFactor(fUnimportanceFactor);
        
        if (sBlobMaterial != null)
            SetBlobMaterial(sBlobMaterial);
        SetBlobMapSize(fBlobMapSize);
        SetBlobFixedOrientation(bBlobHasFixedOrientation);
        
        METHOD_UpdateAllTrackings = RegisterCallMethod("UpdateAllTrackings");
        METHOD_AnimationFinished = RegisterCallMethod("AnimationFinished");
        METHOD_CallUpdateMotion = RegisterCallMethod("CallUpdateMotion");
        METHOD_TurnDone = RegisterCallMethod("TurnDone");
        METHOD_InterpolatePositionDone = RegisterCallMethod("InterpolatePositionDone");
       
//DEL USUNIETE, BO POWODUJE KONFLIKTY Z NOWYM SYSTEMEM SKINOW        
//DEL        // zaladowanie skina ustawionego w AI
//DEL        if(m_cSkin != null)
//DEL           LoadSkin(m_cSkin);
        
        if (bPortalIndependent)
        {
            SetFlag(EFlags._PORTAL_INDEPENDENT);
            //odlacz od budynku, bo inaczej system portali i tak ci nie przepusci
            DetachFromParentAndKeepWorldPos();
        }
        
        // PROFILING
        if (m_nInstanceNumber == 0)
        {
            PROFILE_RequestEvent = ProfileAdd(sAIProfilingPage, "Request Event");
            PROFILE_CalcProfile = ProfileAdd(sAIProfilingPage, "AI Calculation");
            PROFILE_ObjectsMsg = ProfileAdd(sAIProfilingPage, "Objects Message");
            PROFILE_NoiseMsg = ProfileAdd(sAIProfilingPage, "Noise Message");
            PROFILE_PainMsg = ProfileAdd(sAIProfilingPage, "Pain Message");
            PROFILE_Recognition = ProfileAdd(sAIProfilingPage, "Recognition");
        }
        
        InitSounds();
        /** Zmiana parametrow w zaleznosci od mesha (i ew. skina)  */
        InitParamsFromMesh();
        
        // zainicjuj maksymalne zycie AI (do sprawdzania, czy bardzo ucierpial)
        // zalozenie: w edytorze ustawiamy fHealth
        fMaxHealth = fHealth;

        //TST:        
        //RegisterKeyRequest();
    }
    
    
    public void LogMatrix()
    {
        CrashLog(GetName() + "(Up: " + GetUpVector() +
                 ",Forward: " + GetForwardVector() +
                 ",Pos: " + GetPosition() + ")\n");
    }
    
    public void OnPostCreate()
    {
        CreateController(m_sControllerClassName);

        Initialize();
        CallMethodIn(METHOD_CallUpdateMotion, 0f); 

        CallMethodEveryMinMax(METHOD_UpdateAllTrackings, 
                              m_fMinTrackingUpdateTime, 
                              m_fMaxTrackingUpdateTime, 
                              m_fMinTrackingUpdateTime * GetTimeDeviation());

        if ( WaypointSystem.InBuilding(this) )
        {
            WaypointSystem.CorrectPosInBuilding(this, 25f);
            
            m_bUsePathfinder = false;
            m_bUseIndoorPathfinder = true;
            
            // najpierw probujemy ladowac
            m_WpSystem = null;
            m_WpSystem = WaypointSystem.LoadWaypoints(this);
            
            if (m_WpSystem == null)
            {
                m_WpSystem = new WaypointSystem(this);
                m_WpSystem.GenerateWaypoints();
            }
        }
        UsePathfinder(m_bUsePathfinder); //refreshowanie flag        

        if (bDisappearOnStart)
            Disappear(null);
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        
        m_nInstances--;
    }
    
    public float GetTimeDeviation()
    {
        return (float)m_nInstanceNumber / (float)m_nInstances;
    }
    

    protected String GetRandomSoundsDirectory()
    {
        String token;
        StringTokenizer defaultSoundDirs = new StringTokenizer(sDefaultSoundsPaths, ";", false);
        ArrayList dirsArray = new ArrayList();
        File dir;
        while (defaultSoundDirs.hasMoreTokens())
        {
            token = defaultSoundDirs.nextToken();
            dir = new File(token);
            if (dir.exists() && dir.isDirectory())
                dirsArray.add(token);
        }
        if (dirsArray.size() > 0)
            return (String)dirsArray.get(RandomInt(dirsArray.size()));
        else
            return "";
    }

    
    void Initialize()
    {
        InitializeAIWeapon();
        if (m_nInstanceNumber == 0)
            InitializeCommSystem((ChromeModuleSingle) GetModule());
    }
    
    /////////////////////////////////////////////////////////////////////////////
    
    /** Zwraca punkt, z ktorego patrzy AI
     */
    public Vector GetLookFromPoint()
    {
        return GetPosition();
    }

    /** Pobranie pozycji z ktorej strzela AI dla podanego iSpeed'a i przycelowania
     *  UWAGA: Zalezy od rodzaju AI - pokryc w klasach pochodnych
     */
    public Vector GetBarrelPos(byte iSpeed, boolean bAiming)
    {
        return GetPosition();
    }
    
    /** Pobranie wysokosci znad ziemi z ktorej strzela AI dla podanego iSpeed'a i przycelowania
     *  UWAGA: Zalezy od rodzaju AI - pokryc w klasach pochodnych
     */
    public float GetBarrelHeightOverGround(byte iSpeed, boolean bAiming)
    {
        return 150f;
    }
    
    /** Pobranie pozycji wyznaczajacej w przyblizeniu najwyzej polozony punkt AI
     *  w ktory mozna puscic tarce'a (dla podanego iSpeed'a i przycelowania)
     *  UWAGA: Zalezy od rodzaju AI - pokryc w klasach pochodnych
     */
    public Vector GetTopmostPoint(byte iSpeed, boolean bAiming)
    {
        Vector vMax = new Vector(),
            vMin = new Vector();
        GetMeshExtentsInWorld(vMin, vMax);
        float fY = vMax.fY - 5;
        vMax.Add(vMin);
        vMax.Mul(0.5f);
        vMax.fY = fY;
        return vMax;
    }

    /** Zraca pozycje guna do trace'owania, czy przeciwnik jest widoczny z guna. Metoda
     * konieczna do poprawnego dzialania walkera */
    public Vector GetVisibilityCheckFireOrigin()
    {
        return GetFireOrigin();
    }
    
    /** Wylaczenie wszystkich czynnosci zyciowych po smierci AI */
    void DisableBodyActivities()
    {
        StopGoTo();
        StopTurn();
        StopInterpolatePosition(false);
        StopTrackingObject();
        SetPhysicsActive(false);
        StopAIAnim(false);
        
        DisableCallMethod(METHOD_UpdateAllTrackings);
        DisableCallMethod(METHOD_CallUpdateMotion);
    }
    
/*  Ponizsze przeciazone metody sa niepotrzebne, gdyz wylaczanie cienia
    dla obiektow nierenderujacych sie badz nieaktywnych na module
    realizowane jest w C++
    
    public void EnableRendering(boolean bEnable)
    {
        super.EnableRendering(bEnable);
        UpdateShadowCasting();
    }
    
    public void ActivateOnModule()
    {
        super.ActivateOnModule();
        UpdateShadowCasting();
    }

    public void DeactivateOnModule()
    {
        super.DeactivateOnModule();
        LogR("[NewAI.DeactivateOnModule] WARNING: This method is obsolete and dangerous and shouldn't be used any more!!!\n");
        UpdateShadowCasting();
    }
    
    public void ActivateOnModuleGridIndependent()
    {
        super.ActivateOnModuleGridIndependent();
        UpdateShadowCasting();
    }

    public void DeactivateOnModuleGridIndependent()
    {
        super.DeactivateOnModuleGridIndependent();
        LogR("[NewAI.DeactivateOnModuleGridIndependent] WARNING: This method is obsolete and dangerous and shouldn't be used any more!!!\n");
        UpdateShadowCasting();
    }
    
    public void DeactivateOnModuleAlways()
    {
        super.DeactivateOnModuleAlways();
        UpdateShadowCasting();
    }

    void UpdateShadowCasting()
    {
        if (bCastShadows && IsActiveOnModule() && IsRenderable())
            SetFlag(EFlags._CAST_SHADOWS);
        else
            ClearFlag(EFlags._CAST_SHADOWS);
    }
*/
    /////////////////////////////////////////////////////////////////////////////
    // Obsluga akcji edytorowych
    //
    public void Appear(ControlObject m_cRefMtxHolder)
    {
        if (m_cRefMtxHolder != null && 
            m_cRefMtxHolder.GetPositionVectorVolatile() != null)
        {
            Vector vPos = GetInFormationPosition(m_cRefMtxHolder.GetPositionVectorVolatile(), null);
            UpdatePathMap(false);
            FromUpForwardPos(m_cRefMtxHolder.GetUpVectorVolatile(),
                             m_cRefMtxHolder.GetForwardVectorVolatile(),
                             vPos);
            if (m_bUsePathfinder)
                UpdatePathMap(true); // przywroc stampa po ukryciu
            UpdatePortals();
            UpdateWaypointSystem(vPos);
        }        
        
        Activate();
    }
    
    public void Disappear(ControlObject m_cRefMtxHolder)
    {
        if (m_cRefMtxHolder != null && 
            m_cRefMtxHolder.GetPositionVectorVolatile() != null)
        {
            UpdatePathMap(false); // wylaczenie stampa
            Vector vPos = GetInFormationPosition(m_cRefMtxHolder.GetPositionVectorVolatile(), null);
            FromUpForwardPos(m_cRefMtxHolder.GetUpVectorVolatile(),
                             m_cRefMtxHolder.GetForwardVectorVolatile(),
                             vPos);
            UpdatePortals();
            UpdateWaypointSystem(vPos);
        }        
        Deactivate();
    }


    /** Przyataczowanie do odpowiedniego poltal objectu
     */
    void UpdatePortals()
    {
        Vector vMove = new Vector(0, -100, 0);
        MoveByEllipsoid(vMove); // to powinno wystarczyc ;-)
    }
    
    /** Znalezienie 'najbardziej poprawnego' waypointa */
    void UpdateWaypointSystem(Vector vPos)
    {
        if (m_WpSystem != null)
        {
            short nearest = m_WpSystem.FindNearestPoint(vPos);
            if (nearest >= 0)
                m_WpSystem.m_CurrWaypoint = nearest;
        }
    }
    
    ////////////////////////////////////////////////////////////////////////////
    // TRACE'OWANIE AI
    //
    public static int _AITRACE_NO_FLAGS     = 0;
    public static int _AITRACE_IGNORE_GLASS = 1;
    
    private static int[] l_aExcludeObjectsOldFlags = new int[5];
    static Collision AITrace(ControlObject objToCall, Vector vStart, Vector vEnd,
                             int nAITraceFlags,
                             ControlObject[] aExcludeObjects)
    {
        ControlObject obj;
        int excludeObjectsCount = 0;
        if (aExcludeObjects != null)
        {
            excludeObjectsCount = aExcludeObjects.length;
            // jesli trzeba, zwieksz rozmiar tablicy na zapamietane flagi
            if (excludeObjectsCount > l_aExcludeObjectsOldFlags.length)
                l_aExcludeObjectsOldFlags = new int[excludeObjectsCount];
            // zapamietaj flagi i wylacz blocktrace dla excludowanych
            for (int i = 0; i < excludeObjectsCount; i++)
            {
                obj = aExcludeObjects[i];
                if (obj != null)
                {
                    l_aExcludeObjectsOldFlags[i] = obj.GetFlags();
                    obj.ClearFlag(EFlags._BLOCK_TRACE);
                }
            }
        }
        
        Collision collCurr, collAll;
        collAll = objToCall.TraceTerrain(vStart, vEnd);
        
        collCurr = objToCall.TraceTrees(vStart, vEnd);
        if (collCurr != null)
            collAll = collCurr;

        int nFaceIgnoreFlags = EFaceFlags.NO_BLOCK_RAY;
        if ((nAITraceFlags & _AITRACE_IGNORE_GLASS) != 0)
            nFaceIgnoreFlags |= EFaceFlags.SEE_THROUGH;
        collCurr = new Collision(); // to niezbyt ladne - kiedys to trzeba przerobic
        if (objToCall.TraceObjectsWithFaceFlags(collCurr, vStart, vEnd, 
                                                0, //defaultowe flagi i tak sa ustawiane
                                                nFaceIgnoreFlags))
        {
            collAll = collCurr;
        }

        // przywroc poprzednie flagi
        for (int i = 0; i < excludeObjectsCount; i++)
        {
            obj = aExcludeObjects[i];
            if (obj != null)
                obj.SetFlags(l_aExcludeObjectsOldFlags[i]);
        }
        return collAll;
    }
    
    Collision AITrace(Vector vStart, Vector vEnd,
                      int nAITraceFlags,
                      ControlObject[] aExcludeObjects)
    {
        return AITrace(this, vStart, vEnd, nAITraceFlags, aExcludeObjects);
    }
/*    
    private static Vector l_vOnCollMove      = new Vector();
    private static Vector l_vTraceStart      = new Vector();
    private static Vector l_vTraceEndNonExcl = new Vector();

    Collision AITrace(Vector vStart, Vector vEnd, 
                      int nAITraceFlags, 
                      ControlObject[] aExcludeList)
    {
        l_vTraceStart.Set(vStart);
        
        l_vOnCollMove.Set(vEnd);
        l_vOnCollMove.Sub(vStart);
        float len = l_vOnCollMove.Len();
        
        if (len < MathUtils._SMALL_03) //straszniekrotkitrejs
            return null;

        l_vOnCollMove.Mul(0.1f / len);

        Collision collTerrain, collTrees, 
            collObjects, collAll = null;
        int nPossibleGlassObjectsLeft = 100;
        
        ControlObject currentExclude = null;
        if (aExcludeList != null && aExcludeList.length > 0)
            currentExclude = aExcludeList[0];

        do {
            collTerrain = TraceTerrain(l_vTraceStart, vEnd);
            collAll = collTerrain;
            
            collTrees = TraceTrees(l_vTraceStart, vEnd);
            if (collTrees != null)
                collAll = collTrees;
            
            l_vTraceEndNonExcl.Set(vEnd);
            
            if (currentExclude != null)
                collObjects = TraceObjectsExclude(l_vTraceStart, vEnd, currentExclude);
            else
                collObjects = TraceObjects(l_vTraceStart, vEnd);

            if (collObjects != null)
            {
                // sprawdz, czy nie trzeba pominac jakiegos obiektu z aExcludeList
                if (collObjects.Obstacle != null && aExcludeList != null)
                {
                    for (int i = 0; i < aExcludeList.length; i++)
                        if (collObjects.Obstacle == aExcludeList[i])
                        {
                            currentExclude = aExcludeList[i];
                            break;
                        }
                }
                
                if(((nAITraceFlags & _AITRACE_IGNORE_GLASS) != 0) && 
                   (collObjects.nMaterial == EMaterialType._GLASS)) // trafienie w szybe
                {
                    l_vTraceStart.Set(vEnd);
                    l_vTraceStart.Add(l_vOnCollMove);
                    vEnd.Set(l_vTraceEndNonExcl);
                }
                else // nie glass i nie exclude (cont) - obiekt jest przeszkoda
                {
                    collAll = collObjects;
                    break;
                }
            }
            else
                break; // wyjdz z petli

            nPossibleGlassObjectsLeft--;
        } while(nPossibleGlassObjectsLeft > 0);
        
        return collAll;
    }
*/
    
    /////////////////////////////////////////////////////////////////////////////
    // AI wystepujace w filmach
    //

    /** Rozpoczecie udzialu w filmie dla tego AI
     *  Metoda wolana gdy AI bierze udzial w filmie i moze byc przez niego przestawione
     */
    public void StartMovieActing()
    {
    }

    /** Zakonczenie udzialu w filmie dla tego AI
     *  Metoda wolana gdy AI bierze udzial w filmie i moze byc przez niego przestawione
     */
    public void StopMovieActing()
    {
        Vector vPos = GetPositionVectorVolatile();
        UpdateWaypointSystem(vPos);
        UpdatePortals();
    }
    /////////////////////////////////////////////////////////////////////////////
    
    /////////////////////////////////////////////////////////////////////////////
    // Implementacja IFreezable
    //
    protected boolean m_bIsFrozen = false;
    private boolean m_bWasPhysicsActiveBeforeFreeze = false;
    
    public void Freeze()
    {
        if (!IsFrozen())
        {
            m_bIsFrozen = true;
            m_bWasPhysicsActiveBeforeFreeze = GetPhysicsActive();
            SetPhysicsActive(false);
            FreezeCallMethods();
            StopAnim("");
            if (m_Controller != null)
                m_Controller.Freeze();
            if (ActiveWeapon != null)
                ActiveWeapon.FreezeCallMethods();
        }
    }
    
    
    public void Unfreeze()
    {
        if (IsFrozen())
        {
            m_bIsFrozen = false;
            if (m_bWasPhysicsActiveBeforeFreeze)
                SetPhysicsActive(true);
            UnfreezeCallMethods();
            StartAnim("");
            if (m_Controller != null)
                m_Controller.Unfreeze();
            if (ActiveWeapon != null)
                ActiveWeapon.UnfreezeCallMethods();
        }
    }
    
    
    public boolean IsFrozen()
    {
        return m_bIsFrozen;
    }
    
    
    public void Die()
    {
        if (!IsDead())
        {
            super.Die();
            if (m_CommSystem != null)
                m_CommSystem.BreakRadioMessage(this);
            
            if (m_Controller != null)
                m_Controller.Die();
            
            if (GetAIGroup() != null)
                GetAIGroup().MemberDie(this);
            
            DisableBodyActivities();
            
            //FIXIT chamski hack zamykajacy drzwi po smierci
            ((ChromeModule)GetModule()).GetDoorControler().IsNearDoorable(this);
        }
    }
    
    public void Respawn()
    {
        bDead = false;
        fHealth = fMaxHealth;
        if (m_Controller != null)
            m_Controller.Respawn();
        CallMethodIn(METHOD_CallUpdateMotion, 0);
    }
    
    
    public boolean IsDead()
    {
        return bDead;
    }
    /////////////////////////////////////////////////////////////////////////////
    protected boolean m_bIsActive = true;
    protected boolean m_bWasFrozenBeforeDeactivate = false;
    
    public void Activate()
    {
        if (!m_bIsActive)
        {
            if (!m_bWasFrozenBeforeDeactivate)
                Unfreeze();
            
            ActivateOnModule();
            EnableRendering(true);

            m_bIsActive = true;
            if (m_Controller != null)
                m_Controller.NotifyMeshActivation(true);
        }
    }

    public void Deactivate()
    {
        if (m_bIsActive)
        {
            m_bWasFrozenBeforeDeactivate = IsFrozen();
            Freeze();
            
            DeactivateOnModuleAlways();
            EnableRendering(false);
            
            m_bIsActive = false;
            if (m_Controller != null)
                m_Controller.NotifyMeshActivation(false);
        }
    }

    /////////////////////////////////////////////////////////////////////////////
    void CreateController(String sControllerClassName)
    {
        if (sControllerClassName == null)
        {
            CrashLog("sControllerClassName == null\n");
            return;
        }
        
        m_Controller = (AIController) CreateObject(sControllerClassName);
        
        if (m_Controller == null)
        {
            CrashLog("Error in creating AIController of class:" + sControllerClassName + "\n");
            return;
        }
        
        m_Controller.InitController(this);
    }
    
    public AIController GetController()
    {
        return m_Controller;
    }
    
    void SetAIGroup(AIGroup group)
    {
        m_AIGroup = group;
    }
    
    AIGroup GetAIGroup()
    {
        return m_AIGroup;
    }

    /** Pobranie docelowej pozycji w swiecie z zachowaniem formacji
     */
    public Vector GetInFormationPosition(Vector vGroupPos, Vector vGroupDir)
    {
        if (m_AIGroup != null)
            return m_AIGroup.GetMemberFormationPosition(this, vGroupPos, vGroupDir);
        else
            return vGroupPos;
    }
    
    void SetHearing(IAIHearingSense hearing)
    {
        m_Hearing = hearing;
    }
    
    
    void SetPainSense(IAIPainSense pain)
    {
        m_Pain = pain;
    }
    

    public void OnCollisionFullInfo(ControlObject Col, Vector vPoint, Vector vNormal)
    {
        m_Controller.CollisionMsg(Col, vPoint, vNormal);
    }

    
    public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
    {
        if (m_Hearing != null && !IsDead() && !IsFrozen())
            m_Hearing.OnHearNoise(Noisy, fNoiseLevel, nNoiseType);
    }
    
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        // powiadom przeciwnika, ze trafil
        if (Assassin instanceof ChromeActor)
            ((ChromeActor)Assassin).NotifyHit(this, nDamageType);

        if (m_Pain != null && !IsDead() && !IsFrozen())
            m_Pain.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        MakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        if (bHitReactionAllowed && !m_bHitReactionDisabled)
            HitReaction(vSpeed);
        
        // zawolaj handlery
        if (Assassin instanceof Player && aOnDamageFromPlayer != null)
            InvokeActionChain(aOnDamageFromPlayer);
        
        if (Assassin instanceof ChromeActor)
        {
            ChromeActor actor = (ChromeActor)Assassin;
            if (aOnDamageFromFriend != null && IsFriend(actor))
                InvokeActionChain(aOnDamageFromFriend);
            
            if (aOnDamageFromEnemy != null && IsEnemy(actor)) // bez else, bo ma byc rozbudowany system rozpoznawania wrog/przyjaciel ;-)
                InvokeActionChain(aOnDamageFromEnemy);
        }
    }
    
    public void HitReaction(Vector vHitDir)
    {
    }

    public void MakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation,
                           Vector vSpeed, int nMeshElementorBoneID, int nDamageType, boolean bClampDamage)
    {
        float fMultiplier = GetDamageMultiplier(nMeshElementorBoneID);

        // odebranie energii
        fDamage *= fMultiplier;
        Damage(fDamage, nDamageType);
    }
    
    boolean DetectEnemyOnNoise()
    {
        return bDetectEnemyOnNoise;
    }
    ////////////////////////////////////////////////////////////////////////
    // Animacje AI
    //
#if DEBUG_ANIMATIONS
    HashMap m_MissingAnims = new HashMap(); // ustawiane w setuserseqid
    HashSet m_MissingAnimsLogged = new HashSet(); // eliminacja powtorzen
    
    
    public void SetUserSeqID(String sSequence, int nUserSeqID)
    {
        super.SetUserSeqID(sSequence, nUserSeqID);
        if (super.GetAnimID(0, nUserSeqID) < 0)
        {
            Integer key = new Integer(nUserSeqID);
            String value = (String)m_MissingAnims.get(key);
            if (value == null)
                m_MissingAnims.put(key, new String(sSequence));
            else
            {
                if (value.compareTo(sSequence) != 0)
                    CrashLog("ERROR: SetUserSeqID: Redeclaration of user seq id (\"" + 
                             value + "\", \"" + sSequence + "\")!!!\n");
            }
        }
    }
    
    public int GetAnimID(int nElemID, int nUserSeqID)
    {
        int result = super.GetAnimID(nElemID, nUserSeqID);
        if (result < 0)
        {
            Integer key = new Integer(nUserSeqID);
            String value = (String)m_MissingAnims.get(key);
            if (value != null && !m_MissingAnimsLogged.contains(value))
            {
                m_MissingAnimsLogged.add(value);
                CrashLog("WARNING: " + GetName() + ".GetAnimID(int, int) for non existing anim: \"" + value + "\"!!!\n");
            }
        }
        return result;
    }
    
    
    public int GetAnimID(String sElement, String sSequence)
    {
        int result = super.GetAnimID(sElement, sSequence);
        if (result < 0)
        {
            if (!m_MissingAnimsLogged.contains(sSequence))
            {
                m_MissingAnimsLogged.add(sSequence);
                CrashLog("WARNING: " + GetName() + ".GetAnimID(String, String) for non existing anim: \"" + sSequence + "\"!!!\n");
            }
        }
        return result;
    }

#endif
    /** Zmiana czasu Morphingu w zaleznosci od aktualnego stanu ai  */
    void UpdateMorphTime()
    {
    }
    
    /** Odtworzenie animacji jeden raz */
    final public void PlayAIAnim(int nID)
    {
        PlayAIAnim(nID, 1);
    }

    
    /** Odtworzenie animacji podana ilosc razy */
    public void PlayAIAnim(int nID, int nTimes)
    {
        if (nTimes > 0)
        {
            UpdateMorphTime();
            m_nCurrentAnimID = nID;
            m_Anims.Play(nID, nTimes);
            CallMethodOnceIn(METHOD_AnimationFinished, m_Anims.GetLength(nID) * nTimes);
        }
    }
    
    
    /** Odtworzenie animacji podana ilosc razy */
    final public void PlayAIAnim(String sSequenceName, int nTimes)
    {
        if (nTimes > 0)
        {
            UpdateMorphTime();
            m_nCurrentAnimID = _ANIM_ID_STRING;
            int nID = GetAnimID(m_Anims.m_sRootElementName, sSequenceName);
            StartAnim("");
            PlayAnim(nID, nTimes);
            CallMethodOnceIn(METHOD_AnimationFinished, GetAnimLength(sSequenceName) * nTimes);
        }
    }

    
    /** Odtwarzanie animacji w kolko */
    public void PlayAIAnimLoop(int nID)
    {
        UpdateMorphTime();
        m_Anims.PlayLoop(nID);
    }
    
    
    /** Pobranie dlugosci animacji */
    final public float GetAIAnimLength(int nID)
    {
        return m_Anims.GetLength(nID);
    }
    
    
    /** Zatrzymanie odtwarzania animacji odpalonej przez PlayAIAnim */
    final public void StopAIAnim(boolean bControllerNotification)
    {
        m_Anims.Stop("");
        DisableCallMethod(METHOD_AnimationFinished);

        if (m_nCurrentAnimID != _ANIM_ID_NONE)
        {
            int lastAnimID = m_nCurrentAnimID;
            m_nCurrentAnimID = _ANIM_ID_NONE;
            if (bControllerNotification)
                m_Controller.AnimationStopped(lastAnimID);
        }
    }

    
    /** Metoda wolana po czasie potrzebnym na odegranie animacji
     */
    protected void AnimationFinished()
    {
        if (m_nCurrentAnimID != _ANIM_ID_NONE)
        {
            int lastAnimID = m_nCurrentAnimID;
            m_nCurrentAnimID = _ANIM_ID_NONE;
            m_Controller.AnimationEnd(lastAnimID);
        }
    }

    ////////////////////////////////////////////////////////////////////////
    // SLEDZENIE CELU CIALEM
    //
    
    /** Rozpoczecie sledzenia podanego celu (nakierowywania ciala) 
     *  @param cTarget sledzony cel
     *  @param bLookOnly znacznik, ze AI tylko wodzi wzrokiem (a nie np gunem)
     *  @return true, gdy mozliwe jest sledzenie podanego celu w podany sposob
     */
    public boolean StartTrackingObject(ChromeActor cTarget, boolean bLookOnly, boolean bCanTurn)
    {
        m_TrackedObject = cTarget;
        m_bTrackLookOnly = bLookOnly;
        m_bTrackCanTurn = bCanTurn;
        return (cTarget != null);
    }
    
    
    /** Zakonczenie sledzenia celu (nakierowywania ciala) 
     *  @return true, gdy byl sledzony jakis obiekt
     */
    public boolean StopTrackingObject()
    {
        if (m_TrackedObject != null)
        {
            m_TrackedObject = null;
            return true;
        }
        return false;
    }
    
    
    /** Update ustawienia ciala AI w kierunku sledzonego obiektu
     */
    protected void UpdateTrackingObject()
    {
    }
    ////////////////////////////////////////////////////////////////////////

    /** Zwraca kierunek, w ktorym aktualnie patrzy AI (do pokrycia w klasach pochodnych)
     */
    public Vector GetLookDir()
    {
        return GetForwardVector();
    }
    
    ////////////////////////////////////////////////////////////////////////
    protected void UpdateAllTrackings()
    {
        if (m_TrackedObject != null)
            UpdateTrackingObject();
        UpdateTrackingDir();

        // wizualizacja biezacego waypointa
        if (m_bWPVis)
            m_ToCurrWPLine.PointFromTo(GetPositionVectorVolatile(), m_WpSystem.GetCurrWPPos());
    }
    
    // ustawienie AI do pionu jesli od niego odstaje
    protected void TryToVerticalize()
    {
        if (GetUpVectorVolatile().fY < 0.999f) // sprawdz czy wektor do gory nie odstaje od pionu (>2.5[deg])
        {
            ControlObject parent = GetParent();
            if (!(parent instanceof Vehicle ||
                  parent instanceof StationaryCannon ||
                  parent instanceof FlyingVehicle ||
                  parent instanceof NewAIWalker))
            {
                CrashLog("WARNING: AI sie przekrzywil (" + GetName() + "), parent = " +
                         parent + "\n");
                //CHAMSKI ^ 2 trick
                FromUpForwardPos(Vector.Up, GetForwardVectorVolatile(), GetPositionVectorVolatile());
            }
        }
    }
    ////////////////////////////////////////////////////////////////////////
    
    public final static float _COS_1_PI_BY_8 = (float)Math.cos(Math.PI * 1./8.);
    public final static float _COS_2_PI_BY_8 = (float)Math.cos(Math.PI * 2./8.);
    public final static float _COS_3_PI_BY_8 = (float)Math.cos(Math.PI * 3./8.);
    public final static float _COS_4_PI_BY_8 = (float)Math.cos(Math.PI * 4./8.);
    public final static float _COS_5_PI_BY_8 = (float)Math.cos(Math.PI * 5./8.);
    public final static float _COS_6_PI_BY_8 = (float)Math.cos(Math.PI * 6./8.);
    public final static float _COS_7_PI_BY_8 = (float)Math.cos(Math.PI * 7./8.);

    
    protected void CalcMotionStateFromSpeedDir(AIMotionState cMotion, 
                                               Vector vBodyForward,
                                               Vector vSpeedDir)
    {
        //ustaw zerowa predkosc
        cMotion.iMoveX = cMotion.iMoveZ = 0;

        vSpeedDir.fY = 0;
        float fSpeedLen = vSpeedDir.Len();
        if (fSpeedLen > 0.1f)
        {
            vSpeedDir.Mul(1.f / fSpeedLen);
            vBodyForward.fY = 0;
            vBodyForward.Normalize();

            float fDot = vBodyForward.Dot(vSpeedDir);
            if (fDot > _COS_3_PI_BY_8) // kat < (3/8)PI
                cMotion.iMoveZ = 1;
            else if (fDot < _COS_5_PI_BY_8) // kat > (5/8)PI
                cMotion.iMoveZ = -1;
            
            if (fDot < _COS_1_PI_BY_8 &&
                fDot > _COS_7_PI_BY_8)
                cMotion.iMoveX = 1;

            // oblicz skladowa fY z Crossa - do zbadania kierunku
            if (vBodyForward.fZ * vSpeedDir.fX - 
                vSpeedDir.fZ * vBodyForward.fX < 0)
                cMotion.iMoveX *= -1;
        }
    }
    
    /** Ustawia pola iMoveX i iMoveZ w MotionState na podstawie kierunku predkosci 
     */
    public void CalcMotionStateFromSpeedDir(AIMotionState cMotion)
    {
        CalcMotionStateFromSpeedDir(cMotion, GetForwardVector(), GetSpeed());
    }
    
    /** Handler do wolania UpdateMotion przez CallMethod
     */
    public void CallUpdateMotion()
    {
        UpdateMotion();
    }
    
    public void CallOrRemoveUpdateMotion()
    {
        if (m_Motion.IsEqual(m_OldMotion))
            DisableCallMethod(METHOD_CallUpdateMotion);
        else
            CallUpdateMotion();
    }
    
    /** Wlacza odpowiednia animacje na podstawie parametrow opisujacych 
     *  stan z MotionState AI
     *  @return czas potrzebny na przejscie do nowego MotionState'a
     */
    public float UpdateMotion()
    {
        DisableCallMethod(METHOD_CallUpdateMotion);
        m_OldMotion = new AIMotionState(m_Motion);
        return 0;
    }
    
    ////////////////////////////////////////////////////////////////////////
    // Poruszanie sie AI
    //
    protected boolean m_bUsePathfinder = true;
    protected boolean m_bUseIndoorPathfinder = true;
    
    protected Vector m_aCurrentGoToPath[] = null;
    protected int m_nCurrentGoToPathLen = 0;
    protected int m_nWaypointsInPath = 0;
    protected Vector m_vCurrentGoToPoint = null;
    protected int m_nCurrentGoToPathIdx = 0;
    protected Vector m_vGoToDestination = new Vector();
    protected float m_fDestinationRadius = 50.f;

    protected boolean m_bLastGoToSuccessfull;

    
    protected ControlObject m_GuardedObject = null;
    protected float m_fGuardedAreaRadius = 0;
    protected boolean m_bGuardCritical = false;
    
    private Vector m_vValidEnd = new Vector();
    
    /** Modyfikacja pozycji, by dojscie do niej nie spowodowalo ODEJSCIA dalej niz
     *  na m_fGuardAreaRadius od pozycji obiektu m_GuardedObject. Jesli to niemozliwe
     *  zwracana jest pozycja startowa
     */
    protected Vector GetValidGoToPosition(Vector vStart, Vector vEnd)
    {
        Vector vGuardedPos;
        m_vValidEnd.Set(vEnd);
        m_vValidEnd.fY = 0;
        
        //        CrashLog("GetValidGoToPosition: vStart = " + vStart + 
        //                 " vEnd = " + vEnd);
        
        if (m_fGuardedAreaRadius > 0 &&
            m_GuardedObject != null &&
            (vGuardedPos = m_GuardedObject.GetPosition()) != null)
        {
            float fEndDist = MathUtils.dist2D(vGuardedPos, vEnd);

            if (fEndDist > m_fGuardedAreaRadius) // jesli punkt koncowy za daleko
            {
                //                CrashLog("[end:out]");
                float fStartDist = MathUtils.dist2D(vGuardedPos, vStart);
                if (fStartDist > m_fGuardedAreaRadius) // zaczynal na zewnatrz
                {
                    //                    CrashLog("[start:out]");
                    if (fStartDist < fEndDist) 
                    {
                        m_vValidEnd.Set(vStart); //oddali sie - lepiej niech nie idzie wcale
                        //                        CrashLog("[wrong_dir]");
                    }
                }
                else // zaczynal w srodku, ale chce wyjsc - skroc droge
                {
                    m_vValidEnd.Sub(vStart);
                    float fLenFactor = (m_fGuardedAreaRadius - fStartDist) / fEndDist;
                    m_vValidEnd.fX *= fLenFactor;
                    m_vValidEnd.fZ *= fLenFactor;
                    m_vValidEnd.Add(vStart);
                    m_vValidEnd.fY = 0;
                    //                    CrashLog("[start:in], m_vValidEnd = " + m_vValidEnd);
                }
            }
        }
        //        CrashLog("\n");

        return m_vValidEnd;
    }
    
    /** Obliczenie wartosci predkosci poruszania sie dla aktualnego MotionState'a */
    float GetSpeedValueForActualMotion()
    {
        return GetSpeedValueForMotion(m_ActualMotion);
    }
    
    /** Obliczenie wartosci predkosci poruszania sie w zaleznosci od podanego MotionState'a */
    float GetSpeedValueForMotion(AIMotionState cMotion)
    {
        float fSpeed = m_aMotionVelocity[cMotion.GetSpeed()];
        if (cMotion.iMoveX != 0)
            fSpeed *= m_aMotionVelocityStrafeMultiplier[cMotion.GetSpeed()];
        return fSpeed;
    }
    
    /** Obliczenie predkosci katowej dla aktualnego MotionState'a */
    float GetAngSpeedForActualMotion()
    {
        return GetAngSpeedForMotion(m_ActualMotion);
    }

    /** Obliczenie predkosci katowej dla podanego MotionState'a */
    float GetAngSpeedForMotion(AIMotionState cMotion)
    {
        return m_aMotionAngularVelocity[cMotion.GetSpeed()];
    }

    /** Ustawienie strzezonego obiektu. AI nie powinno oddalac sie bardziej niz
     *  na odleglosc fRadius od podanego obiektu. Gdy cObject == null, nie
     *  ma pozycji (nie jest aktywny na module) lub fRadius <=0 
     *  @param cObject strzezony obiekt
     *  @param fRadius maksymalne oddalenie sie od celu
     */
    public void GuardObject(ControlObject cObject, float fRadius, boolean bCritical)
    {
        m_GuardedObject = cObject;
        m_fGuardedAreaRadius = fRadius;
        m_bGuardCritical = bCritical;
    }
    
    /** Zakladamy ze to, czy AI jest w budynku czy nie,
     * mozna rozpoznac po obecnosci systemu way pointow
     */
    boolean InBuilding()
    {
        return (m_WpSystem != null);
    }
    
    /** Wlaczenie/wylaczenie uzywania pathfindera przy poruszaniu sie AI */
    public void UsePathfinder(boolean bUsePathFinder)
    {
        m_bUsePathfinder = bUsePathFinder;
        if (bUsePathFinder)
        {
            UseIndoorPathfinder(false);
            UpdatePathMap(true, m_iPathFinderStampSize);
            SetFlag(EFlags._STOPPED_BY_PATHFINDER);
        }
        else
        {
            UpdatePathMap(false, m_iPathFinderStampSize);
            ClearFlag(EFlags._STOPPED_BY_PATHFINDER);
        }
    }

    public void UseIndoorPathfinder(boolean bUsePathFinder)
    {
        m_bUseIndoorPathfinder = bUsePathFinder;
        if (bUsePathFinder)
            UsePathfinder(false);
    }
    
    public boolean CanStandAtPos(Vector vPos)
    {
        if (m_bUsePathfinder)
		{
			UpdatePathMap(false, m_iPathFinderStampSize);
			boolean bRet = IsPlaceMoveable(vPos, m_iPathFinderStampSize);
			UpdatePathMap(true, m_iPathFinderStampSize);
            return bRet;
		}
        else
            return true;
    }

    private Vector m_vStartPos = new Vector();
    /** Wyslanie AI do podanego punktu */
    public void GoToPosition(Vector vDest)
    {
        m_bLastGoToSuccessfull = true; // zalozmy, ze sie uda...
        GetPosition(m_vStartPos);

        Vector vEndPos = GetValidGoToPosition(m_vStartPos, vDest);
        
        if (MathUtils.dist2D(m_vStartPos, vEndPos) > m_fDestinationRadius)
        {
            if (m_bUsePathfinder)
            {
                m_aCurrentGoToPath = FindPath(m_vStartPos, vEndPos);
                m_nCurrentGoToPathLen = (m_aCurrentGoToPath != null) ? m_aCurrentGoToPath.length :
                                                                       0;
                if (m_nCurrentGoToPathLen > 1 && !IsPlaceMoveable(vEndPos, m_iPathFinderStampSize))
                {
                    //HACK: jesli znalazl sciezke, a nie moze dojsc do punktu koncowego - niech podchodzi
                    float fLastDist2 = vEndPos.Distance2(m_aCurrentGoToPath[0]);
                    for (int i = 1; i < m_nCurrentGoToPathLen; i++)
                    {
                        float fDist2 = vEndPos.Distance2(m_aCurrentGoToPath[i]);
                        if (fDist2 > fLastDist2) // jesli sie oddala - przerwij
                        {
                            m_nCurrentGoToPathLen = i;
                            break;
                        }
                        fLastDist2 = fDist2;
                    }
                }
            }
            else
            {
                if ( (m_WpSystem != null) && 
                     ((cWaypoint == null) || (!bPortalIndependent)) &&
                     m_bUseIndoorPathfinder &&
                     bAllowUsingIndoorPathfinder)
                {
                    FindPathInfo info = m_WpSystem.FindPath(GetPosition(), vEndPos);
                    m_nCurrentGoToPathLen = info.GetRealSteps();
                    m_nWaypointsInPath = info.GetWPSteps();
                    
                    if (m_nCurrentGoToPathLen > 1)
                        m_aCurrentGoToPath = m_WpSystem.GetPathTab();
                    else
                        m_aCurrentGoToPath = null;
                    /*                    
                    m_WpSystem.GetCloserPoint(vEndPos);
                    
                    vEndPos.Set(m_WpSystem.m_CurrWaypoint.m_vPos);
                    if (MathUtils.dist2D2(m_vStartPos, vEndPos) < 10f)
                    {
                    // niestety nie da sie podejsc blizej - jestesmy tak blisko, jak sie da
                    GoToFinished();
                    return;
                    }
                    else
                    {
                    //                        vEndPos.Set(m_WpSystem.m_CurrWaypoint.m_vPos);
                    m_aCurrentGoToPath = new Vector[2];
                    m_aCurrentGoToPath[0] = m_vStartPos;
                    m_aCurrentGoToPath[1] = vEndPos;
                    }
                    */                    
                }
                else
                {
                    m_nCurrentGoToPathLen = 2;
                    m_aCurrentGoToPath = new Vector[2];
                    m_aCurrentGoToPath[0] = m_vStartPos;
                    m_aCurrentGoToPath[1] = vEndPos;
                }
            }
            if ((m_aCurrentGoToPath != null) && (m_nCurrentGoToPathLen > 1))
            {
                m_vGoToDestination.Set(vEndPos);

                m_nCurrentGoToPathIdx = 1;
                m_vCurrentGoToPoint = m_aCurrentGoToPath[m_nCurrentGoToPathIdx];
                
                SetDestinationPos(m_vCurrentGoToPoint);
                SetDestinationRadius(m_fDestinationRadius);
                
                UpdateTrackingDir();
            }
            else
            {
                //                CrashLog("WARNING: No path to " + vEndPos + "(" + GetName() + ")\n");
                m_bLastGoToSuccessfull = false;
                DisableCallMethod("GoToFinished");
                CallMethodIn("GoToFinished", 0);
            }
        }
        else
        {
            //            CrashLog("GOTO TO CLOSE! (" + GetName() + ")\n");
            m_bLastGoToSuccessfull = false;
            DisableCallMethod("GoToFinished");
            CallMethodIn("GoToFinished", 0);
        }
    }
    
    
    public boolean WasLastGoToSuccessfull()
    {
        return m_bLastGoToSuccessfull;
    }
    
    
    /** Funkcja powodujaca natychmiastowe zatrzymanie AI i uniewaznienie jego
     *  dotychczasowej sciezki.
     */
    public void StopGoTo()
    {
        ClearDestinationPos();
        ClearDestinationDir();
        m_vCurrentGoToPoint = null; 
        m_aCurrentGoToPath = null;
        m_Motion.StopMove();
        //        UpdateMotion();
        CallMethodIn(METHOD_CallUpdateMotion, m_fStopUpdateMotionDelay);
        SetLocalSpeed(Vector.Zero);
    }
    
    
    /** Wolane gdy AI dojdzie do celu podanego jako parametr GoToPosition
     */
    public void GoToFinished()
    {
        StopGoTo();
        m_Controller.Notify(AIEvents._NOTICE_DEST_POS);
    }

    
    protected Vector m_vSpeedDir = new Vector();
    protected static Vector sm_vUTD_PlayerDir = new Vector();
    /** Funkcja pomocnicza ustawiajaca kierunek poruszania sie na nastepny punkt na sciezce;
     *  Wywoluje sie periodycznie (co m_fUpdateDirTime) aby uaktualnic kierunek np po kolizji.
     */
    public void UpdateTrackingDir()
    {
        if (m_vCurrentGoToPoint != null)
        {
            // jesli w budynku to pootwieraj pobliskie drzwi
            ((ChromeModule)GetModule()).GetDoorControler().IsNearDoorable(this);

            m_vSpeedDir.Set(m_vCurrentGoToPoint);
            m_vSpeedDir.Sub(GetPositionVectorVolatile());
            m_vSpeedDir.fY = 0.0f;
            float fSpeedDirLen = m_vSpeedDir.Len();
            if (fSpeedDirLen > MathUtils._SMALL_03)
            {
                m_vSpeedDir.Mul(1.f/fSpeedDirLen);
            }
            else
                m_vSpeedDir = GetForwardVector();
            
            if (m_TrackedObject == null || !bCanTurnWhileMoving)
            {
                SetMaxAngSpeed(GetAngSpeedForMotion(m_Motion));
                SetFacingDestDir(m_vSpeedDir);
            }
            
            boolean bShouldStop = false;
            if (fMinWalkOnPlayerDistance > 1)
            {
                Player player = ((ChromeModule)GetModule()).GetMainPlayer();
                if (player != null)
                {
                    if (GetDistance2To(player) < fMinWalkOnPlayerDistance * fMinWalkOnPlayerDistance)
                    {
                        player.GetPosition(sm_vUTD_PlayerDir);
                        sm_vUTD_PlayerDir.Sub(GetPositionVectorVolatile());
                        sm_vUTD_PlayerDir.Normalize();
                        if (sm_vUTD_PlayerDir.Dot(m_vSpeedDir) > _WALK_ON_PLAYER_ANGLE_COS)
                            bShouldStop = true;
                    }
                }
            }

            if (bShouldStop)
                m_Motion.StopMove();
            else
                CalcMotionStateFromSpeedDir(m_Motion, GetForwardVector(), m_vSpeedDir);
            UpdateMotion();
            float fSpeed = GetSpeedValueForActualMotion();
            m_vSpeedDir.Mul(fSpeed);
            
            if (bShouldStop)
                SetSpeedValue(0);
            else
                SetSpeed(m_vSpeedDir);
            
            TryToVerticalize();
        }
    }

    /** Handler wolany po dojsciu do punktu okreslonego przez SetDestinationPos 
     *  na odleglosc okreslona przez SetDestinationRadius (m_fDestinationRadius)
     */
    void OnDestinationPos()
    {
        if (m_vCurrentGoToPoint != null)
        {        
            /** Update aktualnego waypointa.... */
            if ( (m_WpSystem != null) && 
                 ((cWaypoint == null) || (!bPortalIndependent)) )
            {
                if (m_nCurrentGoToPathIdx < m_nWaypointsInPath)
                {
                    m_WpSystem.SetCurrWaypoint(m_WpSystem.m_aWayPointsPath[m_nCurrentGoToPathIdx]);
                }
            }
            m_nCurrentGoToPathIdx++;
            // Czy doszedl do ostatniego punktu?
            if( m_nCurrentGoToPathIdx >= m_nCurrentGoToPathLen ) 
            {
                m_aCurrentGoToPath = null;
                m_vCurrentGoToPoint = null;
                
                if ( MathUtils.dist2D(m_vGoToDestination,GetPosition()) > m_fDestinationRadius)
                    GoToPosition(m_vGoToDestination); // jeszcze nie doszedl...
                else 
                    GoToFinished();
            }
            else // przejdz do nastepnego
            {
                m_vCurrentGoToPoint = m_aCurrentGoToPath[m_nCurrentGoToPathIdx];

                SetDestinationPos(m_vCurrentGoToPoint);
                UpdateTrackingDir();
            }
        }
    }

    /** Handler wolany, gdy AI zostanie zatrzymane przez PathFinder 
     *  (w normalnych warunkach nie powinien byc wolany) */
    void OnBlockMove()
    {
        if (m_bUsePathfinder)
            GoToPosition(m_vGoToDestination); // sprobuj kontynuowac
    }
    
    ////////////////////////////////////////////////////////////////////////
    
    /** Obrocenie sie AI o podany kat z domyslna predkoscia */
    public float Turn(float fAngle)
    {
        return Turn(fAngle, GetAngSpeedForMotion(m_Motion));
    }

    /** Obrocenie sie AI o podany kat z podana predkoscia */
    public float Turn(float fAngle, float fAngSpeed)
    {
        TryToVerticalize();

        fAngSpeed = Math.abs(fAngSpeed);
        float fTime = Math.abs(fAngle) / fAngSpeed;
        SetAngSpeed(fAngSpeed * -MathUtils.sign(fAngle));
        CallMethodOnceIn(METHOD_TurnDone, fTime);
        m_Motion.iTurn = (byte)MathUtils.sign(fAngle);
        UpdateMotion();
        return fTime;
    }
    
    /** Obrocenie sie AI do podanego kierunku */
    public float Turn(Vector vDir)
    {
        Vector vWorldDir = new Vector(vDir);
        Vector vLocalDir = VectorWorldToLocal(vWorldDir);
        
        float fAngle = (float)(Math.atan2(vLocalDir.fX, vLocalDir.fZ) * 180 / Math.PI);
        SetFacingDestDir(vDir);
        float fAngSpeed = GetAngSpeedForMotion(m_Motion);
        SetMaxAngSpeed(fAngSpeed);
        float fTime = Math.abs(fAngle) / fAngSpeed;
        CallMethodOnceIn(METHOD_TurnDone, fTime);
        
        if (Math.abs(fAngle) > m_fMinTurnAngleToUpdateMotion)
        {
            //LogR("UpdateMotion w Turn!\n");            
            m_Motion.iTurn = (byte)MathUtils.sign(fAngle);
            UpdateMotion();
        }
        
        TryToVerticalize();
        return fTime;
    }

    /** Metoda wolana po zakonczeniu obracania sie */
    void TurnDone()
    {
        TryToVerticalize();

        StopTurn();
        m_Controller.Notify(AIEvents._NOTICE_ANGLE_REACHED);
    }
    
    
    /** Natychmiastowe zatrzymanie obracania sie  */
    void StopTurn()
    {
        DisableCallMethod(METHOD_TurnDone);
        m_Motion.iTurn = 0;
        CallMethodIn(METHOD_CallUpdateMotion, m_fStopUpdateMotionDelay);
        SetAngSpeed(0);
    }
    
    /////////////////////////////////////////////////////////////////////////////

    /** Zapamietana na czas wykonywania InterpolatePositionTo masa obiektu
     *  gdy -1 to interpolacja nie jest wykonywana  */
    protected float m_fIntPosOldMass = -1;
    /** Zapamietana na czas wykonywania InterpolatePositionTo flaga _BLOCK_MOVE */
    protected boolean m_bIntPos_BLOCK_MOVE;
    /** Zapamietana decelowa pozycja obiektu dla InterpolatePositionTo */
    protected Vector m_vIntPosDestPos = new Vector();
    /** Zapamietany decelowy kierunek obiektu dla InterpolatePositionTo */
    protected Vector m_vIntPosDestDir = new Vector();
    /** Wektor kierunku (predkosc poruszania sie) dla InterpolatePositionTo */
    private Vector m_vIntPosDir = new Vector();
    /** Zapamietana wartosc m_bUsePathfinder */
    private boolean m_bIntPosWasUsingPathfinder = false;

    /** Wywoluje InterpolatePositionTo(Vector, float, boolean) z wlaczonymi kolizjami
     */
    public float InterpolatePositionTo(Vector vNewPos, Vector vNewDir, float fMoveSpeed)
    {
        return InterpolatePositionTo(vNewPos, vNewDir, fMoveSpeed, false);
    }
    
    /** Przesuniecie z aktualnej pozycji do podanej bez wykryania kolizji
     *  @param vNewPos docelowa pozycja
     *  @param vNewDir docelowy kierunek
     *  @param fMoveSpeed predkosc przesuwania sie
     *  @param bDisableCollisions znacznik, ze podczas interpolacji maja nie byc wykrywane 
     *         kolizje MOVE dla i z obiektem
     *  @return czas potrzebny na dojscie do podanej pozycji
     *  UWAGA: nie korzysta z OnDestinationPos - AI nie moze miec FreezeCallMethods, 
     *         gdyz inaczej sie nie zatrzyma
     */
    public float InterpolatePositionTo(Vector vNewPos, Vector vNewDir, float fMoveSpeed, boolean bDisableCollisions)
    {
        float fAbsSpeed = Math.abs(fMoveSpeed),
            fTime = 0;
        Vector vMyPos = GetPosition();

        if (vMyPos != null &&
            vNewPos != null && 
            fAbsSpeed > MathUtils._SMALL_03)
        {
            m_vIntPosDir.Set(vNewPos);
            m_vIntPosDir.Sub(vMyPos);
            
            float fDistance = m_vIntPosDir.Len();
            if (fDistance > MathUtils._SMALL_03)
            {
                m_fIntPosOldMass = GetMass();
                m_bIntPos_BLOCK_MOVE = IsSetFlag(EFlags._BLOCK_MOVE);
                m_bIntPosWasUsingPathfinder = m_bUsePathfinder;

                m_vIntPosDestPos.Set(vNewPos);
                m_vIntPosDir.Mul(fMoveSpeed / fDistance); // nomalizacja + zmiana dlugosci na odpowiednia
                
                SetPhysicsType(EPhysics._FLY);
                UsePathfinder(false);
                
                if (bDisableCollisions)
                {
                    SetCollFlags(ECollFlags.OBJCOL_FLAG_NOTREES | 
                                 ECollFlags.OBJCOL_FLAG_NOTERRAIN |
                                 ECollFlags.OBJCOL_FLAG_NOOBJECTS);
                    ClearFlag(EFlags._BLOCK_MOVE);
                }
                
                SetMass(0);
                SetSpeed(m_vIntPosDir);
                
                fTime = fDistance / fAbsSpeed;
                CallMethodOnceIn(METHOD_InterpolatePositionDone, fTime);
            }
        }
            
        if (vNewDir != null)
        {
            m_vIntPosDestDir.Set(vNewDir);
            SetDestDir(vNewDir);
        }
        else
            m_vIntPosDestDir.Set(Vector.Zero);
        
        return fTime;
    }

    /** Metoda wolana po uplynieciu czasu potrzebnego na przeinterpolowanie pozycji */
    protected void InterpolatePositionDone()
    {
        StopInterpolatePosition(true);
    }
    
    /** Natychmiastowe zatrzymanie interpolacji pozycji
     *  @param bMoveToDest gdy true - AI zostanie przesuniete do pozycji podanej w InterpolatePositionTo
     */
    public void StopInterpolatePosition(boolean bMoveToDest)
    {
        DisableCallMethod(METHOD_InterpolatePositionDone);
        
        if (m_fIntPosOldMass >= 0)
        {
            UsePathfinder(m_bIntPosWasUsingPathfinder);
            SetPhysicsType(EPhysics._WALK);
            SetMass(m_fIntPosOldMass);
            SetSpeedValue(0);

            ClearCollFlags(ECollFlags.OBJCOL_FLAG_NOTREES | 
                           ECollFlags.OBJCOL_FLAG_NOTERRAIN |
                           ECollFlags.OBJCOL_FLAG_NOOBJECTS);

            if (m_bIntPos_BLOCK_MOVE)
                SetFlag(EFlags._BLOCK_MOVE);
            if (bMoveToDest)
            {
                SetPositionWorld(m_vIntPosDestPos);
                if (m_vIntPosDestDir.Len2() > 0f)
                    SetDir(m_vIntPosDestDir);
            }
        }
    }

    
    ////////////////////////////////////////////////////////////////////////
    final public void CallMethodOnceIn(int nMethodID, float fTime)
    {
        DisableCallMethod(nMethodID);
        CallMethodIn(nMethodID, fTime);
    }

    /////////////////////////////////////////////////////////////////////
    // OBSLUGA INVENTORY AI
    //
    
    /** metoda inicjalizujaca inventory
     */
    void InitInventory()
    {
        cInventory = (InventoryAI) CreateObjectNoInit("InventoryAI");
        cInventory.Owner = this;
        cInventory.InitObject();		
        
		// CallOnFrameEnd("FillInventory");
		int METHOD_FillInventory = RegisterCallMethod("FillInventory");
		CallMethodIn(METHOD_FillInventory,0);
		UnfreezeCallMethod(METHOD_FillInventory);
    }

    Actor cAIInventoryExecutor = null;
    void ExecuteAIInventory()
    {
        if (cAIInventoryExecutor == null)
            return;
        // sprawdzamy, czy mamy do czynienia z PlayerHUD
        try
        {
            PlayerHUD cPlayerHUD = (PlayerHUD)cAIInventoryExecutor;
            // teraz sprawdzam czy trzeba wlaczyc czy wylaczyc inventory gracza i AI
            if (cPlayerHUD.SetAIInventory(cInventory))
                bIsCorpseActive = true;
        }
        catch( ClassCastException e) 
        {
            Log("[NewAI.Execute]: NewAI corpse can be executed only by PlayerHUD\n");
        }
        cAIInventoryExecutor = null;
    }

    /////////////////////////////////////////////////////////////////////////////
    // wsiadanie / wysiadanie AI
    EnumGetInType GetGetInType()
    {
        return cGetInAs;
    }
    
    /** Obsluga przenoszenia inventory AI do gracza
     */
    void Execute(Actor cExecutor)
    {
        super.Execute(cExecutor);
        
        cAIInventoryExecutor = cExecutor;
        CallMethodIn("ExecuteAIInventory", 0f);
    }

    /** Wrzucenie itemow o podanych nazwach do inventory
     */
    void InsertItems(String aItems[], int nItems)
    {
        InvObject cObject;
        for (int i = 0; i < nItems; i++)
        {
            if( GetClassID(aItems[i]) != 0)
            {
                cObject = (InvObject) CreateObject(aItems[i]);
                cObject.AddToInventory(this);
            }
        }
    }
    
    /** Wrzucenie przedmiotow do inventory
     */
    void FillInventory()
    {
        String sToken;
        String aItemClassNames[] = new String[10]; // max elems in group
        
        
        // najpierw wrzucamy to, co ma miec konkretne AI:

        // konkretne przedmioty z Levelu
        if (aItemsFromModule != null)
        {
            for (int i=0; i<aItemsFromModule.length; i++)
                if (aItemsFromModule[i] instanceof InvObjectInst &&
                    !aItemsFromModule[i].IsInInventory())
                {
                    aItemsFromModule[i].AddToInventory(this);
                }
        }
        
        // przedmioty po klasach
        if (aItems != null)
        {
            for (int i=0; i<aItems.length; i++)
                if (aItems[i] instanceof InvObjectInst &&
                    !aItems[i].IsInInventory())
                {
                    aItems[i].AddToInventory(this);
                }
        }
        
        // teraz healthexy (zalezne od modyfikatorow - znaczny wplyw na poziom trudnosci)
        String[] aHealthexClass = new String[] { DrugHealthex.class.getName() };
        for (int i = 0; i < mod_nMaxHealtexesNumber; i++)
            if (MathUtils.CanHappen(mod_nSingleHealtexProbability))
                InsertItems(aHealthexClass, 1);
        
        String[] aGrenadeClass = new String[] { WeaponGrenade.class.getName() };
        for (int i = 0; i < mod_nMaxGrenadesNumber; i++)
            if (MathUtils.CanHappen(mod_nSingleGrenadeProbability))
                InsertItems(aGrenadeClass, 1);
                        
        
        // teraz defaultowe rzeczy
        if (sDefaultItems != null)
        {
            StringTokenizer cDefaultItemsIter = new StringTokenizer(sDefaultItems, " ,+%", true);
            int nGroupItems = 0,
                nProbability = nDefaultItemProbability;
            while (cDefaultItemsIter.hasMoreTokens())
            {
                sToken = cDefaultItemsIter.nextToken();
                if (sToken.compareTo("%") == 0)
                {
                    if (cDefaultItemsIter.hasMoreTokens())
                    {
                        sToken = cDefaultItemsIter.nextToken();
                        try 
                        {
                            nProbability = Integer.valueOf(sToken).intValue();
                        } 
                        catch (java.lang.NumberFormatException e)
                        {
                            LogD("Incorrect probability value!\n");
                            nProbability = nDefaultItemProbability;
                        }
                    }
                    else
                    {
                        LogD("Default items names parsing error!\n");
                        return;
                    }
                }
                else if (sToken.compareTo(" ") == 0)
                    ;
                else if (sToken.compareTo("+") == 0)
                    ;
                else if (sToken.compareTo(",") == 0)
                {
                    if (aItemClassNames[nGroupItems] != null &&
                        aItemClassNames[nGroupItems].compareTo("WeaponGrenade") != 0 &&
                        MathUtils.CanHappen(nProbability))
                    {
                        InsertItems(aItemClassNames, nGroupItems);
                    }
                    nGroupItems = 0;
                    nProbability = nDefaultItemProbability;
                }
                else
                {
                    aItemClassNames[nGroupItems++] = sToken;
                }
            }
            // wrzucenie ostatniego itema/itemow
            if (MathUtils.CanHappen(nProbability))
                InsertItems(aItemClassNames, nGroupItems);
        }
    }

    /////////////////////////////////////////////////////////////////////
    // BRON AI
    void InitializeAIWeapon()
    {
        if (ActiveWeapon != null)
        {
            Weapon toRemove = ActiveWeapon;
            UseWeapon((Weapon) null);

            // wyciagamy z inventory stara bron
            cInventory.RemoveInvObject(toRemove);
            toRemove.ChangeInvState(this, EInvObjState._ONGROUND);
            toRemove.DetachFromParent();
            toRemove.DeactivateOnModuleAlways();
            //            toRemove.delete();    
            toRemove = null;
        }
        
        //Weapon Gun = (Weapon) CreateObject(m_sAIWeapon);
        if (cAIWeapon != null && !(cAIWeapon instanceof WeaponHands))
        {
            if (!cAIWeapon.IsCreatedFromEngine())
            {
                // obiekt nie byl jeszcze prawidlowo utworzony - stworz go...
                cAIWeapon = (Weapon)CreateObject(cAIWeapon.getClass().getName());
            }
            cAIWeapon.AddToInventory(this, false);
            cAIWeapon.SetLODCoeff(fAIWeaponLODCoef);
            
            InitializeAIAmmo(cAIWeapon);

            UseWeapon(cAIWeapon);

            WeaponReload();
            m_nGrenadesLeft = nGrenades;
            
            PlaceWeapons();
        }
    }
    
    void InitializeAIAmmo(Weapon cWeapon)
    {
        if (MathUtils.CanHappen(mod_nSpareAmmoProbability))
        {
            int nDesiredAmmo = (int)(cWeapon.nCapacity * RandomFloat(mod_fMinSpareAmmoClips, mod_fMaxSpareAmmoClips));
            if (nDesiredAmmo > 0)
            {
                String sAmmoClass = "";
                switch (cWeapon.eBulletType)
                {
                case EAmmoType._12mmShort:
                    sAmmoClass = "Ammo12mmShort";
                    break;
                case EAmmoType._14mmLong:
                    sAmmoClass = "Ammo14mmLong";
                    break;
                case EAmmoType._8mmLong:
                    sAmmoClass = "Ammo8mmLong";
                    break;
                case EAmmoType._9mmShort:
                    sAmmoClass = "Ammo9mmShort";
                    break;            
                case EAmmoType._Energy:
                    sAmmoClass = "AmmoEnergy";
                    break;
                case EAmmoType._HEX:
                    sAmmoClass = "AmmoHEX";
                    break;
                case EAmmoType._Rocket:
                    sAmmoClass = "AmmoRockets";
                    break;
                case EAmmoType._Shotgun:
                    sAmmoClass = "AmmoShotgun";
                    break;
                default:
                    return;
                }
                
                int nAmmo = 0;
                do 
                {
                    Ammo cAmmo = (Ammo)CreateObject(sAmmoClass);
                    cAmmo.AddToInventory(this, false);
                    if (nDesiredAmmo - nAmmo > cAmmo.nCapacity)
                        cAmmo.nCount = cAmmo.nCapacity;
                    else
                        cAmmo.nCount = nDesiredAmmo - nAmmo;
                    nAmmo += cAmmo.nCount;
                }
                    while(nAmmo < nDesiredAmmo);
            }
        }
    }
    
    void PlaceWeapons()
    {
    }
    
    
    
    //////////////////////////////////////////////////////////////////////////////////////////////////////
    // Statystyki strzelania do obliczenia parametrow rozrzutu
    //
    
    
    /** Wyzerowanie statystyk strzelania
     */
    public void ResetFiringStatistics()
    {
        m_nRoundsHit = m_nRoundsShot = 0;
        m_fMaxHitFiringDeviation = 0;
        m_fLastResetFiringStatisticsTime = GetTime();
    }

    /** Rozpoczecie serii strzalow (kilka pojedynczych albo tryb auto */
    public void StartFiring()
    {
        CalcFiringDevLineAngle();
        if (CalcActualHitRatio() > m_fDesiredHitRatio)
            m_fFiringDeviation = RandomFloat(m_fMaxHitFiringDeviation, 1); // na zewnatrz
        else
            m_fFiringDeviation = RandomFloat(0, m_fMaxHitFiringDeviation); // wewnatrz
            
        m_fFiringDeviation = MathUtils.crop(m_fFiringDeviation, 0, 1);
    }
    
    void CalcFiringDevLineAngle()
    {
        // oblicz kierunek prostej wyznaczajacej rozrzut strzelajacego ai
        m_fFiringDevLineAngle = RandomFloat(-45, 45);
        // obroc prosta o 180 (tozsamosc, ale tu chodzi o kat - poruszamy sie faktycznie po polprostej)
        if (RandomInt(2) == 0)
            m_fFiringDevLineAngle += 180;
    }
    
    protected void UpdatePosOnDevLine()
    {
        float fActualHitRatio = CalcActualHitRatio();
        float fHitRatioDelta = (float)Math.abs(fActualHitRatio - m_fDesiredHitRatio);
        fHitRatioDelta *= m_fHitRatioChangeSpeed;
        if (fHitRatioDelta < 0.05f)
            fHitRatioDelta = 0.05f;
        
        if (fActualHitRatio > m_fDesiredHitRatio)
            m_fFiringDeviation += fHitRatioDelta;
        else
            m_fFiringDeviation -= fHitRatioDelta;
        
        if (m_fFiringDeviation > 1)
            m_fFiringDeviation = 1;
        else if (m_fFiringDeviation <= fHitRatioDelta)
        {
            if (m_fFiringDeviation <= 0)
                m_fFiringDeviation = 0;
            CalcFiringDevLineAngle();  
        }
        
        float fTime = GetTime();
        if (fTime - m_fLastDesiredHitRatioChangeCheckTime >
            _DESIRED_HIT_RATIO_CHANGE_CHECK_INTERVAL)
        {
            m_fLastDesiredHitRatioChangeCheckTime = fTime;
            m_fLastDesiredHitRatio = m_fDesiredHitRatio;
            if (Math.abs(m_fLastDesiredHitRatio - 
                         m_fDesiredHitRatio) >  m_fCriticalDesiredHitRatioChangeThreshold)
            {
                ResetFiringStatistics();
            }
        }
        if (fTime - m_fLastResetFiringStatisticsTime > _MAX_RESET_FIRING_STATISTICS_INTERVAL)
        {
            ResetFiringStatistics();
        }

    }
    
    public float CalcActualHitRatio()
    {
        if (m_nRoundsShot > 0)
        {
            if (m_nRoundsHit == 0)
                return 0;
            else
                return MathUtils.crop((float)m_nRoundsHit / (float)m_nRoundsShot, 0, 1);
        }
        else
            return RandomFloat(0, 1);
    }
    
    /** Callback wolany przez bron
     */
    void MessageWeapon(int nState)
    {
        if ((nState & Weapon.STATE_SHOT) != 0)
        {
            m_nRoundsShot++;
            UpdatePosOnDevLine();
        }
        m_Controller.MessageWeapon(nState);
    }
    
    /** Callback wolany przez trafiony obiekt
     */
    public void NotifyHit(ChromeActor victim, int damageType)
    {
        if (m_Controller.GetActiveEnemy() == victim && m_nRoundsHit < m_nRoundsShot)
            m_nRoundsHit++;
        if (m_fFiringDeviation > m_fMaxHitFiringDeviation)
            m_fMaxHitFiringDeviation = m_fFiringDeviation;
        m_Controller.TargetHitNotification(victim, damageType);
    }

    public void UseWeapon(Weapon weapon)
    {
        super.UseWeapon(weapon);
        m_Controller.ActiveWeaponChanged();
    }

    
    /** tymczasowe przeladowanie broni     */
    int m_nAmmoForActiveWeapon = 10000000;
    int GetAmmoForActiveWeapon()
    {
        if (ActiveWeapon == null)
            return 0;
        else
            return m_nAmmoForActiveWeapon;        
    }

    boolean WeaponReload()    
    {
        if ( m_nAmmoForActiveWeapon >= ActiveWeapon.nCapacity )
        {
            m_nAmmoForActiveWeapon = m_nAmmoForActiveWeapon - ActiveWeapon.nCapacity;
            ActiveWeapon.Reload(ActiveWeapon.nCapacity);
        }
        else
        {
            ActiveWeapon.Reload(m_nAmmoForActiveWeapon);
            m_nAmmoForActiveWeapon = 0;
        }
        return true;
    }
    
    boolean m_bWPVis = false;
    LaserPointer m_ToCurrWPLine = null;
    
    public void VisualizeWaypointSystem(boolean bVisualize)
    {
        if (m_WpSystem == null)
            return;

        m_bWPVis = bVisualize;
        
        if (bVisualize)
        {
            m_WpSystem.VisualizeWaypointSystem(this);
            if (m_ToCurrWPLine == null)
                m_ToCurrWPLine = Tools.CreateLaserPointer(GetModule(), LaserPointer._BEAM_RED, 1, 100f, true);
        }
        else
        {
            m_WpSystem.DevisualizeWaypointSystem(this);
            if (m_ToCurrWPLine != null)
            {
                m_ToCurrWPLine.delete();
                m_ToCurrWPLine = null;
            }
        }
    }
    
    public void InitParamsFromMesh()
    {
        if (fHealth == -1)
            fHealth = fDefaultAIHealth;
    }

    
    public void InitSounds()
    {
        if (sSoundsPath == null)
            sSoundsPath = GetRandomSoundsDirectory();

        File fullPath = new File(sSoundsPath);
        if (fullPath != null && fullPath.exists())
            m_sSoundsPathPrefix = fullPath.getPath() + "/";
        else
            m_sSoundsPathPrefix = "";

        if (m_aSoundsGroups != null)
            for (int i = 0; i < m_aSoundsGroups.length; i++)
                if (m_aSoundsGroups[i] != null)
                    m_aSoundsGroups[i].Init(sSoundsPath);
    }

    
    public boolean SendRadioMessage(int nMsgType)
    {
        if (m_CommSystem != null && bCanUseRadioCommunication && !IsDead() && !s_bRadioCommDisabledForMovie)
        {
            float fTime = GetTime();
            if (fTime > m_fNextScreamTime &&
                fTime > m_CommSystem.GetNextMessageTime(nMsgType))
            {
                Camera cam = ((ChromeModule)GetModule()).GetActiveViewCamera();
                float camDist2 = GetDistance2To( cam.GetPositionVolatile() );
                if (camDist2 < _LISTENER_RADIO_MSG_MAX_DIST2)
                {
                    NewAI chatBuddy = null;
                    boolean bNeedsBuddy = m_CommSystem.CheckIfMessageNeedsBuddy(nMsgType);
                    FriendInfo friendInfo;
                    NewAI buddy;
                    float fMinDist2 = Float.MAX_VALUE;
                    ArrayList friendsList = m_Controller.m_aAlliesList;
                    for (int i = 0; i < friendsList.size(); i++)
                    {
                        friendInfo = (FriendInfo)friendsList.get(i);
                        if (friendInfo.m_Reference instanceof NewAI)
                        {
                            buddy = (NewAI)friendInfo.m_Reference;
                            
                            if (buddy.bCanUseRadioCommunication &&
                                buddy.IsActiveOnModule() &&
                                !buddy.IsDead() && !buddy.IsFrozen() &&
                                IsFriend(buddy) &&
                                fTime > buddy.m_fNextScreamTime)
                            {
                                // wybierz tego blizego niz graniczna odleglosc albo najblizszego
                                float fDist2 = GetDistance2To(buddy);
                                if (fDist2 < _TEAM_RADIO_MSG_ACCEPTABLE_DIST2)
                                {
                                    chatBuddy = buddy;
                                    break;
                                }
                                if (fDist2 < fMinDist2 && 
                                    fDist2 < _TEAM_RADIO_MSG_MAX_DIST2) // wybierz tylko tych odpowiednio bliskich
                                {
                                    chatBuddy = buddy;
                                    fMinDist2 = fDist2;
                                    if (!bNeedsBuddy)
                                        break; // jeden w poblizu wystarczy, gdy nie trzeba odpowiedzi
                                }
                            }
                        }
                    }
                    if (chatBuddy == null) // musi miec kto sluchac
                        return false;

                    if (bNeedsBuddy) // jesli ma mu kto odpowiedziec...
                        return m_CommSystem.RadioMessage(nMsgType, this, chatBuddy);
                    else
                        return m_CommSystem.RadioMessage(nMsgType, this, null);
                }
            }
        }
        return false;
    }
    
    
    /** Wydanie przez AI losowego dzwieku okreslonego typu
     * @param iScreamType typ wydawanego dzwieku (stala _SCREAMTYPE_*)
     * @return czas potrzebny na odegranie dzwieku
     */
    public float Scream(int iScreamType)
    {
        String fileName, filePath;
        float duration = 0;
        float time = GetTime();

        if (time >= m_fNextScreamTime &&
            m_aSoundsGroups != null &&
            m_aSoundsGroups[iScreamType] != null &&
            time >= m_aNextScreamTypeTime[iScreamType] &&
            (fileName = m_aSoundsGroups[iScreamType].GetSoundName()) != null)
        {
            m_nLastScreamType = iScreamType;
            float range = m_aSoundsGroups[iScreamType].fNoiseRange;
            if (range > 0)
                MakeNoise(range * GetMakeNoiseMult(), Pawn._NOISE_SCREAM);

            filePath = m_sSoundsPathPrefix + fileName;
            duration = GetWaveDuration(filePath);
            
            m_fNextScreamTime = time + duration;
            m_aNextScreamTypeTime[iScreamType] = m_fNextScreamTime + m_aSoundsGroups[iScreamType].GetRandomDelay();
            AttachOneShotSound(filePath, m_fMinScreamRange, m_fMaxScreamRange);
        }
        
        return duration;
    }

    
    public float GetNextScreamTime(int iScreamType)
    {
        if (m_aSoundsGroups != null &&
            m_aSoundsGroups[iScreamType] != null)
            return Math.max(m_aNextScreamTypeTime[iScreamType], m_fNextScreamTime);
        else
            return -1;
    }
    
    public void SetNextScreamTime(float fTime)
    {
        m_fNextScreamTime = Math.max(fTime, m_fNextScreamTime);
    }
    
    /** Zwraca typ ostatnio wydanego przez AI dzwieku  */
    public int GetLastScreamType()
    {
        return m_nLastScreamType;
    }
    
    float GetMakeNoiseMult()
    {
        return fMakeNoiseMult;
    }
    
    ///////////////////////////////////////////////////////////////////////////
    public void ChangeWaypoint(Waypoint cNewWaypoint, boolean bStopCurrActivity)
    {
        // zmiana siezki na nowa...
        cFirstWaypoint = cNewWaypoint;
        
        if (cWaypoint != null) // zmiana sciezki
        {
            if (bStopCurrActivity)
            {
                SetWaypoint(null);
                m_bWaypointChanged = false;// natychmiastowa zmiana jest 'niezauwazalna'

                // usun z kolejki zadan taski EditorActivityEnd
                int i = 0;
                while (i < m_Controller.m_TaskList.GetTasksNum())
                {
                    if (m_Controller.m_TaskList.GetTask(i) instanceof TaskEditorActivityEnd)
                        m_Controller.m_TaskList.RemoveTask(i);
                    else
                        i++;
                }

                // Przegeneruj scenariusze
                m_Controller.RequestEvent(AIEvents._EV_EDITOR_ACTIVITY, true);
                // przejdz do nast. waypointa
                m_Controller.ServeNextWaypointActivity();
            }
            else
            {
                m_NewWaypoint = cNewWaypoint;
                m_bWaypointChanged = true;
            }
        }
        else //nowa sciezka albo po zakonczeniu poprzedniej
        {
            m_bWaypointChanged = false;
            m_Controller.ServeNextWaypointActivity();
        }
    }

    
    public Waypoint GetWaypoint()
    {
        return cWaypoint;
    }
    
    public void SetWaypoint(Waypoint waypoint)
    {
        cWaypoint = waypoint;
    }
    
    public Waypoint GetNextWaypoint()
    {
        Waypoint cRet = null;
        if (m_bWaypointChanged)
        {
            SetWaypoint(m_NewWaypoint);
            m_bWaypointChanged = false;
            cRet = cWaypoint;
        }
        else
            cRet = cWaypoint.cNext;
        return cRet;
    }
    
    //////////////////////////////////////////////////////////////////////////////

    public void TriggerObjectNotification(TriggerObject trigger, ExecutionInfo currentExecutionInfo)
    {
        m_Controller.TriggerObjectNotification(trigger, currentExecutionInfo);
    }
    //////////////////////////////////////////////////////////////////////////////
    // Implementacja interfejsu ipar_WeaponParams

    public void SetWeaponParams(ParamWeaponParams params)
    {
        if (ActiveWeapon != null)
        {
            ActiveWeapon.SetWeaponParams(params);
            if (m_Controller != null)
                m_Controller.ActiveWeaponChanged();
        }
    }
    //////////////////////////////////////////////////////////////////////////////
    String DescribeMotionState(AIMotionState cMotion)
    {
        String moveDir = "";
        if (cMotion.iMoveZ != 0 || cMotion.iMoveX != 0)
        {
            moveDir += " move: ";
            if (cMotion.iMoveZ == 1)
                moveDir += "Fwd";
            else if (cMotion.iMoveZ == -1)
                moveDir += "Bk";
            
            if (cMotion.iMoveX == 1)
                moveDir += "L";
            else if (cMotion.iMoveX == -1)
                moveDir += "R";
        }
        else
            moveDir += " <stop>";
        
        if (cMotion.iTurn == -1)
            moveDir += " trnR";
        else if (cMotion.iTurn == 1)
            moveDir += " trnL";
        
        return MotionState.aSpeedNames[cMotion.GetSpeed()] + 
               moveDir + 
               ", fire = " + cMotion.bFiring +
               ", aim = " + cMotion.bAiming;
    }

    //////////////////////////////////////////////////////////////////////////////
    // odgrywanie komunikatow radiowych przez AI
    public static RadioCommunicationSystem m_CommSystem = null;
    
    public void InitializeCommSystem(ChromeModuleSingle module)
    {
        m_CommSystem = (RadioCommunicationSystem) module.CreateObject("RadioCommunicationSystem");
        m_CommSystem.Init(module);
        m_CommSystem.ActivateOnModule();
    }
    
    public static RadioCommunicationSystem GetCommSystem()
    {
        return m_CommSystem;
    }
    
    /////////////////////////////////////////////////////////////////////////////
    // Implementacja ipar_MotionSpeed
    
    public void SetMotionSpeedValue(int iMotionSpeed, float fNewSpeedValue)
    {
        if (iMotionSpeed >=0 && iMotionSpeed < m_aMotionVelocity.length)
        {
            m_aMotionVelocity[iMotionSpeed] = fNewSpeedValue;
        }
    }
    
    public void MultiplyMotionSpeedValue(int iMotionSpeed, float fSpeedValueMulitplier)
    {
        if (iMotionSpeed >=0 && iMotionSpeed < m_aMotionVelocity.length)
        {
            m_aMotionVelocity[iMotionSpeed] *= fSpeedValueMulitplier;
        }
    }

    /////////////////////////////////////////////////////////////////////////////
    // Implementacja IObjCount
    public int GetObjsCount()
    {
        return 1;
    }
    
    public int GetDeadObjsCount()
    {
        if (bDead)
            return 1;
        else
            return 0;
    }
    
    /////////////////////////////////////////////////////////////////////////////
    // Implementacja ipar_HitReaction
    public void EnableHitReaction(boolean bHitReactionAllowed)
    {
        this.bHitReactionAllowed = bHitReactionAllowed;
    }
    
    /////////////////////////////////////////////////////////////////////////////
    // Odpalenie smierci ai na fizyce
    public void MovieDie()
    {
        TakeDamage(fHealth * 2 + 1, 0, null, null, null, EBones._NON_BONE, EnumDamageType._ALL);
    }
    
    
    /////////////////////////////////////////////////////////////////////////////
    // MODYFIKATORY
    //
    
    public boolean bUseParamsModifiers         = true;//#\NewAI;when true, ai uses params modifiers (for example: difficulty level)
    
    public float mod_fAccuracyMult             = 1.f;   // mnoznik celnosci ai
    public float mod_fFiringTimeMult           = 1.f;   // mnoznik 'dlugosci serii'
    public float mod_fFireDelayMult            = 1.f;   // mnoznik dlugosci czasu przerwy miedzy seriami
    public int   mod_nSingleHealtexProbability = 50;    // prawdopodobienstwo [%] pojawienia sie kazdego z healthexow w inventory
    public int   mod_nMaxHealtexesNumber       = 1;     // maksymalna liczba helathexow dodawanych do inventory
    public float mod_fMinHitRatioMult          = 1.f;   // mnoznik minimalnego prawdopodobienstwa trafiania w cel
    public float mod_fMaxHitRatioMult          = 1.f;   // mnoznik maksymalnego prawdopodobienstwa trafiania w cel
    public float mod_fMinSpareAmmoClips        = 0.5f;  // ile ai ma miec zapasowej amunicji (w pelnych nCapacity weapona) - min
    public float mod_fMaxSpareAmmoClips        = 1f;    // ile ai ma miec zapasowej amunicji (w pelnych nCapacity weapona) - max
    public int   mod_nSpareAmmoProbability     = 100;   // prawdopodobienstwo, ze AI bedzie mialo w inv. dodatkowe ammo
    public int   mod_nSingleGrenadeProbability = 50;    // prawdopodobienstwo [%] pojawienia sie kazdego z granatow w inventory
    public int   mod_nMaxGrenadesNumber        = 1;     // maksymalna liczba granatow dodawanych do inventory
    // lista modyfikatorow 
    protected static ArrayList s_ModifiersList = new ArrayList();
    
    /** Usuniecie wszystkich modyfikatorow. Musi byc zawolane na poczatku (przed dodawaniem)
     */
    public static void ResetModifiers()
    {
        s_ModifiersList.clear();
    }
    
    /** Dodanie nowego modyfikatora do listy
     */
    public static void AddModifier(AIParamsMod modifier)
    {
        s_ModifiersList.add(modifier);
    }
    
    /** Metoda dokonujaca modyfikacji parametrow ai na podstawie dodanych wczesniej modyfikatorow
     */
    protected void ApplyModifiers()
    {
        if (bUseParamsModifiers)
        {
            for (int i = 0; i < s_ModifiersList.size(); i++)
            {
                AIParamsMod mod = (AIParamsMod)s_ModifiersList.get(i);
                mod.Apply(this);
            }
        }
    }
    
    
    //*********************************************************
    //                      SaveGame
    //*********************************************************
    
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[NewAI.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_NEWAI)
        {
            super.SGLoadChunk(cFC);
            m_Controller = (AIController)cFC.LoadObject(m_Controller, this);
            
            m_bHitReactionDisabled = cFC.LoadBool();
            
            m_nLastScreamType = cFC.LoadInt();
            m_fNextScreamTime = cFC.LoadFloat();
            
            int arrayLen = cFC.LoadInt();
            if (arrayLen < 0)
                m_aNextScreamTypeTime = null;
            else
            {
                m_aNextScreamTypeTime = new float[arrayLen];
                for (int i = 0; i < arrayLen; i++)
                    m_aNextScreamTypeTime[i] = cFC.LoadFloat();
            }
            
            cWaypoint = (Waypoint)cFC.LoadObjectRef();
            cFirstWaypoint = (Waypoint)cFC.LoadObjectRef();
            m_NewWaypoint = (Waypoint)cFC.LoadObjectRef();
            
            m_bWaypointChanged = cFC.LoadBool();
            bPortalIndependent = cFC.LoadBool();

            m_Killer = (ChromeActor)cFC.LoadObjectRef();

            m_nGrenadesLeft = cFC.LoadInt();
            
            m_nRoundsHit = cFC.LoadInt();
            m_nRoundsShot = cFC.LoadInt();
            m_fDesiredHitRatio = cFC.LoadFloat();
            m_fLastDesiredHitRatio = cFC.LoadFloat();
            m_fFiringDevLineAngle = cFC.LoadFloat();
            m_fFiringDeviation = cFC.LoadFloat();
            m_fMaxHitFiringDeviation = cFC.LoadFloat();
            m_fHitRatioChangeSpeed = cFC.LoadFloat();
            m_fCriticalDesiredHitRatioChangeThreshold = cFC.LoadFloat();
            m_fLastDesiredHitRatioChangeCheckTime = cFC.LoadFloat();
            m_fLastResetFiringStatisticsTime = cFC.LoadFloat();
            
            m_nCurrentAnimID = cFC.LoadInt();

            m_TrackedObject = (ChromeActor)cFC.LoadObjectRef();
            m_bTrackLookOnly = cFC.LoadBool();
            m_bTrackCanTurn = cFC.LoadBool();
            
            m_bIsFrozen = cFC.LoadBool();
            m_bWasPhysicsActiveBeforeFreeze = cFC.LoadBool();

            m_bIsActive = cFC.LoadBool();
            m_bWasFrozenBeforeDeactivate = cFC.LoadBool();
            m_bUsePathfinder = cFC.LoadBool();
            m_bUseIndoorPathfinder = cFC.LoadBool();

            arrayLen = cFC.LoadInt();
            if (arrayLen < 0)
                m_aCurrentGoToPath = null;
            else
            {
                m_aCurrentGoToPath = new Vector[arrayLen];
                for (int i = 0; i < arrayLen; i++)
                    m_aCurrentGoToPath[i] = cFC.LoadVector();
            }
            
            m_nCurrentGoToPathLen = cFC.LoadInt();
            m_nWaypointsInPath = cFC.LoadInt();
            m_vCurrentGoToPoint = cFC.LoadVector();
            m_nCurrentGoToPathIdx = cFC.LoadInt();
            m_vGoToDestination = cFC.LoadVector();
            m_fDestinationRadius = cFC.LoadFloat();
            m_bLastGoToSuccessfull = cFC.LoadBool();
            
            m_GuardedObject = (ControlObject)cFC.LoadObjectRef();
            m_fGuardedAreaRadius = cFC.LoadFloat();
            m_bGuardCritical = cFC.LoadBool();
            
            m_vStartPos = cFC.LoadVector();

            m_fIntPosOldMass = cFC.LoadFloat();
            m_bIntPos_BLOCK_MOVE = cFC.LoadBool();
            m_vIntPosDestPos = cFC.LoadVector();
            m_vIntPosDir = cFC.LoadVector();
            m_vIntPosDestDir = cFC.LoadVector();
            
            m_bIntPosWasUsingPathfinder = cFC.LoadBool();
            cAIInventoryExecutor = (Actor)cFC.LoadObjectRef();
            m_nAmmoForActiveWeapon = cFC.LoadInt();
            
            m_Motion = (AIMotionState)cFC.LoadObject(m_Motion, this);
            m_OldMotion = (AIMotionState)cFC.LoadObject(m_OldMotion, this);
            m_ActualMotion = (AIMotionState)cFC.LoadObject(m_ActualMotion, this);

            
            arrayLen = cFC.LoadInt();
            if (arrayLen < 0)
                m_aMotionVelocity = null;
            else
            {
                m_aMotionVelocity = new float[arrayLen];
                for (int i = 0; i < arrayLen; i++)
                    m_aMotionVelocity[i] = cFC.LoadFloat();
            }
            
            m_WpSystem = (WaypointSystem) cFC.LoadObject(m_WpSystem, this);
        }
        
        cFC.delete();
    }
    

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[NewAI.SGSaveChunk]\n");
        
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_NEWAI, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveObject(m_Controller);
        
        cFC.SaveBool(m_bHitReactionDisabled);
        
        cFC.SaveInt(m_nLastScreamType);
        cFC.SaveFloat(m_fNextScreamTime);
        
        if (m_aNextScreamTypeTime == null)
            cFC.SaveInt(-1);
        else
        {
            cFC.SaveInt(m_aNextScreamTypeTime.length);
            for (int i = 0; i < m_aNextScreamTypeTime.length; i++)
                cFC.SaveFloat(m_aNextScreamTypeTime[i]);
        }
            
        cFC.SaveObjectRef(cWaypoint);
        cFC.SaveObjectRef(cFirstWaypoint);
        cFC.SaveObjectRef(m_NewWaypoint);
        
        cFC.SaveBool(m_bWaypointChanged);
        cFC.SaveBool(bPortalIndependent);

        cFC.SaveObjectRef(m_Killer);

        cFC.SaveInt(m_nGrenadesLeft);
        
        cFC.SaveInt(m_nRoundsHit);
        cFC.SaveInt(m_nRoundsShot);
        cFC.SaveFloat(m_fDesiredHitRatio);
        cFC.SaveFloat(m_fLastDesiredHitRatio);
        cFC.SaveFloat(m_fFiringDevLineAngle);
        cFC.SaveFloat(m_fFiringDeviation);
        cFC.SaveFloat(m_fMaxHitFiringDeviation);
        cFC.SaveFloat(m_fHitRatioChangeSpeed);
        cFC.SaveFloat(m_fCriticalDesiredHitRatioChangeThreshold);
        cFC.SaveFloat(m_fLastDesiredHitRatioChangeCheckTime);
        cFC.SaveFloat(m_fLastResetFiringStatisticsTime);

        
        cFC.SaveInt(m_nCurrentAnimID);

        cFC.SaveObjectRef(m_TrackedObject);
        cFC.SaveBool(m_bTrackLookOnly);
        cFC.SaveBool(m_bTrackCanTurn);
        
        cFC.SaveBool(m_bIsFrozen);
        cFC.SaveBool(m_bWasPhysicsActiveBeforeFreeze);

        cFC.SaveBool(m_bIsActive);
        cFC.SaveBool(m_bWasFrozenBeforeDeactivate);
        cFC.SaveBool(m_bUsePathfinder);
        cFC.SaveBool(m_bUseIndoorPathfinder);

        if (m_aCurrentGoToPath != null)
        {
            cFC.SaveInt(m_aCurrentGoToPath.length);
            for (int i = 0; i < m_aCurrentGoToPath.length; i++)
                cFC.SaveVector(m_aCurrentGoToPath[i]);
        }
        else
            cFC.SaveInt(-1); // goto path == null
        
        cFC.SaveInt(m_nCurrentGoToPathLen);
        cFC.SaveInt(m_nWaypointsInPath);
        cFC.SaveVector(m_vCurrentGoToPoint);
        cFC.SaveInt(m_nCurrentGoToPathIdx);
        cFC.SaveVector(m_vGoToDestination);
        cFC.SaveFloat(m_fDestinationRadius);
        cFC.SaveBool(m_bLastGoToSuccessfull);
        
        cFC.SaveObjectRef(m_GuardedObject);
        cFC.SaveFloat(m_fGuardedAreaRadius);
        cFC.SaveBool(m_bGuardCritical);
        
        cFC.SaveVector(m_vStartPos);

        cFC.SaveFloat(m_fIntPosOldMass);
        cFC.SaveBool(m_bIntPos_BLOCK_MOVE);
        cFC.SaveVector(m_vIntPosDestPos);
        cFC.SaveVector(m_vIntPosDir);
        cFC.SaveVector(m_vIntPosDestDir);
        cFC.SaveBool(m_bIntPosWasUsingPathfinder);
        cFC.SaveObjectRef(cAIInventoryExecutor);
        cFC.SaveInt(m_nAmmoForActiveWeapon);

        cFC.SaveObject(m_Motion);
        cFC.SaveObject(m_OldMotion);
        cFC.SaveObject(m_ActualMotion);

        if (m_aMotionVelocity != null)
        {
            cFC.SaveInt(m_aMotionVelocity.length);
            for (int i = 0; i < m_aMotionVelocity.length; i++)
                cFC.SaveFloat(m_aMotionVelocity[i]);
        }
        else
            cFC.SaveInt(-1); //null

        cFC.SaveObject(m_WpSystem);
        
        cFC.delete(); 
    }
    
    public void SGUpdate()
    {
        
        FileChunk.Log("[NewAI.SGUpdate]\n");
		
        super.SGUpdate();
		                
        // update dla obiektow ladowanych przez LoadObject
        if (m_Controller != null)
            m_Controller.SGUpdate();
		else
			CrashLog("[NewAI.SGUpdate] Error: AIController was not created !\n");
		
        if (!IsDead() && !m_bIsFrozen && m_bIsActive)
            UpdateAllTrackings();		
		
        if (m_Motion != null)
            m_Motion.SGUpdate();
        if (m_OldMotion != null)
            m_OldMotion.SGUpdate();
        if (m_ActualMotion != null)
            m_ActualMotion.SGUpdate();

        // przywroc defaultowe motion type'y w waypointach, do ktorych referencje ma ai
        if (cWaypoint != null && cWaypoint.cMotion == null)
            cWaypoint.cMotion = new mt_Move();

        if (cFirstWaypoint != null && cFirstWaypoint.cMotion == null)
            cFirstWaypoint.cMotion = new mt_Move();

        if (m_NewWaypoint != null && m_NewWaypoint.cMotion == null)
            m_NewWaypoint.cMotion = new mt_Move();
        
        if (m_nInstanceNumber == 0 && m_CommSystem != null)
            m_CommSystem.Reinitialize();
    }
    
    public void Checkpoint()
    {
        m_Controller.Checkpoint();
    }
    
    public void MovingEnd()
    {
        m_Controller.MovingEnd();
    }
}
