public class AnimalAttack extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
    static float _MIN_TURN_ANGLE_COS = (float)Math.cos(30);
    static float _DIST_THRESHOLD = 100.f;
    
    
    
    static Vector m_vDir = new Vector();
	void PrepareScenario(AIController ai)
	{
        ChromeActor enemy = ai.GetActiveEnemy();
        if (enemy != null)
        {
            NewAIAnimal mesh = (NewAIAnimal)ai.GetMesh();
            enemy.GetPosition(m_vDir);
            m_vDir.Sub(mesh.GetPositionVectorVolatile());
            float dist2 = m_vDir.Len2();
            
            if (MathUtils.dot2D(mesh.GetForwardVectorVolatile(), m_vDir) < _MIN_TURN_ANGLE_COS)
                ai.AddTask(new TaskTurnAtDir(m_vDir));
            else
            {
                
                if (dist2 <= mesh.fBiteAttackRange * mesh.fBiteAttackRange ||
                    (ai.m_nLastPreparedScenario == _ID && 
                     !mesh.m_bLastGoToSuccessfull && 
                     !mesh.CanStandAtPos(enemy.GetPositionVectorVolatile())))
                {
                    ai.AddTask(new TaskTrackingStart(enemy));
                    ai.AddTask(new TaskEnableBiting(mesh.fBiteAnimDelay));
                    ai.AddTask(new TaskPlayAnim(AIAnimationsAnimal.A_AGGRESION_ATTACK));
                    ai.AddCleaningTask(new TaskEnableBiting(false));
                    ai.AddCleaningTask(new TaskTrackingStop());
                }
                else
                {
                    float dist = (float)Math.sqrt(dist2);
                    float distDelta;
                    if (mesh.fBiteAttackRange > _DIST_THRESHOLD)
                        distDelta = mesh.fBiteAttackRange - _DIST_THRESHOLD;
                    else
                        distDelta = 0;
                    
                    m_vDir.Mul((dist - distDelta) / dist);
                    m_vDir.Add(mesh.GetPositionVectorVolatile());
                    
                    ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_RUN));
                    ai.AddTask(new TaskGotoPos(m_vDir, 5));
                    ai.AddCleaningTask(new TaskMotionStateChange(MotionState.SPEED_WALK));
                }
            }
        }
        super.PrepareScenario(ai);
	}
	
    public String toString()
    {
        return "AA";
    }

    int GetID()
    {
        return _ID;   
    }        
}
