public class IdlePlayAnim_Animal extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;

    final static int _ALT_ANIM_PROB = 50;
    final static int _LOOK_ANIM_PROB = 30;
    
    void PrepareScenario(AIController ai)
    {
        NewAIAnimal mesh = (NewAIAnimal)ai.GetMesh();
        
        if (MathUtils.CanHappen(_LOOK_ANIM_PROB))
        {
            ai.AddTask(new TaskPlayAnim(AIAnimationsAnimal.A_IDLE_LOOK));
        }
        else if (MathUtils.CanHappen(_ALT_ANIM_PROB))
        {
            if (mesh.bAggressive)
                ai.AddTask(new TaskPlayAnim(AIAnimationsAnimal.A_AGGRESION_IDLE_ALT));
            else
                ai.AddTask(new TaskPlayAnim(AIAnimationsAnimal.A_IDLE_ALT));
        }
        else
        {
            int nTimes = ai.RandomInt(3) + 1;
            if (mesh.bAggressive)
                ai.AddTask(new TaskPlayAnim(AIAnimationsAnimal.A_AGGRESION_IDLE, nTimes));
            else
                ai.AddTask(new TaskPlayAnim(AIAnimationsAnimal.A_IDLE, nTimes));
        }
        super.PrepareScenario(ai);        
    }
    
    public String toString()
    {
        return "IPAA";
    }
    
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        

}
