public class AttackFromHideout extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
	
	AttackFromHideout()
	{
        m_fPriority = _PRIORITY_CLASS_MEDIUM;
		m_fProbability = 4; // TODO: przerzucic gdzies	
	}
    
	void PrepareScenario(AIController ai)
	{
		ChromeActor cEnemy = ai.GetActiveEnemy();
        
        if (cEnemy != null)
        {
            // strzelamy troche na poczatek
            ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_RUN));
            ai.AddTask(new TaskTrackingStart(cEnemy));             
            ai.AddTask(new TaskStartFire());
            int nAttackStopCnd = TaskWait._STOP_CND_RELOAD;
            float fAttackTime;
            if (MathUtils.CanHappen(75))
            {
                nAttackStopCnd |= TaskWait._STOP_CND_TAKE_DAMAGE;
                fAttackTime = ai.RandomFloat(1, 4);
            }
            else
            {
                // tu zachowanie bardziej berserkowe - bez reakcji na postrzal - czekaj dluzej
                fAttackTime = ai.RandomFloat(2, 4);
            }
            ai.AddTask(new TaskWait(fAttackTime, nAttackStopCnd));
            ai.AddTask(new TaskStopFire());
            
            // czekamy schowani za hideoutem
            ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_DUCK));
            ai.AddTask(new TaskStartFire());
            // czekamy zawsze troche
            ai.AddTask(new TaskWait(GameObject.RandomFloat(0.5f, 2), TaskWait._STOP_CND_RELOAD));
            
            if (MathUtils.CanHappen(70) && ai.Grenades() > 2 && ai.CanThrowGrenade())
            {
                ai.AddTask(new TaskEnableHitReaction(false));
                ai.AddTask(new TaskStopFire());
                ai.AddTask(new TaskScream(RadioCommunicationSystem._RADIO_MSG_FIRE_IN_THE_HOLE, TaskScream._SOURCE_RADIO));
                ai.AddTask(new TaskThrowGrenade(cEnemy.GetPosition(), ((AIControllerHuman)ai).GetLastCheckedGrenadeTrajectoryHeight() ));
                ai.AddCleaningTask(new TaskEnableHitReaction(true));
                ai.AddTask(new TaskWait(GameObject.RandomFloat(0.5f, 2), TaskWait._STOP_CND_RELOAD));
            }
            
            // z duzym prawdop. czekanie na zakonczenie strzelania
            if (MathUtils.CanHappen(90))
            {
                // i potem dopoki przeciwnik nie skonczy strzelac przynajmniej 1-2s
                ai.AddTask(new TaskWaitFire(GameObject.RandomFloat(1, 2)));
            }

            // czyscimy taski
            ai.AddCleaningTask(new TaskStopFire());
            ai.AddCleaningTask(new TaskTrackingStop());
        }
        else
            ai.AddTask(new TaskWait(1));
        
		super.PrepareScenario(ai);
	}            
    
    public String toString()
    {
        return "AfH";
    }
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }
}
