public class EditorGoByLift extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
    public final static float _UPDATE_INTERVAL = 0.5f;

    static int init = _EDITOR_SCENARIOS.SetBit(_ID);

    
	void PrepareScenario(AIController ai)
	{
        bhv_GoByLift bhvData = (bhv_GoByLift)ai.GetCurrActivity();
        int nType = bhvData.cType.GetValue();
        
        LiftPlatform cLift = null;
        LiftPlatformFloor cDestFloor = null;
        LiftPlatformButton cButton = bhvData.cFloorButton;
        if (cButton != null)
        {
            cLift = cButton.GetLift();
            cDestFloor = cButton.GetFloor();
            
            if (cLift != null && cDestFloor != null)
            {
                LiftPlatformFloor cCurrFloor = cLift.GetCurrentFloor();
                if (cCurrFloor != null) // jesli stoi
                {
                    if (cCurrFloor != cDestFloor) // jeszcze nie dojechal do celu
                    {
                        if ((nType & EnumGoByLiftType._START_LIFT) != 0) // ma wystarowac winde
                        {
                            // obrocenie sie w kierunku celu
                            Vector vLastDir = ai.GetMesh().GetForwardVector();
                            ai.AddTask(new TaskTurnAtDir(ai.GetCurrWaypoint().GetForwardVector()));
                            ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_KEYBOARD));
                            ai.AddTask(new TaskTurnAtDir(vLastDir));
                            
                            ai.AddTask(new TaskSendLiftToFloor(cLift, cDestFloor));
                            
                            if ((nType & EnumGoByLiftType._WAIT_FOR_FLOOR) == 0) // nie ma czekac
                            {
                                ai.AddCleaningTask(new TaskEditorActivityEnd());
                            }
                        }
                        else
                            ai.AddTask(new TaskWait(_UPDATE_INTERVAL));
                    }
                    else // dojechal
                    {
                        ai.AddCleaningTask(new TaskEditorActivityEnd());
                    }
                }
                else //jedzie
                {
                    ai.AddTask(new TaskWait(_UPDATE_INTERVAL));
                }
            }
            else
                GameObject.CrashLog("ERROR: Lift or Floor is null in LiftPlatformButton " + cButton.GetName() +"\n");
        }
        else
            GameObject.CrashLog("ERROR: cButton == null in bhvGoByLift (Waypoint: " +
                                ai.GetCurrWaypoint() + ")\n");
        super.PrepareScenario(ai);        
    }

    public String toString()
    {
        return "EBL";
    }
    
    int GetID()
    {
        return _ID;   
    }    
}
