public class EditorUseLift extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
    public final static float _UPDATE_INTERVAL = 0.5f;

    public final static float _DESTINATION_EPSILON = 5f;

    public final static float _MIN_DIR_DOT = 0.95f;
    
    
    static int init = _EDITOR_SCENARIOS.SetBit(_ID);

    
	void PrepareScenario(AIController ai)
	{
        mt_UseLift useData = (mt_UseLift)ai.GetCurrWaypoint().cMotion;

        LiftPlatform cLift = null;
        LiftPlatformButton cButton = useData.cButton;

        if (cButton != null)
            cLift = cButton.GetLift();
        
        if (cLift != null && cButton != null)
        {
            LiftPlatformFloor cFloor = cButton.GetFloor();
            if (cFloor != null)
            {
                if (!cLift.IsPlayerAbove(ai.GetMesh()) && // jeszcze nie jest w windzie &&
                    cLift.GetCurrentFloor() != cFloor) // nie ma windy - przywolaj i/lub poczekaj
                {
                    if (useData.bCanCallLift) // moze ja przywolac
                    {
                        Vector vDir = cButton.GetPosition();
                        vDir.Sub(ai.GetMesh().GetPositionVectorVolatile());
                        vDir.Normalize();
                        
                        if (MathUtils.dot2D(vDir,ai.GetMesh().GetForwardVectorVolatile())
                            < _MIN_DIR_DOT) // trzeba sie obrocic
                        {
                            ai.AddTask(new TaskTrackingStop());
                            ai.AddTask(new TaskStopFire());
                            ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_WALK));
                            ai.AddTask(new TaskTurnAtDir(vDir));
                        }
                        else if (cButton.IsActive(ai.GetMesh())) // mozna wcisnac - winda nie jedzie
                        {
                            ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_KEYBOARD));
                            ai.AddTask(new TaskExecute(cButton));
                        }
                        else
                            ai.AddTask(new TaskWait(_UPDATE_INTERVAL)); // poczekaj chwile
                    }
                    else
                        ai.AddTask(new TaskWait(_UPDATE_INTERVAL)); // poczekaj chwile
                }
                else // winda jest - wejdz i zakoncz
                {
                    float fRadiusx = useData.fRadius + _DESTINATION_EPSILON;
                    if (MathUtils.dist2D2(ai.GetCurrWaypoint().GetPosition(),
                                          ai.GetMesh().GetPosition()) >  fRadiusx * fRadiusx )
                    {
                        ai.AddTask(new TaskTurnAtObject(ai.GetCurrWaypoint()));
                        ai.AddTask(new TaskMotionStateChange((byte)useData.cSpeed.GetValue()));
                        ai.AddTask(new TaskGoToObject(ai.GetCurrWaypoint(),
                                                      5f,
                                                      useData.fRadius));
                    }
                    else //doszedl - obroc sie o 180[deg]
                    {
                        Vector vBack = ai.GetMesh().GetForwardVector();
                        vBack.fY = 0;
                        vBack.Negate();
                        
                        ai.AddTask(new TaskTurnAtDir(vBack));
                        ai.AddCleaningTask(new TaskEditorActivityEnd());
                    }
                }
            }
            else
            {
                GameObject.CrashLog("ERROR: Floor for button " + cButton.GetName() + " is null!!!\n");
            }
            
        }
        else
        {
            GameObject.CrashLog("ERROR: cLift == null or cButton == null in mt_UseLift (Waypoint: " + 
                       ai.GetCurrWaypoint() + ")\n");
        }
        super.PrepareScenario(ai);        
    }

    public String toString()
    {
        return "EMTL";
    }
    
    int GetID()
    {
        return _ID;   
    }    
}