public class IdleWalk extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;

	static float _MIN_GOTO_TIME = 2f;
	static float _MAX_GOTO_TIME = 5f;
	static float _MIN_GOTO_DISTANCE = 150f;
	static float _MAX_GOTO_DISTANCE = 450f;
	
	void PrepareScenario(AIController ai)
	{
		// losujemy docelowy punkt
        Vector vDestPosVol = MathUtils.CalcRandomMoveVolatile(_MIN_GOTO_DISTANCE, _MAX_GOTO_DISTANCE);
        vDestPosVol.Add(ai.GetMesh().GetPositionVectorVolatile());
		
		// wstajemy na wypadek, gdybysmy nie stali
		ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_WALK));

        if (!ai.GetMesh().bCanTurnWhileMoving)
            ai.AddTask(new TaskTurnAtPos(vDestPosVol));
		// idziemy
		ai.AddTask(new TaskGotoPos(vDestPosVol,
								   GameObject.RandomFloat(_MIN_GOTO_TIME, _MAX_GOTO_TIME)));
		
        super.PrepareScenario(ai);
	}
	
    public String toString()
    {
        return "IW";
    }
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }         
}
