public class RetreatShoot extends Scenario
{
    /** zakres odleglosci na jaka ma sie wycofywac     */
    final static float _MIN_RETREAT_DIST = 400;
    final static float _MAX_RETREAT_DIST = 800;    
    
    static int _ID = _NUM_OF_SCENARIOS++;

    public RetreatShoot()
    {
		m_fProbability = 4;
    }
    
	void PrepareScenario(AIController ai)
	{
        // trzeba sie zastanowic jak ustalac obiekt od ktorego ma uciekac
        ChromeActor cEnemy = null;
		cEnemy = ai.m_cActiveEnemy;        
        
		Vector vDestPos = ai.GetMesh().GetPosition();
                         
        float fDist = GameObject.RandomFloat(_MIN_RETREAT_DIST, _MAX_RETREAT_DIST);
        Vector vDir = ai.GetOppositeDir(cEnemy); // kierunek przeciwny        
        vDir.Mul(fDist);
        vDestPos.Add(vDir);
        
        ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_RUN));

        ai.AddTask(new TaskTurnAtPos(cEnemy.GetPosition()));
        ai.AddTask(new TaskTrackingStart(cEnemy)); 
		ai.AddTask(new TaskStartFire());		
        
        ai.AddTask(new TaskGotoPos(vDestPos,  4));  
        if (ai.m_nLastPreparedScenario == _ID && ai.GetMesh().m_bLastGoToSuccessfull)
            ai.AddTask(new TaskWait(1, TaskWait._STOP_CND_TAKE_DAMAGE | TaskWait._STOP_CND_RELOAD));
        
        ai.AddCleaningTask(new TaskTrackingStop());
		ai.AddCleaningTask(new TaskStopFire());        
        
        super.PrepareScenario(ai);
	}        
    
    public String toString()
    {
        return "RS";
    }
    
    // pt:. -------------   TESTY -----------  
    int GetID()
    {   
        return _ID;   
    }        
}
