public class Scenario //implements Recogniseable
{
    /////////////////////////////////////////////////////////////////////////////
    // Maski scenariuszy nalezacych do danej kategorii
    //
    static BitVector _EDITOR_SCENARIOS = new BitVector();
    
    
    /** licznik wszystkich utworzonych scenariuszy    */
    static int _NUM_OF_SCENARIOS = 0;
    
    
    
    /////////////////////////////////////////////////////////////////////////////
    // KLASY PRIORYTETOW SCENARIUSZA
    public static final float _PRIORITY_CLASS_LOW = 10;
    public static final float _PRIORITY_CLASS_MEDIUM = 20;
    public static final float _PRIORITY_CLASS_HIGH = 30;
	

	/** priorytet scenariusza */
	float m_fPriority = _PRIORITY_CLASS_LOW;
	
	/** prawdopodobienstwo wygenerowania scenariusza w srod scenariuszy o tym samym priorytecie
	 */
	float m_fProbability = 1;
    
    Scenario()
    {
    }
    

    Scenario(float fPriority)
    {
        m_fPriority = fPriority;
    }
    

    Scenario(float fPriority, float fProbability)
    {
        m_fPriority = fPriority;
		m_fProbability = fProbability;
    }	
	

    float GetPriority()
	{
		return m_fPriority;
	}
	

    float GetProbability()
	{
		return m_fProbability;
	}	
    

    void Initialize()
    {
    }
    
    
    /** budujemy liste taskow dla AI w zaleznosci od sytuacji, w ktorej
	 * sie znajdzie 
	 * UWAGA: ze wzgledu na to, ze dodawany jest tu terminator scenariusza, trzeba 
	 *        wolac to na koncu PrepareScenario w klasach dziedziczacych ze Scenario
	 */
	void PrepareScenario(AIController ai)
	{
        ai.AddTask(new TaskTerminator());
	}
	
    /** testowanie identyfikatora (fizycznie zwaca poprawne ID w klasach pochodnych)
     */
    int GetID()
    {
        return -1;
    }
}
