public class IdlePlayAnim_W extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;

    final static int _UP_DOWN_ANIM_PROB = 50;
    final static float _MIN_UP_DOWN_HOLD_TIME = 0.5f;
    final static float _MAX_UP_DOWN_HOLD_TIME = 3f;

    final static float _MIN_NORMAL_HOLD_TIME = 1f;
    final static float _MAX_NORMAL_HOLD_TIME = 4f;
    
    void PrepareScenario(AIController ai)
    {
        if (MathUtils.CanHappen(_UP_DOWN_ANIM_PROB))
        {
            if (MathUtils.CanHappen(50))
            {
                ai.AddTask(new TaskPlayAnim(AIAnimationsWalker.A_NORMAL2DOWN));
                ai.AddTask(new TaskWait(ai.RandomFloat(_MIN_UP_DOWN_HOLD_TIME, 
                                                       _MAX_UP_DOWN_HOLD_TIME)));
                ai.AddTask(new TaskPlayAnim(AIAnimationsWalker.A_DOWN2NORMAL));
            }
            else
            {
                ai.AddTask(new TaskPlayAnim(AIAnimationsWalker.A_NORMAL2UP));
                ai.AddTask(new TaskWait(ai.RandomFloat(_MIN_UP_DOWN_HOLD_TIME, 
                                                       _MAX_UP_DOWN_HOLD_TIME)));
                ai.AddTask(new TaskPlayAnim(AIAnimationsWalker.A_UP2NORMAL));
            }
        }
        ai.AddTask(new TaskWait(ai.RandomFloat(_MIN_NORMAL_HOLD_TIME, 
                                               _MAX_NORMAL_HOLD_TIME)));
        super.PrepareScenario(ai);        
    }
    
    public String toString()
    {
        return "IPAW";
    }
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        

}
