public class TaskAppear extends Task
{
    ControlObject m_cRefMtxHolder = null;
    
    boolean m_bAppear = true;
    
    
    /** Pojawienie sie AI */
    public TaskAppear()
    {
        this(true);    
    }
    
    /** Pojawienie sie / znikniecie AI */
    public TaskAppear(boolean bAppear)
    {
        this(null, bAppear);
    }

    /** Pojawienie sie AI na pozycji wyznaczonej przez podany obiekt */
    public TaskAppear(ControlObject cSpawnPoint)
    {
        this(cSpawnPoint, true);
    }

    /** Pojawienie sie / znikniecie AI na pozycji wyznaczonej przez podany obiekt */
    public TaskAppear(ControlObject cSpawnPoint, boolean bAppear)
    {
        m_cRefMtxHolder = cSpawnPoint;
        m_bAppear = bAppear;
    }
    
    
    public void Perform()
    {
        super.Perform();
        
        if (m_bAppear)
            m_cAI.GetMesh().Appear(m_cRefMtxHolder);
        else
            m_cAI.GetMesh().Disappear(m_cRefMtxHolder);
        m_cAI.Notify(AIEvents._NOTICE_END_TASK);
    }
    
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskAppear.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_APPEAR)
        {
            super.SGLoadChunk(cFC);
            m_cRefMtxHolder = (ControlObject)cFC.LoadObjectRef();
            m_bAppear = cFC.LoadBool();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskAppear.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_APPEAR, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveObjectRef(m_cRefMtxHolder);
        cFC.SaveBool(m_bAppear);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskAppear.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
