public class TaskEnableHitReaction extends Task
{
    boolean m_bEnable;

    public TaskEnableHitReaction()
    {
        this(true);
    }
                      
    public TaskEnableHitReaction(boolean bEnable)
    {
        m_bEnable = bEnable;
    }
    
    public void Perform()
    {
        super.Perform();
		m_cAI.GetMesh().m_bHitReactionDisabled = !m_bEnable;
        m_cAI.Notify(AIEvents._NOTICE_END_TASK);
	}
	public String toString()
	{
		return 	"EnableHitReaction(" + m_bEnable + ")";
	}	
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskEnableHitReaction.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_ENABLE_HIT_REACTION)
        {
            super.SGLoadChunk(cFC);
            m_bEnable = cFC.LoadBool();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskEnableHitReaction.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_ENABLE_HIT_REACTION, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveBool(m_bEnable);
        
        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskEnableHitReaction.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
