public class TaskInvokeActionChain extends Task
{
    Action[] m_aChain = null;
    
    public TaskInvokeActionChain()
    {
        //SG
    }
    
    public TaskInvokeActionChain(Action[] aChain)
    {
        m_aChain = aChain;
    }

    public void Perform()
    {
        super.Perform();
        m_cAI.InvokeActionChain(m_aChain);
        m_cAI.Notify(AIEvents._NOTICE_END_TASK);
	}
	
    
    public String toString()
    {
        return "InvokeActionChain(...)";
    }
    
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskInvokeActionChain.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_INVOKE_ACTION_CHAIN)
        {
            super.SGLoadChunk(cFC);
            int size = cFC.LoadInt();
            if (size < 0)
                m_aChain = null;
            else
            {
                m_aChain = new Action[size];
                for (int i = 0; i < size; i++)
                    m_aChain[i] = (Action)cFC.LoadObjectRef();
            }
                
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskInvokeActionChain.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_INVOKE_ACTION_CHAIN, cFCParent);
        
        super.SGSaveChunk(cFC);
        if (m_aChain != null)
        {
            cFC.SaveInt(m_aChain.length);
            for (int i = 0; i < m_aChain.length; i++)
                cFC.SaveObjectRef(m_aChain[i]);
        }
        else
            cFC.SaveInt(-1);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskInvokeActionChain.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
