public class TaskSendLiftToFloor extends Task
{
    LiftPlatform m_cLift = null;
	LiftPlatformFloor m_cFloor = null;
	
    public TaskSendLiftToFloor()
    {
        //SG
    }
    
	TaskSendLiftToFloor(LiftPlatform cLift, LiftPlatformFloor cFloor)
	{
        m_cLift = cLift;
		m_cFloor = cFloor;
	}
	
    public void Perform()
    {
        super.Perform();
        
        m_cAI.StartTaskTime(0f);
		m_cLift.Run(m_cFloor);
    }
    
    public String toString()
    {
        return "TaskSendLiftToFloor";
    }	    
    
    /** obsluguje komunikat wyslany z AIControllera */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch (nNotice)
		{
    		case AIEvents._NOTICE_TASK_TIME_PASSED:
                m_cAI.Notify(AIEvents._NOTICE_END_TASK);
			break;            
		}
    }	

    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskSendLiftToFloor.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_SEND_LIFT_TO_FLOOR)
        {
            super.SGLoadChunk(cFC);
            m_cLift = (LiftPlatform)cFC.LoadObjectRef();
            m_cFloor = (LiftPlatformFloor)cFC.LoadObjectRef();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskSendLiftToFloor.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_SEND_LIFT_TO_FLOOR, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveObjectRef(m_cLift);
	    cFC.SaveObjectRef(m_cFloor);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskSendLiftToFloor.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
