public class TaskTurnAtObject extends Task
{
    ControlObject m_Object = null;
    
    
    public TaskTurnAtObject()
    {
        //SG
    }
    
    public TaskTurnAtObject(ControlObject cObject)
	{
		m_Object = cObject;
	}    
    /** wykonuje zadanie     */
    public void Perform()
    {
        super.Perform();
        
        if (m_Object != null)
        {
            Vector vDestPos = m_Object.GetPosition();
            if(vDestPos!=null)
            {
                // ustalenie kierunku 
                Vector vDir = vDestPos;
                vDir.Sub(m_cAI.GetMesh().GetPositionVectorVolatile());
                vDir.Normalize();                
		        m_cAI.GetMesh().Turn(vDir);
            }
            else
                m_cAI.Notify(AIEvents._NOTICE_END_TASK);
        }
        else
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);  // TODO: wywalic po naprawienu Turn
    }	    
    
    public void Cancel(boolean bFast)
    {
        m_cAI.GetMesh().StopTurn();
        super.Cancel(bFast);
    }    

    /** obsluguje komunikat wyslany z AIControllera     */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
		{
        case AIEvents._NOTICE_ANGLE_REACHED:
			m_cAI.Notify(AIEvents._NOTICE_END_TASK);
			break;
		}
    }	    	 
    
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskTurnAtObject.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_TURN_AT_OBJECT)
        {
            super.SGLoadChunk(cFC);
	        m_Object = (ControlObject)cFC.LoadObjectRef();
      }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskTurnAtObject.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_TURN_AT_OBJECT, cFCParent);
        
        super.SGSaveChunk(cFC);
	    cFC.SaveObjectRef(m_Object);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskTurnAtObject.SGUpdate]\n");
        super.SGUpdate();
        //
    }
}
