import java.io.*;

public class FileChooser implements FilenameFilter
{
    protected String sDirectoryName;
    protected String sNamePrefix;
    protected String[] aExtensions;
    
    public FileChooser(String directoryName, String namePrefix, String[] extensions)
    {
        if (directoryName != null)
            sDirectoryName = new String(directoryName);
        if (namePrefix != null)
            sNamePrefix = namePrefix.toLowerCase();
        
        if (extensions != null)
        {
            aExtensions = new String[extensions.length];
            for (int i = 0; i < extensions.length; i++)
            {
                aExtensions[i] = extensions[i].toLowerCase();
                if (!aExtensions[i].startsWith("."))
                    aExtensions[i] = "." + aExtensions[i];                   
            }                
        }
    }
    
    public String[] GetFilesList()
    {
        File dir = new File(sDirectoryName);
        if (dir.exists())
            return dir.list(this);
        else
            return null;
    }
   
    public boolean accept(File dir, String name)
    {
        String toLower = name.toLowerCase();
        if (toLower.startsWith(sNamePrefix))
        {   
            if (aExtensions == null)
                return true;
            for (int i = 0; i < aExtensions.length; i++)
                if (toLower.endsWith(aExtensions[i]))
                    return true;
        }
        return false;
    }
}
