public class SoundsGroup
{
    public static String[] SOUND_FILE_EXTS = new String[] {"wav", "ogg" };

    public String sNamePrefix = null;
    public float fNoiseRange = 0;
    public float fMinDelay = 0;
    public float fMaxDelay = 0;
        
    RandomStringsGroup cNames = null;
    
    public SoundsGroup(String namePrefix, float noiseRange)
    {
        this(namePrefix, noiseRange, 0, 0);
    }
    
    public SoundsGroup(String namePrefix, float noiseRange, float minDelayTime, float maxDelayTime)
    {
        sNamePrefix = namePrefix;
        fNoiseRange = noiseRange;
        fMinDelay = minDelayTime;
        fMaxDelay = maxDelayTime;
    }
    
    public void Init(String profileDir)
    {
        String[] list = null;
        if (sNamePrefix != null && profileDir != null)
        {
            FileChooser fileChooser = new FileChooser(profileDir, sNamePrefix, SOUND_FILE_EXTS);
            list = fileChooser.GetFilesList();
        }
        cNames = new RandomStringsGroup(list);
    }
    
    public String GetSoundName()
    {
        return cNames.GetRandomValue();
    }
    
    public float GetRandomDelay()
    {
        return GameObject.RandomFloat(fMinDelay, fMaxDelay);
    }
}
