public class DefLocation extends Sprite
{
	static String _DEF_TEXTURE = "CH_P_ikonki.png";
	static int _DEF_SIZE_X = 17;
	static int _DEF_SIZE_Y = 11;
	static int _DEF_TEX_SPACE_X = 15;
	static int _DEF_TEX_SPACE_Y = 5;
	static float _UPDATE_POS_TIME = 0.2f;
	
	/** nazwa tekstury sprite'a */
	String m_TexName = _DEF_TEXTURE;
	
	/** wielkosc tekstury sprite'a */
	Vector m_vTexSize = null;

	/** koordynaty tekstury sprite'a ktory nie jest accomplished*/
	Rect m_vTexRect = null;
	
	/** koordynaty tekstury sprite'a ktory jest accomplished */
	Rect m_vTexRectAccomp = null;

	/** numer tekstury sprite'a */
	int m_iTexNo = 0;
	
	/** grupa, do ktorej nalezy lokacja */
	int m_iGroupNo = 0;
	
	/** numer objective'a, do ktorego nalezy lokacja */
	int m_iObjectiveNo = 0;
	
	Vector m_vWorldPos = null;
	
	String m_TrackedObjectName = null;
	ControlObject m_TrackedObject = null;

    String m_sText = null;
    
	String m_ToolTip = null;
	Sprite m_ToolTipSprite = null;
	boolean m_bToolTipVisible = false;
	Vector m_vToolTipTextSize = null;
	
	/** czy lokacja ma byc wyswietlana */
	private boolean m_bEnabled = false;
    /** czy lokacja ma byc wyswietlana na danym kompie sieciowym*/
	private boolean m_bEnabledNet = true;

    /**Czy objective zostal wykonany wazne dla kompasu, takie objective'y sie tam nie wyswietlaja*/
    private boolean m_bObjectiveAccomplished = false;
    
	/** czy lokacja ma byc wyswietlana na poczatku */
	boolean m_bEnableOnStart = true;
	
	DefLocation()
	{
		bSG = false;
	}
	
    
    public void OnCreate()
    {
        SetSpriteMaterial("sprite_nofiltering.mat");
    }
    
	/** inicjacja lokacji na mapie
	 */
	void InitLocation(int iGroupNo, int iObjectiveNo,
					  String meshStringID, Vector vWorldPos, String toolTip)
	{
		InitLocation(iGroupNo, iObjectiveNo, meshStringID, toolTip);
		
		InitWorldPosition(vWorldPos);
	}
	
	/** inicjacja lokacji na mapie - sledzimy obiekt
	 */
	void InitLocation(int iGroupNo, int iObjectiveNo,
					  String meshStringID, String objectName, String toolTip)
	{
		InitLocation(iGroupNo, iObjectiveNo, meshStringID, toolTip);
		
		InitWorldPosition(objectName);
	}
	
	void InitLocation(int iGroupNo, int iObjectiveNo, String meshStringID, String toolTip)
	{
		if (meshStringID == null)
		{
			CrashLog("Bledna cyfra przy tworzeniu sprite'a na mapie");
			return;
		}
		
        m_sText = new String(meshStringID);
		m_iGroupNo = iGroupNo;
		m_iObjectiveNo = iObjectiveNo;

		// ustalamy teksture sprite'a
		float fRows = java.lang.Float.valueOf(meshStringID.substring(0,1)).floatValue() - 1f;
		float fColumns = 0;
		if (meshStringID.length() == 1)
			fColumns = 0;
		else
		{
			switch ( meshStringID.charAt(1) )
			{
				case 'a':
					fColumns = 1f;
				break;
				case 'b':
					fColumns = 2f;
				break;
				case 'c':
					fColumns = 3f;
				break;
				default:
					CrashLog("Bledna cyfra przy tworzeniu sprite'a na mapie");
				return;
			}
		}
		
		float fPosX = fColumns * (_DEF_SIZE_X + _DEF_TEX_SPACE_X);
		float fPosY = fRows * (_DEF_SIZE_Y + _DEF_TEX_SPACE_Y);
        if (fRows < 6)
        {
		    m_vTexRect = new Rect(fPosX * EHudInvParams._P256,
		    					  fPosY * EHudInvParams._P128,
		    					  (fPosX + _DEF_SIZE_X) * EHudInvParams._P256,
		    					  (fPosY + _DEF_SIZE_Y) * EHudInvParams._P128);
		    float fMoveX = 4f * (_DEF_SIZE_X + _DEF_TEX_SPACE_X);
		    m_vTexRectAccomp = new Rect((fPosX + fMoveX) * EHudInvParams._P256,
		    						    fPosY * EHudInvParams._P128,
		    						    (fPosX + fMoveX + _DEF_SIZE_X) * EHudInvParams._P256,
		    						    (fPosY + _DEF_SIZE_Y) * EHudInvParams._P128);
        }
        else
        {
            fPosX = 224;
            fPosY = 96;
            m_vTexRect = new Rect(fPosX * EHudInvParams._P256,
		    					  fPosY * EHudInvParams._P128,
		    					  (fPosX + _DEF_SIZE_X) * EHudInvParams._P256,
		    					  (fPosY + _DEF_SIZE_Y) * EHudInvParams._P128);
            fPosY = 112;
		    m_vTexRectAccomp = new Rect(fPosX * EHudInvParams._P256,
		    						    fPosY * EHudInvParams._P128,
		    						    (fPosX + _DEF_SIZE_X) * EHudInvParams._P256,
		    						    (fPosY + _DEF_SIZE_Y) * EHudInvParams._P128);
        }
		m_iTexNo = AddTexture(_DEF_TEXTURE);
		SetUnaccomplishedTex();
		MoveTop();

		// ustalamy standardowa wielkosc
		m_vTexSize = new Vector(_DEF_SIZE_X, _DEF_SIZE_Y, 0f);
        SetSize(new Vector(m_vTexSize.fX * GetScreenWidth()/800f, 
                m_vTexSize.fY * GetScreenHeight()/600f, 0));
		
		m_ToolTip = toolTip;
		
		if (m_ToolTip != null)
		{
			ProcessMouse(true);
			InitToolTipSprite();
		}
		else
			ProcessMouse(false);
	}
	
	void InitToolTipSprite()
	{
		m_ToolTipSprite	= (Sprite) CreateObject("Sprite");
		m_ToolTipSprite.SetNoTexture();
		m_ToolTipSprite.SetTextColor(1f, 1f, 1f, 0.7f);
		m_ToolTipSprite.SetFont(ChromeFonts.FONT_HINT);
		m_ToolTipSprite.DisplayText(m_ToolTip);
		m_vToolTipTextSize = m_ToolTipSprite.GetTextExtent(m_ToolTip);
		Vector m_Size = new Vector(m_vToolTipTextSize);
        m_ToolTipSprite.SetSize(m_Size);
		m_ToolTipSprite.ProcessMouse(false);
		//GetModule().AddSprite(m_ToolTipSprite);
        AddChild(m_ToolTipSprite);
		m_ToolTipSprite.MoveTop();
	}
	
	void InitWorldPosition(Vector vWorldPos)
	{
		m_vWorldPos = new Vector(vWorldPos);
	}
	
	void InitWorldPosition(String trackedObjectName)
	{
		if (trackedObjectName != null)
		{
			m_TrackedObjectName = new String(trackedObjectName);
			m_TrackedObject = (ControlObject) GetModule().GetObjectByName(trackedObjectName);
			TrackObjectPosition(true);
		}
	}
	
    void Enable()
    {
        Enable( false );
    }
    
	void Enable(boolean bNet)
	{
        if ( bNet )
		    m_bEnabledNet = true;
        else
            m_bEnabled = true;
        
        if (GetHudCompass() != null && !m_bObjectiveAccomplished)
            GetHudCompass().ShowLocation(this);
    }
    
    void Disable()
    {
        Disable( false );
    }
	
	void Disable(boolean bNet)
	{
        if ( bNet )
		    m_bEnabledNet = false;
        else
            m_bEnabled = false;
        
        if (GetHudCompass() != null)
            GetHudCompass().HideLocation(this);
    }
    
    boolean CanShow()
    {
        return m_bEnabled && m_bEnabledNet;
    }
    
    boolean IsEnabled()
    {
        return IsEnabled( false );
    }
    
    boolean IsEnabled(boolean bNet)
    {
        return bNet ? m_bEnabledNet : m_bEnabled;
    }
    
    Vector l_vNewPos = new Vector();
	public void UpdateObjectPos()
	{
		if (m_TrackedObject == null)
			m_TrackedObject = (ControlObject) GetModule().GetObjectByName(m_TrackedObjectName);
		if (m_TrackedObject != null)
		{
			l_vNewPos.Set(m_TrackedObject.GetPositionVectorVolatile());
			if ( (!l_vNewPos.equals(m_vWorldPos)) )
			{
                if (m_vWorldPos == null)
                    m_vWorldPos = new Vector();
				m_vWorldPos.Set(l_vNewPos);
				SetOnMapPos();
			}
		}
	}
	
	public void TrackObjectPosition(boolean bTrack)
	{
		if (m_TrackedObjectName == null)
			return;
        
		if (bTrack)
		{
			UpdateObjectPos();
			DisableCallMethod("UpdateObjectPos");
			CallMethodEvery("UpdateObjectPos", _UPDATE_POS_TIME);
		}
		else
		{
			DisableCallMethod("UpdateObjectPos");
			m_TrackedObject = null;
		}
	}
	
	void AttachLocationToParent(Sprite parent)
	{
		parent.AddChild(this);

		if (m_TrackedObject != null)
			UpdateObjectPos();
		else
			SetOnMapPos();
	}
	
	void SetOnMapPos()
	{
		PlayerHUD player = (PlayerHUD) ((ChromeModule) GetModule()).GetMainPlayer();
		if ( (player == null) || (player.HUD == null) || (m_vWorldPos == null) )
			return;
		Vector vPos = player.HUD.GetHUDMap().GetOnMapPos(m_vWorldPos);
		/*vPos.fX += player.HUD.GetHUDMap().m_cMap.GetPos().fX;
		vPos.fY += player.HUD.GetHUDMap().m_cMap.GetPos().fY;*/
		vPos.fX -= (float) _DEF_SIZE_X / 2f;
		vPos.fY -= (float) _DEF_SIZE_Y / 2f;
		SetRelativePos(vPos);
	}
	
	void SetUnaccomplishedTex()
	{
        m_bObjectiveAccomplished = false;
        SetAlpha(1f);
		SetTexture(m_iTexNo, m_vTexRect);
	}
	
	void SetAccomplishedTex()
	{
        //Wykonane objectivy nie pokazuja sie na kompasie
        if (GetHudCompass() != null)
            GetHudCompass().HideLocation(this);
        
        m_bObjectiveAccomplished = true;
        SetAlpha(0.5f);
		SetTexture(m_iTexNo, m_vTexRectAccomp);
	}
	
    boolean IsAccomplished()
    {
        return m_bObjectiveAccomplished;
    }
    
	boolean HasObjective()
	{
		SingleObjective obj = SingleObjective.m_Manager.FindObjective(m_iGroupNo, m_iObjectiveNo);
		if (obj != null)
			return true;
		else
			return false;
	}
	
	void ShowLocation()
	{
		Show();
        MoveTop();
		if (m_ToolTipSprite != null)
			ProcessMouse(true);
		TrackObjectPosition(true);		
	}
    
    void HideToolTip()
    {
        if (m_ToolTipSprite != null)
		{
			ProcessMouse(false);
			m_ToolTipSprite.Hide();
		}
    }
    
	void HideLocation()
	{
		Hide();
		HideToolTip();
		TrackObjectPosition(false);
	}
	
    HUDCompass GetHudCompass()
    {
        PlayerHUD cPlayer = (PlayerHUD)((ChromeModule)GetModule()).GetMainPlayer();
        if (cPlayer != null)
        {
            HUDCompass cCompass = ((HUDManager)cPlayer.HUD).GetHUDCompass();
            return cCompass;
        }
        return null;
    }
    
    void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
    {
		if (!m_bEnabled || !m_bEnabledNet)
			return;
		if (m_bToolTipVisible)
			m_ToolTipSprite.SetPos(new Vector(fMouseX, fMouseY - m_vToolTipTextSize.fY, 0f));
    }

    void OnMouseEnter(float fMouseX, float fMouseY)
    {
		if (!m_bEnabled || !m_bEnabledNet)
			return;
		m_bToolTipVisible = true;
		m_ToolTipSprite.SetPos(new Vector(fMouseX, fMouseY - m_vToolTipTextSize.fY, 0f));
		m_ToolTipSprite.Show();
        m_ToolTipSprite.MoveTop();
    }
    
    void OnMouseLeave(float fMouseX, float fMouseY)
    {
		if (!m_bEnabled || !m_bEnabledNet)
			return;
		m_bToolTipVisible = false;
		m_ToolTipSprite.Hide();
    }
	
    void OnDestroy()
    {
        if (m_ToolTipSprite != null)
        {
            GetModule().RemoveSprite(m_ToolTipSprite);
            m_ToolTipSprite.delete();
            m_ToolTipSprite = null;
        }
        if (m_iTexNo != 0)
            ReleaseTexture(m_iTexNo);
    }
    
    void Destroy()
    {
        GetModule().RemoveSprite(this);
    }
}
