/** klasa opisujaca lokacje objective lub dowolna inna lokacje
 * (dowolna w takim sensie, ze nie jest przypisana do objective)
 */
public class LocationDescription
{
	/** numer grupy, do ktorej nalezy location */
	int m_iLocationGroupNo = 0;
	
	/** numer location */
	int m_iLocationNo = 0;
	
	/** tekst, ktory identyfikuje standardowa teksturke lokacji */
	String m_TextStringID = null;
	
	/** nazwa sledzonego obiektu */
	String m_TrackedName = null;
	
	/** pozycja w swiecie lokacji */
	Vector m_vWorldPos = null;
	
	String m_ToolTip = null;
	
	LocationDescription(int iGroupNo, int iLocationNo,
						String textStringID, Vector vWorldPos)
	{
		m_iLocationGroupNo = iGroupNo;
		m_iLocationNo = iLocationNo;
		m_TextStringID = new String(textStringID);
		m_vWorldPos = new Vector(vWorldPos);
	}

	LocationDescription(int iGroupNo, int iLocationNo,
						String textStringID, String objName)
	{
		m_iLocationGroupNo = iGroupNo;
		m_iLocationNo = iLocationNo;
		m_TextStringID = new String(textStringID);
		m_TrackedName = new String(objName);
	}
	
	void SetToolTip(String s)
	{
		m_ToolTip = new String(s);
	}
	
	static LocationDescription FindLocation(int iGroupNo, int iObjectiveNo,
											java.util.Vector locations)
	{
		for (int i = 0; i < locations.size(); i++)
		{
			LocationDescription loc = (LocationDescription) locations.elementAt(i);
			if ( (loc.m_iLocationGroupNo == iGroupNo) && (loc.m_iLocationNo == iObjectiveNo) )
				return loc;
		}
		return null;
	}
}
