public class Objective extends EditorObjective
{
    {sEditorComment = "Game objective";}
    
    String GetText()
    {
        return sTextID;
    }
    
    public void OnCreate()
    {
        bSG = true;
        super.OnCreate();
    }
    
    public void Enable()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        module.m_ObjectivesManager.EnableObjective(iObjectiveOrderNumber);
    }
    
    public void Disable()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        module.m_ObjectivesManager.DisableObjective(iObjectiveOrderNumber);
    }
    
    public boolean IsEnabled()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return false;
        
        ChromeModule module = (ChromeModule) GetModule();
        return module.m_ObjectivesManager.IsEnabledObjective(iObjectiveOrderNumber);
    }
    
    public void Accomplish()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        module.m_ObjectivesManager.SetAccomplished(iObjectiveOrderNumber);
    }
    
    public void Unaccomplish()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        module.m_ObjectivesManager.SetUnaccomplished(iObjectiveOrderNumber);
    }
    
    public boolean IsAccomplished()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return false;
        
        ChromeModule module = (ChromeModule) GetModule();
        return module.m_ObjectivesManager.IsAccomplished(iObjectiveOrderNumber);
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[Objective.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_OBJECTIVE)
        {
            super.SGLoadChunk(cFC);
            
            ChromeModule module = (ChromeModule) GetModule();
            module.m_ObjectivesManager.SetMessagesActive(false);
            
            if(cFC.LoadBool())
			{
				//module.m_ObjectivesManager.EnableLocation(iObjectiveOrderNumber);
                Enable();
			}
            else
			{
				//module.m_ObjectivesManager.DisableLocation(iObjectiveOrderNumber);
                Disable();
			}
            
            if(cFC.LoadBool())
                Accomplish();
            else
                Unaccomplish();
            
            module.m_ObjectivesManager.SetMessagesActive(true);
        }
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Objective.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_OBJECTIVE, cFCParent);

        super.SGSaveChunk(cFC);
        
        cFC.SaveBool(IsEnabled());
        cFC.SaveBool(IsAccomplished());
        
		cFC.delete();
    }
}
