
/**Pawn jest to kazdy {@link Actor}, ktory moze byc kontrolowany przez
 * gracza lub AI. Potrafi poslugiwac sie bronia.*/
public class Pawn extends AnimActor implements ipar_StepsNoise
{
    static int s_nLocale = -1;
    
    static float MAX_STEP_CHECK_TRACE_LEN = 350.f;
    static float MAX_STEP_CHECK_TRACE_LEN2 = 2500.f;
    
    /**Czy obcinac czesci ciala przy postrzale*/
    boolean bCutBodyParts = true; // not SG
    /** okresla jaki system czastek ma byc uruchamiany do symulacji bryzgow krwi od urywanej konczyny */
    public String sCutBodyPartsBlood[] = {    
        "",//_PELVIS
        "",//_SPINE
        "",//_SPINE1
        "",//_SPINE2
        "CutBodyPartBlood",//_NECK
        "CutBodyPartBlood",//_HEAD    
        "CutBodyPartBlood",//_L_CLAVICLE
        "CutBodyPartBlood",//_L_UPPERARM
        "CutBodyPartBlood",//_L_FOREARM
        "CutBodyPartBlood",//_L_HAND
        "CutBodyPartBlood",//_R_CLAVICLE
        "CutBodyPartBlood",//_R_UPPERARM
        "CutBodyPartBlood",//_R_FOREARM
        "CutBodyPartBlood",//_R_HAND    
        "CutBodyPartBlood",//_L_THIGH
        "CutBodyPartBlood",//_R_THIGH        
        "CutBodyPartBlood",//_L_FINGER2
        "CutBodyPartBlood",//_R_FINGER2    
        "CutBodyPartBlood",//_L_CALF
        "CutBodyPartBlood",//_R_CALF
        "CutBodyPartBlood",//_L_FOOT
        "CutBodyPartBlood",//_R_FOOT
    };

    /** okresla ile "energii" trzeba zabrac zeby urwac konczyne*/
    public float fCutBodyPartsCutDamage[] = {
        0.0f,//_PELVIS
        0.0f,//_SPINE
        0.0f,//_SPINE1
        0.0f,//_SPINE2
        100.0f,//_NECK
        100.0f,//_HEAD    
        100.0f,//_L_CLAVICLE
        100.0f,//_L_UPPERARM
        100.0f,//_L_FOREARM
        100.0f,//_L_HAND
        100.0f,//_R_CLAVICLE
        100.0f,//_R_UPPERARM
        100.0f,//_R_FOREARM
        100.0f,//_R_HAND    
        100.0f,//_L_THIGH
        100.0f,//_R_THIGH        
        100.0f,//_L_FINGER2
        100.0f,//_R_FINGER2    
        100.0f,//_L_CALF
        100.0f,//_R_CALF
        100.0f,//_L_FOOT
        100.0f,//_R_FOOT
    };

    /** okresla ile "energii" jeszcze pozostalo w konczynie*/
    public float fCutBodyPartsCurrentDamage[] = {
        0.0f,//_PELVIS
        0.0f,//_SPINE
        0.0f,//_SPINE1
        0.0f,//_SPINE2
        100.0f,//_NECK
        100.0f,//_HEAD    
        100.0f,//_L_CLAVICLE
        100.0f,//_L_UPPERARM
        100.0f,//_L_FOREARM
        100.0f,//_L_HAND
        100.0f,//_R_CLAVICLE
        100.0f,//_R_UPPERARM
        100.0f,//_R_FOREARM
        100.0f,//_R_HAND    
        100.0f,//_L_THIGH
        100.0f,//_R_THIGH        
        100.0f,//_L_FINGER2
        100.0f,//_R_FINGER2    
        100.0f,//_L_CALF
        100.0f,//_R_CALF
        100.0f,//_L_FOOT
        100.0f,//_R_FOOT
    };

    /** Zmienna steruje sprawdzaniem */
    public static boolean bTerrainError = false;
    
    /** Znacznik, czy AI ma upadac po smierci na fizyce (in.: na animacji) */
    public boolean bUsePhysicsToDeathFall = true;//#PAWN

    // flaga okresla czy mozna przeszukac zwloki Pawna
    public boolean bNoBodySearch = false;//#PAWN
    
    /** Aktualna bron Pawna */
    Weapon ActiveWeapon = null; //dyn // SG
    int    nActiveWeaponId = -1; //dyn // not SG
    
    /** Poprzednia bron */
    Weapon PreviousActiveWeapon = null; //dyn // SG
    
    /** flaga mowiaca czy w danej chwili przeszukiwane sa zwloki pawna
     */
    public boolean bIsCorpseActive = false; //dyn // SG

    /** Flaga mowi czy obiekt ma byc widoczny na detektorze ruchu
     */
    public boolean bShowOnMoveDetector = true;//#PAWN;
    
    /** InvIndex dla kazdego rodzaju broni */
    int [] nWeaponInvIndex = null; // not SG

    /** Lista przedmiotow (Inventory) pawna */
    Inventory cInventory = null; //dyn // SG

	SeatInfo cSeatInfo = null; // SG
    
    /** czy chodzimy po wodzie ? */
    protected boolean bInWater = false; //dyn // not SG
    
    /** czy chodzimy po wodzie na tyle gleboko ze powinnismy zaczac plywac? */
    protected boolean bUnderWater = false; //dyn // not SG

    // dlugosc promienia strzelanego przy chodzeniu do badania po czym chodzi Pawn
    float fStepCheckTraceLen = MAX_STEP_CHECK_TRACE_LEN;
    
    /**Index tablicy FX i Splatow dla glownych czesci ciala 
     */
    final static int BODY_PART_UNKNOWN = -1;
    final static int BODY_PART_TORSO = 0;
    final static int BODY_PART_HEAD = 1;
    final static int BODY_PART_LEG = 2;
    final static int BODY_PART_ARM = 3;
    
    /** Wspolczynniki sily trafienia dla poszczegolnych czesci ciala
     *  (BODY_PART_..)
     */
    public float aDamageMultipliers[] = { 1.f, 5.f, .6f, .6f};

    

    /** Odleglosci, z jakich mozna uslyszec poruszajacego sie gracza */
    float aStepVirtualNoise[] = {0,   //STILL
                                 1500, //SWIM
                                 0, //CRAWL (bylo 150) \
                                 0, //DUCK (bylo 300)  | Zalozenie - gracz ma byc nieslyszalny dla AI jak cicho chodzi...
                                 0, //WALK (bylo 450)  /
                                 1500 //RUN
                                 };
    
    // typy halasow jakie moga byc w grze
    static final int _NOISE_MOTION                  = 1;
    static final int _NOISE_WEAPON_FIRING           = 2;
    static final int _NOISE_BULLET_HIT              = 3;
    static final int _NOISE_SCREAM                  = 4; // rozne krzyki AI (od zwolywania sie po krzyk z bolu)
    static final int _NOISE_DANGEROUS_OBJECT_NEARBY = 5; // dzwiek ostrzegawczy wydawany np. przez granaty, bomby (dla AI)
    static final int _NOISE_BODY_FALL               = 6; // dzwiek osuwajacego sie ciala AI
    static final int _NOISE_EXPLOSION               = 7; // dzwiek wybuchu (granat)
    static final int _NOISE_PASSAGE                 = 8; // dzwiek odpalany w przejsciach (np. drzwi, winda)
    
    /** Masa ciala pawna - do symulacji fizyki ciala */
    public float fBodyMass = 100;  //#PAWN
    
    /** Tablica z poziomami glosnosci do odgrywania dzwiekow stawiania krokow */
    float aStepVolume[] = {1.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.0f};

    /** Numer materialu na ktorym aktualnie stoi pawn */
    int nStandingOnMaterial = 0; // not SG
    
    MeshObject cStandingOnObject = null;
    
    //////////////////////////////////////////////////
    // Paramsy wyrzucania fizyka rzeczy z Inventory //
    //////////////////////////////////////////////////
    

    /** Wysokosc z jakiej wyrzucane sa przedmioty przy uzyciu PhysicsDrop */
    public float fPhDropHeight = 100.f; // not SG
    /** Przesuniecie do przodu dla wyrzucania sa przedmiotow przy uzyciu PhysicsDrop */
    public float fPhDropForward = 1.f; // not SG
    /** Predkosc do gory z jakia wyrzucane sa przedmioty przy uzyciu PhysicsDrop */
    public float fPhDropVSpeed = 130.f; // not SG
    /** Predkosc do przodu z jakia wyrzucane sa przedmioty przy uzyciu PhysicsDrop */
    public float fPhDropHSpeed = 70.f; // not SG
    
    
    /** Dumik oka pod ktory bedzie podpinana kamera po smierci */
    ControlObject m_cDeathCameraEyeDummy = null;

    /** czy pawn jest w budynku, czy na zewnatrz */
    public boolean m_bPawnInBuilding = false;
    
    String sFXBlood = "FXBlood";
    ////////////
    // Metody //
    ////////////

    /** Wolane przy tworzeniu Pawna. Wazne, zeby wolac to dla klas pochodnych od Pawn
     * bo tu tworzy sie tablica broni odpowiednia.
     */
    public void OnCreate()
    {
        if (s_nLocale == -1)
            s_nLocale = ELocale.GetLocale();
        
        sFXBlood = GetHitFXByLocale(s_nLocale);
        
        // zawolanie OnCreate z aktora
        super.OnCreate();
		
		// bSG = true;
        
        // ustawienie parametrow liczenia kolizji z promieniami
        SetTraceCollType(ECollTraceFlags._ELEMENT_BOX);
        SetCollType(ECollFlags.OBJCOL_TYPE_ELLIPSOID);
        
        ClearFlag(EFlags._RECEIVE_SHADOWS);
        
        // temp rem by macki
        ClearFlag(EFlags._FXPARTICLE_COLLISION);
        
        //ShowCoarseBox(true);

        nWeaponInvIndex = new int[EWeaponType.count];
        
        InitInventory();

        // inicjacja fizyki ciala
        PhysicsCreate( fBodyMass );

        SetMaxClimbAngle(65);
        
    }

    void OnDestroy()
    {
        super.OnDestroy();
        if ( m_cDeathCameraEyeDummy != null )
        {
            m_cDeathCameraEyeDummy.delete();
            m_cDeathCameraEyeDummy = null;
        }
    }
    
    /**
     */
    void InitInventory()
    {
        //Log ("<> Creating Inventory\n");
        cInventory = (Inventory)CreateObjectNoInit("Inventory");
        cInventory.Owner = this;
        cInventory.InitObject();
    }

    /** 
     * Sprawdza czy podany obiekt znajduje sie w inwentory pawna
     */
    boolean IsObjectInInventory(InvObject cObj)
    {
        return ( ( cInventory != null ) &&
                 ( cObj       != null ) &&
                 ( cInventory.BecomeToThisInventory( cObj ) ) );
    }
    
    

        
    /**Wiadomosci tekstowe wypisywane podczas roznych okazji.
     * Pawn nic sobie z nich nie robi, ale Player wypisuje na ekran.
     */
    void TextMessage(String s)
    {
    }

    /**
     * Dzwieki damage'u (ustawiane wg locale razem z fxem krwi)
     */
    String[] aDamageSounds = null;
    
    /**Zwraca nazwe dzwieku w zaleznosci od trafienia w poszczegolne czesci ciala.
     * @return nazwa dzwieku
     */
    String GetHitSound(int nBone)
    {
        //TODO FIXIT
        return aDamageSounds[ RandomInt( aDamageSounds.length ) ];
    }

    /**Zwraca nazwe dzwieku w zaleznosci od trafienia w poszczegolne czesci ciala i od typu damage.
     * @return nazwa dzwieku */
    String GetHitSound(int nMeshElementorBoneID, int nDamageType)
    {
        //TODO FIXIT
        if (nDamageType == EnumDamageType._DROWNING)
            return "Data/Sounds/Player/drowning" + (1+RandomInt(3)) + ".wav";
        else
            return GetHitSound(nMeshElementorBoneID);
    }


    boolean bSinking = false; // not SG
    float fLastSinkingTime = 0;

    void Respawn()
    {
        bInWater = false;
        bUnderWater = false;
        bSinking = false;
        
        if (m_cDeathCameraEyeDummy != null)
            m_cDeathCameraEyeDummy.DeactivateOnModuleAlways();
        
        for(int i = 0; i < 22; ++i)
            fCutBodyPartsCurrentDamage[i] = fCutBodyPartsCutDamage[i];
    }

    static boolean bSinkingDisabled = false;
    
    
    
    void CheckIfSwimming()
    {
		
/* Player ma wlasne CheckIfSwimming(), a to nie jest wolane w onframe pawna, wiec ten kod
   nie jest uzywany
		Vector currPos = GetPosition();
        float fWaterLevel = GetModule().GetWaterLevel();

        bUnderWater = bInWater    = fWaterLevel > currPos.fY;
        
        //zmieniam definicje topienia sie,
        if (fWaterLevel > currPos .fY +  165)
        {
            if(!bSinkingDisabled)
            {
                if (!bSinking)
                {
                    LogD(" Sinking !\n");
                    bSinking = true;
                    fLastSinkingTime = GetTime();
                    TakeDamage(10, null, null, null, EBones._NON_BONE);
                }
                else
                {
                    if (GetTime() - fLastSinkingTime > 1)
                    {
                        TakeDamage(40, null, null, null, EBones._NON_BONE);
                        fLastSinkingTime = GetTime();
                    }
                }
            }
            else
                bUnderWater = bInWater = false;
        }
        else
        {
            bSinking = false;
        }
        
        if(bSinkingDisabled)
			bUnderWater = bInWater = false;
        
        if(currPos.fY < -3000.0f)
            Die();
*/		
    }
    
    static Vector l_vStartPOF = new Vector();
    static Vector l_vEndPOF = new Vector();
    
    
    /**
     */
    void ProcessOnFrame()
    {
        CheckIfSwimming();
        
        // gracz wisi i chyba stoi na jakims obiekcie
        // liczymy kolizje z obiektami pod graczem
        GetPosition(l_vStartPOF);
        l_vStartPOF.fY += 10.0f;
        
        l_vEndPOF.Set(0, -fStepCheckTraceLen, 0);
        l_vEndPOF.Add(l_vStartPOF);
        
        nStandingOnMaterial = -1;
        
        Collision stCollObject = null;
        boolean bNextCheck = false;
        do {
            
            // sprawdzamy kolizje z obiektami
            stCollObject=TraceObjectsExclude(l_vStartPOF, l_vEndPOF, this);

            // jest kolizja z obiektem
            if((stCollObject!=null) && (stCollObject.Obstacle != null))
            {
                nStandingOnMaterial =  stCollObject.nMaterial;
                cStandingOnObject = (MeshObject)stCollObject.Obstacle;
            }
            else
                cStandingOnObject = null;
        
            // sprawdzamy kolizje z drzewami
            Collision stCollTrees=TraceTrees(l_vStartPOF, l_vEndPOF);
            if(stCollTrees!=null)
                nStandingOnMaterial = stCollTrees.nMaterial;
        
            if(nStandingOnMaterial == -1)
            {
                float fGroundHeight = TerrainHeight(l_vEndPOF.fX, l_vEndPOF.fZ);
                
                // gdy badany byl trace przecinajacy ziemie to nie ma co dalej robic
                if(l_vStartPOF.fY > fGroundHeight && l_vEndPOF.fY < fGroundHeight)
                    bNextCheck = false;
                else
                {
                    // wydluzenie tracea tylko za pierwsza iteracja
                    if(!bNextCheck)
                    {
                        // wyzdluzamy trace'a
                        l_vEndPOF.fY -= MAX_STEP_CHECK_TRACE_LEN2;
                        bNextCheck = true;
                    }
                    else
                        bNextCheck = false;
                }
            }
            else
                bNextCheck = false;
            
        } while(bNextCheck);
        
        // nie byl ustawiony material, wiec wlaczamy ziemie
        if(nStandingOnMaterial == -1)
        {
            // nie ma kolizji pewnie latamy lub stoimy na terenie
            nStandingOnMaterial = EMaterialType._GROUND;
        }

        //
        ChromeModule module = (ChromeModule)GetModule();
        
        // dla gracza jeszcze okreslamy czy jest w budynku
        if(this == module.GetMainPlayer())
        {
            if (stCollObject != null && stCollObject.Obstacle instanceof LiftPlatformBase)
            {
                //windy na wieze straznicze powinny miec ustawione bOutdoorLift na true
                SoundEmitter.bListenerInsideBuilding = !((LiftPlatformBase)stCollObject.Obstacle).bOutdoorLift;
            }
            else
            {
                SoundEmitter.bListenerInsideBuilding = 
                    (stCollObject != null) && (
                    (stCollObject.Obstacle instanceof Inside) ||
                    (stCollObject.Obstacle instanceof Teleport) ||
                    (stCollObject.Obstacle instanceof DoorsObject) ||
                    //((stCollObject.Obstacle instanceof LiftPlatformBase) && 
                    // !((LiftPlatformBase)stCollObject.Obstacle).bOutdoorLift) ||
                    stCollObject.Obstacle.IsInPortalObject()
                    );
            }            
            
            /*
            LogR("bListenerInsideBuilding="+SoundEmitter.bListenerInsideBuilding+"\n");
            if(stCollObject.Obstacle != null)
            {
                LogR("stCollObject.Obstacle="+stCollObject.Obstacle.GetName()+":"+stCollObject.Obstacle.getClass().getName()+"\n");
            }
            */
            
            if(SoundEmitter.bListenerInsideBuilding == false &&
               bPrevListenerInsideBuilding == true)
            {
                // wyjscie z budynku
                GetModule().ListenerGoesToOpenSpace();
                
                m_bPawnInBuilding = false;
                SetCollFlags(ECollFlags.OBJCOL_FLAG_TESTTERRAINTYPE);
            }
            else
            {
                if(SoundEmitter.bListenerInsideBuilding == true &&
                   bPrevListenerInsideBuilding == false)
                {
                    // wejscie do budynku
                    GetModule().ListenerGoesInToBuilding();
                    
                    m_bPawnInBuilding = true;
                    ClearCollFlags(ECollFlags.OBJCOL_FLAG_TESTTERRAINTYPE);
                }
            }
            
            bPrevListenerInsideBuilding = SoundEmitter.bListenerInsideBuilding;
        }
    }
    
    static boolean bPrevListenerInsideBuilding = false;
    
    static final float fMaxStepSoundDist = 2000.f;
    static final float fMaxStepSoundDist2 = fMaxStepSoundDist * fMaxStepSoundDist;
                    
    float fStepSoundMin = 50f;
    float fStepSoundMax = 4000f;

    /** Zwraca odpowiedni dzwiek chodzenia w zaleznosci od MotionState i materialu
     * na jakim chodzi Pawn
     */
    void PlayStepSound(MotionState mot, int nMaterial)
    {
        ChromeModule module = (ChromeModule)GetModule();
        // sprawdzamy odleglosc do gracza
        if(this instanceof Player || !(module instanceof ChromeModuleSingle))
        {
            PlayStepSound(mot, nMaterial, fStepSoundMin, fStepSoundMax);
        }
        else
        {
            Camera cam = module.GetActiveViewCamera();
            float fDist2 = GetDistance2To( cam.GetPositionVolatile() );
            if(fDist2 < fMaxStepSoundDist2)
                PlayStepSound(mot, nMaterial, 50.0f, fMaxStepSoundDist);
        }
    }
    
    /** Odpalenie dzwieku krokow w zaleznosci od MotionState i materialu z podaniem zasiegow dzwieku
     *  ale bez testowania odleglosci od kamery
     */
    void PlayStepSound(MotionState mot, int nMaterial, float fMinDist, float fMaxDist)
    {
        //LogR("[Pawn.PlayStepSound] nMaterial="+nMaterial+"\n");
        // pobieramy z modulu dzwiek
        ChromeModule module = (ChromeModule)GetModule();

        // rozszyfrowujemy rodzaj dzwieku poruszania sie
        int nMotionStepType = ChromeModule._STEP_SOUND_MOVE;
        
        if( mot.iSpeed == MotionState.SPEED_DUCK ) 
            nMotionStepType = ChromeModule._STEP_SOUND_NONE;
        else if (mot.iSpeed == MotionState.SPEED_CRAWL)
            nMotionStepType = ChromeModule._STEP_SOUND_NONE;
        else if(bInWater/*mot.iSpeed == MotionState.SPEED_SWIM*/)
            nMotionStepType = ChromeModule._STEP_SOUND_SWIM;

        // troche chamsko, ale w wodzie odpalamy zawsze dzwiek
        if(nMaterial == EMaterialType._WATER)
            nMotionStepType = ChromeModule._STEP_SOUND_MOVE;
        
        if (nMotionStepType != ChromeModule._STEP_SOUND_NONE)
        {
            String sStepSound = module.GetStepSound(nMaterial, nMotionStepType);
            if(sStepSound != null)
                AttachOneShotSound(sStepSound, fMinDist, fMaxDist);
        }
    }
    
/*    public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        MakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType, true);
        Bleed(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
    }
	
    public void Bleed(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        // odpalenie dzwiekow trafienia w cialo - nie maja one nic wspolnego ze wzdychaniem AI
        //CrashLog("Playing bleed sound\n");
        PlaySound(GetHitSound(nDamageType), 2000.0f, 5000.0f);
        
        // odpalamy efekt trafienia - vSpeed - normalna
        ExecuteFX(GetHitFX(nDamageType), vHitLocation, vSpeed);
        ExecuteParticleSystem("krew", vHitLocation, vSpeed);
        
        //TODO sprawdzic, czy w nDamage jest "dobry" id kosci
        if (nDamageType != -1)
        {
            //TODO przy damagu ogolnym (-1) od np rakiet zakrwawiac jakies elementy
            //Zalewanie krwia
            this.ExecuteFXTraceProjected(this, GetMeshElemFromBoneID((byte)nDamageType), "TraceBlood", PointWorldToLocal(vHitLocation), VectorWorldToLocal(vSpeed));
                        
            //TODO lepsze warunki
            //Obcinanie czesci ciala
            //if ((this instanceof AIBase) && 
            //(((MeshObject)this).GetElementsNumber()> 1) && 
            //(fDamage >= 40f) && //trzeba uzyc mocniejszej broni do odstrzelenia
            //bCutBodyParts
            //)
            //{
            //CrashLog("Cutting " + EBones.GetNameFromID((byte)nDamageType) + " from " + GetName());
            //CutBodyPart((byte)nDamageType, true);
            //}
        }
    }

    public void MakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation,
                           Vector vSpeed, int nDamageType)
    {
        MakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType, true);
    }

    public void MakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation,
                           Vector vSpeed, int nDamageType, boolean bClampDamage)
    {
        float fMultiplier = GetDamageMultiplier(nDamageType);

        // odebranie energii
        boolean bWasDead = bDead;
        fDamage *= fMultiplier;
        Damage(fDamage);

        if (bDead && bUsePhysicsToDeathFall)
        {
            if (!bWasDead && (nDamageType != EBones._NON_BONE))
            {
                //uderzamy sztucznie w szyje
                nDamageType = EBones._NECK; 
                vHitLocation = GetBoneJointPos((byte)nDamageType);
            }
            
            //boolean bClampDamageNow = bClampDamage;
            boolean bClampDamageNow = true;
            
            if(nDamageType == -2)
            {
                // dla trafienia rakieta zwiekszamy sile rozrzutu
                fDamage*=100.5f;
                vSpeed.Mul(10.0f);
                //CrashLog("Zwiekszamy damage fDamage="+fDamage+"\n");
                
                bClampDamageNow = false;
                
                nDamageType = EBones._NECK;
                vHitLocation = GetBoneJointPos((byte)nDamageType);
                
            }
            else
            {
                // PZ: Hack zeby nie latal:
                fDamage/=3.0f;
                vSpeed.fY = 0;
            }
            
            Physics.Simulate(this, vHitLocation, vSpeed, fDamage, nDamageType, bClampDamage);
        }
    }
*/
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
	public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
	{
        MakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType, true);
        Bleed(fDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
	}
	
    public void Bleed(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        // odpalenie dzwiekow trafienia w cialo - nie maja one nic wspolnego ze wzdychaniem AI
        PlaySound(GetHitSound(nMeshElementorBoneID, nDamageType), 2000.0f, 5000.0f);
        
        // odpalamy efekt trafienia - vSpeed - normalna (potrzebne wektory nie moga byc nullami)
        if (vHitLocation != null && vSpeed != null)
        {
            if (GetHitFX() != null)
            {
                ExecuteFX(GetHitFX(), vHitLocation, vSpeed);
                ExecuteParticleSystem(GetHitFX(), vHitLocation, vSpeed);
            }
            
            if (nMeshElementorBoneID != EBones._NON_BONE)
            {
                // Zalewanie krwia - jezeli trafilismy w kosc:
                int iMeshElement = GetMeshElemFromBoneID((byte) nMeshElementorBoneID);
                if (s_nLocale != ELocale._GERMAN)
                    ExecuteFXTraceProjected( this, iMeshElement, "TraceBlood", 
                                         PointWorldToLocal(iMeshElement, vHitLocation), 
                                         VectorWorldToLocal(iMeshElement, vSpeed) );
            }
        }
    }

    public void MakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation,
                           Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        MakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType, true);
    }

    public void MakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation,
                           Vector vSpeed, int nMeshElementorBoneID, int nDamageType, boolean bClampDamage)
    {
        float fMultiplier = GetDamageMultiplier(nMeshElementorBoneID);

        boolean bDeadBeforeDamage = bDead;
        fDamage *= fMultiplier;
        Damage(fDamage, nDamageType);

        if (bDead && bUsePhysicsToDeathFall)
        {
			// jezeli go wlasnie usmiercilismy i dostal w kosc
            if ( (!bDeadBeforeDamage) && (nMeshElementorBoneID != EBones._NON_BONE) )
            {
                // uderzamy sztucznie w szyje
                //nMeshElementorBoneID = EBones._NECK; 
                //vHitLocation = GetBoneJointPos((byte) nMeshElementorBoneID);
            }
            
            if ( (nDamageType == EnumDamageType._BLAST) || (nDamageType == EnumDamageType._BLAST_SPECIAL) )
            {
                // zwiekszamy sile odrzutu
                //fDamage *= 100.5f;
                //vSpeed.Mul(10f);
                //nMeshElementorBoneID = EBones._NON_BONE;
                //vHitLocation = GetBoneJointPos((byte) nMeshElementorBoneID);
            }
			else
			if (nDamageType == EnumDamageType._COLLISION)
			{
                vSpeed.fY = 0f;
                nMeshElementorBoneID = EBones._NECK;
                vHitLocation = GetBoneJointPos((byte) nMeshElementorBoneID);
			}
            else
            {
                fDamage /= 3f;
                vSpeed.fY = 0f;
            }
            //w wersji ocenzurowanej nie mozna poniewierac zwlok
            if (!(bDeadBeforeDamage && s_nLocale == ELocale._GERMAN))
                Physics.Simulate(this, vHitLocation, vSpeed, fPhSimDamage, nMeshElementorBoneID, bClampDamage);
        }
    }
	
    /**Zwraca nazwe efektu w zaleznosci od trfienia w poszczegolne czesci ciala.
     * @return nazwa efektu */
    String GetHitFX()
    {
        return sFXBlood;
    }

    String GetHitFXByLocale(int nLocale)
    {
        //dzwieki standardowe        
        aDamageSounds = new String[]{ "Data/Sounds/Player/bhit_flesh-1",
                           "Data/Sounds/Player/bhit_flesh-2", 
                           "Data/Sounds/Player/bhit_flesh-3",
                           "Data/Sounds/HitFleshL_01",
                           "Data/Sounds/HitFleshS_01",
                           "Data/Sounds/HitFleshS_02"  };

        switch (nLocale)
        {
        case ELocale._GERMAN:
            
            if (this instanceof PlayerSingle)
                return null;

            if (this instanceof PlayerNetBase)
                return "MetalBulletLarge";
            
            //tu bedzie ai
            aDamageSounds = new String[]{ "Data/Sounds/Weapon/ricwoodpistol",
                               "Data/Sounds/Weapon/ricwoodpistol", 
                               "Data/Sounds/Weapon/ricplasticpistol",
                               "Data/Sounds/Weapon/ricplasticpistol"};
            
            return "MetalBulletSmall";
        default:
            aDamageSounds = new String[]{ "Data/Sounds/Player/bhit_flesh-1",
                               "Data/Sounds/Player/bhit_flesh-2", 
                               "Data/Sounds/Player/bhit_flesh-3",
                               "Data/Sounds/HitFleshL_01",
                               "Data/Sounds/HitFleshS_01",
                               "Data/Sounds/HitFleshS_02"  };
            
            if (this instanceof PlayerNetBase)
                return "FXBloodMultiplayer";
            
            return "FXBlood";
        }
    }
    
    //to bedzie wolane przez bron
    public boolean CutBodyPart(byte eBone, float fDamage)
    {             
     fCutBodyPartsCurrentDamage[eBone] -= fDamage;          
     CutBodyPart(eBone, true);
     return true;     
    }
    
    protected boolean CanCutBodyPart(byte eBone, float fDamage)
    {
     if((bCutBodyParts && bDead) == false)
      return false;             
            
     if(fCutBodyPartsCurrentDamage[eBone] <= 0.0f)
      return false;
     
     fCutBodyPartsCurrentDamage[eBone] -= fDamage;
     
     return
            //tych czesci ciala nie urywamy
            eBone != EBones._NON_BONE &&
            eBone != EBones._PELVIS &&
            eBone != EBones._SPINE &&
            eBone != EBones._SPINE1 &&
            eBone != EBones._SPINE2 &&             
            fCutBodyPartsCurrentDamage[eBone] <= 0.0f;
    }

    public void OnVehicleCollision(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed)
    {
        MakeDamage(fDamage, fDamage, Assassin, vHitLocation, vSpeed, EBones._NON_BONE, EnumDamageType._COLLISION, false);
    }

    /** Called by the dead Pawn
     */
    public void YouKilledMe(GameObject Victim)
    {
    }


    ///////////////////////////////////////////////////////////////////////////////
    // Obsluga broni
    ////////////


    /**Pobiera nastepna bron o danym typie (pistol, rifle, heavy...).
     * @param eWeaponType
     * @return Weapon
     */
    Weapon GetNextWeapon(byte eWeaponType)
    {
        Weapon weapon, prevWeapon;

        if (nWeaponInvIndex[eWeaponType] == 0)
        {
            weapon = GetNthWeapon( eWeaponType, 1 );
            if (weapon == null)
                nWeaponInvIndex[eWeaponType] = 0;
            else
                nWeaponInvIndex[eWeaponType] = weapon.nInvIndex;
            return weapon;
        }

        //ustaw sie na pozycji nInvIndex wiekszej niz nWeaponInvIndex
        //i o pasujacym rodzaju broni
        weapon = (Weapon)cInventory.GetFirstInvObject( EInvObjType._GUN );
        
        //najpierw znajdujemy w inventory bron ktora mamy
        while (weapon != null && weapon != ActiveWeapon)
        {
            weapon = (Weapon)cInventory.GetNextInvObject();
        }
        
        //potem szukamy nastepnej
        while ( (weapon != null) &&
                ( (weapon.nInvIndex < nWeaponInvIndex[eWeaponType]) ||//slabsza bron
                  ((weapon.nInvIndex == nWeaponInvIndex[eWeaponType]) && (weapon == ActiveWeapon))||//ten sam obiekt
                  ((weapon.nInvIndex == nWeaponInvIndex[eWeaponType]) && (eWeaponType == EWeaponType._GRENADE))||//taki sam granat
                  (weapon.nType != eWeaponType) ) )//inny typ broni
        {
            weapon = (Weapon)cInventory.GetNextInvObject();
        }

        if (weapon == null)
            nWeaponInvIndex[eWeaponType] = 0;
        else
            nWeaponInvIndex[eWeaponType] = weapon.nInvIndex;

        return weapon;
    }

    /** Typy broni od najlepszej do najgorszej
     * wykorzystywane w GetBestWeapon()
     */
    static byte[] sm_aBestWeapons = new byte[] { EWeaponType._MINIGUN,
                                                 EWeaponType._RIFLE,
                                                 EWeaponType._PISTOL,
                                                 EWeaponType._GRENADE,
                                                 EWeaponType._KNIFE,
                                                 EWeaponType._HAND 
                                               };
    
    /** Zwraca najlepsza dostepna obecnie w inventory bron. Jesli nie ma
     * zadnej palnej, to jest nia noz albo raczki.
     * Nigdy nie powinna zwrocic nulla!
     */
    Weapon GetBestWeapon()
    {
        return GetBestWeapon( null );
    }
    
    /** Zwraca najlepsza dostepna obecnie w inventory bron
     * z wyjatkiem podanej tej w parametrze
     * Uwzglednia to, czy dla danej broni gracz posiada amunicje
     */
    
    Weapon GetBestWeapon(Weapon cExcludeWeapon)
    {
        Weapon cBestWeapon = null;
        
        //przegladamy kolejne typy broni
        for ( int i=0; i<sm_aBestWeapons.length; i++ )
        {
            byte eWeaponType   = sm_aBestWeapons[i];
           
            int  nCnt          = 1;
            do
            {
                //pobieramy kolejna bron wybranego typu
                cBestWeapon = FindNthWeapon( eWeaponType, nCnt++ );    
                //jesli nie znaleziono to koniec, trzeba szukac jakis 
                //gorszego typu
                if ( cBestWeapon == null )
                    break;
                    
                //jesli znaleziono to sprawdzmy czy 
                // 1. to nie czasem ta co mamy ominac
                // 2. czasami brakuje jej amunicji
                if ( cBestWeapon == cExcludeWeapon || 
                     GetAllAmmoCount( cBestWeapon ) <= 0 )
                {
                    //jesli nam nie pasuje, to szukamy dalej
                    cBestWeapon = null;
                }
            } while ( cBestWeapon == null );
            
            if ( cBestWeapon != null )
                break;
        }
        return cBestWeapon;
    }
    
    
    /**Szuka n-tej broni danego typu w plecaku.<br>
     * n z przedzialu 1..
     * Zakladamy, ze Inventory zwraca posortowana liste broni.
     */
    Weapon FindNthWeapon(byte eWeaponType, int n)
    {
        Weapon cWeapon = (Weapon)cInventory.GetFirstInvObject( EInvObjType._GUN );
        while (cWeapon != null)
        {
            if ( cWeapon.nType == eWeaponType )
            {
                if (--n <= 0)
                    return cWeapon;
            }
            cWeapon = (Weapon)cInventory.GetNextInvObject();
        }
        return null;
    }
    
    /**Szuka n-tej broni danego typu w plecaku.<br>
     * Dodatkowo uwzglednia jakis cuda z nWeaponInvIndex
     * Zakladamy, ze Inventory zwraca posortowana liste broni.
     */
    Weapon GetNthWeapon(byte eWeaponType, int n)
    {
        int i = 0;
        Weapon gun = (Weapon)cInventory.GetFirstInvObject( EInvObjType._GUN );
        Weapon prevGun = null;
        while (gun != null)
        {
            if ( gun.nType == eWeaponType )
            {
                // przesuwamy i tylko, jesli nastepny gun jest innego rodzaju
                if ( (prevGun == null) || (gun.nInvIndex != prevGun.nInvIndex) )
                { 
                    i++;
                    if (i == n)
                    {
                        nWeaponInvIndex[eWeaponType]= gun.nInvIndex;
                        return gun;
                    }
                }
            }
            prevGun = gun;
            gun = (Weapon)cInventory.GetNextInvObject();
            
        }
        return null;
    }

    
    
    /**Szuka w plecaku broni danego typu i umieszcza ja w lapkach
     */
    void UseWeapon(String sWeaponName)
    {
        if (sWeaponName == "")
            UseWeapon((Weapon)null);
        else {
            //pobieramy wszystkie dostepne weapony
            java.util.Vector guns = cInventory.GetInvObjects( EInvObjType._GUN );

            //szukamy wlasciwego
            for (int i=0; i<guns.size(); i++)
                if (((Weapon)guns.elementAt(i)).sName == sWeaponName)
                {
                    UseWeapon((Weapon)guns.elementAt(i));
                    break;
                }
        }
    }

    /**
     */
    void ChangeWeapon(Weapon weapon)
    {
    }
    
    /** Umieszcza w lapkach podana bron
     */
    void UseWeapon(Weapon weapon)
    {
        /*LogD(" "+ActiveWeapon+
             " netId:"+((ActiveWeapon!=null)?(""+ActiveWeapon.GetNetId()):"-")+
             " -> "+weapon+
             " netId:"+((weapon!=null)?(""+weapon.GetNetId()):"-")+"\n");*/

// REM bo np. przy load potrzeba odswiezyc stan...
//        if ( ActiveWeapon != null && 
//             ActiveWeapon == weapon )
//        {
//            CrashLog("ERROR: UseWeapon( ActiveWeapon "+ActiveWeapon+" )!!!!!\n");
//            Thread.dumpStack();
//            return;
//        }

        //schowaj jesli cos masz
        if (ActiveWeapon != null)
        {
            if (m_bCloaking)
                ActiveWeapon.SetCloaking(false);
            
            if (ActiveWeapon.Owner == this)
                ActiveWeapon.ChangeInvState(this, EInvObjState._INVENTORY);
            else
            {
                //w grze sieciowej nie chce zmieniac stanu obiektu
                if ( !(GetModule() instanceof ModuleNet) )
                    ActiveWeapon.ChangeInvState(this, EInvObjState._ONGROUND);
                /*LogR("ERROR: "+this+
                     " Wywalam bron "+ActiveWeapon+" na ziemie,"+
                     "bo ma ownera "+ActiveWeapon.Owner+"\n");*/
            }
        }

        //maly hack, zeby przy rzucie kolejnym granatem pamietac poprzednia bron, a nie taki sam granat
        if (ActiveWeapon == null || weapon == null)
            PreviousActiveWeapon = ActiveWeapon;
        else
            if (weapon.nInvIndex != ActiveWeapon.nInvIndex)
                PreviousActiveWeapon = ActiveWeapon;
        
        // wyciagnij jesli masz co
        if ((weapon != null) && (weapon.Owner == this))
        {
            weapon.ChangeInvState(this, EInvObjState._HANDS);
            ActiveWeapon    = weapon;
            
            if (m_bCloaking)
                ActiveWeapon.SetCloaking(m_bCloaking);
            
            nActiveWeaponId = weapon.GetNetId();
        }
        else
        {
            ActiveWeapon = null;
            nActiveWeaponId = -1;
            if ( weapon != null )
            {
                LogD("ERROR: "+this+
                     " Bron "+weapon+" ma ownera "+weapon.Owner+
                     " zatem nie moze byc ActiveWeapon!\n");
            }
        }
        
        WeaponUsed();        
    }
    
    /**Do nadpisania w playerze
     */
    void WeaponUsed()
    {
        //przelicz amunicje
        CountAmmo();
/*
        if(ActiveWeapon != null)
            LogD("Got weapon "+ ActiveWeapon + " with "+ nTotalAmmo + " ammo\n");
        else
            LogD("Got NULL or wrong weapon\n");
*/
    }
    
    /**
     */
    void WeaponThrown()
    {
        //przelicz amunicje
        CountAmmo();
    }
    
    /** TODO Metoda przelacza na nastepna bron gracza
    * Gdy udaje sie zmienic bron to wola WeaponChanged()
    */
    /*    void ChangeWeaponNext()
    {
    }

    /** TODO Metoda przelacza na poprzednia bron gracza
    * Gdy udaje sie zmienic bron to wola WeaponChanged()
    */
    /*    void ChangeWeaponPrev()
    {
    }

    /** Wyrzuca aktywna bron
    */
    void WeaponThrowAway()
    {
        LogD("\n");
        
        if (ActiveWeapon == null)
            LogD("Cannot throw away NULL weapon\n");
        else
        {
            if (m_bCloaking)
                ActiveWeapon.SetCloaking(false);
            /*
            //uzyjmy jakiejs innej broni
            UseWeapon((Weapon)null);

            //wyciagamy z inventory stara bron
            cInventory.RemoveInvObject(PreviousActiveWeapon);
            //liczymy polozenie wyrzuconej broni na ziemi
            PreviousActiveWeapon.SetPosition(ComputeDroppingPosition());
            //i pokazujemy ja
            PreviousActiveWeapon.ChangeInvState(this, EInvObjState._ONGROUND);
            */
        }
        
        
        WeaponThrown();        
        /*            
        PreviousActiveWeapon = ActiveWeapon;
        ActiveWeapon = null;
        
        WeaponThrown();
        */        
    }

    /** Wolane gdy granat zostaje wyrzucony z reki i trzeba to uwzglednic
     * w wygladzie Pawna.
     */
    void WeaponGrenadeThrown()
    {   
    }
    
    /** Znika niesiana przez Pawna bron (niszczy obiekt broni, co jest przydatne
     * np. dla granatow, nozy...)
     */
    void WeaponAnnihilate(Weapon cToAnnihilate)
    {
        if (cToAnnihilate != null)
        {
            //wyciagamy z inventory stara bron
            cInventory.RemoveInvObject( cToAnnihilate );

            // gdy kasujemy aktywna bron trzeba dac nowa w lapki
            if( cToAnnihilate == ActiveWeapon)
            {
                Weapon newWpn = (Weapon)(cInventory.GetSpecificInvObject( cToAnnihilate.nInvIndex ));
                if (newWpn == null)
                {
                    if (PreviousActiveWeapon != null && cInventory.GetIndex(PreviousActiveWeapon) != -1)
                        newWpn = PreviousActiveWeapon;
                    else
                        newWpn = GetBestWeapon();
                }

                //uzyjmy jakiejs innej broni tego samego typu lub noza
                UseWeapon( newWpn );
                
                PreviousActiveWeapon = null;
            }
            
            // niszczymy stara bron (wyrzucony noz lub granat)
            cToAnnihilate.CallMethodIn("delete", 0);
        }
    }

    /** Odpalenie efektu wystrzalu z broni
     */
    void ExecuteFXBarrel(String sFXName)
    {
        if(ActiveWeapon!=null)
            ExecuteFX( ActiveWeapon, sFXName, ActiveWeapon.vBarrelElementPos);
        
        // odpalamy efekt widocznego lotu pocisku
        //if(RandomInt(100) < 15) 
        //CrashLog("WeaponBeam fFXPosY="+ActiveWeapon.fFXPosY+" fFXSizeY="+ActiveWeapon.fFXSizeY+" ActiveWeapon.vBarrel="+ActiveWeapon.vBarrel+"\n");
		if (ActiveWeapon.m_bShowFXBeam)
			ActiveWeapon.ExecuteFX(ActiveWeapon, "WeaponBeam", ActiveWeapon.vBarrelElementPos);
    }

    /** @return pozycja na ktorej wyswietlic FXa wystrzalu z broni
     */
    Vector GetBarrelPos()
    {
        return Vector.Zero;
    }
    
    /** @return punkt, z ktorego strzelamy, we wspolrzednych swiata
     */
    public Vector GetFireOrigin()
    {
        if ( (ActiveWeapon != null) &&
             (ActiveWeapon.nType == EWeaponType._GRENADE) )
            return GetBoneJointPos(EBones._R_HAND);
        else
            return GetBoneJointPos(EBones._SPINE1);
    }

    
    /** */
    int nTotalAmmo = 0;
    
    /** Zlicza amunicje w inwentory dla aktualnej broni
     * i wpisuje ja do nTotalAmmo
     */
    void CountAmmo()
    {
        nTotalAmmo = GetAmmoCount( ActiveWeapon );
    }
    
    /** Zwraca ilosc amunicji w inwentory dla podanej broni
     */
    int GetAmmoCount(Weapon cWeapon)
    {
        int nCountAmmo = 0;
        
        if ( cWeapon != null )
        {
            java.util.Vector ammoVec = cInventory.GetInvObjects( EInvObjType._AMMO );
            for (int i=0; i<ammoVec.size(); i++)
                if ( ((Ammo)ammoVec.elementAt(i)).eAmmoType == cWeapon.eBulletType )
                    nCountAmmo += ((Ammo)ammoVec.elementAt(i)).nCount;    
        }
        return nCountAmmo;
    }
    
    /** Zwraca ilosc amunicji w inwentory dla podanej broni
     * wraz z amunicja w samej broni
     */
    int GetAllAmmoCount(Weapon cWeapon)
    {
        return cWeapon.nAmmo + GetAmmoCount( cWeapon );
    }
    
    
    /** Sprawdza czy wogole jest jakas amunicja do aktualnej broni
     */
    boolean IsAmmoAvailable()
    {
        return nTotalAmmo > 0;
    }

    /** Szuka amunicji i przeladowuje bron.
     */
    boolean WeaponReload()
    {
        if (ActiveWeapon == null)
            return false;

        if ( Role < ERole._AUTHORITY )
            return true;
        
        //to sie odgrywa tylko na serwerze
            
        //kolekcjonowanie amunicji
        java.util.Vector ammoVec = cInventory.GetInvObjects( EInvObjType._AMMO );
        
        Ammo ammo;
        //bierzemy tylko tyle ile trzeba
        int need = ActiveWeapon.nCapacity - ActiveWeapon.nAmmo;
        for (int i=0; (i<ammoVec.size()) && (need > 0); i++)
        {
            ammo = (Ammo)(ammoVec.elementAt(i));
            
            //mamy pudelko z wlasciwa amunicja
            if (ammo.eAmmoType == ActiveWeapon.eBulletType)
                if (ammo.nCount <= need)
                {
                    //to pudelko jest juz puste
                    need -= ammo.nCount;
                    cInventory.RemoveInvObject( ammo );
                    ammo.DetachFromParent();
                    ammo.MsgSendClientState();
					if (!ammo.IsCreatedDuringLoading())
						ammo.delete();
                }
                else
                {
                    ammo.nCount -= need;
                    need = 0;
                    ammo.MsgSendClientCount();
                }
        }

        // reload jesli jest jakas amunicja
        int availableAmmo = ActiveWeapon.nCapacity - need;
        if (availableAmmo > 0)
        {
            ActiveWeapon.Reload( availableAmmo );
            ActiveWeapon.MsgSendClientAmmo();
            
            nTotalAmmo -= availableAmmo;
            return true;
        }
        else
        {
            return false;
        }
    }
    
    void MessageWeapon(int nState)
    {

    }

    /** Zwraca jeden z punktow, od widocznosci ktorego uzaleznione jest,
     *  czy AI go widzi
     *  @param nPoint numer punktu do zwrocenia
     *  @return punkt o numerze nPoint lub null, jesli nPoint > ilosci
     *          dostepnych punktow
     */
    public Vector GetPointToLookAt(int nPoint)
    {
        switch (nPoint)
        {
        case 0: 
            return GetBoneJointPos(EBones._SPINE1);
        case 1:
            return GetBoneJointPos(EBones._HEAD);
        default:
            return null;
        }
    }

    ///////////////////////////////////////////////////////////////////////////////
    // Pozycje kamery - uzywane przez CameraPlayer
    ////////////

    /**Zwraca pozycje kamery dla snajperek
     */
    Vector GetSniperCameraPos()
    {
        return ActiveWeapon.GetPosition();
    }

    /**Zwraca pozycje kamery dla trybu FPP
    *
    Vector GetNormalCameraPos()
    {
    return GetBoneJointPos(EBones._HEAD);
    }
    */
    
    ///////////////////////////////////////////////////////////////////////////////
    // Inventory
    ////////////
    
    /** metoda zwraca invnetory powna
     */
    public Inventory GetInventory()
    {
        return this.cInventory;	
    }

    /** odleglosc na jaka bedzie rzucany przedmiot na teren
     */
    float fThrowDist = 50.0f;

    /** metoda wyliczajaca  wspolrzedne przedmiotu 
     *  po zdropowaniu go na teren
     */
    public Vector ComputeDroppingPosition()
    {
        /*
        Vector vPos = GetPosition();
        Vector vShiftDir = GetForwardVector();
        vShiftDir.Mul(fThrowDist);
        vPos.Add(vShiftDir);
        vPos.fY = TerrainHeight(vPos.fX, vPos.fZ) + 7.5f;
        return vPos;
        */
        
        Vector vStart = GetPosition(), 
            vEnd;
        vStart.fY += 100.f;
        vEnd = new Vector(vStart);

        Vector vShiftDir = GetForwardVector();
        vShiftDir.Mul(fThrowDist);
        vEnd.Add(vShiftDir);

        // Trace do przodu
        Collision col = TraceObjectsExclude(vStart, vEnd, this);
        if (col != null)
        {
            // cofnij troche, zeby w cos nie wpadlo
        }
        // TODO: dodac traceowanie drzew i terenu

        // Trace w dol
        vStart = new Vector(vEnd);
        vEnd.fY = TerrainHeight(vEnd.fX, vEnd.fZ);
        // TODO: drzewa jw
        col = TraceObjectsExclude(vStart, vEnd, this);
        
        vEnd.fY += 7.5f;
        return vEnd;        
    }
    

    /** Oblicza skad beda wyrzucane przedmioty przy uzyciu InvObject.PhysicsDrop
     */
    Vector ComputePhysicsDropPosition()
    {
        Vector vDir = GetForwardVector();
        Vector vRight = GetRightVector();
        vDir.Mul(fPhDropForward);
        vDir.fY = fPhDropVSpeed;
        vDir.Add(GetPosition());
        vDir.Add(vRight.Mul2(-50 + RandomFloat(100)));        
        //CrashLog("[Pawn.ComputePhysicsDropPosition] vPos = "+vPos+"\n");
        
        return vDir;
    }
    
    /** Oblicza predkosc (i kierunek) wyrzucania przedmiotow przy uzyciu InvObject.PhysicsDrop
     */
    Vector ComputePhysicsDropSpeed()
    {
        Vector vDir = GetForwardVector();
        vDir.fX *= 0.9f + RandomFloat(0.2f);
        vDir.fZ *= 0.9f + RandomFloat(0.2f);
        vDir.Mul(fPhDropHSpeed * RandomFloat(1f, 2f));
        vDir.fY = fPhDropVSpeed;
        return vDir;
    }

    //////////////////////////////////////////////////
    // obsluga trafiania Pawna w rozne czesci ciala //
    //////////////////////////////////////////////////
    
    int GetBodyPartFromBone(int eBone)
    {
        switch (eBone)
        {
        case EBones._PELVIS:
        case EBones._SPINE:
        case EBones._SPINE1:
        case EBones._SPINE2:        return BODY_PART_TORSO;
        case EBones._NECK:
        case EBones._HEAD:          return BODY_PART_HEAD;
        case EBones._L_CLAVICLE:
        case EBones._L_UPPERARM:
        case EBones._L_FOREARM:
        case EBones._L_HAND:
        case EBones._R_CLAVICLE:
        case EBones._R_UPPERARM:
        case EBones._R_FOREARM:
        case EBones._R_HAND:        return BODY_PART_ARM;
        case EBones._L_THIGH:
        case EBones._R_THIGH:
        case EBones._L_CALF:
        case EBones._R_CALF:
        case EBones._L_FOOT:
        case EBones._R_FOOT:        return BODY_PART_LEG;
        }

        //FIX IT: czasem dostajemy eBone=-1... Sprawdzic to

        return BODY_PART_UNKNOWN;
    }

    /** Zwraca wartosc mnoznika odbierania energii w zaleznosci od podanej czesci ciala.
     * @param nElement numer mesh elementu(kosci) dla Pawna jest to jedna z wartosci z klasy EBone
     * @return wartosc przez jaka nalezy pomnozyc odierana Pawnowi energie
     */
    float GetDamageMultiplier(int nBone)
    {
        int iBodyPart = GetBodyPartFromBone(nBone);
        switch(iBodyPart)
        {
        case BODY_PART_UNKNOWN : return 1.f;
        default : return aDamageMultipliers[iBodyPart];
        }
    }

    ///////////////////////////////////////////////////////////////////////////
    // Pawn jako TriggerObject po smierci

    //-------------------------------------------------------------------------    
    void Execute( Actor executor )
    {
        super.Execute(executor);
        
    }
    //-------------------------------------------------------------------------         
    
    /** Aktywny tylko jesli nie zyje
     */
    public boolean IsActive(ControlObject Activator)
    {
        if (fHealth > 0)
            return false;
        else
            return !bNoBodySearch;
    }
    
    /** Podaje opis obiektu
     * @return string z opisem obiektu (<code>String</code>)
     */
    String GetTip()
    {
        return "&SEARCH_BODY&";
    }    
    
    ///////////////////////////////////////////////////////////////////////////////
    // Pawn podrozujacy pojazdami
    ///////////////////////////////////////////////////////////////////////////////
	SeatInfo m_cSeatToGetInOut = null; // na potrzeby sieci

    void ActionGetIn(SeatInfo seatInfo)
    {
		m_cSeatToGetInOut = seatInfo;
		ActionGetInDo();
    }
	
    void ActionGetInDo()
    {
		if (GetModule() instanceof ModuleNet)
		{
			PrepareToGetIn( m_cSeatToGetInOut );
			if (m_cSeatToGetInOut.GetReserver() == this)
				GetIn( m_cSeatToGetInOut );
		}			
		else
			GetIn( m_cSeatToGetInOut );
    }
	
    /** Wejscie do pojazdu */
    void GetIn(SeatInfo seatInfo)
    {
		cSeatInfo = seatInfo;
		cSeatInfo.Occupy(this);

        if (!cSeatInfo.AttachOccupant())
            CrashLog("[Pawn.GetIn] ERROR attaching to seat!\n");
		
		SetSpeed(new Vector(0, 0, 0)); //odpowiednie ustawienie fizyki
		SetPhysicsActive(false);
    }
	
    void ActionGetOut()
    {
        ActionGetOutDo();
    }
	
    void ActionGetOutDo()
    {
        GetOut();
    }
    
    /** Wyjscie z pojazdu */
    boolean GetOut()
    {
        if (cSeatInfo == null)
		{
			CrashLog("Pawn.GetOut(): cSeatInfo == null\n");
			return false;
		}

		if (!SeatInfoCanGetOut())
		{
			CrashLog("Pawn.GetOut(): !cSeatInfo.CanGetOut()\n");
		    return false;
		}

		cSeatInfo.Occupy(null);
		cSeatInfo.Reserve(null);
		
        DetachFromParentAndKeepWorldPos(); // odlaczamy sie od pojazdu
		SetPhysicsActive(true); // zaczynamy chodzic
		
		return true;
	}
    
    
    boolean SeatInfoCanGetOut()
    {
        return cSeatInfo.CanGetOut();
    }
	
    SeatInfo GetSeat()
	{
		return cSeatInfo;
	}
    
	void PrepareToGetIn(SeatInfo seat)
	{
	}
	
    void CheckVehicle()
    {
        Vector vPos		= GetPosition();
        Vector vStart	= new Vector ( vPos );
        Vector vEnd		= new Vector ( vPos );
        vStart.fY += 50.0f;
        vEnd.fY   -= 50.0f;

        Collision colObj = TraceObjectsExclude( vStart, vEnd, this ); 
        if ( (colObj != null) && (colObj.Obstacle  instanceof Vehicle) )
        {
            Vehicle vehicle = (Vehicle) colObj.Obstacle;
			
			if (vehicle.GetSeatOccupiedBy(this) != null)
				return; // juz jedziemy tym pojazdem, wiec nie attachujemy sie

			AttachAsChildToAndKeepWorldPos(colObj.Obstacle);
        }
		else
		{
			if ( (GetParent() != null) && (GetParent() instanceof Vehicle) )
			{
	            Vehicle vehicle = (Vehicle) GetParent();
				
				if (vehicle.GetSeatOccupiedBy(this) != null)
					return; // jestesmy pasazerem lub kierowca, nie detachujemy sie
				DetachFromParentAndKeepWorldPos();
			}
		}
    }
    
    Vector GetCarPosition()
    {
        if (cSeatInfo != null)
            return cSeatInfo.GetOccupiedObject().GetPosition();
        else
        {
            CrashLog("[Pawn::GetCarPosition] cVehicle == null");
            return GetPosition();
        }
    }
    /**
     * Na potrzeby sieci, 
     * pozycja pojazdu na onrender
     */
    void GetCarRenderPosition(Vector vPos,Vector vDir,Vector vRight)
    {
        if (cSeatInfo != null)
            cSeatInfo.GetOccupiedObject().GetRenderPosition( vPos, vDir, vRight );
        else
        {
            CrashLog("[Pawn::GetCarPosition] cVehicle == null");
            GetRenderPosition( vPos, vDir, vRight );
        }
    }
	
	/** wolane, gdy pojazd ulegnie wypadkowi */
	void VehicleCrashed()
	{
	}
    
    ///////////////////////////////////////////////////////////////////////////
    // Zycie podwodne
    ///////////////////////////////////////////////////////////////////////////

    /** Sprawdza, czy jestesmy pod woda
     */
    boolean IsUnderWater()
    {
        Vector vStart = GetBoneJointPos(EBones._SPINE1);
        Vector vEnd = new Vector(vStart);
        vEnd.Add(new Vector(0, 200, 0));
        Collision stCollObject = TraceObjectsExclude(vStart, vEnd, this);
        if ( (stCollObject != null) &&
             (stCollObject.Obstacle instanceof WaterSurface) )
            return true;
        else
            return false;
    }

    void SetCloaking(boolean bOn)
    {
        if (m_bCloaking != bOn)
        {
            super.SetCloaking(bOn);
            if (ActiveWeapon != null)
                ActiveWeapon.SetCloaking(bOn);
        }
    }
    
    ///////////////////////////////////////////////////////////////////////////
    // Dzwiek chodzenia
    ///////////////////////////////////////////////////////////////////////////


    
    
    void PutWeaponInHands( Weapon weapon )
    {
        UseWeapon( weapon );
    }
    
    
    
    /** Procki umozliwiajace automatyczne wziecie do rak podnoszonej
     * z ziemi broni. W chwili obecnej nie wykorzystywane
     */
    
    Weapon cLastAddedWeapon = null; // not SG
    /** Callback od Weapona ze Pawn wlasnie go wzial do inwentory
     */
    void WeaponAddedToInventory(Weapon weapon)
    {
        cLastAddedWeapon = weapon;
        
        CallMethodIn("PutLastAddedWeaponInHands",0.0f);
    }
    
    void PutLastAddedWeaponInHands()
    {
        DisableCallMethod("PutLastAddedWeaponInHands");
        
        if (( cLastAddedWeapon != null ) && (cLastAddedWeapon != ActiveWeapon ))
        {
            UseWeapon( cLastAddedWeapon );
        }
    }
    
 
    public void Die()
    {
        super.Die();
        if (cInventory != null)
            cInventory.OwnerDied();
    }
    
    public void SetStepsNoiseRange(int iMotionState, float fNoiseRange)
    {
        if ( (aStepVirtualNoise != null) && (aStepVirtualNoise.length > iMotionState) )
            aStepVirtualNoise[iMotionState] = fNoiseRange;
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
	Weapon ActiveWeaponSG = null;
	Weapon PreviousActiveWeaponSG = null;
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Pawn.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_PAWN)
        {
			super.SGLoadChunk(cFC);
			
            bUsePhysicsToDeathFall = cFC.LoadBool();
			// Aktualna bron Pawna
			ActiveWeaponSG = (Weapon)GameObject.cSG.LoadObjectRef(cFC);
			// Poprzednia bron
			PreviousActiveWeaponSG = (Weapon)GameObject.cSG.LoadObjectRef(cFC);
						
			// Zajmowane siedzenie w pojezdzie
			cSeatInfo = (SeatInfo)GameObject.cSG.LoadObjectRef(cFC);
			
			// flaga mowiaca czy w danej chwili przeszukiwane sa zwloki pawna
			bIsCorpseActive = cFC.LoadBool();
			// tonicie wyaczane jest w teleporcie
			bSinkingDisabled = cFC.LoadBool();			
			
			// toniemy
			bSinking = cFC.LoadBool();
			// czy chodzimy po wodzie ?
			bInWater = cFC.LoadBool();
			// czy chodzimy po wodzie na tyle gleboko ze powinnismy zaczac plywac?
			bUnderWater = cFC.LoadBool();
            
            boolean bIsInventory = cFC.LoadBool();
            if(bIsInventory)
            {
                if(cInventory == null)
                {
                    CrashLog("Creating inventory for <"+getClass().getName()+"> nID="+GetUniqueID()+"\n");
                    InitInventory();
                }
                
                // odczytujemy zawartosc inventory
                cInventory.SGLoadChunk(cFC);
            }
            
            m_bPawnInBuilding = cFC.LoadBool();
        }
		
		cFC.delete();
	}
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Pawn.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_PAWN, cFCParent);
		
		super.SGSaveChunk(cFC);
		
        cFC.SaveBool(bUsePhysicsToDeathFall);
		// Aktualna bron Pawna
		GameObject.cSG.SaveObjectRef(cFC,ActiveWeapon);
		// Poprzednia bron
		GameObject.cSG.SaveObjectRef(cFC,PreviousActiveWeapon);	
		
		// Zajmowane siedzenie w pojezdzie
		GameObject.cSG.SaveObjectRef(cFC,cSeatInfo);

		// flaga mowiaca czy w danej chwili przeszukiwane sa zwloki pawna
		cFC.SaveBool(bIsCorpseActive);
		// tonicie wyaczane jest w teleporcie
		cFC.SaveBool(bSinkingDisabled);
		
		// toniemy
		cFC.SaveBool(bSinking);		
		// czy chodzimy po wodzie ?
		cFC.SaveBool(bInWater);
		// czy chodzimy po wodzie na tyle gleboko ze powinnismy zaczac plywac?
		cFC.SaveBool(bUnderWater);		
		
        cFC.SaveBool(cInventory != null);
        if(cInventory == null)
        {
            // nie ma Inventory !!!!!
            CrashLog("ERROR! Object <"+GetName()+":"+GetUniqueID()+"> has no cInventory\n");
        }
        else
        {
            cInventory.SGSaveChunk(cFC);
        }
        
        cFC.SaveBool(m_bPawnInBuilding);
        
		cFC.delete(); 
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[Pawn.SGUpdate]\n");
		
		if ((ActiveWeapon != null) && (ActiveWeapon.Owner != this))
			ActiveWeapon = null;
		
        if (m_cDeathCameraEyeDummy != null)
            m_cDeathCameraEyeDummy.DeactivateOnModuleAlways();       

		if (ActiveWeaponSG != ActiveWeapon)
        {
            boolean bEnableRendering = false;
			
            if(ActiveWeaponSG != null)
			{				
                bEnableRendering = ActiveWeaponSG.IsRenderable();
			}
            			
			UseWeapon(ActiveWeaponSG);
							            
            // przywracamy stan broni, bo UseWeapon zmienia renderowanie
            if(ActiveWeaponSG != null)
			{
				ActiveWeaponSG.Owner = this;
                if (!bEnableRendering) 
					ActiveWeaponSG.EnableRendering(false);
			}
        }
		PreviousActiveWeapon = PreviousActiveWeaponSG;		
		
		super.SGUpdate();
	}
    
    
    boolean CanBeShowOnMoveDetector()
    {
        return bShowOnMoveDetector && (!bDead);
    }
    
    
    /**
     *  Przeladowywanie skinow, potrzebne do sieci
     */
    
    protected NetPlayerModelInfo m_cModelInfo = null;
    NetPlayerModelInfo GetModelInfo(){ return m_cModelInfo; }
        
    void ReloadPartialSkins()
    {
        if ( m_cModelInfo != null )
            m_cModelInfo.ApplyPartialSkins( this );
        ReloadTeamSkins( m_nTeamSkinSet );
    }
    
    //zestaw skinow druzynowych jaki jest zaladowany/powinien byc przeladowany na mesha, 
    private int m_nTeamSkinSet = NetTeamInfo.NONE;
    
    int GetTeamSkinSet(){ return m_nTeamSkinSet; }
    
    void ReloadTeamSkins(int nTeamSkinSet)
    {
        m_nTeamSkinSet = nTeamSkinSet;
        
        if ( m_nTeamSkinSet != NetTeamInfo.NONE )
        {
            String sSkin = NetTeamInfo._TEAM_SKINS[ m_nTeamSkinSet ];
            SetSkinLeavePrevious( sSkin );
        }
    }

    //lista meshelementow ktore moga byc oczami
    static String[] sm_aEyeElements = { "Lip_eye_R.Target","Bip01 Head","Bip01"};
    boolean InitDeathCameraEyeDummy()
    {
        m_cDeathCameraEyeDummy = (ControlObject)CreateObject("MeshObject");
        ((MeshObject)m_cDeathCameraEyeDummy).LoadMesh("data/meshes/logan/LoganCameraBox.3DA");
        m_cDeathCameraEyeDummy.DeactivateOnModule();
        ((MeshObject)m_cDeathCameraEyeDummy).EnableRendering(false);
        m_cDeathCameraEyeDummy.RegisterInInteractionMap();
        RegisterInInteractionMap();
        SetInteraction(m_cDeathCameraEyeDummy, false);
        m_cDeathCameraEyeDummy.SetFlag(EFlags._COLLISION);
        m_cDeathCameraEyeDummy.ClearFlag(EFlags._BLOCK_MOVE | EFlags._BLOCK_TRACE | EFlags._FXPARTICLE_COLLISION);
        int nEyeId = -1;
        //oczywiscie HSoldier nie ma ani "Lip_eye_R" ani "Bip01 Head"
        //wiec trzeba temu jakos zaradzic...
        for (int i=0; i<sm_aEyeElements.length; i++ )
        {
            nEyeId = GetElementID( sm_aEyeElements[i] );
            if (nEyeId != -1)
                break;
        }
        if (nEyeId > -1)
        {
            //AttachChild( m_cDeathCameraEyeDummy, nEyeId );
            m_cDeathCameraEyeDummy.SetDir( GetForwardVector() );    
        }
        return (nEyeId > -1);
    }
    
    void GetEyePos(Vector vPos)
    {
        if ( m_cDeathCameraEyeDummy != null )
             m_cDeathCameraEyeDummy.GetPosition( vPos );
        else
        {
            Tools.CrashLogError("GetEyePos uzyte bez zainicjowania m_cDeathCameraEyeDummy");
            GetPosition( vPos );
        }
    }
    
    void GetEyeForwardVector(Vector vDir)
    {
        if ( m_cDeathCameraEyeDummy != null )
            m_cDeathCameraEyeDummy.GetForwardVector( vDir );
        else
        {
            Tools.CrashLogError("GetEyeForwardVector uzyte bez zainicjowania m_cDeathCameraEyeDummy");
            GetForwardVector( vDir );
        }
    }
}