
/**
 */
public class Physics extends GameObject
{
    /** Obniza punkt wybuchu - w ten sposob ciala wylatuje bardziej do gory.  */
    static float fExplosionPosCorrection = 0;//-50;

    /** Korekcja kata, pod jakim obrywa cialo (abs() musi byc < 90). >0 - do gory */
    static float fHitAngleCorrection = (float)(0 * java.lang.Math.PI / 180.0);

    // parametry uderzenia punktowego
    public static float fHitDuration = 0.2f;
    public static float fHitRadius = 25.f;

    // parametry eksplozji
    static float fExplosionDuration = 0.25f;
    static float fExplosionRadius = 100.f;

    // sila
    public static float fStrength = 50e4f;

    /** UWAGA ta metoda moze zmodyfiowac wektory vHitLocation, vDir!!!!!!!!!!!!!
     */
	static void Simulate(Pawn who, Vector vHitLocation, Vector vDir,
                                   float fDamage, int nMeshElementorBoneID)
	{
		Simulate(who, vHitLocation, vDir, fDamage, nMeshElementorBoneID, true);
	}
	
    static void Simulate(Pawn who, Vector vHitLocation, Vector vDir,
                                   float fDamage, int nMeshElementorBoneID, boolean bClampDamage)
    {
        //GameObject.printStackTrace("simulate "+fDamage+", "+vHitLocation);
        
        float fEffectiveStrength;

		if (bClampDamage)
	        fDamage = fDamage < 200 ? fDamage : 200;

        if (who.fHealth > 0)
        {
            //jeszcze zyje - tylko zachwianie 
            //TODO
        }
        else
        {
            //smierc

            if (!who.bDead)
            {
                fEffectiveStrength = fDamage * fStrength / 2;
                //CrashLog("eff strength:"+fEffectiveStrength+"\n");
                
                //podnosimy, tak, zeby kulki w nogach nie znajdowaly sie pod ziemia
                // na dzien dobry. ta translacja musi byc min. wielkosci promienia
                // kulki (obecnie 10)
                Vector vPos = who.GetPosition();
                vPos.Add(new Vector(0, 7.5f, 0));
                who.SetPositionWorld(vPos);
                
                //uderzamy sztucznie w szyje
                //nMeshElementorBoneID = EBones._NECK;
                //vHitLocation = who.GetBoneJointPos((byte)nMeshElementorBoneID);
            }
            else
            {
                fEffectiveStrength = fDamage * fStrength / 100;
                //CrashLog("wasdead"+fEffectiveStrength+"\n");
            }
            

            who.ClearFlag(EFlags._BLOCK_MOVE);
            who.ClearFlag(EFlags._NO_BODY_PHYSICS);
            who.SetFlag(EFlags._NO_ANIMATION_REFRESH);
            who.ClearFlag(EFlags._NO_ANIMATION);
            
            //CrashLog("Elem " + EBones.GetNameFromID((byte)nMeshElementorBoneID));
            
            if (nMeshElementorBoneID != EBones._NON_BONE)
            {
                LogD("Explosion 1");
                //sila przylozona punktowo
                //CrashLog("postrzal\n");
                //CrashLog("super on take damage "+ vHitLocation+", "+nMeshElementorBoneID+", \n");

                //zmiana kata uderzenia
                vDir.Normalize();
                vDir.Add(new Vector(0, (float)java.lang.Math.tan(fHitAngleCorrection), 0));

                //symulacja
                who.PhysicsDirExplosion( vHitLocation, vDir, fEffectiveStrength,
                                     fHitDuration, fHitRadius);
            }
            else
            {
                //eksplozja lub bez przyczyny
                //CrashLog("eksplozja\n");

                if (vHitLocation != null)
                {
                    //eksplozja

                    //zmiana polozenia wybuchajacej rzeczy
                    vHitLocation.Add(new Vector(0, fExplosionPosCorrection, 0));

                    //symulacja
                    fEffectiveStrength *= 0.016f;
                    LogD("Explosion 2");
                    who.PhysicsExplosion( vHitLocation, fEffectiveStrength,
                                          fExplosionDuration, fExplosionRadius);
                }
                else
                {
                    // inne obrazenia - przewracamy sie na twarz
                    //CrashLog("inne\n");

                    if (vDir == null)
                    {
                        LogD("Explosion 3");
                        //popychamy za glowe w przod przez 2 sekundy
                        who.PhysicsDirExplosion(
                                                who.GetBoneJointPos(EBones._HEAD),
                                                who.GetForwardVector(),
                                                20e4f,
                                                3.0f,
                                                fHitRadius);
                    }
                    else
                    {
                        //ciecie nozem
                        LogD("Explosion 4");
                        who.PhysicsDirExplosion(
                                                who.GetBoneJointPos(EBones._HEAD),
                                                who.GetForwardVector(),
                                                20e4f,
                                                .1f,
                                                fHitRadius);
                    }
                }
            }
            
            //CrashLog("body hit with strength: "+fEffectiveStrength+"\n");
        }
    }
}
