public class SpringTestMesh extends AIPatroler
{
    float fLastTime;
    Vector vStartPos = null;
    Spring spring = null;
    float fSpeed = 0f;
    float fSpeedPrev = 0f;
    float fAcceleration = 0f;
    float fAccelerator = 100f;
    float fTurning;
    float fMaxSpeed = 1000f;
    FreeCamera camera = null;
    /**Wspolczynnik uzalezniajacy predkosc obrotu od predkosci w przod*/
    float fTurnSpeedCoeff = 1f;
    float fMaxTurnSpeed = 30f;
    float fMinTurnSpeed = 5f;
    boolean bDestSpeedSet = true;
    float fDestSpeed = 0f;
    Vector vPrevPos = new Vector();

    void DefineAnimationSet(){}
    void UpdateMotion(){}
        
    
    
    Vector vDefAttenuation = new Vector(0.96f, 0.96f, 0);
    public void OnCreate()
    {
        super.OnCreate();
        aMotionVelocity[MotionState.SPEED_STILL] = 0;
        aMotionVelocity[MotionState.SPEED_SWIM] = 200;/*swim*/
        aMotionVelocity[MotionState.SPEED_CRAWL] = 200;    
        aMotionVelocity[MotionState.SPEED_DUCK] = 300;
        aMotionVelocity[MotionState.SPEED_WALK] = 400;
        aMotionVelocity[MotionState.SPEED_RUN] = 500;
        SetMaxAngSpeed(30);
        spring = new Spring();
        spring.SetAttenuation(vDefAttenuation);
        fLastTime = GetTime();
        vStartPos = GetPosition();
        camera = (FreeCamera)CreateObject("FreeCamera");
        GetModule().ActivateCamera(camera);
        ((ControlObject)this).SetPhysicsType(EPhysics._FLY);
    }
    
    public void OnFrame()
    {
        spring.Calculate(GetTime() - fLastTime);
        UpdateMovement(GetTime() - fLastTime);
        fLastTime = GetTime();
        Vector vSpringPos = spring.GetPosition();
        Vector vXDeviation = GetForwardVector();
        vXDeviation.Mul(vSpringPos.fX);
        Vector vZDeviation = GetRightVector();
        vZDeviation.Mul(vSpringPos.fY);
        Vector vNewUp = new Vector(Vector.Up);
        vNewUp.Add(vXDeviation);
        vNewUp.Add(vZDeviation);
        FromUpForwardPos(vNewUp, GetForwardVector(), GetPosition());
    }

    boolean bFirstCameraUpdate = false;
    void UpdateMovement(float fTime)
    {
        //if (fAcceleration != 0f)
        {
            //SetLocalSpeed(GetForwardVector());
            //fSpeed += fAcceleration*fTime;
            //SetSpeedValue(fSpeed);
            
        }
        fSpeed = GetSpeedValue();
        float fSpeedDelta = fSpeed - fSpeedPrev;
        fSpeedDelta *= (-0.1f);
        fSpeedPrev = fSpeed;
        if (fSpeedDelta != 0)
            LogD("speedDelta: " + fSpeedDelta);
        Vector vSpringVelocity = new Vector(fSpeedDelta, GetAngSpeed() * 0.01f, 0f);
        //if ((fSpeedDelta != 0f) || (fTurning != 0f))
        {        
            spring.SetVelocity(vSpringVelocity);
        }
        //LogD("vSpeed: " + vSpeed.toString());
        
        Vector vPos = GetPosition();
        vPos.Sub(vPrevPos);
        vPrevPos = GetPosition();
        //kamera do wywalenia
            Vector vCameraPosition = camera.GetPosition();
            vCameraPosition.Add(vPos);
            if (bFirstCameraUpdate)
            {
                vCameraPosition = GetPosition();            
                bFirstCameraUpdate = false;
            }
            camera.SetPosition(vCameraPosition);
        //kamera
        /*
        float fSpeedTurn = 0f;
        if (fTurning > 0f)
        {
            fSpeedTurn = fTurnSpeedCoeff * fSpeed + fMaxTurnSpeed;
            ((ControlObject)this).RotateLocal(Vector.Up, fSpeedTurn * fTime);
        }
        else
        {
            if (fTurning < 0f)
            {
                fSpeedTurn = fTurnSpeedCoeff * (fSpeed) + fMaxTurnSpeed;
                ((ControlObject)this).RotateLocal(Vector.Up, -fSpeedTurn * fTime);
            }
            
        }*/
        //LogD("fSpeed: " + fSpeed + " fAccel: "+ fAcceleration + " fTurning: " + fSpeedTurn);
    }
    
        
    float fVelocityX = 0f;
    float fVelocityY = 0f;
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (bKeyState)
        {
            Vector vAttenuation = spring.GetAttenuation();
            switch(nKeyCode)
            {
                case EKey._T:
                    fVelocityX += 1f;
                    break;
                case EKey._G:
                    fVelocityX-= 1f;
                    break;
                case EKey._Y:
                    fVelocityY += 1f;
                    break;
                case EKey._H:
                    fVelocityY -= 1f;
                    break;
                case EKey._U:
                    spring.SetVelocity(new Vector(fVelocityX, fVelocityY, 0f));
                    break;
                case EKey._I:
                    vAttenuation.fX += 0.01;
                    break;
                case EKey._K:
                    vAttenuation.fX -= 0.01;
                    break;
                case EKey._O:
                    vAttenuation.fY += 0.01;
                    break;
                case EKey._L:
                    vAttenuation.fY -= 0.01;
                    break;
                case EKey._J:
                    spring.SetAttenuation(vAttenuation);
                    break;
                case EKey._END:
                    Vector vCurPos = GetPosition();
                    //LogD("pos " + vCurPos.toString());
                    camera.SetPosition(vCurPos);//new Vector(vCurPos.fX + 700f, vCurPos.fY + 300f, vCurPos.fZ));
                    break;
                case EKey._SPACE:
                    Reset();
                    break;
                case EKey._P:
                    SetSpeed(100f);
                    break;
                case EKey._SEMICOLON:
                    SetSpeed(0);
                    break;
                case EKey._W:
                    fAcceleration = fAccelerator;
                    break;
                case EKey._S:
                    fAcceleration = -fAccelerator;
                    break;
                case EKey._A:
                    ((ControlObject)this).SetAngSpeed(30f);
                    fTurning = fMaxTurnSpeed;
                    break;
                case EKey._D:
                    ((ControlObject)this).SetAngSpeed(-30f);
                    fTurning = -fMaxTurnSpeed;
                    break;
                    
            }
            //LogD("AttX " + vAttenuation.fX + " AttY " + vAttenuation.fY + " VelX " + fVelocityX + " VelY " + fVelocityY);
        }
        else//puszczenie klawisza
        {
            switch(nKeyCode)
            {
                case EKey._W:
                    fAcceleration = 0f;
                    break;
                case EKey._S:
                    fAcceleration = 0f;
                    break;
                case EKey._A:
                    ((ControlObject)this).SetAngSpeed(0f);
                    fTurning = 0f;
                    break;
                case EKey._D:
                    ((ControlObject)this).SetAngSpeed(0f);
                    fTurning = 0f;
                    break;
            }
        }
        
    }
    
    
    void Reset()
    {
        SetPosition(vStartPos);
        spring = new Spring();
        spring.SetAttenuation(vDefAttenuation);
        fSpeed = 0f;
        fAcceleration = 0f;
        fTurning = 0f;
        SetDestinationSpeed(200f);
         //((ControlObject)this).SetDestDir(new Vector(Vector.Forward));
    }
    
    public void SetSpeed(float fNewSpeed)
    {
        if (bDestSpeedSet)
        {
            if (fNewSpeed == fDestSpeed)
            {
                bDestSpeedSet = false;
                fSpeed = fNewSpeed;
                return;
            }
            if (fNewSpeed < fDestSpeed)
            {
                if (fAcceleration < 0f)
                {
                    bDestSpeedSet = false;   
                    fNewSpeed = fDestSpeed;
                    fAcceleration = 0f;
                }
                else
                    fAcceleration = fAccelerator;
            }
            else 
            {
                if (fAcceleration > 0f)
                {
                    bDestSpeedSet = false;   
                    fNewSpeed = fDestSpeed;
                    fAcceleration = 0f;
                }
                else 
                    fAcceleration = - fAccelerator;
            }
            fSpeed = fNewSpeed;
        }
        else
        {
            if (fNewSpeed >= fMaxSpeed)
                fNewSpeed = fMaxSpeed;
            fSpeed = fNewSpeed;
        }
        /*Vector vForward = GetForwardVector();
            
        vForward.Mul(fNewSpeed);
        vSpeed = vForward;*/
    }
    
    void SetDestinationSpeed(float fSpeed)
    {
        bDestSpeedSet = true;
        fDestSpeed = fSpeed;
    }
    
    void SetDestinationDir(Vector vDir)
    {
        //bDestDir
        //vDestinationDir = vDir;
    }
}
