public class FPPHandsPlasma extends FPPHands
{
    int nChargeMaterial = -1;
    
    static int nChargeMaterialsCount = 9;
    static String sChargeMatPrefix = "Dzialo3Ammo0";
    int m_nCurChargeMaterialID = -1;
    
    FPPHandsPlasma()
    {
        MeshName = "Data/Meshes/Logan/plasma.3DA";
        nDigitSet = Precache._PREMAT_DIGIT_PLASMA;
    }

    public void OnCreate()
    {
        super.OnCreate();
        
        nChargeMaterial = MaterialGetID( sChargeMatPrefix + "0_SI.mat" );
    }
    
    void SetChargeMaterial(int nMat)    
    {
        if (nMat >= 0 && nMat < nChargeMaterialsCount)
        {
            int iMat = Precache.GetDigitMat(nDigitSet, nMat);
            if(iMat > -1) 
            {
                m_nCurChargeMaterialID = nMat;
                if(!m_bCloakingOn && !m_bTermovisionOn) 
                    ReplaceOriginalMaterial(nChargeMaterial, iMat );
            }
        }
    }

    public void SetCloaking(boolean bOn)
    {
        super.SetCloaking(bOn);
        if (!bOn)   
            SetChargeMaterial(m_nCurChargeMaterialID);
    }
    
    public void SetTermovision(boolean bOn)
    {
        super.SetTermovision(bOn);
        if (!bOn)
            SetChargeMaterial(m_nCurChargeMaterialID);
    }
    
}
