public class PlayerHUD extends PlayerTriggered
{
    HUDManager HUD = null;
    
	/** pojazd w jakim znajduje sie player*/
	Vehicle m_Vehicle = null;

    public void OnCreate()
    {
        Log("[PlayerHUD.OnCreate]\n");
        super.OnCreate();
    }

    /** Inicjalizacja HUDa gracza. Gdy sie tego nie zawola to gracz nie ma HUDa, co jest
     * przydatne w grze sieciowej.
     */
    void InitHUD()
    {
		HUD = (HUDManager)CreateObject("HUDManager");
        HUD.InitInGame(this, cGameInitInfo);
        		
        if (bNetIsOwner)
            HUD.aHUDComponent[HUD._HUD_CONSOLE].Activate();
        
        fHealth = 1.0f;

		bDisableTriggerDetection = false;
    }
    
    /** Tworzy HUD i wypelnia go domyslnymi wartosciami.
     * Uwaga: Ta metoda powinna byc zawolana z modulu po ObjectInit
     */
    public void ResetHUD()
    {
        if(HUD==null) 
            return;
        
        HUD.GetHUDPlayer().SetTextHealth(fHealth);
    }    
    
    void OnDestroy()
    {
        // odlaczamy sprite'y inventory od HUDa
        //CrashLog("cInventory.Unacquire\n");
        if ( cInventory != null )
             cInventory.Unacquire();
        
        super.OnDestroy();
        LogD("\n");

        if(HUD!=null)
        {
            HUD.delete();
            HUD=null;
        }
    }
    
    //---------------------------------------------------------------
    /** inicjalizacja inventory playera
     */
    void InitInventory()
    {
        Log("[PlayerHUD.InitInventory]\n");
        
        cInventory = (InventoryPlayer)CreateObjectNoInit("InventoryPlayer");
        //cInventory = (Inventory)CreateObjectNoInit("Inventory");
        cInventory.Owner = this;
        cInventory.InitObject();
        
    }

    /** Ustawienie graczowi inventory AI gdy jest przeszukiwane cialo
     */
    boolean SetAIInventory(Inventory cAIInventory)
    {
        if (HUD != null)
        {
			// jezeli inventory jest juz aktywne
			if ( ((HUDCompInvPl)HUD.aHUDComponent[HUDManager._HUD_INV_PLAYER]).bActiveFlag )
				return false;
			
		    ((HUDCompInvPl)HUD.aHUDComponent[HUDManager._HUD_INV_PLAYER]).SetInvAI(cAIInventory);
		    ((HUDCompInvPl)HUD.aHUDComponent[HUDManager._HUD_INV_PLAYER]).ActivateSlow();
			
			// sprawdzamy, czy udalo sie aktywowac
			if ( ((HUDCompInvPl)HUD.aHUDComponent[HUDManager._HUD_INV_PLAYER]).bActiveFlag )
				return true;
			else
				return false;
        }
		return true;
    }
//-------------------------------------------------------------------------------------------------    
//-------------------------------------------------------------------------------------------------    
/*    public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        super.OnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);
		
		if (Assassin instanceof ControlObject && HUD != null)
        {
            HUD.ShowHitAssassinPlace( ((ControlObject) Assassin).GetPosition() );
        }
    }
*/	
    // metoda wolana z OnTakeDamage playera
    void TakeDamageSpecialEffects(float fDamage, Vector vAssassinPos, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        super.TakeDamageSpecialEffects(fDamage, vAssassinPos, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        
        // dolozenie na HUDzie efektu trafienia
        if (vAssassinPos != null && HUD != null)
        {
            HUD.ShowHitAssassinPlace( vAssassinPos );
        }
    }
    
    public void Damage(float fDamage)
    {
        super.Damage(fDamage);
        RefreshHealth();
    }
    
    public void Damage(float fDamage, int nDamageType)
    {
        super.Damage(fDamage, nDamageType);
        RefreshHealth();
    }
    
	void RefreshHealth()
	{
		if (HUD!=null && bNetIsOwner)
            HUD.GetHUDPlayer().SetTextHealth(fHealth);
	}

    void RefreshAmmoLeft()
    {
        if (HUD!=null && ActiveWeapon!=null  && bNetIsOwner && (HUD.GetHUDPlayer()!=null))
        {
            HUD.GetHUDPlayer().SetTextAmmoLeft( ActiveWeapon );
            HUD.GetHUDPlayer().Draw();
            
            if(HandsAnims.cMesh instanceof FPPHands)
                ((FPPHands)HandsAnims.cMesh).ChangedAmmoQuantity( ActiveWeapon );
        }
    }
    
    void UseWeapon(Weapon weapon)
    {
        super.UseWeapon(weapon);
        
        RefreshAmmoLeft();
    }
    
    void WeaponUsed()
    {
        super.WeaponUsed();
        
        if(HUD==null) return;
        
        HUD.GetHUDPlayer().SetWeapon( ActiveWeapon );
        RefreshAmmoLeft();
        
        /*nie ma juz wylaczania celownika
        //sprawdzam czy gracz ma wlaczony implant SMART PISTOL LINK
        if ((cInventory != null) && (cInventory.IsImplantActive(cInventory._IMPLANT_SMART_PISTOL_LINK)) 
            && (ActiveWeapon!= null) && (ActiveWeapon.nType == EWeaponType._PISTOL))
           HUD.GetHUDCrossHair().Activate(); 
        else
           HUD.GetHUDCrossHair().Deactivate();
        */
       
        
    }

    String GetAmmoText(Weapon cWeapon)
    {
        String sRet = null;
        if(cWeapon==null)
            sRet = "N/A";
        else
        {
            if(cWeapon.eBulletType == EAmmoType._Unlimited)
                sRet = "N/A";
            else
            {
                if(cWeapon.eBulletType == EAmmoType._Grenades)
                {
                    // liczymy ile gracz ma granatow
                    int nGrenades = 0;
                    java.util.Vector aGuns = cInventory.GetInvObjects(EInvObjType._GUN);
                    for(int i=0; i<aGuns.size(); i++)
                    {
                        InvObject cObj = (InvObject)aGuns.elementAt(i);
                        if(cObj.nInvIndex == cWeapon.nInvIndex)
                            nGrenades++;
                    }

                    sRet = "1/" + nGrenades;
                }
                else
                {
                    sRet = cWeapon.nAmmo + "/" + nTotalAmmo;
                }
            }
        }
        return sRet;
    }
    
    int GetTotalAmmoCount(Weapon cWeapon)
    {
        if(cWeapon==null)
            return -1;
        else
        {
            if(cWeapon.eBulletType == EAmmoType._Unlimited)
                return -1;
            else
            {
                if(cWeapon.eBulletType == EAmmoType._Grenades)
                {
                    // liczymy ile gracz ma granatow
                    int nGrenades = 0;
                    java.util.Vector aGuns = cInventory.GetInvObjects(EInvObjType._GUN);
                    for(int i=0; i<aGuns.size(); i++)
                    {
                        InvObject cObj = (InvObject)aGuns.elementAt(i);
                        if(cObj.nInvIndex == cWeapon.nInvIndex)
                            nGrenades++;
                    }

                    return nGrenades;
                }
                else
                {
                    return cWeapon.nAmmo + nTotalAmmo;
                }
            }
        }
    }
    
    void CountAmmo()
    {
        if( ActiveWeapon == null ) return;
        super.CountAmmo();
        
        RefreshAmmoLeft();
    }
    
    void MessageWeapon(int nState)
    {
        //Log("[PlayerSingle.MessageWeapon]: "+nState+"\n");
        
        super.MessageWeapon(nState);
 
        if (HUD==null) 
            return;
        
        // gdy brakuje amunicji to odrazu pokazujemy
        if ( (nState & Weapon.STATE_SHOT) != 0 )
        {
            RefreshAmmoLeft();
        }
    }
    
    
    
    void TextMessage(String s)
    {
        if (HUD==null) 
            return;
        
        HUD.AddConsText(s);
    }

/********************************************************************/
   
    
///////////////////////////////////////////////////////////////////////////////

    public void SetActiveTrigger(TriggerObject trigger)
    {
        super.SetActiveTrigger(trigger);
        HUD.GetHUDPlayer().UpdateActiveTrigger();
    }

	///////////////////////////////////////////////////////////////////////////////
	// POJAZDY
	///////////////////////////////////////////////////////////////////////////////

    void GetIn(SeatInfo seatInfo)
    {
		super.GetIn(seatInfo);
	
		if ( (cSeatInfo != null) &&
			 (cSeatInfo.GetOccupiedObject() == seatInfo.GetOccupiedObject()) )
		{
			if (seatInfo.GetOccupiedObject() instanceof Vehicle)
				PrepareHUDToGetIn((Vehicle) seatInfo.GetOccupiedObject());
			if (seatInfo.GetOccupiedObject() instanceof StationaryCannon)
				PrepareHUDToGetIn();
		}
			 
    }
	
    /** Wyjscie z pojazdu
     */
    boolean GetOut()
    {
		if (!super.GetOut())
			return false;

		PrepareHUDToGetOut();
		return true;
    }
	
	void PrepareHUDToGetIn()
	{
/* usuniete, by gracz mogl podpiac buttony myszy np. pod jazde do przodu           
		UnregisterMouseButtonRequest();
		UnregisterMouseAxisRequest();        
*/		
        if (HUD != null)
            SetActiveTrigger( null ); // odznaczenie triggera
	}
	
	void PrepareHUDToGetIn(Vehicle vehicle)
	{
/* usuniete, by gracz mogl podpiac buttony myszy np. pod jazde do przodu           
		UnregisterMouseButtonRequest();
		UnregisterMouseAxisRequest();        
*/
        if (HUD != null)
        {
            //ustawienie HUD dla pojazdow
            HUDUniversal hudUniversal = (HUDUniversal) HUD.aHUDComponent[HUD._HUD_UNIVERSAL];
			m_Vehicle = vehicle;
			m_Vehicle.SetUpHudComponentToUpdate(HUD);

            SetActiveTrigger( null ); // odznaczenie triggera
            
            //deaktywuje menu jesli jakies bylo
            HUD.DeactivateCurMenu();
            
            //jesli trzeba to chowam celownik
            if (!vehicle.IsArmed() && HUD.GetHUDCrossHair()!=null)
                HUD.GetHUDCrossHair().Deactivate();
        }
	}

	void PrepareHUDToGetOut()
	{
        if (HUD != null)
        {
            HUD.aHUDComponent[HUD._HUD_UNIVERSAL].Deactivate();
			
            if(HUD.GetHUDCrossHair()!=null)
                HUD.GetHUDCrossHair().Activate();
            
			if (m_Vehicle != null)
			{
	            m_Vehicle.StopUpdatingHud(HUD);
				m_Vehicle = null;
			}
			
            HUD.aHUDComponent[HUD._PLAYER_DATA].Activate();

/* usuniete, by gracz mogl podpiac buttony myszy np. pod jazde do przodu           
*/			
			if ( (HUD.GetHUDMap() == null) ||
				 (!HUD.GetHUDMap().bActiveFlag) )
			{
			    if (bNetIsOwner)
			    {
				    RegisterMouseButtonRequest();
				    RegisterMouseAxisRequest();
                }
			}
/**/            
        }
	}
	
    //////////////////////////////////////
    // obsluga niestandardowych widokow //
    //////////////////////////////////////

    void InitViewForAiming()
    {
        super.InitViewForAiming();

        if(HUD==null) return;

        // sprawdz, czy sniperka (dowolna - na razie)
        if (ActiveWeapon != null &&
            ActiveWeapon.cZoomer != null &&
            ActiveWeapon.cZoomer.eAimingType == EWeaponAimingType._SNIPER)
        {
            //dodatkowy hack na to, zeby sie nie wlaczala powtornie
            //snajperka (co powoduje ze pozniej nie chce zniknac)
            HUDComponent cHUDSniper = HUD.aHUDComponent[HUD._HUD_SNIPER];
            if ((cHUDSniper != null) && (!cHUDSniper.bActiveFlag))
            {
                //ukryj wszystkie HUD'y
                HUD.HideAll();
                // TODO: Obsluga innych snajperek
                ((HUDSniper)cHUDSniper).SetWeapon(ActiveWeapon);
                ((HUDSniper)cHUDSniper).SetCompass(HUD.GetHUDAddCompassSniper());
                cHUDSniper.Activate();
            }
        }
        else
        {
            // w przycelowaniu wlaczamy celownik
            // nie trzeba juz tego robic, bo zawsze jest celownik
            //HUD.GetHUDCrossHair().Activate();
        }
        
    }

    void RestoreViewAfterAiming()
    {   
        super.RestoreViewAfterAiming();

        if (HUD!=null)
        {
            HUDComponent cHUDSniper = HUD.aHUDComponent[HUD._HUD_SNIPER];
            if ((cHUDSniper != null) && (cHUDSniper.bActiveFlag))
            {
                cHUDSniper.Deactivate();
                
                HUD.UnhideAll();
            }
            else
            {
                // powracamy do normalnego trybu - wylaczamy celownik
                //sprawdzam czy gracz ma wlaczony implant SMART PISTOL LINK
                /*nie ma juz wylaczania celownika
                if ((cInventory != null) && (cInventory.IsImplantActive(cInventory._IMPLANT_SMART_PISTOL_LINK)) 
                    && (ActiveWeapon!= null) && (ActiveWeapon.nType == EWeaponType._PISTOL));
                else
                    HUD.GetHUDCrossHair().Deactivate();
                */
            }
        }
    }

    
    void UseBinoculars(Binoculars cBinocularsEx)
    {
        if (HUD == null || !HUD.CanActivate(HUDManager._HUD_BINOCULARS))
            return;
        
        super.UseBinoculars(cBinocularsEx);
        
        /*if (HUD.GetHUDBinoculars() == null)
        {
			HUD.CreateHUDBinoculars(this);
        }*/
        cBinocularsEx.cBinocularsHUD = HUD.GetHUDBinoculars();
        HUD.GetHUDBinoculars().SetBinoculars(cBinocularsEx);
			
    }
    
    void UseBinocularsDo()
    {
        if (HUD == null || !HUD.CanActivate(HUDManager._HUD_BINOCULARS))
            return;
        
        super.UseBinocularsDo();
        
        
        HUDBinoculars cBinocularsHUD = HUD.GetHUDBinoculars();
        
        if (cBinocularsHUD != null)
        {
            cBinocularsHUD.Activate();
            //jesli sie nie udalo aktywowac hud'a
            if (!cBinocularsHUD.bActiveFlag && HUD != null )
            {
                HUD.GetHUDBinoculars().SetBinoculars(null);
            }
            else
            {
                cBinoculars.SetState("BeingUsed");
            }
        }
 
        if ( HUD.GetHUDNiunia() != null )
        {
		    HUD.GetHUDNiunia().MoveTop();
        }
        
        // wyslanie komunikatu do modulu ze gracz uzyl lornetki
        if ( GetModule() != null && GetModule() instanceof ChromeModuleSingle )
        {
            ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_BINOCULARSUSED );
        }
    }
    
    
    void RestoreViewAfterBinoculars()
    {
        super.RestoreViewAfterBinoculars();
        
        if (HUD != null)
        {
  //          HUD.aHUDComponent[HUD._HUD_BINOCULARS].Deactivate();
  //          HUD.UnhideAll();
        }
    }
 
    void Execute( Actor cExecutor )
    {
        
        super.Execute( cExecutor );
        
        //sprawdzamy, czy mamy do czynienia z PlayerHUD
        cInventory.PrintInventory();
 
        try
        {
            /*PlayerHUD cPlayerHUD = (PlayerHUD)cExecutor;
            cPlayerHUD.SetOtherPlayerInventory(cInventory);
            bIsCorpseActive = false;*/
            
        } catch( ClassCastException e) {
            LogD(": PlayerHUD corpse can be executed only by PlayerHUD\n");
        }
        
    }    
    
    
    
    
//---------------------------------------------------------------------------------    
 
    public boolean IsActive(ControlObject Activator)
    {
      if (fHealth > 0) return false;
      else return bIsCorpseActive;
    }

    Vector GetForwardVectorCompass()
    {
        if (cSeatInfo == null)
            return GetForwardVector();
        else
            return ((Vehicle) cSeatInfo.GetOccupiedObject()).m_Physics.m_vVehicleForward;
    }
    
    Vector GetRightVectorCompass()
    {
        if (cSeatInfo == null)
            return GetRightVector();
        else
            return ((Vehicle) cSeatInfo.GetOccupiedObject()).m_Physics.m_vVehicleRight;
    }
    
    void NotEnoughRoomInInventory()
    {
        if ( bNetIsOwner )
        {
            TextMessage("&NO_INV_ROOM&");
        }
        else if ( Role == ERole._AUTHORITY )
        {
            MsgSendClientNoInvRoom();
        }
    }
        
    /**
     * Do nadpisania w sieci
     */
    void MsgSendClientNoInvRoom()
    {
        
    }

    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[PlayerHUD.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_PLAYER_HUD)
        {	
			super.SGLoadChunk(cFC);

			// pojazd w jakim znajduje sie player
			m_Vehicle = (Vehicle)GameObject.cSG.LoadObjectRef(cFC);
			
			if (HUD == null)
				CrashLog("[PlayerHUD.SGLoadChunk] ERROR! Loading HUDManager failed ! \n");
			HUD.SGLoadChunk(cFC);
        }
		
		cFC.delete();
    }
	    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[PlayerHUD.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_PLAYER_HUD, cFCParent);
		
		super.SGSaveChunk(cFC);
		    
		// pojazd w jakim znajduje sie player
		cFC.SaveObjectRef(m_Vehicle);
		
		HUD.SGSaveChunk(cFC);
					        
        cFC.delete();
    }	    	    
	
	public void SGUpdate()
	{
		FileChunk.Log("[PlayerHUD.SGUpdate]\n");
		super.SGUpdate();
        RefreshHealth();
		CountAmmo();
		RefreshAmmoLeft();
		HUD.SGUpdate();
	}	
}
