public class PlayerLevel00 extends PlayerSingle
{
    boolean bInputsAllowed = true;
    
    public void OnCreate()
    {
        super.OnCreate();
        
        SetCollHandler(ECollFlags.OBJCOL_HANDLER_FULLINFO);
    }
    
    public void OnCollisionFullInfo(ControlObject Col,Vector vPoint,Vector vNormal)
    {
        if (Col instanceof Barrier)
        {
            SetCollHandler(ECollFlags.OBJCOL_HANDLER_NONE);
            
            Level00 level = (Level00) GetModule();
            if (!level.bFirstTutorial)
            {
                level.MoveTutorItemsToPlayerInventory();
 				if (level.m_nObjectsInChest > 0)
                    level.ObjectsCollected(); // gdyby nie udalo sie wziac wszystkich obiektow i tak konczymy
            }
            else
            {
                if (level.bTutorialEnded) 
                    return;
                
                if (cBinoculars != null)
                {
                    cBinoculars.EndUse();
                    RestoreViewAfterBinoculars();
                }
                
                HUD.GetHudUniversal().ShowDialog(this, "OnTutorialProceed", "OnTutorialEnd");
                ((ChromeGame)ChromeGame.cSingleton).EnableLoadSave(false); 
                
                DisableCallMethod("StopMakingStepNoise");
                CallMethodEvery("StopMakingStepNoise", 0.5f);
                
                motion.Reset();
                UpdateMotion();
                
                bInputsAllowed = false;
                bUnableToAct = true;
                
                vNormal = VectorWorldToLocal(vNormal);
                vNormal.Normalize();
                vNormal.Mul(100f);
                SetLocalSpeed(vNormal, false);
                DisableCallMethod("RestoreZeroSpeed");
                CallMethodIn("RestoreZeroSpeed", 0.25f);
            }
        }
    }
    
    public void RestoreZeroSpeed()
    {
        SetLocalSpeed(new Vector(Vector.Zero), false);
    }
    
    public void OnTutorialProceed()
    {
        ((ChromeGame)ChromeGame.cSingleton).EnableLoadSave(true); 
        bInputsAllowed = true;
        bUnableToAct = false;

        SetCollHandler(ECollFlags.OBJCOL_HANDLER_FULLINFO);
        
        DisableCallMethod("StopMakingStepNoise");
    }
    
    boolean CanUseItem(InvObject cItem)
    {
        if (super.CanUseItem(cItem))
        {
            if (cItem.nInvIndex == InvObject._E_BINOCULARS)
                return HUD.GetActiveHudMenu() != HUDManager._HUD_UNIVERSAL;
            return true;
        }
        else
        {
            return false;
        }
    }
    
    public void OnTutorialEnd()
    {
        bInputsAllowed = true;
        bUnableToAct = false;
        ((ChromeGame)ChromeGame.cSingleton).EnableLoadSave(true); 
        Level00 level = (Level00) GetModule();
        level.cHintManager.m_bTutorial = false;
        level.bFirstTutorial = false;
        level.MoveTutorItemsToPlayerInventory();
 		if (level.m_nObjectsInChest > 0)
            level.ObjectsCollected(); // gdyby nie udalo sie wziac wszystkich obiektow i tak konczymy
        level.EndTutorial();
        
        DisableCallMethod("StopMakingStepNoise");
    }
}