public class Precache extends Sprite
{
    boolean bSimplePrecacheMode = true;
    
    int nTexture = 0;
    Sprite cText = null;
    
    String sBackGround = "Data/Textures/CH_M_Keysmenu.png";
    static String sAdditionalScreen = null;
    
    String m_sPrecachingText = "&PRECACHING&";
    
    static boolean bPrecaching = false;

    public void OnCreate()
    {
        ActivateOnModule();
        
        SetPos(new Vector(0.0f, 0.0f, 0.0f));
        if(bSimplePrecacheMode)
        {
            nTexture = AddTexture("Data/Interface/ER_T_Black.png");
            SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            SetTexture(nTexture, new Rect(0, 0, 1, 1));
        }
        else
        {
            nTexture = AddTexture( (sAdditionalScreen!=null) ? sAdditionalScreen : sBackGround);
            SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            SetTexture(nTexture, new Rect(0, 0, 0.78125f, 0.5859375f));
        }
        GetModule().AddSprite(this);
        MoveTop();
        Show();
        
        cText = (Sprite) CreateObject("Sprite");
        if(bSimplePrecacheMode) AddChild(cText);
        
        cText.SetFont(ChromeFonts.FONT_VERDANA_22);
        cText.SetTextPosFlags(ESpriteText.HORIZ_MIDDLE|ESpriteText.VERT_MIDDLE);
        
        String sText = m_sPrecachingText;
        cText.DisplayText(sText);
        
        Vector vTemp = cText.GetTextExtent(sText);
        cText.SetSize(vTemp);
        vTemp.fX = (GetScreenWidth() - vTemp.fX)/2;
        vTemp.fY = (GetScreenHeight()- vTemp.fY)/2;
        cText.SetPos(vTemp);
        
        cText.Show();
        
        ClearInputQueue();
    }
    
    void OnDestroy()
    {
        RemoveSprite(cText);
        cText.delete();
        cText = null;
        
        ReleaseTexture(nTexture);
        RemoveSprite(this);
        GetModule().UnMuteAllSounds();
        bPrecaching = false;
    }
    
    Camera cPlayerCamera = null;
    
    void Start(Camera cPlayerCam)
    {
        cPlayerCamera = cPlayerCam;
        GetModule().TimerStop();
        
        MoveTop();
        cText.MoveTop();
        bPrecaching = true;
        
        GetModule().MuteAllSounds();
        
        CrashLog("PRECACHE START\n");
        ProfileIntervalStart();
    }
    
    /** Dla podanej kamery ustawia rozne widoki z niej i renderuje
     */
    void PrecacheCamera(Camera cCam)
    {
        if(Game.IsGameInEditor()) return;
        
        //TODO ewentualne zmiany zasiegow widzenia
        ForceRender();
    }
    
    /** Dla podanej pozycji ustawia kamere i robi 4 widoki z niej
     */
    void Precache4CameraView(Vector vPos)
    {
        //FIXIT hack, zeby nie kopiowac parametrow
        Camera cCam = cPlayerCamera;
        
        cCam.FromForwardUpPos( Vector.Forward, Vector.Up, vPos);
        PrecacheCamera(cCam);
        
        cCam.FromForwardUpPos( Vector.Right, Vector.Up, vPos);
        PrecacheCamera(cCam);    
        
        cCam.FromForwardUpPos( Vector.Backward, Vector.Up, vPos);
        PrecacheCamera(cCam);
        
        cCam.FromForwardUpPos( Vector.Left, Vector.Up, vPos);
        PrecacheCamera(cCam);
    }
    
    boolean bDisableOnFrame = false;
    
    void OnFrame()
    {
        if(bDisableOnFrame) return;
        
        if(Game.IsGameInEditor())
        {
            cPlayerCamera = null;
        }
        
        //CrashLog("OnFrame\n");
        if(cPlayerCamera != null)
        {
            // PRECACHE BRONI
            CrashLog("PrecacheWeapons\n");
		    PrecacheWeapons();
        
            CrashLog("PrecacheMeshes\n");
            PrecacheMeshes();
            
            CrashLog("PrecacheViews\n");
            
            // odpalamy widoki na terenie
            Module mod = GetModule();
            Vector vExtents = mod.GetTerrainSize();
            Vector vTemp = new Vector();
            
            int nElems = 3;
            for(float x=0; x<vExtents.fX; x+=vExtents.fX/nElems)
                for(float z=0; z<vExtents.fZ; z+=vExtents.fZ/nElems)
                {
                    // czytamy wysokosc terenu plus tak na oko wysokosc Logana
                    float y = mod.TerrainHeight(x,z) + 200.f;
                    float fWaterLevel = mod.GetWaterLevel();
                    if(y < fWaterLevel) y = fWaterLevel+100.f;
                    vTemp.Set(x,y,z);
                    CrashLog("Precache4CameraView\n");
                    Precache4CameraView(vTemp);
                }

            // odpalanie cacheowania tekstur
            //Precache();
            
            // wlaczamy normalny tryb
            cPlayerCamera = null;
        }
        else
        {
            //WaitForUserInput();
            //PZ:
            CrashLog("PrecacheStartGame\n");
            StartGame();
        }
    }
    
    void WaitForUserInput()
    {
        RegisterKeyRequest();
    }

    void StartGame()
    {
        UnregisterKeyRequest();

        // przywracamy czas
        Module cMod = GetModule();
        cMod.TimerStart();

        bDisableOnFrame = true;
        
        //start jest opozniony, zeby wszystkie metody wolane z OnCreate'ow przez CallMethodIn(..., 0)
        //mogly sie wywolac pod przykrywka precacha
        CallMethodIn("DelayedStartGame", 1.0f);
    }

    void DelayedStartGame()
    {
        float fPrecacheTime = ProfileIntervalEnd();
        CrashLog("PRECACHE END fPrecacheTime="+fPrecacheTime+"\n");
        
        Module cMod = GetModule();
        cMod.RemoveSprite(this);
        if( cMod instanceof ChromeModuleSingle)
            ((ChromeModuleSingle)cMod).StartLevelAction();
        
        // kasujemy sie w pizdu
        CallMethodIn("delete", 0);
    }
    
    void SwitchScreens()
    {
        ReleaseTexture(nTexture);
        
        nTexture = AddTexture(sBackGround);
        SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
        SetTexture(nTexture, new Rect(0, 0, 0.78125f, 0.5859375f));
        
        UnregisterKeyRequest();
        CallMethodIn("WaitForUserInput", 2.0f);
        
        sAdditionalScreen = null;
    }
    
    public void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if(bKeyState)
        {
            if(sAdditionalScreen!=null)
            {
                SwitchScreens();
            }
            else
                StartGame();
        }
    }
    
    /////////////////////////////////////////////////////////////////////////////////

    // wolane gdy modul sie kasuje, tu ma byc wyrzucenie wszystkich
    // precachowanych danych
    static void ModuleDestroys(ChromeModule cMod)
    {
        ReleaseDigits(cMod);
        ReleaseWeapons();
        ReleaseMeshes();
    }
    
    static java.util.Vector aPreloadedWeapons = null;
    
    static void ReleaseWeapons()
    {
        if(aPreloadedWeapons==null) return;
        for(int i=0; i<aPreloadedWeapons.size(); ++i)
        {
            MeshObject cObj = (MeshObject)aPreloadedWeapons.elementAt(i);
            cObj.delete();
        }
        aPreloadedWeapons = null;
    }
    
    void PrecacheWeapons()
    {
        CrashLog("PrecacheDigits\n");
        // precachujemy cyferki
        PrecacheDigits();
        
        ChromeModule cModule = (ChromeModule)GetModule();
        GameObject[] aWeapons = GetObjectsFromClassModule("Weapon", cModule);
        
        Player cPlayer = cModule.GetMainPlayer();
        
        CrashLog("Precache FindWeaponByName\n");
        
        if (cPlayer != null)
        {
            // wczytujemy wszystkie bronie
            if(aWeapons != null)
            {
                for(int i=0; i<aWeapons.length; ++i)
                    if (aWeapons[i] != null)
                    {
                        cPlayer.FindWeaponByName(aWeapons[i].getClass());
                    }
            }
        }
        
        CrashLog("Precache Weapons main loop\n");
        
        // robimy liste wszystkich klas broni uzytych
        aPreloadedWeapons = new java.util.Vector(10);
        for(int j=0; j<aWeapons.length; ++j)
        {
            PrecacheWeaponFPP( (Weapon)aWeapons[j] );
        }
        
        //LogR("aPreloadedWeapons.size()="+aPreloadedWeapons.size()+"\n");
    }

    private static java.util.ArrayList m_aMeshesNamesToPrecache = null;
    private static java.util.ArrayList m_aMeshesToPrecache = null;
    
    static void AddMeshToPrecache(String sMeshName)
    {
        if (sMeshName != null)
        {
            if (m_aMeshesNamesToPrecache == null)
                m_aMeshesNamesToPrecache = new java.util.ArrayList();

            for (int i = 0; i < m_aMeshesNamesToPrecache.size(); i++)
            {
                if ( sMeshName.equalsIgnoreCase((String) m_aMeshesNamesToPrecache.get(i)) )
                    return;
            }
            m_aMeshesNamesToPrecache.add(sMeshName);
        }
    }
    
    void PrecacheMeshes()
    {
        if (m_aMeshesNamesToPrecache == null)
            return;
        
        if (m_aMeshesToPrecache == null)
            m_aMeshesToPrecache = new java.util.ArrayList();
        
        CrashLog("Precache meshes loop\n");
        
        for (int i = 0; i < m_aMeshesNamesToPrecache.size(); i++)
        {
            String sMeshName = (String) m_aMeshesNamesToPrecache.get(i);
            CrashLog("Precache mesh <"+sMeshName+">\n");
            
            MeshObject cObj = (MeshObject) CreateObjectNoInit("MeshObject");
            cObj.MeshName = sMeshName;
            cObj.InitObject();
            m_aMeshesToPrecache.add(cObj);
        }
        m_aMeshesNamesToPrecache.clear();
        m_aMeshesNamesToPrecache = null;
    }
    
    static void ReleaseMeshes()
    {
        if (m_aMeshesToPrecache == null)
            return;
        
        for (int i = 0; i < m_aMeshesToPrecache.size(); i++)
        {
            MeshObject cObj = (MeshObject) m_aMeshesToPrecache.get(i);
            cObj.delete();
        }
        m_aMeshesToPrecache.clear();
        m_aMeshesToPrecache = null;
    }
    
    void PrecacheWeaponFPP(Weapon cWeaponToPrecache)
    {
        String sWeaponMesh = null;
        
        // wycigamy nazwe mesha tpp
        FPPHands cHands = (FPPHands)GetObjectOfClass(cWeaponToPrecache.sFPPHandsClass);
        sWeaponMesh = cHands.MeshName;
        
        // szukamy czy juz nie ma dodanej tej broni
        boolean bFound = false;
        for(int k=0; k<aPreloadedWeapons.size(); ++k)
        {
            MeshObject cWeapon = (MeshObject)aPreloadedWeapons.elementAt(k);
            if(cWeapon.MeshName.equals(sWeaponMesh))
            {
                bFound = true;
                break;
            }
        }
        
        if(!bFound)
        {
            // dodajemy nowego mesha
            MeshObject cObj = (MeshObject)CreateObjectNoInit("MeshObject");
            cObj.MeshName = sWeaponMesh;
            cObj.InitObject();
            aPreloadedWeapons.addElement(cObj);
        }
    }

    ////////////
    // cyferki
    
    static int _PREMAT_DIGIT_YELLOW = 0;
    static int _PREMAT_DIGIT_RED    = 1;
    static int _PREMAT_DIGIT_PLASMA = 2;
    

    static int GetDigitMat(int nSet, int nDigit)
    {
        // gdy nie ma jeszcze materialow to je wczytujemy
        if(aMatSets == null) PrecacheDigits();
        
        if(nSet >= aMatSets.size()) return -1;

        MaterialPreLoadSet cMat = (MaterialPreLoadSet)aMatSets.elementAt(nSet);
        if(cMat != null)
            return cMat.GetMat(nDigit);
        return -1;
    }
    
    static java.util.Vector aMatSets = null;
    
    static void PrecacheDigits()
    {
        aMatSets = new java.util.Vector(0);
        
        // dodajemy zestawy materialow
        aMatSets.addElement( new MaterialPreLoadSet(10,"Cyferka","_SI.mat") );//_PREMAT_DIGIT_YELLOW
        aMatSets.addElement( new MaterialPreLoadSet(10,"Caws_digit","_SI.mat") );//_PREMAT_DIGIT_RED
        aMatSets.addElement( new MaterialPreLoadSet(FPPHandsPlasma.nChargeMaterialsCount,FPPHandsPlasma.sChargeMatPrefix,"_SI.mat") );//_PREMAT_DIGIT_PLASMA
    }
    
    static void ReleaseDigits(Module cMod)
    {
        if(aMatSets==null) return;
        for(int i=0; i<aMatSets.size(); ++i)
        {
            MaterialPreLoadSet cMat = (MaterialPreLoadSet)aMatSets.elementAt(i);
            cMat.Release();
        }
        aMatSets = null;
    }
}

class MaterialPreLoadSet
{
    int[] aPreloadedMaterials = null;

    int GetMat(int n) { return aPreloadedMaterials[n]; }
    
    MaterialPreLoadSet(int nMaterials, String sPrefix, String sSufix)
    {
        aPreloadedMaterials = new int[nMaterials];
        
        // preloadujemy materialy do cyferek
        for(int i=0; i<aPreloadedMaterials.length; ++i)
        {
            String sMat = sPrefix + i + sSufix;
            aPreloadedMaterials[i] = GameObject.MaterialLoad(sMat);
        }
    }
    
    void Release()
    {
        for(int i=0; i<aPreloadedMaterials.length; ++i)
        {
            GameObject.MaterialFree(aPreloadedMaterials[i]);
        }
    }
}