/** Klasa obsluguje sound emitter, ktory wydaje co jakis czas losowo wybrany dzwiek.
 * Przydatne np. do robienia wiatru, cwierkania goryli w dzungli lub innych takich.
 */
public class SoundEmitterRandom extends SoundEmitter
{
    /** Sciezka do katalogu z ktorego beda losowane dzwieki - na koncu musi byc slash ! */
    public String sSoundPath = "Data/Sounds/";//#SOUND_EMITTER_RANDOM
    
    /** Nazwy waveow z ktorych maj byc losowane dzwieki oddzielone znakiem ';' (nazwy *.wav) */
    public String sSounds = "";//#SOUND_EMITTER_RANDOM
    
    /** Minimalny czas co jaki ma byc odgrywany dzwiek */
    public float fMinTimeBetweenSounds = 5.0f;//#SOUND_EMITTER_RANDOM
    
    /** Maksymalny czas co jaki ma byc odgrywany dzwiek */
    public float fMaxTimeBetweenSounds = 10.0f;//#SOUND_EMITTER_RANDOM
    
/************************************************************************************/    
    
    void OnCreate()
    {
        super.OnCreate();
        
        ClearFlag(EFlags._NOT_STATIC);
    }
    
    /** Zwraca losowy czas spomiedzy podanych w klasie parametrow
     */
    float GetNextTime()
    {
        return fMinTimeBetweenSounds + RandomFloat(fMaxTimeBetweenSounds - fMinTimeBetweenSounds);
    }
        
    /** Wektor z dzwiekami ktore mozna odgrywac */
    java.util.Vector aSounds = new java.util.Vector(0);
    
    void Init()
    {
        // parsujemy stringa i budujemy z niego wektor nazw dzwiekow
        java.util.StringTokenizer st = new java.util.StringTokenizer(sSounds, ";");
        while (st.hasMoreTokens())
        {
            String s = new String( sSoundPath + st.nextToken() );
            LogD(s+"\n");
            aSounds.addElement( s );
        }
        
        Reinitialize();
    }

    void Reinitialize()
    {
        // wylaczamy wolanie metody Check
        DisableCallMethods();

        // wlaczamy losowanie dzwieku za losowy czas
        CallMethodIn("MakeNoisySound", GetNextTime());
    }
    
    void MakeNoisySound()
    {
        if ( (!bListenerInsideBuilding) &&
             (!bSoundDisabled) )
        {
            // losujemy jeden z dzwiekow
            String sSound = null;
            if(aSounds.size() != 0)
                sSound = (String)aSounds.elementAt( RandomInt(aSounds.size()) );

            UpdateDistanceToCamera();
            
            // odpalamy dzwiek tylko jak gracz moze go uslyszec
            if(fDistanceToCamera < fMaxDistance)
            {
                // odgrywamy dzwiek (UWAGA!!! bylo AttachOneShotSound, ale dla nieruchomych
                // obiektow powinnismy odpalac przez PlaySound
                if(sSound!=null)
                    PlaySound(sSound, fMinDistance, fMaxDistance);
                else
                    LogR("[SoundEmitterRandom.MakeNoisySound] No sounds defined in <"+GetName()+":"+GetUniqueID()+">\n");
            }
        }

        float fDelay = GetNextTime();
        CallMethodInMinMax("MakeNoisySound", fDelay, 2.f*fDelay);
    }
}
