public class APCNet extends APC
{
    
    /**
     * Czas przez jaki widac wraka
     * Oczywiscie jak wyspawnowany w miedzyczasie pojazd-wlasciciel 
     * zginie szybciej to wrak przestawiany jest na nowe miejsce
     */
    //TODO: przeniesc do vehicla bo jest i tu i w sieciowym jeepie
    static float sm_fWreckVisibleTime = 60.0f;
    
    int METHOD_HideWreck = 0;
    
    APCNet()
    {
        super();
        
        fDamageThreshold = 70; //musi byc mozliwosc rozwalenia w sieci przez jeepa
        
        //goscie z transportowca powinni miec szanse przezycie
        m_fOccupantsDamageMulOnCrash = 0.75f;
        
        m_cCannonControllerClass = CannonControllerAPCNet.class;
        
        m_fCannonMinVAngle = -40f;
        m_fCannonMaxVAngle = 15f;
        
        fFireDamage = 1000.0f;//750.0f;
        fRateOfFire = 22.5f;//45.0f;
        //nRoundShots = 12;
        //fLongDelay  = 1.0f;
    }
    
	void OnCreate()
    {
        METHOD_HideWreck = RegisterCallMethod( "HideWreck" );
            
        super.OnCreate();
        
        if (m_Physics != null)
		{
			//m_Physics.m_Params._ACCELERATION_COEF = 1800f; // przyspieszenie
			//m_Physics.m_Params._BRAKE_COEF = 3000f; // sila hamowania
            //m_Physics.m_Params._MAX_TURN_ANGLE = 90.0f; // szybkosc skretu w stopniach na sekunde
    	    m_Physics.m_Params.SetMaxSpeed(1500);
        	m_Physics.m_Params._CURR_MAX_SPEED = m_Physics.m_Params.GetMaxSpeed(); // nie zmieniac !!!
            m_Physics.m_Params._MAX_SPEED_TO_SAFE_COLLISION = m_Physics.m_Params.GetMaxSpeed() * 0.5f;
            m_Physics.m_Params._DAMAGE_COEFF_SAFE_COLLISION = 0.02f;
    	}
        
        DeleteAllSeatsInfos();
		AddSeatInfo(new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_DRIVER,
							 EGetInOutAnimType._UNKNOWN, new Vector(300f, 0f, -400f)));
		AddSeatInfo(new SeatInfo(this, "Passenger", EPassengerRole._VEHICLE_PASSENGER,
						     EGetInOutAnimType._UNKNOWN, new Vector(-300f, 0f, -400f)));
        AddSeatInfo(new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_PASSENGER_IDLE,
							 EGetInOutAnimType._UNKNOWN, new Vector( 0f, 0f, -910f)));
        AddSeatInfo(new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_PASSENGER_IDLE,
							 EGetInOutAnimType._UNKNOWN, new Vector( 0f, 0f, -910f)));
        AddSeatInfo(new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_PASSENGER_IDLE,
							 EGetInOutAnimType._UNKNOWN, new Vector( 0f, 0f, -910f)));
        AddSeatInfo(new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_PASSENGER_IDLE,
							 EGetInOutAnimType._UNKNOWN, new Vector( 0f, 0f, -910f)));
        
    }
    
    void DeactivateChildren()
    {
        GameObject [] children = GetChildren();
        if (children == null) return;
        for (int i = 0; i < children.length; i++)
        {
            // zwykle obiekty odlaczamy i chowamy
            if ( cCannon != children[i] )
                ((MeshObject)children[i]).DetachFromParent();
            ((MeshObject)children[i]).EnableRendering(false);
            ((MeshObject)children[i]).DeactivateOnModuleAlways();
            ((MeshObject)children[i]).DeleteAttachedFXes();
        }
    }
    
    void ActivateChildren()
    {
        GameObject [] children = GetChildren();
        if (children == null) return;
        for (int i = 0; i < children.length; i++)
        {
            ((MeshObject)children[i]).EnableRendering( (cCannon != children[i]) );
            ((MeshObject)children[i]).ActivateOnModule();
        }
    }
    
    void Respawn( boolean bOnRestartLevel )
    {
        super.Respawn( bOnRestartLevel );
        
        ActivateChildren();
        
        if ( bOnRestartLevel )
            HideWreck();
    }

    void ShowWreck()
    {
		HideWreck();
		super.ShowWreck();
		CallMethodIn( METHOD_HideWreck, sm_fWreckVisibleTime );
    }
    
    void HideWreck()
    {
        super.HideWreck();
        DisableCallMethod( METHOD_HideWreck );
    }

    
    public void OnReplicateServer()
    {
        super.OnReplicateServer();
        
        Pawn[] aPassengers = GetOccupants( EPassengerRole._VEHICLE_PASSENGER_IDLE );
        if ( aPassengers != null )
            for ( int i = 0; i<aPassengers.length; ++i )
            {
                if ( aPassengers[i] != null && aPassengers[i].bNetIsOwner )
                {
                    Replicate( sm_nVehicleHealthSet );
                    break;
                }        
            }
    }
}
