public class FlyingVehiclePhysicsNet extends FlyingVehiclePhysics
{
    FlyingVehiclePhysicsNet()
    {
        super();
        
        _MIN_PHYSICS_UPDATE_GRAIN = 0.05f;
        
        
        //_MAX_VERT_ANGLE = 45f;
        _MAX_VERT_ANGLE = 25f;
    }
    
    public class GotoPointState extends FlyingVehiclePhysics.GotoPointState
    {
        public void OnFrame()
        {
            float fTimeNow = GetTime();
            do 
            {
                Physics_MakeUpTurnDecision(_DEG_PRECISION);
			    CheckMoveDecision();
			    Physics_MakeUpDownDecision( m_Owner.GetPosition(),
									        m_vDestPoints[m_iCurrPoint].fY);
                
            }
            while ( UpdatePhysics( fTimeNow ) );
        }
    }
    
    public class StartState extends FlyingVehiclePhysics.StartState
    {
        public void OnFrame()
        {
            float fTimeNow = GetTime();
            do 
            {
                if (bSetLandingAngle)
			    {
				    Physics_MakeUpTurnDecision( 1.0f );
				    if (java.lang.Math.abs(Physics_CalcAngle()) < 1.0f)
				    {
					    bSetLandingAngle = false;
					    m_iTurnFlag      = _NO_TURN;
				    }
			    }
			    //CheckStartDecision( m_Owner.GetPosition() );
                FryingActors();
            } while( UpdatePhysics( fTimeNow ) );
        }
    }
    
    public void UpdatePhysics()
    {
        float fTimeNow = GetTime();
        while ( UpdatePhysics( fTimeNow ) )
            ; //do nothing
    }
    
    boolean UpdatePhysics(float fTimeNow)
	{
        //Log("we m_fCurrSpeed "+m_fCurrSpeed+"\n");
        
        /*
        super.UpdatePhysics();
        
        boolean bRet = true;
        if ( bRet )
            return false;
        */
        //LogD("\n");
		float fTimeToUpdate = fTimeNow - m_fLastT;
		
		// symulujemy jedna ramke fizyki
		if (fTimeToUpdate >= _MIN_PHYSICS_UPDATE_GRAIN)
		{
		    // te wartosci bedziemy przeksztalcac w krokach
		    m_vVehicleForward   = m_Owner.GetForwardVector();
		    m_vVehiclePos       = m_Owner.GetPosition();
                
			UpdateOneStep( _MIN_PHYSICS_UPDATE_GRAIN );
            
            fTimeToUpdate   -= _MIN_PHYSICS_UPDATE_GRAIN;
            m_fLastT        += _MIN_PHYSICS_UPDATE_GRAIN;
		

		    // fizyka zostala przesymulowana, teraz okreslamy polozenie i orientacje pojazdu
		    // na podstawie m_vVehiclePos i m_vVehicleForward
		    float fUpDown = m_fCurrSpeed / _MAX_FW_SPEED / 3f;
		    if (fUpDown > 1f)
		    	fUpDown = 1f;
		    fUpDown *= _MAX_VERT_ANGLE;
		
		    float fLeftRight = m_fCurrTurnSpeed  / _MAX_TURN_SPEED;
		    fLeftRight *= _MAX_HORIZ_ANGLE;
		    
            //LogD(" vForward "+m_vVehicleForward+"\n");
                 
		    Vector vUp = new Vector(Vector.Up);
            /*
		    Vector vRightAxis = m_vVehicleForward.Cross(Vector.Up);
		    vRightAxis.Normalize();

		    vUp = RotateVector( Vector.Up, -fUpDown, vRightAxis);
		    m_vVehicleForward = RotateVector( m_vVehicleForward, -fUpDown, vRightAxis );
		    vUp = RotateVector( vUp, fLeftRight, m_vVehicleForward );
            */
        
            /*
            LogD(" vForward "+m_vVehicleForward+ 
                 " vUp "+vUp+
                 " fUpDown "+fUpDown+
                 " fLeftRight "+fLeftRight+"\n");
            */
		
		    m_Owner.FromUpForwardPos( vUp, m_vVehicleForward, m_vVehiclePos );
        
            // Update predkosci Ownera (zalozenie: fizyka ownera jest wylaczona!!!)
            Vector vSpeed = m_Owner.GetForwardVector();
            vSpeed.Mul( m_fCurrSpeed );
            vSpeed.fY = m_fCurrUpDownSpeed;
            m_Owner.SetSpeed( vSpeed );
        }
    
        //Log("wy m_fCurrSpeed "+m_fCurrSpeed+"\n");
        return (fTimeToUpdate >= _MIN_PHYSICS_UPDATE_GRAIN);
	}
        
}
