public class JeepNet extends Jeep
{
    /**
     * Czas przez jaki widac wraka
     * Oczywiscie jak wyspawnowany w miedzyczasie pojazd-wlasciciel 
     * zginie szybciej to wrak przestawiany jest na nowe miejsce
     */
    static float sm_fWreckVisibleTime = 60.0f;
            
    JeepNet()
    {
        super();
        
        // UWAGA !!! jezeli w edytorze ustawi sie wartosci inne niz ponizsze,
        // ponizsze zostana nadpisane - licza sie ustawienia z edytora
        
        fHealth = 2000f;
        fMaxHealth = 2000f; // wazne, gdy pokazywany bylby procent zycia wroga
        
        fDamageThreshold = 40f;
        
        //goscie z jeepa powinni ginac przy rozwaleniu pojazdu
        m_fOccupantsDamageMulOnCrash = 1.0f;
        
        fFireRange = 40000.0f;
        fFireDamage = 75f;
        fRateOfFire = 550f; // nie ustawiac wiecej niz 600 ze wzgledu na wydajnosc !!!
	}
    
    void InitCannonController(ICannonController cNewCannon)
    {
        super.InitCannonController(cNewCannon);
        
        cCannon.SetAccuracy(2.0f, 1.5f); // celnosc broni
    }

    int METHOD_HideWreck = 0;
    
	void OnCreate()
    {
        METHOD_HideWreck = RegisterCallMethod( "HideWreck" );
            
        super.OnCreate();

        if (m_Physics != null)
		{
			m_Physics.m_Params._ACCELERATION_COEF = 1800f; // przyspieszenie
			m_Physics.m_Params._BRAKE_COEF = 3000f; // sila hamowania
            m_Physics.m_Params._MAX_TURN_ANGLE = 120.0f; // szybkosc skretu w stopniach na sekunde
    	    m_Physics.m_Params.SetMaxSpeed(2100);
        	m_Physics.m_Params._CURR_MAX_SPEED = m_Physics.m_Params.GetMaxSpeed(); // nie zmieniac !!!
            m_Physics.m_Params._MAX_SPEED_TO_SAFE_COLLISION = m_Physics.m_Params.GetMaxSpeed() * 0.5f;
            m_Physics.m_Params._DAMAGE_COEFF_SAFE_COLLISION = 0.02f;
            m_Physics.m_Params._SLIDE_COEF = 700f;
    	}
		
		SetMaxInterpolateDistance(2100f);
	}
    
    void Respawn( boolean bOnRestartLevel )
    {
        super.Respawn( bOnRestartLevel );
        
        if ( bOnRestartLevel )
            HideWreck();
    }

    void ShowWreck()
    {
		HideWreck();
		super.ShowWreck();
		CallMethodIn( METHOD_HideWreck, sm_fWreckVisibleTime );
    }
    
    void HideWreck()
    {
        super.HideWreck();
        DisableCallMethod( METHOD_HideWreck );
    }
}
