public class Speeder extends VehicleCar
{
	float _UPDATE_ENGINE_TIME = 0.1f;
	static String _ENGINES_EXHAUST = "FXFlyerEngine";
	int _NOF_ENGINES = 18;
	int aEngines[] = null;
    int aEnginesRunTimeFXes[] = null;
    
    boolean m_bEnginesOn = false;
    
    /** wartosc szybkosci skretu speedera do przechowania na czas patrolowania */
    float m_fOldTurningValue = 0f;

	Speeder()
	{
        m_sSoundAccelName = null;
		m_sSoundBrakeName = null;
		m_sSoundSlideName = null;
        m_sSoundStartName = null;
        m_sSoundLoopName = "Data/Sounds/Vehicles/shuttle";
        m_sSoundStopName = null;
		
	    fBlobMapSize = 275f;
	    sBlobMaterial = "blobs_speeder.mat";
		
        /*prev
		m_fObservedSightVAngle = 10f;
		m_fOverObservedHeight = 250f;
		m_fOverObservedBack = -50f;
        */
        m_fObservedSightVAngle = 15f;
	    m_fOverObservedHeight = 200f;
	    m_fOverObservedBack = 650f;
        
        m_aSpeeds = new float[] { 0f, 300f, 900f, 1500f, 2250f, 3000f };
        m_iStampSize = 13;
        
        fBlowUpShakeStrength = 300;
        fBlowUpShakeDistMin = 500;
        fBlowUpShakeDistMax = 2000;
	}	
	
    public boolean IsArmed()
    {
        return false;
    }
    
    SeatInfo m_cSeatInfo = null;
        
	void OnCreate()
    {
		super.OnCreate();
		
        // hack me hard!
        SetUnImportanceFactor(0);
        
		DeleteAllSeatsInfos();
        m_cSeatInfo = new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_DRIVER,
                                   EGetInOutAnimType._UNKNOWN, new Vector(250, 0, 0));
        m_cSeatInfo.m_fBeginPosRadius = 500f;
		AddSeatInfo( m_cSeatInfo );
		
		if (m_Physics != null)
		{
			m_Physics.m_Params._TIME_BETWEEN_SLIDE_SOUNDS = 0.15f;
			m_Physics.m_Params._TIME_BETWEEN_ACCEL_SOUNDS = 0.1f;
			
            m_Physics.m_Params._SLIDE_SUPRESS = 700.0f;
			m_Physics.m_Params._ACCELERATION_COEF = 1500f;
            m_Physics.m_Params._TREE_HIT_SUPR = 0.2f;
        
            m_Physics.m_Params._TURNING_SPEED = 2000.0f;
            m_Physics.m_Params._MAX_TURN_ANGLE = 90.0f;
            
			m_Physics.m_Params._WHEEL_MOVE_SPEED_COEF = 1f;
			m_Physics.m_Params.SetMaxSpeed(3000.0f);
			m_Physics._HEIGHT_OVER_GROUND = 100f;
            
            m_Physics.m_Params._MAX_HORIZ_DEV = 20f;
            m_Physics.m_Params._HORIZ_DEV_ACCEL = 60f;
            
            m_Physics.m_bFlyOverWater = true;
		}
		
        SetFlag(EFlags._CAST_SHADOWS);
        SetBlobMaterial(sBlobMaterial);
        SetBlobMapSize(fBlobMapSize);
		
        SetTraceCollType(ECollTraceFlags._HULL);
        SetCollType(ECollFlags.OBJCOL_TYPE_PERFACEOBJECT);
			
		SetUpEngines();
		
		//SetUpWeapons();
        
        sBlowUpFX = "FXJeepBlow";
        
        m_fAttenuation = 0.92f;
        m_fForceFactor = 100f;
        m_fAmplitudeCoeff = 0.3f;
        
        m_fDownTestVectorLen = -350f;
        
        //SetEllipsoidNoExtents(220f, 200f, 100f);
    }
	
    void OnDestroy()
    {
        super.OnDestroy();
        m_cSeatInfo = null;
    }
    void CreatePhysics()
    {
		m_Physics = new PhysicsSpeeder(this);
        m_Physics.Init();
    }
	
    public Vector GetPointToLookAt(int nPoint)
    {
        Vector vPoint = GetPosition();
        vPoint.fY += 100f;
        return vPoint;
    }
    
	void CheckRadiuses()
	{
		if (m_VehiclePath != null)
		{
			for (int i = 0; i < m_VehiclePath.GetPointsNum(); i++)
			{
				if (m_VehiclePath.GetPoint(i).fRadius == 0f)
					m_VehiclePath.GetPoint(i).fRadius = 300f;
			}
		}
	}
	
    void GetTriggerExtents(Camera cam, Vector vMinExtent, Vector vMaxExtent)
    {
        GetScreenExtents(cam, vMinExtent, vMaxExtent);
    }
	
	void SetUpEngines()
	{
		aEngines = new int[_NOF_ENGINES];
        aEnginesRunTimeFXes = new int[_NOF_ENGINES];
		for (int i = 0; i < 9; i++)
			aEngines[i] = GetElementID("LEngine0" + Integer.toString(i + 1));
		for (int i = 0; i < 9; i++)
			aEngines[i + 9] = GetElementID("REngine0" + Integer.toString(i + 1));
        
        for(int i=0; i<aEnginesRunTimeFXes.length; ++i)
            aEnginesRunTimeFXes[i] = 0;
	}
	
	void TurnEngines(boolean bTurn)
	{
        m_bEnginesOn = bTurn;
        
		StopEngineFXes();
		if (bTurn)
			CallMethodEvery("BurnEngines", _UPDATE_ENGINE_TIME);
	}
	
    void StopEngineFXes()
    {
        DeleteAttachedFXes();
        DisableCallMethod("BurnEngines");
        for(int i=0; i<aEnginesRunTimeFXes.length; ++i)
            if(aEnginesRunTimeFXes[i]!=0) DeleteFXSequence( aEnginesRunTimeFXes[i] );
    }
    
    void BurnEngines()
    {
        for (int i = 0; i < _NOF_ENGINES; i++)
            aEnginesRunTimeFXes[i] = ExecuteFX(this, aEngines[i], _ENGINES_EXHAUST, new Vector());
    }
	
	public void PawnGotIn(SeatInfo info, Pawn pawn)
	{
		super.PawnGotIn(info, pawn);
		
		TurnEngines(true);
	}
	
	public void PawnGotOut(SeatInfo info, Pawn pawn)
	{
		super.PawnGotOut(info, pawn);
		
		TurnEngines(false);
	}
	
    public boolean IsActive(ControlObject Activator)
    {
        if(!bActiveTrigger) return false;
        
		if (Activator == GetFirstOccupant(EPassengerRole._VEHICLE_DRIVER))
			return false;
		
        return ( (GetFirstOccupant(EPassengerRole._VEHICLE_DRIVER) == null) && 
                 (fHealth > 0) && (m_bCanDrive) );
    }
	
	public void ActivateVehicle(boolean bActivate, boolean bGridIndependent, boolean bActivatePhysics)
	{
		super.ActivateVehicle(bActivate, bGridIndependent, bActivatePhysics);

        if(m_bEnginesOn)
        {
            if(bActivate)
            {
                // aktywujemy speedera, wiec normalnie wlaczamy silniki
		        TurnEngines(true);
            }
            else
            {
                // deaktywacja speedera, wiec wylaczamy silniki
                StopEngineFXes();
            }
        }
        //DeleteAttachedFXes();
        
/*		ChromeActor driver = GetFirstOccupant(EPassengerRole._VEHICLE_DRIVER);
		if ( (driver != null) && (driver instanceof AIDriverSpeeder) )
			((AIDriverSpeeder) driver).ActivateAI(bActivate, AIBase._FREEZE_ADVENTURE);
*/	}

    private boolean bWereEnginesOn = false;
	
	private boolean bIsInMovie = false;
	
	public void SetVehicleForMovie(boolean bIsInMovie, boolean bPlayEngineStartStopSound)
	{
        super.SetVehicleForMovie(bIsInMovie, bPlayEngineStartStopSound);
		
		this.bIsInMovie = bIsInMovie;
        
		if (bIsInMovie)
        {
            bWereEnginesOn = m_bEnginesOn;
            TurnEngines(true);
        }
		else
    		TurnEngines(bWereEnginesOn);
	}
    /** Rozwalka samochodu */
    public void Die()
    {
        super.Die();
        
    	TurnEngines(false);
    }

	void SetVehicleParamsForPatrol()
	{
        super.SetVehicleParamsForPatrol();
        
        m_fOldTurningValue = m_Physics.m_Params._MAX_TURN_ANGLE;
        m_Physics.m_Params._MAX_TURN_ANGLE = 120f;
	}
	
	void RestoreVehicleParamsBeforePatrol()
	{
        super.RestoreVehicleParamsBeforePatrol();
        
        m_Physics.m_Params._MAX_TURN_ANGLE = m_fOldTurningValue;
	}
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Speeder.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_SPEEDER)
        {	
			super.SGLoadChunk(cFC);

            m_bEnginesOn = cFC.LoadBool();
            bWereEnginesOn = cFC.LoadBool();
			bIsInMovie = cFC.LoadBool();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Speeder.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_SPEEDER, cFCParent);
		
		super.SGSaveChunk(cFC);
		
        cFC.SaveBool(m_bEnginesOn);
        cFC.SaveBool(bWereEnginesOn);
		cFC.SaveBool(bIsInMovie);
	
        cFC.delete();
    }	    			
    
	public void SGUpdate()
	{
		FileChunk.Log("[Speeder.SGSaveChunk]\n");
		
		super.SGUpdate();
		
		boolean bEnginesOn = m_bEnginesOn;
        
        TurnEngines(false);
        
        if ( (CurrentState instanceof MovieSimulateState) || bEnginesOn ) 
            TurnEngines(true);
		
		if (bIsInMovie)
			m_bEnginesOn = bWereEnginesOn;
	}
}