/** pojazd posiadajacy dzialko sterowane automatycznie lub przez gracza
 */
public class VehicleAttacker extends VehicleCar implements ICannonMesh
{
    /** Klasa strzelajacego dzialka*/
    Class m_cCannonControllerClass = CannonController.class;
        
    /** Strzelajace dzialko */
    ICannonController cCannon = null;
	
    /** zasieg strzalu */
    public float fFireRange = 30000.0f;//#ATTACKER;
    
    /** sila razenia */
    public float fFireDamage = 80.f;//#ATTACKER;
    
	/** ilosc strzalow w serii */
    public int nRoundShots = 12;//#ATTACKER;
    
    /** czestotliwosc, ilosc strzalow na minute */
    public float fRateOfFire = 600.0f;//#ATTACKER;
    
    /** czas pomiedzy seriami */
    public float fLongDelay = 1f;//#ATTACKER;

    public boolean bAttackInMovie = false;//#ATTACKER;Should this vehicle attack it's enemies when part of a movie
    
	/** parametry kamery dzialka gdy gracz prowadzi i strzela */
	float m_fOverCannonHeightDrive = 75f;
	float m_fFromCannonBackDrive = 600f;

	float m_fOverCannonFOV = 82f;
	float m_fOverCannonAimFOV = 60f;
	
	/** parametry kamery dzialka gdy gracz tylko obsluguje dzialko */
	float m_fOverCannonHeightShoot = 300f;
	float m_fFromCannonBackShoot = 800f;
    
    /** parametry dzialka (katy)*/
    float m_fCannonMaxHAngle = 180.0f;  
    float m_fCannonMinVAngle = -30.0f;  
    float m_fCannonMaxVAngle =  30.0f;  
    
	/** czy dzialko jest sterowane przez AI */
	boolean m_bCannonControllingByAI = false;
	/** maksymalny kat obrotu przy dzialku sterowanym przez AI */
	public float m_fAIControlledCannonHAngle = 180f;//#ATTACKER;
    float m_fAIControlledCannonVMinAngle = 0f;
    float m_fAIControlledCannonVMaxAngle = 0f;

    public float m_fCannonHorizAngSpeed = 500f;//#ATTACKER;
    public float m_fCannonVertAngSpeed = 500f;//#ATTACKER;
    
    
	/** obiekt, ktory kontroluje dzialko (strzela z niego) */
	Pawn m_CannonController = null;

	/** zmienne do przechowywania wartosci */
	float fOldTargetFindingAngle = 0;
	float fOldTargetHoldingAngle = 0;
	float fOldTargetMaxVAngle = 0;

	/** czy w danym momencie pojazd jest sterowany przez AI */
	boolean m_bSteeringByAI = false;
    
    int METHOD_StartControllingCannonByPlayerDo = 0;

    /** obrotowe dzialko */
    int m_iRevolvingBarrel = -1;
    float _MAX_ANGLE_SPEED = 1080f;
    float _ANGLE_ACCEL = 1550f;
    float m_fCurrAngle = 0f;
    float m_fCurrAngleAccel = 0f;
    float m_fCurrAngleSpeed = 0f;
    float m_fLastUpdateTime = 0f;
    boolean m_bFiring = false;
    byte m_iMode = 0;
    
	void OnCreate()
    {
        super.OnCreate();
        
        METHOD_StartControllingCannonByPlayerDo = RegisterCallMethod("StartControllingCannonByPlayerDo");
        
        InitCannon();
        
        m_iRevolvingBarrel = GetElementID("lufy");
        if (m_iRevolvingBarrel != -1)
        {
            SetElementAnimType(m_iRevolvingBarrel, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
            SetAnimMorphTime("lufy", 0f);
        }
	}
		
    void InitCannon()
    {
		if (!CannonController.HasCannonMounted(this))
			return;
		
        // inicjalizujemy guna strzelajacego z jeepa
        if ( Role == ERole._AUTHORITY )
        {
            ICannonController cNewCannon = (ICannonController) CreateObject( m_cCannonControllerClass.getName() );
            InitCannonController( cNewCannon );
        }
    }
    
    public boolean IsArmed()
    {
        return (cCannon != null);
    }
    
    void InitCannonController(ICannonController cNewCannon)
    {
        cCannon = cNewCannon;
        
        cCannon.InitController(this);
        
		cCannon.SetMaxHorizAngle(m_fCannonMaxHAngle);
		cCannon.SetMinVertAngle(m_fCannonMinVAngle);
		cCannon.SetMaxVertAngle(m_fCannonMaxVAngle);
        m_fAIControlledCannonVMinAngle = m_fCannonMinVAngle;
        m_fAIControlledCannonVMaxAngle = m_fCannonMaxVAngle;
        
		cCannon.SetHorizAngSpeed(m_fCannonHorizAngSpeed);
		cCannon.SetVertAngSpeed(m_fCannonVertAngSpeed);
        cCannon.SetFireParams( nRoundShots, fRateOfFire, fLongDelay, 
							   fFireRange, fFireDamage );
		
		// ustalenie rozrzutu broni
        cCannon.SetAccuracy(3.5f, 2f);
    }
	
	public void PawnGotIn(SeatInfo info, Pawn pawn)
	{
		super.PawnGotIn(info, pawn);
        
        if (m_bModuleNet)
        {
            //w sieci dzialkiem bedzie sterowal tylko pasazer
            if (pawn instanceof Player &&
                info.GetRole() == EPassengerRole._VEHICLE_PASSENGER)
            {
                StartControllingCannonByPlayer( false );
            }
            
            SetAnimMorphTime("lufy", 0f);
            return;
        }
        
		if (pawn instanceof Player)
			StartControllingCannonByPlayer(info.GetRole() == EPassengerRole._VEHICLE_DRIVER);
		else
		{
			if (info.GetRole() == EPassengerRole._VEHICLE_PASSENGER)
				StartControllingCannonByAI(pawn);
		}
	}

	public void PawnGotOut(SeatInfo info, Pawn pawn)
	{
		super.PawnGotOut(info, pawn);
        
        if (m_bModuleNet)
        {
            if (pawn instanceof Player &&
                info.GetRole() == EPassengerRole._VEHICLE_PASSENGER)
                StopControllingCannonByPlayer();
            return;
        }

        if (pawn instanceof Player)
			StopControllingCannonByPlayer();
		else
		{
			if (info.GetRole() == EPassengerRole._VEHICLE_PASSENGER)
				StopControllingCannonByAI();
		}
	}

	/** po wywolaniu tej metody jezeli gracz wsiadl do samochodu gracz moze sterowac dzialkiem */
	void StartControllingCannonByPlayer(boolean bDriveAndShootMode)
	{
		// jezeli ktos kontroluje to dzialko, to przestaje
		if (m_CannonController != null)
		{
			if (m_CannonController instanceof Player)
				return; // player steruje juz dzialkiem
			
			StopControllingCannonByAI();
		}
		
		Pawn cannonController = null;
		
		Pawn []occupants = GetAllOccupants();
		for (int i = 0; i < occupants.length; i++)
		{
			if (occupants[i] instanceof Player)
			{
                //w sieci dzialkiem bedzie sterowal tylko pasazer
                if (m_bModuleNet &&
                    ((occupants[i].cSeatInfo == null)||
                     (occupants[i].cSeatInfo.GetRole() != EPassengerRole._VEHICLE_PASSENGER))
                    )
                    continue;
				cannonController = occupants[i];
				break;
			}
		}
		
		if (cannonController == null)
		{
			CrashLog("Cannot start controlling cannon in this vehicle !!!");
			return;
		}
		
		m_CannonController = cannonController;
		m_bCannonControllingByAI = false;
        m_bDriveAndShootMode = bDriveAndShootMode;
		
		StartControllingCannonByPlayerDo();
	}
    
    boolean m_bDriveAndShootMode = false;
    
    void StartControllingCannonByPlayerDo()
    {
        if (cCannon != null)
		{
            if (m_bDriveAndShootMode)   
			    cCannon.StartManualControl(m_CannonController, 
                                           m_fOverCannonHeightDrive, 
                                           m_fFromCannonBackDrive,
                                           m_fOverCannonHeightShoot, 
                                           m_fFromCannonBackShoot,
										   m_fOverCannonFOV,
										   m_fOverCannonAimFOV,
                                           false);
            else
			    cCannon.StartManualControl(m_CannonController, 
                                           m_fOverCannonHeightShoot, 
                                           m_fFromCannonBackShoot,
                                           m_fOverCannonHeightShoot, 
                                           m_fFromCannonBackShoot,
										   m_fOverCannonFOV,
										   m_fOverCannonAimFOV,
                                           true);
                
        }
        else
        {
            if (m_bModuleNet)
            {
                //jesli cannon sie jeszcze nie zreplikowal, 
                //to sprobujmy za chwile
                CallMethodIn( METHOD_StartControllingCannonByPlayerDo, 0.1f );
            }
        }
    }
    
	/** przerwanie sterowania dzialkiem przez gracza */
	void StopControllingCannonByPlayer()
	{
        DisableCallMethod( METHOD_StartControllingCannonByPlayerDo );
        
		if (cCannon == null)
			return;
		
		//CrashLog("[VehicleAttacker.StopControllingCannonByPlayer]" + ((GameObject)cCannon).GetUniqueID() + " " + cCannon.getClass().getName()+ "\n");
		
		cCannon.StopManualControl();
		m_CannonController = null;
	}
	
	void StartControllingCannonByAI(Pawn ai)
	{
        CrashLog("[VehicleAttacker.StartControllingCannonByAI]\n");
        
		if (ai == null)
		{
			CrashLog("ERROR: StartControllingCannonByAI() ai == null\n");
			return;
		}
		m_bCannonControllingByAI = true;
		m_CannonController = ai;
		
		// ustawiamy parametry dzialka tak, by moglo strzelac ze swoboda 360 stopni
		fOldTargetFindingAngle = cCannon.GetTargetFindingAngle();
		fOldTargetHoldingAngle = cCannon.GetMaxHorizAngle();
        fOldTargetMaxVAngle = cCannon.GetMaxVertAngle();
        
		cCannon.SetTargetFindingAngle(m_fAIControlledCannonHAngle);
        cCannon.SetMaxHorizAngle(m_fAIControlledCannonHAngle);
        cCannon.SetMinVertAngle(m_fAIControlledCannonVMinAngle);
        cCannon.SetMaxVertAngle(m_fAIControlledCannonVMaxAngle);
        
		cCannon.StartAutonomicHuntingByUser(ai); // zaczynamy strzelac w przeciwnika
        
        // dodatkowe sprawdzenie jesli attacker jest zdeaktywowany na module
        if(!IsActiveOnModule())
        {
            m_bCannonControllingByAI = false;
			cCannon.StopAutonomicHunting();
        }
	}
	
	void StopControllingCannonByAI()
	{
        CrashLog("[VehicleAttacker.StopControllingCannonByAI]\n");
        
		m_bCannonControllingByAI = false;
		m_CannonController = null;
		
		// przywracamy wartosci dla dzialka
		cCannon.SetTargetFindingAngle(fOldTargetFindingAngle);
        cCannon.SetMaxHorizAngle(fOldTargetHoldingAngle);
        cCannon.SetMaxVertAngle(fOldTargetMaxVAngle);
		cCannon.StopAutonomicHunting();
	}

///////////////////////////////////////////////////////////////////////////////
// implementacja interfejsu Appear
///////////////////////////////////////////////////////////////////////////////
    public void Appear(ControlObject cDestinationObj)
	{
		super.Appear(cDestinationObj);

		if (m_CannonController != null)
		{
			m_bCannonControllingByAI = true;
			cCannon.StartAutonomicHuntingByUser(m_CannonController);
		}
	}
    
    public void Disappear(ControlObject cDestinationObj)
	{
		super.Disappear(cDestinationObj);
		
        if (m_CannonController != null)
		{
			m_bCannonControllingByAI = false;
			cCannon.StopAutonomicHunting();
		}
	}

    public void Die()
    {
        super.Die();
        
        DetachCannonSound();
    }
    
    public void OnDestroy()
    {
        if (cCannon instanceof GameObject)
        {
			if (cCannon instanceof CannonController)
				((CannonController)cCannon).m_CannonUser = null;
            ((GameObject) cCannon).delete();
            cCannon = null;
        }
    }

	public void SetVehicleForMovie(boolean bIsInMovie, boolean bPlayEngineStartStopSound)
	{
        super.SetVehicleForMovie(bIsInMovie, bPlayEngineStartStopSound);
        
        if ( (bAttackInMovie) && (IsActiveOnModule()) )
        {
            if (bIsInMovie)
                cCannon.StartAutonomicHuntingByConflictSide(GetConflictSide());
            else
                cCannon.StopAutonomicHunting();
        }
	}
    
    public void SetFXSizeX(float fSizeX)
    {
        fFXSizeX = fSizeX;
    }
    
    public void SetFXSizeY(float fSizeY)
    {
        fFXSizeY = fSizeY;
    }
    
    public void SetFXZero(float fZero)
    {
        fFXZero = fZero;
    }
    
    public void SetFXPosY(float fPosY)
    {
        fFXPosY = fPosY;
    }

    public void FireStarted(byte iMode)
    {
        m_iMode = iMode;
        m_bFiring = false;
        m_fCurrAngleAccel = _ANGLE_ACCEL;
        m_fLastUpdateTime = GetTime();
    }
    
    public void FireStopped()
    {
        m_bFiring = false;
        m_fCurrAngleAccel = -_ANGLE_ACCEL;
    }
    
    public void UpdateRotationBarrel()
    {
        if (!bDead)
            UpdateCannonSounds(m_fCurrAngleSpeed);
        
        if ( (m_fCurrAngleAccel != 0f) && (m_iRevolvingBarrel != -1) )
        {
            float fT = GetTime();

            m_fCurrAngleSpeed += (fT - m_fLastUpdateTime) * m_fCurrAngleAccel;
            
            if (m_fCurrAngleSpeed < 0)
            {
                m_fCurrAngleAccel = 0f;
                m_fCurrAngleSpeed = 0f;
            }
            if (m_fCurrAngleSpeed > _MAX_ANGLE_SPEED)
            {
                if (!m_bFiring)
                {
                    m_bFiring = true;
                    cCannon.SuperStartFire(m_iMode);
                }
                m_fCurrAngleSpeed = _MAX_ANGLE_SPEED;
            }
            
            m_fCurrAngle += (fT - m_fLastUpdateTime) * m_fCurrAngleSpeed;

            RotateElementWithAnim(m_iRevolvingBarrel, Vector.Forward, m_fCurrAngle);
            
            m_fLastUpdateTime = fT;
        }
    }
    
    String m_CannonSoundName = "Data/Sounds/Weapon/JeepCannonSpin";
    int m_nCannonLoopId = 0;
    float m_fMinCannonFreq = 0.7f;
    float m_fMaxCannonFreq = 1.6f;
    
    void AttachCannonSound()
    {
        if ((m_CannonSoundName != null ) && 
            (m_nCannonLoopId == 0) )
        {
             m_nCannonLoopId = AttachSound(m_CannonSoundName, 1000f, 5000f);
             if (m_nCannonLoopId == 0)
                 return;
        }
    }
    
    void DetachCannonSound()
    {
        if (m_nCannonLoopId != 0)
        {
            DetachSound(m_nCannonLoopId);            
            m_nCannonLoopId = 0;
        }
    }
    
    void UpdateCannonSounds(float fSpeed)
    {
        if (fSpeed == 0f && m_nCannonLoopId == 0)
            return;
        if (fSpeed == 0f)
        {
            DetachCannonSound();
            return;
        }
        if (m_nCannonLoopId == 0)
            AttachCannonSound();
            
        if (m_nCannonLoopId != 0)
        {
            // zmieniamy czestotliwosc
            float fFreq = m_fMinCannonFreq +
                          (m_fMaxCannonFreq - m_fMinCannonFreq) * fSpeed / _MAX_ANGLE_SPEED;
            SetSoundFreq(m_nCannonLoopId, fFreq);
        }
    }

    public void GlobalOnFrame()
    {
        super.GlobalOnFrame();
        
        UpdateRotationBarrel();
    }

    // implementacja metody z ICannonMesh
    public void SetFireParams(int nShots, float fRateOfFire, float fLongDelay, float fRange, float fDamage)
    {
        if (cCannon == null)
            return;
        cCannon.SetFireParams( nShots, fRateOfFire, fLongDelay, fRange, fDamage );
    }
    
	///////////////////////////////////////////////////////////////////////////////
	// siec
	///////////////////////////////////////////////////////////////////////////////
    float fCannonDir = 0.0f;
    boolean bCannonFiring = false;
    
    // zeby cannon nie musial byc sieciowy bedziemy replikowac jego zmienne
    static int repSetCannonState = -1;
    public void ReplicationInit()
    {
        super.ReplicationInit();
        repSetCannonState = NewReplicationSet("fCannonDir,bCannonFiring");
        
        SetNetPriority(2.0f);
    }
  
    /** Replikacja odpowiednich zestawow dla odpowiednich warunkow */
    public void OnReplicateServer()
    {
        super.OnReplicateServer();
        
        if(bDontReplicate) return;
        
        Replicate(  repSetCannonState );
    }
    
    public int GetRole()
    {
        return Role;
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[VehicleAttacker.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_VEHICLE_ATTACKER)
        {	
			super.SGLoadChunk(cFC);

		    ((ISaveGame)cCannon).SGLoadChunk(cFC);
            bAttackInMovie = cFC.LoadBool();
            m_bCannonControllingByAI = cFC.LoadBool();
            m_CannonController = (Pawn) cFC.LoadObjectRef();
	        fOldTargetFindingAngle = cFC.LoadFloat();
	        fOldTargetHoldingAngle = cFC.LoadFloat();
            fOldTargetMaxVAngle = cFC.LoadFloat();
		    m_bSteeringByAI = cFC.LoadBool();
		    m_bDriveAndShootMode = cFC.LoadBool();
            
            m_fCurrAngle = cFC.LoadFloat();
            m_fCurrAngleAccel = cFC.LoadFloat();
            m_fCurrAngleSpeed = cFC.LoadFloat();
            m_fLastUpdateTime = cFC.LoadFloat();
            m_bFiring = cFC.LoadBool();
            m_iMode = (byte) cFC.LoadInt();
    	    m_fAIControlledCannonHAngle = cFC.LoadFloat();
            m_fAIControlledCannonVMinAngle = cFC.LoadFloat();
            m_fAIControlledCannonVMaxAngle = cFC.LoadFloat();
        }
		
		cFC.delete();
    }
	    
    /** Metoda zapisujaca dane do Save gracza */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[VehicleAttacker.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_VEHICLE_ATTACKER, cFCParent);
		
		super.SGSaveChunk(cFC);

		cCannon.SGSaveChunk(cFC);
        cFC.SaveBool(bAttackInMovie);
        cFC.SaveBool(m_bCannonControllingByAI);
        cFC.SaveObjectRef(m_CannonController);
	    cFC.SaveFloat(fOldTargetFindingAngle);
	    cFC.SaveFloat(fOldTargetHoldingAngle);
        cFC.SaveFloat(fOldTargetMaxVAngle);
		cFC.SaveBool(m_bSteeringByAI);
		cFC.SaveBool(m_bDriveAndShootMode);

        cFC.SaveFloat(m_fCurrAngle);
        cFC.SaveFloat(m_fCurrAngleAccel);
        cFC.SaveFloat(m_fCurrAngleSpeed);
        cFC.SaveFloat(m_fLastUpdateTime);
        cFC.SaveBool(m_bFiring);
        cFC.SaveInt(m_iMode);
	    cFC.SaveFloat(m_fAIControlledCannonHAngle);
        cFC.SaveFloat(m_fAIControlledCannonVMinAngle);
        cFC.SaveFloat(m_fAIControlledCannonVMaxAngle);
        
        cFC.delete();
    }	    				
	
    /** Metoda wywolujaca odpowiednie akcje po odczycie danych
     */		
	public void SGUpdate()
	{
		FileChunk.Log("[VehicleAttacker.SGUpdate]\n");
		
		super.SGUpdate();	
		
		cCannon.SGUpdate();
		cCannon.StopFire();
        
        m_nCannonLoopId = 0;
	}	
    
    public void OnAudioReinitialize()
    {
        super.OnAudioReinitialize();
        m_nCannonLoopId = 0;
    }
    
}
