class VehicleParams implements ISaveGame
{
	private float _MAX_SPEED = 2100;				// predkosc maksymalna pojazdu
	float _CURR_MAX_SPEED = _MAX_SPEED;		// biezaca predkosc maksymalna pojazdu
	float _MIN_SPEED = -1300f;				// predkosc maksymalna pojazdu do tylu
	
	float _ACCELERATION_COEF = 450f;		// przyspieszenie do przodu / tylu
	float _BRAKE_COEF = 2000f;				// przyspieszenie przy hamowaniu
	float _SLOW_COEF = 900f;				// zwalnianie przy puszczonym przyspieszaniu / zwalnianiu
	float _FLY_SLOW_COEF = 0f;				// zwalnianie przy nacisnietym przyspieszaniu w powietrzu 
	
	float _SUSPENSION_HEIGHT = 40f;			// wysokosc zawieszenia pojazdu
	float _SPRING_MIN = -10f;				// min ustawienie sprezyny, powinno byc = -_SUSPENSION_HEIGHT
	float _SPRING_MAX = 10f;				// max ustawienie sprezyny
	
	float _SPRING_NORMAL = -20f;			// ustawienie sprezyny w locie
	
	float _TURNING_SPEED = 200f;			// szybkosc przyrostu skretu w stopniach na sec
	float _MAX_TURN_ANGLE = 80f;			// maksymalny kat skretu w stopniach
	float _MAX_VIS_TURN_ANGLE = 45f;		// maksymalny kat skretu w stopniach do wizualizacji
	float _DECREASE_TURNING_SPEED = 360;	// ile stopni na sec ma sie wygaszac obrot
	float _GRAVITY_ACCEL = -3000f;			// przyspieszenie ziemskie
	float _EXPLOSION_ACCEL = 4000f;			// przyspieszenie od wybuchu bomby
	float _GROUND_ALIGN_INERTIA = 30f;		// bezwladnosc przy zmianie normalnej przy jezdzie bez oderwania od ziemis
	float _GROUND_FLY_ALIGN_INERTIA = 10f;	// bezwladnosc przy zmianie normalnej po upadku
	float _UP_FLY_ALIGN_INERTIA = 3f;		// bezwladnosc przy zmianie normalnej w czasie lotu
	float _MAX_SLOPE_ANGLE = 0.5f;			// maksymalne nachylenie zbocza,
											// pod ktre mona wjecha
											// bardziej stromo - mniejsze
	float _MAX_BOUNCE_RANGE = 2000f;		// szybkosc zeslizgiwania sie (maksymalna odleglosc, na ktora sie odbijamy)
	float _SLIDE_TIME_COEF = 2000f;			// jak szybko wygaszac poslizg w cm na sec
	float _SLIDE_SPEED_COEF = 2f;			// wspolczynnik zwalniania przy najezdzaniu
											// na strome sciany. Zakres - <1, ...>,
											// im wieksze, tym szybciej zwalnia
	float _TIME_TO_GOING_BACK = 0.1f;		// czas po jakim z hamowania chcemy przejsc do jechania do tylu
	float _REAL_FLY_TIME = 0.2f;			// czas po jakim uznajemy, ze lecimy
	float _REAL_FLY_TIME_CONTROL = 0.1f;	// czas po w locie nie mozna skrecic
	float _MAX_LANDING_TIME = 0.2f;			// maksymalny czas ladowania pojazdu
	float _MAX_FLYING_TIME = 1.0f;			// max czas lotu po ktorym sprawdzamy czy nie jestesmy pod ziemia
	float _WHEEL_MOVE_SPEED_COEF = 0.30f;	// wspolczynnik szybkosci obracania kol do przodu
	float _SPRING_TIME_MOVE_COEF = 250f;	// szybkosc przemieszczania sie sprezyny w cm na sek
	float _SLIDE_COEF = 700f;				// wspolczynnik poslizgu
	float _SLIDE_SMOKE_COEF = _SLIDE_COEF/6f;// kiedy ma sie pojawiac dym przy poslizgu
	float _SLIDE_SUPRESS = 600f;			// wspolczynnik wygaszania poslizgu
	float _MAX_VERT_DEV = 10f;				// maksymalne odchylenie normalnej pojazdu przy starcie / hamowaniu
	float _MAX_HORIZ_DEV = 10f;				// maksymalne odchylenie normalnej pojazdu przy skrecaniu
	float _VERT_DEV_ACCEL = 10f;//100f;		// przyspieszenie odchylenia przy starcie / hamowaniu
	float _HORIZ_DEV_ACCEL	= 10f;//100f;	// przyspieszenie odchylenia przy skrecaniu
	float _COLL_SUPRESS = 800;//800f;		// szybkosc wytlumiania odbicia
	float _OBJ_HIT_SUPR = 15f;				// tlumienie odbicia niesprezystego od obiektu
	float _OBJ_HIT_SPEED_SUPR = 2f;			// tlumienie odbicia niesprezystego od obiektu
	float _TREE_HIT_SUPR = 15f; //15;		// tlumienie odbicia niesprezystego od drzewa 
	float _TIME_BTW_SMOKES = 0.05f;			// czas pomiedzy kolejnymi dymkami spod kol
	float _TIME_BTW_SMOKES_SLIDE = 0.05f;	// czas pomiedzy kolejnymi dymkami spod kol przy poslizgach
	float _TIME_BETWEEN_SLIDE_SOUNDS = 0.3f;// czas pomiedzy odegraniem dzwieku poslizgu
	float _MIN_SOUND_FREQ = 0.7f;			// minimalna czestotliwosc dzwieku silnika
	float _MAX_SOUND_FREQ = 3.0f;			// maksymalna czestotliwosc dzwieku silnika
	float _COLL_COEF = 0;					// wartosc, do ktorej bedzie obcinany wektor przesuniecia po kolizji
	float _OUT_OF_TRACK_SPEED = _MAX_SPEED/5f;// maksymalna predkosc na poboczu
	float _NUM_OF_TURNS = 4f;				// liczba obrotw po uderzeniu np. bomba
	float _HIT_ROTATION_SPEED = 900f;		// predkosc w obrotach na sekunde po uderzeniu np. bomba
	float _MAX_TIME_OUTSIDE = 3f;			// maksymalny czas poza trasa w sekundach
	
	// wspolczynnik skretu
	float _COEFF_TURN = 1.0f;
	
	float _COLL_COEF_MAX_SPEED = _MAX_SPEED/2f;// /5f;// maksymalna predkosc odbicia

    float _TIME_BETWEEN_ACCEL_SOUNDS = 1f;	// czas pomiedzy odegraniem dzwieku przyspieszenia
	float _TIME_BETWEEN_BRAKE_SOUNDS = 1f;	// czas pomiedzy odegraniem dzwieku hamowania
	float _TIME_BETWEEN_HIT_SOUNDS = 1f;	// czas pomiedzy odegraniem dzwieku kolizji

	float _NORMAL_INTERPOLATION_COEFF = 5.0f; // wspolczynnik interpolacji normalnej (czym wiekszy tym wolniej sie interpoluje)
	
	
    float _MIN_SPEED_TO_COLLIDE             = _MAX_SPEED * 0.2f;
	// parametry kolizji pojazdu i zmiany energii po kolizjach
	// maksymalna predkosc przy jakiej jeszcze kolizje uwazamy za lekkie
	float _MAX_SPEED_TO_SAFE_COLLISION		= _MAX_SPEED * 0.8f; 
	// ilosc energi (w stosunku do fMaxHealth) jaka jest zabierana przy "lekkich kolizjach"
	float _DAMAGE_COEFF_SAFE_COLLISION		= 0.01f;
	// ilosc energi (w stosunku do fMaxHealth) jaka jest zabierana przy "ciezkich kolizjach"
	float _DAMAGE_COEFF_HARD_COLLISION		= 0.05f;
    // ilosc energi (w stosunku do fMaxHealth) jaka jest zabierana podczas jazdy w wodzie (na sekunde)
    float _DAMAGE_COEFF_WATER_COLLISION     = 0.05f;
	
	// maksymalna predkosc przy jakiej jeszcze kolizje z AI uwazamy za lekkie
	float _MAX_SPEED_TO_SAFE_COLLISION_AI	= _MAX_SPEED * 0.5f; 
	// ilosc energi (w stosunku do fMaxHealth) jaka jest zabierana AI przy "lekkich kolizjach"
	float _DAMAGE_COEFF_SAFE_COLLISION_AI	= 0.1f;
	// przy ciezkich kolizjach AI ginie :-)

	// to razy speed pojazdu zostanie podane by wyrzucic pawna przy kolizji
	float _PAWN_HIT_COEF = 2.0f;
    
    //predkosc obracania sie walkera w stopniach na sec
    //MK: nie save'uje bo nie zmienia sie w trakcie gry
    float _ROTATE_SPEED = 30.0f;			
    
    //na jaka glebokosc moze pojazd wjechac "bezbolesnie" w wode
    //MK: nie save'uje bo nie zmienia sie w trakcie gry
    float _WATER_LEVEL_MARGIN = 200.0f;

    float _FALL_DAMAGE_HEIGHT_MIN = 300f;
    float _FALL_DAMAGE = 100f; // uwaga, zaleznosc kwadratowa przy zadawaniu damage
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    void SetMaxSpeed(float fSpeed)
    {
        _MAX_SPEED = fSpeed;
        _CURR_MAX_SPEED = fSpeed;
        _OUT_OF_TRACK_SPEED = _MAX_SPEED/5f;
        _COLL_COEF_MAX_SPEED = _MAX_SPEED/2f;
        _MIN_SPEED_TO_COLLIDE = _MAX_SPEED * 0.2f;
        _MAX_SPEED_TO_SAFE_COLLISION = _MAX_SPEED * 0.8f;
    }
    
    float GetMaxSpeed()
    {
        return _MAX_SPEED;
    }
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[VehicleParams.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_VEHICLE_PARAMS)
        {
            _MAX_SPEED = cFC.LoadFloat();
            _CURR_MAX_SPEED = cFC.LoadFloat();
            _MIN_SPEED = cFC.LoadFloat();
            _ACCELERATION_COEF = cFC.LoadFloat();
            _BRAKE_COEF = cFC.LoadFloat();
            _SLOW_COEF = cFC.LoadFloat();
            _TURNING_SPEED = cFC.LoadFloat();
            _MAX_TURN_ANGLE = cFC.LoadFloat();
            _DECREASE_TURNING_SPEED = cFC.LoadFloat();
            _GRAVITY_ACCEL = cFC.LoadFloat();
            _SLIDE_TIME_COEF = cFC.LoadFloat();
            _SLIDE_SPEED_COEF = cFC.LoadFloat();
            _SLIDE_COEF = cFC.LoadFloat();
            _SLIDE_SUPRESS = cFC.LoadFloat();
            _SPRING_MIN = cFC.LoadFloat();
            _SPRING_MAX = cFC.LoadFloat();
            _SPRING_TIME_MOVE_COEF = cFC.LoadFloat();
            _TREE_HIT_SUPR = cFC.LoadFloat();
            _WHEEL_MOVE_SPEED_COEF = cFC.LoadFloat();
            _TIME_BTW_SMOKES = cFC.LoadFloat();
            _TIME_BTW_SMOKES_SLIDE = cFC.LoadFloat();
			_MAX_VERT_DEV = cFC.LoadFloat();
			_MAX_HORIZ_DEV = cFC.LoadFloat();
			_VERT_DEV_ACCEL = cFC.LoadFloat();
			_HORIZ_DEV_ACCEL = cFC.LoadFloat();			
    }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[VehicleParams.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_VEHICLE_PARAMS, cFCParent);
		
        cFC.SaveFloat(_MAX_SPEED);
        cFC.SaveFloat(_CURR_MAX_SPEED);
        cFC.SaveFloat(_MIN_SPEED);
        cFC.SaveFloat(_ACCELERATION_COEF);
        cFC.SaveFloat(_BRAKE_COEF);
        cFC.SaveFloat(_SLOW_COEF);
        cFC.SaveFloat(_TURNING_SPEED);
        cFC.SaveFloat(_MAX_TURN_ANGLE);
        cFC.SaveFloat(_DECREASE_TURNING_SPEED);
        cFC.SaveFloat(_GRAVITY_ACCEL);
        cFC.SaveFloat(_SLIDE_TIME_COEF);
        cFC.SaveFloat(_SLIDE_SPEED_COEF);
        cFC.SaveFloat(_SLIDE_COEF);
        cFC.SaveFloat(_SLIDE_SUPRESS);
        cFC.SaveFloat(_SPRING_MIN);
        cFC.SaveFloat(_SPRING_MAX);
        cFC.SaveFloat(_SPRING_TIME_MOVE_COEF);
        cFC.SaveFloat(_TREE_HIT_SUPR);
        cFC.SaveFloat(_WHEEL_MOVE_SPEED_COEF);
        cFC.SaveFloat(_TIME_BTW_SMOKES);
        cFC.SaveFloat(_TIME_BTW_SMOKES_SLIDE);		
        cFC.SaveFloat(_MAX_VERT_DEV);
        cFC.SaveFloat(_MAX_HORIZ_DEV);
        cFC.SaveFloat(_VERT_DEV_ACCEL);
        cFC.SaveFloat(_HORIZ_DEV_ACCEL);
								
        cFC.delete();
    }
	
	public void SGUpdate()
    {
        SetMaxSpeed(GetMaxSpeed());
    }
}
