public class CTFBase extends NetTeamObject implements INetGameObject
{
    //czy baza ma byc aktywna na levelu, nawet jak nie gramy w SMD ani TD
    public boolean m_bAlwaysActive = false; //#Net
    
    /** Flaga przypisana do bazy */
    CTFFlag m_cFlag = null;
    
    /** Pozycja flagi w bazie */
    Vector  m_vFlagPos = null;
    
    void OnCreate()
    {
        super.OnCreate();
        
        SetFlag( EFlags._PORTAL_INDEPENDENT );
        ClearFlag( EFlags._COLLISION );
        
        //TODO: pobrac miejsce respawnu flagi z mesh elementu
        int nId = GetElementID("hook1");
        if ( nId > 0 )
            m_vFlagPos = GetElementPos( nId );
        else
        {
            m_vFlagPos = GetPosition();
            m_vFlagPos.fY += 350.0f;
        }
        LogD(" "+m_vFlagPos+"\n");
        SetSkin( false );
        
        // preloadujemy skiny
        PreloadSkin("Red");
        PreloadSkin("RedDark");
        PreloadSkin("Blue");
        PreloadSkin("BlueDark");
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        
        UnloadSkin("Red");
        UnloadSkin("RedDark");
        UnloadSkin("Blue");
        UnloadSkin("BlueDark");
    }
    
    public void OnPostCreate()
    {
        CheckActive();
    }

    
    void SetFlag( CTFFlag cFlag )    
    {   
        m_cFlag = cFlag;   
        
        CheckActive();
    }
    
    boolean CheckActive()
    {
        boolean bActive = m_bAlwaysActive || (m_cFlag != null);
        if ( bActive )
            ActivateOnModule();
        else
            DeactivateOnModuleAlways();
        return bActive;
    }
        
    public void ServerDeleteIfNotActive()
    {
        if ( ! CheckActive() )
            CallMethodIn("delete",0.0f);
    }
    
    CTFFlag GetFlag()                   {   return m_cFlag;    }
    Vector  GetFlagPosition()           {   return m_vFlagPos; }
    
    int GetTeamId()
    {
        if ( AllowTeam( NetTeamInfo.BLUE ) )
            return NetTeamInfo.BLUE;
        return NetTeamInfo.RED;
    }
    
    public void ReplicationInit()
    {
    }
    
    void BaseOnOff(boolean bOnOff)
    {
        SetSkin( bOnOff );
    }
    
    void SetSkin(boolean bBaseOn)
    {   
        String sSkin = "Default";
        
        switch ( GetTeamId() )
        {
        case NetTeamInfo.RED:
            sSkin = bBaseOn ? "Red" : "RedDark";
            break;
        case NetTeamInfo.BLUE:
            sSkin = bBaseOn ? "Blue" : "BlueDark";
            break;
        }
        SetSkin( sSkin );
    }
}

