public class CTFFlag extends InvObjectInst
{
    final static int OWN   = 0,
                     ENEMY = 1;
    
    //czy flaga ma byc widoczna jak gracz ja niesie
    static boolean sm_bVisibleInPlayerHands = false;
                     
        
    
    
    NetGameInfoCTF m_cGameInfo    = null;
    CTFBase        m_cBase        = null;
    int            m_nTeamId      = NetTeamInfo.NONE;
    Vector         m_vBasePos     = null;
    PlayerNetCTF   m_cPlayerOwner = null;
    
    int            m_nGameInfoId  = -1;
    int            m_nBaseId      = -1;
    
    NetObjectPositionController m_cPositionController = null;
        
    boolean m_bBaseOnOff = false;
    
    //FX do odpalania nad graczem
    String     m_sFXName = "FXFlagBlue";
    
    int METHOD_ScheduledBackToBase = 0;

    CTFFlag()
    {
        super();
        
        sName    = "Flag";
        MeshName = "Data/Meshes/Objects/flag.3da";
        
        nInvIndex = InvObject._E_NET_CTF_FLAG;
        nInvType  = EInvObjType._EQUIP;
     
        bHiddenButUsable   = true;
        
        //teksturka i wymiary do inwentory
        sTexFileName = "Data/Textures/CH_I_Weapons4.png";
      	nCellsWidth = 2;
	    nCellsHeight = 3;
        //rozmiary tekstury
        nTexSizeX = 256;
        nTexSizeY = 256;
        m_bThrowAwayOnRemoveFromInventory = true;
        
        //wylaczam ta flage bo nie chciala dobrze wypadac
        //na klientach z jeepa
        //TODO: jak beda na jakis levelach CTFowych windy to
        //rozwiazac to inaczej
        bAttachToMovingPlatformAfterDrop = false;
    }
    
    public void OnCreate()
    {
        METHOD_ScheduledBackToBase = RegisterCallMethod("ScheduledBackToBase");
        
        super.OnCreate();
        
        SetFlag( EFlags._PORTAL_INDEPENDENT );
        
        //Uwaga, flagi EFlags._BLOCK_TRACE i EFlags._COLLISION sa z jednej
        //strony potrzebne (zeby mozna bylo ustawiac ja jako activetrigger
        //z drugiej strony nie chcemy zeby odkladaly sie na niej trace'y
        //oraz zeby gracz z nia kolidowal
        //Z tego powodu flagi ta bedza domyslnie wylaczone, natomiast
        //beda wlaczane przez NetGameInfoCTF tylko na sama chwile 
        //trace'owania otoczenia przez gracza w poszukiwaniu triggera
        ClearFlag( EFlags._BLOCK_TRACE );
        ClearFlag( EFlags._COLLISION );
        
        m_cPositionController = (NetObjectPositionController)CreateObject("NetObjectPositionController");
        m_cPositionController.SetControlledObject( this );
    }
    
    public void OnDestroy()
    {
        DetachFromParent();
        
        if ( m_cPositionController != null )
        {
            m_cPositionController.delete();
            m_cPositionController = null;
        }
        
        super.OnDestroy();
    }
    
    void ServerInit(CTFBase           cBase,
                    NetGameInfoCTF    cGameInfo )
    {
        if ( Role < ERole._AUTHORITY )
            return;
        
        m_cBase      = cBase;
        cBase.SetFlag( this );
        
        m_cGameInfo  = cGameInfo;
        m_nTeamId    = cBase.GetTeamId();
        m_vBasePos   = cBase.GetFlagPosition();
        LogD(" "+m_vBasePos+"\n");
        
        ServerRespawn();
    }
    
    void SetBaseOnOff( boolean bOnOff )
    {
        m_bBaseOnOff = bOnOff;
        CheckBaseOnOff();
        MsgSendClientBaseOnOff();
    }
    boolean IsBaseOn()  {   return m_bBaseOnOff;   }
   
    
    public void OnReplicateServer()
    {
        super.OnReplicateServer();
        
        if ( bNetInit )
        {
            MsgSendClientInit();
            MsgSendClientBaseOnOff();
        }
    }

    
    static final int MSG_CLIENT_INIT          = 50; // netgameinfo, base pos, team id
    static final int MSG_CLIENT_BASE_ONOFF    = 52; // czy baza dziala
    
    /** Odebranie komunikatow przychodzacych z sieci
     */
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case MSG_CLIENT_INIT:
            LogD("MSG_CLIENT_INIT\n");
            MsgRecvClientInit();
            break;
            
        case MSG_CLIENT_BASE_ONOFF:
            LogD("MSG_CLIENT_BASE_ONOFF\n");
            MsgRecvClientBaseOnOff();
            break;
            
         default:
            super.OnMessage();        
        }
    }
    
    void MsgSendClientInit()
    {
        MessageNew( MSG_CLIENT_INIT );
        MessagePackInt( m_cGameInfo.GetNetId() );
        MessagePackInt( m_cBase.GetNetId() );
        MessagePackInt( m_nTeamId );
        MessagePackVector( m_vBasePos );
        MessageSend();
    }
    
    void MsgRecvClientInit()
    {
        m_nGameInfoId   = MessageUnPackInt();
        m_nBaseId       = MessageUnPackInt();
        m_nTeamId       = MessageUnPackInt();
        m_vBasePos      = MessageUnPackVector();
        MessageEnd();
        
        TryFindGameInfo();
        TryFindBase();
    }
       
    
    void MsgSendClientBaseOnOff()
    {
        MessageNew( MSG_CLIENT_BASE_ONOFF );
        MessagePackBoolean( m_bBaseOnOff );
        MessageSend();
    }
    
    void MsgRecvClientBaseOnOff()
    {
        m_bBaseOnOff = MessageUnPackBoolean();
        MessageEnd();
        
        CheckBaseOnOff();        
    }
    
    void ServerRespawn()
    {
        if ( Role < ERole._AUTHORITY )
            return;
        LogD("\n");
        
        CancelScheduleBackToBase();
        
        //Uwaga, wazne!
        //Zaznaczmy ze spawnujemy sie w bazie, zeby
        //czasem system nie pomyslal ze ktos nas 
        //poprostu wyrzucil...
        SetBaseOnOff( true );
        
        if ( cInventory != null )
        {
            cInventory.RemoveInvObject( this );
            ChangeInvState( null, EInvObjState._ONGROUND );
        }
        
        SetPosition( m_vBasePos );
        MsgSendClientState();
    }
        
    //wyrzucenie flafi na serwerze
    void ThrowFlag()
    {
        if ( Role < ERole._AUTHORITY )
            return;
        
        if ( cInventory != null )
        {
            ActionThrowAway();
        }
    }
    
    //uzycie flagi bedzie polegalo na jej wyrzuceniu...
    public void Use()
    {
        ThrowFlag();
    }
    
    
    //Call back, flaga dodana do inwentory
    public void AddedToInventory()
    {
        super.AddedToInventory();
        
        //wiadomo juz ze nie jest na swoim miejscu bazowym
        SetBaseOnOff( false );
        //odwolujemy tez ewentualnie zaplanowane odstawienie do bazy
        CancelScheduleBackToBase();
           
        if ( Owner instanceof PlayerNetCTF )
        {
            m_cPlayerOwner = (PlayerNetCTF)Owner;
            
            if ( Role == ERole._AUTHORITY )
            {
                //ktos ja przejal
                m_cGameInfo.EventFlagCapturedByPlayer( this, m_cPlayerOwner );
            }
            
            m_cPositionController.StopMoving();
            
            //dolaczyc mesha od gracza
            if ( sm_bVisibleInPlayerHands )
            {
                m_cPlayerOwner.AttachChild( this );
                SetPosition( new Vector(0.0f,0.0f,-60.0f) );
                EnableRendering( true );
            }
            if ( m_sFXName != null )
                m_cPlayerOwner.StartFlagFX( m_sFXName );
        }
        else
        {
            m_cPlayerOwner = null;
            LogD("Flaga przejeta przez obiekt "+Owner+" - to nie PlayerNet!!\n");
        }
    }

    public void RemovedOnGround()
    {
        super.RemovedOnGround();
        
        //flaga "wyleciala" z inwentarza
        if ( m_cPlayerOwner != null )
        {
            //zawiadommy system o tym
            if ( Role == ERole._AUTHORITY )
                m_cGameInfo.EventFlagRemovedOnGround( this, m_cPlayerOwner );
        
            //niech przez chwilke nie bedzie aktywna,
            ActiveOffForAWhile();
            
            //odlaczyc mesha od gracza
            if ( sm_bVisibleInPlayerHands )
                DetachFromParent();
            
            //kazmy jej sie poruszac
            if ( IsBaseOn() )  
                m_cPositionController.StartRotateAndSwingSlow();
            else
                m_cPositionController.StartRotateAndSwingFast();
            
            m_cPlayerOwner.StopFlagFX();
            
            //wylaczamy flagi do kolizji
            ClearFlag( EFlags._BLOCK_TRACE );
            ClearFlag( EFlags._COLLISION );
        }
    }
    
    boolean m_bIsActiveLocal = true;
    
    void ActiveOffForAWhile()
    {
        m_bIsActiveLocal = false;
        DisableCallMethod("ActiveOn");
        CallMethodIn("ActiveOn",2.0f);
    }
    
    void ActiveOn()
    {
        m_bIsActiveLocal = true;
    }
    
    public boolean IsActive(ControlObject cActivator)
    {
        return ( m_bIsActiveLocal && super.IsActive( cActivator ) );
    }
        
    void Execute()
    {
    }

    void CheckBaseOnOff()
    {
        if ( m_cBase != null )
        {
            m_cBase.BaseOnOff( m_bBaseOnOff );
            if ( m_bBaseOnOff )
                m_cPositionController.StartRotateAndSwingSlow();
            else
                m_cPositionController.StartRotateAndSwingFast();
        }
        else
            CallMethodIn("CheckBaseOnOff",0.1f);
    }
    
    Vector GetBasePos()
    {
        return m_vBasePos;
    }
    
    boolean IsBaseOnOff()
    {
        return m_bBaseOnOff;
    }
    
    void TryFindGameInfo()
    {
        GameObject     cObj = GetObjectByNetId( m_nGameInfoId );
        if ( cObj == null )
        {
            CallMethodIn("TryFindGameInfo",0.1f);
            return;
        }
        if ( cObj instanceof NetGameInfoCTF )
        {
            m_cGameInfo = (NetGameInfoCTF)cObj;
            
            LogD(" "+this+" "+m_cGameInfo+"\n");
            //dodajemy sie tam na liscie
            m_cGameInfo.m_aFlags.addElement( this );
        }
        else
        {
            CrashLog("ERROR: "+cObj+" nie jest z klasy NetGameInfoCTF!!!!\n");
        }
    }
    
    void TryFindBase()
    {
        GameObject     cObj = GetObjectByNetId( m_nBaseId );
        if ( cObj == null )
        {
            CallMethodIn("TryFindBase",0.1f);
            return;
        }
        if ( cObj instanceof CTFBase )
        {
            m_cBase = (CTFBase)cObj;
            
            LogD(" "+this+" "+m_cBase+"\n");
            m_cBase.SetFlag( this );
        }
        else
        {
            CrashLog("ERROR: "+cObj+" nie jest z klasy CTFBase!!!!\n");
        }
    }
    
    void ScheduleBackToBase( float fTime )
    {
        CancelScheduleBackToBase();
        CallMethodIn( METHOD_ScheduledBackToBase,fTime );
    }
    
    void CancelScheduleBackToBase()
    {
        DisableCallMethod( METHOD_ScheduledBackToBase );
    }
    
    void ScheduledBackToBase()
    {
        m_cGameInfo.EventScheduledBackToBase( this );        
    }

    /**
     * System wlaczania/wylaczania flag kolizji obiektu
     * Uzywany do tymczasowego wlaczania kolizji na
     * czas traceowania active trigerra
     * Istotne gdy obiekt jest typu hologramowego
     */
    /**
     * Zapamietanie stanu flag obiektu
     * a nastepnie wlaczenie flag kolizji
     */
    public void StoreFlagsAndEnableGetActiveTrigger()
    {
        StoreFlags();
        SetFlag( EFlags._BLOCK_TRACE );
        SetFlag( EFlags._COLLISION );
    }
    
    /** zapamietany ostatnio stanu flag obiektu */
    private int  m_nStoredFlags = 0;
    /** Zapamietanie stanu flag obiektu */
    private void StoreFlags()  { m_nStoredFlags = GetFlags(); }
    /** Przywrocenie zapamietanego stanu flag obiektu */
    public  void RestoreFlags(){ SetFlags( m_nStoredFlags );  }
}

class CTFFlagInfo
{
    private Vector  m_vPos      = null;
    private boolean m_bHasOwner = false;
    
    CTFFlagInfo(int nX, int nZ, boolean bHasOwner )
    {
        m_vPos      = new Vector( (float)nX, 0.0f, (float)nZ );
        m_bHasOwner = bHasOwner;
    }
    
    Vector  GetPos()   {    return m_vPos;      }
    boolean HasOwner() {    return m_bHasOwner; }
}

class CTFBaseInfo
{
    private Vector  m_vPos   = null;
    private boolean m_bOnOff = false;    
    
    CTFBaseInfo(Vector vPos, boolean bOnOff )
    {
        m_vPos      = vPos;
        m_bOnOff    = bOnOff;
    }
    
    Vector GetPos()     { return m_vPos;    }
    boolean IsOnOff()   { return m_bOnOff;  }
}
